/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB(c) Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 3.15.0
        Device            :  PIC16F1619
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.20
*/

/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
 */

#include "mcc_generated_files/mcc.h"

#define SMALL       0
#define MAIN_PULSE  1

uint8_t Channel_u8;
uint8_t State_u8;

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();


    Channel_u8 = 0;
    State_u8 = 0;
    
    while (1)
    {
        // Add your application code
        while( GetStartTransmit() )
        {
            if( Channel_u8 == 0 && State_u8 == SMALL )
            {
                PIR1bits.CCP1IF = 0;
                CCP1CONbits.EN = true;
                TMR1 = 0;
                TMR1_StartTimer();
            }

            switch(State_u8)
            {
                case(SMALL):
                    if( Channel_u8 < 9 )
                    {
                        CCP1_CompareCountSet(GetShortPulse(Channel_u8));
                        State_u8 = MAIN_PULSE;
                    }
                    if( Channel_u8 == 9 )
                    {
                        CCP1_CompareCountSet(350);
                        Channel_u8 = 10;
                    }
                    LATA0 = false;
                    break;

                case(MAIN_PULSE):
                    CCP1_CompareCountSet(GetMainPulse(Channel_u8)-100);
                    LATA0 = true;
                    State_u8 = SMALL;
                    ++Channel_u8;
                    break;

                default:
                    State_u8 = SMALL;
                    break;
            }
            while( !CCP1_IsCompareComplete() ){};
            
            if(Channel_u8 > 9)
            {
                LATA0 = true;
                ClearStartTransmit();
                CCP1CONbits.EN = false;
                TMR1_StopTimer();
                State_u8 = SMALL;
                Channel_u8 = 0;
            }
        }
    }
}
/**
 End of File
*/