// Version 1.37 (B)
// Generated 18/04/2016 GMT

/*
 * Copyright © 2016, Microchip Technology Inc. and its subsidiaries ("Microchip")
 * All rights reserved.
 * 
 * This software is developed by Microchip Technology Inc. and its subsidiaries ("Microchip").
 * 
 * Redistribution and use in source and binary forms, with or without modification, are
 * permitted provided that the following conditions are met:
 * 
 *     1. Redistributions of source code must retain the above copyright notice, this list of
 *        conditions and the following disclaimer.
 * 
 *     2. Redistributions in binary form must reproduce the above copyright notice, this list
 *        of conditions and the following disclaimer in the documentation and/or other
 *        materials provided with the distribution.
 * 
 *     3. Microchip's name may not be used to endorse or promote products derived from this
 *        software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY MICROCHIP "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL MICROCHIP BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING BUT NOT LIMITED TO
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWSOEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _PIC16F1619_H_
#define _PIC16F1619_H_

/*
 * C Header file for the Microchip PIC Microcontroller
 * PIC16F1619
 */
#ifndef __XC8
#warning Header file pic16f1619.h included directly. Use #include <xc.h> instead.
#endif

/*
 * Register Definitions
 */

// Register: INDF0
extern volatile unsigned char           INDF0               @ 0x000;
#ifndef _LIB_BUILD
asm("INDF0 equ 00h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned INDF0                  :8;
    };
} INDF0bits_t;
extern volatile INDF0bits_t INDF0bits @ 0x000;
// bitfield macros
#define _INDF0_INDF0_POSN                                   0x0
#define _INDF0_INDF0_POSITION                               0x0
#define _INDF0_INDF0_SIZE                                   0x8
#define _INDF0_INDF0_LENGTH                                 0x8
#define _INDF0_INDF0_MASK                                   0xFF

// Register: INDF1
extern volatile unsigned char           INDF1               @ 0x001;
#ifndef _LIB_BUILD
asm("INDF1 equ 01h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned INDF1                  :8;
    };
} INDF1bits_t;
extern volatile INDF1bits_t INDF1bits @ 0x001;
// bitfield macros
#define _INDF1_INDF1_POSN                                   0x0
#define _INDF1_INDF1_POSITION                               0x0
#define _INDF1_INDF1_SIZE                                   0x8
#define _INDF1_INDF1_LENGTH                                 0x8
#define _INDF1_INDF1_MASK                                   0xFF

// Register: PCL
extern volatile unsigned char           PCL                 @ 0x002;
#ifndef _LIB_BUILD
asm("PCL equ 02h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PCL                    :8;
    };
} PCLbits_t;
extern volatile PCLbits_t PCLbits @ 0x002;
// bitfield macros
#define _PCL_PCL_POSN                                       0x0
#define _PCL_PCL_POSITION                                   0x0
#define _PCL_PCL_SIZE                                       0x8
#define _PCL_PCL_LENGTH                                     0x8
#define _PCL_PCL_MASK                                       0xFF

// Register: STATUS
extern volatile unsigned char           STATUS              @ 0x003;
#ifndef _LIB_BUILD
asm("STATUS equ 03h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned C                      :1;
        unsigned DC                     :1;
        unsigned Z                      :1;
        unsigned nPD                    :1;
        unsigned nTO                    :1;
    };
    struct {
        unsigned CARRY                  :1;
    };
    struct {
        unsigned                        :2;
        unsigned ZERO                   :1;
    };
} STATUSbits_t;
extern volatile STATUSbits_t STATUSbits @ 0x003;
// bitfield macros
#define _STATUS_C_POSN                                      0x0
#define _STATUS_C_POSITION                                  0x0
#define _STATUS_C_SIZE                                      0x1
#define _STATUS_C_LENGTH                                    0x1
#define _STATUS_C_MASK                                      0x1
#define _STATUS_DC_POSN                                     0x1
#define _STATUS_DC_POSITION                                 0x1
#define _STATUS_DC_SIZE                                     0x1
#define _STATUS_DC_LENGTH                                   0x1
#define _STATUS_DC_MASK                                     0x2
#define _STATUS_Z_POSN                                      0x2
#define _STATUS_Z_POSITION                                  0x2
#define _STATUS_Z_SIZE                                      0x1
#define _STATUS_Z_LENGTH                                    0x1
#define _STATUS_Z_MASK                                      0x4
#define _STATUS_nPD_POSN                                    0x3
#define _STATUS_nPD_POSITION                                0x3
#define _STATUS_nPD_SIZE                                    0x1
#define _STATUS_nPD_LENGTH                                  0x1
#define _STATUS_nPD_MASK                                    0x8
#define _STATUS_nTO_POSN                                    0x4
#define _STATUS_nTO_POSITION                                0x4
#define _STATUS_nTO_SIZE                                    0x1
#define _STATUS_nTO_LENGTH                                  0x1
#define _STATUS_nTO_MASK                                    0x10
#define _STATUS_CARRY_POSN                                  0x0
#define _STATUS_CARRY_POSITION                              0x0
#define _STATUS_CARRY_SIZE                                  0x1
#define _STATUS_CARRY_LENGTH                                0x1
#define _STATUS_CARRY_MASK                                  0x1
#define _STATUS_ZERO_POSN                                   0x2
#define _STATUS_ZERO_POSITION                               0x2
#define _STATUS_ZERO_SIZE                                   0x1
#define _STATUS_ZERO_LENGTH                                 0x1
#define _STATUS_ZERO_MASK                                   0x4

// Register: FSR0
extern volatile unsigned short          FSR0                @ 0x004;

// Register: FSR0L
extern volatile unsigned char           FSR0L               @ 0x004;
#ifndef _LIB_BUILD
asm("FSR0L equ 04h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned FSR0L                  :8;
    };
} FSR0Lbits_t;
extern volatile FSR0Lbits_t FSR0Lbits @ 0x004;
// bitfield macros
#define _FSR0L_FSR0L_POSN                                   0x0
#define _FSR0L_FSR0L_POSITION                               0x0
#define _FSR0L_FSR0L_SIZE                                   0x8
#define _FSR0L_FSR0L_LENGTH                                 0x8
#define _FSR0L_FSR0L_MASK                                   0xFF

// Register: FSR0H
extern volatile unsigned char           FSR0H               @ 0x005;
#ifndef _LIB_BUILD
asm("FSR0H equ 05h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned FSR0H                  :8;
    };
} FSR0Hbits_t;
extern volatile FSR0Hbits_t FSR0Hbits @ 0x005;
// bitfield macros
#define _FSR0H_FSR0H_POSN                                   0x0
#define _FSR0H_FSR0H_POSITION                               0x0
#define _FSR0H_FSR0H_SIZE                                   0x8
#define _FSR0H_FSR0H_LENGTH                                 0x8
#define _FSR0H_FSR0H_MASK                                   0xFF

// Register: FSR1
extern volatile unsigned short          FSR1                @ 0x006;

// Register: FSR1L
extern volatile unsigned char           FSR1L               @ 0x006;
#ifndef _LIB_BUILD
asm("FSR1L equ 06h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned FSR1L                  :8;
    };
} FSR1Lbits_t;
extern volatile FSR1Lbits_t FSR1Lbits @ 0x006;
// bitfield macros
#define _FSR1L_FSR1L_POSN                                   0x0
#define _FSR1L_FSR1L_POSITION                               0x0
#define _FSR1L_FSR1L_SIZE                                   0x8
#define _FSR1L_FSR1L_LENGTH                                 0x8
#define _FSR1L_FSR1L_MASK                                   0xFF

// Register: FSR1H
extern volatile unsigned char           FSR1H               @ 0x007;
#ifndef _LIB_BUILD
asm("FSR1H equ 07h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned FSR1H                  :8;
    };
} FSR1Hbits_t;
extern volatile FSR1Hbits_t FSR1Hbits @ 0x007;
// bitfield macros
#define _FSR1H_FSR1H_POSN                                   0x0
#define _FSR1H_FSR1H_POSITION                               0x0
#define _FSR1H_FSR1H_SIZE                                   0x8
#define _FSR1H_FSR1H_LENGTH                                 0x8
#define _FSR1H_FSR1H_MASK                                   0xFF

// Register: BSR
extern volatile unsigned char           BSR                 @ 0x008;
#ifndef _LIB_BUILD
asm("BSR equ 08h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned BSR                    :5;
    };
    struct {
        unsigned BSR0                   :1;
        unsigned BSR1                   :1;
        unsigned BSR2                   :1;
        unsigned BSR3                   :1;
        unsigned BSR4                   :1;
    };
} BSRbits_t;
extern volatile BSRbits_t BSRbits @ 0x008;
// bitfield macros
#define _BSR_BSR_POSN                                       0x0
#define _BSR_BSR_POSITION                                   0x0
#define _BSR_BSR_SIZE                                       0x5
#define _BSR_BSR_LENGTH                                     0x5
#define _BSR_BSR_MASK                                       0x1F
#define _BSR_BSR0_POSN                                      0x0
#define _BSR_BSR0_POSITION                                  0x0
#define _BSR_BSR0_SIZE                                      0x1
#define _BSR_BSR0_LENGTH                                    0x1
#define _BSR_BSR0_MASK                                      0x1
#define _BSR_BSR1_POSN                                      0x1
#define _BSR_BSR1_POSITION                                  0x1
#define _BSR_BSR1_SIZE                                      0x1
#define _BSR_BSR1_LENGTH                                    0x1
#define _BSR_BSR1_MASK                                      0x2
#define _BSR_BSR2_POSN                                      0x2
#define _BSR_BSR2_POSITION                                  0x2
#define _BSR_BSR2_SIZE                                      0x1
#define _BSR_BSR2_LENGTH                                    0x1
#define _BSR_BSR2_MASK                                      0x4
#define _BSR_BSR3_POSN                                      0x3
#define _BSR_BSR3_POSITION                                  0x3
#define _BSR_BSR3_SIZE                                      0x1
#define _BSR_BSR3_LENGTH                                    0x1
#define _BSR_BSR3_MASK                                      0x8
#define _BSR_BSR4_POSN                                      0x4
#define _BSR_BSR4_POSITION                                  0x4
#define _BSR_BSR4_SIZE                                      0x1
#define _BSR_BSR4_LENGTH                                    0x1
#define _BSR_BSR4_MASK                                      0x10

// Register: WREG
extern volatile unsigned char           WREG                @ 0x009;
#ifndef _LIB_BUILD
asm("WREG equ 09h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned WREG0                  :8;
    };
} WREGbits_t;
extern volatile WREGbits_t WREGbits @ 0x009;
// bitfield macros
#define _WREG_WREG0_POSN                                    0x0
#define _WREG_WREG0_POSITION                                0x0
#define _WREG_WREG0_SIZE                                    0x8
#define _WREG_WREG0_LENGTH                                  0x8
#define _WREG_WREG0_MASK                                    0xFF

// Register: PCLATH
extern volatile unsigned char           PCLATH              @ 0x00A;
#ifndef _LIB_BUILD
asm("PCLATH equ 0Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PCLATH                 :7;
    };
} PCLATHbits_t;
extern volatile PCLATHbits_t PCLATHbits @ 0x00A;
// bitfield macros
#define _PCLATH_PCLATH_POSN                                 0x0
#define _PCLATH_PCLATH_POSITION                             0x0
#define _PCLATH_PCLATH_SIZE                                 0x7
#define _PCLATH_PCLATH_LENGTH                               0x7
#define _PCLATH_PCLATH_MASK                                 0x7F

// Register: INTCON
extern volatile unsigned char           INTCON              @ 0x00B;
#ifndef _LIB_BUILD
asm("INTCON equ 0Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned IOCIF                  :1;
        unsigned INTF                   :1;
        unsigned TMR0IF                 :1;
        unsigned IOCIE                  :1;
        unsigned INTE                   :1;
        unsigned TMR0IE                 :1;
        unsigned PEIE                   :1;
        unsigned GIE                    :1;
    };
    struct {
        unsigned                        :2;
        unsigned T0IF                   :1;
        unsigned                        :2;
        unsigned T0IE                   :1;
    };
} INTCONbits_t;
extern volatile INTCONbits_t INTCONbits @ 0x00B;
// bitfield macros
#define _INTCON_IOCIF_POSN                                  0x0
#define _INTCON_IOCIF_POSITION                              0x0
#define _INTCON_IOCIF_SIZE                                  0x1
#define _INTCON_IOCIF_LENGTH                                0x1
#define _INTCON_IOCIF_MASK                                  0x1
#define _INTCON_INTF_POSN                                   0x1
#define _INTCON_INTF_POSITION                               0x1
#define _INTCON_INTF_SIZE                                   0x1
#define _INTCON_INTF_LENGTH                                 0x1
#define _INTCON_INTF_MASK                                   0x2
#define _INTCON_TMR0IF_POSN                                 0x2
#define _INTCON_TMR0IF_POSITION                             0x2
#define _INTCON_TMR0IF_SIZE                                 0x1
#define _INTCON_TMR0IF_LENGTH                               0x1
#define _INTCON_TMR0IF_MASK                                 0x4
#define _INTCON_IOCIE_POSN                                  0x3
#define _INTCON_IOCIE_POSITION                              0x3
#define _INTCON_IOCIE_SIZE                                  0x1
#define _INTCON_IOCIE_LENGTH                                0x1
#define _INTCON_IOCIE_MASK                                  0x8
#define _INTCON_INTE_POSN                                   0x4
#define _INTCON_INTE_POSITION                               0x4
#define _INTCON_INTE_SIZE                                   0x1
#define _INTCON_INTE_LENGTH                                 0x1
#define _INTCON_INTE_MASK                                   0x10
#define _INTCON_TMR0IE_POSN                                 0x5
#define _INTCON_TMR0IE_POSITION                             0x5
#define _INTCON_TMR0IE_SIZE                                 0x1
#define _INTCON_TMR0IE_LENGTH                               0x1
#define _INTCON_TMR0IE_MASK                                 0x20
#define _INTCON_PEIE_POSN                                   0x6
#define _INTCON_PEIE_POSITION                               0x6
#define _INTCON_PEIE_SIZE                                   0x1
#define _INTCON_PEIE_LENGTH                                 0x1
#define _INTCON_PEIE_MASK                                   0x40
#define _INTCON_GIE_POSN                                    0x7
#define _INTCON_GIE_POSITION                                0x7
#define _INTCON_GIE_SIZE                                    0x1
#define _INTCON_GIE_LENGTH                                  0x1
#define _INTCON_GIE_MASK                                    0x80
#define _INTCON_T0IF_POSN                                   0x2
#define _INTCON_T0IF_POSITION                               0x2
#define _INTCON_T0IF_SIZE                                   0x1
#define _INTCON_T0IF_LENGTH                                 0x1
#define _INTCON_T0IF_MASK                                   0x4
#define _INTCON_T0IE_POSN                                   0x5
#define _INTCON_T0IE_POSITION                               0x5
#define _INTCON_T0IE_SIZE                                   0x1
#define _INTCON_T0IE_LENGTH                                 0x1
#define _INTCON_T0IE_MASK                                   0x20

// Register: PORTA
extern volatile unsigned char           PORTA               @ 0x00C;
#ifndef _LIB_BUILD
asm("PORTA equ 0Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RA0                    :1;
        unsigned RA1                    :1;
        unsigned RA2                    :1;
        unsigned RA3                    :1;
        unsigned RA4                    :1;
        unsigned RA5                    :1;
    };
} PORTAbits_t;
extern volatile PORTAbits_t PORTAbits @ 0x00C;
// bitfield macros
#define _PORTA_RA0_POSN                                     0x0
#define _PORTA_RA0_POSITION                                 0x0
#define _PORTA_RA0_SIZE                                     0x1
#define _PORTA_RA0_LENGTH                                   0x1
#define _PORTA_RA0_MASK                                     0x1
#define _PORTA_RA1_POSN                                     0x1
#define _PORTA_RA1_POSITION                                 0x1
#define _PORTA_RA1_SIZE                                     0x1
#define _PORTA_RA1_LENGTH                                   0x1
#define _PORTA_RA1_MASK                                     0x2
#define _PORTA_RA2_POSN                                     0x2
#define _PORTA_RA2_POSITION                                 0x2
#define _PORTA_RA2_SIZE                                     0x1
#define _PORTA_RA2_LENGTH                                   0x1
#define _PORTA_RA2_MASK                                     0x4
#define _PORTA_RA3_POSN                                     0x3
#define _PORTA_RA3_POSITION                                 0x3
#define _PORTA_RA3_SIZE                                     0x1
#define _PORTA_RA3_LENGTH                                   0x1
#define _PORTA_RA3_MASK                                     0x8
#define _PORTA_RA4_POSN                                     0x4
#define _PORTA_RA4_POSITION                                 0x4
#define _PORTA_RA4_SIZE                                     0x1
#define _PORTA_RA4_LENGTH                                   0x1
#define _PORTA_RA4_MASK                                     0x10
#define _PORTA_RA5_POSN                                     0x5
#define _PORTA_RA5_POSITION                                 0x5
#define _PORTA_RA5_SIZE                                     0x1
#define _PORTA_RA5_LENGTH                                   0x1
#define _PORTA_RA5_MASK                                     0x20

// Register: PORTB
extern volatile unsigned char           PORTB               @ 0x00D;
#ifndef _LIB_BUILD
asm("PORTB equ 0Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned RB4                    :1;
        unsigned RB5                    :1;
        unsigned RB6                    :1;
        unsigned RB7                    :1;
    };
} PORTBbits_t;
extern volatile PORTBbits_t PORTBbits @ 0x00D;
// bitfield macros
#define _PORTB_RB4_POSN                                     0x4
#define _PORTB_RB4_POSITION                                 0x4
#define _PORTB_RB4_SIZE                                     0x1
#define _PORTB_RB4_LENGTH                                   0x1
#define _PORTB_RB4_MASK                                     0x10
#define _PORTB_RB5_POSN                                     0x5
#define _PORTB_RB5_POSITION                                 0x5
#define _PORTB_RB5_SIZE                                     0x1
#define _PORTB_RB5_LENGTH                                   0x1
#define _PORTB_RB5_MASK                                     0x20
#define _PORTB_RB6_POSN                                     0x6
#define _PORTB_RB6_POSITION                                 0x6
#define _PORTB_RB6_SIZE                                     0x1
#define _PORTB_RB6_LENGTH                                   0x1
#define _PORTB_RB6_MASK                                     0x40
#define _PORTB_RB7_POSN                                     0x7
#define _PORTB_RB7_POSITION                                 0x7
#define _PORTB_RB7_SIZE                                     0x1
#define _PORTB_RB7_LENGTH                                   0x1
#define _PORTB_RB7_MASK                                     0x80

// Register: PORTC
extern volatile unsigned char           PORTC               @ 0x00E;
#ifndef _LIB_BUILD
asm("PORTC equ 0Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RC0                    :1;
        unsigned RC1                    :1;
        unsigned RC2                    :1;
        unsigned RC3                    :1;
        unsigned RC4                    :1;
        unsigned RC5                    :1;
        unsigned RC6                    :1;
        unsigned RC7                    :1;
    };
} PORTCbits_t;
extern volatile PORTCbits_t PORTCbits @ 0x00E;
// bitfield macros
#define _PORTC_RC0_POSN                                     0x0
#define _PORTC_RC0_POSITION                                 0x0
#define _PORTC_RC0_SIZE                                     0x1
#define _PORTC_RC0_LENGTH                                   0x1
#define _PORTC_RC0_MASK                                     0x1
#define _PORTC_RC1_POSN                                     0x1
#define _PORTC_RC1_POSITION                                 0x1
#define _PORTC_RC1_SIZE                                     0x1
#define _PORTC_RC1_LENGTH                                   0x1
#define _PORTC_RC1_MASK                                     0x2
#define _PORTC_RC2_POSN                                     0x2
#define _PORTC_RC2_POSITION                                 0x2
#define _PORTC_RC2_SIZE                                     0x1
#define _PORTC_RC2_LENGTH                                   0x1
#define _PORTC_RC2_MASK                                     0x4
#define _PORTC_RC3_POSN                                     0x3
#define _PORTC_RC3_POSITION                                 0x3
#define _PORTC_RC3_SIZE                                     0x1
#define _PORTC_RC3_LENGTH                                   0x1
#define _PORTC_RC3_MASK                                     0x8
#define _PORTC_RC4_POSN                                     0x4
#define _PORTC_RC4_POSITION                                 0x4
#define _PORTC_RC4_SIZE                                     0x1
#define _PORTC_RC4_LENGTH                                   0x1
#define _PORTC_RC4_MASK                                     0x10
#define _PORTC_RC5_POSN                                     0x5
#define _PORTC_RC5_POSITION                                 0x5
#define _PORTC_RC5_SIZE                                     0x1
#define _PORTC_RC5_LENGTH                                   0x1
#define _PORTC_RC5_MASK                                     0x20
#define _PORTC_RC6_POSN                                     0x6
#define _PORTC_RC6_POSITION                                 0x6
#define _PORTC_RC6_SIZE                                     0x1
#define _PORTC_RC6_LENGTH                                   0x1
#define _PORTC_RC6_MASK                                     0x40
#define _PORTC_RC7_POSN                                     0x7
#define _PORTC_RC7_POSITION                                 0x7
#define _PORTC_RC7_SIZE                                     0x1
#define _PORTC_RC7_LENGTH                                   0x1
#define _PORTC_RC7_MASK                                     0x80

// Register: PIR1
extern volatile unsigned char           PIR1                @ 0x010;
#ifndef _LIB_BUILD
asm("PIR1 equ 010h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR1IF                 :1;
        unsigned TMR2IF                 :1;
        unsigned CCP1IF                 :1;
        unsigned SSP1IF                 :1;
        unsigned TXIF                   :1;
        unsigned RCIF                   :1;
        unsigned ADIF                   :1;
        unsigned TMR1GIF                :1;
    };
} PIR1bits_t;
extern volatile PIR1bits_t PIR1bits @ 0x010;
// bitfield macros
#define _PIR1_TMR1IF_POSN                                   0x0
#define _PIR1_TMR1IF_POSITION                               0x0
#define _PIR1_TMR1IF_SIZE                                   0x1
#define _PIR1_TMR1IF_LENGTH                                 0x1
#define _PIR1_TMR1IF_MASK                                   0x1
#define _PIR1_TMR2IF_POSN                                   0x1
#define _PIR1_TMR2IF_POSITION                               0x1
#define _PIR1_TMR2IF_SIZE                                   0x1
#define _PIR1_TMR2IF_LENGTH                                 0x1
#define _PIR1_TMR2IF_MASK                                   0x2
#define _PIR1_CCP1IF_POSN                                   0x2
#define _PIR1_CCP1IF_POSITION                               0x2
#define _PIR1_CCP1IF_SIZE                                   0x1
#define _PIR1_CCP1IF_LENGTH                                 0x1
#define _PIR1_CCP1IF_MASK                                   0x4
#define _PIR1_SSP1IF_POSN                                   0x3
#define _PIR1_SSP1IF_POSITION                               0x3
#define _PIR1_SSP1IF_SIZE                                   0x1
#define _PIR1_SSP1IF_LENGTH                                 0x1
#define _PIR1_SSP1IF_MASK                                   0x8
#define _PIR1_TXIF_POSN                                     0x4
#define _PIR1_TXIF_POSITION                                 0x4
#define _PIR1_TXIF_SIZE                                     0x1
#define _PIR1_TXIF_LENGTH                                   0x1
#define _PIR1_TXIF_MASK                                     0x10
#define _PIR1_RCIF_POSN                                     0x5
#define _PIR1_RCIF_POSITION                                 0x5
#define _PIR1_RCIF_SIZE                                     0x1
#define _PIR1_RCIF_LENGTH                                   0x1
#define _PIR1_RCIF_MASK                                     0x20
#define _PIR1_ADIF_POSN                                     0x6
#define _PIR1_ADIF_POSITION                                 0x6
#define _PIR1_ADIF_SIZE                                     0x1
#define _PIR1_ADIF_LENGTH                                   0x1
#define _PIR1_ADIF_MASK                                     0x40
#define _PIR1_TMR1GIF_POSN                                  0x7
#define _PIR1_TMR1GIF_POSITION                              0x7
#define _PIR1_TMR1GIF_SIZE                                  0x1
#define _PIR1_TMR1GIF_LENGTH                                0x1
#define _PIR1_TMR1GIF_MASK                                  0x80

// Register: PIR2
extern volatile unsigned char           PIR2                @ 0x011;
#ifndef _LIB_BUILD
asm("PIR2 equ 011h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CCP2IF                 :1;
        unsigned TMR4IF                 :1;
        unsigned TMR6IF                 :1;
        unsigned BCL1IF                 :1;
        unsigned                        :1;
        unsigned C1IF                   :1;
        unsigned C2IF                   :1;
        unsigned OSFIF                  :1;
    };
} PIR2bits_t;
extern volatile PIR2bits_t PIR2bits @ 0x011;
// bitfield macros
#define _PIR2_CCP2IF_POSN                                   0x0
#define _PIR2_CCP2IF_POSITION                               0x0
#define _PIR2_CCP2IF_SIZE                                   0x1
#define _PIR2_CCP2IF_LENGTH                                 0x1
#define _PIR2_CCP2IF_MASK                                   0x1
#define _PIR2_TMR4IF_POSN                                   0x1
#define _PIR2_TMR4IF_POSITION                               0x1
#define _PIR2_TMR4IF_SIZE                                   0x1
#define _PIR2_TMR4IF_LENGTH                                 0x1
#define _PIR2_TMR4IF_MASK                                   0x2
#define _PIR2_TMR6IF_POSN                                   0x2
#define _PIR2_TMR6IF_POSITION                               0x2
#define _PIR2_TMR6IF_SIZE                                   0x1
#define _PIR2_TMR6IF_LENGTH                                 0x1
#define _PIR2_TMR6IF_MASK                                   0x4
#define _PIR2_BCL1IF_POSN                                   0x3
#define _PIR2_BCL1IF_POSITION                               0x3
#define _PIR2_BCL1IF_SIZE                                   0x1
#define _PIR2_BCL1IF_LENGTH                                 0x1
#define _PIR2_BCL1IF_MASK                                   0x8
#define _PIR2_C1IF_POSN                                     0x5
#define _PIR2_C1IF_POSITION                                 0x5
#define _PIR2_C1IF_SIZE                                     0x1
#define _PIR2_C1IF_LENGTH                                   0x1
#define _PIR2_C1IF_MASK                                     0x20
#define _PIR2_C2IF_POSN                                     0x6
#define _PIR2_C2IF_POSITION                                 0x6
#define _PIR2_C2IF_SIZE                                     0x1
#define _PIR2_C2IF_LENGTH                                   0x1
#define _PIR2_C2IF_MASK                                     0x40
#define _PIR2_OSFIF_POSN                                    0x7
#define _PIR2_OSFIF_POSITION                                0x7
#define _PIR2_OSFIF_SIZE                                    0x1
#define _PIR2_OSFIF_LENGTH                                  0x1
#define _PIR2_OSFIF_MASK                                    0x80

// Register: PIR3
extern volatile unsigned char           PIR3                @ 0x012;
#ifndef _LIB_BUILD
asm("PIR3 equ 012h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CLC1IF                 :1;
        unsigned CLC2IF                 :1;
        unsigned CLC3IF                 :1;
        unsigned CLC4IF                 :1;
        unsigned ZCDIF                  :1;
        unsigned CWGIF                  :1;
    };
} PIR3bits_t;
extern volatile PIR3bits_t PIR3bits @ 0x012;
// bitfield macros
#define _PIR3_CLC1IF_POSN                                   0x0
#define _PIR3_CLC1IF_POSITION                               0x0
#define _PIR3_CLC1IF_SIZE                                   0x1
#define _PIR3_CLC1IF_LENGTH                                 0x1
#define _PIR3_CLC1IF_MASK                                   0x1
#define _PIR3_CLC2IF_POSN                                   0x1
#define _PIR3_CLC2IF_POSITION                               0x1
#define _PIR3_CLC2IF_SIZE                                   0x1
#define _PIR3_CLC2IF_LENGTH                                 0x1
#define _PIR3_CLC2IF_MASK                                   0x2
#define _PIR3_CLC3IF_POSN                                   0x2
#define _PIR3_CLC3IF_POSITION                               0x2
#define _PIR3_CLC3IF_SIZE                                   0x1
#define _PIR3_CLC3IF_LENGTH                                 0x1
#define _PIR3_CLC3IF_MASK                                   0x4
#define _PIR3_CLC4IF_POSN                                   0x3
#define _PIR3_CLC4IF_POSITION                               0x3
#define _PIR3_CLC4IF_SIZE                                   0x1
#define _PIR3_CLC4IF_LENGTH                                 0x1
#define _PIR3_CLC4IF_MASK                                   0x8
#define _PIR3_ZCDIF_POSN                                    0x4
#define _PIR3_ZCDIF_POSITION                                0x4
#define _PIR3_ZCDIF_SIZE                                    0x1
#define _PIR3_ZCDIF_LENGTH                                  0x1
#define _PIR3_ZCDIF_MASK                                    0x10
#define _PIR3_CWGIF_POSN                                    0x5
#define _PIR3_CWGIF_POSITION                                0x5
#define _PIR3_CWGIF_SIZE                                    0x1
#define _PIR3_CWGIF_LENGTH                                  0x1
#define _PIR3_CWGIF_MASK                                    0x20

// Register: PIR4
extern volatile unsigned char           PIR4                @ 0x013;
#ifndef _LIB_BUILD
asm("PIR4 equ 013h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1IF                 :1;
        unsigned SMT1PRAIF              :1;
        unsigned SMT1PWAIF              :1;
        unsigned SMT2IF                 :1;
        unsigned SMT2PRAIF              :1;
        unsigned SMT2PWAIF              :1;
        unsigned CRCIF                  :1;
        unsigned SCANIF                 :1;
    };
} PIR4bits_t;
extern volatile PIR4bits_t PIR4bits @ 0x013;
// bitfield macros
#define _PIR4_SMT1IF_POSN                                   0x0
#define _PIR4_SMT1IF_POSITION                               0x0
#define _PIR4_SMT1IF_SIZE                                   0x1
#define _PIR4_SMT1IF_LENGTH                                 0x1
#define _PIR4_SMT1IF_MASK                                   0x1
#define _PIR4_SMT1PRAIF_POSN                                0x1
#define _PIR4_SMT1PRAIF_POSITION                            0x1
#define _PIR4_SMT1PRAIF_SIZE                                0x1
#define _PIR4_SMT1PRAIF_LENGTH                              0x1
#define _PIR4_SMT1PRAIF_MASK                                0x2
#define _PIR4_SMT1PWAIF_POSN                                0x2
#define _PIR4_SMT1PWAIF_POSITION                            0x2
#define _PIR4_SMT1PWAIF_SIZE                                0x1
#define _PIR4_SMT1PWAIF_LENGTH                              0x1
#define _PIR4_SMT1PWAIF_MASK                                0x4
#define _PIR4_SMT2IF_POSN                                   0x3
#define _PIR4_SMT2IF_POSITION                               0x3
#define _PIR4_SMT2IF_SIZE                                   0x1
#define _PIR4_SMT2IF_LENGTH                                 0x1
#define _PIR4_SMT2IF_MASK                                   0x8
#define _PIR4_SMT2PRAIF_POSN                                0x4
#define _PIR4_SMT2PRAIF_POSITION                            0x4
#define _PIR4_SMT2PRAIF_SIZE                                0x1
#define _PIR4_SMT2PRAIF_LENGTH                              0x1
#define _PIR4_SMT2PRAIF_MASK                                0x10
#define _PIR4_SMT2PWAIF_POSN                                0x5
#define _PIR4_SMT2PWAIF_POSITION                            0x5
#define _PIR4_SMT2PWAIF_SIZE                                0x1
#define _PIR4_SMT2PWAIF_LENGTH                              0x1
#define _PIR4_SMT2PWAIF_MASK                                0x20
#define _PIR4_CRCIF_POSN                                    0x6
#define _PIR4_CRCIF_POSITION                                0x6
#define _PIR4_CRCIF_SIZE                                    0x1
#define _PIR4_CRCIF_LENGTH                                  0x1
#define _PIR4_CRCIF_MASK                                    0x40
#define _PIR4_SCANIF_POSN                                   0x7
#define _PIR4_SCANIF_POSITION                               0x7
#define _PIR4_SCANIF_SIZE                                   0x1
#define _PIR4_SCANIF_LENGTH                                 0x1
#define _PIR4_SCANIF_MASK                                   0x80

// Register: PIR5
extern volatile unsigned char           PIR5                @ 0x014;
#ifndef _LIB_BUILD
asm("PIR5 equ 014h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1DIF                :1;
        unsigned PID1EIF                :1;
        unsigned AT1IF                  :1;
        unsigned                        :1;
        unsigned TMR5IF                 :1;
        unsigned TMR5GIF                :1;
        unsigned TMR3IF                 :1;
        unsigned TMR3GIF                :1;
    };
} PIR5bits_t;
extern volatile PIR5bits_t PIR5bits @ 0x014;
// bitfield macros
#define _PIR5_PID1DIF_POSN                                  0x0
#define _PIR5_PID1DIF_POSITION                              0x0
#define _PIR5_PID1DIF_SIZE                                  0x1
#define _PIR5_PID1DIF_LENGTH                                0x1
#define _PIR5_PID1DIF_MASK                                  0x1
#define _PIR5_PID1EIF_POSN                                  0x1
#define _PIR5_PID1EIF_POSITION                              0x1
#define _PIR5_PID1EIF_SIZE                                  0x1
#define _PIR5_PID1EIF_LENGTH                                0x1
#define _PIR5_PID1EIF_MASK                                  0x2
#define _PIR5_AT1IF_POSN                                    0x2
#define _PIR5_AT1IF_POSITION                                0x2
#define _PIR5_AT1IF_SIZE                                    0x1
#define _PIR5_AT1IF_LENGTH                                  0x1
#define _PIR5_AT1IF_MASK                                    0x4
#define _PIR5_TMR5IF_POSN                                   0x4
#define _PIR5_TMR5IF_POSITION                               0x4
#define _PIR5_TMR5IF_SIZE                                   0x1
#define _PIR5_TMR5IF_LENGTH                                 0x1
#define _PIR5_TMR5IF_MASK                                   0x10
#define _PIR5_TMR5GIF_POSN                                  0x5
#define _PIR5_TMR5GIF_POSITION                              0x5
#define _PIR5_TMR5GIF_SIZE                                  0x1
#define _PIR5_TMR5GIF_LENGTH                                0x1
#define _PIR5_TMR5GIF_MASK                                  0x20
#define _PIR5_TMR3IF_POSN                                   0x6
#define _PIR5_TMR3IF_POSITION                               0x6
#define _PIR5_TMR3IF_SIZE                                   0x1
#define _PIR5_TMR3IF_LENGTH                                 0x1
#define _PIR5_TMR3IF_MASK                                   0x40
#define _PIR5_TMR3GIF_POSN                                  0x7
#define _PIR5_TMR3GIF_POSITION                              0x7
#define _PIR5_TMR3GIF_SIZE                                  0x1
#define _PIR5_TMR3GIF_LENGTH                                0x1
#define _PIR5_TMR3GIF_MASK                                  0x80

// Register: TMR0
extern volatile unsigned char           TMR0                @ 0x015;
#ifndef _LIB_BUILD
asm("TMR0 equ 015h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR0                   :8;
    };
} TMR0bits_t;
extern volatile TMR0bits_t TMR0bits @ 0x015;
// bitfield macros
#define _TMR0_TMR0_POSN                                     0x0
#define _TMR0_TMR0_POSITION                                 0x0
#define _TMR0_TMR0_SIZE                                     0x8
#define _TMR0_TMR0_LENGTH                                   0x8
#define _TMR0_TMR0_MASK                                     0xFF

// Register: TMR1
extern volatile unsigned short          TMR1                @ 0x016;
#ifndef _LIB_BUILD
asm("TMR1 equ 016h");
#endif

// Register: TMR1L
extern volatile unsigned char           TMR1L               @ 0x016;
#ifndef _LIB_BUILD
asm("TMR1L equ 016h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR1L                  :8;
    };
} TMR1Lbits_t;
extern volatile TMR1Lbits_t TMR1Lbits @ 0x016;
// bitfield macros
#define _TMR1L_TMR1L_POSN                                   0x0
#define _TMR1L_TMR1L_POSITION                               0x0
#define _TMR1L_TMR1L_SIZE                                   0x8
#define _TMR1L_TMR1L_LENGTH                                 0x8
#define _TMR1L_TMR1L_MASK                                   0xFF

// Register: TMR1H
extern volatile unsigned char           TMR1H               @ 0x017;
#ifndef _LIB_BUILD
asm("TMR1H equ 017h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR1H                  :8;
    };
} TMR1Hbits_t;
extern volatile TMR1Hbits_t TMR1Hbits @ 0x017;
// bitfield macros
#define _TMR1H_TMR1H_POSN                                   0x0
#define _TMR1H_TMR1H_POSITION                               0x0
#define _TMR1H_TMR1H_SIZE                                   0x8
#define _TMR1H_TMR1H_LENGTH                                 0x8
#define _TMR1H_TMR1H_MASK                                   0xFF

// Register: T1CON
extern volatile unsigned char           T1CON               @ 0x018;
#ifndef _LIB_BUILD
asm("T1CON equ 018h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR1ON                 :1;
        unsigned                        :1;
        unsigned nT1SYNC                :1;
        unsigned                        :1;
        unsigned T1CKPS                 :2;
        unsigned TMR1CS                 :2;
    };
    struct {
        unsigned                        :4;
        unsigned T1CKPS0                :1;
        unsigned T1CKPS1                :1;
        unsigned TMR1CS0                :1;
        unsigned TMR1CS1                :1;
    };
} T1CONbits_t;
extern volatile T1CONbits_t T1CONbits @ 0x018;
// bitfield macros
#define _T1CON_TMR1ON_POSN                                  0x0
#define _T1CON_TMR1ON_POSITION                              0x0
#define _T1CON_TMR1ON_SIZE                                  0x1
#define _T1CON_TMR1ON_LENGTH                                0x1
#define _T1CON_TMR1ON_MASK                                  0x1
#define _T1CON_nT1SYNC_POSN                                 0x2
#define _T1CON_nT1SYNC_POSITION                             0x2
#define _T1CON_nT1SYNC_SIZE                                 0x1
#define _T1CON_nT1SYNC_LENGTH                               0x1
#define _T1CON_nT1SYNC_MASK                                 0x4
#define _T1CON_T1CKPS_POSN                                  0x4
#define _T1CON_T1CKPS_POSITION                              0x4
#define _T1CON_T1CKPS_SIZE                                  0x2
#define _T1CON_T1CKPS_LENGTH                                0x2
#define _T1CON_T1CKPS_MASK                                  0x30
#define _T1CON_TMR1CS_POSN                                  0x6
#define _T1CON_TMR1CS_POSITION                              0x6
#define _T1CON_TMR1CS_SIZE                                  0x2
#define _T1CON_TMR1CS_LENGTH                                0x2
#define _T1CON_TMR1CS_MASK                                  0xC0
#define _T1CON_T1CKPS0_POSN                                 0x4
#define _T1CON_T1CKPS0_POSITION                             0x4
#define _T1CON_T1CKPS0_SIZE                                 0x1
#define _T1CON_T1CKPS0_LENGTH                               0x1
#define _T1CON_T1CKPS0_MASK                                 0x10
#define _T1CON_T1CKPS1_POSN                                 0x5
#define _T1CON_T1CKPS1_POSITION                             0x5
#define _T1CON_T1CKPS1_SIZE                                 0x1
#define _T1CON_T1CKPS1_LENGTH                               0x1
#define _T1CON_T1CKPS1_MASK                                 0x20
#define _T1CON_TMR1CS0_POSN                                 0x6
#define _T1CON_TMR1CS0_POSITION                             0x6
#define _T1CON_TMR1CS0_SIZE                                 0x1
#define _T1CON_TMR1CS0_LENGTH                               0x1
#define _T1CON_TMR1CS0_MASK                                 0x40
#define _T1CON_TMR1CS1_POSN                                 0x7
#define _T1CON_TMR1CS1_POSITION                             0x7
#define _T1CON_TMR1CS1_SIZE                                 0x1
#define _T1CON_TMR1CS1_LENGTH                               0x1
#define _T1CON_TMR1CS1_MASK                                 0x80

// Register: T1GCON
extern volatile unsigned char           T1GCON              @ 0x019;
#ifndef _LIB_BUILD
asm("T1GCON equ 019h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T1GSS                  :2;
        unsigned T1GVAL                 :1;
        unsigned T1GGO_nDONE            :1;
        unsigned T1GSPM                 :1;
        unsigned T1GTM                  :1;
        unsigned T1GPOL                 :1;
        unsigned TMR1GE                 :1;
    };
    struct {
        unsigned T1GSS0                 :1;
        unsigned T1GSS1                 :1;
    };
} T1GCONbits_t;
extern volatile T1GCONbits_t T1GCONbits @ 0x019;
// bitfield macros
#define _T1GCON_T1GSS_POSN                                  0x0
#define _T1GCON_T1GSS_POSITION                              0x0
#define _T1GCON_T1GSS_SIZE                                  0x2
#define _T1GCON_T1GSS_LENGTH                                0x2
#define _T1GCON_T1GSS_MASK                                  0x3
#define _T1GCON_T1GVAL_POSN                                 0x2
#define _T1GCON_T1GVAL_POSITION                             0x2
#define _T1GCON_T1GVAL_SIZE                                 0x1
#define _T1GCON_T1GVAL_LENGTH                               0x1
#define _T1GCON_T1GVAL_MASK                                 0x4
#define _T1GCON_T1GGO_nDONE_POSN                            0x3
#define _T1GCON_T1GGO_nDONE_POSITION                        0x3
#define _T1GCON_T1GGO_nDONE_SIZE                            0x1
#define _T1GCON_T1GGO_nDONE_LENGTH                          0x1
#define _T1GCON_T1GGO_nDONE_MASK                            0x8
#define _T1GCON_T1GSPM_POSN                                 0x4
#define _T1GCON_T1GSPM_POSITION                             0x4
#define _T1GCON_T1GSPM_SIZE                                 0x1
#define _T1GCON_T1GSPM_LENGTH                               0x1
#define _T1GCON_T1GSPM_MASK                                 0x10
#define _T1GCON_T1GTM_POSN                                  0x5
#define _T1GCON_T1GTM_POSITION                              0x5
#define _T1GCON_T1GTM_SIZE                                  0x1
#define _T1GCON_T1GTM_LENGTH                                0x1
#define _T1GCON_T1GTM_MASK                                  0x20
#define _T1GCON_T1GPOL_POSN                                 0x6
#define _T1GCON_T1GPOL_POSITION                             0x6
#define _T1GCON_T1GPOL_SIZE                                 0x1
#define _T1GCON_T1GPOL_LENGTH                               0x1
#define _T1GCON_T1GPOL_MASK                                 0x40
#define _T1GCON_TMR1GE_POSN                                 0x7
#define _T1GCON_TMR1GE_POSITION                             0x7
#define _T1GCON_TMR1GE_SIZE                                 0x1
#define _T1GCON_TMR1GE_LENGTH                               0x1
#define _T1GCON_TMR1GE_MASK                                 0x80
#define _T1GCON_T1GSS0_POSN                                 0x0
#define _T1GCON_T1GSS0_POSITION                             0x0
#define _T1GCON_T1GSS0_SIZE                                 0x1
#define _T1GCON_T1GSS0_LENGTH                               0x1
#define _T1GCON_T1GSS0_MASK                                 0x1
#define _T1GCON_T1GSS1_POSN                                 0x1
#define _T1GCON_T1GSS1_POSITION                             0x1
#define _T1GCON_T1GSS1_SIZE                                 0x1
#define _T1GCON_T1GSS1_LENGTH                               0x1
#define _T1GCON_T1GSS1_MASK                                 0x2

// Register: T2TMR
extern volatile unsigned char           T2TMR               @ 0x01A;
#ifndef _LIB_BUILD
asm("T2TMR equ 01Ah");
#endif
// aliases
extern volatile unsigned char           TMR2                @ 0x01A;
#ifndef _LIB_BUILD
asm("TMR2 equ 01Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR                    :8;
    };
    struct {
        unsigned TMR2                   :8;
    };
} T2TMRbits_t;
extern volatile T2TMRbits_t T2TMRbits @ 0x01A;
// bitfield macros
#define _T2TMR_TMR_POSN                                     0x0
#define _T2TMR_TMR_POSITION                                 0x0
#define _T2TMR_TMR_SIZE                                     0x8
#define _T2TMR_TMR_LENGTH                                   0x8
#define _T2TMR_TMR_MASK                                     0xFF
#define _T2TMR_TMR2_POSN                                    0x0
#define _T2TMR_TMR2_POSITION                                0x0
#define _T2TMR_TMR2_SIZE                                    0x8
#define _T2TMR_TMR2_LENGTH                                  0x8
#define _T2TMR_TMR2_MASK                                    0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned TMR                    :8;
    };
    struct {
        unsigned TMR2                   :8;
    };
} TMR2bits_t;
extern volatile TMR2bits_t TMR2bits @ 0x01A;
// bitfield macros
#define _TMR2_TMR_POSN                                      0x0
#define _TMR2_TMR_POSITION                                  0x0
#define _TMR2_TMR_SIZE                                      0x8
#define _TMR2_TMR_LENGTH                                    0x8
#define _TMR2_TMR_MASK                                      0xFF
#define _TMR2_TMR2_POSN                                     0x0
#define _TMR2_TMR2_POSITION                                 0x0
#define _TMR2_TMR2_SIZE                                     0x8
#define _TMR2_TMR2_LENGTH                                   0x8
#define _TMR2_TMR2_MASK                                     0xFF

// Register: T2PR
extern volatile unsigned char           T2PR                @ 0x01B;
#ifndef _LIB_BUILD
asm("T2PR equ 01Bh");
#endif
// aliases
extern volatile unsigned char           PR2                 @ 0x01B;
#ifndef _LIB_BUILD
asm("PR2 equ 01Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PR                     :8;
    };
    struct {
        unsigned T2PR                   :8;
    };
} T2PRbits_t;
extern volatile T2PRbits_t T2PRbits @ 0x01B;
// bitfield macros
#define _T2PR_PR_POSN                                       0x0
#define _T2PR_PR_POSITION                                   0x0
#define _T2PR_PR_SIZE                                       0x8
#define _T2PR_PR_LENGTH                                     0x8
#define _T2PR_PR_MASK                                       0xFF
#define _T2PR_T2PR_POSN                                     0x0
#define _T2PR_T2PR_POSITION                                 0x0
#define _T2PR_T2PR_SIZE                                     0x8
#define _T2PR_T2PR_LENGTH                                   0x8
#define _T2PR_T2PR_MASK                                     0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned PR                     :8;
    };
    struct {
        unsigned T2PR                   :8;
    };
} PR2bits_t;
extern volatile PR2bits_t PR2bits @ 0x01B;
// bitfield macros
#define _PR2_PR_POSN                                        0x0
#define _PR2_PR_POSITION                                    0x0
#define _PR2_PR_SIZE                                        0x8
#define _PR2_PR_LENGTH                                      0x8
#define _PR2_PR_MASK                                        0xFF
#define _PR2_T2PR_POSN                                      0x0
#define _PR2_T2PR_POSITION                                  0x0
#define _PR2_T2PR_SIZE                                      0x8
#define _PR2_T2PR_LENGTH                                    0x8
#define _PR2_T2PR_MASK                                      0xFF

// Register: T2CON
extern volatile unsigned char           T2CON               @ 0x01C;
#ifndef _LIB_BUILD
asm("T2CON equ 01Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned OUTPS                  :4;
        unsigned CKPS                   :3;
        unsigned ON                     :1;
    };
    struct {
        unsigned OUTPS0                 :1;
        unsigned OUTPS1                 :1;
        unsigned OUTPS2                 :1;
        unsigned OUTPS3                 :1;
        unsigned CKPS0                  :1;
        unsigned CKPS1                  :1;
        unsigned CKPS2                  :1;
    };
    struct {
        unsigned T2OUTPS                :4;
        unsigned T2CKPS                 :3;
        unsigned T2ON                   :1;
    };
    struct {
        unsigned T2OUTPS0               :1;
        unsigned T2OUTPS1               :1;
        unsigned T2OUTPS2               :1;
        unsigned T2OUTPS3               :1;
        unsigned T2CKPS0                :1;
        unsigned T2CKPS1                :1;
        unsigned T2CKPS2                :1;
        unsigned TMR2ON                 :1;
    };
} T2CONbits_t;
extern volatile T2CONbits_t T2CONbits @ 0x01C;
// bitfield macros
#define _T2CON_OUTPS_POSN                                   0x0
#define _T2CON_OUTPS_POSITION                               0x0
#define _T2CON_OUTPS_SIZE                                   0x4
#define _T2CON_OUTPS_LENGTH                                 0x4
#define _T2CON_OUTPS_MASK                                   0xF
#define _T2CON_CKPS_POSN                                    0x4
#define _T2CON_CKPS_POSITION                                0x4
#define _T2CON_CKPS_SIZE                                    0x3
#define _T2CON_CKPS_LENGTH                                  0x3
#define _T2CON_CKPS_MASK                                    0x70
#define _T2CON_ON_POSN                                      0x7
#define _T2CON_ON_POSITION                                  0x7
#define _T2CON_ON_SIZE                                      0x1
#define _T2CON_ON_LENGTH                                    0x1
#define _T2CON_ON_MASK                                      0x80
#define _T2CON_OUTPS0_POSN                                  0x0
#define _T2CON_OUTPS0_POSITION                              0x0
#define _T2CON_OUTPS0_SIZE                                  0x1
#define _T2CON_OUTPS0_LENGTH                                0x1
#define _T2CON_OUTPS0_MASK                                  0x1
#define _T2CON_OUTPS1_POSN                                  0x1
#define _T2CON_OUTPS1_POSITION                              0x1
#define _T2CON_OUTPS1_SIZE                                  0x1
#define _T2CON_OUTPS1_LENGTH                                0x1
#define _T2CON_OUTPS1_MASK                                  0x2
#define _T2CON_OUTPS2_POSN                                  0x2
#define _T2CON_OUTPS2_POSITION                              0x2
#define _T2CON_OUTPS2_SIZE                                  0x1
#define _T2CON_OUTPS2_LENGTH                                0x1
#define _T2CON_OUTPS2_MASK                                  0x4
#define _T2CON_OUTPS3_POSN                                  0x3
#define _T2CON_OUTPS3_POSITION                              0x3
#define _T2CON_OUTPS3_SIZE                                  0x1
#define _T2CON_OUTPS3_LENGTH                                0x1
#define _T2CON_OUTPS3_MASK                                  0x8
#define _T2CON_CKPS0_POSN                                   0x4
#define _T2CON_CKPS0_POSITION                               0x4
#define _T2CON_CKPS0_SIZE                                   0x1
#define _T2CON_CKPS0_LENGTH                                 0x1
#define _T2CON_CKPS0_MASK                                   0x10
#define _T2CON_CKPS1_POSN                                   0x5
#define _T2CON_CKPS1_POSITION                               0x5
#define _T2CON_CKPS1_SIZE                                   0x1
#define _T2CON_CKPS1_LENGTH                                 0x1
#define _T2CON_CKPS1_MASK                                   0x20
#define _T2CON_CKPS2_POSN                                   0x6
#define _T2CON_CKPS2_POSITION                               0x6
#define _T2CON_CKPS2_SIZE                                   0x1
#define _T2CON_CKPS2_LENGTH                                 0x1
#define _T2CON_CKPS2_MASK                                   0x40
#define _T2CON_T2OUTPS_POSN                                 0x0
#define _T2CON_T2OUTPS_POSITION                             0x0
#define _T2CON_T2OUTPS_SIZE                                 0x4
#define _T2CON_T2OUTPS_LENGTH                               0x4
#define _T2CON_T2OUTPS_MASK                                 0xF
#define _T2CON_T2CKPS_POSN                                  0x4
#define _T2CON_T2CKPS_POSITION                              0x4
#define _T2CON_T2CKPS_SIZE                                  0x3
#define _T2CON_T2CKPS_LENGTH                                0x3
#define _T2CON_T2CKPS_MASK                                  0x70
#define _T2CON_T2ON_POSN                                    0x7
#define _T2CON_T2ON_POSITION                                0x7
#define _T2CON_T2ON_SIZE                                    0x1
#define _T2CON_T2ON_LENGTH                                  0x1
#define _T2CON_T2ON_MASK                                    0x80
#define _T2CON_T2OUTPS0_POSN                                0x0
#define _T2CON_T2OUTPS0_POSITION                            0x0
#define _T2CON_T2OUTPS0_SIZE                                0x1
#define _T2CON_T2OUTPS0_LENGTH                              0x1
#define _T2CON_T2OUTPS0_MASK                                0x1
#define _T2CON_T2OUTPS1_POSN                                0x1
#define _T2CON_T2OUTPS1_POSITION                            0x1
#define _T2CON_T2OUTPS1_SIZE                                0x1
#define _T2CON_T2OUTPS1_LENGTH                              0x1
#define _T2CON_T2OUTPS1_MASK                                0x2
#define _T2CON_T2OUTPS2_POSN                                0x2
#define _T2CON_T2OUTPS2_POSITION                            0x2
#define _T2CON_T2OUTPS2_SIZE                                0x1
#define _T2CON_T2OUTPS2_LENGTH                              0x1
#define _T2CON_T2OUTPS2_MASK                                0x4
#define _T2CON_T2OUTPS3_POSN                                0x3
#define _T2CON_T2OUTPS3_POSITION                            0x3
#define _T2CON_T2OUTPS3_SIZE                                0x1
#define _T2CON_T2OUTPS3_LENGTH                              0x1
#define _T2CON_T2OUTPS3_MASK                                0x8
#define _T2CON_T2CKPS0_POSN                                 0x4
#define _T2CON_T2CKPS0_POSITION                             0x4
#define _T2CON_T2CKPS0_SIZE                                 0x1
#define _T2CON_T2CKPS0_LENGTH                               0x1
#define _T2CON_T2CKPS0_MASK                                 0x10
#define _T2CON_T2CKPS1_POSN                                 0x5
#define _T2CON_T2CKPS1_POSITION                             0x5
#define _T2CON_T2CKPS1_SIZE                                 0x1
#define _T2CON_T2CKPS1_LENGTH                               0x1
#define _T2CON_T2CKPS1_MASK                                 0x20
#define _T2CON_T2CKPS2_POSN                                 0x6
#define _T2CON_T2CKPS2_POSITION                             0x6
#define _T2CON_T2CKPS2_SIZE                                 0x1
#define _T2CON_T2CKPS2_LENGTH                               0x1
#define _T2CON_T2CKPS2_MASK                                 0x40
#define _T2CON_TMR2ON_POSN                                  0x7
#define _T2CON_TMR2ON_POSITION                              0x7
#define _T2CON_TMR2ON_SIZE                                  0x1
#define _T2CON_TMR2ON_LENGTH                                0x1
#define _T2CON_TMR2ON_MASK                                  0x80

// Register: T2HLT
extern volatile unsigned char           T2HLT               @ 0x01D;
#ifndef _LIB_BUILD
asm("T2HLT equ 01Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned MODE                   :5;
        unsigned CKSYNC                 :1;
        unsigned CKPOL                  :1;
        unsigned PSYNC                  :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
        unsigned MODE3                  :1;
        unsigned MODE4                  :1;
    };
    struct {
        unsigned T2MODE                 :5;
        unsigned T2CKSYNC               :1;
        unsigned T2CKPOL                :1;
        unsigned T2PSYNC                :1;
    };
    struct {
        unsigned T2MODE0                :1;
        unsigned T2MODE1                :1;
        unsigned T2MODE2                :1;
        unsigned T2MODE3                :1;
        unsigned T2MODE4                :1;
    };
} T2HLTbits_t;
extern volatile T2HLTbits_t T2HLTbits @ 0x01D;
// bitfield macros
#define _T2HLT_MODE_POSN                                    0x0
#define _T2HLT_MODE_POSITION                                0x0
#define _T2HLT_MODE_SIZE                                    0x5
#define _T2HLT_MODE_LENGTH                                  0x5
#define _T2HLT_MODE_MASK                                    0x1F
#define _T2HLT_CKSYNC_POSN                                  0x5
#define _T2HLT_CKSYNC_POSITION                              0x5
#define _T2HLT_CKSYNC_SIZE                                  0x1
#define _T2HLT_CKSYNC_LENGTH                                0x1
#define _T2HLT_CKSYNC_MASK                                  0x20
#define _T2HLT_CKPOL_POSN                                   0x6
#define _T2HLT_CKPOL_POSITION                               0x6
#define _T2HLT_CKPOL_SIZE                                   0x1
#define _T2HLT_CKPOL_LENGTH                                 0x1
#define _T2HLT_CKPOL_MASK                                   0x40
#define _T2HLT_PSYNC_POSN                                   0x7
#define _T2HLT_PSYNC_POSITION                               0x7
#define _T2HLT_PSYNC_SIZE                                   0x1
#define _T2HLT_PSYNC_LENGTH                                 0x1
#define _T2HLT_PSYNC_MASK                                   0x80
#define _T2HLT_MODE0_POSN                                   0x0
#define _T2HLT_MODE0_POSITION                               0x0
#define _T2HLT_MODE0_SIZE                                   0x1
#define _T2HLT_MODE0_LENGTH                                 0x1
#define _T2HLT_MODE0_MASK                                   0x1
#define _T2HLT_MODE1_POSN                                   0x1
#define _T2HLT_MODE1_POSITION                               0x1
#define _T2HLT_MODE1_SIZE                                   0x1
#define _T2HLT_MODE1_LENGTH                                 0x1
#define _T2HLT_MODE1_MASK                                   0x2
#define _T2HLT_MODE2_POSN                                   0x2
#define _T2HLT_MODE2_POSITION                               0x2
#define _T2HLT_MODE2_SIZE                                   0x1
#define _T2HLT_MODE2_LENGTH                                 0x1
#define _T2HLT_MODE2_MASK                                   0x4
#define _T2HLT_MODE3_POSN                                   0x3
#define _T2HLT_MODE3_POSITION                               0x3
#define _T2HLT_MODE3_SIZE                                   0x1
#define _T2HLT_MODE3_LENGTH                                 0x1
#define _T2HLT_MODE3_MASK                                   0x8
#define _T2HLT_MODE4_POSN                                   0x4
#define _T2HLT_MODE4_POSITION                               0x4
#define _T2HLT_MODE4_SIZE                                   0x1
#define _T2HLT_MODE4_LENGTH                                 0x1
#define _T2HLT_MODE4_MASK                                   0x10
#define _T2HLT_T2MODE_POSN                                  0x0
#define _T2HLT_T2MODE_POSITION                              0x0
#define _T2HLT_T2MODE_SIZE                                  0x5
#define _T2HLT_T2MODE_LENGTH                                0x5
#define _T2HLT_T2MODE_MASK                                  0x1F
#define _T2HLT_T2CKSYNC_POSN                                0x5
#define _T2HLT_T2CKSYNC_POSITION                            0x5
#define _T2HLT_T2CKSYNC_SIZE                                0x1
#define _T2HLT_T2CKSYNC_LENGTH                              0x1
#define _T2HLT_T2CKSYNC_MASK                                0x20
#define _T2HLT_T2CKPOL_POSN                                 0x6
#define _T2HLT_T2CKPOL_POSITION                             0x6
#define _T2HLT_T2CKPOL_SIZE                                 0x1
#define _T2HLT_T2CKPOL_LENGTH                               0x1
#define _T2HLT_T2CKPOL_MASK                                 0x40
#define _T2HLT_T2PSYNC_POSN                                 0x7
#define _T2HLT_T2PSYNC_POSITION                             0x7
#define _T2HLT_T2PSYNC_SIZE                                 0x1
#define _T2HLT_T2PSYNC_LENGTH                               0x1
#define _T2HLT_T2PSYNC_MASK                                 0x80
#define _T2HLT_T2MODE0_POSN                                 0x0
#define _T2HLT_T2MODE0_POSITION                             0x0
#define _T2HLT_T2MODE0_SIZE                                 0x1
#define _T2HLT_T2MODE0_LENGTH                               0x1
#define _T2HLT_T2MODE0_MASK                                 0x1
#define _T2HLT_T2MODE1_POSN                                 0x1
#define _T2HLT_T2MODE1_POSITION                             0x1
#define _T2HLT_T2MODE1_SIZE                                 0x1
#define _T2HLT_T2MODE1_LENGTH                               0x1
#define _T2HLT_T2MODE1_MASK                                 0x2
#define _T2HLT_T2MODE2_POSN                                 0x2
#define _T2HLT_T2MODE2_POSITION                             0x2
#define _T2HLT_T2MODE2_SIZE                                 0x1
#define _T2HLT_T2MODE2_LENGTH                               0x1
#define _T2HLT_T2MODE2_MASK                                 0x4
#define _T2HLT_T2MODE3_POSN                                 0x3
#define _T2HLT_T2MODE3_POSITION                             0x3
#define _T2HLT_T2MODE3_SIZE                                 0x1
#define _T2HLT_T2MODE3_LENGTH                               0x1
#define _T2HLT_T2MODE3_MASK                                 0x8
#define _T2HLT_T2MODE4_POSN                                 0x4
#define _T2HLT_T2MODE4_POSITION                             0x4
#define _T2HLT_T2MODE4_SIZE                                 0x1
#define _T2HLT_T2MODE4_LENGTH                               0x1
#define _T2HLT_T2MODE4_MASK                                 0x10

// Register: T2CLKCON
extern volatile unsigned char           T2CLKCON            @ 0x01E;
#ifndef _LIB_BUILD
asm("T2CLKCON equ 01Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CS                     :4;
    };
    struct {
        unsigned CS0                    :1;
        unsigned CS1                    :1;
        unsigned CS2                    :1;
        unsigned CS3                    :1;
    };
    struct {
        unsigned T2CS                   :4;
    };
    struct {
        unsigned T2CS0                  :1;
        unsigned T2CS1                  :1;
        unsigned T2CS2                  :1;
        unsigned T2CS3                  :1;
    };
} T2CLKCONbits_t;
extern volatile T2CLKCONbits_t T2CLKCONbits @ 0x01E;
// bitfield macros
#define _T2CLKCON_CS_POSN                                   0x0
#define _T2CLKCON_CS_POSITION                               0x0
#define _T2CLKCON_CS_SIZE                                   0x4
#define _T2CLKCON_CS_LENGTH                                 0x4
#define _T2CLKCON_CS_MASK                                   0xF
#define _T2CLKCON_CS0_POSN                                  0x0
#define _T2CLKCON_CS0_POSITION                              0x0
#define _T2CLKCON_CS0_SIZE                                  0x1
#define _T2CLKCON_CS0_LENGTH                                0x1
#define _T2CLKCON_CS0_MASK                                  0x1
#define _T2CLKCON_CS1_POSN                                  0x1
#define _T2CLKCON_CS1_POSITION                              0x1
#define _T2CLKCON_CS1_SIZE                                  0x1
#define _T2CLKCON_CS1_LENGTH                                0x1
#define _T2CLKCON_CS1_MASK                                  0x2
#define _T2CLKCON_CS2_POSN                                  0x2
#define _T2CLKCON_CS2_POSITION                              0x2
#define _T2CLKCON_CS2_SIZE                                  0x1
#define _T2CLKCON_CS2_LENGTH                                0x1
#define _T2CLKCON_CS2_MASK                                  0x4
#define _T2CLKCON_CS3_POSN                                  0x3
#define _T2CLKCON_CS3_POSITION                              0x3
#define _T2CLKCON_CS3_SIZE                                  0x1
#define _T2CLKCON_CS3_LENGTH                                0x1
#define _T2CLKCON_CS3_MASK                                  0x8
#define _T2CLKCON_T2CS_POSN                                 0x0
#define _T2CLKCON_T2CS_POSITION                             0x0
#define _T2CLKCON_T2CS_SIZE                                 0x4
#define _T2CLKCON_T2CS_LENGTH                               0x4
#define _T2CLKCON_T2CS_MASK                                 0xF
#define _T2CLKCON_T2CS0_POSN                                0x0
#define _T2CLKCON_T2CS0_POSITION                            0x0
#define _T2CLKCON_T2CS0_SIZE                                0x1
#define _T2CLKCON_T2CS0_LENGTH                              0x1
#define _T2CLKCON_T2CS0_MASK                                0x1
#define _T2CLKCON_T2CS1_POSN                                0x1
#define _T2CLKCON_T2CS1_POSITION                            0x1
#define _T2CLKCON_T2CS1_SIZE                                0x1
#define _T2CLKCON_T2CS1_LENGTH                              0x1
#define _T2CLKCON_T2CS1_MASK                                0x2
#define _T2CLKCON_T2CS2_POSN                                0x2
#define _T2CLKCON_T2CS2_POSITION                            0x2
#define _T2CLKCON_T2CS2_SIZE                                0x1
#define _T2CLKCON_T2CS2_LENGTH                              0x1
#define _T2CLKCON_T2CS2_MASK                                0x4
#define _T2CLKCON_T2CS3_POSN                                0x3
#define _T2CLKCON_T2CS3_POSITION                            0x3
#define _T2CLKCON_T2CS3_SIZE                                0x1
#define _T2CLKCON_T2CS3_LENGTH                              0x1
#define _T2CLKCON_T2CS3_MASK                                0x8

// Register: T2RST
extern volatile unsigned char           T2RST               @ 0x01F;
#ifndef _LIB_BUILD
asm("T2RST equ 01Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RSEL                   :4;
    };
    struct {
        unsigned RSEL0                  :1;
        unsigned RSEL1                  :1;
        unsigned RSEL2                  :1;
        unsigned RSEL3                  :1;
    };
    struct {
        unsigned T2RSEL                 :4;
    };
    struct {
        unsigned T2RSEL0                :1;
        unsigned T2RSEL1                :1;
        unsigned T2RSEL2                :1;
        unsigned T2RSEL3                :1;
    };
} T2RSTbits_t;
extern volatile T2RSTbits_t T2RSTbits @ 0x01F;
// bitfield macros
#define _T2RST_RSEL_POSN                                    0x0
#define _T2RST_RSEL_POSITION                                0x0
#define _T2RST_RSEL_SIZE                                    0x4
#define _T2RST_RSEL_LENGTH                                  0x4
#define _T2RST_RSEL_MASK                                    0xF
#define _T2RST_RSEL0_POSN                                   0x0
#define _T2RST_RSEL0_POSITION                               0x0
#define _T2RST_RSEL0_SIZE                                   0x1
#define _T2RST_RSEL0_LENGTH                                 0x1
#define _T2RST_RSEL0_MASK                                   0x1
#define _T2RST_RSEL1_POSN                                   0x1
#define _T2RST_RSEL1_POSITION                               0x1
#define _T2RST_RSEL1_SIZE                                   0x1
#define _T2RST_RSEL1_LENGTH                                 0x1
#define _T2RST_RSEL1_MASK                                   0x2
#define _T2RST_RSEL2_POSN                                   0x2
#define _T2RST_RSEL2_POSITION                               0x2
#define _T2RST_RSEL2_SIZE                                   0x1
#define _T2RST_RSEL2_LENGTH                                 0x1
#define _T2RST_RSEL2_MASK                                   0x4
#define _T2RST_RSEL3_POSN                                   0x3
#define _T2RST_RSEL3_POSITION                               0x3
#define _T2RST_RSEL3_SIZE                                   0x1
#define _T2RST_RSEL3_LENGTH                                 0x1
#define _T2RST_RSEL3_MASK                                   0x8
#define _T2RST_T2RSEL_POSN                                  0x0
#define _T2RST_T2RSEL_POSITION                              0x0
#define _T2RST_T2RSEL_SIZE                                  0x4
#define _T2RST_T2RSEL_LENGTH                                0x4
#define _T2RST_T2RSEL_MASK                                  0xF
#define _T2RST_T2RSEL0_POSN                                 0x0
#define _T2RST_T2RSEL0_POSITION                             0x0
#define _T2RST_T2RSEL0_SIZE                                 0x1
#define _T2RST_T2RSEL0_LENGTH                               0x1
#define _T2RST_T2RSEL0_MASK                                 0x1
#define _T2RST_T2RSEL1_POSN                                 0x1
#define _T2RST_T2RSEL1_POSITION                             0x1
#define _T2RST_T2RSEL1_SIZE                                 0x1
#define _T2RST_T2RSEL1_LENGTH                               0x1
#define _T2RST_T2RSEL1_MASK                                 0x2
#define _T2RST_T2RSEL2_POSN                                 0x2
#define _T2RST_T2RSEL2_POSITION                             0x2
#define _T2RST_T2RSEL2_SIZE                                 0x1
#define _T2RST_T2RSEL2_LENGTH                               0x1
#define _T2RST_T2RSEL2_MASK                                 0x4
#define _T2RST_T2RSEL3_POSN                                 0x3
#define _T2RST_T2RSEL3_POSITION                             0x3
#define _T2RST_T2RSEL3_SIZE                                 0x1
#define _T2RST_T2RSEL3_LENGTH                               0x1
#define _T2RST_T2RSEL3_MASK                                 0x8

// Register: TRISA
extern volatile unsigned char           TRISA               @ 0x08C;
#ifndef _LIB_BUILD
asm("TRISA equ 08Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TRISA0                 :1;
        unsigned TRISA1                 :1;
        unsigned TRISA2                 :1;
        unsigned TRISA3                 :1;
        unsigned TRISA4                 :1;
        unsigned TRISA5                 :1;
    };
} TRISAbits_t;
extern volatile TRISAbits_t TRISAbits @ 0x08C;
// bitfield macros
#define _TRISA_TRISA0_POSN                                  0x0
#define _TRISA_TRISA0_POSITION                              0x0
#define _TRISA_TRISA0_SIZE                                  0x1
#define _TRISA_TRISA0_LENGTH                                0x1
#define _TRISA_TRISA0_MASK                                  0x1
#define _TRISA_TRISA1_POSN                                  0x1
#define _TRISA_TRISA1_POSITION                              0x1
#define _TRISA_TRISA1_SIZE                                  0x1
#define _TRISA_TRISA1_LENGTH                                0x1
#define _TRISA_TRISA1_MASK                                  0x2
#define _TRISA_TRISA2_POSN                                  0x2
#define _TRISA_TRISA2_POSITION                              0x2
#define _TRISA_TRISA2_SIZE                                  0x1
#define _TRISA_TRISA2_LENGTH                                0x1
#define _TRISA_TRISA2_MASK                                  0x4
#define _TRISA_TRISA3_POSN                                  0x3
#define _TRISA_TRISA3_POSITION                              0x3
#define _TRISA_TRISA3_SIZE                                  0x1
#define _TRISA_TRISA3_LENGTH                                0x1
#define _TRISA_TRISA3_MASK                                  0x8
#define _TRISA_TRISA4_POSN                                  0x4
#define _TRISA_TRISA4_POSITION                              0x4
#define _TRISA_TRISA4_SIZE                                  0x1
#define _TRISA_TRISA4_LENGTH                                0x1
#define _TRISA_TRISA4_MASK                                  0x10
#define _TRISA_TRISA5_POSN                                  0x5
#define _TRISA_TRISA5_POSITION                              0x5
#define _TRISA_TRISA5_SIZE                                  0x1
#define _TRISA_TRISA5_LENGTH                                0x1
#define _TRISA_TRISA5_MASK                                  0x20

// Register: TRISB
extern volatile unsigned char           TRISB               @ 0x08D;
#ifndef _LIB_BUILD
asm("TRISB equ 08Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned TRISB4                 :1;
        unsigned TRISB5                 :1;
        unsigned TRISB6                 :1;
        unsigned TRISB7                 :1;
    };
} TRISBbits_t;
extern volatile TRISBbits_t TRISBbits @ 0x08D;
// bitfield macros
#define _TRISB_TRISB4_POSN                                  0x4
#define _TRISB_TRISB4_POSITION                              0x4
#define _TRISB_TRISB4_SIZE                                  0x1
#define _TRISB_TRISB4_LENGTH                                0x1
#define _TRISB_TRISB4_MASK                                  0x10
#define _TRISB_TRISB5_POSN                                  0x5
#define _TRISB_TRISB5_POSITION                              0x5
#define _TRISB_TRISB5_SIZE                                  0x1
#define _TRISB_TRISB5_LENGTH                                0x1
#define _TRISB_TRISB5_MASK                                  0x20
#define _TRISB_TRISB6_POSN                                  0x6
#define _TRISB_TRISB6_POSITION                              0x6
#define _TRISB_TRISB6_SIZE                                  0x1
#define _TRISB_TRISB6_LENGTH                                0x1
#define _TRISB_TRISB6_MASK                                  0x40
#define _TRISB_TRISB7_POSN                                  0x7
#define _TRISB_TRISB7_POSITION                              0x7
#define _TRISB_TRISB7_SIZE                                  0x1
#define _TRISB_TRISB7_LENGTH                                0x1
#define _TRISB_TRISB7_MASK                                  0x80

// Register: TRISC
extern volatile unsigned char           TRISC               @ 0x08E;
#ifndef _LIB_BUILD
asm("TRISC equ 08Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TRISC0                 :1;
        unsigned TRISC1                 :1;
        unsigned TRISC2                 :1;
        unsigned TRISC3                 :1;
        unsigned TRISC4                 :1;
        unsigned TRISC5                 :1;
        unsigned TRISC6                 :1;
        unsigned TRISC7                 :1;
    };
} TRISCbits_t;
extern volatile TRISCbits_t TRISCbits @ 0x08E;
// bitfield macros
#define _TRISC_TRISC0_POSN                                  0x0
#define _TRISC_TRISC0_POSITION                              0x0
#define _TRISC_TRISC0_SIZE                                  0x1
#define _TRISC_TRISC0_LENGTH                                0x1
#define _TRISC_TRISC0_MASK                                  0x1
#define _TRISC_TRISC1_POSN                                  0x1
#define _TRISC_TRISC1_POSITION                              0x1
#define _TRISC_TRISC1_SIZE                                  0x1
#define _TRISC_TRISC1_LENGTH                                0x1
#define _TRISC_TRISC1_MASK                                  0x2
#define _TRISC_TRISC2_POSN                                  0x2
#define _TRISC_TRISC2_POSITION                              0x2
#define _TRISC_TRISC2_SIZE                                  0x1
#define _TRISC_TRISC2_LENGTH                                0x1
#define _TRISC_TRISC2_MASK                                  0x4
#define _TRISC_TRISC3_POSN                                  0x3
#define _TRISC_TRISC3_POSITION                              0x3
#define _TRISC_TRISC3_SIZE                                  0x1
#define _TRISC_TRISC3_LENGTH                                0x1
#define _TRISC_TRISC3_MASK                                  0x8
#define _TRISC_TRISC4_POSN                                  0x4
#define _TRISC_TRISC4_POSITION                              0x4
#define _TRISC_TRISC4_SIZE                                  0x1
#define _TRISC_TRISC4_LENGTH                                0x1
#define _TRISC_TRISC4_MASK                                  0x10
#define _TRISC_TRISC5_POSN                                  0x5
#define _TRISC_TRISC5_POSITION                              0x5
#define _TRISC_TRISC5_SIZE                                  0x1
#define _TRISC_TRISC5_LENGTH                                0x1
#define _TRISC_TRISC5_MASK                                  0x20
#define _TRISC_TRISC6_POSN                                  0x6
#define _TRISC_TRISC6_POSITION                              0x6
#define _TRISC_TRISC6_SIZE                                  0x1
#define _TRISC_TRISC6_LENGTH                                0x1
#define _TRISC_TRISC6_MASK                                  0x40
#define _TRISC_TRISC7_POSN                                  0x7
#define _TRISC_TRISC7_POSITION                              0x7
#define _TRISC_TRISC7_SIZE                                  0x1
#define _TRISC_TRISC7_LENGTH                                0x1
#define _TRISC_TRISC7_MASK                                  0x80

// Register: PIE1
extern volatile unsigned char           PIE1                @ 0x090;
#ifndef _LIB_BUILD
asm("PIE1 equ 090h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR1IE                 :1;
        unsigned TMR2IE                 :1;
        unsigned CCP1IE                 :1;
        unsigned SSP1IE                 :1;
        unsigned TXIE                   :1;
        unsigned RCIE                   :1;
        unsigned ADIE                   :1;
        unsigned TMR1GIE                :1;
    };
} PIE1bits_t;
extern volatile PIE1bits_t PIE1bits @ 0x090;
// bitfield macros
#define _PIE1_TMR1IE_POSN                                   0x0
#define _PIE1_TMR1IE_POSITION                               0x0
#define _PIE1_TMR1IE_SIZE                                   0x1
#define _PIE1_TMR1IE_LENGTH                                 0x1
#define _PIE1_TMR1IE_MASK                                   0x1
#define _PIE1_TMR2IE_POSN                                   0x1
#define _PIE1_TMR2IE_POSITION                               0x1
#define _PIE1_TMR2IE_SIZE                                   0x1
#define _PIE1_TMR2IE_LENGTH                                 0x1
#define _PIE1_TMR2IE_MASK                                   0x2
#define _PIE1_CCP1IE_POSN                                   0x2
#define _PIE1_CCP1IE_POSITION                               0x2
#define _PIE1_CCP1IE_SIZE                                   0x1
#define _PIE1_CCP1IE_LENGTH                                 0x1
#define _PIE1_CCP1IE_MASK                                   0x4
#define _PIE1_SSP1IE_POSN                                   0x3
#define _PIE1_SSP1IE_POSITION                               0x3
#define _PIE1_SSP1IE_SIZE                                   0x1
#define _PIE1_SSP1IE_LENGTH                                 0x1
#define _PIE1_SSP1IE_MASK                                   0x8
#define _PIE1_TXIE_POSN                                     0x4
#define _PIE1_TXIE_POSITION                                 0x4
#define _PIE1_TXIE_SIZE                                     0x1
#define _PIE1_TXIE_LENGTH                                   0x1
#define _PIE1_TXIE_MASK                                     0x10
#define _PIE1_RCIE_POSN                                     0x5
#define _PIE1_RCIE_POSITION                                 0x5
#define _PIE1_RCIE_SIZE                                     0x1
#define _PIE1_RCIE_LENGTH                                   0x1
#define _PIE1_RCIE_MASK                                     0x20
#define _PIE1_ADIE_POSN                                     0x6
#define _PIE1_ADIE_POSITION                                 0x6
#define _PIE1_ADIE_SIZE                                     0x1
#define _PIE1_ADIE_LENGTH                                   0x1
#define _PIE1_ADIE_MASK                                     0x40
#define _PIE1_TMR1GIE_POSN                                  0x7
#define _PIE1_TMR1GIE_POSITION                              0x7
#define _PIE1_TMR1GIE_SIZE                                  0x1
#define _PIE1_TMR1GIE_LENGTH                                0x1
#define _PIE1_TMR1GIE_MASK                                  0x80

// Register: PIE2
extern volatile unsigned char           PIE2                @ 0x091;
#ifndef _LIB_BUILD
asm("PIE2 equ 091h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CCP2IE                 :1;
        unsigned TMR4IE                 :1;
        unsigned TMR6IE                 :1;
        unsigned BCL1IE                 :1;
        unsigned                        :1;
        unsigned C1IE                   :1;
        unsigned C2IE                   :1;
        unsigned OSCFIE                 :1;
    };
} PIE2bits_t;
extern volatile PIE2bits_t PIE2bits @ 0x091;
// bitfield macros
#define _PIE2_CCP2IE_POSN                                   0x0
#define _PIE2_CCP2IE_POSITION                               0x0
#define _PIE2_CCP2IE_SIZE                                   0x1
#define _PIE2_CCP2IE_LENGTH                                 0x1
#define _PIE2_CCP2IE_MASK                                   0x1
#define _PIE2_TMR4IE_POSN                                   0x1
#define _PIE2_TMR4IE_POSITION                               0x1
#define _PIE2_TMR4IE_SIZE                                   0x1
#define _PIE2_TMR4IE_LENGTH                                 0x1
#define _PIE2_TMR4IE_MASK                                   0x2
#define _PIE2_TMR6IE_POSN                                   0x2
#define _PIE2_TMR6IE_POSITION                               0x2
#define _PIE2_TMR6IE_SIZE                                   0x1
#define _PIE2_TMR6IE_LENGTH                                 0x1
#define _PIE2_TMR6IE_MASK                                   0x4
#define _PIE2_BCL1IE_POSN                                   0x3
#define _PIE2_BCL1IE_POSITION                               0x3
#define _PIE2_BCL1IE_SIZE                                   0x1
#define _PIE2_BCL1IE_LENGTH                                 0x1
#define _PIE2_BCL1IE_MASK                                   0x8
#define _PIE2_C1IE_POSN                                     0x5
#define _PIE2_C1IE_POSITION                                 0x5
#define _PIE2_C1IE_SIZE                                     0x1
#define _PIE2_C1IE_LENGTH                                   0x1
#define _PIE2_C1IE_MASK                                     0x20
#define _PIE2_C2IE_POSN                                     0x6
#define _PIE2_C2IE_POSITION                                 0x6
#define _PIE2_C2IE_SIZE                                     0x1
#define _PIE2_C2IE_LENGTH                                   0x1
#define _PIE2_C2IE_MASK                                     0x40
#define _PIE2_OSCFIE_POSN                                   0x7
#define _PIE2_OSCFIE_POSITION                               0x7
#define _PIE2_OSCFIE_SIZE                                   0x1
#define _PIE2_OSCFIE_LENGTH                                 0x1
#define _PIE2_OSCFIE_MASK                                   0x80

// Register: PIE3
extern volatile unsigned char           PIE3                @ 0x092;
#ifndef _LIB_BUILD
asm("PIE3 equ 092h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CLC1IE                 :1;
        unsigned CLC2IE                 :1;
        unsigned CLC3IE                 :1;
        unsigned CLC4IE                 :1;
        unsigned ZCDIE                  :1;
        unsigned CWGIE                  :1;
    };
} PIE3bits_t;
extern volatile PIE3bits_t PIE3bits @ 0x092;
// bitfield macros
#define _PIE3_CLC1IE_POSN                                   0x0
#define _PIE3_CLC1IE_POSITION                               0x0
#define _PIE3_CLC1IE_SIZE                                   0x1
#define _PIE3_CLC1IE_LENGTH                                 0x1
#define _PIE3_CLC1IE_MASK                                   0x1
#define _PIE3_CLC2IE_POSN                                   0x1
#define _PIE3_CLC2IE_POSITION                               0x1
#define _PIE3_CLC2IE_SIZE                                   0x1
#define _PIE3_CLC2IE_LENGTH                                 0x1
#define _PIE3_CLC2IE_MASK                                   0x2
#define _PIE3_CLC3IE_POSN                                   0x2
#define _PIE3_CLC3IE_POSITION                               0x2
#define _PIE3_CLC3IE_SIZE                                   0x1
#define _PIE3_CLC3IE_LENGTH                                 0x1
#define _PIE3_CLC3IE_MASK                                   0x4
#define _PIE3_CLC4IE_POSN                                   0x3
#define _PIE3_CLC4IE_POSITION                               0x3
#define _PIE3_CLC4IE_SIZE                                   0x1
#define _PIE3_CLC4IE_LENGTH                                 0x1
#define _PIE3_CLC4IE_MASK                                   0x8
#define _PIE3_ZCDIE_POSN                                    0x4
#define _PIE3_ZCDIE_POSITION                                0x4
#define _PIE3_ZCDIE_SIZE                                    0x1
#define _PIE3_ZCDIE_LENGTH                                  0x1
#define _PIE3_ZCDIE_MASK                                    0x10
#define _PIE3_CWGIE_POSN                                    0x5
#define _PIE3_CWGIE_POSITION                                0x5
#define _PIE3_CWGIE_SIZE                                    0x1
#define _PIE3_CWGIE_LENGTH                                  0x1
#define _PIE3_CWGIE_MASK                                    0x20

// Register: PIE4
extern volatile unsigned char           PIE4                @ 0x093;
#ifndef _LIB_BUILD
asm("PIE4 equ 093h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1IE                 :1;
        unsigned SMT1PRAIE              :1;
        unsigned SMT1PWAIE              :1;
        unsigned SMT2IE                 :1;
        unsigned SMT2PRAIE              :1;
        unsigned SMT2PWAIE              :1;
        unsigned CRCIE                  :1;
        unsigned SCANIE                 :1;
    };
} PIE4bits_t;
extern volatile PIE4bits_t PIE4bits @ 0x093;
// bitfield macros
#define _PIE4_SMT1IE_POSN                                   0x0
#define _PIE4_SMT1IE_POSITION                               0x0
#define _PIE4_SMT1IE_SIZE                                   0x1
#define _PIE4_SMT1IE_LENGTH                                 0x1
#define _PIE4_SMT1IE_MASK                                   0x1
#define _PIE4_SMT1PRAIE_POSN                                0x1
#define _PIE4_SMT1PRAIE_POSITION                            0x1
#define _PIE4_SMT1PRAIE_SIZE                                0x1
#define _PIE4_SMT1PRAIE_LENGTH                              0x1
#define _PIE4_SMT1PRAIE_MASK                                0x2
#define _PIE4_SMT1PWAIE_POSN                                0x2
#define _PIE4_SMT1PWAIE_POSITION                            0x2
#define _PIE4_SMT1PWAIE_SIZE                                0x1
#define _PIE4_SMT1PWAIE_LENGTH                              0x1
#define _PIE4_SMT1PWAIE_MASK                                0x4
#define _PIE4_SMT2IE_POSN                                   0x3
#define _PIE4_SMT2IE_POSITION                               0x3
#define _PIE4_SMT2IE_SIZE                                   0x1
#define _PIE4_SMT2IE_LENGTH                                 0x1
#define _PIE4_SMT2IE_MASK                                   0x8
#define _PIE4_SMT2PRAIE_POSN                                0x4
#define _PIE4_SMT2PRAIE_POSITION                            0x4
#define _PIE4_SMT2PRAIE_SIZE                                0x1
#define _PIE4_SMT2PRAIE_LENGTH                              0x1
#define _PIE4_SMT2PRAIE_MASK                                0x10
#define _PIE4_SMT2PWAIE_POSN                                0x5
#define _PIE4_SMT2PWAIE_POSITION                            0x5
#define _PIE4_SMT2PWAIE_SIZE                                0x1
#define _PIE4_SMT2PWAIE_LENGTH                              0x1
#define _PIE4_SMT2PWAIE_MASK                                0x20
#define _PIE4_CRCIE_POSN                                    0x6
#define _PIE4_CRCIE_POSITION                                0x6
#define _PIE4_CRCIE_SIZE                                    0x1
#define _PIE4_CRCIE_LENGTH                                  0x1
#define _PIE4_CRCIE_MASK                                    0x40
#define _PIE4_SCANIE_POSN                                   0x7
#define _PIE4_SCANIE_POSITION                               0x7
#define _PIE4_SCANIE_SIZE                                   0x1
#define _PIE4_SCANIE_LENGTH                                 0x1
#define _PIE4_SCANIE_MASK                                   0x80

// Register: PIE5
extern volatile unsigned char           PIE5                @ 0x094;
#ifndef _LIB_BUILD
asm("PIE5 equ 094h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1DIE                :1;
        unsigned PID1EIE                :1;
        unsigned AT1IE                  :1;
        unsigned                        :1;
        unsigned TMR5IE                 :1;
        unsigned TMR5GIE                :1;
        unsigned TMR3IE                 :1;
        unsigned TMR3GIE                :1;
    };
} PIE5bits_t;
extern volatile PIE5bits_t PIE5bits @ 0x094;
// bitfield macros
#define _PIE5_PID1DIE_POSN                                  0x0
#define _PIE5_PID1DIE_POSITION                              0x0
#define _PIE5_PID1DIE_SIZE                                  0x1
#define _PIE5_PID1DIE_LENGTH                                0x1
#define _PIE5_PID1DIE_MASK                                  0x1
#define _PIE5_PID1EIE_POSN                                  0x1
#define _PIE5_PID1EIE_POSITION                              0x1
#define _PIE5_PID1EIE_SIZE                                  0x1
#define _PIE5_PID1EIE_LENGTH                                0x1
#define _PIE5_PID1EIE_MASK                                  0x2
#define _PIE5_AT1IE_POSN                                    0x2
#define _PIE5_AT1IE_POSITION                                0x2
#define _PIE5_AT1IE_SIZE                                    0x1
#define _PIE5_AT1IE_LENGTH                                  0x1
#define _PIE5_AT1IE_MASK                                    0x4
#define _PIE5_TMR5IE_POSN                                   0x4
#define _PIE5_TMR5IE_POSITION                               0x4
#define _PIE5_TMR5IE_SIZE                                   0x1
#define _PIE5_TMR5IE_LENGTH                                 0x1
#define _PIE5_TMR5IE_MASK                                   0x10
#define _PIE5_TMR5GIE_POSN                                  0x5
#define _PIE5_TMR5GIE_POSITION                              0x5
#define _PIE5_TMR5GIE_SIZE                                  0x1
#define _PIE5_TMR5GIE_LENGTH                                0x1
#define _PIE5_TMR5GIE_MASK                                  0x20
#define _PIE5_TMR3IE_POSN                                   0x6
#define _PIE5_TMR3IE_POSITION                               0x6
#define _PIE5_TMR3IE_SIZE                                   0x1
#define _PIE5_TMR3IE_LENGTH                                 0x1
#define _PIE5_TMR3IE_MASK                                   0x40
#define _PIE5_TMR3GIE_POSN                                  0x7
#define _PIE5_TMR3GIE_POSITION                              0x7
#define _PIE5_TMR3GIE_SIZE                                  0x1
#define _PIE5_TMR3GIE_LENGTH                                0x1
#define _PIE5_TMR3GIE_MASK                                  0x80

// Register: OPTION_REG
extern volatile unsigned char           OPTION_REG          @ 0x095;
#ifndef _LIB_BUILD
asm("OPTION_REG equ 095h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PS                     :3;
        unsigned PSA                    :1;
        unsigned TMR0SE                 :1;
        unsigned TMR0CS                 :1;
        unsigned INTEDG                 :1;
        unsigned nWPUEN                 :1;
    };
    struct {
        unsigned PS0                    :1;
        unsigned PS1                    :1;
        unsigned PS2                    :1;
        unsigned                        :1;
        unsigned T0SE                   :1;
        unsigned T0CS                   :1;
    };
} OPTION_REGbits_t;
extern volatile OPTION_REGbits_t OPTION_REGbits @ 0x095;
// bitfield macros
#define _OPTION_REG_PS_POSN                                 0x0
#define _OPTION_REG_PS_POSITION                             0x0
#define _OPTION_REG_PS_SIZE                                 0x3
#define _OPTION_REG_PS_LENGTH                               0x3
#define _OPTION_REG_PS_MASK                                 0x7
#define _OPTION_REG_PSA_POSN                                0x3
#define _OPTION_REG_PSA_POSITION                            0x3
#define _OPTION_REG_PSA_SIZE                                0x1
#define _OPTION_REG_PSA_LENGTH                              0x1
#define _OPTION_REG_PSA_MASK                                0x8
#define _OPTION_REG_TMR0SE_POSN                             0x4
#define _OPTION_REG_TMR0SE_POSITION                         0x4
#define _OPTION_REG_TMR0SE_SIZE                             0x1
#define _OPTION_REG_TMR0SE_LENGTH                           0x1
#define _OPTION_REG_TMR0SE_MASK                             0x10
#define _OPTION_REG_TMR0CS_POSN                             0x5
#define _OPTION_REG_TMR0CS_POSITION                         0x5
#define _OPTION_REG_TMR0CS_SIZE                             0x1
#define _OPTION_REG_TMR0CS_LENGTH                           0x1
#define _OPTION_REG_TMR0CS_MASK                             0x20
#define _OPTION_REG_INTEDG_POSN                             0x6
#define _OPTION_REG_INTEDG_POSITION                         0x6
#define _OPTION_REG_INTEDG_SIZE                             0x1
#define _OPTION_REG_INTEDG_LENGTH                           0x1
#define _OPTION_REG_INTEDG_MASK                             0x40
#define _OPTION_REG_nWPUEN_POSN                             0x7
#define _OPTION_REG_nWPUEN_POSITION                         0x7
#define _OPTION_REG_nWPUEN_SIZE                             0x1
#define _OPTION_REG_nWPUEN_LENGTH                           0x1
#define _OPTION_REG_nWPUEN_MASK                             0x80
#define _OPTION_REG_PS0_POSN                                0x0
#define _OPTION_REG_PS0_POSITION                            0x0
#define _OPTION_REG_PS0_SIZE                                0x1
#define _OPTION_REG_PS0_LENGTH                              0x1
#define _OPTION_REG_PS0_MASK                                0x1
#define _OPTION_REG_PS1_POSN                                0x1
#define _OPTION_REG_PS1_POSITION                            0x1
#define _OPTION_REG_PS1_SIZE                                0x1
#define _OPTION_REG_PS1_LENGTH                              0x1
#define _OPTION_REG_PS1_MASK                                0x2
#define _OPTION_REG_PS2_POSN                                0x2
#define _OPTION_REG_PS2_POSITION                            0x2
#define _OPTION_REG_PS2_SIZE                                0x1
#define _OPTION_REG_PS2_LENGTH                              0x1
#define _OPTION_REG_PS2_MASK                                0x4
#define _OPTION_REG_T0SE_POSN                               0x4
#define _OPTION_REG_T0SE_POSITION                           0x4
#define _OPTION_REG_T0SE_SIZE                               0x1
#define _OPTION_REG_T0SE_LENGTH                             0x1
#define _OPTION_REG_T0SE_MASK                               0x10
#define _OPTION_REG_T0CS_POSN                               0x5
#define _OPTION_REG_T0CS_POSITION                           0x5
#define _OPTION_REG_T0CS_SIZE                               0x1
#define _OPTION_REG_T0CS_LENGTH                             0x1
#define _OPTION_REG_T0CS_MASK                               0x20

// Register: PCON
extern volatile unsigned char           PCON                @ 0x096;
#ifndef _LIB_BUILD
asm("PCON equ 096h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned nBOR                   :1;
        unsigned nPOR                   :1;
        unsigned nRI                    :1;
        unsigned nRMCLR                 :1;
        unsigned nRWDT                  :1;
        unsigned nWDTWV                 :1;
        unsigned STKUNF                 :1;
        unsigned STKOVF                 :1;
    };
} PCONbits_t;
extern volatile PCONbits_t PCONbits @ 0x096;
// bitfield macros
#define _PCON_nBOR_POSN                                     0x0
#define _PCON_nBOR_POSITION                                 0x0
#define _PCON_nBOR_SIZE                                     0x1
#define _PCON_nBOR_LENGTH                                   0x1
#define _PCON_nBOR_MASK                                     0x1
#define _PCON_nPOR_POSN                                     0x1
#define _PCON_nPOR_POSITION                                 0x1
#define _PCON_nPOR_SIZE                                     0x1
#define _PCON_nPOR_LENGTH                                   0x1
#define _PCON_nPOR_MASK                                     0x2
#define _PCON_nRI_POSN                                      0x2
#define _PCON_nRI_POSITION                                  0x2
#define _PCON_nRI_SIZE                                      0x1
#define _PCON_nRI_LENGTH                                    0x1
#define _PCON_nRI_MASK                                      0x4
#define _PCON_nRMCLR_POSN                                   0x3
#define _PCON_nRMCLR_POSITION                               0x3
#define _PCON_nRMCLR_SIZE                                   0x1
#define _PCON_nRMCLR_LENGTH                                 0x1
#define _PCON_nRMCLR_MASK                                   0x8
#define _PCON_nRWDT_POSN                                    0x4
#define _PCON_nRWDT_POSITION                                0x4
#define _PCON_nRWDT_SIZE                                    0x1
#define _PCON_nRWDT_LENGTH                                  0x1
#define _PCON_nRWDT_MASK                                    0x10
#define _PCON_nWDTWV_POSN                                   0x5
#define _PCON_nWDTWV_POSITION                               0x5
#define _PCON_nWDTWV_SIZE                                   0x1
#define _PCON_nWDTWV_LENGTH                                 0x1
#define _PCON_nWDTWV_MASK                                   0x20
#define _PCON_STKUNF_POSN                                   0x6
#define _PCON_STKUNF_POSITION                               0x6
#define _PCON_STKUNF_SIZE                                   0x1
#define _PCON_STKUNF_LENGTH                                 0x1
#define _PCON_STKUNF_MASK                                   0x40
#define _PCON_STKOVF_POSN                                   0x7
#define _PCON_STKOVF_POSITION                               0x7
#define _PCON_STKOVF_SIZE                                   0x1
#define _PCON_STKOVF_LENGTH                                 0x1
#define _PCON_STKOVF_MASK                                   0x80

// Register: OSCTUNE
extern volatile unsigned char           OSCTUNE             @ 0x098;
#ifndef _LIB_BUILD
asm("OSCTUNE equ 098h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TUN                    :6;
    };
    struct {
        unsigned TUN0                   :1;
        unsigned TUN1                   :1;
        unsigned TUN2                   :1;
        unsigned TUN3                   :1;
        unsigned TUN4                   :1;
        unsigned TUN5                   :1;
    };
} OSCTUNEbits_t;
extern volatile OSCTUNEbits_t OSCTUNEbits @ 0x098;
// bitfield macros
#define _OSCTUNE_TUN_POSN                                   0x0
#define _OSCTUNE_TUN_POSITION                               0x0
#define _OSCTUNE_TUN_SIZE                                   0x6
#define _OSCTUNE_TUN_LENGTH                                 0x6
#define _OSCTUNE_TUN_MASK                                   0x3F
#define _OSCTUNE_TUN0_POSN                                  0x0
#define _OSCTUNE_TUN0_POSITION                              0x0
#define _OSCTUNE_TUN0_SIZE                                  0x1
#define _OSCTUNE_TUN0_LENGTH                                0x1
#define _OSCTUNE_TUN0_MASK                                  0x1
#define _OSCTUNE_TUN1_POSN                                  0x1
#define _OSCTUNE_TUN1_POSITION                              0x1
#define _OSCTUNE_TUN1_SIZE                                  0x1
#define _OSCTUNE_TUN1_LENGTH                                0x1
#define _OSCTUNE_TUN1_MASK                                  0x2
#define _OSCTUNE_TUN2_POSN                                  0x2
#define _OSCTUNE_TUN2_POSITION                              0x2
#define _OSCTUNE_TUN2_SIZE                                  0x1
#define _OSCTUNE_TUN2_LENGTH                                0x1
#define _OSCTUNE_TUN2_MASK                                  0x4
#define _OSCTUNE_TUN3_POSN                                  0x3
#define _OSCTUNE_TUN3_POSITION                              0x3
#define _OSCTUNE_TUN3_SIZE                                  0x1
#define _OSCTUNE_TUN3_LENGTH                                0x1
#define _OSCTUNE_TUN3_MASK                                  0x8
#define _OSCTUNE_TUN4_POSN                                  0x4
#define _OSCTUNE_TUN4_POSITION                              0x4
#define _OSCTUNE_TUN4_SIZE                                  0x1
#define _OSCTUNE_TUN4_LENGTH                                0x1
#define _OSCTUNE_TUN4_MASK                                  0x10
#define _OSCTUNE_TUN5_POSN                                  0x5
#define _OSCTUNE_TUN5_POSITION                              0x5
#define _OSCTUNE_TUN5_SIZE                                  0x1
#define _OSCTUNE_TUN5_LENGTH                                0x1
#define _OSCTUNE_TUN5_MASK                                  0x20

// Register: OSCCON
extern volatile unsigned char           OSCCON              @ 0x099;
#ifndef _LIB_BUILD
asm("OSCCON equ 099h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SCS                    :2;
        unsigned                        :1;
        unsigned IRCF                   :4;
        unsigned SPLLEN                 :1;
    };
    struct {
        unsigned SCS0                   :1;
        unsigned SCS1                   :1;
        unsigned                        :1;
        unsigned IRCF0                  :1;
        unsigned IRCF1                  :1;
        unsigned IRCF2                  :1;
        unsigned IRCF3                  :1;
    };
} OSCCONbits_t;
extern volatile OSCCONbits_t OSCCONbits @ 0x099;
// bitfield macros
#define _OSCCON_SCS_POSN                                    0x0
#define _OSCCON_SCS_POSITION                                0x0
#define _OSCCON_SCS_SIZE                                    0x2
#define _OSCCON_SCS_LENGTH                                  0x2
#define _OSCCON_SCS_MASK                                    0x3
#define _OSCCON_IRCF_POSN                                   0x3
#define _OSCCON_IRCF_POSITION                               0x3
#define _OSCCON_IRCF_SIZE                                   0x4
#define _OSCCON_IRCF_LENGTH                                 0x4
#define _OSCCON_IRCF_MASK                                   0x78
#define _OSCCON_SPLLEN_POSN                                 0x7
#define _OSCCON_SPLLEN_POSITION                             0x7
#define _OSCCON_SPLLEN_SIZE                                 0x1
#define _OSCCON_SPLLEN_LENGTH                               0x1
#define _OSCCON_SPLLEN_MASK                                 0x80
#define _OSCCON_SCS0_POSN                                   0x0
#define _OSCCON_SCS0_POSITION                               0x0
#define _OSCCON_SCS0_SIZE                                   0x1
#define _OSCCON_SCS0_LENGTH                                 0x1
#define _OSCCON_SCS0_MASK                                   0x1
#define _OSCCON_SCS1_POSN                                   0x1
#define _OSCCON_SCS1_POSITION                               0x1
#define _OSCCON_SCS1_SIZE                                   0x1
#define _OSCCON_SCS1_LENGTH                                 0x1
#define _OSCCON_SCS1_MASK                                   0x2
#define _OSCCON_IRCF0_POSN                                  0x3
#define _OSCCON_IRCF0_POSITION                              0x3
#define _OSCCON_IRCF0_SIZE                                  0x1
#define _OSCCON_IRCF0_LENGTH                                0x1
#define _OSCCON_IRCF0_MASK                                  0x8
#define _OSCCON_IRCF1_POSN                                  0x4
#define _OSCCON_IRCF1_POSITION                              0x4
#define _OSCCON_IRCF1_SIZE                                  0x1
#define _OSCCON_IRCF1_LENGTH                                0x1
#define _OSCCON_IRCF1_MASK                                  0x10
#define _OSCCON_IRCF2_POSN                                  0x5
#define _OSCCON_IRCF2_POSITION                              0x5
#define _OSCCON_IRCF2_SIZE                                  0x1
#define _OSCCON_IRCF2_LENGTH                                0x1
#define _OSCCON_IRCF2_MASK                                  0x20
#define _OSCCON_IRCF3_POSN                                  0x6
#define _OSCCON_IRCF3_POSITION                              0x6
#define _OSCCON_IRCF3_SIZE                                  0x1
#define _OSCCON_IRCF3_LENGTH                                0x1
#define _OSCCON_IRCF3_MASK                                  0x40

// Register: OSCSTAT
extern volatile unsigned char           OSCSTAT             @ 0x09A;
#ifndef _LIB_BUILD
asm("OSCSTAT equ 09Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned HFIOFS                 :1;
        unsigned LFIOFR                 :1;
        unsigned MFIOFR                 :1;
        unsigned HFIOFL                 :1;
        unsigned HFIOFR                 :1;
        unsigned OSTS                   :1;
        unsigned PLLR                   :1;
    };
} OSCSTATbits_t;
extern volatile OSCSTATbits_t OSCSTATbits @ 0x09A;
// bitfield macros
#define _OSCSTAT_HFIOFS_POSN                                0x0
#define _OSCSTAT_HFIOFS_POSITION                            0x0
#define _OSCSTAT_HFIOFS_SIZE                                0x1
#define _OSCSTAT_HFIOFS_LENGTH                              0x1
#define _OSCSTAT_HFIOFS_MASK                                0x1
#define _OSCSTAT_LFIOFR_POSN                                0x1
#define _OSCSTAT_LFIOFR_POSITION                            0x1
#define _OSCSTAT_LFIOFR_SIZE                                0x1
#define _OSCSTAT_LFIOFR_LENGTH                              0x1
#define _OSCSTAT_LFIOFR_MASK                                0x2
#define _OSCSTAT_MFIOFR_POSN                                0x2
#define _OSCSTAT_MFIOFR_POSITION                            0x2
#define _OSCSTAT_MFIOFR_SIZE                                0x1
#define _OSCSTAT_MFIOFR_LENGTH                              0x1
#define _OSCSTAT_MFIOFR_MASK                                0x4
#define _OSCSTAT_HFIOFL_POSN                                0x3
#define _OSCSTAT_HFIOFL_POSITION                            0x3
#define _OSCSTAT_HFIOFL_SIZE                                0x1
#define _OSCSTAT_HFIOFL_LENGTH                              0x1
#define _OSCSTAT_HFIOFL_MASK                                0x8
#define _OSCSTAT_HFIOFR_POSN                                0x4
#define _OSCSTAT_HFIOFR_POSITION                            0x4
#define _OSCSTAT_HFIOFR_SIZE                                0x1
#define _OSCSTAT_HFIOFR_LENGTH                              0x1
#define _OSCSTAT_HFIOFR_MASK                                0x10
#define _OSCSTAT_OSTS_POSN                                  0x5
#define _OSCSTAT_OSTS_POSITION                              0x5
#define _OSCSTAT_OSTS_SIZE                                  0x1
#define _OSCSTAT_OSTS_LENGTH                                0x1
#define _OSCSTAT_OSTS_MASK                                  0x20
#define _OSCSTAT_PLLR_POSN                                  0x6
#define _OSCSTAT_PLLR_POSITION                              0x6
#define _OSCSTAT_PLLR_SIZE                                  0x1
#define _OSCSTAT_PLLR_LENGTH                                0x1
#define _OSCSTAT_PLLR_MASK                                  0x40

// Register: ADRES
extern volatile unsigned short          ADRES               @ 0x09B;
#ifndef _LIB_BUILD
asm("ADRES equ 09Bh");
#endif

// Register: ADRESL
extern volatile unsigned char           ADRESL              @ 0x09B;
#ifndef _LIB_BUILD
asm("ADRESL equ 09Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ADRESL                 :8;
    };
} ADRESLbits_t;
extern volatile ADRESLbits_t ADRESLbits @ 0x09B;
// bitfield macros
#define _ADRESL_ADRESL_POSN                                 0x0
#define _ADRESL_ADRESL_POSITION                             0x0
#define _ADRESL_ADRESL_SIZE                                 0x8
#define _ADRESL_ADRESL_LENGTH                               0x8
#define _ADRESL_ADRESL_MASK                                 0xFF

// Register: ADRESH
extern volatile unsigned char           ADRESH              @ 0x09C;
#ifndef _LIB_BUILD
asm("ADRESH equ 09Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ADRESH                 :8;
    };
} ADRESHbits_t;
extern volatile ADRESHbits_t ADRESHbits @ 0x09C;
// bitfield macros
#define _ADRESH_ADRESH_POSN                                 0x0
#define _ADRESH_ADRESH_POSITION                             0x0
#define _ADRESH_ADRESH_SIZE                                 0x8
#define _ADRESH_ADRESH_LENGTH                               0x8
#define _ADRESH_ADRESH_MASK                                 0xFF

// Register: ADCON0
extern volatile unsigned char           ADCON0              @ 0x09D;
#ifndef _LIB_BUILD
asm("ADCON0 equ 09Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ADON                   :1;
        unsigned GO_nDONE               :1;
        unsigned CHS                    :5;
    };
    struct {
        unsigned                        :1;
        unsigned ADGO                   :1;
        unsigned CHS0                   :1;
        unsigned CHS1                   :1;
        unsigned CHS2                   :1;
        unsigned CHS3                   :1;
        unsigned CHS4                   :1;
    };
    struct {
        unsigned                        :1;
        unsigned GO                     :1;
    };
} ADCON0bits_t;
extern volatile ADCON0bits_t ADCON0bits @ 0x09D;
// bitfield macros
#define _ADCON0_ADON_POSN                                   0x0
#define _ADCON0_ADON_POSITION                               0x0
#define _ADCON0_ADON_SIZE                                   0x1
#define _ADCON0_ADON_LENGTH                                 0x1
#define _ADCON0_ADON_MASK                                   0x1
#define _ADCON0_GO_nDONE_POSN                               0x1
#define _ADCON0_GO_nDONE_POSITION                           0x1
#define _ADCON0_GO_nDONE_SIZE                               0x1
#define _ADCON0_GO_nDONE_LENGTH                             0x1
#define _ADCON0_GO_nDONE_MASK                               0x2
#define _ADCON0_CHS_POSN                                    0x2
#define _ADCON0_CHS_POSITION                                0x2
#define _ADCON0_CHS_SIZE                                    0x5
#define _ADCON0_CHS_LENGTH                                  0x5
#define _ADCON0_CHS_MASK                                    0x7C
#define _ADCON0_ADGO_POSN                                   0x1
#define _ADCON0_ADGO_POSITION                               0x1
#define _ADCON0_ADGO_SIZE                                   0x1
#define _ADCON0_ADGO_LENGTH                                 0x1
#define _ADCON0_ADGO_MASK                                   0x2
#define _ADCON0_CHS0_POSN                                   0x2
#define _ADCON0_CHS0_POSITION                               0x2
#define _ADCON0_CHS0_SIZE                                   0x1
#define _ADCON0_CHS0_LENGTH                                 0x1
#define _ADCON0_CHS0_MASK                                   0x4
#define _ADCON0_CHS1_POSN                                   0x3
#define _ADCON0_CHS1_POSITION                               0x3
#define _ADCON0_CHS1_SIZE                                   0x1
#define _ADCON0_CHS1_LENGTH                                 0x1
#define _ADCON0_CHS1_MASK                                   0x8
#define _ADCON0_CHS2_POSN                                   0x4
#define _ADCON0_CHS2_POSITION                               0x4
#define _ADCON0_CHS2_SIZE                                   0x1
#define _ADCON0_CHS2_LENGTH                                 0x1
#define _ADCON0_CHS2_MASK                                   0x10
#define _ADCON0_CHS3_POSN                                   0x5
#define _ADCON0_CHS3_POSITION                               0x5
#define _ADCON0_CHS3_SIZE                                   0x1
#define _ADCON0_CHS3_LENGTH                                 0x1
#define _ADCON0_CHS3_MASK                                   0x20
#define _ADCON0_CHS4_POSN                                   0x6
#define _ADCON0_CHS4_POSITION                               0x6
#define _ADCON0_CHS4_SIZE                                   0x1
#define _ADCON0_CHS4_LENGTH                                 0x1
#define _ADCON0_CHS4_MASK                                   0x40
#define _ADCON0_GO_POSN                                     0x1
#define _ADCON0_GO_POSITION                                 0x1
#define _ADCON0_GO_SIZE                                     0x1
#define _ADCON0_GO_LENGTH                                   0x1
#define _ADCON0_GO_MASK                                     0x2

// Register: ADCON1
extern volatile unsigned char           ADCON1              @ 0x09E;
#ifndef _LIB_BUILD
asm("ADCON1 equ 09Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ADPREF                 :2;
        unsigned                        :2;
        unsigned ADCS                   :3;
        unsigned ADFM                   :1;
    };
    struct {
        unsigned ADPREF0                :1;
        unsigned ADPREF1                :1;
        unsigned                        :2;
        unsigned ADCS0                  :1;
        unsigned ADCS1                  :1;
        unsigned ADCS2                  :1;
    };
} ADCON1bits_t;
extern volatile ADCON1bits_t ADCON1bits @ 0x09E;
// bitfield macros
#define _ADCON1_ADPREF_POSN                                 0x0
#define _ADCON1_ADPREF_POSITION                             0x0
#define _ADCON1_ADPREF_SIZE                                 0x2
#define _ADCON1_ADPREF_LENGTH                               0x2
#define _ADCON1_ADPREF_MASK                                 0x3
#define _ADCON1_ADCS_POSN                                   0x4
#define _ADCON1_ADCS_POSITION                               0x4
#define _ADCON1_ADCS_SIZE                                   0x3
#define _ADCON1_ADCS_LENGTH                                 0x3
#define _ADCON1_ADCS_MASK                                   0x70
#define _ADCON1_ADFM_POSN                                   0x7
#define _ADCON1_ADFM_POSITION                               0x7
#define _ADCON1_ADFM_SIZE                                   0x1
#define _ADCON1_ADFM_LENGTH                                 0x1
#define _ADCON1_ADFM_MASK                                   0x80
#define _ADCON1_ADPREF0_POSN                                0x0
#define _ADCON1_ADPREF0_POSITION                            0x0
#define _ADCON1_ADPREF0_SIZE                                0x1
#define _ADCON1_ADPREF0_LENGTH                              0x1
#define _ADCON1_ADPREF0_MASK                                0x1
#define _ADCON1_ADPREF1_POSN                                0x1
#define _ADCON1_ADPREF1_POSITION                            0x1
#define _ADCON1_ADPREF1_SIZE                                0x1
#define _ADCON1_ADPREF1_LENGTH                              0x1
#define _ADCON1_ADPREF1_MASK                                0x2
#define _ADCON1_ADCS0_POSN                                  0x4
#define _ADCON1_ADCS0_POSITION                              0x4
#define _ADCON1_ADCS0_SIZE                                  0x1
#define _ADCON1_ADCS0_LENGTH                                0x1
#define _ADCON1_ADCS0_MASK                                  0x10
#define _ADCON1_ADCS1_POSN                                  0x5
#define _ADCON1_ADCS1_POSITION                              0x5
#define _ADCON1_ADCS1_SIZE                                  0x1
#define _ADCON1_ADCS1_LENGTH                                0x1
#define _ADCON1_ADCS1_MASK                                  0x20
#define _ADCON1_ADCS2_POSN                                  0x6
#define _ADCON1_ADCS2_POSITION                              0x6
#define _ADCON1_ADCS2_SIZE                                  0x1
#define _ADCON1_ADCS2_LENGTH                                0x1
#define _ADCON1_ADCS2_MASK                                  0x40

// Register: ADCON2
extern volatile unsigned char           ADCON2              @ 0x09F;
#ifndef _LIB_BUILD
asm("ADCON2 equ 09Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :3;
        unsigned TRIGSEL                :5;
    };
    struct {
        unsigned                        :4;
        unsigned TRIGSEL0               :1;
        unsigned TRIGSEL1               :1;
        unsigned TRIGSEL2               :1;
        unsigned TRIGSEL3               :1;
    };
} ADCON2bits_t;
extern volatile ADCON2bits_t ADCON2bits @ 0x09F;
// bitfield macros
#define _ADCON2_TRIGSEL_POSN                                0x3
#define _ADCON2_TRIGSEL_POSITION                            0x3
#define _ADCON2_TRIGSEL_SIZE                                0x5
#define _ADCON2_TRIGSEL_LENGTH                              0x5
#define _ADCON2_TRIGSEL_MASK                                0xF8
#define _ADCON2_TRIGSEL0_POSN                               0x4
#define _ADCON2_TRIGSEL0_POSITION                           0x4
#define _ADCON2_TRIGSEL0_SIZE                               0x1
#define _ADCON2_TRIGSEL0_LENGTH                             0x1
#define _ADCON2_TRIGSEL0_MASK                               0x10
#define _ADCON2_TRIGSEL1_POSN                               0x5
#define _ADCON2_TRIGSEL1_POSITION                           0x5
#define _ADCON2_TRIGSEL1_SIZE                               0x1
#define _ADCON2_TRIGSEL1_LENGTH                             0x1
#define _ADCON2_TRIGSEL1_MASK                               0x20
#define _ADCON2_TRIGSEL2_POSN                               0x6
#define _ADCON2_TRIGSEL2_POSITION                           0x6
#define _ADCON2_TRIGSEL2_SIZE                               0x1
#define _ADCON2_TRIGSEL2_LENGTH                             0x1
#define _ADCON2_TRIGSEL2_MASK                               0x40
#define _ADCON2_TRIGSEL3_POSN                               0x7
#define _ADCON2_TRIGSEL3_POSITION                           0x7
#define _ADCON2_TRIGSEL3_SIZE                               0x1
#define _ADCON2_TRIGSEL3_LENGTH                             0x1
#define _ADCON2_TRIGSEL3_MASK                               0x80

// Register: LATA
extern volatile unsigned char           LATA                @ 0x10C;
#ifndef _LIB_BUILD
asm("LATA equ 010Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LATA0                  :1;
        unsigned LATA1                  :1;
        unsigned LATA2                  :1;
        unsigned LATA3                  :1;
        unsigned LATA4                  :1;
        unsigned LATA5                  :1;
    };
} LATAbits_t;
extern volatile LATAbits_t LATAbits @ 0x10C;
// bitfield macros
#define _LATA_LATA0_POSN                                    0x0
#define _LATA_LATA0_POSITION                                0x0
#define _LATA_LATA0_SIZE                                    0x1
#define _LATA_LATA0_LENGTH                                  0x1
#define _LATA_LATA0_MASK                                    0x1
#define _LATA_LATA1_POSN                                    0x1
#define _LATA_LATA1_POSITION                                0x1
#define _LATA_LATA1_SIZE                                    0x1
#define _LATA_LATA1_LENGTH                                  0x1
#define _LATA_LATA1_MASK                                    0x2
#define _LATA_LATA2_POSN                                    0x2
#define _LATA_LATA2_POSITION                                0x2
#define _LATA_LATA2_SIZE                                    0x1
#define _LATA_LATA2_LENGTH                                  0x1
#define _LATA_LATA2_MASK                                    0x4
#define _LATA_LATA3_POSN                                    0x3
#define _LATA_LATA3_POSITION                                0x3
#define _LATA_LATA3_SIZE                                    0x1
#define _LATA_LATA3_LENGTH                                  0x1
#define _LATA_LATA3_MASK                                    0x8
#define _LATA_LATA4_POSN                                    0x4
#define _LATA_LATA4_POSITION                                0x4
#define _LATA_LATA4_SIZE                                    0x1
#define _LATA_LATA4_LENGTH                                  0x1
#define _LATA_LATA4_MASK                                    0x10
#define _LATA_LATA5_POSN                                    0x5
#define _LATA_LATA5_POSITION                                0x5
#define _LATA_LATA5_SIZE                                    0x1
#define _LATA_LATA5_LENGTH                                  0x1
#define _LATA_LATA5_MASK                                    0x20

// Register: LATB
extern volatile unsigned char           LATB                @ 0x10D;
#ifndef _LIB_BUILD
asm("LATB equ 010Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned LATB4                  :1;
        unsigned LATB5                  :1;
        unsigned LATB6                  :1;
        unsigned LATB7                  :1;
    };
} LATBbits_t;
extern volatile LATBbits_t LATBbits @ 0x10D;
// bitfield macros
#define _LATB_LATB4_POSN                                    0x4
#define _LATB_LATB4_POSITION                                0x4
#define _LATB_LATB4_SIZE                                    0x1
#define _LATB_LATB4_LENGTH                                  0x1
#define _LATB_LATB4_MASK                                    0x10
#define _LATB_LATB5_POSN                                    0x5
#define _LATB_LATB5_POSITION                                0x5
#define _LATB_LATB5_SIZE                                    0x1
#define _LATB_LATB5_LENGTH                                  0x1
#define _LATB_LATB5_MASK                                    0x20
#define _LATB_LATB6_POSN                                    0x6
#define _LATB_LATB6_POSITION                                0x6
#define _LATB_LATB6_SIZE                                    0x1
#define _LATB_LATB6_LENGTH                                  0x1
#define _LATB_LATB6_MASK                                    0x40
#define _LATB_LATB7_POSN                                    0x7
#define _LATB_LATB7_POSITION                                0x7
#define _LATB_LATB7_SIZE                                    0x1
#define _LATB_LATB7_LENGTH                                  0x1
#define _LATB_LATB7_MASK                                    0x80

// Register: LATC
extern volatile unsigned char           LATC                @ 0x10E;
#ifndef _LIB_BUILD
asm("LATC equ 010Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LATC0                  :1;
        unsigned LATC1                  :1;
        unsigned LATC2                  :1;
        unsigned LATC3                  :1;
        unsigned LATC4                  :1;
        unsigned LATC5                  :1;
        unsigned LATC6                  :1;
        unsigned LATC7                  :1;
    };
} LATCbits_t;
extern volatile LATCbits_t LATCbits @ 0x10E;
// bitfield macros
#define _LATC_LATC0_POSN                                    0x0
#define _LATC_LATC0_POSITION                                0x0
#define _LATC_LATC0_SIZE                                    0x1
#define _LATC_LATC0_LENGTH                                  0x1
#define _LATC_LATC0_MASK                                    0x1
#define _LATC_LATC1_POSN                                    0x1
#define _LATC_LATC1_POSITION                                0x1
#define _LATC_LATC1_SIZE                                    0x1
#define _LATC_LATC1_LENGTH                                  0x1
#define _LATC_LATC1_MASK                                    0x2
#define _LATC_LATC2_POSN                                    0x2
#define _LATC_LATC2_POSITION                                0x2
#define _LATC_LATC2_SIZE                                    0x1
#define _LATC_LATC2_LENGTH                                  0x1
#define _LATC_LATC2_MASK                                    0x4
#define _LATC_LATC3_POSN                                    0x3
#define _LATC_LATC3_POSITION                                0x3
#define _LATC_LATC3_SIZE                                    0x1
#define _LATC_LATC3_LENGTH                                  0x1
#define _LATC_LATC3_MASK                                    0x8
#define _LATC_LATC4_POSN                                    0x4
#define _LATC_LATC4_POSITION                                0x4
#define _LATC_LATC4_SIZE                                    0x1
#define _LATC_LATC4_LENGTH                                  0x1
#define _LATC_LATC4_MASK                                    0x10
#define _LATC_LATC5_POSN                                    0x5
#define _LATC_LATC5_POSITION                                0x5
#define _LATC_LATC5_SIZE                                    0x1
#define _LATC_LATC5_LENGTH                                  0x1
#define _LATC_LATC5_MASK                                    0x20
#define _LATC_LATC6_POSN                                    0x6
#define _LATC_LATC6_POSITION                                0x6
#define _LATC_LATC6_SIZE                                    0x1
#define _LATC_LATC6_LENGTH                                  0x1
#define _LATC_LATC6_MASK                                    0x40
#define _LATC_LATC7_POSN                                    0x7
#define _LATC_LATC7_POSITION                                0x7
#define _LATC_LATC7_SIZE                                    0x1
#define _LATC_LATC7_LENGTH                                  0x1
#define _LATC_LATC7_MASK                                    0x80

// Register: CM1CON0
extern volatile unsigned char           CM1CON0             @ 0x111;
#ifndef _LIB_BUILD
asm("CM1CON0 equ 0111h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned C1SYNC                 :1;
        unsigned C1HYS                  :1;
        unsigned C1SP                   :1;
        unsigned                        :1;
        unsigned C1POL                  :1;
        unsigned                        :1;
        unsigned C1OUT                  :1;
        unsigned C1ON                   :1;
    };
} CM1CON0bits_t;
extern volatile CM1CON0bits_t CM1CON0bits @ 0x111;
// bitfield macros
#define _CM1CON0_C1SYNC_POSN                                0x0
#define _CM1CON0_C1SYNC_POSITION                            0x0
#define _CM1CON0_C1SYNC_SIZE                                0x1
#define _CM1CON0_C1SYNC_LENGTH                              0x1
#define _CM1CON0_C1SYNC_MASK                                0x1
#define _CM1CON0_C1HYS_POSN                                 0x1
#define _CM1CON0_C1HYS_POSITION                             0x1
#define _CM1CON0_C1HYS_SIZE                                 0x1
#define _CM1CON0_C1HYS_LENGTH                               0x1
#define _CM1CON0_C1HYS_MASK                                 0x2
#define _CM1CON0_C1SP_POSN                                  0x2
#define _CM1CON0_C1SP_POSITION                              0x2
#define _CM1CON0_C1SP_SIZE                                  0x1
#define _CM1CON0_C1SP_LENGTH                                0x1
#define _CM1CON0_C1SP_MASK                                  0x4
#define _CM1CON0_C1POL_POSN                                 0x4
#define _CM1CON0_C1POL_POSITION                             0x4
#define _CM1CON0_C1POL_SIZE                                 0x1
#define _CM1CON0_C1POL_LENGTH                               0x1
#define _CM1CON0_C1POL_MASK                                 0x10
#define _CM1CON0_C1OUT_POSN                                 0x6
#define _CM1CON0_C1OUT_POSITION                             0x6
#define _CM1CON0_C1OUT_SIZE                                 0x1
#define _CM1CON0_C1OUT_LENGTH                               0x1
#define _CM1CON0_C1OUT_MASK                                 0x40
#define _CM1CON0_C1ON_POSN                                  0x7
#define _CM1CON0_C1ON_POSITION                              0x7
#define _CM1CON0_C1ON_SIZE                                  0x1
#define _CM1CON0_C1ON_LENGTH                                0x1
#define _CM1CON0_C1ON_MASK                                  0x80

// Register: CM1CON1
extern volatile unsigned char           CM1CON1             @ 0x112;
#ifndef _LIB_BUILD
asm("CM1CON1 equ 0112h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned C1NCH0                 :1;
        unsigned C1NCH1                 :1;
        unsigned C1NCH2                 :1;
        unsigned                        :1;
        unsigned C1PCH0                 :1;
        unsigned C1PCH1                 :1;
        unsigned C1INTN                 :1;
        unsigned C1INTP                 :1;
    };
    struct {
        unsigned C1NCH                  :3;
        unsigned                        :1;
        unsigned C1PCH                  :2;
    };
} CM1CON1bits_t;
extern volatile CM1CON1bits_t CM1CON1bits @ 0x112;
// bitfield macros
#define _CM1CON1_C1NCH0_POSN                                0x0
#define _CM1CON1_C1NCH0_POSITION                            0x0
#define _CM1CON1_C1NCH0_SIZE                                0x1
#define _CM1CON1_C1NCH0_LENGTH                              0x1
#define _CM1CON1_C1NCH0_MASK                                0x1
#define _CM1CON1_C1NCH1_POSN                                0x1
#define _CM1CON1_C1NCH1_POSITION                            0x1
#define _CM1CON1_C1NCH1_SIZE                                0x1
#define _CM1CON1_C1NCH1_LENGTH                              0x1
#define _CM1CON1_C1NCH1_MASK                                0x2
#define _CM1CON1_C1NCH2_POSN                                0x2
#define _CM1CON1_C1NCH2_POSITION                            0x2
#define _CM1CON1_C1NCH2_SIZE                                0x1
#define _CM1CON1_C1NCH2_LENGTH                              0x1
#define _CM1CON1_C1NCH2_MASK                                0x4
#define _CM1CON1_C1PCH0_POSN                                0x4
#define _CM1CON1_C1PCH0_POSITION                            0x4
#define _CM1CON1_C1PCH0_SIZE                                0x1
#define _CM1CON1_C1PCH0_LENGTH                              0x1
#define _CM1CON1_C1PCH0_MASK                                0x10
#define _CM1CON1_C1PCH1_POSN                                0x5
#define _CM1CON1_C1PCH1_POSITION                            0x5
#define _CM1CON1_C1PCH1_SIZE                                0x1
#define _CM1CON1_C1PCH1_LENGTH                              0x1
#define _CM1CON1_C1PCH1_MASK                                0x20
#define _CM1CON1_C1INTN_POSN                                0x6
#define _CM1CON1_C1INTN_POSITION                            0x6
#define _CM1CON1_C1INTN_SIZE                                0x1
#define _CM1CON1_C1INTN_LENGTH                              0x1
#define _CM1CON1_C1INTN_MASK                                0x40
#define _CM1CON1_C1INTP_POSN                                0x7
#define _CM1CON1_C1INTP_POSITION                            0x7
#define _CM1CON1_C1INTP_SIZE                                0x1
#define _CM1CON1_C1INTP_LENGTH                              0x1
#define _CM1CON1_C1INTP_MASK                                0x80
#define _CM1CON1_C1NCH_POSN                                 0x0
#define _CM1CON1_C1NCH_POSITION                             0x0
#define _CM1CON1_C1NCH_SIZE                                 0x3
#define _CM1CON1_C1NCH_LENGTH                               0x3
#define _CM1CON1_C1NCH_MASK                                 0x7
#define _CM1CON1_C1PCH_POSN                                 0x4
#define _CM1CON1_C1PCH_POSITION                             0x4
#define _CM1CON1_C1PCH_SIZE                                 0x2
#define _CM1CON1_C1PCH_LENGTH                               0x2
#define _CM1CON1_C1PCH_MASK                                 0x30

// Register: CM2CON0
extern volatile unsigned char           CM2CON0             @ 0x113;
#ifndef _LIB_BUILD
asm("CM2CON0 equ 0113h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned C2SYNC                 :1;
        unsigned C2HYS                  :1;
        unsigned C2SP                   :1;
        unsigned                        :1;
        unsigned C2POL                  :1;
        unsigned                        :1;
        unsigned C2OUT                  :1;
        unsigned C2ON                   :1;
    };
} CM2CON0bits_t;
extern volatile CM2CON0bits_t CM2CON0bits @ 0x113;
// bitfield macros
#define _CM2CON0_C2SYNC_POSN                                0x0
#define _CM2CON0_C2SYNC_POSITION                            0x0
#define _CM2CON0_C2SYNC_SIZE                                0x1
#define _CM2CON0_C2SYNC_LENGTH                              0x1
#define _CM2CON0_C2SYNC_MASK                                0x1
#define _CM2CON0_C2HYS_POSN                                 0x1
#define _CM2CON0_C2HYS_POSITION                             0x1
#define _CM2CON0_C2HYS_SIZE                                 0x1
#define _CM2CON0_C2HYS_LENGTH                               0x1
#define _CM2CON0_C2HYS_MASK                                 0x2
#define _CM2CON0_C2SP_POSN                                  0x2
#define _CM2CON0_C2SP_POSITION                              0x2
#define _CM2CON0_C2SP_SIZE                                  0x1
#define _CM2CON0_C2SP_LENGTH                                0x1
#define _CM2CON0_C2SP_MASK                                  0x4
#define _CM2CON0_C2POL_POSN                                 0x4
#define _CM2CON0_C2POL_POSITION                             0x4
#define _CM2CON0_C2POL_SIZE                                 0x1
#define _CM2CON0_C2POL_LENGTH                               0x1
#define _CM2CON0_C2POL_MASK                                 0x10
#define _CM2CON0_C2OUT_POSN                                 0x6
#define _CM2CON0_C2OUT_POSITION                             0x6
#define _CM2CON0_C2OUT_SIZE                                 0x1
#define _CM2CON0_C2OUT_LENGTH                               0x1
#define _CM2CON0_C2OUT_MASK                                 0x40
#define _CM2CON0_C2ON_POSN                                  0x7
#define _CM2CON0_C2ON_POSITION                              0x7
#define _CM2CON0_C2ON_SIZE                                  0x1
#define _CM2CON0_C2ON_LENGTH                                0x1
#define _CM2CON0_C2ON_MASK                                  0x80

// Register: CM2CON1
extern volatile unsigned char           CM2CON1             @ 0x114;
#ifndef _LIB_BUILD
asm("CM2CON1 equ 0114h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned C2NCH0                 :1;
        unsigned C2NCH1                 :1;
        unsigned C2NCH2                 :1;
        unsigned                        :1;
        unsigned C2PCH0                 :1;
        unsigned C2PCH1                 :1;
        unsigned C2INTN                 :1;
        unsigned C2INTP                 :1;
    };
    struct {
        unsigned C2NCH                  :3;
        unsigned                        :1;
        unsigned C2PCH                  :2;
    };
} CM2CON1bits_t;
extern volatile CM2CON1bits_t CM2CON1bits @ 0x114;
// bitfield macros
#define _CM2CON1_C2NCH0_POSN                                0x0
#define _CM2CON1_C2NCH0_POSITION                            0x0
#define _CM2CON1_C2NCH0_SIZE                                0x1
#define _CM2CON1_C2NCH0_LENGTH                              0x1
#define _CM2CON1_C2NCH0_MASK                                0x1
#define _CM2CON1_C2NCH1_POSN                                0x1
#define _CM2CON1_C2NCH1_POSITION                            0x1
#define _CM2CON1_C2NCH1_SIZE                                0x1
#define _CM2CON1_C2NCH1_LENGTH                              0x1
#define _CM2CON1_C2NCH1_MASK                                0x2
#define _CM2CON1_C2NCH2_POSN                                0x2
#define _CM2CON1_C2NCH2_POSITION                            0x2
#define _CM2CON1_C2NCH2_SIZE                                0x1
#define _CM2CON1_C2NCH2_LENGTH                              0x1
#define _CM2CON1_C2NCH2_MASK                                0x4
#define _CM2CON1_C2PCH0_POSN                                0x4
#define _CM2CON1_C2PCH0_POSITION                            0x4
#define _CM2CON1_C2PCH0_SIZE                                0x1
#define _CM2CON1_C2PCH0_LENGTH                              0x1
#define _CM2CON1_C2PCH0_MASK                                0x10
#define _CM2CON1_C2PCH1_POSN                                0x5
#define _CM2CON1_C2PCH1_POSITION                            0x5
#define _CM2CON1_C2PCH1_SIZE                                0x1
#define _CM2CON1_C2PCH1_LENGTH                              0x1
#define _CM2CON1_C2PCH1_MASK                                0x20
#define _CM2CON1_C2INTN_POSN                                0x6
#define _CM2CON1_C2INTN_POSITION                            0x6
#define _CM2CON1_C2INTN_SIZE                                0x1
#define _CM2CON1_C2INTN_LENGTH                              0x1
#define _CM2CON1_C2INTN_MASK                                0x40
#define _CM2CON1_C2INTP_POSN                                0x7
#define _CM2CON1_C2INTP_POSITION                            0x7
#define _CM2CON1_C2INTP_SIZE                                0x1
#define _CM2CON1_C2INTP_LENGTH                              0x1
#define _CM2CON1_C2INTP_MASK                                0x80
#define _CM2CON1_C2NCH_POSN                                 0x0
#define _CM2CON1_C2NCH_POSITION                             0x0
#define _CM2CON1_C2NCH_SIZE                                 0x3
#define _CM2CON1_C2NCH_LENGTH                               0x3
#define _CM2CON1_C2NCH_MASK                                 0x7
#define _CM2CON1_C2PCH_POSN                                 0x4
#define _CM2CON1_C2PCH_POSITION                             0x4
#define _CM2CON1_C2PCH_SIZE                                 0x2
#define _CM2CON1_C2PCH_LENGTH                               0x2
#define _CM2CON1_C2PCH_MASK                                 0x30

// Register: CMOUT
extern volatile unsigned char           CMOUT               @ 0x115;
#ifndef _LIB_BUILD
asm("CMOUT equ 0115h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned MC1OUT                 :1;
        unsigned MC2OUT                 :1;
    };
} CMOUTbits_t;
extern volatile CMOUTbits_t CMOUTbits @ 0x115;
// bitfield macros
#define _CMOUT_MC1OUT_POSN                                  0x0
#define _CMOUT_MC1OUT_POSITION                              0x0
#define _CMOUT_MC1OUT_SIZE                                  0x1
#define _CMOUT_MC1OUT_LENGTH                                0x1
#define _CMOUT_MC1OUT_MASK                                  0x1
#define _CMOUT_MC2OUT_POSN                                  0x1
#define _CMOUT_MC2OUT_POSITION                              0x1
#define _CMOUT_MC2OUT_SIZE                                  0x1
#define _CMOUT_MC2OUT_LENGTH                                0x1
#define _CMOUT_MC2OUT_MASK                                  0x2

// Register: BORCON
extern volatile unsigned char           BORCON              @ 0x116;
#ifndef _LIB_BUILD
asm("BORCON equ 0116h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned BORRDY                 :1;
        unsigned                        :5;
        unsigned BORFS                  :1;
        unsigned SBOREN                 :1;
    };
} BORCONbits_t;
extern volatile BORCONbits_t BORCONbits @ 0x116;
// bitfield macros
#define _BORCON_BORRDY_POSN                                 0x0
#define _BORCON_BORRDY_POSITION                             0x0
#define _BORCON_BORRDY_SIZE                                 0x1
#define _BORCON_BORRDY_LENGTH                               0x1
#define _BORCON_BORRDY_MASK                                 0x1
#define _BORCON_BORFS_POSN                                  0x6
#define _BORCON_BORFS_POSITION                              0x6
#define _BORCON_BORFS_SIZE                                  0x1
#define _BORCON_BORFS_LENGTH                                0x1
#define _BORCON_BORFS_MASK                                  0x40
#define _BORCON_SBOREN_POSN                                 0x7
#define _BORCON_SBOREN_POSITION                             0x7
#define _BORCON_SBOREN_SIZE                                 0x1
#define _BORCON_SBOREN_LENGTH                               0x1
#define _BORCON_SBOREN_MASK                                 0x80

// Register: FVRCON
extern volatile unsigned char           FVRCON              @ 0x117;
#ifndef _LIB_BUILD
asm("FVRCON equ 0117h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ADFVR                  :2;
        unsigned CDAFVR                 :2;
        unsigned TSRNG                  :1;
        unsigned TSEN                   :1;
        unsigned FVRRDY                 :1;
        unsigned FVREN                  :1;
    };
    struct {
        unsigned ADFVR0                 :1;
        unsigned ADFVR1                 :1;
        unsigned CDAFVR0                :1;
        unsigned CDAFVR1                :1;
    };
} FVRCONbits_t;
extern volatile FVRCONbits_t FVRCONbits @ 0x117;
// bitfield macros
#define _FVRCON_ADFVR_POSN                                  0x0
#define _FVRCON_ADFVR_POSITION                              0x0
#define _FVRCON_ADFVR_SIZE                                  0x2
#define _FVRCON_ADFVR_LENGTH                                0x2
#define _FVRCON_ADFVR_MASK                                  0x3
#define _FVRCON_CDAFVR_POSN                                 0x2
#define _FVRCON_CDAFVR_POSITION                             0x2
#define _FVRCON_CDAFVR_SIZE                                 0x2
#define _FVRCON_CDAFVR_LENGTH                               0x2
#define _FVRCON_CDAFVR_MASK                                 0xC
#define _FVRCON_TSRNG_POSN                                  0x4
#define _FVRCON_TSRNG_POSITION                              0x4
#define _FVRCON_TSRNG_SIZE                                  0x1
#define _FVRCON_TSRNG_LENGTH                                0x1
#define _FVRCON_TSRNG_MASK                                  0x10
#define _FVRCON_TSEN_POSN                                   0x5
#define _FVRCON_TSEN_POSITION                               0x5
#define _FVRCON_TSEN_SIZE                                   0x1
#define _FVRCON_TSEN_LENGTH                                 0x1
#define _FVRCON_TSEN_MASK                                   0x20
#define _FVRCON_FVRRDY_POSN                                 0x6
#define _FVRCON_FVRRDY_POSITION                             0x6
#define _FVRCON_FVRRDY_SIZE                                 0x1
#define _FVRCON_FVRRDY_LENGTH                               0x1
#define _FVRCON_FVRRDY_MASK                                 0x40
#define _FVRCON_FVREN_POSN                                  0x7
#define _FVRCON_FVREN_POSITION                              0x7
#define _FVRCON_FVREN_SIZE                                  0x1
#define _FVRCON_FVREN_LENGTH                                0x1
#define _FVRCON_FVREN_MASK                                  0x80
#define _FVRCON_ADFVR0_POSN                                 0x0
#define _FVRCON_ADFVR0_POSITION                             0x0
#define _FVRCON_ADFVR0_SIZE                                 0x1
#define _FVRCON_ADFVR0_LENGTH                               0x1
#define _FVRCON_ADFVR0_MASK                                 0x1
#define _FVRCON_ADFVR1_POSN                                 0x1
#define _FVRCON_ADFVR1_POSITION                             0x1
#define _FVRCON_ADFVR1_SIZE                                 0x1
#define _FVRCON_ADFVR1_LENGTH                               0x1
#define _FVRCON_ADFVR1_MASK                                 0x2
#define _FVRCON_CDAFVR0_POSN                                0x2
#define _FVRCON_CDAFVR0_POSITION                            0x2
#define _FVRCON_CDAFVR0_SIZE                                0x1
#define _FVRCON_CDAFVR0_LENGTH                              0x1
#define _FVRCON_CDAFVR0_MASK                                0x4
#define _FVRCON_CDAFVR1_POSN                                0x3
#define _FVRCON_CDAFVR1_POSITION                            0x3
#define _FVRCON_CDAFVR1_SIZE                                0x1
#define _FVRCON_CDAFVR1_LENGTH                              0x1
#define _FVRCON_CDAFVR1_MASK                                0x8

// Register: DAC1CON0
extern volatile unsigned char           DAC1CON0            @ 0x118;
#ifndef _LIB_BUILD
asm("DAC1CON0 equ 0118h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :2;
        unsigned DAC1PSS                :2;
        unsigned                        :1;
        unsigned DAC1OE                 :1;
        unsigned                        :1;
        unsigned DAC1EN                 :1;
    };
    struct {
        unsigned                        :2;
        unsigned D1PSS0                 :1;
        unsigned D1PSS1                 :1;
    };
} DAC1CON0bits_t;
extern volatile DAC1CON0bits_t DAC1CON0bits @ 0x118;
// bitfield macros
#define _DAC1CON0_DAC1PSS_POSN                              0x2
#define _DAC1CON0_DAC1PSS_POSITION                          0x2
#define _DAC1CON0_DAC1PSS_SIZE                              0x2
#define _DAC1CON0_DAC1PSS_LENGTH                            0x2
#define _DAC1CON0_DAC1PSS_MASK                              0xC
#define _DAC1CON0_DAC1OE_POSN                               0x5
#define _DAC1CON0_DAC1OE_POSITION                           0x5
#define _DAC1CON0_DAC1OE_SIZE                               0x1
#define _DAC1CON0_DAC1OE_LENGTH                             0x1
#define _DAC1CON0_DAC1OE_MASK                               0x20
#define _DAC1CON0_DAC1EN_POSN                               0x7
#define _DAC1CON0_DAC1EN_POSITION                           0x7
#define _DAC1CON0_DAC1EN_SIZE                               0x1
#define _DAC1CON0_DAC1EN_LENGTH                             0x1
#define _DAC1CON0_DAC1EN_MASK                               0x80
#define _DAC1CON0_D1PSS0_POSN                               0x2
#define _DAC1CON0_D1PSS0_POSITION                           0x2
#define _DAC1CON0_D1PSS0_SIZE                               0x1
#define _DAC1CON0_D1PSS0_LENGTH                             0x1
#define _DAC1CON0_D1PSS0_MASK                               0x4
#define _DAC1CON0_D1PSS1_POSN                               0x3
#define _DAC1CON0_D1PSS1_POSITION                           0x3
#define _DAC1CON0_D1PSS1_SIZE                               0x1
#define _DAC1CON0_D1PSS1_LENGTH                             0x1
#define _DAC1CON0_D1PSS1_MASK                               0x8

// Register: DAC1CON1
extern volatile unsigned char           DAC1CON1            @ 0x119;
#ifndef _LIB_BUILD
asm("DAC1CON1 equ 0119h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned DAC1R                  :8;
    };
    struct {
        unsigned DAC1R0                 :1;
        unsigned DAC1R1                 :1;
        unsigned DAC1R2                 :1;
        unsigned DAC1R3                 :1;
        unsigned DAC1R4                 :1;
        unsigned DAC1R5                 :1;
        unsigned DAC1R6                 :1;
        unsigned DAC1R7                 :1;
    };
} DAC1CON1bits_t;
extern volatile DAC1CON1bits_t DAC1CON1bits @ 0x119;
// bitfield macros
#define _DAC1CON1_DAC1R_POSN                                0x0
#define _DAC1CON1_DAC1R_POSITION                            0x0
#define _DAC1CON1_DAC1R_SIZE                                0x8
#define _DAC1CON1_DAC1R_LENGTH                              0x8
#define _DAC1CON1_DAC1R_MASK                                0xFF
#define _DAC1CON1_DAC1R0_POSN                               0x0
#define _DAC1CON1_DAC1R0_POSITION                           0x0
#define _DAC1CON1_DAC1R0_SIZE                               0x1
#define _DAC1CON1_DAC1R0_LENGTH                             0x1
#define _DAC1CON1_DAC1R0_MASK                               0x1
#define _DAC1CON1_DAC1R1_POSN                               0x1
#define _DAC1CON1_DAC1R1_POSITION                           0x1
#define _DAC1CON1_DAC1R1_SIZE                               0x1
#define _DAC1CON1_DAC1R1_LENGTH                             0x1
#define _DAC1CON1_DAC1R1_MASK                               0x2
#define _DAC1CON1_DAC1R2_POSN                               0x2
#define _DAC1CON1_DAC1R2_POSITION                           0x2
#define _DAC1CON1_DAC1R2_SIZE                               0x1
#define _DAC1CON1_DAC1R2_LENGTH                             0x1
#define _DAC1CON1_DAC1R2_MASK                               0x4
#define _DAC1CON1_DAC1R3_POSN                               0x3
#define _DAC1CON1_DAC1R3_POSITION                           0x3
#define _DAC1CON1_DAC1R3_SIZE                               0x1
#define _DAC1CON1_DAC1R3_LENGTH                             0x1
#define _DAC1CON1_DAC1R3_MASK                               0x8
#define _DAC1CON1_DAC1R4_POSN                               0x4
#define _DAC1CON1_DAC1R4_POSITION                           0x4
#define _DAC1CON1_DAC1R4_SIZE                               0x1
#define _DAC1CON1_DAC1R4_LENGTH                             0x1
#define _DAC1CON1_DAC1R4_MASK                               0x10
#define _DAC1CON1_DAC1R5_POSN                               0x5
#define _DAC1CON1_DAC1R5_POSITION                           0x5
#define _DAC1CON1_DAC1R5_SIZE                               0x1
#define _DAC1CON1_DAC1R5_LENGTH                             0x1
#define _DAC1CON1_DAC1R5_MASK                               0x20
#define _DAC1CON1_DAC1R6_POSN                               0x6
#define _DAC1CON1_DAC1R6_POSITION                           0x6
#define _DAC1CON1_DAC1R6_SIZE                               0x1
#define _DAC1CON1_DAC1R6_LENGTH                             0x1
#define _DAC1CON1_DAC1R6_MASK                               0x40
#define _DAC1CON1_DAC1R7_POSN                               0x7
#define _DAC1CON1_DAC1R7_POSITION                           0x7
#define _DAC1CON1_DAC1R7_SIZE                               0x1
#define _DAC1CON1_DAC1R7_LENGTH                             0x1
#define _DAC1CON1_DAC1R7_MASK                               0x80

// Register: ZCD1CON
extern volatile unsigned char           ZCD1CON             @ 0x11C;
#ifndef _LIB_BUILD
asm("ZCD1CON equ 011Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ZCD1INTN               :1;
        unsigned ZCD1INTP               :1;
        unsigned                        :2;
        unsigned ZCD1POL                :1;
        unsigned ZCD1OUT                :1;
        unsigned                        :1;
        unsigned ZCD1EN                 :1;
    };
} ZCD1CONbits_t;
extern volatile ZCD1CONbits_t ZCD1CONbits @ 0x11C;
// bitfield macros
#define _ZCD1CON_ZCD1INTN_POSN                              0x0
#define _ZCD1CON_ZCD1INTN_POSITION                          0x0
#define _ZCD1CON_ZCD1INTN_SIZE                              0x1
#define _ZCD1CON_ZCD1INTN_LENGTH                            0x1
#define _ZCD1CON_ZCD1INTN_MASK                              0x1
#define _ZCD1CON_ZCD1INTP_POSN                              0x1
#define _ZCD1CON_ZCD1INTP_POSITION                          0x1
#define _ZCD1CON_ZCD1INTP_SIZE                              0x1
#define _ZCD1CON_ZCD1INTP_LENGTH                            0x1
#define _ZCD1CON_ZCD1INTP_MASK                              0x2
#define _ZCD1CON_ZCD1POL_POSN                               0x4
#define _ZCD1CON_ZCD1POL_POSITION                           0x4
#define _ZCD1CON_ZCD1POL_SIZE                               0x1
#define _ZCD1CON_ZCD1POL_LENGTH                             0x1
#define _ZCD1CON_ZCD1POL_MASK                               0x10
#define _ZCD1CON_ZCD1OUT_POSN                               0x5
#define _ZCD1CON_ZCD1OUT_POSITION                           0x5
#define _ZCD1CON_ZCD1OUT_SIZE                               0x1
#define _ZCD1CON_ZCD1OUT_LENGTH                             0x1
#define _ZCD1CON_ZCD1OUT_MASK                               0x20
#define _ZCD1CON_ZCD1EN_POSN                                0x7
#define _ZCD1CON_ZCD1EN_POSITION                            0x7
#define _ZCD1CON_ZCD1EN_SIZE                                0x1
#define _ZCD1CON_ZCD1EN_LENGTH                              0x1
#define _ZCD1CON_ZCD1EN_MASK                                0x80

// Register: ANSELA
extern volatile unsigned char           ANSELA              @ 0x18C;
#ifndef _LIB_BUILD
asm("ANSELA equ 018Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ANSA0                  :1;
        unsigned ANSA1                  :1;
        unsigned ANSA2                  :1;
        unsigned                        :1;
        unsigned ANSA4                  :1;
    };
    struct {
        unsigned ANSELA                 :6;
    };
} ANSELAbits_t;
extern volatile ANSELAbits_t ANSELAbits @ 0x18C;
// bitfield macros
#define _ANSELA_ANSA0_POSN                                  0x0
#define _ANSELA_ANSA0_POSITION                              0x0
#define _ANSELA_ANSA0_SIZE                                  0x1
#define _ANSELA_ANSA0_LENGTH                                0x1
#define _ANSELA_ANSA0_MASK                                  0x1
#define _ANSELA_ANSA1_POSN                                  0x1
#define _ANSELA_ANSA1_POSITION                              0x1
#define _ANSELA_ANSA1_SIZE                                  0x1
#define _ANSELA_ANSA1_LENGTH                                0x1
#define _ANSELA_ANSA1_MASK                                  0x2
#define _ANSELA_ANSA2_POSN                                  0x2
#define _ANSELA_ANSA2_POSITION                              0x2
#define _ANSELA_ANSA2_SIZE                                  0x1
#define _ANSELA_ANSA2_LENGTH                                0x1
#define _ANSELA_ANSA2_MASK                                  0x4
#define _ANSELA_ANSA4_POSN                                  0x4
#define _ANSELA_ANSA4_POSITION                              0x4
#define _ANSELA_ANSA4_SIZE                                  0x1
#define _ANSELA_ANSA4_LENGTH                                0x1
#define _ANSELA_ANSA4_MASK                                  0x10
#define _ANSELA_ANSELA_POSN                                 0x0
#define _ANSELA_ANSELA_POSITION                             0x0
#define _ANSELA_ANSELA_SIZE                                 0x6
#define _ANSELA_ANSELA_LENGTH                               0x6
#define _ANSELA_ANSELA_MASK                                 0x3F

// Register: ANSELB
extern volatile unsigned char           ANSELB              @ 0x18D;
#ifndef _LIB_BUILD
asm("ANSELB equ 018Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned ANSB4                  :1;
        unsigned ANSB5                  :1;
        unsigned ANSB6                  :1;
        unsigned ANSB7                  :1;
    };
} ANSELBbits_t;
extern volatile ANSELBbits_t ANSELBbits @ 0x18D;
// bitfield macros
#define _ANSELB_ANSB4_POSN                                  0x4
#define _ANSELB_ANSB4_POSITION                              0x4
#define _ANSELB_ANSB4_SIZE                                  0x1
#define _ANSELB_ANSB4_LENGTH                                0x1
#define _ANSELB_ANSB4_MASK                                  0x10
#define _ANSELB_ANSB5_POSN                                  0x5
#define _ANSELB_ANSB5_POSITION                              0x5
#define _ANSELB_ANSB5_SIZE                                  0x1
#define _ANSELB_ANSB5_LENGTH                                0x1
#define _ANSELB_ANSB5_MASK                                  0x20
#define _ANSELB_ANSB6_POSN                                  0x6
#define _ANSELB_ANSB6_POSITION                              0x6
#define _ANSELB_ANSB6_SIZE                                  0x1
#define _ANSELB_ANSB6_LENGTH                                0x1
#define _ANSELB_ANSB6_MASK                                  0x40
#define _ANSELB_ANSB7_POSN                                  0x7
#define _ANSELB_ANSB7_POSITION                              0x7
#define _ANSELB_ANSB7_SIZE                                  0x1
#define _ANSELB_ANSB7_LENGTH                                0x1
#define _ANSELB_ANSB7_MASK                                  0x80

// Register: ANSELC
extern volatile unsigned char           ANSELC              @ 0x18E;
#ifndef _LIB_BUILD
asm("ANSELC equ 018Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ANSC0                  :1;
        unsigned ANSC1                  :1;
        unsigned ANSC2                  :1;
        unsigned ANSC3                  :1;
        unsigned                        :2;
        unsigned ANSC6                  :1;
        unsigned ANSC7                  :1;
    };
    struct {
        unsigned ANSELC                 :8;
    };
} ANSELCbits_t;
extern volatile ANSELCbits_t ANSELCbits @ 0x18E;
// bitfield macros
#define _ANSELC_ANSC0_POSN                                  0x0
#define _ANSELC_ANSC0_POSITION                              0x0
#define _ANSELC_ANSC0_SIZE                                  0x1
#define _ANSELC_ANSC0_LENGTH                                0x1
#define _ANSELC_ANSC0_MASK                                  0x1
#define _ANSELC_ANSC1_POSN                                  0x1
#define _ANSELC_ANSC1_POSITION                              0x1
#define _ANSELC_ANSC1_SIZE                                  0x1
#define _ANSELC_ANSC1_LENGTH                                0x1
#define _ANSELC_ANSC1_MASK                                  0x2
#define _ANSELC_ANSC2_POSN                                  0x2
#define _ANSELC_ANSC2_POSITION                              0x2
#define _ANSELC_ANSC2_SIZE                                  0x1
#define _ANSELC_ANSC2_LENGTH                                0x1
#define _ANSELC_ANSC2_MASK                                  0x4
#define _ANSELC_ANSC3_POSN                                  0x3
#define _ANSELC_ANSC3_POSITION                              0x3
#define _ANSELC_ANSC3_SIZE                                  0x1
#define _ANSELC_ANSC3_LENGTH                                0x1
#define _ANSELC_ANSC3_MASK                                  0x8
#define _ANSELC_ANSC6_POSN                                  0x6
#define _ANSELC_ANSC6_POSITION                              0x6
#define _ANSELC_ANSC6_SIZE                                  0x1
#define _ANSELC_ANSC6_LENGTH                                0x1
#define _ANSELC_ANSC6_MASK                                  0x40
#define _ANSELC_ANSC7_POSN                                  0x7
#define _ANSELC_ANSC7_POSITION                              0x7
#define _ANSELC_ANSC7_SIZE                                  0x1
#define _ANSELC_ANSC7_LENGTH                                0x1
#define _ANSELC_ANSC7_MASK                                  0x80
#define _ANSELC_ANSELC_POSN                                 0x0
#define _ANSELC_ANSELC_POSITION                             0x0
#define _ANSELC_ANSELC_SIZE                                 0x8
#define _ANSELC_ANSELC_LENGTH                               0x8
#define _ANSELC_ANSELC_MASK                                 0xFF

// Register: PMADR
extern volatile unsigned short          PMADR               @ 0x191;
#ifndef _LIB_BUILD
asm("PMADR equ 0191h");
#endif

// Register: PMADRL
extern volatile unsigned char           PMADRL              @ 0x191;
#ifndef _LIB_BUILD
asm("PMADRL equ 0191h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PMADRL                 :8;
    };
} PMADRLbits_t;
extern volatile PMADRLbits_t PMADRLbits @ 0x191;
// bitfield macros
#define _PMADRL_PMADRL_POSN                                 0x0
#define _PMADRL_PMADRL_POSITION                             0x0
#define _PMADRL_PMADRL_SIZE                                 0x8
#define _PMADRL_PMADRL_LENGTH                               0x8
#define _PMADRL_PMADRL_MASK                                 0xFF

// Register: PMADRH
extern volatile unsigned char           PMADRH              @ 0x192;
#ifndef _LIB_BUILD
asm("PMADRH equ 0192h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PMADRH                 :7;
    };
} PMADRHbits_t;
extern volatile PMADRHbits_t PMADRHbits @ 0x192;
// bitfield macros
#define _PMADRH_PMADRH_POSN                                 0x0
#define _PMADRH_PMADRH_POSITION                             0x0
#define _PMADRH_PMADRH_SIZE                                 0x7
#define _PMADRH_PMADRH_LENGTH                               0x7
#define _PMADRH_PMADRH_MASK                                 0x7F

// Register: PMDAT
extern volatile unsigned short          PMDAT               @ 0x193;
#ifndef _LIB_BUILD
asm("PMDAT equ 0193h");
#endif

// Register: PMDATL
extern volatile unsigned char           PMDATL              @ 0x193;
#ifndef _LIB_BUILD
asm("PMDATL equ 0193h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PMDATL                 :8;
    };
} PMDATLbits_t;
extern volatile PMDATLbits_t PMDATLbits @ 0x193;
// bitfield macros
#define _PMDATL_PMDATL_POSN                                 0x0
#define _PMDATL_PMDATL_POSITION                             0x0
#define _PMDATL_PMDATL_SIZE                                 0x8
#define _PMDATL_PMDATL_LENGTH                               0x8
#define _PMDATL_PMDATL_MASK                                 0xFF

// Register: PMDATH
extern volatile unsigned char           PMDATH              @ 0x194;
#ifndef _LIB_BUILD
asm("PMDATH equ 0194h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PMDATH                 :6;
    };
} PMDATHbits_t;
extern volatile PMDATHbits_t PMDATHbits @ 0x194;
// bitfield macros
#define _PMDATH_PMDATH_POSN                                 0x0
#define _PMDATH_PMDATH_POSITION                             0x0
#define _PMDATH_PMDATH_SIZE                                 0x6
#define _PMDATH_PMDATH_LENGTH                               0x6
#define _PMDATH_PMDATH_MASK                                 0x3F

// Register: PMCON1
extern volatile unsigned char           PMCON1              @ 0x195;
#ifndef _LIB_BUILD
asm("PMCON1 equ 0195h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RD                     :1;
        unsigned WR                     :1;
        unsigned WREN                   :1;
        unsigned WRERR                  :1;
        unsigned FREE                   :1;
        unsigned LWLO                   :1;
        unsigned CFGS                   :1;
    };
} PMCON1bits_t;
extern volatile PMCON1bits_t PMCON1bits @ 0x195;
// bitfield macros
#define _PMCON1_RD_POSN                                     0x0
#define _PMCON1_RD_POSITION                                 0x0
#define _PMCON1_RD_SIZE                                     0x1
#define _PMCON1_RD_LENGTH                                   0x1
#define _PMCON1_RD_MASK                                     0x1
#define _PMCON1_WR_POSN                                     0x1
#define _PMCON1_WR_POSITION                                 0x1
#define _PMCON1_WR_SIZE                                     0x1
#define _PMCON1_WR_LENGTH                                   0x1
#define _PMCON1_WR_MASK                                     0x2
#define _PMCON1_WREN_POSN                                   0x2
#define _PMCON1_WREN_POSITION                               0x2
#define _PMCON1_WREN_SIZE                                   0x1
#define _PMCON1_WREN_LENGTH                                 0x1
#define _PMCON1_WREN_MASK                                   0x4
#define _PMCON1_WRERR_POSN                                  0x3
#define _PMCON1_WRERR_POSITION                              0x3
#define _PMCON1_WRERR_SIZE                                  0x1
#define _PMCON1_WRERR_LENGTH                                0x1
#define _PMCON1_WRERR_MASK                                  0x8
#define _PMCON1_FREE_POSN                                   0x4
#define _PMCON1_FREE_POSITION                               0x4
#define _PMCON1_FREE_SIZE                                   0x1
#define _PMCON1_FREE_LENGTH                                 0x1
#define _PMCON1_FREE_MASK                                   0x10
#define _PMCON1_LWLO_POSN                                   0x5
#define _PMCON1_LWLO_POSITION                               0x5
#define _PMCON1_LWLO_SIZE                                   0x1
#define _PMCON1_LWLO_LENGTH                                 0x1
#define _PMCON1_LWLO_MASK                                   0x20
#define _PMCON1_CFGS_POSN                                   0x6
#define _PMCON1_CFGS_POSITION                               0x6
#define _PMCON1_CFGS_SIZE                                   0x1
#define _PMCON1_CFGS_LENGTH                                 0x1
#define _PMCON1_CFGS_MASK                                   0x40

// Register: PMCON2
extern volatile unsigned char           PMCON2              @ 0x196;
#ifndef _LIB_BUILD
asm("PMCON2 equ 0196h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PMCON2                 :8;
    };
} PMCON2bits_t;
extern volatile PMCON2bits_t PMCON2bits @ 0x196;
// bitfield macros
#define _PMCON2_PMCON2_POSN                                 0x0
#define _PMCON2_PMCON2_POSITION                             0x0
#define _PMCON2_PMCON2_SIZE                                 0x8
#define _PMCON2_PMCON2_LENGTH                               0x8
#define _PMCON2_PMCON2_MASK                                 0xFF

// Register: VREGCON
extern volatile unsigned char           VREGCON             @ 0x197;
#ifndef _LIB_BUILD
asm("VREGCON equ 0197h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned VREGPM                 :2;
    };
    struct {
        unsigned VREGPM0                :1;
        unsigned VREGPM1                :1;
    };
} VREGCONbits_t;
extern volatile VREGCONbits_t VREGCONbits @ 0x197;
// bitfield macros
#define _VREGCON_VREGPM_POSN                                0x0
#define _VREGCON_VREGPM_POSITION                            0x0
#define _VREGCON_VREGPM_SIZE                                0x2
#define _VREGCON_VREGPM_LENGTH                              0x2
#define _VREGCON_VREGPM_MASK                                0x3
#define _VREGCON_VREGPM0_POSN                               0x0
#define _VREGCON_VREGPM0_POSITION                           0x0
#define _VREGCON_VREGPM0_SIZE                               0x1
#define _VREGCON_VREGPM0_LENGTH                             0x1
#define _VREGCON_VREGPM0_MASK                               0x1
#define _VREGCON_VREGPM1_POSN                               0x1
#define _VREGCON_VREGPM1_POSITION                           0x1
#define _VREGCON_VREGPM1_SIZE                               0x1
#define _VREGCON_VREGPM1_LENGTH                             0x1
#define _VREGCON_VREGPM1_MASK                               0x2

// Register: RC1REG
extern volatile unsigned char           RC1REG              @ 0x199;
#ifndef _LIB_BUILD
asm("RC1REG equ 0199h");
#endif
// aliases
extern volatile unsigned char           RCREG               @ 0x199;
#ifndef _LIB_BUILD
asm("RCREG equ 0199h");
#endif
extern volatile unsigned char           RCREG1              @ 0x199;
#ifndef _LIB_BUILD
asm("RCREG1 equ 0199h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RC1REG                 :8;
    };
} RC1REGbits_t;
extern volatile RC1REGbits_t RC1REGbits @ 0x199;
// bitfield macros
#define _RC1REG_RC1REG_POSN                                 0x0
#define _RC1REG_RC1REG_POSITION                             0x0
#define _RC1REG_RC1REG_SIZE                                 0x8
#define _RC1REG_RC1REG_LENGTH                               0x8
#define _RC1REG_RC1REG_MASK                                 0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned RC1REG                 :8;
    };
} RCREGbits_t;
extern volatile RCREGbits_t RCREGbits @ 0x199;
// bitfield macros
#define _RCREG_RC1REG_POSN                                  0x0
#define _RCREG_RC1REG_POSITION                              0x0
#define _RCREG_RC1REG_SIZE                                  0x8
#define _RCREG_RC1REG_LENGTH                                0x8
#define _RCREG_RC1REG_MASK                                  0xFF
typedef union {
    struct {
        unsigned RC1REG                 :8;
    };
} RCREG1bits_t;
extern volatile RCREG1bits_t RCREG1bits @ 0x199;
// bitfield macros
#define _RCREG1_RC1REG_POSN                                 0x0
#define _RCREG1_RC1REG_POSITION                             0x0
#define _RCREG1_RC1REG_SIZE                                 0x8
#define _RCREG1_RC1REG_LENGTH                               0x8
#define _RCREG1_RC1REG_MASK                                 0xFF

// Register: TX1REG
extern volatile unsigned char           TX1REG              @ 0x19A;
#ifndef _LIB_BUILD
asm("TX1REG equ 019Ah");
#endif
// aliases
extern volatile unsigned char           TXREG1              @ 0x19A;
#ifndef _LIB_BUILD
asm("TXREG1 equ 019Ah");
#endif
extern volatile unsigned char           TXREG               @ 0x19A;
#ifndef _LIB_BUILD
asm("TXREG equ 019Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TX1REG                 :8;
    };
} TX1REGbits_t;
extern volatile TX1REGbits_t TX1REGbits @ 0x19A;
// bitfield macros
#define _TX1REG_TX1REG_POSN                                 0x0
#define _TX1REG_TX1REG_POSITION                             0x0
#define _TX1REG_TX1REG_SIZE                                 0x8
#define _TX1REG_TX1REG_LENGTH                               0x8
#define _TX1REG_TX1REG_MASK                                 0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned TX1REG                 :8;
    };
} TXREG1bits_t;
extern volatile TXREG1bits_t TXREG1bits @ 0x19A;
// bitfield macros
#define _TXREG1_TX1REG_POSN                                 0x0
#define _TXREG1_TX1REG_POSITION                             0x0
#define _TXREG1_TX1REG_SIZE                                 0x8
#define _TXREG1_TX1REG_LENGTH                               0x8
#define _TXREG1_TX1REG_MASK                                 0xFF
typedef union {
    struct {
        unsigned TX1REG                 :8;
    };
} TXREGbits_t;
extern volatile TXREGbits_t TXREGbits @ 0x19A;
// bitfield macros
#define _TXREG_TX1REG_POSN                                  0x0
#define _TXREG_TX1REG_POSITION                              0x0
#define _TXREG_TX1REG_SIZE                                  0x8
#define _TXREG_TX1REG_LENGTH                                0x8
#define _TXREG_TX1REG_MASK                                  0xFF

// Register: SP1BRG
extern volatile unsigned short          SP1BRG              @ 0x19B;
#ifndef _LIB_BUILD
asm("SP1BRG equ 019Bh");
#endif

// Register: SP1BRGL
extern volatile unsigned char           SP1BRGL             @ 0x19B;
#ifndef _LIB_BUILD
asm("SP1BRGL equ 019Bh");
#endif
// aliases
extern volatile unsigned char           SPBRG               @ 0x19B;
#ifndef _LIB_BUILD
asm("SPBRG equ 019Bh");
#endif
extern volatile unsigned char           SPBRG1              @ 0x19B;
#ifndef _LIB_BUILD
asm("SPBRG1 equ 019Bh");
#endif
extern volatile unsigned char           SPBRGL              @ 0x19B;
#ifndef _LIB_BUILD
asm("SPBRGL equ 019Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SP1BRGL                :8;
    };
} SP1BRGLbits_t;
extern volatile SP1BRGLbits_t SP1BRGLbits @ 0x19B;
// bitfield macros
#define _SP1BRGL_SP1BRGL_POSN                               0x0
#define _SP1BRGL_SP1BRGL_POSITION                           0x0
#define _SP1BRGL_SP1BRGL_SIZE                               0x8
#define _SP1BRGL_SP1BRGL_LENGTH                             0x8
#define _SP1BRGL_SP1BRGL_MASK                               0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned SP1BRGL                :8;
    };
} SPBRGbits_t;
extern volatile SPBRGbits_t SPBRGbits @ 0x19B;
// bitfield macros
#define _SPBRG_SP1BRGL_POSN                                 0x0
#define _SPBRG_SP1BRGL_POSITION                             0x0
#define _SPBRG_SP1BRGL_SIZE                                 0x8
#define _SPBRG_SP1BRGL_LENGTH                               0x8
#define _SPBRG_SP1BRGL_MASK                                 0xFF
typedef union {
    struct {
        unsigned SP1BRGL                :8;
    };
} SPBRG1bits_t;
extern volatile SPBRG1bits_t SPBRG1bits @ 0x19B;
// bitfield macros
#define _SPBRG1_SP1BRGL_POSN                                0x0
#define _SPBRG1_SP1BRGL_POSITION                            0x0
#define _SPBRG1_SP1BRGL_SIZE                                0x8
#define _SPBRG1_SP1BRGL_LENGTH                              0x8
#define _SPBRG1_SP1BRGL_MASK                                0xFF
typedef union {
    struct {
        unsigned SP1BRGL                :8;
    };
} SPBRGLbits_t;
extern volatile SPBRGLbits_t SPBRGLbits @ 0x19B;
// bitfield macros
#define _SPBRGL_SP1BRGL_POSN                                0x0
#define _SPBRGL_SP1BRGL_POSITION                            0x0
#define _SPBRGL_SP1BRGL_SIZE                                0x8
#define _SPBRGL_SP1BRGL_LENGTH                              0x8
#define _SPBRGL_SP1BRGL_MASK                                0xFF

// Register: SP1BRGH
extern volatile unsigned char           SP1BRGH             @ 0x19C;
#ifndef _LIB_BUILD
asm("SP1BRGH equ 019Ch");
#endif
// aliases
extern volatile unsigned char           SPBRGH              @ 0x19C;
#ifndef _LIB_BUILD
asm("SPBRGH equ 019Ch");
#endif
extern volatile unsigned char           SPBRGH1             @ 0x19C;
#ifndef _LIB_BUILD
asm("SPBRGH1 equ 019Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SP1BRGH                :8;
    };
} SP1BRGHbits_t;
extern volatile SP1BRGHbits_t SP1BRGHbits @ 0x19C;
// bitfield macros
#define _SP1BRGH_SP1BRGH_POSN                               0x0
#define _SP1BRGH_SP1BRGH_POSITION                           0x0
#define _SP1BRGH_SP1BRGH_SIZE                               0x8
#define _SP1BRGH_SP1BRGH_LENGTH                             0x8
#define _SP1BRGH_SP1BRGH_MASK                               0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned SP1BRGH                :8;
    };
} SPBRGHbits_t;
extern volatile SPBRGHbits_t SPBRGHbits @ 0x19C;
// bitfield macros
#define _SPBRGH_SP1BRGH_POSN                                0x0
#define _SPBRGH_SP1BRGH_POSITION                            0x0
#define _SPBRGH_SP1BRGH_SIZE                                0x8
#define _SPBRGH_SP1BRGH_LENGTH                              0x8
#define _SPBRGH_SP1BRGH_MASK                                0xFF
typedef union {
    struct {
        unsigned SP1BRGH                :8;
    };
} SPBRGH1bits_t;
extern volatile SPBRGH1bits_t SPBRGH1bits @ 0x19C;
// bitfield macros
#define _SPBRGH1_SP1BRGH_POSN                               0x0
#define _SPBRGH1_SP1BRGH_POSITION                           0x0
#define _SPBRGH1_SP1BRGH_SIZE                               0x8
#define _SPBRGH1_SP1BRGH_LENGTH                             0x8
#define _SPBRGH1_SP1BRGH_MASK                               0xFF

// Register: RC1STA
extern volatile unsigned char           RC1STA              @ 0x19D;
#ifndef _LIB_BUILD
asm("RC1STA equ 019Dh");
#endif
// aliases
extern volatile unsigned char           RCSTA1              @ 0x19D;
#ifndef _LIB_BUILD
asm("RCSTA1 equ 019Dh");
#endif
extern volatile unsigned char           RCSTA               @ 0x19D;
#ifndef _LIB_BUILD
asm("RCSTA equ 019Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RX9D                   :1;
        unsigned OERR                   :1;
        unsigned FERR                   :1;
        unsigned ADDEN                  :1;
        unsigned CREN                   :1;
        unsigned SREN                   :1;
        unsigned RX9                    :1;
        unsigned SPEN                   :1;
    };
} RC1STAbits_t;
extern volatile RC1STAbits_t RC1STAbits @ 0x19D;
// bitfield macros
#define _RC1STA_RX9D_POSN                                   0x0
#define _RC1STA_RX9D_POSITION                               0x0
#define _RC1STA_RX9D_SIZE                                   0x1
#define _RC1STA_RX9D_LENGTH                                 0x1
#define _RC1STA_RX9D_MASK                                   0x1
#define _RC1STA_OERR_POSN                                   0x1
#define _RC1STA_OERR_POSITION                               0x1
#define _RC1STA_OERR_SIZE                                   0x1
#define _RC1STA_OERR_LENGTH                                 0x1
#define _RC1STA_OERR_MASK                                   0x2
#define _RC1STA_FERR_POSN                                   0x2
#define _RC1STA_FERR_POSITION                               0x2
#define _RC1STA_FERR_SIZE                                   0x1
#define _RC1STA_FERR_LENGTH                                 0x1
#define _RC1STA_FERR_MASK                                   0x4
#define _RC1STA_ADDEN_POSN                                  0x3
#define _RC1STA_ADDEN_POSITION                              0x3
#define _RC1STA_ADDEN_SIZE                                  0x1
#define _RC1STA_ADDEN_LENGTH                                0x1
#define _RC1STA_ADDEN_MASK                                  0x8
#define _RC1STA_CREN_POSN                                   0x4
#define _RC1STA_CREN_POSITION                               0x4
#define _RC1STA_CREN_SIZE                                   0x1
#define _RC1STA_CREN_LENGTH                                 0x1
#define _RC1STA_CREN_MASK                                   0x10
#define _RC1STA_SREN_POSN                                   0x5
#define _RC1STA_SREN_POSITION                               0x5
#define _RC1STA_SREN_SIZE                                   0x1
#define _RC1STA_SREN_LENGTH                                 0x1
#define _RC1STA_SREN_MASK                                   0x20
#define _RC1STA_RX9_POSN                                    0x6
#define _RC1STA_RX9_POSITION                                0x6
#define _RC1STA_RX9_SIZE                                    0x1
#define _RC1STA_RX9_LENGTH                                  0x1
#define _RC1STA_RX9_MASK                                    0x40
#define _RC1STA_SPEN_POSN                                   0x7
#define _RC1STA_SPEN_POSITION                               0x7
#define _RC1STA_SPEN_SIZE                                   0x1
#define _RC1STA_SPEN_LENGTH                                 0x1
#define _RC1STA_SPEN_MASK                                   0x80
// alias bitfield definitions
typedef union {
    struct {
        unsigned RX9D                   :1;
        unsigned OERR                   :1;
        unsigned FERR                   :1;
        unsigned ADDEN                  :1;
        unsigned CREN                   :1;
        unsigned SREN                   :1;
        unsigned RX9                    :1;
        unsigned SPEN                   :1;
    };
} RCSTA1bits_t;
extern volatile RCSTA1bits_t RCSTA1bits @ 0x19D;
// bitfield macros
#define _RCSTA1_RX9D_POSN                                   0x0
#define _RCSTA1_RX9D_POSITION                               0x0
#define _RCSTA1_RX9D_SIZE                                   0x1
#define _RCSTA1_RX9D_LENGTH                                 0x1
#define _RCSTA1_RX9D_MASK                                   0x1
#define _RCSTA1_OERR_POSN                                   0x1
#define _RCSTA1_OERR_POSITION                               0x1
#define _RCSTA1_OERR_SIZE                                   0x1
#define _RCSTA1_OERR_LENGTH                                 0x1
#define _RCSTA1_OERR_MASK                                   0x2
#define _RCSTA1_FERR_POSN                                   0x2
#define _RCSTA1_FERR_POSITION                               0x2
#define _RCSTA1_FERR_SIZE                                   0x1
#define _RCSTA1_FERR_LENGTH                                 0x1
#define _RCSTA1_FERR_MASK                                   0x4
#define _RCSTA1_ADDEN_POSN                                  0x3
#define _RCSTA1_ADDEN_POSITION                              0x3
#define _RCSTA1_ADDEN_SIZE                                  0x1
#define _RCSTA1_ADDEN_LENGTH                                0x1
#define _RCSTA1_ADDEN_MASK                                  0x8
#define _RCSTA1_CREN_POSN                                   0x4
#define _RCSTA1_CREN_POSITION                               0x4
#define _RCSTA1_CREN_SIZE                                   0x1
#define _RCSTA1_CREN_LENGTH                                 0x1
#define _RCSTA1_CREN_MASK                                   0x10
#define _RCSTA1_SREN_POSN                                   0x5
#define _RCSTA1_SREN_POSITION                               0x5
#define _RCSTA1_SREN_SIZE                                   0x1
#define _RCSTA1_SREN_LENGTH                                 0x1
#define _RCSTA1_SREN_MASK                                   0x20
#define _RCSTA1_RX9_POSN                                    0x6
#define _RCSTA1_RX9_POSITION                                0x6
#define _RCSTA1_RX9_SIZE                                    0x1
#define _RCSTA1_RX9_LENGTH                                  0x1
#define _RCSTA1_RX9_MASK                                    0x40
#define _RCSTA1_SPEN_POSN                                   0x7
#define _RCSTA1_SPEN_POSITION                               0x7
#define _RCSTA1_SPEN_SIZE                                   0x1
#define _RCSTA1_SPEN_LENGTH                                 0x1
#define _RCSTA1_SPEN_MASK                                   0x80
typedef union {
    struct {
        unsigned RX9D                   :1;
        unsigned OERR                   :1;
        unsigned FERR                   :1;
        unsigned ADDEN                  :1;
        unsigned CREN                   :1;
        unsigned SREN                   :1;
        unsigned RX9                    :1;
        unsigned SPEN                   :1;
    };
} RCSTAbits_t;
extern volatile RCSTAbits_t RCSTAbits @ 0x19D;
// bitfield macros
#define _RCSTA_RX9D_POSN                                    0x0
#define _RCSTA_RX9D_POSITION                                0x0
#define _RCSTA_RX9D_SIZE                                    0x1
#define _RCSTA_RX9D_LENGTH                                  0x1
#define _RCSTA_RX9D_MASK                                    0x1
#define _RCSTA_OERR_POSN                                    0x1
#define _RCSTA_OERR_POSITION                                0x1
#define _RCSTA_OERR_SIZE                                    0x1
#define _RCSTA_OERR_LENGTH                                  0x1
#define _RCSTA_OERR_MASK                                    0x2
#define _RCSTA_FERR_POSN                                    0x2
#define _RCSTA_FERR_POSITION                                0x2
#define _RCSTA_FERR_SIZE                                    0x1
#define _RCSTA_FERR_LENGTH                                  0x1
#define _RCSTA_FERR_MASK                                    0x4
#define _RCSTA_ADDEN_POSN                                   0x3
#define _RCSTA_ADDEN_POSITION                               0x3
#define _RCSTA_ADDEN_SIZE                                   0x1
#define _RCSTA_ADDEN_LENGTH                                 0x1
#define _RCSTA_ADDEN_MASK                                   0x8
#define _RCSTA_CREN_POSN                                    0x4
#define _RCSTA_CREN_POSITION                                0x4
#define _RCSTA_CREN_SIZE                                    0x1
#define _RCSTA_CREN_LENGTH                                  0x1
#define _RCSTA_CREN_MASK                                    0x10
#define _RCSTA_SREN_POSN                                    0x5
#define _RCSTA_SREN_POSITION                                0x5
#define _RCSTA_SREN_SIZE                                    0x1
#define _RCSTA_SREN_LENGTH                                  0x1
#define _RCSTA_SREN_MASK                                    0x20
#define _RCSTA_RX9_POSN                                     0x6
#define _RCSTA_RX9_POSITION                                 0x6
#define _RCSTA_RX9_SIZE                                     0x1
#define _RCSTA_RX9_LENGTH                                   0x1
#define _RCSTA_RX9_MASK                                     0x40
#define _RCSTA_SPEN_POSN                                    0x7
#define _RCSTA_SPEN_POSITION                                0x7
#define _RCSTA_SPEN_SIZE                                    0x1
#define _RCSTA_SPEN_LENGTH                                  0x1
#define _RCSTA_SPEN_MASK                                    0x80

// Register: TX1STA
extern volatile unsigned char           TX1STA              @ 0x19E;
#ifndef _LIB_BUILD
asm("TX1STA equ 019Eh");
#endif
// aliases
extern volatile unsigned char           TXSTA1              @ 0x19E;
#ifndef _LIB_BUILD
asm("TXSTA1 equ 019Eh");
#endif
extern volatile unsigned char           TXSTA               @ 0x19E;
#ifndef _LIB_BUILD
asm("TXSTA equ 019Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TX9D                   :1;
        unsigned TRMT                   :1;
        unsigned BRGH                   :1;
        unsigned SENDB                  :1;
        unsigned SYNC                   :1;
        unsigned TXEN                   :1;
        unsigned TX9                    :1;
        unsigned CSRC                   :1;
    };
} TX1STAbits_t;
extern volatile TX1STAbits_t TX1STAbits @ 0x19E;
// bitfield macros
#define _TX1STA_TX9D_POSN                                   0x0
#define _TX1STA_TX9D_POSITION                               0x0
#define _TX1STA_TX9D_SIZE                                   0x1
#define _TX1STA_TX9D_LENGTH                                 0x1
#define _TX1STA_TX9D_MASK                                   0x1
#define _TX1STA_TRMT_POSN                                   0x1
#define _TX1STA_TRMT_POSITION                               0x1
#define _TX1STA_TRMT_SIZE                                   0x1
#define _TX1STA_TRMT_LENGTH                                 0x1
#define _TX1STA_TRMT_MASK                                   0x2
#define _TX1STA_BRGH_POSN                                   0x2
#define _TX1STA_BRGH_POSITION                               0x2
#define _TX1STA_BRGH_SIZE                                   0x1
#define _TX1STA_BRGH_LENGTH                                 0x1
#define _TX1STA_BRGH_MASK                                   0x4
#define _TX1STA_SENDB_POSN                                  0x3
#define _TX1STA_SENDB_POSITION                              0x3
#define _TX1STA_SENDB_SIZE                                  0x1
#define _TX1STA_SENDB_LENGTH                                0x1
#define _TX1STA_SENDB_MASK                                  0x8
#define _TX1STA_SYNC_POSN                                   0x4
#define _TX1STA_SYNC_POSITION                               0x4
#define _TX1STA_SYNC_SIZE                                   0x1
#define _TX1STA_SYNC_LENGTH                                 0x1
#define _TX1STA_SYNC_MASK                                   0x10
#define _TX1STA_TXEN_POSN                                   0x5
#define _TX1STA_TXEN_POSITION                               0x5
#define _TX1STA_TXEN_SIZE                                   0x1
#define _TX1STA_TXEN_LENGTH                                 0x1
#define _TX1STA_TXEN_MASK                                   0x20
#define _TX1STA_TX9_POSN                                    0x6
#define _TX1STA_TX9_POSITION                                0x6
#define _TX1STA_TX9_SIZE                                    0x1
#define _TX1STA_TX9_LENGTH                                  0x1
#define _TX1STA_TX9_MASK                                    0x40
#define _TX1STA_CSRC_POSN                                   0x7
#define _TX1STA_CSRC_POSITION                               0x7
#define _TX1STA_CSRC_SIZE                                   0x1
#define _TX1STA_CSRC_LENGTH                                 0x1
#define _TX1STA_CSRC_MASK                                   0x80
// alias bitfield definitions
typedef union {
    struct {
        unsigned TX9D                   :1;
        unsigned TRMT                   :1;
        unsigned BRGH                   :1;
        unsigned SENDB                  :1;
        unsigned SYNC                   :1;
        unsigned TXEN                   :1;
        unsigned TX9                    :1;
        unsigned CSRC                   :1;
    };
} TXSTA1bits_t;
extern volatile TXSTA1bits_t TXSTA1bits @ 0x19E;
// bitfield macros
#define _TXSTA1_TX9D_POSN                                   0x0
#define _TXSTA1_TX9D_POSITION                               0x0
#define _TXSTA1_TX9D_SIZE                                   0x1
#define _TXSTA1_TX9D_LENGTH                                 0x1
#define _TXSTA1_TX9D_MASK                                   0x1
#define _TXSTA1_TRMT_POSN                                   0x1
#define _TXSTA1_TRMT_POSITION                               0x1
#define _TXSTA1_TRMT_SIZE                                   0x1
#define _TXSTA1_TRMT_LENGTH                                 0x1
#define _TXSTA1_TRMT_MASK                                   0x2
#define _TXSTA1_BRGH_POSN                                   0x2
#define _TXSTA1_BRGH_POSITION                               0x2
#define _TXSTA1_BRGH_SIZE                                   0x1
#define _TXSTA1_BRGH_LENGTH                                 0x1
#define _TXSTA1_BRGH_MASK                                   0x4
#define _TXSTA1_SENDB_POSN                                  0x3
#define _TXSTA1_SENDB_POSITION                              0x3
#define _TXSTA1_SENDB_SIZE                                  0x1
#define _TXSTA1_SENDB_LENGTH                                0x1
#define _TXSTA1_SENDB_MASK                                  0x8
#define _TXSTA1_SYNC_POSN                                   0x4
#define _TXSTA1_SYNC_POSITION                               0x4
#define _TXSTA1_SYNC_SIZE                                   0x1
#define _TXSTA1_SYNC_LENGTH                                 0x1
#define _TXSTA1_SYNC_MASK                                   0x10
#define _TXSTA1_TXEN_POSN                                   0x5
#define _TXSTA1_TXEN_POSITION                               0x5
#define _TXSTA1_TXEN_SIZE                                   0x1
#define _TXSTA1_TXEN_LENGTH                                 0x1
#define _TXSTA1_TXEN_MASK                                   0x20
#define _TXSTA1_TX9_POSN                                    0x6
#define _TXSTA1_TX9_POSITION                                0x6
#define _TXSTA1_TX9_SIZE                                    0x1
#define _TXSTA1_TX9_LENGTH                                  0x1
#define _TXSTA1_TX9_MASK                                    0x40
#define _TXSTA1_CSRC_POSN                                   0x7
#define _TXSTA1_CSRC_POSITION                               0x7
#define _TXSTA1_CSRC_SIZE                                   0x1
#define _TXSTA1_CSRC_LENGTH                                 0x1
#define _TXSTA1_CSRC_MASK                                   0x80
typedef union {
    struct {
        unsigned TX9D                   :1;
        unsigned TRMT                   :1;
        unsigned BRGH                   :1;
        unsigned SENDB                  :1;
        unsigned SYNC                   :1;
        unsigned TXEN                   :1;
        unsigned TX9                    :1;
        unsigned CSRC                   :1;
    };
} TXSTAbits_t;
extern volatile TXSTAbits_t TXSTAbits @ 0x19E;
// bitfield macros
#define _TXSTA_TX9D_POSN                                    0x0
#define _TXSTA_TX9D_POSITION                                0x0
#define _TXSTA_TX9D_SIZE                                    0x1
#define _TXSTA_TX9D_LENGTH                                  0x1
#define _TXSTA_TX9D_MASK                                    0x1
#define _TXSTA_TRMT_POSN                                    0x1
#define _TXSTA_TRMT_POSITION                                0x1
#define _TXSTA_TRMT_SIZE                                    0x1
#define _TXSTA_TRMT_LENGTH                                  0x1
#define _TXSTA_TRMT_MASK                                    0x2
#define _TXSTA_BRGH_POSN                                    0x2
#define _TXSTA_BRGH_POSITION                                0x2
#define _TXSTA_BRGH_SIZE                                    0x1
#define _TXSTA_BRGH_LENGTH                                  0x1
#define _TXSTA_BRGH_MASK                                    0x4
#define _TXSTA_SENDB_POSN                                   0x3
#define _TXSTA_SENDB_POSITION                               0x3
#define _TXSTA_SENDB_SIZE                                   0x1
#define _TXSTA_SENDB_LENGTH                                 0x1
#define _TXSTA_SENDB_MASK                                   0x8
#define _TXSTA_SYNC_POSN                                    0x4
#define _TXSTA_SYNC_POSITION                                0x4
#define _TXSTA_SYNC_SIZE                                    0x1
#define _TXSTA_SYNC_LENGTH                                  0x1
#define _TXSTA_SYNC_MASK                                    0x10
#define _TXSTA_TXEN_POSN                                    0x5
#define _TXSTA_TXEN_POSITION                                0x5
#define _TXSTA_TXEN_SIZE                                    0x1
#define _TXSTA_TXEN_LENGTH                                  0x1
#define _TXSTA_TXEN_MASK                                    0x20
#define _TXSTA_TX9_POSN                                     0x6
#define _TXSTA_TX9_POSITION                                 0x6
#define _TXSTA_TX9_SIZE                                     0x1
#define _TXSTA_TX9_LENGTH                                   0x1
#define _TXSTA_TX9_MASK                                     0x40
#define _TXSTA_CSRC_POSN                                    0x7
#define _TXSTA_CSRC_POSITION                                0x7
#define _TXSTA_CSRC_SIZE                                    0x1
#define _TXSTA_CSRC_LENGTH                                  0x1
#define _TXSTA_CSRC_MASK                                    0x80

// Register: BAUD1CON
extern volatile unsigned char           BAUD1CON            @ 0x19F;
#ifndef _LIB_BUILD
asm("BAUD1CON equ 019Fh");
#endif
// aliases
extern volatile unsigned char           BAUDCON1            @ 0x19F;
#ifndef _LIB_BUILD
asm("BAUDCON1 equ 019Fh");
#endif
extern volatile unsigned char           BAUDCTL1            @ 0x19F;
#ifndef _LIB_BUILD
asm("BAUDCTL1 equ 019Fh");
#endif
extern volatile unsigned char           BAUDCON             @ 0x19F;
#ifndef _LIB_BUILD
asm("BAUDCON equ 019Fh");
#endif
extern volatile unsigned char           BAUDCTL             @ 0x19F;
#ifndef _LIB_BUILD
asm("BAUDCTL equ 019Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ABDEN                  :1;
        unsigned WUE                    :1;
        unsigned                        :1;
        unsigned BRG16                  :1;
        unsigned SCKP                   :1;
        unsigned                        :1;
        unsigned RCIDL                  :1;
        unsigned ABDOVF                 :1;
    };
} BAUD1CONbits_t;
extern volatile BAUD1CONbits_t BAUD1CONbits @ 0x19F;
// bitfield macros
#define _BAUD1CON_ABDEN_POSN                                0x0
#define _BAUD1CON_ABDEN_POSITION                            0x0
#define _BAUD1CON_ABDEN_SIZE                                0x1
#define _BAUD1CON_ABDEN_LENGTH                              0x1
#define _BAUD1CON_ABDEN_MASK                                0x1
#define _BAUD1CON_WUE_POSN                                  0x1
#define _BAUD1CON_WUE_POSITION                              0x1
#define _BAUD1CON_WUE_SIZE                                  0x1
#define _BAUD1CON_WUE_LENGTH                                0x1
#define _BAUD1CON_WUE_MASK                                  0x2
#define _BAUD1CON_BRG16_POSN                                0x3
#define _BAUD1CON_BRG16_POSITION                            0x3
#define _BAUD1CON_BRG16_SIZE                                0x1
#define _BAUD1CON_BRG16_LENGTH                              0x1
#define _BAUD1CON_BRG16_MASK                                0x8
#define _BAUD1CON_SCKP_POSN                                 0x4
#define _BAUD1CON_SCKP_POSITION                             0x4
#define _BAUD1CON_SCKP_SIZE                                 0x1
#define _BAUD1CON_SCKP_LENGTH                               0x1
#define _BAUD1CON_SCKP_MASK                                 0x10
#define _BAUD1CON_RCIDL_POSN                                0x6
#define _BAUD1CON_RCIDL_POSITION                            0x6
#define _BAUD1CON_RCIDL_SIZE                                0x1
#define _BAUD1CON_RCIDL_LENGTH                              0x1
#define _BAUD1CON_RCIDL_MASK                                0x40
#define _BAUD1CON_ABDOVF_POSN                               0x7
#define _BAUD1CON_ABDOVF_POSITION                           0x7
#define _BAUD1CON_ABDOVF_SIZE                               0x1
#define _BAUD1CON_ABDOVF_LENGTH                             0x1
#define _BAUD1CON_ABDOVF_MASK                               0x80
// alias bitfield definitions
typedef union {
    struct {
        unsigned ABDEN                  :1;
        unsigned WUE                    :1;
        unsigned                        :1;
        unsigned BRG16                  :1;
        unsigned SCKP                   :1;
        unsigned                        :1;
        unsigned RCIDL                  :1;
        unsigned ABDOVF                 :1;
    };
} BAUDCON1bits_t;
extern volatile BAUDCON1bits_t BAUDCON1bits @ 0x19F;
// bitfield macros
#define _BAUDCON1_ABDEN_POSN                                0x0
#define _BAUDCON1_ABDEN_POSITION                            0x0
#define _BAUDCON1_ABDEN_SIZE                                0x1
#define _BAUDCON1_ABDEN_LENGTH                              0x1
#define _BAUDCON1_ABDEN_MASK                                0x1
#define _BAUDCON1_WUE_POSN                                  0x1
#define _BAUDCON1_WUE_POSITION                              0x1
#define _BAUDCON1_WUE_SIZE                                  0x1
#define _BAUDCON1_WUE_LENGTH                                0x1
#define _BAUDCON1_WUE_MASK                                  0x2
#define _BAUDCON1_BRG16_POSN                                0x3
#define _BAUDCON1_BRG16_POSITION                            0x3
#define _BAUDCON1_BRG16_SIZE                                0x1
#define _BAUDCON1_BRG16_LENGTH                              0x1
#define _BAUDCON1_BRG16_MASK                                0x8
#define _BAUDCON1_SCKP_POSN                                 0x4
#define _BAUDCON1_SCKP_POSITION                             0x4
#define _BAUDCON1_SCKP_SIZE                                 0x1
#define _BAUDCON1_SCKP_LENGTH                               0x1
#define _BAUDCON1_SCKP_MASK                                 0x10
#define _BAUDCON1_RCIDL_POSN                                0x6
#define _BAUDCON1_RCIDL_POSITION                            0x6
#define _BAUDCON1_RCIDL_SIZE                                0x1
#define _BAUDCON1_RCIDL_LENGTH                              0x1
#define _BAUDCON1_RCIDL_MASK                                0x40
#define _BAUDCON1_ABDOVF_POSN                               0x7
#define _BAUDCON1_ABDOVF_POSITION                           0x7
#define _BAUDCON1_ABDOVF_SIZE                               0x1
#define _BAUDCON1_ABDOVF_LENGTH                             0x1
#define _BAUDCON1_ABDOVF_MASK                               0x80
typedef union {
    struct {
        unsigned ABDEN                  :1;
        unsigned WUE                    :1;
        unsigned                        :1;
        unsigned BRG16                  :1;
        unsigned SCKP                   :1;
        unsigned                        :1;
        unsigned RCIDL                  :1;
        unsigned ABDOVF                 :1;
    };
} BAUDCTL1bits_t;
extern volatile BAUDCTL1bits_t BAUDCTL1bits @ 0x19F;
// bitfield macros
#define _BAUDCTL1_ABDEN_POSN                                0x0
#define _BAUDCTL1_ABDEN_POSITION                            0x0
#define _BAUDCTL1_ABDEN_SIZE                                0x1
#define _BAUDCTL1_ABDEN_LENGTH                              0x1
#define _BAUDCTL1_ABDEN_MASK                                0x1
#define _BAUDCTL1_WUE_POSN                                  0x1
#define _BAUDCTL1_WUE_POSITION                              0x1
#define _BAUDCTL1_WUE_SIZE                                  0x1
#define _BAUDCTL1_WUE_LENGTH                                0x1
#define _BAUDCTL1_WUE_MASK                                  0x2
#define _BAUDCTL1_BRG16_POSN                                0x3
#define _BAUDCTL1_BRG16_POSITION                            0x3
#define _BAUDCTL1_BRG16_SIZE                                0x1
#define _BAUDCTL1_BRG16_LENGTH                              0x1
#define _BAUDCTL1_BRG16_MASK                                0x8
#define _BAUDCTL1_SCKP_POSN                                 0x4
#define _BAUDCTL1_SCKP_POSITION                             0x4
#define _BAUDCTL1_SCKP_SIZE                                 0x1
#define _BAUDCTL1_SCKP_LENGTH                               0x1
#define _BAUDCTL1_SCKP_MASK                                 0x10
#define _BAUDCTL1_RCIDL_POSN                                0x6
#define _BAUDCTL1_RCIDL_POSITION                            0x6
#define _BAUDCTL1_RCIDL_SIZE                                0x1
#define _BAUDCTL1_RCIDL_LENGTH                              0x1
#define _BAUDCTL1_RCIDL_MASK                                0x40
#define _BAUDCTL1_ABDOVF_POSN                               0x7
#define _BAUDCTL1_ABDOVF_POSITION                           0x7
#define _BAUDCTL1_ABDOVF_SIZE                               0x1
#define _BAUDCTL1_ABDOVF_LENGTH                             0x1
#define _BAUDCTL1_ABDOVF_MASK                               0x80
typedef union {
    struct {
        unsigned ABDEN                  :1;
        unsigned WUE                    :1;
        unsigned                        :1;
        unsigned BRG16                  :1;
        unsigned SCKP                   :1;
        unsigned                        :1;
        unsigned RCIDL                  :1;
        unsigned ABDOVF                 :1;
    };
} BAUDCONbits_t;
extern volatile BAUDCONbits_t BAUDCONbits @ 0x19F;
// bitfield macros
#define _BAUDCON_ABDEN_POSN                                 0x0
#define _BAUDCON_ABDEN_POSITION                             0x0
#define _BAUDCON_ABDEN_SIZE                                 0x1
#define _BAUDCON_ABDEN_LENGTH                               0x1
#define _BAUDCON_ABDEN_MASK                                 0x1
#define _BAUDCON_WUE_POSN                                   0x1
#define _BAUDCON_WUE_POSITION                               0x1
#define _BAUDCON_WUE_SIZE                                   0x1
#define _BAUDCON_WUE_LENGTH                                 0x1
#define _BAUDCON_WUE_MASK                                   0x2
#define _BAUDCON_BRG16_POSN                                 0x3
#define _BAUDCON_BRG16_POSITION                             0x3
#define _BAUDCON_BRG16_SIZE                                 0x1
#define _BAUDCON_BRG16_LENGTH                               0x1
#define _BAUDCON_BRG16_MASK                                 0x8
#define _BAUDCON_SCKP_POSN                                  0x4
#define _BAUDCON_SCKP_POSITION                              0x4
#define _BAUDCON_SCKP_SIZE                                  0x1
#define _BAUDCON_SCKP_LENGTH                                0x1
#define _BAUDCON_SCKP_MASK                                  0x10
#define _BAUDCON_RCIDL_POSN                                 0x6
#define _BAUDCON_RCIDL_POSITION                             0x6
#define _BAUDCON_RCIDL_SIZE                                 0x1
#define _BAUDCON_RCIDL_LENGTH                               0x1
#define _BAUDCON_RCIDL_MASK                                 0x40
#define _BAUDCON_ABDOVF_POSN                                0x7
#define _BAUDCON_ABDOVF_POSITION                            0x7
#define _BAUDCON_ABDOVF_SIZE                                0x1
#define _BAUDCON_ABDOVF_LENGTH                              0x1
#define _BAUDCON_ABDOVF_MASK                                0x80
typedef union {
    struct {
        unsigned ABDEN                  :1;
        unsigned WUE                    :1;
        unsigned                        :1;
        unsigned BRG16                  :1;
        unsigned SCKP                   :1;
        unsigned                        :1;
        unsigned RCIDL                  :1;
        unsigned ABDOVF                 :1;
    };
} BAUDCTLbits_t;
extern volatile BAUDCTLbits_t BAUDCTLbits @ 0x19F;
// bitfield macros
#define _BAUDCTL_ABDEN_POSN                                 0x0
#define _BAUDCTL_ABDEN_POSITION                             0x0
#define _BAUDCTL_ABDEN_SIZE                                 0x1
#define _BAUDCTL_ABDEN_LENGTH                               0x1
#define _BAUDCTL_ABDEN_MASK                                 0x1
#define _BAUDCTL_WUE_POSN                                   0x1
#define _BAUDCTL_WUE_POSITION                               0x1
#define _BAUDCTL_WUE_SIZE                                   0x1
#define _BAUDCTL_WUE_LENGTH                                 0x1
#define _BAUDCTL_WUE_MASK                                   0x2
#define _BAUDCTL_BRG16_POSN                                 0x3
#define _BAUDCTL_BRG16_POSITION                             0x3
#define _BAUDCTL_BRG16_SIZE                                 0x1
#define _BAUDCTL_BRG16_LENGTH                               0x1
#define _BAUDCTL_BRG16_MASK                                 0x8
#define _BAUDCTL_SCKP_POSN                                  0x4
#define _BAUDCTL_SCKP_POSITION                              0x4
#define _BAUDCTL_SCKP_SIZE                                  0x1
#define _BAUDCTL_SCKP_LENGTH                                0x1
#define _BAUDCTL_SCKP_MASK                                  0x10
#define _BAUDCTL_RCIDL_POSN                                 0x6
#define _BAUDCTL_RCIDL_POSITION                             0x6
#define _BAUDCTL_RCIDL_SIZE                                 0x1
#define _BAUDCTL_RCIDL_LENGTH                               0x1
#define _BAUDCTL_RCIDL_MASK                                 0x40
#define _BAUDCTL_ABDOVF_POSN                                0x7
#define _BAUDCTL_ABDOVF_POSITION                            0x7
#define _BAUDCTL_ABDOVF_SIZE                                0x1
#define _BAUDCTL_ABDOVF_LENGTH                              0x1
#define _BAUDCTL_ABDOVF_MASK                                0x80

// Register: WPUA
extern volatile unsigned char           WPUA                @ 0x20C;
#ifndef _LIB_BUILD
asm("WPUA equ 020Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned WPUA0                  :1;
        unsigned WPUA1                  :1;
        unsigned WPUA2                  :1;
        unsigned WPUA3                  :1;
        unsigned WPUA4                  :1;
        unsigned WPUA5                  :1;
    };
    struct {
        unsigned WPUA                   :6;
    };
} WPUAbits_t;
extern volatile WPUAbits_t WPUAbits @ 0x20C;
// bitfield macros
#define _WPUA_WPUA0_POSN                                    0x0
#define _WPUA_WPUA0_POSITION                                0x0
#define _WPUA_WPUA0_SIZE                                    0x1
#define _WPUA_WPUA0_LENGTH                                  0x1
#define _WPUA_WPUA0_MASK                                    0x1
#define _WPUA_WPUA1_POSN                                    0x1
#define _WPUA_WPUA1_POSITION                                0x1
#define _WPUA_WPUA1_SIZE                                    0x1
#define _WPUA_WPUA1_LENGTH                                  0x1
#define _WPUA_WPUA1_MASK                                    0x2
#define _WPUA_WPUA2_POSN                                    0x2
#define _WPUA_WPUA2_POSITION                                0x2
#define _WPUA_WPUA2_SIZE                                    0x1
#define _WPUA_WPUA2_LENGTH                                  0x1
#define _WPUA_WPUA2_MASK                                    0x4
#define _WPUA_WPUA3_POSN                                    0x3
#define _WPUA_WPUA3_POSITION                                0x3
#define _WPUA_WPUA3_SIZE                                    0x1
#define _WPUA_WPUA3_LENGTH                                  0x1
#define _WPUA_WPUA3_MASK                                    0x8
#define _WPUA_WPUA4_POSN                                    0x4
#define _WPUA_WPUA4_POSITION                                0x4
#define _WPUA_WPUA4_SIZE                                    0x1
#define _WPUA_WPUA4_LENGTH                                  0x1
#define _WPUA_WPUA4_MASK                                    0x10
#define _WPUA_WPUA5_POSN                                    0x5
#define _WPUA_WPUA5_POSITION                                0x5
#define _WPUA_WPUA5_SIZE                                    0x1
#define _WPUA_WPUA5_LENGTH                                  0x1
#define _WPUA_WPUA5_MASK                                    0x20
#define _WPUA_WPUA_POSN                                     0x0
#define _WPUA_WPUA_POSITION                                 0x0
#define _WPUA_WPUA_SIZE                                     0x6
#define _WPUA_WPUA_LENGTH                                   0x6
#define _WPUA_WPUA_MASK                                     0x3F

// Register: WPUB
extern volatile unsigned char           WPUB                @ 0x20D;
#ifndef _LIB_BUILD
asm("WPUB equ 020Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned WPUB4                  :1;
        unsigned WPUB5                  :1;
        unsigned WPUB6                  :1;
        unsigned WPUB7                  :1;
    };
} WPUBbits_t;
extern volatile WPUBbits_t WPUBbits @ 0x20D;
// bitfield macros
#define _WPUB_WPUB4_POSN                                    0x4
#define _WPUB_WPUB4_POSITION                                0x4
#define _WPUB_WPUB4_SIZE                                    0x1
#define _WPUB_WPUB4_LENGTH                                  0x1
#define _WPUB_WPUB4_MASK                                    0x10
#define _WPUB_WPUB5_POSN                                    0x5
#define _WPUB_WPUB5_POSITION                                0x5
#define _WPUB_WPUB5_SIZE                                    0x1
#define _WPUB_WPUB5_LENGTH                                  0x1
#define _WPUB_WPUB5_MASK                                    0x20
#define _WPUB_WPUB6_POSN                                    0x6
#define _WPUB_WPUB6_POSITION                                0x6
#define _WPUB_WPUB6_SIZE                                    0x1
#define _WPUB_WPUB6_LENGTH                                  0x1
#define _WPUB_WPUB6_MASK                                    0x40
#define _WPUB_WPUB7_POSN                                    0x7
#define _WPUB_WPUB7_POSITION                                0x7
#define _WPUB_WPUB7_SIZE                                    0x1
#define _WPUB_WPUB7_LENGTH                                  0x1
#define _WPUB_WPUB7_MASK                                    0x80

// Register: WPUC
extern volatile unsigned char           WPUC                @ 0x20E;
#ifndef _LIB_BUILD
asm("WPUC equ 020Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned WPUC0                  :1;
        unsigned WPUC1                  :1;
        unsigned WPUC2                  :1;
        unsigned WPUC3                  :1;
        unsigned WPUC4                  :1;
        unsigned WPUC5                  :1;
        unsigned WPUC6                  :1;
        unsigned WPUC7                  :1;
    };
    struct {
        unsigned WPUA                   :6;
    };
} WPUCbits_t;
extern volatile WPUCbits_t WPUCbits @ 0x20E;
// bitfield macros
#define _WPUC_WPUC0_POSN                                    0x0
#define _WPUC_WPUC0_POSITION                                0x0
#define _WPUC_WPUC0_SIZE                                    0x1
#define _WPUC_WPUC0_LENGTH                                  0x1
#define _WPUC_WPUC0_MASK                                    0x1
#define _WPUC_WPUC1_POSN                                    0x1
#define _WPUC_WPUC1_POSITION                                0x1
#define _WPUC_WPUC1_SIZE                                    0x1
#define _WPUC_WPUC1_LENGTH                                  0x1
#define _WPUC_WPUC1_MASK                                    0x2
#define _WPUC_WPUC2_POSN                                    0x2
#define _WPUC_WPUC2_POSITION                                0x2
#define _WPUC_WPUC2_SIZE                                    0x1
#define _WPUC_WPUC2_LENGTH                                  0x1
#define _WPUC_WPUC2_MASK                                    0x4
#define _WPUC_WPUC3_POSN                                    0x3
#define _WPUC_WPUC3_POSITION                                0x3
#define _WPUC_WPUC3_SIZE                                    0x1
#define _WPUC_WPUC3_LENGTH                                  0x1
#define _WPUC_WPUC3_MASK                                    0x8
#define _WPUC_WPUC4_POSN                                    0x4
#define _WPUC_WPUC4_POSITION                                0x4
#define _WPUC_WPUC4_SIZE                                    0x1
#define _WPUC_WPUC4_LENGTH                                  0x1
#define _WPUC_WPUC4_MASK                                    0x10
#define _WPUC_WPUC5_POSN                                    0x5
#define _WPUC_WPUC5_POSITION                                0x5
#define _WPUC_WPUC5_SIZE                                    0x1
#define _WPUC_WPUC5_LENGTH                                  0x1
#define _WPUC_WPUC5_MASK                                    0x20
#define _WPUC_WPUC6_POSN                                    0x6
#define _WPUC_WPUC6_POSITION                                0x6
#define _WPUC_WPUC6_SIZE                                    0x1
#define _WPUC_WPUC6_LENGTH                                  0x1
#define _WPUC_WPUC6_MASK                                    0x40
#define _WPUC_WPUC7_POSN                                    0x7
#define _WPUC_WPUC7_POSITION                                0x7
#define _WPUC_WPUC7_SIZE                                    0x1
#define _WPUC_WPUC7_LENGTH                                  0x1
#define _WPUC_WPUC7_MASK                                    0x80
#define _WPUC_WPUA_POSN                                     0x0
#define _WPUC_WPUA_POSITION                                 0x0
#define _WPUC_WPUA_SIZE                                     0x6
#define _WPUC_WPUA_LENGTH                                   0x6
#define _WPUC_WPUA_MASK                                     0x3F

// Register: SSP1BUF
extern volatile unsigned char           SSP1BUF             @ 0x211;
#ifndef _LIB_BUILD
asm("SSP1BUF equ 0211h");
#endif
// aliases
extern volatile unsigned char           SSPBUF              @ 0x211;
#ifndef _LIB_BUILD
asm("SSPBUF equ 0211h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SSP1BUF0               :1;
        unsigned SSP1BUF1               :1;
        unsigned SSP1BUF2               :1;
        unsigned SSP1BUF3               :1;
        unsigned SSP1BUF4               :1;
        unsigned SSP1BUF5               :1;
        unsigned SSP1BUF6               :1;
        unsigned SSP1BUF7               :1;
    };
    struct {
        unsigned BUF                    :8;
    };
    struct {
        unsigned BUF0                   :1;
        unsigned BUF1                   :1;
        unsigned BUF2                   :1;
        unsigned BUF3                   :1;
        unsigned BUF4                   :1;
        unsigned BUF5                   :1;
        unsigned BUF6                   :1;
        unsigned BUF7                   :1;
    };
    struct {
        unsigned SSP1BUF                :8;
    };
} SSP1BUFbits_t;
extern volatile SSP1BUFbits_t SSP1BUFbits @ 0x211;
// bitfield macros
#define _SSP1BUF_SSP1BUF0_POSN                              0x0
#define _SSP1BUF_SSP1BUF0_POSITION                          0x0
#define _SSP1BUF_SSP1BUF0_SIZE                              0x1
#define _SSP1BUF_SSP1BUF0_LENGTH                            0x1
#define _SSP1BUF_SSP1BUF0_MASK                              0x1
#define _SSP1BUF_SSP1BUF1_POSN                              0x1
#define _SSP1BUF_SSP1BUF1_POSITION                          0x1
#define _SSP1BUF_SSP1BUF1_SIZE                              0x1
#define _SSP1BUF_SSP1BUF1_LENGTH                            0x1
#define _SSP1BUF_SSP1BUF1_MASK                              0x2
#define _SSP1BUF_SSP1BUF2_POSN                              0x2
#define _SSP1BUF_SSP1BUF2_POSITION                          0x2
#define _SSP1BUF_SSP1BUF2_SIZE                              0x1
#define _SSP1BUF_SSP1BUF2_LENGTH                            0x1
#define _SSP1BUF_SSP1BUF2_MASK                              0x4
#define _SSP1BUF_SSP1BUF3_POSN                              0x3
#define _SSP1BUF_SSP1BUF3_POSITION                          0x3
#define _SSP1BUF_SSP1BUF3_SIZE                              0x1
#define _SSP1BUF_SSP1BUF3_LENGTH                            0x1
#define _SSP1BUF_SSP1BUF3_MASK                              0x8
#define _SSP1BUF_SSP1BUF4_POSN                              0x4
#define _SSP1BUF_SSP1BUF4_POSITION                          0x4
#define _SSP1BUF_SSP1BUF4_SIZE                              0x1
#define _SSP1BUF_SSP1BUF4_LENGTH                            0x1
#define _SSP1BUF_SSP1BUF4_MASK                              0x10
#define _SSP1BUF_SSP1BUF5_POSN                              0x5
#define _SSP1BUF_SSP1BUF5_POSITION                          0x5
#define _SSP1BUF_SSP1BUF5_SIZE                              0x1
#define _SSP1BUF_SSP1BUF5_LENGTH                            0x1
#define _SSP1BUF_SSP1BUF5_MASK                              0x20
#define _SSP1BUF_SSP1BUF6_POSN                              0x6
#define _SSP1BUF_SSP1BUF6_POSITION                          0x6
#define _SSP1BUF_SSP1BUF6_SIZE                              0x1
#define _SSP1BUF_SSP1BUF6_LENGTH                            0x1
#define _SSP1BUF_SSP1BUF6_MASK                              0x40
#define _SSP1BUF_SSP1BUF7_POSN                              0x7
#define _SSP1BUF_SSP1BUF7_POSITION                          0x7
#define _SSP1BUF_SSP1BUF7_SIZE                              0x1
#define _SSP1BUF_SSP1BUF7_LENGTH                            0x1
#define _SSP1BUF_SSP1BUF7_MASK                              0x80
#define _SSP1BUF_BUF_POSN                                   0x0
#define _SSP1BUF_BUF_POSITION                               0x0
#define _SSP1BUF_BUF_SIZE                                   0x8
#define _SSP1BUF_BUF_LENGTH                                 0x8
#define _SSP1BUF_BUF_MASK                                   0xFF
#define _SSP1BUF_BUF0_POSN                                  0x0
#define _SSP1BUF_BUF0_POSITION                              0x0
#define _SSP1BUF_BUF0_SIZE                                  0x1
#define _SSP1BUF_BUF0_LENGTH                                0x1
#define _SSP1BUF_BUF0_MASK                                  0x1
#define _SSP1BUF_BUF1_POSN                                  0x1
#define _SSP1BUF_BUF1_POSITION                              0x1
#define _SSP1BUF_BUF1_SIZE                                  0x1
#define _SSP1BUF_BUF1_LENGTH                                0x1
#define _SSP1BUF_BUF1_MASK                                  0x2
#define _SSP1BUF_BUF2_POSN                                  0x2
#define _SSP1BUF_BUF2_POSITION                              0x2
#define _SSP1BUF_BUF2_SIZE                                  0x1
#define _SSP1BUF_BUF2_LENGTH                                0x1
#define _SSP1BUF_BUF2_MASK                                  0x4
#define _SSP1BUF_BUF3_POSN                                  0x3
#define _SSP1BUF_BUF3_POSITION                              0x3
#define _SSP1BUF_BUF3_SIZE                                  0x1
#define _SSP1BUF_BUF3_LENGTH                                0x1
#define _SSP1BUF_BUF3_MASK                                  0x8
#define _SSP1BUF_BUF4_POSN                                  0x4
#define _SSP1BUF_BUF4_POSITION                              0x4
#define _SSP1BUF_BUF4_SIZE                                  0x1
#define _SSP1BUF_BUF4_LENGTH                                0x1
#define _SSP1BUF_BUF4_MASK                                  0x10
#define _SSP1BUF_BUF5_POSN                                  0x5
#define _SSP1BUF_BUF5_POSITION                              0x5
#define _SSP1BUF_BUF5_SIZE                                  0x1
#define _SSP1BUF_BUF5_LENGTH                                0x1
#define _SSP1BUF_BUF5_MASK                                  0x20
#define _SSP1BUF_BUF6_POSN                                  0x6
#define _SSP1BUF_BUF6_POSITION                              0x6
#define _SSP1BUF_BUF6_SIZE                                  0x1
#define _SSP1BUF_BUF6_LENGTH                                0x1
#define _SSP1BUF_BUF6_MASK                                  0x40
#define _SSP1BUF_BUF7_POSN                                  0x7
#define _SSP1BUF_BUF7_POSITION                              0x7
#define _SSP1BUF_BUF7_SIZE                                  0x1
#define _SSP1BUF_BUF7_LENGTH                                0x1
#define _SSP1BUF_BUF7_MASK                                  0x80
#define _SSP1BUF_SSP1BUF_POSN                               0x0
#define _SSP1BUF_SSP1BUF_POSITION                           0x0
#define _SSP1BUF_SSP1BUF_SIZE                               0x8
#define _SSP1BUF_SSP1BUF_LENGTH                             0x8
#define _SSP1BUF_SSP1BUF_MASK                               0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned SSP1BUF0               :1;
        unsigned SSP1BUF1               :1;
        unsigned SSP1BUF2               :1;
        unsigned SSP1BUF3               :1;
        unsigned SSP1BUF4               :1;
        unsigned SSP1BUF5               :1;
        unsigned SSP1BUF6               :1;
        unsigned SSP1BUF7               :1;
    };
    struct {
        unsigned BUF                    :8;
    };
    struct {
        unsigned BUF0                   :1;
        unsigned BUF1                   :1;
        unsigned BUF2                   :1;
        unsigned BUF3                   :1;
        unsigned BUF4                   :1;
        unsigned BUF5                   :1;
        unsigned BUF6                   :1;
        unsigned BUF7                   :1;
    };
    struct {
        unsigned SSP1BUF                :8;
    };
} SSPBUFbits_t;
extern volatile SSPBUFbits_t SSPBUFbits @ 0x211;
// bitfield macros
#define _SSPBUF_SSP1BUF0_POSN                               0x0
#define _SSPBUF_SSP1BUF0_POSITION                           0x0
#define _SSPBUF_SSP1BUF0_SIZE                               0x1
#define _SSPBUF_SSP1BUF0_LENGTH                             0x1
#define _SSPBUF_SSP1BUF0_MASK                               0x1
#define _SSPBUF_SSP1BUF1_POSN                               0x1
#define _SSPBUF_SSP1BUF1_POSITION                           0x1
#define _SSPBUF_SSP1BUF1_SIZE                               0x1
#define _SSPBUF_SSP1BUF1_LENGTH                             0x1
#define _SSPBUF_SSP1BUF1_MASK                               0x2
#define _SSPBUF_SSP1BUF2_POSN                               0x2
#define _SSPBUF_SSP1BUF2_POSITION                           0x2
#define _SSPBUF_SSP1BUF2_SIZE                               0x1
#define _SSPBUF_SSP1BUF2_LENGTH                             0x1
#define _SSPBUF_SSP1BUF2_MASK                               0x4
#define _SSPBUF_SSP1BUF3_POSN                               0x3
#define _SSPBUF_SSP1BUF3_POSITION                           0x3
#define _SSPBUF_SSP1BUF3_SIZE                               0x1
#define _SSPBUF_SSP1BUF3_LENGTH                             0x1
#define _SSPBUF_SSP1BUF3_MASK                               0x8
#define _SSPBUF_SSP1BUF4_POSN                               0x4
#define _SSPBUF_SSP1BUF4_POSITION                           0x4
#define _SSPBUF_SSP1BUF4_SIZE                               0x1
#define _SSPBUF_SSP1BUF4_LENGTH                             0x1
#define _SSPBUF_SSP1BUF4_MASK                               0x10
#define _SSPBUF_SSP1BUF5_POSN                               0x5
#define _SSPBUF_SSP1BUF5_POSITION                           0x5
#define _SSPBUF_SSP1BUF5_SIZE                               0x1
#define _SSPBUF_SSP1BUF5_LENGTH                             0x1
#define _SSPBUF_SSP1BUF5_MASK                               0x20
#define _SSPBUF_SSP1BUF6_POSN                               0x6
#define _SSPBUF_SSP1BUF6_POSITION                           0x6
#define _SSPBUF_SSP1BUF6_SIZE                               0x1
#define _SSPBUF_SSP1BUF6_LENGTH                             0x1
#define _SSPBUF_SSP1BUF6_MASK                               0x40
#define _SSPBUF_SSP1BUF7_POSN                               0x7
#define _SSPBUF_SSP1BUF7_POSITION                           0x7
#define _SSPBUF_SSP1BUF7_SIZE                               0x1
#define _SSPBUF_SSP1BUF7_LENGTH                             0x1
#define _SSPBUF_SSP1BUF7_MASK                               0x80
#define _SSPBUF_BUF_POSN                                    0x0
#define _SSPBUF_BUF_POSITION                                0x0
#define _SSPBUF_BUF_SIZE                                    0x8
#define _SSPBUF_BUF_LENGTH                                  0x8
#define _SSPBUF_BUF_MASK                                    0xFF
#define _SSPBUF_BUF0_POSN                                   0x0
#define _SSPBUF_BUF0_POSITION                               0x0
#define _SSPBUF_BUF0_SIZE                                   0x1
#define _SSPBUF_BUF0_LENGTH                                 0x1
#define _SSPBUF_BUF0_MASK                                   0x1
#define _SSPBUF_BUF1_POSN                                   0x1
#define _SSPBUF_BUF1_POSITION                               0x1
#define _SSPBUF_BUF1_SIZE                                   0x1
#define _SSPBUF_BUF1_LENGTH                                 0x1
#define _SSPBUF_BUF1_MASK                                   0x2
#define _SSPBUF_BUF2_POSN                                   0x2
#define _SSPBUF_BUF2_POSITION                               0x2
#define _SSPBUF_BUF2_SIZE                                   0x1
#define _SSPBUF_BUF2_LENGTH                                 0x1
#define _SSPBUF_BUF2_MASK                                   0x4
#define _SSPBUF_BUF3_POSN                                   0x3
#define _SSPBUF_BUF3_POSITION                               0x3
#define _SSPBUF_BUF3_SIZE                                   0x1
#define _SSPBUF_BUF3_LENGTH                                 0x1
#define _SSPBUF_BUF3_MASK                                   0x8
#define _SSPBUF_BUF4_POSN                                   0x4
#define _SSPBUF_BUF4_POSITION                               0x4
#define _SSPBUF_BUF4_SIZE                                   0x1
#define _SSPBUF_BUF4_LENGTH                                 0x1
#define _SSPBUF_BUF4_MASK                                   0x10
#define _SSPBUF_BUF5_POSN                                   0x5
#define _SSPBUF_BUF5_POSITION                               0x5
#define _SSPBUF_BUF5_SIZE                                   0x1
#define _SSPBUF_BUF5_LENGTH                                 0x1
#define _SSPBUF_BUF5_MASK                                   0x20
#define _SSPBUF_BUF6_POSN                                   0x6
#define _SSPBUF_BUF6_POSITION                               0x6
#define _SSPBUF_BUF6_SIZE                                   0x1
#define _SSPBUF_BUF6_LENGTH                                 0x1
#define _SSPBUF_BUF6_MASK                                   0x40
#define _SSPBUF_BUF7_POSN                                   0x7
#define _SSPBUF_BUF7_POSITION                               0x7
#define _SSPBUF_BUF7_SIZE                                   0x1
#define _SSPBUF_BUF7_LENGTH                                 0x1
#define _SSPBUF_BUF7_MASK                                   0x80
#define _SSPBUF_SSP1BUF_POSN                                0x0
#define _SSPBUF_SSP1BUF_POSITION                            0x0
#define _SSPBUF_SSP1BUF_SIZE                                0x8
#define _SSPBUF_SSP1BUF_LENGTH                              0x8
#define _SSPBUF_SSP1BUF_MASK                                0xFF

// Register: SSP1ADD
extern volatile unsigned char           SSP1ADD             @ 0x212;
#ifndef _LIB_BUILD
asm("SSP1ADD equ 0212h");
#endif
// aliases
extern volatile unsigned char           SSPADD              @ 0x212;
#ifndef _LIB_BUILD
asm("SSPADD equ 0212h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SSP1ADD0               :1;
        unsigned SSP1ADD1               :1;
        unsigned SSP1ADD2               :1;
        unsigned SSP1ADD3               :1;
        unsigned SSP1ADD4               :1;
        unsigned SSP1ADD5               :1;
        unsigned SSP1ADD6               :1;
        unsigned SSP1ADD7               :1;
    };
    struct {
        unsigned ADD                    :8;
    };
    struct {
        unsigned ADD0                   :1;
        unsigned ADD1                   :1;
        unsigned ADD2                   :1;
        unsigned ADD3                   :1;
        unsigned ADD4                   :1;
        unsigned ADD5                   :1;
        unsigned ADD6                   :1;
        unsigned ADD7                   :1;
    };
    struct {
        unsigned SSP1ADD                :8;
    };
} SSP1ADDbits_t;
extern volatile SSP1ADDbits_t SSP1ADDbits @ 0x212;
// bitfield macros
#define _SSP1ADD_SSP1ADD0_POSN                              0x0
#define _SSP1ADD_SSP1ADD0_POSITION                          0x0
#define _SSP1ADD_SSP1ADD0_SIZE                              0x1
#define _SSP1ADD_SSP1ADD0_LENGTH                            0x1
#define _SSP1ADD_SSP1ADD0_MASK                              0x1
#define _SSP1ADD_SSP1ADD1_POSN                              0x1
#define _SSP1ADD_SSP1ADD1_POSITION                          0x1
#define _SSP1ADD_SSP1ADD1_SIZE                              0x1
#define _SSP1ADD_SSP1ADD1_LENGTH                            0x1
#define _SSP1ADD_SSP1ADD1_MASK                              0x2
#define _SSP1ADD_SSP1ADD2_POSN                              0x2
#define _SSP1ADD_SSP1ADD2_POSITION                          0x2
#define _SSP1ADD_SSP1ADD2_SIZE                              0x1
#define _SSP1ADD_SSP1ADD2_LENGTH                            0x1
#define _SSP1ADD_SSP1ADD2_MASK                              0x4
#define _SSP1ADD_SSP1ADD3_POSN                              0x3
#define _SSP1ADD_SSP1ADD3_POSITION                          0x3
#define _SSP1ADD_SSP1ADD3_SIZE                              0x1
#define _SSP1ADD_SSP1ADD3_LENGTH                            0x1
#define _SSP1ADD_SSP1ADD3_MASK                              0x8
#define _SSP1ADD_SSP1ADD4_POSN                              0x4
#define _SSP1ADD_SSP1ADD4_POSITION                          0x4
#define _SSP1ADD_SSP1ADD4_SIZE                              0x1
#define _SSP1ADD_SSP1ADD4_LENGTH                            0x1
#define _SSP1ADD_SSP1ADD4_MASK                              0x10
#define _SSP1ADD_SSP1ADD5_POSN                              0x5
#define _SSP1ADD_SSP1ADD5_POSITION                          0x5
#define _SSP1ADD_SSP1ADD5_SIZE                              0x1
#define _SSP1ADD_SSP1ADD5_LENGTH                            0x1
#define _SSP1ADD_SSP1ADD5_MASK                              0x20
#define _SSP1ADD_SSP1ADD6_POSN                              0x6
#define _SSP1ADD_SSP1ADD6_POSITION                          0x6
#define _SSP1ADD_SSP1ADD6_SIZE                              0x1
#define _SSP1ADD_SSP1ADD6_LENGTH                            0x1
#define _SSP1ADD_SSP1ADD6_MASK                              0x40
#define _SSP1ADD_SSP1ADD7_POSN                              0x7
#define _SSP1ADD_SSP1ADD7_POSITION                          0x7
#define _SSP1ADD_SSP1ADD7_SIZE                              0x1
#define _SSP1ADD_SSP1ADD7_LENGTH                            0x1
#define _SSP1ADD_SSP1ADD7_MASK                              0x80
#define _SSP1ADD_ADD_POSN                                   0x0
#define _SSP1ADD_ADD_POSITION                               0x0
#define _SSP1ADD_ADD_SIZE                                   0x8
#define _SSP1ADD_ADD_LENGTH                                 0x8
#define _SSP1ADD_ADD_MASK                                   0xFF
#define _SSP1ADD_ADD0_POSN                                  0x0
#define _SSP1ADD_ADD0_POSITION                              0x0
#define _SSP1ADD_ADD0_SIZE                                  0x1
#define _SSP1ADD_ADD0_LENGTH                                0x1
#define _SSP1ADD_ADD0_MASK                                  0x1
#define _SSP1ADD_ADD1_POSN                                  0x1
#define _SSP1ADD_ADD1_POSITION                              0x1
#define _SSP1ADD_ADD1_SIZE                                  0x1
#define _SSP1ADD_ADD1_LENGTH                                0x1
#define _SSP1ADD_ADD1_MASK                                  0x2
#define _SSP1ADD_ADD2_POSN                                  0x2
#define _SSP1ADD_ADD2_POSITION                              0x2
#define _SSP1ADD_ADD2_SIZE                                  0x1
#define _SSP1ADD_ADD2_LENGTH                                0x1
#define _SSP1ADD_ADD2_MASK                                  0x4
#define _SSP1ADD_ADD3_POSN                                  0x3
#define _SSP1ADD_ADD3_POSITION                              0x3
#define _SSP1ADD_ADD3_SIZE                                  0x1
#define _SSP1ADD_ADD3_LENGTH                                0x1
#define _SSP1ADD_ADD3_MASK                                  0x8
#define _SSP1ADD_ADD4_POSN                                  0x4
#define _SSP1ADD_ADD4_POSITION                              0x4
#define _SSP1ADD_ADD4_SIZE                                  0x1
#define _SSP1ADD_ADD4_LENGTH                                0x1
#define _SSP1ADD_ADD4_MASK                                  0x10
#define _SSP1ADD_ADD5_POSN                                  0x5
#define _SSP1ADD_ADD5_POSITION                              0x5
#define _SSP1ADD_ADD5_SIZE                                  0x1
#define _SSP1ADD_ADD5_LENGTH                                0x1
#define _SSP1ADD_ADD5_MASK                                  0x20
#define _SSP1ADD_ADD6_POSN                                  0x6
#define _SSP1ADD_ADD6_POSITION                              0x6
#define _SSP1ADD_ADD6_SIZE                                  0x1
#define _SSP1ADD_ADD6_LENGTH                                0x1
#define _SSP1ADD_ADD6_MASK                                  0x40
#define _SSP1ADD_ADD7_POSN                                  0x7
#define _SSP1ADD_ADD7_POSITION                              0x7
#define _SSP1ADD_ADD7_SIZE                                  0x1
#define _SSP1ADD_ADD7_LENGTH                                0x1
#define _SSP1ADD_ADD7_MASK                                  0x80
#define _SSP1ADD_SSP1ADD_POSN                               0x0
#define _SSP1ADD_SSP1ADD_POSITION                           0x0
#define _SSP1ADD_SSP1ADD_SIZE                               0x8
#define _SSP1ADD_SSP1ADD_LENGTH                             0x8
#define _SSP1ADD_SSP1ADD_MASK                               0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned SSP1ADD0               :1;
        unsigned SSP1ADD1               :1;
        unsigned SSP1ADD2               :1;
        unsigned SSP1ADD3               :1;
        unsigned SSP1ADD4               :1;
        unsigned SSP1ADD5               :1;
        unsigned SSP1ADD6               :1;
        unsigned SSP1ADD7               :1;
    };
    struct {
        unsigned ADD                    :8;
    };
    struct {
        unsigned ADD0                   :1;
        unsigned ADD1                   :1;
        unsigned ADD2                   :1;
        unsigned ADD3                   :1;
        unsigned ADD4                   :1;
        unsigned ADD5                   :1;
        unsigned ADD6                   :1;
        unsigned ADD7                   :1;
    };
    struct {
        unsigned SSP1ADD                :8;
    };
} SSPADDbits_t;
extern volatile SSPADDbits_t SSPADDbits @ 0x212;
// bitfield macros
#define _SSPADD_SSP1ADD0_POSN                               0x0
#define _SSPADD_SSP1ADD0_POSITION                           0x0
#define _SSPADD_SSP1ADD0_SIZE                               0x1
#define _SSPADD_SSP1ADD0_LENGTH                             0x1
#define _SSPADD_SSP1ADD0_MASK                               0x1
#define _SSPADD_SSP1ADD1_POSN                               0x1
#define _SSPADD_SSP1ADD1_POSITION                           0x1
#define _SSPADD_SSP1ADD1_SIZE                               0x1
#define _SSPADD_SSP1ADD1_LENGTH                             0x1
#define _SSPADD_SSP1ADD1_MASK                               0x2
#define _SSPADD_SSP1ADD2_POSN                               0x2
#define _SSPADD_SSP1ADD2_POSITION                           0x2
#define _SSPADD_SSP1ADD2_SIZE                               0x1
#define _SSPADD_SSP1ADD2_LENGTH                             0x1
#define _SSPADD_SSP1ADD2_MASK                               0x4
#define _SSPADD_SSP1ADD3_POSN                               0x3
#define _SSPADD_SSP1ADD3_POSITION                           0x3
#define _SSPADD_SSP1ADD3_SIZE                               0x1
#define _SSPADD_SSP1ADD3_LENGTH                             0x1
#define _SSPADD_SSP1ADD3_MASK                               0x8
#define _SSPADD_SSP1ADD4_POSN                               0x4
#define _SSPADD_SSP1ADD4_POSITION                           0x4
#define _SSPADD_SSP1ADD4_SIZE                               0x1
#define _SSPADD_SSP1ADD4_LENGTH                             0x1
#define _SSPADD_SSP1ADD4_MASK                               0x10
#define _SSPADD_SSP1ADD5_POSN                               0x5
#define _SSPADD_SSP1ADD5_POSITION                           0x5
#define _SSPADD_SSP1ADD5_SIZE                               0x1
#define _SSPADD_SSP1ADD5_LENGTH                             0x1
#define _SSPADD_SSP1ADD5_MASK                               0x20
#define _SSPADD_SSP1ADD6_POSN                               0x6
#define _SSPADD_SSP1ADD6_POSITION                           0x6
#define _SSPADD_SSP1ADD6_SIZE                               0x1
#define _SSPADD_SSP1ADD6_LENGTH                             0x1
#define _SSPADD_SSP1ADD6_MASK                               0x40
#define _SSPADD_SSP1ADD7_POSN                               0x7
#define _SSPADD_SSP1ADD7_POSITION                           0x7
#define _SSPADD_SSP1ADD7_SIZE                               0x1
#define _SSPADD_SSP1ADD7_LENGTH                             0x1
#define _SSPADD_SSP1ADD7_MASK                               0x80
#define _SSPADD_ADD_POSN                                    0x0
#define _SSPADD_ADD_POSITION                                0x0
#define _SSPADD_ADD_SIZE                                    0x8
#define _SSPADD_ADD_LENGTH                                  0x8
#define _SSPADD_ADD_MASK                                    0xFF
#define _SSPADD_ADD0_POSN                                   0x0
#define _SSPADD_ADD0_POSITION                               0x0
#define _SSPADD_ADD0_SIZE                                   0x1
#define _SSPADD_ADD0_LENGTH                                 0x1
#define _SSPADD_ADD0_MASK                                   0x1
#define _SSPADD_ADD1_POSN                                   0x1
#define _SSPADD_ADD1_POSITION                               0x1
#define _SSPADD_ADD1_SIZE                                   0x1
#define _SSPADD_ADD1_LENGTH                                 0x1
#define _SSPADD_ADD1_MASK                                   0x2
#define _SSPADD_ADD2_POSN                                   0x2
#define _SSPADD_ADD2_POSITION                               0x2
#define _SSPADD_ADD2_SIZE                                   0x1
#define _SSPADD_ADD2_LENGTH                                 0x1
#define _SSPADD_ADD2_MASK                                   0x4
#define _SSPADD_ADD3_POSN                                   0x3
#define _SSPADD_ADD3_POSITION                               0x3
#define _SSPADD_ADD3_SIZE                                   0x1
#define _SSPADD_ADD3_LENGTH                                 0x1
#define _SSPADD_ADD3_MASK                                   0x8
#define _SSPADD_ADD4_POSN                                   0x4
#define _SSPADD_ADD4_POSITION                               0x4
#define _SSPADD_ADD4_SIZE                                   0x1
#define _SSPADD_ADD4_LENGTH                                 0x1
#define _SSPADD_ADD4_MASK                                   0x10
#define _SSPADD_ADD5_POSN                                   0x5
#define _SSPADD_ADD5_POSITION                               0x5
#define _SSPADD_ADD5_SIZE                                   0x1
#define _SSPADD_ADD5_LENGTH                                 0x1
#define _SSPADD_ADD5_MASK                                   0x20
#define _SSPADD_ADD6_POSN                                   0x6
#define _SSPADD_ADD6_POSITION                               0x6
#define _SSPADD_ADD6_SIZE                                   0x1
#define _SSPADD_ADD6_LENGTH                                 0x1
#define _SSPADD_ADD6_MASK                                   0x40
#define _SSPADD_ADD7_POSN                                   0x7
#define _SSPADD_ADD7_POSITION                               0x7
#define _SSPADD_ADD7_SIZE                                   0x1
#define _SSPADD_ADD7_LENGTH                                 0x1
#define _SSPADD_ADD7_MASK                                   0x80
#define _SSPADD_SSP1ADD_POSN                                0x0
#define _SSPADD_SSP1ADD_POSITION                            0x0
#define _SSPADD_SSP1ADD_SIZE                                0x8
#define _SSPADD_SSP1ADD_LENGTH                              0x8
#define _SSPADD_SSP1ADD_MASK                                0xFF

// Register: SSP1MSK
extern volatile unsigned char           SSP1MSK             @ 0x213;
#ifndef _LIB_BUILD
asm("SSP1MSK equ 0213h");
#endif
// aliases
extern volatile unsigned char           SSPMSK              @ 0x213;
#ifndef _LIB_BUILD
asm("SSPMSK equ 0213h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SSP1MSK0               :1;
        unsigned SSP1MSK1               :1;
        unsigned SSP1MSK2               :1;
        unsigned SSP1MSK3               :1;
        unsigned SSP1MSK4               :1;
        unsigned SSP1MSK5               :1;
        unsigned SSP1MSK6               :1;
        unsigned SSP1MSK7               :1;
    };
    struct {
        unsigned MSK                    :8;
    };
    struct {
        unsigned MSK0                   :1;
        unsigned MSK1                   :1;
        unsigned MSK2                   :1;
        unsigned MSK3                   :1;
        unsigned MSK4                   :1;
        unsigned MSK5                   :1;
        unsigned MSK6                   :1;
        unsigned MSK7                   :1;
    };
    struct {
        unsigned SSP1MSK                :8;
    };
} SSP1MSKbits_t;
extern volatile SSP1MSKbits_t SSP1MSKbits @ 0x213;
// bitfield macros
#define _SSP1MSK_SSP1MSK0_POSN                              0x0
#define _SSP1MSK_SSP1MSK0_POSITION                          0x0
#define _SSP1MSK_SSP1MSK0_SIZE                              0x1
#define _SSP1MSK_SSP1MSK0_LENGTH                            0x1
#define _SSP1MSK_SSP1MSK0_MASK                              0x1
#define _SSP1MSK_SSP1MSK1_POSN                              0x1
#define _SSP1MSK_SSP1MSK1_POSITION                          0x1
#define _SSP1MSK_SSP1MSK1_SIZE                              0x1
#define _SSP1MSK_SSP1MSK1_LENGTH                            0x1
#define _SSP1MSK_SSP1MSK1_MASK                              0x2
#define _SSP1MSK_SSP1MSK2_POSN                              0x2
#define _SSP1MSK_SSP1MSK2_POSITION                          0x2
#define _SSP1MSK_SSP1MSK2_SIZE                              0x1
#define _SSP1MSK_SSP1MSK2_LENGTH                            0x1
#define _SSP1MSK_SSP1MSK2_MASK                              0x4
#define _SSP1MSK_SSP1MSK3_POSN                              0x3
#define _SSP1MSK_SSP1MSK3_POSITION                          0x3
#define _SSP1MSK_SSP1MSK3_SIZE                              0x1
#define _SSP1MSK_SSP1MSK3_LENGTH                            0x1
#define _SSP1MSK_SSP1MSK3_MASK                              0x8
#define _SSP1MSK_SSP1MSK4_POSN                              0x4
#define _SSP1MSK_SSP1MSK4_POSITION                          0x4
#define _SSP1MSK_SSP1MSK4_SIZE                              0x1
#define _SSP1MSK_SSP1MSK4_LENGTH                            0x1
#define _SSP1MSK_SSP1MSK4_MASK                              0x10
#define _SSP1MSK_SSP1MSK5_POSN                              0x5
#define _SSP1MSK_SSP1MSK5_POSITION                          0x5
#define _SSP1MSK_SSP1MSK5_SIZE                              0x1
#define _SSP1MSK_SSP1MSK5_LENGTH                            0x1
#define _SSP1MSK_SSP1MSK5_MASK                              0x20
#define _SSP1MSK_SSP1MSK6_POSN                              0x6
#define _SSP1MSK_SSP1MSK6_POSITION                          0x6
#define _SSP1MSK_SSP1MSK6_SIZE                              0x1
#define _SSP1MSK_SSP1MSK6_LENGTH                            0x1
#define _SSP1MSK_SSP1MSK6_MASK                              0x40
#define _SSP1MSK_SSP1MSK7_POSN                              0x7
#define _SSP1MSK_SSP1MSK7_POSITION                          0x7
#define _SSP1MSK_SSP1MSK7_SIZE                              0x1
#define _SSP1MSK_SSP1MSK7_LENGTH                            0x1
#define _SSP1MSK_SSP1MSK7_MASK                              0x80
#define _SSP1MSK_MSK_POSN                                   0x0
#define _SSP1MSK_MSK_POSITION                               0x0
#define _SSP1MSK_MSK_SIZE                                   0x8
#define _SSP1MSK_MSK_LENGTH                                 0x8
#define _SSP1MSK_MSK_MASK                                   0xFF
#define _SSP1MSK_MSK0_POSN                                  0x0
#define _SSP1MSK_MSK0_POSITION                              0x0
#define _SSP1MSK_MSK0_SIZE                                  0x1
#define _SSP1MSK_MSK0_LENGTH                                0x1
#define _SSP1MSK_MSK0_MASK                                  0x1
#define _SSP1MSK_MSK1_POSN                                  0x1
#define _SSP1MSK_MSK1_POSITION                              0x1
#define _SSP1MSK_MSK1_SIZE                                  0x1
#define _SSP1MSK_MSK1_LENGTH                                0x1
#define _SSP1MSK_MSK1_MASK                                  0x2
#define _SSP1MSK_MSK2_POSN                                  0x2
#define _SSP1MSK_MSK2_POSITION                              0x2
#define _SSP1MSK_MSK2_SIZE                                  0x1
#define _SSP1MSK_MSK2_LENGTH                                0x1
#define _SSP1MSK_MSK2_MASK                                  0x4
#define _SSP1MSK_MSK3_POSN                                  0x3
#define _SSP1MSK_MSK3_POSITION                              0x3
#define _SSP1MSK_MSK3_SIZE                                  0x1
#define _SSP1MSK_MSK3_LENGTH                                0x1
#define _SSP1MSK_MSK3_MASK                                  0x8
#define _SSP1MSK_MSK4_POSN                                  0x4
#define _SSP1MSK_MSK4_POSITION                              0x4
#define _SSP1MSK_MSK4_SIZE                                  0x1
#define _SSP1MSK_MSK4_LENGTH                                0x1
#define _SSP1MSK_MSK4_MASK                                  0x10
#define _SSP1MSK_MSK5_POSN                                  0x5
#define _SSP1MSK_MSK5_POSITION                              0x5
#define _SSP1MSK_MSK5_SIZE                                  0x1
#define _SSP1MSK_MSK5_LENGTH                                0x1
#define _SSP1MSK_MSK5_MASK                                  0x20
#define _SSP1MSK_MSK6_POSN                                  0x6
#define _SSP1MSK_MSK6_POSITION                              0x6
#define _SSP1MSK_MSK6_SIZE                                  0x1
#define _SSP1MSK_MSK6_LENGTH                                0x1
#define _SSP1MSK_MSK6_MASK                                  0x40
#define _SSP1MSK_MSK7_POSN                                  0x7
#define _SSP1MSK_MSK7_POSITION                              0x7
#define _SSP1MSK_MSK7_SIZE                                  0x1
#define _SSP1MSK_MSK7_LENGTH                                0x1
#define _SSP1MSK_MSK7_MASK                                  0x80
#define _SSP1MSK_SSP1MSK_POSN                               0x0
#define _SSP1MSK_SSP1MSK_POSITION                           0x0
#define _SSP1MSK_SSP1MSK_SIZE                               0x8
#define _SSP1MSK_SSP1MSK_LENGTH                             0x8
#define _SSP1MSK_SSP1MSK_MASK                               0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned SSP1MSK0               :1;
        unsigned SSP1MSK1               :1;
        unsigned SSP1MSK2               :1;
        unsigned SSP1MSK3               :1;
        unsigned SSP1MSK4               :1;
        unsigned SSP1MSK5               :1;
        unsigned SSP1MSK6               :1;
        unsigned SSP1MSK7               :1;
    };
    struct {
        unsigned MSK                    :8;
    };
    struct {
        unsigned MSK0                   :1;
        unsigned MSK1                   :1;
        unsigned MSK2                   :1;
        unsigned MSK3                   :1;
        unsigned MSK4                   :1;
        unsigned MSK5                   :1;
        unsigned MSK6                   :1;
        unsigned MSK7                   :1;
    };
    struct {
        unsigned SSP1MSK                :8;
    };
} SSPMSKbits_t;
extern volatile SSPMSKbits_t SSPMSKbits @ 0x213;
// bitfield macros
#define _SSPMSK_SSP1MSK0_POSN                               0x0
#define _SSPMSK_SSP1MSK0_POSITION                           0x0
#define _SSPMSK_SSP1MSK0_SIZE                               0x1
#define _SSPMSK_SSP1MSK0_LENGTH                             0x1
#define _SSPMSK_SSP1MSK0_MASK                               0x1
#define _SSPMSK_SSP1MSK1_POSN                               0x1
#define _SSPMSK_SSP1MSK1_POSITION                           0x1
#define _SSPMSK_SSP1MSK1_SIZE                               0x1
#define _SSPMSK_SSP1MSK1_LENGTH                             0x1
#define _SSPMSK_SSP1MSK1_MASK                               0x2
#define _SSPMSK_SSP1MSK2_POSN                               0x2
#define _SSPMSK_SSP1MSK2_POSITION                           0x2
#define _SSPMSK_SSP1MSK2_SIZE                               0x1
#define _SSPMSK_SSP1MSK2_LENGTH                             0x1
#define _SSPMSK_SSP1MSK2_MASK                               0x4
#define _SSPMSK_SSP1MSK3_POSN                               0x3
#define _SSPMSK_SSP1MSK3_POSITION                           0x3
#define _SSPMSK_SSP1MSK3_SIZE                               0x1
#define _SSPMSK_SSP1MSK3_LENGTH                             0x1
#define _SSPMSK_SSP1MSK3_MASK                               0x8
#define _SSPMSK_SSP1MSK4_POSN                               0x4
#define _SSPMSK_SSP1MSK4_POSITION                           0x4
#define _SSPMSK_SSP1MSK4_SIZE                               0x1
#define _SSPMSK_SSP1MSK4_LENGTH                             0x1
#define _SSPMSK_SSP1MSK4_MASK                               0x10
#define _SSPMSK_SSP1MSK5_POSN                               0x5
#define _SSPMSK_SSP1MSK5_POSITION                           0x5
#define _SSPMSK_SSP1MSK5_SIZE                               0x1
#define _SSPMSK_SSP1MSK5_LENGTH                             0x1
#define _SSPMSK_SSP1MSK5_MASK                               0x20
#define _SSPMSK_SSP1MSK6_POSN                               0x6
#define _SSPMSK_SSP1MSK6_POSITION                           0x6
#define _SSPMSK_SSP1MSK6_SIZE                               0x1
#define _SSPMSK_SSP1MSK6_LENGTH                             0x1
#define _SSPMSK_SSP1MSK6_MASK                               0x40
#define _SSPMSK_SSP1MSK7_POSN                               0x7
#define _SSPMSK_SSP1MSK7_POSITION                           0x7
#define _SSPMSK_SSP1MSK7_SIZE                               0x1
#define _SSPMSK_SSP1MSK7_LENGTH                             0x1
#define _SSPMSK_SSP1MSK7_MASK                               0x80
#define _SSPMSK_MSK_POSN                                    0x0
#define _SSPMSK_MSK_POSITION                                0x0
#define _SSPMSK_MSK_SIZE                                    0x8
#define _SSPMSK_MSK_LENGTH                                  0x8
#define _SSPMSK_MSK_MASK                                    0xFF
#define _SSPMSK_MSK0_POSN                                   0x0
#define _SSPMSK_MSK0_POSITION                               0x0
#define _SSPMSK_MSK0_SIZE                                   0x1
#define _SSPMSK_MSK0_LENGTH                                 0x1
#define _SSPMSK_MSK0_MASK                                   0x1
#define _SSPMSK_MSK1_POSN                                   0x1
#define _SSPMSK_MSK1_POSITION                               0x1
#define _SSPMSK_MSK1_SIZE                                   0x1
#define _SSPMSK_MSK1_LENGTH                                 0x1
#define _SSPMSK_MSK1_MASK                                   0x2
#define _SSPMSK_MSK2_POSN                                   0x2
#define _SSPMSK_MSK2_POSITION                               0x2
#define _SSPMSK_MSK2_SIZE                                   0x1
#define _SSPMSK_MSK2_LENGTH                                 0x1
#define _SSPMSK_MSK2_MASK                                   0x4
#define _SSPMSK_MSK3_POSN                                   0x3
#define _SSPMSK_MSK3_POSITION                               0x3
#define _SSPMSK_MSK3_SIZE                                   0x1
#define _SSPMSK_MSK3_LENGTH                                 0x1
#define _SSPMSK_MSK3_MASK                                   0x8
#define _SSPMSK_MSK4_POSN                                   0x4
#define _SSPMSK_MSK4_POSITION                               0x4
#define _SSPMSK_MSK4_SIZE                                   0x1
#define _SSPMSK_MSK4_LENGTH                                 0x1
#define _SSPMSK_MSK4_MASK                                   0x10
#define _SSPMSK_MSK5_POSN                                   0x5
#define _SSPMSK_MSK5_POSITION                               0x5
#define _SSPMSK_MSK5_SIZE                                   0x1
#define _SSPMSK_MSK5_LENGTH                                 0x1
#define _SSPMSK_MSK5_MASK                                   0x20
#define _SSPMSK_MSK6_POSN                                   0x6
#define _SSPMSK_MSK6_POSITION                               0x6
#define _SSPMSK_MSK6_SIZE                                   0x1
#define _SSPMSK_MSK6_LENGTH                                 0x1
#define _SSPMSK_MSK6_MASK                                   0x40
#define _SSPMSK_MSK7_POSN                                   0x7
#define _SSPMSK_MSK7_POSITION                               0x7
#define _SSPMSK_MSK7_SIZE                                   0x1
#define _SSPMSK_MSK7_LENGTH                                 0x1
#define _SSPMSK_MSK7_MASK                                   0x80
#define _SSPMSK_SSP1MSK_POSN                                0x0
#define _SSPMSK_SSP1MSK_POSITION                            0x0
#define _SSPMSK_SSP1MSK_SIZE                                0x8
#define _SSPMSK_SSP1MSK_LENGTH                              0x8
#define _SSPMSK_SSP1MSK_MASK                                0xFF

// Register: SSP1STAT
extern volatile unsigned char           SSP1STAT            @ 0x214;
#ifndef _LIB_BUILD
asm("SSP1STAT equ 0214h");
#endif
// aliases
extern volatile unsigned char           SSPSTAT             @ 0x214;
#ifndef _LIB_BUILD
asm("SSPSTAT equ 0214h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned BF                     :1;
        unsigned UA                     :1;
        unsigned R_nW                   :1;
        unsigned S                      :1;
        unsigned P                      :1;
        unsigned D_nA                   :1;
        unsigned CKE                    :1;
        unsigned SMP                    :1;
    };
} SSP1STATbits_t;
extern volatile SSP1STATbits_t SSP1STATbits @ 0x214;
// bitfield macros
#define _SSP1STAT_BF_POSN                                   0x0
#define _SSP1STAT_BF_POSITION                               0x0
#define _SSP1STAT_BF_SIZE                                   0x1
#define _SSP1STAT_BF_LENGTH                                 0x1
#define _SSP1STAT_BF_MASK                                   0x1
#define _SSP1STAT_UA_POSN                                   0x1
#define _SSP1STAT_UA_POSITION                               0x1
#define _SSP1STAT_UA_SIZE                                   0x1
#define _SSP1STAT_UA_LENGTH                                 0x1
#define _SSP1STAT_UA_MASK                                   0x2
#define _SSP1STAT_R_nW_POSN                                 0x2
#define _SSP1STAT_R_nW_POSITION                             0x2
#define _SSP1STAT_R_nW_SIZE                                 0x1
#define _SSP1STAT_R_nW_LENGTH                               0x1
#define _SSP1STAT_R_nW_MASK                                 0x4
#define _SSP1STAT_S_POSN                                    0x3
#define _SSP1STAT_S_POSITION                                0x3
#define _SSP1STAT_S_SIZE                                    0x1
#define _SSP1STAT_S_LENGTH                                  0x1
#define _SSP1STAT_S_MASK                                    0x8
#define _SSP1STAT_P_POSN                                    0x4
#define _SSP1STAT_P_POSITION                                0x4
#define _SSP1STAT_P_SIZE                                    0x1
#define _SSP1STAT_P_LENGTH                                  0x1
#define _SSP1STAT_P_MASK                                    0x10
#define _SSP1STAT_D_nA_POSN                                 0x5
#define _SSP1STAT_D_nA_POSITION                             0x5
#define _SSP1STAT_D_nA_SIZE                                 0x1
#define _SSP1STAT_D_nA_LENGTH                               0x1
#define _SSP1STAT_D_nA_MASK                                 0x20
#define _SSP1STAT_CKE_POSN                                  0x6
#define _SSP1STAT_CKE_POSITION                              0x6
#define _SSP1STAT_CKE_SIZE                                  0x1
#define _SSP1STAT_CKE_LENGTH                                0x1
#define _SSP1STAT_CKE_MASK                                  0x40
#define _SSP1STAT_SMP_POSN                                  0x7
#define _SSP1STAT_SMP_POSITION                              0x7
#define _SSP1STAT_SMP_SIZE                                  0x1
#define _SSP1STAT_SMP_LENGTH                                0x1
#define _SSP1STAT_SMP_MASK                                  0x80
// alias bitfield definitions
typedef union {
    struct {
        unsigned BF                     :1;
        unsigned UA                     :1;
        unsigned R_nW                   :1;
        unsigned S                      :1;
        unsigned P                      :1;
        unsigned D_nA                   :1;
        unsigned CKE                    :1;
        unsigned SMP                    :1;
    };
} SSPSTATbits_t;
extern volatile SSPSTATbits_t SSPSTATbits @ 0x214;
// bitfield macros
#define _SSPSTAT_BF_POSN                                    0x0
#define _SSPSTAT_BF_POSITION                                0x0
#define _SSPSTAT_BF_SIZE                                    0x1
#define _SSPSTAT_BF_LENGTH                                  0x1
#define _SSPSTAT_BF_MASK                                    0x1
#define _SSPSTAT_UA_POSN                                    0x1
#define _SSPSTAT_UA_POSITION                                0x1
#define _SSPSTAT_UA_SIZE                                    0x1
#define _SSPSTAT_UA_LENGTH                                  0x1
#define _SSPSTAT_UA_MASK                                    0x2
#define _SSPSTAT_R_nW_POSN                                  0x2
#define _SSPSTAT_R_nW_POSITION                              0x2
#define _SSPSTAT_R_nW_SIZE                                  0x1
#define _SSPSTAT_R_nW_LENGTH                                0x1
#define _SSPSTAT_R_nW_MASK                                  0x4
#define _SSPSTAT_S_POSN                                     0x3
#define _SSPSTAT_S_POSITION                                 0x3
#define _SSPSTAT_S_SIZE                                     0x1
#define _SSPSTAT_S_LENGTH                                   0x1
#define _SSPSTAT_S_MASK                                     0x8
#define _SSPSTAT_P_POSN                                     0x4
#define _SSPSTAT_P_POSITION                                 0x4
#define _SSPSTAT_P_SIZE                                     0x1
#define _SSPSTAT_P_LENGTH                                   0x1
#define _SSPSTAT_P_MASK                                     0x10
#define _SSPSTAT_D_nA_POSN                                  0x5
#define _SSPSTAT_D_nA_POSITION                              0x5
#define _SSPSTAT_D_nA_SIZE                                  0x1
#define _SSPSTAT_D_nA_LENGTH                                0x1
#define _SSPSTAT_D_nA_MASK                                  0x20
#define _SSPSTAT_CKE_POSN                                   0x6
#define _SSPSTAT_CKE_POSITION                               0x6
#define _SSPSTAT_CKE_SIZE                                   0x1
#define _SSPSTAT_CKE_LENGTH                                 0x1
#define _SSPSTAT_CKE_MASK                                   0x40
#define _SSPSTAT_SMP_POSN                                   0x7
#define _SSPSTAT_SMP_POSITION                               0x7
#define _SSPSTAT_SMP_SIZE                                   0x1
#define _SSPSTAT_SMP_LENGTH                                 0x1
#define _SSPSTAT_SMP_MASK                                   0x80

// Register: SSP1CON1
extern volatile unsigned char           SSP1CON1            @ 0x215;
#ifndef _LIB_BUILD
asm("SSP1CON1 equ 0215h");
#endif
// aliases
extern volatile unsigned char           SSPCON              @ 0x215;
#ifndef _LIB_BUILD
asm("SSPCON equ 0215h");
#endif
extern volatile unsigned char           SSPCON1             @ 0x215;
#ifndef _LIB_BUILD
asm("SSPCON1 equ 0215h");
#endif
extern volatile unsigned char           SSP1CON             @ 0x215;
#ifndef _LIB_BUILD
asm("SSP1CON equ 0215h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SSPM                   :4;
        unsigned CKP                    :1;
        unsigned SSPEN                  :1;
        unsigned SSPOV                  :1;
        unsigned WCOL                   :1;
    };
    struct {
        unsigned SSPM0                  :1;
        unsigned SSPM1                  :1;
        unsigned SSPM2                  :1;
        unsigned SSPM3                  :1;
    };
} SSP1CON1bits_t;
extern volatile SSP1CON1bits_t SSP1CON1bits @ 0x215;
// bitfield macros
#define _SSP1CON1_SSPM_POSN                                 0x0
#define _SSP1CON1_SSPM_POSITION                             0x0
#define _SSP1CON1_SSPM_SIZE                                 0x4
#define _SSP1CON1_SSPM_LENGTH                               0x4
#define _SSP1CON1_SSPM_MASK                                 0xF
#define _SSP1CON1_CKP_POSN                                  0x4
#define _SSP1CON1_CKP_POSITION                              0x4
#define _SSP1CON1_CKP_SIZE                                  0x1
#define _SSP1CON1_CKP_LENGTH                                0x1
#define _SSP1CON1_CKP_MASK                                  0x10
#define _SSP1CON1_SSPEN_POSN                                0x5
#define _SSP1CON1_SSPEN_POSITION                            0x5
#define _SSP1CON1_SSPEN_SIZE                                0x1
#define _SSP1CON1_SSPEN_LENGTH                              0x1
#define _SSP1CON1_SSPEN_MASK                                0x20
#define _SSP1CON1_SSPOV_POSN                                0x6
#define _SSP1CON1_SSPOV_POSITION                            0x6
#define _SSP1CON1_SSPOV_SIZE                                0x1
#define _SSP1CON1_SSPOV_LENGTH                              0x1
#define _SSP1CON1_SSPOV_MASK                                0x40
#define _SSP1CON1_WCOL_POSN                                 0x7
#define _SSP1CON1_WCOL_POSITION                             0x7
#define _SSP1CON1_WCOL_SIZE                                 0x1
#define _SSP1CON1_WCOL_LENGTH                               0x1
#define _SSP1CON1_WCOL_MASK                                 0x80
#define _SSP1CON1_SSPM0_POSN                                0x0
#define _SSP1CON1_SSPM0_POSITION                            0x0
#define _SSP1CON1_SSPM0_SIZE                                0x1
#define _SSP1CON1_SSPM0_LENGTH                              0x1
#define _SSP1CON1_SSPM0_MASK                                0x1
#define _SSP1CON1_SSPM1_POSN                                0x1
#define _SSP1CON1_SSPM1_POSITION                            0x1
#define _SSP1CON1_SSPM1_SIZE                                0x1
#define _SSP1CON1_SSPM1_LENGTH                              0x1
#define _SSP1CON1_SSPM1_MASK                                0x2
#define _SSP1CON1_SSPM2_POSN                                0x2
#define _SSP1CON1_SSPM2_POSITION                            0x2
#define _SSP1CON1_SSPM2_SIZE                                0x1
#define _SSP1CON1_SSPM2_LENGTH                              0x1
#define _SSP1CON1_SSPM2_MASK                                0x4
#define _SSP1CON1_SSPM3_POSN                                0x3
#define _SSP1CON1_SSPM3_POSITION                            0x3
#define _SSP1CON1_SSPM3_SIZE                                0x1
#define _SSP1CON1_SSPM3_LENGTH                              0x1
#define _SSP1CON1_SSPM3_MASK                                0x8
// alias bitfield definitions
typedef union {
    struct {
        unsigned SSPM                   :4;
        unsigned CKP                    :1;
        unsigned SSPEN                  :1;
        unsigned SSPOV                  :1;
        unsigned WCOL                   :1;
    };
    struct {
        unsigned SSPM0                  :1;
        unsigned SSPM1                  :1;
        unsigned SSPM2                  :1;
        unsigned SSPM3                  :1;
    };
} SSPCONbits_t;
extern volatile SSPCONbits_t SSPCONbits @ 0x215;
// bitfield macros
#define _SSPCON_SSPM_POSN                                   0x0
#define _SSPCON_SSPM_POSITION                               0x0
#define _SSPCON_SSPM_SIZE                                   0x4
#define _SSPCON_SSPM_LENGTH                                 0x4
#define _SSPCON_SSPM_MASK                                   0xF
#define _SSPCON_CKP_POSN                                    0x4
#define _SSPCON_CKP_POSITION                                0x4
#define _SSPCON_CKP_SIZE                                    0x1
#define _SSPCON_CKP_LENGTH                                  0x1
#define _SSPCON_CKP_MASK                                    0x10
#define _SSPCON_SSPEN_POSN                                  0x5
#define _SSPCON_SSPEN_POSITION                              0x5
#define _SSPCON_SSPEN_SIZE                                  0x1
#define _SSPCON_SSPEN_LENGTH                                0x1
#define _SSPCON_SSPEN_MASK                                  0x20
#define _SSPCON_SSPOV_POSN                                  0x6
#define _SSPCON_SSPOV_POSITION                              0x6
#define _SSPCON_SSPOV_SIZE                                  0x1
#define _SSPCON_SSPOV_LENGTH                                0x1
#define _SSPCON_SSPOV_MASK                                  0x40
#define _SSPCON_WCOL_POSN                                   0x7
#define _SSPCON_WCOL_POSITION                               0x7
#define _SSPCON_WCOL_SIZE                                   0x1
#define _SSPCON_WCOL_LENGTH                                 0x1
#define _SSPCON_WCOL_MASK                                   0x80
#define _SSPCON_SSPM0_POSN                                  0x0
#define _SSPCON_SSPM0_POSITION                              0x0
#define _SSPCON_SSPM0_SIZE                                  0x1
#define _SSPCON_SSPM0_LENGTH                                0x1
#define _SSPCON_SSPM0_MASK                                  0x1
#define _SSPCON_SSPM1_POSN                                  0x1
#define _SSPCON_SSPM1_POSITION                              0x1
#define _SSPCON_SSPM1_SIZE                                  0x1
#define _SSPCON_SSPM1_LENGTH                                0x1
#define _SSPCON_SSPM1_MASK                                  0x2
#define _SSPCON_SSPM2_POSN                                  0x2
#define _SSPCON_SSPM2_POSITION                              0x2
#define _SSPCON_SSPM2_SIZE                                  0x1
#define _SSPCON_SSPM2_LENGTH                                0x1
#define _SSPCON_SSPM2_MASK                                  0x4
#define _SSPCON_SSPM3_POSN                                  0x3
#define _SSPCON_SSPM3_POSITION                              0x3
#define _SSPCON_SSPM3_SIZE                                  0x1
#define _SSPCON_SSPM3_LENGTH                                0x1
#define _SSPCON_SSPM3_MASK                                  0x8
typedef union {
    struct {
        unsigned SSPM                   :4;
        unsigned CKP                    :1;
        unsigned SSPEN                  :1;
        unsigned SSPOV                  :1;
        unsigned WCOL                   :1;
    };
    struct {
        unsigned SSPM0                  :1;
        unsigned SSPM1                  :1;
        unsigned SSPM2                  :1;
        unsigned SSPM3                  :1;
    };
} SSPCON1bits_t;
extern volatile SSPCON1bits_t SSPCON1bits @ 0x215;
// bitfield macros
#define _SSPCON1_SSPM_POSN                                  0x0
#define _SSPCON1_SSPM_POSITION                              0x0
#define _SSPCON1_SSPM_SIZE                                  0x4
#define _SSPCON1_SSPM_LENGTH                                0x4
#define _SSPCON1_SSPM_MASK                                  0xF
#define _SSPCON1_CKP_POSN                                   0x4
#define _SSPCON1_CKP_POSITION                               0x4
#define _SSPCON1_CKP_SIZE                                   0x1
#define _SSPCON1_CKP_LENGTH                                 0x1
#define _SSPCON1_CKP_MASK                                   0x10
#define _SSPCON1_SSPEN_POSN                                 0x5
#define _SSPCON1_SSPEN_POSITION                             0x5
#define _SSPCON1_SSPEN_SIZE                                 0x1
#define _SSPCON1_SSPEN_LENGTH                               0x1
#define _SSPCON1_SSPEN_MASK                                 0x20
#define _SSPCON1_SSPOV_POSN                                 0x6
#define _SSPCON1_SSPOV_POSITION                             0x6
#define _SSPCON1_SSPOV_SIZE                                 0x1
#define _SSPCON1_SSPOV_LENGTH                               0x1
#define _SSPCON1_SSPOV_MASK                                 0x40
#define _SSPCON1_WCOL_POSN                                  0x7
#define _SSPCON1_WCOL_POSITION                              0x7
#define _SSPCON1_WCOL_SIZE                                  0x1
#define _SSPCON1_WCOL_LENGTH                                0x1
#define _SSPCON1_WCOL_MASK                                  0x80
#define _SSPCON1_SSPM0_POSN                                 0x0
#define _SSPCON1_SSPM0_POSITION                             0x0
#define _SSPCON1_SSPM0_SIZE                                 0x1
#define _SSPCON1_SSPM0_LENGTH                               0x1
#define _SSPCON1_SSPM0_MASK                                 0x1
#define _SSPCON1_SSPM1_POSN                                 0x1
#define _SSPCON1_SSPM1_POSITION                             0x1
#define _SSPCON1_SSPM1_SIZE                                 0x1
#define _SSPCON1_SSPM1_LENGTH                               0x1
#define _SSPCON1_SSPM1_MASK                                 0x2
#define _SSPCON1_SSPM2_POSN                                 0x2
#define _SSPCON1_SSPM2_POSITION                             0x2
#define _SSPCON1_SSPM2_SIZE                                 0x1
#define _SSPCON1_SSPM2_LENGTH                               0x1
#define _SSPCON1_SSPM2_MASK                                 0x4
#define _SSPCON1_SSPM3_POSN                                 0x3
#define _SSPCON1_SSPM3_POSITION                             0x3
#define _SSPCON1_SSPM3_SIZE                                 0x1
#define _SSPCON1_SSPM3_LENGTH                               0x1
#define _SSPCON1_SSPM3_MASK                                 0x8
typedef union {
    struct {
        unsigned SSPM                   :4;
        unsigned CKP                    :1;
        unsigned SSPEN                  :1;
        unsigned SSPOV                  :1;
        unsigned WCOL                   :1;
    };
    struct {
        unsigned SSPM0                  :1;
        unsigned SSPM1                  :1;
        unsigned SSPM2                  :1;
        unsigned SSPM3                  :1;
    };
} SSP1CONbits_t;
extern volatile SSP1CONbits_t SSP1CONbits @ 0x215;
// bitfield macros
#define _SSP1CON_SSPM_POSN                                  0x0
#define _SSP1CON_SSPM_POSITION                              0x0
#define _SSP1CON_SSPM_SIZE                                  0x4
#define _SSP1CON_SSPM_LENGTH                                0x4
#define _SSP1CON_SSPM_MASK                                  0xF
#define _SSP1CON_CKP_POSN                                   0x4
#define _SSP1CON_CKP_POSITION                               0x4
#define _SSP1CON_CKP_SIZE                                   0x1
#define _SSP1CON_CKP_LENGTH                                 0x1
#define _SSP1CON_CKP_MASK                                   0x10
#define _SSP1CON_SSPEN_POSN                                 0x5
#define _SSP1CON_SSPEN_POSITION                             0x5
#define _SSP1CON_SSPEN_SIZE                                 0x1
#define _SSP1CON_SSPEN_LENGTH                               0x1
#define _SSP1CON_SSPEN_MASK                                 0x20
#define _SSP1CON_SSPOV_POSN                                 0x6
#define _SSP1CON_SSPOV_POSITION                             0x6
#define _SSP1CON_SSPOV_SIZE                                 0x1
#define _SSP1CON_SSPOV_LENGTH                               0x1
#define _SSP1CON_SSPOV_MASK                                 0x40
#define _SSP1CON_WCOL_POSN                                  0x7
#define _SSP1CON_WCOL_POSITION                              0x7
#define _SSP1CON_WCOL_SIZE                                  0x1
#define _SSP1CON_WCOL_LENGTH                                0x1
#define _SSP1CON_WCOL_MASK                                  0x80
#define _SSP1CON_SSPM0_POSN                                 0x0
#define _SSP1CON_SSPM0_POSITION                             0x0
#define _SSP1CON_SSPM0_SIZE                                 0x1
#define _SSP1CON_SSPM0_LENGTH                               0x1
#define _SSP1CON_SSPM0_MASK                                 0x1
#define _SSP1CON_SSPM1_POSN                                 0x1
#define _SSP1CON_SSPM1_POSITION                             0x1
#define _SSP1CON_SSPM1_SIZE                                 0x1
#define _SSP1CON_SSPM1_LENGTH                               0x1
#define _SSP1CON_SSPM1_MASK                                 0x2
#define _SSP1CON_SSPM2_POSN                                 0x2
#define _SSP1CON_SSPM2_POSITION                             0x2
#define _SSP1CON_SSPM2_SIZE                                 0x1
#define _SSP1CON_SSPM2_LENGTH                               0x1
#define _SSP1CON_SSPM2_MASK                                 0x4
#define _SSP1CON_SSPM3_POSN                                 0x3
#define _SSP1CON_SSPM3_POSITION                             0x3
#define _SSP1CON_SSPM3_SIZE                                 0x1
#define _SSP1CON_SSPM3_LENGTH                               0x1
#define _SSP1CON_SSPM3_MASK                                 0x8

// Register: SSP1CON2
extern volatile unsigned char           SSP1CON2            @ 0x216;
#ifndef _LIB_BUILD
asm("SSP1CON2 equ 0216h");
#endif
// aliases
extern volatile unsigned char           SSPCON2             @ 0x216;
#ifndef _LIB_BUILD
asm("SSPCON2 equ 0216h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SEN                    :1;
        unsigned RSEN                   :1;
        unsigned PEN                    :1;
        unsigned RCEN                   :1;
        unsigned ACKEN                  :1;
        unsigned ACKDT                  :1;
        unsigned ACKSTAT                :1;
        unsigned GCEN                   :1;
    };
} SSP1CON2bits_t;
extern volatile SSP1CON2bits_t SSP1CON2bits @ 0x216;
// bitfield macros
#define _SSP1CON2_SEN_POSN                                  0x0
#define _SSP1CON2_SEN_POSITION                              0x0
#define _SSP1CON2_SEN_SIZE                                  0x1
#define _SSP1CON2_SEN_LENGTH                                0x1
#define _SSP1CON2_SEN_MASK                                  0x1
#define _SSP1CON2_RSEN_POSN                                 0x1
#define _SSP1CON2_RSEN_POSITION                             0x1
#define _SSP1CON2_RSEN_SIZE                                 0x1
#define _SSP1CON2_RSEN_LENGTH                               0x1
#define _SSP1CON2_RSEN_MASK                                 0x2
#define _SSP1CON2_PEN_POSN                                  0x2
#define _SSP1CON2_PEN_POSITION                              0x2
#define _SSP1CON2_PEN_SIZE                                  0x1
#define _SSP1CON2_PEN_LENGTH                                0x1
#define _SSP1CON2_PEN_MASK                                  0x4
#define _SSP1CON2_RCEN_POSN                                 0x3
#define _SSP1CON2_RCEN_POSITION                             0x3
#define _SSP1CON2_RCEN_SIZE                                 0x1
#define _SSP1CON2_RCEN_LENGTH                               0x1
#define _SSP1CON2_RCEN_MASK                                 0x8
#define _SSP1CON2_ACKEN_POSN                                0x4
#define _SSP1CON2_ACKEN_POSITION                            0x4
#define _SSP1CON2_ACKEN_SIZE                                0x1
#define _SSP1CON2_ACKEN_LENGTH                              0x1
#define _SSP1CON2_ACKEN_MASK                                0x10
#define _SSP1CON2_ACKDT_POSN                                0x5
#define _SSP1CON2_ACKDT_POSITION                            0x5
#define _SSP1CON2_ACKDT_SIZE                                0x1
#define _SSP1CON2_ACKDT_LENGTH                              0x1
#define _SSP1CON2_ACKDT_MASK                                0x20
#define _SSP1CON2_ACKSTAT_POSN                              0x6
#define _SSP1CON2_ACKSTAT_POSITION                          0x6
#define _SSP1CON2_ACKSTAT_SIZE                              0x1
#define _SSP1CON2_ACKSTAT_LENGTH                            0x1
#define _SSP1CON2_ACKSTAT_MASK                              0x40
#define _SSP1CON2_GCEN_POSN                                 0x7
#define _SSP1CON2_GCEN_POSITION                             0x7
#define _SSP1CON2_GCEN_SIZE                                 0x1
#define _SSP1CON2_GCEN_LENGTH                               0x1
#define _SSP1CON2_GCEN_MASK                                 0x80
// alias bitfield definitions
typedef union {
    struct {
        unsigned SEN                    :1;
        unsigned RSEN                   :1;
        unsigned PEN                    :1;
        unsigned RCEN                   :1;
        unsigned ACKEN                  :1;
        unsigned ACKDT                  :1;
        unsigned ACKSTAT                :1;
        unsigned GCEN                   :1;
    };
} SSPCON2bits_t;
extern volatile SSPCON2bits_t SSPCON2bits @ 0x216;
// bitfield macros
#define _SSPCON2_SEN_POSN                                   0x0
#define _SSPCON2_SEN_POSITION                               0x0
#define _SSPCON2_SEN_SIZE                                   0x1
#define _SSPCON2_SEN_LENGTH                                 0x1
#define _SSPCON2_SEN_MASK                                   0x1
#define _SSPCON2_RSEN_POSN                                  0x1
#define _SSPCON2_RSEN_POSITION                              0x1
#define _SSPCON2_RSEN_SIZE                                  0x1
#define _SSPCON2_RSEN_LENGTH                                0x1
#define _SSPCON2_RSEN_MASK                                  0x2
#define _SSPCON2_PEN_POSN                                   0x2
#define _SSPCON2_PEN_POSITION                               0x2
#define _SSPCON2_PEN_SIZE                                   0x1
#define _SSPCON2_PEN_LENGTH                                 0x1
#define _SSPCON2_PEN_MASK                                   0x4
#define _SSPCON2_RCEN_POSN                                  0x3
#define _SSPCON2_RCEN_POSITION                              0x3
#define _SSPCON2_RCEN_SIZE                                  0x1
#define _SSPCON2_RCEN_LENGTH                                0x1
#define _SSPCON2_RCEN_MASK                                  0x8
#define _SSPCON2_ACKEN_POSN                                 0x4
#define _SSPCON2_ACKEN_POSITION                             0x4
#define _SSPCON2_ACKEN_SIZE                                 0x1
#define _SSPCON2_ACKEN_LENGTH                               0x1
#define _SSPCON2_ACKEN_MASK                                 0x10
#define _SSPCON2_ACKDT_POSN                                 0x5
#define _SSPCON2_ACKDT_POSITION                             0x5
#define _SSPCON2_ACKDT_SIZE                                 0x1
#define _SSPCON2_ACKDT_LENGTH                               0x1
#define _SSPCON2_ACKDT_MASK                                 0x20
#define _SSPCON2_ACKSTAT_POSN                               0x6
#define _SSPCON2_ACKSTAT_POSITION                           0x6
#define _SSPCON2_ACKSTAT_SIZE                               0x1
#define _SSPCON2_ACKSTAT_LENGTH                             0x1
#define _SSPCON2_ACKSTAT_MASK                               0x40
#define _SSPCON2_GCEN_POSN                                  0x7
#define _SSPCON2_GCEN_POSITION                              0x7
#define _SSPCON2_GCEN_SIZE                                  0x1
#define _SSPCON2_GCEN_LENGTH                                0x1
#define _SSPCON2_GCEN_MASK                                  0x80

// Register: SSP1CON3
extern volatile unsigned char           SSP1CON3            @ 0x217;
#ifndef _LIB_BUILD
asm("SSP1CON3 equ 0217h");
#endif
// aliases
extern volatile unsigned char           SSPCON3             @ 0x217;
#ifndef _LIB_BUILD
asm("SSPCON3 equ 0217h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned DHEN                   :1;
        unsigned AHEN                   :1;
        unsigned SBCDE                  :1;
        unsigned SDAHT                  :1;
        unsigned BOEN                   :1;
        unsigned SCIE                   :1;
        unsigned PCIE                   :1;
        unsigned ACKTIM                 :1;
    };
} SSP1CON3bits_t;
extern volatile SSP1CON3bits_t SSP1CON3bits @ 0x217;
// bitfield macros
#define _SSP1CON3_DHEN_POSN                                 0x0
#define _SSP1CON3_DHEN_POSITION                             0x0
#define _SSP1CON3_DHEN_SIZE                                 0x1
#define _SSP1CON3_DHEN_LENGTH                               0x1
#define _SSP1CON3_DHEN_MASK                                 0x1
#define _SSP1CON3_AHEN_POSN                                 0x1
#define _SSP1CON3_AHEN_POSITION                             0x1
#define _SSP1CON3_AHEN_SIZE                                 0x1
#define _SSP1CON3_AHEN_LENGTH                               0x1
#define _SSP1CON3_AHEN_MASK                                 0x2
#define _SSP1CON3_SBCDE_POSN                                0x2
#define _SSP1CON3_SBCDE_POSITION                            0x2
#define _SSP1CON3_SBCDE_SIZE                                0x1
#define _SSP1CON3_SBCDE_LENGTH                              0x1
#define _SSP1CON3_SBCDE_MASK                                0x4
#define _SSP1CON3_SDAHT_POSN                                0x3
#define _SSP1CON3_SDAHT_POSITION                            0x3
#define _SSP1CON3_SDAHT_SIZE                                0x1
#define _SSP1CON3_SDAHT_LENGTH                              0x1
#define _SSP1CON3_SDAHT_MASK                                0x8
#define _SSP1CON3_BOEN_POSN                                 0x4
#define _SSP1CON3_BOEN_POSITION                             0x4
#define _SSP1CON3_BOEN_SIZE                                 0x1
#define _SSP1CON3_BOEN_LENGTH                               0x1
#define _SSP1CON3_BOEN_MASK                                 0x10
#define _SSP1CON3_SCIE_POSN                                 0x5
#define _SSP1CON3_SCIE_POSITION                             0x5
#define _SSP1CON3_SCIE_SIZE                                 0x1
#define _SSP1CON3_SCIE_LENGTH                               0x1
#define _SSP1CON3_SCIE_MASK                                 0x20
#define _SSP1CON3_PCIE_POSN                                 0x6
#define _SSP1CON3_PCIE_POSITION                             0x6
#define _SSP1CON3_PCIE_SIZE                                 0x1
#define _SSP1CON3_PCIE_LENGTH                               0x1
#define _SSP1CON3_PCIE_MASK                                 0x40
#define _SSP1CON3_ACKTIM_POSN                               0x7
#define _SSP1CON3_ACKTIM_POSITION                           0x7
#define _SSP1CON3_ACKTIM_SIZE                               0x1
#define _SSP1CON3_ACKTIM_LENGTH                             0x1
#define _SSP1CON3_ACKTIM_MASK                               0x80
// alias bitfield definitions
typedef union {
    struct {
        unsigned DHEN                   :1;
        unsigned AHEN                   :1;
        unsigned SBCDE                  :1;
        unsigned SDAHT                  :1;
        unsigned BOEN                   :1;
        unsigned SCIE                   :1;
        unsigned PCIE                   :1;
        unsigned ACKTIM                 :1;
    };
} SSPCON3bits_t;
extern volatile SSPCON3bits_t SSPCON3bits @ 0x217;
// bitfield macros
#define _SSPCON3_DHEN_POSN                                  0x0
#define _SSPCON3_DHEN_POSITION                              0x0
#define _SSPCON3_DHEN_SIZE                                  0x1
#define _SSPCON3_DHEN_LENGTH                                0x1
#define _SSPCON3_DHEN_MASK                                  0x1
#define _SSPCON3_AHEN_POSN                                  0x1
#define _SSPCON3_AHEN_POSITION                              0x1
#define _SSPCON3_AHEN_SIZE                                  0x1
#define _SSPCON3_AHEN_LENGTH                                0x1
#define _SSPCON3_AHEN_MASK                                  0x2
#define _SSPCON3_SBCDE_POSN                                 0x2
#define _SSPCON3_SBCDE_POSITION                             0x2
#define _SSPCON3_SBCDE_SIZE                                 0x1
#define _SSPCON3_SBCDE_LENGTH                               0x1
#define _SSPCON3_SBCDE_MASK                                 0x4
#define _SSPCON3_SDAHT_POSN                                 0x3
#define _SSPCON3_SDAHT_POSITION                             0x3
#define _SSPCON3_SDAHT_SIZE                                 0x1
#define _SSPCON3_SDAHT_LENGTH                               0x1
#define _SSPCON3_SDAHT_MASK                                 0x8
#define _SSPCON3_BOEN_POSN                                  0x4
#define _SSPCON3_BOEN_POSITION                              0x4
#define _SSPCON3_BOEN_SIZE                                  0x1
#define _SSPCON3_BOEN_LENGTH                                0x1
#define _SSPCON3_BOEN_MASK                                  0x10
#define _SSPCON3_SCIE_POSN                                  0x5
#define _SSPCON3_SCIE_POSITION                              0x5
#define _SSPCON3_SCIE_SIZE                                  0x1
#define _SSPCON3_SCIE_LENGTH                                0x1
#define _SSPCON3_SCIE_MASK                                  0x20
#define _SSPCON3_PCIE_POSN                                  0x6
#define _SSPCON3_PCIE_POSITION                              0x6
#define _SSPCON3_PCIE_SIZE                                  0x1
#define _SSPCON3_PCIE_LENGTH                                0x1
#define _SSPCON3_PCIE_MASK                                  0x40
#define _SSPCON3_ACKTIM_POSN                                0x7
#define _SSPCON3_ACKTIM_POSITION                            0x7
#define _SSPCON3_ACKTIM_SIZE                                0x1
#define _SSPCON3_ACKTIM_LENGTH                              0x1
#define _SSPCON3_ACKTIM_MASK                                0x80

// Register: ODCONA
extern volatile unsigned char           ODCONA              @ 0x28C;
#ifndef _LIB_BUILD
asm("ODCONA equ 028Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ODA0                   :1;
        unsigned ODA1                   :1;
        unsigned ODA2                   :1;
        unsigned                        :1;
        unsigned ODA4                   :1;
        unsigned ODA5                   :1;
    };
} ODCONAbits_t;
extern volatile ODCONAbits_t ODCONAbits @ 0x28C;
// bitfield macros
#define _ODCONA_ODA0_POSN                                   0x0
#define _ODCONA_ODA0_POSITION                               0x0
#define _ODCONA_ODA0_SIZE                                   0x1
#define _ODCONA_ODA0_LENGTH                                 0x1
#define _ODCONA_ODA0_MASK                                   0x1
#define _ODCONA_ODA1_POSN                                   0x1
#define _ODCONA_ODA1_POSITION                               0x1
#define _ODCONA_ODA1_SIZE                                   0x1
#define _ODCONA_ODA1_LENGTH                                 0x1
#define _ODCONA_ODA1_MASK                                   0x2
#define _ODCONA_ODA2_POSN                                   0x2
#define _ODCONA_ODA2_POSITION                               0x2
#define _ODCONA_ODA2_SIZE                                   0x1
#define _ODCONA_ODA2_LENGTH                                 0x1
#define _ODCONA_ODA2_MASK                                   0x4
#define _ODCONA_ODA4_POSN                                   0x4
#define _ODCONA_ODA4_POSITION                               0x4
#define _ODCONA_ODA4_SIZE                                   0x1
#define _ODCONA_ODA4_LENGTH                                 0x1
#define _ODCONA_ODA4_MASK                                   0x10
#define _ODCONA_ODA5_POSN                                   0x5
#define _ODCONA_ODA5_POSITION                               0x5
#define _ODCONA_ODA5_SIZE                                   0x1
#define _ODCONA_ODA5_LENGTH                                 0x1
#define _ODCONA_ODA5_MASK                                   0x20

// Register: ODCONB
extern volatile unsigned char           ODCONB              @ 0x28D;
#ifndef _LIB_BUILD
asm("ODCONB equ 028Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned ODB4                   :1;
        unsigned ODB5                   :1;
        unsigned ODB6                   :1;
        unsigned ODB7                   :1;
    };
} ODCONBbits_t;
extern volatile ODCONBbits_t ODCONBbits @ 0x28D;
// bitfield macros
#define _ODCONB_ODB4_POSN                                   0x4
#define _ODCONB_ODB4_POSITION                               0x4
#define _ODCONB_ODB4_SIZE                                   0x1
#define _ODCONB_ODB4_LENGTH                                 0x1
#define _ODCONB_ODB4_MASK                                   0x10
#define _ODCONB_ODB5_POSN                                   0x5
#define _ODCONB_ODB5_POSITION                               0x5
#define _ODCONB_ODB5_SIZE                                   0x1
#define _ODCONB_ODB5_LENGTH                                 0x1
#define _ODCONB_ODB5_MASK                                   0x20
#define _ODCONB_ODB6_POSN                                   0x6
#define _ODCONB_ODB6_POSITION                               0x6
#define _ODCONB_ODB6_SIZE                                   0x1
#define _ODCONB_ODB6_LENGTH                                 0x1
#define _ODCONB_ODB6_MASK                                   0x40
#define _ODCONB_ODB7_POSN                                   0x7
#define _ODCONB_ODB7_POSITION                               0x7
#define _ODCONB_ODB7_SIZE                                   0x1
#define _ODCONB_ODB7_LENGTH                                 0x1
#define _ODCONB_ODB7_MASK                                   0x80

// Register: ODCONC
extern volatile unsigned char           ODCONC              @ 0x28E;
#ifndef _LIB_BUILD
asm("ODCONC equ 028Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ODC0                   :1;
        unsigned ODC1                   :1;
        unsigned ODC2                   :1;
        unsigned ODC3                   :1;
        unsigned ODC4                   :1;
        unsigned ODC5                   :1;
        unsigned ODC6                   :1;
        unsigned ODC7                   :1;
    };
} ODCONCbits_t;
extern volatile ODCONCbits_t ODCONCbits @ 0x28E;
// bitfield macros
#define _ODCONC_ODC0_POSN                                   0x0
#define _ODCONC_ODC0_POSITION                               0x0
#define _ODCONC_ODC0_SIZE                                   0x1
#define _ODCONC_ODC0_LENGTH                                 0x1
#define _ODCONC_ODC0_MASK                                   0x1
#define _ODCONC_ODC1_POSN                                   0x1
#define _ODCONC_ODC1_POSITION                               0x1
#define _ODCONC_ODC1_SIZE                                   0x1
#define _ODCONC_ODC1_LENGTH                                 0x1
#define _ODCONC_ODC1_MASK                                   0x2
#define _ODCONC_ODC2_POSN                                   0x2
#define _ODCONC_ODC2_POSITION                               0x2
#define _ODCONC_ODC2_SIZE                                   0x1
#define _ODCONC_ODC2_LENGTH                                 0x1
#define _ODCONC_ODC2_MASK                                   0x4
#define _ODCONC_ODC3_POSN                                   0x3
#define _ODCONC_ODC3_POSITION                               0x3
#define _ODCONC_ODC3_SIZE                                   0x1
#define _ODCONC_ODC3_LENGTH                                 0x1
#define _ODCONC_ODC3_MASK                                   0x8
#define _ODCONC_ODC4_POSN                                   0x4
#define _ODCONC_ODC4_POSITION                               0x4
#define _ODCONC_ODC4_SIZE                                   0x1
#define _ODCONC_ODC4_LENGTH                                 0x1
#define _ODCONC_ODC4_MASK                                   0x10
#define _ODCONC_ODC5_POSN                                   0x5
#define _ODCONC_ODC5_POSITION                               0x5
#define _ODCONC_ODC5_SIZE                                   0x1
#define _ODCONC_ODC5_LENGTH                                 0x1
#define _ODCONC_ODC5_MASK                                   0x20
#define _ODCONC_ODC6_POSN                                   0x6
#define _ODCONC_ODC6_POSITION                               0x6
#define _ODCONC_ODC6_SIZE                                   0x1
#define _ODCONC_ODC6_LENGTH                                 0x1
#define _ODCONC_ODC6_MASK                                   0x40
#define _ODCONC_ODC7_POSN                                   0x7
#define _ODCONC_ODC7_POSITION                               0x7
#define _ODCONC_ODC7_SIZE                                   0x1
#define _ODCONC_ODC7_LENGTH                                 0x1
#define _ODCONC_ODC7_MASK                                   0x80

// Register: CCPR1
extern volatile unsigned short          CCPR1               @ 0x291;
#ifndef _LIB_BUILD
asm("CCPR1 equ 0291h");
#endif

// Register: CCPR1L
extern volatile unsigned char           CCPR1L              @ 0x291;
#ifndef _LIB_BUILD
asm("CCPR1L equ 0291h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RL                     :8;
    };
} CCPR1Lbits_t;
extern volatile CCPR1Lbits_t CCPR1Lbits @ 0x291;
// bitfield macros
#define _CCPR1L_RL_POSN                                     0x0
#define _CCPR1L_RL_POSITION                                 0x0
#define _CCPR1L_RL_SIZE                                     0x8
#define _CCPR1L_RL_LENGTH                                   0x8
#define _CCPR1L_RL_MASK                                     0xFF

// Register: CCPR1H
extern volatile unsigned char           CCPR1H              @ 0x292;
#ifndef _LIB_BUILD
asm("CCPR1H equ 0292h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RH                     :8;
    };
} CCPR1Hbits_t;
extern volatile CCPR1Hbits_t CCPR1Hbits @ 0x292;
// bitfield macros
#define _CCPR1H_RH_POSN                                     0x0
#define _CCPR1H_RH_POSITION                                 0x0
#define _CCPR1H_RH_SIZE                                     0x8
#define _CCPR1H_RH_LENGTH                                   0x8
#define _CCPR1H_RH_MASK                                     0xFF

// Register: CCP1CON
extern volatile unsigned char           CCP1CON             @ 0x293;
#ifndef _LIB_BUILD
asm("CCP1CON equ 0293h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned MODE                   :4;
        unsigned FMT                    :1;
        unsigned OUT                    :1;
        unsigned                        :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
        unsigned MODE3                  :1;
    };
    struct {
        unsigned CCP1MODE               :4;
        unsigned CCP1FMT                :1;
        unsigned CCP1OUT                :1;
        unsigned                        :1;
        unsigned CCP1EN                 :1;
    };
    struct {
        unsigned CCP1MODE0              :1;
        unsigned CCP1MODE1              :1;
        unsigned CCP1MODE2              :1;
        unsigned CCP1MODE3              :1;
    };
} CCP1CONbits_t;
extern volatile CCP1CONbits_t CCP1CONbits @ 0x293;
// bitfield macros
#define _CCP1CON_MODE_POSN                                  0x0
#define _CCP1CON_MODE_POSITION                              0x0
#define _CCP1CON_MODE_SIZE                                  0x4
#define _CCP1CON_MODE_LENGTH                                0x4
#define _CCP1CON_MODE_MASK                                  0xF
#define _CCP1CON_FMT_POSN                                   0x4
#define _CCP1CON_FMT_POSITION                               0x4
#define _CCP1CON_FMT_SIZE                                   0x1
#define _CCP1CON_FMT_LENGTH                                 0x1
#define _CCP1CON_FMT_MASK                                   0x10
#define _CCP1CON_OUT_POSN                                   0x5
#define _CCP1CON_OUT_POSITION                               0x5
#define _CCP1CON_OUT_SIZE                                   0x1
#define _CCP1CON_OUT_LENGTH                                 0x1
#define _CCP1CON_OUT_MASK                                   0x20
#define _CCP1CON_EN_POSN                                    0x7
#define _CCP1CON_EN_POSITION                                0x7
#define _CCP1CON_EN_SIZE                                    0x1
#define _CCP1CON_EN_LENGTH                                  0x1
#define _CCP1CON_EN_MASK                                    0x80
#define _CCP1CON_MODE0_POSN                                 0x0
#define _CCP1CON_MODE0_POSITION                             0x0
#define _CCP1CON_MODE0_SIZE                                 0x1
#define _CCP1CON_MODE0_LENGTH                               0x1
#define _CCP1CON_MODE0_MASK                                 0x1
#define _CCP1CON_MODE1_POSN                                 0x1
#define _CCP1CON_MODE1_POSITION                             0x1
#define _CCP1CON_MODE1_SIZE                                 0x1
#define _CCP1CON_MODE1_LENGTH                               0x1
#define _CCP1CON_MODE1_MASK                                 0x2
#define _CCP1CON_MODE2_POSN                                 0x2
#define _CCP1CON_MODE2_POSITION                             0x2
#define _CCP1CON_MODE2_SIZE                                 0x1
#define _CCP1CON_MODE2_LENGTH                               0x1
#define _CCP1CON_MODE2_MASK                                 0x4
#define _CCP1CON_MODE3_POSN                                 0x3
#define _CCP1CON_MODE3_POSITION                             0x3
#define _CCP1CON_MODE3_SIZE                                 0x1
#define _CCP1CON_MODE3_LENGTH                               0x1
#define _CCP1CON_MODE3_MASK                                 0x8
#define _CCP1CON_CCP1MODE_POSN                              0x0
#define _CCP1CON_CCP1MODE_POSITION                          0x0
#define _CCP1CON_CCP1MODE_SIZE                              0x4
#define _CCP1CON_CCP1MODE_LENGTH                            0x4
#define _CCP1CON_CCP1MODE_MASK                              0xF
#define _CCP1CON_CCP1FMT_POSN                               0x4
#define _CCP1CON_CCP1FMT_POSITION                           0x4
#define _CCP1CON_CCP1FMT_SIZE                               0x1
#define _CCP1CON_CCP1FMT_LENGTH                             0x1
#define _CCP1CON_CCP1FMT_MASK                               0x10
#define _CCP1CON_CCP1OUT_POSN                               0x5
#define _CCP1CON_CCP1OUT_POSITION                           0x5
#define _CCP1CON_CCP1OUT_SIZE                               0x1
#define _CCP1CON_CCP1OUT_LENGTH                             0x1
#define _CCP1CON_CCP1OUT_MASK                               0x20
#define _CCP1CON_CCP1EN_POSN                                0x7
#define _CCP1CON_CCP1EN_POSITION                            0x7
#define _CCP1CON_CCP1EN_SIZE                                0x1
#define _CCP1CON_CCP1EN_LENGTH                              0x1
#define _CCP1CON_CCP1EN_MASK                                0x80
#define _CCP1CON_CCP1MODE0_POSN                             0x0
#define _CCP1CON_CCP1MODE0_POSITION                         0x0
#define _CCP1CON_CCP1MODE0_SIZE                             0x1
#define _CCP1CON_CCP1MODE0_LENGTH                           0x1
#define _CCP1CON_CCP1MODE0_MASK                             0x1
#define _CCP1CON_CCP1MODE1_POSN                             0x1
#define _CCP1CON_CCP1MODE1_POSITION                         0x1
#define _CCP1CON_CCP1MODE1_SIZE                             0x1
#define _CCP1CON_CCP1MODE1_LENGTH                           0x1
#define _CCP1CON_CCP1MODE1_MASK                             0x2
#define _CCP1CON_CCP1MODE2_POSN                             0x2
#define _CCP1CON_CCP1MODE2_POSITION                         0x2
#define _CCP1CON_CCP1MODE2_SIZE                             0x1
#define _CCP1CON_CCP1MODE2_LENGTH                           0x1
#define _CCP1CON_CCP1MODE2_MASK                             0x4
#define _CCP1CON_CCP1MODE3_POSN                             0x3
#define _CCP1CON_CCP1MODE3_POSITION                         0x3
#define _CCP1CON_CCP1MODE3_SIZE                             0x1
#define _CCP1CON_CCP1MODE3_LENGTH                           0x1
#define _CCP1CON_CCP1MODE3_MASK                             0x8

// Register: CCP1CAP
extern volatile unsigned char           CCP1CAP             @ 0x294;
#ifndef _LIB_BUILD
asm("CCP1CAP equ 0294h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CTS                    :8;
    };
    struct {
        unsigned CTS0                   :1;
        unsigned CTS1                   :1;
        unsigned CTS2                   :1;
    };
    struct {
        unsigned CCP1CTS                :8;
    };
    struct {
        unsigned CCP1CTS0               :1;
        unsigned CCP1CTS1               :1;
        unsigned CCP1CTS2               :1;
    };
} CCP1CAPbits_t;
extern volatile CCP1CAPbits_t CCP1CAPbits @ 0x294;
// bitfield macros
#define _CCP1CAP_CTS_POSN                                   0x0
#define _CCP1CAP_CTS_POSITION                               0x0
#define _CCP1CAP_CTS_SIZE                                   0x8
#define _CCP1CAP_CTS_LENGTH                                 0x8
#define _CCP1CAP_CTS_MASK                                   0xFF
#define _CCP1CAP_CTS0_POSN                                  0x0
#define _CCP1CAP_CTS0_POSITION                              0x0
#define _CCP1CAP_CTS0_SIZE                                  0x1
#define _CCP1CAP_CTS0_LENGTH                                0x1
#define _CCP1CAP_CTS0_MASK                                  0x1
#define _CCP1CAP_CTS1_POSN                                  0x1
#define _CCP1CAP_CTS1_POSITION                              0x1
#define _CCP1CAP_CTS1_SIZE                                  0x1
#define _CCP1CAP_CTS1_LENGTH                                0x1
#define _CCP1CAP_CTS1_MASK                                  0x2
#define _CCP1CAP_CTS2_POSN                                  0x2
#define _CCP1CAP_CTS2_POSITION                              0x2
#define _CCP1CAP_CTS2_SIZE                                  0x1
#define _CCP1CAP_CTS2_LENGTH                                0x1
#define _CCP1CAP_CTS2_MASK                                  0x4
#define _CCP1CAP_CCP1CTS_POSN                               0x0
#define _CCP1CAP_CCP1CTS_POSITION                           0x0
#define _CCP1CAP_CCP1CTS_SIZE                               0x8
#define _CCP1CAP_CCP1CTS_LENGTH                             0x8
#define _CCP1CAP_CCP1CTS_MASK                               0xFF
#define _CCP1CAP_CCP1CTS0_POSN                              0x0
#define _CCP1CAP_CCP1CTS0_POSITION                          0x0
#define _CCP1CAP_CCP1CTS0_SIZE                              0x1
#define _CCP1CAP_CCP1CTS0_LENGTH                            0x1
#define _CCP1CAP_CCP1CTS0_MASK                              0x1
#define _CCP1CAP_CCP1CTS1_POSN                              0x1
#define _CCP1CAP_CCP1CTS1_POSITION                          0x1
#define _CCP1CAP_CCP1CTS1_SIZE                              0x1
#define _CCP1CAP_CCP1CTS1_LENGTH                            0x1
#define _CCP1CAP_CCP1CTS1_MASK                              0x2
#define _CCP1CAP_CCP1CTS2_POSN                              0x2
#define _CCP1CAP_CCP1CTS2_POSITION                          0x2
#define _CCP1CAP_CCP1CTS2_SIZE                              0x1
#define _CCP1CAP_CCP1CTS2_LENGTH                            0x1
#define _CCP1CAP_CCP1CTS2_MASK                              0x4

// Register: CCPR2
extern volatile unsigned short          CCPR2               @ 0x298;
#ifndef _LIB_BUILD
asm("CCPR2 equ 0298h");
#endif

// Register: CCPR2L
extern volatile unsigned char           CCPR2L              @ 0x298;
#ifndef _LIB_BUILD
asm("CCPR2L equ 0298h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RL                     :8;
    };
} CCPR2Lbits_t;
extern volatile CCPR2Lbits_t CCPR2Lbits @ 0x298;
// bitfield macros
#define _CCPR2L_RL_POSN                                     0x0
#define _CCPR2L_RL_POSITION                                 0x0
#define _CCPR2L_RL_SIZE                                     0x8
#define _CCPR2L_RL_LENGTH                                   0x8
#define _CCPR2L_RL_MASK                                     0xFF

// Register: CCPR2H
extern volatile unsigned char           CCPR2H              @ 0x299;
#ifndef _LIB_BUILD
asm("CCPR2H equ 0299h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RH                     :8;
    };
} CCPR2Hbits_t;
extern volatile CCPR2Hbits_t CCPR2Hbits @ 0x299;
// bitfield macros
#define _CCPR2H_RH_POSN                                     0x0
#define _CCPR2H_RH_POSITION                                 0x0
#define _CCPR2H_RH_SIZE                                     0x8
#define _CCPR2H_RH_LENGTH                                   0x8
#define _CCPR2H_RH_MASK                                     0xFF

// Register: CCP2CON
extern volatile unsigned char           CCP2CON             @ 0x29A;
#ifndef _LIB_BUILD
asm("CCP2CON equ 029Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned MODE                   :4;
        unsigned FMT                    :1;
        unsigned OUT                    :1;
        unsigned                        :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
        unsigned MODE3                  :1;
    };
    struct {
        unsigned CCP2MODE               :4;
        unsigned CCP2FMT                :1;
        unsigned CCP2OUT                :1;
        unsigned                        :1;
        unsigned CCP2EN                 :1;
    };
    struct {
        unsigned CCP2MODE0              :1;
        unsigned CCP2MODE1              :1;
        unsigned CCP2MODE2              :1;
        unsigned CCP2MODE3              :1;
    };
} CCP2CONbits_t;
extern volatile CCP2CONbits_t CCP2CONbits @ 0x29A;
// bitfield macros
#define _CCP2CON_MODE_POSN                                  0x0
#define _CCP2CON_MODE_POSITION                              0x0
#define _CCP2CON_MODE_SIZE                                  0x4
#define _CCP2CON_MODE_LENGTH                                0x4
#define _CCP2CON_MODE_MASK                                  0xF
#define _CCP2CON_FMT_POSN                                   0x4
#define _CCP2CON_FMT_POSITION                               0x4
#define _CCP2CON_FMT_SIZE                                   0x1
#define _CCP2CON_FMT_LENGTH                                 0x1
#define _CCP2CON_FMT_MASK                                   0x10
#define _CCP2CON_OUT_POSN                                   0x5
#define _CCP2CON_OUT_POSITION                               0x5
#define _CCP2CON_OUT_SIZE                                   0x1
#define _CCP2CON_OUT_LENGTH                                 0x1
#define _CCP2CON_OUT_MASK                                   0x20
#define _CCP2CON_EN_POSN                                    0x7
#define _CCP2CON_EN_POSITION                                0x7
#define _CCP2CON_EN_SIZE                                    0x1
#define _CCP2CON_EN_LENGTH                                  0x1
#define _CCP2CON_EN_MASK                                    0x80
#define _CCP2CON_MODE0_POSN                                 0x0
#define _CCP2CON_MODE0_POSITION                             0x0
#define _CCP2CON_MODE0_SIZE                                 0x1
#define _CCP2CON_MODE0_LENGTH                               0x1
#define _CCP2CON_MODE0_MASK                                 0x1
#define _CCP2CON_MODE1_POSN                                 0x1
#define _CCP2CON_MODE1_POSITION                             0x1
#define _CCP2CON_MODE1_SIZE                                 0x1
#define _CCP2CON_MODE1_LENGTH                               0x1
#define _CCP2CON_MODE1_MASK                                 0x2
#define _CCP2CON_MODE2_POSN                                 0x2
#define _CCP2CON_MODE2_POSITION                             0x2
#define _CCP2CON_MODE2_SIZE                                 0x1
#define _CCP2CON_MODE2_LENGTH                               0x1
#define _CCP2CON_MODE2_MASK                                 0x4
#define _CCP2CON_MODE3_POSN                                 0x3
#define _CCP2CON_MODE3_POSITION                             0x3
#define _CCP2CON_MODE3_SIZE                                 0x1
#define _CCP2CON_MODE3_LENGTH                               0x1
#define _CCP2CON_MODE3_MASK                                 0x8
#define _CCP2CON_CCP2MODE_POSN                              0x0
#define _CCP2CON_CCP2MODE_POSITION                          0x0
#define _CCP2CON_CCP2MODE_SIZE                              0x4
#define _CCP2CON_CCP2MODE_LENGTH                            0x4
#define _CCP2CON_CCP2MODE_MASK                              0xF
#define _CCP2CON_CCP2FMT_POSN                               0x4
#define _CCP2CON_CCP2FMT_POSITION                           0x4
#define _CCP2CON_CCP2FMT_SIZE                               0x1
#define _CCP2CON_CCP2FMT_LENGTH                             0x1
#define _CCP2CON_CCP2FMT_MASK                               0x10
#define _CCP2CON_CCP2OUT_POSN                               0x5
#define _CCP2CON_CCP2OUT_POSITION                           0x5
#define _CCP2CON_CCP2OUT_SIZE                               0x1
#define _CCP2CON_CCP2OUT_LENGTH                             0x1
#define _CCP2CON_CCP2OUT_MASK                               0x20
#define _CCP2CON_CCP2EN_POSN                                0x7
#define _CCP2CON_CCP2EN_POSITION                            0x7
#define _CCP2CON_CCP2EN_SIZE                                0x1
#define _CCP2CON_CCP2EN_LENGTH                              0x1
#define _CCP2CON_CCP2EN_MASK                                0x80
#define _CCP2CON_CCP2MODE0_POSN                             0x0
#define _CCP2CON_CCP2MODE0_POSITION                         0x0
#define _CCP2CON_CCP2MODE0_SIZE                             0x1
#define _CCP2CON_CCP2MODE0_LENGTH                           0x1
#define _CCP2CON_CCP2MODE0_MASK                             0x1
#define _CCP2CON_CCP2MODE1_POSN                             0x1
#define _CCP2CON_CCP2MODE1_POSITION                         0x1
#define _CCP2CON_CCP2MODE1_SIZE                             0x1
#define _CCP2CON_CCP2MODE1_LENGTH                           0x1
#define _CCP2CON_CCP2MODE1_MASK                             0x2
#define _CCP2CON_CCP2MODE2_POSN                             0x2
#define _CCP2CON_CCP2MODE2_POSITION                         0x2
#define _CCP2CON_CCP2MODE2_SIZE                             0x1
#define _CCP2CON_CCP2MODE2_LENGTH                           0x1
#define _CCP2CON_CCP2MODE2_MASK                             0x4
#define _CCP2CON_CCP2MODE3_POSN                             0x3
#define _CCP2CON_CCP2MODE3_POSITION                         0x3
#define _CCP2CON_CCP2MODE3_SIZE                             0x1
#define _CCP2CON_CCP2MODE3_LENGTH                           0x1
#define _CCP2CON_CCP2MODE3_MASK                             0x8

// Register: CCP2CAP
extern volatile unsigned char           CCP2CAP             @ 0x29B;
#ifndef _LIB_BUILD
asm("CCP2CAP equ 029Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CTS                    :8;
    };
    struct {
        unsigned CTS0                   :1;
        unsigned CTS1                   :1;
        unsigned CTS2                   :1;
    };
    struct {
        unsigned CCP2CTS                :8;
    };
    struct {
        unsigned CCP2CTS0               :1;
        unsigned CCP2CTS1               :1;
        unsigned CCP2CTS2               :1;
    };
} CCP2CAPbits_t;
extern volatile CCP2CAPbits_t CCP2CAPbits @ 0x29B;
// bitfield macros
#define _CCP2CAP_CTS_POSN                                   0x0
#define _CCP2CAP_CTS_POSITION                               0x0
#define _CCP2CAP_CTS_SIZE                                   0x8
#define _CCP2CAP_CTS_LENGTH                                 0x8
#define _CCP2CAP_CTS_MASK                                   0xFF
#define _CCP2CAP_CTS0_POSN                                  0x0
#define _CCP2CAP_CTS0_POSITION                              0x0
#define _CCP2CAP_CTS0_SIZE                                  0x1
#define _CCP2CAP_CTS0_LENGTH                                0x1
#define _CCP2CAP_CTS0_MASK                                  0x1
#define _CCP2CAP_CTS1_POSN                                  0x1
#define _CCP2CAP_CTS1_POSITION                              0x1
#define _CCP2CAP_CTS1_SIZE                                  0x1
#define _CCP2CAP_CTS1_LENGTH                                0x1
#define _CCP2CAP_CTS1_MASK                                  0x2
#define _CCP2CAP_CTS2_POSN                                  0x2
#define _CCP2CAP_CTS2_POSITION                              0x2
#define _CCP2CAP_CTS2_SIZE                                  0x1
#define _CCP2CAP_CTS2_LENGTH                                0x1
#define _CCP2CAP_CTS2_MASK                                  0x4
#define _CCP2CAP_CCP2CTS_POSN                               0x0
#define _CCP2CAP_CCP2CTS_POSITION                           0x0
#define _CCP2CAP_CCP2CTS_SIZE                               0x8
#define _CCP2CAP_CCP2CTS_LENGTH                             0x8
#define _CCP2CAP_CCP2CTS_MASK                               0xFF
#define _CCP2CAP_CCP2CTS0_POSN                              0x0
#define _CCP2CAP_CCP2CTS0_POSITION                          0x0
#define _CCP2CAP_CCP2CTS0_SIZE                              0x1
#define _CCP2CAP_CCP2CTS0_LENGTH                            0x1
#define _CCP2CAP_CCP2CTS0_MASK                              0x1
#define _CCP2CAP_CCP2CTS1_POSN                              0x1
#define _CCP2CAP_CCP2CTS1_POSITION                          0x1
#define _CCP2CAP_CCP2CTS1_SIZE                              0x1
#define _CCP2CAP_CCP2CTS1_LENGTH                            0x1
#define _CCP2CAP_CCP2CTS1_MASK                              0x2
#define _CCP2CAP_CCP2CTS2_POSN                              0x2
#define _CCP2CAP_CCP2CTS2_POSITION                          0x2
#define _CCP2CAP_CCP2CTS2_SIZE                              0x1
#define _CCP2CAP_CCP2CTS2_LENGTH                            0x1
#define _CCP2CAP_CCP2CTS2_MASK                              0x4

// Register: CCPTMRS
extern volatile unsigned char           CCPTMRS             @ 0x29E;
#ifndef _LIB_BUILD
asm("CCPTMRS equ 029Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CCP1TSEL               :2;
        unsigned CCP2TSEL               :2;
        unsigned P3TSEL                 :2;
        unsigned P4TSEL                 :2;
    };
    struct {
        unsigned CCP1TSEL0              :1;
        unsigned CCP1TSEL1              :1;
        unsigned CCP2TSEL0              :1;
        unsigned CCP2TSEL1              :1;
        unsigned P3TSEL0                :1;
        unsigned P3TSEL1                :1;
        unsigned P4TSEL0                :1;
        unsigned P4TSEL1                :1;
    };
} CCPTMRSbits_t;
extern volatile CCPTMRSbits_t CCPTMRSbits @ 0x29E;
// bitfield macros
#define _CCPTMRS_CCP1TSEL_POSN                              0x0
#define _CCPTMRS_CCP1TSEL_POSITION                          0x0
#define _CCPTMRS_CCP1TSEL_SIZE                              0x2
#define _CCPTMRS_CCP1TSEL_LENGTH                            0x2
#define _CCPTMRS_CCP1TSEL_MASK                              0x3
#define _CCPTMRS_CCP2TSEL_POSN                              0x2
#define _CCPTMRS_CCP2TSEL_POSITION                          0x2
#define _CCPTMRS_CCP2TSEL_SIZE                              0x2
#define _CCPTMRS_CCP2TSEL_LENGTH                            0x2
#define _CCPTMRS_CCP2TSEL_MASK                              0xC
#define _CCPTMRS_P3TSEL_POSN                                0x4
#define _CCPTMRS_P3TSEL_POSITION                            0x4
#define _CCPTMRS_P3TSEL_SIZE                                0x2
#define _CCPTMRS_P3TSEL_LENGTH                              0x2
#define _CCPTMRS_P3TSEL_MASK                                0x30
#define _CCPTMRS_P4TSEL_POSN                                0x6
#define _CCPTMRS_P4TSEL_POSITION                            0x6
#define _CCPTMRS_P4TSEL_SIZE                                0x2
#define _CCPTMRS_P4TSEL_LENGTH                              0x2
#define _CCPTMRS_P4TSEL_MASK                                0xC0
#define _CCPTMRS_CCP1TSEL0_POSN                             0x0
#define _CCPTMRS_CCP1TSEL0_POSITION                         0x0
#define _CCPTMRS_CCP1TSEL0_SIZE                             0x1
#define _CCPTMRS_CCP1TSEL0_LENGTH                           0x1
#define _CCPTMRS_CCP1TSEL0_MASK                             0x1
#define _CCPTMRS_CCP1TSEL1_POSN                             0x1
#define _CCPTMRS_CCP1TSEL1_POSITION                         0x1
#define _CCPTMRS_CCP1TSEL1_SIZE                             0x1
#define _CCPTMRS_CCP1TSEL1_LENGTH                           0x1
#define _CCPTMRS_CCP1TSEL1_MASK                             0x2
#define _CCPTMRS_CCP2TSEL0_POSN                             0x2
#define _CCPTMRS_CCP2TSEL0_POSITION                         0x2
#define _CCPTMRS_CCP2TSEL0_SIZE                             0x1
#define _CCPTMRS_CCP2TSEL0_LENGTH                           0x1
#define _CCPTMRS_CCP2TSEL0_MASK                             0x4
#define _CCPTMRS_CCP2TSEL1_POSN                             0x3
#define _CCPTMRS_CCP2TSEL1_POSITION                         0x3
#define _CCPTMRS_CCP2TSEL1_SIZE                             0x1
#define _CCPTMRS_CCP2TSEL1_LENGTH                           0x1
#define _CCPTMRS_CCP2TSEL1_MASK                             0x8
#define _CCPTMRS_P3TSEL0_POSN                               0x4
#define _CCPTMRS_P3TSEL0_POSITION                           0x4
#define _CCPTMRS_P3TSEL0_SIZE                               0x1
#define _CCPTMRS_P3TSEL0_LENGTH                             0x1
#define _CCPTMRS_P3TSEL0_MASK                               0x10
#define _CCPTMRS_P3TSEL1_POSN                               0x5
#define _CCPTMRS_P3TSEL1_POSITION                           0x5
#define _CCPTMRS_P3TSEL1_SIZE                               0x1
#define _CCPTMRS_P3TSEL1_LENGTH                             0x1
#define _CCPTMRS_P3TSEL1_MASK                               0x20
#define _CCPTMRS_P4TSEL0_POSN                               0x6
#define _CCPTMRS_P4TSEL0_POSITION                           0x6
#define _CCPTMRS_P4TSEL0_SIZE                               0x1
#define _CCPTMRS_P4TSEL0_LENGTH                             0x1
#define _CCPTMRS_P4TSEL0_MASK                               0x40
#define _CCPTMRS_P4TSEL1_POSN                               0x7
#define _CCPTMRS_P4TSEL1_POSITION                           0x7
#define _CCPTMRS_P4TSEL1_SIZE                               0x1
#define _CCPTMRS_P4TSEL1_LENGTH                             0x1
#define _CCPTMRS_P4TSEL1_MASK                               0x80

// Register: SLRCONA
extern volatile unsigned char           SLRCONA             @ 0x30C;
#ifndef _LIB_BUILD
asm("SLRCONA equ 030Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SLRA0                  :1;
        unsigned SLRA1                  :1;
        unsigned SLRA2                  :1;
        unsigned                        :1;
        unsigned SLRA4                  :1;
        unsigned SLRA5                  :1;
    };
} SLRCONAbits_t;
extern volatile SLRCONAbits_t SLRCONAbits @ 0x30C;
// bitfield macros
#define _SLRCONA_SLRA0_POSN                                 0x0
#define _SLRCONA_SLRA0_POSITION                             0x0
#define _SLRCONA_SLRA0_SIZE                                 0x1
#define _SLRCONA_SLRA0_LENGTH                               0x1
#define _SLRCONA_SLRA0_MASK                                 0x1
#define _SLRCONA_SLRA1_POSN                                 0x1
#define _SLRCONA_SLRA1_POSITION                             0x1
#define _SLRCONA_SLRA1_SIZE                                 0x1
#define _SLRCONA_SLRA1_LENGTH                               0x1
#define _SLRCONA_SLRA1_MASK                                 0x2
#define _SLRCONA_SLRA2_POSN                                 0x2
#define _SLRCONA_SLRA2_POSITION                             0x2
#define _SLRCONA_SLRA2_SIZE                                 0x1
#define _SLRCONA_SLRA2_LENGTH                               0x1
#define _SLRCONA_SLRA2_MASK                                 0x4
#define _SLRCONA_SLRA4_POSN                                 0x4
#define _SLRCONA_SLRA4_POSITION                             0x4
#define _SLRCONA_SLRA4_SIZE                                 0x1
#define _SLRCONA_SLRA4_LENGTH                               0x1
#define _SLRCONA_SLRA4_MASK                                 0x10
#define _SLRCONA_SLRA5_POSN                                 0x5
#define _SLRCONA_SLRA5_POSITION                             0x5
#define _SLRCONA_SLRA5_SIZE                                 0x1
#define _SLRCONA_SLRA5_LENGTH                               0x1
#define _SLRCONA_SLRA5_MASK                                 0x20

// Register: SLRCONB
extern volatile unsigned char           SLRCONB             @ 0x30D;
#ifndef _LIB_BUILD
asm("SLRCONB equ 030Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned SLRB4                  :1;
        unsigned SLRB5                  :1;
        unsigned SLRB6                  :1;
        unsigned SLRB7                  :1;
    };
} SLRCONBbits_t;
extern volatile SLRCONBbits_t SLRCONBbits @ 0x30D;
// bitfield macros
#define _SLRCONB_SLRB4_POSN                                 0x4
#define _SLRCONB_SLRB4_POSITION                             0x4
#define _SLRCONB_SLRB4_SIZE                                 0x1
#define _SLRCONB_SLRB4_LENGTH                               0x1
#define _SLRCONB_SLRB4_MASK                                 0x10
#define _SLRCONB_SLRB5_POSN                                 0x5
#define _SLRCONB_SLRB5_POSITION                             0x5
#define _SLRCONB_SLRB5_SIZE                                 0x1
#define _SLRCONB_SLRB5_LENGTH                               0x1
#define _SLRCONB_SLRB5_MASK                                 0x20
#define _SLRCONB_SLRB6_POSN                                 0x6
#define _SLRCONB_SLRB6_POSITION                             0x6
#define _SLRCONB_SLRB6_SIZE                                 0x1
#define _SLRCONB_SLRB6_LENGTH                               0x1
#define _SLRCONB_SLRB6_MASK                                 0x40
#define _SLRCONB_SLRB7_POSN                                 0x7
#define _SLRCONB_SLRB7_POSITION                             0x7
#define _SLRCONB_SLRB7_SIZE                                 0x1
#define _SLRCONB_SLRB7_LENGTH                               0x1
#define _SLRCONB_SLRB7_MASK                                 0x80

// Register: SLRCONC
extern volatile unsigned char           SLRCONC             @ 0x30E;
#ifndef _LIB_BUILD
asm("SLRCONC equ 030Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SLRC0                  :1;
        unsigned SLRC1                  :1;
        unsigned SLRC2                  :1;
        unsigned SLRC3                  :1;
        unsigned SLRC4                  :1;
        unsigned SLRC5                  :1;
        unsigned SLRC6                  :1;
        unsigned SLRC7                  :1;
    };
} SLRCONCbits_t;
extern volatile SLRCONCbits_t SLRCONCbits @ 0x30E;
// bitfield macros
#define _SLRCONC_SLRC0_POSN                                 0x0
#define _SLRCONC_SLRC0_POSITION                             0x0
#define _SLRCONC_SLRC0_SIZE                                 0x1
#define _SLRCONC_SLRC0_LENGTH                               0x1
#define _SLRCONC_SLRC0_MASK                                 0x1
#define _SLRCONC_SLRC1_POSN                                 0x1
#define _SLRCONC_SLRC1_POSITION                             0x1
#define _SLRCONC_SLRC1_SIZE                                 0x1
#define _SLRCONC_SLRC1_LENGTH                               0x1
#define _SLRCONC_SLRC1_MASK                                 0x2
#define _SLRCONC_SLRC2_POSN                                 0x2
#define _SLRCONC_SLRC2_POSITION                             0x2
#define _SLRCONC_SLRC2_SIZE                                 0x1
#define _SLRCONC_SLRC2_LENGTH                               0x1
#define _SLRCONC_SLRC2_MASK                                 0x4
#define _SLRCONC_SLRC3_POSN                                 0x3
#define _SLRCONC_SLRC3_POSITION                             0x3
#define _SLRCONC_SLRC3_SIZE                                 0x1
#define _SLRCONC_SLRC3_LENGTH                               0x1
#define _SLRCONC_SLRC3_MASK                                 0x8
#define _SLRCONC_SLRC4_POSN                                 0x4
#define _SLRCONC_SLRC4_POSITION                             0x4
#define _SLRCONC_SLRC4_SIZE                                 0x1
#define _SLRCONC_SLRC4_LENGTH                               0x1
#define _SLRCONC_SLRC4_MASK                                 0x10
#define _SLRCONC_SLRC5_POSN                                 0x5
#define _SLRCONC_SLRC5_POSITION                             0x5
#define _SLRCONC_SLRC5_SIZE                                 0x1
#define _SLRCONC_SLRC5_LENGTH                               0x1
#define _SLRCONC_SLRC5_MASK                                 0x20
#define _SLRCONC_SLRC6_POSN                                 0x6
#define _SLRCONC_SLRC6_POSITION                             0x6
#define _SLRCONC_SLRC6_SIZE                                 0x1
#define _SLRCONC_SLRC6_LENGTH                               0x1
#define _SLRCONC_SLRC6_MASK                                 0x40
#define _SLRCONC_SLRC7_POSN                                 0x7
#define _SLRCONC_SLRC7_POSITION                             0x7
#define _SLRCONC_SLRC7_SIZE                                 0x1
#define _SLRCONC_SLRC7_LENGTH                               0x1
#define _SLRCONC_SLRC7_MASK                                 0x80

// Register: INLVLA
extern volatile unsigned char           INLVLA              @ 0x38C;
#ifndef _LIB_BUILD
asm("INLVLA equ 038Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned INLVLA0                :1;
        unsigned INLVLA1                :1;
        unsigned INLVLA2                :1;
        unsigned INLVLA3                :1;
        unsigned INLVLA4                :1;
        unsigned INLVLA5                :1;
    };
} INLVLAbits_t;
extern volatile INLVLAbits_t INLVLAbits @ 0x38C;
// bitfield macros
#define _INLVLA_INLVLA0_POSN                                0x0
#define _INLVLA_INLVLA0_POSITION                            0x0
#define _INLVLA_INLVLA0_SIZE                                0x1
#define _INLVLA_INLVLA0_LENGTH                              0x1
#define _INLVLA_INLVLA0_MASK                                0x1
#define _INLVLA_INLVLA1_POSN                                0x1
#define _INLVLA_INLVLA1_POSITION                            0x1
#define _INLVLA_INLVLA1_SIZE                                0x1
#define _INLVLA_INLVLA1_LENGTH                              0x1
#define _INLVLA_INLVLA1_MASK                                0x2
#define _INLVLA_INLVLA2_POSN                                0x2
#define _INLVLA_INLVLA2_POSITION                            0x2
#define _INLVLA_INLVLA2_SIZE                                0x1
#define _INLVLA_INLVLA2_LENGTH                              0x1
#define _INLVLA_INLVLA2_MASK                                0x4
#define _INLVLA_INLVLA3_POSN                                0x3
#define _INLVLA_INLVLA3_POSITION                            0x3
#define _INLVLA_INLVLA3_SIZE                                0x1
#define _INLVLA_INLVLA3_LENGTH                              0x1
#define _INLVLA_INLVLA3_MASK                                0x8
#define _INLVLA_INLVLA4_POSN                                0x4
#define _INLVLA_INLVLA4_POSITION                            0x4
#define _INLVLA_INLVLA4_SIZE                                0x1
#define _INLVLA_INLVLA4_LENGTH                              0x1
#define _INLVLA_INLVLA4_MASK                                0x10
#define _INLVLA_INLVLA5_POSN                                0x5
#define _INLVLA_INLVLA5_POSITION                            0x5
#define _INLVLA_INLVLA5_SIZE                                0x1
#define _INLVLA_INLVLA5_LENGTH                              0x1
#define _INLVLA_INLVLA5_MASK                                0x20

// Register: INLVLB
extern volatile unsigned char           INLVLB              @ 0x38D;
#ifndef _LIB_BUILD
asm("INLVLB equ 038Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned INLVLB4                :1;
        unsigned INLVLB5                :1;
        unsigned INLVLB6                :1;
        unsigned INLVLB7                :1;
    };
} INLVLBbits_t;
extern volatile INLVLBbits_t INLVLBbits @ 0x38D;
// bitfield macros
#define _INLVLB_INLVLB4_POSN                                0x4
#define _INLVLB_INLVLB4_POSITION                            0x4
#define _INLVLB_INLVLB4_SIZE                                0x1
#define _INLVLB_INLVLB4_LENGTH                              0x1
#define _INLVLB_INLVLB4_MASK                                0x10
#define _INLVLB_INLVLB5_POSN                                0x5
#define _INLVLB_INLVLB5_POSITION                            0x5
#define _INLVLB_INLVLB5_SIZE                                0x1
#define _INLVLB_INLVLB5_LENGTH                              0x1
#define _INLVLB_INLVLB5_MASK                                0x20
#define _INLVLB_INLVLB6_POSN                                0x6
#define _INLVLB_INLVLB6_POSITION                            0x6
#define _INLVLB_INLVLB6_SIZE                                0x1
#define _INLVLB_INLVLB6_LENGTH                              0x1
#define _INLVLB_INLVLB6_MASK                                0x40
#define _INLVLB_INLVLB7_POSN                                0x7
#define _INLVLB_INLVLB7_POSITION                            0x7
#define _INLVLB_INLVLB7_SIZE                                0x1
#define _INLVLB_INLVLB7_LENGTH                              0x1
#define _INLVLB_INLVLB7_MASK                                0x80

// Register: INLVLC
extern volatile unsigned char           INLVLC              @ 0x38E;
#ifndef _LIB_BUILD
asm("INLVLC equ 038Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned INLVLC0                :1;
        unsigned INLVLC1                :1;
        unsigned INLVLC2                :1;
        unsigned INLVLC3                :1;
        unsigned INLVLC4                :1;
        unsigned INLVLC5                :1;
        unsigned INLVLC6                :1;
        unsigned INLVLC7                :1;
    };
} INLVLCbits_t;
extern volatile INLVLCbits_t INLVLCbits @ 0x38E;
// bitfield macros
#define _INLVLC_INLVLC0_POSN                                0x0
#define _INLVLC_INLVLC0_POSITION                            0x0
#define _INLVLC_INLVLC0_SIZE                                0x1
#define _INLVLC_INLVLC0_LENGTH                              0x1
#define _INLVLC_INLVLC0_MASK                                0x1
#define _INLVLC_INLVLC1_POSN                                0x1
#define _INLVLC_INLVLC1_POSITION                            0x1
#define _INLVLC_INLVLC1_SIZE                                0x1
#define _INLVLC_INLVLC1_LENGTH                              0x1
#define _INLVLC_INLVLC1_MASK                                0x2
#define _INLVLC_INLVLC2_POSN                                0x2
#define _INLVLC_INLVLC2_POSITION                            0x2
#define _INLVLC_INLVLC2_SIZE                                0x1
#define _INLVLC_INLVLC2_LENGTH                              0x1
#define _INLVLC_INLVLC2_MASK                                0x4
#define _INLVLC_INLVLC3_POSN                                0x3
#define _INLVLC_INLVLC3_POSITION                            0x3
#define _INLVLC_INLVLC3_SIZE                                0x1
#define _INLVLC_INLVLC3_LENGTH                              0x1
#define _INLVLC_INLVLC3_MASK                                0x8
#define _INLVLC_INLVLC4_POSN                                0x4
#define _INLVLC_INLVLC4_POSITION                            0x4
#define _INLVLC_INLVLC4_SIZE                                0x1
#define _INLVLC_INLVLC4_LENGTH                              0x1
#define _INLVLC_INLVLC4_MASK                                0x10
#define _INLVLC_INLVLC5_POSN                                0x5
#define _INLVLC_INLVLC5_POSITION                            0x5
#define _INLVLC_INLVLC5_SIZE                                0x1
#define _INLVLC_INLVLC5_LENGTH                              0x1
#define _INLVLC_INLVLC5_MASK                                0x20
#define _INLVLC_INLVLC6_POSN                                0x6
#define _INLVLC_INLVLC6_POSITION                            0x6
#define _INLVLC_INLVLC6_SIZE                                0x1
#define _INLVLC_INLVLC6_LENGTH                              0x1
#define _INLVLC_INLVLC6_MASK                                0x40
#define _INLVLC_INLVLC7_POSN                                0x7
#define _INLVLC_INLVLC7_POSITION                            0x7
#define _INLVLC_INLVLC7_SIZE                                0x1
#define _INLVLC_INLVLC7_LENGTH                              0x1
#define _INLVLC_INLVLC7_MASK                                0x80

// Register: IOCAP
extern volatile unsigned char           IOCAP               @ 0x391;
#ifndef _LIB_BUILD
asm("IOCAP equ 0391h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned IOCAP0                 :1;
        unsigned IOCAP1                 :1;
        unsigned IOCAP2                 :1;
        unsigned IOCAP3                 :1;
        unsigned IOCAP4                 :1;
        unsigned IOCAP5                 :1;
    };
    struct {
        unsigned IOCAP                  :6;
    };
} IOCAPbits_t;
extern volatile IOCAPbits_t IOCAPbits @ 0x391;
// bitfield macros
#define _IOCAP_IOCAP0_POSN                                  0x0
#define _IOCAP_IOCAP0_POSITION                              0x0
#define _IOCAP_IOCAP0_SIZE                                  0x1
#define _IOCAP_IOCAP0_LENGTH                                0x1
#define _IOCAP_IOCAP0_MASK                                  0x1
#define _IOCAP_IOCAP1_POSN                                  0x1
#define _IOCAP_IOCAP1_POSITION                              0x1
#define _IOCAP_IOCAP1_SIZE                                  0x1
#define _IOCAP_IOCAP1_LENGTH                                0x1
#define _IOCAP_IOCAP1_MASK                                  0x2
#define _IOCAP_IOCAP2_POSN                                  0x2
#define _IOCAP_IOCAP2_POSITION                              0x2
#define _IOCAP_IOCAP2_SIZE                                  0x1
#define _IOCAP_IOCAP2_LENGTH                                0x1
#define _IOCAP_IOCAP2_MASK                                  0x4
#define _IOCAP_IOCAP3_POSN                                  0x3
#define _IOCAP_IOCAP3_POSITION                              0x3
#define _IOCAP_IOCAP3_SIZE                                  0x1
#define _IOCAP_IOCAP3_LENGTH                                0x1
#define _IOCAP_IOCAP3_MASK                                  0x8
#define _IOCAP_IOCAP4_POSN                                  0x4
#define _IOCAP_IOCAP4_POSITION                              0x4
#define _IOCAP_IOCAP4_SIZE                                  0x1
#define _IOCAP_IOCAP4_LENGTH                                0x1
#define _IOCAP_IOCAP4_MASK                                  0x10
#define _IOCAP_IOCAP5_POSN                                  0x5
#define _IOCAP_IOCAP5_POSITION                              0x5
#define _IOCAP_IOCAP5_SIZE                                  0x1
#define _IOCAP_IOCAP5_LENGTH                                0x1
#define _IOCAP_IOCAP5_MASK                                  0x20
#define _IOCAP_IOCAP_POSN                                   0x0
#define _IOCAP_IOCAP_POSITION                               0x0
#define _IOCAP_IOCAP_SIZE                                   0x6
#define _IOCAP_IOCAP_LENGTH                                 0x6
#define _IOCAP_IOCAP_MASK                                   0x3F

// Register: IOCAN
extern volatile unsigned char           IOCAN               @ 0x392;
#ifndef _LIB_BUILD
asm("IOCAN equ 0392h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned IOCAN0                 :1;
        unsigned IOCAN1                 :1;
        unsigned IOCAN2                 :1;
        unsigned IOCAN3                 :1;
        unsigned IOCAN4                 :1;
        unsigned IOCAN5                 :1;
    };
    struct {
        unsigned IOCAN                  :6;
    };
} IOCANbits_t;
extern volatile IOCANbits_t IOCANbits @ 0x392;
// bitfield macros
#define _IOCAN_IOCAN0_POSN                                  0x0
#define _IOCAN_IOCAN0_POSITION                              0x0
#define _IOCAN_IOCAN0_SIZE                                  0x1
#define _IOCAN_IOCAN0_LENGTH                                0x1
#define _IOCAN_IOCAN0_MASK                                  0x1
#define _IOCAN_IOCAN1_POSN                                  0x1
#define _IOCAN_IOCAN1_POSITION                              0x1
#define _IOCAN_IOCAN1_SIZE                                  0x1
#define _IOCAN_IOCAN1_LENGTH                                0x1
#define _IOCAN_IOCAN1_MASK                                  0x2
#define _IOCAN_IOCAN2_POSN                                  0x2
#define _IOCAN_IOCAN2_POSITION                              0x2
#define _IOCAN_IOCAN2_SIZE                                  0x1
#define _IOCAN_IOCAN2_LENGTH                                0x1
#define _IOCAN_IOCAN2_MASK                                  0x4
#define _IOCAN_IOCAN3_POSN                                  0x3
#define _IOCAN_IOCAN3_POSITION                              0x3
#define _IOCAN_IOCAN3_SIZE                                  0x1
#define _IOCAN_IOCAN3_LENGTH                                0x1
#define _IOCAN_IOCAN3_MASK                                  0x8
#define _IOCAN_IOCAN4_POSN                                  0x4
#define _IOCAN_IOCAN4_POSITION                              0x4
#define _IOCAN_IOCAN4_SIZE                                  0x1
#define _IOCAN_IOCAN4_LENGTH                                0x1
#define _IOCAN_IOCAN4_MASK                                  0x10
#define _IOCAN_IOCAN5_POSN                                  0x5
#define _IOCAN_IOCAN5_POSITION                              0x5
#define _IOCAN_IOCAN5_SIZE                                  0x1
#define _IOCAN_IOCAN5_LENGTH                                0x1
#define _IOCAN_IOCAN5_MASK                                  0x20
#define _IOCAN_IOCAN_POSN                                   0x0
#define _IOCAN_IOCAN_POSITION                               0x0
#define _IOCAN_IOCAN_SIZE                                   0x6
#define _IOCAN_IOCAN_LENGTH                                 0x6
#define _IOCAN_IOCAN_MASK                                   0x3F

// Register: IOCAF
extern volatile unsigned char           IOCAF               @ 0x393;
#ifndef _LIB_BUILD
asm("IOCAF equ 0393h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned IOCAF0                 :1;
        unsigned IOCAF1                 :1;
        unsigned IOCAF2                 :1;
        unsigned IOCAF3                 :1;
        unsigned IOCAF4                 :1;
        unsigned IOCAF5                 :1;
    };
    struct {
        unsigned IOCAF                  :6;
    };
} IOCAFbits_t;
extern volatile IOCAFbits_t IOCAFbits @ 0x393;
// bitfield macros
#define _IOCAF_IOCAF0_POSN                                  0x0
#define _IOCAF_IOCAF0_POSITION                              0x0
#define _IOCAF_IOCAF0_SIZE                                  0x1
#define _IOCAF_IOCAF0_LENGTH                                0x1
#define _IOCAF_IOCAF0_MASK                                  0x1
#define _IOCAF_IOCAF1_POSN                                  0x1
#define _IOCAF_IOCAF1_POSITION                              0x1
#define _IOCAF_IOCAF1_SIZE                                  0x1
#define _IOCAF_IOCAF1_LENGTH                                0x1
#define _IOCAF_IOCAF1_MASK                                  0x2
#define _IOCAF_IOCAF2_POSN                                  0x2
#define _IOCAF_IOCAF2_POSITION                              0x2
#define _IOCAF_IOCAF2_SIZE                                  0x1
#define _IOCAF_IOCAF2_LENGTH                                0x1
#define _IOCAF_IOCAF2_MASK                                  0x4
#define _IOCAF_IOCAF3_POSN                                  0x3
#define _IOCAF_IOCAF3_POSITION                              0x3
#define _IOCAF_IOCAF3_SIZE                                  0x1
#define _IOCAF_IOCAF3_LENGTH                                0x1
#define _IOCAF_IOCAF3_MASK                                  0x8
#define _IOCAF_IOCAF4_POSN                                  0x4
#define _IOCAF_IOCAF4_POSITION                              0x4
#define _IOCAF_IOCAF4_SIZE                                  0x1
#define _IOCAF_IOCAF4_LENGTH                                0x1
#define _IOCAF_IOCAF4_MASK                                  0x10
#define _IOCAF_IOCAF5_POSN                                  0x5
#define _IOCAF_IOCAF5_POSITION                              0x5
#define _IOCAF_IOCAF5_SIZE                                  0x1
#define _IOCAF_IOCAF5_LENGTH                                0x1
#define _IOCAF_IOCAF5_MASK                                  0x20
#define _IOCAF_IOCAF_POSN                                   0x0
#define _IOCAF_IOCAF_POSITION                               0x0
#define _IOCAF_IOCAF_SIZE                                   0x6
#define _IOCAF_IOCAF_LENGTH                                 0x6
#define _IOCAF_IOCAF_MASK                                   0x3F

// Register: IOCBP
extern volatile unsigned char           IOCBP               @ 0x394;
#ifndef _LIB_BUILD
asm("IOCBP equ 0394h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned IOCBP4                 :1;
        unsigned IOCBP5                 :1;
        unsigned IOCBP6                 :1;
        unsigned IOCBP7                 :1;
    };
} IOCBPbits_t;
extern volatile IOCBPbits_t IOCBPbits @ 0x394;
// bitfield macros
#define _IOCBP_IOCBP4_POSN                                  0x4
#define _IOCBP_IOCBP4_POSITION                              0x4
#define _IOCBP_IOCBP4_SIZE                                  0x1
#define _IOCBP_IOCBP4_LENGTH                                0x1
#define _IOCBP_IOCBP4_MASK                                  0x10
#define _IOCBP_IOCBP5_POSN                                  0x5
#define _IOCBP_IOCBP5_POSITION                              0x5
#define _IOCBP_IOCBP5_SIZE                                  0x1
#define _IOCBP_IOCBP5_LENGTH                                0x1
#define _IOCBP_IOCBP5_MASK                                  0x20
#define _IOCBP_IOCBP6_POSN                                  0x6
#define _IOCBP_IOCBP6_POSITION                              0x6
#define _IOCBP_IOCBP6_SIZE                                  0x1
#define _IOCBP_IOCBP6_LENGTH                                0x1
#define _IOCBP_IOCBP6_MASK                                  0x40
#define _IOCBP_IOCBP7_POSN                                  0x7
#define _IOCBP_IOCBP7_POSITION                              0x7
#define _IOCBP_IOCBP7_SIZE                                  0x1
#define _IOCBP_IOCBP7_LENGTH                                0x1
#define _IOCBP_IOCBP7_MASK                                  0x80

// Register: IOCBN
extern volatile unsigned char           IOCBN               @ 0x395;
#ifndef _LIB_BUILD
asm("IOCBN equ 0395h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned IOCBN4                 :1;
        unsigned IOCBN5                 :1;
        unsigned IOCBN6                 :1;
        unsigned IOCBN7                 :1;
    };
} IOCBNbits_t;
extern volatile IOCBNbits_t IOCBNbits @ 0x395;
// bitfield macros
#define _IOCBN_IOCBN4_POSN                                  0x4
#define _IOCBN_IOCBN4_POSITION                              0x4
#define _IOCBN_IOCBN4_SIZE                                  0x1
#define _IOCBN_IOCBN4_LENGTH                                0x1
#define _IOCBN_IOCBN4_MASK                                  0x10
#define _IOCBN_IOCBN5_POSN                                  0x5
#define _IOCBN_IOCBN5_POSITION                              0x5
#define _IOCBN_IOCBN5_SIZE                                  0x1
#define _IOCBN_IOCBN5_LENGTH                                0x1
#define _IOCBN_IOCBN5_MASK                                  0x20
#define _IOCBN_IOCBN6_POSN                                  0x6
#define _IOCBN_IOCBN6_POSITION                              0x6
#define _IOCBN_IOCBN6_SIZE                                  0x1
#define _IOCBN_IOCBN6_LENGTH                                0x1
#define _IOCBN_IOCBN6_MASK                                  0x40
#define _IOCBN_IOCBN7_POSN                                  0x7
#define _IOCBN_IOCBN7_POSITION                              0x7
#define _IOCBN_IOCBN7_SIZE                                  0x1
#define _IOCBN_IOCBN7_LENGTH                                0x1
#define _IOCBN_IOCBN7_MASK                                  0x80

// Register: IOCBF
extern volatile unsigned char           IOCBF               @ 0x396;
#ifndef _LIB_BUILD
asm("IOCBF equ 0396h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned IOCBF4                 :1;
        unsigned IOCBF5                 :1;
        unsigned IOCBF6                 :1;
        unsigned IOCBF7                 :1;
    };
} IOCBFbits_t;
extern volatile IOCBFbits_t IOCBFbits @ 0x396;
// bitfield macros
#define _IOCBF_IOCBF4_POSN                                  0x4
#define _IOCBF_IOCBF4_POSITION                              0x4
#define _IOCBF_IOCBF4_SIZE                                  0x1
#define _IOCBF_IOCBF4_LENGTH                                0x1
#define _IOCBF_IOCBF4_MASK                                  0x10
#define _IOCBF_IOCBF5_POSN                                  0x5
#define _IOCBF_IOCBF5_POSITION                              0x5
#define _IOCBF_IOCBF5_SIZE                                  0x1
#define _IOCBF_IOCBF5_LENGTH                                0x1
#define _IOCBF_IOCBF5_MASK                                  0x20
#define _IOCBF_IOCBF6_POSN                                  0x6
#define _IOCBF_IOCBF6_POSITION                              0x6
#define _IOCBF_IOCBF6_SIZE                                  0x1
#define _IOCBF_IOCBF6_LENGTH                                0x1
#define _IOCBF_IOCBF6_MASK                                  0x40
#define _IOCBF_IOCBF7_POSN                                  0x7
#define _IOCBF_IOCBF7_POSITION                              0x7
#define _IOCBF_IOCBF7_SIZE                                  0x1
#define _IOCBF_IOCBF7_LENGTH                                0x1
#define _IOCBF_IOCBF7_MASK                                  0x80

// Register: IOCCP
extern volatile unsigned char           IOCCP               @ 0x397;
#ifndef _LIB_BUILD
asm("IOCCP equ 0397h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned IOCCP0                 :1;
        unsigned IOCCP1                 :1;
        unsigned IOCCP2                 :1;
        unsigned IOCCP3                 :1;
        unsigned IOCCP4                 :1;
        unsigned IOCCP5                 :1;
        unsigned IOCCP6                 :1;
        unsigned IOCCP7                 :1;
    };
} IOCCPbits_t;
extern volatile IOCCPbits_t IOCCPbits @ 0x397;
// bitfield macros
#define _IOCCP_IOCCP0_POSN                                  0x0
#define _IOCCP_IOCCP0_POSITION                              0x0
#define _IOCCP_IOCCP0_SIZE                                  0x1
#define _IOCCP_IOCCP0_LENGTH                                0x1
#define _IOCCP_IOCCP0_MASK                                  0x1
#define _IOCCP_IOCCP1_POSN                                  0x1
#define _IOCCP_IOCCP1_POSITION                              0x1
#define _IOCCP_IOCCP1_SIZE                                  0x1
#define _IOCCP_IOCCP1_LENGTH                                0x1
#define _IOCCP_IOCCP1_MASK                                  0x2
#define _IOCCP_IOCCP2_POSN                                  0x2
#define _IOCCP_IOCCP2_POSITION                              0x2
#define _IOCCP_IOCCP2_SIZE                                  0x1
#define _IOCCP_IOCCP2_LENGTH                                0x1
#define _IOCCP_IOCCP2_MASK                                  0x4
#define _IOCCP_IOCCP3_POSN                                  0x3
#define _IOCCP_IOCCP3_POSITION                              0x3
#define _IOCCP_IOCCP3_SIZE                                  0x1
#define _IOCCP_IOCCP3_LENGTH                                0x1
#define _IOCCP_IOCCP3_MASK                                  0x8
#define _IOCCP_IOCCP4_POSN                                  0x4
#define _IOCCP_IOCCP4_POSITION                              0x4
#define _IOCCP_IOCCP4_SIZE                                  0x1
#define _IOCCP_IOCCP4_LENGTH                                0x1
#define _IOCCP_IOCCP4_MASK                                  0x10
#define _IOCCP_IOCCP5_POSN                                  0x5
#define _IOCCP_IOCCP5_POSITION                              0x5
#define _IOCCP_IOCCP5_SIZE                                  0x1
#define _IOCCP_IOCCP5_LENGTH                                0x1
#define _IOCCP_IOCCP5_MASK                                  0x20
#define _IOCCP_IOCCP6_POSN                                  0x6
#define _IOCCP_IOCCP6_POSITION                              0x6
#define _IOCCP_IOCCP6_SIZE                                  0x1
#define _IOCCP_IOCCP6_LENGTH                                0x1
#define _IOCCP_IOCCP6_MASK                                  0x40
#define _IOCCP_IOCCP7_POSN                                  0x7
#define _IOCCP_IOCCP7_POSITION                              0x7
#define _IOCCP_IOCCP7_SIZE                                  0x1
#define _IOCCP_IOCCP7_LENGTH                                0x1
#define _IOCCP_IOCCP7_MASK                                  0x80

// Register: IOCCN
extern volatile unsigned char           IOCCN               @ 0x398;
#ifndef _LIB_BUILD
asm("IOCCN equ 0398h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned IOCCN0                 :1;
        unsigned IOCCN1                 :1;
        unsigned IOCCN2                 :1;
        unsigned IOCCN3                 :1;
        unsigned IOCCN4                 :1;
        unsigned IOCCN5                 :1;
        unsigned IOCCN6                 :1;
        unsigned IOCCN7                 :1;
    };
} IOCCNbits_t;
extern volatile IOCCNbits_t IOCCNbits @ 0x398;
// bitfield macros
#define _IOCCN_IOCCN0_POSN                                  0x0
#define _IOCCN_IOCCN0_POSITION                              0x0
#define _IOCCN_IOCCN0_SIZE                                  0x1
#define _IOCCN_IOCCN0_LENGTH                                0x1
#define _IOCCN_IOCCN0_MASK                                  0x1
#define _IOCCN_IOCCN1_POSN                                  0x1
#define _IOCCN_IOCCN1_POSITION                              0x1
#define _IOCCN_IOCCN1_SIZE                                  0x1
#define _IOCCN_IOCCN1_LENGTH                                0x1
#define _IOCCN_IOCCN1_MASK                                  0x2
#define _IOCCN_IOCCN2_POSN                                  0x2
#define _IOCCN_IOCCN2_POSITION                              0x2
#define _IOCCN_IOCCN2_SIZE                                  0x1
#define _IOCCN_IOCCN2_LENGTH                                0x1
#define _IOCCN_IOCCN2_MASK                                  0x4
#define _IOCCN_IOCCN3_POSN                                  0x3
#define _IOCCN_IOCCN3_POSITION                              0x3
#define _IOCCN_IOCCN3_SIZE                                  0x1
#define _IOCCN_IOCCN3_LENGTH                                0x1
#define _IOCCN_IOCCN3_MASK                                  0x8
#define _IOCCN_IOCCN4_POSN                                  0x4
#define _IOCCN_IOCCN4_POSITION                              0x4
#define _IOCCN_IOCCN4_SIZE                                  0x1
#define _IOCCN_IOCCN4_LENGTH                                0x1
#define _IOCCN_IOCCN4_MASK                                  0x10
#define _IOCCN_IOCCN5_POSN                                  0x5
#define _IOCCN_IOCCN5_POSITION                              0x5
#define _IOCCN_IOCCN5_SIZE                                  0x1
#define _IOCCN_IOCCN5_LENGTH                                0x1
#define _IOCCN_IOCCN5_MASK                                  0x20
#define _IOCCN_IOCCN6_POSN                                  0x6
#define _IOCCN_IOCCN6_POSITION                              0x6
#define _IOCCN_IOCCN6_SIZE                                  0x1
#define _IOCCN_IOCCN6_LENGTH                                0x1
#define _IOCCN_IOCCN6_MASK                                  0x40
#define _IOCCN_IOCCN7_POSN                                  0x7
#define _IOCCN_IOCCN7_POSITION                              0x7
#define _IOCCN_IOCCN7_SIZE                                  0x1
#define _IOCCN_IOCCN7_LENGTH                                0x1
#define _IOCCN_IOCCN7_MASK                                  0x80

// Register: IOCCF
extern volatile unsigned char           IOCCF               @ 0x399;
#ifndef _LIB_BUILD
asm("IOCCF equ 0399h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned IOCCF0                 :1;
        unsigned IOCCF1                 :1;
        unsigned IOCCF2                 :1;
        unsigned IOCCF3                 :1;
        unsigned IOCCF4                 :1;
        unsigned IOCCF5                 :1;
        unsigned IOCCF6                 :1;
        unsigned IOCCF7                 :1;
    };
} IOCCFbits_t;
extern volatile IOCCFbits_t IOCCFbits @ 0x399;
// bitfield macros
#define _IOCCF_IOCCF0_POSN                                  0x0
#define _IOCCF_IOCCF0_POSITION                              0x0
#define _IOCCF_IOCCF0_SIZE                                  0x1
#define _IOCCF_IOCCF0_LENGTH                                0x1
#define _IOCCF_IOCCF0_MASK                                  0x1
#define _IOCCF_IOCCF1_POSN                                  0x1
#define _IOCCF_IOCCF1_POSITION                              0x1
#define _IOCCF_IOCCF1_SIZE                                  0x1
#define _IOCCF_IOCCF1_LENGTH                                0x1
#define _IOCCF_IOCCF1_MASK                                  0x2
#define _IOCCF_IOCCF2_POSN                                  0x2
#define _IOCCF_IOCCF2_POSITION                              0x2
#define _IOCCF_IOCCF2_SIZE                                  0x1
#define _IOCCF_IOCCF2_LENGTH                                0x1
#define _IOCCF_IOCCF2_MASK                                  0x4
#define _IOCCF_IOCCF3_POSN                                  0x3
#define _IOCCF_IOCCF3_POSITION                              0x3
#define _IOCCF_IOCCF3_SIZE                                  0x1
#define _IOCCF_IOCCF3_LENGTH                                0x1
#define _IOCCF_IOCCF3_MASK                                  0x8
#define _IOCCF_IOCCF4_POSN                                  0x4
#define _IOCCF_IOCCF4_POSITION                              0x4
#define _IOCCF_IOCCF4_SIZE                                  0x1
#define _IOCCF_IOCCF4_LENGTH                                0x1
#define _IOCCF_IOCCF4_MASK                                  0x10
#define _IOCCF_IOCCF5_POSN                                  0x5
#define _IOCCF_IOCCF5_POSITION                              0x5
#define _IOCCF_IOCCF5_SIZE                                  0x1
#define _IOCCF_IOCCF5_LENGTH                                0x1
#define _IOCCF_IOCCF5_MASK                                  0x20
#define _IOCCF_IOCCF6_POSN                                  0x6
#define _IOCCF_IOCCF6_POSITION                              0x6
#define _IOCCF_IOCCF6_SIZE                                  0x1
#define _IOCCF_IOCCF6_LENGTH                                0x1
#define _IOCCF_IOCCF6_MASK                                  0x40
#define _IOCCF_IOCCF7_POSN                                  0x7
#define _IOCCF_IOCCF7_POSITION                              0x7
#define _IOCCF_IOCCF7_SIZE                                  0x1
#define _IOCCF_IOCCF7_LENGTH                                0x1
#define _IOCCF_IOCCF7_MASK                                  0x80

// Register: HIDRVC
extern volatile unsigned char           HIDRVC              @ 0x40E;
#ifndef _LIB_BUILD
asm("HIDRVC equ 040Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned HIDC4                  :1;
        unsigned HIDC5                  :1;
    };
} HIDRVCbits_t;
extern volatile HIDRVCbits_t HIDRVCbits @ 0x40E;
// bitfield macros
#define _HIDRVC_HIDC4_POSN                                  0x4
#define _HIDRVC_HIDC4_POSITION                              0x4
#define _HIDRVC_HIDC4_SIZE                                  0x1
#define _HIDRVC_HIDC4_LENGTH                                0x1
#define _HIDRVC_HIDC4_MASK                                  0x10
#define _HIDRVC_HIDC5_POSN                                  0x5
#define _HIDRVC_HIDC5_POSITION                              0x5
#define _HIDRVC_HIDC5_SIZE                                  0x1
#define _HIDRVC_HIDC5_LENGTH                                0x1
#define _HIDRVC_HIDC5_MASK                                  0x20

// Register: T4TMR
extern volatile unsigned char           T4TMR               @ 0x413;
#ifndef _LIB_BUILD
asm("T4TMR equ 0413h");
#endif
// aliases
extern volatile unsigned char           TMR4                @ 0x413;
#ifndef _LIB_BUILD
asm("TMR4 equ 0413h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR                    :8;
    };
    struct {
        unsigned TMR4                   :8;
    };
} T4TMRbits_t;
extern volatile T4TMRbits_t T4TMRbits @ 0x413;
// bitfield macros
#define _T4TMR_TMR_POSN                                     0x0
#define _T4TMR_TMR_POSITION                                 0x0
#define _T4TMR_TMR_SIZE                                     0x8
#define _T4TMR_TMR_LENGTH                                   0x8
#define _T4TMR_TMR_MASK                                     0xFF
#define _T4TMR_TMR4_POSN                                    0x0
#define _T4TMR_TMR4_POSITION                                0x0
#define _T4TMR_TMR4_SIZE                                    0x8
#define _T4TMR_TMR4_LENGTH                                  0x8
#define _T4TMR_TMR4_MASK                                    0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned TMR                    :8;
    };
    struct {
        unsigned TMR4                   :8;
    };
} TMR4bits_t;
extern volatile TMR4bits_t TMR4bits @ 0x413;
// bitfield macros
#define _TMR4_TMR_POSN                                      0x0
#define _TMR4_TMR_POSITION                                  0x0
#define _TMR4_TMR_SIZE                                      0x8
#define _TMR4_TMR_LENGTH                                    0x8
#define _TMR4_TMR_MASK                                      0xFF
#define _TMR4_TMR4_POSN                                     0x0
#define _TMR4_TMR4_POSITION                                 0x0
#define _TMR4_TMR4_SIZE                                     0x8
#define _TMR4_TMR4_LENGTH                                   0x8
#define _TMR4_TMR4_MASK                                     0xFF

// Register: T4PR
extern volatile unsigned char           T4PR                @ 0x414;
#ifndef _LIB_BUILD
asm("T4PR equ 0414h");
#endif
// aliases
extern volatile unsigned char           PR4                 @ 0x414;
#ifndef _LIB_BUILD
asm("PR4 equ 0414h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PR                     :8;
    };
    struct {
        unsigned T4PR                   :8;
    };
} T4PRbits_t;
extern volatile T4PRbits_t T4PRbits @ 0x414;
// bitfield macros
#define _T4PR_PR_POSN                                       0x0
#define _T4PR_PR_POSITION                                   0x0
#define _T4PR_PR_SIZE                                       0x8
#define _T4PR_PR_LENGTH                                     0x8
#define _T4PR_PR_MASK                                       0xFF
#define _T4PR_T4PR_POSN                                     0x0
#define _T4PR_T4PR_POSITION                                 0x0
#define _T4PR_T4PR_SIZE                                     0x8
#define _T4PR_T4PR_LENGTH                                   0x8
#define _T4PR_T4PR_MASK                                     0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned PR                     :8;
    };
    struct {
        unsigned T4PR                   :8;
    };
} PR4bits_t;
extern volatile PR4bits_t PR4bits @ 0x414;
// bitfield macros
#define _PR4_PR_POSN                                        0x0
#define _PR4_PR_POSITION                                    0x0
#define _PR4_PR_SIZE                                        0x8
#define _PR4_PR_LENGTH                                      0x8
#define _PR4_PR_MASK                                        0xFF
#define _PR4_T4PR_POSN                                      0x0
#define _PR4_T4PR_POSITION                                  0x0
#define _PR4_T4PR_SIZE                                      0x8
#define _PR4_T4PR_LENGTH                                    0x8
#define _PR4_T4PR_MASK                                      0xFF

// Register: T4CON
extern volatile unsigned char           T4CON               @ 0x415;
#ifndef _LIB_BUILD
asm("T4CON equ 0415h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned OUTPS                  :4;
        unsigned CKPS                   :3;
        unsigned ON                     :1;
    };
    struct {
        unsigned OUTPS0                 :1;
        unsigned OUTPS1                 :1;
        unsigned OUTPS2                 :1;
        unsigned OUTPS3                 :1;
        unsigned CKPS0                  :1;
        unsigned CKPS1                  :1;
        unsigned CKPS2                  :1;
    };
    struct {
        unsigned T4OUTPS                :4;
        unsigned T4CKPS                 :3;
        unsigned T4ON                   :1;
    };
    struct {
        unsigned T4OUTPS0               :1;
        unsigned T4OUTPS1               :1;
        unsigned T4OUTPS2               :1;
        unsigned T4OUTPS3               :1;
        unsigned T4CKPS0                :1;
        unsigned T4CKPS1                :1;
        unsigned T4CKPS2                :1;
        unsigned TMR4ON                 :1;
    };
} T4CONbits_t;
extern volatile T4CONbits_t T4CONbits @ 0x415;
// bitfield macros
#define _T4CON_OUTPS_POSN                                   0x0
#define _T4CON_OUTPS_POSITION                               0x0
#define _T4CON_OUTPS_SIZE                                   0x4
#define _T4CON_OUTPS_LENGTH                                 0x4
#define _T4CON_OUTPS_MASK                                   0xF
#define _T4CON_CKPS_POSN                                    0x4
#define _T4CON_CKPS_POSITION                                0x4
#define _T4CON_CKPS_SIZE                                    0x3
#define _T4CON_CKPS_LENGTH                                  0x3
#define _T4CON_CKPS_MASK                                    0x70
#define _T4CON_ON_POSN                                      0x7
#define _T4CON_ON_POSITION                                  0x7
#define _T4CON_ON_SIZE                                      0x1
#define _T4CON_ON_LENGTH                                    0x1
#define _T4CON_ON_MASK                                      0x80
#define _T4CON_OUTPS0_POSN                                  0x0
#define _T4CON_OUTPS0_POSITION                              0x0
#define _T4CON_OUTPS0_SIZE                                  0x1
#define _T4CON_OUTPS0_LENGTH                                0x1
#define _T4CON_OUTPS0_MASK                                  0x1
#define _T4CON_OUTPS1_POSN                                  0x1
#define _T4CON_OUTPS1_POSITION                              0x1
#define _T4CON_OUTPS1_SIZE                                  0x1
#define _T4CON_OUTPS1_LENGTH                                0x1
#define _T4CON_OUTPS1_MASK                                  0x2
#define _T4CON_OUTPS2_POSN                                  0x2
#define _T4CON_OUTPS2_POSITION                              0x2
#define _T4CON_OUTPS2_SIZE                                  0x1
#define _T4CON_OUTPS2_LENGTH                                0x1
#define _T4CON_OUTPS2_MASK                                  0x4
#define _T4CON_OUTPS3_POSN                                  0x3
#define _T4CON_OUTPS3_POSITION                              0x3
#define _T4CON_OUTPS3_SIZE                                  0x1
#define _T4CON_OUTPS3_LENGTH                                0x1
#define _T4CON_OUTPS3_MASK                                  0x8
#define _T4CON_CKPS0_POSN                                   0x4
#define _T4CON_CKPS0_POSITION                               0x4
#define _T4CON_CKPS0_SIZE                                   0x1
#define _T4CON_CKPS0_LENGTH                                 0x1
#define _T4CON_CKPS0_MASK                                   0x10
#define _T4CON_CKPS1_POSN                                   0x5
#define _T4CON_CKPS1_POSITION                               0x5
#define _T4CON_CKPS1_SIZE                                   0x1
#define _T4CON_CKPS1_LENGTH                                 0x1
#define _T4CON_CKPS1_MASK                                   0x20
#define _T4CON_CKPS2_POSN                                   0x6
#define _T4CON_CKPS2_POSITION                               0x6
#define _T4CON_CKPS2_SIZE                                   0x1
#define _T4CON_CKPS2_LENGTH                                 0x1
#define _T4CON_CKPS2_MASK                                   0x40
#define _T4CON_T4OUTPS_POSN                                 0x0
#define _T4CON_T4OUTPS_POSITION                             0x0
#define _T4CON_T4OUTPS_SIZE                                 0x4
#define _T4CON_T4OUTPS_LENGTH                               0x4
#define _T4CON_T4OUTPS_MASK                                 0xF
#define _T4CON_T4CKPS_POSN                                  0x4
#define _T4CON_T4CKPS_POSITION                              0x4
#define _T4CON_T4CKPS_SIZE                                  0x3
#define _T4CON_T4CKPS_LENGTH                                0x3
#define _T4CON_T4CKPS_MASK                                  0x70
#define _T4CON_T4ON_POSN                                    0x7
#define _T4CON_T4ON_POSITION                                0x7
#define _T4CON_T4ON_SIZE                                    0x1
#define _T4CON_T4ON_LENGTH                                  0x1
#define _T4CON_T4ON_MASK                                    0x80
#define _T4CON_T4OUTPS0_POSN                                0x0
#define _T4CON_T4OUTPS0_POSITION                            0x0
#define _T4CON_T4OUTPS0_SIZE                                0x1
#define _T4CON_T4OUTPS0_LENGTH                              0x1
#define _T4CON_T4OUTPS0_MASK                                0x1
#define _T4CON_T4OUTPS1_POSN                                0x1
#define _T4CON_T4OUTPS1_POSITION                            0x1
#define _T4CON_T4OUTPS1_SIZE                                0x1
#define _T4CON_T4OUTPS1_LENGTH                              0x1
#define _T4CON_T4OUTPS1_MASK                                0x2
#define _T4CON_T4OUTPS2_POSN                                0x2
#define _T4CON_T4OUTPS2_POSITION                            0x2
#define _T4CON_T4OUTPS2_SIZE                                0x1
#define _T4CON_T4OUTPS2_LENGTH                              0x1
#define _T4CON_T4OUTPS2_MASK                                0x4
#define _T4CON_T4OUTPS3_POSN                                0x3
#define _T4CON_T4OUTPS3_POSITION                            0x3
#define _T4CON_T4OUTPS3_SIZE                                0x1
#define _T4CON_T4OUTPS3_LENGTH                              0x1
#define _T4CON_T4OUTPS3_MASK                                0x8
#define _T4CON_T4CKPS0_POSN                                 0x4
#define _T4CON_T4CKPS0_POSITION                             0x4
#define _T4CON_T4CKPS0_SIZE                                 0x1
#define _T4CON_T4CKPS0_LENGTH                               0x1
#define _T4CON_T4CKPS0_MASK                                 0x10
#define _T4CON_T4CKPS1_POSN                                 0x5
#define _T4CON_T4CKPS1_POSITION                             0x5
#define _T4CON_T4CKPS1_SIZE                                 0x1
#define _T4CON_T4CKPS1_LENGTH                               0x1
#define _T4CON_T4CKPS1_MASK                                 0x20
#define _T4CON_T4CKPS2_POSN                                 0x6
#define _T4CON_T4CKPS2_POSITION                             0x6
#define _T4CON_T4CKPS2_SIZE                                 0x1
#define _T4CON_T4CKPS2_LENGTH                               0x1
#define _T4CON_T4CKPS2_MASK                                 0x40
#define _T4CON_TMR4ON_POSN                                  0x7
#define _T4CON_TMR4ON_POSITION                              0x7
#define _T4CON_TMR4ON_SIZE                                  0x1
#define _T4CON_TMR4ON_LENGTH                                0x1
#define _T4CON_TMR4ON_MASK                                  0x80

// Register: T4HLT
extern volatile unsigned char           T4HLT               @ 0x416;
#ifndef _LIB_BUILD
asm("T4HLT equ 0416h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned MODE                   :5;
        unsigned CKSYNC                 :1;
        unsigned CKPOL                  :1;
        unsigned PSYNC                  :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
        unsigned MODE3                  :1;
        unsigned MODE4                  :1;
    };
    struct {
        unsigned T4MODE                 :5;
        unsigned T4CKSYNC               :1;
        unsigned T4CKPOL                :1;
        unsigned T4PSYNC                :1;
    };
    struct {
        unsigned T4MODE0                :1;
        unsigned T4MODE1                :1;
        unsigned T4MODE2                :1;
        unsigned T4MODE3                :1;
        unsigned T4MODE4                :1;
    };
} T4HLTbits_t;
extern volatile T4HLTbits_t T4HLTbits @ 0x416;
// bitfield macros
#define _T4HLT_MODE_POSN                                    0x0
#define _T4HLT_MODE_POSITION                                0x0
#define _T4HLT_MODE_SIZE                                    0x5
#define _T4HLT_MODE_LENGTH                                  0x5
#define _T4HLT_MODE_MASK                                    0x1F
#define _T4HLT_CKSYNC_POSN                                  0x5
#define _T4HLT_CKSYNC_POSITION                              0x5
#define _T4HLT_CKSYNC_SIZE                                  0x1
#define _T4HLT_CKSYNC_LENGTH                                0x1
#define _T4HLT_CKSYNC_MASK                                  0x20
#define _T4HLT_CKPOL_POSN                                   0x6
#define _T4HLT_CKPOL_POSITION                               0x6
#define _T4HLT_CKPOL_SIZE                                   0x1
#define _T4HLT_CKPOL_LENGTH                                 0x1
#define _T4HLT_CKPOL_MASK                                   0x40
#define _T4HLT_PSYNC_POSN                                   0x7
#define _T4HLT_PSYNC_POSITION                               0x7
#define _T4HLT_PSYNC_SIZE                                   0x1
#define _T4HLT_PSYNC_LENGTH                                 0x1
#define _T4HLT_PSYNC_MASK                                   0x80
#define _T4HLT_MODE0_POSN                                   0x0
#define _T4HLT_MODE0_POSITION                               0x0
#define _T4HLT_MODE0_SIZE                                   0x1
#define _T4HLT_MODE0_LENGTH                                 0x1
#define _T4HLT_MODE0_MASK                                   0x1
#define _T4HLT_MODE1_POSN                                   0x1
#define _T4HLT_MODE1_POSITION                               0x1
#define _T4HLT_MODE1_SIZE                                   0x1
#define _T4HLT_MODE1_LENGTH                                 0x1
#define _T4HLT_MODE1_MASK                                   0x2
#define _T4HLT_MODE2_POSN                                   0x2
#define _T4HLT_MODE2_POSITION                               0x2
#define _T4HLT_MODE2_SIZE                                   0x1
#define _T4HLT_MODE2_LENGTH                                 0x1
#define _T4HLT_MODE2_MASK                                   0x4
#define _T4HLT_MODE3_POSN                                   0x3
#define _T4HLT_MODE3_POSITION                               0x3
#define _T4HLT_MODE3_SIZE                                   0x1
#define _T4HLT_MODE3_LENGTH                                 0x1
#define _T4HLT_MODE3_MASK                                   0x8
#define _T4HLT_MODE4_POSN                                   0x4
#define _T4HLT_MODE4_POSITION                               0x4
#define _T4HLT_MODE4_SIZE                                   0x1
#define _T4HLT_MODE4_LENGTH                                 0x1
#define _T4HLT_MODE4_MASK                                   0x10
#define _T4HLT_T4MODE_POSN                                  0x0
#define _T4HLT_T4MODE_POSITION                              0x0
#define _T4HLT_T4MODE_SIZE                                  0x5
#define _T4HLT_T4MODE_LENGTH                                0x5
#define _T4HLT_T4MODE_MASK                                  0x1F
#define _T4HLT_T4CKSYNC_POSN                                0x5
#define _T4HLT_T4CKSYNC_POSITION                            0x5
#define _T4HLT_T4CKSYNC_SIZE                                0x1
#define _T4HLT_T4CKSYNC_LENGTH                              0x1
#define _T4HLT_T4CKSYNC_MASK                                0x20
#define _T4HLT_T4CKPOL_POSN                                 0x6
#define _T4HLT_T4CKPOL_POSITION                             0x6
#define _T4HLT_T4CKPOL_SIZE                                 0x1
#define _T4HLT_T4CKPOL_LENGTH                               0x1
#define _T4HLT_T4CKPOL_MASK                                 0x40
#define _T4HLT_T4PSYNC_POSN                                 0x7
#define _T4HLT_T4PSYNC_POSITION                             0x7
#define _T4HLT_T4PSYNC_SIZE                                 0x1
#define _T4HLT_T4PSYNC_LENGTH                               0x1
#define _T4HLT_T4PSYNC_MASK                                 0x80
#define _T4HLT_T4MODE0_POSN                                 0x0
#define _T4HLT_T4MODE0_POSITION                             0x0
#define _T4HLT_T4MODE0_SIZE                                 0x1
#define _T4HLT_T4MODE0_LENGTH                               0x1
#define _T4HLT_T4MODE0_MASK                                 0x1
#define _T4HLT_T4MODE1_POSN                                 0x1
#define _T4HLT_T4MODE1_POSITION                             0x1
#define _T4HLT_T4MODE1_SIZE                                 0x1
#define _T4HLT_T4MODE1_LENGTH                               0x1
#define _T4HLT_T4MODE1_MASK                                 0x2
#define _T4HLT_T4MODE2_POSN                                 0x2
#define _T4HLT_T4MODE2_POSITION                             0x2
#define _T4HLT_T4MODE2_SIZE                                 0x1
#define _T4HLT_T4MODE2_LENGTH                               0x1
#define _T4HLT_T4MODE2_MASK                                 0x4
#define _T4HLT_T4MODE3_POSN                                 0x3
#define _T4HLT_T4MODE3_POSITION                             0x3
#define _T4HLT_T4MODE3_SIZE                                 0x1
#define _T4HLT_T4MODE3_LENGTH                               0x1
#define _T4HLT_T4MODE3_MASK                                 0x8
#define _T4HLT_T4MODE4_POSN                                 0x4
#define _T4HLT_T4MODE4_POSITION                             0x4
#define _T4HLT_T4MODE4_SIZE                                 0x1
#define _T4HLT_T4MODE4_LENGTH                               0x1
#define _T4HLT_T4MODE4_MASK                                 0x10

// Register: T4CLKCON
extern volatile unsigned char           T4CLKCON            @ 0x417;
#ifndef _LIB_BUILD
asm("T4CLKCON equ 0417h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CS                     :4;
    };
    struct {
        unsigned CS0                    :1;
        unsigned CS1                    :1;
        unsigned CS2                    :1;
        unsigned CS3                    :1;
    };
    struct {
        unsigned T4CS                   :4;
    };
    struct {
        unsigned T4CS0                  :1;
        unsigned T4CS1                  :1;
        unsigned T4CS2                  :1;
        unsigned T4CS3                  :1;
    };
} T4CLKCONbits_t;
extern volatile T4CLKCONbits_t T4CLKCONbits @ 0x417;
// bitfield macros
#define _T4CLKCON_CS_POSN                                   0x0
#define _T4CLKCON_CS_POSITION                               0x0
#define _T4CLKCON_CS_SIZE                                   0x4
#define _T4CLKCON_CS_LENGTH                                 0x4
#define _T4CLKCON_CS_MASK                                   0xF
#define _T4CLKCON_CS0_POSN                                  0x0
#define _T4CLKCON_CS0_POSITION                              0x0
#define _T4CLKCON_CS0_SIZE                                  0x1
#define _T4CLKCON_CS0_LENGTH                                0x1
#define _T4CLKCON_CS0_MASK                                  0x1
#define _T4CLKCON_CS1_POSN                                  0x1
#define _T4CLKCON_CS1_POSITION                              0x1
#define _T4CLKCON_CS1_SIZE                                  0x1
#define _T4CLKCON_CS1_LENGTH                                0x1
#define _T4CLKCON_CS1_MASK                                  0x2
#define _T4CLKCON_CS2_POSN                                  0x2
#define _T4CLKCON_CS2_POSITION                              0x2
#define _T4CLKCON_CS2_SIZE                                  0x1
#define _T4CLKCON_CS2_LENGTH                                0x1
#define _T4CLKCON_CS2_MASK                                  0x4
#define _T4CLKCON_CS3_POSN                                  0x3
#define _T4CLKCON_CS3_POSITION                              0x3
#define _T4CLKCON_CS3_SIZE                                  0x1
#define _T4CLKCON_CS3_LENGTH                                0x1
#define _T4CLKCON_CS3_MASK                                  0x8
#define _T4CLKCON_T4CS_POSN                                 0x0
#define _T4CLKCON_T4CS_POSITION                             0x0
#define _T4CLKCON_T4CS_SIZE                                 0x4
#define _T4CLKCON_T4CS_LENGTH                               0x4
#define _T4CLKCON_T4CS_MASK                                 0xF
#define _T4CLKCON_T4CS0_POSN                                0x0
#define _T4CLKCON_T4CS0_POSITION                            0x0
#define _T4CLKCON_T4CS0_SIZE                                0x1
#define _T4CLKCON_T4CS0_LENGTH                              0x1
#define _T4CLKCON_T4CS0_MASK                                0x1
#define _T4CLKCON_T4CS1_POSN                                0x1
#define _T4CLKCON_T4CS1_POSITION                            0x1
#define _T4CLKCON_T4CS1_SIZE                                0x1
#define _T4CLKCON_T4CS1_LENGTH                              0x1
#define _T4CLKCON_T4CS1_MASK                                0x2
#define _T4CLKCON_T4CS2_POSN                                0x2
#define _T4CLKCON_T4CS2_POSITION                            0x2
#define _T4CLKCON_T4CS2_SIZE                                0x1
#define _T4CLKCON_T4CS2_LENGTH                              0x1
#define _T4CLKCON_T4CS2_MASK                                0x4
#define _T4CLKCON_T4CS3_POSN                                0x3
#define _T4CLKCON_T4CS3_POSITION                            0x3
#define _T4CLKCON_T4CS3_SIZE                                0x1
#define _T4CLKCON_T4CS3_LENGTH                              0x1
#define _T4CLKCON_T4CS3_MASK                                0x8

// Register: T4RST
extern volatile unsigned char           T4RST               @ 0x418;
#ifndef _LIB_BUILD
asm("T4RST equ 0418h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RSEL                   :4;
    };
    struct {
        unsigned RSEL0                  :1;
        unsigned RSEL1                  :1;
        unsigned RSEL2                  :1;
        unsigned RSEL3                  :1;
    };
    struct {
        unsigned T4RSEL                 :4;
    };
    struct {
        unsigned T4RSEL0                :1;
        unsigned T4RSEL1                :1;
        unsigned T4RSEL2                :1;
        unsigned T4RSEL3                :1;
    };
} T4RSTbits_t;
extern volatile T4RSTbits_t T4RSTbits @ 0x418;
// bitfield macros
#define _T4RST_RSEL_POSN                                    0x0
#define _T4RST_RSEL_POSITION                                0x0
#define _T4RST_RSEL_SIZE                                    0x4
#define _T4RST_RSEL_LENGTH                                  0x4
#define _T4RST_RSEL_MASK                                    0xF
#define _T4RST_RSEL0_POSN                                   0x0
#define _T4RST_RSEL0_POSITION                               0x0
#define _T4RST_RSEL0_SIZE                                   0x1
#define _T4RST_RSEL0_LENGTH                                 0x1
#define _T4RST_RSEL0_MASK                                   0x1
#define _T4RST_RSEL1_POSN                                   0x1
#define _T4RST_RSEL1_POSITION                               0x1
#define _T4RST_RSEL1_SIZE                                   0x1
#define _T4RST_RSEL1_LENGTH                                 0x1
#define _T4RST_RSEL1_MASK                                   0x2
#define _T4RST_RSEL2_POSN                                   0x2
#define _T4RST_RSEL2_POSITION                               0x2
#define _T4RST_RSEL2_SIZE                                   0x1
#define _T4RST_RSEL2_LENGTH                                 0x1
#define _T4RST_RSEL2_MASK                                   0x4
#define _T4RST_RSEL3_POSN                                   0x3
#define _T4RST_RSEL3_POSITION                               0x3
#define _T4RST_RSEL3_SIZE                                   0x1
#define _T4RST_RSEL3_LENGTH                                 0x1
#define _T4RST_RSEL3_MASK                                   0x8
#define _T4RST_T4RSEL_POSN                                  0x0
#define _T4RST_T4RSEL_POSITION                              0x0
#define _T4RST_T4RSEL_SIZE                                  0x4
#define _T4RST_T4RSEL_LENGTH                                0x4
#define _T4RST_T4RSEL_MASK                                  0xF
#define _T4RST_T4RSEL0_POSN                                 0x0
#define _T4RST_T4RSEL0_POSITION                             0x0
#define _T4RST_T4RSEL0_SIZE                                 0x1
#define _T4RST_T4RSEL0_LENGTH                               0x1
#define _T4RST_T4RSEL0_MASK                                 0x1
#define _T4RST_T4RSEL1_POSN                                 0x1
#define _T4RST_T4RSEL1_POSITION                             0x1
#define _T4RST_T4RSEL1_SIZE                                 0x1
#define _T4RST_T4RSEL1_LENGTH                               0x1
#define _T4RST_T4RSEL1_MASK                                 0x2
#define _T4RST_T4RSEL2_POSN                                 0x2
#define _T4RST_T4RSEL2_POSITION                             0x2
#define _T4RST_T4RSEL2_SIZE                                 0x1
#define _T4RST_T4RSEL2_LENGTH                               0x1
#define _T4RST_T4RSEL2_MASK                                 0x4
#define _T4RST_T4RSEL3_POSN                                 0x3
#define _T4RST_T4RSEL3_POSITION                             0x3
#define _T4RST_T4RSEL3_SIZE                                 0x1
#define _T4RST_T4RSEL3_LENGTH                               0x1
#define _T4RST_T4RSEL3_MASK                                 0x8

// Register: T6TMR
extern volatile unsigned char           T6TMR               @ 0x41A;
#ifndef _LIB_BUILD
asm("T6TMR equ 041Ah");
#endif
// aliases
extern volatile unsigned char           TMR6                @ 0x41A;
#ifndef _LIB_BUILD
asm("TMR6 equ 041Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR                    :8;
    };
    struct {
        unsigned TMR6                   :8;
    };
} T6TMRbits_t;
extern volatile T6TMRbits_t T6TMRbits @ 0x41A;
// bitfield macros
#define _T6TMR_TMR_POSN                                     0x0
#define _T6TMR_TMR_POSITION                                 0x0
#define _T6TMR_TMR_SIZE                                     0x8
#define _T6TMR_TMR_LENGTH                                   0x8
#define _T6TMR_TMR_MASK                                     0xFF
#define _T6TMR_TMR6_POSN                                    0x0
#define _T6TMR_TMR6_POSITION                                0x0
#define _T6TMR_TMR6_SIZE                                    0x8
#define _T6TMR_TMR6_LENGTH                                  0x8
#define _T6TMR_TMR6_MASK                                    0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned TMR                    :8;
    };
    struct {
        unsigned TMR6                   :8;
    };
} TMR6bits_t;
extern volatile TMR6bits_t TMR6bits @ 0x41A;
// bitfield macros
#define _TMR6_TMR_POSN                                      0x0
#define _TMR6_TMR_POSITION                                  0x0
#define _TMR6_TMR_SIZE                                      0x8
#define _TMR6_TMR_LENGTH                                    0x8
#define _TMR6_TMR_MASK                                      0xFF
#define _TMR6_TMR6_POSN                                     0x0
#define _TMR6_TMR6_POSITION                                 0x0
#define _TMR6_TMR6_SIZE                                     0x8
#define _TMR6_TMR6_LENGTH                                   0x8
#define _TMR6_TMR6_MASK                                     0xFF

// Register: T6PR
extern volatile unsigned char           T6PR                @ 0x41B;
#ifndef _LIB_BUILD
asm("T6PR equ 041Bh");
#endif
// aliases
extern volatile unsigned char           PR6                 @ 0x41B;
#ifndef _LIB_BUILD
asm("PR6 equ 041Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PR                     :8;
    };
    struct {
        unsigned T6PR                   :8;
    };
} T6PRbits_t;
extern volatile T6PRbits_t T6PRbits @ 0x41B;
// bitfield macros
#define _T6PR_PR_POSN                                       0x0
#define _T6PR_PR_POSITION                                   0x0
#define _T6PR_PR_SIZE                                       0x8
#define _T6PR_PR_LENGTH                                     0x8
#define _T6PR_PR_MASK                                       0xFF
#define _T6PR_T6PR_POSN                                     0x0
#define _T6PR_T6PR_POSITION                                 0x0
#define _T6PR_T6PR_SIZE                                     0x8
#define _T6PR_T6PR_LENGTH                                   0x8
#define _T6PR_T6PR_MASK                                     0xFF
// alias bitfield definitions
typedef union {
    struct {
        unsigned PR                     :8;
    };
    struct {
        unsigned T6PR                   :8;
    };
} PR6bits_t;
extern volatile PR6bits_t PR6bits @ 0x41B;
// bitfield macros
#define _PR6_PR_POSN                                        0x0
#define _PR6_PR_POSITION                                    0x0
#define _PR6_PR_SIZE                                        0x8
#define _PR6_PR_LENGTH                                      0x8
#define _PR6_PR_MASK                                        0xFF
#define _PR6_T6PR_POSN                                      0x0
#define _PR6_T6PR_POSITION                                  0x0
#define _PR6_T6PR_SIZE                                      0x8
#define _PR6_T6PR_LENGTH                                    0x8
#define _PR6_T6PR_MASK                                      0xFF

// Register: T6CON
extern volatile unsigned char           T6CON               @ 0x41C;
#ifndef _LIB_BUILD
asm("T6CON equ 041Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned OUTPS                  :4;
        unsigned CKPS                   :3;
        unsigned ON                     :1;
    };
    struct {
        unsigned OUTPS0                 :1;
        unsigned OUTPS1                 :1;
        unsigned OUTPS2                 :1;
        unsigned OUTPS3                 :1;
        unsigned CKPS0                  :1;
        unsigned CKPS1                  :1;
        unsigned CKPS2                  :1;
    };
    struct {
        unsigned T6OUTPS                :4;
        unsigned T6CKPS                 :3;
        unsigned T6ON                   :1;
    };
    struct {
        unsigned T6OUTPS0               :1;
        unsigned T6OUTPS1               :1;
        unsigned T6OUTPS2               :1;
        unsigned T6OUTPS3               :1;
        unsigned T6CKPS0                :1;
        unsigned T6CKPS1                :1;
        unsigned T6CKPS2                :1;
        unsigned TMR6ON                 :1;
    };
} T6CONbits_t;
extern volatile T6CONbits_t T6CONbits @ 0x41C;
// bitfield macros
#define _T6CON_OUTPS_POSN                                   0x0
#define _T6CON_OUTPS_POSITION                               0x0
#define _T6CON_OUTPS_SIZE                                   0x4
#define _T6CON_OUTPS_LENGTH                                 0x4
#define _T6CON_OUTPS_MASK                                   0xF
#define _T6CON_CKPS_POSN                                    0x4
#define _T6CON_CKPS_POSITION                                0x4
#define _T6CON_CKPS_SIZE                                    0x3
#define _T6CON_CKPS_LENGTH                                  0x3
#define _T6CON_CKPS_MASK                                    0x70
#define _T6CON_ON_POSN                                      0x7
#define _T6CON_ON_POSITION                                  0x7
#define _T6CON_ON_SIZE                                      0x1
#define _T6CON_ON_LENGTH                                    0x1
#define _T6CON_ON_MASK                                      0x80
#define _T6CON_OUTPS0_POSN                                  0x0
#define _T6CON_OUTPS0_POSITION                              0x0
#define _T6CON_OUTPS0_SIZE                                  0x1
#define _T6CON_OUTPS0_LENGTH                                0x1
#define _T6CON_OUTPS0_MASK                                  0x1
#define _T6CON_OUTPS1_POSN                                  0x1
#define _T6CON_OUTPS1_POSITION                              0x1
#define _T6CON_OUTPS1_SIZE                                  0x1
#define _T6CON_OUTPS1_LENGTH                                0x1
#define _T6CON_OUTPS1_MASK                                  0x2
#define _T6CON_OUTPS2_POSN                                  0x2
#define _T6CON_OUTPS2_POSITION                              0x2
#define _T6CON_OUTPS2_SIZE                                  0x1
#define _T6CON_OUTPS2_LENGTH                                0x1
#define _T6CON_OUTPS2_MASK                                  0x4
#define _T6CON_OUTPS3_POSN                                  0x3
#define _T6CON_OUTPS3_POSITION                              0x3
#define _T6CON_OUTPS3_SIZE                                  0x1
#define _T6CON_OUTPS3_LENGTH                                0x1
#define _T6CON_OUTPS3_MASK                                  0x8
#define _T6CON_CKPS0_POSN                                   0x4
#define _T6CON_CKPS0_POSITION                               0x4
#define _T6CON_CKPS0_SIZE                                   0x1
#define _T6CON_CKPS0_LENGTH                                 0x1
#define _T6CON_CKPS0_MASK                                   0x10
#define _T6CON_CKPS1_POSN                                   0x5
#define _T6CON_CKPS1_POSITION                               0x5
#define _T6CON_CKPS1_SIZE                                   0x1
#define _T6CON_CKPS1_LENGTH                                 0x1
#define _T6CON_CKPS1_MASK                                   0x20
#define _T6CON_CKPS2_POSN                                   0x6
#define _T6CON_CKPS2_POSITION                               0x6
#define _T6CON_CKPS2_SIZE                                   0x1
#define _T6CON_CKPS2_LENGTH                                 0x1
#define _T6CON_CKPS2_MASK                                   0x40
#define _T6CON_T6OUTPS_POSN                                 0x0
#define _T6CON_T6OUTPS_POSITION                             0x0
#define _T6CON_T6OUTPS_SIZE                                 0x4
#define _T6CON_T6OUTPS_LENGTH                               0x4
#define _T6CON_T6OUTPS_MASK                                 0xF
#define _T6CON_T6CKPS_POSN                                  0x4
#define _T6CON_T6CKPS_POSITION                              0x4
#define _T6CON_T6CKPS_SIZE                                  0x3
#define _T6CON_T6CKPS_LENGTH                                0x3
#define _T6CON_T6CKPS_MASK                                  0x70
#define _T6CON_T6ON_POSN                                    0x7
#define _T6CON_T6ON_POSITION                                0x7
#define _T6CON_T6ON_SIZE                                    0x1
#define _T6CON_T6ON_LENGTH                                  0x1
#define _T6CON_T6ON_MASK                                    0x80
#define _T6CON_T6OUTPS0_POSN                                0x0
#define _T6CON_T6OUTPS0_POSITION                            0x0
#define _T6CON_T6OUTPS0_SIZE                                0x1
#define _T6CON_T6OUTPS0_LENGTH                              0x1
#define _T6CON_T6OUTPS0_MASK                                0x1
#define _T6CON_T6OUTPS1_POSN                                0x1
#define _T6CON_T6OUTPS1_POSITION                            0x1
#define _T6CON_T6OUTPS1_SIZE                                0x1
#define _T6CON_T6OUTPS1_LENGTH                              0x1
#define _T6CON_T6OUTPS1_MASK                                0x2
#define _T6CON_T6OUTPS2_POSN                                0x2
#define _T6CON_T6OUTPS2_POSITION                            0x2
#define _T6CON_T6OUTPS2_SIZE                                0x1
#define _T6CON_T6OUTPS2_LENGTH                              0x1
#define _T6CON_T6OUTPS2_MASK                                0x4
#define _T6CON_T6OUTPS3_POSN                                0x3
#define _T6CON_T6OUTPS3_POSITION                            0x3
#define _T6CON_T6OUTPS3_SIZE                                0x1
#define _T6CON_T6OUTPS3_LENGTH                              0x1
#define _T6CON_T6OUTPS3_MASK                                0x8
#define _T6CON_T6CKPS0_POSN                                 0x4
#define _T6CON_T6CKPS0_POSITION                             0x4
#define _T6CON_T6CKPS0_SIZE                                 0x1
#define _T6CON_T6CKPS0_LENGTH                               0x1
#define _T6CON_T6CKPS0_MASK                                 0x10
#define _T6CON_T6CKPS1_POSN                                 0x5
#define _T6CON_T6CKPS1_POSITION                             0x5
#define _T6CON_T6CKPS1_SIZE                                 0x1
#define _T6CON_T6CKPS1_LENGTH                               0x1
#define _T6CON_T6CKPS1_MASK                                 0x20
#define _T6CON_T6CKPS2_POSN                                 0x6
#define _T6CON_T6CKPS2_POSITION                             0x6
#define _T6CON_T6CKPS2_SIZE                                 0x1
#define _T6CON_T6CKPS2_LENGTH                               0x1
#define _T6CON_T6CKPS2_MASK                                 0x40
#define _T6CON_TMR6ON_POSN                                  0x7
#define _T6CON_TMR6ON_POSITION                              0x7
#define _T6CON_TMR6ON_SIZE                                  0x1
#define _T6CON_TMR6ON_LENGTH                                0x1
#define _T6CON_TMR6ON_MASK                                  0x80

// Register: T6HLT
extern volatile unsigned char           T6HLT               @ 0x41D;
#ifndef _LIB_BUILD
asm("T6HLT equ 041Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned MODE                   :5;
        unsigned CKSYNC                 :1;
        unsigned CKPOL                  :1;
        unsigned PSYNC                  :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
        unsigned MODE3                  :1;
        unsigned MODE4                  :1;
    };
    struct {
        unsigned T6MODE                 :5;
        unsigned T6CKSYNC               :1;
        unsigned T6CKPOL                :1;
        unsigned T6PSYNC                :1;
    };
    struct {
        unsigned T6MODE0                :1;
        unsigned T6MODE1                :1;
        unsigned T6MODE2                :1;
        unsigned T6MODE3                :1;
        unsigned T6MODE4                :1;
    };
} T6HLTbits_t;
extern volatile T6HLTbits_t T6HLTbits @ 0x41D;
// bitfield macros
#define _T6HLT_MODE_POSN                                    0x0
#define _T6HLT_MODE_POSITION                                0x0
#define _T6HLT_MODE_SIZE                                    0x5
#define _T6HLT_MODE_LENGTH                                  0x5
#define _T6HLT_MODE_MASK                                    0x1F
#define _T6HLT_CKSYNC_POSN                                  0x5
#define _T6HLT_CKSYNC_POSITION                              0x5
#define _T6HLT_CKSYNC_SIZE                                  0x1
#define _T6HLT_CKSYNC_LENGTH                                0x1
#define _T6HLT_CKSYNC_MASK                                  0x20
#define _T6HLT_CKPOL_POSN                                   0x6
#define _T6HLT_CKPOL_POSITION                               0x6
#define _T6HLT_CKPOL_SIZE                                   0x1
#define _T6HLT_CKPOL_LENGTH                                 0x1
#define _T6HLT_CKPOL_MASK                                   0x40
#define _T6HLT_PSYNC_POSN                                   0x7
#define _T6HLT_PSYNC_POSITION                               0x7
#define _T6HLT_PSYNC_SIZE                                   0x1
#define _T6HLT_PSYNC_LENGTH                                 0x1
#define _T6HLT_PSYNC_MASK                                   0x80
#define _T6HLT_MODE0_POSN                                   0x0
#define _T6HLT_MODE0_POSITION                               0x0
#define _T6HLT_MODE0_SIZE                                   0x1
#define _T6HLT_MODE0_LENGTH                                 0x1
#define _T6HLT_MODE0_MASK                                   0x1
#define _T6HLT_MODE1_POSN                                   0x1
#define _T6HLT_MODE1_POSITION                               0x1
#define _T6HLT_MODE1_SIZE                                   0x1
#define _T6HLT_MODE1_LENGTH                                 0x1
#define _T6HLT_MODE1_MASK                                   0x2
#define _T6HLT_MODE2_POSN                                   0x2
#define _T6HLT_MODE2_POSITION                               0x2
#define _T6HLT_MODE2_SIZE                                   0x1
#define _T6HLT_MODE2_LENGTH                                 0x1
#define _T6HLT_MODE2_MASK                                   0x4
#define _T6HLT_MODE3_POSN                                   0x3
#define _T6HLT_MODE3_POSITION                               0x3
#define _T6HLT_MODE3_SIZE                                   0x1
#define _T6HLT_MODE3_LENGTH                                 0x1
#define _T6HLT_MODE3_MASK                                   0x8
#define _T6HLT_MODE4_POSN                                   0x4
#define _T6HLT_MODE4_POSITION                               0x4
#define _T6HLT_MODE4_SIZE                                   0x1
#define _T6HLT_MODE4_LENGTH                                 0x1
#define _T6HLT_MODE4_MASK                                   0x10
#define _T6HLT_T6MODE_POSN                                  0x0
#define _T6HLT_T6MODE_POSITION                              0x0
#define _T6HLT_T6MODE_SIZE                                  0x5
#define _T6HLT_T6MODE_LENGTH                                0x5
#define _T6HLT_T6MODE_MASK                                  0x1F
#define _T6HLT_T6CKSYNC_POSN                                0x5
#define _T6HLT_T6CKSYNC_POSITION                            0x5
#define _T6HLT_T6CKSYNC_SIZE                                0x1
#define _T6HLT_T6CKSYNC_LENGTH                              0x1
#define _T6HLT_T6CKSYNC_MASK                                0x20
#define _T6HLT_T6CKPOL_POSN                                 0x6
#define _T6HLT_T6CKPOL_POSITION                             0x6
#define _T6HLT_T6CKPOL_SIZE                                 0x1
#define _T6HLT_T6CKPOL_LENGTH                               0x1
#define _T6HLT_T6CKPOL_MASK                                 0x40
#define _T6HLT_T6PSYNC_POSN                                 0x7
#define _T6HLT_T6PSYNC_POSITION                             0x7
#define _T6HLT_T6PSYNC_SIZE                                 0x1
#define _T6HLT_T6PSYNC_LENGTH                               0x1
#define _T6HLT_T6PSYNC_MASK                                 0x80
#define _T6HLT_T6MODE0_POSN                                 0x0
#define _T6HLT_T6MODE0_POSITION                             0x0
#define _T6HLT_T6MODE0_SIZE                                 0x1
#define _T6HLT_T6MODE0_LENGTH                               0x1
#define _T6HLT_T6MODE0_MASK                                 0x1
#define _T6HLT_T6MODE1_POSN                                 0x1
#define _T6HLT_T6MODE1_POSITION                             0x1
#define _T6HLT_T6MODE1_SIZE                                 0x1
#define _T6HLT_T6MODE1_LENGTH                               0x1
#define _T6HLT_T6MODE1_MASK                                 0x2
#define _T6HLT_T6MODE2_POSN                                 0x2
#define _T6HLT_T6MODE2_POSITION                             0x2
#define _T6HLT_T6MODE2_SIZE                                 0x1
#define _T6HLT_T6MODE2_LENGTH                               0x1
#define _T6HLT_T6MODE2_MASK                                 0x4
#define _T6HLT_T6MODE3_POSN                                 0x3
#define _T6HLT_T6MODE3_POSITION                             0x3
#define _T6HLT_T6MODE3_SIZE                                 0x1
#define _T6HLT_T6MODE3_LENGTH                               0x1
#define _T6HLT_T6MODE3_MASK                                 0x8
#define _T6HLT_T6MODE4_POSN                                 0x4
#define _T6HLT_T6MODE4_POSITION                             0x4
#define _T6HLT_T6MODE4_SIZE                                 0x1
#define _T6HLT_T6MODE4_LENGTH                               0x1
#define _T6HLT_T6MODE4_MASK                                 0x10

// Register: T6CLKCON
extern volatile unsigned char           T6CLKCON            @ 0x41E;
#ifndef _LIB_BUILD
asm("T6CLKCON equ 041Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CS                     :4;
    };
    struct {
        unsigned CS0                    :1;
        unsigned CS1                    :1;
        unsigned CS2                    :1;
        unsigned CS3                    :1;
    };
    struct {
        unsigned T6CS                   :4;
    };
    struct {
        unsigned T6CS0                  :1;
        unsigned T6CS1                  :1;
        unsigned T6CS2                  :1;
        unsigned T6CS3                  :1;
    };
} T6CLKCONbits_t;
extern volatile T6CLKCONbits_t T6CLKCONbits @ 0x41E;
// bitfield macros
#define _T6CLKCON_CS_POSN                                   0x0
#define _T6CLKCON_CS_POSITION                               0x0
#define _T6CLKCON_CS_SIZE                                   0x4
#define _T6CLKCON_CS_LENGTH                                 0x4
#define _T6CLKCON_CS_MASK                                   0xF
#define _T6CLKCON_CS0_POSN                                  0x0
#define _T6CLKCON_CS0_POSITION                              0x0
#define _T6CLKCON_CS0_SIZE                                  0x1
#define _T6CLKCON_CS0_LENGTH                                0x1
#define _T6CLKCON_CS0_MASK                                  0x1
#define _T6CLKCON_CS1_POSN                                  0x1
#define _T6CLKCON_CS1_POSITION                              0x1
#define _T6CLKCON_CS1_SIZE                                  0x1
#define _T6CLKCON_CS1_LENGTH                                0x1
#define _T6CLKCON_CS1_MASK                                  0x2
#define _T6CLKCON_CS2_POSN                                  0x2
#define _T6CLKCON_CS2_POSITION                              0x2
#define _T6CLKCON_CS2_SIZE                                  0x1
#define _T6CLKCON_CS2_LENGTH                                0x1
#define _T6CLKCON_CS2_MASK                                  0x4
#define _T6CLKCON_CS3_POSN                                  0x3
#define _T6CLKCON_CS3_POSITION                              0x3
#define _T6CLKCON_CS3_SIZE                                  0x1
#define _T6CLKCON_CS3_LENGTH                                0x1
#define _T6CLKCON_CS3_MASK                                  0x8
#define _T6CLKCON_T6CS_POSN                                 0x0
#define _T6CLKCON_T6CS_POSITION                             0x0
#define _T6CLKCON_T6CS_SIZE                                 0x4
#define _T6CLKCON_T6CS_LENGTH                               0x4
#define _T6CLKCON_T6CS_MASK                                 0xF
#define _T6CLKCON_T6CS0_POSN                                0x0
#define _T6CLKCON_T6CS0_POSITION                            0x0
#define _T6CLKCON_T6CS0_SIZE                                0x1
#define _T6CLKCON_T6CS0_LENGTH                              0x1
#define _T6CLKCON_T6CS0_MASK                                0x1
#define _T6CLKCON_T6CS1_POSN                                0x1
#define _T6CLKCON_T6CS1_POSITION                            0x1
#define _T6CLKCON_T6CS1_SIZE                                0x1
#define _T6CLKCON_T6CS1_LENGTH                              0x1
#define _T6CLKCON_T6CS1_MASK                                0x2
#define _T6CLKCON_T6CS2_POSN                                0x2
#define _T6CLKCON_T6CS2_POSITION                            0x2
#define _T6CLKCON_T6CS2_SIZE                                0x1
#define _T6CLKCON_T6CS2_LENGTH                              0x1
#define _T6CLKCON_T6CS2_MASK                                0x4
#define _T6CLKCON_T6CS3_POSN                                0x3
#define _T6CLKCON_T6CS3_POSITION                            0x3
#define _T6CLKCON_T6CS3_SIZE                                0x1
#define _T6CLKCON_T6CS3_LENGTH                              0x1
#define _T6CLKCON_T6CS3_MASK                                0x8

// Register: T6RST
extern volatile unsigned char           T6RST               @ 0x41F;
#ifndef _LIB_BUILD
asm("T6RST equ 041Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RSEL                   :4;
    };
    struct {
        unsigned RSEL0                  :1;
        unsigned RSEL1                  :1;
        unsigned RSEL2                  :1;
        unsigned RSEL3                  :1;
    };
    struct {
        unsigned T6RSEL                 :4;
    };
    struct {
        unsigned T6RSEL0                :1;
        unsigned T6RSEL1                :1;
        unsigned T6RSEL2                :1;
        unsigned T6RSEL3                :1;
    };
} T6RSTbits_t;
extern volatile T6RSTbits_t T6RSTbits @ 0x41F;
// bitfield macros
#define _T6RST_RSEL_POSN                                    0x0
#define _T6RST_RSEL_POSITION                                0x0
#define _T6RST_RSEL_SIZE                                    0x4
#define _T6RST_RSEL_LENGTH                                  0x4
#define _T6RST_RSEL_MASK                                    0xF
#define _T6RST_RSEL0_POSN                                   0x0
#define _T6RST_RSEL0_POSITION                               0x0
#define _T6RST_RSEL0_SIZE                                   0x1
#define _T6RST_RSEL0_LENGTH                                 0x1
#define _T6RST_RSEL0_MASK                                   0x1
#define _T6RST_RSEL1_POSN                                   0x1
#define _T6RST_RSEL1_POSITION                               0x1
#define _T6RST_RSEL1_SIZE                                   0x1
#define _T6RST_RSEL1_LENGTH                                 0x1
#define _T6RST_RSEL1_MASK                                   0x2
#define _T6RST_RSEL2_POSN                                   0x2
#define _T6RST_RSEL2_POSITION                               0x2
#define _T6RST_RSEL2_SIZE                                   0x1
#define _T6RST_RSEL2_LENGTH                                 0x1
#define _T6RST_RSEL2_MASK                                   0x4
#define _T6RST_RSEL3_POSN                                   0x3
#define _T6RST_RSEL3_POSITION                               0x3
#define _T6RST_RSEL3_SIZE                                   0x1
#define _T6RST_RSEL3_LENGTH                                 0x1
#define _T6RST_RSEL3_MASK                                   0x8
#define _T6RST_T6RSEL_POSN                                  0x0
#define _T6RST_T6RSEL_POSITION                              0x0
#define _T6RST_T6RSEL_SIZE                                  0x4
#define _T6RST_T6RSEL_LENGTH                                0x4
#define _T6RST_T6RSEL_MASK                                  0xF
#define _T6RST_T6RSEL0_POSN                                 0x0
#define _T6RST_T6RSEL0_POSITION                             0x0
#define _T6RST_T6RSEL0_SIZE                                 0x1
#define _T6RST_T6RSEL0_LENGTH                               0x1
#define _T6RST_T6RSEL0_MASK                                 0x1
#define _T6RST_T6RSEL1_POSN                                 0x1
#define _T6RST_T6RSEL1_POSITION                             0x1
#define _T6RST_T6RSEL1_SIZE                                 0x1
#define _T6RST_T6RSEL1_LENGTH                               0x1
#define _T6RST_T6RSEL1_MASK                                 0x2
#define _T6RST_T6RSEL2_POSN                                 0x2
#define _T6RST_T6RSEL2_POSITION                             0x2
#define _T6RST_T6RSEL2_SIZE                                 0x1
#define _T6RST_T6RSEL2_LENGTH                               0x1
#define _T6RST_T6RSEL2_MASK                                 0x4
#define _T6RST_T6RSEL3_POSN                                 0x3
#define _T6RST_T6RSEL3_POSITION                             0x3
#define _T6RST_T6RSEL3_SIZE                                 0x1
#define _T6RST_T6RSEL3_LENGTH                               0x1
#define _T6RST_T6RSEL3_MASK                                 0x8

// Register: TMR3L
extern volatile unsigned char           TMR3L               @ 0x493;
#ifndef _LIB_BUILD
asm("TMR3L equ 0493h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR3L                  :8;
    };
} TMR3Lbits_t;
extern volatile TMR3Lbits_t TMR3Lbits @ 0x493;
// bitfield macros
#define _TMR3L_TMR3L_POSN                                   0x0
#define _TMR3L_TMR3L_POSITION                               0x0
#define _TMR3L_TMR3L_SIZE                                   0x8
#define _TMR3L_TMR3L_LENGTH                                 0x8
#define _TMR3L_TMR3L_MASK                                   0xFF

// Register: TMR3H
extern volatile unsigned char           TMR3H               @ 0x494;
#ifndef _LIB_BUILD
asm("TMR3H equ 0494h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR3H                  :8;
    };
} TMR3Hbits_t;
extern volatile TMR3Hbits_t TMR3Hbits @ 0x494;
// bitfield macros
#define _TMR3H_TMR3H_POSN                                   0x0
#define _TMR3H_TMR3H_POSITION                               0x0
#define _TMR3H_TMR3H_SIZE                                   0x8
#define _TMR3H_TMR3H_LENGTH                                 0x8
#define _TMR3H_TMR3H_MASK                                   0xFF

// Register: T3CON
extern volatile unsigned char           T3CON               @ 0x495;
#ifndef _LIB_BUILD
asm("T3CON equ 0495h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR3ON                 :1;
        unsigned                        :1;
        unsigned T3SYNC                 :1;
        unsigned                        :1;
        unsigned T3CKPS                 :2;
        unsigned TMR3CS                 :2;
    };
    struct {
        unsigned                        :4;
        unsigned T3CKPS0                :1;
        unsigned T3CKPS1                :1;
        unsigned TMR3CS0                :1;
        unsigned TMR3CS1                :1;
    };
} T3CONbits_t;
extern volatile T3CONbits_t T3CONbits @ 0x495;
// bitfield macros
#define _T3CON_TMR3ON_POSN                                  0x0
#define _T3CON_TMR3ON_POSITION                              0x0
#define _T3CON_TMR3ON_SIZE                                  0x1
#define _T3CON_TMR3ON_LENGTH                                0x1
#define _T3CON_TMR3ON_MASK                                  0x1
#define _T3CON_T3SYNC_POSN                                  0x2
#define _T3CON_T3SYNC_POSITION                              0x2
#define _T3CON_T3SYNC_SIZE                                  0x1
#define _T3CON_T3SYNC_LENGTH                                0x1
#define _T3CON_T3SYNC_MASK                                  0x4
#define _T3CON_T3CKPS_POSN                                  0x4
#define _T3CON_T3CKPS_POSITION                              0x4
#define _T3CON_T3CKPS_SIZE                                  0x2
#define _T3CON_T3CKPS_LENGTH                                0x2
#define _T3CON_T3CKPS_MASK                                  0x30
#define _T3CON_TMR3CS_POSN                                  0x6
#define _T3CON_TMR3CS_POSITION                              0x6
#define _T3CON_TMR3CS_SIZE                                  0x2
#define _T3CON_TMR3CS_LENGTH                                0x2
#define _T3CON_TMR3CS_MASK                                  0xC0
#define _T3CON_T3CKPS0_POSN                                 0x4
#define _T3CON_T3CKPS0_POSITION                             0x4
#define _T3CON_T3CKPS0_SIZE                                 0x1
#define _T3CON_T3CKPS0_LENGTH                               0x1
#define _T3CON_T3CKPS0_MASK                                 0x10
#define _T3CON_T3CKPS1_POSN                                 0x5
#define _T3CON_T3CKPS1_POSITION                             0x5
#define _T3CON_T3CKPS1_SIZE                                 0x1
#define _T3CON_T3CKPS1_LENGTH                               0x1
#define _T3CON_T3CKPS1_MASK                                 0x20
#define _T3CON_TMR3CS0_POSN                                 0x6
#define _T3CON_TMR3CS0_POSITION                             0x6
#define _T3CON_TMR3CS0_SIZE                                 0x1
#define _T3CON_TMR3CS0_LENGTH                               0x1
#define _T3CON_TMR3CS0_MASK                                 0x40
#define _T3CON_TMR3CS1_POSN                                 0x7
#define _T3CON_TMR3CS1_POSITION                             0x7
#define _T3CON_TMR3CS1_SIZE                                 0x1
#define _T3CON_TMR3CS1_LENGTH                               0x1
#define _T3CON_TMR3CS1_MASK                                 0x80

// Register: T3GCON
extern volatile unsigned char           T3GCON              @ 0x496;
#ifndef _LIB_BUILD
asm("T3GCON equ 0496h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T3GSS                  :2;
        unsigned T3GVAL                 :1;
        unsigned T3GGO_nDONE            :1;
        unsigned T3GSPM                 :1;
        unsigned T3GTM                  :1;
        unsigned T3GPOL                 :1;
        unsigned TMR3GE                 :1;
    };
    struct {
        unsigned T3GSS0                 :1;
        unsigned T3GSS1                 :1;
    };
} T3GCONbits_t;
extern volatile T3GCONbits_t T3GCONbits @ 0x496;
// bitfield macros
#define _T3GCON_T3GSS_POSN                                  0x0
#define _T3GCON_T3GSS_POSITION                              0x0
#define _T3GCON_T3GSS_SIZE                                  0x2
#define _T3GCON_T3GSS_LENGTH                                0x2
#define _T3GCON_T3GSS_MASK                                  0x3
#define _T3GCON_T3GVAL_POSN                                 0x2
#define _T3GCON_T3GVAL_POSITION                             0x2
#define _T3GCON_T3GVAL_SIZE                                 0x1
#define _T3GCON_T3GVAL_LENGTH                               0x1
#define _T3GCON_T3GVAL_MASK                                 0x4
#define _T3GCON_T3GGO_nDONE_POSN                            0x3
#define _T3GCON_T3GGO_nDONE_POSITION                        0x3
#define _T3GCON_T3GGO_nDONE_SIZE                            0x1
#define _T3GCON_T3GGO_nDONE_LENGTH                          0x1
#define _T3GCON_T3GGO_nDONE_MASK                            0x8
#define _T3GCON_T3GSPM_POSN                                 0x4
#define _T3GCON_T3GSPM_POSITION                             0x4
#define _T3GCON_T3GSPM_SIZE                                 0x1
#define _T3GCON_T3GSPM_LENGTH                               0x1
#define _T3GCON_T3GSPM_MASK                                 0x10
#define _T3GCON_T3GTM_POSN                                  0x5
#define _T3GCON_T3GTM_POSITION                              0x5
#define _T3GCON_T3GTM_SIZE                                  0x1
#define _T3GCON_T3GTM_LENGTH                                0x1
#define _T3GCON_T3GTM_MASK                                  0x20
#define _T3GCON_T3GPOL_POSN                                 0x6
#define _T3GCON_T3GPOL_POSITION                             0x6
#define _T3GCON_T3GPOL_SIZE                                 0x1
#define _T3GCON_T3GPOL_LENGTH                               0x1
#define _T3GCON_T3GPOL_MASK                                 0x40
#define _T3GCON_TMR3GE_POSN                                 0x7
#define _T3GCON_TMR3GE_POSITION                             0x7
#define _T3GCON_TMR3GE_SIZE                                 0x1
#define _T3GCON_TMR3GE_LENGTH                               0x1
#define _T3GCON_TMR3GE_MASK                                 0x80
#define _T3GCON_T3GSS0_POSN                                 0x0
#define _T3GCON_T3GSS0_POSITION                             0x0
#define _T3GCON_T3GSS0_SIZE                                 0x1
#define _T3GCON_T3GSS0_LENGTH                               0x1
#define _T3GCON_T3GSS0_MASK                                 0x1
#define _T3GCON_T3GSS1_POSN                                 0x1
#define _T3GCON_T3GSS1_POSITION                             0x1
#define _T3GCON_T3GSS1_SIZE                                 0x1
#define _T3GCON_T3GSS1_LENGTH                               0x1
#define _T3GCON_T3GSS1_MASK                                 0x2

// Register: TMR5L
extern volatile unsigned char           TMR5L               @ 0x49A;
#ifndef _LIB_BUILD
asm("TMR5L equ 049Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR5L                  :8;
    };
} TMR5Lbits_t;
extern volatile TMR5Lbits_t TMR5Lbits @ 0x49A;
// bitfield macros
#define _TMR5L_TMR5L_POSN                                   0x0
#define _TMR5L_TMR5L_POSITION                               0x0
#define _TMR5L_TMR5L_SIZE                                   0x8
#define _TMR5L_TMR5L_LENGTH                                 0x8
#define _TMR5L_TMR5L_MASK                                   0xFF

// Register: TMR5H
extern volatile unsigned char           TMR5H               @ 0x49B;
#ifndef _LIB_BUILD
asm("TMR5H equ 049Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR5H                  :8;
    };
} TMR5Hbits_t;
extern volatile TMR5Hbits_t TMR5Hbits @ 0x49B;
// bitfield macros
#define _TMR5H_TMR5H_POSN                                   0x0
#define _TMR5H_TMR5H_POSITION                               0x0
#define _TMR5H_TMR5H_SIZE                                   0x8
#define _TMR5H_TMR5H_LENGTH                                 0x8
#define _TMR5H_TMR5H_MASK                                   0xFF

// Register: T5CON
extern volatile unsigned char           T5CON               @ 0x49C;
#ifndef _LIB_BUILD
asm("T5CON equ 049Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TMR5ON                 :1;
        unsigned                        :1;
        unsigned T5SYNC                 :1;
        unsigned                        :1;
        unsigned T5CKPS                 :2;
        unsigned TMR5CS                 :2;
    };
    struct {
        unsigned                        :4;
        unsigned T5CKPS0                :1;
        unsigned T5CKPS1                :1;
        unsigned TMR5CS0                :1;
        unsigned TMR5CS1                :1;
    };
} T5CONbits_t;
extern volatile T5CONbits_t T5CONbits @ 0x49C;
// bitfield macros
#define _T5CON_TMR5ON_POSN                                  0x0
#define _T5CON_TMR5ON_POSITION                              0x0
#define _T5CON_TMR5ON_SIZE                                  0x1
#define _T5CON_TMR5ON_LENGTH                                0x1
#define _T5CON_TMR5ON_MASK                                  0x1
#define _T5CON_T5SYNC_POSN                                  0x2
#define _T5CON_T5SYNC_POSITION                              0x2
#define _T5CON_T5SYNC_SIZE                                  0x1
#define _T5CON_T5SYNC_LENGTH                                0x1
#define _T5CON_T5SYNC_MASK                                  0x4
#define _T5CON_T5CKPS_POSN                                  0x4
#define _T5CON_T5CKPS_POSITION                              0x4
#define _T5CON_T5CKPS_SIZE                                  0x2
#define _T5CON_T5CKPS_LENGTH                                0x2
#define _T5CON_T5CKPS_MASK                                  0x30
#define _T5CON_TMR5CS_POSN                                  0x6
#define _T5CON_TMR5CS_POSITION                              0x6
#define _T5CON_TMR5CS_SIZE                                  0x2
#define _T5CON_TMR5CS_LENGTH                                0x2
#define _T5CON_TMR5CS_MASK                                  0xC0
#define _T5CON_T5CKPS0_POSN                                 0x4
#define _T5CON_T5CKPS0_POSITION                             0x4
#define _T5CON_T5CKPS0_SIZE                                 0x1
#define _T5CON_T5CKPS0_LENGTH                               0x1
#define _T5CON_T5CKPS0_MASK                                 0x10
#define _T5CON_T5CKPS1_POSN                                 0x5
#define _T5CON_T5CKPS1_POSITION                             0x5
#define _T5CON_T5CKPS1_SIZE                                 0x1
#define _T5CON_T5CKPS1_LENGTH                               0x1
#define _T5CON_T5CKPS1_MASK                                 0x20
#define _T5CON_TMR5CS0_POSN                                 0x6
#define _T5CON_TMR5CS0_POSITION                             0x6
#define _T5CON_TMR5CS0_SIZE                                 0x1
#define _T5CON_TMR5CS0_LENGTH                               0x1
#define _T5CON_TMR5CS0_MASK                                 0x40
#define _T5CON_TMR5CS1_POSN                                 0x7
#define _T5CON_TMR5CS1_POSITION                             0x7
#define _T5CON_TMR5CS1_SIZE                                 0x1
#define _T5CON_TMR5CS1_LENGTH                               0x1
#define _T5CON_TMR5CS1_MASK                                 0x80

// Register: T5GCON
extern volatile unsigned char           T5GCON              @ 0x49D;
#ifndef _LIB_BUILD
asm("T5GCON equ 049Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T5GSS                  :2;
        unsigned T5GVAL                 :1;
        unsigned T5GGO_nDONE            :1;
        unsigned T5GSPM                 :1;
        unsigned T5GTM                  :1;
        unsigned T5GPOL                 :1;
        unsigned TMR5GE                 :1;
    };
    struct {
        unsigned T5GSS0                 :1;
        unsigned T5GSS1                 :1;
    };
} T5GCONbits_t;
extern volatile T5GCONbits_t T5GCONbits @ 0x49D;
// bitfield macros
#define _T5GCON_T5GSS_POSN                                  0x0
#define _T5GCON_T5GSS_POSITION                              0x0
#define _T5GCON_T5GSS_SIZE                                  0x2
#define _T5GCON_T5GSS_LENGTH                                0x2
#define _T5GCON_T5GSS_MASK                                  0x3
#define _T5GCON_T5GVAL_POSN                                 0x2
#define _T5GCON_T5GVAL_POSITION                             0x2
#define _T5GCON_T5GVAL_SIZE                                 0x1
#define _T5GCON_T5GVAL_LENGTH                               0x1
#define _T5GCON_T5GVAL_MASK                                 0x4
#define _T5GCON_T5GGO_nDONE_POSN                            0x3
#define _T5GCON_T5GGO_nDONE_POSITION                        0x3
#define _T5GCON_T5GGO_nDONE_SIZE                            0x1
#define _T5GCON_T5GGO_nDONE_LENGTH                          0x1
#define _T5GCON_T5GGO_nDONE_MASK                            0x8
#define _T5GCON_T5GSPM_POSN                                 0x4
#define _T5GCON_T5GSPM_POSITION                             0x4
#define _T5GCON_T5GSPM_SIZE                                 0x1
#define _T5GCON_T5GSPM_LENGTH                               0x1
#define _T5GCON_T5GSPM_MASK                                 0x10
#define _T5GCON_T5GTM_POSN                                  0x5
#define _T5GCON_T5GTM_POSITION                              0x5
#define _T5GCON_T5GTM_SIZE                                  0x1
#define _T5GCON_T5GTM_LENGTH                                0x1
#define _T5GCON_T5GTM_MASK                                  0x20
#define _T5GCON_T5GPOL_POSN                                 0x6
#define _T5GCON_T5GPOL_POSITION                             0x6
#define _T5GCON_T5GPOL_SIZE                                 0x1
#define _T5GCON_T5GPOL_LENGTH                               0x1
#define _T5GCON_T5GPOL_MASK                                 0x40
#define _T5GCON_TMR5GE_POSN                                 0x7
#define _T5GCON_TMR5GE_POSITION                             0x7
#define _T5GCON_TMR5GE_SIZE                                 0x1
#define _T5GCON_TMR5GE_LENGTH                               0x1
#define _T5GCON_TMR5GE_MASK                                 0x80
#define _T5GCON_T5GSS0_POSN                                 0x0
#define _T5GCON_T5GSS0_POSITION                             0x0
#define _T5GCON_T5GSS0_SIZE                                 0x1
#define _T5GCON_T5GSS0_LENGTH                               0x1
#define _T5GCON_T5GSS0_MASK                                 0x1
#define _T5GCON_T5GSS1_POSN                                 0x1
#define _T5GCON_T5GSS1_POSITION                             0x1
#define _T5GCON_T5GSS1_SIZE                                 0x1
#define _T5GCON_T5GSS1_LENGTH                               0x1
#define _T5GCON_T5GSS1_MASK                                 0x2

// Register: PID1SET
extern volatile unsigned short          PID1SET             @ 0x58C;
#ifndef _LIB_BUILD
asm("PID1SET equ 058Ch");
#endif

// Register: PID1SETL
extern volatile unsigned char           PID1SETL            @ 0x58C;
#ifndef _LIB_BUILD
asm("PID1SETL equ 058Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1SET0               :1;
        unsigned PID1SET1               :1;
        unsigned PID1SET2               :1;
        unsigned PID1SET3               :1;
        unsigned PID1SET4               :1;
        unsigned PID1SET5               :1;
        unsigned PID1SET6               :1;
        unsigned PID1SET7               :1;
    };
    struct {
        unsigned SET0                   :1;
        unsigned SET1                   :1;
        unsigned SET2                   :1;
        unsigned SET3                   :1;
        unsigned SET4                   :1;
        unsigned SET5                   :1;
        unsigned SET6                   :1;
        unsigned SET7                   :1;
    };
} PID1SETLbits_t;
extern volatile PID1SETLbits_t PID1SETLbits @ 0x58C;
// bitfield macros
#define _PID1SETL_PID1SET0_POSN                             0x0
#define _PID1SETL_PID1SET0_POSITION                         0x0
#define _PID1SETL_PID1SET0_SIZE                             0x1
#define _PID1SETL_PID1SET0_LENGTH                           0x1
#define _PID1SETL_PID1SET0_MASK                             0x1
#define _PID1SETL_PID1SET1_POSN                             0x1
#define _PID1SETL_PID1SET1_POSITION                         0x1
#define _PID1SETL_PID1SET1_SIZE                             0x1
#define _PID1SETL_PID1SET1_LENGTH                           0x1
#define _PID1SETL_PID1SET1_MASK                             0x2
#define _PID1SETL_PID1SET2_POSN                             0x2
#define _PID1SETL_PID1SET2_POSITION                         0x2
#define _PID1SETL_PID1SET2_SIZE                             0x1
#define _PID1SETL_PID1SET2_LENGTH                           0x1
#define _PID1SETL_PID1SET2_MASK                             0x4
#define _PID1SETL_PID1SET3_POSN                             0x3
#define _PID1SETL_PID1SET3_POSITION                         0x3
#define _PID1SETL_PID1SET3_SIZE                             0x1
#define _PID1SETL_PID1SET3_LENGTH                           0x1
#define _PID1SETL_PID1SET3_MASK                             0x8
#define _PID1SETL_PID1SET4_POSN                             0x4
#define _PID1SETL_PID1SET4_POSITION                         0x4
#define _PID1SETL_PID1SET4_SIZE                             0x1
#define _PID1SETL_PID1SET4_LENGTH                           0x1
#define _PID1SETL_PID1SET4_MASK                             0x10
#define _PID1SETL_PID1SET5_POSN                             0x5
#define _PID1SETL_PID1SET5_POSITION                         0x5
#define _PID1SETL_PID1SET5_SIZE                             0x1
#define _PID1SETL_PID1SET5_LENGTH                           0x1
#define _PID1SETL_PID1SET5_MASK                             0x20
#define _PID1SETL_PID1SET6_POSN                             0x6
#define _PID1SETL_PID1SET6_POSITION                         0x6
#define _PID1SETL_PID1SET6_SIZE                             0x1
#define _PID1SETL_PID1SET6_LENGTH                           0x1
#define _PID1SETL_PID1SET6_MASK                             0x40
#define _PID1SETL_PID1SET7_POSN                             0x7
#define _PID1SETL_PID1SET7_POSITION                         0x7
#define _PID1SETL_PID1SET7_SIZE                             0x1
#define _PID1SETL_PID1SET7_LENGTH                           0x1
#define _PID1SETL_PID1SET7_MASK                             0x80
#define _PID1SETL_SET0_POSN                                 0x0
#define _PID1SETL_SET0_POSITION                             0x0
#define _PID1SETL_SET0_SIZE                                 0x1
#define _PID1SETL_SET0_LENGTH                               0x1
#define _PID1SETL_SET0_MASK                                 0x1
#define _PID1SETL_SET1_POSN                                 0x1
#define _PID1SETL_SET1_POSITION                             0x1
#define _PID1SETL_SET1_SIZE                                 0x1
#define _PID1SETL_SET1_LENGTH                               0x1
#define _PID1SETL_SET1_MASK                                 0x2
#define _PID1SETL_SET2_POSN                                 0x2
#define _PID1SETL_SET2_POSITION                             0x2
#define _PID1SETL_SET2_SIZE                                 0x1
#define _PID1SETL_SET2_LENGTH                               0x1
#define _PID1SETL_SET2_MASK                                 0x4
#define _PID1SETL_SET3_POSN                                 0x3
#define _PID1SETL_SET3_POSITION                             0x3
#define _PID1SETL_SET3_SIZE                                 0x1
#define _PID1SETL_SET3_LENGTH                               0x1
#define _PID1SETL_SET3_MASK                                 0x8
#define _PID1SETL_SET4_POSN                                 0x4
#define _PID1SETL_SET4_POSITION                             0x4
#define _PID1SETL_SET4_SIZE                                 0x1
#define _PID1SETL_SET4_LENGTH                               0x1
#define _PID1SETL_SET4_MASK                                 0x10
#define _PID1SETL_SET5_POSN                                 0x5
#define _PID1SETL_SET5_POSITION                             0x5
#define _PID1SETL_SET5_SIZE                                 0x1
#define _PID1SETL_SET5_LENGTH                               0x1
#define _PID1SETL_SET5_MASK                                 0x20
#define _PID1SETL_SET6_POSN                                 0x6
#define _PID1SETL_SET6_POSITION                             0x6
#define _PID1SETL_SET6_SIZE                                 0x1
#define _PID1SETL_SET6_LENGTH                               0x1
#define _PID1SETL_SET6_MASK                                 0x40
#define _PID1SETL_SET7_POSN                                 0x7
#define _PID1SETL_SET7_POSITION                             0x7
#define _PID1SETL_SET7_SIZE                                 0x1
#define _PID1SETL_SET7_LENGTH                               0x1
#define _PID1SETL_SET7_MASK                                 0x80

// Register: PID1SETH
extern volatile unsigned char           PID1SETH            @ 0x58D;
#ifndef _LIB_BUILD
asm("PID1SETH equ 058Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1SET8               :1;
        unsigned PID1SET9               :1;
        unsigned PID1SET10              :1;
        unsigned PID1SET11              :1;
        unsigned PID1SET12              :1;
        unsigned PID1SET13              :1;
        unsigned PID1SET14              :1;
        unsigned PID1SET15              :1;
    };
    struct {
        unsigned SET8                   :1;
        unsigned SET9                   :1;
        unsigned SET10                  :1;
        unsigned SET11                  :1;
        unsigned SET12                  :1;
        unsigned SET13                  :1;
        unsigned SET14                  :1;
        unsigned SET15                  :1;
    };
} PID1SETHbits_t;
extern volatile PID1SETHbits_t PID1SETHbits @ 0x58D;
// bitfield macros
#define _PID1SETH_PID1SET8_POSN                             0x0
#define _PID1SETH_PID1SET8_POSITION                         0x0
#define _PID1SETH_PID1SET8_SIZE                             0x1
#define _PID1SETH_PID1SET8_LENGTH                           0x1
#define _PID1SETH_PID1SET8_MASK                             0x1
#define _PID1SETH_PID1SET9_POSN                             0x1
#define _PID1SETH_PID1SET9_POSITION                         0x1
#define _PID1SETH_PID1SET9_SIZE                             0x1
#define _PID1SETH_PID1SET9_LENGTH                           0x1
#define _PID1SETH_PID1SET9_MASK                             0x2
#define _PID1SETH_PID1SET10_POSN                            0x2
#define _PID1SETH_PID1SET10_POSITION                        0x2
#define _PID1SETH_PID1SET10_SIZE                            0x1
#define _PID1SETH_PID1SET10_LENGTH                          0x1
#define _PID1SETH_PID1SET10_MASK                            0x4
#define _PID1SETH_PID1SET11_POSN                            0x3
#define _PID1SETH_PID1SET11_POSITION                        0x3
#define _PID1SETH_PID1SET11_SIZE                            0x1
#define _PID1SETH_PID1SET11_LENGTH                          0x1
#define _PID1SETH_PID1SET11_MASK                            0x8
#define _PID1SETH_PID1SET12_POSN                            0x4
#define _PID1SETH_PID1SET12_POSITION                        0x4
#define _PID1SETH_PID1SET12_SIZE                            0x1
#define _PID1SETH_PID1SET12_LENGTH                          0x1
#define _PID1SETH_PID1SET12_MASK                            0x10
#define _PID1SETH_PID1SET13_POSN                            0x5
#define _PID1SETH_PID1SET13_POSITION                        0x5
#define _PID1SETH_PID1SET13_SIZE                            0x1
#define _PID1SETH_PID1SET13_LENGTH                          0x1
#define _PID1SETH_PID1SET13_MASK                            0x20
#define _PID1SETH_PID1SET14_POSN                            0x6
#define _PID1SETH_PID1SET14_POSITION                        0x6
#define _PID1SETH_PID1SET14_SIZE                            0x1
#define _PID1SETH_PID1SET14_LENGTH                          0x1
#define _PID1SETH_PID1SET14_MASK                            0x40
#define _PID1SETH_PID1SET15_POSN                            0x7
#define _PID1SETH_PID1SET15_POSITION                        0x7
#define _PID1SETH_PID1SET15_SIZE                            0x1
#define _PID1SETH_PID1SET15_LENGTH                          0x1
#define _PID1SETH_PID1SET15_MASK                            0x80
#define _PID1SETH_SET8_POSN                                 0x0
#define _PID1SETH_SET8_POSITION                             0x0
#define _PID1SETH_SET8_SIZE                                 0x1
#define _PID1SETH_SET8_LENGTH                               0x1
#define _PID1SETH_SET8_MASK                                 0x1
#define _PID1SETH_SET9_POSN                                 0x1
#define _PID1SETH_SET9_POSITION                             0x1
#define _PID1SETH_SET9_SIZE                                 0x1
#define _PID1SETH_SET9_LENGTH                               0x1
#define _PID1SETH_SET9_MASK                                 0x2
#define _PID1SETH_SET10_POSN                                0x2
#define _PID1SETH_SET10_POSITION                            0x2
#define _PID1SETH_SET10_SIZE                                0x1
#define _PID1SETH_SET10_LENGTH                              0x1
#define _PID1SETH_SET10_MASK                                0x4
#define _PID1SETH_SET11_POSN                                0x3
#define _PID1SETH_SET11_POSITION                            0x3
#define _PID1SETH_SET11_SIZE                                0x1
#define _PID1SETH_SET11_LENGTH                              0x1
#define _PID1SETH_SET11_MASK                                0x8
#define _PID1SETH_SET12_POSN                                0x4
#define _PID1SETH_SET12_POSITION                            0x4
#define _PID1SETH_SET12_SIZE                                0x1
#define _PID1SETH_SET12_LENGTH                              0x1
#define _PID1SETH_SET12_MASK                                0x10
#define _PID1SETH_SET13_POSN                                0x5
#define _PID1SETH_SET13_POSITION                            0x5
#define _PID1SETH_SET13_SIZE                                0x1
#define _PID1SETH_SET13_LENGTH                              0x1
#define _PID1SETH_SET13_MASK                                0x20
#define _PID1SETH_SET14_POSN                                0x6
#define _PID1SETH_SET14_POSITION                            0x6
#define _PID1SETH_SET14_SIZE                                0x1
#define _PID1SETH_SET14_LENGTH                              0x1
#define _PID1SETH_SET14_MASK                                0x40
#define _PID1SETH_SET15_POSN                                0x7
#define _PID1SETH_SET15_POSITION                            0x7
#define _PID1SETH_SET15_SIZE                                0x1
#define _PID1SETH_SET15_LENGTH                              0x1
#define _PID1SETH_SET15_MASK                                0x80

// Register: PID1IN
extern volatile unsigned short          PID1IN              @ 0x58E;
#ifndef _LIB_BUILD
asm("PID1IN equ 058Eh");
#endif

// Register: PID1INL
extern volatile unsigned char           PID1INL             @ 0x58E;
#ifndef _LIB_BUILD
asm("PID1INL equ 058Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1IN0                :1;
        unsigned PID1IN1                :1;
        unsigned PID1IN2                :1;
        unsigned PID1IN3                :1;
        unsigned PID1IN4                :1;
        unsigned PID1IN5                :1;
        unsigned PID1IN6                :1;
        unsigned PID1IN7                :1;
    };
    struct {
        unsigned IN0                    :1;
        unsigned IN1                    :1;
        unsigned IN2                    :1;
        unsigned IN3                    :1;
        unsigned IN4                    :1;
        unsigned IN5                    :1;
        unsigned IN6                    :1;
        unsigned IN7                    :1;
    };
} PID1INLbits_t;
extern volatile PID1INLbits_t PID1INLbits @ 0x58E;
// bitfield macros
#define _PID1INL_PID1IN0_POSN                               0x0
#define _PID1INL_PID1IN0_POSITION                           0x0
#define _PID1INL_PID1IN0_SIZE                               0x1
#define _PID1INL_PID1IN0_LENGTH                             0x1
#define _PID1INL_PID1IN0_MASK                               0x1
#define _PID1INL_PID1IN1_POSN                               0x1
#define _PID1INL_PID1IN1_POSITION                           0x1
#define _PID1INL_PID1IN1_SIZE                               0x1
#define _PID1INL_PID1IN1_LENGTH                             0x1
#define _PID1INL_PID1IN1_MASK                               0x2
#define _PID1INL_PID1IN2_POSN                               0x2
#define _PID1INL_PID1IN2_POSITION                           0x2
#define _PID1INL_PID1IN2_SIZE                               0x1
#define _PID1INL_PID1IN2_LENGTH                             0x1
#define _PID1INL_PID1IN2_MASK                               0x4
#define _PID1INL_PID1IN3_POSN                               0x3
#define _PID1INL_PID1IN3_POSITION                           0x3
#define _PID1INL_PID1IN3_SIZE                               0x1
#define _PID1INL_PID1IN3_LENGTH                             0x1
#define _PID1INL_PID1IN3_MASK                               0x8
#define _PID1INL_PID1IN4_POSN                               0x4
#define _PID1INL_PID1IN4_POSITION                           0x4
#define _PID1INL_PID1IN4_SIZE                               0x1
#define _PID1INL_PID1IN4_LENGTH                             0x1
#define _PID1INL_PID1IN4_MASK                               0x10
#define _PID1INL_PID1IN5_POSN                               0x5
#define _PID1INL_PID1IN5_POSITION                           0x5
#define _PID1INL_PID1IN5_SIZE                               0x1
#define _PID1INL_PID1IN5_LENGTH                             0x1
#define _PID1INL_PID1IN5_MASK                               0x20
#define _PID1INL_PID1IN6_POSN                               0x6
#define _PID1INL_PID1IN6_POSITION                           0x6
#define _PID1INL_PID1IN6_SIZE                               0x1
#define _PID1INL_PID1IN6_LENGTH                             0x1
#define _PID1INL_PID1IN6_MASK                               0x40
#define _PID1INL_PID1IN7_POSN                               0x7
#define _PID1INL_PID1IN7_POSITION                           0x7
#define _PID1INL_PID1IN7_SIZE                               0x1
#define _PID1INL_PID1IN7_LENGTH                             0x1
#define _PID1INL_PID1IN7_MASK                               0x80
#define _PID1INL_IN0_POSN                                   0x0
#define _PID1INL_IN0_POSITION                               0x0
#define _PID1INL_IN0_SIZE                                   0x1
#define _PID1INL_IN0_LENGTH                                 0x1
#define _PID1INL_IN0_MASK                                   0x1
#define _PID1INL_IN1_POSN                                   0x1
#define _PID1INL_IN1_POSITION                               0x1
#define _PID1INL_IN1_SIZE                                   0x1
#define _PID1INL_IN1_LENGTH                                 0x1
#define _PID1INL_IN1_MASK                                   0x2
#define _PID1INL_IN2_POSN                                   0x2
#define _PID1INL_IN2_POSITION                               0x2
#define _PID1INL_IN2_SIZE                                   0x1
#define _PID1INL_IN2_LENGTH                                 0x1
#define _PID1INL_IN2_MASK                                   0x4
#define _PID1INL_IN3_POSN                                   0x3
#define _PID1INL_IN3_POSITION                               0x3
#define _PID1INL_IN3_SIZE                                   0x1
#define _PID1INL_IN3_LENGTH                                 0x1
#define _PID1INL_IN3_MASK                                   0x8
#define _PID1INL_IN4_POSN                                   0x4
#define _PID1INL_IN4_POSITION                               0x4
#define _PID1INL_IN4_SIZE                                   0x1
#define _PID1INL_IN4_LENGTH                                 0x1
#define _PID1INL_IN4_MASK                                   0x10
#define _PID1INL_IN5_POSN                                   0x5
#define _PID1INL_IN5_POSITION                               0x5
#define _PID1INL_IN5_SIZE                                   0x1
#define _PID1INL_IN5_LENGTH                                 0x1
#define _PID1INL_IN5_MASK                                   0x20
#define _PID1INL_IN6_POSN                                   0x6
#define _PID1INL_IN6_POSITION                               0x6
#define _PID1INL_IN6_SIZE                                   0x1
#define _PID1INL_IN6_LENGTH                                 0x1
#define _PID1INL_IN6_MASK                                   0x40
#define _PID1INL_IN7_POSN                                   0x7
#define _PID1INL_IN7_POSITION                               0x7
#define _PID1INL_IN7_SIZE                                   0x1
#define _PID1INL_IN7_LENGTH                                 0x1
#define _PID1INL_IN7_MASK                                   0x80

// Register: PID1INH
extern volatile unsigned char           PID1INH             @ 0x58F;
#ifndef _LIB_BUILD
asm("PID1INH equ 058Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1IN8                :1;
        unsigned PID1IN9                :1;
        unsigned PID1IN10               :1;
        unsigned PID1IN11               :1;
        unsigned PID1IN12               :1;
        unsigned PID1IN13               :1;
        unsigned PID1IN14               :1;
        unsigned PID1IN15               :1;
    };
    struct {
        unsigned IN8                    :1;
        unsigned IN9                    :1;
        unsigned IN10                   :1;
        unsigned IN11                   :1;
        unsigned IN12                   :1;
        unsigned IN13                   :1;
        unsigned IN14                   :1;
        unsigned IN15                   :1;
    };
} PID1INHbits_t;
extern volatile PID1INHbits_t PID1INHbits @ 0x58F;
// bitfield macros
#define _PID1INH_PID1IN8_POSN                               0x0
#define _PID1INH_PID1IN8_POSITION                           0x0
#define _PID1INH_PID1IN8_SIZE                               0x1
#define _PID1INH_PID1IN8_LENGTH                             0x1
#define _PID1INH_PID1IN8_MASK                               0x1
#define _PID1INH_PID1IN9_POSN                               0x1
#define _PID1INH_PID1IN9_POSITION                           0x1
#define _PID1INH_PID1IN9_SIZE                               0x1
#define _PID1INH_PID1IN9_LENGTH                             0x1
#define _PID1INH_PID1IN9_MASK                               0x2
#define _PID1INH_PID1IN10_POSN                              0x2
#define _PID1INH_PID1IN10_POSITION                          0x2
#define _PID1INH_PID1IN10_SIZE                              0x1
#define _PID1INH_PID1IN10_LENGTH                            0x1
#define _PID1INH_PID1IN10_MASK                              0x4
#define _PID1INH_PID1IN11_POSN                              0x3
#define _PID1INH_PID1IN11_POSITION                          0x3
#define _PID1INH_PID1IN11_SIZE                              0x1
#define _PID1INH_PID1IN11_LENGTH                            0x1
#define _PID1INH_PID1IN11_MASK                              0x8
#define _PID1INH_PID1IN12_POSN                              0x4
#define _PID1INH_PID1IN12_POSITION                          0x4
#define _PID1INH_PID1IN12_SIZE                              0x1
#define _PID1INH_PID1IN12_LENGTH                            0x1
#define _PID1INH_PID1IN12_MASK                              0x10
#define _PID1INH_PID1IN13_POSN                              0x5
#define _PID1INH_PID1IN13_POSITION                          0x5
#define _PID1INH_PID1IN13_SIZE                              0x1
#define _PID1INH_PID1IN13_LENGTH                            0x1
#define _PID1INH_PID1IN13_MASK                              0x20
#define _PID1INH_PID1IN14_POSN                              0x6
#define _PID1INH_PID1IN14_POSITION                          0x6
#define _PID1INH_PID1IN14_SIZE                              0x1
#define _PID1INH_PID1IN14_LENGTH                            0x1
#define _PID1INH_PID1IN14_MASK                              0x40
#define _PID1INH_PID1IN15_POSN                              0x7
#define _PID1INH_PID1IN15_POSITION                          0x7
#define _PID1INH_PID1IN15_SIZE                              0x1
#define _PID1INH_PID1IN15_LENGTH                            0x1
#define _PID1INH_PID1IN15_MASK                              0x80
#define _PID1INH_IN8_POSN                                   0x0
#define _PID1INH_IN8_POSITION                               0x0
#define _PID1INH_IN8_SIZE                                   0x1
#define _PID1INH_IN8_LENGTH                                 0x1
#define _PID1INH_IN8_MASK                                   0x1
#define _PID1INH_IN9_POSN                                   0x1
#define _PID1INH_IN9_POSITION                               0x1
#define _PID1INH_IN9_SIZE                                   0x1
#define _PID1INH_IN9_LENGTH                                 0x1
#define _PID1INH_IN9_MASK                                   0x2
#define _PID1INH_IN10_POSN                                  0x2
#define _PID1INH_IN10_POSITION                              0x2
#define _PID1INH_IN10_SIZE                                  0x1
#define _PID1INH_IN10_LENGTH                                0x1
#define _PID1INH_IN10_MASK                                  0x4
#define _PID1INH_IN11_POSN                                  0x3
#define _PID1INH_IN11_POSITION                              0x3
#define _PID1INH_IN11_SIZE                                  0x1
#define _PID1INH_IN11_LENGTH                                0x1
#define _PID1INH_IN11_MASK                                  0x8
#define _PID1INH_IN12_POSN                                  0x4
#define _PID1INH_IN12_POSITION                              0x4
#define _PID1INH_IN12_SIZE                                  0x1
#define _PID1INH_IN12_LENGTH                                0x1
#define _PID1INH_IN12_MASK                                  0x10
#define _PID1INH_IN13_POSN                                  0x5
#define _PID1INH_IN13_POSITION                              0x5
#define _PID1INH_IN13_SIZE                                  0x1
#define _PID1INH_IN13_LENGTH                                0x1
#define _PID1INH_IN13_MASK                                  0x20
#define _PID1INH_IN14_POSN                                  0x6
#define _PID1INH_IN14_POSITION                              0x6
#define _PID1INH_IN14_SIZE                                  0x1
#define _PID1INH_IN14_LENGTH                                0x1
#define _PID1INH_IN14_MASK                                  0x40
#define _PID1INH_IN15_POSN                                  0x7
#define _PID1INH_IN15_POSITION                              0x7
#define _PID1INH_IN15_SIZE                                  0x1
#define _PID1INH_IN15_LENGTH                                0x1
#define _PID1INH_IN15_MASK                                  0x80

// Register: PID1K1
extern volatile unsigned short          PID1K1              @ 0x590;
#ifndef _LIB_BUILD
asm("PID1K1 equ 0590h");
#endif

// Register: PID1K1L
extern volatile unsigned char           PID1K1L             @ 0x590;
#ifndef _LIB_BUILD
asm("PID1K1L equ 0590h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1K10                :1;
        unsigned PID1K11                :1;
        unsigned PID1K12                :1;
        unsigned PID1K13                :1;
        unsigned PID1K14                :1;
        unsigned PID1K15                :1;
        unsigned PID1K16                :1;
        unsigned PID1K17                :1;
    };
    struct {
        unsigned K10                    :1;
        unsigned K11                    :1;
        unsigned K12                    :1;
        unsigned K13                    :1;
        unsigned K14                    :1;
        unsigned K15                    :1;
        unsigned K16                    :1;
        unsigned K17                    :1;
    };
} PID1K1Lbits_t;
extern volatile PID1K1Lbits_t PID1K1Lbits @ 0x590;
// bitfield macros
#define _PID1K1L_PID1K10_POSN                               0x0
#define _PID1K1L_PID1K10_POSITION                           0x0
#define _PID1K1L_PID1K10_SIZE                               0x1
#define _PID1K1L_PID1K10_LENGTH                             0x1
#define _PID1K1L_PID1K10_MASK                               0x1
#define _PID1K1L_PID1K11_POSN                               0x1
#define _PID1K1L_PID1K11_POSITION                           0x1
#define _PID1K1L_PID1K11_SIZE                               0x1
#define _PID1K1L_PID1K11_LENGTH                             0x1
#define _PID1K1L_PID1K11_MASK                               0x2
#define _PID1K1L_PID1K12_POSN                               0x2
#define _PID1K1L_PID1K12_POSITION                           0x2
#define _PID1K1L_PID1K12_SIZE                               0x1
#define _PID1K1L_PID1K12_LENGTH                             0x1
#define _PID1K1L_PID1K12_MASK                               0x4
#define _PID1K1L_PID1K13_POSN                               0x3
#define _PID1K1L_PID1K13_POSITION                           0x3
#define _PID1K1L_PID1K13_SIZE                               0x1
#define _PID1K1L_PID1K13_LENGTH                             0x1
#define _PID1K1L_PID1K13_MASK                               0x8
#define _PID1K1L_PID1K14_POSN                               0x4
#define _PID1K1L_PID1K14_POSITION                           0x4
#define _PID1K1L_PID1K14_SIZE                               0x1
#define _PID1K1L_PID1K14_LENGTH                             0x1
#define _PID1K1L_PID1K14_MASK                               0x10
#define _PID1K1L_PID1K15_POSN                               0x5
#define _PID1K1L_PID1K15_POSITION                           0x5
#define _PID1K1L_PID1K15_SIZE                               0x1
#define _PID1K1L_PID1K15_LENGTH                             0x1
#define _PID1K1L_PID1K15_MASK                               0x20
#define _PID1K1L_PID1K16_POSN                               0x6
#define _PID1K1L_PID1K16_POSITION                           0x6
#define _PID1K1L_PID1K16_SIZE                               0x1
#define _PID1K1L_PID1K16_LENGTH                             0x1
#define _PID1K1L_PID1K16_MASK                               0x40
#define _PID1K1L_PID1K17_POSN                               0x7
#define _PID1K1L_PID1K17_POSITION                           0x7
#define _PID1K1L_PID1K17_SIZE                               0x1
#define _PID1K1L_PID1K17_LENGTH                             0x1
#define _PID1K1L_PID1K17_MASK                               0x80
#define _PID1K1L_K10_POSN                                   0x0
#define _PID1K1L_K10_POSITION                               0x0
#define _PID1K1L_K10_SIZE                                   0x1
#define _PID1K1L_K10_LENGTH                                 0x1
#define _PID1K1L_K10_MASK                                   0x1
#define _PID1K1L_K11_POSN                                   0x1
#define _PID1K1L_K11_POSITION                               0x1
#define _PID1K1L_K11_SIZE                                   0x1
#define _PID1K1L_K11_LENGTH                                 0x1
#define _PID1K1L_K11_MASK                                   0x2
#define _PID1K1L_K12_POSN                                   0x2
#define _PID1K1L_K12_POSITION                               0x2
#define _PID1K1L_K12_SIZE                                   0x1
#define _PID1K1L_K12_LENGTH                                 0x1
#define _PID1K1L_K12_MASK                                   0x4
#define _PID1K1L_K13_POSN                                   0x3
#define _PID1K1L_K13_POSITION                               0x3
#define _PID1K1L_K13_SIZE                                   0x1
#define _PID1K1L_K13_LENGTH                                 0x1
#define _PID1K1L_K13_MASK                                   0x8
#define _PID1K1L_K14_POSN                                   0x4
#define _PID1K1L_K14_POSITION                               0x4
#define _PID1K1L_K14_SIZE                                   0x1
#define _PID1K1L_K14_LENGTH                                 0x1
#define _PID1K1L_K14_MASK                                   0x10
#define _PID1K1L_K15_POSN                                   0x5
#define _PID1K1L_K15_POSITION                               0x5
#define _PID1K1L_K15_SIZE                                   0x1
#define _PID1K1L_K15_LENGTH                                 0x1
#define _PID1K1L_K15_MASK                                   0x20
#define _PID1K1L_K16_POSN                                   0x6
#define _PID1K1L_K16_POSITION                               0x6
#define _PID1K1L_K16_SIZE                                   0x1
#define _PID1K1L_K16_LENGTH                                 0x1
#define _PID1K1L_K16_MASK                                   0x40
#define _PID1K1L_K17_POSN                                   0x7
#define _PID1K1L_K17_POSITION                               0x7
#define _PID1K1L_K17_SIZE                                   0x1
#define _PID1K1L_K17_LENGTH                                 0x1
#define _PID1K1L_K17_MASK                                   0x80

// Register: PID1K1H
extern volatile unsigned char           PID1K1H             @ 0x591;
#ifndef _LIB_BUILD
asm("PID1K1H equ 0591h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1K18                :1;
        unsigned PID1K19                :1;
        unsigned PID1K110               :1;
        unsigned PID1K111               :1;
        unsigned PID1K112               :1;
        unsigned PID1K113               :1;
        unsigned PID1K114               :1;
        unsigned PID1K115               :1;
    };
    struct {
        unsigned K18                    :1;
        unsigned K19                    :1;
        unsigned K110                   :1;
        unsigned K111                   :1;
        unsigned K112                   :1;
        unsigned K113                   :1;
        unsigned K114                   :1;
        unsigned K115                   :1;
    };
} PID1K1Hbits_t;
extern volatile PID1K1Hbits_t PID1K1Hbits @ 0x591;
// bitfield macros
#define _PID1K1H_PID1K18_POSN                               0x0
#define _PID1K1H_PID1K18_POSITION                           0x0
#define _PID1K1H_PID1K18_SIZE                               0x1
#define _PID1K1H_PID1K18_LENGTH                             0x1
#define _PID1K1H_PID1K18_MASK                               0x1
#define _PID1K1H_PID1K19_POSN                               0x1
#define _PID1K1H_PID1K19_POSITION                           0x1
#define _PID1K1H_PID1K19_SIZE                               0x1
#define _PID1K1H_PID1K19_LENGTH                             0x1
#define _PID1K1H_PID1K19_MASK                               0x2
#define _PID1K1H_PID1K110_POSN                              0x2
#define _PID1K1H_PID1K110_POSITION                          0x2
#define _PID1K1H_PID1K110_SIZE                              0x1
#define _PID1K1H_PID1K110_LENGTH                            0x1
#define _PID1K1H_PID1K110_MASK                              0x4
#define _PID1K1H_PID1K111_POSN                              0x3
#define _PID1K1H_PID1K111_POSITION                          0x3
#define _PID1K1H_PID1K111_SIZE                              0x1
#define _PID1K1H_PID1K111_LENGTH                            0x1
#define _PID1K1H_PID1K111_MASK                              0x8
#define _PID1K1H_PID1K112_POSN                              0x4
#define _PID1K1H_PID1K112_POSITION                          0x4
#define _PID1K1H_PID1K112_SIZE                              0x1
#define _PID1K1H_PID1K112_LENGTH                            0x1
#define _PID1K1H_PID1K112_MASK                              0x10
#define _PID1K1H_PID1K113_POSN                              0x5
#define _PID1K1H_PID1K113_POSITION                          0x5
#define _PID1K1H_PID1K113_SIZE                              0x1
#define _PID1K1H_PID1K113_LENGTH                            0x1
#define _PID1K1H_PID1K113_MASK                              0x20
#define _PID1K1H_PID1K114_POSN                              0x6
#define _PID1K1H_PID1K114_POSITION                          0x6
#define _PID1K1H_PID1K114_SIZE                              0x1
#define _PID1K1H_PID1K114_LENGTH                            0x1
#define _PID1K1H_PID1K114_MASK                              0x40
#define _PID1K1H_PID1K115_POSN                              0x7
#define _PID1K1H_PID1K115_POSITION                          0x7
#define _PID1K1H_PID1K115_SIZE                              0x1
#define _PID1K1H_PID1K115_LENGTH                            0x1
#define _PID1K1H_PID1K115_MASK                              0x80
#define _PID1K1H_K18_POSN                                   0x0
#define _PID1K1H_K18_POSITION                               0x0
#define _PID1K1H_K18_SIZE                                   0x1
#define _PID1K1H_K18_LENGTH                                 0x1
#define _PID1K1H_K18_MASK                                   0x1
#define _PID1K1H_K19_POSN                                   0x1
#define _PID1K1H_K19_POSITION                               0x1
#define _PID1K1H_K19_SIZE                                   0x1
#define _PID1K1H_K19_LENGTH                                 0x1
#define _PID1K1H_K19_MASK                                   0x2
#define _PID1K1H_K110_POSN                                  0x2
#define _PID1K1H_K110_POSITION                              0x2
#define _PID1K1H_K110_SIZE                                  0x1
#define _PID1K1H_K110_LENGTH                                0x1
#define _PID1K1H_K110_MASK                                  0x4
#define _PID1K1H_K111_POSN                                  0x3
#define _PID1K1H_K111_POSITION                              0x3
#define _PID1K1H_K111_SIZE                                  0x1
#define _PID1K1H_K111_LENGTH                                0x1
#define _PID1K1H_K111_MASK                                  0x8
#define _PID1K1H_K112_POSN                                  0x4
#define _PID1K1H_K112_POSITION                              0x4
#define _PID1K1H_K112_SIZE                                  0x1
#define _PID1K1H_K112_LENGTH                                0x1
#define _PID1K1H_K112_MASK                                  0x10
#define _PID1K1H_K113_POSN                                  0x5
#define _PID1K1H_K113_POSITION                              0x5
#define _PID1K1H_K113_SIZE                                  0x1
#define _PID1K1H_K113_LENGTH                                0x1
#define _PID1K1H_K113_MASK                                  0x20
#define _PID1K1H_K114_POSN                                  0x6
#define _PID1K1H_K114_POSITION                              0x6
#define _PID1K1H_K114_SIZE                                  0x1
#define _PID1K1H_K114_LENGTH                                0x1
#define _PID1K1H_K114_MASK                                  0x40
#define _PID1K1H_K115_POSN                                  0x7
#define _PID1K1H_K115_POSITION                              0x7
#define _PID1K1H_K115_SIZE                                  0x1
#define _PID1K1H_K115_LENGTH                                0x1
#define _PID1K1H_K115_MASK                                  0x80

// Register: PID1K2
extern volatile unsigned short          PID1K2              @ 0x592;
#ifndef _LIB_BUILD
asm("PID1K2 equ 0592h");
#endif

// Register: PID1K2L
extern volatile unsigned char           PID1K2L             @ 0x592;
#ifndef _LIB_BUILD
asm("PID1K2L equ 0592h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1K20                :1;
        unsigned PID1K21                :1;
        unsigned PID1K22                :1;
        unsigned PID1K23                :1;
        unsigned PID1K24                :1;
        unsigned PID1K25                :1;
        unsigned PID1K26                :1;
        unsigned PID1K27                :1;
    };
    struct {
        unsigned K20                    :1;
        unsigned K21                    :1;
        unsigned K22                    :1;
        unsigned K23                    :1;
        unsigned K24                    :1;
        unsigned K25                    :1;
        unsigned K26                    :1;
        unsigned K27                    :1;
    };
} PID1K2Lbits_t;
extern volatile PID1K2Lbits_t PID1K2Lbits @ 0x592;
// bitfield macros
#define _PID1K2L_PID1K20_POSN                               0x0
#define _PID1K2L_PID1K20_POSITION                           0x0
#define _PID1K2L_PID1K20_SIZE                               0x1
#define _PID1K2L_PID1K20_LENGTH                             0x1
#define _PID1K2L_PID1K20_MASK                               0x1
#define _PID1K2L_PID1K21_POSN                               0x1
#define _PID1K2L_PID1K21_POSITION                           0x1
#define _PID1K2L_PID1K21_SIZE                               0x1
#define _PID1K2L_PID1K21_LENGTH                             0x1
#define _PID1K2L_PID1K21_MASK                               0x2
#define _PID1K2L_PID1K22_POSN                               0x2
#define _PID1K2L_PID1K22_POSITION                           0x2
#define _PID1K2L_PID1K22_SIZE                               0x1
#define _PID1K2L_PID1K22_LENGTH                             0x1
#define _PID1K2L_PID1K22_MASK                               0x4
#define _PID1K2L_PID1K23_POSN                               0x3
#define _PID1K2L_PID1K23_POSITION                           0x3
#define _PID1K2L_PID1K23_SIZE                               0x1
#define _PID1K2L_PID1K23_LENGTH                             0x1
#define _PID1K2L_PID1K23_MASK                               0x8
#define _PID1K2L_PID1K24_POSN                               0x4
#define _PID1K2L_PID1K24_POSITION                           0x4
#define _PID1K2L_PID1K24_SIZE                               0x1
#define _PID1K2L_PID1K24_LENGTH                             0x1
#define _PID1K2L_PID1K24_MASK                               0x10
#define _PID1K2L_PID1K25_POSN                               0x5
#define _PID1K2L_PID1K25_POSITION                           0x5
#define _PID1K2L_PID1K25_SIZE                               0x1
#define _PID1K2L_PID1K25_LENGTH                             0x1
#define _PID1K2L_PID1K25_MASK                               0x20
#define _PID1K2L_PID1K26_POSN                               0x6
#define _PID1K2L_PID1K26_POSITION                           0x6
#define _PID1K2L_PID1K26_SIZE                               0x1
#define _PID1K2L_PID1K26_LENGTH                             0x1
#define _PID1K2L_PID1K26_MASK                               0x40
#define _PID1K2L_PID1K27_POSN                               0x7
#define _PID1K2L_PID1K27_POSITION                           0x7
#define _PID1K2L_PID1K27_SIZE                               0x1
#define _PID1K2L_PID1K27_LENGTH                             0x1
#define _PID1K2L_PID1K27_MASK                               0x80
#define _PID1K2L_K20_POSN                                   0x0
#define _PID1K2L_K20_POSITION                               0x0
#define _PID1K2L_K20_SIZE                                   0x1
#define _PID1K2L_K20_LENGTH                                 0x1
#define _PID1K2L_K20_MASK                                   0x1
#define _PID1K2L_K21_POSN                                   0x1
#define _PID1K2L_K21_POSITION                               0x1
#define _PID1K2L_K21_SIZE                                   0x1
#define _PID1K2L_K21_LENGTH                                 0x1
#define _PID1K2L_K21_MASK                                   0x2
#define _PID1K2L_K22_POSN                                   0x2
#define _PID1K2L_K22_POSITION                               0x2
#define _PID1K2L_K22_SIZE                                   0x1
#define _PID1K2L_K22_LENGTH                                 0x1
#define _PID1K2L_K22_MASK                                   0x4
#define _PID1K2L_K23_POSN                                   0x3
#define _PID1K2L_K23_POSITION                               0x3
#define _PID1K2L_K23_SIZE                                   0x1
#define _PID1K2L_K23_LENGTH                                 0x1
#define _PID1K2L_K23_MASK                                   0x8
#define _PID1K2L_K24_POSN                                   0x4
#define _PID1K2L_K24_POSITION                               0x4
#define _PID1K2L_K24_SIZE                                   0x1
#define _PID1K2L_K24_LENGTH                                 0x1
#define _PID1K2L_K24_MASK                                   0x10
#define _PID1K2L_K25_POSN                                   0x5
#define _PID1K2L_K25_POSITION                               0x5
#define _PID1K2L_K25_SIZE                                   0x1
#define _PID1K2L_K25_LENGTH                                 0x1
#define _PID1K2L_K25_MASK                                   0x20
#define _PID1K2L_K26_POSN                                   0x6
#define _PID1K2L_K26_POSITION                               0x6
#define _PID1K2L_K26_SIZE                                   0x1
#define _PID1K2L_K26_LENGTH                                 0x1
#define _PID1K2L_K26_MASK                                   0x40
#define _PID1K2L_K27_POSN                                   0x7
#define _PID1K2L_K27_POSITION                               0x7
#define _PID1K2L_K27_SIZE                                   0x1
#define _PID1K2L_K27_LENGTH                                 0x1
#define _PID1K2L_K27_MASK                                   0x80

// Register: PID1K2H
extern volatile unsigned char           PID1K2H             @ 0x593;
#ifndef _LIB_BUILD
asm("PID1K2H equ 0593h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1K28                :1;
        unsigned PID1K29                :1;
        unsigned PID1K210               :1;
        unsigned PID1K211               :1;
        unsigned PID1K212               :1;
        unsigned PID1K213               :1;
        unsigned PID1K214               :1;
        unsigned PID1K215               :1;
    };
    struct {
        unsigned K28                    :1;
        unsigned K29                    :1;
        unsigned K210                   :1;
        unsigned K211                   :1;
        unsigned K212                   :1;
        unsigned K213                   :1;
        unsigned K214                   :1;
        unsigned K215                   :1;
    };
} PID1K2Hbits_t;
extern volatile PID1K2Hbits_t PID1K2Hbits @ 0x593;
// bitfield macros
#define _PID1K2H_PID1K28_POSN                               0x0
#define _PID1K2H_PID1K28_POSITION                           0x0
#define _PID1K2H_PID1K28_SIZE                               0x1
#define _PID1K2H_PID1K28_LENGTH                             0x1
#define _PID1K2H_PID1K28_MASK                               0x1
#define _PID1K2H_PID1K29_POSN                               0x1
#define _PID1K2H_PID1K29_POSITION                           0x1
#define _PID1K2H_PID1K29_SIZE                               0x1
#define _PID1K2H_PID1K29_LENGTH                             0x1
#define _PID1K2H_PID1K29_MASK                               0x2
#define _PID1K2H_PID1K210_POSN                              0x2
#define _PID1K2H_PID1K210_POSITION                          0x2
#define _PID1K2H_PID1K210_SIZE                              0x1
#define _PID1K2H_PID1K210_LENGTH                            0x1
#define _PID1K2H_PID1K210_MASK                              0x4
#define _PID1K2H_PID1K211_POSN                              0x3
#define _PID1K2H_PID1K211_POSITION                          0x3
#define _PID1K2H_PID1K211_SIZE                              0x1
#define _PID1K2H_PID1K211_LENGTH                            0x1
#define _PID1K2H_PID1K211_MASK                              0x8
#define _PID1K2H_PID1K212_POSN                              0x4
#define _PID1K2H_PID1K212_POSITION                          0x4
#define _PID1K2H_PID1K212_SIZE                              0x1
#define _PID1K2H_PID1K212_LENGTH                            0x1
#define _PID1K2H_PID1K212_MASK                              0x10
#define _PID1K2H_PID1K213_POSN                              0x5
#define _PID1K2H_PID1K213_POSITION                          0x5
#define _PID1K2H_PID1K213_SIZE                              0x1
#define _PID1K2H_PID1K213_LENGTH                            0x1
#define _PID1K2H_PID1K213_MASK                              0x20
#define _PID1K2H_PID1K214_POSN                              0x6
#define _PID1K2H_PID1K214_POSITION                          0x6
#define _PID1K2H_PID1K214_SIZE                              0x1
#define _PID1K2H_PID1K214_LENGTH                            0x1
#define _PID1K2H_PID1K214_MASK                              0x40
#define _PID1K2H_PID1K215_POSN                              0x7
#define _PID1K2H_PID1K215_POSITION                          0x7
#define _PID1K2H_PID1K215_SIZE                              0x1
#define _PID1K2H_PID1K215_LENGTH                            0x1
#define _PID1K2H_PID1K215_MASK                              0x80
#define _PID1K2H_K28_POSN                                   0x0
#define _PID1K2H_K28_POSITION                               0x0
#define _PID1K2H_K28_SIZE                                   0x1
#define _PID1K2H_K28_LENGTH                                 0x1
#define _PID1K2H_K28_MASK                                   0x1
#define _PID1K2H_K29_POSN                                   0x1
#define _PID1K2H_K29_POSITION                               0x1
#define _PID1K2H_K29_SIZE                                   0x1
#define _PID1K2H_K29_LENGTH                                 0x1
#define _PID1K2H_K29_MASK                                   0x2
#define _PID1K2H_K210_POSN                                  0x2
#define _PID1K2H_K210_POSITION                              0x2
#define _PID1K2H_K210_SIZE                                  0x1
#define _PID1K2H_K210_LENGTH                                0x1
#define _PID1K2H_K210_MASK                                  0x4
#define _PID1K2H_K211_POSN                                  0x3
#define _PID1K2H_K211_POSITION                              0x3
#define _PID1K2H_K211_SIZE                                  0x1
#define _PID1K2H_K211_LENGTH                                0x1
#define _PID1K2H_K211_MASK                                  0x8
#define _PID1K2H_K212_POSN                                  0x4
#define _PID1K2H_K212_POSITION                              0x4
#define _PID1K2H_K212_SIZE                                  0x1
#define _PID1K2H_K212_LENGTH                                0x1
#define _PID1K2H_K212_MASK                                  0x10
#define _PID1K2H_K213_POSN                                  0x5
#define _PID1K2H_K213_POSITION                              0x5
#define _PID1K2H_K213_SIZE                                  0x1
#define _PID1K2H_K213_LENGTH                                0x1
#define _PID1K2H_K213_MASK                                  0x20
#define _PID1K2H_K214_POSN                                  0x6
#define _PID1K2H_K214_POSITION                              0x6
#define _PID1K2H_K214_SIZE                                  0x1
#define _PID1K2H_K214_LENGTH                                0x1
#define _PID1K2H_K214_MASK                                  0x40
#define _PID1K2H_K215_POSN                                  0x7
#define _PID1K2H_K215_POSITION                              0x7
#define _PID1K2H_K215_SIZE                                  0x1
#define _PID1K2H_K215_LENGTH                                0x1
#define _PID1K2H_K215_MASK                                  0x80

// Register: PID1K3
extern volatile unsigned short          PID1K3              @ 0x594;
#ifndef _LIB_BUILD
asm("PID1K3 equ 0594h");
#endif

// Register: PID1K3L
extern volatile unsigned char           PID1K3L             @ 0x594;
#ifndef _LIB_BUILD
asm("PID1K3L equ 0594h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1K30                :1;
        unsigned PID1K31                :1;
        unsigned PID1K32                :1;
        unsigned PID1K33                :1;
        unsigned PID1K34                :1;
        unsigned PID1K35                :1;
        unsigned PID1K36                :1;
        unsigned PID1K37                :1;
    };
    struct {
        unsigned K30                    :1;
        unsigned K31                    :1;
        unsigned K32                    :1;
        unsigned K33                    :1;
        unsigned K34                    :1;
        unsigned K35                    :1;
        unsigned K36                    :1;
        unsigned K37                    :1;
    };
} PID1K3Lbits_t;
extern volatile PID1K3Lbits_t PID1K3Lbits @ 0x594;
// bitfield macros
#define _PID1K3L_PID1K30_POSN                               0x0
#define _PID1K3L_PID1K30_POSITION                           0x0
#define _PID1K3L_PID1K30_SIZE                               0x1
#define _PID1K3L_PID1K30_LENGTH                             0x1
#define _PID1K3L_PID1K30_MASK                               0x1
#define _PID1K3L_PID1K31_POSN                               0x1
#define _PID1K3L_PID1K31_POSITION                           0x1
#define _PID1K3L_PID1K31_SIZE                               0x1
#define _PID1K3L_PID1K31_LENGTH                             0x1
#define _PID1K3L_PID1K31_MASK                               0x2
#define _PID1K3L_PID1K32_POSN                               0x2
#define _PID1K3L_PID1K32_POSITION                           0x2
#define _PID1K3L_PID1K32_SIZE                               0x1
#define _PID1K3L_PID1K32_LENGTH                             0x1
#define _PID1K3L_PID1K32_MASK                               0x4
#define _PID1K3L_PID1K33_POSN                               0x3
#define _PID1K3L_PID1K33_POSITION                           0x3
#define _PID1K3L_PID1K33_SIZE                               0x1
#define _PID1K3L_PID1K33_LENGTH                             0x1
#define _PID1K3L_PID1K33_MASK                               0x8
#define _PID1K3L_PID1K34_POSN                               0x4
#define _PID1K3L_PID1K34_POSITION                           0x4
#define _PID1K3L_PID1K34_SIZE                               0x1
#define _PID1K3L_PID1K34_LENGTH                             0x1
#define _PID1K3L_PID1K34_MASK                               0x10
#define _PID1K3L_PID1K35_POSN                               0x5
#define _PID1K3L_PID1K35_POSITION                           0x5
#define _PID1K3L_PID1K35_SIZE                               0x1
#define _PID1K3L_PID1K35_LENGTH                             0x1
#define _PID1K3L_PID1K35_MASK                               0x20
#define _PID1K3L_PID1K36_POSN                               0x6
#define _PID1K3L_PID1K36_POSITION                           0x6
#define _PID1K3L_PID1K36_SIZE                               0x1
#define _PID1K3L_PID1K36_LENGTH                             0x1
#define _PID1K3L_PID1K36_MASK                               0x40
#define _PID1K3L_PID1K37_POSN                               0x7
#define _PID1K3L_PID1K37_POSITION                           0x7
#define _PID1K3L_PID1K37_SIZE                               0x1
#define _PID1K3L_PID1K37_LENGTH                             0x1
#define _PID1K3L_PID1K37_MASK                               0x80
#define _PID1K3L_K30_POSN                                   0x0
#define _PID1K3L_K30_POSITION                               0x0
#define _PID1K3L_K30_SIZE                                   0x1
#define _PID1K3L_K30_LENGTH                                 0x1
#define _PID1K3L_K30_MASK                                   0x1
#define _PID1K3L_K31_POSN                                   0x1
#define _PID1K3L_K31_POSITION                               0x1
#define _PID1K3L_K31_SIZE                                   0x1
#define _PID1K3L_K31_LENGTH                                 0x1
#define _PID1K3L_K31_MASK                                   0x2
#define _PID1K3L_K32_POSN                                   0x2
#define _PID1K3L_K32_POSITION                               0x2
#define _PID1K3L_K32_SIZE                                   0x1
#define _PID1K3L_K32_LENGTH                                 0x1
#define _PID1K3L_K32_MASK                                   0x4
#define _PID1K3L_K33_POSN                                   0x3
#define _PID1K3L_K33_POSITION                               0x3
#define _PID1K3L_K33_SIZE                                   0x1
#define _PID1K3L_K33_LENGTH                                 0x1
#define _PID1K3L_K33_MASK                                   0x8
#define _PID1K3L_K34_POSN                                   0x4
#define _PID1K3L_K34_POSITION                               0x4
#define _PID1K3L_K34_SIZE                                   0x1
#define _PID1K3L_K34_LENGTH                                 0x1
#define _PID1K3L_K34_MASK                                   0x10
#define _PID1K3L_K35_POSN                                   0x5
#define _PID1K3L_K35_POSITION                               0x5
#define _PID1K3L_K35_SIZE                                   0x1
#define _PID1K3L_K35_LENGTH                                 0x1
#define _PID1K3L_K35_MASK                                   0x20
#define _PID1K3L_K36_POSN                                   0x6
#define _PID1K3L_K36_POSITION                               0x6
#define _PID1K3L_K36_SIZE                                   0x1
#define _PID1K3L_K36_LENGTH                                 0x1
#define _PID1K3L_K36_MASK                                   0x40
#define _PID1K3L_K37_POSN                                   0x7
#define _PID1K3L_K37_POSITION                               0x7
#define _PID1K3L_K37_SIZE                                   0x1
#define _PID1K3L_K37_LENGTH                                 0x1
#define _PID1K3L_K37_MASK                                   0x80

// Register: PID1K3H
extern volatile unsigned char           PID1K3H             @ 0x595;
#ifndef _LIB_BUILD
asm("PID1K3H equ 0595h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1K38                :1;
        unsigned PID1K39                :1;
        unsigned PID1K310               :1;
        unsigned PID1K311               :1;
        unsigned PID1K312               :1;
        unsigned PID1K313               :1;
        unsigned PID1K314               :1;
        unsigned PID1K315               :1;
    };
    struct {
        unsigned K38                    :1;
        unsigned K39                    :1;
        unsigned K310                   :1;
        unsigned K311                   :1;
        unsigned K312                   :1;
        unsigned K313                   :1;
        unsigned K314                   :1;
        unsigned K315                   :1;
    };
} PID1K3Hbits_t;
extern volatile PID1K3Hbits_t PID1K3Hbits @ 0x595;
// bitfield macros
#define _PID1K3H_PID1K38_POSN                               0x0
#define _PID1K3H_PID1K38_POSITION                           0x0
#define _PID1K3H_PID1K38_SIZE                               0x1
#define _PID1K3H_PID1K38_LENGTH                             0x1
#define _PID1K3H_PID1K38_MASK                               0x1
#define _PID1K3H_PID1K39_POSN                               0x1
#define _PID1K3H_PID1K39_POSITION                           0x1
#define _PID1K3H_PID1K39_SIZE                               0x1
#define _PID1K3H_PID1K39_LENGTH                             0x1
#define _PID1K3H_PID1K39_MASK                               0x2
#define _PID1K3H_PID1K310_POSN                              0x2
#define _PID1K3H_PID1K310_POSITION                          0x2
#define _PID1K3H_PID1K310_SIZE                              0x1
#define _PID1K3H_PID1K310_LENGTH                            0x1
#define _PID1K3H_PID1K310_MASK                              0x4
#define _PID1K3H_PID1K311_POSN                              0x3
#define _PID1K3H_PID1K311_POSITION                          0x3
#define _PID1K3H_PID1K311_SIZE                              0x1
#define _PID1K3H_PID1K311_LENGTH                            0x1
#define _PID1K3H_PID1K311_MASK                              0x8
#define _PID1K3H_PID1K312_POSN                              0x4
#define _PID1K3H_PID1K312_POSITION                          0x4
#define _PID1K3H_PID1K312_SIZE                              0x1
#define _PID1K3H_PID1K312_LENGTH                            0x1
#define _PID1K3H_PID1K312_MASK                              0x10
#define _PID1K3H_PID1K313_POSN                              0x5
#define _PID1K3H_PID1K313_POSITION                          0x5
#define _PID1K3H_PID1K313_SIZE                              0x1
#define _PID1K3H_PID1K313_LENGTH                            0x1
#define _PID1K3H_PID1K313_MASK                              0x20
#define _PID1K3H_PID1K314_POSN                              0x6
#define _PID1K3H_PID1K314_POSITION                          0x6
#define _PID1K3H_PID1K314_SIZE                              0x1
#define _PID1K3H_PID1K314_LENGTH                            0x1
#define _PID1K3H_PID1K314_MASK                              0x40
#define _PID1K3H_PID1K315_POSN                              0x7
#define _PID1K3H_PID1K315_POSITION                          0x7
#define _PID1K3H_PID1K315_SIZE                              0x1
#define _PID1K3H_PID1K315_LENGTH                            0x1
#define _PID1K3H_PID1K315_MASK                              0x80
#define _PID1K3H_K38_POSN                                   0x0
#define _PID1K3H_K38_POSITION                               0x0
#define _PID1K3H_K38_SIZE                                   0x1
#define _PID1K3H_K38_LENGTH                                 0x1
#define _PID1K3H_K38_MASK                                   0x1
#define _PID1K3H_K39_POSN                                   0x1
#define _PID1K3H_K39_POSITION                               0x1
#define _PID1K3H_K39_SIZE                                   0x1
#define _PID1K3H_K39_LENGTH                                 0x1
#define _PID1K3H_K39_MASK                                   0x2
#define _PID1K3H_K310_POSN                                  0x2
#define _PID1K3H_K310_POSITION                              0x2
#define _PID1K3H_K310_SIZE                                  0x1
#define _PID1K3H_K310_LENGTH                                0x1
#define _PID1K3H_K310_MASK                                  0x4
#define _PID1K3H_K311_POSN                                  0x3
#define _PID1K3H_K311_POSITION                              0x3
#define _PID1K3H_K311_SIZE                                  0x1
#define _PID1K3H_K311_LENGTH                                0x1
#define _PID1K3H_K311_MASK                                  0x8
#define _PID1K3H_K312_POSN                                  0x4
#define _PID1K3H_K312_POSITION                              0x4
#define _PID1K3H_K312_SIZE                                  0x1
#define _PID1K3H_K312_LENGTH                                0x1
#define _PID1K3H_K312_MASK                                  0x10
#define _PID1K3H_K313_POSN                                  0x5
#define _PID1K3H_K313_POSITION                              0x5
#define _PID1K3H_K313_SIZE                                  0x1
#define _PID1K3H_K313_LENGTH                                0x1
#define _PID1K3H_K313_MASK                                  0x20
#define _PID1K3H_K314_POSN                                  0x6
#define _PID1K3H_K314_POSITION                              0x6
#define _PID1K3H_K314_SIZE                                  0x1
#define _PID1K3H_K314_LENGTH                                0x1
#define _PID1K3H_K314_MASK                                  0x40
#define _PID1K3H_K315_POSN                                  0x7
#define _PID1K3H_K315_POSITION                              0x7
#define _PID1K3H_K315_SIZE                                  0x1
#define _PID1K3H_K315_LENGTH                                0x1
#define _PID1K3H_K315_MASK                                  0x80

// Register: PID1OUT
#ifndef _LIB_BUILD
asm("PID1OUT equ 0596h");
#endif

// Register: PID1OUTLL
extern volatile unsigned char           PID1OUTLL           @ 0x596;
#ifndef _LIB_BUILD
asm("PID1OUTLL equ 0596h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1OUT0               :1;
        unsigned PID1OUT1               :1;
        unsigned PID1OUT2               :1;
        unsigned PID1OUT3               :1;
        unsigned PID1OUT4               :1;
        unsigned PID1OUT5               :1;
        unsigned PID1OUT6               :1;
        unsigned PID1OUT7               :1;
    };
    struct {
        unsigned OUT0                   :1;
        unsigned OUT1                   :1;
        unsigned OUT2                   :1;
        unsigned OUT3                   :1;
        unsigned OUT4                   :1;
        unsigned OUT5                   :1;
        unsigned OUT6                   :1;
        unsigned OUT7                   :1;
    };
} PID1OUTLLbits_t;
extern volatile PID1OUTLLbits_t PID1OUTLLbits @ 0x596;
// bitfield macros
#define _PID1OUTLL_PID1OUT0_POSN                            0x0
#define _PID1OUTLL_PID1OUT0_POSITION                        0x0
#define _PID1OUTLL_PID1OUT0_SIZE                            0x1
#define _PID1OUTLL_PID1OUT0_LENGTH                          0x1
#define _PID1OUTLL_PID1OUT0_MASK                            0x1
#define _PID1OUTLL_PID1OUT1_POSN                            0x1
#define _PID1OUTLL_PID1OUT1_POSITION                        0x1
#define _PID1OUTLL_PID1OUT1_SIZE                            0x1
#define _PID1OUTLL_PID1OUT1_LENGTH                          0x1
#define _PID1OUTLL_PID1OUT1_MASK                            0x2
#define _PID1OUTLL_PID1OUT2_POSN                            0x2
#define _PID1OUTLL_PID1OUT2_POSITION                        0x2
#define _PID1OUTLL_PID1OUT2_SIZE                            0x1
#define _PID1OUTLL_PID1OUT2_LENGTH                          0x1
#define _PID1OUTLL_PID1OUT2_MASK                            0x4
#define _PID1OUTLL_PID1OUT3_POSN                            0x3
#define _PID1OUTLL_PID1OUT3_POSITION                        0x3
#define _PID1OUTLL_PID1OUT3_SIZE                            0x1
#define _PID1OUTLL_PID1OUT3_LENGTH                          0x1
#define _PID1OUTLL_PID1OUT3_MASK                            0x8
#define _PID1OUTLL_PID1OUT4_POSN                            0x4
#define _PID1OUTLL_PID1OUT4_POSITION                        0x4
#define _PID1OUTLL_PID1OUT4_SIZE                            0x1
#define _PID1OUTLL_PID1OUT4_LENGTH                          0x1
#define _PID1OUTLL_PID1OUT4_MASK                            0x10
#define _PID1OUTLL_PID1OUT5_POSN                            0x5
#define _PID1OUTLL_PID1OUT5_POSITION                        0x5
#define _PID1OUTLL_PID1OUT5_SIZE                            0x1
#define _PID1OUTLL_PID1OUT5_LENGTH                          0x1
#define _PID1OUTLL_PID1OUT5_MASK                            0x20
#define _PID1OUTLL_PID1OUT6_POSN                            0x6
#define _PID1OUTLL_PID1OUT6_POSITION                        0x6
#define _PID1OUTLL_PID1OUT6_SIZE                            0x1
#define _PID1OUTLL_PID1OUT6_LENGTH                          0x1
#define _PID1OUTLL_PID1OUT6_MASK                            0x40
#define _PID1OUTLL_PID1OUT7_POSN                            0x7
#define _PID1OUTLL_PID1OUT7_POSITION                        0x7
#define _PID1OUTLL_PID1OUT7_SIZE                            0x1
#define _PID1OUTLL_PID1OUT7_LENGTH                          0x1
#define _PID1OUTLL_PID1OUT7_MASK                            0x80
#define _PID1OUTLL_OUT0_POSN                                0x0
#define _PID1OUTLL_OUT0_POSITION                            0x0
#define _PID1OUTLL_OUT0_SIZE                                0x1
#define _PID1OUTLL_OUT0_LENGTH                              0x1
#define _PID1OUTLL_OUT0_MASK                                0x1
#define _PID1OUTLL_OUT1_POSN                                0x1
#define _PID1OUTLL_OUT1_POSITION                            0x1
#define _PID1OUTLL_OUT1_SIZE                                0x1
#define _PID1OUTLL_OUT1_LENGTH                              0x1
#define _PID1OUTLL_OUT1_MASK                                0x2
#define _PID1OUTLL_OUT2_POSN                                0x2
#define _PID1OUTLL_OUT2_POSITION                            0x2
#define _PID1OUTLL_OUT2_SIZE                                0x1
#define _PID1OUTLL_OUT2_LENGTH                              0x1
#define _PID1OUTLL_OUT2_MASK                                0x4
#define _PID1OUTLL_OUT3_POSN                                0x3
#define _PID1OUTLL_OUT3_POSITION                            0x3
#define _PID1OUTLL_OUT3_SIZE                                0x1
#define _PID1OUTLL_OUT3_LENGTH                              0x1
#define _PID1OUTLL_OUT3_MASK                                0x8
#define _PID1OUTLL_OUT4_POSN                                0x4
#define _PID1OUTLL_OUT4_POSITION                            0x4
#define _PID1OUTLL_OUT4_SIZE                                0x1
#define _PID1OUTLL_OUT4_LENGTH                              0x1
#define _PID1OUTLL_OUT4_MASK                                0x10
#define _PID1OUTLL_OUT5_POSN                                0x5
#define _PID1OUTLL_OUT5_POSITION                            0x5
#define _PID1OUTLL_OUT5_SIZE                                0x1
#define _PID1OUTLL_OUT5_LENGTH                              0x1
#define _PID1OUTLL_OUT5_MASK                                0x20
#define _PID1OUTLL_OUT6_POSN                                0x6
#define _PID1OUTLL_OUT6_POSITION                            0x6
#define _PID1OUTLL_OUT6_SIZE                                0x1
#define _PID1OUTLL_OUT6_LENGTH                              0x1
#define _PID1OUTLL_OUT6_MASK                                0x40
#define _PID1OUTLL_OUT7_POSN                                0x7
#define _PID1OUTLL_OUT7_POSITION                            0x7
#define _PID1OUTLL_OUT7_SIZE                                0x1
#define _PID1OUTLL_OUT7_LENGTH                              0x1
#define _PID1OUTLL_OUT7_MASK                                0x80

// Register: PID1OUTLH
extern volatile unsigned char           PID1OUTLH           @ 0x597;
#ifndef _LIB_BUILD
asm("PID1OUTLH equ 0597h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1OUT8               :1;
        unsigned PID1OUT9               :1;
        unsigned PID1OUT10              :1;
        unsigned PID1OUT11              :1;
        unsigned PID1OUT12              :1;
        unsigned PID1OUT13              :1;
        unsigned PID1OUT14              :1;
        unsigned PID1OUT15              :1;
    };
    struct {
        unsigned OUT8                   :1;
        unsigned OUT9                   :1;
        unsigned OUT10                  :1;
        unsigned OUT11                  :1;
        unsigned OUT12                  :1;
        unsigned OUT13                  :1;
        unsigned OUT14                  :1;
        unsigned OUT15                  :1;
    };
} PID1OUTLHbits_t;
extern volatile PID1OUTLHbits_t PID1OUTLHbits @ 0x597;
// bitfield macros
#define _PID1OUTLH_PID1OUT8_POSN                            0x0
#define _PID1OUTLH_PID1OUT8_POSITION                        0x0
#define _PID1OUTLH_PID1OUT8_SIZE                            0x1
#define _PID1OUTLH_PID1OUT8_LENGTH                          0x1
#define _PID1OUTLH_PID1OUT8_MASK                            0x1
#define _PID1OUTLH_PID1OUT9_POSN                            0x1
#define _PID1OUTLH_PID1OUT9_POSITION                        0x1
#define _PID1OUTLH_PID1OUT9_SIZE                            0x1
#define _PID1OUTLH_PID1OUT9_LENGTH                          0x1
#define _PID1OUTLH_PID1OUT9_MASK                            0x2
#define _PID1OUTLH_PID1OUT10_POSN                           0x2
#define _PID1OUTLH_PID1OUT10_POSITION                       0x2
#define _PID1OUTLH_PID1OUT10_SIZE                           0x1
#define _PID1OUTLH_PID1OUT10_LENGTH                         0x1
#define _PID1OUTLH_PID1OUT10_MASK                           0x4
#define _PID1OUTLH_PID1OUT11_POSN                           0x3
#define _PID1OUTLH_PID1OUT11_POSITION                       0x3
#define _PID1OUTLH_PID1OUT11_SIZE                           0x1
#define _PID1OUTLH_PID1OUT11_LENGTH                         0x1
#define _PID1OUTLH_PID1OUT11_MASK                           0x8
#define _PID1OUTLH_PID1OUT12_POSN                           0x4
#define _PID1OUTLH_PID1OUT12_POSITION                       0x4
#define _PID1OUTLH_PID1OUT12_SIZE                           0x1
#define _PID1OUTLH_PID1OUT12_LENGTH                         0x1
#define _PID1OUTLH_PID1OUT12_MASK                           0x10
#define _PID1OUTLH_PID1OUT13_POSN                           0x5
#define _PID1OUTLH_PID1OUT13_POSITION                       0x5
#define _PID1OUTLH_PID1OUT13_SIZE                           0x1
#define _PID1OUTLH_PID1OUT13_LENGTH                         0x1
#define _PID1OUTLH_PID1OUT13_MASK                           0x20
#define _PID1OUTLH_PID1OUT14_POSN                           0x6
#define _PID1OUTLH_PID1OUT14_POSITION                       0x6
#define _PID1OUTLH_PID1OUT14_SIZE                           0x1
#define _PID1OUTLH_PID1OUT14_LENGTH                         0x1
#define _PID1OUTLH_PID1OUT14_MASK                           0x40
#define _PID1OUTLH_PID1OUT15_POSN                           0x7
#define _PID1OUTLH_PID1OUT15_POSITION                       0x7
#define _PID1OUTLH_PID1OUT15_SIZE                           0x1
#define _PID1OUTLH_PID1OUT15_LENGTH                         0x1
#define _PID1OUTLH_PID1OUT15_MASK                           0x80
#define _PID1OUTLH_OUT8_POSN                                0x0
#define _PID1OUTLH_OUT8_POSITION                            0x0
#define _PID1OUTLH_OUT8_SIZE                                0x1
#define _PID1OUTLH_OUT8_LENGTH                              0x1
#define _PID1OUTLH_OUT8_MASK                                0x1
#define _PID1OUTLH_OUT9_POSN                                0x1
#define _PID1OUTLH_OUT9_POSITION                            0x1
#define _PID1OUTLH_OUT9_SIZE                                0x1
#define _PID1OUTLH_OUT9_LENGTH                              0x1
#define _PID1OUTLH_OUT9_MASK                                0x2
#define _PID1OUTLH_OUT10_POSN                               0x2
#define _PID1OUTLH_OUT10_POSITION                           0x2
#define _PID1OUTLH_OUT10_SIZE                               0x1
#define _PID1OUTLH_OUT10_LENGTH                             0x1
#define _PID1OUTLH_OUT10_MASK                               0x4
#define _PID1OUTLH_OUT11_POSN                               0x3
#define _PID1OUTLH_OUT11_POSITION                           0x3
#define _PID1OUTLH_OUT11_SIZE                               0x1
#define _PID1OUTLH_OUT11_LENGTH                             0x1
#define _PID1OUTLH_OUT11_MASK                               0x8
#define _PID1OUTLH_OUT12_POSN                               0x4
#define _PID1OUTLH_OUT12_POSITION                           0x4
#define _PID1OUTLH_OUT12_SIZE                               0x1
#define _PID1OUTLH_OUT12_LENGTH                             0x1
#define _PID1OUTLH_OUT12_MASK                               0x10
#define _PID1OUTLH_OUT13_POSN                               0x5
#define _PID1OUTLH_OUT13_POSITION                           0x5
#define _PID1OUTLH_OUT13_SIZE                               0x1
#define _PID1OUTLH_OUT13_LENGTH                             0x1
#define _PID1OUTLH_OUT13_MASK                               0x20
#define _PID1OUTLH_OUT14_POSN                               0x6
#define _PID1OUTLH_OUT14_POSITION                           0x6
#define _PID1OUTLH_OUT14_SIZE                               0x1
#define _PID1OUTLH_OUT14_LENGTH                             0x1
#define _PID1OUTLH_OUT14_MASK                               0x40
#define _PID1OUTLH_OUT15_POSN                               0x7
#define _PID1OUTLH_OUT15_POSITION                           0x7
#define _PID1OUTLH_OUT15_SIZE                               0x1
#define _PID1OUTLH_OUT15_LENGTH                             0x1
#define _PID1OUTLH_OUT15_MASK                               0x80

// Register: PID1OUTHL
extern volatile unsigned char           PID1OUTHL           @ 0x598;
#ifndef _LIB_BUILD
asm("PID1OUTHL equ 0598h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1OUT16              :1;
        unsigned PID1OUT17              :1;
        unsigned PID1OUT18              :1;
        unsigned PID1OUT19              :1;
        unsigned PID1OUT20              :1;
        unsigned PID1OUT21              :1;
        unsigned PID1OUT22              :1;
        unsigned PID1OUT23              :1;
    };
    struct {
        unsigned OUT16                  :1;
        unsigned OUT17                  :1;
        unsigned OUT18                  :1;
        unsigned OUT19                  :1;
        unsigned OUT20                  :1;
        unsigned OUT21                  :1;
        unsigned OUT22                  :1;
        unsigned OUT23                  :1;
    };
} PID1OUTHLbits_t;
extern volatile PID1OUTHLbits_t PID1OUTHLbits @ 0x598;
// bitfield macros
#define _PID1OUTHL_PID1OUT16_POSN                           0x0
#define _PID1OUTHL_PID1OUT16_POSITION                       0x0
#define _PID1OUTHL_PID1OUT16_SIZE                           0x1
#define _PID1OUTHL_PID1OUT16_LENGTH                         0x1
#define _PID1OUTHL_PID1OUT16_MASK                           0x1
#define _PID1OUTHL_PID1OUT17_POSN                           0x1
#define _PID1OUTHL_PID1OUT17_POSITION                       0x1
#define _PID1OUTHL_PID1OUT17_SIZE                           0x1
#define _PID1OUTHL_PID1OUT17_LENGTH                         0x1
#define _PID1OUTHL_PID1OUT17_MASK                           0x2
#define _PID1OUTHL_PID1OUT18_POSN                           0x2
#define _PID1OUTHL_PID1OUT18_POSITION                       0x2
#define _PID1OUTHL_PID1OUT18_SIZE                           0x1
#define _PID1OUTHL_PID1OUT18_LENGTH                         0x1
#define _PID1OUTHL_PID1OUT18_MASK                           0x4
#define _PID1OUTHL_PID1OUT19_POSN                           0x3
#define _PID1OUTHL_PID1OUT19_POSITION                       0x3
#define _PID1OUTHL_PID1OUT19_SIZE                           0x1
#define _PID1OUTHL_PID1OUT19_LENGTH                         0x1
#define _PID1OUTHL_PID1OUT19_MASK                           0x8
#define _PID1OUTHL_PID1OUT20_POSN                           0x4
#define _PID1OUTHL_PID1OUT20_POSITION                       0x4
#define _PID1OUTHL_PID1OUT20_SIZE                           0x1
#define _PID1OUTHL_PID1OUT20_LENGTH                         0x1
#define _PID1OUTHL_PID1OUT20_MASK                           0x10
#define _PID1OUTHL_PID1OUT21_POSN                           0x5
#define _PID1OUTHL_PID1OUT21_POSITION                       0x5
#define _PID1OUTHL_PID1OUT21_SIZE                           0x1
#define _PID1OUTHL_PID1OUT21_LENGTH                         0x1
#define _PID1OUTHL_PID1OUT21_MASK                           0x20
#define _PID1OUTHL_PID1OUT22_POSN                           0x6
#define _PID1OUTHL_PID1OUT22_POSITION                       0x6
#define _PID1OUTHL_PID1OUT22_SIZE                           0x1
#define _PID1OUTHL_PID1OUT22_LENGTH                         0x1
#define _PID1OUTHL_PID1OUT22_MASK                           0x40
#define _PID1OUTHL_PID1OUT23_POSN                           0x7
#define _PID1OUTHL_PID1OUT23_POSITION                       0x7
#define _PID1OUTHL_PID1OUT23_SIZE                           0x1
#define _PID1OUTHL_PID1OUT23_LENGTH                         0x1
#define _PID1OUTHL_PID1OUT23_MASK                           0x80
#define _PID1OUTHL_OUT16_POSN                               0x0
#define _PID1OUTHL_OUT16_POSITION                           0x0
#define _PID1OUTHL_OUT16_SIZE                               0x1
#define _PID1OUTHL_OUT16_LENGTH                             0x1
#define _PID1OUTHL_OUT16_MASK                               0x1
#define _PID1OUTHL_OUT17_POSN                               0x1
#define _PID1OUTHL_OUT17_POSITION                           0x1
#define _PID1OUTHL_OUT17_SIZE                               0x1
#define _PID1OUTHL_OUT17_LENGTH                             0x1
#define _PID1OUTHL_OUT17_MASK                               0x2
#define _PID1OUTHL_OUT18_POSN                               0x2
#define _PID1OUTHL_OUT18_POSITION                           0x2
#define _PID1OUTHL_OUT18_SIZE                               0x1
#define _PID1OUTHL_OUT18_LENGTH                             0x1
#define _PID1OUTHL_OUT18_MASK                               0x4
#define _PID1OUTHL_OUT19_POSN                               0x3
#define _PID1OUTHL_OUT19_POSITION                           0x3
#define _PID1OUTHL_OUT19_SIZE                               0x1
#define _PID1OUTHL_OUT19_LENGTH                             0x1
#define _PID1OUTHL_OUT19_MASK                               0x8
#define _PID1OUTHL_OUT20_POSN                               0x4
#define _PID1OUTHL_OUT20_POSITION                           0x4
#define _PID1OUTHL_OUT20_SIZE                               0x1
#define _PID1OUTHL_OUT20_LENGTH                             0x1
#define _PID1OUTHL_OUT20_MASK                               0x10
#define _PID1OUTHL_OUT21_POSN                               0x5
#define _PID1OUTHL_OUT21_POSITION                           0x5
#define _PID1OUTHL_OUT21_SIZE                               0x1
#define _PID1OUTHL_OUT21_LENGTH                             0x1
#define _PID1OUTHL_OUT21_MASK                               0x20
#define _PID1OUTHL_OUT22_POSN                               0x6
#define _PID1OUTHL_OUT22_POSITION                           0x6
#define _PID1OUTHL_OUT22_SIZE                               0x1
#define _PID1OUTHL_OUT22_LENGTH                             0x1
#define _PID1OUTHL_OUT22_MASK                               0x40
#define _PID1OUTHL_OUT23_POSN                               0x7
#define _PID1OUTHL_OUT23_POSITION                           0x7
#define _PID1OUTHL_OUT23_SIZE                               0x1
#define _PID1OUTHL_OUT23_LENGTH                             0x1
#define _PID1OUTHL_OUT23_MASK                               0x80

// Register: PID1OUTHH
extern volatile unsigned char           PID1OUTHH           @ 0x599;
#ifndef _LIB_BUILD
asm("PID1OUTHH equ 0599h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1OUT24              :1;
        unsigned PID1OUT25              :1;
        unsigned PID1OUT26              :1;
        unsigned PID1OUT27              :1;
        unsigned PID1OUT28              :1;
        unsigned PID1OUT29              :1;
        unsigned PID1OUT30              :1;
        unsigned PID1OUT31              :1;
    };
    struct {
        unsigned OUT24                  :1;
        unsigned OUT25                  :1;
        unsigned OUT26                  :1;
        unsigned OUT27                  :1;
        unsigned OUT28                  :1;
        unsigned OUT29                  :1;
        unsigned OUT30                  :1;
        unsigned OUT31                  :1;
    };
} PID1OUTHHbits_t;
extern volatile PID1OUTHHbits_t PID1OUTHHbits @ 0x599;
// bitfield macros
#define _PID1OUTHH_PID1OUT24_POSN                           0x0
#define _PID1OUTHH_PID1OUT24_POSITION                       0x0
#define _PID1OUTHH_PID1OUT24_SIZE                           0x1
#define _PID1OUTHH_PID1OUT24_LENGTH                         0x1
#define _PID1OUTHH_PID1OUT24_MASK                           0x1
#define _PID1OUTHH_PID1OUT25_POSN                           0x1
#define _PID1OUTHH_PID1OUT25_POSITION                       0x1
#define _PID1OUTHH_PID1OUT25_SIZE                           0x1
#define _PID1OUTHH_PID1OUT25_LENGTH                         0x1
#define _PID1OUTHH_PID1OUT25_MASK                           0x2
#define _PID1OUTHH_PID1OUT26_POSN                           0x2
#define _PID1OUTHH_PID1OUT26_POSITION                       0x2
#define _PID1OUTHH_PID1OUT26_SIZE                           0x1
#define _PID1OUTHH_PID1OUT26_LENGTH                         0x1
#define _PID1OUTHH_PID1OUT26_MASK                           0x4
#define _PID1OUTHH_PID1OUT27_POSN                           0x3
#define _PID1OUTHH_PID1OUT27_POSITION                       0x3
#define _PID1OUTHH_PID1OUT27_SIZE                           0x1
#define _PID1OUTHH_PID1OUT27_LENGTH                         0x1
#define _PID1OUTHH_PID1OUT27_MASK                           0x8
#define _PID1OUTHH_PID1OUT28_POSN                           0x4
#define _PID1OUTHH_PID1OUT28_POSITION                       0x4
#define _PID1OUTHH_PID1OUT28_SIZE                           0x1
#define _PID1OUTHH_PID1OUT28_LENGTH                         0x1
#define _PID1OUTHH_PID1OUT28_MASK                           0x10
#define _PID1OUTHH_PID1OUT29_POSN                           0x5
#define _PID1OUTHH_PID1OUT29_POSITION                       0x5
#define _PID1OUTHH_PID1OUT29_SIZE                           0x1
#define _PID1OUTHH_PID1OUT29_LENGTH                         0x1
#define _PID1OUTHH_PID1OUT29_MASK                           0x20
#define _PID1OUTHH_PID1OUT30_POSN                           0x6
#define _PID1OUTHH_PID1OUT30_POSITION                       0x6
#define _PID1OUTHH_PID1OUT30_SIZE                           0x1
#define _PID1OUTHH_PID1OUT30_LENGTH                         0x1
#define _PID1OUTHH_PID1OUT30_MASK                           0x40
#define _PID1OUTHH_PID1OUT31_POSN                           0x7
#define _PID1OUTHH_PID1OUT31_POSITION                       0x7
#define _PID1OUTHH_PID1OUT31_SIZE                           0x1
#define _PID1OUTHH_PID1OUT31_LENGTH                         0x1
#define _PID1OUTHH_PID1OUT31_MASK                           0x80
#define _PID1OUTHH_OUT24_POSN                               0x0
#define _PID1OUTHH_OUT24_POSITION                           0x0
#define _PID1OUTHH_OUT24_SIZE                               0x1
#define _PID1OUTHH_OUT24_LENGTH                             0x1
#define _PID1OUTHH_OUT24_MASK                               0x1
#define _PID1OUTHH_OUT25_POSN                               0x1
#define _PID1OUTHH_OUT25_POSITION                           0x1
#define _PID1OUTHH_OUT25_SIZE                               0x1
#define _PID1OUTHH_OUT25_LENGTH                             0x1
#define _PID1OUTHH_OUT25_MASK                               0x2
#define _PID1OUTHH_OUT26_POSN                               0x2
#define _PID1OUTHH_OUT26_POSITION                           0x2
#define _PID1OUTHH_OUT26_SIZE                               0x1
#define _PID1OUTHH_OUT26_LENGTH                             0x1
#define _PID1OUTHH_OUT26_MASK                               0x4
#define _PID1OUTHH_OUT27_POSN                               0x3
#define _PID1OUTHH_OUT27_POSITION                           0x3
#define _PID1OUTHH_OUT27_SIZE                               0x1
#define _PID1OUTHH_OUT27_LENGTH                             0x1
#define _PID1OUTHH_OUT27_MASK                               0x8
#define _PID1OUTHH_OUT28_POSN                               0x4
#define _PID1OUTHH_OUT28_POSITION                           0x4
#define _PID1OUTHH_OUT28_SIZE                               0x1
#define _PID1OUTHH_OUT28_LENGTH                             0x1
#define _PID1OUTHH_OUT28_MASK                               0x10
#define _PID1OUTHH_OUT29_POSN                               0x5
#define _PID1OUTHH_OUT29_POSITION                           0x5
#define _PID1OUTHH_OUT29_SIZE                               0x1
#define _PID1OUTHH_OUT29_LENGTH                             0x1
#define _PID1OUTHH_OUT29_MASK                               0x20
#define _PID1OUTHH_OUT30_POSN                               0x6
#define _PID1OUTHH_OUT30_POSITION                           0x6
#define _PID1OUTHH_OUT30_SIZE                               0x1
#define _PID1OUTHH_OUT30_LENGTH                             0x1
#define _PID1OUTHH_OUT30_MASK                               0x40
#define _PID1OUTHH_OUT31_POSN                               0x7
#define _PID1OUTHH_OUT31_POSITION                           0x7
#define _PID1OUTHH_OUT31_SIZE                               0x1
#define _PID1OUTHH_OUT31_LENGTH                             0x1
#define _PID1OUTHH_OUT31_MASK                               0x80

// Register: PID1OUTU
extern volatile unsigned char           PID1OUTU            @ 0x59A;
#ifndef _LIB_BUILD
asm("PID1OUTU equ 059Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1OUT32              :1;
        unsigned PID1OUT33              :1;
        unsigned PID1OUT34              :1;
        unsigned PID1OUT35              :1;
    };
    struct {
        unsigned OUT32                  :1;
        unsigned OUT33                  :1;
        unsigned OUT34                  :1;
        unsigned OUT35                  :1;
    };
} PID1OUTUbits_t;
extern volatile PID1OUTUbits_t PID1OUTUbits @ 0x59A;
// bitfield macros
#define _PID1OUTU_PID1OUT32_POSN                            0x0
#define _PID1OUTU_PID1OUT32_POSITION                        0x0
#define _PID1OUTU_PID1OUT32_SIZE                            0x1
#define _PID1OUTU_PID1OUT32_LENGTH                          0x1
#define _PID1OUTU_PID1OUT32_MASK                            0x1
#define _PID1OUTU_PID1OUT33_POSN                            0x1
#define _PID1OUTU_PID1OUT33_POSITION                        0x1
#define _PID1OUTU_PID1OUT33_SIZE                            0x1
#define _PID1OUTU_PID1OUT33_LENGTH                          0x1
#define _PID1OUTU_PID1OUT33_MASK                            0x2
#define _PID1OUTU_PID1OUT34_POSN                            0x2
#define _PID1OUTU_PID1OUT34_POSITION                        0x2
#define _PID1OUTU_PID1OUT34_SIZE                            0x1
#define _PID1OUTU_PID1OUT34_LENGTH                          0x1
#define _PID1OUTU_PID1OUT34_MASK                            0x4
#define _PID1OUTU_PID1OUT35_POSN                            0x3
#define _PID1OUTU_PID1OUT35_POSITION                        0x3
#define _PID1OUTU_PID1OUT35_SIZE                            0x1
#define _PID1OUTU_PID1OUT35_LENGTH                          0x1
#define _PID1OUTU_PID1OUT35_MASK                            0x8
#define _PID1OUTU_OUT32_POSN                                0x0
#define _PID1OUTU_OUT32_POSITION                            0x0
#define _PID1OUTU_OUT32_SIZE                                0x1
#define _PID1OUTU_OUT32_LENGTH                              0x1
#define _PID1OUTU_OUT32_MASK                                0x1
#define _PID1OUTU_OUT33_POSN                                0x1
#define _PID1OUTU_OUT33_POSITION                            0x1
#define _PID1OUTU_OUT33_SIZE                                0x1
#define _PID1OUTU_OUT33_LENGTH                              0x1
#define _PID1OUTU_OUT33_MASK                                0x2
#define _PID1OUTU_OUT34_POSN                                0x2
#define _PID1OUTU_OUT34_POSITION                            0x2
#define _PID1OUTU_OUT34_SIZE                                0x1
#define _PID1OUTU_OUT34_LENGTH                              0x1
#define _PID1OUTU_OUT34_MASK                                0x4
#define _PID1OUTU_OUT35_POSN                                0x3
#define _PID1OUTU_OUT35_POSITION                            0x3
#define _PID1OUTU_OUT35_SIZE                                0x1
#define _PID1OUTU_OUT35_LENGTH                              0x1
#define _PID1OUTU_OUT35_MASK                                0x8

// Register: PID1Z1
#ifndef __CCI__
extern volatile unsigned short long     PID1Z1              @ 0x59B;
#endif
#ifndef _LIB_BUILD
asm("PID1Z1 equ 059Bh");
#endif

// Register: PID1Z1L
extern volatile unsigned char           PID1Z1L             @ 0x59B;
#ifndef _LIB_BUILD
asm("PID1Z1L equ 059Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1Z10                :1;
        unsigned PID1Z11                :1;
        unsigned PID1Z12                :1;
        unsigned PID1Z13                :1;
        unsigned PID1Z14                :1;
        unsigned PID1Z15                :1;
        unsigned PID1Z16                :1;
        unsigned PID1Z17                :1;
    };
    struct {
        unsigned Z10                    :1;
        unsigned Z11                    :1;
        unsigned Z12                    :1;
        unsigned Z13                    :1;
        unsigned Z14                    :1;
        unsigned Z15                    :1;
        unsigned Z16                    :1;
        unsigned Z17                    :1;
    };
} PID1Z1Lbits_t;
extern volatile PID1Z1Lbits_t PID1Z1Lbits @ 0x59B;
// bitfield macros
#define _PID1Z1L_PID1Z10_POSN                               0x0
#define _PID1Z1L_PID1Z10_POSITION                           0x0
#define _PID1Z1L_PID1Z10_SIZE                               0x1
#define _PID1Z1L_PID1Z10_LENGTH                             0x1
#define _PID1Z1L_PID1Z10_MASK                               0x1
#define _PID1Z1L_PID1Z11_POSN                               0x1
#define _PID1Z1L_PID1Z11_POSITION                           0x1
#define _PID1Z1L_PID1Z11_SIZE                               0x1
#define _PID1Z1L_PID1Z11_LENGTH                             0x1
#define _PID1Z1L_PID1Z11_MASK                               0x2
#define _PID1Z1L_PID1Z12_POSN                               0x2
#define _PID1Z1L_PID1Z12_POSITION                           0x2
#define _PID1Z1L_PID1Z12_SIZE                               0x1
#define _PID1Z1L_PID1Z12_LENGTH                             0x1
#define _PID1Z1L_PID1Z12_MASK                               0x4
#define _PID1Z1L_PID1Z13_POSN                               0x3
#define _PID1Z1L_PID1Z13_POSITION                           0x3
#define _PID1Z1L_PID1Z13_SIZE                               0x1
#define _PID1Z1L_PID1Z13_LENGTH                             0x1
#define _PID1Z1L_PID1Z13_MASK                               0x8
#define _PID1Z1L_PID1Z14_POSN                               0x4
#define _PID1Z1L_PID1Z14_POSITION                           0x4
#define _PID1Z1L_PID1Z14_SIZE                               0x1
#define _PID1Z1L_PID1Z14_LENGTH                             0x1
#define _PID1Z1L_PID1Z14_MASK                               0x10
#define _PID1Z1L_PID1Z15_POSN                               0x5
#define _PID1Z1L_PID1Z15_POSITION                           0x5
#define _PID1Z1L_PID1Z15_SIZE                               0x1
#define _PID1Z1L_PID1Z15_LENGTH                             0x1
#define _PID1Z1L_PID1Z15_MASK                               0x20
#define _PID1Z1L_PID1Z16_POSN                               0x6
#define _PID1Z1L_PID1Z16_POSITION                           0x6
#define _PID1Z1L_PID1Z16_SIZE                               0x1
#define _PID1Z1L_PID1Z16_LENGTH                             0x1
#define _PID1Z1L_PID1Z16_MASK                               0x40
#define _PID1Z1L_PID1Z17_POSN                               0x7
#define _PID1Z1L_PID1Z17_POSITION                           0x7
#define _PID1Z1L_PID1Z17_SIZE                               0x1
#define _PID1Z1L_PID1Z17_LENGTH                             0x1
#define _PID1Z1L_PID1Z17_MASK                               0x80
#define _PID1Z1L_Z10_POSN                                   0x0
#define _PID1Z1L_Z10_POSITION                               0x0
#define _PID1Z1L_Z10_SIZE                                   0x1
#define _PID1Z1L_Z10_LENGTH                                 0x1
#define _PID1Z1L_Z10_MASK                                   0x1
#define _PID1Z1L_Z11_POSN                                   0x1
#define _PID1Z1L_Z11_POSITION                               0x1
#define _PID1Z1L_Z11_SIZE                                   0x1
#define _PID1Z1L_Z11_LENGTH                                 0x1
#define _PID1Z1L_Z11_MASK                                   0x2
#define _PID1Z1L_Z12_POSN                                   0x2
#define _PID1Z1L_Z12_POSITION                               0x2
#define _PID1Z1L_Z12_SIZE                                   0x1
#define _PID1Z1L_Z12_LENGTH                                 0x1
#define _PID1Z1L_Z12_MASK                                   0x4
#define _PID1Z1L_Z13_POSN                                   0x3
#define _PID1Z1L_Z13_POSITION                               0x3
#define _PID1Z1L_Z13_SIZE                                   0x1
#define _PID1Z1L_Z13_LENGTH                                 0x1
#define _PID1Z1L_Z13_MASK                                   0x8
#define _PID1Z1L_Z14_POSN                                   0x4
#define _PID1Z1L_Z14_POSITION                               0x4
#define _PID1Z1L_Z14_SIZE                                   0x1
#define _PID1Z1L_Z14_LENGTH                                 0x1
#define _PID1Z1L_Z14_MASK                                   0x10
#define _PID1Z1L_Z15_POSN                                   0x5
#define _PID1Z1L_Z15_POSITION                               0x5
#define _PID1Z1L_Z15_SIZE                                   0x1
#define _PID1Z1L_Z15_LENGTH                                 0x1
#define _PID1Z1L_Z15_MASK                                   0x20
#define _PID1Z1L_Z16_POSN                                   0x6
#define _PID1Z1L_Z16_POSITION                               0x6
#define _PID1Z1L_Z16_SIZE                                   0x1
#define _PID1Z1L_Z16_LENGTH                                 0x1
#define _PID1Z1L_Z16_MASK                                   0x40
#define _PID1Z1L_Z17_POSN                                   0x7
#define _PID1Z1L_Z17_POSITION                               0x7
#define _PID1Z1L_Z17_SIZE                                   0x1
#define _PID1Z1L_Z17_LENGTH                                 0x1
#define _PID1Z1L_Z17_MASK                                   0x80

// Register: PID1Z1H
extern volatile unsigned char           PID1Z1H             @ 0x59C;
#ifndef _LIB_BUILD
asm("PID1Z1H equ 059Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1Z18                :1;
        unsigned PID1Z19                :1;
        unsigned PID1Z110               :1;
        unsigned PID1Z111               :1;
        unsigned PID1Z112               :1;
        unsigned PID1Z113               :1;
        unsigned PID1Z114               :1;
        unsigned PID1Z115               :1;
    };
    struct {
        unsigned Z18                    :1;
        unsigned Z19                    :1;
        unsigned Z110                   :1;
        unsigned Z111                   :1;
        unsigned Z112                   :1;
        unsigned Z113                   :1;
        unsigned Z114                   :1;
        unsigned Z115                   :1;
    };
} PID1Z1Hbits_t;
extern volatile PID1Z1Hbits_t PID1Z1Hbits @ 0x59C;
// bitfield macros
#define _PID1Z1H_PID1Z18_POSN                               0x0
#define _PID1Z1H_PID1Z18_POSITION                           0x0
#define _PID1Z1H_PID1Z18_SIZE                               0x1
#define _PID1Z1H_PID1Z18_LENGTH                             0x1
#define _PID1Z1H_PID1Z18_MASK                               0x1
#define _PID1Z1H_PID1Z19_POSN                               0x1
#define _PID1Z1H_PID1Z19_POSITION                           0x1
#define _PID1Z1H_PID1Z19_SIZE                               0x1
#define _PID1Z1H_PID1Z19_LENGTH                             0x1
#define _PID1Z1H_PID1Z19_MASK                               0x2
#define _PID1Z1H_PID1Z110_POSN                              0x2
#define _PID1Z1H_PID1Z110_POSITION                          0x2
#define _PID1Z1H_PID1Z110_SIZE                              0x1
#define _PID1Z1H_PID1Z110_LENGTH                            0x1
#define _PID1Z1H_PID1Z110_MASK                              0x4
#define _PID1Z1H_PID1Z111_POSN                              0x3
#define _PID1Z1H_PID1Z111_POSITION                          0x3
#define _PID1Z1H_PID1Z111_SIZE                              0x1
#define _PID1Z1H_PID1Z111_LENGTH                            0x1
#define _PID1Z1H_PID1Z111_MASK                              0x8
#define _PID1Z1H_PID1Z112_POSN                              0x4
#define _PID1Z1H_PID1Z112_POSITION                          0x4
#define _PID1Z1H_PID1Z112_SIZE                              0x1
#define _PID1Z1H_PID1Z112_LENGTH                            0x1
#define _PID1Z1H_PID1Z112_MASK                              0x10
#define _PID1Z1H_PID1Z113_POSN                              0x5
#define _PID1Z1H_PID1Z113_POSITION                          0x5
#define _PID1Z1H_PID1Z113_SIZE                              0x1
#define _PID1Z1H_PID1Z113_LENGTH                            0x1
#define _PID1Z1H_PID1Z113_MASK                              0x20
#define _PID1Z1H_PID1Z114_POSN                              0x6
#define _PID1Z1H_PID1Z114_POSITION                          0x6
#define _PID1Z1H_PID1Z114_SIZE                              0x1
#define _PID1Z1H_PID1Z114_LENGTH                            0x1
#define _PID1Z1H_PID1Z114_MASK                              0x40
#define _PID1Z1H_PID1Z115_POSN                              0x7
#define _PID1Z1H_PID1Z115_POSITION                          0x7
#define _PID1Z1H_PID1Z115_SIZE                              0x1
#define _PID1Z1H_PID1Z115_LENGTH                            0x1
#define _PID1Z1H_PID1Z115_MASK                              0x80
#define _PID1Z1H_Z18_POSN                                   0x0
#define _PID1Z1H_Z18_POSITION                               0x0
#define _PID1Z1H_Z18_SIZE                                   0x1
#define _PID1Z1H_Z18_LENGTH                                 0x1
#define _PID1Z1H_Z18_MASK                                   0x1
#define _PID1Z1H_Z19_POSN                                   0x1
#define _PID1Z1H_Z19_POSITION                               0x1
#define _PID1Z1H_Z19_SIZE                                   0x1
#define _PID1Z1H_Z19_LENGTH                                 0x1
#define _PID1Z1H_Z19_MASK                                   0x2
#define _PID1Z1H_Z110_POSN                                  0x2
#define _PID1Z1H_Z110_POSITION                              0x2
#define _PID1Z1H_Z110_SIZE                                  0x1
#define _PID1Z1H_Z110_LENGTH                                0x1
#define _PID1Z1H_Z110_MASK                                  0x4
#define _PID1Z1H_Z111_POSN                                  0x3
#define _PID1Z1H_Z111_POSITION                              0x3
#define _PID1Z1H_Z111_SIZE                                  0x1
#define _PID1Z1H_Z111_LENGTH                                0x1
#define _PID1Z1H_Z111_MASK                                  0x8
#define _PID1Z1H_Z112_POSN                                  0x4
#define _PID1Z1H_Z112_POSITION                              0x4
#define _PID1Z1H_Z112_SIZE                                  0x1
#define _PID1Z1H_Z112_LENGTH                                0x1
#define _PID1Z1H_Z112_MASK                                  0x10
#define _PID1Z1H_Z113_POSN                                  0x5
#define _PID1Z1H_Z113_POSITION                              0x5
#define _PID1Z1H_Z113_SIZE                                  0x1
#define _PID1Z1H_Z113_LENGTH                                0x1
#define _PID1Z1H_Z113_MASK                                  0x20
#define _PID1Z1H_Z114_POSN                                  0x6
#define _PID1Z1H_Z114_POSITION                              0x6
#define _PID1Z1H_Z114_SIZE                                  0x1
#define _PID1Z1H_Z114_LENGTH                                0x1
#define _PID1Z1H_Z114_MASK                                  0x40
#define _PID1Z1H_Z115_POSN                                  0x7
#define _PID1Z1H_Z115_POSITION                              0x7
#define _PID1Z1H_Z115_SIZE                                  0x1
#define _PID1Z1H_Z115_LENGTH                                0x1
#define _PID1Z1H_Z115_MASK                                  0x80

// Register: PID1Z1U
extern volatile unsigned char           PID1Z1U             @ 0x59D;
#ifndef _LIB_BUILD
asm("PID1Z1U equ 059Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1Z116               :1;
    };
    struct {
        unsigned Z116                   :1;
    };
} PID1Z1Ubits_t;
extern volatile PID1Z1Ubits_t PID1Z1Ubits @ 0x59D;
// bitfield macros
#define _PID1Z1U_PID1Z116_POSN                              0x0
#define _PID1Z1U_PID1Z116_POSITION                          0x0
#define _PID1Z1U_PID1Z116_SIZE                              0x1
#define _PID1Z1U_PID1Z116_LENGTH                            0x1
#define _PID1Z1U_PID1Z116_MASK                              0x1
#define _PID1Z1U_Z116_POSN                                  0x0
#define _PID1Z1U_Z116_POSITION                              0x0
#define _PID1Z1U_Z116_SIZE                                  0x1
#define _PID1Z1U_Z116_LENGTH                                0x1
#define _PID1Z1U_Z116_MASK                                  0x1

// Register: PID1Z2
#ifndef __CCI__
extern volatile unsigned short long     PID1Z2              @ 0x60C;
#endif
#ifndef _LIB_BUILD
asm("PID1Z2 equ 060Ch");
#endif

// Register: PID1Z2L
extern volatile unsigned char           PID1Z2L             @ 0x60C;
#ifndef _LIB_BUILD
asm("PID1Z2L equ 060Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1Z20                :1;
        unsigned PID1Z21                :1;
        unsigned PID1Z22                :1;
        unsigned PID1Z23                :1;
        unsigned PID1Z24                :1;
        unsigned PID1Z25                :1;
        unsigned PID1Z26                :1;
        unsigned PID1Z27                :1;
    };
    struct {
        unsigned Z20                    :1;
        unsigned Z21                    :1;
        unsigned Z22                    :1;
        unsigned Z23                    :1;
        unsigned Z24                    :1;
        unsigned Z25                    :1;
        unsigned Z26                    :1;
        unsigned Z27                    :1;
    };
} PID1Z2Lbits_t;
extern volatile PID1Z2Lbits_t PID1Z2Lbits @ 0x60C;
// bitfield macros
#define _PID1Z2L_PID1Z20_POSN                               0x0
#define _PID1Z2L_PID1Z20_POSITION                           0x0
#define _PID1Z2L_PID1Z20_SIZE                               0x1
#define _PID1Z2L_PID1Z20_LENGTH                             0x1
#define _PID1Z2L_PID1Z20_MASK                               0x1
#define _PID1Z2L_PID1Z21_POSN                               0x1
#define _PID1Z2L_PID1Z21_POSITION                           0x1
#define _PID1Z2L_PID1Z21_SIZE                               0x1
#define _PID1Z2L_PID1Z21_LENGTH                             0x1
#define _PID1Z2L_PID1Z21_MASK                               0x2
#define _PID1Z2L_PID1Z22_POSN                               0x2
#define _PID1Z2L_PID1Z22_POSITION                           0x2
#define _PID1Z2L_PID1Z22_SIZE                               0x1
#define _PID1Z2L_PID1Z22_LENGTH                             0x1
#define _PID1Z2L_PID1Z22_MASK                               0x4
#define _PID1Z2L_PID1Z23_POSN                               0x3
#define _PID1Z2L_PID1Z23_POSITION                           0x3
#define _PID1Z2L_PID1Z23_SIZE                               0x1
#define _PID1Z2L_PID1Z23_LENGTH                             0x1
#define _PID1Z2L_PID1Z23_MASK                               0x8
#define _PID1Z2L_PID1Z24_POSN                               0x4
#define _PID1Z2L_PID1Z24_POSITION                           0x4
#define _PID1Z2L_PID1Z24_SIZE                               0x1
#define _PID1Z2L_PID1Z24_LENGTH                             0x1
#define _PID1Z2L_PID1Z24_MASK                               0x10
#define _PID1Z2L_PID1Z25_POSN                               0x5
#define _PID1Z2L_PID1Z25_POSITION                           0x5
#define _PID1Z2L_PID1Z25_SIZE                               0x1
#define _PID1Z2L_PID1Z25_LENGTH                             0x1
#define _PID1Z2L_PID1Z25_MASK                               0x20
#define _PID1Z2L_PID1Z26_POSN                               0x6
#define _PID1Z2L_PID1Z26_POSITION                           0x6
#define _PID1Z2L_PID1Z26_SIZE                               0x1
#define _PID1Z2L_PID1Z26_LENGTH                             0x1
#define _PID1Z2L_PID1Z26_MASK                               0x40
#define _PID1Z2L_PID1Z27_POSN                               0x7
#define _PID1Z2L_PID1Z27_POSITION                           0x7
#define _PID1Z2L_PID1Z27_SIZE                               0x1
#define _PID1Z2L_PID1Z27_LENGTH                             0x1
#define _PID1Z2L_PID1Z27_MASK                               0x80
#define _PID1Z2L_Z20_POSN                                   0x0
#define _PID1Z2L_Z20_POSITION                               0x0
#define _PID1Z2L_Z20_SIZE                                   0x1
#define _PID1Z2L_Z20_LENGTH                                 0x1
#define _PID1Z2L_Z20_MASK                                   0x1
#define _PID1Z2L_Z21_POSN                                   0x1
#define _PID1Z2L_Z21_POSITION                               0x1
#define _PID1Z2L_Z21_SIZE                                   0x1
#define _PID1Z2L_Z21_LENGTH                                 0x1
#define _PID1Z2L_Z21_MASK                                   0x2
#define _PID1Z2L_Z22_POSN                                   0x2
#define _PID1Z2L_Z22_POSITION                               0x2
#define _PID1Z2L_Z22_SIZE                                   0x1
#define _PID1Z2L_Z22_LENGTH                                 0x1
#define _PID1Z2L_Z22_MASK                                   0x4
#define _PID1Z2L_Z23_POSN                                   0x3
#define _PID1Z2L_Z23_POSITION                               0x3
#define _PID1Z2L_Z23_SIZE                                   0x1
#define _PID1Z2L_Z23_LENGTH                                 0x1
#define _PID1Z2L_Z23_MASK                                   0x8
#define _PID1Z2L_Z24_POSN                                   0x4
#define _PID1Z2L_Z24_POSITION                               0x4
#define _PID1Z2L_Z24_SIZE                                   0x1
#define _PID1Z2L_Z24_LENGTH                                 0x1
#define _PID1Z2L_Z24_MASK                                   0x10
#define _PID1Z2L_Z25_POSN                                   0x5
#define _PID1Z2L_Z25_POSITION                               0x5
#define _PID1Z2L_Z25_SIZE                                   0x1
#define _PID1Z2L_Z25_LENGTH                                 0x1
#define _PID1Z2L_Z25_MASK                                   0x20
#define _PID1Z2L_Z26_POSN                                   0x6
#define _PID1Z2L_Z26_POSITION                               0x6
#define _PID1Z2L_Z26_SIZE                                   0x1
#define _PID1Z2L_Z26_LENGTH                                 0x1
#define _PID1Z2L_Z26_MASK                                   0x40
#define _PID1Z2L_Z27_POSN                                   0x7
#define _PID1Z2L_Z27_POSITION                               0x7
#define _PID1Z2L_Z27_SIZE                                   0x1
#define _PID1Z2L_Z27_LENGTH                                 0x1
#define _PID1Z2L_Z27_MASK                                   0x80

// Register: PID1Z2H
extern volatile unsigned char           PID1Z2H             @ 0x60D;
#ifndef _LIB_BUILD
asm("PID1Z2H equ 060Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1Z28                :1;
        unsigned PID1Z29                :1;
        unsigned PID1Z210               :1;
        unsigned PID1Z211               :1;
        unsigned PID1Z212               :1;
        unsigned PID1Z213               :1;
        unsigned PID1Z214               :1;
        unsigned PID1Z215               :1;
    };
    struct {
        unsigned Z28                    :1;
        unsigned Z29                    :1;
        unsigned Z210                   :1;
        unsigned Z211                   :1;
        unsigned Z212                   :1;
        unsigned Z213                   :1;
        unsigned Z214                   :1;
        unsigned Z215                   :1;
    };
} PID1Z2Hbits_t;
extern volatile PID1Z2Hbits_t PID1Z2Hbits @ 0x60D;
// bitfield macros
#define _PID1Z2H_PID1Z28_POSN                               0x0
#define _PID1Z2H_PID1Z28_POSITION                           0x0
#define _PID1Z2H_PID1Z28_SIZE                               0x1
#define _PID1Z2H_PID1Z28_LENGTH                             0x1
#define _PID1Z2H_PID1Z28_MASK                               0x1
#define _PID1Z2H_PID1Z29_POSN                               0x1
#define _PID1Z2H_PID1Z29_POSITION                           0x1
#define _PID1Z2H_PID1Z29_SIZE                               0x1
#define _PID1Z2H_PID1Z29_LENGTH                             0x1
#define _PID1Z2H_PID1Z29_MASK                               0x2
#define _PID1Z2H_PID1Z210_POSN                              0x2
#define _PID1Z2H_PID1Z210_POSITION                          0x2
#define _PID1Z2H_PID1Z210_SIZE                              0x1
#define _PID1Z2H_PID1Z210_LENGTH                            0x1
#define _PID1Z2H_PID1Z210_MASK                              0x4
#define _PID1Z2H_PID1Z211_POSN                              0x3
#define _PID1Z2H_PID1Z211_POSITION                          0x3
#define _PID1Z2H_PID1Z211_SIZE                              0x1
#define _PID1Z2H_PID1Z211_LENGTH                            0x1
#define _PID1Z2H_PID1Z211_MASK                              0x8
#define _PID1Z2H_PID1Z212_POSN                              0x4
#define _PID1Z2H_PID1Z212_POSITION                          0x4
#define _PID1Z2H_PID1Z212_SIZE                              0x1
#define _PID1Z2H_PID1Z212_LENGTH                            0x1
#define _PID1Z2H_PID1Z212_MASK                              0x10
#define _PID1Z2H_PID1Z213_POSN                              0x5
#define _PID1Z2H_PID1Z213_POSITION                          0x5
#define _PID1Z2H_PID1Z213_SIZE                              0x1
#define _PID1Z2H_PID1Z213_LENGTH                            0x1
#define _PID1Z2H_PID1Z213_MASK                              0x20
#define _PID1Z2H_PID1Z214_POSN                              0x6
#define _PID1Z2H_PID1Z214_POSITION                          0x6
#define _PID1Z2H_PID1Z214_SIZE                              0x1
#define _PID1Z2H_PID1Z214_LENGTH                            0x1
#define _PID1Z2H_PID1Z214_MASK                              0x40
#define _PID1Z2H_PID1Z215_POSN                              0x7
#define _PID1Z2H_PID1Z215_POSITION                          0x7
#define _PID1Z2H_PID1Z215_SIZE                              0x1
#define _PID1Z2H_PID1Z215_LENGTH                            0x1
#define _PID1Z2H_PID1Z215_MASK                              0x80
#define _PID1Z2H_Z28_POSN                                   0x0
#define _PID1Z2H_Z28_POSITION                               0x0
#define _PID1Z2H_Z28_SIZE                                   0x1
#define _PID1Z2H_Z28_LENGTH                                 0x1
#define _PID1Z2H_Z28_MASK                                   0x1
#define _PID1Z2H_Z29_POSN                                   0x1
#define _PID1Z2H_Z29_POSITION                               0x1
#define _PID1Z2H_Z29_SIZE                                   0x1
#define _PID1Z2H_Z29_LENGTH                                 0x1
#define _PID1Z2H_Z29_MASK                                   0x2
#define _PID1Z2H_Z210_POSN                                  0x2
#define _PID1Z2H_Z210_POSITION                              0x2
#define _PID1Z2H_Z210_SIZE                                  0x1
#define _PID1Z2H_Z210_LENGTH                                0x1
#define _PID1Z2H_Z210_MASK                                  0x4
#define _PID1Z2H_Z211_POSN                                  0x3
#define _PID1Z2H_Z211_POSITION                              0x3
#define _PID1Z2H_Z211_SIZE                                  0x1
#define _PID1Z2H_Z211_LENGTH                                0x1
#define _PID1Z2H_Z211_MASK                                  0x8
#define _PID1Z2H_Z212_POSN                                  0x4
#define _PID1Z2H_Z212_POSITION                              0x4
#define _PID1Z2H_Z212_SIZE                                  0x1
#define _PID1Z2H_Z212_LENGTH                                0x1
#define _PID1Z2H_Z212_MASK                                  0x10
#define _PID1Z2H_Z213_POSN                                  0x5
#define _PID1Z2H_Z213_POSITION                              0x5
#define _PID1Z2H_Z213_SIZE                                  0x1
#define _PID1Z2H_Z213_LENGTH                                0x1
#define _PID1Z2H_Z213_MASK                                  0x20
#define _PID1Z2H_Z214_POSN                                  0x6
#define _PID1Z2H_Z214_POSITION                              0x6
#define _PID1Z2H_Z214_SIZE                                  0x1
#define _PID1Z2H_Z214_LENGTH                                0x1
#define _PID1Z2H_Z214_MASK                                  0x40
#define _PID1Z2H_Z215_POSN                                  0x7
#define _PID1Z2H_Z215_POSITION                              0x7
#define _PID1Z2H_Z215_SIZE                                  0x1
#define _PID1Z2H_Z215_LENGTH                                0x1
#define _PID1Z2H_Z215_MASK                                  0x80

// Register: PID1Z2U
extern volatile unsigned char           PID1Z2U             @ 0x60E;
#ifndef _LIB_BUILD
asm("PID1Z2U equ 060Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1Z216               :1;
    };
    struct {
        unsigned Z216                   :1;
    };
} PID1Z2Ubits_t;
extern volatile PID1Z2Ubits_t PID1Z2Ubits @ 0x60E;
// bitfield macros
#define _PID1Z2U_PID1Z216_POSN                              0x0
#define _PID1Z2U_PID1Z216_POSITION                          0x0
#define _PID1Z2U_PID1Z216_SIZE                              0x1
#define _PID1Z2U_PID1Z216_LENGTH                            0x1
#define _PID1Z2U_PID1Z216_MASK                              0x1
#define _PID1Z2U_Z216_POSN                                  0x0
#define _PID1Z2U_Z216_POSITION                              0x0
#define _PID1Z2U_Z216_SIZE                                  0x1
#define _PID1Z2U_Z216_LENGTH                                0x1
#define _PID1Z2U_Z216_MASK                                  0x1

// Register: PID1ACC
#ifndef _LIB_BUILD
asm("PID1ACC equ 060Fh");
#endif

// Register: PID1ACCLL
extern volatile unsigned char           PID1ACCLL           @ 0x60F;
#ifndef _LIB_BUILD
asm("PID1ACCLL equ 060Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1ACC0               :1;
        unsigned PID1ACC1               :1;
        unsigned PID1ACC2               :1;
        unsigned PID1ACC3               :1;
        unsigned PID1ACC4               :1;
        unsigned PID1ACC5               :1;
        unsigned PID1ACC6               :1;
        unsigned PID1ACC7               :1;
    };
    struct {
        unsigned ACC0                   :1;
        unsigned ACC1                   :1;
        unsigned ACC2                   :1;
        unsigned ACC3                   :1;
        unsigned ACC4                   :1;
        unsigned ACC5                   :1;
        unsigned ACC6                   :1;
        unsigned ACC7                   :1;
    };
} PID1ACCLLbits_t;
extern volatile PID1ACCLLbits_t PID1ACCLLbits @ 0x60F;
// bitfield macros
#define _PID1ACCLL_PID1ACC0_POSN                            0x0
#define _PID1ACCLL_PID1ACC0_POSITION                        0x0
#define _PID1ACCLL_PID1ACC0_SIZE                            0x1
#define _PID1ACCLL_PID1ACC0_LENGTH                          0x1
#define _PID1ACCLL_PID1ACC0_MASK                            0x1
#define _PID1ACCLL_PID1ACC1_POSN                            0x1
#define _PID1ACCLL_PID1ACC1_POSITION                        0x1
#define _PID1ACCLL_PID1ACC1_SIZE                            0x1
#define _PID1ACCLL_PID1ACC1_LENGTH                          0x1
#define _PID1ACCLL_PID1ACC1_MASK                            0x2
#define _PID1ACCLL_PID1ACC2_POSN                            0x2
#define _PID1ACCLL_PID1ACC2_POSITION                        0x2
#define _PID1ACCLL_PID1ACC2_SIZE                            0x1
#define _PID1ACCLL_PID1ACC2_LENGTH                          0x1
#define _PID1ACCLL_PID1ACC2_MASK                            0x4
#define _PID1ACCLL_PID1ACC3_POSN                            0x3
#define _PID1ACCLL_PID1ACC3_POSITION                        0x3
#define _PID1ACCLL_PID1ACC3_SIZE                            0x1
#define _PID1ACCLL_PID1ACC3_LENGTH                          0x1
#define _PID1ACCLL_PID1ACC3_MASK                            0x8
#define _PID1ACCLL_PID1ACC4_POSN                            0x4
#define _PID1ACCLL_PID1ACC4_POSITION                        0x4
#define _PID1ACCLL_PID1ACC4_SIZE                            0x1
#define _PID1ACCLL_PID1ACC4_LENGTH                          0x1
#define _PID1ACCLL_PID1ACC4_MASK                            0x10
#define _PID1ACCLL_PID1ACC5_POSN                            0x5
#define _PID1ACCLL_PID1ACC5_POSITION                        0x5
#define _PID1ACCLL_PID1ACC5_SIZE                            0x1
#define _PID1ACCLL_PID1ACC5_LENGTH                          0x1
#define _PID1ACCLL_PID1ACC5_MASK                            0x20
#define _PID1ACCLL_PID1ACC6_POSN                            0x6
#define _PID1ACCLL_PID1ACC6_POSITION                        0x6
#define _PID1ACCLL_PID1ACC6_SIZE                            0x1
#define _PID1ACCLL_PID1ACC6_LENGTH                          0x1
#define _PID1ACCLL_PID1ACC6_MASK                            0x40
#define _PID1ACCLL_PID1ACC7_POSN                            0x7
#define _PID1ACCLL_PID1ACC7_POSITION                        0x7
#define _PID1ACCLL_PID1ACC7_SIZE                            0x1
#define _PID1ACCLL_PID1ACC7_LENGTH                          0x1
#define _PID1ACCLL_PID1ACC7_MASK                            0x80
#define _PID1ACCLL_ACC0_POSN                                0x0
#define _PID1ACCLL_ACC0_POSITION                            0x0
#define _PID1ACCLL_ACC0_SIZE                                0x1
#define _PID1ACCLL_ACC0_LENGTH                              0x1
#define _PID1ACCLL_ACC0_MASK                                0x1
#define _PID1ACCLL_ACC1_POSN                                0x1
#define _PID1ACCLL_ACC1_POSITION                            0x1
#define _PID1ACCLL_ACC1_SIZE                                0x1
#define _PID1ACCLL_ACC1_LENGTH                              0x1
#define _PID1ACCLL_ACC1_MASK                                0x2
#define _PID1ACCLL_ACC2_POSN                                0x2
#define _PID1ACCLL_ACC2_POSITION                            0x2
#define _PID1ACCLL_ACC2_SIZE                                0x1
#define _PID1ACCLL_ACC2_LENGTH                              0x1
#define _PID1ACCLL_ACC2_MASK                                0x4
#define _PID1ACCLL_ACC3_POSN                                0x3
#define _PID1ACCLL_ACC3_POSITION                            0x3
#define _PID1ACCLL_ACC3_SIZE                                0x1
#define _PID1ACCLL_ACC3_LENGTH                              0x1
#define _PID1ACCLL_ACC3_MASK                                0x8
#define _PID1ACCLL_ACC4_POSN                                0x4
#define _PID1ACCLL_ACC4_POSITION                            0x4
#define _PID1ACCLL_ACC4_SIZE                                0x1
#define _PID1ACCLL_ACC4_LENGTH                              0x1
#define _PID1ACCLL_ACC4_MASK                                0x10
#define _PID1ACCLL_ACC5_POSN                                0x5
#define _PID1ACCLL_ACC5_POSITION                            0x5
#define _PID1ACCLL_ACC5_SIZE                                0x1
#define _PID1ACCLL_ACC5_LENGTH                              0x1
#define _PID1ACCLL_ACC5_MASK                                0x20
#define _PID1ACCLL_ACC6_POSN                                0x6
#define _PID1ACCLL_ACC6_POSITION                            0x6
#define _PID1ACCLL_ACC6_SIZE                                0x1
#define _PID1ACCLL_ACC6_LENGTH                              0x1
#define _PID1ACCLL_ACC6_MASK                                0x40
#define _PID1ACCLL_ACC7_POSN                                0x7
#define _PID1ACCLL_ACC7_POSITION                            0x7
#define _PID1ACCLL_ACC7_SIZE                                0x1
#define _PID1ACCLL_ACC7_LENGTH                              0x1
#define _PID1ACCLL_ACC7_MASK                                0x80

// Register: PID1ACCLH
extern volatile unsigned char           PID1ACCLH           @ 0x610;
#ifndef _LIB_BUILD
asm("PID1ACCLH equ 0610h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1ACC8               :1;
        unsigned PID1ACC9               :1;
        unsigned PID1ACC10              :1;
        unsigned PID1ACC11              :1;
        unsigned PID1ACC12              :1;
        unsigned PID1ACC13              :1;
        unsigned PID1ACC14              :1;
        unsigned PID1ACC15              :1;
    };
    struct {
        unsigned ACC8                   :1;
        unsigned ACC9                   :1;
        unsigned ACC10                  :1;
        unsigned ACC11                  :1;
        unsigned ACC12                  :1;
        unsigned ACC13                  :1;
        unsigned ACC14                  :1;
        unsigned ACC15                  :1;
    };
} PID1ACCLHbits_t;
extern volatile PID1ACCLHbits_t PID1ACCLHbits @ 0x610;
// bitfield macros
#define _PID1ACCLH_PID1ACC8_POSN                            0x0
#define _PID1ACCLH_PID1ACC8_POSITION                        0x0
#define _PID1ACCLH_PID1ACC8_SIZE                            0x1
#define _PID1ACCLH_PID1ACC8_LENGTH                          0x1
#define _PID1ACCLH_PID1ACC8_MASK                            0x1
#define _PID1ACCLH_PID1ACC9_POSN                            0x1
#define _PID1ACCLH_PID1ACC9_POSITION                        0x1
#define _PID1ACCLH_PID1ACC9_SIZE                            0x1
#define _PID1ACCLH_PID1ACC9_LENGTH                          0x1
#define _PID1ACCLH_PID1ACC9_MASK                            0x2
#define _PID1ACCLH_PID1ACC10_POSN                           0x2
#define _PID1ACCLH_PID1ACC10_POSITION                       0x2
#define _PID1ACCLH_PID1ACC10_SIZE                           0x1
#define _PID1ACCLH_PID1ACC10_LENGTH                         0x1
#define _PID1ACCLH_PID1ACC10_MASK                           0x4
#define _PID1ACCLH_PID1ACC11_POSN                           0x3
#define _PID1ACCLH_PID1ACC11_POSITION                       0x3
#define _PID1ACCLH_PID1ACC11_SIZE                           0x1
#define _PID1ACCLH_PID1ACC11_LENGTH                         0x1
#define _PID1ACCLH_PID1ACC11_MASK                           0x8
#define _PID1ACCLH_PID1ACC12_POSN                           0x4
#define _PID1ACCLH_PID1ACC12_POSITION                       0x4
#define _PID1ACCLH_PID1ACC12_SIZE                           0x1
#define _PID1ACCLH_PID1ACC12_LENGTH                         0x1
#define _PID1ACCLH_PID1ACC12_MASK                           0x10
#define _PID1ACCLH_PID1ACC13_POSN                           0x5
#define _PID1ACCLH_PID1ACC13_POSITION                       0x5
#define _PID1ACCLH_PID1ACC13_SIZE                           0x1
#define _PID1ACCLH_PID1ACC13_LENGTH                         0x1
#define _PID1ACCLH_PID1ACC13_MASK                           0x20
#define _PID1ACCLH_PID1ACC14_POSN                           0x6
#define _PID1ACCLH_PID1ACC14_POSITION                       0x6
#define _PID1ACCLH_PID1ACC14_SIZE                           0x1
#define _PID1ACCLH_PID1ACC14_LENGTH                         0x1
#define _PID1ACCLH_PID1ACC14_MASK                           0x40
#define _PID1ACCLH_PID1ACC15_POSN                           0x7
#define _PID1ACCLH_PID1ACC15_POSITION                       0x7
#define _PID1ACCLH_PID1ACC15_SIZE                           0x1
#define _PID1ACCLH_PID1ACC15_LENGTH                         0x1
#define _PID1ACCLH_PID1ACC15_MASK                           0x80
#define _PID1ACCLH_ACC8_POSN                                0x0
#define _PID1ACCLH_ACC8_POSITION                            0x0
#define _PID1ACCLH_ACC8_SIZE                                0x1
#define _PID1ACCLH_ACC8_LENGTH                              0x1
#define _PID1ACCLH_ACC8_MASK                                0x1
#define _PID1ACCLH_ACC9_POSN                                0x1
#define _PID1ACCLH_ACC9_POSITION                            0x1
#define _PID1ACCLH_ACC9_SIZE                                0x1
#define _PID1ACCLH_ACC9_LENGTH                              0x1
#define _PID1ACCLH_ACC9_MASK                                0x2
#define _PID1ACCLH_ACC10_POSN                               0x2
#define _PID1ACCLH_ACC10_POSITION                           0x2
#define _PID1ACCLH_ACC10_SIZE                               0x1
#define _PID1ACCLH_ACC10_LENGTH                             0x1
#define _PID1ACCLH_ACC10_MASK                               0x4
#define _PID1ACCLH_ACC11_POSN                               0x3
#define _PID1ACCLH_ACC11_POSITION                           0x3
#define _PID1ACCLH_ACC11_SIZE                               0x1
#define _PID1ACCLH_ACC11_LENGTH                             0x1
#define _PID1ACCLH_ACC11_MASK                               0x8
#define _PID1ACCLH_ACC12_POSN                               0x4
#define _PID1ACCLH_ACC12_POSITION                           0x4
#define _PID1ACCLH_ACC12_SIZE                               0x1
#define _PID1ACCLH_ACC12_LENGTH                             0x1
#define _PID1ACCLH_ACC12_MASK                               0x10
#define _PID1ACCLH_ACC13_POSN                               0x5
#define _PID1ACCLH_ACC13_POSITION                           0x5
#define _PID1ACCLH_ACC13_SIZE                               0x1
#define _PID1ACCLH_ACC13_LENGTH                             0x1
#define _PID1ACCLH_ACC13_MASK                               0x20
#define _PID1ACCLH_ACC14_POSN                               0x6
#define _PID1ACCLH_ACC14_POSITION                           0x6
#define _PID1ACCLH_ACC14_SIZE                               0x1
#define _PID1ACCLH_ACC14_LENGTH                             0x1
#define _PID1ACCLH_ACC14_MASK                               0x40
#define _PID1ACCLH_ACC15_POSN                               0x7
#define _PID1ACCLH_ACC15_POSITION                           0x7
#define _PID1ACCLH_ACC15_SIZE                               0x1
#define _PID1ACCLH_ACC15_LENGTH                             0x1
#define _PID1ACCLH_ACC15_MASK                               0x80

// Register: PID1ACCHL
extern volatile unsigned char           PID1ACCHL           @ 0x611;
#ifndef _LIB_BUILD
asm("PID1ACCHL equ 0611h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1ACC16              :1;
        unsigned PID1ACC17              :1;
        unsigned PID1ACC18              :1;
        unsigned PID1ACC19              :1;
        unsigned PID1ACC20              :1;
        unsigned PID1ACC21              :1;
        unsigned PID1ACC22              :1;
        unsigned PID1ACC23              :1;
    };
    struct {
        unsigned ACC16                  :1;
        unsigned ACC17                  :1;
        unsigned ACC18                  :1;
        unsigned ACC19                  :1;
        unsigned ACC20                  :1;
        unsigned ACC21                  :1;
        unsigned ACC22                  :1;
        unsigned ACC23                  :1;
    };
} PID1ACCHLbits_t;
extern volatile PID1ACCHLbits_t PID1ACCHLbits @ 0x611;
// bitfield macros
#define _PID1ACCHL_PID1ACC16_POSN                           0x0
#define _PID1ACCHL_PID1ACC16_POSITION                       0x0
#define _PID1ACCHL_PID1ACC16_SIZE                           0x1
#define _PID1ACCHL_PID1ACC16_LENGTH                         0x1
#define _PID1ACCHL_PID1ACC16_MASK                           0x1
#define _PID1ACCHL_PID1ACC17_POSN                           0x1
#define _PID1ACCHL_PID1ACC17_POSITION                       0x1
#define _PID1ACCHL_PID1ACC17_SIZE                           0x1
#define _PID1ACCHL_PID1ACC17_LENGTH                         0x1
#define _PID1ACCHL_PID1ACC17_MASK                           0x2
#define _PID1ACCHL_PID1ACC18_POSN                           0x2
#define _PID1ACCHL_PID1ACC18_POSITION                       0x2
#define _PID1ACCHL_PID1ACC18_SIZE                           0x1
#define _PID1ACCHL_PID1ACC18_LENGTH                         0x1
#define _PID1ACCHL_PID1ACC18_MASK                           0x4
#define _PID1ACCHL_PID1ACC19_POSN                           0x3
#define _PID1ACCHL_PID1ACC19_POSITION                       0x3
#define _PID1ACCHL_PID1ACC19_SIZE                           0x1
#define _PID1ACCHL_PID1ACC19_LENGTH                         0x1
#define _PID1ACCHL_PID1ACC19_MASK                           0x8
#define _PID1ACCHL_PID1ACC20_POSN                           0x4
#define _PID1ACCHL_PID1ACC20_POSITION                       0x4
#define _PID1ACCHL_PID1ACC20_SIZE                           0x1
#define _PID1ACCHL_PID1ACC20_LENGTH                         0x1
#define _PID1ACCHL_PID1ACC20_MASK                           0x10
#define _PID1ACCHL_PID1ACC21_POSN                           0x5
#define _PID1ACCHL_PID1ACC21_POSITION                       0x5
#define _PID1ACCHL_PID1ACC21_SIZE                           0x1
#define _PID1ACCHL_PID1ACC21_LENGTH                         0x1
#define _PID1ACCHL_PID1ACC21_MASK                           0x20
#define _PID1ACCHL_PID1ACC22_POSN                           0x6
#define _PID1ACCHL_PID1ACC22_POSITION                       0x6
#define _PID1ACCHL_PID1ACC22_SIZE                           0x1
#define _PID1ACCHL_PID1ACC22_LENGTH                         0x1
#define _PID1ACCHL_PID1ACC22_MASK                           0x40
#define _PID1ACCHL_PID1ACC23_POSN                           0x7
#define _PID1ACCHL_PID1ACC23_POSITION                       0x7
#define _PID1ACCHL_PID1ACC23_SIZE                           0x1
#define _PID1ACCHL_PID1ACC23_LENGTH                         0x1
#define _PID1ACCHL_PID1ACC23_MASK                           0x80
#define _PID1ACCHL_ACC16_POSN                               0x0
#define _PID1ACCHL_ACC16_POSITION                           0x0
#define _PID1ACCHL_ACC16_SIZE                               0x1
#define _PID1ACCHL_ACC16_LENGTH                             0x1
#define _PID1ACCHL_ACC16_MASK                               0x1
#define _PID1ACCHL_ACC17_POSN                               0x1
#define _PID1ACCHL_ACC17_POSITION                           0x1
#define _PID1ACCHL_ACC17_SIZE                               0x1
#define _PID1ACCHL_ACC17_LENGTH                             0x1
#define _PID1ACCHL_ACC17_MASK                               0x2
#define _PID1ACCHL_ACC18_POSN                               0x2
#define _PID1ACCHL_ACC18_POSITION                           0x2
#define _PID1ACCHL_ACC18_SIZE                               0x1
#define _PID1ACCHL_ACC18_LENGTH                             0x1
#define _PID1ACCHL_ACC18_MASK                               0x4
#define _PID1ACCHL_ACC19_POSN                               0x3
#define _PID1ACCHL_ACC19_POSITION                           0x3
#define _PID1ACCHL_ACC19_SIZE                               0x1
#define _PID1ACCHL_ACC19_LENGTH                             0x1
#define _PID1ACCHL_ACC19_MASK                               0x8
#define _PID1ACCHL_ACC20_POSN                               0x4
#define _PID1ACCHL_ACC20_POSITION                           0x4
#define _PID1ACCHL_ACC20_SIZE                               0x1
#define _PID1ACCHL_ACC20_LENGTH                             0x1
#define _PID1ACCHL_ACC20_MASK                               0x10
#define _PID1ACCHL_ACC21_POSN                               0x5
#define _PID1ACCHL_ACC21_POSITION                           0x5
#define _PID1ACCHL_ACC21_SIZE                               0x1
#define _PID1ACCHL_ACC21_LENGTH                             0x1
#define _PID1ACCHL_ACC21_MASK                               0x20
#define _PID1ACCHL_ACC22_POSN                               0x6
#define _PID1ACCHL_ACC22_POSITION                           0x6
#define _PID1ACCHL_ACC22_SIZE                               0x1
#define _PID1ACCHL_ACC22_LENGTH                             0x1
#define _PID1ACCHL_ACC22_MASK                               0x40
#define _PID1ACCHL_ACC23_POSN                               0x7
#define _PID1ACCHL_ACC23_POSITION                           0x7
#define _PID1ACCHL_ACC23_SIZE                               0x1
#define _PID1ACCHL_ACC23_LENGTH                             0x1
#define _PID1ACCHL_ACC23_MASK                               0x80

// Register: PID1ACCHH
extern volatile unsigned char           PID1ACCHH           @ 0x612;
#ifndef _LIB_BUILD
asm("PID1ACCHH equ 0612h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1ACC24              :1;
        unsigned PID1ACC25              :1;
        unsigned PID1ACC26              :1;
        unsigned PID1ACC27              :1;
        unsigned PID1ACC28              :1;
        unsigned PID1ACC29              :1;
        unsigned PID1ACC30              :1;
        unsigned PID1ACC31              :1;
    };
    struct {
        unsigned ACC24                  :1;
        unsigned ACC25                  :1;
        unsigned ACC26                  :1;
        unsigned ACC27                  :1;
        unsigned ACC28                  :1;
        unsigned ACC29                  :1;
        unsigned ACC30                  :1;
        unsigned ACC31                  :1;
    };
} PID1ACCHHbits_t;
extern volatile PID1ACCHHbits_t PID1ACCHHbits @ 0x612;
// bitfield macros
#define _PID1ACCHH_PID1ACC24_POSN                           0x0
#define _PID1ACCHH_PID1ACC24_POSITION                       0x0
#define _PID1ACCHH_PID1ACC24_SIZE                           0x1
#define _PID1ACCHH_PID1ACC24_LENGTH                         0x1
#define _PID1ACCHH_PID1ACC24_MASK                           0x1
#define _PID1ACCHH_PID1ACC25_POSN                           0x1
#define _PID1ACCHH_PID1ACC25_POSITION                       0x1
#define _PID1ACCHH_PID1ACC25_SIZE                           0x1
#define _PID1ACCHH_PID1ACC25_LENGTH                         0x1
#define _PID1ACCHH_PID1ACC25_MASK                           0x2
#define _PID1ACCHH_PID1ACC26_POSN                           0x2
#define _PID1ACCHH_PID1ACC26_POSITION                       0x2
#define _PID1ACCHH_PID1ACC26_SIZE                           0x1
#define _PID1ACCHH_PID1ACC26_LENGTH                         0x1
#define _PID1ACCHH_PID1ACC26_MASK                           0x4
#define _PID1ACCHH_PID1ACC27_POSN                           0x3
#define _PID1ACCHH_PID1ACC27_POSITION                       0x3
#define _PID1ACCHH_PID1ACC27_SIZE                           0x1
#define _PID1ACCHH_PID1ACC27_LENGTH                         0x1
#define _PID1ACCHH_PID1ACC27_MASK                           0x8
#define _PID1ACCHH_PID1ACC28_POSN                           0x4
#define _PID1ACCHH_PID1ACC28_POSITION                       0x4
#define _PID1ACCHH_PID1ACC28_SIZE                           0x1
#define _PID1ACCHH_PID1ACC28_LENGTH                         0x1
#define _PID1ACCHH_PID1ACC28_MASK                           0x10
#define _PID1ACCHH_PID1ACC29_POSN                           0x5
#define _PID1ACCHH_PID1ACC29_POSITION                       0x5
#define _PID1ACCHH_PID1ACC29_SIZE                           0x1
#define _PID1ACCHH_PID1ACC29_LENGTH                         0x1
#define _PID1ACCHH_PID1ACC29_MASK                           0x20
#define _PID1ACCHH_PID1ACC30_POSN                           0x6
#define _PID1ACCHH_PID1ACC30_POSITION                       0x6
#define _PID1ACCHH_PID1ACC30_SIZE                           0x1
#define _PID1ACCHH_PID1ACC30_LENGTH                         0x1
#define _PID1ACCHH_PID1ACC30_MASK                           0x40
#define _PID1ACCHH_PID1ACC31_POSN                           0x7
#define _PID1ACCHH_PID1ACC31_POSITION                       0x7
#define _PID1ACCHH_PID1ACC31_SIZE                           0x1
#define _PID1ACCHH_PID1ACC31_LENGTH                         0x1
#define _PID1ACCHH_PID1ACC31_MASK                           0x80
#define _PID1ACCHH_ACC24_POSN                               0x0
#define _PID1ACCHH_ACC24_POSITION                           0x0
#define _PID1ACCHH_ACC24_SIZE                               0x1
#define _PID1ACCHH_ACC24_LENGTH                             0x1
#define _PID1ACCHH_ACC24_MASK                               0x1
#define _PID1ACCHH_ACC25_POSN                               0x1
#define _PID1ACCHH_ACC25_POSITION                           0x1
#define _PID1ACCHH_ACC25_SIZE                               0x1
#define _PID1ACCHH_ACC25_LENGTH                             0x1
#define _PID1ACCHH_ACC25_MASK                               0x2
#define _PID1ACCHH_ACC26_POSN                               0x2
#define _PID1ACCHH_ACC26_POSITION                           0x2
#define _PID1ACCHH_ACC26_SIZE                               0x1
#define _PID1ACCHH_ACC26_LENGTH                             0x1
#define _PID1ACCHH_ACC26_MASK                               0x4
#define _PID1ACCHH_ACC27_POSN                               0x3
#define _PID1ACCHH_ACC27_POSITION                           0x3
#define _PID1ACCHH_ACC27_SIZE                               0x1
#define _PID1ACCHH_ACC27_LENGTH                             0x1
#define _PID1ACCHH_ACC27_MASK                               0x8
#define _PID1ACCHH_ACC28_POSN                               0x4
#define _PID1ACCHH_ACC28_POSITION                           0x4
#define _PID1ACCHH_ACC28_SIZE                               0x1
#define _PID1ACCHH_ACC28_LENGTH                             0x1
#define _PID1ACCHH_ACC28_MASK                               0x10
#define _PID1ACCHH_ACC29_POSN                               0x5
#define _PID1ACCHH_ACC29_POSITION                           0x5
#define _PID1ACCHH_ACC29_SIZE                               0x1
#define _PID1ACCHH_ACC29_LENGTH                             0x1
#define _PID1ACCHH_ACC29_MASK                               0x20
#define _PID1ACCHH_ACC30_POSN                               0x6
#define _PID1ACCHH_ACC30_POSITION                           0x6
#define _PID1ACCHH_ACC30_SIZE                               0x1
#define _PID1ACCHH_ACC30_LENGTH                             0x1
#define _PID1ACCHH_ACC30_MASK                               0x40
#define _PID1ACCHH_ACC31_POSN                               0x7
#define _PID1ACCHH_ACC31_POSITION                           0x7
#define _PID1ACCHH_ACC31_SIZE                               0x1
#define _PID1ACCHH_ACC31_LENGTH                             0x1
#define _PID1ACCHH_ACC31_MASK                               0x80

// Register: PID1ACCU
extern volatile unsigned char           PID1ACCU            @ 0x613;
#ifndef _LIB_BUILD
asm("PID1ACCU equ 0613h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1ACC32              :1;
        unsigned PID1ACC33              :1;
        unsigned PID1ACC34              :1;
    };
    struct {
        unsigned ACC32                  :1;
        unsigned ACC33                  :1;
        unsigned ACC34                  :1;
    };
} PID1ACCUbits_t;
extern volatile PID1ACCUbits_t PID1ACCUbits @ 0x613;
// bitfield macros
#define _PID1ACCU_PID1ACC32_POSN                            0x0
#define _PID1ACCU_PID1ACC32_POSITION                        0x0
#define _PID1ACCU_PID1ACC32_SIZE                            0x1
#define _PID1ACCU_PID1ACC32_LENGTH                          0x1
#define _PID1ACCU_PID1ACC32_MASK                            0x1
#define _PID1ACCU_PID1ACC33_POSN                            0x1
#define _PID1ACCU_PID1ACC33_POSITION                        0x1
#define _PID1ACCU_PID1ACC33_SIZE                            0x1
#define _PID1ACCU_PID1ACC33_LENGTH                          0x1
#define _PID1ACCU_PID1ACC33_MASK                            0x2
#define _PID1ACCU_PID1ACC34_POSN                            0x2
#define _PID1ACCU_PID1ACC34_POSITION                        0x2
#define _PID1ACCU_PID1ACC34_SIZE                            0x1
#define _PID1ACCU_PID1ACC34_LENGTH                          0x1
#define _PID1ACCU_PID1ACC34_MASK                            0x4
#define _PID1ACCU_ACC32_POSN                                0x0
#define _PID1ACCU_ACC32_POSITION                            0x0
#define _PID1ACCU_ACC32_SIZE                                0x1
#define _PID1ACCU_ACC32_LENGTH                              0x1
#define _PID1ACCU_ACC32_MASK                                0x1
#define _PID1ACCU_ACC33_POSN                                0x1
#define _PID1ACCU_ACC33_POSITION                            0x1
#define _PID1ACCU_ACC33_SIZE                                0x1
#define _PID1ACCU_ACC33_LENGTH                              0x1
#define _PID1ACCU_ACC33_MASK                                0x2
#define _PID1ACCU_ACC34_POSN                                0x2
#define _PID1ACCU_ACC34_POSITION                            0x2
#define _PID1ACCU_ACC34_SIZE                                0x1
#define _PID1ACCU_ACC34_LENGTH                              0x1
#define _PID1ACCU_ACC34_MASK                                0x4

// Register: PID1CON
extern volatile unsigned char           PID1CON             @ 0x614;
#ifndef _LIB_BUILD
asm("PID1CON equ 0614h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PID1MODE               :3;
        unsigned                        :3;
        unsigned PID1BUSY               :1;
        unsigned PID1EN                 :1;
    };
    struct {
        unsigned MODE                   :3;
        unsigned                        :3;
        unsigned BUSY                   :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
    };
    struct {
        unsigned PID1MODE0              :1;
        unsigned PID1MODE1              :1;
        unsigned PID1MODE2              :1;
    };
} PID1CONbits_t;
extern volatile PID1CONbits_t PID1CONbits @ 0x614;
// bitfield macros
#define _PID1CON_PID1MODE_POSN                              0x0
#define _PID1CON_PID1MODE_POSITION                          0x0
#define _PID1CON_PID1MODE_SIZE                              0x3
#define _PID1CON_PID1MODE_LENGTH                            0x3
#define _PID1CON_PID1MODE_MASK                              0x7
#define _PID1CON_PID1BUSY_POSN                              0x6
#define _PID1CON_PID1BUSY_POSITION                          0x6
#define _PID1CON_PID1BUSY_SIZE                              0x1
#define _PID1CON_PID1BUSY_LENGTH                            0x1
#define _PID1CON_PID1BUSY_MASK                              0x40
#define _PID1CON_PID1EN_POSN                                0x7
#define _PID1CON_PID1EN_POSITION                            0x7
#define _PID1CON_PID1EN_SIZE                                0x1
#define _PID1CON_PID1EN_LENGTH                              0x1
#define _PID1CON_PID1EN_MASK                                0x80
#define _PID1CON_MODE_POSN                                  0x0
#define _PID1CON_MODE_POSITION                              0x0
#define _PID1CON_MODE_SIZE                                  0x3
#define _PID1CON_MODE_LENGTH                                0x3
#define _PID1CON_MODE_MASK                                  0x7
#define _PID1CON_BUSY_POSN                                  0x6
#define _PID1CON_BUSY_POSITION                              0x6
#define _PID1CON_BUSY_SIZE                                  0x1
#define _PID1CON_BUSY_LENGTH                                0x1
#define _PID1CON_BUSY_MASK                                  0x40
#define _PID1CON_EN_POSN                                    0x7
#define _PID1CON_EN_POSITION                                0x7
#define _PID1CON_EN_SIZE                                    0x1
#define _PID1CON_EN_LENGTH                                  0x1
#define _PID1CON_EN_MASK                                    0x80
#define _PID1CON_MODE0_POSN                                 0x0
#define _PID1CON_MODE0_POSITION                             0x0
#define _PID1CON_MODE0_SIZE                                 0x1
#define _PID1CON_MODE0_LENGTH                               0x1
#define _PID1CON_MODE0_MASK                                 0x1
#define _PID1CON_MODE1_POSN                                 0x1
#define _PID1CON_MODE1_POSITION                             0x1
#define _PID1CON_MODE1_SIZE                                 0x1
#define _PID1CON_MODE1_LENGTH                               0x1
#define _PID1CON_MODE1_MASK                                 0x2
#define _PID1CON_MODE2_POSN                                 0x2
#define _PID1CON_MODE2_POSITION                             0x2
#define _PID1CON_MODE2_SIZE                                 0x1
#define _PID1CON_MODE2_LENGTH                               0x1
#define _PID1CON_MODE2_MASK                                 0x4
#define _PID1CON_PID1MODE0_POSN                             0x0
#define _PID1CON_PID1MODE0_POSITION                         0x0
#define _PID1CON_PID1MODE0_SIZE                             0x1
#define _PID1CON_PID1MODE0_LENGTH                           0x1
#define _PID1CON_PID1MODE0_MASK                             0x1
#define _PID1CON_PID1MODE1_POSN                             0x1
#define _PID1CON_PID1MODE1_POSITION                         0x1
#define _PID1CON_PID1MODE1_SIZE                             0x1
#define _PID1CON_PID1MODE1_LENGTH                           0x1
#define _PID1CON_PID1MODE1_MASK                             0x2
#define _PID1CON_PID1MODE2_POSN                             0x2
#define _PID1CON_PID1MODE2_POSITION                         0x2
#define _PID1CON_PID1MODE2_SIZE                             0x1
#define _PID1CON_PID1MODE2_LENGTH                           0x1
#define _PID1CON_PID1MODE2_MASK                             0x4

// Register: PWM3DCL
extern volatile unsigned char           PWM3DCL             @ 0x617;
#ifndef _LIB_BUILD
asm("PWM3DCL equ 0617h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :6;
        unsigned DC                     :2;
    };
    struct {
        unsigned                        :6;
        unsigned DC0                    :1;
        unsigned DC1                    :1;
    };
    struct {
        unsigned                        :6;
        unsigned PWM3DC0                :1;
        unsigned PWM3DC1                :1;
    };
    struct {
        unsigned                        :6;
        unsigned PWMPW0                 :1;
        unsigned PWMPW1                 :1;
    };
} PWM3DCLbits_t;
extern volatile PWM3DCLbits_t PWM3DCLbits @ 0x617;
// bitfield macros
#define _PWM3DCL_DC_POSN                                    0x6
#define _PWM3DCL_DC_POSITION                                0x6
#define _PWM3DCL_DC_SIZE                                    0x2
#define _PWM3DCL_DC_LENGTH                                  0x2
#define _PWM3DCL_DC_MASK                                    0xC0
#define _PWM3DCL_DC0_POSN                                   0x6
#define _PWM3DCL_DC0_POSITION                               0x6
#define _PWM3DCL_DC0_SIZE                                   0x1
#define _PWM3DCL_DC0_LENGTH                                 0x1
#define _PWM3DCL_DC0_MASK                                   0x40
#define _PWM3DCL_DC1_POSN                                   0x7
#define _PWM3DCL_DC1_POSITION                               0x7
#define _PWM3DCL_DC1_SIZE                                   0x1
#define _PWM3DCL_DC1_LENGTH                                 0x1
#define _PWM3DCL_DC1_MASK                                   0x80
#define _PWM3DCL_PWM3DC0_POSN                               0x6
#define _PWM3DCL_PWM3DC0_POSITION                           0x6
#define _PWM3DCL_PWM3DC0_SIZE                               0x1
#define _PWM3DCL_PWM3DC0_LENGTH                             0x1
#define _PWM3DCL_PWM3DC0_MASK                               0x40
#define _PWM3DCL_PWM3DC1_POSN                               0x7
#define _PWM3DCL_PWM3DC1_POSITION                           0x7
#define _PWM3DCL_PWM3DC1_SIZE                               0x1
#define _PWM3DCL_PWM3DC1_LENGTH                             0x1
#define _PWM3DCL_PWM3DC1_MASK                               0x80
#define _PWM3DCL_PWMPW0_POSN                                0x6
#define _PWM3DCL_PWMPW0_POSITION                            0x6
#define _PWM3DCL_PWMPW0_SIZE                                0x1
#define _PWM3DCL_PWMPW0_LENGTH                              0x1
#define _PWM3DCL_PWMPW0_MASK                                0x40
#define _PWM3DCL_PWMPW1_POSN                                0x7
#define _PWM3DCL_PWMPW1_POSITION                            0x7
#define _PWM3DCL_PWMPW1_SIZE                                0x1
#define _PWM3DCL_PWMPW1_LENGTH                              0x1
#define _PWM3DCL_PWMPW1_MASK                                0x80

// Register: PWM3DCH
extern volatile unsigned char           PWM3DCH             @ 0x618;
#ifndef _LIB_BUILD
asm("PWM3DCH equ 0618h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned DC                     :8;
    };
    struct {
        unsigned DC2                    :1;
        unsigned DC3                    :1;
        unsigned DC4                    :1;
        unsigned DC5                    :1;
        unsigned DC6                    :1;
        unsigned DC7                    :1;
        unsigned DC8                    :1;
        unsigned DC9                    :1;
    };
    struct {
        unsigned PWM3DC2                :1;
        unsigned PWM3DC3                :1;
        unsigned PWM3DC4                :1;
        unsigned PWM3DC5                :1;
        unsigned PWM3DC6                :1;
        unsigned PWM3DC7                :1;
        unsigned PWM3DC8                :1;
        unsigned PWM3DC9                :1;
    };
    struct {
        unsigned PWMPW2                 :1;
        unsigned PWMPW3                 :1;
        unsigned PWMPW4                 :1;
        unsigned PWMPW5                 :1;
        unsigned PWMPW6                 :1;
        unsigned PWMPW7                 :1;
        unsigned PWMPW8                 :1;
        unsigned PWMPW9                 :1;
    };
} PWM3DCHbits_t;
extern volatile PWM3DCHbits_t PWM3DCHbits @ 0x618;
// bitfield macros
#define _PWM3DCH_DC_POSN                                    0x0
#define _PWM3DCH_DC_POSITION                                0x0
#define _PWM3DCH_DC_SIZE                                    0x8
#define _PWM3DCH_DC_LENGTH                                  0x8
#define _PWM3DCH_DC_MASK                                    0xFF
#define _PWM3DCH_DC2_POSN                                   0x0
#define _PWM3DCH_DC2_POSITION                               0x0
#define _PWM3DCH_DC2_SIZE                                   0x1
#define _PWM3DCH_DC2_LENGTH                                 0x1
#define _PWM3DCH_DC2_MASK                                   0x1
#define _PWM3DCH_DC3_POSN                                   0x1
#define _PWM3DCH_DC3_POSITION                               0x1
#define _PWM3DCH_DC3_SIZE                                   0x1
#define _PWM3DCH_DC3_LENGTH                                 0x1
#define _PWM3DCH_DC3_MASK                                   0x2
#define _PWM3DCH_DC4_POSN                                   0x2
#define _PWM3DCH_DC4_POSITION                               0x2
#define _PWM3DCH_DC4_SIZE                                   0x1
#define _PWM3DCH_DC4_LENGTH                                 0x1
#define _PWM3DCH_DC4_MASK                                   0x4
#define _PWM3DCH_DC5_POSN                                   0x3
#define _PWM3DCH_DC5_POSITION                               0x3
#define _PWM3DCH_DC5_SIZE                                   0x1
#define _PWM3DCH_DC5_LENGTH                                 0x1
#define _PWM3DCH_DC5_MASK                                   0x8
#define _PWM3DCH_DC6_POSN                                   0x4
#define _PWM3DCH_DC6_POSITION                               0x4
#define _PWM3DCH_DC6_SIZE                                   0x1
#define _PWM3DCH_DC6_LENGTH                                 0x1
#define _PWM3DCH_DC6_MASK                                   0x10
#define _PWM3DCH_DC7_POSN                                   0x5
#define _PWM3DCH_DC7_POSITION                               0x5
#define _PWM3DCH_DC7_SIZE                                   0x1
#define _PWM3DCH_DC7_LENGTH                                 0x1
#define _PWM3DCH_DC7_MASK                                   0x20
#define _PWM3DCH_DC8_POSN                                   0x6
#define _PWM3DCH_DC8_POSITION                               0x6
#define _PWM3DCH_DC8_SIZE                                   0x1
#define _PWM3DCH_DC8_LENGTH                                 0x1
#define _PWM3DCH_DC8_MASK                                   0x40
#define _PWM3DCH_DC9_POSN                                   0x7
#define _PWM3DCH_DC9_POSITION                               0x7
#define _PWM3DCH_DC9_SIZE                                   0x1
#define _PWM3DCH_DC9_LENGTH                                 0x1
#define _PWM3DCH_DC9_MASK                                   0x80
#define _PWM3DCH_PWM3DC2_POSN                               0x0
#define _PWM3DCH_PWM3DC2_POSITION                           0x0
#define _PWM3DCH_PWM3DC2_SIZE                               0x1
#define _PWM3DCH_PWM3DC2_LENGTH                             0x1
#define _PWM3DCH_PWM3DC2_MASK                               0x1
#define _PWM3DCH_PWM3DC3_POSN                               0x1
#define _PWM3DCH_PWM3DC3_POSITION                           0x1
#define _PWM3DCH_PWM3DC3_SIZE                               0x1
#define _PWM3DCH_PWM3DC3_LENGTH                             0x1
#define _PWM3DCH_PWM3DC3_MASK                               0x2
#define _PWM3DCH_PWM3DC4_POSN                               0x2
#define _PWM3DCH_PWM3DC4_POSITION                           0x2
#define _PWM3DCH_PWM3DC4_SIZE                               0x1
#define _PWM3DCH_PWM3DC4_LENGTH                             0x1
#define _PWM3DCH_PWM3DC4_MASK                               0x4
#define _PWM3DCH_PWM3DC5_POSN                               0x3
#define _PWM3DCH_PWM3DC5_POSITION                           0x3
#define _PWM3DCH_PWM3DC5_SIZE                               0x1
#define _PWM3DCH_PWM3DC5_LENGTH                             0x1
#define _PWM3DCH_PWM3DC5_MASK                               0x8
#define _PWM3DCH_PWM3DC6_POSN                               0x4
#define _PWM3DCH_PWM3DC6_POSITION                           0x4
#define _PWM3DCH_PWM3DC6_SIZE                               0x1
#define _PWM3DCH_PWM3DC6_LENGTH                             0x1
#define _PWM3DCH_PWM3DC6_MASK                               0x10
#define _PWM3DCH_PWM3DC7_POSN                               0x5
#define _PWM3DCH_PWM3DC7_POSITION                           0x5
#define _PWM3DCH_PWM3DC7_SIZE                               0x1
#define _PWM3DCH_PWM3DC7_LENGTH                             0x1
#define _PWM3DCH_PWM3DC7_MASK                               0x20
#define _PWM3DCH_PWM3DC8_POSN                               0x6
#define _PWM3DCH_PWM3DC8_POSITION                           0x6
#define _PWM3DCH_PWM3DC8_SIZE                               0x1
#define _PWM3DCH_PWM3DC8_LENGTH                             0x1
#define _PWM3DCH_PWM3DC8_MASK                               0x40
#define _PWM3DCH_PWM3DC9_POSN                               0x7
#define _PWM3DCH_PWM3DC9_POSITION                           0x7
#define _PWM3DCH_PWM3DC9_SIZE                               0x1
#define _PWM3DCH_PWM3DC9_LENGTH                             0x1
#define _PWM3DCH_PWM3DC9_MASK                               0x80
#define _PWM3DCH_PWMPW2_POSN                                0x0
#define _PWM3DCH_PWMPW2_POSITION                            0x0
#define _PWM3DCH_PWMPW2_SIZE                                0x1
#define _PWM3DCH_PWMPW2_LENGTH                              0x1
#define _PWM3DCH_PWMPW2_MASK                                0x1
#define _PWM3DCH_PWMPW3_POSN                                0x1
#define _PWM3DCH_PWMPW3_POSITION                            0x1
#define _PWM3DCH_PWMPW3_SIZE                                0x1
#define _PWM3DCH_PWMPW3_LENGTH                              0x1
#define _PWM3DCH_PWMPW3_MASK                                0x2
#define _PWM3DCH_PWMPW4_POSN                                0x2
#define _PWM3DCH_PWMPW4_POSITION                            0x2
#define _PWM3DCH_PWMPW4_SIZE                                0x1
#define _PWM3DCH_PWMPW4_LENGTH                              0x1
#define _PWM3DCH_PWMPW4_MASK                                0x4
#define _PWM3DCH_PWMPW5_POSN                                0x3
#define _PWM3DCH_PWMPW5_POSITION                            0x3
#define _PWM3DCH_PWMPW5_SIZE                                0x1
#define _PWM3DCH_PWMPW5_LENGTH                              0x1
#define _PWM3DCH_PWMPW5_MASK                                0x8
#define _PWM3DCH_PWMPW6_POSN                                0x4
#define _PWM3DCH_PWMPW6_POSITION                            0x4
#define _PWM3DCH_PWMPW6_SIZE                                0x1
#define _PWM3DCH_PWMPW6_LENGTH                              0x1
#define _PWM3DCH_PWMPW6_MASK                                0x10
#define _PWM3DCH_PWMPW7_POSN                                0x5
#define _PWM3DCH_PWMPW7_POSITION                            0x5
#define _PWM3DCH_PWMPW7_SIZE                                0x1
#define _PWM3DCH_PWMPW7_LENGTH                              0x1
#define _PWM3DCH_PWMPW7_MASK                                0x20
#define _PWM3DCH_PWMPW8_POSN                                0x6
#define _PWM3DCH_PWMPW8_POSITION                            0x6
#define _PWM3DCH_PWMPW8_SIZE                                0x1
#define _PWM3DCH_PWMPW8_LENGTH                              0x1
#define _PWM3DCH_PWMPW8_MASK                                0x40
#define _PWM3DCH_PWMPW9_POSN                                0x7
#define _PWM3DCH_PWMPW9_POSITION                            0x7
#define _PWM3DCH_PWMPW9_SIZE                                0x1
#define _PWM3DCH_PWMPW9_LENGTH                              0x1
#define _PWM3DCH_PWMPW9_MASK                                0x80

// Register: PWM3CON
extern volatile unsigned char           PWM3CON             @ 0x619;
#ifndef _LIB_BUILD
asm("PWM3CON equ 0619h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned POL                    :1;
        unsigned OUT                    :1;
        unsigned                        :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned                        :4;
        unsigned PWM3POL                :1;
        unsigned PWM3OUT                :1;
        unsigned                        :1;
        unsigned PWM3EN                 :1;
    };
} PWM3CONbits_t;
extern volatile PWM3CONbits_t PWM3CONbits @ 0x619;
// bitfield macros
#define _PWM3CON_POL_POSN                                   0x4
#define _PWM3CON_POL_POSITION                               0x4
#define _PWM3CON_POL_SIZE                                   0x1
#define _PWM3CON_POL_LENGTH                                 0x1
#define _PWM3CON_POL_MASK                                   0x10
#define _PWM3CON_OUT_POSN                                   0x5
#define _PWM3CON_OUT_POSITION                               0x5
#define _PWM3CON_OUT_SIZE                                   0x1
#define _PWM3CON_OUT_LENGTH                                 0x1
#define _PWM3CON_OUT_MASK                                   0x20
#define _PWM3CON_EN_POSN                                    0x7
#define _PWM3CON_EN_POSITION                                0x7
#define _PWM3CON_EN_SIZE                                    0x1
#define _PWM3CON_EN_LENGTH                                  0x1
#define _PWM3CON_EN_MASK                                    0x80
#define _PWM3CON_PWM3POL_POSN                               0x4
#define _PWM3CON_PWM3POL_POSITION                           0x4
#define _PWM3CON_PWM3POL_SIZE                               0x1
#define _PWM3CON_PWM3POL_LENGTH                             0x1
#define _PWM3CON_PWM3POL_MASK                               0x10
#define _PWM3CON_PWM3OUT_POSN                               0x5
#define _PWM3CON_PWM3OUT_POSITION                           0x5
#define _PWM3CON_PWM3OUT_SIZE                               0x1
#define _PWM3CON_PWM3OUT_LENGTH                             0x1
#define _PWM3CON_PWM3OUT_MASK                               0x20
#define _PWM3CON_PWM3EN_POSN                                0x7
#define _PWM3CON_PWM3EN_POSITION                            0x7
#define _PWM3CON_PWM3EN_SIZE                                0x1
#define _PWM3CON_PWM3EN_LENGTH                              0x1
#define _PWM3CON_PWM3EN_MASK                                0x80

// Register: PWM4DCL
extern volatile unsigned char           PWM4DCL             @ 0x61A;
#ifndef _LIB_BUILD
asm("PWM4DCL equ 061Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :6;
        unsigned DC                     :2;
    };
    struct {
        unsigned                        :6;
        unsigned DC0                    :1;
        unsigned DC1                    :1;
    };
    struct {
        unsigned                        :6;
        unsigned PWM4DC0                :1;
        unsigned PWM4DC1                :1;
    };
    struct {
        unsigned                        :6;
        unsigned PWMPW0                 :1;
        unsigned PWMPW1                 :1;
    };
} PWM4DCLbits_t;
extern volatile PWM4DCLbits_t PWM4DCLbits @ 0x61A;
// bitfield macros
#define _PWM4DCL_DC_POSN                                    0x6
#define _PWM4DCL_DC_POSITION                                0x6
#define _PWM4DCL_DC_SIZE                                    0x2
#define _PWM4DCL_DC_LENGTH                                  0x2
#define _PWM4DCL_DC_MASK                                    0xC0
#define _PWM4DCL_DC0_POSN                                   0x6
#define _PWM4DCL_DC0_POSITION                               0x6
#define _PWM4DCL_DC0_SIZE                                   0x1
#define _PWM4DCL_DC0_LENGTH                                 0x1
#define _PWM4DCL_DC0_MASK                                   0x40
#define _PWM4DCL_DC1_POSN                                   0x7
#define _PWM4DCL_DC1_POSITION                               0x7
#define _PWM4DCL_DC1_SIZE                                   0x1
#define _PWM4DCL_DC1_LENGTH                                 0x1
#define _PWM4DCL_DC1_MASK                                   0x80
#define _PWM4DCL_PWM4DC0_POSN                               0x6
#define _PWM4DCL_PWM4DC0_POSITION                           0x6
#define _PWM4DCL_PWM4DC0_SIZE                               0x1
#define _PWM4DCL_PWM4DC0_LENGTH                             0x1
#define _PWM4DCL_PWM4DC0_MASK                               0x40
#define _PWM4DCL_PWM4DC1_POSN                               0x7
#define _PWM4DCL_PWM4DC1_POSITION                           0x7
#define _PWM4DCL_PWM4DC1_SIZE                               0x1
#define _PWM4DCL_PWM4DC1_LENGTH                             0x1
#define _PWM4DCL_PWM4DC1_MASK                               0x80
#define _PWM4DCL_PWMPW0_POSN                                0x6
#define _PWM4DCL_PWMPW0_POSITION                            0x6
#define _PWM4DCL_PWMPW0_SIZE                                0x1
#define _PWM4DCL_PWMPW0_LENGTH                              0x1
#define _PWM4DCL_PWMPW0_MASK                                0x40
#define _PWM4DCL_PWMPW1_POSN                                0x7
#define _PWM4DCL_PWMPW1_POSITION                            0x7
#define _PWM4DCL_PWMPW1_SIZE                                0x1
#define _PWM4DCL_PWMPW1_LENGTH                              0x1
#define _PWM4DCL_PWMPW1_MASK                                0x80

// Register: PWM4DCH
extern volatile unsigned char           PWM4DCH             @ 0x61B;
#ifndef _LIB_BUILD
asm("PWM4DCH equ 061Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned DC                     :8;
    };
    struct {
        unsigned DC2                    :1;
        unsigned DC3                    :1;
        unsigned DC4                    :1;
        unsigned DC5                    :1;
        unsigned DC6                    :1;
        unsigned DC7                    :1;
        unsigned DC8                    :1;
        unsigned DC9                    :1;
    };
    struct {
        unsigned PWM4DC2                :1;
        unsigned PWM4DC3                :1;
        unsigned PWM4DC4                :1;
        unsigned PWM4DC5                :1;
        unsigned PWM4DC6                :1;
        unsigned PWM4DC7                :1;
        unsigned PWM4DC8                :1;
        unsigned PWM4DC9                :1;
    };
    struct {
        unsigned PWMPW2                 :1;
        unsigned PWMPW3                 :1;
        unsigned PWMPW4                 :1;
        unsigned PWMPW5                 :1;
        unsigned PWMPW6                 :1;
        unsigned PWMPW7                 :1;
        unsigned PWMPW8                 :1;
        unsigned PWMPW9                 :1;
    };
} PWM4DCHbits_t;
extern volatile PWM4DCHbits_t PWM4DCHbits @ 0x61B;
// bitfield macros
#define _PWM4DCH_DC_POSN                                    0x0
#define _PWM4DCH_DC_POSITION                                0x0
#define _PWM4DCH_DC_SIZE                                    0x8
#define _PWM4DCH_DC_LENGTH                                  0x8
#define _PWM4DCH_DC_MASK                                    0xFF
#define _PWM4DCH_DC2_POSN                                   0x0
#define _PWM4DCH_DC2_POSITION                               0x0
#define _PWM4DCH_DC2_SIZE                                   0x1
#define _PWM4DCH_DC2_LENGTH                                 0x1
#define _PWM4DCH_DC2_MASK                                   0x1
#define _PWM4DCH_DC3_POSN                                   0x1
#define _PWM4DCH_DC3_POSITION                               0x1
#define _PWM4DCH_DC3_SIZE                                   0x1
#define _PWM4DCH_DC3_LENGTH                                 0x1
#define _PWM4DCH_DC3_MASK                                   0x2
#define _PWM4DCH_DC4_POSN                                   0x2
#define _PWM4DCH_DC4_POSITION                               0x2
#define _PWM4DCH_DC4_SIZE                                   0x1
#define _PWM4DCH_DC4_LENGTH                                 0x1
#define _PWM4DCH_DC4_MASK                                   0x4
#define _PWM4DCH_DC5_POSN                                   0x3
#define _PWM4DCH_DC5_POSITION                               0x3
#define _PWM4DCH_DC5_SIZE                                   0x1
#define _PWM4DCH_DC5_LENGTH                                 0x1
#define _PWM4DCH_DC5_MASK                                   0x8
#define _PWM4DCH_DC6_POSN                                   0x4
#define _PWM4DCH_DC6_POSITION                               0x4
#define _PWM4DCH_DC6_SIZE                                   0x1
#define _PWM4DCH_DC6_LENGTH                                 0x1
#define _PWM4DCH_DC6_MASK                                   0x10
#define _PWM4DCH_DC7_POSN                                   0x5
#define _PWM4DCH_DC7_POSITION                               0x5
#define _PWM4DCH_DC7_SIZE                                   0x1
#define _PWM4DCH_DC7_LENGTH                                 0x1
#define _PWM4DCH_DC7_MASK                                   0x20
#define _PWM4DCH_DC8_POSN                                   0x6
#define _PWM4DCH_DC8_POSITION                               0x6
#define _PWM4DCH_DC8_SIZE                                   0x1
#define _PWM4DCH_DC8_LENGTH                                 0x1
#define _PWM4DCH_DC8_MASK                                   0x40
#define _PWM4DCH_DC9_POSN                                   0x7
#define _PWM4DCH_DC9_POSITION                               0x7
#define _PWM4DCH_DC9_SIZE                                   0x1
#define _PWM4DCH_DC9_LENGTH                                 0x1
#define _PWM4DCH_DC9_MASK                                   0x80
#define _PWM4DCH_PWM4DC2_POSN                               0x0
#define _PWM4DCH_PWM4DC2_POSITION                           0x0
#define _PWM4DCH_PWM4DC2_SIZE                               0x1
#define _PWM4DCH_PWM4DC2_LENGTH                             0x1
#define _PWM4DCH_PWM4DC2_MASK                               0x1
#define _PWM4DCH_PWM4DC3_POSN                               0x1
#define _PWM4DCH_PWM4DC3_POSITION                           0x1
#define _PWM4DCH_PWM4DC3_SIZE                               0x1
#define _PWM4DCH_PWM4DC3_LENGTH                             0x1
#define _PWM4DCH_PWM4DC3_MASK                               0x2
#define _PWM4DCH_PWM4DC4_POSN                               0x2
#define _PWM4DCH_PWM4DC4_POSITION                           0x2
#define _PWM4DCH_PWM4DC4_SIZE                               0x1
#define _PWM4DCH_PWM4DC4_LENGTH                             0x1
#define _PWM4DCH_PWM4DC4_MASK                               0x4
#define _PWM4DCH_PWM4DC5_POSN                               0x3
#define _PWM4DCH_PWM4DC5_POSITION                           0x3
#define _PWM4DCH_PWM4DC5_SIZE                               0x1
#define _PWM4DCH_PWM4DC5_LENGTH                             0x1
#define _PWM4DCH_PWM4DC5_MASK                               0x8
#define _PWM4DCH_PWM4DC6_POSN                               0x4
#define _PWM4DCH_PWM4DC6_POSITION                           0x4
#define _PWM4DCH_PWM4DC6_SIZE                               0x1
#define _PWM4DCH_PWM4DC6_LENGTH                             0x1
#define _PWM4DCH_PWM4DC6_MASK                               0x10
#define _PWM4DCH_PWM4DC7_POSN                               0x5
#define _PWM4DCH_PWM4DC7_POSITION                           0x5
#define _PWM4DCH_PWM4DC7_SIZE                               0x1
#define _PWM4DCH_PWM4DC7_LENGTH                             0x1
#define _PWM4DCH_PWM4DC7_MASK                               0x20
#define _PWM4DCH_PWM4DC8_POSN                               0x6
#define _PWM4DCH_PWM4DC8_POSITION                           0x6
#define _PWM4DCH_PWM4DC8_SIZE                               0x1
#define _PWM4DCH_PWM4DC8_LENGTH                             0x1
#define _PWM4DCH_PWM4DC8_MASK                               0x40
#define _PWM4DCH_PWM4DC9_POSN                               0x7
#define _PWM4DCH_PWM4DC9_POSITION                           0x7
#define _PWM4DCH_PWM4DC9_SIZE                               0x1
#define _PWM4DCH_PWM4DC9_LENGTH                             0x1
#define _PWM4DCH_PWM4DC9_MASK                               0x80
#define _PWM4DCH_PWMPW2_POSN                                0x0
#define _PWM4DCH_PWMPW2_POSITION                            0x0
#define _PWM4DCH_PWMPW2_SIZE                                0x1
#define _PWM4DCH_PWMPW2_LENGTH                              0x1
#define _PWM4DCH_PWMPW2_MASK                                0x1
#define _PWM4DCH_PWMPW3_POSN                                0x1
#define _PWM4DCH_PWMPW3_POSITION                            0x1
#define _PWM4DCH_PWMPW3_SIZE                                0x1
#define _PWM4DCH_PWMPW3_LENGTH                              0x1
#define _PWM4DCH_PWMPW3_MASK                                0x2
#define _PWM4DCH_PWMPW4_POSN                                0x2
#define _PWM4DCH_PWMPW4_POSITION                            0x2
#define _PWM4DCH_PWMPW4_SIZE                                0x1
#define _PWM4DCH_PWMPW4_LENGTH                              0x1
#define _PWM4DCH_PWMPW4_MASK                                0x4
#define _PWM4DCH_PWMPW5_POSN                                0x3
#define _PWM4DCH_PWMPW5_POSITION                            0x3
#define _PWM4DCH_PWMPW5_SIZE                                0x1
#define _PWM4DCH_PWMPW5_LENGTH                              0x1
#define _PWM4DCH_PWMPW5_MASK                                0x8
#define _PWM4DCH_PWMPW6_POSN                                0x4
#define _PWM4DCH_PWMPW6_POSITION                            0x4
#define _PWM4DCH_PWMPW6_SIZE                                0x1
#define _PWM4DCH_PWMPW6_LENGTH                              0x1
#define _PWM4DCH_PWMPW6_MASK                                0x10
#define _PWM4DCH_PWMPW7_POSN                                0x5
#define _PWM4DCH_PWMPW7_POSITION                            0x5
#define _PWM4DCH_PWMPW7_SIZE                                0x1
#define _PWM4DCH_PWMPW7_LENGTH                              0x1
#define _PWM4DCH_PWMPW7_MASK                                0x20
#define _PWM4DCH_PWMPW8_POSN                                0x6
#define _PWM4DCH_PWMPW8_POSITION                            0x6
#define _PWM4DCH_PWMPW8_SIZE                                0x1
#define _PWM4DCH_PWMPW8_LENGTH                              0x1
#define _PWM4DCH_PWMPW8_MASK                                0x40
#define _PWM4DCH_PWMPW9_POSN                                0x7
#define _PWM4DCH_PWMPW9_POSITION                            0x7
#define _PWM4DCH_PWMPW9_SIZE                                0x1
#define _PWM4DCH_PWMPW9_LENGTH                              0x1
#define _PWM4DCH_PWMPW9_MASK                                0x80

// Register: PWM4CON
extern volatile unsigned char           PWM4CON             @ 0x61C;
#ifndef _LIB_BUILD
asm("PWM4CON equ 061Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :4;
        unsigned POL                    :1;
        unsigned OUT                    :1;
        unsigned                        :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned                        :4;
        unsigned PWM4POL                :1;
        unsigned PWM4OUT                :1;
        unsigned                        :1;
        unsigned PWM4EN                 :1;
    };
} PWM4CONbits_t;
extern volatile PWM4CONbits_t PWM4CONbits @ 0x61C;
// bitfield macros
#define _PWM4CON_POL_POSN                                   0x4
#define _PWM4CON_POL_POSITION                               0x4
#define _PWM4CON_POL_SIZE                                   0x1
#define _PWM4CON_POL_LENGTH                                 0x1
#define _PWM4CON_POL_MASK                                   0x10
#define _PWM4CON_OUT_POSN                                   0x5
#define _PWM4CON_OUT_POSITION                               0x5
#define _PWM4CON_OUT_SIZE                                   0x1
#define _PWM4CON_OUT_LENGTH                                 0x1
#define _PWM4CON_OUT_MASK                                   0x20
#define _PWM4CON_EN_POSN                                    0x7
#define _PWM4CON_EN_POSITION                                0x7
#define _PWM4CON_EN_SIZE                                    0x1
#define _PWM4CON_EN_LENGTH                                  0x1
#define _PWM4CON_EN_MASK                                    0x80
#define _PWM4CON_PWM4POL_POSN                               0x4
#define _PWM4CON_PWM4POL_POSITION                           0x4
#define _PWM4CON_PWM4POL_SIZE                               0x1
#define _PWM4CON_PWM4POL_LENGTH                             0x1
#define _PWM4CON_PWM4POL_MASK                               0x10
#define _PWM4CON_PWM4OUT_POSN                               0x5
#define _PWM4CON_PWM4OUT_POSITION                           0x5
#define _PWM4CON_PWM4OUT_SIZE                               0x1
#define _PWM4CON_PWM4OUT_LENGTH                             0x1
#define _PWM4CON_PWM4OUT_MASK                               0x20
#define _PWM4CON_PWM4EN_POSN                                0x7
#define _PWM4CON_PWM4EN_POSITION                            0x7
#define _PWM4CON_PWM4EN_SIZE                                0x1
#define _PWM4CON_PWM4EN_LENGTH                              0x1
#define _PWM4CON_PWM4EN_MASK                                0x80

// Register: CWG1DBR
extern volatile unsigned char           CWG1DBR             @ 0x691;
#ifndef _LIB_BUILD
asm("CWG1DBR equ 0691h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned DBR                    :6;
    };
    struct {
        unsigned DBR0                   :1;
        unsigned DBR1                   :1;
        unsigned DBR2                   :1;
        unsigned DBR3                   :1;
        unsigned DBR4                   :1;
        unsigned DBR5                   :1;
    };
    struct {
        unsigned CWG1DBR                :6;
    };
    struct {
        unsigned CWG1DBR0               :1;
        unsigned CWG1DBR1               :1;
        unsigned CWG1DBR2               :1;
        unsigned CWG1DBR3               :1;
        unsigned CWG1DBR4               :1;
        unsigned CWG1DBR5               :1;
    };
} CWG1DBRbits_t;
extern volatile CWG1DBRbits_t CWG1DBRbits @ 0x691;
// bitfield macros
#define _CWG1DBR_DBR_POSN                                   0x0
#define _CWG1DBR_DBR_POSITION                               0x0
#define _CWG1DBR_DBR_SIZE                                   0x6
#define _CWG1DBR_DBR_LENGTH                                 0x6
#define _CWG1DBR_DBR_MASK                                   0x3F
#define _CWG1DBR_DBR0_POSN                                  0x0
#define _CWG1DBR_DBR0_POSITION                              0x0
#define _CWG1DBR_DBR0_SIZE                                  0x1
#define _CWG1DBR_DBR0_LENGTH                                0x1
#define _CWG1DBR_DBR0_MASK                                  0x1
#define _CWG1DBR_DBR1_POSN                                  0x1
#define _CWG1DBR_DBR1_POSITION                              0x1
#define _CWG1DBR_DBR1_SIZE                                  0x1
#define _CWG1DBR_DBR1_LENGTH                                0x1
#define _CWG1DBR_DBR1_MASK                                  0x2
#define _CWG1DBR_DBR2_POSN                                  0x2
#define _CWG1DBR_DBR2_POSITION                              0x2
#define _CWG1DBR_DBR2_SIZE                                  0x1
#define _CWG1DBR_DBR2_LENGTH                                0x1
#define _CWG1DBR_DBR2_MASK                                  0x4
#define _CWG1DBR_DBR3_POSN                                  0x3
#define _CWG1DBR_DBR3_POSITION                              0x3
#define _CWG1DBR_DBR3_SIZE                                  0x1
#define _CWG1DBR_DBR3_LENGTH                                0x1
#define _CWG1DBR_DBR3_MASK                                  0x8
#define _CWG1DBR_DBR4_POSN                                  0x4
#define _CWG1DBR_DBR4_POSITION                              0x4
#define _CWG1DBR_DBR4_SIZE                                  0x1
#define _CWG1DBR_DBR4_LENGTH                                0x1
#define _CWG1DBR_DBR4_MASK                                  0x10
#define _CWG1DBR_DBR5_POSN                                  0x5
#define _CWG1DBR_DBR5_POSITION                              0x5
#define _CWG1DBR_DBR5_SIZE                                  0x1
#define _CWG1DBR_DBR5_LENGTH                                0x1
#define _CWG1DBR_DBR5_MASK                                  0x20
#define _CWG1DBR_CWG1DBR_POSN                               0x0
#define _CWG1DBR_CWG1DBR_POSITION                           0x0
#define _CWG1DBR_CWG1DBR_SIZE                               0x6
#define _CWG1DBR_CWG1DBR_LENGTH                             0x6
#define _CWG1DBR_CWG1DBR_MASK                               0x3F
#define _CWG1DBR_CWG1DBR0_POSN                              0x0
#define _CWG1DBR_CWG1DBR0_POSITION                          0x0
#define _CWG1DBR_CWG1DBR0_SIZE                              0x1
#define _CWG1DBR_CWG1DBR0_LENGTH                            0x1
#define _CWG1DBR_CWG1DBR0_MASK                              0x1
#define _CWG1DBR_CWG1DBR1_POSN                              0x1
#define _CWG1DBR_CWG1DBR1_POSITION                          0x1
#define _CWG1DBR_CWG1DBR1_SIZE                              0x1
#define _CWG1DBR_CWG1DBR1_LENGTH                            0x1
#define _CWG1DBR_CWG1DBR1_MASK                              0x2
#define _CWG1DBR_CWG1DBR2_POSN                              0x2
#define _CWG1DBR_CWG1DBR2_POSITION                          0x2
#define _CWG1DBR_CWG1DBR2_SIZE                              0x1
#define _CWG1DBR_CWG1DBR2_LENGTH                            0x1
#define _CWG1DBR_CWG1DBR2_MASK                              0x4
#define _CWG1DBR_CWG1DBR3_POSN                              0x3
#define _CWG1DBR_CWG1DBR3_POSITION                          0x3
#define _CWG1DBR_CWG1DBR3_SIZE                              0x1
#define _CWG1DBR_CWG1DBR3_LENGTH                            0x1
#define _CWG1DBR_CWG1DBR3_MASK                              0x8
#define _CWG1DBR_CWG1DBR4_POSN                              0x4
#define _CWG1DBR_CWG1DBR4_POSITION                          0x4
#define _CWG1DBR_CWG1DBR4_SIZE                              0x1
#define _CWG1DBR_CWG1DBR4_LENGTH                            0x1
#define _CWG1DBR_CWG1DBR4_MASK                              0x10
#define _CWG1DBR_CWG1DBR5_POSN                              0x5
#define _CWG1DBR_CWG1DBR5_POSITION                          0x5
#define _CWG1DBR_CWG1DBR5_SIZE                              0x1
#define _CWG1DBR_CWG1DBR5_LENGTH                            0x1
#define _CWG1DBR_CWG1DBR5_MASK                              0x20

// Register: CWG1DBF
extern volatile unsigned char           CWG1DBF             @ 0x692;
#ifndef _LIB_BUILD
asm("CWG1DBF equ 0692h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned DBF                    :6;
    };
    struct {
        unsigned DBF0                   :1;
        unsigned DBF1                   :1;
        unsigned DBF2                   :1;
        unsigned DBF3                   :1;
        unsigned DBF4                   :1;
        unsigned DBF5                   :1;
    };
    struct {
        unsigned CWG1DBF                :6;
    };
    struct {
        unsigned CWG1DBF0               :1;
        unsigned CWG1DBF1               :1;
        unsigned CWG1DBF2               :1;
        unsigned CWG1DBF3               :1;
        unsigned CWG1DBF4               :1;
        unsigned CWG1DBF5               :1;
    };
} CWG1DBFbits_t;
extern volatile CWG1DBFbits_t CWG1DBFbits @ 0x692;
// bitfield macros
#define _CWG1DBF_DBF_POSN                                   0x0
#define _CWG1DBF_DBF_POSITION                               0x0
#define _CWG1DBF_DBF_SIZE                                   0x6
#define _CWG1DBF_DBF_LENGTH                                 0x6
#define _CWG1DBF_DBF_MASK                                   0x3F
#define _CWG1DBF_DBF0_POSN                                  0x0
#define _CWG1DBF_DBF0_POSITION                              0x0
#define _CWG1DBF_DBF0_SIZE                                  0x1
#define _CWG1DBF_DBF0_LENGTH                                0x1
#define _CWG1DBF_DBF0_MASK                                  0x1
#define _CWG1DBF_DBF1_POSN                                  0x1
#define _CWG1DBF_DBF1_POSITION                              0x1
#define _CWG1DBF_DBF1_SIZE                                  0x1
#define _CWG1DBF_DBF1_LENGTH                                0x1
#define _CWG1DBF_DBF1_MASK                                  0x2
#define _CWG1DBF_DBF2_POSN                                  0x2
#define _CWG1DBF_DBF2_POSITION                              0x2
#define _CWG1DBF_DBF2_SIZE                                  0x1
#define _CWG1DBF_DBF2_LENGTH                                0x1
#define _CWG1DBF_DBF2_MASK                                  0x4
#define _CWG1DBF_DBF3_POSN                                  0x3
#define _CWG1DBF_DBF3_POSITION                              0x3
#define _CWG1DBF_DBF3_SIZE                                  0x1
#define _CWG1DBF_DBF3_LENGTH                                0x1
#define _CWG1DBF_DBF3_MASK                                  0x8
#define _CWG1DBF_DBF4_POSN                                  0x4
#define _CWG1DBF_DBF4_POSITION                              0x4
#define _CWG1DBF_DBF4_SIZE                                  0x1
#define _CWG1DBF_DBF4_LENGTH                                0x1
#define _CWG1DBF_DBF4_MASK                                  0x10
#define _CWG1DBF_DBF5_POSN                                  0x5
#define _CWG1DBF_DBF5_POSITION                              0x5
#define _CWG1DBF_DBF5_SIZE                                  0x1
#define _CWG1DBF_DBF5_LENGTH                                0x1
#define _CWG1DBF_DBF5_MASK                                  0x20
#define _CWG1DBF_CWG1DBF_POSN                               0x0
#define _CWG1DBF_CWG1DBF_POSITION                           0x0
#define _CWG1DBF_CWG1DBF_SIZE                               0x6
#define _CWG1DBF_CWG1DBF_LENGTH                             0x6
#define _CWG1DBF_CWG1DBF_MASK                               0x3F
#define _CWG1DBF_CWG1DBF0_POSN                              0x0
#define _CWG1DBF_CWG1DBF0_POSITION                          0x0
#define _CWG1DBF_CWG1DBF0_SIZE                              0x1
#define _CWG1DBF_CWG1DBF0_LENGTH                            0x1
#define _CWG1DBF_CWG1DBF0_MASK                              0x1
#define _CWG1DBF_CWG1DBF1_POSN                              0x1
#define _CWG1DBF_CWG1DBF1_POSITION                          0x1
#define _CWG1DBF_CWG1DBF1_SIZE                              0x1
#define _CWG1DBF_CWG1DBF1_LENGTH                            0x1
#define _CWG1DBF_CWG1DBF1_MASK                              0x2
#define _CWG1DBF_CWG1DBF2_POSN                              0x2
#define _CWG1DBF_CWG1DBF2_POSITION                          0x2
#define _CWG1DBF_CWG1DBF2_SIZE                              0x1
#define _CWG1DBF_CWG1DBF2_LENGTH                            0x1
#define _CWG1DBF_CWG1DBF2_MASK                              0x4
#define _CWG1DBF_CWG1DBF3_POSN                              0x3
#define _CWG1DBF_CWG1DBF3_POSITION                          0x3
#define _CWG1DBF_CWG1DBF3_SIZE                              0x1
#define _CWG1DBF_CWG1DBF3_LENGTH                            0x1
#define _CWG1DBF_CWG1DBF3_MASK                              0x8
#define _CWG1DBF_CWG1DBF4_POSN                              0x4
#define _CWG1DBF_CWG1DBF4_POSITION                          0x4
#define _CWG1DBF_CWG1DBF4_SIZE                              0x1
#define _CWG1DBF_CWG1DBF4_LENGTH                            0x1
#define _CWG1DBF_CWG1DBF4_MASK                              0x10
#define _CWG1DBF_CWG1DBF5_POSN                              0x5
#define _CWG1DBF_CWG1DBF5_POSITION                          0x5
#define _CWG1DBF_CWG1DBF5_SIZE                              0x1
#define _CWG1DBF_CWG1DBF5_LENGTH                            0x1
#define _CWG1DBF_CWG1DBF5_MASK                              0x20

// Register: CWG1AS0
extern volatile unsigned char           CWG1AS0             @ 0x693;
#ifndef _LIB_BUILD
asm("CWG1AS0 equ 0693h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :2;
        unsigned LSAC                   :2;
        unsigned LSBD                   :2;
        unsigned REN                    :1;
        unsigned SHUTDOWN               :1;
    };
    struct {
        unsigned                        :2;
        unsigned LSAC0                  :1;
        unsigned LSAC1                  :1;
        unsigned LSBD0                  :1;
        unsigned LSBD1                  :1;
    };
    struct {
        unsigned                        :2;
        unsigned CWG1LSAC               :2;
        unsigned CWG1LSBD               :2;
        unsigned CWG1REN                :1;
        unsigned CWG1SHUTDOWN           :1;
    };
    struct {
        unsigned                        :2;
        unsigned CWG1LSAC0              :1;
        unsigned CWG1LSAC1              :1;
        unsigned CWG1LSBD0              :1;
        unsigned CWG1LSBD1              :1;
    };
} CWG1AS0bits_t;
extern volatile CWG1AS0bits_t CWG1AS0bits @ 0x693;
// bitfield macros
#define _CWG1AS0_LSAC_POSN                                  0x2
#define _CWG1AS0_LSAC_POSITION                              0x2
#define _CWG1AS0_LSAC_SIZE                                  0x2
#define _CWG1AS0_LSAC_LENGTH                                0x2
#define _CWG1AS0_LSAC_MASK                                  0xC
#define _CWG1AS0_LSBD_POSN                                  0x4
#define _CWG1AS0_LSBD_POSITION                              0x4
#define _CWG1AS0_LSBD_SIZE                                  0x2
#define _CWG1AS0_LSBD_LENGTH                                0x2
#define _CWG1AS0_LSBD_MASK                                  0x30
#define _CWG1AS0_REN_POSN                                   0x6
#define _CWG1AS0_REN_POSITION                               0x6
#define _CWG1AS0_REN_SIZE                                   0x1
#define _CWG1AS0_REN_LENGTH                                 0x1
#define _CWG1AS0_REN_MASK                                   0x40
#define _CWG1AS0_SHUTDOWN_POSN                              0x7
#define _CWG1AS0_SHUTDOWN_POSITION                          0x7
#define _CWG1AS0_SHUTDOWN_SIZE                              0x1
#define _CWG1AS0_SHUTDOWN_LENGTH                            0x1
#define _CWG1AS0_SHUTDOWN_MASK                              0x80
#define _CWG1AS0_LSAC0_POSN                                 0x2
#define _CWG1AS0_LSAC0_POSITION                             0x2
#define _CWG1AS0_LSAC0_SIZE                                 0x1
#define _CWG1AS0_LSAC0_LENGTH                               0x1
#define _CWG1AS0_LSAC0_MASK                                 0x4
#define _CWG1AS0_LSAC1_POSN                                 0x3
#define _CWG1AS0_LSAC1_POSITION                             0x3
#define _CWG1AS0_LSAC1_SIZE                                 0x1
#define _CWG1AS0_LSAC1_LENGTH                               0x1
#define _CWG1AS0_LSAC1_MASK                                 0x8
#define _CWG1AS0_LSBD0_POSN                                 0x4
#define _CWG1AS0_LSBD0_POSITION                             0x4
#define _CWG1AS0_LSBD0_SIZE                                 0x1
#define _CWG1AS0_LSBD0_LENGTH                               0x1
#define _CWG1AS0_LSBD0_MASK                                 0x10
#define _CWG1AS0_LSBD1_POSN                                 0x5
#define _CWG1AS0_LSBD1_POSITION                             0x5
#define _CWG1AS0_LSBD1_SIZE                                 0x1
#define _CWG1AS0_LSBD1_LENGTH                               0x1
#define _CWG1AS0_LSBD1_MASK                                 0x20
#define _CWG1AS0_CWG1LSAC_POSN                              0x2
#define _CWG1AS0_CWG1LSAC_POSITION                          0x2
#define _CWG1AS0_CWG1LSAC_SIZE                              0x2
#define _CWG1AS0_CWG1LSAC_LENGTH                            0x2
#define _CWG1AS0_CWG1LSAC_MASK                              0xC
#define _CWG1AS0_CWG1LSBD_POSN                              0x4
#define _CWG1AS0_CWG1LSBD_POSITION                          0x4
#define _CWG1AS0_CWG1LSBD_SIZE                              0x2
#define _CWG1AS0_CWG1LSBD_LENGTH                            0x2
#define _CWG1AS0_CWG1LSBD_MASK                              0x30
#define _CWG1AS0_CWG1REN_POSN                               0x6
#define _CWG1AS0_CWG1REN_POSITION                           0x6
#define _CWG1AS0_CWG1REN_SIZE                               0x1
#define _CWG1AS0_CWG1REN_LENGTH                             0x1
#define _CWG1AS0_CWG1REN_MASK                               0x40
#define _CWG1AS0_CWG1SHUTDOWN_POSN                          0x7
#define _CWG1AS0_CWG1SHUTDOWN_POSITION                      0x7
#define _CWG1AS0_CWG1SHUTDOWN_SIZE                          0x1
#define _CWG1AS0_CWG1SHUTDOWN_LENGTH                        0x1
#define _CWG1AS0_CWG1SHUTDOWN_MASK                          0x80
#define _CWG1AS0_CWG1LSAC0_POSN                             0x2
#define _CWG1AS0_CWG1LSAC0_POSITION                         0x2
#define _CWG1AS0_CWG1LSAC0_SIZE                             0x1
#define _CWG1AS0_CWG1LSAC0_LENGTH                           0x1
#define _CWG1AS0_CWG1LSAC0_MASK                             0x4
#define _CWG1AS0_CWG1LSAC1_POSN                             0x3
#define _CWG1AS0_CWG1LSAC1_POSITION                         0x3
#define _CWG1AS0_CWG1LSAC1_SIZE                             0x1
#define _CWG1AS0_CWG1LSAC1_LENGTH                           0x1
#define _CWG1AS0_CWG1LSAC1_MASK                             0x8
#define _CWG1AS0_CWG1LSBD0_POSN                             0x4
#define _CWG1AS0_CWG1LSBD0_POSITION                         0x4
#define _CWG1AS0_CWG1LSBD0_SIZE                             0x1
#define _CWG1AS0_CWG1LSBD0_LENGTH                           0x1
#define _CWG1AS0_CWG1LSBD0_MASK                             0x10
#define _CWG1AS0_CWG1LSBD1_POSN                             0x5
#define _CWG1AS0_CWG1LSBD1_POSITION                         0x5
#define _CWG1AS0_CWG1LSBD1_SIZE                             0x1
#define _CWG1AS0_CWG1LSBD1_LENGTH                           0x1
#define _CWG1AS0_CWG1LSBD1_MASK                             0x20

// Register: CWG1AS1
extern volatile unsigned char           CWG1AS1             @ 0x694;
#ifndef _LIB_BUILD
asm("CWG1AS1 equ 0694h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned INAS                   :1;
        unsigned C1AS                   :1;
        unsigned C2AS                   :1;
        unsigned                        :1;
        unsigned TMR2AS                 :1;
        unsigned TMR4AS                 :1;
        unsigned TMR6AS                 :1;
    };
    struct {
        unsigned CWG1INAS               :1;
        unsigned CWG1C1AS               :1;
        unsigned CWG1C2AS               :1;
        unsigned                        :1;
        unsigned CWG1TMR2AS             :1;
        unsigned CWG1TMR4AS             :1;
        unsigned CWG1TMR6AS             :1;
    };
} CWG1AS1bits_t;
extern volatile CWG1AS1bits_t CWG1AS1bits @ 0x694;
// bitfield macros
#define _CWG1AS1_INAS_POSN                                  0x0
#define _CWG1AS1_INAS_POSITION                              0x0
#define _CWG1AS1_INAS_SIZE                                  0x1
#define _CWG1AS1_INAS_LENGTH                                0x1
#define _CWG1AS1_INAS_MASK                                  0x1
#define _CWG1AS1_C1AS_POSN                                  0x1
#define _CWG1AS1_C1AS_POSITION                              0x1
#define _CWG1AS1_C1AS_SIZE                                  0x1
#define _CWG1AS1_C1AS_LENGTH                                0x1
#define _CWG1AS1_C1AS_MASK                                  0x2
#define _CWG1AS1_C2AS_POSN                                  0x2
#define _CWG1AS1_C2AS_POSITION                              0x2
#define _CWG1AS1_C2AS_SIZE                                  0x1
#define _CWG1AS1_C2AS_LENGTH                                0x1
#define _CWG1AS1_C2AS_MASK                                  0x4
#define _CWG1AS1_TMR2AS_POSN                                0x4
#define _CWG1AS1_TMR2AS_POSITION                            0x4
#define _CWG1AS1_TMR2AS_SIZE                                0x1
#define _CWG1AS1_TMR2AS_LENGTH                              0x1
#define _CWG1AS1_TMR2AS_MASK                                0x10
#define _CWG1AS1_TMR4AS_POSN                                0x5
#define _CWG1AS1_TMR4AS_POSITION                            0x5
#define _CWG1AS1_TMR4AS_SIZE                                0x1
#define _CWG1AS1_TMR4AS_LENGTH                              0x1
#define _CWG1AS1_TMR4AS_MASK                                0x20
#define _CWG1AS1_TMR6AS_POSN                                0x6
#define _CWG1AS1_TMR6AS_POSITION                            0x6
#define _CWG1AS1_TMR6AS_SIZE                                0x1
#define _CWG1AS1_TMR6AS_LENGTH                              0x1
#define _CWG1AS1_TMR6AS_MASK                                0x40
#define _CWG1AS1_CWG1INAS_POSN                              0x0
#define _CWG1AS1_CWG1INAS_POSITION                          0x0
#define _CWG1AS1_CWG1INAS_SIZE                              0x1
#define _CWG1AS1_CWG1INAS_LENGTH                            0x1
#define _CWG1AS1_CWG1INAS_MASK                              0x1
#define _CWG1AS1_CWG1C1AS_POSN                              0x1
#define _CWG1AS1_CWG1C1AS_POSITION                          0x1
#define _CWG1AS1_CWG1C1AS_SIZE                              0x1
#define _CWG1AS1_CWG1C1AS_LENGTH                            0x1
#define _CWG1AS1_CWG1C1AS_MASK                              0x2
#define _CWG1AS1_CWG1C2AS_POSN                              0x2
#define _CWG1AS1_CWG1C2AS_POSITION                          0x2
#define _CWG1AS1_CWG1C2AS_SIZE                              0x1
#define _CWG1AS1_CWG1C2AS_LENGTH                            0x1
#define _CWG1AS1_CWG1C2AS_MASK                              0x4
#define _CWG1AS1_CWG1TMR2AS_POSN                            0x4
#define _CWG1AS1_CWG1TMR2AS_POSITION                        0x4
#define _CWG1AS1_CWG1TMR2AS_SIZE                            0x1
#define _CWG1AS1_CWG1TMR2AS_LENGTH                          0x1
#define _CWG1AS1_CWG1TMR2AS_MASK                            0x10
#define _CWG1AS1_CWG1TMR4AS_POSN                            0x5
#define _CWG1AS1_CWG1TMR4AS_POSITION                        0x5
#define _CWG1AS1_CWG1TMR4AS_SIZE                            0x1
#define _CWG1AS1_CWG1TMR4AS_LENGTH                          0x1
#define _CWG1AS1_CWG1TMR4AS_MASK                            0x20
#define _CWG1AS1_CWG1TMR6AS_POSN                            0x6
#define _CWG1AS1_CWG1TMR6AS_POSITION                        0x6
#define _CWG1AS1_CWG1TMR6AS_SIZE                            0x1
#define _CWG1AS1_CWG1TMR6AS_LENGTH                          0x1
#define _CWG1AS1_CWG1TMR6AS_MASK                            0x40

// Register: CWG1OCON0
extern volatile unsigned char           CWG1OCON0           @ 0x695;
#ifndef _LIB_BUILD
asm("CWG1OCON0 equ 0695h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned STRA                   :1;
        unsigned STRB                   :1;
        unsigned STRC                   :1;
        unsigned STRD                   :1;
        unsigned OVRA                   :1;
        unsigned OVRB                   :1;
        unsigned OVRC                   :1;
        unsigned OVRD                   :1;
    };
    struct {
        unsigned CWG1STRA               :1;
        unsigned CWG1STRB               :1;
        unsigned CWG1STRC               :1;
        unsigned CWG1STRD               :1;
        unsigned CWG1OVRA               :1;
        unsigned CWG1OVRB               :1;
        unsigned CWG1OVRC               :1;
        unsigned CWG1OVRD               :1;
    };
} CWG1OCON0bits_t;
extern volatile CWG1OCON0bits_t CWG1OCON0bits @ 0x695;
// bitfield macros
#define _CWG1OCON0_STRA_POSN                                0x0
#define _CWG1OCON0_STRA_POSITION                            0x0
#define _CWG1OCON0_STRA_SIZE                                0x1
#define _CWG1OCON0_STRA_LENGTH                              0x1
#define _CWG1OCON0_STRA_MASK                                0x1
#define _CWG1OCON0_STRB_POSN                                0x1
#define _CWG1OCON0_STRB_POSITION                            0x1
#define _CWG1OCON0_STRB_SIZE                                0x1
#define _CWG1OCON0_STRB_LENGTH                              0x1
#define _CWG1OCON0_STRB_MASK                                0x2
#define _CWG1OCON0_STRC_POSN                                0x2
#define _CWG1OCON0_STRC_POSITION                            0x2
#define _CWG1OCON0_STRC_SIZE                                0x1
#define _CWG1OCON0_STRC_LENGTH                              0x1
#define _CWG1OCON0_STRC_MASK                                0x4
#define _CWG1OCON0_STRD_POSN                                0x3
#define _CWG1OCON0_STRD_POSITION                            0x3
#define _CWG1OCON0_STRD_SIZE                                0x1
#define _CWG1OCON0_STRD_LENGTH                              0x1
#define _CWG1OCON0_STRD_MASK                                0x8
#define _CWG1OCON0_OVRA_POSN                                0x4
#define _CWG1OCON0_OVRA_POSITION                            0x4
#define _CWG1OCON0_OVRA_SIZE                                0x1
#define _CWG1OCON0_OVRA_LENGTH                              0x1
#define _CWG1OCON0_OVRA_MASK                                0x10
#define _CWG1OCON0_OVRB_POSN                                0x5
#define _CWG1OCON0_OVRB_POSITION                            0x5
#define _CWG1OCON0_OVRB_SIZE                                0x1
#define _CWG1OCON0_OVRB_LENGTH                              0x1
#define _CWG1OCON0_OVRB_MASK                                0x20
#define _CWG1OCON0_OVRC_POSN                                0x6
#define _CWG1OCON0_OVRC_POSITION                            0x6
#define _CWG1OCON0_OVRC_SIZE                                0x1
#define _CWG1OCON0_OVRC_LENGTH                              0x1
#define _CWG1OCON0_OVRC_MASK                                0x40
#define _CWG1OCON0_OVRD_POSN                                0x7
#define _CWG1OCON0_OVRD_POSITION                            0x7
#define _CWG1OCON0_OVRD_SIZE                                0x1
#define _CWG1OCON0_OVRD_LENGTH                              0x1
#define _CWG1OCON0_OVRD_MASK                                0x80
#define _CWG1OCON0_CWG1STRA_POSN                            0x0
#define _CWG1OCON0_CWG1STRA_POSITION                        0x0
#define _CWG1OCON0_CWG1STRA_SIZE                            0x1
#define _CWG1OCON0_CWG1STRA_LENGTH                          0x1
#define _CWG1OCON0_CWG1STRA_MASK                            0x1
#define _CWG1OCON0_CWG1STRB_POSN                            0x1
#define _CWG1OCON0_CWG1STRB_POSITION                        0x1
#define _CWG1OCON0_CWG1STRB_SIZE                            0x1
#define _CWG1OCON0_CWG1STRB_LENGTH                          0x1
#define _CWG1OCON0_CWG1STRB_MASK                            0x2
#define _CWG1OCON0_CWG1STRC_POSN                            0x2
#define _CWG1OCON0_CWG1STRC_POSITION                        0x2
#define _CWG1OCON0_CWG1STRC_SIZE                            0x1
#define _CWG1OCON0_CWG1STRC_LENGTH                          0x1
#define _CWG1OCON0_CWG1STRC_MASK                            0x4
#define _CWG1OCON0_CWG1STRD_POSN                            0x3
#define _CWG1OCON0_CWG1STRD_POSITION                        0x3
#define _CWG1OCON0_CWG1STRD_SIZE                            0x1
#define _CWG1OCON0_CWG1STRD_LENGTH                          0x1
#define _CWG1OCON0_CWG1STRD_MASK                            0x8
#define _CWG1OCON0_CWG1OVRA_POSN                            0x4
#define _CWG1OCON0_CWG1OVRA_POSITION                        0x4
#define _CWG1OCON0_CWG1OVRA_SIZE                            0x1
#define _CWG1OCON0_CWG1OVRA_LENGTH                          0x1
#define _CWG1OCON0_CWG1OVRA_MASK                            0x10
#define _CWG1OCON0_CWG1OVRB_POSN                            0x5
#define _CWG1OCON0_CWG1OVRB_POSITION                        0x5
#define _CWG1OCON0_CWG1OVRB_SIZE                            0x1
#define _CWG1OCON0_CWG1OVRB_LENGTH                          0x1
#define _CWG1OCON0_CWG1OVRB_MASK                            0x20
#define _CWG1OCON0_CWG1OVRC_POSN                            0x6
#define _CWG1OCON0_CWG1OVRC_POSITION                        0x6
#define _CWG1OCON0_CWG1OVRC_SIZE                            0x1
#define _CWG1OCON0_CWG1OVRC_LENGTH                          0x1
#define _CWG1OCON0_CWG1OVRC_MASK                            0x40
#define _CWG1OCON0_CWG1OVRD_POSN                            0x7
#define _CWG1OCON0_CWG1OVRD_POSITION                        0x7
#define _CWG1OCON0_CWG1OVRD_SIZE                            0x1
#define _CWG1OCON0_CWG1OVRD_LENGTH                          0x1
#define _CWG1OCON0_CWG1OVRD_MASK                            0x80

// Register: CWG1CON0
extern volatile unsigned char           CWG1CON0            @ 0x696;
#ifndef _LIB_BUILD
asm("CWG1CON0 equ 0696h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned MODE                   :3;
        unsigned                        :3;
        unsigned LD                     :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
        unsigned                        :4;
        unsigned G1EN                   :1;
    };
    struct {
        unsigned CWG1MODE               :3;
        unsigned                        :3;
        unsigned CWG1LD                 :1;
        unsigned CWG1EN                 :1;
    };
    struct {
        unsigned CWG1MODE0              :1;
        unsigned CWG1MODE1              :1;
        unsigned CWG1MODE2              :1;
    };
} CWG1CON0bits_t;
extern volatile CWG1CON0bits_t CWG1CON0bits @ 0x696;
// bitfield macros
#define _CWG1CON0_MODE_POSN                                 0x0
#define _CWG1CON0_MODE_POSITION                             0x0
#define _CWG1CON0_MODE_SIZE                                 0x3
#define _CWG1CON0_MODE_LENGTH                               0x3
#define _CWG1CON0_MODE_MASK                                 0x7
#define _CWG1CON0_LD_POSN                                   0x6
#define _CWG1CON0_LD_POSITION                               0x6
#define _CWG1CON0_LD_SIZE                                   0x1
#define _CWG1CON0_LD_LENGTH                                 0x1
#define _CWG1CON0_LD_MASK                                   0x40
#define _CWG1CON0_EN_POSN                                   0x7
#define _CWG1CON0_EN_POSITION                               0x7
#define _CWG1CON0_EN_SIZE                                   0x1
#define _CWG1CON0_EN_LENGTH                                 0x1
#define _CWG1CON0_EN_MASK                                   0x80
#define _CWG1CON0_MODE0_POSN                                0x0
#define _CWG1CON0_MODE0_POSITION                            0x0
#define _CWG1CON0_MODE0_SIZE                                0x1
#define _CWG1CON0_MODE0_LENGTH                              0x1
#define _CWG1CON0_MODE0_MASK                                0x1
#define _CWG1CON0_MODE1_POSN                                0x1
#define _CWG1CON0_MODE1_POSITION                            0x1
#define _CWG1CON0_MODE1_SIZE                                0x1
#define _CWG1CON0_MODE1_LENGTH                              0x1
#define _CWG1CON0_MODE1_MASK                                0x2
#define _CWG1CON0_MODE2_POSN                                0x2
#define _CWG1CON0_MODE2_POSITION                            0x2
#define _CWG1CON0_MODE2_SIZE                                0x1
#define _CWG1CON0_MODE2_LENGTH                              0x1
#define _CWG1CON0_MODE2_MASK                                0x4
#define _CWG1CON0_G1EN_POSN                                 0x7
#define _CWG1CON0_G1EN_POSITION                             0x7
#define _CWG1CON0_G1EN_SIZE                                 0x1
#define _CWG1CON0_G1EN_LENGTH                               0x1
#define _CWG1CON0_G1EN_MASK                                 0x80
#define _CWG1CON0_CWG1MODE_POSN                             0x0
#define _CWG1CON0_CWG1MODE_POSITION                         0x0
#define _CWG1CON0_CWG1MODE_SIZE                             0x3
#define _CWG1CON0_CWG1MODE_LENGTH                           0x3
#define _CWG1CON0_CWG1MODE_MASK                             0x7
#define _CWG1CON0_CWG1LD_POSN                               0x6
#define _CWG1CON0_CWG1LD_POSITION                           0x6
#define _CWG1CON0_CWG1LD_SIZE                               0x1
#define _CWG1CON0_CWG1LD_LENGTH                             0x1
#define _CWG1CON0_CWG1LD_MASK                               0x40
#define _CWG1CON0_CWG1EN_POSN                               0x7
#define _CWG1CON0_CWG1EN_POSITION                           0x7
#define _CWG1CON0_CWG1EN_SIZE                               0x1
#define _CWG1CON0_CWG1EN_LENGTH                             0x1
#define _CWG1CON0_CWG1EN_MASK                               0x80
#define _CWG1CON0_CWG1MODE0_POSN                            0x0
#define _CWG1CON0_CWG1MODE0_POSITION                        0x0
#define _CWG1CON0_CWG1MODE0_SIZE                            0x1
#define _CWG1CON0_CWG1MODE0_LENGTH                          0x1
#define _CWG1CON0_CWG1MODE0_MASK                            0x1
#define _CWG1CON0_CWG1MODE1_POSN                            0x1
#define _CWG1CON0_CWG1MODE1_POSITION                        0x1
#define _CWG1CON0_CWG1MODE1_SIZE                            0x1
#define _CWG1CON0_CWG1MODE1_LENGTH                          0x1
#define _CWG1CON0_CWG1MODE1_MASK                            0x2
#define _CWG1CON0_CWG1MODE2_POSN                            0x2
#define _CWG1CON0_CWG1MODE2_POSITION                        0x2
#define _CWG1CON0_CWG1MODE2_SIZE                            0x1
#define _CWG1CON0_CWG1MODE2_LENGTH                          0x1
#define _CWG1CON0_CWG1MODE2_MASK                            0x4

// Register: CWG1CON1
extern volatile unsigned char           CWG1CON1            @ 0x697;
#ifndef _LIB_BUILD
asm("CWG1CON1 equ 0697h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned POLA                   :1;
        unsigned POLB                   :1;
        unsigned POLC                   :1;
        unsigned POLD                   :1;
        unsigned                        :1;
        unsigned IN                     :1;
    };
    struct {
        unsigned CWG1POLA               :1;
        unsigned CWG1POLB               :1;
        unsigned CWG1POLC               :1;
        unsigned CWG1POLD               :1;
        unsigned                        :1;
        unsigned CWG1IN                 :1;
    };
} CWG1CON1bits_t;
extern volatile CWG1CON1bits_t CWG1CON1bits @ 0x697;
// bitfield macros
#define _CWG1CON1_POLA_POSN                                 0x0
#define _CWG1CON1_POLA_POSITION                             0x0
#define _CWG1CON1_POLA_SIZE                                 0x1
#define _CWG1CON1_POLA_LENGTH                               0x1
#define _CWG1CON1_POLA_MASK                                 0x1
#define _CWG1CON1_POLB_POSN                                 0x1
#define _CWG1CON1_POLB_POSITION                             0x1
#define _CWG1CON1_POLB_SIZE                                 0x1
#define _CWG1CON1_POLB_LENGTH                               0x1
#define _CWG1CON1_POLB_MASK                                 0x2
#define _CWG1CON1_POLC_POSN                                 0x2
#define _CWG1CON1_POLC_POSITION                             0x2
#define _CWG1CON1_POLC_SIZE                                 0x1
#define _CWG1CON1_POLC_LENGTH                               0x1
#define _CWG1CON1_POLC_MASK                                 0x4
#define _CWG1CON1_POLD_POSN                                 0x3
#define _CWG1CON1_POLD_POSITION                             0x3
#define _CWG1CON1_POLD_SIZE                                 0x1
#define _CWG1CON1_POLD_LENGTH                               0x1
#define _CWG1CON1_POLD_MASK                                 0x8
#define _CWG1CON1_IN_POSN                                   0x5
#define _CWG1CON1_IN_POSITION                               0x5
#define _CWG1CON1_IN_SIZE                                   0x1
#define _CWG1CON1_IN_LENGTH                                 0x1
#define _CWG1CON1_IN_MASK                                   0x20
#define _CWG1CON1_CWG1POLA_POSN                             0x0
#define _CWG1CON1_CWG1POLA_POSITION                         0x0
#define _CWG1CON1_CWG1POLA_SIZE                             0x1
#define _CWG1CON1_CWG1POLA_LENGTH                           0x1
#define _CWG1CON1_CWG1POLA_MASK                             0x1
#define _CWG1CON1_CWG1POLB_POSN                             0x1
#define _CWG1CON1_CWG1POLB_POSITION                         0x1
#define _CWG1CON1_CWG1POLB_SIZE                             0x1
#define _CWG1CON1_CWG1POLB_LENGTH                           0x1
#define _CWG1CON1_CWG1POLB_MASK                             0x2
#define _CWG1CON1_CWG1POLC_POSN                             0x2
#define _CWG1CON1_CWG1POLC_POSITION                         0x2
#define _CWG1CON1_CWG1POLC_SIZE                             0x1
#define _CWG1CON1_CWG1POLC_LENGTH                           0x1
#define _CWG1CON1_CWG1POLC_MASK                             0x4
#define _CWG1CON1_CWG1POLD_POSN                             0x3
#define _CWG1CON1_CWG1POLD_POSITION                         0x3
#define _CWG1CON1_CWG1POLD_SIZE                             0x1
#define _CWG1CON1_CWG1POLD_LENGTH                           0x1
#define _CWG1CON1_CWG1POLD_MASK                             0x8
#define _CWG1CON1_CWG1IN_POSN                               0x5
#define _CWG1CON1_CWG1IN_POSITION                           0x5
#define _CWG1CON1_CWG1IN_SIZE                               0x1
#define _CWG1CON1_CWG1IN_LENGTH                             0x1
#define _CWG1CON1_CWG1IN_MASK                               0x20

// Register: CWG1CLKCON
extern volatile unsigned char           CWG1CLKCON          @ 0x699;
#ifndef _LIB_BUILD
asm("CWG1CLKCON equ 0699h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CS                     :1;
    };
    struct {
        unsigned CWG1CS                 :1;
    };
} CWG1CLKCONbits_t;
extern volatile CWG1CLKCONbits_t CWG1CLKCONbits @ 0x699;
// bitfield macros
#define _CWG1CLKCON_CS_POSN                                 0x0
#define _CWG1CLKCON_CS_POSITION                             0x0
#define _CWG1CLKCON_CS_SIZE                                 0x1
#define _CWG1CLKCON_CS_LENGTH                               0x1
#define _CWG1CLKCON_CS_MASK                                 0x1
#define _CWG1CLKCON_CWG1CS_POSN                             0x0
#define _CWG1CLKCON_CWG1CS_POSITION                         0x0
#define _CWG1CLKCON_CWG1CS_SIZE                             0x1
#define _CWG1CLKCON_CWG1CS_LENGTH                           0x1
#define _CWG1CLKCON_CWG1CS_MASK                             0x1

// Register: CWG1ISM
extern volatile unsigned char           CWG1ISM             @ 0x69A;
#ifndef _LIB_BUILD
asm("CWG1ISM equ 069Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned IS                     :8;
    };
    struct {
        unsigned IS0                    :1;
        unsigned IS1                    :1;
        unsigned IS2                    :1;
        unsigned IS3                    :1;
    };
    struct {
        unsigned CWG1IS                 :8;
    };
    struct {
        unsigned CWG1IS0                :1;
        unsigned CWG1IS1                :1;
        unsigned CWG1IS2                :1;
        unsigned CWG1IS3                :1;
    };
} CWG1ISMbits_t;
extern volatile CWG1ISMbits_t CWG1ISMbits @ 0x69A;
// bitfield macros
#define _CWG1ISM_IS_POSN                                    0x0
#define _CWG1ISM_IS_POSITION                                0x0
#define _CWG1ISM_IS_SIZE                                    0x8
#define _CWG1ISM_IS_LENGTH                                  0x8
#define _CWG1ISM_IS_MASK                                    0xFF
#define _CWG1ISM_IS0_POSN                                   0x0
#define _CWG1ISM_IS0_POSITION                               0x0
#define _CWG1ISM_IS0_SIZE                                   0x1
#define _CWG1ISM_IS0_LENGTH                                 0x1
#define _CWG1ISM_IS0_MASK                                   0x1
#define _CWG1ISM_IS1_POSN                                   0x1
#define _CWG1ISM_IS1_POSITION                               0x1
#define _CWG1ISM_IS1_SIZE                                   0x1
#define _CWG1ISM_IS1_LENGTH                                 0x1
#define _CWG1ISM_IS1_MASK                                   0x2
#define _CWG1ISM_IS2_POSN                                   0x2
#define _CWG1ISM_IS2_POSITION                               0x2
#define _CWG1ISM_IS2_SIZE                                   0x1
#define _CWG1ISM_IS2_LENGTH                                 0x1
#define _CWG1ISM_IS2_MASK                                   0x4
#define _CWG1ISM_IS3_POSN                                   0x3
#define _CWG1ISM_IS3_POSITION                               0x3
#define _CWG1ISM_IS3_SIZE                                   0x1
#define _CWG1ISM_IS3_LENGTH                                 0x1
#define _CWG1ISM_IS3_MASK                                   0x8
#define _CWG1ISM_CWG1IS_POSN                                0x0
#define _CWG1ISM_CWG1IS_POSITION                            0x0
#define _CWG1ISM_CWG1IS_SIZE                                0x8
#define _CWG1ISM_CWG1IS_LENGTH                              0x8
#define _CWG1ISM_CWG1IS_MASK                                0xFF
#define _CWG1ISM_CWG1IS0_POSN                               0x0
#define _CWG1ISM_CWG1IS0_POSITION                           0x0
#define _CWG1ISM_CWG1IS0_SIZE                               0x1
#define _CWG1ISM_CWG1IS0_LENGTH                             0x1
#define _CWG1ISM_CWG1IS0_MASK                               0x1
#define _CWG1ISM_CWG1IS1_POSN                               0x1
#define _CWG1ISM_CWG1IS1_POSITION                           0x1
#define _CWG1ISM_CWG1IS1_SIZE                               0x1
#define _CWG1ISM_CWG1IS1_LENGTH                             0x1
#define _CWG1ISM_CWG1IS1_MASK                               0x2
#define _CWG1ISM_CWG1IS2_POSN                               0x2
#define _CWG1ISM_CWG1IS2_POSITION                           0x2
#define _CWG1ISM_CWG1IS2_SIZE                               0x1
#define _CWG1ISM_CWG1IS2_LENGTH                             0x1
#define _CWG1ISM_CWG1IS2_MASK                               0x4
#define _CWG1ISM_CWG1IS3_POSN                               0x3
#define _CWG1ISM_CWG1IS3_POSITION                           0x3
#define _CWG1ISM_CWG1IS3_SIZE                               0x1
#define _CWG1ISM_CWG1IS3_LENGTH                             0x1
#define _CWG1ISM_CWG1IS3_MASK                               0x8

// Register: WDTCON0
extern volatile unsigned char           WDTCON0             @ 0x711;
#ifndef _LIB_BUILD
asm("WDTCON0 equ 0711h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SEN                    :1;
        unsigned WDTPS                  :5;
    };
    struct {
        unsigned SWDTEN                 :1;
    };
    struct {
        unsigned WDTSEN                 :1;
    };
    struct {
        unsigned                        :1;
        unsigned WDTPS0                 :1;
        unsigned WDTPS1                 :1;
        unsigned WDTPS2                 :1;
        unsigned WDTPS3                 :1;
        unsigned WDTPS4                 :1;
    };
} WDTCON0bits_t;
extern volatile WDTCON0bits_t WDTCON0bits @ 0x711;
// bitfield macros
#define _WDTCON0_SEN_POSN                                   0x0
#define _WDTCON0_SEN_POSITION                               0x0
#define _WDTCON0_SEN_SIZE                                   0x1
#define _WDTCON0_SEN_LENGTH                                 0x1
#define _WDTCON0_SEN_MASK                                   0x1
#define _WDTCON0_WDTPS_POSN                                 0x1
#define _WDTCON0_WDTPS_POSITION                             0x1
#define _WDTCON0_WDTPS_SIZE                                 0x5
#define _WDTCON0_WDTPS_LENGTH                               0x5
#define _WDTCON0_WDTPS_MASK                                 0x3E
#define _WDTCON0_SWDTEN_POSN                                0x0
#define _WDTCON0_SWDTEN_POSITION                            0x0
#define _WDTCON0_SWDTEN_SIZE                                0x1
#define _WDTCON0_SWDTEN_LENGTH                              0x1
#define _WDTCON0_SWDTEN_MASK                                0x1
#define _WDTCON0_WDTSEN_POSN                                0x0
#define _WDTCON0_WDTSEN_POSITION                            0x0
#define _WDTCON0_WDTSEN_SIZE                                0x1
#define _WDTCON0_WDTSEN_LENGTH                              0x1
#define _WDTCON0_WDTSEN_MASK                                0x1
#define _WDTCON0_WDTPS0_POSN                                0x1
#define _WDTCON0_WDTPS0_POSITION                            0x1
#define _WDTCON0_WDTPS0_SIZE                                0x1
#define _WDTCON0_WDTPS0_LENGTH                              0x1
#define _WDTCON0_WDTPS0_MASK                                0x2
#define _WDTCON0_WDTPS1_POSN                                0x2
#define _WDTCON0_WDTPS1_POSITION                            0x2
#define _WDTCON0_WDTPS1_SIZE                                0x1
#define _WDTCON0_WDTPS1_LENGTH                              0x1
#define _WDTCON0_WDTPS1_MASK                                0x4
#define _WDTCON0_WDTPS2_POSN                                0x3
#define _WDTCON0_WDTPS2_POSITION                            0x3
#define _WDTCON0_WDTPS2_SIZE                                0x1
#define _WDTCON0_WDTPS2_LENGTH                              0x1
#define _WDTCON0_WDTPS2_MASK                                0x8
#define _WDTCON0_WDTPS3_POSN                                0x4
#define _WDTCON0_WDTPS3_POSITION                            0x4
#define _WDTCON0_WDTPS3_SIZE                                0x1
#define _WDTCON0_WDTPS3_LENGTH                              0x1
#define _WDTCON0_WDTPS3_MASK                                0x10
#define _WDTCON0_WDTPS4_POSN                                0x5
#define _WDTCON0_WDTPS4_POSITION                            0x5
#define _WDTCON0_WDTPS4_SIZE                                0x1
#define _WDTCON0_WDTPS4_LENGTH                              0x1
#define _WDTCON0_WDTPS4_MASK                                0x20

// Register: WDTCON1
extern volatile unsigned char           WDTCON1             @ 0x712;
#ifndef _LIB_BUILD
asm("WDTCON1 equ 0712h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned WINDOW                 :3;
        unsigned                        :1;
        unsigned WDTCS                  :3;
    };
    struct {
        unsigned WINDOW0                :1;
        unsigned WINDOW1                :1;
        unsigned WINDOW2                :1;
    };
    struct {
        unsigned WDTWINDOW              :3;
    };
    struct {
        unsigned WDTWINDOW0             :1;
        unsigned WDTWINDOW1             :1;
        unsigned WDTWINDOW2             :1;
        unsigned                        :1;
        unsigned WDTCS0                 :1;
        unsigned WDTCS1                 :1;
        unsigned WDTCS2                 :1;
    };
} WDTCON1bits_t;
extern volatile WDTCON1bits_t WDTCON1bits @ 0x712;
// bitfield macros
#define _WDTCON1_WINDOW_POSN                                0x0
#define _WDTCON1_WINDOW_POSITION                            0x0
#define _WDTCON1_WINDOW_SIZE                                0x3
#define _WDTCON1_WINDOW_LENGTH                              0x3
#define _WDTCON1_WINDOW_MASK                                0x7
#define _WDTCON1_WDTCS_POSN                                 0x4
#define _WDTCON1_WDTCS_POSITION                             0x4
#define _WDTCON1_WDTCS_SIZE                                 0x3
#define _WDTCON1_WDTCS_LENGTH                               0x3
#define _WDTCON1_WDTCS_MASK                                 0x70
#define _WDTCON1_WINDOW0_POSN                               0x0
#define _WDTCON1_WINDOW0_POSITION                           0x0
#define _WDTCON1_WINDOW0_SIZE                               0x1
#define _WDTCON1_WINDOW0_LENGTH                             0x1
#define _WDTCON1_WINDOW0_MASK                               0x1
#define _WDTCON1_WINDOW1_POSN                               0x1
#define _WDTCON1_WINDOW1_POSITION                           0x1
#define _WDTCON1_WINDOW1_SIZE                               0x1
#define _WDTCON1_WINDOW1_LENGTH                             0x1
#define _WDTCON1_WINDOW1_MASK                               0x2
#define _WDTCON1_WINDOW2_POSN                               0x2
#define _WDTCON1_WINDOW2_POSITION                           0x2
#define _WDTCON1_WINDOW2_SIZE                               0x1
#define _WDTCON1_WINDOW2_LENGTH                             0x1
#define _WDTCON1_WINDOW2_MASK                               0x4
#define _WDTCON1_WDTWINDOW_POSN                             0x0
#define _WDTCON1_WDTWINDOW_POSITION                         0x0
#define _WDTCON1_WDTWINDOW_SIZE                             0x3
#define _WDTCON1_WDTWINDOW_LENGTH                           0x3
#define _WDTCON1_WDTWINDOW_MASK                             0x7
#define _WDTCON1_WDTWINDOW0_POSN                            0x0
#define _WDTCON1_WDTWINDOW0_POSITION                        0x0
#define _WDTCON1_WDTWINDOW0_SIZE                            0x1
#define _WDTCON1_WDTWINDOW0_LENGTH                          0x1
#define _WDTCON1_WDTWINDOW0_MASK                            0x1
#define _WDTCON1_WDTWINDOW1_POSN                            0x1
#define _WDTCON1_WDTWINDOW1_POSITION                        0x1
#define _WDTCON1_WDTWINDOW1_SIZE                            0x1
#define _WDTCON1_WDTWINDOW1_LENGTH                          0x1
#define _WDTCON1_WDTWINDOW1_MASK                            0x2
#define _WDTCON1_WDTWINDOW2_POSN                            0x2
#define _WDTCON1_WDTWINDOW2_POSITION                        0x2
#define _WDTCON1_WDTWINDOW2_SIZE                            0x1
#define _WDTCON1_WDTWINDOW2_LENGTH                          0x1
#define _WDTCON1_WDTWINDOW2_MASK                            0x4
#define _WDTCON1_WDTCS0_POSN                                0x4
#define _WDTCON1_WDTCS0_POSITION                            0x4
#define _WDTCON1_WDTCS0_SIZE                                0x1
#define _WDTCON1_WDTCS0_LENGTH                              0x1
#define _WDTCON1_WDTCS0_MASK                                0x10
#define _WDTCON1_WDTCS1_POSN                                0x5
#define _WDTCON1_WDTCS1_POSITION                            0x5
#define _WDTCON1_WDTCS1_SIZE                                0x1
#define _WDTCON1_WDTCS1_LENGTH                              0x1
#define _WDTCON1_WDTCS1_MASK                                0x20
#define _WDTCON1_WDTCS2_POSN                                0x6
#define _WDTCON1_WDTCS2_POSITION                            0x6
#define _WDTCON1_WDTCS2_SIZE                                0x1
#define _WDTCON1_WDTCS2_LENGTH                              0x1
#define _WDTCON1_WDTCS2_MASK                                0x40

// Register: WDTPSL
extern volatile unsigned char           WDTPSL              @ 0x713;
#ifndef _LIB_BUILD
asm("WDTPSL equ 0713h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PSCNT                  :8;
    };
    struct {
        unsigned PSCNT0                 :1;
        unsigned PSCNT1                 :1;
        unsigned PSCNT2                 :1;
        unsigned PSCNT3                 :1;
        unsigned PSCNT4                 :1;
        unsigned PSCNT5                 :1;
        unsigned PSCNT6                 :1;
        unsigned PSCNT7                 :1;
    };
    struct {
        unsigned WDTPSCNT               :8;
    };
    struct {
        unsigned WDTPSCNT0              :1;
        unsigned WDTPSCNT1              :1;
        unsigned WDTPSCNT2              :1;
        unsigned WDTPSCNT3              :1;
        unsigned WDTPSCNT4              :1;
        unsigned WDTPSCNT5              :1;
        unsigned WDTPSCNT6              :1;
        unsigned WDTPSCNT7              :1;
    };
} WDTPSLbits_t;
extern volatile WDTPSLbits_t WDTPSLbits @ 0x713;
// bitfield macros
#define _WDTPSL_PSCNT_POSN                                  0x0
#define _WDTPSL_PSCNT_POSITION                              0x0
#define _WDTPSL_PSCNT_SIZE                                  0x8
#define _WDTPSL_PSCNT_LENGTH                                0x8
#define _WDTPSL_PSCNT_MASK                                  0xFF
#define _WDTPSL_PSCNT0_POSN                                 0x0
#define _WDTPSL_PSCNT0_POSITION                             0x0
#define _WDTPSL_PSCNT0_SIZE                                 0x1
#define _WDTPSL_PSCNT0_LENGTH                               0x1
#define _WDTPSL_PSCNT0_MASK                                 0x1
#define _WDTPSL_PSCNT1_POSN                                 0x1
#define _WDTPSL_PSCNT1_POSITION                             0x1
#define _WDTPSL_PSCNT1_SIZE                                 0x1
#define _WDTPSL_PSCNT1_LENGTH                               0x1
#define _WDTPSL_PSCNT1_MASK                                 0x2
#define _WDTPSL_PSCNT2_POSN                                 0x2
#define _WDTPSL_PSCNT2_POSITION                             0x2
#define _WDTPSL_PSCNT2_SIZE                                 0x1
#define _WDTPSL_PSCNT2_LENGTH                               0x1
#define _WDTPSL_PSCNT2_MASK                                 0x4
#define _WDTPSL_PSCNT3_POSN                                 0x3
#define _WDTPSL_PSCNT3_POSITION                             0x3
#define _WDTPSL_PSCNT3_SIZE                                 0x1
#define _WDTPSL_PSCNT3_LENGTH                               0x1
#define _WDTPSL_PSCNT3_MASK                                 0x8
#define _WDTPSL_PSCNT4_POSN                                 0x4
#define _WDTPSL_PSCNT4_POSITION                             0x4
#define _WDTPSL_PSCNT4_SIZE                                 0x1
#define _WDTPSL_PSCNT4_LENGTH                               0x1
#define _WDTPSL_PSCNT4_MASK                                 0x10
#define _WDTPSL_PSCNT5_POSN                                 0x5
#define _WDTPSL_PSCNT5_POSITION                             0x5
#define _WDTPSL_PSCNT5_SIZE                                 0x1
#define _WDTPSL_PSCNT5_LENGTH                               0x1
#define _WDTPSL_PSCNT5_MASK                                 0x20
#define _WDTPSL_PSCNT6_POSN                                 0x6
#define _WDTPSL_PSCNT6_POSITION                             0x6
#define _WDTPSL_PSCNT6_SIZE                                 0x1
#define _WDTPSL_PSCNT6_LENGTH                               0x1
#define _WDTPSL_PSCNT6_MASK                                 0x40
#define _WDTPSL_PSCNT7_POSN                                 0x7
#define _WDTPSL_PSCNT7_POSITION                             0x7
#define _WDTPSL_PSCNT7_SIZE                                 0x1
#define _WDTPSL_PSCNT7_LENGTH                               0x1
#define _WDTPSL_PSCNT7_MASK                                 0x80
#define _WDTPSL_WDTPSCNT_POSN                               0x0
#define _WDTPSL_WDTPSCNT_POSITION                           0x0
#define _WDTPSL_WDTPSCNT_SIZE                               0x8
#define _WDTPSL_WDTPSCNT_LENGTH                             0x8
#define _WDTPSL_WDTPSCNT_MASK                               0xFF
#define _WDTPSL_WDTPSCNT0_POSN                              0x0
#define _WDTPSL_WDTPSCNT0_POSITION                          0x0
#define _WDTPSL_WDTPSCNT0_SIZE                              0x1
#define _WDTPSL_WDTPSCNT0_LENGTH                            0x1
#define _WDTPSL_WDTPSCNT0_MASK                              0x1
#define _WDTPSL_WDTPSCNT1_POSN                              0x1
#define _WDTPSL_WDTPSCNT1_POSITION                          0x1
#define _WDTPSL_WDTPSCNT1_SIZE                              0x1
#define _WDTPSL_WDTPSCNT1_LENGTH                            0x1
#define _WDTPSL_WDTPSCNT1_MASK                              0x2
#define _WDTPSL_WDTPSCNT2_POSN                              0x2
#define _WDTPSL_WDTPSCNT2_POSITION                          0x2
#define _WDTPSL_WDTPSCNT2_SIZE                              0x1
#define _WDTPSL_WDTPSCNT2_LENGTH                            0x1
#define _WDTPSL_WDTPSCNT2_MASK                              0x4
#define _WDTPSL_WDTPSCNT3_POSN                              0x3
#define _WDTPSL_WDTPSCNT3_POSITION                          0x3
#define _WDTPSL_WDTPSCNT3_SIZE                              0x1
#define _WDTPSL_WDTPSCNT3_LENGTH                            0x1
#define _WDTPSL_WDTPSCNT3_MASK                              0x8
#define _WDTPSL_WDTPSCNT4_POSN                              0x4
#define _WDTPSL_WDTPSCNT4_POSITION                          0x4
#define _WDTPSL_WDTPSCNT4_SIZE                              0x1
#define _WDTPSL_WDTPSCNT4_LENGTH                            0x1
#define _WDTPSL_WDTPSCNT4_MASK                              0x10
#define _WDTPSL_WDTPSCNT5_POSN                              0x5
#define _WDTPSL_WDTPSCNT5_POSITION                          0x5
#define _WDTPSL_WDTPSCNT5_SIZE                              0x1
#define _WDTPSL_WDTPSCNT5_LENGTH                            0x1
#define _WDTPSL_WDTPSCNT5_MASK                              0x20
#define _WDTPSL_WDTPSCNT6_POSN                              0x6
#define _WDTPSL_WDTPSCNT6_POSITION                          0x6
#define _WDTPSL_WDTPSCNT6_SIZE                              0x1
#define _WDTPSL_WDTPSCNT6_LENGTH                            0x1
#define _WDTPSL_WDTPSCNT6_MASK                              0x40
#define _WDTPSL_WDTPSCNT7_POSN                              0x7
#define _WDTPSL_WDTPSCNT7_POSITION                          0x7
#define _WDTPSL_WDTPSCNT7_SIZE                              0x1
#define _WDTPSL_WDTPSCNT7_LENGTH                            0x1
#define _WDTPSL_WDTPSCNT7_MASK                              0x80

// Register: WDTPSH
extern volatile unsigned char           WDTPSH              @ 0x714;
#ifndef _LIB_BUILD
asm("WDTPSH equ 0714h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PSCNT                  :8;
    };
    struct {
        unsigned PSCNT8                 :1;
        unsigned PSCNT9                 :1;
        unsigned PSCNT10                :1;
        unsigned PSCNT11                :1;
        unsigned PSCNT12                :1;
        unsigned PSCNT13                :1;
        unsigned PSCNT14                :1;
        unsigned PSCNT15                :1;
    };
    struct {
        unsigned WDTPSCNT               :8;
    };
    struct {
        unsigned WDTPSCNT8              :1;
        unsigned WDTPSCNT9              :1;
        unsigned WDTPSCNT10             :1;
        unsigned WDTPSCNT11             :1;
        unsigned WDTPSCNT12             :1;
        unsigned WDTPSCNT13             :1;
        unsigned WDTPSCNT14             :1;
        unsigned WDTPSCNT15             :1;
    };
} WDTPSHbits_t;
extern volatile WDTPSHbits_t WDTPSHbits @ 0x714;
// bitfield macros
#define _WDTPSH_PSCNT_POSN                                  0x0
#define _WDTPSH_PSCNT_POSITION                              0x0
#define _WDTPSH_PSCNT_SIZE                                  0x8
#define _WDTPSH_PSCNT_LENGTH                                0x8
#define _WDTPSH_PSCNT_MASK                                  0xFF
#define _WDTPSH_PSCNT8_POSN                                 0x0
#define _WDTPSH_PSCNT8_POSITION                             0x0
#define _WDTPSH_PSCNT8_SIZE                                 0x1
#define _WDTPSH_PSCNT8_LENGTH                               0x1
#define _WDTPSH_PSCNT8_MASK                                 0x1
#define _WDTPSH_PSCNT9_POSN                                 0x1
#define _WDTPSH_PSCNT9_POSITION                             0x1
#define _WDTPSH_PSCNT9_SIZE                                 0x1
#define _WDTPSH_PSCNT9_LENGTH                               0x1
#define _WDTPSH_PSCNT9_MASK                                 0x2
#define _WDTPSH_PSCNT10_POSN                                0x2
#define _WDTPSH_PSCNT10_POSITION                            0x2
#define _WDTPSH_PSCNT10_SIZE                                0x1
#define _WDTPSH_PSCNT10_LENGTH                              0x1
#define _WDTPSH_PSCNT10_MASK                                0x4
#define _WDTPSH_PSCNT11_POSN                                0x3
#define _WDTPSH_PSCNT11_POSITION                            0x3
#define _WDTPSH_PSCNT11_SIZE                                0x1
#define _WDTPSH_PSCNT11_LENGTH                              0x1
#define _WDTPSH_PSCNT11_MASK                                0x8
#define _WDTPSH_PSCNT12_POSN                                0x4
#define _WDTPSH_PSCNT12_POSITION                            0x4
#define _WDTPSH_PSCNT12_SIZE                                0x1
#define _WDTPSH_PSCNT12_LENGTH                              0x1
#define _WDTPSH_PSCNT12_MASK                                0x10
#define _WDTPSH_PSCNT13_POSN                                0x5
#define _WDTPSH_PSCNT13_POSITION                            0x5
#define _WDTPSH_PSCNT13_SIZE                                0x1
#define _WDTPSH_PSCNT13_LENGTH                              0x1
#define _WDTPSH_PSCNT13_MASK                                0x20
#define _WDTPSH_PSCNT14_POSN                                0x6
#define _WDTPSH_PSCNT14_POSITION                            0x6
#define _WDTPSH_PSCNT14_SIZE                                0x1
#define _WDTPSH_PSCNT14_LENGTH                              0x1
#define _WDTPSH_PSCNT14_MASK                                0x40
#define _WDTPSH_PSCNT15_POSN                                0x7
#define _WDTPSH_PSCNT15_POSITION                            0x7
#define _WDTPSH_PSCNT15_SIZE                                0x1
#define _WDTPSH_PSCNT15_LENGTH                              0x1
#define _WDTPSH_PSCNT15_MASK                                0x80
#define _WDTPSH_WDTPSCNT_POSN                               0x0
#define _WDTPSH_WDTPSCNT_POSITION                           0x0
#define _WDTPSH_WDTPSCNT_SIZE                               0x8
#define _WDTPSH_WDTPSCNT_LENGTH                             0x8
#define _WDTPSH_WDTPSCNT_MASK                               0xFF
#define _WDTPSH_WDTPSCNT8_POSN                              0x0
#define _WDTPSH_WDTPSCNT8_POSITION                          0x0
#define _WDTPSH_WDTPSCNT8_SIZE                              0x1
#define _WDTPSH_WDTPSCNT8_LENGTH                            0x1
#define _WDTPSH_WDTPSCNT8_MASK                              0x1
#define _WDTPSH_WDTPSCNT9_POSN                              0x1
#define _WDTPSH_WDTPSCNT9_POSITION                          0x1
#define _WDTPSH_WDTPSCNT9_SIZE                              0x1
#define _WDTPSH_WDTPSCNT9_LENGTH                            0x1
#define _WDTPSH_WDTPSCNT9_MASK                              0x2
#define _WDTPSH_WDTPSCNT10_POSN                             0x2
#define _WDTPSH_WDTPSCNT10_POSITION                         0x2
#define _WDTPSH_WDTPSCNT10_SIZE                             0x1
#define _WDTPSH_WDTPSCNT10_LENGTH                           0x1
#define _WDTPSH_WDTPSCNT10_MASK                             0x4
#define _WDTPSH_WDTPSCNT11_POSN                             0x3
#define _WDTPSH_WDTPSCNT11_POSITION                         0x3
#define _WDTPSH_WDTPSCNT11_SIZE                             0x1
#define _WDTPSH_WDTPSCNT11_LENGTH                           0x1
#define _WDTPSH_WDTPSCNT11_MASK                             0x8
#define _WDTPSH_WDTPSCNT12_POSN                             0x4
#define _WDTPSH_WDTPSCNT12_POSITION                         0x4
#define _WDTPSH_WDTPSCNT12_SIZE                             0x1
#define _WDTPSH_WDTPSCNT12_LENGTH                           0x1
#define _WDTPSH_WDTPSCNT12_MASK                             0x10
#define _WDTPSH_WDTPSCNT13_POSN                             0x5
#define _WDTPSH_WDTPSCNT13_POSITION                         0x5
#define _WDTPSH_WDTPSCNT13_SIZE                             0x1
#define _WDTPSH_WDTPSCNT13_LENGTH                           0x1
#define _WDTPSH_WDTPSCNT13_MASK                             0x20
#define _WDTPSH_WDTPSCNT14_POSN                             0x6
#define _WDTPSH_WDTPSCNT14_POSITION                         0x6
#define _WDTPSH_WDTPSCNT14_SIZE                             0x1
#define _WDTPSH_WDTPSCNT14_LENGTH                           0x1
#define _WDTPSH_WDTPSCNT14_MASK                             0x40
#define _WDTPSH_WDTPSCNT15_POSN                             0x7
#define _WDTPSH_WDTPSCNT15_POSITION                         0x7
#define _WDTPSH_WDTPSCNT15_SIZE                             0x1
#define _WDTPSH_WDTPSCNT15_LENGTH                           0x1
#define _WDTPSH_WDTPSCNT15_MASK                             0x80

// Register: WDTTMR
extern volatile unsigned char           WDTTMR              @ 0x715;
#ifndef _LIB_BUILD
asm("WDTTMR equ 0715h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PSCNT16                :1;
        unsigned PSCNT17                :1;
        unsigned STATE                  :1;
        unsigned WDTTMR                 :5;
    };
    struct {
        unsigned WDTPSCNT16             :1;
        unsigned WDTPSCNT17             :1;
        unsigned WDTSTATE               :1;
        unsigned WDTTMR0                :1;
        unsigned WDTTMR1                :1;
        unsigned WDTTMR2                :1;
        unsigned WDTTMR3                :1;
        unsigned WDTTMR4                :1;
    };
} WDTTMRbits_t;
extern volatile WDTTMRbits_t WDTTMRbits @ 0x715;
// bitfield macros
#define _WDTTMR_PSCNT16_POSN                                0x0
#define _WDTTMR_PSCNT16_POSITION                            0x0
#define _WDTTMR_PSCNT16_SIZE                                0x1
#define _WDTTMR_PSCNT16_LENGTH                              0x1
#define _WDTTMR_PSCNT16_MASK                                0x1
#define _WDTTMR_PSCNT17_POSN                                0x1
#define _WDTTMR_PSCNT17_POSITION                            0x1
#define _WDTTMR_PSCNT17_SIZE                                0x1
#define _WDTTMR_PSCNT17_LENGTH                              0x1
#define _WDTTMR_PSCNT17_MASK                                0x2
#define _WDTTMR_STATE_POSN                                  0x2
#define _WDTTMR_STATE_POSITION                              0x2
#define _WDTTMR_STATE_SIZE                                  0x1
#define _WDTTMR_STATE_LENGTH                                0x1
#define _WDTTMR_STATE_MASK                                  0x4
#define _WDTTMR_WDTTMR_POSN                                 0x3
#define _WDTTMR_WDTTMR_POSITION                             0x3
#define _WDTTMR_WDTTMR_SIZE                                 0x5
#define _WDTTMR_WDTTMR_LENGTH                               0x5
#define _WDTTMR_WDTTMR_MASK                                 0xF8
#define _WDTTMR_WDTPSCNT16_POSN                             0x0
#define _WDTTMR_WDTPSCNT16_POSITION                         0x0
#define _WDTTMR_WDTPSCNT16_SIZE                             0x1
#define _WDTTMR_WDTPSCNT16_LENGTH                           0x1
#define _WDTTMR_WDTPSCNT16_MASK                             0x1
#define _WDTTMR_WDTPSCNT17_POSN                             0x1
#define _WDTTMR_WDTPSCNT17_POSITION                         0x1
#define _WDTTMR_WDTPSCNT17_SIZE                             0x1
#define _WDTTMR_WDTPSCNT17_LENGTH                           0x1
#define _WDTTMR_WDTPSCNT17_MASK                             0x2
#define _WDTTMR_WDTSTATE_POSN                               0x2
#define _WDTTMR_WDTSTATE_POSITION                           0x2
#define _WDTTMR_WDTSTATE_SIZE                               0x1
#define _WDTTMR_WDTSTATE_LENGTH                             0x1
#define _WDTTMR_WDTSTATE_MASK                               0x4
#define _WDTTMR_WDTTMR0_POSN                                0x3
#define _WDTTMR_WDTTMR0_POSITION                            0x3
#define _WDTTMR_WDTTMR0_SIZE                                0x1
#define _WDTTMR_WDTTMR0_LENGTH                              0x1
#define _WDTTMR_WDTTMR0_MASK                                0x8
#define _WDTTMR_WDTTMR1_POSN                                0x4
#define _WDTTMR_WDTTMR1_POSITION                            0x4
#define _WDTTMR_WDTTMR1_SIZE                                0x1
#define _WDTTMR_WDTTMR1_LENGTH                              0x1
#define _WDTTMR_WDTTMR1_MASK                                0x10
#define _WDTTMR_WDTTMR2_POSN                                0x5
#define _WDTTMR_WDTTMR2_POSITION                            0x5
#define _WDTTMR_WDTTMR2_SIZE                                0x1
#define _WDTTMR_WDTTMR2_LENGTH                              0x1
#define _WDTTMR_WDTTMR2_MASK                                0x20
#define _WDTTMR_WDTTMR3_POSN                                0x6
#define _WDTTMR_WDTTMR3_POSITION                            0x6
#define _WDTTMR_WDTTMR3_SIZE                                0x1
#define _WDTTMR_WDTTMR3_LENGTH                              0x1
#define _WDTTMR_WDTTMR3_MASK                                0x40
#define _WDTTMR_WDTTMR4_POSN                                0x7
#define _WDTTMR_WDTTMR4_POSITION                            0x7
#define _WDTTMR_WDTTMR4_SIZE                                0x1
#define _WDTTMR_WDTTMR4_LENGTH                              0x1
#define _WDTTMR_WDTTMR4_MASK                                0x80

// Register: SCANLADR
extern volatile unsigned short          SCANLADR            @ 0x718;
#ifndef _LIB_BUILD
asm("SCANLADR equ 0718h");
#endif

// Register: SCANLADRL
extern volatile unsigned char           SCANLADRL           @ 0x718;
#ifndef _LIB_BUILD
asm("SCANLADRL equ 0718h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LADR                   :8;
    };
    struct {
        unsigned LDAR0                  :1;
        unsigned LDAR1                  :1;
        unsigned LADR2                  :1;
        unsigned LADR3                  :1;
        unsigned LADR4                  :1;
        unsigned LADR5                  :1;
        unsigned LADR6                  :1;
        unsigned LADR7                  :1;
    };
    struct {
        unsigned SCANLADR               :8;
    };
    struct {
        unsigned SCANLADR0              :1;
        unsigned SCANLADR1              :1;
        unsigned SCANLADR2              :1;
        unsigned SCANLADR3              :1;
        unsigned SCANLADR4              :1;
        unsigned SCANLADR5              :1;
        unsigned SCANLADR6              :1;
        unsigned SCANLADR7              :1;
    };
} SCANLADRLbits_t;
extern volatile SCANLADRLbits_t SCANLADRLbits @ 0x718;
// bitfield macros
#define _SCANLADRL_LADR_POSN                                0x0
#define _SCANLADRL_LADR_POSITION                            0x0
#define _SCANLADRL_LADR_SIZE                                0x8
#define _SCANLADRL_LADR_LENGTH                              0x8
#define _SCANLADRL_LADR_MASK                                0xFF
#define _SCANLADRL_LDAR0_POSN                               0x0
#define _SCANLADRL_LDAR0_POSITION                           0x0
#define _SCANLADRL_LDAR0_SIZE                               0x1
#define _SCANLADRL_LDAR0_LENGTH                             0x1
#define _SCANLADRL_LDAR0_MASK                               0x1
#define _SCANLADRL_LDAR1_POSN                               0x1
#define _SCANLADRL_LDAR1_POSITION                           0x1
#define _SCANLADRL_LDAR1_SIZE                               0x1
#define _SCANLADRL_LDAR1_LENGTH                             0x1
#define _SCANLADRL_LDAR1_MASK                               0x2
#define _SCANLADRL_LADR2_POSN                               0x2
#define _SCANLADRL_LADR2_POSITION                           0x2
#define _SCANLADRL_LADR2_SIZE                               0x1
#define _SCANLADRL_LADR2_LENGTH                             0x1
#define _SCANLADRL_LADR2_MASK                               0x4
#define _SCANLADRL_LADR3_POSN                               0x3
#define _SCANLADRL_LADR3_POSITION                           0x3
#define _SCANLADRL_LADR3_SIZE                               0x1
#define _SCANLADRL_LADR3_LENGTH                             0x1
#define _SCANLADRL_LADR3_MASK                               0x8
#define _SCANLADRL_LADR4_POSN                               0x4
#define _SCANLADRL_LADR4_POSITION                           0x4
#define _SCANLADRL_LADR4_SIZE                               0x1
#define _SCANLADRL_LADR4_LENGTH                             0x1
#define _SCANLADRL_LADR4_MASK                               0x10
#define _SCANLADRL_LADR5_POSN                               0x5
#define _SCANLADRL_LADR5_POSITION                           0x5
#define _SCANLADRL_LADR5_SIZE                               0x1
#define _SCANLADRL_LADR5_LENGTH                             0x1
#define _SCANLADRL_LADR5_MASK                               0x20
#define _SCANLADRL_LADR6_POSN                               0x6
#define _SCANLADRL_LADR6_POSITION                           0x6
#define _SCANLADRL_LADR6_SIZE                               0x1
#define _SCANLADRL_LADR6_LENGTH                             0x1
#define _SCANLADRL_LADR6_MASK                               0x40
#define _SCANLADRL_LADR7_POSN                               0x7
#define _SCANLADRL_LADR7_POSITION                           0x7
#define _SCANLADRL_LADR7_SIZE                               0x1
#define _SCANLADRL_LADR7_LENGTH                             0x1
#define _SCANLADRL_LADR7_MASK                               0x80
#define _SCANLADRL_SCANLADR_POSN                            0x0
#define _SCANLADRL_SCANLADR_POSITION                        0x0
#define _SCANLADRL_SCANLADR_SIZE                            0x8
#define _SCANLADRL_SCANLADR_LENGTH                          0x8
#define _SCANLADRL_SCANLADR_MASK                            0xFF
#define _SCANLADRL_SCANLADR0_POSN                           0x0
#define _SCANLADRL_SCANLADR0_POSITION                       0x0
#define _SCANLADRL_SCANLADR0_SIZE                           0x1
#define _SCANLADRL_SCANLADR0_LENGTH                         0x1
#define _SCANLADRL_SCANLADR0_MASK                           0x1
#define _SCANLADRL_SCANLADR1_POSN                           0x1
#define _SCANLADRL_SCANLADR1_POSITION                       0x1
#define _SCANLADRL_SCANLADR1_SIZE                           0x1
#define _SCANLADRL_SCANLADR1_LENGTH                         0x1
#define _SCANLADRL_SCANLADR1_MASK                           0x2
#define _SCANLADRL_SCANLADR2_POSN                           0x2
#define _SCANLADRL_SCANLADR2_POSITION                       0x2
#define _SCANLADRL_SCANLADR2_SIZE                           0x1
#define _SCANLADRL_SCANLADR2_LENGTH                         0x1
#define _SCANLADRL_SCANLADR2_MASK                           0x4
#define _SCANLADRL_SCANLADR3_POSN                           0x3
#define _SCANLADRL_SCANLADR3_POSITION                       0x3
#define _SCANLADRL_SCANLADR3_SIZE                           0x1
#define _SCANLADRL_SCANLADR3_LENGTH                         0x1
#define _SCANLADRL_SCANLADR3_MASK                           0x8
#define _SCANLADRL_SCANLADR4_POSN                           0x4
#define _SCANLADRL_SCANLADR4_POSITION                       0x4
#define _SCANLADRL_SCANLADR4_SIZE                           0x1
#define _SCANLADRL_SCANLADR4_LENGTH                         0x1
#define _SCANLADRL_SCANLADR4_MASK                           0x10
#define _SCANLADRL_SCANLADR5_POSN                           0x5
#define _SCANLADRL_SCANLADR5_POSITION                       0x5
#define _SCANLADRL_SCANLADR5_SIZE                           0x1
#define _SCANLADRL_SCANLADR5_LENGTH                         0x1
#define _SCANLADRL_SCANLADR5_MASK                           0x20
#define _SCANLADRL_SCANLADR6_POSN                           0x6
#define _SCANLADRL_SCANLADR6_POSITION                       0x6
#define _SCANLADRL_SCANLADR6_SIZE                           0x1
#define _SCANLADRL_SCANLADR6_LENGTH                         0x1
#define _SCANLADRL_SCANLADR6_MASK                           0x40
#define _SCANLADRL_SCANLADR7_POSN                           0x7
#define _SCANLADRL_SCANLADR7_POSITION                       0x7
#define _SCANLADRL_SCANLADR7_SIZE                           0x1
#define _SCANLADRL_SCANLADR7_LENGTH                         0x1
#define _SCANLADRL_SCANLADR7_MASK                           0x80

// Register: SCANLADRH
extern volatile unsigned char           SCANLADRH           @ 0x719;
#ifndef _LIB_BUILD
asm("SCANLADRH equ 0719h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LADR                   :8;
    };
    struct {
        unsigned LADR8                  :1;
        unsigned LADR9                  :1;
        unsigned LADR10                 :1;
        unsigned LADR11                 :1;
        unsigned LADR12                 :1;
        unsigned LADR13                 :1;
        unsigned LADR14                 :1;
        unsigned LADR15                 :1;
    };
    struct {
        unsigned SCANLADR               :8;
    };
    struct {
        unsigned SCANLADR8              :1;
        unsigned SCANLADR9              :1;
        unsigned SCANLADR10             :1;
        unsigned SCANLADR11             :1;
        unsigned SCANLADR12             :1;
        unsigned SCANLADR13             :1;
        unsigned SCANLADR14             :1;
        unsigned SCANLADR15             :1;
    };
} SCANLADRHbits_t;
extern volatile SCANLADRHbits_t SCANLADRHbits @ 0x719;
// bitfield macros
#define _SCANLADRH_LADR_POSN                                0x0
#define _SCANLADRH_LADR_POSITION                            0x0
#define _SCANLADRH_LADR_SIZE                                0x8
#define _SCANLADRH_LADR_LENGTH                              0x8
#define _SCANLADRH_LADR_MASK                                0xFF
#define _SCANLADRH_LADR8_POSN                               0x0
#define _SCANLADRH_LADR8_POSITION                           0x0
#define _SCANLADRH_LADR8_SIZE                               0x1
#define _SCANLADRH_LADR8_LENGTH                             0x1
#define _SCANLADRH_LADR8_MASK                               0x1
#define _SCANLADRH_LADR9_POSN                               0x1
#define _SCANLADRH_LADR9_POSITION                           0x1
#define _SCANLADRH_LADR9_SIZE                               0x1
#define _SCANLADRH_LADR9_LENGTH                             0x1
#define _SCANLADRH_LADR9_MASK                               0x2
#define _SCANLADRH_LADR10_POSN                              0x2
#define _SCANLADRH_LADR10_POSITION                          0x2
#define _SCANLADRH_LADR10_SIZE                              0x1
#define _SCANLADRH_LADR10_LENGTH                            0x1
#define _SCANLADRH_LADR10_MASK                              0x4
#define _SCANLADRH_LADR11_POSN                              0x3
#define _SCANLADRH_LADR11_POSITION                          0x3
#define _SCANLADRH_LADR11_SIZE                              0x1
#define _SCANLADRH_LADR11_LENGTH                            0x1
#define _SCANLADRH_LADR11_MASK                              0x8
#define _SCANLADRH_LADR12_POSN                              0x4
#define _SCANLADRH_LADR12_POSITION                          0x4
#define _SCANLADRH_LADR12_SIZE                              0x1
#define _SCANLADRH_LADR12_LENGTH                            0x1
#define _SCANLADRH_LADR12_MASK                              0x10
#define _SCANLADRH_LADR13_POSN                              0x5
#define _SCANLADRH_LADR13_POSITION                          0x5
#define _SCANLADRH_LADR13_SIZE                              0x1
#define _SCANLADRH_LADR13_LENGTH                            0x1
#define _SCANLADRH_LADR13_MASK                              0x20
#define _SCANLADRH_LADR14_POSN                              0x6
#define _SCANLADRH_LADR14_POSITION                          0x6
#define _SCANLADRH_LADR14_SIZE                              0x1
#define _SCANLADRH_LADR14_LENGTH                            0x1
#define _SCANLADRH_LADR14_MASK                              0x40
#define _SCANLADRH_LADR15_POSN                              0x7
#define _SCANLADRH_LADR15_POSITION                          0x7
#define _SCANLADRH_LADR15_SIZE                              0x1
#define _SCANLADRH_LADR15_LENGTH                            0x1
#define _SCANLADRH_LADR15_MASK                              0x80
#define _SCANLADRH_SCANLADR_POSN                            0x0
#define _SCANLADRH_SCANLADR_POSITION                        0x0
#define _SCANLADRH_SCANLADR_SIZE                            0x8
#define _SCANLADRH_SCANLADR_LENGTH                          0x8
#define _SCANLADRH_SCANLADR_MASK                            0xFF
#define _SCANLADRH_SCANLADR8_POSN                           0x0
#define _SCANLADRH_SCANLADR8_POSITION                       0x0
#define _SCANLADRH_SCANLADR8_SIZE                           0x1
#define _SCANLADRH_SCANLADR8_LENGTH                         0x1
#define _SCANLADRH_SCANLADR8_MASK                           0x1
#define _SCANLADRH_SCANLADR9_POSN                           0x1
#define _SCANLADRH_SCANLADR9_POSITION                       0x1
#define _SCANLADRH_SCANLADR9_SIZE                           0x1
#define _SCANLADRH_SCANLADR9_LENGTH                         0x1
#define _SCANLADRH_SCANLADR9_MASK                           0x2
#define _SCANLADRH_SCANLADR10_POSN                          0x2
#define _SCANLADRH_SCANLADR10_POSITION                      0x2
#define _SCANLADRH_SCANLADR10_SIZE                          0x1
#define _SCANLADRH_SCANLADR10_LENGTH                        0x1
#define _SCANLADRH_SCANLADR10_MASK                          0x4
#define _SCANLADRH_SCANLADR11_POSN                          0x3
#define _SCANLADRH_SCANLADR11_POSITION                      0x3
#define _SCANLADRH_SCANLADR11_SIZE                          0x1
#define _SCANLADRH_SCANLADR11_LENGTH                        0x1
#define _SCANLADRH_SCANLADR11_MASK                          0x8
#define _SCANLADRH_SCANLADR12_POSN                          0x4
#define _SCANLADRH_SCANLADR12_POSITION                      0x4
#define _SCANLADRH_SCANLADR12_SIZE                          0x1
#define _SCANLADRH_SCANLADR12_LENGTH                        0x1
#define _SCANLADRH_SCANLADR12_MASK                          0x10
#define _SCANLADRH_SCANLADR13_POSN                          0x5
#define _SCANLADRH_SCANLADR13_POSITION                      0x5
#define _SCANLADRH_SCANLADR13_SIZE                          0x1
#define _SCANLADRH_SCANLADR13_LENGTH                        0x1
#define _SCANLADRH_SCANLADR13_MASK                          0x20
#define _SCANLADRH_SCANLADR14_POSN                          0x6
#define _SCANLADRH_SCANLADR14_POSITION                      0x6
#define _SCANLADRH_SCANLADR14_SIZE                          0x1
#define _SCANLADRH_SCANLADR14_LENGTH                        0x1
#define _SCANLADRH_SCANLADR14_MASK                          0x40
#define _SCANLADRH_SCANLADR15_POSN                          0x7
#define _SCANLADRH_SCANLADR15_POSITION                      0x7
#define _SCANLADRH_SCANLADR15_SIZE                          0x1
#define _SCANLADRH_SCANLADR15_LENGTH                        0x1
#define _SCANLADRH_SCANLADR15_MASK                          0x80

// Register: SCANHADR
extern volatile unsigned short          SCANHADR            @ 0x71A;
#ifndef _LIB_BUILD
asm("SCANHADR equ 071Ah");
#endif

// Register: SCANHADRL
extern volatile unsigned char           SCANHADRL           @ 0x71A;
#ifndef _LIB_BUILD
asm("SCANHADRL equ 071Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned HADR                   :8;
    };
    struct {
        unsigned HADR0                  :1;
        unsigned HADR1                  :1;
        unsigned HARD2                  :1;
        unsigned HADR3                  :1;
        unsigned HADR4                  :1;
        unsigned HADR5                  :1;
        unsigned HADR6                  :1;
        unsigned HADR7                  :1;
    };
    struct {
        unsigned SCANHADR               :8;
    };
    struct {
        unsigned SCANHADR0              :1;
        unsigned SCANHADR1              :1;
        unsigned SCANHADR2              :1;
        unsigned SCANHADR3              :1;
        unsigned SCANHADR4              :1;
        unsigned SCANHADR5              :1;
        unsigned SCANHADR6              :1;
        unsigned SCANHADR7              :1;
    };
} SCANHADRLbits_t;
extern volatile SCANHADRLbits_t SCANHADRLbits @ 0x71A;
// bitfield macros
#define _SCANHADRL_HADR_POSN                                0x0
#define _SCANHADRL_HADR_POSITION                            0x0
#define _SCANHADRL_HADR_SIZE                                0x8
#define _SCANHADRL_HADR_LENGTH                              0x8
#define _SCANHADRL_HADR_MASK                                0xFF
#define _SCANHADRL_HADR0_POSN                               0x0
#define _SCANHADRL_HADR0_POSITION                           0x0
#define _SCANHADRL_HADR0_SIZE                               0x1
#define _SCANHADRL_HADR0_LENGTH                             0x1
#define _SCANHADRL_HADR0_MASK                               0x1
#define _SCANHADRL_HADR1_POSN                               0x1
#define _SCANHADRL_HADR1_POSITION                           0x1
#define _SCANHADRL_HADR1_SIZE                               0x1
#define _SCANHADRL_HADR1_LENGTH                             0x1
#define _SCANHADRL_HADR1_MASK                               0x2
#define _SCANHADRL_HARD2_POSN                               0x2
#define _SCANHADRL_HARD2_POSITION                           0x2
#define _SCANHADRL_HARD2_SIZE                               0x1
#define _SCANHADRL_HARD2_LENGTH                             0x1
#define _SCANHADRL_HARD2_MASK                               0x4
#define _SCANHADRL_HADR3_POSN                               0x3
#define _SCANHADRL_HADR3_POSITION                           0x3
#define _SCANHADRL_HADR3_SIZE                               0x1
#define _SCANHADRL_HADR3_LENGTH                             0x1
#define _SCANHADRL_HADR3_MASK                               0x8
#define _SCANHADRL_HADR4_POSN                               0x4
#define _SCANHADRL_HADR4_POSITION                           0x4
#define _SCANHADRL_HADR4_SIZE                               0x1
#define _SCANHADRL_HADR4_LENGTH                             0x1
#define _SCANHADRL_HADR4_MASK                               0x10
#define _SCANHADRL_HADR5_POSN                               0x5
#define _SCANHADRL_HADR5_POSITION                           0x5
#define _SCANHADRL_HADR5_SIZE                               0x1
#define _SCANHADRL_HADR5_LENGTH                             0x1
#define _SCANHADRL_HADR5_MASK                               0x20
#define _SCANHADRL_HADR6_POSN                               0x6
#define _SCANHADRL_HADR6_POSITION                           0x6
#define _SCANHADRL_HADR6_SIZE                               0x1
#define _SCANHADRL_HADR6_LENGTH                             0x1
#define _SCANHADRL_HADR6_MASK                               0x40
#define _SCANHADRL_HADR7_POSN                               0x7
#define _SCANHADRL_HADR7_POSITION                           0x7
#define _SCANHADRL_HADR7_SIZE                               0x1
#define _SCANHADRL_HADR7_LENGTH                             0x1
#define _SCANHADRL_HADR7_MASK                               0x80
#define _SCANHADRL_SCANHADR_POSN                            0x0
#define _SCANHADRL_SCANHADR_POSITION                        0x0
#define _SCANHADRL_SCANHADR_SIZE                            0x8
#define _SCANHADRL_SCANHADR_LENGTH                          0x8
#define _SCANHADRL_SCANHADR_MASK                            0xFF
#define _SCANHADRL_SCANHADR0_POSN                           0x0
#define _SCANHADRL_SCANHADR0_POSITION                       0x0
#define _SCANHADRL_SCANHADR0_SIZE                           0x1
#define _SCANHADRL_SCANHADR0_LENGTH                         0x1
#define _SCANHADRL_SCANHADR0_MASK                           0x1
#define _SCANHADRL_SCANHADR1_POSN                           0x1
#define _SCANHADRL_SCANHADR1_POSITION                       0x1
#define _SCANHADRL_SCANHADR1_SIZE                           0x1
#define _SCANHADRL_SCANHADR1_LENGTH                         0x1
#define _SCANHADRL_SCANHADR1_MASK                           0x2
#define _SCANHADRL_SCANHADR2_POSN                           0x2
#define _SCANHADRL_SCANHADR2_POSITION                       0x2
#define _SCANHADRL_SCANHADR2_SIZE                           0x1
#define _SCANHADRL_SCANHADR2_LENGTH                         0x1
#define _SCANHADRL_SCANHADR2_MASK                           0x4
#define _SCANHADRL_SCANHADR3_POSN                           0x3
#define _SCANHADRL_SCANHADR3_POSITION                       0x3
#define _SCANHADRL_SCANHADR3_SIZE                           0x1
#define _SCANHADRL_SCANHADR3_LENGTH                         0x1
#define _SCANHADRL_SCANHADR3_MASK                           0x8
#define _SCANHADRL_SCANHADR4_POSN                           0x4
#define _SCANHADRL_SCANHADR4_POSITION                       0x4
#define _SCANHADRL_SCANHADR4_SIZE                           0x1
#define _SCANHADRL_SCANHADR4_LENGTH                         0x1
#define _SCANHADRL_SCANHADR4_MASK                           0x10
#define _SCANHADRL_SCANHADR5_POSN                           0x5
#define _SCANHADRL_SCANHADR5_POSITION                       0x5
#define _SCANHADRL_SCANHADR5_SIZE                           0x1
#define _SCANHADRL_SCANHADR5_LENGTH                         0x1
#define _SCANHADRL_SCANHADR5_MASK                           0x20
#define _SCANHADRL_SCANHADR6_POSN                           0x6
#define _SCANHADRL_SCANHADR6_POSITION                       0x6
#define _SCANHADRL_SCANHADR6_SIZE                           0x1
#define _SCANHADRL_SCANHADR6_LENGTH                         0x1
#define _SCANHADRL_SCANHADR6_MASK                           0x40
#define _SCANHADRL_SCANHADR7_POSN                           0x7
#define _SCANHADRL_SCANHADR7_POSITION                       0x7
#define _SCANHADRL_SCANHADR7_SIZE                           0x1
#define _SCANHADRL_SCANHADR7_LENGTH                         0x1
#define _SCANHADRL_SCANHADR7_MASK                           0x80

// Register: SCANHADRH
extern volatile unsigned char           SCANHADRH           @ 0x71B;
#ifndef _LIB_BUILD
asm("SCANHADRH equ 071Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned HADR                   :8;
    };
    struct {
        unsigned HADR8                  :1;
        unsigned HADR9                  :1;
        unsigned HADR10                 :1;
        unsigned HADR11                 :1;
        unsigned HADR12                 :1;
        unsigned HADR13                 :1;
        unsigned HADR14                 :1;
        unsigned HADR15                 :1;
    };
    struct {
        unsigned SCANHADR               :8;
    };
    struct {
        unsigned SCANHADR8              :1;
        unsigned SCANHADR9              :1;
        unsigned SCANHADR10             :1;
        unsigned SCANHADR11             :1;
        unsigned SCANHADR12             :1;
        unsigned SCANHADR13             :1;
        unsigned SCANHADR14             :1;
        unsigned SCANHADR15             :1;
    };
} SCANHADRHbits_t;
extern volatile SCANHADRHbits_t SCANHADRHbits @ 0x71B;
// bitfield macros
#define _SCANHADRH_HADR_POSN                                0x0
#define _SCANHADRH_HADR_POSITION                            0x0
#define _SCANHADRH_HADR_SIZE                                0x8
#define _SCANHADRH_HADR_LENGTH                              0x8
#define _SCANHADRH_HADR_MASK                                0xFF
#define _SCANHADRH_HADR8_POSN                               0x0
#define _SCANHADRH_HADR8_POSITION                           0x0
#define _SCANHADRH_HADR8_SIZE                               0x1
#define _SCANHADRH_HADR8_LENGTH                             0x1
#define _SCANHADRH_HADR8_MASK                               0x1
#define _SCANHADRH_HADR9_POSN                               0x1
#define _SCANHADRH_HADR9_POSITION                           0x1
#define _SCANHADRH_HADR9_SIZE                               0x1
#define _SCANHADRH_HADR9_LENGTH                             0x1
#define _SCANHADRH_HADR9_MASK                               0x2
#define _SCANHADRH_HADR10_POSN                              0x2
#define _SCANHADRH_HADR10_POSITION                          0x2
#define _SCANHADRH_HADR10_SIZE                              0x1
#define _SCANHADRH_HADR10_LENGTH                            0x1
#define _SCANHADRH_HADR10_MASK                              0x4
#define _SCANHADRH_HADR11_POSN                              0x3
#define _SCANHADRH_HADR11_POSITION                          0x3
#define _SCANHADRH_HADR11_SIZE                              0x1
#define _SCANHADRH_HADR11_LENGTH                            0x1
#define _SCANHADRH_HADR11_MASK                              0x8
#define _SCANHADRH_HADR12_POSN                              0x4
#define _SCANHADRH_HADR12_POSITION                          0x4
#define _SCANHADRH_HADR12_SIZE                              0x1
#define _SCANHADRH_HADR12_LENGTH                            0x1
#define _SCANHADRH_HADR12_MASK                              0x10
#define _SCANHADRH_HADR13_POSN                              0x5
#define _SCANHADRH_HADR13_POSITION                          0x5
#define _SCANHADRH_HADR13_SIZE                              0x1
#define _SCANHADRH_HADR13_LENGTH                            0x1
#define _SCANHADRH_HADR13_MASK                              0x20
#define _SCANHADRH_HADR14_POSN                              0x6
#define _SCANHADRH_HADR14_POSITION                          0x6
#define _SCANHADRH_HADR14_SIZE                              0x1
#define _SCANHADRH_HADR14_LENGTH                            0x1
#define _SCANHADRH_HADR14_MASK                              0x40
#define _SCANHADRH_HADR15_POSN                              0x7
#define _SCANHADRH_HADR15_POSITION                          0x7
#define _SCANHADRH_HADR15_SIZE                              0x1
#define _SCANHADRH_HADR15_LENGTH                            0x1
#define _SCANHADRH_HADR15_MASK                              0x80
#define _SCANHADRH_SCANHADR_POSN                            0x0
#define _SCANHADRH_SCANHADR_POSITION                        0x0
#define _SCANHADRH_SCANHADR_SIZE                            0x8
#define _SCANHADRH_SCANHADR_LENGTH                          0x8
#define _SCANHADRH_SCANHADR_MASK                            0xFF
#define _SCANHADRH_SCANHADR8_POSN                           0x0
#define _SCANHADRH_SCANHADR8_POSITION                       0x0
#define _SCANHADRH_SCANHADR8_SIZE                           0x1
#define _SCANHADRH_SCANHADR8_LENGTH                         0x1
#define _SCANHADRH_SCANHADR8_MASK                           0x1
#define _SCANHADRH_SCANHADR9_POSN                           0x1
#define _SCANHADRH_SCANHADR9_POSITION                       0x1
#define _SCANHADRH_SCANHADR9_SIZE                           0x1
#define _SCANHADRH_SCANHADR9_LENGTH                         0x1
#define _SCANHADRH_SCANHADR9_MASK                           0x2
#define _SCANHADRH_SCANHADR10_POSN                          0x2
#define _SCANHADRH_SCANHADR10_POSITION                      0x2
#define _SCANHADRH_SCANHADR10_SIZE                          0x1
#define _SCANHADRH_SCANHADR10_LENGTH                        0x1
#define _SCANHADRH_SCANHADR10_MASK                          0x4
#define _SCANHADRH_SCANHADR11_POSN                          0x3
#define _SCANHADRH_SCANHADR11_POSITION                      0x3
#define _SCANHADRH_SCANHADR11_SIZE                          0x1
#define _SCANHADRH_SCANHADR11_LENGTH                        0x1
#define _SCANHADRH_SCANHADR11_MASK                          0x8
#define _SCANHADRH_SCANHADR12_POSN                          0x4
#define _SCANHADRH_SCANHADR12_POSITION                      0x4
#define _SCANHADRH_SCANHADR12_SIZE                          0x1
#define _SCANHADRH_SCANHADR12_LENGTH                        0x1
#define _SCANHADRH_SCANHADR12_MASK                          0x10
#define _SCANHADRH_SCANHADR13_POSN                          0x5
#define _SCANHADRH_SCANHADR13_POSITION                      0x5
#define _SCANHADRH_SCANHADR13_SIZE                          0x1
#define _SCANHADRH_SCANHADR13_LENGTH                        0x1
#define _SCANHADRH_SCANHADR13_MASK                          0x20
#define _SCANHADRH_SCANHADR14_POSN                          0x6
#define _SCANHADRH_SCANHADR14_POSITION                      0x6
#define _SCANHADRH_SCANHADR14_SIZE                          0x1
#define _SCANHADRH_SCANHADR14_LENGTH                        0x1
#define _SCANHADRH_SCANHADR14_MASK                          0x40
#define _SCANHADRH_SCANHADR15_POSN                          0x7
#define _SCANHADRH_SCANHADR15_POSITION                      0x7
#define _SCANHADRH_SCANHADR15_SIZE                          0x1
#define _SCANHADRH_SCANHADR15_LENGTH                        0x1
#define _SCANHADRH_SCANHADR15_MASK                          0x80

// Register: SCANCON0
extern volatile unsigned char           SCANCON0            @ 0x71C;
#ifndef _LIB_BUILD
asm("SCANCON0 equ 071Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned MODE                   :2;
        unsigned                        :1;
        unsigned INTM                   :1;
        unsigned INVALID                :1;
        unsigned BUSY                   :1;
        unsigned SCANGO                 :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
    };
    struct {
        unsigned SCANMODE               :2;
        unsigned                        :1;
        unsigned SCANINTM               :1;
        unsigned SCANINVALID            :1;
        unsigned SCANBUSY               :1;
        unsigned                        :1;
        unsigned SCANEN                 :1;
    };
    struct {
        unsigned SCANMODE0              :1;
        unsigned SCANMODE1              :1;
    };
} SCANCON0bits_t;
extern volatile SCANCON0bits_t SCANCON0bits @ 0x71C;
// bitfield macros
#define _SCANCON0_MODE_POSN                                 0x0
#define _SCANCON0_MODE_POSITION                             0x0
#define _SCANCON0_MODE_SIZE                                 0x2
#define _SCANCON0_MODE_LENGTH                               0x2
#define _SCANCON0_MODE_MASK                                 0x3
#define _SCANCON0_INTM_POSN                                 0x3
#define _SCANCON0_INTM_POSITION                             0x3
#define _SCANCON0_INTM_SIZE                                 0x1
#define _SCANCON0_INTM_LENGTH                               0x1
#define _SCANCON0_INTM_MASK                                 0x8
#define _SCANCON0_INVALID_POSN                              0x4
#define _SCANCON0_INVALID_POSITION                          0x4
#define _SCANCON0_INVALID_SIZE                              0x1
#define _SCANCON0_INVALID_LENGTH                            0x1
#define _SCANCON0_INVALID_MASK                              0x10
#define _SCANCON0_BUSY_POSN                                 0x5
#define _SCANCON0_BUSY_POSITION                             0x5
#define _SCANCON0_BUSY_SIZE                                 0x1
#define _SCANCON0_BUSY_LENGTH                               0x1
#define _SCANCON0_BUSY_MASK                                 0x20
#define _SCANCON0_SCANGO_POSN                               0x6
#define _SCANCON0_SCANGO_POSITION                           0x6
#define _SCANCON0_SCANGO_SIZE                               0x1
#define _SCANCON0_SCANGO_LENGTH                             0x1
#define _SCANCON0_SCANGO_MASK                               0x40
#define _SCANCON0_EN_POSN                                   0x7
#define _SCANCON0_EN_POSITION                               0x7
#define _SCANCON0_EN_SIZE                                   0x1
#define _SCANCON0_EN_LENGTH                                 0x1
#define _SCANCON0_EN_MASK                                   0x80
#define _SCANCON0_MODE0_POSN                                0x0
#define _SCANCON0_MODE0_POSITION                            0x0
#define _SCANCON0_MODE0_SIZE                                0x1
#define _SCANCON0_MODE0_LENGTH                              0x1
#define _SCANCON0_MODE0_MASK                                0x1
#define _SCANCON0_MODE1_POSN                                0x1
#define _SCANCON0_MODE1_POSITION                            0x1
#define _SCANCON0_MODE1_SIZE                                0x1
#define _SCANCON0_MODE1_LENGTH                              0x1
#define _SCANCON0_MODE1_MASK                                0x2
#define _SCANCON0_SCANMODE_POSN                             0x0
#define _SCANCON0_SCANMODE_POSITION                         0x0
#define _SCANCON0_SCANMODE_SIZE                             0x2
#define _SCANCON0_SCANMODE_LENGTH                           0x2
#define _SCANCON0_SCANMODE_MASK                             0x3
#define _SCANCON0_SCANINTM_POSN                             0x3
#define _SCANCON0_SCANINTM_POSITION                         0x3
#define _SCANCON0_SCANINTM_SIZE                             0x1
#define _SCANCON0_SCANINTM_LENGTH                           0x1
#define _SCANCON0_SCANINTM_MASK                             0x8
#define _SCANCON0_SCANINVALID_POSN                          0x4
#define _SCANCON0_SCANINVALID_POSITION                      0x4
#define _SCANCON0_SCANINVALID_SIZE                          0x1
#define _SCANCON0_SCANINVALID_LENGTH                        0x1
#define _SCANCON0_SCANINVALID_MASK                          0x10
#define _SCANCON0_SCANBUSY_POSN                             0x5
#define _SCANCON0_SCANBUSY_POSITION                         0x5
#define _SCANCON0_SCANBUSY_SIZE                             0x1
#define _SCANCON0_SCANBUSY_LENGTH                           0x1
#define _SCANCON0_SCANBUSY_MASK                             0x20
#define _SCANCON0_SCANEN_POSN                               0x7
#define _SCANCON0_SCANEN_POSITION                           0x7
#define _SCANCON0_SCANEN_SIZE                               0x1
#define _SCANCON0_SCANEN_LENGTH                             0x1
#define _SCANCON0_SCANEN_MASK                               0x80
#define _SCANCON0_SCANMODE0_POSN                            0x0
#define _SCANCON0_SCANMODE0_POSITION                        0x0
#define _SCANCON0_SCANMODE0_SIZE                            0x1
#define _SCANCON0_SCANMODE0_LENGTH                          0x1
#define _SCANCON0_SCANMODE0_MASK                            0x1
#define _SCANCON0_SCANMODE1_POSN                            0x1
#define _SCANCON0_SCANMODE1_POSITION                        0x1
#define _SCANCON0_SCANMODE1_SIZE                            0x1
#define _SCANCON0_SCANMODE1_LENGTH                          0x1
#define _SCANCON0_SCANMODE1_MASK                            0x2

// Register: SCANTRIG
extern volatile unsigned char           SCANTRIG            @ 0x71D;
#ifndef _LIB_BUILD
asm("SCANTRIG equ 071Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TSEL                   :8;
    };
    struct {
        unsigned TSEL0                  :1;
        unsigned TSEL1                  :1;
        unsigned TSEL2                  :1;
        unsigned TSEL3                  :1;
    };
    struct {
        unsigned SCANTSEL               :8;
    };
    struct {
        unsigned SCANTSEL0              :1;
        unsigned SCANTSEL1              :1;
        unsigned SCANTSEL2              :1;
        unsigned SCANTSEL3              :1;
    };
} SCANTRIGbits_t;
extern volatile SCANTRIGbits_t SCANTRIGbits @ 0x71D;
// bitfield macros
#define _SCANTRIG_TSEL_POSN                                 0x0
#define _SCANTRIG_TSEL_POSITION                             0x0
#define _SCANTRIG_TSEL_SIZE                                 0x8
#define _SCANTRIG_TSEL_LENGTH                               0x8
#define _SCANTRIG_TSEL_MASK                                 0xFF
#define _SCANTRIG_TSEL0_POSN                                0x0
#define _SCANTRIG_TSEL0_POSITION                            0x0
#define _SCANTRIG_TSEL0_SIZE                                0x1
#define _SCANTRIG_TSEL0_LENGTH                              0x1
#define _SCANTRIG_TSEL0_MASK                                0x1
#define _SCANTRIG_TSEL1_POSN                                0x1
#define _SCANTRIG_TSEL1_POSITION                            0x1
#define _SCANTRIG_TSEL1_SIZE                                0x1
#define _SCANTRIG_TSEL1_LENGTH                              0x1
#define _SCANTRIG_TSEL1_MASK                                0x2
#define _SCANTRIG_TSEL2_POSN                                0x2
#define _SCANTRIG_TSEL2_POSITION                            0x2
#define _SCANTRIG_TSEL2_SIZE                                0x1
#define _SCANTRIG_TSEL2_LENGTH                              0x1
#define _SCANTRIG_TSEL2_MASK                                0x4
#define _SCANTRIG_TSEL3_POSN                                0x3
#define _SCANTRIG_TSEL3_POSITION                            0x3
#define _SCANTRIG_TSEL3_SIZE                                0x1
#define _SCANTRIG_TSEL3_LENGTH                              0x1
#define _SCANTRIG_TSEL3_MASK                                0x8
#define _SCANTRIG_SCANTSEL_POSN                             0x0
#define _SCANTRIG_SCANTSEL_POSITION                         0x0
#define _SCANTRIG_SCANTSEL_SIZE                             0x8
#define _SCANTRIG_SCANTSEL_LENGTH                           0x8
#define _SCANTRIG_SCANTSEL_MASK                             0xFF
#define _SCANTRIG_SCANTSEL0_POSN                            0x0
#define _SCANTRIG_SCANTSEL0_POSITION                        0x0
#define _SCANTRIG_SCANTSEL0_SIZE                            0x1
#define _SCANTRIG_SCANTSEL0_LENGTH                          0x1
#define _SCANTRIG_SCANTSEL0_MASK                            0x1
#define _SCANTRIG_SCANTSEL1_POSN                            0x1
#define _SCANTRIG_SCANTSEL1_POSITION                        0x1
#define _SCANTRIG_SCANTSEL1_SIZE                            0x1
#define _SCANTRIG_SCANTSEL1_LENGTH                          0x1
#define _SCANTRIG_SCANTSEL1_MASK                            0x2
#define _SCANTRIG_SCANTSEL2_POSN                            0x2
#define _SCANTRIG_SCANTSEL2_POSITION                        0x2
#define _SCANTRIG_SCANTSEL2_SIZE                            0x1
#define _SCANTRIG_SCANTSEL2_LENGTH                          0x1
#define _SCANTRIG_SCANTSEL2_MASK                            0x4
#define _SCANTRIG_SCANTSEL3_POSN                            0x3
#define _SCANTRIG_SCANTSEL3_POSITION                        0x3
#define _SCANTRIG_SCANTSEL3_SIZE                            0x1
#define _SCANTRIG_SCANTSEL3_LENGTH                          0x1
#define _SCANTRIG_SCANTSEL3_MASK                            0x8

// Register: CRCDAT
extern volatile unsigned short          CRCDAT              @ 0x791;
#ifndef _LIB_BUILD
asm("CRCDAT equ 0791h");
#endif

// Register: CRCDATL
extern volatile unsigned char           CRCDATL             @ 0x791;
#ifndef _LIB_BUILD
asm("CRCDATL equ 0791h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned DAT                    :8;
    };
    struct {
        unsigned DAT0                   :1;
        unsigned DAT1                   :1;
        unsigned DAT2                   :1;
        unsigned DAT3                   :1;
        unsigned DAT4                   :1;
        unsigned DAT5                   :1;
        unsigned DAT6                   :1;
        unsigned DAT7                   :1;
    };
    struct {
        unsigned CRCDAT                 :8;
    };
    struct {
        unsigned CRCDAT0                :1;
        unsigned CRCDAT1                :1;
        unsigned CRCDAT2                :1;
        unsigned CRCDAT3                :1;
        unsigned CRCDAT4                :1;
        unsigned CRCDAT5                :1;
        unsigned CRCDAT6                :1;
        unsigned CRDCDAT7               :1;
    };
} CRCDATLbits_t;
extern volatile CRCDATLbits_t CRCDATLbits @ 0x791;
// bitfield macros
#define _CRCDATL_DAT_POSN                                   0x0
#define _CRCDATL_DAT_POSITION                               0x0
#define _CRCDATL_DAT_SIZE                                   0x8
#define _CRCDATL_DAT_LENGTH                                 0x8
#define _CRCDATL_DAT_MASK                                   0xFF
#define _CRCDATL_DAT0_POSN                                  0x0
#define _CRCDATL_DAT0_POSITION                              0x0
#define _CRCDATL_DAT0_SIZE                                  0x1
#define _CRCDATL_DAT0_LENGTH                                0x1
#define _CRCDATL_DAT0_MASK                                  0x1
#define _CRCDATL_DAT1_POSN                                  0x1
#define _CRCDATL_DAT1_POSITION                              0x1
#define _CRCDATL_DAT1_SIZE                                  0x1
#define _CRCDATL_DAT1_LENGTH                                0x1
#define _CRCDATL_DAT1_MASK                                  0x2
#define _CRCDATL_DAT2_POSN                                  0x2
#define _CRCDATL_DAT2_POSITION                              0x2
#define _CRCDATL_DAT2_SIZE                                  0x1
#define _CRCDATL_DAT2_LENGTH                                0x1
#define _CRCDATL_DAT2_MASK                                  0x4
#define _CRCDATL_DAT3_POSN                                  0x3
#define _CRCDATL_DAT3_POSITION                              0x3
#define _CRCDATL_DAT3_SIZE                                  0x1
#define _CRCDATL_DAT3_LENGTH                                0x1
#define _CRCDATL_DAT3_MASK                                  0x8
#define _CRCDATL_DAT4_POSN                                  0x4
#define _CRCDATL_DAT4_POSITION                              0x4
#define _CRCDATL_DAT4_SIZE                                  0x1
#define _CRCDATL_DAT4_LENGTH                                0x1
#define _CRCDATL_DAT4_MASK                                  0x10
#define _CRCDATL_DAT5_POSN                                  0x5
#define _CRCDATL_DAT5_POSITION                              0x5
#define _CRCDATL_DAT5_SIZE                                  0x1
#define _CRCDATL_DAT5_LENGTH                                0x1
#define _CRCDATL_DAT5_MASK                                  0x20
#define _CRCDATL_DAT6_POSN                                  0x6
#define _CRCDATL_DAT6_POSITION                              0x6
#define _CRCDATL_DAT6_SIZE                                  0x1
#define _CRCDATL_DAT6_LENGTH                                0x1
#define _CRCDATL_DAT6_MASK                                  0x40
#define _CRCDATL_DAT7_POSN                                  0x7
#define _CRCDATL_DAT7_POSITION                              0x7
#define _CRCDATL_DAT7_SIZE                                  0x1
#define _CRCDATL_DAT7_LENGTH                                0x1
#define _CRCDATL_DAT7_MASK                                  0x80
#define _CRCDATL_CRCDAT_POSN                                0x0
#define _CRCDATL_CRCDAT_POSITION                            0x0
#define _CRCDATL_CRCDAT_SIZE                                0x8
#define _CRCDATL_CRCDAT_LENGTH                              0x8
#define _CRCDATL_CRCDAT_MASK                                0xFF
#define _CRCDATL_CRCDAT0_POSN                               0x0
#define _CRCDATL_CRCDAT0_POSITION                           0x0
#define _CRCDATL_CRCDAT0_SIZE                               0x1
#define _CRCDATL_CRCDAT0_LENGTH                             0x1
#define _CRCDATL_CRCDAT0_MASK                               0x1
#define _CRCDATL_CRCDAT1_POSN                               0x1
#define _CRCDATL_CRCDAT1_POSITION                           0x1
#define _CRCDATL_CRCDAT1_SIZE                               0x1
#define _CRCDATL_CRCDAT1_LENGTH                             0x1
#define _CRCDATL_CRCDAT1_MASK                               0x2
#define _CRCDATL_CRCDAT2_POSN                               0x2
#define _CRCDATL_CRCDAT2_POSITION                           0x2
#define _CRCDATL_CRCDAT2_SIZE                               0x1
#define _CRCDATL_CRCDAT2_LENGTH                             0x1
#define _CRCDATL_CRCDAT2_MASK                               0x4
#define _CRCDATL_CRCDAT3_POSN                               0x3
#define _CRCDATL_CRCDAT3_POSITION                           0x3
#define _CRCDATL_CRCDAT3_SIZE                               0x1
#define _CRCDATL_CRCDAT3_LENGTH                             0x1
#define _CRCDATL_CRCDAT3_MASK                               0x8
#define _CRCDATL_CRCDAT4_POSN                               0x4
#define _CRCDATL_CRCDAT4_POSITION                           0x4
#define _CRCDATL_CRCDAT4_SIZE                               0x1
#define _CRCDATL_CRCDAT4_LENGTH                             0x1
#define _CRCDATL_CRCDAT4_MASK                               0x10
#define _CRCDATL_CRCDAT5_POSN                               0x5
#define _CRCDATL_CRCDAT5_POSITION                           0x5
#define _CRCDATL_CRCDAT5_SIZE                               0x1
#define _CRCDATL_CRCDAT5_LENGTH                             0x1
#define _CRCDATL_CRCDAT5_MASK                               0x20
#define _CRCDATL_CRCDAT6_POSN                               0x6
#define _CRCDATL_CRCDAT6_POSITION                           0x6
#define _CRCDATL_CRCDAT6_SIZE                               0x1
#define _CRCDATL_CRCDAT6_LENGTH                             0x1
#define _CRCDATL_CRCDAT6_MASK                               0x40
#define _CRCDATL_CRDCDAT7_POSN                              0x7
#define _CRCDATL_CRDCDAT7_POSITION                          0x7
#define _CRCDATL_CRDCDAT7_SIZE                              0x1
#define _CRCDATL_CRDCDAT7_LENGTH                            0x1
#define _CRCDATL_CRDCDAT7_MASK                              0x80

// Register: CRCDATH
extern volatile unsigned char           CRCDATH             @ 0x792;
#ifndef _LIB_BUILD
asm("CRCDATH equ 0792h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned DAT                    :8;
    };
    struct {
        unsigned DAT8                   :1;
        unsigned DAT9                   :1;
        unsigned DAT10                  :1;
        unsigned DAT11                  :1;
        unsigned DAT12                  :1;
        unsigned DAT13                  :1;
        unsigned DAT14                  :1;
        unsigned DAT15                  :1;
    };
    struct {
        unsigned CRCDAT                 :8;
    };
    struct {
        unsigned CRCDAT8                :1;
        unsigned CRCDAT9                :1;
        unsigned CRCDAT10               :1;
        unsigned CRCDAT11               :1;
        unsigned CRCDAT12               :1;
        unsigned CRCDAT13               :1;
        unsigned CRCDAT14               :1;
        unsigned CRCDAT15               :1;
    };
} CRCDATHbits_t;
extern volatile CRCDATHbits_t CRCDATHbits @ 0x792;
// bitfield macros
#define _CRCDATH_DAT_POSN                                   0x0
#define _CRCDATH_DAT_POSITION                               0x0
#define _CRCDATH_DAT_SIZE                                   0x8
#define _CRCDATH_DAT_LENGTH                                 0x8
#define _CRCDATH_DAT_MASK                                   0xFF
#define _CRCDATH_DAT8_POSN                                  0x0
#define _CRCDATH_DAT8_POSITION                              0x0
#define _CRCDATH_DAT8_SIZE                                  0x1
#define _CRCDATH_DAT8_LENGTH                                0x1
#define _CRCDATH_DAT8_MASK                                  0x1
#define _CRCDATH_DAT9_POSN                                  0x1
#define _CRCDATH_DAT9_POSITION                              0x1
#define _CRCDATH_DAT9_SIZE                                  0x1
#define _CRCDATH_DAT9_LENGTH                                0x1
#define _CRCDATH_DAT9_MASK                                  0x2
#define _CRCDATH_DAT10_POSN                                 0x2
#define _CRCDATH_DAT10_POSITION                             0x2
#define _CRCDATH_DAT10_SIZE                                 0x1
#define _CRCDATH_DAT10_LENGTH                               0x1
#define _CRCDATH_DAT10_MASK                                 0x4
#define _CRCDATH_DAT11_POSN                                 0x3
#define _CRCDATH_DAT11_POSITION                             0x3
#define _CRCDATH_DAT11_SIZE                                 0x1
#define _CRCDATH_DAT11_LENGTH                               0x1
#define _CRCDATH_DAT11_MASK                                 0x8
#define _CRCDATH_DAT12_POSN                                 0x4
#define _CRCDATH_DAT12_POSITION                             0x4
#define _CRCDATH_DAT12_SIZE                                 0x1
#define _CRCDATH_DAT12_LENGTH                               0x1
#define _CRCDATH_DAT12_MASK                                 0x10
#define _CRCDATH_DAT13_POSN                                 0x5
#define _CRCDATH_DAT13_POSITION                             0x5
#define _CRCDATH_DAT13_SIZE                                 0x1
#define _CRCDATH_DAT13_LENGTH                               0x1
#define _CRCDATH_DAT13_MASK                                 0x20
#define _CRCDATH_DAT14_POSN                                 0x6
#define _CRCDATH_DAT14_POSITION                             0x6
#define _CRCDATH_DAT14_SIZE                                 0x1
#define _CRCDATH_DAT14_LENGTH                               0x1
#define _CRCDATH_DAT14_MASK                                 0x40
#define _CRCDATH_DAT15_POSN                                 0x7
#define _CRCDATH_DAT15_POSITION                             0x7
#define _CRCDATH_DAT15_SIZE                                 0x1
#define _CRCDATH_DAT15_LENGTH                               0x1
#define _CRCDATH_DAT15_MASK                                 0x80
#define _CRCDATH_CRCDAT_POSN                                0x0
#define _CRCDATH_CRCDAT_POSITION                            0x0
#define _CRCDATH_CRCDAT_SIZE                                0x8
#define _CRCDATH_CRCDAT_LENGTH                              0x8
#define _CRCDATH_CRCDAT_MASK                                0xFF
#define _CRCDATH_CRCDAT8_POSN                               0x0
#define _CRCDATH_CRCDAT8_POSITION                           0x0
#define _CRCDATH_CRCDAT8_SIZE                               0x1
#define _CRCDATH_CRCDAT8_LENGTH                             0x1
#define _CRCDATH_CRCDAT8_MASK                               0x1
#define _CRCDATH_CRCDAT9_POSN                               0x1
#define _CRCDATH_CRCDAT9_POSITION                           0x1
#define _CRCDATH_CRCDAT9_SIZE                               0x1
#define _CRCDATH_CRCDAT9_LENGTH                             0x1
#define _CRCDATH_CRCDAT9_MASK                               0x2
#define _CRCDATH_CRCDAT10_POSN                              0x2
#define _CRCDATH_CRCDAT10_POSITION                          0x2
#define _CRCDATH_CRCDAT10_SIZE                              0x1
#define _CRCDATH_CRCDAT10_LENGTH                            0x1
#define _CRCDATH_CRCDAT10_MASK                              0x4
#define _CRCDATH_CRCDAT11_POSN                              0x3
#define _CRCDATH_CRCDAT11_POSITION                          0x3
#define _CRCDATH_CRCDAT11_SIZE                              0x1
#define _CRCDATH_CRCDAT11_LENGTH                            0x1
#define _CRCDATH_CRCDAT11_MASK                              0x8
#define _CRCDATH_CRCDAT12_POSN                              0x4
#define _CRCDATH_CRCDAT12_POSITION                          0x4
#define _CRCDATH_CRCDAT12_SIZE                              0x1
#define _CRCDATH_CRCDAT12_LENGTH                            0x1
#define _CRCDATH_CRCDAT12_MASK                              0x10
#define _CRCDATH_CRCDAT13_POSN                              0x5
#define _CRCDATH_CRCDAT13_POSITION                          0x5
#define _CRCDATH_CRCDAT13_SIZE                              0x1
#define _CRCDATH_CRCDAT13_LENGTH                            0x1
#define _CRCDATH_CRCDAT13_MASK                              0x20
#define _CRCDATH_CRCDAT14_POSN                              0x6
#define _CRCDATH_CRCDAT14_POSITION                          0x6
#define _CRCDATH_CRCDAT14_SIZE                              0x1
#define _CRCDATH_CRCDAT14_LENGTH                            0x1
#define _CRCDATH_CRCDAT14_MASK                              0x40
#define _CRCDATH_CRCDAT15_POSN                              0x7
#define _CRCDATH_CRCDAT15_POSITION                          0x7
#define _CRCDATH_CRCDAT15_SIZE                              0x1
#define _CRCDATH_CRCDAT15_LENGTH                            0x1
#define _CRCDATH_CRCDAT15_MASK                              0x80

// Register: CRCACC
extern volatile unsigned short          CRCACC              @ 0x793;
#ifndef _LIB_BUILD
asm("CRCACC equ 0793h");
#endif

// Register: CRCACCL
extern volatile unsigned char           CRCACCL             @ 0x793;
#ifndef _LIB_BUILD
asm("CRCACCL equ 0793h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ACC                    :8;
    };
    struct {
        unsigned ACC0                   :1;
        unsigned ACC1                   :1;
        unsigned ACC2                   :1;
        unsigned ACC3                   :1;
        unsigned ACC4                   :1;
        unsigned ACC5                   :1;
        unsigned ACC6                   :1;
        unsigned ACC7                   :1;
    };
    struct {
        unsigned CRCACC                 :8;
    };
    struct {
        unsigned CRCACC0                :1;
        unsigned CRCACC1                :1;
        unsigned CRCACC2                :1;
        unsigned CRCACC3                :1;
        unsigned CRCACC4                :1;
        unsigned CRCACC5                :1;
        unsigned CRCACC6                :1;
        unsigned CRCACC7                :1;
    };
} CRCACCLbits_t;
extern volatile CRCACCLbits_t CRCACCLbits @ 0x793;
// bitfield macros
#define _CRCACCL_ACC_POSN                                   0x0
#define _CRCACCL_ACC_POSITION                               0x0
#define _CRCACCL_ACC_SIZE                                   0x8
#define _CRCACCL_ACC_LENGTH                                 0x8
#define _CRCACCL_ACC_MASK                                   0xFF
#define _CRCACCL_ACC0_POSN                                  0x0
#define _CRCACCL_ACC0_POSITION                              0x0
#define _CRCACCL_ACC0_SIZE                                  0x1
#define _CRCACCL_ACC0_LENGTH                                0x1
#define _CRCACCL_ACC0_MASK                                  0x1
#define _CRCACCL_ACC1_POSN                                  0x1
#define _CRCACCL_ACC1_POSITION                              0x1
#define _CRCACCL_ACC1_SIZE                                  0x1
#define _CRCACCL_ACC1_LENGTH                                0x1
#define _CRCACCL_ACC1_MASK                                  0x2
#define _CRCACCL_ACC2_POSN                                  0x2
#define _CRCACCL_ACC2_POSITION                              0x2
#define _CRCACCL_ACC2_SIZE                                  0x1
#define _CRCACCL_ACC2_LENGTH                                0x1
#define _CRCACCL_ACC2_MASK                                  0x4
#define _CRCACCL_ACC3_POSN                                  0x3
#define _CRCACCL_ACC3_POSITION                              0x3
#define _CRCACCL_ACC3_SIZE                                  0x1
#define _CRCACCL_ACC3_LENGTH                                0x1
#define _CRCACCL_ACC3_MASK                                  0x8
#define _CRCACCL_ACC4_POSN                                  0x4
#define _CRCACCL_ACC4_POSITION                              0x4
#define _CRCACCL_ACC4_SIZE                                  0x1
#define _CRCACCL_ACC4_LENGTH                                0x1
#define _CRCACCL_ACC4_MASK                                  0x10
#define _CRCACCL_ACC5_POSN                                  0x5
#define _CRCACCL_ACC5_POSITION                              0x5
#define _CRCACCL_ACC5_SIZE                                  0x1
#define _CRCACCL_ACC5_LENGTH                                0x1
#define _CRCACCL_ACC5_MASK                                  0x20
#define _CRCACCL_ACC6_POSN                                  0x6
#define _CRCACCL_ACC6_POSITION                              0x6
#define _CRCACCL_ACC6_SIZE                                  0x1
#define _CRCACCL_ACC6_LENGTH                                0x1
#define _CRCACCL_ACC6_MASK                                  0x40
#define _CRCACCL_ACC7_POSN                                  0x7
#define _CRCACCL_ACC7_POSITION                              0x7
#define _CRCACCL_ACC7_SIZE                                  0x1
#define _CRCACCL_ACC7_LENGTH                                0x1
#define _CRCACCL_ACC7_MASK                                  0x80
#define _CRCACCL_CRCACC_POSN                                0x0
#define _CRCACCL_CRCACC_POSITION                            0x0
#define _CRCACCL_CRCACC_SIZE                                0x8
#define _CRCACCL_CRCACC_LENGTH                              0x8
#define _CRCACCL_CRCACC_MASK                                0xFF
#define _CRCACCL_CRCACC0_POSN                               0x0
#define _CRCACCL_CRCACC0_POSITION                           0x0
#define _CRCACCL_CRCACC0_SIZE                               0x1
#define _CRCACCL_CRCACC0_LENGTH                             0x1
#define _CRCACCL_CRCACC0_MASK                               0x1
#define _CRCACCL_CRCACC1_POSN                               0x1
#define _CRCACCL_CRCACC1_POSITION                           0x1
#define _CRCACCL_CRCACC1_SIZE                               0x1
#define _CRCACCL_CRCACC1_LENGTH                             0x1
#define _CRCACCL_CRCACC1_MASK                               0x2
#define _CRCACCL_CRCACC2_POSN                               0x2
#define _CRCACCL_CRCACC2_POSITION                           0x2
#define _CRCACCL_CRCACC2_SIZE                               0x1
#define _CRCACCL_CRCACC2_LENGTH                             0x1
#define _CRCACCL_CRCACC2_MASK                               0x4
#define _CRCACCL_CRCACC3_POSN                               0x3
#define _CRCACCL_CRCACC3_POSITION                           0x3
#define _CRCACCL_CRCACC3_SIZE                               0x1
#define _CRCACCL_CRCACC3_LENGTH                             0x1
#define _CRCACCL_CRCACC3_MASK                               0x8
#define _CRCACCL_CRCACC4_POSN                               0x4
#define _CRCACCL_CRCACC4_POSITION                           0x4
#define _CRCACCL_CRCACC4_SIZE                               0x1
#define _CRCACCL_CRCACC4_LENGTH                             0x1
#define _CRCACCL_CRCACC4_MASK                               0x10
#define _CRCACCL_CRCACC5_POSN                               0x5
#define _CRCACCL_CRCACC5_POSITION                           0x5
#define _CRCACCL_CRCACC5_SIZE                               0x1
#define _CRCACCL_CRCACC5_LENGTH                             0x1
#define _CRCACCL_CRCACC5_MASK                               0x20
#define _CRCACCL_CRCACC6_POSN                               0x6
#define _CRCACCL_CRCACC6_POSITION                           0x6
#define _CRCACCL_CRCACC6_SIZE                               0x1
#define _CRCACCL_CRCACC6_LENGTH                             0x1
#define _CRCACCL_CRCACC6_MASK                               0x40
#define _CRCACCL_CRCACC7_POSN                               0x7
#define _CRCACCL_CRCACC7_POSITION                           0x7
#define _CRCACCL_CRCACC7_SIZE                               0x1
#define _CRCACCL_CRCACC7_LENGTH                             0x1
#define _CRCACCL_CRCACC7_MASK                               0x80

// Register: CRCACCH
extern volatile unsigned char           CRCACCH             @ 0x794;
#ifndef _LIB_BUILD
asm("CRCACCH equ 0794h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ACC                    :8;
    };
    struct {
        unsigned ACC8                   :1;
        unsigned ACC9                   :1;
        unsigned ACC10                  :1;
        unsigned ACC11                  :1;
        unsigned ACC12                  :1;
        unsigned ACC13                  :1;
        unsigned ACC14                  :1;
        unsigned ACC15                  :1;
    };
    struct {
        unsigned CRCACC                 :8;
    };
    struct {
        unsigned CRCACC8                :1;
        unsigned CRCACC9                :1;
        unsigned CRCACC10               :1;
        unsigned CRCACC11               :1;
        unsigned CRCACC12               :1;
        unsigned CRCACC13               :1;
        unsigned CRCACC14               :1;
        unsigned CRCACC15               :1;
    };
} CRCACCHbits_t;
extern volatile CRCACCHbits_t CRCACCHbits @ 0x794;
// bitfield macros
#define _CRCACCH_ACC_POSN                                   0x0
#define _CRCACCH_ACC_POSITION                               0x0
#define _CRCACCH_ACC_SIZE                                   0x8
#define _CRCACCH_ACC_LENGTH                                 0x8
#define _CRCACCH_ACC_MASK                                   0xFF
#define _CRCACCH_ACC8_POSN                                  0x0
#define _CRCACCH_ACC8_POSITION                              0x0
#define _CRCACCH_ACC8_SIZE                                  0x1
#define _CRCACCH_ACC8_LENGTH                                0x1
#define _CRCACCH_ACC8_MASK                                  0x1
#define _CRCACCH_ACC9_POSN                                  0x1
#define _CRCACCH_ACC9_POSITION                              0x1
#define _CRCACCH_ACC9_SIZE                                  0x1
#define _CRCACCH_ACC9_LENGTH                                0x1
#define _CRCACCH_ACC9_MASK                                  0x2
#define _CRCACCH_ACC10_POSN                                 0x2
#define _CRCACCH_ACC10_POSITION                             0x2
#define _CRCACCH_ACC10_SIZE                                 0x1
#define _CRCACCH_ACC10_LENGTH                               0x1
#define _CRCACCH_ACC10_MASK                                 0x4
#define _CRCACCH_ACC11_POSN                                 0x3
#define _CRCACCH_ACC11_POSITION                             0x3
#define _CRCACCH_ACC11_SIZE                                 0x1
#define _CRCACCH_ACC11_LENGTH                               0x1
#define _CRCACCH_ACC11_MASK                                 0x8
#define _CRCACCH_ACC12_POSN                                 0x4
#define _CRCACCH_ACC12_POSITION                             0x4
#define _CRCACCH_ACC12_SIZE                                 0x1
#define _CRCACCH_ACC12_LENGTH                               0x1
#define _CRCACCH_ACC12_MASK                                 0x10
#define _CRCACCH_ACC13_POSN                                 0x5
#define _CRCACCH_ACC13_POSITION                             0x5
#define _CRCACCH_ACC13_SIZE                                 0x1
#define _CRCACCH_ACC13_LENGTH                               0x1
#define _CRCACCH_ACC13_MASK                                 0x20
#define _CRCACCH_ACC14_POSN                                 0x6
#define _CRCACCH_ACC14_POSITION                             0x6
#define _CRCACCH_ACC14_SIZE                                 0x1
#define _CRCACCH_ACC14_LENGTH                               0x1
#define _CRCACCH_ACC14_MASK                                 0x40
#define _CRCACCH_ACC15_POSN                                 0x7
#define _CRCACCH_ACC15_POSITION                             0x7
#define _CRCACCH_ACC15_SIZE                                 0x1
#define _CRCACCH_ACC15_LENGTH                               0x1
#define _CRCACCH_ACC15_MASK                                 0x80
#define _CRCACCH_CRCACC_POSN                                0x0
#define _CRCACCH_CRCACC_POSITION                            0x0
#define _CRCACCH_CRCACC_SIZE                                0x8
#define _CRCACCH_CRCACC_LENGTH                              0x8
#define _CRCACCH_CRCACC_MASK                                0xFF
#define _CRCACCH_CRCACC8_POSN                               0x0
#define _CRCACCH_CRCACC8_POSITION                           0x0
#define _CRCACCH_CRCACC8_SIZE                               0x1
#define _CRCACCH_CRCACC8_LENGTH                             0x1
#define _CRCACCH_CRCACC8_MASK                               0x1
#define _CRCACCH_CRCACC9_POSN                               0x1
#define _CRCACCH_CRCACC9_POSITION                           0x1
#define _CRCACCH_CRCACC9_SIZE                               0x1
#define _CRCACCH_CRCACC9_LENGTH                             0x1
#define _CRCACCH_CRCACC9_MASK                               0x2
#define _CRCACCH_CRCACC10_POSN                              0x2
#define _CRCACCH_CRCACC10_POSITION                          0x2
#define _CRCACCH_CRCACC10_SIZE                              0x1
#define _CRCACCH_CRCACC10_LENGTH                            0x1
#define _CRCACCH_CRCACC10_MASK                              0x4
#define _CRCACCH_CRCACC11_POSN                              0x3
#define _CRCACCH_CRCACC11_POSITION                          0x3
#define _CRCACCH_CRCACC11_SIZE                              0x1
#define _CRCACCH_CRCACC11_LENGTH                            0x1
#define _CRCACCH_CRCACC11_MASK                              0x8
#define _CRCACCH_CRCACC12_POSN                              0x4
#define _CRCACCH_CRCACC12_POSITION                          0x4
#define _CRCACCH_CRCACC12_SIZE                              0x1
#define _CRCACCH_CRCACC12_LENGTH                            0x1
#define _CRCACCH_CRCACC12_MASK                              0x10
#define _CRCACCH_CRCACC13_POSN                              0x5
#define _CRCACCH_CRCACC13_POSITION                          0x5
#define _CRCACCH_CRCACC13_SIZE                              0x1
#define _CRCACCH_CRCACC13_LENGTH                            0x1
#define _CRCACCH_CRCACC13_MASK                              0x20
#define _CRCACCH_CRCACC14_POSN                              0x6
#define _CRCACCH_CRCACC14_POSITION                          0x6
#define _CRCACCH_CRCACC14_SIZE                              0x1
#define _CRCACCH_CRCACC14_LENGTH                            0x1
#define _CRCACCH_CRCACC14_MASK                              0x40
#define _CRCACCH_CRCACC15_POSN                              0x7
#define _CRCACCH_CRCACC15_POSITION                          0x7
#define _CRCACCH_CRCACC15_SIZE                              0x1
#define _CRCACCH_CRCACC15_LENGTH                            0x1
#define _CRCACCH_CRCACC15_MASK                              0x80

// Register: CRCSHIFT
extern volatile unsigned short          CRCSHIFT            @ 0x795;
#ifndef _LIB_BUILD
asm("CRCSHIFT equ 0795h");
#endif

// Register: CRCSHIFTL
extern volatile unsigned char           CRCSHIFTL           @ 0x795;
#ifndef _LIB_BUILD
asm("CRCSHIFTL equ 0795h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SHIFT                  :8;
    };
    struct {
        unsigned SHIFT0                 :1;
        unsigned SHIFT1                 :1;
        unsigned SHIFT2                 :1;
        unsigned SHIFT3                 :1;
        unsigned SHIFT4                 :1;
        unsigned SHIFT5                 :1;
        unsigned SHIFT6                 :1;
        unsigned SHIFT7                 :1;
    };
    struct {
        unsigned CRCSHIFT               :8;
    };
    struct {
        unsigned CRCSHIFT0              :1;
        unsigned CRCSHIFT1              :1;
        unsigned CRCSHIFT2              :1;
        unsigned CRCSHIFT3              :1;
        unsigned CRCSHIFT4              :1;
        unsigned CRCSHIFT5              :1;
        unsigned CRCSHIFT6              :1;
        unsigned CRCSHIFT7              :1;
    };
} CRCSHIFTLbits_t;
extern volatile CRCSHIFTLbits_t CRCSHIFTLbits @ 0x795;
// bitfield macros
#define _CRCSHIFTL_SHIFT_POSN                               0x0
#define _CRCSHIFTL_SHIFT_POSITION                           0x0
#define _CRCSHIFTL_SHIFT_SIZE                               0x8
#define _CRCSHIFTL_SHIFT_LENGTH                             0x8
#define _CRCSHIFTL_SHIFT_MASK                               0xFF
#define _CRCSHIFTL_SHIFT0_POSN                              0x0
#define _CRCSHIFTL_SHIFT0_POSITION                          0x0
#define _CRCSHIFTL_SHIFT0_SIZE                              0x1
#define _CRCSHIFTL_SHIFT0_LENGTH                            0x1
#define _CRCSHIFTL_SHIFT0_MASK                              0x1
#define _CRCSHIFTL_SHIFT1_POSN                              0x1
#define _CRCSHIFTL_SHIFT1_POSITION                          0x1
#define _CRCSHIFTL_SHIFT1_SIZE                              0x1
#define _CRCSHIFTL_SHIFT1_LENGTH                            0x1
#define _CRCSHIFTL_SHIFT1_MASK                              0x2
#define _CRCSHIFTL_SHIFT2_POSN                              0x2
#define _CRCSHIFTL_SHIFT2_POSITION                          0x2
#define _CRCSHIFTL_SHIFT2_SIZE                              0x1
#define _CRCSHIFTL_SHIFT2_LENGTH                            0x1
#define _CRCSHIFTL_SHIFT2_MASK                              0x4
#define _CRCSHIFTL_SHIFT3_POSN                              0x3
#define _CRCSHIFTL_SHIFT3_POSITION                          0x3
#define _CRCSHIFTL_SHIFT3_SIZE                              0x1
#define _CRCSHIFTL_SHIFT3_LENGTH                            0x1
#define _CRCSHIFTL_SHIFT3_MASK                              0x8
#define _CRCSHIFTL_SHIFT4_POSN                              0x4
#define _CRCSHIFTL_SHIFT4_POSITION                          0x4
#define _CRCSHIFTL_SHIFT4_SIZE                              0x1
#define _CRCSHIFTL_SHIFT4_LENGTH                            0x1
#define _CRCSHIFTL_SHIFT4_MASK                              0x10
#define _CRCSHIFTL_SHIFT5_POSN                              0x5
#define _CRCSHIFTL_SHIFT5_POSITION                          0x5
#define _CRCSHIFTL_SHIFT5_SIZE                              0x1
#define _CRCSHIFTL_SHIFT5_LENGTH                            0x1
#define _CRCSHIFTL_SHIFT5_MASK                              0x20
#define _CRCSHIFTL_SHIFT6_POSN                              0x6
#define _CRCSHIFTL_SHIFT6_POSITION                          0x6
#define _CRCSHIFTL_SHIFT6_SIZE                              0x1
#define _CRCSHIFTL_SHIFT6_LENGTH                            0x1
#define _CRCSHIFTL_SHIFT6_MASK                              0x40
#define _CRCSHIFTL_SHIFT7_POSN                              0x7
#define _CRCSHIFTL_SHIFT7_POSITION                          0x7
#define _CRCSHIFTL_SHIFT7_SIZE                              0x1
#define _CRCSHIFTL_SHIFT7_LENGTH                            0x1
#define _CRCSHIFTL_SHIFT7_MASK                              0x80
#define _CRCSHIFTL_CRCSHIFT_POSN                            0x0
#define _CRCSHIFTL_CRCSHIFT_POSITION                        0x0
#define _CRCSHIFTL_CRCSHIFT_SIZE                            0x8
#define _CRCSHIFTL_CRCSHIFT_LENGTH                          0x8
#define _CRCSHIFTL_CRCSHIFT_MASK                            0xFF
#define _CRCSHIFTL_CRCSHIFT0_POSN                           0x0
#define _CRCSHIFTL_CRCSHIFT0_POSITION                       0x0
#define _CRCSHIFTL_CRCSHIFT0_SIZE                           0x1
#define _CRCSHIFTL_CRCSHIFT0_LENGTH                         0x1
#define _CRCSHIFTL_CRCSHIFT0_MASK                           0x1
#define _CRCSHIFTL_CRCSHIFT1_POSN                           0x1
#define _CRCSHIFTL_CRCSHIFT1_POSITION                       0x1
#define _CRCSHIFTL_CRCSHIFT1_SIZE                           0x1
#define _CRCSHIFTL_CRCSHIFT1_LENGTH                         0x1
#define _CRCSHIFTL_CRCSHIFT1_MASK                           0x2
#define _CRCSHIFTL_CRCSHIFT2_POSN                           0x2
#define _CRCSHIFTL_CRCSHIFT2_POSITION                       0x2
#define _CRCSHIFTL_CRCSHIFT2_SIZE                           0x1
#define _CRCSHIFTL_CRCSHIFT2_LENGTH                         0x1
#define _CRCSHIFTL_CRCSHIFT2_MASK                           0x4
#define _CRCSHIFTL_CRCSHIFT3_POSN                           0x3
#define _CRCSHIFTL_CRCSHIFT3_POSITION                       0x3
#define _CRCSHIFTL_CRCSHIFT3_SIZE                           0x1
#define _CRCSHIFTL_CRCSHIFT3_LENGTH                         0x1
#define _CRCSHIFTL_CRCSHIFT3_MASK                           0x8
#define _CRCSHIFTL_CRCSHIFT4_POSN                           0x4
#define _CRCSHIFTL_CRCSHIFT4_POSITION                       0x4
#define _CRCSHIFTL_CRCSHIFT4_SIZE                           0x1
#define _CRCSHIFTL_CRCSHIFT4_LENGTH                         0x1
#define _CRCSHIFTL_CRCSHIFT4_MASK                           0x10
#define _CRCSHIFTL_CRCSHIFT5_POSN                           0x5
#define _CRCSHIFTL_CRCSHIFT5_POSITION                       0x5
#define _CRCSHIFTL_CRCSHIFT5_SIZE                           0x1
#define _CRCSHIFTL_CRCSHIFT5_LENGTH                         0x1
#define _CRCSHIFTL_CRCSHIFT5_MASK                           0x20
#define _CRCSHIFTL_CRCSHIFT6_POSN                           0x6
#define _CRCSHIFTL_CRCSHIFT6_POSITION                       0x6
#define _CRCSHIFTL_CRCSHIFT6_SIZE                           0x1
#define _CRCSHIFTL_CRCSHIFT6_LENGTH                         0x1
#define _CRCSHIFTL_CRCSHIFT6_MASK                           0x40
#define _CRCSHIFTL_CRCSHIFT7_POSN                           0x7
#define _CRCSHIFTL_CRCSHIFT7_POSITION                       0x7
#define _CRCSHIFTL_CRCSHIFT7_SIZE                           0x1
#define _CRCSHIFTL_CRCSHIFT7_LENGTH                         0x1
#define _CRCSHIFTL_CRCSHIFT7_MASK                           0x80

// Register: CRCSHIFTH
extern volatile unsigned char           CRCSHIFTH           @ 0x796;
#ifndef _LIB_BUILD
asm("CRCSHIFTH equ 0796h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SHIFT                  :8;
    };
    struct {
        unsigned SHIFT8                 :1;
        unsigned SHIFT9                 :1;
        unsigned SHIFT10                :1;
        unsigned SHIFT11                :1;
        unsigned SHIFT12                :1;
        unsigned SHIFT13                :1;
        unsigned SHIFT14                :1;
        unsigned SHIFT15                :1;
    };
    struct {
        unsigned CRCSHIFT               :8;
    };
    struct {
        unsigned CRCSHIFT8              :1;
        unsigned CRCSHIFT9              :1;
        unsigned CRCSHIFT10             :1;
        unsigned CRCSHIFT11             :1;
        unsigned CRCSHIFT12             :1;
        unsigned CRCSHIFT13             :1;
        unsigned CRCSHIFT14             :1;
        unsigned CRCSHIFT15             :1;
    };
} CRCSHIFTHbits_t;
extern volatile CRCSHIFTHbits_t CRCSHIFTHbits @ 0x796;
// bitfield macros
#define _CRCSHIFTH_SHIFT_POSN                               0x0
#define _CRCSHIFTH_SHIFT_POSITION                           0x0
#define _CRCSHIFTH_SHIFT_SIZE                               0x8
#define _CRCSHIFTH_SHIFT_LENGTH                             0x8
#define _CRCSHIFTH_SHIFT_MASK                               0xFF
#define _CRCSHIFTH_SHIFT8_POSN                              0x0
#define _CRCSHIFTH_SHIFT8_POSITION                          0x0
#define _CRCSHIFTH_SHIFT8_SIZE                              0x1
#define _CRCSHIFTH_SHIFT8_LENGTH                            0x1
#define _CRCSHIFTH_SHIFT8_MASK                              0x1
#define _CRCSHIFTH_SHIFT9_POSN                              0x1
#define _CRCSHIFTH_SHIFT9_POSITION                          0x1
#define _CRCSHIFTH_SHIFT9_SIZE                              0x1
#define _CRCSHIFTH_SHIFT9_LENGTH                            0x1
#define _CRCSHIFTH_SHIFT9_MASK                              0x2
#define _CRCSHIFTH_SHIFT10_POSN                             0x2
#define _CRCSHIFTH_SHIFT10_POSITION                         0x2
#define _CRCSHIFTH_SHIFT10_SIZE                             0x1
#define _CRCSHIFTH_SHIFT10_LENGTH                           0x1
#define _CRCSHIFTH_SHIFT10_MASK                             0x4
#define _CRCSHIFTH_SHIFT11_POSN                             0x3
#define _CRCSHIFTH_SHIFT11_POSITION                         0x3
#define _CRCSHIFTH_SHIFT11_SIZE                             0x1
#define _CRCSHIFTH_SHIFT11_LENGTH                           0x1
#define _CRCSHIFTH_SHIFT11_MASK                             0x8
#define _CRCSHIFTH_SHIFT12_POSN                             0x4
#define _CRCSHIFTH_SHIFT12_POSITION                         0x4
#define _CRCSHIFTH_SHIFT12_SIZE                             0x1
#define _CRCSHIFTH_SHIFT12_LENGTH                           0x1
#define _CRCSHIFTH_SHIFT12_MASK                             0x10
#define _CRCSHIFTH_SHIFT13_POSN                             0x5
#define _CRCSHIFTH_SHIFT13_POSITION                         0x5
#define _CRCSHIFTH_SHIFT13_SIZE                             0x1
#define _CRCSHIFTH_SHIFT13_LENGTH                           0x1
#define _CRCSHIFTH_SHIFT13_MASK                             0x20
#define _CRCSHIFTH_SHIFT14_POSN                             0x6
#define _CRCSHIFTH_SHIFT14_POSITION                         0x6
#define _CRCSHIFTH_SHIFT14_SIZE                             0x1
#define _CRCSHIFTH_SHIFT14_LENGTH                           0x1
#define _CRCSHIFTH_SHIFT14_MASK                             0x40
#define _CRCSHIFTH_SHIFT15_POSN                             0x7
#define _CRCSHIFTH_SHIFT15_POSITION                         0x7
#define _CRCSHIFTH_SHIFT15_SIZE                             0x1
#define _CRCSHIFTH_SHIFT15_LENGTH                           0x1
#define _CRCSHIFTH_SHIFT15_MASK                             0x80
#define _CRCSHIFTH_CRCSHIFT_POSN                            0x0
#define _CRCSHIFTH_CRCSHIFT_POSITION                        0x0
#define _CRCSHIFTH_CRCSHIFT_SIZE                            0x8
#define _CRCSHIFTH_CRCSHIFT_LENGTH                          0x8
#define _CRCSHIFTH_CRCSHIFT_MASK                            0xFF
#define _CRCSHIFTH_CRCSHIFT8_POSN                           0x0
#define _CRCSHIFTH_CRCSHIFT8_POSITION                       0x0
#define _CRCSHIFTH_CRCSHIFT8_SIZE                           0x1
#define _CRCSHIFTH_CRCSHIFT8_LENGTH                         0x1
#define _CRCSHIFTH_CRCSHIFT8_MASK                           0x1
#define _CRCSHIFTH_CRCSHIFT9_POSN                           0x1
#define _CRCSHIFTH_CRCSHIFT9_POSITION                       0x1
#define _CRCSHIFTH_CRCSHIFT9_SIZE                           0x1
#define _CRCSHIFTH_CRCSHIFT9_LENGTH                         0x1
#define _CRCSHIFTH_CRCSHIFT9_MASK                           0x2
#define _CRCSHIFTH_CRCSHIFT10_POSN                          0x2
#define _CRCSHIFTH_CRCSHIFT10_POSITION                      0x2
#define _CRCSHIFTH_CRCSHIFT10_SIZE                          0x1
#define _CRCSHIFTH_CRCSHIFT10_LENGTH                        0x1
#define _CRCSHIFTH_CRCSHIFT10_MASK                          0x4
#define _CRCSHIFTH_CRCSHIFT11_POSN                          0x3
#define _CRCSHIFTH_CRCSHIFT11_POSITION                      0x3
#define _CRCSHIFTH_CRCSHIFT11_SIZE                          0x1
#define _CRCSHIFTH_CRCSHIFT11_LENGTH                        0x1
#define _CRCSHIFTH_CRCSHIFT11_MASK                          0x8
#define _CRCSHIFTH_CRCSHIFT12_POSN                          0x4
#define _CRCSHIFTH_CRCSHIFT12_POSITION                      0x4
#define _CRCSHIFTH_CRCSHIFT12_SIZE                          0x1
#define _CRCSHIFTH_CRCSHIFT12_LENGTH                        0x1
#define _CRCSHIFTH_CRCSHIFT12_MASK                          0x10
#define _CRCSHIFTH_CRCSHIFT13_POSN                          0x5
#define _CRCSHIFTH_CRCSHIFT13_POSITION                      0x5
#define _CRCSHIFTH_CRCSHIFT13_SIZE                          0x1
#define _CRCSHIFTH_CRCSHIFT13_LENGTH                        0x1
#define _CRCSHIFTH_CRCSHIFT13_MASK                          0x20
#define _CRCSHIFTH_CRCSHIFT14_POSN                          0x6
#define _CRCSHIFTH_CRCSHIFT14_POSITION                      0x6
#define _CRCSHIFTH_CRCSHIFT14_SIZE                          0x1
#define _CRCSHIFTH_CRCSHIFT14_LENGTH                        0x1
#define _CRCSHIFTH_CRCSHIFT14_MASK                          0x40
#define _CRCSHIFTH_CRCSHIFT15_POSN                          0x7
#define _CRCSHIFTH_CRCSHIFT15_POSITION                      0x7
#define _CRCSHIFTH_CRCSHIFT15_SIZE                          0x1
#define _CRCSHIFTH_CRCSHIFT15_LENGTH                        0x1
#define _CRCSHIFTH_CRCSHIFT15_MASK                          0x80

// Register: CRCXOR
extern volatile unsigned short          CRCXOR              @ 0x797;
#ifndef _LIB_BUILD
asm("CRCXOR equ 0797h");
#endif

// Register: CRCXORL
extern volatile unsigned char           CRCXORL             @ 0x797;
#ifndef _LIB_BUILD
asm("CRCXORL equ 0797h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned                        :1;
        unsigned XOR1                   :1;
        unsigned XOR2                   :1;
        unsigned XOR3                   :1;
        unsigned XOR4                   :1;
        unsigned XOR5                   :1;
        unsigned XOR6                   :1;
        unsigned XOR7                   :1;
    };
    struct {
        unsigned                        :1;
        unsigned CRCXOR1                :1;
        unsigned CRCXOR2                :1;
        unsigned CRCXOR3                :1;
        unsigned CRCXOR4                :1;
        unsigned CRCXOR5                :1;
        unsigned CRCXOR6                :1;
        unsigned CRCXOR7                :1;
    };
} CRCXORLbits_t;
extern volatile CRCXORLbits_t CRCXORLbits @ 0x797;
// bitfield macros
#define _CRCXORL_XOR1_POSN                                  0x1
#define _CRCXORL_XOR1_POSITION                              0x1
#define _CRCXORL_XOR1_SIZE                                  0x1
#define _CRCXORL_XOR1_LENGTH                                0x1
#define _CRCXORL_XOR1_MASK                                  0x2
#define _CRCXORL_XOR2_POSN                                  0x2
#define _CRCXORL_XOR2_POSITION                              0x2
#define _CRCXORL_XOR2_SIZE                                  0x1
#define _CRCXORL_XOR2_LENGTH                                0x1
#define _CRCXORL_XOR2_MASK                                  0x4
#define _CRCXORL_XOR3_POSN                                  0x3
#define _CRCXORL_XOR3_POSITION                              0x3
#define _CRCXORL_XOR3_SIZE                                  0x1
#define _CRCXORL_XOR3_LENGTH                                0x1
#define _CRCXORL_XOR3_MASK                                  0x8
#define _CRCXORL_XOR4_POSN                                  0x4
#define _CRCXORL_XOR4_POSITION                              0x4
#define _CRCXORL_XOR4_SIZE                                  0x1
#define _CRCXORL_XOR4_LENGTH                                0x1
#define _CRCXORL_XOR4_MASK                                  0x10
#define _CRCXORL_XOR5_POSN                                  0x5
#define _CRCXORL_XOR5_POSITION                              0x5
#define _CRCXORL_XOR5_SIZE                                  0x1
#define _CRCXORL_XOR5_LENGTH                                0x1
#define _CRCXORL_XOR5_MASK                                  0x20
#define _CRCXORL_XOR6_POSN                                  0x6
#define _CRCXORL_XOR6_POSITION                              0x6
#define _CRCXORL_XOR6_SIZE                                  0x1
#define _CRCXORL_XOR6_LENGTH                                0x1
#define _CRCXORL_XOR6_MASK                                  0x40
#define _CRCXORL_XOR7_POSN                                  0x7
#define _CRCXORL_XOR7_POSITION                              0x7
#define _CRCXORL_XOR7_SIZE                                  0x1
#define _CRCXORL_XOR7_LENGTH                                0x1
#define _CRCXORL_XOR7_MASK                                  0x80
#define _CRCXORL_CRCXOR1_POSN                               0x1
#define _CRCXORL_CRCXOR1_POSITION                           0x1
#define _CRCXORL_CRCXOR1_SIZE                               0x1
#define _CRCXORL_CRCXOR1_LENGTH                             0x1
#define _CRCXORL_CRCXOR1_MASK                               0x2
#define _CRCXORL_CRCXOR2_POSN                               0x2
#define _CRCXORL_CRCXOR2_POSITION                           0x2
#define _CRCXORL_CRCXOR2_SIZE                               0x1
#define _CRCXORL_CRCXOR2_LENGTH                             0x1
#define _CRCXORL_CRCXOR2_MASK                               0x4
#define _CRCXORL_CRCXOR3_POSN                               0x3
#define _CRCXORL_CRCXOR3_POSITION                           0x3
#define _CRCXORL_CRCXOR3_SIZE                               0x1
#define _CRCXORL_CRCXOR3_LENGTH                             0x1
#define _CRCXORL_CRCXOR3_MASK                               0x8
#define _CRCXORL_CRCXOR4_POSN                               0x4
#define _CRCXORL_CRCXOR4_POSITION                           0x4
#define _CRCXORL_CRCXOR4_SIZE                               0x1
#define _CRCXORL_CRCXOR4_LENGTH                             0x1
#define _CRCXORL_CRCXOR4_MASK                               0x10
#define _CRCXORL_CRCXOR5_POSN                               0x5
#define _CRCXORL_CRCXOR5_POSITION                           0x5
#define _CRCXORL_CRCXOR5_SIZE                               0x1
#define _CRCXORL_CRCXOR5_LENGTH                             0x1
#define _CRCXORL_CRCXOR5_MASK                               0x20
#define _CRCXORL_CRCXOR6_POSN                               0x6
#define _CRCXORL_CRCXOR6_POSITION                           0x6
#define _CRCXORL_CRCXOR6_SIZE                               0x1
#define _CRCXORL_CRCXOR6_LENGTH                             0x1
#define _CRCXORL_CRCXOR6_MASK                               0x40
#define _CRCXORL_CRCXOR7_POSN                               0x7
#define _CRCXORL_CRCXOR7_POSITION                           0x7
#define _CRCXORL_CRCXOR7_SIZE                               0x1
#define _CRCXORL_CRCXOR7_LENGTH                             0x1
#define _CRCXORL_CRCXOR7_MASK                               0x80

// Register: CRCXORH
extern volatile unsigned char           CRCXORH             @ 0x798;
#ifndef _LIB_BUILD
asm("CRCXORH equ 0798h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned XOR8                   :1;
        unsigned XOR9                   :1;
        unsigned XOR10                  :1;
        unsigned XOR11                  :1;
        unsigned XOR12                  :1;
        unsigned XOR13                  :1;
        unsigned XOR14                  :1;
        unsigned XOR15                  :1;
    };
    struct {
        unsigned CRCXOR8                :1;
        unsigned CRCXOR9                :1;
        unsigned CRCXOR10               :1;
        unsigned CRCXOR11               :1;
        unsigned CRCXOR12               :1;
        unsigned CRCXOR13               :1;
        unsigned CRCXOR14               :1;
        unsigned CRCXOR15               :1;
    };
} CRCXORHbits_t;
extern volatile CRCXORHbits_t CRCXORHbits @ 0x798;
// bitfield macros
#define _CRCXORH_XOR8_POSN                                  0x0
#define _CRCXORH_XOR8_POSITION                              0x0
#define _CRCXORH_XOR8_SIZE                                  0x1
#define _CRCXORH_XOR8_LENGTH                                0x1
#define _CRCXORH_XOR8_MASK                                  0x1
#define _CRCXORH_XOR9_POSN                                  0x1
#define _CRCXORH_XOR9_POSITION                              0x1
#define _CRCXORH_XOR9_SIZE                                  0x1
#define _CRCXORH_XOR9_LENGTH                                0x1
#define _CRCXORH_XOR9_MASK                                  0x2
#define _CRCXORH_XOR10_POSN                                 0x2
#define _CRCXORH_XOR10_POSITION                             0x2
#define _CRCXORH_XOR10_SIZE                                 0x1
#define _CRCXORH_XOR10_LENGTH                               0x1
#define _CRCXORH_XOR10_MASK                                 0x4
#define _CRCXORH_XOR11_POSN                                 0x3
#define _CRCXORH_XOR11_POSITION                             0x3
#define _CRCXORH_XOR11_SIZE                                 0x1
#define _CRCXORH_XOR11_LENGTH                               0x1
#define _CRCXORH_XOR11_MASK                                 0x8
#define _CRCXORH_XOR12_POSN                                 0x4
#define _CRCXORH_XOR12_POSITION                             0x4
#define _CRCXORH_XOR12_SIZE                                 0x1
#define _CRCXORH_XOR12_LENGTH                               0x1
#define _CRCXORH_XOR12_MASK                                 0x10
#define _CRCXORH_XOR13_POSN                                 0x5
#define _CRCXORH_XOR13_POSITION                             0x5
#define _CRCXORH_XOR13_SIZE                                 0x1
#define _CRCXORH_XOR13_LENGTH                               0x1
#define _CRCXORH_XOR13_MASK                                 0x20
#define _CRCXORH_XOR14_POSN                                 0x6
#define _CRCXORH_XOR14_POSITION                             0x6
#define _CRCXORH_XOR14_SIZE                                 0x1
#define _CRCXORH_XOR14_LENGTH                               0x1
#define _CRCXORH_XOR14_MASK                                 0x40
#define _CRCXORH_XOR15_POSN                                 0x7
#define _CRCXORH_XOR15_POSITION                             0x7
#define _CRCXORH_XOR15_SIZE                                 0x1
#define _CRCXORH_XOR15_LENGTH                               0x1
#define _CRCXORH_XOR15_MASK                                 0x80
#define _CRCXORH_CRCXOR8_POSN                               0x0
#define _CRCXORH_CRCXOR8_POSITION                           0x0
#define _CRCXORH_CRCXOR8_SIZE                               0x1
#define _CRCXORH_CRCXOR8_LENGTH                             0x1
#define _CRCXORH_CRCXOR8_MASK                               0x1
#define _CRCXORH_CRCXOR9_POSN                               0x1
#define _CRCXORH_CRCXOR9_POSITION                           0x1
#define _CRCXORH_CRCXOR9_SIZE                               0x1
#define _CRCXORH_CRCXOR9_LENGTH                             0x1
#define _CRCXORH_CRCXOR9_MASK                               0x2
#define _CRCXORH_CRCXOR10_POSN                              0x2
#define _CRCXORH_CRCXOR10_POSITION                          0x2
#define _CRCXORH_CRCXOR10_SIZE                              0x1
#define _CRCXORH_CRCXOR10_LENGTH                            0x1
#define _CRCXORH_CRCXOR10_MASK                              0x4
#define _CRCXORH_CRCXOR11_POSN                              0x3
#define _CRCXORH_CRCXOR11_POSITION                          0x3
#define _CRCXORH_CRCXOR11_SIZE                              0x1
#define _CRCXORH_CRCXOR11_LENGTH                            0x1
#define _CRCXORH_CRCXOR11_MASK                              0x8
#define _CRCXORH_CRCXOR12_POSN                              0x4
#define _CRCXORH_CRCXOR12_POSITION                          0x4
#define _CRCXORH_CRCXOR12_SIZE                              0x1
#define _CRCXORH_CRCXOR12_LENGTH                            0x1
#define _CRCXORH_CRCXOR12_MASK                              0x10
#define _CRCXORH_CRCXOR13_POSN                              0x5
#define _CRCXORH_CRCXOR13_POSITION                          0x5
#define _CRCXORH_CRCXOR13_SIZE                              0x1
#define _CRCXORH_CRCXOR13_LENGTH                            0x1
#define _CRCXORH_CRCXOR13_MASK                              0x20
#define _CRCXORH_CRCXOR14_POSN                              0x6
#define _CRCXORH_CRCXOR14_POSITION                          0x6
#define _CRCXORH_CRCXOR14_SIZE                              0x1
#define _CRCXORH_CRCXOR14_LENGTH                            0x1
#define _CRCXORH_CRCXOR14_MASK                              0x40
#define _CRCXORH_CRCXOR15_POSN                              0x7
#define _CRCXORH_CRCXOR15_POSITION                          0x7
#define _CRCXORH_CRCXOR15_SIZE                              0x1
#define _CRCXORH_CRCXOR15_LENGTH                            0x1
#define _CRCXORH_CRCXOR15_MASK                              0x80

// Register: CRCCON0
extern volatile unsigned char           CRCCON0             @ 0x799;
#ifndef _LIB_BUILD
asm("CRCCON0 equ 0799h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned FULL                   :1;
        unsigned SHIFTM                 :1;
        unsigned                        :2;
        unsigned ACCM                   :1;
        unsigned BUSY                   :1;
        unsigned CRCGO                  :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned CRCFULL                :1;
        unsigned CRCSHIFTM              :1;
        unsigned                        :2;
        unsigned CRCACCM                :1;
        unsigned CRCBUSY                :1;
        unsigned                        :1;
        unsigned CRCEN                  :1;
    };
} CRCCON0bits_t;
extern volatile CRCCON0bits_t CRCCON0bits @ 0x799;
// bitfield macros
#define _CRCCON0_FULL_POSN                                  0x0
#define _CRCCON0_FULL_POSITION                              0x0
#define _CRCCON0_FULL_SIZE                                  0x1
#define _CRCCON0_FULL_LENGTH                                0x1
#define _CRCCON0_FULL_MASK                                  0x1
#define _CRCCON0_SHIFTM_POSN                                0x1
#define _CRCCON0_SHIFTM_POSITION                            0x1
#define _CRCCON0_SHIFTM_SIZE                                0x1
#define _CRCCON0_SHIFTM_LENGTH                              0x1
#define _CRCCON0_SHIFTM_MASK                                0x2
#define _CRCCON0_ACCM_POSN                                  0x4
#define _CRCCON0_ACCM_POSITION                              0x4
#define _CRCCON0_ACCM_SIZE                                  0x1
#define _CRCCON0_ACCM_LENGTH                                0x1
#define _CRCCON0_ACCM_MASK                                  0x10
#define _CRCCON0_BUSY_POSN                                  0x5
#define _CRCCON0_BUSY_POSITION                              0x5
#define _CRCCON0_BUSY_SIZE                                  0x1
#define _CRCCON0_BUSY_LENGTH                                0x1
#define _CRCCON0_BUSY_MASK                                  0x20
#define _CRCCON0_CRCGO_POSN                                 0x6
#define _CRCCON0_CRCGO_POSITION                             0x6
#define _CRCCON0_CRCGO_SIZE                                 0x1
#define _CRCCON0_CRCGO_LENGTH                               0x1
#define _CRCCON0_CRCGO_MASK                                 0x40
#define _CRCCON0_EN_POSN                                    0x7
#define _CRCCON0_EN_POSITION                                0x7
#define _CRCCON0_EN_SIZE                                    0x1
#define _CRCCON0_EN_LENGTH                                  0x1
#define _CRCCON0_EN_MASK                                    0x80
#define _CRCCON0_CRCFULL_POSN                               0x0
#define _CRCCON0_CRCFULL_POSITION                           0x0
#define _CRCCON0_CRCFULL_SIZE                               0x1
#define _CRCCON0_CRCFULL_LENGTH                             0x1
#define _CRCCON0_CRCFULL_MASK                               0x1
#define _CRCCON0_CRCSHIFTM_POSN                             0x1
#define _CRCCON0_CRCSHIFTM_POSITION                         0x1
#define _CRCCON0_CRCSHIFTM_SIZE                             0x1
#define _CRCCON0_CRCSHIFTM_LENGTH                           0x1
#define _CRCCON0_CRCSHIFTM_MASK                             0x2
#define _CRCCON0_CRCACCM_POSN                               0x4
#define _CRCCON0_CRCACCM_POSITION                           0x4
#define _CRCCON0_CRCACCM_SIZE                               0x1
#define _CRCCON0_CRCACCM_LENGTH                             0x1
#define _CRCCON0_CRCACCM_MASK                               0x10
#define _CRCCON0_CRCBUSY_POSN                               0x5
#define _CRCCON0_CRCBUSY_POSITION                           0x5
#define _CRCCON0_CRCBUSY_SIZE                               0x1
#define _CRCCON0_CRCBUSY_LENGTH                             0x1
#define _CRCCON0_CRCBUSY_MASK                               0x20
#define _CRCCON0_CRCEN_POSN                                 0x7
#define _CRCCON0_CRCEN_POSITION                             0x7
#define _CRCCON0_CRCEN_SIZE                                 0x1
#define _CRCCON0_CRCEN_LENGTH                               0x1
#define _CRCCON0_CRCEN_MASK                                 0x80

// Register: CRCCON1
extern volatile unsigned char           CRCCON1             @ 0x79A;
#ifndef _LIB_BUILD
asm("CRCCON1 equ 079Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PLEN                   :4;
        unsigned DLEN                   :4;
    };
    struct {
        unsigned PLEN0                  :1;
        unsigned PLEN1                  :1;
        unsigned PLEN2                  :1;
        unsigned PLEN3                  :1;
        unsigned DLEN0                  :1;
        unsigned DLEN1                  :1;
        unsigned DLEN2                  :1;
        unsigned DLEN3                  :1;
    };
    struct {
        unsigned CRCPLEN                :4;
        unsigned CRCDLEN                :4;
    };
    struct {
        unsigned CRCPLEN0               :1;
        unsigned CRCPLEN1               :1;
        unsigned CRCPLEN2               :1;
        unsigned CRCPLEN3               :1;
        unsigned CRCDLEN0               :1;
        unsigned CRCDLEN1               :1;
        unsigned CRCDLEN2               :1;
        unsigned CRCDLEN3               :1;
    };
} CRCCON1bits_t;
extern volatile CRCCON1bits_t CRCCON1bits @ 0x79A;
// bitfield macros
#define _CRCCON1_PLEN_POSN                                  0x0
#define _CRCCON1_PLEN_POSITION                              0x0
#define _CRCCON1_PLEN_SIZE                                  0x4
#define _CRCCON1_PLEN_LENGTH                                0x4
#define _CRCCON1_PLEN_MASK                                  0xF
#define _CRCCON1_DLEN_POSN                                  0x4
#define _CRCCON1_DLEN_POSITION                              0x4
#define _CRCCON1_DLEN_SIZE                                  0x4
#define _CRCCON1_DLEN_LENGTH                                0x4
#define _CRCCON1_DLEN_MASK                                  0xF0
#define _CRCCON1_PLEN0_POSN                                 0x0
#define _CRCCON1_PLEN0_POSITION                             0x0
#define _CRCCON1_PLEN0_SIZE                                 0x1
#define _CRCCON1_PLEN0_LENGTH                               0x1
#define _CRCCON1_PLEN0_MASK                                 0x1
#define _CRCCON1_PLEN1_POSN                                 0x1
#define _CRCCON1_PLEN1_POSITION                             0x1
#define _CRCCON1_PLEN1_SIZE                                 0x1
#define _CRCCON1_PLEN1_LENGTH                               0x1
#define _CRCCON1_PLEN1_MASK                                 0x2
#define _CRCCON1_PLEN2_POSN                                 0x2
#define _CRCCON1_PLEN2_POSITION                             0x2
#define _CRCCON1_PLEN2_SIZE                                 0x1
#define _CRCCON1_PLEN2_LENGTH                               0x1
#define _CRCCON1_PLEN2_MASK                                 0x4
#define _CRCCON1_PLEN3_POSN                                 0x3
#define _CRCCON1_PLEN3_POSITION                             0x3
#define _CRCCON1_PLEN3_SIZE                                 0x1
#define _CRCCON1_PLEN3_LENGTH                               0x1
#define _CRCCON1_PLEN3_MASK                                 0x8
#define _CRCCON1_DLEN0_POSN                                 0x4
#define _CRCCON1_DLEN0_POSITION                             0x4
#define _CRCCON1_DLEN0_SIZE                                 0x1
#define _CRCCON1_DLEN0_LENGTH                               0x1
#define _CRCCON1_DLEN0_MASK                                 0x10
#define _CRCCON1_DLEN1_POSN                                 0x5
#define _CRCCON1_DLEN1_POSITION                             0x5
#define _CRCCON1_DLEN1_SIZE                                 0x1
#define _CRCCON1_DLEN1_LENGTH                               0x1
#define _CRCCON1_DLEN1_MASK                                 0x20
#define _CRCCON1_DLEN2_POSN                                 0x6
#define _CRCCON1_DLEN2_POSITION                             0x6
#define _CRCCON1_DLEN2_SIZE                                 0x1
#define _CRCCON1_DLEN2_LENGTH                               0x1
#define _CRCCON1_DLEN2_MASK                                 0x40
#define _CRCCON1_DLEN3_POSN                                 0x7
#define _CRCCON1_DLEN3_POSITION                             0x7
#define _CRCCON1_DLEN3_SIZE                                 0x1
#define _CRCCON1_DLEN3_LENGTH                               0x1
#define _CRCCON1_DLEN3_MASK                                 0x80
#define _CRCCON1_CRCPLEN_POSN                               0x0
#define _CRCCON1_CRCPLEN_POSITION                           0x0
#define _CRCCON1_CRCPLEN_SIZE                               0x4
#define _CRCCON1_CRCPLEN_LENGTH                             0x4
#define _CRCCON1_CRCPLEN_MASK                               0xF
#define _CRCCON1_CRCDLEN_POSN                               0x4
#define _CRCCON1_CRCDLEN_POSITION                           0x4
#define _CRCCON1_CRCDLEN_SIZE                               0x4
#define _CRCCON1_CRCDLEN_LENGTH                             0x4
#define _CRCCON1_CRCDLEN_MASK                               0xF0
#define _CRCCON1_CRCPLEN0_POSN                              0x0
#define _CRCCON1_CRCPLEN0_POSITION                          0x0
#define _CRCCON1_CRCPLEN0_SIZE                              0x1
#define _CRCCON1_CRCPLEN0_LENGTH                            0x1
#define _CRCCON1_CRCPLEN0_MASK                              0x1
#define _CRCCON1_CRCPLEN1_POSN                              0x1
#define _CRCCON1_CRCPLEN1_POSITION                          0x1
#define _CRCCON1_CRCPLEN1_SIZE                              0x1
#define _CRCCON1_CRCPLEN1_LENGTH                            0x1
#define _CRCCON1_CRCPLEN1_MASK                              0x2
#define _CRCCON1_CRCPLEN2_POSN                              0x2
#define _CRCCON1_CRCPLEN2_POSITION                          0x2
#define _CRCCON1_CRCPLEN2_SIZE                              0x1
#define _CRCCON1_CRCPLEN2_LENGTH                            0x1
#define _CRCCON1_CRCPLEN2_MASK                              0x4
#define _CRCCON1_CRCPLEN3_POSN                              0x3
#define _CRCCON1_CRCPLEN3_POSITION                          0x3
#define _CRCCON1_CRCPLEN3_SIZE                              0x1
#define _CRCCON1_CRCPLEN3_LENGTH                            0x1
#define _CRCCON1_CRCPLEN3_MASK                              0x8
#define _CRCCON1_CRCDLEN0_POSN                              0x4
#define _CRCCON1_CRCDLEN0_POSITION                          0x4
#define _CRCCON1_CRCDLEN0_SIZE                              0x1
#define _CRCCON1_CRCDLEN0_LENGTH                            0x1
#define _CRCCON1_CRCDLEN0_MASK                              0x10
#define _CRCCON1_CRCDLEN1_POSN                              0x5
#define _CRCCON1_CRCDLEN1_POSITION                          0x5
#define _CRCCON1_CRCDLEN1_SIZE                              0x1
#define _CRCCON1_CRCDLEN1_LENGTH                            0x1
#define _CRCCON1_CRCDLEN1_MASK                              0x20
#define _CRCCON1_CRCDLEN2_POSN                              0x6
#define _CRCCON1_CRCDLEN2_POSITION                          0x6
#define _CRCCON1_CRCDLEN2_SIZE                              0x1
#define _CRCCON1_CRCDLEN2_LENGTH                            0x1
#define _CRCCON1_CRCDLEN2_MASK                              0x40
#define _CRCCON1_CRCDLEN3_POSN                              0x7
#define _CRCCON1_CRCDLEN3_POSITION                          0x7
#define _CRCCON1_CRCDLEN3_SIZE                              0x1
#define _CRCCON1_CRCDLEN3_LENGTH                            0x1
#define _CRCCON1_CRCDLEN3_MASK                              0x80

// Register: AT1RES
extern volatile unsigned short          AT1RES              @ 0x80C;
#ifndef _LIB_BUILD
asm("AT1RES equ 080Ch");
#endif

// Register: AT1RESL
extern volatile unsigned char           AT1RESL             @ 0x80C;
#ifndef _LIB_BUILD
asm("AT1RESL equ 080Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1RES0                :1;
        unsigned AT1RES1                :1;
        unsigned AT1RES2                :1;
        unsigned AT1RES3                :1;
        unsigned AT1RES4                :1;
        unsigned AT1RES5                :1;
        unsigned AT1RES6                :1;
        unsigned AT1RES7                :1;
    };
    struct {
        unsigned RES0                   :1;
        unsigned RES1                   :1;
        unsigned RES2                   :1;
        unsigned RES3                   :1;
        unsigned RES4                   :1;
        unsigned RES5                   :1;
        unsigned RES6                   :1;
        unsigned RES7                   :1;
    };
} AT1RESLbits_t;
extern volatile AT1RESLbits_t AT1RESLbits @ 0x80C;
// bitfield macros
#define _AT1RESL_AT1RES0_POSN                               0x0
#define _AT1RESL_AT1RES0_POSITION                           0x0
#define _AT1RESL_AT1RES0_SIZE                               0x1
#define _AT1RESL_AT1RES0_LENGTH                             0x1
#define _AT1RESL_AT1RES0_MASK                               0x1
#define _AT1RESL_AT1RES1_POSN                               0x1
#define _AT1RESL_AT1RES1_POSITION                           0x1
#define _AT1RESL_AT1RES1_SIZE                               0x1
#define _AT1RESL_AT1RES1_LENGTH                             0x1
#define _AT1RESL_AT1RES1_MASK                               0x2
#define _AT1RESL_AT1RES2_POSN                               0x2
#define _AT1RESL_AT1RES2_POSITION                           0x2
#define _AT1RESL_AT1RES2_SIZE                               0x1
#define _AT1RESL_AT1RES2_LENGTH                             0x1
#define _AT1RESL_AT1RES2_MASK                               0x4
#define _AT1RESL_AT1RES3_POSN                               0x3
#define _AT1RESL_AT1RES3_POSITION                           0x3
#define _AT1RESL_AT1RES3_SIZE                               0x1
#define _AT1RESL_AT1RES3_LENGTH                             0x1
#define _AT1RESL_AT1RES3_MASK                               0x8
#define _AT1RESL_AT1RES4_POSN                               0x4
#define _AT1RESL_AT1RES4_POSITION                           0x4
#define _AT1RESL_AT1RES4_SIZE                               0x1
#define _AT1RESL_AT1RES4_LENGTH                             0x1
#define _AT1RESL_AT1RES4_MASK                               0x10
#define _AT1RESL_AT1RES5_POSN                               0x5
#define _AT1RESL_AT1RES5_POSITION                           0x5
#define _AT1RESL_AT1RES5_SIZE                               0x1
#define _AT1RESL_AT1RES5_LENGTH                             0x1
#define _AT1RESL_AT1RES5_MASK                               0x20
#define _AT1RESL_AT1RES6_POSN                               0x6
#define _AT1RESL_AT1RES6_POSITION                           0x6
#define _AT1RESL_AT1RES6_SIZE                               0x1
#define _AT1RESL_AT1RES6_LENGTH                             0x1
#define _AT1RESL_AT1RES6_MASK                               0x40
#define _AT1RESL_AT1RES7_POSN                               0x7
#define _AT1RESL_AT1RES7_POSITION                           0x7
#define _AT1RESL_AT1RES7_SIZE                               0x1
#define _AT1RESL_AT1RES7_LENGTH                             0x1
#define _AT1RESL_AT1RES7_MASK                               0x80
#define _AT1RESL_RES0_POSN                                  0x0
#define _AT1RESL_RES0_POSITION                              0x0
#define _AT1RESL_RES0_SIZE                                  0x1
#define _AT1RESL_RES0_LENGTH                                0x1
#define _AT1RESL_RES0_MASK                                  0x1
#define _AT1RESL_RES1_POSN                                  0x1
#define _AT1RESL_RES1_POSITION                              0x1
#define _AT1RESL_RES1_SIZE                                  0x1
#define _AT1RESL_RES1_LENGTH                                0x1
#define _AT1RESL_RES1_MASK                                  0x2
#define _AT1RESL_RES2_POSN                                  0x2
#define _AT1RESL_RES2_POSITION                              0x2
#define _AT1RESL_RES2_SIZE                                  0x1
#define _AT1RESL_RES2_LENGTH                                0x1
#define _AT1RESL_RES2_MASK                                  0x4
#define _AT1RESL_RES3_POSN                                  0x3
#define _AT1RESL_RES3_POSITION                              0x3
#define _AT1RESL_RES3_SIZE                                  0x1
#define _AT1RESL_RES3_LENGTH                                0x1
#define _AT1RESL_RES3_MASK                                  0x8
#define _AT1RESL_RES4_POSN                                  0x4
#define _AT1RESL_RES4_POSITION                              0x4
#define _AT1RESL_RES4_SIZE                                  0x1
#define _AT1RESL_RES4_LENGTH                                0x1
#define _AT1RESL_RES4_MASK                                  0x10
#define _AT1RESL_RES5_POSN                                  0x5
#define _AT1RESL_RES5_POSITION                              0x5
#define _AT1RESL_RES5_SIZE                                  0x1
#define _AT1RESL_RES5_LENGTH                                0x1
#define _AT1RESL_RES5_MASK                                  0x20
#define _AT1RESL_RES6_POSN                                  0x6
#define _AT1RESL_RES6_POSITION                              0x6
#define _AT1RESL_RES6_SIZE                                  0x1
#define _AT1RESL_RES6_LENGTH                                0x1
#define _AT1RESL_RES6_MASK                                  0x40
#define _AT1RESL_RES7_POSN                                  0x7
#define _AT1RESL_RES7_POSITION                              0x7
#define _AT1RESL_RES7_SIZE                                  0x1
#define _AT1RESL_RES7_LENGTH                                0x1
#define _AT1RESL_RES7_MASK                                  0x80

// Register: AT1RESH
extern volatile unsigned char           AT1RESH             @ 0x80D;
#ifndef _LIB_BUILD
asm("AT1RESH equ 080Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1RES8                :1;
        unsigned AT1RES9                :1;
    };
    struct {
        unsigned RES8                   :1;
        unsigned RES9                   :1;
    };
} AT1RESHbits_t;
extern volatile AT1RESHbits_t AT1RESHbits @ 0x80D;
// bitfield macros
#define _AT1RESH_AT1RES8_POSN                               0x0
#define _AT1RESH_AT1RES8_POSITION                           0x0
#define _AT1RESH_AT1RES8_SIZE                               0x1
#define _AT1RESH_AT1RES8_LENGTH                             0x1
#define _AT1RESH_AT1RES8_MASK                               0x1
#define _AT1RESH_AT1RES9_POSN                               0x1
#define _AT1RESH_AT1RES9_POSITION                           0x1
#define _AT1RESH_AT1RES9_SIZE                               0x1
#define _AT1RESH_AT1RES9_LENGTH                             0x1
#define _AT1RESH_AT1RES9_MASK                               0x2
#define _AT1RESH_RES8_POSN                                  0x0
#define _AT1RESH_RES8_POSITION                              0x0
#define _AT1RESH_RES8_SIZE                                  0x1
#define _AT1RESH_RES8_LENGTH                                0x1
#define _AT1RESH_RES8_MASK                                  0x1
#define _AT1RESH_RES9_POSN                                  0x1
#define _AT1RESH_RES9_POSITION                              0x1
#define _AT1RESH_RES9_SIZE                                  0x1
#define _AT1RESH_RES9_LENGTH                                0x1
#define _AT1RESH_RES9_MASK                                  0x2

// Register: AT1MISS
extern volatile unsigned short          AT1MISS             @ 0x80E;
#ifndef _LIB_BUILD
asm("AT1MISS equ 080Eh");
#endif

// Register: AT1MISSL
extern volatile unsigned char           AT1MISSL            @ 0x80E;
#ifndef _LIB_BUILD
asm("AT1MISSL equ 080Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1MISS0               :1;
        unsigned AT1MISS1               :1;
        unsigned AT1MISS2               :1;
        unsigned AT1MISS3               :1;
        unsigned AT1MISS4               :1;
        unsigned AT1MISS5               :1;
        unsigned AT1MISS6               :1;
        unsigned AT1MISS7               :1;
    };
    struct {
        unsigned MISS0                  :1;
        unsigned MISS1                  :1;
        unsigned MISS2                  :1;
        unsigned MISS3                  :1;
        unsigned MISS4                  :1;
        unsigned MISS5                  :1;
        unsigned MISS6                  :1;
        unsigned MISS7                  :1;
    };
} AT1MISSLbits_t;
extern volatile AT1MISSLbits_t AT1MISSLbits @ 0x80E;
// bitfield macros
#define _AT1MISSL_AT1MISS0_POSN                             0x0
#define _AT1MISSL_AT1MISS0_POSITION                         0x0
#define _AT1MISSL_AT1MISS0_SIZE                             0x1
#define _AT1MISSL_AT1MISS0_LENGTH                           0x1
#define _AT1MISSL_AT1MISS0_MASK                             0x1
#define _AT1MISSL_AT1MISS1_POSN                             0x1
#define _AT1MISSL_AT1MISS1_POSITION                         0x1
#define _AT1MISSL_AT1MISS1_SIZE                             0x1
#define _AT1MISSL_AT1MISS1_LENGTH                           0x1
#define _AT1MISSL_AT1MISS1_MASK                             0x2
#define _AT1MISSL_AT1MISS2_POSN                             0x2
#define _AT1MISSL_AT1MISS2_POSITION                         0x2
#define _AT1MISSL_AT1MISS2_SIZE                             0x1
#define _AT1MISSL_AT1MISS2_LENGTH                           0x1
#define _AT1MISSL_AT1MISS2_MASK                             0x4
#define _AT1MISSL_AT1MISS3_POSN                             0x3
#define _AT1MISSL_AT1MISS3_POSITION                         0x3
#define _AT1MISSL_AT1MISS3_SIZE                             0x1
#define _AT1MISSL_AT1MISS3_LENGTH                           0x1
#define _AT1MISSL_AT1MISS3_MASK                             0x8
#define _AT1MISSL_AT1MISS4_POSN                             0x4
#define _AT1MISSL_AT1MISS4_POSITION                         0x4
#define _AT1MISSL_AT1MISS4_SIZE                             0x1
#define _AT1MISSL_AT1MISS4_LENGTH                           0x1
#define _AT1MISSL_AT1MISS4_MASK                             0x10
#define _AT1MISSL_AT1MISS5_POSN                             0x5
#define _AT1MISSL_AT1MISS5_POSITION                         0x5
#define _AT1MISSL_AT1MISS5_SIZE                             0x1
#define _AT1MISSL_AT1MISS5_LENGTH                           0x1
#define _AT1MISSL_AT1MISS5_MASK                             0x20
#define _AT1MISSL_AT1MISS6_POSN                             0x6
#define _AT1MISSL_AT1MISS6_POSITION                         0x6
#define _AT1MISSL_AT1MISS6_SIZE                             0x1
#define _AT1MISSL_AT1MISS6_LENGTH                           0x1
#define _AT1MISSL_AT1MISS6_MASK                             0x40
#define _AT1MISSL_AT1MISS7_POSN                             0x7
#define _AT1MISSL_AT1MISS7_POSITION                         0x7
#define _AT1MISSL_AT1MISS7_SIZE                             0x1
#define _AT1MISSL_AT1MISS7_LENGTH                           0x1
#define _AT1MISSL_AT1MISS7_MASK                             0x80
#define _AT1MISSL_MISS0_POSN                                0x0
#define _AT1MISSL_MISS0_POSITION                            0x0
#define _AT1MISSL_MISS0_SIZE                                0x1
#define _AT1MISSL_MISS0_LENGTH                              0x1
#define _AT1MISSL_MISS0_MASK                                0x1
#define _AT1MISSL_MISS1_POSN                                0x1
#define _AT1MISSL_MISS1_POSITION                            0x1
#define _AT1MISSL_MISS1_SIZE                                0x1
#define _AT1MISSL_MISS1_LENGTH                              0x1
#define _AT1MISSL_MISS1_MASK                                0x2
#define _AT1MISSL_MISS2_POSN                                0x2
#define _AT1MISSL_MISS2_POSITION                            0x2
#define _AT1MISSL_MISS2_SIZE                                0x1
#define _AT1MISSL_MISS2_LENGTH                              0x1
#define _AT1MISSL_MISS2_MASK                                0x4
#define _AT1MISSL_MISS3_POSN                                0x3
#define _AT1MISSL_MISS3_POSITION                            0x3
#define _AT1MISSL_MISS3_SIZE                                0x1
#define _AT1MISSL_MISS3_LENGTH                              0x1
#define _AT1MISSL_MISS3_MASK                                0x8
#define _AT1MISSL_MISS4_POSN                                0x4
#define _AT1MISSL_MISS4_POSITION                            0x4
#define _AT1MISSL_MISS4_SIZE                                0x1
#define _AT1MISSL_MISS4_LENGTH                              0x1
#define _AT1MISSL_MISS4_MASK                                0x10
#define _AT1MISSL_MISS5_POSN                                0x5
#define _AT1MISSL_MISS5_POSITION                            0x5
#define _AT1MISSL_MISS5_SIZE                                0x1
#define _AT1MISSL_MISS5_LENGTH                              0x1
#define _AT1MISSL_MISS5_MASK                                0x20
#define _AT1MISSL_MISS6_POSN                                0x6
#define _AT1MISSL_MISS6_POSITION                            0x6
#define _AT1MISSL_MISS6_SIZE                                0x1
#define _AT1MISSL_MISS6_LENGTH                              0x1
#define _AT1MISSL_MISS6_MASK                                0x40
#define _AT1MISSL_MISS7_POSN                                0x7
#define _AT1MISSL_MISS7_POSITION                            0x7
#define _AT1MISSL_MISS7_SIZE                                0x1
#define _AT1MISSL_MISS7_LENGTH                              0x1
#define _AT1MISSL_MISS7_MASK                                0x80

// Register: AT1MISSH
extern volatile unsigned char           AT1MISSH            @ 0x80F;
#ifndef _LIB_BUILD
asm("AT1MISSH equ 080Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1MISS8               :1;
        unsigned AT1MISS9               :1;
        unsigned AT1MISS10              :1;
        unsigned AT1MISS11              :1;
        unsigned AT1MISS12              :1;
        unsigned AT1MISS13              :1;
        unsigned AT1MISS14              :1;
        unsigned AT1MISS15              :1;
    };
    struct {
        unsigned MISS8                  :1;
        unsigned MISS9                  :1;
        unsigned MISS10                 :1;
        unsigned MISS11                 :1;
        unsigned MISS12                 :1;
        unsigned MISS13                 :1;
        unsigned MISS14                 :1;
        unsigned MISS15                 :1;
    };
} AT1MISSHbits_t;
extern volatile AT1MISSHbits_t AT1MISSHbits @ 0x80F;
// bitfield macros
#define _AT1MISSH_AT1MISS8_POSN                             0x0
#define _AT1MISSH_AT1MISS8_POSITION                         0x0
#define _AT1MISSH_AT1MISS8_SIZE                             0x1
#define _AT1MISSH_AT1MISS8_LENGTH                           0x1
#define _AT1MISSH_AT1MISS8_MASK                             0x1
#define _AT1MISSH_AT1MISS9_POSN                             0x1
#define _AT1MISSH_AT1MISS9_POSITION                         0x1
#define _AT1MISSH_AT1MISS9_SIZE                             0x1
#define _AT1MISSH_AT1MISS9_LENGTH                           0x1
#define _AT1MISSH_AT1MISS9_MASK                             0x2
#define _AT1MISSH_AT1MISS10_POSN                            0x2
#define _AT1MISSH_AT1MISS10_POSITION                        0x2
#define _AT1MISSH_AT1MISS10_SIZE                            0x1
#define _AT1MISSH_AT1MISS10_LENGTH                          0x1
#define _AT1MISSH_AT1MISS10_MASK                            0x4
#define _AT1MISSH_AT1MISS11_POSN                            0x3
#define _AT1MISSH_AT1MISS11_POSITION                        0x3
#define _AT1MISSH_AT1MISS11_SIZE                            0x1
#define _AT1MISSH_AT1MISS11_LENGTH                          0x1
#define _AT1MISSH_AT1MISS11_MASK                            0x8
#define _AT1MISSH_AT1MISS12_POSN                            0x4
#define _AT1MISSH_AT1MISS12_POSITION                        0x4
#define _AT1MISSH_AT1MISS12_SIZE                            0x1
#define _AT1MISSH_AT1MISS12_LENGTH                          0x1
#define _AT1MISSH_AT1MISS12_MASK                            0x10
#define _AT1MISSH_AT1MISS13_POSN                            0x5
#define _AT1MISSH_AT1MISS13_POSITION                        0x5
#define _AT1MISSH_AT1MISS13_SIZE                            0x1
#define _AT1MISSH_AT1MISS13_LENGTH                          0x1
#define _AT1MISSH_AT1MISS13_MASK                            0x20
#define _AT1MISSH_AT1MISS14_POSN                            0x6
#define _AT1MISSH_AT1MISS14_POSITION                        0x6
#define _AT1MISSH_AT1MISS14_SIZE                            0x1
#define _AT1MISSH_AT1MISS14_LENGTH                          0x1
#define _AT1MISSH_AT1MISS14_MASK                            0x40
#define _AT1MISSH_AT1MISS15_POSN                            0x7
#define _AT1MISSH_AT1MISS15_POSITION                        0x7
#define _AT1MISSH_AT1MISS15_SIZE                            0x1
#define _AT1MISSH_AT1MISS15_LENGTH                          0x1
#define _AT1MISSH_AT1MISS15_MASK                            0x80
#define _AT1MISSH_MISS8_POSN                                0x0
#define _AT1MISSH_MISS8_POSITION                            0x0
#define _AT1MISSH_MISS8_SIZE                                0x1
#define _AT1MISSH_MISS8_LENGTH                              0x1
#define _AT1MISSH_MISS8_MASK                                0x1
#define _AT1MISSH_MISS9_POSN                                0x1
#define _AT1MISSH_MISS9_POSITION                            0x1
#define _AT1MISSH_MISS9_SIZE                                0x1
#define _AT1MISSH_MISS9_LENGTH                              0x1
#define _AT1MISSH_MISS9_MASK                                0x2
#define _AT1MISSH_MISS10_POSN                               0x2
#define _AT1MISSH_MISS10_POSITION                           0x2
#define _AT1MISSH_MISS10_SIZE                               0x1
#define _AT1MISSH_MISS10_LENGTH                             0x1
#define _AT1MISSH_MISS10_MASK                               0x4
#define _AT1MISSH_MISS11_POSN                               0x3
#define _AT1MISSH_MISS11_POSITION                           0x3
#define _AT1MISSH_MISS11_SIZE                               0x1
#define _AT1MISSH_MISS11_LENGTH                             0x1
#define _AT1MISSH_MISS11_MASK                               0x8
#define _AT1MISSH_MISS12_POSN                               0x4
#define _AT1MISSH_MISS12_POSITION                           0x4
#define _AT1MISSH_MISS12_SIZE                               0x1
#define _AT1MISSH_MISS12_LENGTH                             0x1
#define _AT1MISSH_MISS12_MASK                               0x10
#define _AT1MISSH_MISS13_POSN                               0x5
#define _AT1MISSH_MISS13_POSITION                           0x5
#define _AT1MISSH_MISS13_SIZE                               0x1
#define _AT1MISSH_MISS13_LENGTH                             0x1
#define _AT1MISSH_MISS13_MASK                               0x20
#define _AT1MISSH_MISS14_POSN                               0x6
#define _AT1MISSH_MISS14_POSITION                           0x6
#define _AT1MISSH_MISS14_SIZE                               0x1
#define _AT1MISSH_MISS14_LENGTH                             0x1
#define _AT1MISSH_MISS14_MASK                               0x40
#define _AT1MISSH_MISS15_POSN                               0x7
#define _AT1MISSH_MISS15_POSITION                           0x7
#define _AT1MISSH_MISS15_SIZE                               0x1
#define _AT1MISSH_MISS15_LENGTH                             0x1
#define _AT1MISSH_MISS15_MASK                               0x80

// Register: AT1PER
extern volatile unsigned short          AT1PER              @ 0x810;
#ifndef _LIB_BUILD
asm("AT1PER equ 0810h");
#endif

// Register: AT1PERL
extern volatile unsigned char           AT1PERL             @ 0x810;
#ifndef _LIB_BUILD
asm("AT1PERL equ 0810h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1PER0                :1;
        unsigned AT1PER1                :1;
        unsigned AT1PER2                :1;
        unsigned AT1PER3                :1;
        unsigned AT1PER4                :1;
        unsigned AT1PER5                :1;
        unsigned AT1PER6                :1;
        unsigned AT1PER7                :1;
    };
    struct {
        unsigned PER0                   :1;
        unsigned PER1                   :1;
        unsigned PER2                   :1;
        unsigned PER3                   :1;
        unsigned PER4                   :1;
        unsigned PER5                   :1;
        unsigned PER6                   :1;
        unsigned PER7                   :1;
    };
    struct {
        unsigned PERL0                  :1;
        unsigned PERL1                  :1;
        unsigned PERL2                  :1;
        unsigned PERL3                  :1;
        unsigned PERL4                  :1;
        unsigned PERL5                  :1;
        unsigned PERL6                  :1;
        unsigned PERL7                  :1;
    };
} AT1PERLbits_t;
extern volatile AT1PERLbits_t AT1PERLbits @ 0x810;
// bitfield macros
#define _AT1PERL_AT1PER0_POSN                               0x0
#define _AT1PERL_AT1PER0_POSITION                           0x0
#define _AT1PERL_AT1PER0_SIZE                               0x1
#define _AT1PERL_AT1PER0_LENGTH                             0x1
#define _AT1PERL_AT1PER0_MASK                               0x1
#define _AT1PERL_AT1PER1_POSN                               0x1
#define _AT1PERL_AT1PER1_POSITION                           0x1
#define _AT1PERL_AT1PER1_SIZE                               0x1
#define _AT1PERL_AT1PER1_LENGTH                             0x1
#define _AT1PERL_AT1PER1_MASK                               0x2
#define _AT1PERL_AT1PER2_POSN                               0x2
#define _AT1PERL_AT1PER2_POSITION                           0x2
#define _AT1PERL_AT1PER2_SIZE                               0x1
#define _AT1PERL_AT1PER2_LENGTH                             0x1
#define _AT1PERL_AT1PER2_MASK                               0x4
#define _AT1PERL_AT1PER3_POSN                               0x3
#define _AT1PERL_AT1PER3_POSITION                           0x3
#define _AT1PERL_AT1PER3_SIZE                               0x1
#define _AT1PERL_AT1PER3_LENGTH                             0x1
#define _AT1PERL_AT1PER3_MASK                               0x8
#define _AT1PERL_AT1PER4_POSN                               0x4
#define _AT1PERL_AT1PER4_POSITION                           0x4
#define _AT1PERL_AT1PER4_SIZE                               0x1
#define _AT1PERL_AT1PER4_LENGTH                             0x1
#define _AT1PERL_AT1PER4_MASK                               0x10
#define _AT1PERL_AT1PER5_POSN                               0x5
#define _AT1PERL_AT1PER5_POSITION                           0x5
#define _AT1PERL_AT1PER5_SIZE                               0x1
#define _AT1PERL_AT1PER5_LENGTH                             0x1
#define _AT1PERL_AT1PER5_MASK                               0x20
#define _AT1PERL_AT1PER6_POSN                               0x6
#define _AT1PERL_AT1PER6_POSITION                           0x6
#define _AT1PERL_AT1PER6_SIZE                               0x1
#define _AT1PERL_AT1PER6_LENGTH                             0x1
#define _AT1PERL_AT1PER6_MASK                               0x40
#define _AT1PERL_AT1PER7_POSN                               0x7
#define _AT1PERL_AT1PER7_POSITION                           0x7
#define _AT1PERL_AT1PER7_SIZE                               0x1
#define _AT1PERL_AT1PER7_LENGTH                             0x1
#define _AT1PERL_AT1PER7_MASK                               0x80
#define _AT1PERL_PER0_POSN                                  0x0
#define _AT1PERL_PER0_POSITION                              0x0
#define _AT1PERL_PER0_SIZE                                  0x1
#define _AT1PERL_PER0_LENGTH                                0x1
#define _AT1PERL_PER0_MASK                                  0x1
#define _AT1PERL_PER1_POSN                                  0x1
#define _AT1PERL_PER1_POSITION                              0x1
#define _AT1PERL_PER1_SIZE                                  0x1
#define _AT1PERL_PER1_LENGTH                                0x1
#define _AT1PERL_PER1_MASK                                  0x2
#define _AT1PERL_PER2_POSN                                  0x2
#define _AT1PERL_PER2_POSITION                              0x2
#define _AT1PERL_PER2_SIZE                                  0x1
#define _AT1PERL_PER2_LENGTH                                0x1
#define _AT1PERL_PER2_MASK                                  0x4
#define _AT1PERL_PER3_POSN                                  0x3
#define _AT1PERL_PER3_POSITION                              0x3
#define _AT1PERL_PER3_SIZE                                  0x1
#define _AT1PERL_PER3_LENGTH                                0x1
#define _AT1PERL_PER3_MASK                                  0x8
#define _AT1PERL_PER4_POSN                                  0x4
#define _AT1PERL_PER4_POSITION                              0x4
#define _AT1PERL_PER4_SIZE                                  0x1
#define _AT1PERL_PER4_LENGTH                                0x1
#define _AT1PERL_PER4_MASK                                  0x10
#define _AT1PERL_PER5_POSN                                  0x5
#define _AT1PERL_PER5_POSITION                              0x5
#define _AT1PERL_PER5_SIZE                                  0x1
#define _AT1PERL_PER5_LENGTH                                0x1
#define _AT1PERL_PER5_MASK                                  0x20
#define _AT1PERL_PER6_POSN                                  0x6
#define _AT1PERL_PER6_POSITION                              0x6
#define _AT1PERL_PER6_SIZE                                  0x1
#define _AT1PERL_PER6_LENGTH                                0x1
#define _AT1PERL_PER6_MASK                                  0x40
#define _AT1PERL_PER7_POSN                                  0x7
#define _AT1PERL_PER7_POSITION                              0x7
#define _AT1PERL_PER7_SIZE                                  0x1
#define _AT1PERL_PER7_LENGTH                                0x1
#define _AT1PERL_PER7_MASK                                  0x80
#define _AT1PERL_PERL0_POSN                                 0x0
#define _AT1PERL_PERL0_POSITION                             0x0
#define _AT1PERL_PERL0_SIZE                                 0x1
#define _AT1PERL_PERL0_LENGTH                               0x1
#define _AT1PERL_PERL0_MASK                                 0x1
#define _AT1PERL_PERL1_POSN                                 0x1
#define _AT1PERL_PERL1_POSITION                             0x1
#define _AT1PERL_PERL1_SIZE                                 0x1
#define _AT1PERL_PERL1_LENGTH                               0x1
#define _AT1PERL_PERL1_MASK                                 0x2
#define _AT1PERL_PERL2_POSN                                 0x2
#define _AT1PERL_PERL2_POSITION                             0x2
#define _AT1PERL_PERL2_SIZE                                 0x1
#define _AT1PERL_PERL2_LENGTH                               0x1
#define _AT1PERL_PERL2_MASK                                 0x4
#define _AT1PERL_PERL3_POSN                                 0x3
#define _AT1PERL_PERL3_POSITION                             0x3
#define _AT1PERL_PERL3_SIZE                                 0x1
#define _AT1PERL_PERL3_LENGTH                               0x1
#define _AT1PERL_PERL3_MASK                                 0x8
#define _AT1PERL_PERL4_POSN                                 0x4
#define _AT1PERL_PERL4_POSITION                             0x4
#define _AT1PERL_PERL4_SIZE                                 0x1
#define _AT1PERL_PERL4_LENGTH                               0x1
#define _AT1PERL_PERL4_MASK                                 0x10
#define _AT1PERL_PERL5_POSN                                 0x5
#define _AT1PERL_PERL5_POSITION                             0x5
#define _AT1PERL_PERL5_SIZE                                 0x1
#define _AT1PERL_PERL5_LENGTH                               0x1
#define _AT1PERL_PERL5_MASK                                 0x20
#define _AT1PERL_PERL6_POSN                                 0x6
#define _AT1PERL_PERL6_POSITION                             0x6
#define _AT1PERL_PERL6_SIZE                                 0x1
#define _AT1PERL_PERL6_LENGTH                               0x1
#define _AT1PERL_PERL6_MASK                                 0x40
#define _AT1PERL_PERL7_POSN                                 0x7
#define _AT1PERL_PERL7_POSITION                             0x7
#define _AT1PERL_PERL7_SIZE                                 0x1
#define _AT1PERL_PERL7_LENGTH                               0x1
#define _AT1PERL_PERL7_MASK                                 0x80

// Register: AT1PERH
extern volatile unsigned char           AT1PERH             @ 0x811;
#ifndef _LIB_BUILD
asm("AT1PERH equ 0811h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1PER8                :1;
        unsigned AT1PER9                :1;
        unsigned AT1PER10               :1;
        unsigned AT1PER11               :1;
        unsigned AT1PER12               :1;
        unsigned AT1PER13               :1;
        unsigned AT1PER14               :1;
        unsigned AT1POV                 :1;
    };
    struct {
        unsigned PER8                   :1;
        unsigned PER9                   :1;
        unsigned PER10                  :1;
        unsigned PER11                  :1;
        unsigned PER12                  :1;
        unsigned PER13                  :1;
        unsigned PER14                  :1;
        unsigned PER15                  :1;
    };
    struct {
        unsigned PERH0                  :1;
        unsigned PERH1                  :1;
        unsigned PERH2                  :1;
        unsigned PERH3                  :1;
        unsigned PERH4                  :1;
        unsigned PERH5                  :1;
        unsigned PERH6                  :1;
        unsigned PERH7                  :1;
    };
} AT1PERHbits_t;
extern volatile AT1PERHbits_t AT1PERHbits @ 0x811;
// bitfield macros
#define _AT1PERH_AT1PER8_POSN                               0x0
#define _AT1PERH_AT1PER8_POSITION                           0x0
#define _AT1PERH_AT1PER8_SIZE                               0x1
#define _AT1PERH_AT1PER8_LENGTH                             0x1
#define _AT1PERH_AT1PER8_MASK                               0x1
#define _AT1PERH_AT1PER9_POSN                               0x1
#define _AT1PERH_AT1PER9_POSITION                           0x1
#define _AT1PERH_AT1PER9_SIZE                               0x1
#define _AT1PERH_AT1PER9_LENGTH                             0x1
#define _AT1PERH_AT1PER9_MASK                               0x2
#define _AT1PERH_AT1PER10_POSN                              0x2
#define _AT1PERH_AT1PER10_POSITION                          0x2
#define _AT1PERH_AT1PER10_SIZE                              0x1
#define _AT1PERH_AT1PER10_LENGTH                            0x1
#define _AT1PERH_AT1PER10_MASK                              0x4
#define _AT1PERH_AT1PER11_POSN                              0x3
#define _AT1PERH_AT1PER11_POSITION                          0x3
#define _AT1PERH_AT1PER11_SIZE                              0x1
#define _AT1PERH_AT1PER11_LENGTH                            0x1
#define _AT1PERH_AT1PER11_MASK                              0x8
#define _AT1PERH_AT1PER12_POSN                              0x4
#define _AT1PERH_AT1PER12_POSITION                          0x4
#define _AT1PERH_AT1PER12_SIZE                              0x1
#define _AT1PERH_AT1PER12_LENGTH                            0x1
#define _AT1PERH_AT1PER12_MASK                              0x10
#define _AT1PERH_AT1PER13_POSN                              0x5
#define _AT1PERH_AT1PER13_POSITION                          0x5
#define _AT1PERH_AT1PER13_SIZE                              0x1
#define _AT1PERH_AT1PER13_LENGTH                            0x1
#define _AT1PERH_AT1PER13_MASK                              0x20
#define _AT1PERH_AT1PER14_POSN                              0x6
#define _AT1PERH_AT1PER14_POSITION                          0x6
#define _AT1PERH_AT1PER14_SIZE                              0x1
#define _AT1PERH_AT1PER14_LENGTH                            0x1
#define _AT1PERH_AT1PER14_MASK                              0x40
#define _AT1PERH_AT1POV_POSN                                0x7
#define _AT1PERH_AT1POV_POSITION                            0x7
#define _AT1PERH_AT1POV_SIZE                                0x1
#define _AT1PERH_AT1POV_LENGTH                              0x1
#define _AT1PERH_AT1POV_MASK                                0x80
#define _AT1PERH_PER8_POSN                                  0x0
#define _AT1PERH_PER8_POSITION                              0x0
#define _AT1PERH_PER8_SIZE                                  0x1
#define _AT1PERH_PER8_LENGTH                                0x1
#define _AT1PERH_PER8_MASK                                  0x1
#define _AT1PERH_PER9_POSN                                  0x1
#define _AT1PERH_PER9_POSITION                              0x1
#define _AT1PERH_PER9_SIZE                                  0x1
#define _AT1PERH_PER9_LENGTH                                0x1
#define _AT1PERH_PER9_MASK                                  0x2
#define _AT1PERH_PER10_POSN                                 0x2
#define _AT1PERH_PER10_POSITION                             0x2
#define _AT1PERH_PER10_SIZE                                 0x1
#define _AT1PERH_PER10_LENGTH                               0x1
#define _AT1PERH_PER10_MASK                                 0x4
#define _AT1PERH_PER11_POSN                                 0x3
#define _AT1PERH_PER11_POSITION                             0x3
#define _AT1PERH_PER11_SIZE                                 0x1
#define _AT1PERH_PER11_LENGTH                               0x1
#define _AT1PERH_PER11_MASK                                 0x8
#define _AT1PERH_PER12_POSN                                 0x4
#define _AT1PERH_PER12_POSITION                             0x4
#define _AT1PERH_PER12_SIZE                                 0x1
#define _AT1PERH_PER12_LENGTH                               0x1
#define _AT1PERH_PER12_MASK                                 0x10
#define _AT1PERH_PER13_POSN                                 0x5
#define _AT1PERH_PER13_POSITION                             0x5
#define _AT1PERH_PER13_SIZE                                 0x1
#define _AT1PERH_PER13_LENGTH                               0x1
#define _AT1PERH_PER13_MASK                                 0x20
#define _AT1PERH_PER14_POSN                                 0x6
#define _AT1PERH_PER14_POSITION                             0x6
#define _AT1PERH_PER14_SIZE                                 0x1
#define _AT1PERH_PER14_LENGTH                               0x1
#define _AT1PERH_PER14_MASK                                 0x40
#define _AT1PERH_PER15_POSN                                 0x7
#define _AT1PERH_PER15_POSITION                             0x7
#define _AT1PERH_PER15_SIZE                                 0x1
#define _AT1PERH_PER15_LENGTH                               0x1
#define _AT1PERH_PER15_MASK                                 0x80
#define _AT1PERH_PERH0_POSN                                 0x0
#define _AT1PERH_PERH0_POSITION                             0x0
#define _AT1PERH_PERH0_SIZE                                 0x1
#define _AT1PERH_PERH0_LENGTH                               0x1
#define _AT1PERH_PERH0_MASK                                 0x1
#define _AT1PERH_PERH1_POSN                                 0x1
#define _AT1PERH_PERH1_POSITION                             0x1
#define _AT1PERH_PERH1_SIZE                                 0x1
#define _AT1PERH_PERH1_LENGTH                               0x1
#define _AT1PERH_PERH1_MASK                                 0x2
#define _AT1PERH_PERH2_POSN                                 0x2
#define _AT1PERH_PERH2_POSITION                             0x2
#define _AT1PERH_PERH2_SIZE                                 0x1
#define _AT1PERH_PERH2_LENGTH                               0x1
#define _AT1PERH_PERH2_MASK                                 0x4
#define _AT1PERH_PERH3_POSN                                 0x3
#define _AT1PERH_PERH3_POSITION                             0x3
#define _AT1PERH_PERH3_SIZE                                 0x1
#define _AT1PERH_PERH3_LENGTH                               0x1
#define _AT1PERH_PERH3_MASK                                 0x8
#define _AT1PERH_PERH4_POSN                                 0x4
#define _AT1PERH_PERH4_POSITION                             0x4
#define _AT1PERH_PERH4_SIZE                                 0x1
#define _AT1PERH_PERH4_LENGTH                               0x1
#define _AT1PERH_PERH4_MASK                                 0x10
#define _AT1PERH_PERH5_POSN                                 0x5
#define _AT1PERH_PERH5_POSITION                             0x5
#define _AT1PERH_PERH5_SIZE                                 0x1
#define _AT1PERH_PERH5_LENGTH                               0x1
#define _AT1PERH_PERH5_MASK                                 0x20
#define _AT1PERH_PERH6_POSN                                 0x6
#define _AT1PERH_PERH6_POSITION                             0x6
#define _AT1PERH_PERH6_SIZE                                 0x1
#define _AT1PERH_PERH6_LENGTH                               0x1
#define _AT1PERH_PERH6_MASK                                 0x40
#define _AT1PERH_PERH7_POSN                                 0x7
#define _AT1PERH_PERH7_POSITION                             0x7
#define _AT1PERH_PERH7_SIZE                                 0x1
#define _AT1PERH_PERH7_LENGTH                               0x1
#define _AT1PERH_PERH7_MASK                                 0x80

// Register: AT1PHS
extern volatile unsigned short          AT1PHS              @ 0x812;
#ifndef _LIB_BUILD
asm("AT1PHS equ 0812h");
#endif

// Register: AT1PHSL
extern volatile unsigned char           AT1PHSL             @ 0x812;
#ifndef _LIB_BUILD
asm("AT1PHSL equ 0812h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1PHS0                :1;
        unsigned AT1PHS1                :1;
        unsigned AT1PHS2                :1;
        unsigned AT1PHS3                :1;
        unsigned AT1PHS4                :1;
        unsigned AT1PHS5                :1;
        unsigned AT1PHS6                :1;
        unsigned AT1PHS7                :1;
    };
    struct {
        unsigned PHS0                   :1;
        unsigned PHS1                   :1;
        unsigned PHS2                   :1;
        unsigned PHS3                   :1;
        unsigned PHS4                   :1;
        unsigned PHS5                   :1;
        unsigned PHS6                   :1;
        unsigned PHS7                   :1;
    };
} AT1PHSLbits_t;
extern volatile AT1PHSLbits_t AT1PHSLbits @ 0x812;
// bitfield macros
#define _AT1PHSL_AT1PHS0_POSN                               0x0
#define _AT1PHSL_AT1PHS0_POSITION                           0x0
#define _AT1PHSL_AT1PHS0_SIZE                               0x1
#define _AT1PHSL_AT1PHS0_LENGTH                             0x1
#define _AT1PHSL_AT1PHS0_MASK                               0x1
#define _AT1PHSL_AT1PHS1_POSN                               0x1
#define _AT1PHSL_AT1PHS1_POSITION                           0x1
#define _AT1PHSL_AT1PHS1_SIZE                               0x1
#define _AT1PHSL_AT1PHS1_LENGTH                             0x1
#define _AT1PHSL_AT1PHS1_MASK                               0x2
#define _AT1PHSL_AT1PHS2_POSN                               0x2
#define _AT1PHSL_AT1PHS2_POSITION                           0x2
#define _AT1PHSL_AT1PHS2_SIZE                               0x1
#define _AT1PHSL_AT1PHS2_LENGTH                             0x1
#define _AT1PHSL_AT1PHS2_MASK                               0x4
#define _AT1PHSL_AT1PHS3_POSN                               0x3
#define _AT1PHSL_AT1PHS3_POSITION                           0x3
#define _AT1PHSL_AT1PHS3_SIZE                               0x1
#define _AT1PHSL_AT1PHS3_LENGTH                             0x1
#define _AT1PHSL_AT1PHS3_MASK                               0x8
#define _AT1PHSL_AT1PHS4_POSN                               0x4
#define _AT1PHSL_AT1PHS4_POSITION                           0x4
#define _AT1PHSL_AT1PHS4_SIZE                               0x1
#define _AT1PHSL_AT1PHS4_LENGTH                             0x1
#define _AT1PHSL_AT1PHS4_MASK                               0x10
#define _AT1PHSL_AT1PHS5_POSN                               0x5
#define _AT1PHSL_AT1PHS5_POSITION                           0x5
#define _AT1PHSL_AT1PHS5_SIZE                               0x1
#define _AT1PHSL_AT1PHS5_LENGTH                             0x1
#define _AT1PHSL_AT1PHS5_MASK                               0x20
#define _AT1PHSL_AT1PHS6_POSN                               0x6
#define _AT1PHSL_AT1PHS6_POSITION                           0x6
#define _AT1PHSL_AT1PHS6_SIZE                               0x1
#define _AT1PHSL_AT1PHS6_LENGTH                             0x1
#define _AT1PHSL_AT1PHS6_MASK                               0x40
#define _AT1PHSL_AT1PHS7_POSN                               0x7
#define _AT1PHSL_AT1PHS7_POSITION                           0x7
#define _AT1PHSL_AT1PHS7_SIZE                               0x1
#define _AT1PHSL_AT1PHS7_LENGTH                             0x1
#define _AT1PHSL_AT1PHS7_MASK                               0x80
#define _AT1PHSL_PHS0_POSN                                  0x0
#define _AT1PHSL_PHS0_POSITION                              0x0
#define _AT1PHSL_PHS0_SIZE                                  0x1
#define _AT1PHSL_PHS0_LENGTH                                0x1
#define _AT1PHSL_PHS0_MASK                                  0x1
#define _AT1PHSL_PHS1_POSN                                  0x1
#define _AT1PHSL_PHS1_POSITION                              0x1
#define _AT1PHSL_PHS1_SIZE                                  0x1
#define _AT1PHSL_PHS1_LENGTH                                0x1
#define _AT1PHSL_PHS1_MASK                                  0x2
#define _AT1PHSL_PHS2_POSN                                  0x2
#define _AT1PHSL_PHS2_POSITION                              0x2
#define _AT1PHSL_PHS2_SIZE                                  0x1
#define _AT1PHSL_PHS2_LENGTH                                0x1
#define _AT1PHSL_PHS2_MASK                                  0x4
#define _AT1PHSL_PHS3_POSN                                  0x3
#define _AT1PHSL_PHS3_POSITION                              0x3
#define _AT1PHSL_PHS3_SIZE                                  0x1
#define _AT1PHSL_PHS3_LENGTH                                0x1
#define _AT1PHSL_PHS3_MASK                                  0x8
#define _AT1PHSL_PHS4_POSN                                  0x4
#define _AT1PHSL_PHS4_POSITION                              0x4
#define _AT1PHSL_PHS4_SIZE                                  0x1
#define _AT1PHSL_PHS4_LENGTH                                0x1
#define _AT1PHSL_PHS4_MASK                                  0x10
#define _AT1PHSL_PHS5_POSN                                  0x5
#define _AT1PHSL_PHS5_POSITION                              0x5
#define _AT1PHSL_PHS5_SIZE                                  0x1
#define _AT1PHSL_PHS5_LENGTH                                0x1
#define _AT1PHSL_PHS5_MASK                                  0x20
#define _AT1PHSL_PHS6_POSN                                  0x6
#define _AT1PHSL_PHS6_POSITION                              0x6
#define _AT1PHSL_PHS6_SIZE                                  0x1
#define _AT1PHSL_PHS6_LENGTH                                0x1
#define _AT1PHSL_PHS6_MASK                                  0x40
#define _AT1PHSL_PHS7_POSN                                  0x7
#define _AT1PHSL_PHS7_POSITION                              0x7
#define _AT1PHSL_PHS7_SIZE                                  0x1
#define _AT1PHSL_PHS7_LENGTH                                0x1
#define _AT1PHSL_PHS7_MASK                                  0x80

// Register: AT1PHSH
extern volatile unsigned char           AT1PHSH             @ 0x813;
#ifndef _LIB_BUILD
asm("AT1PHSH equ 0813h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1PHS8                :1;
        unsigned AT1PHS9                :1;
    };
    struct {
        unsigned PHS8                   :1;
        unsigned PHS9                   :1;
    };
    struct {
        unsigned PHSL8                  :1;
        unsigned PHSL9                  :1;
    };
} AT1PHSHbits_t;
extern volatile AT1PHSHbits_t AT1PHSHbits @ 0x813;
// bitfield macros
#define _AT1PHSH_AT1PHS8_POSN                               0x0
#define _AT1PHSH_AT1PHS8_POSITION                           0x0
#define _AT1PHSH_AT1PHS8_SIZE                               0x1
#define _AT1PHSH_AT1PHS8_LENGTH                             0x1
#define _AT1PHSH_AT1PHS8_MASK                               0x1
#define _AT1PHSH_AT1PHS9_POSN                               0x1
#define _AT1PHSH_AT1PHS9_POSITION                           0x1
#define _AT1PHSH_AT1PHS9_SIZE                               0x1
#define _AT1PHSH_AT1PHS9_LENGTH                             0x1
#define _AT1PHSH_AT1PHS9_MASK                               0x2
#define _AT1PHSH_PHS8_POSN                                  0x0
#define _AT1PHSH_PHS8_POSITION                              0x0
#define _AT1PHSH_PHS8_SIZE                                  0x1
#define _AT1PHSH_PHS8_LENGTH                                0x1
#define _AT1PHSH_PHS8_MASK                                  0x1
#define _AT1PHSH_PHS9_POSN                                  0x1
#define _AT1PHSH_PHS9_POSITION                              0x1
#define _AT1PHSH_PHS9_SIZE                                  0x1
#define _AT1PHSH_PHS9_LENGTH                                0x1
#define _AT1PHSH_PHS9_MASK                                  0x2
#define _AT1PHSH_PHSL8_POSN                                 0x0
#define _AT1PHSH_PHSL8_POSITION                             0x0
#define _AT1PHSH_PHSL8_SIZE                                 0x1
#define _AT1PHSH_PHSL8_LENGTH                               0x1
#define _AT1PHSH_PHSL8_MASK                                 0x1
#define _AT1PHSH_PHSL9_POSN                                 0x1
#define _AT1PHSH_PHSL9_POSITION                             0x1
#define _AT1PHSH_PHSL9_SIZE                                 0x1
#define _AT1PHSH_PHSL9_LENGTH                               0x1
#define _AT1PHSH_PHSL9_MASK                                 0x2

// Register: AT1CON0
extern volatile unsigned char           AT1CON0             @ 0x814;
#ifndef _LIB_BUILD
asm("AT1CON0 equ 0814h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned MODE                   :1;
        unsigned APMOD                  :1;
        unsigned                        :1;
        unsigned POL                    :1;
        unsigned PS                     :2;
        unsigned PREC                   :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned                        :4;
        unsigned PS0                    :1;
        unsigned PS1                    :1;
    };
    struct {
        unsigned AT1MODE                :1;
        unsigned AT1APMOD               :1;
        unsigned                        :1;
        unsigned AT1POL                 :1;
        unsigned AT1PS                  :2;
        unsigned AT1PREC                :1;
        unsigned AT1EN                  :1;
    };
    struct {
        unsigned                        :4;
        unsigned AT1PS0                 :1;
        unsigned AT1PS1                 :1;
    };
} AT1CON0bits_t;
extern volatile AT1CON0bits_t AT1CON0bits @ 0x814;
// bitfield macros
#define _AT1CON0_MODE_POSN                                  0x0
#define _AT1CON0_MODE_POSITION                              0x0
#define _AT1CON0_MODE_SIZE                                  0x1
#define _AT1CON0_MODE_LENGTH                                0x1
#define _AT1CON0_MODE_MASK                                  0x1
#define _AT1CON0_APMOD_POSN                                 0x1
#define _AT1CON0_APMOD_POSITION                             0x1
#define _AT1CON0_APMOD_SIZE                                 0x1
#define _AT1CON0_APMOD_LENGTH                               0x1
#define _AT1CON0_APMOD_MASK                                 0x2
#define _AT1CON0_POL_POSN                                   0x3
#define _AT1CON0_POL_POSITION                               0x3
#define _AT1CON0_POL_SIZE                                   0x1
#define _AT1CON0_POL_LENGTH                                 0x1
#define _AT1CON0_POL_MASK                                   0x8
#define _AT1CON0_PS_POSN                                    0x4
#define _AT1CON0_PS_POSITION                                0x4
#define _AT1CON0_PS_SIZE                                    0x2
#define _AT1CON0_PS_LENGTH                                  0x2
#define _AT1CON0_PS_MASK                                    0x30
#define _AT1CON0_PREC_POSN                                  0x6
#define _AT1CON0_PREC_POSITION                              0x6
#define _AT1CON0_PREC_SIZE                                  0x1
#define _AT1CON0_PREC_LENGTH                                0x1
#define _AT1CON0_PREC_MASK                                  0x40
#define _AT1CON0_EN_POSN                                    0x7
#define _AT1CON0_EN_POSITION                                0x7
#define _AT1CON0_EN_SIZE                                    0x1
#define _AT1CON0_EN_LENGTH                                  0x1
#define _AT1CON0_EN_MASK                                    0x80
#define _AT1CON0_PS0_POSN                                   0x4
#define _AT1CON0_PS0_POSITION                               0x4
#define _AT1CON0_PS0_SIZE                                   0x1
#define _AT1CON0_PS0_LENGTH                                 0x1
#define _AT1CON0_PS0_MASK                                   0x10
#define _AT1CON0_PS1_POSN                                   0x5
#define _AT1CON0_PS1_POSITION                               0x5
#define _AT1CON0_PS1_SIZE                                   0x1
#define _AT1CON0_PS1_LENGTH                                 0x1
#define _AT1CON0_PS1_MASK                                   0x20
#define _AT1CON0_AT1MODE_POSN                               0x0
#define _AT1CON0_AT1MODE_POSITION                           0x0
#define _AT1CON0_AT1MODE_SIZE                               0x1
#define _AT1CON0_AT1MODE_LENGTH                             0x1
#define _AT1CON0_AT1MODE_MASK                               0x1
#define _AT1CON0_AT1APMOD_POSN                              0x1
#define _AT1CON0_AT1APMOD_POSITION                          0x1
#define _AT1CON0_AT1APMOD_SIZE                              0x1
#define _AT1CON0_AT1APMOD_LENGTH                            0x1
#define _AT1CON0_AT1APMOD_MASK                              0x2
#define _AT1CON0_AT1POL_POSN                                0x3
#define _AT1CON0_AT1POL_POSITION                            0x3
#define _AT1CON0_AT1POL_SIZE                                0x1
#define _AT1CON0_AT1POL_LENGTH                              0x1
#define _AT1CON0_AT1POL_MASK                                0x8
#define _AT1CON0_AT1PS_POSN                                 0x4
#define _AT1CON0_AT1PS_POSITION                             0x4
#define _AT1CON0_AT1PS_SIZE                                 0x2
#define _AT1CON0_AT1PS_LENGTH                               0x2
#define _AT1CON0_AT1PS_MASK                                 0x30
#define _AT1CON0_AT1PREC_POSN                               0x6
#define _AT1CON0_AT1PREC_POSITION                           0x6
#define _AT1CON0_AT1PREC_SIZE                               0x1
#define _AT1CON0_AT1PREC_LENGTH                             0x1
#define _AT1CON0_AT1PREC_MASK                               0x40
#define _AT1CON0_AT1EN_POSN                                 0x7
#define _AT1CON0_AT1EN_POSITION                             0x7
#define _AT1CON0_AT1EN_SIZE                                 0x1
#define _AT1CON0_AT1EN_LENGTH                               0x1
#define _AT1CON0_AT1EN_MASK                                 0x80
#define _AT1CON0_AT1PS0_POSN                                0x4
#define _AT1CON0_AT1PS0_POSITION                            0x4
#define _AT1CON0_AT1PS0_SIZE                                0x1
#define _AT1CON0_AT1PS0_LENGTH                              0x1
#define _AT1CON0_AT1PS0_MASK                                0x10
#define _AT1CON0_AT1PS1_POSN                                0x5
#define _AT1CON0_AT1PS1_POSITION                            0x5
#define _AT1CON0_AT1PS1_SIZE                                0x1
#define _AT1CON0_AT1PS1_LENGTH                              0x1
#define _AT1CON0_AT1PS1_MASK                                0x20

// Register: AT1CON1
extern volatile unsigned char           AT1CON1             @ 0x815;
#ifndef _LIB_BUILD
asm("AT1CON1 equ 0815h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned VALID                  :1;
        unsigned ACCS                   :1;
        unsigned MPP                    :1;
        unsigned                        :1;
        unsigned PRP                    :1;
        unsigned                        :1;
        unsigned PHP                    :1;
    };
    struct {
        unsigned AT1VALID               :1;
        unsigned AT1ACCS                :1;
        unsigned AT1MPP                 :1;
        unsigned                        :1;
        unsigned AT1PRP                 :1;
        unsigned                        :1;
        unsigned AT1PHP                 :1;
    };
} AT1CON1bits_t;
extern volatile AT1CON1bits_t AT1CON1bits @ 0x815;
// bitfield macros
#define _AT1CON1_VALID_POSN                                 0x0
#define _AT1CON1_VALID_POSITION                             0x0
#define _AT1CON1_VALID_SIZE                                 0x1
#define _AT1CON1_VALID_LENGTH                               0x1
#define _AT1CON1_VALID_MASK                                 0x1
#define _AT1CON1_ACCS_POSN                                  0x1
#define _AT1CON1_ACCS_POSITION                              0x1
#define _AT1CON1_ACCS_SIZE                                  0x1
#define _AT1CON1_ACCS_LENGTH                                0x1
#define _AT1CON1_ACCS_MASK                                  0x2
#define _AT1CON1_MPP_POSN                                   0x2
#define _AT1CON1_MPP_POSITION                               0x2
#define _AT1CON1_MPP_SIZE                                   0x1
#define _AT1CON1_MPP_LENGTH                                 0x1
#define _AT1CON1_MPP_MASK                                   0x4
#define _AT1CON1_PRP_POSN                                   0x4
#define _AT1CON1_PRP_POSITION                               0x4
#define _AT1CON1_PRP_SIZE                                   0x1
#define _AT1CON1_PRP_LENGTH                                 0x1
#define _AT1CON1_PRP_MASK                                   0x10
#define _AT1CON1_PHP_POSN                                   0x6
#define _AT1CON1_PHP_POSITION                               0x6
#define _AT1CON1_PHP_SIZE                                   0x1
#define _AT1CON1_PHP_LENGTH                                 0x1
#define _AT1CON1_PHP_MASK                                   0x40
#define _AT1CON1_AT1VALID_POSN                              0x0
#define _AT1CON1_AT1VALID_POSITION                          0x0
#define _AT1CON1_AT1VALID_SIZE                              0x1
#define _AT1CON1_AT1VALID_LENGTH                            0x1
#define _AT1CON1_AT1VALID_MASK                              0x1
#define _AT1CON1_AT1ACCS_POSN                               0x1
#define _AT1CON1_AT1ACCS_POSITION                           0x1
#define _AT1CON1_AT1ACCS_SIZE                               0x1
#define _AT1CON1_AT1ACCS_LENGTH                             0x1
#define _AT1CON1_AT1ACCS_MASK                               0x2
#define _AT1CON1_AT1MPP_POSN                                0x2
#define _AT1CON1_AT1MPP_POSITION                            0x2
#define _AT1CON1_AT1MPP_SIZE                                0x1
#define _AT1CON1_AT1MPP_LENGTH                              0x1
#define _AT1CON1_AT1MPP_MASK                                0x4
#define _AT1CON1_AT1PRP_POSN                                0x4
#define _AT1CON1_AT1PRP_POSITION                            0x4
#define _AT1CON1_AT1PRP_SIZE                                0x1
#define _AT1CON1_AT1PRP_LENGTH                              0x1
#define _AT1CON1_AT1PRP_MASK                                0x10
#define _AT1CON1_AT1PHP_POSN                                0x6
#define _AT1CON1_AT1PHP_POSITION                            0x6
#define _AT1CON1_AT1PHP_SIZE                                0x1
#define _AT1CON1_AT1PHP_LENGTH                              0x1
#define _AT1CON1_AT1PHP_MASK                                0x40

// Register: AT1IR0
extern volatile unsigned char           AT1IR0              @ 0x816;
#ifndef _LIB_BUILD
asm("AT1IR0 equ 0816h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1PERIF               :1;
        unsigned AT1MISSIF              :1;
        unsigned AT1PHSIF               :1;
    };
} AT1IR0bits_t;
extern volatile AT1IR0bits_t AT1IR0bits @ 0x816;
// bitfield macros
#define _AT1IR0_AT1PERIF_POSN                               0x0
#define _AT1IR0_AT1PERIF_POSITION                           0x0
#define _AT1IR0_AT1PERIF_SIZE                               0x1
#define _AT1IR0_AT1PERIF_LENGTH                             0x1
#define _AT1IR0_AT1PERIF_MASK                               0x1
#define _AT1IR0_AT1MISSIF_POSN                              0x1
#define _AT1IR0_AT1MISSIF_POSITION                          0x1
#define _AT1IR0_AT1MISSIF_SIZE                              0x1
#define _AT1IR0_AT1MISSIF_LENGTH                            0x1
#define _AT1IR0_AT1MISSIF_MASK                              0x2
#define _AT1IR0_AT1PHSIF_POSN                               0x2
#define _AT1IR0_AT1PHSIF_POSITION                           0x2
#define _AT1IR0_AT1PHSIF_SIZE                               0x1
#define _AT1IR0_AT1PHSIF_LENGTH                             0x1
#define _AT1IR0_AT1PHSIF_MASK                               0x4

// Register: AT1IE0
extern volatile unsigned char           AT1IE0              @ 0x817;
#ifndef _LIB_BUILD
asm("AT1IE0 equ 0817h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1PERIE               :1;
        unsigned AT1MISSIE              :1;
        unsigned AT1PHSIE               :1;
    };
} AT1IE0bits_t;
extern volatile AT1IE0bits_t AT1IE0bits @ 0x817;
// bitfield macros
#define _AT1IE0_AT1PERIE_POSN                               0x0
#define _AT1IE0_AT1PERIE_POSITION                           0x0
#define _AT1IE0_AT1PERIE_SIZE                               0x1
#define _AT1IE0_AT1PERIE_LENGTH                             0x1
#define _AT1IE0_AT1PERIE_MASK                               0x1
#define _AT1IE0_AT1MISSIE_POSN                              0x1
#define _AT1IE0_AT1MISSIE_POSITION                          0x1
#define _AT1IE0_AT1MISSIE_SIZE                              0x1
#define _AT1IE0_AT1MISSIE_LENGTH                            0x1
#define _AT1IE0_AT1MISSIE_MASK                              0x2
#define _AT1IE0_AT1PHSIE_POSN                               0x2
#define _AT1IE0_AT1PHSIE_POSITION                           0x2
#define _AT1IE0_AT1PHSIE_SIZE                               0x1
#define _AT1IE0_AT1PHSIE_LENGTH                             0x1
#define _AT1IE0_AT1PHSIE_MASK                               0x4

// Register: AT1IR1
extern volatile unsigned char           AT1IR1              @ 0x818;
#ifndef _LIB_BUILD
asm("AT1IR1 equ 0818h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CC1IF               :1;
        unsigned AT1CC2IF               :1;
        unsigned AT1CC3IF               :1;
    };
} AT1IR1bits_t;
extern volatile AT1IR1bits_t AT1IR1bits @ 0x818;
// bitfield macros
#define _AT1IR1_AT1CC1IF_POSN                               0x0
#define _AT1IR1_AT1CC1IF_POSITION                           0x0
#define _AT1IR1_AT1CC1IF_SIZE                               0x1
#define _AT1IR1_AT1CC1IF_LENGTH                             0x1
#define _AT1IR1_AT1CC1IF_MASK                               0x1
#define _AT1IR1_AT1CC2IF_POSN                               0x1
#define _AT1IR1_AT1CC2IF_POSITION                           0x1
#define _AT1IR1_AT1CC2IF_SIZE                               0x1
#define _AT1IR1_AT1CC2IF_LENGTH                             0x1
#define _AT1IR1_AT1CC2IF_MASK                               0x2
#define _AT1IR1_AT1CC3IF_POSN                               0x2
#define _AT1IR1_AT1CC3IF_POSITION                           0x2
#define _AT1IR1_AT1CC3IF_SIZE                               0x1
#define _AT1IR1_AT1CC3IF_LENGTH                             0x1
#define _AT1IR1_AT1CC3IF_MASK                               0x4

// Register: AT1IE1
extern volatile unsigned char           AT1IE1              @ 0x819;
#ifndef _LIB_BUILD
asm("AT1IE1 equ 0819h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CC1IE               :1;
        unsigned AT1CC2IE               :1;
        unsigned AT1CC3IE               :1;
    };
} AT1IE1bits_t;
extern volatile AT1IE1bits_t AT1IE1bits @ 0x819;
// bitfield macros
#define _AT1IE1_AT1CC1IE_POSN                               0x0
#define _AT1IE1_AT1CC1IE_POSITION                           0x0
#define _AT1IE1_AT1CC1IE_SIZE                               0x1
#define _AT1IE1_AT1CC1IE_LENGTH                             0x1
#define _AT1IE1_AT1CC1IE_MASK                               0x1
#define _AT1IE1_AT1CC2IE_POSN                               0x1
#define _AT1IE1_AT1CC2IE_POSITION                           0x1
#define _AT1IE1_AT1CC2IE_SIZE                               0x1
#define _AT1IE1_AT1CC2IE_LENGTH                             0x1
#define _AT1IE1_AT1CC2IE_MASK                               0x2
#define _AT1IE1_AT1CC3IE_POSN                               0x2
#define _AT1IE1_AT1CC3IE_POSITION                           0x2
#define _AT1IE1_AT1CC3IE_SIZE                               0x1
#define _AT1IE1_AT1CC3IE_LENGTH                             0x1
#define _AT1IE1_AT1CC3IE_MASK                               0x4

// Register: AT1STPT
extern volatile unsigned short          AT1STPT             @ 0x81A;
#ifndef _LIB_BUILD
asm("AT1STPT equ 081Ah");
#endif

// Register: AT1STPTL
extern volatile unsigned char           AT1STPTL            @ 0x81A;
#ifndef _LIB_BUILD
asm("AT1STPTL equ 081Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1STPT0               :1;
        unsigned AT1STPT1               :1;
        unsigned AT1STPT2               :1;
        unsigned AT1STPT3               :1;
        unsigned AT1STPT4               :1;
        unsigned AT1STPT5               :1;
        unsigned AT1STPT6               :1;
        unsigned AT1STPT7               :1;
    };
    struct {
        unsigned STPT0                  :1;
        unsigned STPT1                  :1;
        unsigned STPT2                  :1;
        unsigned STPT3                  :1;
        unsigned STPT4                  :1;
        unsigned STPT5                  :1;
        unsigned STPT6                  :1;
        unsigned STPT7                  :1;
    };
} AT1STPTLbits_t;
extern volatile AT1STPTLbits_t AT1STPTLbits @ 0x81A;
// bitfield macros
#define _AT1STPTL_AT1STPT0_POSN                             0x0
#define _AT1STPTL_AT1STPT0_POSITION                         0x0
#define _AT1STPTL_AT1STPT0_SIZE                             0x1
#define _AT1STPTL_AT1STPT0_LENGTH                           0x1
#define _AT1STPTL_AT1STPT0_MASK                             0x1
#define _AT1STPTL_AT1STPT1_POSN                             0x1
#define _AT1STPTL_AT1STPT1_POSITION                         0x1
#define _AT1STPTL_AT1STPT1_SIZE                             0x1
#define _AT1STPTL_AT1STPT1_LENGTH                           0x1
#define _AT1STPTL_AT1STPT1_MASK                             0x2
#define _AT1STPTL_AT1STPT2_POSN                             0x2
#define _AT1STPTL_AT1STPT2_POSITION                         0x2
#define _AT1STPTL_AT1STPT2_SIZE                             0x1
#define _AT1STPTL_AT1STPT2_LENGTH                           0x1
#define _AT1STPTL_AT1STPT2_MASK                             0x4
#define _AT1STPTL_AT1STPT3_POSN                             0x3
#define _AT1STPTL_AT1STPT3_POSITION                         0x3
#define _AT1STPTL_AT1STPT3_SIZE                             0x1
#define _AT1STPTL_AT1STPT3_LENGTH                           0x1
#define _AT1STPTL_AT1STPT3_MASK                             0x8
#define _AT1STPTL_AT1STPT4_POSN                             0x4
#define _AT1STPTL_AT1STPT4_POSITION                         0x4
#define _AT1STPTL_AT1STPT4_SIZE                             0x1
#define _AT1STPTL_AT1STPT4_LENGTH                           0x1
#define _AT1STPTL_AT1STPT4_MASK                             0x10
#define _AT1STPTL_AT1STPT5_POSN                             0x5
#define _AT1STPTL_AT1STPT5_POSITION                         0x5
#define _AT1STPTL_AT1STPT5_SIZE                             0x1
#define _AT1STPTL_AT1STPT5_LENGTH                           0x1
#define _AT1STPTL_AT1STPT5_MASK                             0x20
#define _AT1STPTL_AT1STPT6_POSN                             0x6
#define _AT1STPTL_AT1STPT6_POSITION                         0x6
#define _AT1STPTL_AT1STPT6_SIZE                             0x1
#define _AT1STPTL_AT1STPT6_LENGTH                           0x1
#define _AT1STPTL_AT1STPT6_MASK                             0x40
#define _AT1STPTL_AT1STPT7_POSN                             0x7
#define _AT1STPTL_AT1STPT7_POSITION                         0x7
#define _AT1STPTL_AT1STPT7_SIZE                             0x1
#define _AT1STPTL_AT1STPT7_LENGTH                           0x1
#define _AT1STPTL_AT1STPT7_MASK                             0x80
#define _AT1STPTL_STPT0_POSN                                0x0
#define _AT1STPTL_STPT0_POSITION                            0x0
#define _AT1STPTL_STPT0_SIZE                                0x1
#define _AT1STPTL_STPT0_LENGTH                              0x1
#define _AT1STPTL_STPT0_MASK                                0x1
#define _AT1STPTL_STPT1_POSN                                0x1
#define _AT1STPTL_STPT1_POSITION                            0x1
#define _AT1STPTL_STPT1_SIZE                                0x1
#define _AT1STPTL_STPT1_LENGTH                              0x1
#define _AT1STPTL_STPT1_MASK                                0x2
#define _AT1STPTL_STPT2_POSN                                0x2
#define _AT1STPTL_STPT2_POSITION                            0x2
#define _AT1STPTL_STPT2_SIZE                                0x1
#define _AT1STPTL_STPT2_LENGTH                              0x1
#define _AT1STPTL_STPT2_MASK                                0x4
#define _AT1STPTL_STPT3_POSN                                0x3
#define _AT1STPTL_STPT3_POSITION                            0x3
#define _AT1STPTL_STPT3_SIZE                                0x1
#define _AT1STPTL_STPT3_LENGTH                              0x1
#define _AT1STPTL_STPT3_MASK                                0x8
#define _AT1STPTL_STPT4_POSN                                0x4
#define _AT1STPTL_STPT4_POSITION                            0x4
#define _AT1STPTL_STPT4_SIZE                                0x1
#define _AT1STPTL_STPT4_LENGTH                              0x1
#define _AT1STPTL_STPT4_MASK                                0x10
#define _AT1STPTL_STPT5_POSN                                0x5
#define _AT1STPTL_STPT5_POSITION                            0x5
#define _AT1STPTL_STPT5_SIZE                                0x1
#define _AT1STPTL_STPT5_LENGTH                              0x1
#define _AT1STPTL_STPT5_MASK                                0x20
#define _AT1STPTL_STPT6_POSN                                0x6
#define _AT1STPTL_STPT6_POSITION                            0x6
#define _AT1STPTL_STPT6_SIZE                                0x1
#define _AT1STPTL_STPT6_LENGTH                              0x1
#define _AT1STPTL_STPT6_MASK                                0x40
#define _AT1STPTL_STPT7_POSN                                0x7
#define _AT1STPTL_STPT7_POSITION                            0x7
#define _AT1STPTL_STPT7_SIZE                                0x1
#define _AT1STPTL_STPT7_LENGTH                              0x1
#define _AT1STPTL_STPT7_MASK                                0x80

// Register: AT1STPTH
extern volatile unsigned char           AT1STPTH            @ 0x81B;
#ifndef _LIB_BUILD
asm("AT1STPTH equ 081Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1STPT8               :1;
        unsigned AT1STPT9               :1;
        unsigned AT1STPT10              :1;
        unsigned AT1STPT11              :1;
        unsigned AT1STPT12              :1;
        unsigned AT1STPT13              :1;
        unsigned AT1STPT14              :1;
    };
    struct {
        unsigned STPT8                  :1;
        unsigned STPT9                  :1;
        unsigned STPT10                 :1;
        unsigned STPT11                 :1;
        unsigned STPT12                 :1;
        unsigned STPT13                 :1;
        unsigned STPT14                 :1;
    };
} AT1STPTHbits_t;
extern volatile AT1STPTHbits_t AT1STPTHbits @ 0x81B;
// bitfield macros
#define _AT1STPTH_AT1STPT8_POSN                             0x0
#define _AT1STPTH_AT1STPT8_POSITION                         0x0
#define _AT1STPTH_AT1STPT8_SIZE                             0x1
#define _AT1STPTH_AT1STPT8_LENGTH                           0x1
#define _AT1STPTH_AT1STPT8_MASK                             0x1
#define _AT1STPTH_AT1STPT9_POSN                             0x1
#define _AT1STPTH_AT1STPT9_POSITION                         0x1
#define _AT1STPTH_AT1STPT9_SIZE                             0x1
#define _AT1STPTH_AT1STPT9_LENGTH                           0x1
#define _AT1STPTH_AT1STPT9_MASK                             0x2
#define _AT1STPTH_AT1STPT10_POSN                            0x2
#define _AT1STPTH_AT1STPT10_POSITION                        0x2
#define _AT1STPTH_AT1STPT10_SIZE                            0x1
#define _AT1STPTH_AT1STPT10_LENGTH                          0x1
#define _AT1STPTH_AT1STPT10_MASK                            0x4
#define _AT1STPTH_AT1STPT11_POSN                            0x3
#define _AT1STPTH_AT1STPT11_POSITION                        0x3
#define _AT1STPTH_AT1STPT11_SIZE                            0x1
#define _AT1STPTH_AT1STPT11_LENGTH                          0x1
#define _AT1STPTH_AT1STPT11_MASK                            0x8
#define _AT1STPTH_AT1STPT12_POSN                            0x4
#define _AT1STPTH_AT1STPT12_POSITION                        0x4
#define _AT1STPTH_AT1STPT12_SIZE                            0x1
#define _AT1STPTH_AT1STPT12_LENGTH                          0x1
#define _AT1STPTH_AT1STPT12_MASK                            0x10
#define _AT1STPTH_AT1STPT13_POSN                            0x5
#define _AT1STPTH_AT1STPT13_POSITION                        0x5
#define _AT1STPTH_AT1STPT13_SIZE                            0x1
#define _AT1STPTH_AT1STPT13_LENGTH                          0x1
#define _AT1STPTH_AT1STPT13_MASK                            0x20
#define _AT1STPTH_AT1STPT14_POSN                            0x6
#define _AT1STPTH_AT1STPT14_POSITION                        0x6
#define _AT1STPTH_AT1STPT14_SIZE                            0x1
#define _AT1STPTH_AT1STPT14_LENGTH                          0x1
#define _AT1STPTH_AT1STPT14_MASK                            0x40
#define _AT1STPTH_STPT8_POSN                                0x0
#define _AT1STPTH_STPT8_POSITION                            0x0
#define _AT1STPTH_STPT8_SIZE                                0x1
#define _AT1STPTH_STPT8_LENGTH                              0x1
#define _AT1STPTH_STPT8_MASK                                0x1
#define _AT1STPTH_STPT9_POSN                                0x1
#define _AT1STPTH_STPT9_POSITION                            0x1
#define _AT1STPTH_STPT9_SIZE                                0x1
#define _AT1STPTH_STPT9_LENGTH                              0x1
#define _AT1STPTH_STPT9_MASK                                0x2
#define _AT1STPTH_STPT10_POSN                               0x2
#define _AT1STPTH_STPT10_POSITION                           0x2
#define _AT1STPTH_STPT10_SIZE                               0x1
#define _AT1STPTH_STPT10_LENGTH                             0x1
#define _AT1STPTH_STPT10_MASK                               0x4
#define _AT1STPTH_STPT11_POSN                               0x3
#define _AT1STPTH_STPT11_POSITION                           0x3
#define _AT1STPTH_STPT11_SIZE                               0x1
#define _AT1STPTH_STPT11_LENGTH                             0x1
#define _AT1STPTH_STPT11_MASK                               0x8
#define _AT1STPTH_STPT12_POSN                               0x4
#define _AT1STPTH_STPT12_POSITION                           0x4
#define _AT1STPTH_STPT12_SIZE                               0x1
#define _AT1STPTH_STPT12_LENGTH                             0x1
#define _AT1STPTH_STPT12_MASK                               0x10
#define _AT1STPTH_STPT13_POSN                               0x5
#define _AT1STPTH_STPT13_POSITION                           0x5
#define _AT1STPTH_STPT13_SIZE                               0x1
#define _AT1STPTH_STPT13_LENGTH                             0x1
#define _AT1STPTH_STPT13_MASK                               0x20
#define _AT1STPTH_STPT14_POSN                               0x6
#define _AT1STPTH_STPT14_POSITION                           0x6
#define _AT1STPTH_STPT14_SIZE                               0x1
#define _AT1STPTH_STPT14_LENGTH                             0x1
#define _AT1STPTH_STPT14_MASK                               0x40

// Register: AT1ERR
extern volatile unsigned short          AT1ERR              @ 0x81C;
#ifndef _LIB_BUILD
asm("AT1ERR equ 081Ch");
#endif

// Register: AT1ERRL
extern volatile unsigned char           AT1ERRL             @ 0x81C;
#ifndef _LIB_BUILD
asm("AT1ERRL equ 081Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1ERR0                :1;
        unsigned AT1ERR1                :1;
        unsigned AT1ERR2                :1;
        unsigned AT1ERR3                :1;
        unsigned AT1ERR4                :1;
        unsigned AT1ERR5                :1;
        unsigned AT1ERR6                :1;
        unsigned AT1ERR7                :1;
    };
    struct {
        unsigned ERR0                   :1;
        unsigned ERR1                   :1;
        unsigned ERR2                   :1;
        unsigned ERR3                   :1;
        unsigned ERR4                   :1;
        unsigned ERR5                   :1;
        unsigned ERR6                   :1;
        unsigned ERR7                   :1;
    };
    struct {
        unsigned ERRL0                  :1;
        unsigned ERRL1                  :1;
        unsigned ERRL2                  :1;
        unsigned ERRL3                  :1;
        unsigned ERRL4                  :1;
        unsigned ERRL5                  :1;
        unsigned ERRL6                  :1;
        unsigned ERRL7                  :1;
    };
} AT1ERRLbits_t;
extern volatile AT1ERRLbits_t AT1ERRLbits @ 0x81C;
// bitfield macros
#define _AT1ERRL_AT1ERR0_POSN                               0x0
#define _AT1ERRL_AT1ERR0_POSITION                           0x0
#define _AT1ERRL_AT1ERR0_SIZE                               0x1
#define _AT1ERRL_AT1ERR0_LENGTH                             0x1
#define _AT1ERRL_AT1ERR0_MASK                               0x1
#define _AT1ERRL_AT1ERR1_POSN                               0x1
#define _AT1ERRL_AT1ERR1_POSITION                           0x1
#define _AT1ERRL_AT1ERR1_SIZE                               0x1
#define _AT1ERRL_AT1ERR1_LENGTH                             0x1
#define _AT1ERRL_AT1ERR1_MASK                               0x2
#define _AT1ERRL_AT1ERR2_POSN                               0x2
#define _AT1ERRL_AT1ERR2_POSITION                           0x2
#define _AT1ERRL_AT1ERR2_SIZE                               0x1
#define _AT1ERRL_AT1ERR2_LENGTH                             0x1
#define _AT1ERRL_AT1ERR2_MASK                               0x4
#define _AT1ERRL_AT1ERR3_POSN                               0x3
#define _AT1ERRL_AT1ERR3_POSITION                           0x3
#define _AT1ERRL_AT1ERR3_SIZE                               0x1
#define _AT1ERRL_AT1ERR3_LENGTH                             0x1
#define _AT1ERRL_AT1ERR3_MASK                               0x8
#define _AT1ERRL_AT1ERR4_POSN                               0x4
#define _AT1ERRL_AT1ERR4_POSITION                           0x4
#define _AT1ERRL_AT1ERR4_SIZE                               0x1
#define _AT1ERRL_AT1ERR4_LENGTH                             0x1
#define _AT1ERRL_AT1ERR4_MASK                               0x10
#define _AT1ERRL_AT1ERR5_POSN                               0x5
#define _AT1ERRL_AT1ERR5_POSITION                           0x5
#define _AT1ERRL_AT1ERR5_SIZE                               0x1
#define _AT1ERRL_AT1ERR5_LENGTH                             0x1
#define _AT1ERRL_AT1ERR5_MASK                               0x20
#define _AT1ERRL_AT1ERR6_POSN                               0x6
#define _AT1ERRL_AT1ERR6_POSITION                           0x6
#define _AT1ERRL_AT1ERR6_SIZE                               0x1
#define _AT1ERRL_AT1ERR6_LENGTH                             0x1
#define _AT1ERRL_AT1ERR6_MASK                               0x40
#define _AT1ERRL_AT1ERR7_POSN                               0x7
#define _AT1ERRL_AT1ERR7_POSITION                           0x7
#define _AT1ERRL_AT1ERR7_SIZE                               0x1
#define _AT1ERRL_AT1ERR7_LENGTH                             0x1
#define _AT1ERRL_AT1ERR7_MASK                               0x80
#define _AT1ERRL_ERR0_POSN                                  0x0
#define _AT1ERRL_ERR0_POSITION                              0x0
#define _AT1ERRL_ERR0_SIZE                                  0x1
#define _AT1ERRL_ERR0_LENGTH                                0x1
#define _AT1ERRL_ERR0_MASK                                  0x1
#define _AT1ERRL_ERR1_POSN                                  0x1
#define _AT1ERRL_ERR1_POSITION                              0x1
#define _AT1ERRL_ERR1_SIZE                                  0x1
#define _AT1ERRL_ERR1_LENGTH                                0x1
#define _AT1ERRL_ERR1_MASK                                  0x2
#define _AT1ERRL_ERR2_POSN                                  0x2
#define _AT1ERRL_ERR2_POSITION                              0x2
#define _AT1ERRL_ERR2_SIZE                                  0x1
#define _AT1ERRL_ERR2_LENGTH                                0x1
#define _AT1ERRL_ERR2_MASK                                  0x4
#define _AT1ERRL_ERR3_POSN                                  0x3
#define _AT1ERRL_ERR3_POSITION                              0x3
#define _AT1ERRL_ERR3_SIZE                                  0x1
#define _AT1ERRL_ERR3_LENGTH                                0x1
#define _AT1ERRL_ERR3_MASK                                  0x8
#define _AT1ERRL_ERR4_POSN                                  0x4
#define _AT1ERRL_ERR4_POSITION                              0x4
#define _AT1ERRL_ERR4_SIZE                                  0x1
#define _AT1ERRL_ERR4_LENGTH                                0x1
#define _AT1ERRL_ERR4_MASK                                  0x10
#define _AT1ERRL_ERR5_POSN                                  0x5
#define _AT1ERRL_ERR5_POSITION                              0x5
#define _AT1ERRL_ERR5_SIZE                                  0x1
#define _AT1ERRL_ERR5_LENGTH                                0x1
#define _AT1ERRL_ERR5_MASK                                  0x20
#define _AT1ERRL_ERR6_POSN                                  0x6
#define _AT1ERRL_ERR6_POSITION                              0x6
#define _AT1ERRL_ERR6_SIZE                                  0x1
#define _AT1ERRL_ERR6_LENGTH                                0x1
#define _AT1ERRL_ERR6_MASK                                  0x40
#define _AT1ERRL_ERR7_POSN                                  0x7
#define _AT1ERRL_ERR7_POSITION                              0x7
#define _AT1ERRL_ERR7_SIZE                                  0x1
#define _AT1ERRL_ERR7_LENGTH                                0x1
#define _AT1ERRL_ERR7_MASK                                  0x80
#define _AT1ERRL_ERRL0_POSN                                 0x0
#define _AT1ERRL_ERRL0_POSITION                             0x0
#define _AT1ERRL_ERRL0_SIZE                                 0x1
#define _AT1ERRL_ERRL0_LENGTH                               0x1
#define _AT1ERRL_ERRL0_MASK                                 0x1
#define _AT1ERRL_ERRL1_POSN                                 0x1
#define _AT1ERRL_ERRL1_POSITION                             0x1
#define _AT1ERRL_ERRL1_SIZE                                 0x1
#define _AT1ERRL_ERRL1_LENGTH                               0x1
#define _AT1ERRL_ERRL1_MASK                                 0x2
#define _AT1ERRL_ERRL2_POSN                                 0x2
#define _AT1ERRL_ERRL2_POSITION                             0x2
#define _AT1ERRL_ERRL2_SIZE                                 0x1
#define _AT1ERRL_ERRL2_LENGTH                               0x1
#define _AT1ERRL_ERRL2_MASK                                 0x4
#define _AT1ERRL_ERRL3_POSN                                 0x3
#define _AT1ERRL_ERRL3_POSITION                             0x3
#define _AT1ERRL_ERRL3_SIZE                                 0x1
#define _AT1ERRL_ERRL3_LENGTH                               0x1
#define _AT1ERRL_ERRL3_MASK                                 0x8
#define _AT1ERRL_ERRL4_POSN                                 0x4
#define _AT1ERRL_ERRL4_POSITION                             0x4
#define _AT1ERRL_ERRL4_SIZE                                 0x1
#define _AT1ERRL_ERRL4_LENGTH                               0x1
#define _AT1ERRL_ERRL4_MASK                                 0x10
#define _AT1ERRL_ERRL5_POSN                                 0x5
#define _AT1ERRL_ERRL5_POSITION                             0x5
#define _AT1ERRL_ERRL5_SIZE                                 0x1
#define _AT1ERRL_ERRL5_LENGTH                               0x1
#define _AT1ERRL_ERRL5_MASK                                 0x20
#define _AT1ERRL_ERRL6_POSN                                 0x6
#define _AT1ERRL_ERRL6_POSITION                             0x6
#define _AT1ERRL_ERRL6_SIZE                                 0x1
#define _AT1ERRL_ERRL6_LENGTH                               0x1
#define _AT1ERRL_ERRL6_MASK                                 0x40
#define _AT1ERRL_ERRL7_POSN                                 0x7
#define _AT1ERRL_ERRL7_POSITION                             0x7
#define _AT1ERRL_ERRL7_SIZE                                 0x1
#define _AT1ERRL_ERRL7_LENGTH                               0x1
#define _AT1ERRL_ERRL7_MASK                                 0x80

// Register: AT1ERRH
extern volatile unsigned char           AT1ERRH             @ 0x81D;
#ifndef _LIB_BUILD
asm("AT1ERRH equ 081Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1ERR8                :1;
        unsigned AT1ERR9                :1;
        unsigned AT1ERR10               :1;
        unsigned AT1ERR11               :1;
        unsigned AT1ERR12               :1;
        unsigned AT1ERR13               :1;
        unsigned AT1ERR14               :1;
        unsigned AT1ERR15               :1;
    };
    struct {
        unsigned ERR8                   :1;
        unsigned ERR9                   :1;
        unsigned ERR10                  :1;
        unsigned ERR11                  :1;
        unsigned ERR12                  :1;
        unsigned ERR13                  :1;
        unsigned ERR14                  :1;
        unsigned ERR15                  :1;
    };
    struct {
        unsigned ERRH0                  :1;
        unsigned ERRH1                  :1;
        unsigned ERRH2                  :1;
        unsigned ERRH3                  :1;
        unsigned ERRH4                  :1;
        unsigned ERRH5                  :1;
        unsigned ERRH6                  :1;
        unsigned ERRH7                  :1;
    };
} AT1ERRHbits_t;
extern volatile AT1ERRHbits_t AT1ERRHbits @ 0x81D;
// bitfield macros
#define _AT1ERRH_AT1ERR8_POSN                               0x0
#define _AT1ERRH_AT1ERR8_POSITION                           0x0
#define _AT1ERRH_AT1ERR8_SIZE                               0x1
#define _AT1ERRH_AT1ERR8_LENGTH                             0x1
#define _AT1ERRH_AT1ERR8_MASK                               0x1
#define _AT1ERRH_AT1ERR9_POSN                               0x1
#define _AT1ERRH_AT1ERR9_POSITION                           0x1
#define _AT1ERRH_AT1ERR9_SIZE                               0x1
#define _AT1ERRH_AT1ERR9_LENGTH                             0x1
#define _AT1ERRH_AT1ERR9_MASK                               0x2
#define _AT1ERRH_AT1ERR10_POSN                              0x2
#define _AT1ERRH_AT1ERR10_POSITION                          0x2
#define _AT1ERRH_AT1ERR10_SIZE                              0x1
#define _AT1ERRH_AT1ERR10_LENGTH                            0x1
#define _AT1ERRH_AT1ERR10_MASK                              0x4
#define _AT1ERRH_AT1ERR11_POSN                              0x3
#define _AT1ERRH_AT1ERR11_POSITION                          0x3
#define _AT1ERRH_AT1ERR11_SIZE                              0x1
#define _AT1ERRH_AT1ERR11_LENGTH                            0x1
#define _AT1ERRH_AT1ERR11_MASK                              0x8
#define _AT1ERRH_AT1ERR12_POSN                              0x4
#define _AT1ERRH_AT1ERR12_POSITION                          0x4
#define _AT1ERRH_AT1ERR12_SIZE                              0x1
#define _AT1ERRH_AT1ERR12_LENGTH                            0x1
#define _AT1ERRH_AT1ERR12_MASK                              0x10
#define _AT1ERRH_AT1ERR13_POSN                              0x5
#define _AT1ERRH_AT1ERR13_POSITION                          0x5
#define _AT1ERRH_AT1ERR13_SIZE                              0x1
#define _AT1ERRH_AT1ERR13_LENGTH                            0x1
#define _AT1ERRH_AT1ERR13_MASK                              0x20
#define _AT1ERRH_AT1ERR14_POSN                              0x6
#define _AT1ERRH_AT1ERR14_POSITION                          0x6
#define _AT1ERRH_AT1ERR14_SIZE                              0x1
#define _AT1ERRH_AT1ERR14_LENGTH                            0x1
#define _AT1ERRH_AT1ERR14_MASK                              0x40
#define _AT1ERRH_AT1ERR15_POSN                              0x7
#define _AT1ERRH_AT1ERR15_POSITION                          0x7
#define _AT1ERRH_AT1ERR15_SIZE                              0x1
#define _AT1ERRH_AT1ERR15_LENGTH                            0x1
#define _AT1ERRH_AT1ERR15_MASK                              0x80
#define _AT1ERRH_ERR8_POSN                                  0x0
#define _AT1ERRH_ERR8_POSITION                              0x0
#define _AT1ERRH_ERR8_SIZE                                  0x1
#define _AT1ERRH_ERR8_LENGTH                                0x1
#define _AT1ERRH_ERR8_MASK                                  0x1
#define _AT1ERRH_ERR9_POSN                                  0x1
#define _AT1ERRH_ERR9_POSITION                              0x1
#define _AT1ERRH_ERR9_SIZE                                  0x1
#define _AT1ERRH_ERR9_LENGTH                                0x1
#define _AT1ERRH_ERR9_MASK                                  0x2
#define _AT1ERRH_ERR10_POSN                                 0x2
#define _AT1ERRH_ERR10_POSITION                             0x2
#define _AT1ERRH_ERR10_SIZE                                 0x1
#define _AT1ERRH_ERR10_LENGTH                               0x1
#define _AT1ERRH_ERR10_MASK                                 0x4
#define _AT1ERRH_ERR11_POSN                                 0x3
#define _AT1ERRH_ERR11_POSITION                             0x3
#define _AT1ERRH_ERR11_SIZE                                 0x1
#define _AT1ERRH_ERR11_LENGTH                               0x1
#define _AT1ERRH_ERR11_MASK                                 0x8
#define _AT1ERRH_ERR12_POSN                                 0x4
#define _AT1ERRH_ERR12_POSITION                             0x4
#define _AT1ERRH_ERR12_SIZE                                 0x1
#define _AT1ERRH_ERR12_LENGTH                               0x1
#define _AT1ERRH_ERR12_MASK                                 0x10
#define _AT1ERRH_ERR13_POSN                                 0x5
#define _AT1ERRH_ERR13_POSITION                             0x5
#define _AT1ERRH_ERR13_SIZE                                 0x1
#define _AT1ERRH_ERR13_LENGTH                               0x1
#define _AT1ERRH_ERR13_MASK                                 0x20
#define _AT1ERRH_ERR14_POSN                                 0x6
#define _AT1ERRH_ERR14_POSITION                             0x6
#define _AT1ERRH_ERR14_SIZE                                 0x1
#define _AT1ERRH_ERR14_LENGTH                               0x1
#define _AT1ERRH_ERR14_MASK                                 0x40
#define _AT1ERRH_ERR15_POSN                                 0x7
#define _AT1ERRH_ERR15_POSITION                             0x7
#define _AT1ERRH_ERR15_SIZE                                 0x1
#define _AT1ERRH_ERR15_LENGTH                               0x1
#define _AT1ERRH_ERR15_MASK                                 0x80
#define _AT1ERRH_ERRH0_POSN                                 0x0
#define _AT1ERRH_ERRH0_POSITION                             0x0
#define _AT1ERRH_ERRH0_SIZE                                 0x1
#define _AT1ERRH_ERRH0_LENGTH                               0x1
#define _AT1ERRH_ERRH0_MASK                                 0x1
#define _AT1ERRH_ERRH1_POSN                                 0x1
#define _AT1ERRH_ERRH1_POSITION                             0x1
#define _AT1ERRH_ERRH1_SIZE                                 0x1
#define _AT1ERRH_ERRH1_LENGTH                               0x1
#define _AT1ERRH_ERRH1_MASK                                 0x2
#define _AT1ERRH_ERRH2_POSN                                 0x2
#define _AT1ERRH_ERRH2_POSITION                             0x2
#define _AT1ERRH_ERRH2_SIZE                                 0x1
#define _AT1ERRH_ERRH2_LENGTH                               0x1
#define _AT1ERRH_ERRH2_MASK                                 0x4
#define _AT1ERRH_ERRH3_POSN                                 0x3
#define _AT1ERRH_ERRH3_POSITION                             0x3
#define _AT1ERRH_ERRH3_SIZE                                 0x1
#define _AT1ERRH_ERRH3_LENGTH                               0x1
#define _AT1ERRH_ERRH3_MASK                                 0x8
#define _AT1ERRH_ERRH4_POSN                                 0x4
#define _AT1ERRH_ERRH4_POSITION                             0x4
#define _AT1ERRH_ERRH4_SIZE                                 0x1
#define _AT1ERRH_ERRH4_LENGTH                               0x1
#define _AT1ERRH_ERRH4_MASK                                 0x10
#define _AT1ERRH_ERRH5_POSN                                 0x5
#define _AT1ERRH_ERRH5_POSITION                             0x5
#define _AT1ERRH_ERRH5_SIZE                                 0x1
#define _AT1ERRH_ERRH5_LENGTH                               0x1
#define _AT1ERRH_ERRH5_MASK                                 0x20
#define _AT1ERRH_ERRH6_POSN                                 0x6
#define _AT1ERRH_ERRH6_POSITION                             0x6
#define _AT1ERRH_ERRH6_SIZE                                 0x1
#define _AT1ERRH_ERRH6_LENGTH                               0x1
#define _AT1ERRH_ERRH6_MASK                                 0x40
#define _AT1ERRH_ERRH7_POSN                                 0x7
#define _AT1ERRH_ERRH7_POSITION                             0x7
#define _AT1ERRH_ERRH7_SIZE                                 0x1
#define _AT1ERRH_ERRH7_LENGTH                               0x1
#define _AT1ERRH_ERRH7_MASK                                 0x80

// Register: AT1CLK
extern volatile unsigned char           AT1CLK              @ 0x88C;
#ifndef _LIB_BUILD
asm("AT1CLK equ 088Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CS                     :1;
    };
    struct {
        unsigned AT1CS                  :1;
    };
    struct {
        unsigned CS0                    :1;
    };
    struct {
        unsigned AT1CS0                 :1;
    };
} AT1CLKbits_t;
extern volatile AT1CLKbits_t AT1CLKbits @ 0x88C;
// bitfield macros
#define _AT1CLK_CS_POSN                                     0x0
#define _AT1CLK_CS_POSITION                                 0x0
#define _AT1CLK_CS_SIZE                                     0x1
#define _AT1CLK_CS_LENGTH                                   0x1
#define _AT1CLK_CS_MASK                                     0x1
#define _AT1CLK_AT1CS_POSN                                  0x0
#define _AT1CLK_AT1CS_POSITION                              0x0
#define _AT1CLK_AT1CS_SIZE                                  0x1
#define _AT1CLK_AT1CS_LENGTH                                0x1
#define _AT1CLK_AT1CS_MASK                                  0x1
#define _AT1CLK_CS0_POSN                                    0x0
#define _AT1CLK_CS0_POSITION                                0x0
#define _AT1CLK_CS0_SIZE                                    0x1
#define _AT1CLK_CS0_LENGTH                                  0x1
#define _AT1CLK_CS0_MASK                                    0x1
#define _AT1CLK_AT1CS0_POSN                                 0x0
#define _AT1CLK_AT1CS0_POSITION                             0x0
#define _AT1CLK_AT1CS0_SIZE                                 0x1
#define _AT1CLK_AT1CS0_LENGTH                               0x1
#define _AT1CLK_AT1CS0_MASK                                 0x1

// Register: AT1SIG
extern volatile unsigned char           AT1SIG              @ 0x88D;
#ifndef _LIB_BUILD
asm("AT1SIG equ 088Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SSEL                   :3;
    };
    struct {
        unsigned AT1SSEL0               :1;
        unsigned AT1SSEL1               :1;
        unsigned AT1SSEL2               :1;
    };
    struct {
        unsigned SSEL0                  :1;
        unsigned SSEL1                  :1;
        unsigned SSEL2                  :1;
    };
    struct {
        unsigned AT1SSEL                :3;
    };
} AT1SIGbits_t;
extern volatile AT1SIGbits_t AT1SIGbits @ 0x88D;
// bitfield macros
#define _AT1SIG_SSEL_POSN                                   0x0
#define _AT1SIG_SSEL_POSITION                               0x0
#define _AT1SIG_SSEL_SIZE                                   0x3
#define _AT1SIG_SSEL_LENGTH                                 0x3
#define _AT1SIG_SSEL_MASK                                   0x7
#define _AT1SIG_AT1SSEL0_POSN                               0x0
#define _AT1SIG_AT1SSEL0_POSITION                           0x0
#define _AT1SIG_AT1SSEL0_SIZE                               0x1
#define _AT1SIG_AT1SSEL0_LENGTH                             0x1
#define _AT1SIG_AT1SSEL0_MASK                               0x1
#define _AT1SIG_AT1SSEL1_POSN                               0x1
#define _AT1SIG_AT1SSEL1_POSITION                           0x1
#define _AT1SIG_AT1SSEL1_SIZE                               0x1
#define _AT1SIG_AT1SSEL1_LENGTH                             0x1
#define _AT1SIG_AT1SSEL1_MASK                               0x2
#define _AT1SIG_AT1SSEL2_POSN                               0x2
#define _AT1SIG_AT1SSEL2_POSITION                           0x2
#define _AT1SIG_AT1SSEL2_SIZE                               0x1
#define _AT1SIG_AT1SSEL2_LENGTH                             0x1
#define _AT1SIG_AT1SSEL2_MASK                               0x4
#define _AT1SIG_SSEL0_POSN                                  0x0
#define _AT1SIG_SSEL0_POSITION                              0x0
#define _AT1SIG_SSEL0_SIZE                                  0x1
#define _AT1SIG_SSEL0_LENGTH                                0x1
#define _AT1SIG_SSEL0_MASK                                  0x1
#define _AT1SIG_SSEL1_POSN                                  0x1
#define _AT1SIG_SSEL1_POSITION                              0x1
#define _AT1SIG_SSEL1_SIZE                                  0x1
#define _AT1SIG_SSEL1_LENGTH                                0x1
#define _AT1SIG_SSEL1_MASK                                  0x2
#define _AT1SIG_SSEL2_POSN                                  0x2
#define _AT1SIG_SSEL2_POSITION                              0x2
#define _AT1SIG_SSEL2_SIZE                                  0x1
#define _AT1SIG_SSEL2_LENGTH                                0x1
#define _AT1SIG_SSEL2_MASK                                  0x4
#define _AT1SIG_AT1SSEL_POSN                                0x0
#define _AT1SIG_AT1SSEL_POSITION                            0x0
#define _AT1SIG_AT1SSEL_SIZE                                0x3
#define _AT1SIG_AT1SSEL_LENGTH                              0x3
#define _AT1SIG_AT1SSEL_MASK                                0x7

// Register: AT1CSEL1
extern volatile unsigned char           AT1CSEL1            @ 0x88E;
#ifndef _LIB_BUILD
asm("AT1CSEL1 equ 088Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CP1S                   :3;
    };
    struct {
        unsigned AT1CP1S0               :1;
        unsigned AT1CP1S1               :1;
        unsigned AT1CP1S2               :1;
    };
    struct {
        unsigned CP1S0                  :1;
        unsigned CP1S1                  :1;
        unsigned CP1S2                  :1;
    };
    struct {
        unsigned AT1CP1S                :3;
    };
} AT1CSEL1bits_t;
extern volatile AT1CSEL1bits_t AT1CSEL1bits @ 0x88E;
// bitfield macros
#define _AT1CSEL1_CP1S_POSN                                 0x0
#define _AT1CSEL1_CP1S_POSITION                             0x0
#define _AT1CSEL1_CP1S_SIZE                                 0x3
#define _AT1CSEL1_CP1S_LENGTH                               0x3
#define _AT1CSEL1_CP1S_MASK                                 0x7
#define _AT1CSEL1_AT1CP1S0_POSN                             0x0
#define _AT1CSEL1_AT1CP1S0_POSITION                         0x0
#define _AT1CSEL1_AT1CP1S0_SIZE                             0x1
#define _AT1CSEL1_AT1CP1S0_LENGTH                           0x1
#define _AT1CSEL1_AT1CP1S0_MASK                             0x1
#define _AT1CSEL1_AT1CP1S1_POSN                             0x1
#define _AT1CSEL1_AT1CP1S1_POSITION                         0x1
#define _AT1CSEL1_AT1CP1S1_SIZE                             0x1
#define _AT1CSEL1_AT1CP1S1_LENGTH                           0x1
#define _AT1CSEL1_AT1CP1S1_MASK                             0x2
#define _AT1CSEL1_AT1CP1S2_POSN                             0x2
#define _AT1CSEL1_AT1CP1S2_POSITION                         0x2
#define _AT1CSEL1_AT1CP1S2_SIZE                             0x1
#define _AT1CSEL1_AT1CP1S2_LENGTH                           0x1
#define _AT1CSEL1_AT1CP1S2_MASK                             0x4
#define _AT1CSEL1_CP1S0_POSN                                0x0
#define _AT1CSEL1_CP1S0_POSITION                            0x0
#define _AT1CSEL1_CP1S0_SIZE                                0x1
#define _AT1CSEL1_CP1S0_LENGTH                              0x1
#define _AT1CSEL1_CP1S0_MASK                                0x1
#define _AT1CSEL1_CP1S1_POSN                                0x1
#define _AT1CSEL1_CP1S1_POSITION                            0x1
#define _AT1CSEL1_CP1S1_SIZE                                0x1
#define _AT1CSEL1_CP1S1_LENGTH                              0x1
#define _AT1CSEL1_CP1S1_MASK                                0x2
#define _AT1CSEL1_CP1S2_POSN                                0x2
#define _AT1CSEL1_CP1S2_POSITION                            0x2
#define _AT1CSEL1_CP1S2_SIZE                                0x1
#define _AT1CSEL1_CP1S2_LENGTH                              0x1
#define _AT1CSEL1_CP1S2_MASK                                0x4
#define _AT1CSEL1_AT1CP1S_POSN                              0x0
#define _AT1CSEL1_AT1CP1S_POSITION                          0x0
#define _AT1CSEL1_AT1CP1S_SIZE                              0x3
#define _AT1CSEL1_AT1CP1S_LENGTH                            0x3
#define _AT1CSEL1_AT1CP1S_MASK                              0x7

// Register: AT1CC1
extern volatile unsigned short          AT1CC1              @ 0x88F;
#ifndef _LIB_BUILD
asm("AT1CC1 equ 088Fh");
#endif

// Register: AT1CC1L
extern volatile unsigned char           AT1CC1L             @ 0x88F;
#ifndef _LIB_BUILD
asm("AT1CC1L equ 088Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CC10                :1;
        unsigned AT1CC11                :1;
        unsigned AT1CC12                :1;
        unsigned AT1CC13                :1;
        unsigned AT1CC14                :1;
        unsigned AT1CC15                :1;
        unsigned AT1CC16                :1;
        unsigned AT1CC17                :1;
    };
    struct {
        unsigned CC10                   :1;
        unsigned CC11                   :1;
        unsigned CC12                   :1;
        unsigned CC13                   :1;
        unsigned CC14                   :1;
        unsigned CC15                   :1;
        unsigned CC16                   :1;
        unsigned CC17                   :1;
    };
} AT1CC1Lbits_t;
extern volatile AT1CC1Lbits_t AT1CC1Lbits @ 0x88F;
// bitfield macros
#define _AT1CC1L_AT1CC10_POSN                               0x0
#define _AT1CC1L_AT1CC10_POSITION                           0x0
#define _AT1CC1L_AT1CC10_SIZE                               0x1
#define _AT1CC1L_AT1CC10_LENGTH                             0x1
#define _AT1CC1L_AT1CC10_MASK                               0x1
#define _AT1CC1L_AT1CC11_POSN                               0x1
#define _AT1CC1L_AT1CC11_POSITION                           0x1
#define _AT1CC1L_AT1CC11_SIZE                               0x1
#define _AT1CC1L_AT1CC11_LENGTH                             0x1
#define _AT1CC1L_AT1CC11_MASK                               0x2
#define _AT1CC1L_AT1CC12_POSN                               0x2
#define _AT1CC1L_AT1CC12_POSITION                           0x2
#define _AT1CC1L_AT1CC12_SIZE                               0x1
#define _AT1CC1L_AT1CC12_LENGTH                             0x1
#define _AT1CC1L_AT1CC12_MASK                               0x4
#define _AT1CC1L_AT1CC13_POSN                               0x3
#define _AT1CC1L_AT1CC13_POSITION                           0x3
#define _AT1CC1L_AT1CC13_SIZE                               0x1
#define _AT1CC1L_AT1CC13_LENGTH                             0x1
#define _AT1CC1L_AT1CC13_MASK                               0x8
#define _AT1CC1L_AT1CC14_POSN                               0x4
#define _AT1CC1L_AT1CC14_POSITION                           0x4
#define _AT1CC1L_AT1CC14_SIZE                               0x1
#define _AT1CC1L_AT1CC14_LENGTH                             0x1
#define _AT1CC1L_AT1CC14_MASK                               0x10
#define _AT1CC1L_AT1CC15_POSN                               0x5
#define _AT1CC1L_AT1CC15_POSITION                           0x5
#define _AT1CC1L_AT1CC15_SIZE                               0x1
#define _AT1CC1L_AT1CC15_LENGTH                             0x1
#define _AT1CC1L_AT1CC15_MASK                               0x20
#define _AT1CC1L_AT1CC16_POSN                               0x6
#define _AT1CC1L_AT1CC16_POSITION                           0x6
#define _AT1CC1L_AT1CC16_SIZE                               0x1
#define _AT1CC1L_AT1CC16_LENGTH                             0x1
#define _AT1CC1L_AT1CC16_MASK                               0x40
#define _AT1CC1L_AT1CC17_POSN                               0x7
#define _AT1CC1L_AT1CC17_POSITION                           0x7
#define _AT1CC1L_AT1CC17_SIZE                               0x1
#define _AT1CC1L_AT1CC17_LENGTH                             0x1
#define _AT1CC1L_AT1CC17_MASK                               0x80
#define _AT1CC1L_CC10_POSN                                  0x0
#define _AT1CC1L_CC10_POSITION                              0x0
#define _AT1CC1L_CC10_SIZE                                  0x1
#define _AT1CC1L_CC10_LENGTH                                0x1
#define _AT1CC1L_CC10_MASK                                  0x1
#define _AT1CC1L_CC11_POSN                                  0x1
#define _AT1CC1L_CC11_POSITION                              0x1
#define _AT1CC1L_CC11_SIZE                                  0x1
#define _AT1CC1L_CC11_LENGTH                                0x1
#define _AT1CC1L_CC11_MASK                                  0x2
#define _AT1CC1L_CC12_POSN                                  0x2
#define _AT1CC1L_CC12_POSITION                              0x2
#define _AT1CC1L_CC12_SIZE                                  0x1
#define _AT1CC1L_CC12_LENGTH                                0x1
#define _AT1CC1L_CC12_MASK                                  0x4
#define _AT1CC1L_CC13_POSN                                  0x3
#define _AT1CC1L_CC13_POSITION                              0x3
#define _AT1CC1L_CC13_SIZE                                  0x1
#define _AT1CC1L_CC13_LENGTH                                0x1
#define _AT1CC1L_CC13_MASK                                  0x8
#define _AT1CC1L_CC14_POSN                                  0x4
#define _AT1CC1L_CC14_POSITION                              0x4
#define _AT1CC1L_CC14_SIZE                                  0x1
#define _AT1CC1L_CC14_LENGTH                                0x1
#define _AT1CC1L_CC14_MASK                                  0x10
#define _AT1CC1L_CC15_POSN                                  0x5
#define _AT1CC1L_CC15_POSITION                              0x5
#define _AT1CC1L_CC15_SIZE                                  0x1
#define _AT1CC1L_CC15_LENGTH                                0x1
#define _AT1CC1L_CC15_MASK                                  0x20
#define _AT1CC1L_CC16_POSN                                  0x6
#define _AT1CC1L_CC16_POSITION                              0x6
#define _AT1CC1L_CC16_SIZE                                  0x1
#define _AT1CC1L_CC16_LENGTH                                0x1
#define _AT1CC1L_CC16_MASK                                  0x40
#define _AT1CC1L_CC17_POSN                                  0x7
#define _AT1CC1L_CC17_POSITION                              0x7
#define _AT1CC1L_CC17_SIZE                                  0x1
#define _AT1CC1L_CC17_LENGTH                                0x1
#define _AT1CC1L_CC17_MASK                                  0x80

// Register: AT1CC1H
extern volatile unsigned char           AT1CC1H             @ 0x890;
#ifndef _LIB_BUILD
asm("AT1CC1H equ 0890h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CC18                :1;
        unsigned AT1CC19                :1;
    };
    struct {
        unsigned CC18                   :1;
        unsigned CC19                   :1;
    };
} AT1CC1Hbits_t;
extern volatile AT1CC1Hbits_t AT1CC1Hbits @ 0x890;
// bitfield macros
#define _AT1CC1H_AT1CC18_POSN                               0x0
#define _AT1CC1H_AT1CC18_POSITION                           0x0
#define _AT1CC1H_AT1CC18_SIZE                               0x1
#define _AT1CC1H_AT1CC18_LENGTH                             0x1
#define _AT1CC1H_AT1CC18_MASK                               0x1
#define _AT1CC1H_AT1CC19_POSN                               0x1
#define _AT1CC1H_AT1CC19_POSITION                           0x1
#define _AT1CC1H_AT1CC19_SIZE                               0x1
#define _AT1CC1H_AT1CC19_LENGTH                             0x1
#define _AT1CC1H_AT1CC19_MASK                               0x2
#define _AT1CC1H_CC18_POSN                                  0x0
#define _AT1CC1H_CC18_POSITION                              0x0
#define _AT1CC1H_CC18_SIZE                                  0x1
#define _AT1CC1H_CC18_LENGTH                                0x1
#define _AT1CC1H_CC18_MASK                                  0x1
#define _AT1CC1H_CC19_POSN                                  0x1
#define _AT1CC1H_CC19_POSITION                              0x1
#define _AT1CC1H_CC19_SIZE                                  0x1
#define _AT1CC1H_CC19_LENGTH                                0x1
#define _AT1CC1H_CC19_MASK                                  0x2

// Register: AT1CCON1
extern volatile unsigned char           AT1CCON1            @ 0x891;
#ifndef _LIB_BUILD
asm("AT1CCON1 equ 0891h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CC1MODE             :1;
        unsigned                        :2;
        unsigned AT1CAP1P               :1;
        unsigned AT1CC1POL              :1;
        unsigned                        :2;
        unsigned AT1CC1EN               :1;
    };
    struct {
        unsigned CC1MODE                :1;
        unsigned                        :2;
        unsigned CAP1P                  :1;
        unsigned CC1POL                 :1;
        unsigned                        :2;
        unsigned CC1EN                  :1;
    };
} AT1CCON1bits_t;
extern volatile AT1CCON1bits_t AT1CCON1bits @ 0x891;
// bitfield macros
#define _AT1CCON1_AT1CC1MODE_POSN                           0x0
#define _AT1CCON1_AT1CC1MODE_POSITION                       0x0
#define _AT1CCON1_AT1CC1MODE_SIZE                           0x1
#define _AT1CCON1_AT1CC1MODE_LENGTH                         0x1
#define _AT1CCON1_AT1CC1MODE_MASK                           0x1
#define _AT1CCON1_AT1CAP1P_POSN                             0x3
#define _AT1CCON1_AT1CAP1P_POSITION                         0x3
#define _AT1CCON1_AT1CAP1P_SIZE                             0x1
#define _AT1CCON1_AT1CAP1P_LENGTH                           0x1
#define _AT1CCON1_AT1CAP1P_MASK                             0x8
#define _AT1CCON1_AT1CC1POL_POSN                            0x4
#define _AT1CCON1_AT1CC1POL_POSITION                        0x4
#define _AT1CCON1_AT1CC1POL_SIZE                            0x1
#define _AT1CCON1_AT1CC1POL_LENGTH                          0x1
#define _AT1CCON1_AT1CC1POL_MASK                            0x10
#define _AT1CCON1_AT1CC1EN_POSN                             0x7
#define _AT1CCON1_AT1CC1EN_POSITION                         0x7
#define _AT1CCON1_AT1CC1EN_SIZE                             0x1
#define _AT1CCON1_AT1CC1EN_LENGTH                           0x1
#define _AT1CCON1_AT1CC1EN_MASK                             0x80
#define _AT1CCON1_CC1MODE_POSN                              0x0
#define _AT1CCON1_CC1MODE_POSITION                          0x0
#define _AT1CCON1_CC1MODE_SIZE                              0x1
#define _AT1CCON1_CC1MODE_LENGTH                            0x1
#define _AT1CCON1_CC1MODE_MASK                              0x1
#define _AT1CCON1_CAP1P_POSN                                0x3
#define _AT1CCON1_CAP1P_POSITION                            0x3
#define _AT1CCON1_CAP1P_SIZE                                0x1
#define _AT1CCON1_CAP1P_LENGTH                              0x1
#define _AT1CCON1_CAP1P_MASK                                0x8
#define _AT1CCON1_CC1POL_POSN                               0x4
#define _AT1CCON1_CC1POL_POSITION                           0x4
#define _AT1CCON1_CC1POL_SIZE                               0x1
#define _AT1CCON1_CC1POL_LENGTH                             0x1
#define _AT1CCON1_CC1POL_MASK                               0x10
#define _AT1CCON1_CC1EN_POSN                                0x7
#define _AT1CCON1_CC1EN_POSITION                            0x7
#define _AT1CCON1_CC1EN_SIZE                                0x1
#define _AT1CCON1_CC1EN_LENGTH                              0x1
#define _AT1CCON1_CC1EN_MASK                                0x80

// Register: AT1CSEL2
extern volatile unsigned char           AT1CSEL2            @ 0x892;
#ifndef _LIB_BUILD
asm("AT1CSEL2 equ 0892h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CP2S                :3;
    };
    struct {
        unsigned AT1CP2S0               :1;
        unsigned AT1CP2S1               :1;
        unsigned AT1CP2S2               :1;
    };
    struct {
        unsigned CP2S                   :3;
    };
    struct {
        unsigned CP2S0                  :1;
        unsigned CP2S1                  :1;
        unsigned CP2S2                  :1;
    };
} AT1CSEL2bits_t;
extern volatile AT1CSEL2bits_t AT1CSEL2bits @ 0x892;
// bitfield macros
#define _AT1CSEL2_AT1CP2S_POSN                              0x0
#define _AT1CSEL2_AT1CP2S_POSITION                          0x0
#define _AT1CSEL2_AT1CP2S_SIZE                              0x3
#define _AT1CSEL2_AT1CP2S_LENGTH                            0x3
#define _AT1CSEL2_AT1CP2S_MASK                              0x7
#define _AT1CSEL2_AT1CP2S0_POSN                             0x0
#define _AT1CSEL2_AT1CP2S0_POSITION                         0x0
#define _AT1CSEL2_AT1CP2S0_SIZE                             0x1
#define _AT1CSEL2_AT1CP2S0_LENGTH                           0x1
#define _AT1CSEL2_AT1CP2S0_MASK                             0x1
#define _AT1CSEL2_AT1CP2S1_POSN                             0x1
#define _AT1CSEL2_AT1CP2S1_POSITION                         0x1
#define _AT1CSEL2_AT1CP2S1_SIZE                             0x1
#define _AT1CSEL2_AT1CP2S1_LENGTH                           0x1
#define _AT1CSEL2_AT1CP2S1_MASK                             0x2
#define _AT1CSEL2_AT1CP2S2_POSN                             0x2
#define _AT1CSEL2_AT1CP2S2_POSITION                         0x2
#define _AT1CSEL2_AT1CP2S2_SIZE                             0x1
#define _AT1CSEL2_AT1CP2S2_LENGTH                           0x1
#define _AT1CSEL2_AT1CP2S2_MASK                             0x4
#define _AT1CSEL2_CP2S_POSN                                 0x0
#define _AT1CSEL2_CP2S_POSITION                             0x0
#define _AT1CSEL2_CP2S_SIZE                                 0x3
#define _AT1CSEL2_CP2S_LENGTH                               0x3
#define _AT1CSEL2_CP2S_MASK                                 0x7
#define _AT1CSEL2_CP2S0_POSN                                0x0
#define _AT1CSEL2_CP2S0_POSITION                            0x0
#define _AT1CSEL2_CP2S0_SIZE                                0x1
#define _AT1CSEL2_CP2S0_LENGTH                              0x1
#define _AT1CSEL2_CP2S0_MASK                                0x1
#define _AT1CSEL2_CP2S1_POSN                                0x1
#define _AT1CSEL2_CP2S1_POSITION                            0x1
#define _AT1CSEL2_CP2S1_SIZE                                0x1
#define _AT1CSEL2_CP2S1_LENGTH                              0x1
#define _AT1CSEL2_CP2S1_MASK                                0x2
#define _AT1CSEL2_CP2S2_POSN                                0x2
#define _AT1CSEL2_CP2S2_POSITION                            0x2
#define _AT1CSEL2_CP2S2_SIZE                                0x1
#define _AT1CSEL2_CP2S2_LENGTH                              0x1
#define _AT1CSEL2_CP2S2_MASK                                0x4

// Register: AT1CC2
extern volatile unsigned short          AT1CC2              @ 0x893;
#ifndef _LIB_BUILD
asm("AT1CC2 equ 0893h");
#endif

// Register: AT1CC2L
extern volatile unsigned char           AT1CC2L             @ 0x893;
#ifndef _LIB_BUILD
asm("AT1CC2L equ 0893h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CC20                :1;
        unsigned AT1CC21                :1;
        unsigned AT1CC22                :1;
        unsigned AT1CC23                :1;
        unsigned AT1CC24                :1;
        unsigned AT1CC25                :1;
        unsigned AT1CC26                :1;
        unsigned AT1CC27                :1;
    };
    struct {
        unsigned CC20                   :1;
        unsigned CC21                   :1;
        unsigned CC22                   :1;
        unsigned CC13                   :1;
        unsigned CC24                   :1;
        unsigned CCW5                   :1;
        unsigned CC26                   :1;
        unsigned CC27                   :1;
    };
} AT1CC2Lbits_t;
extern volatile AT1CC2Lbits_t AT1CC2Lbits @ 0x893;
// bitfield macros
#define _AT1CC2L_AT1CC20_POSN                               0x0
#define _AT1CC2L_AT1CC20_POSITION                           0x0
#define _AT1CC2L_AT1CC20_SIZE                               0x1
#define _AT1CC2L_AT1CC20_LENGTH                             0x1
#define _AT1CC2L_AT1CC20_MASK                               0x1
#define _AT1CC2L_AT1CC21_POSN                               0x1
#define _AT1CC2L_AT1CC21_POSITION                           0x1
#define _AT1CC2L_AT1CC21_SIZE                               0x1
#define _AT1CC2L_AT1CC21_LENGTH                             0x1
#define _AT1CC2L_AT1CC21_MASK                               0x2
#define _AT1CC2L_AT1CC22_POSN                               0x2
#define _AT1CC2L_AT1CC22_POSITION                           0x2
#define _AT1CC2L_AT1CC22_SIZE                               0x1
#define _AT1CC2L_AT1CC22_LENGTH                             0x1
#define _AT1CC2L_AT1CC22_MASK                               0x4
#define _AT1CC2L_AT1CC23_POSN                               0x3
#define _AT1CC2L_AT1CC23_POSITION                           0x3
#define _AT1CC2L_AT1CC23_SIZE                               0x1
#define _AT1CC2L_AT1CC23_LENGTH                             0x1
#define _AT1CC2L_AT1CC23_MASK                               0x8
#define _AT1CC2L_AT1CC24_POSN                               0x4
#define _AT1CC2L_AT1CC24_POSITION                           0x4
#define _AT1CC2L_AT1CC24_SIZE                               0x1
#define _AT1CC2L_AT1CC24_LENGTH                             0x1
#define _AT1CC2L_AT1CC24_MASK                               0x10
#define _AT1CC2L_AT1CC25_POSN                               0x5
#define _AT1CC2L_AT1CC25_POSITION                           0x5
#define _AT1CC2L_AT1CC25_SIZE                               0x1
#define _AT1CC2L_AT1CC25_LENGTH                             0x1
#define _AT1CC2L_AT1CC25_MASK                               0x20
#define _AT1CC2L_AT1CC26_POSN                               0x6
#define _AT1CC2L_AT1CC26_POSITION                           0x6
#define _AT1CC2L_AT1CC26_SIZE                               0x1
#define _AT1CC2L_AT1CC26_LENGTH                             0x1
#define _AT1CC2L_AT1CC26_MASK                               0x40
#define _AT1CC2L_AT1CC27_POSN                               0x7
#define _AT1CC2L_AT1CC27_POSITION                           0x7
#define _AT1CC2L_AT1CC27_SIZE                               0x1
#define _AT1CC2L_AT1CC27_LENGTH                             0x1
#define _AT1CC2L_AT1CC27_MASK                               0x80
#define _AT1CC2L_CC20_POSN                                  0x0
#define _AT1CC2L_CC20_POSITION                              0x0
#define _AT1CC2L_CC20_SIZE                                  0x1
#define _AT1CC2L_CC20_LENGTH                                0x1
#define _AT1CC2L_CC20_MASK                                  0x1
#define _AT1CC2L_CC21_POSN                                  0x1
#define _AT1CC2L_CC21_POSITION                              0x1
#define _AT1CC2L_CC21_SIZE                                  0x1
#define _AT1CC2L_CC21_LENGTH                                0x1
#define _AT1CC2L_CC21_MASK                                  0x2
#define _AT1CC2L_CC22_POSN                                  0x2
#define _AT1CC2L_CC22_POSITION                              0x2
#define _AT1CC2L_CC22_SIZE                                  0x1
#define _AT1CC2L_CC22_LENGTH                                0x1
#define _AT1CC2L_CC22_MASK                                  0x4
#define _AT1CC2L_CC13_POSN                                  0x3
#define _AT1CC2L_CC13_POSITION                              0x3
#define _AT1CC2L_CC13_SIZE                                  0x1
#define _AT1CC2L_CC13_LENGTH                                0x1
#define _AT1CC2L_CC13_MASK                                  0x8
#define _AT1CC2L_CC24_POSN                                  0x4
#define _AT1CC2L_CC24_POSITION                              0x4
#define _AT1CC2L_CC24_SIZE                                  0x1
#define _AT1CC2L_CC24_LENGTH                                0x1
#define _AT1CC2L_CC24_MASK                                  0x10
#define _AT1CC2L_CCW5_POSN                                  0x5
#define _AT1CC2L_CCW5_POSITION                              0x5
#define _AT1CC2L_CCW5_SIZE                                  0x1
#define _AT1CC2L_CCW5_LENGTH                                0x1
#define _AT1CC2L_CCW5_MASK                                  0x20
#define _AT1CC2L_CC26_POSN                                  0x6
#define _AT1CC2L_CC26_POSITION                              0x6
#define _AT1CC2L_CC26_SIZE                                  0x1
#define _AT1CC2L_CC26_LENGTH                                0x1
#define _AT1CC2L_CC26_MASK                                  0x40
#define _AT1CC2L_CC27_POSN                                  0x7
#define _AT1CC2L_CC27_POSITION                              0x7
#define _AT1CC2L_CC27_SIZE                                  0x1
#define _AT1CC2L_CC27_LENGTH                                0x1
#define _AT1CC2L_CC27_MASK                                  0x80

// Register: AT1CC2H
extern volatile unsigned char           AT1CC2H             @ 0x894;
#ifndef _LIB_BUILD
asm("AT1CC2H equ 0894h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CC28                :1;
        unsigned AT1CC29                :1;
    };
    struct {
        unsigned CC28                   :1;
        unsigned CC29                   :1;
    };
} AT1CC2Hbits_t;
extern volatile AT1CC2Hbits_t AT1CC2Hbits @ 0x894;
// bitfield macros
#define _AT1CC2H_AT1CC28_POSN                               0x0
#define _AT1CC2H_AT1CC28_POSITION                           0x0
#define _AT1CC2H_AT1CC28_SIZE                               0x1
#define _AT1CC2H_AT1CC28_LENGTH                             0x1
#define _AT1CC2H_AT1CC28_MASK                               0x1
#define _AT1CC2H_AT1CC29_POSN                               0x1
#define _AT1CC2H_AT1CC29_POSITION                           0x1
#define _AT1CC2H_AT1CC29_SIZE                               0x1
#define _AT1CC2H_AT1CC29_LENGTH                             0x1
#define _AT1CC2H_AT1CC29_MASK                               0x2
#define _AT1CC2H_CC28_POSN                                  0x0
#define _AT1CC2H_CC28_POSITION                              0x0
#define _AT1CC2H_CC28_SIZE                                  0x1
#define _AT1CC2H_CC28_LENGTH                                0x1
#define _AT1CC2H_CC28_MASK                                  0x1
#define _AT1CC2H_CC29_POSN                                  0x1
#define _AT1CC2H_CC29_POSITION                              0x1
#define _AT1CC2H_CC29_SIZE                                  0x1
#define _AT1CC2H_CC29_LENGTH                                0x1
#define _AT1CC2H_CC29_MASK                                  0x2

// Register: AT1CCON2
extern volatile unsigned char           AT1CCON2            @ 0x895;
#ifndef _LIB_BUILD
asm("AT1CCON2 equ 0895h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CC2MODE             :1;
        unsigned                        :2;
        unsigned AT1CAP2P               :1;
        unsigned AT1CC2POL              :1;
        unsigned                        :2;
        unsigned AT1CC2EN               :1;
    };
    struct {
        unsigned CC2MODE                :1;
        unsigned                        :2;
        unsigned CAP2P                  :1;
        unsigned CC2POL                 :1;
        unsigned                        :2;
        unsigned CC2EN                  :1;
    };
} AT1CCON2bits_t;
extern volatile AT1CCON2bits_t AT1CCON2bits @ 0x895;
// bitfield macros
#define _AT1CCON2_AT1CC2MODE_POSN                           0x0
#define _AT1CCON2_AT1CC2MODE_POSITION                       0x0
#define _AT1CCON2_AT1CC2MODE_SIZE                           0x1
#define _AT1CCON2_AT1CC2MODE_LENGTH                         0x1
#define _AT1CCON2_AT1CC2MODE_MASK                           0x1
#define _AT1CCON2_AT1CAP2P_POSN                             0x3
#define _AT1CCON2_AT1CAP2P_POSITION                         0x3
#define _AT1CCON2_AT1CAP2P_SIZE                             0x1
#define _AT1CCON2_AT1CAP2P_LENGTH                           0x1
#define _AT1CCON2_AT1CAP2P_MASK                             0x8
#define _AT1CCON2_AT1CC2POL_POSN                            0x4
#define _AT1CCON2_AT1CC2POL_POSITION                        0x4
#define _AT1CCON2_AT1CC2POL_SIZE                            0x1
#define _AT1CCON2_AT1CC2POL_LENGTH                          0x1
#define _AT1CCON2_AT1CC2POL_MASK                            0x10
#define _AT1CCON2_AT1CC2EN_POSN                             0x7
#define _AT1CCON2_AT1CC2EN_POSITION                         0x7
#define _AT1CCON2_AT1CC2EN_SIZE                             0x1
#define _AT1CCON2_AT1CC2EN_LENGTH                           0x1
#define _AT1CCON2_AT1CC2EN_MASK                             0x80
#define _AT1CCON2_CC2MODE_POSN                              0x0
#define _AT1CCON2_CC2MODE_POSITION                          0x0
#define _AT1CCON2_CC2MODE_SIZE                              0x1
#define _AT1CCON2_CC2MODE_LENGTH                            0x1
#define _AT1CCON2_CC2MODE_MASK                              0x1
#define _AT1CCON2_CAP2P_POSN                                0x3
#define _AT1CCON2_CAP2P_POSITION                            0x3
#define _AT1CCON2_CAP2P_SIZE                                0x1
#define _AT1CCON2_CAP2P_LENGTH                              0x1
#define _AT1CCON2_CAP2P_MASK                                0x8
#define _AT1CCON2_CC2POL_POSN                               0x4
#define _AT1CCON2_CC2POL_POSITION                           0x4
#define _AT1CCON2_CC2POL_SIZE                               0x1
#define _AT1CCON2_CC2POL_LENGTH                             0x1
#define _AT1CCON2_CC2POL_MASK                               0x10
#define _AT1CCON2_CC2EN_POSN                                0x7
#define _AT1CCON2_CC2EN_POSITION                            0x7
#define _AT1CCON2_CC2EN_SIZE                                0x1
#define _AT1CCON2_CC2EN_LENGTH                              0x1
#define _AT1CCON2_CC2EN_MASK                                0x80

// Register: AT1CSEL3
extern volatile unsigned char           AT1CSEL3            @ 0x896;
#ifndef _LIB_BUILD
asm("AT1CSEL3 equ 0896h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CP3S                :3;
    };
    struct {
        unsigned AT1CP3S0               :1;
        unsigned AT1CP3S1               :1;
        unsigned AT1CP3S2               :1;
    };
    struct {
        unsigned CP3S                   :3;
    };
    struct {
        unsigned CP3S0                  :1;
        unsigned CP3S1                  :1;
        unsigned CP3S2                  :1;
    };
} AT1CSEL3bits_t;
extern volatile AT1CSEL3bits_t AT1CSEL3bits @ 0x896;
// bitfield macros
#define _AT1CSEL3_AT1CP3S_POSN                              0x0
#define _AT1CSEL3_AT1CP3S_POSITION                          0x0
#define _AT1CSEL3_AT1CP3S_SIZE                              0x3
#define _AT1CSEL3_AT1CP3S_LENGTH                            0x3
#define _AT1CSEL3_AT1CP3S_MASK                              0x7
#define _AT1CSEL3_AT1CP3S0_POSN                             0x0
#define _AT1CSEL3_AT1CP3S0_POSITION                         0x0
#define _AT1CSEL3_AT1CP3S0_SIZE                             0x1
#define _AT1CSEL3_AT1CP3S0_LENGTH                           0x1
#define _AT1CSEL3_AT1CP3S0_MASK                             0x1
#define _AT1CSEL3_AT1CP3S1_POSN                             0x1
#define _AT1CSEL3_AT1CP3S1_POSITION                         0x1
#define _AT1CSEL3_AT1CP3S1_SIZE                             0x1
#define _AT1CSEL3_AT1CP3S1_LENGTH                           0x1
#define _AT1CSEL3_AT1CP3S1_MASK                             0x2
#define _AT1CSEL3_AT1CP3S2_POSN                             0x2
#define _AT1CSEL3_AT1CP3S2_POSITION                         0x2
#define _AT1CSEL3_AT1CP3S2_SIZE                             0x1
#define _AT1CSEL3_AT1CP3S2_LENGTH                           0x1
#define _AT1CSEL3_AT1CP3S2_MASK                             0x4
#define _AT1CSEL3_CP3S_POSN                                 0x0
#define _AT1CSEL3_CP3S_POSITION                             0x0
#define _AT1CSEL3_CP3S_SIZE                                 0x3
#define _AT1CSEL3_CP3S_LENGTH                               0x3
#define _AT1CSEL3_CP3S_MASK                                 0x7
#define _AT1CSEL3_CP3S0_POSN                                0x0
#define _AT1CSEL3_CP3S0_POSITION                            0x0
#define _AT1CSEL3_CP3S0_SIZE                                0x1
#define _AT1CSEL3_CP3S0_LENGTH                              0x1
#define _AT1CSEL3_CP3S0_MASK                                0x1
#define _AT1CSEL3_CP3S1_POSN                                0x1
#define _AT1CSEL3_CP3S1_POSITION                            0x1
#define _AT1CSEL3_CP3S1_SIZE                                0x1
#define _AT1CSEL3_CP3S1_LENGTH                              0x1
#define _AT1CSEL3_CP3S1_MASK                                0x2
#define _AT1CSEL3_CP3S2_POSN                                0x2
#define _AT1CSEL3_CP3S2_POSITION                            0x2
#define _AT1CSEL3_CP3S2_SIZE                                0x1
#define _AT1CSEL3_CP3S2_LENGTH                              0x1
#define _AT1CSEL3_CP3S2_MASK                                0x4

// Register: AT1CC3
extern volatile unsigned short          AT1CC3              @ 0x897;
#ifndef _LIB_BUILD
asm("AT1CC3 equ 0897h");
#endif

// Register: AT1CC3L
extern volatile unsigned char           AT1CC3L             @ 0x897;
#ifndef _LIB_BUILD
asm("AT1CC3L equ 0897h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CC30                :1;
        unsigned AT1CC31                :1;
        unsigned AT1CC32                :1;
        unsigned AT1CC33                :1;
        unsigned AT1CC34                :1;
        unsigned AT1CC35                :1;
        unsigned AT1CC36                :1;
        unsigned AT1CC37                :1;
    };
    struct {
        unsigned CC30                   :1;
        unsigned CC31                   :1;
        unsigned CC32                   :1;
        unsigned CC33                   :1;
        unsigned CC34                   :1;
        unsigned CC35                   :1;
        unsigned CC36                   :1;
        unsigned CC37                   :1;
    };
} AT1CC3Lbits_t;
extern volatile AT1CC3Lbits_t AT1CC3Lbits @ 0x897;
// bitfield macros
#define _AT1CC3L_AT1CC30_POSN                               0x0
#define _AT1CC3L_AT1CC30_POSITION                           0x0
#define _AT1CC3L_AT1CC30_SIZE                               0x1
#define _AT1CC3L_AT1CC30_LENGTH                             0x1
#define _AT1CC3L_AT1CC30_MASK                               0x1
#define _AT1CC3L_AT1CC31_POSN                               0x1
#define _AT1CC3L_AT1CC31_POSITION                           0x1
#define _AT1CC3L_AT1CC31_SIZE                               0x1
#define _AT1CC3L_AT1CC31_LENGTH                             0x1
#define _AT1CC3L_AT1CC31_MASK                               0x2
#define _AT1CC3L_AT1CC32_POSN                               0x2
#define _AT1CC3L_AT1CC32_POSITION                           0x2
#define _AT1CC3L_AT1CC32_SIZE                               0x1
#define _AT1CC3L_AT1CC32_LENGTH                             0x1
#define _AT1CC3L_AT1CC32_MASK                               0x4
#define _AT1CC3L_AT1CC33_POSN                               0x3
#define _AT1CC3L_AT1CC33_POSITION                           0x3
#define _AT1CC3L_AT1CC33_SIZE                               0x1
#define _AT1CC3L_AT1CC33_LENGTH                             0x1
#define _AT1CC3L_AT1CC33_MASK                               0x8
#define _AT1CC3L_AT1CC34_POSN                               0x4
#define _AT1CC3L_AT1CC34_POSITION                           0x4
#define _AT1CC3L_AT1CC34_SIZE                               0x1
#define _AT1CC3L_AT1CC34_LENGTH                             0x1
#define _AT1CC3L_AT1CC34_MASK                               0x10
#define _AT1CC3L_AT1CC35_POSN                               0x5
#define _AT1CC3L_AT1CC35_POSITION                           0x5
#define _AT1CC3L_AT1CC35_SIZE                               0x1
#define _AT1CC3L_AT1CC35_LENGTH                             0x1
#define _AT1CC3L_AT1CC35_MASK                               0x20
#define _AT1CC3L_AT1CC36_POSN                               0x6
#define _AT1CC3L_AT1CC36_POSITION                           0x6
#define _AT1CC3L_AT1CC36_SIZE                               0x1
#define _AT1CC3L_AT1CC36_LENGTH                             0x1
#define _AT1CC3L_AT1CC36_MASK                               0x40
#define _AT1CC3L_AT1CC37_POSN                               0x7
#define _AT1CC3L_AT1CC37_POSITION                           0x7
#define _AT1CC3L_AT1CC37_SIZE                               0x1
#define _AT1CC3L_AT1CC37_LENGTH                             0x1
#define _AT1CC3L_AT1CC37_MASK                               0x80
#define _AT1CC3L_CC30_POSN                                  0x0
#define _AT1CC3L_CC30_POSITION                              0x0
#define _AT1CC3L_CC30_SIZE                                  0x1
#define _AT1CC3L_CC30_LENGTH                                0x1
#define _AT1CC3L_CC30_MASK                                  0x1
#define _AT1CC3L_CC31_POSN                                  0x1
#define _AT1CC3L_CC31_POSITION                              0x1
#define _AT1CC3L_CC31_SIZE                                  0x1
#define _AT1CC3L_CC31_LENGTH                                0x1
#define _AT1CC3L_CC31_MASK                                  0x2
#define _AT1CC3L_CC32_POSN                                  0x2
#define _AT1CC3L_CC32_POSITION                              0x2
#define _AT1CC3L_CC32_SIZE                                  0x1
#define _AT1CC3L_CC32_LENGTH                                0x1
#define _AT1CC3L_CC32_MASK                                  0x4
#define _AT1CC3L_CC33_POSN                                  0x3
#define _AT1CC3L_CC33_POSITION                              0x3
#define _AT1CC3L_CC33_SIZE                                  0x1
#define _AT1CC3L_CC33_LENGTH                                0x1
#define _AT1CC3L_CC33_MASK                                  0x8
#define _AT1CC3L_CC34_POSN                                  0x4
#define _AT1CC3L_CC34_POSITION                              0x4
#define _AT1CC3L_CC34_SIZE                                  0x1
#define _AT1CC3L_CC34_LENGTH                                0x1
#define _AT1CC3L_CC34_MASK                                  0x10
#define _AT1CC3L_CC35_POSN                                  0x5
#define _AT1CC3L_CC35_POSITION                              0x5
#define _AT1CC3L_CC35_SIZE                                  0x1
#define _AT1CC3L_CC35_LENGTH                                0x1
#define _AT1CC3L_CC35_MASK                                  0x20
#define _AT1CC3L_CC36_POSN                                  0x6
#define _AT1CC3L_CC36_POSITION                              0x6
#define _AT1CC3L_CC36_SIZE                                  0x1
#define _AT1CC3L_CC36_LENGTH                                0x1
#define _AT1CC3L_CC36_MASK                                  0x40
#define _AT1CC3L_CC37_POSN                                  0x7
#define _AT1CC3L_CC37_POSITION                              0x7
#define _AT1CC3L_CC37_SIZE                                  0x1
#define _AT1CC3L_CC37_LENGTH                                0x1
#define _AT1CC3L_CC37_MASK                                  0x80

// Register: AT1CC3H
extern volatile unsigned char           AT1CC3H             @ 0x898;
#ifndef _LIB_BUILD
asm("AT1CC3H equ 0898h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CC38                :1;
        unsigned AT1CC39                :1;
    };
    struct {
        unsigned CC38                   :1;
        unsigned CC39                   :1;
    };
} AT1CC3Hbits_t;
extern volatile AT1CC3Hbits_t AT1CC3Hbits @ 0x898;
// bitfield macros
#define _AT1CC3H_AT1CC38_POSN                               0x0
#define _AT1CC3H_AT1CC38_POSITION                           0x0
#define _AT1CC3H_AT1CC38_SIZE                               0x1
#define _AT1CC3H_AT1CC38_LENGTH                             0x1
#define _AT1CC3H_AT1CC38_MASK                               0x1
#define _AT1CC3H_AT1CC39_POSN                               0x1
#define _AT1CC3H_AT1CC39_POSITION                           0x1
#define _AT1CC3H_AT1CC39_SIZE                               0x1
#define _AT1CC3H_AT1CC39_LENGTH                             0x1
#define _AT1CC3H_AT1CC39_MASK                               0x2
#define _AT1CC3H_CC38_POSN                                  0x0
#define _AT1CC3H_CC38_POSITION                              0x0
#define _AT1CC3H_CC38_SIZE                                  0x1
#define _AT1CC3H_CC38_LENGTH                                0x1
#define _AT1CC3H_CC38_MASK                                  0x1
#define _AT1CC3H_CC39_POSN                                  0x1
#define _AT1CC3H_CC39_POSITION                              0x1
#define _AT1CC3H_CC39_SIZE                                  0x1
#define _AT1CC3H_CC39_LENGTH                                0x1
#define _AT1CC3H_CC39_MASK                                  0x2

// Register: AT1CCON3
extern volatile unsigned char           AT1CCON3            @ 0x899;
#ifndef _LIB_BUILD
asm("AT1CCON3 equ 0899h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AT1CC3MODE             :1;
        unsigned                        :2;
        unsigned AT1CAP3P               :1;
        unsigned AT1CC3POL              :1;
        unsigned                        :2;
        unsigned AT1CC3EN               :1;
    };
    struct {
        unsigned CC3MODE                :1;
        unsigned                        :2;
        unsigned CAP3P                  :1;
        unsigned CC3POL                 :1;
        unsigned                        :2;
        unsigned CC3EN                  :1;
    };
} AT1CCON3bits_t;
extern volatile AT1CCON3bits_t AT1CCON3bits @ 0x899;
// bitfield macros
#define _AT1CCON3_AT1CC3MODE_POSN                           0x0
#define _AT1CCON3_AT1CC3MODE_POSITION                       0x0
#define _AT1CCON3_AT1CC3MODE_SIZE                           0x1
#define _AT1CCON3_AT1CC3MODE_LENGTH                         0x1
#define _AT1CCON3_AT1CC3MODE_MASK                           0x1
#define _AT1CCON3_AT1CAP3P_POSN                             0x3
#define _AT1CCON3_AT1CAP3P_POSITION                         0x3
#define _AT1CCON3_AT1CAP3P_SIZE                             0x1
#define _AT1CCON3_AT1CAP3P_LENGTH                           0x1
#define _AT1CCON3_AT1CAP3P_MASK                             0x8
#define _AT1CCON3_AT1CC3POL_POSN                            0x4
#define _AT1CCON3_AT1CC3POL_POSITION                        0x4
#define _AT1CCON3_AT1CC3POL_SIZE                            0x1
#define _AT1CCON3_AT1CC3POL_LENGTH                          0x1
#define _AT1CCON3_AT1CC3POL_MASK                            0x10
#define _AT1CCON3_AT1CC3EN_POSN                             0x7
#define _AT1CCON3_AT1CC3EN_POSITION                         0x7
#define _AT1CCON3_AT1CC3EN_SIZE                             0x1
#define _AT1CCON3_AT1CC3EN_LENGTH                           0x1
#define _AT1CCON3_AT1CC3EN_MASK                             0x80
#define _AT1CCON3_CC3MODE_POSN                              0x0
#define _AT1CCON3_CC3MODE_POSITION                          0x0
#define _AT1CCON3_CC3MODE_SIZE                              0x1
#define _AT1CCON3_CC3MODE_LENGTH                            0x1
#define _AT1CCON3_CC3MODE_MASK                              0x1
#define _AT1CCON3_CAP3P_POSN                                0x3
#define _AT1CCON3_CAP3P_POSITION                            0x3
#define _AT1CCON3_CAP3P_SIZE                                0x1
#define _AT1CCON3_CAP3P_LENGTH                              0x1
#define _AT1CCON3_CAP3P_MASK                                0x8
#define _AT1CCON3_CC3POL_POSN                               0x4
#define _AT1CCON3_CC3POL_POSITION                           0x4
#define _AT1CCON3_CC3POL_SIZE                               0x1
#define _AT1CCON3_CC3POL_LENGTH                             0x1
#define _AT1CCON3_CC3POL_MASK                               0x10
#define _AT1CCON3_CC3EN_POSN                                0x7
#define _AT1CCON3_CC3EN_POSITION                            0x7
#define _AT1CCON3_CC3EN_SIZE                                0x1
#define _AT1CCON3_CC3EN_LENGTH                              0x1
#define _AT1CCON3_CC3EN_MASK                                0x80

// Register: SMT1TMR
#ifndef __CCI__
extern volatile unsigned short long     SMT1TMR             @ 0xD8C;
#endif
#ifndef _LIB_BUILD
asm("SMT1TMR equ 0D8Ch");
#endif

// Register: SMT1TMRL
extern volatile unsigned char           SMT1TMRL            @ 0xD8C;
#ifndef _LIB_BUILD
asm("SMT1TMRL equ 0D8Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1TMR                :8;
    };
    struct {
        unsigned SMT1TMR0               :1;
        unsigned SMT1TMR1               :1;
        unsigned SMT1TMR2               :1;
        unsigned SMT1TMR3               :1;
        unsigned SMT1TMR4               :1;
        unsigned SMT1TMR5               :1;
        unsigned SMT1TMR6               :1;
        unsigned SMT1TMR7               :1;
    };
} SMT1TMRLbits_t;
extern volatile SMT1TMRLbits_t SMT1TMRLbits @ 0xD8C;
// bitfield macros
#define _SMT1TMRL_SMT1TMR_POSN                              0x0
#define _SMT1TMRL_SMT1TMR_POSITION                          0x0
#define _SMT1TMRL_SMT1TMR_SIZE                              0x8
#define _SMT1TMRL_SMT1TMR_LENGTH                            0x8
#define _SMT1TMRL_SMT1TMR_MASK                              0xFF
#define _SMT1TMRL_SMT1TMR0_POSN                             0x0
#define _SMT1TMRL_SMT1TMR0_POSITION                         0x0
#define _SMT1TMRL_SMT1TMR0_SIZE                             0x1
#define _SMT1TMRL_SMT1TMR0_LENGTH                           0x1
#define _SMT1TMRL_SMT1TMR0_MASK                             0x1
#define _SMT1TMRL_SMT1TMR1_POSN                             0x1
#define _SMT1TMRL_SMT1TMR1_POSITION                         0x1
#define _SMT1TMRL_SMT1TMR1_SIZE                             0x1
#define _SMT1TMRL_SMT1TMR1_LENGTH                           0x1
#define _SMT1TMRL_SMT1TMR1_MASK                             0x2
#define _SMT1TMRL_SMT1TMR2_POSN                             0x2
#define _SMT1TMRL_SMT1TMR2_POSITION                         0x2
#define _SMT1TMRL_SMT1TMR2_SIZE                             0x1
#define _SMT1TMRL_SMT1TMR2_LENGTH                           0x1
#define _SMT1TMRL_SMT1TMR2_MASK                             0x4
#define _SMT1TMRL_SMT1TMR3_POSN                             0x3
#define _SMT1TMRL_SMT1TMR3_POSITION                         0x3
#define _SMT1TMRL_SMT1TMR3_SIZE                             0x1
#define _SMT1TMRL_SMT1TMR3_LENGTH                           0x1
#define _SMT1TMRL_SMT1TMR3_MASK                             0x8
#define _SMT1TMRL_SMT1TMR4_POSN                             0x4
#define _SMT1TMRL_SMT1TMR4_POSITION                         0x4
#define _SMT1TMRL_SMT1TMR4_SIZE                             0x1
#define _SMT1TMRL_SMT1TMR4_LENGTH                           0x1
#define _SMT1TMRL_SMT1TMR4_MASK                             0x10
#define _SMT1TMRL_SMT1TMR5_POSN                             0x5
#define _SMT1TMRL_SMT1TMR5_POSITION                         0x5
#define _SMT1TMRL_SMT1TMR5_SIZE                             0x1
#define _SMT1TMRL_SMT1TMR5_LENGTH                           0x1
#define _SMT1TMRL_SMT1TMR5_MASK                             0x20
#define _SMT1TMRL_SMT1TMR6_POSN                             0x6
#define _SMT1TMRL_SMT1TMR6_POSITION                         0x6
#define _SMT1TMRL_SMT1TMR6_SIZE                             0x1
#define _SMT1TMRL_SMT1TMR6_LENGTH                           0x1
#define _SMT1TMRL_SMT1TMR6_MASK                             0x40
#define _SMT1TMRL_SMT1TMR7_POSN                             0x7
#define _SMT1TMRL_SMT1TMR7_POSITION                         0x7
#define _SMT1TMRL_SMT1TMR7_SIZE                             0x1
#define _SMT1TMRL_SMT1TMR7_LENGTH                           0x1
#define _SMT1TMRL_SMT1TMR7_MASK                             0x80

// Register: SMT1TMRH
extern volatile unsigned char           SMT1TMRH            @ 0xD8D;
#ifndef _LIB_BUILD
asm("SMT1TMRH equ 0D8Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1TMR                :8;
    };
    struct {
        unsigned SMT1TMR8               :1;
        unsigned SMT1TMR9               :1;
        unsigned SMT1TMR10              :1;
        unsigned SMT1TMR11              :1;
        unsigned SMT1TMR12              :1;
        unsigned SMT1TMR13              :1;
        unsigned SMT1TMR14              :1;
        unsigned SMT1TMR15              :1;
    };
} SMT1TMRHbits_t;
extern volatile SMT1TMRHbits_t SMT1TMRHbits @ 0xD8D;
// bitfield macros
#define _SMT1TMRH_SMT1TMR_POSN                              0x0
#define _SMT1TMRH_SMT1TMR_POSITION                          0x0
#define _SMT1TMRH_SMT1TMR_SIZE                              0x8
#define _SMT1TMRH_SMT1TMR_LENGTH                            0x8
#define _SMT1TMRH_SMT1TMR_MASK                              0xFF
#define _SMT1TMRH_SMT1TMR8_POSN                             0x0
#define _SMT1TMRH_SMT1TMR8_POSITION                         0x0
#define _SMT1TMRH_SMT1TMR8_SIZE                             0x1
#define _SMT1TMRH_SMT1TMR8_LENGTH                           0x1
#define _SMT1TMRH_SMT1TMR8_MASK                             0x1
#define _SMT1TMRH_SMT1TMR9_POSN                             0x1
#define _SMT1TMRH_SMT1TMR9_POSITION                         0x1
#define _SMT1TMRH_SMT1TMR9_SIZE                             0x1
#define _SMT1TMRH_SMT1TMR9_LENGTH                           0x1
#define _SMT1TMRH_SMT1TMR9_MASK                             0x2
#define _SMT1TMRH_SMT1TMR10_POSN                            0x2
#define _SMT1TMRH_SMT1TMR10_POSITION                        0x2
#define _SMT1TMRH_SMT1TMR10_SIZE                            0x1
#define _SMT1TMRH_SMT1TMR10_LENGTH                          0x1
#define _SMT1TMRH_SMT1TMR10_MASK                            0x4
#define _SMT1TMRH_SMT1TMR11_POSN                            0x3
#define _SMT1TMRH_SMT1TMR11_POSITION                        0x3
#define _SMT1TMRH_SMT1TMR11_SIZE                            0x1
#define _SMT1TMRH_SMT1TMR11_LENGTH                          0x1
#define _SMT1TMRH_SMT1TMR11_MASK                            0x8
#define _SMT1TMRH_SMT1TMR12_POSN                            0x4
#define _SMT1TMRH_SMT1TMR12_POSITION                        0x4
#define _SMT1TMRH_SMT1TMR12_SIZE                            0x1
#define _SMT1TMRH_SMT1TMR12_LENGTH                          0x1
#define _SMT1TMRH_SMT1TMR12_MASK                            0x10
#define _SMT1TMRH_SMT1TMR13_POSN                            0x5
#define _SMT1TMRH_SMT1TMR13_POSITION                        0x5
#define _SMT1TMRH_SMT1TMR13_SIZE                            0x1
#define _SMT1TMRH_SMT1TMR13_LENGTH                          0x1
#define _SMT1TMRH_SMT1TMR13_MASK                            0x20
#define _SMT1TMRH_SMT1TMR14_POSN                            0x6
#define _SMT1TMRH_SMT1TMR14_POSITION                        0x6
#define _SMT1TMRH_SMT1TMR14_SIZE                            0x1
#define _SMT1TMRH_SMT1TMR14_LENGTH                          0x1
#define _SMT1TMRH_SMT1TMR14_MASK                            0x40
#define _SMT1TMRH_SMT1TMR15_POSN                            0x7
#define _SMT1TMRH_SMT1TMR15_POSITION                        0x7
#define _SMT1TMRH_SMT1TMR15_SIZE                            0x1
#define _SMT1TMRH_SMT1TMR15_LENGTH                          0x1
#define _SMT1TMRH_SMT1TMR15_MASK                            0x80

// Register: SMT1TMRU
extern volatile unsigned char           SMT1TMRU            @ 0xD8E;
#ifndef _LIB_BUILD
asm("SMT1TMRU equ 0D8Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1TMR                :8;
    };
    struct {
        unsigned SMT1TMR16              :1;
        unsigned SMT1TMR17              :1;
        unsigned SMT1TMR18              :1;
        unsigned SMT1TMR19              :1;
        unsigned SMT1TMR20              :1;
        unsigned SMT1TMR21              :1;
        unsigned SMT1TMR22              :1;
        unsigned SMT1TMR23              :1;
    };
} SMT1TMRUbits_t;
extern volatile SMT1TMRUbits_t SMT1TMRUbits @ 0xD8E;
// bitfield macros
#define _SMT1TMRU_SMT1TMR_POSN                              0x0
#define _SMT1TMRU_SMT1TMR_POSITION                          0x0
#define _SMT1TMRU_SMT1TMR_SIZE                              0x8
#define _SMT1TMRU_SMT1TMR_LENGTH                            0x8
#define _SMT1TMRU_SMT1TMR_MASK                              0xFF
#define _SMT1TMRU_SMT1TMR16_POSN                            0x0
#define _SMT1TMRU_SMT1TMR16_POSITION                        0x0
#define _SMT1TMRU_SMT1TMR16_SIZE                            0x1
#define _SMT1TMRU_SMT1TMR16_LENGTH                          0x1
#define _SMT1TMRU_SMT1TMR16_MASK                            0x1
#define _SMT1TMRU_SMT1TMR17_POSN                            0x1
#define _SMT1TMRU_SMT1TMR17_POSITION                        0x1
#define _SMT1TMRU_SMT1TMR17_SIZE                            0x1
#define _SMT1TMRU_SMT1TMR17_LENGTH                          0x1
#define _SMT1TMRU_SMT1TMR17_MASK                            0x2
#define _SMT1TMRU_SMT1TMR18_POSN                            0x2
#define _SMT1TMRU_SMT1TMR18_POSITION                        0x2
#define _SMT1TMRU_SMT1TMR18_SIZE                            0x1
#define _SMT1TMRU_SMT1TMR18_LENGTH                          0x1
#define _SMT1TMRU_SMT1TMR18_MASK                            0x4
#define _SMT1TMRU_SMT1TMR19_POSN                            0x3
#define _SMT1TMRU_SMT1TMR19_POSITION                        0x3
#define _SMT1TMRU_SMT1TMR19_SIZE                            0x1
#define _SMT1TMRU_SMT1TMR19_LENGTH                          0x1
#define _SMT1TMRU_SMT1TMR19_MASK                            0x8
#define _SMT1TMRU_SMT1TMR20_POSN                            0x4
#define _SMT1TMRU_SMT1TMR20_POSITION                        0x4
#define _SMT1TMRU_SMT1TMR20_SIZE                            0x1
#define _SMT1TMRU_SMT1TMR20_LENGTH                          0x1
#define _SMT1TMRU_SMT1TMR20_MASK                            0x10
#define _SMT1TMRU_SMT1TMR21_POSN                            0x5
#define _SMT1TMRU_SMT1TMR21_POSITION                        0x5
#define _SMT1TMRU_SMT1TMR21_SIZE                            0x1
#define _SMT1TMRU_SMT1TMR21_LENGTH                          0x1
#define _SMT1TMRU_SMT1TMR21_MASK                            0x20
#define _SMT1TMRU_SMT1TMR22_POSN                            0x6
#define _SMT1TMRU_SMT1TMR22_POSITION                        0x6
#define _SMT1TMRU_SMT1TMR22_SIZE                            0x1
#define _SMT1TMRU_SMT1TMR22_LENGTH                          0x1
#define _SMT1TMRU_SMT1TMR22_MASK                            0x40
#define _SMT1TMRU_SMT1TMR23_POSN                            0x7
#define _SMT1TMRU_SMT1TMR23_POSITION                        0x7
#define _SMT1TMRU_SMT1TMR23_SIZE                            0x1
#define _SMT1TMRU_SMT1TMR23_LENGTH                          0x1
#define _SMT1TMRU_SMT1TMR23_MASK                            0x80

// Register: SMT1CPR
#ifndef __CCI__
extern volatile unsigned short long     SMT1CPR             @ 0xD8F;
#endif
#ifndef _LIB_BUILD
asm("SMT1CPR equ 0D8Fh");
#endif

// Register: SMT1CPRL
extern volatile unsigned char           SMT1CPRL            @ 0xD8F;
#ifndef _LIB_BUILD
asm("SMT1CPRL equ 0D8Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1CPR                :8;
    };
    struct {
        unsigned SMT1CPR0               :1;
        unsigned SMT1CPR1               :1;
        unsigned SMT1CPR2               :1;
        unsigned SMT1CPR3               :1;
        unsigned SMT1CPR4               :1;
        unsigned SMT1CPR5               :1;
        unsigned SMT1CPR6               :1;
        unsigned SMT1CPR7               :1;
    };
} SMT1CPRLbits_t;
extern volatile SMT1CPRLbits_t SMT1CPRLbits @ 0xD8F;
// bitfield macros
#define _SMT1CPRL_SMT1CPR_POSN                              0x0
#define _SMT1CPRL_SMT1CPR_POSITION                          0x0
#define _SMT1CPRL_SMT1CPR_SIZE                              0x8
#define _SMT1CPRL_SMT1CPR_LENGTH                            0x8
#define _SMT1CPRL_SMT1CPR_MASK                              0xFF
#define _SMT1CPRL_SMT1CPR0_POSN                             0x0
#define _SMT1CPRL_SMT1CPR0_POSITION                         0x0
#define _SMT1CPRL_SMT1CPR0_SIZE                             0x1
#define _SMT1CPRL_SMT1CPR0_LENGTH                           0x1
#define _SMT1CPRL_SMT1CPR0_MASK                             0x1
#define _SMT1CPRL_SMT1CPR1_POSN                             0x1
#define _SMT1CPRL_SMT1CPR1_POSITION                         0x1
#define _SMT1CPRL_SMT1CPR1_SIZE                             0x1
#define _SMT1CPRL_SMT1CPR1_LENGTH                           0x1
#define _SMT1CPRL_SMT1CPR1_MASK                             0x2
#define _SMT1CPRL_SMT1CPR2_POSN                             0x2
#define _SMT1CPRL_SMT1CPR2_POSITION                         0x2
#define _SMT1CPRL_SMT1CPR2_SIZE                             0x1
#define _SMT1CPRL_SMT1CPR2_LENGTH                           0x1
#define _SMT1CPRL_SMT1CPR2_MASK                             0x4
#define _SMT1CPRL_SMT1CPR3_POSN                             0x3
#define _SMT1CPRL_SMT1CPR3_POSITION                         0x3
#define _SMT1CPRL_SMT1CPR3_SIZE                             0x1
#define _SMT1CPRL_SMT1CPR3_LENGTH                           0x1
#define _SMT1CPRL_SMT1CPR3_MASK                             0x8
#define _SMT1CPRL_SMT1CPR4_POSN                             0x4
#define _SMT1CPRL_SMT1CPR4_POSITION                         0x4
#define _SMT1CPRL_SMT1CPR4_SIZE                             0x1
#define _SMT1CPRL_SMT1CPR4_LENGTH                           0x1
#define _SMT1CPRL_SMT1CPR4_MASK                             0x10
#define _SMT1CPRL_SMT1CPR5_POSN                             0x5
#define _SMT1CPRL_SMT1CPR5_POSITION                         0x5
#define _SMT1CPRL_SMT1CPR5_SIZE                             0x1
#define _SMT1CPRL_SMT1CPR5_LENGTH                           0x1
#define _SMT1CPRL_SMT1CPR5_MASK                             0x20
#define _SMT1CPRL_SMT1CPR6_POSN                             0x6
#define _SMT1CPRL_SMT1CPR6_POSITION                         0x6
#define _SMT1CPRL_SMT1CPR6_SIZE                             0x1
#define _SMT1CPRL_SMT1CPR6_LENGTH                           0x1
#define _SMT1CPRL_SMT1CPR6_MASK                             0x40
#define _SMT1CPRL_SMT1CPR7_POSN                             0x7
#define _SMT1CPRL_SMT1CPR7_POSITION                         0x7
#define _SMT1CPRL_SMT1CPR7_SIZE                             0x1
#define _SMT1CPRL_SMT1CPR7_LENGTH                           0x1
#define _SMT1CPRL_SMT1CPR7_MASK                             0x80

// Register: SMT1CPRH
extern volatile unsigned char           SMT1CPRH            @ 0xD90;
#ifndef _LIB_BUILD
asm("SMT1CPRH equ 0D90h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1CPR                :8;
    };
    struct {
        unsigned SMT1CPR8               :1;
        unsigned SMT1CPR9               :1;
        unsigned SMT1CPR10              :1;
        unsigned SMT1CPR11              :1;
        unsigned SMT1CPR12              :1;
        unsigned SMT1CPR13              :1;
        unsigned SMT1CPR14              :1;
        unsigned SMT1CPR15              :1;
    };
} SMT1CPRHbits_t;
extern volatile SMT1CPRHbits_t SMT1CPRHbits @ 0xD90;
// bitfield macros
#define _SMT1CPRH_SMT1CPR_POSN                              0x0
#define _SMT1CPRH_SMT1CPR_POSITION                          0x0
#define _SMT1CPRH_SMT1CPR_SIZE                              0x8
#define _SMT1CPRH_SMT1CPR_LENGTH                            0x8
#define _SMT1CPRH_SMT1CPR_MASK                              0xFF
#define _SMT1CPRH_SMT1CPR8_POSN                             0x0
#define _SMT1CPRH_SMT1CPR8_POSITION                         0x0
#define _SMT1CPRH_SMT1CPR8_SIZE                             0x1
#define _SMT1CPRH_SMT1CPR8_LENGTH                           0x1
#define _SMT1CPRH_SMT1CPR8_MASK                             0x1
#define _SMT1CPRH_SMT1CPR9_POSN                             0x1
#define _SMT1CPRH_SMT1CPR9_POSITION                         0x1
#define _SMT1CPRH_SMT1CPR9_SIZE                             0x1
#define _SMT1CPRH_SMT1CPR9_LENGTH                           0x1
#define _SMT1CPRH_SMT1CPR9_MASK                             0x2
#define _SMT1CPRH_SMT1CPR10_POSN                            0x2
#define _SMT1CPRH_SMT1CPR10_POSITION                        0x2
#define _SMT1CPRH_SMT1CPR10_SIZE                            0x1
#define _SMT1CPRH_SMT1CPR10_LENGTH                          0x1
#define _SMT1CPRH_SMT1CPR10_MASK                            0x4
#define _SMT1CPRH_SMT1CPR11_POSN                            0x3
#define _SMT1CPRH_SMT1CPR11_POSITION                        0x3
#define _SMT1CPRH_SMT1CPR11_SIZE                            0x1
#define _SMT1CPRH_SMT1CPR11_LENGTH                          0x1
#define _SMT1CPRH_SMT1CPR11_MASK                            0x8
#define _SMT1CPRH_SMT1CPR12_POSN                            0x4
#define _SMT1CPRH_SMT1CPR12_POSITION                        0x4
#define _SMT1CPRH_SMT1CPR12_SIZE                            0x1
#define _SMT1CPRH_SMT1CPR12_LENGTH                          0x1
#define _SMT1CPRH_SMT1CPR12_MASK                            0x10
#define _SMT1CPRH_SMT1CPR13_POSN                            0x5
#define _SMT1CPRH_SMT1CPR13_POSITION                        0x5
#define _SMT1CPRH_SMT1CPR13_SIZE                            0x1
#define _SMT1CPRH_SMT1CPR13_LENGTH                          0x1
#define _SMT1CPRH_SMT1CPR13_MASK                            0x20
#define _SMT1CPRH_SMT1CPR14_POSN                            0x6
#define _SMT1CPRH_SMT1CPR14_POSITION                        0x6
#define _SMT1CPRH_SMT1CPR14_SIZE                            0x1
#define _SMT1CPRH_SMT1CPR14_LENGTH                          0x1
#define _SMT1CPRH_SMT1CPR14_MASK                            0x40
#define _SMT1CPRH_SMT1CPR15_POSN                            0x7
#define _SMT1CPRH_SMT1CPR15_POSITION                        0x7
#define _SMT1CPRH_SMT1CPR15_SIZE                            0x1
#define _SMT1CPRH_SMT1CPR15_LENGTH                          0x1
#define _SMT1CPRH_SMT1CPR15_MASK                            0x80

// Register: SMT1CPRU
extern volatile unsigned char           SMT1CPRU            @ 0xD91;
#ifndef _LIB_BUILD
asm("SMT1CPRU equ 0D91h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1CPR                :8;
    };
    struct {
        unsigned SMT1CPR16              :1;
        unsigned SMT1CPR17              :1;
        unsigned SMT1CPR18              :1;
        unsigned SMT1CPR19              :1;
        unsigned SMT1CPR20              :1;
        unsigned SMT1CPR21              :1;
        unsigned SMT1CPR22              :1;
        unsigned SMT1CPR23              :1;
    };
} SMT1CPRUbits_t;
extern volatile SMT1CPRUbits_t SMT1CPRUbits @ 0xD91;
// bitfield macros
#define _SMT1CPRU_SMT1CPR_POSN                              0x0
#define _SMT1CPRU_SMT1CPR_POSITION                          0x0
#define _SMT1CPRU_SMT1CPR_SIZE                              0x8
#define _SMT1CPRU_SMT1CPR_LENGTH                            0x8
#define _SMT1CPRU_SMT1CPR_MASK                              0xFF
#define _SMT1CPRU_SMT1CPR16_POSN                            0x0
#define _SMT1CPRU_SMT1CPR16_POSITION                        0x0
#define _SMT1CPRU_SMT1CPR16_SIZE                            0x1
#define _SMT1CPRU_SMT1CPR16_LENGTH                          0x1
#define _SMT1CPRU_SMT1CPR16_MASK                            0x1
#define _SMT1CPRU_SMT1CPR17_POSN                            0x1
#define _SMT1CPRU_SMT1CPR17_POSITION                        0x1
#define _SMT1CPRU_SMT1CPR17_SIZE                            0x1
#define _SMT1CPRU_SMT1CPR17_LENGTH                          0x1
#define _SMT1CPRU_SMT1CPR17_MASK                            0x2
#define _SMT1CPRU_SMT1CPR18_POSN                            0x2
#define _SMT1CPRU_SMT1CPR18_POSITION                        0x2
#define _SMT1CPRU_SMT1CPR18_SIZE                            0x1
#define _SMT1CPRU_SMT1CPR18_LENGTH                          0x1
#define _SMT1CPRU_SMT1CPR18_MASK                            0x4
#define _SMT1CPRU_SMT1CPR19_POSN                            0x3
#define _SMT1CPRU_SMT1CPR19_POSITION                        0x3
#define _SMT1CPRU_SMT1CPR19_SIZE                            0x1
#define _SMT1CPRU_SMT1CPR19_LENGTH                          0x1
#define _SMT1CPRU_SMT1CPR19_MASK                            0x8
#define _SMT1CPRU_SMT1CPR20_POSN                            0x4
#define _SMT1CPRU_SMT1CPR20_POSITION                        0x4
#define _SMT1CPRU_SMT1CPR20_SIZE                            0x1
#define _SMT1CPRU_SMT1CPR20_LENGTH                          0x1
#define _SMT1CPRU_SMT1CPR20_MASK                            0x10
#define _SMT1CPRU_SMT1CPR21_POSN                            0x5
#define _SMT1CPRU_SMT1CPR21_POSITION                        0x5
#define _SMT1CPRU_SMT1CPR21_SIZE                            0x1
#define _SMT1CPRU_SMT1CPR21_LENGTH                          0x1
#define _SMT1CPRU_SMT1CPR21_MASK                            0x20
#define _SMT1CPRU_SMT1CPR22_POSN                            0x6
#define _SMT1CPRU_SMT1CPR22_POSITION                        0x6
#define _SMT1CPRU_SMT1CPR22_SIZE                            0x1
#define _SMT1CPRU_SMT1CPR22_LENGTH                          0x1
#define _SMT1CPRU_SMT1CPR22_MASK                            0x40
#define _SMT1CPRU_SMT1CPR23_POSN                            0x7
#define _SMT1CPRU_SMT1CPR23_POSITION                        0x7
#define _SMT1CPRU_SMT1CPR23_SIZE                            0x1
#define _SMT1CPRU_SMT1CPR23_LENGTH                          0x1
#define _SMT1CPRU_SMT1CPR23_MASK                            0x80

// Register: SMT1CPW
#ifndef __CCI__
extern volatile unsigned short long     SMT1CPW             @ 0xD92;
#endif
#ifndef _LIB_BUILD
asm("SMT1CPW equ 0D92h");
#endif

// Register: SMT1CPWL
extern volatile unsigned char           SMT1CPWL            @ 0xD92;
#ifndef _LIB_BUILD
asm("SMT1CPWL equ 0D92h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1CPW                :8;
    };
    struct {
        unsigned SMT1CPW0               :1;
        unsigned SMT1CPW1               :1;
        unsigned SMT1CPW2               :1;
        unsigned SMT1CPW3               :1;
        unsigned SMT1CPW4               :1;
        unsigned SMT1CPW5               :1;
        unsigned SMT1CPW6               :1;
        unsigned SMT1CPW7               :1;
    };
} SMT1CPWLbits_t;
extern volatile SMT1CPWLbits_t SMT1CPWLbits @ 0xD92;
// bitfield macros
#define _SMT1CPWL_SMT1CPW_POSN                              0x0
#define _SMT1CPWL_SMT1CPW_POSITION                          0x0
#define _SMT1CPWL_SMT1CPW_SIZE                              0x8
#define _SMT1CPWL_SMT1CPW_LENGTH                            0x8
#define _SMT1CPWL_SMT1CPW_MASK                              0xFF
#define _SMT1CPWL_SMT1CPW0_POSN                             0x0
#define _SMT1CPWL_SMT1CPW0_POSITION                         0x0
#define _SMT1CPWL_SMT1CPW0_SIZE                             0x1
#define _SMT1CPWL_SMT1CPW0_LENGTH                           0x1
#define _SMT1CPWL_SMT1CPW0_MASK                             0x1
#define _SMT1CPWL_SMT1CPW1_POSN                             0x1
#define _SMT1CPWL_SMT1CPW1_POSITION                         0x1
#define _SMT1CPWL_SMT1CPW1_SIZE                             0x1
#define _SMT1CPWL_SMT1CPW1_LENGTH                           0x1
#define _SMT1CPWL_SMT1CPW1_MASK                             0x2
#define _SMT1CPWL_SMT1CPW2_POSN                             0x2
#define _SMT1CPWL_SMT1CPW2_POSITION                         0x2
#define _SMT1CPWL_SMT1CPW2_SIZE                             0x1
#define _SMT1CPWL_SMT1CPW2_LENGTH                           0x1
#define _SMT1CPWL_SMT1CPW2_MASK                             0x4
#define _SMT1CPWL_SMT1CPW3_POSN                             0x3
#define _SMT1CPWL_SMT1CPW3_POSITION                         0x3
#define _SMT1CPWL_SMT1CPW3_SIZE                             0x1
#define _SMT1CPWL_SMT1CPW3_LENGTH                           0x1
#define _SMT1CPWL_SMT1CPW3_MASK                             0x8
#define _SMT1CPWL_SMT1CPW4_POSN                             0x4
#define _SMT1CPWL_SMT1CPW4_POSITION                         0x4
#define _SMT1CPWL_SMT1CPW4_SIZE                             0x1
#define _SMT1CPWL_SMT1CPW4_LENGTH                           0x1
#define _SMT1CPWL_SMT1CPW4_MASK                             0x10
#define _SMT1CPWL_SMT1CPW5_POSN                             0x5
#define _SMT1CPWL_SMT1CPW5_POSITION                         0x5
#define _SMT1CPWL_SMT1CPW5_SIZE                             0x1
#define _SMT1CPWL_SMT1CPW5_LENGTH                           0x1
#define _SMT1CPWL_SMT1CPW5_MASK                             0x20
#define _SMT1CPWL_SMT1CPW6_POSN                             0x6
#define _SMT1CPWL_SMT1CPW6_POSITION                         0x6
#define _SMT1CPWL_SMT1CPW6_SIZE                             0x1
#define _SMT1CPWL_SMT1CPW6_LENGTH                           0x1
#define _SMT1CPWL_SMT1CPW6_MASK                             0x40
#define _SMT1CPWL_SMT1CPW7_POSN                             0x7
#define _SMT1CPWL_SMT1CPW7_POSITION                         0x7
#define _SMT1CPWL_SMT1CPW7_SIZE                             0x1
#define _SMT1CPWL_SMT1CPW7_LENGTH                           0x1
#define _SMT1CPWL_SMT1CPW7_MASK                             0x80

// Register: SMT1CPWH
extern volatile unsigned char           SMT1CPWH            @ 0xD93;
#ifndef _LIB_BUILD
asm("SMT1CPWH equ 0D93h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1CPW                :8;
    };
    struct {
        unsigned SMT1CPW8               :1;
        unsigned SMT1CPW9               :1;
        unsigned SMT1CPW10              :1;
        unsigned SMT1CPW11              :1;
        unsigned SMT1CPW12              :1;
        unsigned SMT1CPW13              :1;
        unsigned SMT1CPW14              :1;
        unsigned SMT1CPW15              :1;
    };
} SMT1CPWHbits_t;
extern volatile SMT1CPWHbits_t SMT1CPWHbits @ 0xD93;
// bitfield macros
#define _SMT1CPWH_SMT1CPW_POSN                              0x0
#define _SMT1CPWH_SMT1CPW_POSITION                          0x0
#define _SMT1CPWH_SMT1CPW_SIZE                              0x8
#define _SMT1CPWH_SMT1CPW_LENGTH                            0x8
#define _SMT1CPWH_SMT1CPW_MASK                              0xFF
#define _SMT1CPWH_SMT1CPW8_POSN                             0x0
#define _SMT1CPWH_SMT1CPW8_POSITION                         0x0
#define _SMT1CPWH_SMT1CPW8_SIZE                             0x1
#define _SMT1CPWH_SMT1CPW8_LENGTH                           0x1
#define _SMT1CPWH_SMT1CPW8_MASK                             0x1
#define _SMT1CPWH_SMT1CPW9_POSN                             0x1
#define _SMT1CPWH_SMT1CPW9_POSITION                         0x1
#define _SMT1CPWH_SMT1CPW9_SIZE                             0x1
#define _SMT1CPWH_SMT1CPW9_LENGTH                           0x1
#define _SMT1CPWH_SMT1CPW9_MASK                             0x2
#define _SMT1CPWH_SMT1CPW10_POSN                            0x2
#define _SMT1CPWH_SMT1CPW10_POSITION                        0x2
#define _SMT1CPWH_SMT1CPW10_SIZE                            0x1
#define _SMT1CPWH_SMT1CPW10_LENGTH                          0x1
#define _SMT1CPWH_SMT1CPW10_MASK                            0x4
#define _SMT1CPWH_SMT1CPW11_POSN                            0x3
#define _SMT1CPWH_SMT1CPW11_POSITION                        0x3
#define _SMT1CPWH_SMT1CPW11_SIZE                            0x1
#define _SMT1CPWH_SMT1CPW11_LENGTH                          0x1
#define _SMT1CPWH_SMT1CPW11_MASK                            0x8
#define _SMT1CPWH_SMT1CPW12_POSN                            0x4
#define _SMT1CPWH_SMT1CPW12_POSITION                        0x4
#define _SMT1CPWH_SMT1CPW12_SIZE                            0x1
#define _SMT1CPWH_SMT1CPW12_LENGTH                          0x1
#define _SMT1CPWH_SMT1CPW12_MASK                            0x10
#define _SMT1CPWH_SMT1CPW13_POSN                            0x5
#define _SMT1CPWH_SMT1CPW13_POSITION                        0x5
#define _SMT1CPWH_SMT1CPW13_SIZE                            0x1
#define _SMT1CPWH_SMT1CPW13_LENGTH                          0x1
#define _SMT1CPWH_SMT1CPW13_MASK                            0x20
#define _SMT1CPWH_SMT1CPW14_POSN                            0x6
#define _SMT1CPWH_SMT1CPW14_POSITION                        0x6
#define _SMT1CPWH_SMT1CPW14_SIZE                            0x1
#define _SMT1CPWH_SMT1CPW14_LENGTH                          0x1
#define _SMT1CPWH_SMT1CPW14_MASK                            0x40
#define _SMT1CPWH_SMT1CPW15_POSN                            0x7
#define _SMT1CPWH_SMT1CPW15_POSITION                        0x7
#define _SMT1CPWH_SMT1CPW15_SIZE                            0x1
#define _SMT1CPWH_SMT1CPW15_LENGTH                          0x1
#define _SMT1CPWH_SMT1CPW15_MASK                            0x80

// Register: SMT1CPWU
extern volatile unsigned char           SMT1CPWU            @ 0xD94;
#ifndef _LIB_BUILD
asm("SMT1CPWU equ 0D94h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1CPW                :8;
    };
    struct {
        unsigned SMT1CPW16              :1;
        unsigned SMT1CPW17              :1;
        unsigned SMT1CPW18              :1;
        unsigned SMT1CPW19              :1;
        unsigned SMT1CPW20              :1;
        unsigned SMT1CPW21              :1;
        unsigned SMT1CPW22              :1;
        unsigned SMT1CPW23              :1;
    };
} SMT1CPWUbits_t;
extern volatile SMT1CPWUbits_t SMT1CPWUbits @ 0xD94;
// bitfield macros
#define _SMT1CPWU_SMT1CPW_POSN                              0x0
#define _SMT1CPWU_SMT1CPW_POSITION                          0x0
#define _SMT1CPWU_SMT1CPW_SIZE                              0x8
#define _SMT1CPWU_SMT1CPW_LENGTH                            0x8
#define _SMT1CPWU_SMT1CPW_MASK                              0xFF
#define _SMT1CPWU_SMT1CPW16_POSN                            0x0
#define _SMT1CPWU_SMT1CPW16_POSITION                        0x0
#define _SMT1CPWU_SMT1CPW16_SIZE                            0x1
#define _SMT1CPWU_SMT1CPW16_LENGTH                          0x1
#define _SMT1CPWU_SMT1CPW16_MASK                            0x1
#define _SMT1CPWU_SMT1CPW17_POSN                            0x1
#define _SMT1CPWU_SMT1CPW17_POSITION                        0x1
#define _SMT1CPWU_SMT1CPW17_SIZE                            0x1
#define _SMT1CPWU_SMT1CPW17_LENGTH                          0x1
#define _SMT1CPWU_SMT1CPW17_MASK                            0x2
#define _SMT1CPWU_SMT1CPW18_POSN                            0x2
#define _SMT1CPWU_SMT1CPW18_POSITION                        0x2
#define _SMT1CPWU_SMT1CPW18_SIZE                            0x1
#define _SMT1CPWU_SMT1CPW18_LENGTH                          0x1
#define _SMT1CPWU_SMT1CPW18_MASK                            0x4
#define _SMT1CPWU_SMT1CPW19_POSN                            0x3
#define _SMT1CPWU_SMT1CPW19_POSITION                        0x3
#define _SMT1CPWU_SMT1CPW19_SIZE                            0x1
#define _SMT1CPWU_SMT1CPW19_LENGTH                          0x1
#define _SMT1CPWU_SMT1CPW19_MASK                            0x8
#define _SMT1CPWU_SMT1CPW20_POSN                            0x4
#define _SMT1CPWU_SMT1CPW20_POSITION                        0x4
#define _SMT1CPWU_SMT1CPW20_SIZE                            0x1
#define _SMT1CPWU_SMT1CPW20_LENGTH                          0x1
#define _SMT1CPWU_SMT1CPW20_MASK                            0x10
#define _SMT1CPWU_SMT1CPW21_POSN                            0x5
#define _SMT1CPWU_SMT1CPW21_POSITION                        0x5
#define _SMT1CPWU_SMT1CPW21_SIZE                            0x1
#define _SMT1CPWU_SMT1CPW21_LENGTH                          0x1
#define _SMT1CPWU_SMT1CPW21_MASK                            0x20
#define _SMT1CPWU_SMT1CPW22_POSN                            0x6
#define _SMT1CPWU_SMT1CPW22_POSITION                        0x6
#define _SMT1CPWU_SMT1CPW22_SIZE                            0x1
#define _SMT1CPWU_SMT1CPW22_LENGTH                          0x1
#define _SMT1CPWU_SMT1CPW22_MASK                            0x40
#define _SMT1CPWU_SMT1CPW23_POSN                            0x7
#define _SMT1CPWU_SMT1CPW23_POSITION                        0x7
#define _SMT1CPWU_SMT1CPW23_SIZE                            0x1
#define _SMT1CPWU_SMT1CPW23_LENGTH                          0x1
#define _SMT1CPWU_SMT1CPW23_MASK                            0x80

// Register: SMT1PR
#ifndef __CCI__
extern volatile unsigned short long     SMT1PR              @ 0xD95;
#endif
#ifndef _LIB_BUILD
asm("SMT1PR equ 0D95h");
#endif

// Register: SMT1PRL
extern volatile unsigned char           SMT1PRL             @ 0xD95;
#ifndef _LIB_BUILD
asm("SMT1PRL equ 0D95h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1PR                 :8;
    };
    struct {
        unsigned SMT1PR0                :1;
        unsigned SMT1PR1                :1;
        unsigned SMT1PR2                :1;
        unsigned SMT1PR3                :1;
        unsigned SMT1PR4                :1;
        unsigned SMT1PR5                :1;
        unsigned SMT1PR6                :1;
        unsigned SMT1PR7                :1;
    };
} SMT1PRLbits_t;
extern volatile SMT1PRLbits_t SMT1PRLbits @ 0xD95;
// bitfield macros
#define _SMT1PRL_SMT1PR_POSN                                0x0
#define _SMT1PRL_SMT1PR_POSITION                            0x0
#define _SMT1PRL_SMT1PR_SIZE                                0x8
#define _SMT1PRL_SMT1PR_LENGTH                              0x8
#define _SMT1PRL_SMT1PR_MASK                                0xFF
#define _SMT1PRL_SMT1PR0_POSN                               0x0
#define _SMT1PRL_SMT1PR0_POSITION                           0x0
#define _SMT1PRL_SMT1PR0_SIZE                               0x1
#define _SMT1PRL_SMT1PR0_LENGTH                             0x1
#define _SMT1PRL_SMT1PR0_MASK                               0x1
#define _SMT1PRL_SMT1PR1_POSN                               0x1
#define _SMT1PRL_SMT1PR1_POSITION                           0x1
#define _SMT1PRL_SMT1PR1_SIZE                               0x1
#define _SMT1PRL_SMT1PR1_LENGTH                             0x1
#define _SMT1PRL_SMT1PR1_MASK                               0x2
#define _SMT1PRL_SMT1PR2_POSN                               0x2
#define _SMT1PRL_SMT1PR2_POSITION                           0x2
#define _SMT1PRL_SMT1PR2_SIZE                               0x1
#define _SMT1PRL_SMT1PR2_LENGTH                             0x1
#define _SMT1PRL_SMT1PR2_MASK                               0x4
#define _SMT1PRL_SMT1PR3_POSN                               0x3
#define _SMT1PRL_SMT1PR3_POSITION                           0x3
#define _SMT1PRL_SMT1PR3_SIZE                               0x1
#define _SMT1PRL_SMT1PR3_LENGTH                             0x1
#define _SMT1PRL_SMT1PR3_MASK                               0x8
#define _SMT1PRL_SMT1PR4_POSN                               0x4
#define _SMT1PRL_SMT1PR4_POSITION                           0x4
#define _SMT1PRL_SMT1PR4_SIZE                               0x1
#define _SMT1PRL_SMT1PR4_LENGTH                             0x1
#define _SMT1PRL_SMT1PR4_MASK                               0x10
#define _SMT1PRL_SMT1PR5_POSN                               0x5
#define _SMT1PRL_SMT1PR5_POSITION                           0x5
#define _SMT1PRL_SMT1PR5_SIZE                               0x1
#define _SMT1PRL_SMT1PR5_LENGTH                             0x1
#define _SMT1PRL_SMT1PR5_MASK                               0x20
#define _SMT1PRL_SMT1PR6_POSN                               0x6
#define _SMT1PRL_SMT1PR6_POSITION                           0x6
#define _SMT1PRL_SMT1PR6_SIZE                               0x1
#define _SMT1PRL_SMT1PR6_LENGTH                             0x1
#define _SMT1PRL_SMT1PR6_MASK                               0x40
#define _SMT1PRL_SMT1PR7_POSN                               0x7
#define _SMT1PRL_SMT1PR7_POSITION                           0x7
#define _SMT1PRL_SMT1PR7_SIZE                               0x1
#define _SMT1PRL_SMT1PR7_LENGTH                             0x1
#define _SMT1PRL_SMT1PR7_MASK                               0x80

// Register: SMT1PRH
extern volatile unsigned char           SMT1PRH             @ 0xD96;
#ifndef _LIB_BUILD
asm("SMT1PRH equ 0D96h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1PR                 :8;
    };
    struct {
        unsigned SMT1PR8                :1;
        unsigned SMT1PR9                :1;
        unsigned SMT1PR10               :1;
        unsigned SMT1PR11               :1;
        unsigned SMT1PR12               :1;
        unsigned SMT1PR13               :1;
        unsigned SMT1PR14               :1;
        unsigned SMT1PR15               :1;
    };
} SMT1PRHbits_t;
extern volatile SMT1PRHbits_t SMT1PRHbits @ 0xD96;
// bitfield macros
#define _SMT1PRH_SMT1PR_POSN                                0x0
#define _SMT1PRH_SMT1PR_POSITION                            0x0
#define _SMT1PRH_SMT1PR_SIZE                                0x8
#define _SMT1PRH_SMT1PR_LENGTH                              0x8
#define _SMT1PRH_SMT1PR_MASK                                0xFF
#define _SMT1PRH_SMT1PR8_POSN                               0x0
#define _SMT1PRH_SMT1PR8_POSITION                           0x0
#define _SMT1PRH_SMT1PR8_SIZE                               0x1
#define _SMT1PRH_SMT1PR8_LENGTH                             0x1
#define _SMT1PRH_SMT1PR8_MASK                               0x1
#define _SMT1PRH_SMT1PR9_POSN                               0x1
#define _SMT1PRH_SMT1PR9_POSITION                           0x1
#define _SMT1PRH_SMT1PR9_SIZE                               0x1
#define _SMT1PRH_SMT1PR9_LENGTH                             0x1
#define _SMT1PRH_SMT1PR9_MASK                               0x2
#define _SMT1PRH_SMT1PR10_POSN                              0x2
#define _SMT1PRH_SMT1PR10_POSITION                          0x2
#define _SMT1PRH_SMT1PR10_SIZE                              0x1
#define _SMT1PRH_SMT1PR10_LENGTH                            0x1
#define _SMT1PRH_SMT1PR10_MASK                              0x4
#define _SMT1PRH_SMT1PR11_POSN                              0x3
#define _SMT1PRH_SMT1PR11_POSITION                          0x3
#define _SMT1PRH_SMT1PR11_SIZE                              0x1
#define _SMT1PRH_SMT1PR11_LENGTH                            0x1
#define _SMT1PRH_SMT1PR11_MASK                              0x8
#define _SMT1PRH_SMT1PR12_POSN                              0x4
#define _SMT1PRH_SMT1PR12_POSITION                          0x4
#define _SMT1PRH_SMT1PR12_SIZE                              0x1
#define _SMT1PRH_SMT1PR12_LENGTH                            0x1
#define _SMT1PRH_SMT1PR12_MASK                              0x10
#define _SMT1PRH_SMT1PR13_POSN                              0x5
#define _SMT1PRH_SMT1PR13_POSITION                          0x5
#define _SMT1PRH_SMT1PR13_SIZE                              0x1
#define _SMT1PRH_SMT1PR13_LENGTH                            0x1
#define _SMT1PRH_SMT1PR13_MASK                              0x20
#define _SMT1PRH_SMT1PR14_POSN                              0x6
#define _SMT1PRH_SMT1PR14_POSITION                          0x6
#define _SMT1PRH_SMT1PR14_SIZE                              0x1
#define _SMT1PRH_SMT1PR14_LENGTH                            0x1
#define _SMT1PRH_SMT1PR14_MASK                              0x40
#define _SMT1PRH_SMT1PR15_POSN                              0x7
#define _SMT1PRH_SMT1PR15_POSITION                          0x7
#define _SMT1PRH_SMT1PR15_SIZE                              0x1
#define _SMT1PRH_SMT1PR15_LENGTH                            0x1
#define _SMT1PRH_SMT1PR15_MASK                              0x80

// Register: SMT1PRU
extern volatile unsigned char           SMT1PRU             @ 0xD97;
#ifndef _LIB_BUILD
asm("SMT1PRU equ 0D97h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1PR                 :8;
    };
    struct {
        unsigned SMT1PR16               :1;
        unsigned SMT1PR17               :1;
        unsigned SMT1PR18               :1;
        unsigned SMT1PR19               :1;
        unsigned SMT1PR20               :1;
        unsigned SMT1PR21               :1;
        unsigned SMT1PR22               :1;
        unsigned SMT1PR23               :1;
    };
} SMT1PRUbits_t;
extern volatile SMT1PRUbits_t SMT1PRUbits @ 0xD97;
// bitfield macros
#define _SMT1PRU_SMT1PR_POSN                                0x0
#define _SMT1PRU_SMT1PR_POSITION                            0x0
#define _SMT1PRU_SMT1PR_SIZE                                0x8
#define _SMT1PRU_SMT1PR_LENGTH                              0x8
#define _SMT1PRU_SMT1PR_MASK                                0xFF
#define _SMT1PRU_SMT1PR16_POSN                              0x0
#define _SMT1PRU_SMT1PR16_POSITION                          0x0
#define _SMT1PRU_SMT1PR16_SIZE                              0x1
#define _SMT1PRU_SMT1PR16_LENGTH                            0x1
#define _SMT1PRU_SMT1PR16_MASK                              0x1
#define _SMT1PRU_SMT1PR17_POSN                              0x1
#define _SMT1PRU_SMT1PR17_POSITION                          0x1
#define _SMT1PRU_SMT1PR17_SIZE                              0x1
#define _SMT1PRU_SMT1PR17_LENGTH                            0x1
#define _SMT1PRU_SMT1PR17_MASK                              0x2
#define _SMT1PRU_SMT1PR18_POSN                              0x2
#define _SMT1PRU_SMT1PR18_POSITION                          0x2
#define _SMT1PRU_SMT1PR18_SIZE                              0x1
#define _SMT1PRU_SMT1PR18_LENGTH                            0x1
#define _SMT1PRU_SMT1PR18_MASK                              0x4
#define _SMT1PRU_SMT1PR19_POSN                              0x3
#define _SMT1PRU_SMT1PR19_POSITION                          0x3
#define _SMT1PRU_SMT1PR19_SIZE                              0x1
#define _SMT1PRU_SMT1PR19_LENGTH                            0x1
#define _SMT1PRU_SMT1PR19_MASK                              0x8
#define _SMT1PRU_SMT1PR20_POSN                              0x4
#define _SMT1PRU_SMT1PR20_POSITION                          0x4
#define _SMT1PRU_SMT1PR20_SIZE                              0x1
#define _SMT1PRU_SMT1PR20_LENGTH                            0x1
#define _SMT1PRU_SMT1PR20_MASK                              0x10
#define _SMT1PRU_SMT1PR21_POSN                              0x5
#define _SMT1PRU_SMT1PR21_POSITION                          0x5
#define _SMT1PRU_SMT1PR21_SIZE                              0x1
#define _SMT1PRU_SMT1PR21_LENGTH                            0x1
#define _SMT1PRU_SMT1PR21_MASK                              0x20
#define _SMT1PRU_SMT1PR22_POSN                              0x6
#define _SMT1PRU_SMT1PR22_POSITION                          0x6
#define _SMT1PRU_SMT1PR22_SIZE                              0x1
#define _SMT1PRU_SMT1PR22_LENGTH                            0x1
#define _SMT1PRU_SMT1PR22_MASK                              0x40
#define _SMT1PRU_SMT1PR23_POSN                              0x7
#define _SMT1PRU_SMT1PR23_POSITION                          0x7
#define _SMT1PRU_SMT1PR23_SIZE                              0x1
#define _SMT1PRU_SMT1PR23_LENGTH                            0x1
#define _SMT1PRU_SMT1PR23_MASK                              0x80

// Register: SMT1CON0
extern volatile unsigned char           SMT1CON0            @ 0xD98;
#ifndef _LIB_BUILD
asm("SMT1CON0 equ 0D98h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1PS                 :2;
        unsigned CPOL                   :1;
        unsigned SPOL                   :1;
        unsigned WPOL                   :1;
        unsigned STP                    :1;
        unsigned                        :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned SMT1PS0                :1;
        unsigned SMT1PS1                :1;
    };
} SMT1CON0bits_t;
extern volatile SMT1CON0bits_t SMT1CON0bits @ 0xD98;
// bitfield macros
#define _SMT1CON0_SMT1PS_POSN                               0x0
#define _SMT1CON0_SMT1PS_POSITION                           0x0
#define _SMT1CON0_SMT1PS_SIZE                               0x2
#define _SMT1CON0_SMT1PS_LENGTH                             0x2
#define _SMT1CON0_SMT1PS_MASK                               0x3
#define _SMT1CON0_CPOL_POSN                                 0x2
#define _SMT1CON0_CPOL_POSITION                             0x2
#define _SMT1CON0_CPOL_SIZE                                 0x1
#define _SMT1CON0_CPOL_LENGTH                               0x1
#define _SMT1CON0_CPOL_MASK                                 0x4
#define _SMT1CON0_SPOL_POSN                                 0x3
#define _SMT1CON0_SPOL_POSITION                             0x3
#define _SMT1CON0_SPOL_SIZE                                 0x1
#define _SMT1CON0_SPOL_LENGTH                               0x1
#define _SMT1CON0_SPOL_MASK                                 0x8
#define _SMT1CON0_WPOL_POSN                                 0x4
#define _SMT1CON0_WPOL_POSITION                             0x4
#define _SMT1CON0_WPOL_SIZE                                 0x1
#define _SMT1CON0_WPOL_LENGTH                               0x1
#define _SMT1CON0_WPOL_MASK                                 0x10
#define _SMT1CON0_STP_POSN                                  0x5
#define _SMT1CON0_STP_POSITION                              0x5
#define _SMT1CON0_STP_SIZE                                  0x1
#define _SMT1CON0_STP_LENGTH                                0x1
#define _SMT1CON0_STP_MASK                                  0x20
#define _SMT1CON0_EN_POSN                                   0x7
#define _SMT1CON0_EN_POSITION                               0x7
#define _SMT1CON0_EN_SIZE                                   0x1
#define _SMT1CON0_EN_LENGTH                                 0x1
#define _SMT1CON0_EN_MASK                                   0x80
#define _SMT1CON0_SMT1PS0_POSN                              0x0
#define _SMT1CON0_SMT1PS0_POSITION                          0x0
#define _SMT1CON0_SMT1PS0_SIZE                              0x1
#define _SMT1CON0_SMT1PS0_LENGTH                            0x1
#define _SMT1CON0_SMT1PS0_MASK                              0x1
#define _SMT1CON0_SMT1PS1_POSN                              0x1
#define _SMT1CON0_SMT1PS1_POSITION                          0x1
#define _SMT1CON0_SMT1PS1_SIZE                              0x1
#define _SMT1CON0_SMT1PS1_LENGTH                            0x1
#define _SMT1CON0_SMT1PS1_MASK                              0x2

// Register: SMT1CON1
extern volatile unsigned char           SMT1CON1            @ 0xD99;
#ifndef _LIB_BUILD
asm("SMT1CON1 equ 0D99h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned MODE                   :4;
        unsigned                        :2;
        unsigned REPEAT                 :1;
        unsigned SMT1GO                 :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
        unsigned MODE3                  :1;
    };
    struct {
        unsigned SMT1MODE               :4;
        unsigned                        :2;
        unsigned SMT1REPEAT             :1;
    };
    struct {
        unsigned SMT1MODE0              :1;
        unsigned SMT1MODE1              :1;
        unsigned SMT1MODE2              :1;
        unsigned SMT1MODE3              :1;
    };
} SMT1CON1bits_t;
extern volatile SMT1CON1bits_t SMT1CON1bits @ 0xD99;
// bitfield macros
#define _SMT1CON1_MODE_POSN                                 0x0
#define _SMT1CON1_MODE_POSITION                             0x0
#define _SMT1CON1_MODE_SIZE                                 0x4
#define _SMT1CON1_MODE_LENGTH                               0x4
#define _SMT1CON1_MODE_MASK                                 0xF
#define _SMT1CON1_REPEAT_POSN                               0x6
#define _SMT1CON1_REPEAT_POSITION                           0x6
#define _SMT1CON1_REPEAT_SIZE                               0x1
#define _SMT1CON1_REPEAT_LENGTH                             0x1
#define _SMT1CON1_REPEAT_MASK                               0x40
#define _SMT1CON1_SMT1GO_POSN                               0x7
#define _SMT1CON1_SMT1GO_POSITION                           0x7
#define _SMT1CON1_SMT1GO_SIZE                               0x1
#define _SMT1CON1_SMT1GO_LENGTH                             0x1
#define _SMT1CON1_SMT1GO_MASK                               0x80
#define _SMT1CON1_MODE0_POSN                                0x0
#define _SMT1CON1_MODE0_POSITION                            0x0
#define _SMT1CON1_MODE0_SIZE                                0x1
#define _SMT1CON1_MODE0_LENGTH                              0x1
#define _SMT1CON1_MODE0_MASK                                0x1
#define _SMT1CON1_MODE1_POSN                                0x1
#define _SMT1CON1_MODE1_POSITION                            0x1
#define _SMT1CON1_MODE1_SIZE                                0x1
#define _SMT1CON1_MODE1_LENGTH                              0x1
#define _SMT1CON1_MODE1_MASK                                0x2
#define _SMT1CON1_MODE2_POSN                                0x2
#define _SMT1CON1_MODE2_POSITION                            0x2
#define _SMT1CON1_MODE2_SIZE                                0x1
#define _SMT1CON1_MODE2_LENGTH                              0x1
#define _SMT1CON1_MODE2_MASK                                0x4
#define _SMT1CON1_MODE3_POSN                                0x3
#define _SMT1CON1_MODE3_POSITION                            0x3
#define _SMT1CON1_MODE3_SIZE                                0x1
#define _SMT1CON1_MODE3_LENGTH                              0x1
#define _SMT1CON1_MODE3_MASK                                0x8
#define _SMT1CON1_SMT1MODE_POSN                             0x0
#define _SMT1CON1_SMT1MODE_POSITION                         0x0
#define _SMT1CON1_SMT1MODE_SIZE                             0x4
#define _SMT1CON1_SMT1MODE_LENGTH                           0x4
#define _SMT1CON1_SMT1MODE_MASK                             0xF
#define _SMT1CON1_SMT1REPEAT_POSN                           0x6
#define _SMT1CON1_SMT1REPEAT_POSITION                       0x6
#define _SMT1CON1_SMT1REPEAT_SIZE                           0x1
#define _SMT1CON1_SMT1REPEAT_LENGTH                         0x1
#define _SMT1CON1_SMT1REPEAT_MASK                           0x40
#define _SMT1CON1_SMT1MODE0_POSN                            0x0
#define _SMT1CON1_SMT1MODE0_POSITION                        0x0
#define _SMT1CON1_SMT1MODE0_SIZE                            0x1
#define _SMT1CON1_SMT1MODE0_LENGTH                          0x1
#define _SMT1CON1_SMT1MODE0_MASK                            0x1
#define _SMT1CON1_SMT1MODE1_POSN                            0x1
#define _SMT1CON1_SMT1MODE1_POSITION                        0x1
#define _SMT1CON1_SMT1MODE1_SIZE                            0x1
#define _SMT1CON1_SMT1MODE1_LENGTH                          0x1
#define _SMT1CON1_SMT1MODE1_MASK                            0x2
#define _SMT1CON1_SMT1MODE2_POSN                            0x2
#define _SMT1CON1_SMT1MODE2_POSITION                        0x2
#define _SMT1CON1_SMT1MODE2_SIZE                            0x1
#define _SMT1CON1_SMT1MODE2_LENGTH                          0x1
#define _SMT1CON1_SMT1MODE2_MASK                            0x4
#define _SMT1CON1_SMT1MODE3_POSN                            0x3
#define _SMT1CON1_SMT1MODE3_POSITION                        0x3
#define _SMT1CON1_SMT1MODE3_SIZE                            0x1
#define _SMT1CON1_SMT1MODE3_LENGTH                          0x1
#define _SMT1CON1_SMT1MODE3_MASK                            0x8

// Register: SMT1STAT
extern volatile unsigned char           SMT1STAT            @ 0xD9A;
#ifndef _LIB_BUILD
asm("SMT1STAT equ 0D9Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AS                     :1;
        unsigned WS                     :1;
        unsigned TS                     :1;
        unsigned                        :2;
        unsigned RST                    :1;
        unsigned CPWUP                  :1;
        unsigned CPRUP                  :1;
    };
    struct {
        unsigned SMT1AS                 :1;
        unsigned SMT1WS                 :1;
        unsigned SMT1TS                 :1;
        unsigned                        :2;
        unsigned SMT1RESET              :1;
        unsigned SMT1CPWUP              :1;
        unsigned SMT1CPRUP              :1;
    };
} SMT1STATbits_t;
extern volatile SMT1STATbits_t SMT1STATbits @ 0xD9A;
// bitfield macros
#define _SMT1STAT_AS_POSN                                   0x0
#define _SMT1STAT_AS_POSITION                               0x0
#define _SMT1STAT_AS_SIZE                                   0x1
#define _SMT1STAT_AS_LENGTH                                 0x1
#define _SMT1STAT_AS_MASK                                   0x1
#define _SMT1STAT_WS_POSN                                   0x1
#define _SMT1STAT_WS_POSITION                               0x1
#define _SMT1STAT_WS_SIZE                                   0x1
#define _SMT1STAT_WS_LENGTH                                 0x1
#define _SMT1STAT_WS_MASK                                   0x2
#define _SMT1STAT_TS_POSN                                   0x2
#define _SMT1STAT_TS_POSITION                               0x2
#define _SMT1STAT_TS_SIZE                                   0x1
#define _SMT1STAT_TS_LENGTH                                 0x1
#define _SMT1STAT_TS_MASK                                   0x4
#define _SMT1STAT_RST_POSN                                  0x5
#define _SMT1STAT_RST_POSITION                              0x5
#define _SMT1STAT_RST_SIZE                                  0x1
#define _SMT1STAT_RST_LENGTH                                0x1
#define _SMT1STAT_RST_MASK                                  0x20
#define _SMT1STAT_CPWUP_POSN                                0x6
#define _SMT1STAT_CPWUP_POSITION                            0x6
#define _SMT1STAT_CPWUP_SIZE                                0x1
#define _SMT1STAT_CPWUP_LENGTH                              0x1
#define _SMT1STAT_CPWUP_MASK                                0x40
#define _SMT1STAT_CPRUP_POSN                                0x7
#define _SMT1STAT_CPRUP_POSITION                            0x7
#define _SMT1STAT_CPRUP_SIZE                                0x1
#define _SMT1STAT_CPRUP_LENGTH                              0x1
#define _SMT1STAT_CPRUP_MASK                                0x80
#define _SMT1STAT_SMT1AS_POSN                               0x0
#define _SMT1STAT_SMT1AS_POSITION                           0x0
#define _SMT1STAT_SMT1AS_SIZE                               0x1
#define _SMT1STAT_SMT1AS_LENGTH                             0x1
#define _SMT1STAT_SMT1AS_MASK                               0x1
#define _SMT1STAT_SMT1WS_POSN                               0x1
#define _SMT1STAT_SMT1WS_POSITION                           0x1
#define _SMT1STAT_SMT1WS_SIZE                               0x1
#define _SMT1STAT_SMT1WS_LENGTH                             0x1
#define _SMT1STAT_SMT1WS_MASK                               0x2
#define _SMT1STAT_SMT1TS_POSN                               0x2
#define _SMT1STAT_SMT1TS_POSITION                           0x2
#define _SMT1STAT_SMT1TS_SIZE                               0x1
#define _SMT1STAT_SMT1TS_LENGTH                             0x1
#define _SMT1STAT_SMT1TS_MASK                               0x4
#define _SMT1STAT_SMT1RESET_POSN                            0x5
#define _SMT1STAT_SMT1RESET_POSITION                        0x5
#define _SMT1STAT_SMT1RESET_SIZE                            0x1
#define _SMT1STAT_SMT1RESET_LENGTH                          0x1
#define _SMT1STAT_SMT1RESET_MASK                            0x20
#define _SMT1STAT_SMT1CPWUP_POSN                            0x6
#define _SMT1STAT_SMT1CPWUP_POSITION                        0x6
#define _SMT1STAT_SMT1CPWUP_SIZE                            0x1
#define _SMT1STAT_SMT1CPWUP_LENGTH                          0x1
#define _SMT1STAT_SMT1CPWUP_MASK                            0x40
#define _SMT1STAT_SMT1CPRUP_POSN                            0x7
#define _SMT1STAT_SMT1CPRUP_POSITION                        0x7
#define _SMT1STAT_SMT1CPRUP_SIZE                            0x1
#define _SMT1STAT_SMT1CPRUP_LENGTH                          0x1
#define _SMT1STAT_SMT1CPRUP_MASK                            0x80

// Register: SMT1CLK
extern volatile unsigned char           SMT1CLK             @ 0xD9B;
#ifndef _LIB_BUILD
asm("SMT1CLK equ 0D9Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CSEL                   :8;
    };
    struct {
        unsigned CSEL0                  :1;
        unsigned CSEL1                  :1;
        unsigned CSEL2                  :1;
    };
    struct {
        unsigned SMT1CSEL               :8;
    };
    struct {
        unsigned SMT1CSEL0              :1;
        unsigned SMT1CSEL1              :1;
        unsigned SMT1CSEL2              :1;
    };
} SMT1CLKbits_t;
extern volatile SMT1CLKbits_t SMT1CLKbits @ 0xD9B;
// bitfield macros
#define _SMT1CLK_CSEL_POSN                                  0x0
#define _SMT1CLK_CSEL_POSITION                              0x0
#define _SMT1CLK_CSEL_SIZE                                  0x8
#define _SMT1CLK_CSEL_LENGTH                                0x8
#define _SMT1CLK_CSEL_MASK                                  0xFF
#define _SMT1CLK_CSEL0_POSN                                 0x0
#define _SMT1CLK_CSEL0_POSITION                             0x0
#define _SMT1CLK_CSEL0_SIZE                                 0x1
#define _SMT1CLK_CSEL0_LENGTH                               0x1
#define _SMT1CLK_CSEL0_MASK                                 0x1
#define _SMT1CLK_CSEL1_POSN                                 0x1
#define _SMT1CLK_CSEL1_POSITION                             0x1
#define _SMT1CLK_CSEL1_SIZE                                 0x1
#define _SMT1CLK_CSEL1_LENGTH                               0x1
#define _SMT1CLK_CSEL1_MASK                                 0x2
#define _SMT1CLK_CSEL2_POSN                                 0x2
#define _SMT1CLK_CSEL2_POSITION                             0x2
#define _SMT1CLK_CSEL2_SIZE                                 0x1
#define _SMT1CLK_CSEL2_LENGTH                               0x1
#define _SMT1CLK_CSEL2_MASK                                 0x4
#define _SMT1CLK_SMT1CSEL_POSN                              0x0
#define _SMT1CLK_SMT1CSEL_POSITION                          0x0
#define _SMT1CLK_SMT1CSEL_SIZE                              0x8
#define _SMT1CLK_SMT1CSEL_LENGTH                            0x8
#define _SMT1CLK_SMT1CSEL_MASK                              0xFF
#define _SMT1CLK_SMT1CSEL0_POSN                             0x0
#define _SMT1CLK_SMT1CSEL0_POSITION                         0x0
#define _SMT1CLK_SMT1CSEL0_SIZE                             0x1
#define _SMT1CLK_SMT1CSEL0_LENGTH                           0x1
#define _SMT1CLK_SMT1CSEL0_MASK                             0x1
#define _SMT1CLK_SMT1CSEL1_POSN                             0x1
#define _SMT1CLK_SMT1CSEL1_POSITION                         0x1
#define _SMT1CLK_SMT1CSEL1_SIZE                             0x1
#define _SMT1CLK_SMT1CSEL1_LENGTH                           0x1
#define _SMT1CLK_SMT1CSEL1_MASK                             0x2
#define _SMT1CLK_SMT1CSEL2_POSN                             0x2
#define _SMT1CLK_SMT1CSEL2_POSITION                         0x2
#define _SMT1CLK_SMT1CSEL2_SIZE                             0x1
#define _SMT1CLK_SMT1CSEL2_LENGTH                           0x1
#define _SMT1CLK_SMT1CSEL2_MASK                             0x4

// Register: SMT1SIG
extern volatile unsigned char           SMT1SIG             @ 0xD9C;
#ifndef _LIB_BUILD
asm("SMT1SIG equ 0D9Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SSEL                   :8;
    };
    struct {
        unsigned SSEL0                  :1;
        unsigned SSEL1                  :1;
        unsigned SSEL2                  :1;
        unsigned SSEL3                  :1;
        unsigned SSEL4                  :1;
    };
    struct {
        unsigned SMT1SSEL               :8;
    };
    struct {
        unsigned SMT1SSEL0              :1;
        unsigned SMT1SSEL1              :1;
        unsigned SMT1SSEL2              :1;
        unsigned SMT1SSEL3              :1;
        unsigned SMT1SSEL4              :1;
    };
} SMT1SIGbits_t;
extern volatile SMT1SIGbits_t SMT1SIGbits @ 0xD9C;
// bitfield macros
#define _SMT1SIG_SSEL_POSN                                  0x0
#define _SMT1SIG_SSEL_POSITION                              0x0
#define _SMT1SIG_SSEL_SIZE                                  0x8
#define _SMT1SIG_SSEL_LENGTH                                0x8
#define _SMT1SIG_SSEL_MASK                                  0xFF
#define _SMT1SIG_SSEL0_POSN                                 0x0
#define _SMT1SIG_SSEL0_POSITION                             0x0
#define _SMT1SIG_SSEL0_SIZE                                 0x1
#define _SMT1SIG_SSEL0_LENGTH                               0x1
#define _SMT1SIG_SSEL0_MASK                                 0x1
#define _SMT1SIG_SSEL1_POSN                                 0x1
#define _SMT1SIG_SSEL1_POSITION                             0x1
#define _SMT1SIG_SSEL1_SIZE                                 0x1
#define _SMT1SIG_SSEL1_LENGTH                               0x1
#define _SMT1SIG_SSEL1_MASK                                 0x2
#define _SMT1SIG_SSEL2_POSN                                 0x2
#define _SMT1SIG_SSEL2_POSITION                             0x2
#define _SMT1SIG_SSEL2_SIZE                                 0x1
#define _SMT1SIG_SSEL2_LENGTH                               0x1
#define _SMT1SIG_SSEL2_MASK                                 0x4
#define _SMT1SIG_SSEL3_POSN                                 0x3
#define _SMT1SIG_SSEL3_POSITION                             0x3
#define _SMT1SIG_SSEL3_SIZE                                 0x1
#define _SMT1SIG_SSEL3_LENGTH                               0x1
#define _SMT1SIG_SSEL3_MASK                                 0x8
#define _SMT1SIG_SSEL4_POSN                                 0x4
#define _SMT1SIG_SSEL4_POSITION                             0x4
#define _SMT1SIG_SSEL4_SIZE                                 0x1
#define _SMT1SIG_SSEL4_LENGTH                               0x1
#define _SMT1SIG_SSEL4_MASK                                 0x10
#define _SMT1SIG_SMT1SSEL_POSN                              0x0
#define _SMT1SIG_SMT1SSEL_POSITION                          0x0
#define _SMT1SIG_SMT1SSEL_SIZE                              0x8
#define _SMT1SIG_SMT1SSEL_LENGTH                            0x8
#define _SMT1SIG_SMT1SSEL_MASK                              0xFF
#define _SMT1SIG_SMT1SSEL0_POSN                             0x0
#define _SMT1SIG_SMT1SSEL0_POSITION                         0x0
#define _SMT1SIG_SMT1SSEL0_SIZE                             0x1
#define _SMT1SIG_SMT1SSEL0_LENGTH                           0x1
#define _SMT1SIG_SMT1SSEL0_MASK                             0x1
#define _SMT1SIG_SMT1SSEL1_POSN                             0x1
#define _SMT1SIG_SMT1SSEL1_POSITION                         0x1
#define _SMT1SIG_SMT1SSEL1_SIZE                             0x1
#define _SMT1SIG_SMT1SSEL1_LENGTH                           0x1
#define _SMT1SIG_SMT1SSEL1_MASK                             0x2
#define _SMT1SIG_SMT1SSEL2_POSN                             0x2
#define _SMT1SIG_SMT1SSEL2_POSITION                         0x2
#define _SMT1SIG_SMT1SSEL2_SIZE                             0x1
#define _SMT1SIG_SMT1SSEL2_LENGTH                           0x1
#define _SMT1SIG_SMT1SSEL2_MASK                             0x4
#define _SMT1SIG_SMT1SSEL3_POSN                             0x3
#define _SMT1SIG_SMT1SSEL3_POSITION                         0x3
#define _SMT1SIG_SMT1SSEL3_SIZE                             0x1
#define _SMT1SIG_SMT1SSEL3_LENGTH                           0x1
#define _SMT1SIG_SMT1SSEL3_MASK                             0x8
#define _SMT1SIG_SMT1SSEL4_POSN                             0x4
#define _SMT1SIG_SMT1SSEL4_POSITION                         0x4
#define _SMT1SIG_SMT1SSEL4_SIZE                             0x1
#define _SMT1SIG_SMT1SSEL4_LENGTH                           0x1
#define _SMT1SIG_SMT1SSEL4_MASK                             0x10

// Register: SMT1WIN
extern volatile unsigned char           SMT1WIN             @ 0xD9D;
#ifndef _LIB_BUILD
asm("SMT1WIN equ 0D9Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned WSEL                   :8;
    };
    struct {
        unsigned WSEL0                  :1;
        unsigned WSEL1                  :1;
        unsigned WSEL2                  :1;
        unsigned WSEL3                  :1;
        unsigned WSEL4                  :1;
    };
    struct {
        unsigned SMT1WSEL               :8;
    };
    struct {
        unsigned SMT1WSEL0              :1;
        unsigned SMT1WSEL1              :1;
        unsigned SMT1WSEL2              :1;
        unsigned SMT1WSEL3              :1;
        unsigned SMT1WSEL4              :1;
    };
} SMT1WINbits_t;
extern volatile SMT1WINbits_t SMT1WINbits @ 0xD9D;
// bitfield macros
#define _SMT1WIN_WSEL_POSN                                  0x0
#define _SMT1WIN_WSEL_POSITION                              0x0
#define _SMT1WIN_WSEL_SIZE                                  0x8
#define _SMT1WIN_WSEL_LENGTH                                0x8
#define _SMT1WIN_WSEL_MASK                                  0xFF
#define _SMT1WIN_WSEL0_POSN                                 0x0
#define _SMT1WIN_WSEL0_POSITION                             0x0
#define _SMT1WIN_WSEL0_SIZE                                 0x1
#define _SMT1WIN_WSEL0_LENGTH                               0x1
#define _SMT1WIN_WSEL0_MASK                                 0x1
#define _SMT1WIN_WSEL1_POSN                                 0x1
#define _SMT1WIN_WSEL1_POSITION                             0x1
#define _SMT1WIN_WSEL1_SIZE                                 0x1
#define _SMT1WIN_WSEL1_LENGTH                               0x1
#define _SMT1WIN_WSEL1_MASK                                 0x2
#define _SMT1WIN_WSEL2_POSN                                 0x2
#define _SMT1WIN_WSEL2_POSITION                             0x2
#define _SMT1WIN_WSEL2_SIZE                                 0x1
#define _SMT1WIN_WSEL2_LENGTH                               0x1
#define _SMT1WIN_WSEL2_MASK                                 0x4
#define _SMT1WIN_WSEL3_POSN                                 0x3
#define _SMT1WIN_WSEL3_POSITION                             0x3
#define _SMT1WIN_WSEL3_SIZE                                 0x1
#define _SMT1WIN_WSEL3_LENGTH                               0x1
#define _SMT1WIN_WSEL3_MASK                                 0x8
#define _SMT1WIN_WSEL4_POSN                                 0x4
#define _SMT1WIN_WSEL4_POSITION                             0x4
#define _SMT1WIN_WSEL4_SIZE                                 0x1
#define _SMT1WIN_WSEL4_LENGTH                               0x1
#define _SMT1WIN_WSEL4_MASK                                 0x10
#define _SMT1WIN_SMT1WSEL_POSN                              0x0
#define _SMT1WIN_SMT1WSEL_POSITION                          0x0
#define _SMT1WIN_SMT1WSEL_SIZE                              0x8
#define _SMT1WIN_SMT1WSEL_LENGTH                            0x8
#define _SMT1WIN_SMT1WSEL_MASK                              0xFF
#define _SMT1WIN_SMT1WSEL0_POSN                             0x0
#define _SMT1WIN_SMT1WSEL0_POSITION                         0x0
#define _SMT1WIN_SMT1WSEL0_SIZE                             0x1
#define _SMT1WIN_SMT1WSEL0_LENGTH                           0x1
#define _SMT1WIN_SMT1WSEL0_MASK                             0x1
#define _SMT1WIN_SMT1WSEL1_POSN                             0x1
#define _SMT1WIN_SMT1WSEL1_POSITION                         0x1
#define _SMT1WIN_SMT1WSEL1_SIZE                             0x1
#define _SMT1WIN_SMT1WSEL1_LENGTH                           0x1
#define _SMT1WIN_SMT1WSEL1_MASK                             0x2
#define _SMT1WIN_SMT1WSEL2_POSN                             0x2
#define _SMT1WIN_SMT1WSEL2_POSITION                         0x2
#define _SMT1WIN_SMT1WSEL2_SIZE                             0x1
#define _SMT1WIN_SMT1WSEL2_LENGTH                           0x1
#define _SMT1WIN_SMT1WSEL2_MASK                             0x4
#define _SMT1WIN_SMT1WSEL3_POSN                             0x3
#define _SMT1WIN_SMT1WSEL3_POSITION                         0x3
#define _SMT1WIN_SMT1WSEL3_SIZE                             0x1
#define _SMT1WIN_SMT1WSEL3_LENGTH                           0x1
#define _SMT1WIN_SMT1WSEL3_MASK                             0x8
#define _SMT1WIN_SMT1WSEL4_POSN                             0x4
#define _SMT1WIN_SMT1WSEL4_POSITION                         0x4
#define _SMT1WIN_SMT1WSEL4_SIZE                             0x1
#define _SMT1WIN_SMT1WSEL4_LENGTH                           0x1
#define _SMT1WIN_SMT1WSEL4_MASK                             0x10

// Register: SMT2TMR
#ifndef __CCI__
extern volatile unsigned short long     SMT2TMR             @ 0xD9E;
#endif
#ifndef _LIB_BUILD
asm("SMT2TMR equ 0D9Eh");
#endif

// Register: SMT2TMRL
extern volatile unsigned char           SMT2TMRL            @ 0xD9E;
#ifndef _LIB_BUILD
asm("SMT2TMRL equ 0D9Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2TMR                :8;
    };
    struct {
        unsigned SMT2TMR0               :1;
        unsigned SMT2TMR1               :1;
        unsigned SMT2TMR2               :1;
        unsigned SMT2TMR3               :1;
        unsigned SMT2TMR4               :1;
        unsigned SMT2TMR5               :1;
        unsigned SMT2TMR6               :1;
        unsigned SMT2TMR7               :1;
    };
} SMT2TMRLbits_t;
extern volatile SMT2TMRLbits_t SMT2TMRLbits @ 0xD9E;
// bitfield macros
#define _SMT2TMRL_SMT2TMR_POSN                              0x0
#define _SMT2TMRL_SMT2TMR_POSITION                          0x0
#define _SMT2TMRL_SMT2TMR_SIZE                              0x8
#define _SMT2TMRL_SMT2TMR_LENGTH                            0x8
#define _SMT2TMRL_SMT2TMR_MASK                              0xFF
#define _SMT2TMRL_SMT2TMR0_POSN                             0x0
#define _SMT2TMRL_SMT2TMR0_POSITION                         0x0
#define _SMT2TMRL_SMT2TMR0_SIZE                             0x1
#define _SMT2TMRL_SMT2TMR0_LENGTH                           0x1
#define _SMT2TMRL_SMT2TMR0_MASK                             0x1
#define _SMT2TMRL_SMT2TMR1_POSN                             0x1
#define _SMT2TMRL_SMT2TMR1_POSITION                         0x1
#define _SMT2TMRL_SMT2TMR1_SIZE                             0x1
#define _SMT2TMRL_SMT2TMR1_LENGTH                           0x1
#define _SMT2TMRL_SMT2TMR1_MASK                             0x2
#define _SMT2TMRL_SMT2TMR2_POSN                             0x2
#define _SMT2TMRL_SMT2TMR2_POSITION                         0x2
#define _SMT2TMRL_SMT2TMR2_SIZE                             0x1
#define _SMT2TMRL_SMT2TMR2_LENGTH                           0x1
#define _SMT2TMRL_SMT2TMR2_MASK                             0x4
#define _SMT2TMRL_SMT2TMR3_POSN                             0x3
#define _SMT2TMRL_SMT2TMR3_POSITION                         0x3
#define _SMT2TMRL_SMT2TMR3_SIZE                             0x1
#define _SMT2TMRL_SMT2TMR3_LENGTH                           0x1
#define _SMT2TMRL_SMT2TMR3_MASK                             0x8
#define _SMT2TMRL_SMT2TMR4_POSN                             0x4
#define _SMT2TMRL_SMT2TMR4_POSITION                         0x4
#define _SMT2TMRL_SMT2TMR4_SIZE                             0x1
#define _SMT2TMRL_SMT2TMR4_LENGTH                           0x1
#define _SMT2TMRL_SMT2TMR4_MASK                             0x10
#define _SMT2TMRL_SMT2TMR5_POSN                             0x5
#define _SMT2TMRL_SMT2TMR5_POSITION                         0x5
#define _SMT2TMRL_SMT2TMR5_SIZE                             0x1
#define _SMT2TMRL_SMT2TMR5_LENGTH                           0x1
#define _SMT2TMRL_SMT2TMR5_MASK                             0x20
#define _SMT2TMRL_SMT2TMR6_POSN                             0x6
#define _SMT2TMRL_SMT2TMR6_POSITION                         0x6
#define _SMT2TMRL_SMT2TMR6_SIZE                             0x1
#define _SMT2TMRL_SMT2TMR6_LENGTH                           0x1
#define _SMT2TMRL_SMT2TMR6_MASK                             0x40
#define _SMT2TMRL_SMT2TMR7_POSN                             0x7
#define _SMT2TMRL_SMT2TMR7_POSITION                         0x7
#define _SMT2TMRL_SMT2TMR7_SIZE                             0x1
#define _SMT2TMRL_SMT2TMR7_LENGTH                           0x1
#define _SMT2TMRL_SMT2TMR7_MASK                             0x80

// Register: SMT2TMRH
extern volatile unsigned char           SMT2TMRH            @ 0xD9F;
#ifndef _LIB_BUILD
asm("SMT2TMRH equ 0D9Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2TMR                :8;
    };
    struct {
        unsigned SMT2TMR8               :1;
        unsigned SMT2TMR9               :1;
        unsigned SMT2TMR10              :1;
        unsigned SMT2TMR11              :1;
        unsigned SMT2TMR12              :1;
        unsigned SMT2TMR13              :1;
        unsigned SMT2TMR14              :1;
        unsigned SMT2TMR15              :1;
    };
} SMT2TMRHbits_t;
extern volatile SMT2TMRHbits_t SMT2TMRHbits @ 0xD9F;
// bitfield macros
#define _SMT2TMRH_SMT2TMR_POSN                              0x0
#define _SMT2TMRH_SMT2TMR_POSITION                          0x0
#define _SMT2TMRH_SMT2TMR_SIZE                              0x8
#define _SMT2TMRH_SMT2TMR_LENGTH                            0x8
#define _SMT2TMRH_SMT2TMR_MASK                              0xFF
#define _SMT2TMRH_SMT2TMR8_POSN                             0x0
#define _SMT2TMRH_SMT2TMR8_POSITION                         0x0
#define _SMT2TMRH_SMT2TMR8_SIZE                             0x1
#define _SMT2TMRH_SMT2TMR8_LENGTH                           0x1
#define _SMT2TMRH_SMT2TMR8_MASK                             0x1
#define _SMT2TMRH_SMT2TMR9_POSN                             0x1
#define _SMT2TMRH_SMT2TMR9_POSITION                         0x1
#define _SMT2TMRH_SMT2TMR9_SIZE                             0x1
#define _SMT2TMRH_SMT2TMR9_LENGTH                           0x1
#define _SMT2TMRH_SMT2TMR9_MASK                             0x2
#define _SMT2TMRH_SMT2TMR10_POSN                            0x2
#define _SMT2TMRH_SMT2TMR10_POSITION                        0x2
#define _SMT2TMRH_SMT2TMR10_SIZE                            0x1
#define _SMT2TMRH_SMT2TMR10_LENGTH                          0x1
#define _SMT2TMRH_SMT2TMR10_MASK                            0x4
#define _SMT2TMRH_SMT2TMR11_POSN                            0x3
#define _SMT2TMRH_SMT2TMR11_POSITION                        0x3
#define _SMT2TMRH_SMT2TMR11_SIZE                            0x1
#define _SMT2TMRH_SMT2TMR11_LENGTH                          0x1
#define _SMT2TMRH_SMT2TMR11_MASK                            0x8
#define _SMT2TMRH_SMT2TMR12_POSN                            0x4
#define _SMT2TMRH_SMT2TMR12_POSITION                        0x4
#define _SMT2TMRH_SMT2TMR12_SIZE                            0x1
#define _SMT2TMRH_SMT2TMR12_LENGTH                          0x1
#define _SMT2TMRH_SMT2TMR12_MASK                            0x10
#define _SMT2TMRH_SMT2TMR13_POSN                            0x5
#define _SMT2TMRH_SMT2TMR13_POSITION                        0x5
#define _SMT2TMRH_SMT2TMR13_SIZE                            0x1
#define _SMT2TMRH_SMT2TMR13_LENGTH                          0x1
#define _SMT2TMRH_SMT2TMR13_MASK                            0x20
#define _SMT2TMRH_SMT2TMR14_POSN                            0x6
#define _SMT2TMRH_SMT2TMR14_POSITION                        0x6
#define _SMT2TMRH_SMT2TMR14_SIZE                            0x1
#define _SMT2TMRH_SMT2TMR14_LENGTH                          0x1
#define _SMT2TMRH_SMT2TMR14_MASK                            0x40
#define _SMT2TMRH_SMT2TMR15_POSN                            0x7
#define _SMT2TMRH_SMT2TMR15_POSITION                        0x7
#define _SMT2TMRH_SMT2TMR15_SIZE                            0x1
#define _SMT2TMRH_SMT2TMR15_LENGTH                          0x1
#define _SMT2TMRH_SMT2TMR15_MASK                            0x80

// Register: SMT2TMRU
extern volatile unsigned char           SMT2TMRU            @ 0xDA0;
#ifndef _LIB_BUILD
asm("SMT2TMRU equ 0DA0h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2TMR                :8;
    };
    struct {
        unsigned SMT2TMR16              :1;
        unsigned SMT2TMR17              :1;
        unsigned SMT2TMR18              :1;
        unsigned SMT2TMR19              :1;
        unsigned SMT2TMR20              :1;
        unsigned SMT2TMR21              :1;
        unsigned SMT2TMR22              :1;
        unsigned SMT2TMR23              :1;
    };
} SMT2TMRUbits_t;
extern volatile SMT2TMRUbits_t SMT2TMRUbits @ 0xDA0;
// bitfield macros
#define _SMT2TMRU_SMT2TMR_POSN                              0x0
#define _SMT2TMRU_SMT2TMR_POSITION                          0x0
#define _SMT2TMRU_SMT2TMR_SIZE                              0x8
#define _SMT2TMRU_SMT2TMR_LENGTH                            0x8
#define _SMT2TMRU_SMT2TMR_MASK                              0xFF
#define _SMT2TMRU_SMT2TMR16_POSN                            0x0
#define _SMT2TMRU_SMT2TMR16_POSITION                        0x0
#define _SMT2TMRU_SMT2TMR16_SIZE                            0x1
#define _SMT2TMRU_SMT2TMR16_LENGTH                          0x1
#define _SMT2TMRU_SMT2TMR16_MASK                            0x1
#define _SMT2TMRU_SMT2TMR17_POSN                            0x1
#define _SMT2TMRU_SMT2TMR17_POSITION                        0x1
#define _SMT2TMRU_SMT2TMR17_SIZE                            0x1
#define _SMT2TMRU_SMT2TMR17_LENGTH                          0x1
#define _SMT2TMRU_SMT2TMR17_MASK                            0x2
#define _SMT2TMRU_SMT2TMR18_POSN                            0x2
#define _SMT2TMRU_SMT2TMR18_POSITION                        0x2
#define _SMT2TMRU_SMT2TMR18_SIZE                            0x1
#define _SMT2TMRU_SMT2TMR18_LENGTH                          0x1
#define _SMT2TMRU_SMT2TMR18_MASK                            0x4
#define _SMT2TMRU_SMT2TMR19_POSN                            0x3
#define _SMT2TMRU_SMT2TMR19_POSITION                        0x3
#define _SMT2TMRU_SMT2TMR19_SIZE                            0x1
#define _SMT2TMRU_SMT2TMR19_LENGTH                          0x1
#define _SMT2TMRU_SMT2TMR19_MASK                            0x8
#define _SMT2TMRU_SMT2TMR20_POSN                            0x4
#define _SMT2TMRU_SMT2TMR20_POSITION                        0x4
#define _SMT2TMRU_SMT2TMR20_SIZE                            0x1
#define _SMT2TMRU_SMT2TMR20_LENGTH                          0x1
#define _SMT2TMRU_SMT2TMR20_MASK                            0x10
#define _SMT2TMRU_SMT2TMR21_POSN                            0x5
#define _SMT2TMRU_SMT2TMR21_POSITION                        0x5
#define _SMT2TMRU_SMT2TMR21_SIZE                            0x1
#define _SMT2TMRU_SMT2TMR21_LENGTH                          0x1
#define _SMT2TMRU_SMT2TMR21_MASK                            0x20
#define _SMT2TMRU_SMT2TMR22_POSN                            0x6
#define _SMT2TMRU_SMT2TMR22_POSITION                        0x6
#define _SMT2TMRU_SMT2TMR22_SIZE                            0x1
#define _SMT2TMRU_SMT2TMR22_LENGTH                          0x1
#define _SMT2TMRU_SMT2TMR22_MASK                            0x40
#define _SMT2TMRU_SMT2TMR23_POSN                            0x7
#define _SMT2TMRU_SMT2TMR23_POSITION                        0x7
#define _SMT2TMRU_SMT2TMR23_SIZE                            0x1
#define _SMT2TMRU_SMT2TMR23_LENGTH                          0x1
#define _SMT2TMRU_SMT2TMR23_MASK                            0x80

// Register: SMT2CPR
#ifndef __CCI__
extern volatile unsigned short long     SMT2CPR             @ 0xDA1;
#endif
#ifndef _LIB_BUILD
asm("SMT2CPR equ 0DA1h");
#endif

// Register: SMT2CPRL
extern volatile unsigned char           SMT2CPRL            @ 0xDA1;
#ifndef _LIB_BUILD
asm("SMT2CPRL equ 0DA1h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2CPR                :8;
    };
    struct {
        unsigned SMT2CPR0               :1;
        unsigned SMT2CPR1               :1;
        unsigned SMT2CPR2               :1;
        unsigned SMT2CPR3               :1;
        unsigned SMT2CPR4               :1;
        unsigned SMT2CPR5               :1;
        unsigned SMT2CPR6               :1;
        unsigned SMT2CPR7               :1;
    };
} SMT2CPRLbits_t;
extern volatile SMT2CPRLbits_t SMT2CPRLbits @ 0xDA1;
// bitfield macros
#define _SMT2CPRL_SMT2CPR_POSN                              0x0
#define _SMT2CPRL_SMT2CPR_POSITION                          0x0
#define _SMT2CPRL_SMT2CPR_SIZE                              0x8
#define _SMT2CPRL_SMT2CPR_LENGTH                            0x8
#define _SMT2CPRL_SMT2CPR_MASK                              0xFF
#define _SMT2CPRL_SMT2CPR0_POSN                             0x0
#define _SMT2CPRL_SMT2CPR0_POSITION                         0x0
#define _SMT2CPRL_SMT2CPR0_SIZE                             0x1
#define _SMT2CPRL_SMT2CPR0_LENGTH                           0x1
#define _SMT2CPRL_SMT2CPR0_MASK                             0x1
#define _SMT2CPRL_SMT2CPR1_POSN                             0x1
#define _SMT2CPRL_SMT2CPR1_POSITION                         0x1
#define _SMT2CPRL_SMT2CPR1_SIZE                             0x1
#define _SMT2CPRL_SMT2CPR1_LENGTH                           0x1
#define _SMT2CPRL_SMT2CPR1_MASK                             0x2
#define _SMT2CPRL_SMT2CPR2_POSN                             0x2
#define _SMT2CPRL_SMT2CPR2_POSITION                         0x2
#define _SMT2CPRL_SMT2CPR2_SIZE                             0x1
#define _SMT2CPRL_SMT2CPR2_LENGTH                           0x1
#define _SMT2CPRL_SMT2CPR2_MASK                             0x4
#define _SMT2CPRL_SMT2CPR3_POSN                             0x3
#define _SMT2CPRL_SMT2CPR3_POSITION                         0x3
#define _SMT2CPRL_SMT2CPR3_SIZE                             0x1
#define _SMT2CPRL_SMT2CPR3_LENGTH                           0x1
#define _SMT2CPRL_SMT2CPR3_MASK                             0x8
#define _SMT2CPRL_SMT2CPR4_POSN                             0x4
#define _SMT2CPRL_SMT2CPR4_POSITION                         0x4
#define _SMT2CPRL_SMT2CPR4_SIZE                             0x1
#define _SMT2CPRL_SMT2CPR4_LENGTH                           0x1
#define _SMT2CPRL_SMT2CPR4_MASK                             0x10
#define _SMT2CPRL_SMT2CPR5_POSN                             0x5
#define _SMT2CPRL_SMT2CPR5_POSITION                         0x5
#define _SMT2CPRL_SMT2CPR5_SIZE                             0x1
#define _SMT2CPRL_SMT2CPR5_LENGTH                           0x1
#define _SMT2CPRL_SMT2CPR5_MASK                             0x20
#define _SMT2CPRL_SMT2CPR6_POSN                             0x6
#define _SMT2CPRL_SMT2CPR6_POSITION                         0x6
#define _SMT2CPRL_SMT2CPR6_SIZE                             0x1
#define _SMT2CPRL_SMT2CPR6_LENGTH                           0x1
#define _SMT2CPRL_SMT2CPR6_MASK                             0x40
#define _SMT2CPRL_SMT2CPR7_POSN                             0x7
#define _SMT2CPRL_SMT2CPR7_POSITION                         0x7
#define _SMT2CPRL_SMT2CPR7_SIZE                             0x1
#define _SMT2CPRL_SMT2CPR7_LENGTH                           0x1
#define _SMT2CPRL_SMT2CPR7_MASK                             0x80

// Register: SMT2CPRH
extern volatile unsigned char           SMT2CPRH            @ 0xDA2;
#ifndef _LIB_BUILD
asm("SMT2CPRH equ 0DA2h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2CPR                :8;
    };
    struct {
        unsigned SMT2CPR8               :1;
        unsigned SMT2CPR9               :1;
        unsigned SMT2CPR10              :1;
        unsigned SMT2CPR11              :1;
        unsigned SMT2CPR12              :1;
        unsigned SMT2CPR13              :1;
        unsigned SMT2CPR14              :1;
        unsigned SMT2CPR15              :1;
    };
} SMT2CPRHbits_t;
extern volatile SMT2CPRHbits_t SMT2CPRHbits @ 0xDA2;
// bitfield macros
#define _SMT2CPRH_SMT2CPR_POSN                              0x0
#define _SMT2CPRH_SMT2CPR_POSITION                          0x0
#define _SMT2CPRH_SMT2CPR_SIZE                              0x8
#define _SMT2CPRH_SMT2CPR_LENGTH                            0x8
#define _SMT2CPRH_SMT2CPR_MASK                              0xFF
#define _SMT2CPRH_SMT2CPR8_POSN                             0x0
#define _SMT2CPRH_SMT2CPR8_POSITION                         0x0
#define _SMT2CPRH_SMT2CPR8_SIZE                             0x1
#define _SMT2CPRH_SMT2CPR8_LENGTH                           0x1
#define _SMT2CPRH_SMT2CPR8_MASK                             0x1
#define _SMT2CPRH_SMT2CPR9_POSN                             0x1
#define _SMT2CPRH_SMT2CPR9_POSITION                         0x1
#define _SMT2CPRH_SMT2CPR9_SIZE                             0x1
#define _SMT2CPRH_SMT2CPR9_LENGTH                           0x1
#define _SMT2CPRH_SMT2CPR9_MASK                             0x2
#define _SMT2CPRH_SMT2CPR10_POSN                            0x2
#define _SMT2CPRH_SMT2CPR10_POSITION                        0x2
#define _SMT2CPRH_SMT2CPR10_SIZE                            0x1
#define _SMT2CPRH_SMT2CPR10_LENGTH                          0x1
#define _SMT2CPRH_SMT2CPR10_MASK                            0x4
#define _SMT2CPRH_SMT2CPR11_POSN                            0x3
#define _SMT2CPRH_SMT2CPR11_POSITION                        0x3
#define _SMT2CPRH_SMT2CPR11_SIZE                            0x1
#define _SMT2CPRH_SMT2CPR11_LENGTH                          0x1
#define _SMT2CPRH_SMT2CPR11_MASK                            0x8
#define _SMT2CPRH_SMT2CPR12_POSN                            0x4
#define _SMT2CPRH_SMT2CPR12_POSITION                        0x4
#define _SMT2CPRH_SMT2CPR12_SIZE                            0x1
#define _SMT2CPRH_SMT2CPR12_LENGTH                          0x1
#define _SMT2CPRH_SMT2CPR12_MASK                            0x10
#define _SMT2CPRH_SMT2CPR13_POSN                            0x5
#define _SMT2CPRH_SMT2CPR13_POSITION                        0x5
#define _SMT2CPRH_SMT2CPR13_SIZE                            0x1
#define _SMT2CPRH_SMT2CPR13_LENGTH                          0x1
#define _SMT2CPRH_SMT2CPR13_MASK                            0x20
#define _SMT2CPRH_SMT2CPR14_POSN                            0x6
#define _SMT2CPRH_SMT2CPR14_POSITION                        0x6
#define _SMT2CPRH_SMT2CPR14_SIZE                            0x1
#define _SMT2CPRH_SMT2CPR14_LENGTH                          0x1
#define _SMT2CPRH_SMT2CPR14_MASK                            0x40
#define _SMT2CPRH_SMT2CPR15_POSN                            0x7
#define _SMT2CPRH_SMT2CPR15_POSITION                        0x7
#define _SMT2CPRH_SMT2CPR15_SIZE                            0x1
#define _SMT2CPRH_SMT2CPR15_LENGTH                          0x1
#define _SMT2CPRH_SMT2CPR15_MASK                            0x80

// Register: SMT2CPRU
extern volatile unsigned char           SMT2CPRU            @ 0xDA3;
#ifndef _LIB_BUILD
asm("SMT2CPRU equ 0DA3h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2CPR                :8;
    };
    struct {
        unsigned SMT2CPR16              :1;
        unsigned SMT2CPR17              :1;
        unsigned SMT2CPR18              :1;
        unsigned SMT2CPR19              :1;
        unsigned SMT2CPR20              :1;
        unsigned SMT2CPR21              :1;
        unsigned SMT2CPR22              :1;
        unsigned SMT2CPR23              :1;
    };
} SMT2CPRUbits_t;
extern volatile SMT2CPRUbits_t SMT2CPRUbits @ 0xDA3;
// bitfield macros
#define _SMT2CPRU_SMT2CPR_POSN                              0x0
#define _SMT2CPRU_SMT2CPR_POSITION                          0x0
#define _SMT2CPRU_SMT2CPR_SIZE                              0x8
#define _SMT2CPRU_SMT2CPR_LENGTH                            0x8
#define _SMT2CPRU_SMT2CPR_MASK                              0xFF
#define _SMT2CPRU_SMT2CPR16_POSN                            0x0
#define _SMT2CPRU_SMT2CPR16_POSITION                        0x0
#define _SMT2CPRU_SMT2CPR16_SIZE                            0x1
#define _SMT2CPRU_SMT2CPR16_LENGTH                          0x1
#define _SMT2CPRU_SMT2CPR16_MASK                            0x1
#define _SMT2CPRU_SMT2CPR17_POSN                            0x1
#define _SMT2CPRU_SMT2CPR17_POSITION                        0x1
#define _SMT2CPRU_SMT2CPR17_SIZE                            0x1
#define _SMT2CPRU_SMT2CPR17_LENGTH                          0x1
#define _SMT2CPRU_SMT2CPR17_MASK                            0x2
#define _SMT2CPRU_SMT2CPR18_POSN                            0x2
#define _SMT2CPRU_SMT2CPR18_POSITION                        0x2
#define _SMT2CPRU_SMT2CPR18_SIZE                            0x1
#define _SMT2CPRU_SMT2CPR18_LENGTH                          0x1
#define _SMT2CPRU_SMT2CPR18_MASK                            0x4
#define _SMT2CPRU_SMT2CPR19_POSN                            0x3
#define _SMT2CPRU_SMT2CPR19_POSITION                        0x3
#define _SMT2CPRU_SMT2CPR19_SIZE                            0x1
#define _SMT2CPRU_SMT2CPR19_LENGTH                          0x1
#define _SMT2CPRU_SMT2CPR19_MASK                            0x8
#define _SMT2CPRU_SMT2CPR20_POSN                            0x4
#define _SMT2CPRU_SMT2CPR20_POSITION                        0x4
#define _SMT2CPRU_SMT2CPR20_SIZE                            0x1
#define _SMT2CPRU_SMT2CPR20_LENGTH                          0x1
#define _SMT2CPRU_SMT2CPR20_MASK                            0x10
#define _SMT2CPRU_SMT2CPR21_POSN                            0x5
#define _SMT2CPRU_SMT2CPR21_POSITION                        0x5
#define _SMT2CPRU_SMT2CPR21_SIZE                            0x1
#define _SMT2CPRU_SMT2CPR21_LENGTH                          0x1
#define _SMT2CPRU_SMT2CPR21_MASK                            0x20
#define _SMT2CPRU_SMT2CPR22_POSN                            0x6
#define _SMT2CPRU_SMT2CPR22_POSITION                        0x6
#define _SMT2CPRU_SMT2CPR22_SIZE                            0x1
#define _SMT2CPRU_SMT2CPR22_LENGTH                          0x1
#define _SMT2CPRU_SMT2CPR22_MASK                            0x40
#define _SMT2CPRU_SMT2CPR23_POSN                            0x7
#define _SMT2CPRU_SMT2CPR23_POSITION                        0x7
#define _SMT2CPRU_SMT2CPR23_SIZE                            0x1
#define _SMT2CPRU_SMT2CPR23_LENGTH                          0x1
#define _SMT2CPRU_SMT2CPR23_MASK                            0x80

// Register: SMT2CPW
#ifndef __CCI__
extern volatile unsigned short long     SMT2CPW             @ 0xDA4;
#endif
#ifndef _LIB_BUILD
asm("SMT2CPW equ 0DA4h");
#endif

// Register: SMT2CPWL
extern volatile unsigned char           SMT2CPWL            @ 0xDA4;
#ifndef _LIB_BUILD
asm("SMT2CPWL equ 0DA4h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2CPW                :8;
    };
    struct {
        unsigned SMT2CPW0               :1;
        unsigned SMT2CPW1               :1;
        unsigned SMT2CPW2               :1;
        unsigned SMT2CPW3               :1;
        unsigned SMT2CPW4               :1;
        unsigned SMT2CPW5               :1;
        unsigned SMT2CPW6               :1;
        unsigned SMT2CPW7               :1;
    };
} SMT2CPWLbits_t;
extern volatile SMT2CPWLbits_t SMT2CPWLbits @ 0xDA4;
// bitfield macros
#define _SMT2CPWL_SMT2CPW_POSN                              0x0
#define _SMT2CPWL_SMT2CPW_POSITION                          0x0
#define _SMT2CPWL_SMT2CPW_SIZE                              0x8
#define _SMT2CPWL_SMT2CPW_LENGTH                            0x8
#define _SMT2CPWL_SMT2CPW_MASK                              0xFF
#define _SMT2CPWL_SMT2CPW0_POSN                             0x0
#define _SMT2CPWL_SMT2CPW0_POSITION                         0x0
#define _SMT2CPWL_SMT2CPW0_SIZE                             0x1
#define _SMT2CPWL_SMT2CPW0_LENGTH                           0x1
#define _SMT2CPWL_SMT2CPW0_MASK                             0x1
#define _SMT2CPWL_SMT2CPW1_POSN                             0x1
#define _SMT2CPWL_SMT2CPW1_POSITION                         0x1
#define _SMT2CPWL_SMT2CPW1_SIZE                             0x1
#define _SMT2CPWL_SMT2CPW1_LENGTH                           0x1
#define _SMT2CPWL_SMT2CPW1_MASK                             0x2
#define _SMT2CPWL_SMT2CPW2_POSN                             0x2
#define _SMT2CPWL_SMT2CPW2_POSITION                         0x2
#define _SMT2CPWL_SMT2CPW2_SIZE                             0x1
#define _SMT2CPWL_SMT2CPW2_LENGTH                           0x1
#define _SMT2CPWL_SMT2CPW2_MASK                             0x4
#define _SMT2CPWL_SMT2CPW3_POSN                             0x3
#define _SMT2CPWL_SMT2CPW3_POSITION                         0x3
#define _SMT2CPWL_SMT2CPW3_SIZE                             0x1
#define _SMT2CPWL_SMT2CPW3_LENGTH                           0x1
#define _SMT2CPWL_SMT2CPW3_MASK                             0x8
#define _SMT2CPWL_SMT2CPW4_POSN                             0x4
#define _SMT2CPWL_SMT2CPW4_POSITION                         0x4
#define _SMT2CPWL_SMT2CPW4_SIZE                             0x1
#define _SMT2CPWL_SMT2CPW4_LENGTH                           0x1
#define _SMT2CPWL_SMT2CPW4_MASK                             0x10
#define _SMT2CPWL_SMT2CPW5_POSN                             0x5
#define _SMT2CPWL_SMT2CPW5_POSITION                         0x5
#define _SMT2CPWL_SMT2CPW5_SIZE                             0x1
#define _SMT2CPWL_SMT2CPW5_LENGTH                           0x1
#define _SMT2CPWL_SMT2CPW5_MASK                             0x20
#define _SMT2CPWL_SMT2CPW6_POSN                             0x6
#define _SMT2CPWL_SMT2CPW6_POSITION                         0x6
#define _SMT2CPWL_SMT2CPW6_SIZE                             0x1
#define _SMT2CPWL_SMT2CPW6_LENGTH                           0x1
#define _SMT2CPWL_SMT2CPW6_MASK                             0x40
#define _SMT2CPWL_SMT2CPW7_POSN                             0x7
#define _SMT2CPWL_SMT2CPW7_POSITION                         0x7
#define _SMT2CPWL_SMT2CPW7_SIZE                             0x1
#define _SMT2CPWL_SMT2CPW7_LENGTH                           0x1
#define _SMT2CPWL_SMT2CPW7_MASK                             0x80

// Register: SMT2CPWH
extern volatile unsigned char           SMT2CPWH            @ 0xDA5;
#ifndef _LIB_BUILD
asm("SMT2CPWH equ 0DA5h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2CPW                :8;
    };
    struct {
        unsigned SMT2CPW8               :1;
        unsigned SMT2CPW9               :1;
        unsigned SMT2CPW10              :1;
        unsigned SMT2CPW11              :1;
        unsigned SMT2CPW12              :1;
        unsigned SMT2CPW13              :1;
        unsigned SMT2CPW14              :1;
        unsigned SMT2CPW15              :1;
    };
} SMT2CPWHbits_t;
extern volatile SMT2CPWHbits_t SMT2CPWHbits @ 0xDA5;
// bitfield macros
#define _SMT2CPWH_SMT2CPW_POSN                              0x0
#define _SMT2CPWH_SMT2CPW_POSITION                          0x0
#define _SMT2CPWH_SMT2CPW_SIZE                              0x8
#define _SMT2CPWH_SMT2CPW_LENGTH                            0x8
#define _SMT2CPWH_SMT2CPW_MASK                              0xFF
#define _SMT2CPWH_SMT2CPW8_POSN                             0x0
#define _SMT2CPWH_SMT2CPW8_POSITION                         0x0
#define _SMT2CPWH_SMT2CPW8_SIZE                             0x1
#define _SMT2CPWH_SMT2CPW8_LENGTH                           0x1
#define _SMT2CPWH_SMT2CPW8_MASK                             0x1
#define _SMT2CPWH_SMT2CPW9_POSN                             0x1
#define _SMT2CPWH_SMT2CPW9_POSITION                         0x1
#define _SMT2CPWH_SMT2CPW9_SIZE                             0x1
#define _SMT2CPWH_SMT2CPW9_LENGTH                           0x1
#define _SMT2CPWH_SMT2CPW9_MASK                             0x2
#define _SMT2CPWH_SMT2CPW10_POSN                            0x2
#define _SMT2CPWH_SMT2CPW10_POSITION                        0x2
#define _SMT2CPWH_SMT2CPW10_SIZE                            0x1
#define _SMT2CPWH_SMT2CPW10_LENGTH                          0x1
#define _SMT2CPWH_SMT2CPW10_MASK                            0x4
#define _SMT2CPWH_SMT2CPW11_POSN                            0x3
#define _SMT2CPWH_SMT2CPW11_POSITION                        0x3
#define _SMT2CPWH_SMT2CPW11_SIZE                            0x1
#define _SMT2CPWH_SMT2CPW11_LENGTH                          0x1
#define _SMT2CPWH_SMT2CPW11_MASK                            0x8
#define _SMT2CPWH_SMT2CPW12_POSN                            0x4
#define _SMT2CPWH_SMT2CPW12_POSITION                        0x4
#define _SMT2CPWH_SMT2CPW12_SIZE                            0x1
#define _SMT2CPWH_SMT2CPW12_LENGTH                          0x1
#define _SMT2CPWH_SMT2CPW12_MASK                            0x10
#define _SMT2CPWH_SMT2CPW13_POSN                            0x5
#define _SMT2CPWH_SMT2CPW13_POSITION                        0x5
#define _SMT2CPWH_SMT2CPW13_SIZE                            0x1
#define _SMT2CPWH_SMT2CPW13_LENGTH                          0x1
#define _SMT2CPWH_SMT2CPW13_MASK                            0x20
#define _SMT2CPWH_SMT2CPW14_POSN                            0x6
#define _SMT2CPWH_SMT2CPW14_POSITION                        0x6
#define _SMT2CPWH_SMT2CPW14_SIZE                            0x1
#define _SMT2CPWH_SMT2CPW14_LENGTH                          0x1
#define _SMT2CPWH_SMT2CPW14_MASK                            0x40
#define _SMT2CPWH_SMT2CPW15_POSN                            0x7
#define _SMT2CPWH_SMT2CPW15_POSITION                        0x7
#define _SMT2CPWH_SMT2CPW15_SIZE                            0x1
#define _SMT2CPWH_SMT2CPW15_LENGTH                          0x1
#define _SMT2CPWH_SMT2CPW15_MASK                            0x80

// Register: SMT2CPWU
extern volatile unsigned char           SMT2CPWU            @ 0xDA6;
#ifndef _LIB_BUILD
asm("SMT2CPWU equ 0DA6h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2CPW                :8;
    };
    struct {
        unsigned SMT2CPW16              :1;
        unsigned SMT2CPW17              :1;
        unsigned SMT2CPW18              :1;
        unsigned SMT2CPW19              :1;
        unsigned SMT2CPW20              :1;
        unsigned SMT2CPW21              :1;
        unsigned SMT2CPW22              :1;
        unsigned SMT2CPW23              :1;
    };
} SMT2CPWUbits_t;
extern volatile SMT2CPWUbits_t SMT2CPWUbits @ 0xDA6;
// bitfield macros
#define _SMT2CPWU_SMT2CPW_POSN                              0x0
#define _SMT2CPWU_SMT2CPW_POSITION                          0x0
#define _SMT2CPWU_SMT2CPW_SIZE                              0x8
#define _SMT2CPWU_SMT2CPW_LENGTH                            0x8
#define _SMT2CPWU_SMT2CPW_MASK                              0xFF
#define _SMT2CPWU_SMT2CPW16_POSN                            0x0
#define _SMT2CPWU_SMT2CPW16_POSITION                        0x0
#define _SMT2CPWU_SMT2CPW16_SIZE                            0x1
#define _SMT2CPWU_SMT2CPW16_LENGTH                          0x1
#define _SMT2CPWU_SMT2CPW16_MASK                            0x1
#define _SMT2CPWU_SMT2CPW17_POSN                            0x1
#define _SMT2CPWU_SMT2CPW17_POSITION                        0x1
#define _SMT2CPWU_SMT2CPW17_SIZE                            0x1
#define _SMT2CPWU_SMT2CPW17_LENGTH                          0x1
#define _SMT2CPWU_SMT2CPW17_MASK                            0x2
#define _SMT2CPWU_SMT2CPW18_POSN                            0x2
#define _SMT2CPWU_SMT2CPW18_POSITION                        0x2
#define _SMT2CPWU_SMT2CPW18_SIZE                            0x1
#define _SMT2CPWU_SMT2CPW18_LENGTH                          0x1
#define _SMT2CPWU_SMT2CPW18_MASK                            0x4
#define _SMT2CPWU_SMT2CPW19_POSN                            0x3
#define _SMT2CPWU_SMT2CPW19_POSITION                        0x3
#define _SMT2CPWU_SMT2CPW19_SIZE                            0x1
#define _SMT2CPWU_SMT2CPW19_LENGTH                          0x1
#define _SMT2CPWU_SMT2CPW19_MASK                            0x8
#define _SMT2CPWU_SMT2CPW20_POSN                            0x4
#define _SMT2CPWU_SMT2CPW20_POSITION                        0x4
#define _SMT2CPWU_SMT2CPW20_SIZE                            0x1
#define _SMT2CPWU_SMT2CPW20_LENGTH                          0x1
#define _SMT2CPWU_SMT2CPW20_MASK                            0x10
#define _SMT2CPWU_SMT2CPW21_POSN                            0x5
#define _SMT2CPWU_SMT2CPW21_POSITION                        0x5
#define _SMT2CPWU_SMT2CPW21_SIZE                            0x1
#define _SMT2CPWU_SMT2CPW21_LENGTH                          0x1
#define _SMT2CPWU_SMT2CPW21_MASK                            0x20
#define _SMT2CPWU_SMT2CPW22_POSN                            0x6
#define _SMT2CPWU_SMT2CPW22_POSITION                        0x6
#define _SMT2CPWU_SMT2CPW22_SIZE                            0x1
#define _SMT2CPWU_SMT2CPW22_LENGTH                          0x1
#define _SMT2CPWU_SMT2CPW22_MASK                            0x40
#define _SMT2CPWU_SMT2CPW23_POSN                            0x7
#define _SMT2CPWU_SMT2CPW23_POSITION                        0x7
#define _SMT2CPWU_SMT2CPW23_SIZE                            0x1
#define _SMT2CPWU_SMT2CPW23_LENGTH                          0x1
#define _SMT2CPWU_SMT2CPW23_MASK                            0x80

// Register: SMT2PR
#ifndef __CCI__
extern volatile unsigned short long     SMT2PR              @ 0xDA7;
#endif
#ifndef _LIB_BUILD
asm("SMT2PR equ 0DA7h");
#endif

// Register: SMT2PRL
extern volatile unsigned char           SMT2PRL             @ 0xDA7;
#ifndef _LIB_BUILD
asm("SMT2PRL equ 0DA7h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2PR                 :8;
    };
    struct {
        unsigned SMT2PR0                :1;
        unsigned SMT2PR1                :1;
        unsigned SMT2PR2                :1;
        unsigned SMT2PR3                :1;
        unsigned SMT2PR4                :1;
        unsigned SMT2PR5                :1;
        unsigned SMT2PR6                :1;
        unsigned SMT2PR7                :1;
    };
} SMT2PRLbits_t;
extern volatile SMT2PRLbits_t SMT2PRLbits @ 0xDA7;
// bitfield macros
#define _SMT2PRL_SMT2PR_POSN                                0x0
#define _SMT2PRL_SMT2PR_POSITION                            0x0
#define _SMT2PRL_SMT2PR_SIZE                                0x8
#define _SMT2PRL_SMT2PR_LENGTH                              0x8
#define _SMT2PRL_SMT2PR_MASK                                0xFF
#define _SMT2PRL_SMT2PR0_POSN                               0x0
#define _SMT2PRL_SMT2PR0_POSITION                           0x0
#define _SMT2PRL_SMT2PR0_SIZE                               0x1
#define _SMT2PRL_SMT2PR0_LENGTH                             0x1
#define _SMT2PRL_SMT2PR0_MASK                               0x1
#define _SMT2PRL_SMT2PR1_POSN                               0x1
#define _SMT2PRL_SMT2PR1_POSITION                           0x1
#define _SMT2PRL_SMT2PR1_SIZE                               0x1
#define _SMT2PRL_SMT2PR1_LENGTH                             0x1
#define _SMT2PRL_SMT2PR1_MASK                               0x2
#define _SMT2PRL_SMT2PR2_POSN                               0x2
#define _SMT2PRL_SMT2PR2_POSITION                           0x2
#define _SMT2PRL_SMT2PR2_SIZE                               0x1
#define _SMT2PRL_SMT2PR2_LENGTH                             0x1
#define _SMT2PRL_SMT2PR2_MASK                               0x4
#define _SMT2PRL_SMT2PR3_POSN                               0x3
#define _SMT2PRL_SMT2PR3_POSITION                           0x3
#define _SMT2PRL_SMT2PR3_SIZE                               0x1
#define _SMT2PRL_SMT2PR3_LENGTH                             0x1
#define _SMT2PRL_SMT2PR3_MASK                               0x8
#define _SMT2PRL_SMT2PR4_POSN                               0x4
#define _SMT2PRL_SMT2PR4_POSITION                           0x4
#define _SMT2PRL_SMT2PR4_SIZE                               0x1
#define _SMT2PRL_SMT2PR4_LENGTH                             0x1
#define _SMT2PRL_SMT2PR4_MASK                               0x10
#define _SMT2PRL_SMT2PR5_POSN                               0x5
#define _SMT2PRL_SMT2PR5_POSITION                           0x5
#define _SMT2PRL_SMT2PR5_SIZE                               0x1
#define _SMT2PRL_SMT2PR5_LENGTH                             0x1
#define _SMT2PRL_SMT2PR5_MASK                               0x20
#define _SMT2PRL_SMT2PR6_POSN                               0x6
#define _SMT2PRL_SMT2PR6_POSITION                           0x6
#define _SMT2PRL_SMT2PR6_SIZE                               0x1
#define _SMT2PRL_SMT2PR6_LENGTH                             0x1
#define _SMT2PRL_SMT2PR6_MASK                               0x40
#define _SMT2PRL_SMT2PR7_POSN                               0x7
#define _SMT2PRL_SMT2PR7_POSITION                           0x7
#define _SMT2PRL_SMT2PR7_SIZE                               0x1
#define _SMT2PRL_SMT2PR7_LENGTH                             0x1
#define _SMT2PRL_SMT2PR7_MASK                               0x80

// Register: SMT2PRH
extern volatile unsigned char           SMT2PRH             @ 0xDA8;
#ifndef _LIB_BUILD
asm("SMT2PRH equ 0DA8h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2PR                 :8;
    };
    struct {
        unsigned SMT2PR8                :1;
        unsigned SMT2PR9                :1;
        unsigned SMT2PR10               :1;
        unsigned SMT2PR11               :1;
        unsigned SMT2PR12               :1;
        unsigned SMT2PR13               :1;
        unsigned SMT2PR14               :1;
        unsigned SMT2PR15               :1;
    };
} SMT2PRHbits_t;
extern volatile SMT2PRHbits_t SMT2PRHbits @ 0xDA8;
// bitfield macros
#define _SMT2PRH_SMT2PR_POSN                                0x0
#define _SMT2PRH_SMT2PR_POSITION                            0x0
#define _SMT2PRH_SMT2PR_SIZE                                0x8
#define _SMT2PRH_SMT2PR_LENGTH                              0x8
#define _SMT2PRH_SMT2PR_MASK                                0xFF
#define _SMT2PRH_SMT2PR8_POSN                               0x0
#define _SMT2PRH_SMT2PR8_POSITION                           0x0
#define _SMT2PRH_SMT2PR8_SIZE                               0x1
#define _SMT2PRH_SMT2PR8_LENGTH                             0x1
#define _SMT2PRH_SMT2PR8_MASK                               0x1
#define _SMT2PRH_SMT2PR9_POSN                               0x1
#define _SMT2PRH_SMT2PR9_POSITION                           0x1
#define _SMT2PRH_SMT2PR9_SIZE                               0x1
#define _SMT2PRH_SMT2PR9_LENGTH                             0x1
#define _SMT2PRH_SMT2PR9_MASK                               0x2
#define _SMT2PRH_SMT2PR10_POSN                              0x2
#define _SMT2PRH_SMT2PR10_POSITION                          0x2
#define _SMT2PRH_SMT2PR10_SIZE                              0x1
#define _SMT2PRH_SMT2PR10_LENGTH                            0x1
#define _SMT2PRH_SMT2PR10_MASK                              0x4
#define _SMT2PRH_SMT2PR11_POSN                              0x3
#define _SMT2PRH_SMT2PR11_POSITION                          0x3
#define _SMT2PRH_SMT2PR11_SIZE                              0x1
#define _SMT2PRH_SMT2PR11_LENGTH                            0x1
#define _SMT2PRH_SMT2PR11_MASK                              0x8
#define _SMT2PRH_SMT2PR12_POSN                              0x4
#define _SMT2PRH_SMT2PR12_POSITION                          0x4
#define _SMT2PRH_SMT2PR12_SIZE                              0x1
#define _SMT2PRH_SMT2PR12_LENGTH                            0x1
#define _SMT2PRH_SMT2PR12_MASK                              0x10
#define _SMT2PRH_SMT2PR13_POSN                              0x5
#define _SMT2PRH_SMT2PR13_POSITION                          0x5
#define _SMT2PRH_SMT2PR13_SIZE                              0x1
#define _SMT2PRH_SMT2PR13_LENGTH                            0x1
#define _SMT2PRH_SMT2PR13_MASK                              0x20
#define _SMT2PRH_SMT2PR14_POSN                              0x6
#define _SMT2PRH_SMT2PR14_POSITION                          0x6
#define _SMT2PRH_SMT2PR14_SIZE                              0x1
#define _SMT2PRH_SMT2PR14_LENGTH                            0x1
#define _SMT2PRH_SMT2PR14_MASK                              0x40
#define _SMT2PRH_SMT2PR15_POSN                              0x7
#define _SMT2PRH_SMT2PR15_POSITION                          0x7
#define _SMT2PRH_SMT2PR15_SIZE                              0x1
#define _SMT2PRH_SMT2PR15_LENGTH                            0x1
#define _SMT2PRH_SMT2PR15_MASK                              0x80

// Register: SMT2PRU
extern volatile unsigned char           SMT2PRU             @ 0xDA9;
#ifndef _LIB_BUILD
asm("SMT2PRU equ 0DA9h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2PR                 :8;
    };
    struct {
        unsigned SMT2PR16               :1;
        unsigned SMT2PR17               :1;
        unsigned SMT2PR18               :1;
        unsigned SMT2PR19               :1;
        unsigned SMT2PR20               :1;
        unsigned SMT2PR21               :1;
        unsigned SMT2PR22               :1;
        unsigned SMT2PR23               :1;
    };
} SMT2PRUbits_t;
extern volatile SMT2PRUbits_t SMT2PRUbits @ 0xDA9;
// bitfield macros
#define _SMT2PRU_SMT2PR_POSN                                0x0
#define _SMT2PRU_SMT2PR_POSITION                            0x0
#define _SMT2PRU_SMT2PR_SIZE                                0x8
#define _SMT2PRU_SMT2PR_LENGTH                              0x8
#define _SMT2PRU_SMT2PR_MASK                                0xFF
#define _SMT2PRU_SMT2PR16_POSN                              0x0
#define _SMT2PRU_SMT2PR16_POSITION                          0x0
#define _SMT2PRU_SMT2PR16_SIZE                              0x1
#define _SMT2PRU_SMT2PR16_LENGTH                            0x1
#define _SMT2PRU_SMT2PR16_MASK                              0x1
#define _SMT2PRU_SMT2PR17_POSN                              0x1
#define _SMT2PRU_SMT2PR17_POSITION                          0x1
#define _SMT2PRU_SMT2PR17_SIZE                              0x1
#define _SMT2PRU_SMT2PR17_LENGTH                            0x1
#define _SMT2PRU_SMT2PR17_MASK                              0x2
#define _SMT2PRU_SMT2PR18_POSN                              0x2
#define _SMT2PRU_SMT2PR18_POSITION                          0x2
#define _SMT2PRU_SMT2PR18_SIZE                              0x1
#define _SMT2PRU_SMT2PR18_LENGTH                            0x1
#define _SMT2PRU_SMT2PR18_MASK                              0x4
#define _SMT2PRU_SMT2PR19_POSN                              0x3
#define _SMT2PRU_SMT2PR19_POSITION                          0x3
#define _SMT2PRU_SMT2PR19_SIZE                              0x1
#define _SMT2PRU_SMT2PR19_LENGTH                            0x1
#define _SMT2PRU_SMT2PR19_MASK                              0x8
#define _SMT2PRU_SMT2PR20_POSN                              0x4
#define _SMT2PRU_SMT2PR20_POSITION                          0x4
#define _SMT2PRU_SMT2PR20_SIZE                              0x1
#define _SMT2PRU_SMT2PR20_LENGTH                            0x1
#define _SMT2PRU_SMT2PR20_MASK                              0x10
#define _SMT2PRU_SMT2PR21_POSN                              0x5
#define _SMT2PRU_SMT2PR21_POSITION                          0x5
#define _SMT2PRU_SMT2PR21_SIZE                              0x1
#define _SMT2PRU_SMT2PR21_LENGTH                            0x1
#define _SMT2PRU_SMT2PR21_MASK                              0x20
#define _SMT2PRU_SMT2PR22_POSN                              0x6
#define _SMT2PRU_SMT2PR22_POSITION                          0x6
#define _SMT2PRU_SMT2PR22_SIZE                              0x1
#define _SMT2PRU_SMT2PR22_LENGTH                            0x1
#define _SMT2PRU_SMT2PR22_MASK                              0x40
#define _SMT2PRU_SMT2PR23_POSN                              0x7
#define _SMT2PRU_SMT2PR23_POSITION                          0x7
#define _SMT2PRU_SMT2PR23_SIZE                              0x1
#define _SMT2PRU_SMT2PR23_LENGTH                            0x1
#define _SMT2PRU_SMT2PR23_MASK                              0x80

// Register: SMT2CON0
extern volatile unsigned char           SMT2CON0            @ 0xDAA;
#ifndef _LIB_BUILD
asm("SMT2CON0 equ 0DAAh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2PS                 :2;
        unsigned CPOL                   :1;
        unsigned SPOL                   :1;
        unsigned WPOL                   :1;
        unsigned STP                    :1;
        unsigned                        :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned SMT2PS0                :1;
        unsigned SMT2PS1                :1;
    };
} SMT2CON0bits_t;
extern volatile SMT2CON0bits_t SMT2CON0bits @ 0xDAA;
// bitfield macros
#define _SMT2CON0_SMT2PS_POSN                               0x0
#define _SMT2CON0_SMT2PS_POSITION                           0x0
#define _SMT2CON0_SMT2PS_SIZE                               0x2
#define _SMT2CON0_SMT2PS_LENGTH                             0x2
#define _SMT2CON0_SMT2PS_MASK                               0x3
#define _SMT2CON0_CPOL_POSN                                 0x2
#define _SMT2CON0_CPOL_POSITION                             0x2
#define _SMT2CON0_CPOL_SIZE                                 0x1
#define _SMT2CON0_CPOL_LENGTH                               0x1
#define _SMT2CON0_CPOL_MASK                                 0x4
#define _SMT2CON0_SPOL_POSN                                 0x3
#define _SMT2CON0_SPOL_POSITION                             0x3
#define _SMT2CON0_SPOL_SIZE                                 0x1
#define _SMT2CON0_SPOL_LENGTH                               0x1
#define _SMT2CON0_SPOL_MASK                                 0x8
#define _SMT2CON0_WPOL_POSN                                 0x4
#define _SMT2CON0_WPOL_POSITION                             0x4
#define _SMT2CON0_WPOL_SIZE                                 0x1
#define _SMT2CON0_WPOL_LENGTH                               0x1
#define _SMT2CON0_WPOL_MASK                                 0x10
#define _SMT2CON0_STP_POSN                                  0x5
#define _SMT2CON0_STP_POSITION                              0x5
#define _SMT2CON0_STP_SIZE                                  0x1
#define _SMT2CON0_STP_LENGTH                                0x1
#define _SMT2CON0_STP_MASK                                  0x20
#define _SMT2CON0_EN_POSN                                   0x7
#define _SMT2CON0_EN_POSITION                               0x7
#define _SMT2CON0_EN_SIZE                                   0x1
#define _SMT2CON0_EN_LENGTH                                 0x1
#define _SMT2CON0_EN_MASK                                   0x80
#define _SMT2CON0_SMT2PS0_POSN                              0x0
#define _SMT2CON0_SMT2PS0_POSITION                          0x0
#define _SMT2CON0_SMT2PS0_SIZE                              0x1
#define _SMT2CON0_SMT2PS0_LENGTH                            0x1
#define _SMT2CON0_SMT2PS0_MASK                              0x1
#define _SMT2CON0_SMT2PS1_POSN                              0x1
#define _SMT2CON0_SMT2PS1_POSITION                          0x1
#define _SMT2CON0_SMT2PS1_SIZE                              0x1
#define _SMT2CON0_SMT2PS1_LENGTH                            0x1
#define _SMT2CON0_SMT2PS1_MASK                              0x2

// Register: SMT2CON1
extern volatile unsigned char           SMT2CON1            @ 0xDAB;
#ifndef _LIB_BUILD
asm("SMT2CON1 equ 0DABh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned MODE                   :4;
        unsigned                        :2;
        unsigned REPEAT                 :1;
        unsigned SMT2GO                 :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
        unsigned MODE3                  :1;
    };
    struct {
        unsigned SMT2MODE               :4;
        unsigned                        :2;
        unsigned SMT2REPEAT             :1;
    };
    struct {
        unsigned SMT2MODE0              :1;
        unsigned SMT2MODE1              :1;
        unsigned SMT2MODE2              :1;
        unsigned SMT2MODE3              :1;
    };
} SMT2CON1bits_t;
extern volatile SMT2CON1bits_t SMT2CON1bits @ 0xDAB;
// bitfield macros
#define _SMT2CON1_MODE_POSN                                 0x0
#define _SMT2CON1_MODE_POSITION                             0x0
#define _SMT2CON1_MODE_SIZE                                 0x4
#define _SMT2CON1_MODE_LENGTH                               0x4
#define _SMT2CON1_MODE_MASK                                 0xF
#define _SMT2CON1_REPEAT_POSN                               0x6
#define _SMT2CON1_REPEAT_POSITION                           0x6
#define _SMT2CON1_REPEAT_SIZE                               0x1
#define _SMT2CON1_REPEAT_LENGTH                             0x1
#define _SMT2CON1_REPEAT_MASK                               0x40
#define _SMT2CON1_SMT2GO_POSN                               0x7
#define _SMT2CON1_SMT2GO_POSITION                           0x7
#define _SMT2CON1_SMT2GO_SIZE                               0x1
#define _SMT2CON1_SMT2GO_LENGTH                             0x1
#define _SMT2CON1_SMT2GO_MASK                               0x80
#define _SMT2CON1_MODE0_POSN                                0x0
#define _SMT2CON1_MODE0_POSITION                            0x0
#define _SMT2CON1_MODE0_SIZE                                0x1
#define _SMT2CON1_MODE0_LENGTH                              0x1
#define _SMT2CON1_MODE0_MASK                                0x1
#define _SMT2CON1_MODE1_POSN                                0x1
#define _SMT2CON1_MODE1_POSITION                            0x1
#define _SMT2CON1_MODE1_SIZE                                0x1
#define _SMT2CON1_MODE1_LENGTH                              0x1
#define _SMT2CON1_MODE1_MASK                                0x2
#define _SMT2CON1_MODE2_POSN                                0x2
#define _SMT2CON1_MODE2_POSITION                            0x2
#define _SMT2CON1_MODE2_SIZE                                0x1
#define _SMT2CON1_MODE2_LENGTH                              0x1
#define _SMT2CON1_MODE2_MASK                                0x4
#define _SMT2CON1_MODE3_POSN                                0x3
#define _SMT2CON1_MODE3_POSITION                            0x3
#define _SMT2CON1_MODE3_SIZE                                0x1
#define _SMT2CON1_MODE3_LENGTH                              0x1
#define _SMT2CON1_MODE3_MASK                                0x8
#define _SMT2CON1_SMT2MODE_POSN                             0x0
#define _SMT2CON1_SMT2MODE_POSITION                         0x0
#define _SMT2CON1_SMT2MODE_SIZE                             0x4
#define _SMT2CON1_SMT2MODE_LENGTH                           0x4
#define _SMT2CON1_SMT2MODE_MASK                             0xF
#define _SMT2CON1_SMT2REPEAT_POSN                           0x6
#define _SMT2CON1_SMT2REPEAT_POSITION                       0x6
#define _SMT2CON1_SMT2REPEAT_SIZE                           0x1
#define _SMT2CON1_SMT2REPEAT_LENGTH                         0x1
#define _SMT2CON1_SMT2REPEAT_MASK                           0x40
#define _SMT2CON1_SMT2MODE0_POSN                            0x0
#define _SMT2CON1_SMT2MODE0_POSITION                        0x0
#define _SMT2CON1_SMT2MODE0_SIZE                            0x1
#define _SMT2CON1_SMT2MODE0_LENGTH                          0x1
#define _SMT2CON1_SMT2MODE0_MASK                            0x1
#define _SMT2CON1_SMT2MODE1_POSN                            0x1
#define _SMT2CON1_SMT2MODE1_POSITION                        0x1
#define _SMT2CON1_SMT2MODE1_SIZE                            0x1
#define _SMT2CON1_SMT2MODE1_LENGTH                          0x1
#define _SMT2CON1_SMT2MODE1_MASK                            0x2
#define _SMT2CON1_SMT2MODE2_POSN                            0x2
#define _SMT2CON1_SMT2MODE2_POSITION                        0x2
#define _SMT2CON1_SMT2MODE2_SIZE                            0x1
#define _SMT2CON1_SMT2MODE2_LENGTH                          0x1
#define _SMT2CON1_SMT2MODE2_MASK                            0x4
#define _SMT2CON1_SMT2MODE3_POSN                            0x3
#define _SMT2CON1_SMT2MODE3_POSITION                        0x3
#define _SMT2CON1_SMT2MODE3_SIZE                            0x1
#define _SMT2CON1_SMT2MODE3_LENGTH                          0x1
#define _SMT2CON1_SMT2MODE3_MASK                            0x8

// Register: SMT2STAT
extern volatile unsigned char           SMT2STAT            @ 0xDAC;
#ifndef _LIB_BUILD
asm("SMT2STAT equ 0DACh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned AS                     :1;
        unsigned WS                     :1;
        unsigned TS                     :1;
        unsigned                        :2;
        unsigned RST                    :1;
        unsigned CPWUP                  :1;
        unsigned CPRUP                  :1;
    };
    struct {
        unsigned SMT2AS                 :1;
        unsigned SMT2WS                 :1;
        unsigned SMT2TS                 :1;
        unsigned                        :2;
        unsigned SMT2RESET              :1;
        unsigned SMT2CPWUP              :1;
        unsigned SMT2CPRUP              :1;
    };
} SMT2STATbits_t;
extern volatile SMT2STATbits_t SMT2STATbits @ 0xDAC;
// bitfield macros
#define _SMT2STAT_AS_POSN                                   0x0
#define _SMT2STAT_AS_POSITION                               0x0
#define _SMT2STAT_AS_SIZE                                   0x1
#define _SMT2STAT_AS_LENGTH                                 0x1
#define _SMT2STAT_AS_MASK                                   0x1
#define _SMT2STAT_WS_POSN                                   0x1
#define _SMT2STAT_WS_POSITION                               0x1
#define _SMT2STAT_WS_SIZE                                   0x1
#define _SMT2STAT_WS_LENGTH                                 0x1
#define _SMT2STAT_WS_MASK                                   0x2
#define _SMT2STAT_TS_POSN                                   0x2
#define _SMT2STAT_TS_POSITION                               0x2
#define _SMT2STAT_TS_SIZE                                   0x1
#define _SMT2STAT_TS_LENGTH                                 0x1
#define _SMT2STAT_TS_MASK                                   0x4
#define _SMT2STAT_RST_POSN                                  0x5
#define _SMT2STAT_RST_POSITION                              0x5
#define _SMT2STAT_RST_SIZE                                  0x1
#define _SMT2STAT_RST_LENGTH                                0x1
#define _SMT2STAT_RST_MASK                                  0x20
#define _SMT2STAT_CPWUP_POSN                                0x6
#define _SMT2STAT_CPWUP_POSITION                            0x6
#define _SMT2STAT_CPWUP_SIZE                                0x1
#define _SMT2STAT_CPWUP_LENGTH                              0x1
#define _SMT2STAT_CPWUP_MASK                                0x40
#define _SMT2STAT_CPRUP_POSN                                0x7
#define _SMT2STAT_CPRUP_POSITION                            0x7
#define _SMT2STAT_CPRUP_SIZE                                0x1
#define _SMT2STAT_CPRUP_LENGTH                              0x1
#define _SMT2STAT_CPRUP_MASK                                0x80
#define _SMT2STAT_SMT2AS_POSN                               0x0
#define _SMT2STAT_SMT2AS_POSITION                           0x0
#define _SMT2STAT_SMT2AS_SIZE                               0x1
#define _SMT2STAT_SMT2AS_LENGTH                             0x1
#define _SMT2STAT_SMT2AS_MASK                               0x1
#define _SMT2STAT_SMT2WS_POSN                               0x1
#define _SMT2STAT_SMT2WS_POSITION                           0x1
#define _SMT2STAT_SMT2WS_SIZE                               0x1
#define _SMT2STAT_SMT2WS_LENGTH                             0x1
#define _SMT2STAT_SMT2WS_MASK                               0x2
#define _SMT2STAT_SMT2TS_POSN                               0x2
#define _SMT2STAT_SMT2TS_POSITION                           0x2
#define _SMT2STAT_SMT2TS_SIZE                               0x1
#define _SMT2STAT_SMT2TS_LENGTH                             0x1
#define _SMT2STAT_SMT2TS_MASK                               0x4
#define _SMT2STAT_SMT2RESET_POSN                            0x5
#define _SMT2STAT_SMT2RESET_POSITION                        0x5
#define _SMT2STAT_SMT2RESET_SIZE                            0x1
#define _SMT2STAT_SMT2RESET_LENGTH                          0x1
#define _SMT2STAT_SMT2RESET_MASK                            0x20
#define _SMT2STAT_SMT2CPWUP_POSN                            0x6
#define _SMT2STAT_SMT2CPWUP_POSITION                        0x6
#define _SMT2STAT_SMT2CPWUP_SIZE                            0x1
#define _SMT2STAT_SMT2CPWUP_LENGTH                          0x1
#define _SMT2STAT_SMT2CPWUP_MASK                            0x40
#define _SMT2STAT_SMT2CPRUP_POSN                            0x7
#define _SMT2STAT_SMT2CPRUP_POSITION                        0x7
#define _SMT2STAT_SMT2CPRUP_SIZE                            0x1
#define _SMT2STAT_SMT2CPRUP_LENGTH                          0x1
#define _SMT2STAT_SMT2CPRUP_MASK                            0x80

// Register: SMT2CLK
extern volatile unsigned char           SMT2CLK             @ 0xDAD;
#ifndef _LIB_BUILD
asm("SMT2CLK equ 0DADh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CSEL                   :8;
    };
    struct {
        unsigned CSEL0                  :1;
        unsigned CSEL1                  :1;
        unsigned CSEL2                  :1;
    };
    struct {
        unsigned SMT2CSEL               :8;
    };
    struct {
        unsigned SMT2CSEL0              :1;
        unsigned SMT2CSEL1              :1;
        unsigned SMT2CSEL2              :1;
    };
} SMT2CLKbits_t;
extern volatile SMT2CLKbits_t SMT2CLKbits @ 0xDAD;
// bitfield macros
#define _SMT2CLK_CSEL_POSN                                  0x0
#define _SMT2CLK_CSEL_POSITION                              0x0
#define _SMT2CLK_CSEL_SIZE                                  0x8
#define _SMT2CLK_CSEL_LENGTH                                0x8
#define _SMT2CLK_CSEL_MASK                                  0xFF
#define _SMT2CLK_CSEL0_POSN                                 0x0
#define _SMT2CLK_CSEL0_POSITION                             0x0
#define _SMT2CLK_CSEL0_SIZE                                 0x1
#define _SMT2CLK_CSEL0_LENGTH                               0x1
#define _SMT2CLK_CSEL0_MASK                                 0x1
#define _SMT2CLK_CSEL1_POSN                                 0x1
#define _SMT2CLK_CSEL1_POSITION                             0x1
#define _SMT2CLK_CSEL1_SIZE                                 0x1
#define _SMT2CLK_CSEL1_LENGTH                               0x1
#define _SMT2CLK_CSEL1_MASK                                 0x2
#define _SMT2CLK_CSEL2_POSN                                 0x2
#define _SMT2CLK_CSEL2_POSITION                             0x2
#define _SMT2CLK_CSEL2_SIZE                                 0x1
#define _SMT2CLK_CSEL2_LENGTH                               0x1
#define _SMT2CLK_CSEL2_MASK                                 0x4
#define _SMT2CLK_SMT2CSEL_POSN                              0x0
#define _SMT2CLK_SMT2CSEL_POSITION                          0x0
#define _SMT2CLK_SMT2CSEL_SIZE                              0x8
#define _SMT2CLK_SMT2CSEL_LENGTH                            0x8
#define _SMT2CLK_SMT2CSEL_MASK                              0xFF
#define _SMT2CLK_SMT2CSEL0_POSN                             0x0
#define _SMT2CLK_SMT2CSEL0_POSITION                         0x0
#define _SMT2CLK_SMT2CSEL0_SIZE                             0x1
#define _SMT2CLK_SMT2CSEL0_LENGTH                           0x1
#define _SMT2CLK_SMT2CSEL0_MASK                             0x1
#define _SMT2CLK_SMT2CSEL1_POSN                             0x1
#define _SMT2CLK_SMT2CSEL1_POSITION                         0x1
#define _SMT2CLK_SMT2CSEL1_SIZE                             0x1
#define _SMT2CLK_SMT2CSEL1_LENGTH                           0x1
#define _SMT2CLK_SMT2CSEL1_MASK                             0x2
#define _SMT2CLK_SMT2CSEL2_POSN                             0x2
#define _SMT2CLK_SMT2CSEL2_POSITION                         0x2
#define _SMT2CLK_SMT2CSEL2_SIZE                             0x1
#define _SMT2CLK_SMT2CSEL2_LENGTH                           0x1
#define _SMT2CLK_SMT2CSEL2_MASK                             0x4

// Register: SMT2SIG
extern volatile unsigned char           SMT2SIG             @ 0xDAE;
#ifndef _LIB_BUILD
asm("SMT2SIG equ 0DAEh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SSEL                   :8;
    };
    struct {
        unsigned SSEL0                  :1;
        unsigned SSEL1                  :1;
        unsigned SSEL2                  :1;
        unsigned SSEL3                  :1;
        unsigned SSEL4                  :1;
    };
    struct {
        unsigned SMT2SSEL               :8;
    };
    struct {
        unsigned SMT2SSEL0              :1;
        unsigned SMT2SSEL1              :1;
        unsigned SMT2SSEL2              :1;
        unsigned SMT2SSEL3              :1;
        unsigned SMT2SSEL4              :1;
    };
} SMT2SIGbits_t;
extern volatile SMT2SIGbits_t SMT2SIGbits @ 0xDAE;
// bitfield macros
#define _SMT2SIG_SSEL_POSN                                  0x0
#define _SMT2SIG_SSEL_POSITION                              0x0
#define _SMT2SIG_SSEL_SIZE                                  0x8
#define _SMT2SIG_SSEL_LENGTH                                0x8
#define _SMT2SIG_SSEL_MASK                                  0xFF
#define _SMT2SIG_SSEL0_POSN                                 0x0
#define _SMT2SIG_SSEL0_POSITION                             0x0
#define _SMT2SIG_SSEL0_SIZE                                 0x1
#define _SMT2SIG_SSEL0_LENGTH                               0x1
#define _SMT2SIG_SSEL0_MASK                                 0x1
#define _SMT2SIG_SSEL1_POSN                                 0x1
#define _SMT2SIG_SSEL1_POSITION                             0x1
#define _SMT2SIG_SSEL1_SIZE                                 0x1
#define _SMT2SIG_SSEL1_LENGTH                               0x1
#define _SMT2SIG_SSEL1_MASK                                 0x2
#define _SMT2SIG_SSEL2_POSN                                 0x2
#define _SMT2SIG_SSEL2_POSITION                             0x2
#define _SMT2SIG_SSEL2_SIZE                                 0x1
#define _SMT2SIG_SSEL2_LENGTH                               0x1
#define _SMT2SIG_SSEL2_MASK                                 0x4
#define _SMT2SIG_SSEL3_POSN                                 0x3
#define _SMT2SIG_SSEL3_POSITION                             0x3
#define _SMT2SIG_SSEL3_SIZE                                 0x1
#define _SMT2SIG_SSEL3_LENGTH                               0x1
#define _SMT2SIG_SSEL3_MASK                                 0x8
#define _SMT2SIG_SSEL4_POSN                                 0x4
#define _SMT2SIG_SSEL4_POSITION                             0x4
#define _SMT2SIG_SSEL4_SIZE                                 0x1
#define _SMT2SIG_SSEL4_LENGTH                               0x1
#define _SMT2SIG_SSEL4_MASK                                 0x10
#define _SMT2SIG_SMT2SSEL_POSN                              0x0
#define _SMT2SIG_SMT2SSEL_POSITION                          0x0
#define _SMT2SIG_SMT2SSEL_SIZE                              0x8
#define _SMT2SIG_SMT2SSEL_LENGTH                            0x8
#define _SMT2SIG_SMT2SSEL_MASK                              0xFF
#define _SMT2SIG_SMT2SSEL0_POSN                             0x0
#define _SMT2SIG_SMT2SSEL0_POSITION                         0x0
#define _SMT2SIG_SMT2SSEL0_SIZE                             0x1
#define _SMT2SIG_SMT2SSEL0_LENGTH                           0x1
#define _SMT2SIG_SMT2SSEL0_MASK                             0x1
#define _SMT2SIG_SMT2SSEL1_POSN                             0x1
#define _SMT2SIG_SMT2SSEL1_POSITION                         0x1
#define _SMT2SIG_SMT2SSEL1_SIZE                             0x1
#define _SMT2SIG_SMT2SSEL1_LENGTH                           0x1
#define _SMT2SIG_SMT2SSEL1_MASK                             0x2
#define _SMT2SIG_SMT2SSEL2_POSN                             0x2
#define _SMT2SIG_SMT2SSEL2_POSITION                         0x2
#define _SMT2SIG_SMT2SSEL2_SIZE                             0x1
#define _SMT2SIG_SMT2SSEL2_LENGTH                           0x1
#define _SMT2SIG_SMT2SSEL2_MASK                             0x4
#define _SMT2SIG_SMT2SSEL3_POSN                             0x3
#define _SMT2SIG_SMT2SSEL3_POSITION                         0x3
#define _SMT2SIG_SMT2SSEL3_SIZE                             0x1
#define _SMT2SIG_SMT2SSEL3_LENGTH                           0x1
#define _SMT2SIG_SMT2SSEL3_MASK                             0x8
#define _SMT2SIG_SMT2SSEL4_POSN                             0x4
#define _SMT2SIG_SMT2SSEL4_POSITION                         0x4
#define _SMT2SIG_SMT2SSEL4_SIZE                             0x1
#define _SMT2SIG_SMT2SSEL4_LENGTH                           0x1
#define _SMT2SIG_SMT2SSEL4_MASK                             0x10

// Register: SMT2WIN
extern volatile unsigned char           SMT2WIN             @ 0xDAF;
#ifndef _LIB_BUILD
asm("SMT2WIN equ 0DAFh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned WSEL                   :8;
    };
    struct {
        unsigned WSEL0                  :1;
        unsigned WSEL1                  :1;
        unsigned WSEL2                  :1;
        unsigned WSEL3                  :1;
        unsigned WSEL4                  :1;
    };
    struct {
        unsigned SMT2WSEL               :8;
    };
    struct {
        unsigned SMT2WSEL0              :1;
        unsigned SMT2WSEL1              :1;
        unsigned SMT2WSEL2              :1;
        unsigned SMT2WSEL3              :1;
        unsigned SMT2WSEL4              :1;
    };
} SMT2WINbits_t;
extern volatile SMT2WINbits_t SMT2WINbits @ 0xDAF;
// bitfield macros
#define _SMT2WIN_WSEL_POSN                                  0x0
#define _SMT2WIN_WSEL_POSITION                              0x0
#define _SMT2WIN_WSEL_SIZE                                  0x8
#define _SMT2WIN_WSEL_LENGTH                                0x8
#define _SMT2WIN_WSEL_MASK                                  0xFF
#define _SMT2WIN_WSEL0_POSN                                 0x0
#define _SMT2WIN_WSEL0_POSITION                             0x0
#define _SMT2WIN_WSEL0_SIZE                                 0x1
#define _SMT2WIN_WSEL0_LENGTH                               0x1
#define _SMT2WIN_WSEL0_MASK                                 0x1
#define _SMT2WIN_WSEL1_POSN                                 0x1
#define _SMT2WIN_WSEL1_POSITION                             0x1
#define _SMT2WIN_WSEL1_SIZE                                 0x1
#define _SMT2WIN_WSEL1_LENGTH                               0x1
#define _SMT2WIN_WSEL1_MASK                                 0x2
#define _SMT2WIN_WSEL2_POSN                                 0x2
#define _SMT2WIN_WSEL2_POSITION                             0x2
#define _SMT2WIN_WSEL2_SIZE                                 0x1
#define _SMT2WIN_WSEL2_LENGTH                               0x1
#define _SMT2WIN_WSEL2_MASK                                 0x4
#define _SMT2WIN_WSEL3_POSN                                 0x3
#define _SMT2WIN_WSEL3_POSITION                             0x3
#define _SMT2WIN_WSEL3_SIZE                                 0x1
#define _SMT2WIN_WSEL3_LENGTH                               0x1
#define _SMT2WIN_WSEL3_MASK                                 0x8
#define _SMT2WIN_WSEL4_POSN                                 0x4
#define _SMT2WIN_WSEL4_POSITION                             0x4
#define _SMT2WIN_WSEL4_SIZE                                 0x1
#define _SMT2WIN_WSEL4_LENGTH                               0x1
#define _SMT2WIN_WSEL4_MASK                                 0x10
#define _SMT2WIN_SMT2WSEL_POSN                              0x0
#define _SMT2WIN_SMT2WSEL_POSITION                          0x0
#define _SMT2WIN_SMT2WSEL_SIZE                              0x8
#define _SMT2WIN_SMT2WSEL_LENGTH                            0x8
#define _SMT2WIN_SMT2WSEL_MASK                              0xFF
#define _SMT2WIN_SMT2WSEL0_POSN                             0x0
#define _SMT2WIN_SMT2WSEL0_POSITION                         0x0
#define _SMT2WIN_SMT2WSEL0_SIZE                             0x1
#define _SMT2WIN_SMT2WSEL0_LENGTH                           0x1
#define _SMT2WIN_SMT2WSEL0_MASK                             0x1
#define _SMT2WIN_SMT2WSEL1_POSN                             0x1
#define _SMT2WIN_SMT2WSEL1_POSITION                         0x1
#define _SMT2WIN_SMT2WSEL1_SIZE                             0x1
#define _SMT2WIN_SMT2WSEL1_LENGTH                           0x1
#define _SMT2WIN_SMT2WSEL1_MASK                             0x2
#define _SMT2WIN_SMT2WSEL2_POSN                             0x2
#define _SMT2WIN_SMT2WSEL2_POSITION                         0x2
#define _SMT2WIN_SMT2WSEL2_SIZE                             0x1
#define _SMT2WIN_SMT2WSEL2_LENGTH                           0x1
#define _SMT2WIN_SMT2WSEL2_MASK                             0x4
#define _SMT2WIN_SMT2WSEL3_POSN                             0x3
#define _SMT2WIN_SMT2WSEL3_POSITION                         0x3
#define _SMT2WIN_SMT2WSEL3_SIZE                             0x1
#define _SMT2WIN_SMT2WSEL3_LENGTH                           0x1
#define _SMT2WIN_SMT2WSEL3_MASK                             0x8
#define _SMT2WIN_SMT2WSEL4_POSN                             0x4
#define _SMT2WIN_SMT2WSEL4_POSITION                         0x4
#define _SMT2WIN_SMT2WSEL4_SIZE                             0x1
#define _SMT2WIN_SMT2WSEL4_LENGTH                           0x1
#define _SMT2WIN_SMT2WSEL4_MASK                             0x10

// Register: PPSLOCK
extern volatile unsigned char           PPSLOCK             @ 0xE0F;
#ifndef _LIB_BUILD
asm("PPSLOCK equ 0E0Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PPSLOCKED              :1;
    };
} PPSLOCKbits_t;
extern volatile PPSLOCKbits_t PPSLOCKbits @ 0xE0F;
// bitfield macros
#define _PPSLOCK_PPSLOCKED_POSN                             0x0
#define _PPSLOCK_PPSLOCKED_POSITION                         0x0
#define _PPSLOCK_PPSLOCKED_SIZE                             0x1
#define _PPSLOCK_PPSLOCKED_LENGTH                           0x1
#define _PPSLOCK_PPSLOCKED_MASK                             0x1

// Register: INTPPS
extern volatile unsigned char           INTPPS              @ 0xE10;
#ifndef _LIB_BUILD
asm("INTPPS equ 0E10h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned INTPPS0                :1;
        unsigned INTPPS1                :1;
        unsigned INTPPS2                :1;
        unsigned INTPPS3                :1;
        unsigned INTPPS4                :1;
    };
} INTPPSbits_t;
extern volatile INTPPSbits_t INTPPSbits @ 0xE10;
// bitfield macros
#define _INTPPS_INTPPS0_POSN                                0x0
#define _INTPPS_INTPPS0_POSITION                            0x0
#define _INTPPS_INTPPS0_SIZE                                0x1
#define _INTPPS_INTPPS0_LENGTH                              0x1
#define _INTPPS_INTPPS0_MASK                                0x1
#define _INTPPS_INTPPS1_POSN                                0x1
#define _INTPPS_INTPPS1_POSITION                            0x1
#define _INTPPS_INTPPS1_SIZE                                0x1
#define _INTPPS_INTPPS1_LENGTH                              0x1
#define _INTPPS_INTPPS1_MASK                                0x2
#define _INTPPS_INTPPS2_POSN                                0x2
#define _INTPPS_INTPPS2_POSITION                            0x2
#define _INTPPS_INTPPS2_SIZE                                0x1
#define _INTPPS_INTPPS2_LENGTH                              0x1
#define _INTPPS_INTPPS2_MASK                                0x4
#define _INTPPS_INTPPS3_POSN                                0x3
#define _INTPPS_INTPPS3_POSITION                            0x3
#define _INTPPS_INTPPS3_SIZE                                0x1
#define _INTPPS_INTPPS3_LENGTH                              0x1
#define _INTPPS_INTPPS3_MASK                                0x8
#define _INTPPS_INTPPS4_POSN                                0x4
#define _INTPPS_INTPPS4_POSITION                            0x4
#define _INTPPS_INTPPS4_SIZE                                0x1
#define _INTPPS_INTPPS4_LENGTH                              0x1
#define _INTPPS_INTPPS4_MASK                                0x10

// Register: T0CKIPPS
extern volatile unsigned char           T0CKIPPS            @ 0xE11;
#ifndef _LIB_BUILD
asm("T0CKIPPS equ 0E11h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T0CKIPPS0              :1;
        unsigned T0CKIPPS1              :1;
        unsigned T0CKIPPS2              :1;
        unsigned T0CKIPPS3              :1;
        unsigned T0CKIPPS4              :1;
    };
} T0CKIPPSbits_t;
extern volatile T0CKIPPSbits_t T0CKIPPSbits @ 0xE11;
// bitfield macros
#define _T0CKIPPS_T0CKIPPS0_POSN                            0x0
#define _T0CKIPPS_T0CKIPPS0_POSITION                        0x0
#define _T0CKIPPS_T0CKIPPS0_SIZE                            0x1
#define _T0CKIPPS_T0CKIPPS0_LENGTH                          0x1
#define _T0CKIPPS_T0CKIPPS0_MASK                            0x1
#define _T0CKIPPS_T0CKIPPS1_POSN                            0x1
#define _T0CKIPPS_T0CKIPPS1_POSITION                        0x1
#define _T0CKIPPS_T0CKIPPS1_SIZE                            0x1
#define _T0CKIPPS_T0CKIPPS1_LENGTH                          0x1
#define _T0CKIPPS_T0CKIPPS1_MASK                            0x2
#define _T0CKIPPS_T0CKIPPS2_POSN                            0x2
#define _T0CKIPPS_T0CKIPPS2_POSITION                        0x2
#define _T0CKIPPS_T0CKIPPS2_SIZE                            0x1
#define _T0CKIPPS_T0CKIPPS2_LENGTH                          0x1
#define _T0CKIPPS_T0CKIPPS2_MASK                            0x4
#define _T0CKIPPS_T0CKIPPS3_POSN                            0x3
#define _T0CKIPPS_T0CKIPPS3_POSITION                        0x3
#define _T0CKIPPS_T0CKIPPS3_SIZE                            0x1
#define _T0CKIPPS_T0CKIPPS3_LENGTH                          0x1
#define _T0CKIPPS_T0CKIPPS3_MASK                            0x8
#define _T0CKIPPS_T0CKIPPS4_POSN                            0x4
#define _T0CKIPPS_T0CKIPPS4_POSITION                        0x4
#define _T0CKIPPS_T0CKIPPS4_SIZE                            0x1
#define _T0CKIPPS_T0CKIPPS4_LENGTH                          0x1
#define _T0CKIPPS_T0CKIPPS4_MASK                            0x10

// Register: T1CKIPPS
extern volatile unsigned char           T1CKIPPS            @ 0xE12;
#ifndef _LIB_BUILD
asm("T1CKIPPS equ 0E12h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T1CKIPPS0              :1;
        unsigned T1CKIPPS1              :1;
        unsigned T1CKIPPS2              :1;
        unsigned T1CKIPPS3              :1;
        unsigned T1CKIPPS4              :1;
    };
} T1CKIPPSbits_t;
extern volatile T1CKIPPSbits_t T1CKIPPSbits @ 0xE12;
// bitfield macros
#define _T1CKIPPS_T1CKIPPS0_POSN                            0x0
#define _T1CKIPPS_T1CKIPPS0_POSITION                        0x0
#define _T1CKIPPS_T1CKIPPS0_SIZE                            0x1
#define _T1CKIPPS_T1CKIPPS0_LENGTH                          0x1
#define _T1CKIPPS_T1CKIPPS0_MASK                            0x1
#define _T1CKIPPS_T1CKIPPS1_POSN                            0x1
#define _T1CKIPPS_T1CKIPPS1_POSITION                        0x1
#define _T1CKIPPS_T1CKIPPS1_SIZE                            0x1
#define _T1CKIPPS_T1CKIPPS1_LENGTH                          0x1
#define _T1CKIPPS_T1CKIPPS1_MASK                            0x2
#define _T1CKIPPS_T1CKIPPS2_POSN                            0x2
#define _T1CKIPPS_T1CKIPPS2_POSITION                        0x2
#define _T1CKIPPS_T1CKIPPS2_SIZE                            0x1
#define _T1CKIPPS_T1CKIPPS2_LENGTH                          0x1
#define _T1CKIPPS_T1CKIPPS2_MASK                            0x4
#define _T1CKIPPS_T1CKIPPS3_POSN                            0x3
#define _T1CKIPPS_T1CKIPPS3_POSITION                        0x3
#define _T1CKIPPS_T1CKIPPS3_SIZE                            0x1
#define _T1CKIPPS_T1CKIPPS3_LENGTH                          0x1
#define _T1CKIPPS_T1CKIPPS3_MASK                            0x8
#define _T1CKIPPS_T1CKIPPS4_POSN                            0x4
#define _T1CKIPPS_T1CKIPPS4_POSITION                        0x4
#define _T1CKIPPS_T1CKIPPS4_SIZE                            0x1
#define _T1CKIPPS_T1CKIPPS4_LENGTH                          0x1
#define _T1CKIPPS_T1CKIPPS4_MASK                            0x10

// Register: T1GPPS
extern volatile unsigned char           T1GPPS              @ 0xE13;
#ifndef _LIB_BUILD
asm("T1GPPS equ 0E13h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T1GPPS0                :1;
        unsigned T1GPPS1                :1;
        unsigned T1GPPS2                :1;
        unsigned T1GPPS3                :1;
        unsigned T1GPPS4                :1;
    };
} T1GPPSbits_t;
extern volatile T1GPPSbits_t T1GPPSbits @ 0xE13;
// bitfield macros
#define _T1GPPS_T1GPPS0_POSN                                0x0
#define _T1GPPS_T1GPPS0_POSITION                            0x0
#define _T1GPPS_T1GPPS0_SIZE                                0x1
#define _T1GPPS_T1GPPS0_LENGTH                              0x1
#define _T1GPPS_T1GPPS0_MASK                                0x1
#define _T1GPPS_T1GPPS1_POSN                                0x1
#define _T1GPPS_T1GPPS1_POSITION                            0x1
#define _T1GPPS_T1GPPS1_SIZE                                0x1
#define _T1GPPS_T1GPPS1_LENGTH                              0x1
#define _T1GPPS_T1GPPS1_MASK                                0x2
#define _T1GPPS_T1GPPS2_POSN                                0x2
#define _T1GPPS_T1GPPS2_POSITION                            0x2
#define _T1GPPS_T1GPPS2_SIZE                                0x1
#define _T1GPPS_T1GPPS2_LENGTH                              0x1
#define _T1GPPS_T1GPPS2_MASK                                0x4
#define _T1GPPS_T1GPPS3_POSN                                0x3
#define _T1GPPS_T1GPPS3_POSITION                            0x3
#define _T1GPPS_T1GPPS3_SIZE                                0x1
#define _T1GPPS_T1GPPS3_LENGTH                              0x1
#define _T1GPPS_T1GPPS3_MASK                                0x8
#define _T1GPPS_T1GPPS4_POSN                                0x4
#define _T1GPPS_T1GPPS4_POSITION                            0x4
#define _T1GPPS_T1GPPS4_SIZE                                0x1
#define _T1GPPS_T1GPPS4_LENGTH                              0x1
#define _T1GPPS_T1GPPS4_MASK                                0x10

// Register: CCP1PPS
extern volatile unsigned char           CCP1PPS             @ 0xE14;
#ifndef _LIB_BUILD
asm("CCP1PPS equ 0E14h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CCP1PPS0               :1;
        unsigned CCP1PPS1               :1;
        unsigned CCP1PPS2               :1;
        unsigned CCP1PPS3               :1;
        unsigned CCP1PPS4               :1;
    };
} CCP1PPSbits_t;
extern volatile CCP1PPSbits_t CCP1PPSbits @ 0xE14;
// bitfield macros
#define _CCP1PPS_CCP1PPS0_POSN                              0x0
#define _CCP1PPS_CCP1PPS0_POSITION                          0x0
#define _CCP1PPS_CCP1PPS0_SIZE                              0x1
#define _CCP1PPS_CCP1PPS0_LENGTH                            0x1
#define _CCP1PPS_CCP1PPS0_MASK                              0x1
#define _CCP1PPS_CCP1PPS1_POSN                              0x1
#define _CCP1PPS_CCP1PPS1_POSITION                          0x1
#define _CCP1PPS_CCP1PPS1_SIZE                              0x1
#define _CCP1PPS_CCP1PPS1_LENGTH                            0x1
#define _CCP1PPS_CCP1PPS1_MASK                              0x2
#define _CCP1PPS_CCP1PPS2_POSN                              0x2
#define _CCP1PPS_CCP1PPS2_POSITION                          0x2
#define _CCP1PPS_CCP1PPS2_SIZE                              0x1
#define _CCP1PPS_CCP1PPS2_LENGTH                            0x1
#define _CCP1PPS_CCP1PPS2_MASK                              0x4
#define _CCP1PPS_CCP1PPS3_POSN                              0x3
#define _CCP1PPS_CCP1PPS3_POSITION                          0x3
#define _CCP1PPS_CCP1PPS3_SIZE                              0x1
#define _CCP1PPS_CCP1PPS3_LENGTH                            0x1
#define _CCP1PPS_CCP1PPS3_MASK                              0x8
#define _CCP1PPS_CCP1PPS4_POSN                              0x4
#define _CCP1PPS_CCP1PPS4_POSITION                          0x4
#define _CCP1PPS_CCP1PPS4_SIZE                              0x1
#define _CCP1PPS_CCP1PPS4_LENGTH                            0x1
#define _CCP1PPS_CCP1PPS4_MASK                              0x10

// Register: CCP2PPS
extern volatile unsigned char           CCP2PPS             @ 0xE15;
#ifndef _LIB_BUILD
asm("CCP2PPS equ 0E15h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CCP2PPS0               :1;
        unsigned CCP2PPS1               :1;
        unsigned CCP2PPS2               :1;
        unsigned CCP2PPS3               :1;
        unsigned CCP2PPS4               :1;
    };
} CCP2PPSbits_t;
extern volatile CCP2PPSbits_t CCP2PPSbits @ 0xE15;
// bitfield macros
#define _CCP2PPS_CCP2PPS0_POSN                              0x0
#define _CCP2PPS_CCP2PPS0_POSITION                          0x0
#define _CCP2PPS_CCP2PPS0_SIZE                              0x1
#define _CCP2PPS_CCP2PPS0_LENGTH                            0x1
#define _CCP2PPS_CCP2PPS0_MASK                              0x1
#define _CCP2PPS_CCP2PPS1_POSN                              0x1
#define _CCP2PPS_CCP2PPS1_POSITION                          0x1
#define _CCP2PPS_CCP2PPS1_SIZE                              0x1
#define _CCP2PPS_CCP2PPS1_LENGTH                            0x1
#define _CCP2PPS_CCP2PPS1_MASK                              0x2
#define _CCP2PPS_CCP2PPS2_POSN                              0x2
#define _CCP2PPS_CCP2PPS2_POSITION                          0x2
#define _CCP2PPS_CCP2PPS2_SIZE                              0x1
#define _CCP2PPS_CCP2PPS2_LENGTH                            0x1
#define _CCP2PPS_CCP2PPS2_MASK                              0x4
#define _CCP2PPS_CCP2PPS3_POSN                              0x3
#define _CCP2PPS_CCP2PPS3_POSITION                          0x3
#define _CCP2PPS_CCP2PPS3_SIZE                              0x1
#define _CCP2PPS_CCP2PPS3_LENGTH                            0x1
#define _CCP2PPS_CCP2PPS3_MASK                              0x8
#define _CCP2PPS_CCP2PPS4_POSN                              0x4
#define _CCP2PPS_CCP2PPS4_POSITION                          0x4
#define _CCP2PPS_CCP2PPS4_SIZE                              0x1
#define _CCP2PPS_CCP2PPS4_LENGTH                            0x1
#define _CCP2PPS_CCP2PPS4_MASK                              0x10

// Register: ATINPPS
extern volatile unsigned char           ATINPPS             @ 0xE16;
#ifndef _LIB_BUILD
asm("ATINPPS equ 0E16h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ATINPPS0               :1;
        unsigned ATINPPS1               :1;
        unsigned ATINPPS2               :1;
        unsigned ATINPPS3               :1;
        unsigned ATINPPS4               :1;
    };
} ATINPPSbits_t;
extern volatile ATINPPSbits_t ATINPPSbits @ 0xE16;
// bitfield macros
#define _ATINPPS_ATINPPS0_POSN                              0x0
#define _ATINPPS_ATINPPS0_POSITION                          0x0
#define _ATINPPS_ATINPPS0_SIZE                              0x1
#define _ATINPPS_ATINPPS0_LENGTH                            0x1
#define _ATINPPS_ATINPPS0_MASK                              0x1
#define _ATINPPS_ATINPPS1_POSN                              0x1
#define _ATINPPS_ATINPPS1_POSITION                          0x1
#define _ATINPPS_ATINPPS1_SIZE                              0x1
#define _ATINPPS_ATINPPS1_LENGTH                            0x1
#define _ATINPPS_ATINPPS1_MASK                              0x2
#define _ATINPPS_ATINPPS2_POSN                              0x2
#define _ATINPPS_ATINPPS2_POSITION                          0x2
#define _ATINPPS_ATINPPS2_SIZE                              0x1
#define _ATINPPS_ATINPPS2_LENGTH                            0x1
#define _ATINPPS_ATINPPS2_MASK                              0x4
#define _ATINPPS_ATINPPS3_POSN                              0x3
#define _ATINPPS_ATINPPS3_POSITION                          0x3
#define _ATINPPS_ATINPPS3_SIZE                              0x1
#define _ATINPPS_ATINPPS3_LENGTH                            0x1
#define _ATINPPS_ATINPPS3_MASK                              0x8
#define _ATINPPS_ATINPPS4_POSN                              0x4
#define _ATINPPS_ATINPPS4_POSITION                          0x4
#define _ATINPPS_ATINPPS4_SIZE                              0x1
#define _ATINPPS_ATINPPS4_LENGTH                            0x1
#define _ATINPPS_ATINPPS4_MASK                              0x10

// Register: CWGINPPS
extern volatile unsigned char           CWGINPPS            @ 0xE17;
#ifndef _LIB_BUILD
asm("CWGINPPS equ 0E17h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CWGINPPS0              :1;
        unsigned CWGINPPS1              :1;
        unsigned CWGINPPS2              :1;
        unsigned CWGINPPS3              :1;
        unsigned CWGINPPS4              :1;
    };
} CWGINPPSbits_t;
extern volatile CWGINPPSbits_t CWGINPPSbits @ 0xE17;
// bitfield macros
#define _CWGINPPS_CWGINPPS0_POSN                            0x0
#define _CWGINPPS_CWGINPPS0_POSITION                        0x0
#define _CWGINPPS_CWGINPPS0_SIZE                            0x1
#define _CWGINPPS_CWGINPPS0_LENGTH                          0x1
#define _CWGINPPS_CWGINPPS0_MASK                            0x1
#define _CWGINPPS_CWGINPPS1_POSN                            0x1
#define _CWGINPPS_CWGINPPS1_POSITION                        0x1
#define _CWGINPPS_CWGINPPS1_SIZE                            0x1
#define _CWGINPPS_CWGINPPS1_LENGTH                          0x1
#define _CWGINPPS_CWGINPPS1_MASK                            0x2
#define _CWGINPPS_CWGINPPS2_POSN                            0x2
#define _CWGINPPS_CWGINPPS2_POSITION                        0x2
#define _CWGINPPS_CWGINPPS2_SIZE                            0x1
#define _CWGINPPS_CWGINPPS2_LENGTH                          0x1
#define _CWGINPPS_CWGINPPS2_MASK                            0x4
#define _CWGINPPS_CWGINPPS3_POSN                            0x3
#define _CWGINPPS_CWGINPPS3_POSITION                        0x3
#define _CWGINPPS_CWGINPPS3_SIZE                            0x1
#define _CWGINPPS_CWGINPPS3_LENGTH                          0x1
#define _CWGINPPS_CWGINPPS3_MASK                            0x8
#define _CWGINPPS_CWGINPPS4_POSN                            0x4
#define _CWGINPPS_CWGINPPS4_POSITION                        0x4
#define _CWGINPPS_CWGINPPS4_SIZE                            0x1
#define _CWGINPPS_CWGINPPS4_LENGTH                          0x1
#define _CWGINPPS_CWGINPPS4_MASK                            0x10

// Register: T2PPS
extern volatile unsigned char           T2PPS               @ 0xE18;
#ifndef _LIB_BUILD
asm("T2PPS equ 0E18h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T2PPS0                 :1;
        unsigned T2PPS1                 :1;
        unsigned T2PPS2                 :1;
        unsigned T2PPS3                 :1;
        unsigned T2PPS4                 :1;
    };
} T2PPSbits_t;
extern volatile T2PPSbits_t T2PPSbits @ 0xE18;
// bitfield macros
#define _T2PPS_T2PPS0_POSN                                  0x0
#define _T2PPS_T2PPS0_POSITION                              0x0
#define _T2PPS_T2PPS0_SIZE                                  0x1
#define _T2PPS_T2PPS0_LENGTH                                0x1
#define _T2PPS_T2PPS0_MASK                                  0x1
#define _T2PPS_T2PPS1_POSN                                  0x1
#define _T2PPS_T2PPS1_POSITION                              0x1
#define _T2PPS_T2PPS1_SIZE                                  0x1
#define _T2PPS_T2PPS1_LENGTH                                0x1
#define _T2PPS_T2PPS1_MASK                                  0x2
#define _T2PPS_T2PPS2_POSN                                  0x2
#define _T2PPS_T2PPS2_POSITION                              0x2
#define _T2PPS_T2PPS2_SIZE                                  0x1
#define _T2PPS_T2PPS2_LENGTH                                0x1
#define _T2PPS_T2PPS2_MASK                                  0x4
#define _T2PPS_T2PPS3_POSN                                  0x3
#define _T2PPS_T2PPS3_POSITION                              0x3
#define _T2PPS_T2PPS3_SIZE                                  0x1
#define _T2PPS_T2PPS3_LENGTH                                0x1
#define _T2PPS_T2PPS3_MASK                                  0x8
#define _T2PPS_T2PPS4_POSN                                  0x4
#define _T2PPS_T2PPS4_POSITION                              0x4
#define _T2PPS_T2PPS4_SIZE                                  0x1
#define _T2PPS_T2PPS4_LENGTH                                0x1
#define _T2PPS_T2PPS4_MASK                                  0x10

// Register: T3CKIPPS
extern volatile unsigned char           T3CKIPPS            @ 0xE19;
#ifndef _LIB_BUILD
asm("T3CKIPPS equ 0E19h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T3CKIPPS0              :1;
        unsigned T3CKIPPS1              :1;
        unsigned T3CKIPPS2              :1;
        unsigned T3CKIPPS3              :1;
        unsigned T3CKIPPS4              :1;
    };
} T3CKIPPSbits_t;
extern volatile T3CKIPPSbits_t T3CKIPPSbits @ 0xE19;
// bitfield macros
#define _T3CKIPPS_T3CKIPPS0_POSN                            0x0
#define _T3CKIPPS_T3CKIPPS0_POSITION                        0x0
#define _T3CKIPPS_T3CKIPPS0_SIZE                            0x1
#define _T3CKIPPS_T3CKIPPS0_LENGTH                          0x1
#define _T3CKIPPS_T3CKIPPS0_MASK                            0x1
#define _T3CKIPPS_T3CKIPPS1_POSN                            0x1
#define _T3CKIPPS_T3CKIPPS1_POSITION                        0x1
#define _T3CKIPPS_T3CKIPPS1_SIZE                            0x1
#define _T3CKIPPS_T3CKIPPS1_LENGTH                          0x1
#define _T3CKIPPS_T3CKIPPS1_MASK                            0x2
#define _T3CKIPPS_T3CKIPPS2_POSN                            0x2
#define _T3CKIPPS_T3CKIPPS2_POSITION                        0x2
#define _T3CKIPPS_T3CKIPPS2_SIZE                            0x1
#define _T3CKIPPS_T3CKIPPS2_LENGTH                          0x1
#define _T3CKIPPS_T3CKIPPS2_MASK                            0x4
#define _T3CKIPPS_T3CKIPPS3_POSN                            0x3
#define _T3CKIPPS_T3CKIPPS3_POSITION                        0x3
#define _T3CKIPPS_T3CKIPPS3_SIZE                            0x1
#define _T3CKIPPS_T3CKIPPS3_LENGTH                          0x1
#define _T3CKIPPS_T3CKIPPS3_MASK                            0x8
#define _T3CKIPPS_T3CKIPPS4_POSN                            0x4
#define _T3CKIPPS_T3CKIPPS4_POSITION                        0x4
#define _T3CKIPPS_T3CKIPPS4_SIZE                            0x1
#define _T3CKIPPS_T3CKIPPS4_LENGTH                          0x1
#define _T3CKIPPS_T3CKIPPS4_MASK                            0x10

// Register: T3GPPS
extern volatile unsigned char           T3GPPS              @ 0xE1A;
#ifndef _LIB_BUILD
asm("T3GPPS equ 0E1Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T3GPPS0                :1;
        unsigned T3GPPS1                :1;
        unsigned T3GPPS2                :1;
        unsigned T3GPPS3                :1;
        unsigned T3GPPS4                :1;
    };
} T3GPPSbits_t;
extern volatile T3GPPSbits_t T3GPPSbits @ 0xE1A;
// bitfield macros
#define _T3GPPS_T3GPPS0_POSN                                0x0
#define _T3GPPS_T3GPPS0_POSITION                            0x0
#define _T3GPPS_T3GPPS0_SIZE                                0x1
#define _T3GPPS_T3GPPS0_LENGTH                              0x1
#define _T3GPPS_T3GPPS0_MASK                                0x1
#define _T3GPPS_T3GPPS1_POSN                                0x1
#define _T3GPPS_T3GPPS1_POSITION                            0x1
#define _T3GPPS_T3GPPS1_SIZE                                0x1
#define _T3GPPS_T3GPPS1_LENGTH                              0x1
#define _T3GPPS_T3GPPS1_MASK                                0x2
#define _T3GPPS_T3GPPS2_POSN                                0x2
#define _T3GPPS_T3GPPS2_POSITION                            0x2
#define _T3GPPS_T3GPPS2_SIZE                                0x1
#define _T3GPPS_T3GPPS2_LENGTH                              0x1
#define _T3GPPS_T3GPPS2_MASK                                0x4
#define _T3GPPS_T3GPPS3_POSN                                0x3
#define _T3GPPS_T3GPPS3_POSITION                            0x3
#define _T3GPPS_T3GPPS3_SIZE                                0x1
#define _T3GPPS_T3GPPS3_LENGTH                              0x1
#define _T3GPPS_T3GPPS3_MASK                                0x8
#define _T3GPPS_T3GPPS4_POSN                                0x4
#define _T3GPPS_T3GPPS4_POSITION                            0x4
#define _T3GPPS_T3GPPS4_SIZE                                0x1
#define _T3GPPS_T3GPPS4_LENGTH                              0x1
#define _T3GPPS_T3GPPS4_MASK                                0x10

// Register: T4PPS
extern volatile unsigned char           T4PPS               @ 0xE1B;
#ifndef _LIB_BUILD
asm("T4PPS equ 0E1Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T4PPS0                 :1;
        unsigned T4PPS1                 :1;
        unsigned T4PPS2                 :1;
        unsigned T4PPS3                 :1;
        unsigned T4PPS4                 :1;
    };
} T4PPSbits_t;
extern volatile T4PPSbits_t T4PPSbits @ 0xE1B;
// bitfield macros
#define _T4PPS_T4PPS0_POSN                                  0x0
#define _T4PPS_T4PPS0_POSITION                              0x0
#define _T4PPS_T4PPS0_SIZE                                  0x1
#define _T4PPS_T4PPS0_LENGTH                                0x1
#define _T4PPS_T4PPS0_MASK                                  0x1
#define _T4PPS_T4PPS1_POSN                                  0x1
#define _T4PPS_T4PPS1_POSITION                              0x1
#define _T4PPS_T4PPS1_SIZE                                  0x1
#define _T4PPS_T4PPS1_LENGTH                                0x1
#define _T4PPS_T4PPS1_MASK                                  0x2
#define _T4PPS_T4PPS2_POSN                                  0x2
#define _T4PPS_T4PPS2_POSITION                              0x2
#define _T4PPS_T4PPS2_SIZE                                  0x1
#define _T4PPS_T4PPS2_LENGTH                                0x1
#define _T4PPS_T4PPS2_MASK                                  0x4
#define _T4PPS_T4PPS3_POSN                                  0x3
#define _T4PPS_T4PPS3_POSITION                              0x3
#define _T4PPS_T4PPS3_SIZE                                  0x1
#define _T4PPS_T4PPS3_LENGTH                                0x1
#define _T4PPS_T4PPS3_MASK                                  0x8
#define _T4PPS_T4PPS4_POSN                                  0x4
#define _T4PPS_T4PPS4_POSITION                              0x4
#define _T4PPS_T4PPS4_SIZE                                  0x1
#define _T4PPS_T4PPS4_LENGTH                                0x1
#define _T4PPS_T4PPS4_MASK                                  0x10

// Register: T5CKIPPS
extern volatile unsigned char           T5CKIPPS            @ 0xE1C;
#ifndef _LIB_BUILD
asm("T5CKIPPS equ 0E1Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T5CKIPPS0              :1;
        unsigned T5CKIPPS1              :1;
        unsigned T5CKIPPS2              :1;
        unsigned T5CKIPPS3              :1;
        unsigned T5CKIPPS4              :1;
    };
} T5CKIPPSbits_t;
extern volatile T5CKIPPSbits_t T5CKIPPSbits @ 0xE1C;
// bitfield macros
#define _T5CKIPPS_T5CKIPPS0_POSN                            0x0
#define _T5CKIPPS_T5CKIPPS0_POSITION                        0x0
#define _T5CKIPPS_T5CKIPPS0_SIZE                            0x1
#define _T5CKIPPS_T5CKIPPS0_LENGTH                          0x1
#define _T5CKIPPS_T5CKIPPS0_MASK                            0x1
#define _T5CKIPPS_T5CKIPPS1_POSN                            0x1
#define _T5CKIPPS_T5CKIPPS1_POSITION                        0x1
#define _T5CKIPPS_T5CKIPPS1_SIZE                            0x1
#define _T5CKIPPS_T5CKIPPS1_LENGTH                          0x1
#define _T5CKIPPS_T5CKIPPS1_MASK                            0x2
#define _T5CKIPPS_T5CKIPPS2_POSN                            0x2
#define _T5CKIPPS_T5CKIPPS2_POSITION                        0x2
#define _T5CKIPPS_T5CKIPPS2_SIZE                            0x1
#define _T5CKIPPS_T5CKIPPS2_LENGTH                          0x1
#define _T5CKIPPS_T5CKIPPS2_MASK                            0x4
#define _T5CKIPPS_T5CKIPPS3_POSN                            0x3
#define _T5CKIPPS_T5CKIPPS3_POSITION                        0x3
#define _T5CKIPPS_T5CKIPPS3_SIZE                            0x1
#define _T5CKIPPS_T5CKIPPS3_LENGTH                          0x1
#define _T5CKIPPS_T5CKIPPS3_MASK                            0x8
#define _T5CKIPPS_T5CKIPPS4_POSN                            0x4
#define _T5CKIPPS_T5CKIPPS4_POSITION                        0x4
#define _T5CKIPPS_T5CKIPPS4_SIZE                            0x1
#define _T5CKIPPS_T5CKIPPS4_LENGTH                          0x1
#define _T5CKIPPS_T5CKIPPS4_MASK                            0x10

// Register: T5GPPS
extern volatile unsigned char           T5GPPS              @ 0xE1D;
#ifndef _LIB_BUILD
asm("T5GPPS equ 0E1Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T5GPPS0                :1;
        unsigned T5GPPS1                :1;
        unsigned T5GPPS2                :1;
        unsigned T5GPPS3                :1;
        unsigned T5GPPS4                :1;
    };
} T5GPPSbits_t;
extern volatile T5GPPSbits_t T5GPPSbits @ 0xE1D;
// bitfield macros
#define _T5GPPS_T5GPPS0_POSN                                0x0
#define _T5GPPS_T5GPPS0_POSITION                            0x0
#define _T5GPPS_T5GPPS0_SIZE                                0x1
#define _T5GPPS_T5GPPS0_LENGTH                              0x1
#define _T5GPPS_T5GPPS0_MASK                                0x1
#define _T5GPPS_T5GPPS1_POSN                                0x1
#define _T5GPPS_T5GPPS1_POSITION                            0x1
#define _T5GPPS_T5GPPS1_SIZE                                0x1
#define _T5GPPS_T5GPPS1_LENGTH                              0x1
#define _T5GPPS_T5GPPS1_MASK                                0x2
#define _T5GPPS_T5GPPS2_POSN                                0x2
#define _T5GPPS_T5GPPS2_POSITION                            0x2
#define _T5GPPS_T5GPPS2_SIZE                                0x1
#define _T5GPPS_T5GPPS2_LENGTH                              0x1
#define _T5GPPS_T5GPPS2_MASK                                0x4
#define _T5GPPS_T5GPPS3_POSN                                0x3
#define _T5GPPS_T5GPPS3_POSITION                            0x3
#define _T5GPPS_T5GPPS3_SIZE                                0x1
#define _T5GPPS_T5GPPS3_LENGTH                              0x1
#define _T5GPPS_T5GPPS3_MASK                                0x8
#define _T5GPPS_T5GPPS4_POSN                                0x4
#define _T5GPPS_T5GPPS4_POSITION                            0x4
#define _T5GPPS_T5GPPS4_SIZE                                0x1
#define _T5GPPS_T5GPPS4_LENGTH                              0x1
#define _T5GPPS_T5GPPS4_MASK                                0x10

// Register: T6PPS
extern volatile unsigned char           T6PPS               @ 0xE1E;
#ifndef _LIB_BUILD
asm("T6PPS equ 0E1Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned T6PPS0                 :1;
        unsigned T6PPS1                 :1;
        unsigned T6PPS2                 :1;
        unsigned T6PPS3                 :1;
        unsigned T6PPS4                 :1;
    };
} T6PPSbits_t;
extern volatile T6PPSbits_t T6PPSbits @ 0xE1E;
// bitfield macros
#define _T6PPS_T6PPS0_POSN                                  0x0
#define _T6PPS_T6PPS0_POSITION                              0x0
#define _T6PPS_T6PPS0_SIZE                                  0x1
#define _T6PPS_T6PPS0_LENGTH                                0x1
#define _T6PPS_T6PPS0_MASK                                  0x1
#define _T6PPS_T6PPS1_POSN                                  0x1
#define _T6PPS_T6PPS1_POSITION                              0x1
#define _T6PPS_T6PPS1_SIZE                                  0x1
#define _T6PPS_T6PPS1_LENGTH                                0x1
#define _T6PPS_T6PPS1_MASK                                  0x2
#define _T6PPS_T6PPS2_POSN                                  0x2
#define _T6PPS_T6PPS2_POSITION                              0x2
#define _T6PPS_T6PPS2_SIZE                                  0x1
#define _T6PPS_T6PPS2_LENGTH                                0x1
#define _T6PPS_T6PPS2_MASK                                  0x4
#define _T6PPS_T6PPS3_POSN                                  0x3
#define _T6PPS_T6PPS3_POSITION                              0x3
#define _T6PPS_T6PPS3_SIZE                                  0x1
#define _T6PPS_T6PPS3_LENGTH                                0x1
#define _T6PPS_T6PPS3_MASK                                  0x8
#define _T6PPS_T6PPS4_POSN                                  0x4
#define _T6PPS_T6PPS4_POSITION                              0x4
#define _T6PPS_T6PPS4_SIZE                                  0x1
#define _T6PPS_T6PPS4_LENGTH                                0x1
#define _T6PPS_T6PPS4_MASK                                  0x10

// Register: ATCC1PPS
extern volatile unsigned char           ATCC1PPS            @ 0xE1F;
#ifndef _LIB_BUILD
asm("ATCC1PPS equ 0E1Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ATCC1PPS0              :1;
        unsigned ATCC1PPS1              :1;
        unsigned ATCC1PPS2              :1;
        unsigned ATCC1PPS3              :1;
        unsigned ATCC1PPS4              :1;
    };
} ATCC1PPSbits_t;
extern volatile ATCC1PPSbits_t ATCC1PPSbits @ 0xE1F;
// bitfield macros
#define _ATCC1PPS_ATCC1PPS0_POSN                            0x0
#define _ATCC1PPS_ATCC1PPS0_POSITION                        0x0
#define _ATCC1PPS_ATCC1PPS0_SIZE                            0x1
#define _ATCC1PPS_ATCC1PPS0_LENGTH                          0x1
#define _ATCC1PPS_ATCC1PPS0_MASK                            0x1
#define _ATCC1PPS_ATCC1PPS1_POSN                            0x1
#define _ATCC1PPS_ATCC1PPS1_POSITION                        0x1
#define _ATCC1PPS_ATCC1PPS1_SIZE                            0x1
#define _ATCC1PPS_ATCC1PPS1_LENGTH                          0x1
#define _ATCC1PPS_ATCC1PPS1_MASK                            0x2
#define _ATCC1PPS_ATCC1PPS2_POSN                            0x2
#define _ATCC1PPS_ATCC1PPS2_POSITION                        0x2
#define _ATCC1PPS_ATCC1PPS2_SIZE                            0x1
#define _ATCC1PPS_ATCC1PPS2_LENGTH                          0x1
#define _ATCC1PPS_ATCC1PPS2_MASK                            0x4
#define _ATCC1PPS_ATCC1PPS3_POSN                            0x3
#define _ATCC1PPS_ATCC1PPS3_POSITION                        0x3
#define _ATCC1PPS_ATCC1PPS3_SIZE                            0x1
#define _ATCC1PPS_ATCC1PPS3_LENGTH                          0x1
#define _ATCC1PPS_ATCC1PPS3_MASK                            0x8
#define _ATCC1PPS_ATCC1PPS4_POSN                            0x4
#define _ATCC1PPS_ATCC1PPS4_POSITION                        0x4
#define _ATCC1PPS_ATCC1PPS4_SIZE                            0x1
#define _ATCC1PPS_ATCC1PPS4_LENGTH                          0x1
#define _ATCC1PPS_ATCC1PPS4_MASK                            0x10

// Register: SSPCLKPPS
extern volatile unsigned char           SSPCLKPPS           @ 0xE20;
#ifndef _LIB_BUILD
asm("SSPCLKPPS equ 0E20h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SSPCLKPPS0             :1;
        unsigned SSPCLKPPS1             :1;
        unsigned SSPCLKPPS2             :1;
        unsigned SSPCLKPPS3             :1;
        unsigned SSPCLKPPS4             :1;
    };
} SSPCLKPPSbits_t;
extern volatile SSPCLKPPSbits_t SSPCLKPPSbits @ 0xE20;
// bitfield macros
#define _SSPCLKPPS_SSPCLKPPS0_POSN                          0x0
#define _SSPCLKPPS_SSPCLKPPS0_POSITION                      0x0
#define _SSPCLKPPS_SSPCLKPPS0_SIZE                          0x1
#define _SSPCLKPPS_SSPCLKPPS0_LENGTH                        0x1
#define _SSPCLKPPS_SSPCLKPPS0_MASK                          0x1
#define _SSPCLKPPS_SSPCLKPPS1_POSN                          0x1
#define _SSPCLKPPS_SSPCLKPPS1_POSITION                      0x1
#define _SSPCLKPPS_SSPCLKPPS1_SIZE                          0x1
#define _SSPCLKPPS_SSPCLKPPS1_LENGTH                        0x1
#define _SSPCLKPPS_SSPCLKPPS1_MASK                          0x2
#define _SSPCLKPPS_SSPCLKPPS2_POSN                          0x2
#define _SSPCLKPPS_SSPCLKPPS2_POSITION                      0x2
#define _SSPCLKPPS_SSPCLKPPS2_SIZE                          0x1
#define _SSPCLKPPS_SSPCLKPPS2_LENGTH                        0x1
#define _SSPCLKPPS_SSPCLKPPS2_MASK                          0x4
#define _SSPCLKPPS_SSPCLKPPS3_POSN                          0x3
#define _SSPCLKPPS_SSPCLKPPS3_POSITION                      0x3
#define _SSPCLKPPS_SSPCLKPPS3_SIZE                          0x1
#define _SSPCLKPPS_SSPCLKPPS3_LENGTH                        0x1
#define _SSPCLKPPS_SSPCLKPPS3_MASK                          0x8
#define _SSPCLKPPS_SSPCLKPPS4_POSN                          0x4
#define _SSPCLKPPS_SSPCLKPPS4_POSITION                      0x4
#define _SSPCLKPPS_SSPCLKPPS4_SIZE                          0x1
#define _SSPCLKPPS_SSPCLKPPS4_LENGTH                        0x1
#define _SSPCLKPPS_SSPCLKPPS4_MASK                          0x10

// Register: SSPDATPPS
extern volatile unsigned char           SSPDATPPS           @ 0xE21;
#ifndef _LIB_BUILD
asm("SSPDATPPS equ 0E21h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SSPDATPPS0             :1;
        unsigned SSPDATPPS1             :1;
        unsigned SSPDATPPS2             :1;
        unsigned SSPDATPPS3             :1;
        unsigned SSPDATPPS4             :1;
    };
} SSPDATPPSbits_t;
extern volatile SSPDATPPSbits_t SSPDATPPSbits @ 0xE21;
// bitfield macros
#define _SSPDATPPS_SSPDATPPS0_POSN                          0x0
#define _SSPDATPPS_SSPDATPPS0_POSITION                      0x0
#define _SSPDATPPS_SSPDATPPS0_SIZE                          0x1
#define _SSPDATPPS_SSPDATPPS0_LENGTH                        0x1
#define _SSPDATPPS_SSPDATPPS0_MASK                          0x1
#define _SSPDATPPS_SSPDATPPS1_POSN                          0x1
#define _SSPDATPPS_SSPDATPPS1_POSITION                      0x1
#define _SSPDATPPS_SSPDATPPS1_SIZE                          0x1
#define _SSPDATPPS_SSPDATPPS1_LENGTH                        0x1
#define _SSPDATPPS_SSPDATPPS1_MASK                          0x2
#define _SSPDATPPS_SSPDATPPS2_POSN                          0x2
#define _SSPDATPPS_SSPDATPPS2_POSITION                      0x2
#define _SSPDATPPS_SSPDATPPS2_SIZE                          0x1
#define _SSPDATPPS_SSPDATPPS2_LENGTH                        0x1
#define _SSPDATPPS_SSPDATPPS2_MASK                          0x4
#define _SSPDATPPS_SSPDATPPS3_POSN                          0x3
#define _SSPDATPPS_SSPDATPPS3_POSITION                      0x3
#define _SSPDATPPS_SSPDATPPS3_SIZE                          0x1
#define _SSPDATPPS_SSPDATPPS3_LENGTH                        0x1
#define _SSPDATPPS_SSPDATPPS3_MASK                          0x8
#define _SSPDATPPS_SSPDATPPS4_POSN                          0x4
#define _SSPDATPPS_SSPDATPPS4_POSITION                      0x4
#define _SSPDATPPS_SSPDATPPS4_SIZE                          0x1
#define _SSPDATPPS_SSPDATPPS4_LENGTH                        0x1
#define _SSPDATPPS_SSPDATPPS4_MASK                          0x10

// Register: SSPSSPPS
extern volatile unsigned char           SSPSSPPS            @ 0xE22;
#ifndef _LIB_BUILD
asm("SSPSSPPS equ 0E22h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SSPSSPPS0              :1;
        unsigned SSPSSPPS1              :1;
        unsigned SSPSSPPS2              :1;
        unsigned SSPSSPPS3              :1;
        unsigned SSPSSPPS4              :1;
    };
} SSPSSPPSbits_t;
extern volatile SSPSSPPSbits_t SSPSSPPSbits @ 0xE22;
// bitfield macros
#define _SSPSSPPS_SSPSSPPS0_POSN                            0x0
#define _SSPSSPPS_SSPSSPPS0_POSITION                        0x0
#define _SSPSSPPS_SSPSSPPS0_SIZE                            0x1
#define _SSPSSPPS_SSPSSPPS0_LENGTH                          0x1
#define _SSPSSPPS_SSPSSPPS0_MASK                            0x1
#define _SSPSSPPS_SSPSSPPS1_POSN                            0x1
#define _SSPSSPPS_SSPSSPPS1_POSITION                        0x1
#define _SSPSSPPS_SSPSSPPS1_SIZE                            0x1
#define _SSPSSPPS_SSPSSPPS1_LENGTH                          0x1
#define _SSPSSPPS_SSPSSPPS1_MASK                            0x2
#define _SSPSSPPS_SSPSSPPS2_POSN                            0x2
#define _SSPSSPPS_SSPSSPPS2_POSITION                        0x2
#define _SSPSSPPS_SSPSSPPS2_SIZE                            0x1
#define _SSPSSPPS_SSPSSPPS2_LENGTH                          0x1
#define _SSPSSPPS_SSPSSPPS2_MASK                            0x4
#define _SSPSSPPS_SSPSSPPS3_POSN                            0x3
#define _SSPSSPPS_SSPSSPPS3_POSITION                        0x3
#define _SSPSSPPS_SSPSSPPS3_SIZE                            0x1
#define _SSPSSPPS_SSPSSPPS3_LENGTH                          0x1
#define _SSPSSPPS_SSPSSPPS3_MASK                            0x8
#define _SSPSSPPS_SSPSSPPS4_POSN                            0x4
#define _SSPSSPPS_SSPSSPPS4_POSITION                        0x4
#define _SSPSSPPS_SSPSSPPS4_SIZE                            0x1
#define _SSPSSPPS_SSPSSPPS4_LENGTH                          0x1
#define _SSPSSPPS_SSPSSPPS4_MASK                            0x10

// Register: ATCC2PPS
extern volatile unsigned char           ATCC2PPS            @ 0xE23;
#ifndef _LIB_BUILD
asm("ATCC2PPS equ 0E23h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ATCC2PPS0              :1;
        unsigned ATCC2PPS1              :1;
        unsigned ATCC2PPS2              :1;
        unsigned ATCC2PPS3              :1;
        unsigned ATCC2PPS4              :1;
    };
} ATCC2PPSbits_t;
extern volatile ATCC2PPSbits_t ATCC2PPSbits @ 0xE23;
// bitfield macros
#define _ATCC2PPS_ATCC2PPS0_POSN                            0x0
#define _ATCC2PPS_ATCC2PPS0_POSITION                        0x0
#define _ATCC2PPS_ATCC2PPS0_SIZE                            0x1
#define _ATCC2PPS_ATCC2PPS0_LENGTH                          0x1
#define _ATCC2PPS_ATCC2PPS0_MASK                            0x1
#define _ATCC2PPS_ATCC2PPS1_POSN                            0x1
#define _ATCC2PPS_ATCC2PPS1_POSITION                        0x1
#define _ATCC2PPS_ATCC2PPS1_SIZE                            0x1
#define _ATCC2PPS_ATCC2PPS1_LENGTH                          0x1
#define _ATCC2PPS_ATCC2PPS1_MASK                            0x2
#define _ATCC2PPS_ATCC2PPS2_POSN                            0x2
#define _ATCC2PPS_ATCC2PPS2_POSITION                        0x2
#define _ATCC2PPS_ATCC2PPS2_SIZE                            0x1
#define _ATCC2PPS_ATCC2PPS2_LENGTH                          0x1
#define _ATCC2PPS_ATCC2PPS2_MASK                            0x4
#define _ATCC2PPS_ATCC2PPS3_POSN                            0x3
#define _ATCC2PPS_ATCC2PPS3_POSITION                        0x3
#define _ATCC2PPS_ATCC2PPS3_SIZE                            0x1
#define _ATCC2PPS_ATCC2PPS3_LENGTH                          0x1
#define _ATCC2PPS_ATCC2PPS3_MASK                            0x8
#define _ATCC2PPS_ATCC2PPS4_POSN                            0x4
#define _ATCC2PPS_ATCC2PPS4_POSITION                        0x4
#define _ATCC2PPS_ATCC2PPS4_SIZE                            0x1
#define _ATCC2PPS_ATCC2PPS4_LENGTH                          0x1
#define _ATCC2PPS_ATCC2PPS4_MASK                            0x10

// Register: RXPPS
extern volatile unsigned char           RXPPS               @ 0xE24;
#ifndef _LIB_BUILD
asm("RXPPS equ 0E24h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RXPPS0                 :1;
        unsigned RXPPS1                 :1;
        unsigned RXPPS2                 :1;
        unsigned RXPPS3                 :1;
        unsigned RXPPS4                 :1;
    };
} RXPPSbits_t;
extern volatile RXPPSbits_t RXPPSbits @ 0xE24;
// bitfield macros
#define _RXPPS_RXPPS0_POSN                                  0x0
#define _RXPPS_RXPPS0_POSITION                              0x0
#define _RXPPS_RXPPS0_SIZE                                  0x1
#define _RXPPS_RXPPS0_LENGTH                                0x1
#define _RXPPS_RXPPS0_MASK                                  0x1
#define _RXPPS_RXPPS1_POSN                                  0x1
#define _RXPPS_RXPPS1_POSITION                              0x1
#define _RXPPS_RXPPS1_SIZE                                  0x1
#define _RXPPS_RXPPS1_LENGTH                                0x1
#define _RXPPS_RXPPS1_MASK                                  0x2
#define _RXPPS_RXPPS2_POSN                                  0x2
#define _RXPPS_RXPPS2_POSITION                              0x2
#define _RXPPS_RXPPS2_SIZE                                  0x1
#define _RXPPS_RXPPS2_LENGTH                                0x1
#define _RXPPS_RXPPS2_MASK                                  0x4
#define _RXPPS_RXPPS3_POSN                                  0x3
#define _RXPPS_RXPPS3_POSITION                              0x3
#define _RXPPS_RXPPS3_SIZE                                  0x1
#define _RXPPS_RXPPS3_LENGTH                                0x1
#define _RXPPS_RXPPS3_MASK                                  0x8
#define _RXPPS_RXPPS4_POSN                                  0x4
#define _RXPPS_RXPPS4_POSITION                              0x4
#define _RXPPS_RXPPS4_SIZE                                  0x1
#define _RXPPS_RXPPS4_LENGTH                                0x1
#define _RXPPS_RXPPS4_MASK                                  0x10

// Register: CKPPS
extern volatile unsigned char           CKPPS               @ 0xE25;
#ifndef _LIB_BUILD
asm("CKPPS equ 0E25h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CKPPS0                 :1;
        unsigned CKPPS1                 :1;
        unsigned CKPPS2                 :1;
        unsigned CKPPS3                 :1;
        unsigned CKPPS4                 :1;
    };
} CKPPSbits_t;
extern volatile CKPPSbits_t CKPPSbits @ 0xE25;
// bitfield macros
#define _CKPPS_CKPPS0_POSN                                  0x0
#define _CKPPS_CKPPS0_POSITION                              0x0
#define _CKPPS_CKPPS0_SIZE                                  0x1
#define _CKPPS_CKPPS0_LENGTH                                0x1
#define _CKPPS_CKPPS0_MASK                                  0x1
#define _CKPPS_CKPPS1_POSN                                  0x1
#define _CKPPS_CKPPS1_POSITION                              0x1
#define _CKPPS_CKPPS1_SIZE                                  0x1
#define _CKPPS_CKPPS1_LENGTH                                0x1
#define _CKPPS_CKPPS1_MASK                                  0x2
#define _CKPPS_CKPPS2_POSN                                  0x2
#define _CKPPS_CKPPS2_POSITION                              0x2
#define _CKPPS_CKPPS2_SIZE                                  0x1
#define _CKPPS_CKPPS2_LENGTH                                0x1
#define _CKPPS_CKPPS2_MASK                                  0x4
#define _CKPPS_CKPPS3_POSN                                  0x3
#define _CKPPS_CKPPS3_POSITION                              0x3
#define _CKPPS_CKPPS3_SIZE                                  0x1
#define _CKPPS_CKPPS3_LENGTH                                0x1
#define _CKPPS_CKPPS3_MASK                                  0x8
#define _CKPPS_CKPPS4_POSN                                  0x4
#define _CKPPS_CKPPS4_POSITION                              0x4
#define _CKPPS_CKPPS4_SIZE                                  0x1
#define _CKPPS_CKPPS4_LENGTH                                0x1
#define _CKPPS_CKPPS4_MASK                                  0x10

// Register: SMT1SIGPPS
extern volatile unsigned char           SMT1SIGPPS          @ 0xE26;
#ifndef _LIB_BUILD
asm("SMT1SIGPPS equ 0E26h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT1SIGPPS0            :1;
        unsigned SMT1SIGPPS1            :1;
        unsigned SMT1SIGPPS2            :1;
        unsigned SMT1SIGPPS3            :1;
        unsigned SMT1SIGPPS4            :1;
    };
} SMT1SIGPPSbits_t;
extern volatile SMT1SIGPPSbits_t SMT1SIGPPSbits @ 0xE26;
// bitfield macros
#define _SMT1SIGPPS_SMT1SIGPPS0_POSN                        0x0
#define _SMT1SIGPPS_SMT1SIGPPS0_POSITION                    0x0
#define _SMT1SIGPPS_SMT1SIGPPS0_SIZE                        0x1
#define _SMT1SIGPPS_SMT1SIGPPS0_LENGTH                      0x1
#define _SMT1SIGPPS_SMT1SIGPPS0_MASK                        0x1
#define _SMT1SIGPPS_SMT1SIGPPS1_POSN                        0x1
#define _SMT1SIGPPS_SMT1SIGPPS1_POSITION                    0x1
#define _SMT1SIGPPS_SMT1SIGPPS1_SIZE                        0x1
#define _SMT1SIGPPS_SMT1SIGPPS1_LENGTH                      0x1
#define _SMT1SIGPPS_SMT1SIGPPS1_MASK                        0x2
#define _SMT1SIGPPS_SMT1SIGPPS2_POSN                        0x2
#define _SMT1SIGPPS_SMT1SIGPPS2_POSITION                    0x2
#define _SMT1SIGPPS_SMT1SIGPPS2_SIZE                        0x1
#define _SMT1SIGPPS_SMT1SIGPPS2_LENGTH                      0x1
#define _SMT1SIGPPS_SMT1SIGPPS2_MASK                        0x4
#define _SMT1SIGPPS_SMT1SIGPPS3_POSN                        0x3
#define _SMT1SIGPPS_SMT1SIGPPS3_POSITION                    0x3
#define _SMT1SIGPPS_SMT1SIGPPS3_SIZE                        0x1
#define _SMT1SIGPPS_SMT1SIGPPS3_LENGTH                      0x1
#define _SMT1SIGPPS_SMT1SIGPPS3_MASK                        0x8
#define _SMT1SIGPPS_SMT1SIGPPS4_POSN                        0x4
#define _SMT1SIGPPS_SMT1SIGPPS4_POSITION                    0x4
#define _SMT1SIGPPS_SMT1SIGPPS4_SIZE                        0x1
#define _SMT1SIGPPS_SMT1SIGPPS4_LENGTH                      0x1
#define _SMT1SIGPPS_SMT1SIGPPS4_MASK                        0x10

// Register: SMT1WINPPS
extern volatile unsigned char           SMT1WINPPS          @ 0xE27;
#ifndef _LIB_BUILD
asm("SMT1WINPPS equ 0E27h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMTWINPPS0             :1;
        unsigned SMTWINPPS1             :1;
        unsigned SMTWINPPS2             :1;
        unsigned SMTWINPPS3             :1;
        unsigned SMTWINPPS4             :1;
    };
} SMT1WINPPSbits_t;
extern volatile SMT1WINPPSbits_t SMT1WINPPSbits @ 0xE27;
// bitfield macros
#define _SMT1WINPPS_SMTWINPPS0_POSN                         0x0
#define _SMT1WINPPS_SMTWINPPS0_POSITION                     0x0
#define _SMT1WINPPS_SMTWINPPS0_SIZE                         0x1
#define _SMT1WINPPS_SMTWINPPS0_LENGTH                       0x1
#define _SMT1WINPPS_SMTWINPPS0_MASK                         0x1
#define _SMT1WINPPS_SMTWINPPS1_POSN                         0x1
#define _SMT1WINPPS_SMTWINPPS1_POSITION                     0x1
#define _SMT1WINPPS_SMTWINPPS1_SIZE                         0x1
#define _SMT1WINPPS_SMTWINPPS1_LENGTH                       0x1
#define _SMT1WINPPS_SMTWINPPS1_MASK                         0x2
#define _SMT1WINPPS_SMTWINPPS2_POSN                         0x2
#define _SMT1WINPPS_SMTWINPPS2_POSITION                     0x2
#define _SMT1WINPPS_SMTWINPPS2_SIZE                         0x1
#define _SMT1WINPPS_SMTWINPPS2_LENGTH                       0x1
#define _SMT1WINPPS_SMTWINPPS2_MASK                         0x4
#define _SMT1WINPPS_SMTWINPPS3_POSN                         0x3
#define _SMT1WINPPS_SMTWINPPS3_POSITION                     0x3
#define _SMT1WINPPS_SMTWINPPS3_SIZE                         0x1
#define _SMT1WINPPS_SMTWINPPS3_LENGTH                       0x1
#define _SMT1WINPPS_SMTWINPPS3_MASK                         0x8
#define _SMT1WINPPS_SMTWINPPS4_POSN                         0x4
#define _SMT1WINPPS_SMTWINPPS4_POSITION                     0x4
#define _SMT1WINPPS_SMTWINPPS4_SIZE                         0x1
#define _SMT1WINPPS_SMTWINPPS4_LENGTH                       0x1
#define _SMT1WINPPS_SMTWINPPS4_MASK                         0x10

// Register: CLCIN0PPS
extern volatile unsigned char           CLCIN0PPS           @ 0xE28;
#ifndef _LIB_BUILD
asm("CLCIN0PPS equ 0E28h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CLCIN0PPS0             :1;
        unsigned CLCIN0PPS1             :1;
        unsigned CLCIN0PPS2             :1;
        unsigned CLCIN0PPS3             :1;
        unsigned CLCIN0PPS4             :1;
    };
} CLCIN0PPSbits_t;
extern volatile CLCIN0PPSbits_t CLCIN0PPSbits @ 0xE28;
// bitfield macros
#define _CLCIN0PPS_CLCIN0PPS0_POSN                          0x0
#define _CLCIN0PPS_CLCIN0PPS0_POSITION                      0x0
#define _CLCIN0PPS_CLCIN0PPS0_SIZE                          0x1
#define _CLCIN0PPS_CLCIN0PPS0_LENGTH                        0x1
#define _CLCIN0PPS_CLCIN0PPS0_MASK                          0x1
#define _CLCIN0PPS_CLCIN0PPS1_POSN                          0x1
#define _CLCIN0PPS_CLCIN0PPS1_POSITION                      0x1
#define _CLCIN0PPS_CLCIN0PPS1_SIZE                          0x1
#define _CLCIN0PPS_CLCIN0PPS1_LENGTH                        0x1
#define _CLCIN0PPS_CLCIN0PPS1_MASK                          0x2
#define _CLCIN0PPS_CLCIN0PPS2_POSN                          0x2
#define _CLCIN0PPS_CLCIN0PPS2_POSITION                      0x2
#define _CLCIN0PPS_CLCIN0PPS2_SIZE                          0x1
#define _CLCIN0PPS_CLCIN0PPS2_LENGTH                        0x1
#define _CLCIN0PPS_CLCIN0PPS2_MASK                          0x4
#define _CLCIN0PPS_CLCIN0PPS3_POSN                          0x3
#define _CLCIN0PPS_CLCIN0PPS3_POSITION                      0x3
#define _CLCIN0PPS_CLCIN0PPS3_SIZE                          0x1
#define _CLCIN0PPS_CLCIN0PPS3_LENGTH                        0x1
#define _CLCIN0PPS_CLCIN0PPS3_MASK                          0x8
#define _CLCIN0PPS_CLCIN0PPS4_POSN                          0x4
#define _CLCIN0PPS_CLCIN0PPS4_POSITION                      0x4
#define _CLCIN0PPS_CLCIN0PPS4_SIZE                          0x1
#define _CLCIN0PPS_CLCIN0PPS4_LENGTH                        0x1
#define _CLCIN0PPS_CLCIN0PPS4_MASK                          0x10

// Register: CLCIN1PPS
extern volatile unsigned char           CLCIN1PPS           @ 0xE29;
#ifndef _LIB_BUILD
asm("CLCIN1PPS equ 0E29h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CLCIN1PPS0             :1;
        unsigned CLCIN1PPS1             :1;
        unsigned CLCIN1PPS2             :1;
        unsigned CLCIN1PPS3             :1;
        unsigned CLCIN1PPS4             :1;
    };
} CLCIN1PPSbits_t;
extern volatile CLCIN1PPSbits_t CLCIN1PPSbits @ 0xE29;
// bitfield macros
#define _CLCIN1PPS_CLCIN1PPS0_POSN                          0x0
#define _CLCIN1PPS_CLCIN1PPS0_POSITION                      0x0
#define _CLCIN1PPS_CLCIN1PPS0_SIZE                          0x1
#define _CLCIN1PPS_CLCIN1PPS0_LENGTH                        0x1
#define _CLCIN1PPS_CLCIN1PPS0_MASK                          0x1
#define _CLCIN1PPS_CLCIN1PPS1_POSN                          0x1
#define _CLCIN1PPS_CLCIN1PPS1_POSITION                      0x1
#define _CLCIN1PPS_CLCIN1PPS1_SIZE                          0x1
#define _CLCIN1PPS_CLCIN1PPS1_LENGTH                        0x1
#define _CLCIN1PPS_CLCIN1PPS1_MASK                          0x2
#define _CLCIN1PPS_CLCIN1PPS2_POSN                          0x2
#define _CLCIN1PPS_CLCIN1PPS2_POSITION                      0x2
#define _CLCIN1PPS_CLCIN1PPS2_SIZE                          0x1
#define _CLCIN1PPS_CLCIN1PPS2_LENGTH                        0x1
#define _CLCIN1PPS_CLCIN1PPS2_MASK                          0x4
#define _CLCIN1PPS_CLCIN1PPS3_POSN                          0x3
#define _CLCIN1PPS_CLCIN1PPS3_POSITION                      0x3
#define _CLCIN1PPS_CLCIN1PPS3_SIZE                          0x1
#define _CLCIN1PPS_CLCIN1PPS3_LENGTH                        0x1
#define _CLCIN1PPS_CLCIN1PPS3_MASK                          0x8
#define _CLCIN1PPS_CLCIN1PPS4_POSN                          0x4
#define _CLCIN1PPS_CLCIN1PPS4_POSITION                      0x4
#define _CLCIN1PPS_CLCIN1PPS4_SIZE                          0x1
#define _CLCIN1PPS_CLCIN1PPS4_LENGTH                        0x1
#define _CLCIN1PPS_CLCIN1PPS4_MASK                          0x10

// Register: CLCIN2PPS
extern volatile unsigned char           CLCIN2PPS           @ 0xE2A;
#ifndef _LIB_BUILD
asm("CLCIN2PPS equ 0E2Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CLCIN2PPS0             :1;
        unsigned CLCIN2PPS1             :1;
        unsigned CLCIN2PPS2             :1;
        unsigned CLCIN2PPS3             :1;
        unsigned CLCIN2PPS4             :1;
    };
} CLCIN2PPSbits_t;
extern volatile CLCIN2PPSbits_t CLCIN2PPSbits @ 0xE2A;
// bitfield macros
#define _CLCIN2PPS_CLCIN2PPS0_POSN                          0x0
#define _CLCIN2PPS_CLCIN2PPS0_POSITION                      0x0
#define _CLCIN2PPS_CLCIN2PPS0_SIZE                          0x1
#define _CLCIN2PPS_CLCIN2PPS0_LENGTH                        0x1
#define _CLCIN2PPS_CLCIN2PPS0_MASK                          0x1
#define _CLCIN2PPS_CLCIN2PPS1_POSN                          0x1
#define _CLCIN2PPS_CLCIN2PPS1_POSITION                      0x1
#define _CLCIN2PPS_CLCIN2PPS1_SIZE                          0x1
#define _CLCIN2PPS_CLCIN2PPS1_LENGTH                        0x1
#define _CLCIN2PPS_CLCIN2PPS1_MASK                          0x2
#define _CLCIN2PPS_CLCIN2PPS2_POSN                          0x2
#define _CLCIN2PPS_CLCIN2PPS2_POSITION                      0x2
#define _CLCIN2PPS_CLCIN2PPS2_SIZE                          0x1
#define _CLCIN2PPS_CLCIN2PPS2_LENGTH                        0x1
#define _CLCIN2PPS_CLCIN2PPS2_MASK                          0x4
#define _CLCIN2PPS_CLCIN2PPS3_POSN                          0x3
#define _CLCIN2PPS_CLCIN2PPS3_POSITION                      0x3
#define _CLCIN2PPS_CLCIN2PPS3_SIZE                          0x1
#define _CLCIN2PPS_CLCIN2PPS3_LENGTH                        0x1
#define _CLCIN2PPS_CLCIN2PPS3_MASK                          0x8
#define _CLCIN2PPS_CLCIN2PPS4_POSN                          0x4
#define _CLCIN2PPS_CLCIN2PPS4_POSITION                      0x4
#define _CLCIN2PPS_CLCIN2PPS4_SIZE                          0x1
#define _CLCIN2PPS_CLCIN2PPS4_LENGTH                        0x1
#define _CLCIN2PPS_CLCIN2PPS4_MASK                          0x10

// Register: CLCIN3PPS
extern volatile unsigned char           CLCIN3PPS           @ 0xE2B;
#ifndef _LIB_BUILD
asm("CLCIN3PPS equ 0E2Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned CLCIN3PPS0             :1;
        unsigned CLCIN3PPS1             :1;
        unsigned CLCIN3PPS2             :1;
        unsigned CLCIN3PPS3             :1;
        unsigned CLCIN3PPS4             :1;
    };
} CLCIN3PPSbits_t;
extern volatile CLCIN3PPSbits_t CLCIN3PPSbits @ 0xE2B;
// bitfield macros
#define _CLCIN3PPS_CLCIN3PPS0_POSN                          0x0
#define _CLCIN3PPS_CLCIN3PPS0_POSITION                      0x0
#define _CLCIN3PPS_CLCIN3PPS0_SIZE                          0x1
#define _CLCIN3PPS_CLCIN3PPS0_LENGTH                        0x1
#define _CLCIN3PPS_CLCIN3PPS0_MASK                          0x1
#define _CLCIN3PPS_CLCIN3PPS1_POSN                          0x1
#define _CLCIN3PPS_CLCIN3PPS1_POSITION                      0x1
#define _CLCIN3PPS_CLCIN3PPS1_SIZE                          0x1
#define _CLCIN3PPS_CLCIN3PPS1_LENGTH                        0x1
#define _CLCIN3PPS_CLCIN3PPS1_MASK                          0x2
#define _CLCIN3PPS_CLCIN3PPS2_POSN                          0x2
#define _CLCIN3PPS_CLCIN3PPS2_POSITION                      0x2
#define _CLCIN3PPS_CLCIN3PPS2_SIZE                          0x1
#define _CLCIN3PPS_CLCIN3PPS2_LENGTH                        0x1
#define _CLCIN3PPS_CLCIN3PPS2_MASK                          0x4
#define _CLCIN3PPS_CLCIN3PPS3_POSN                          0x3
#define _CLCIN3PPS_CLCIN3PPS3_POSITION                      0x3
#define _CLCIN3PPS_CLCIN3PPS3_SIZE                          0x1
#define _CLCIN3PPS_CLCIN3PPS3_LENGTH                        0x1
#define _CLCIN3PPS_CLCIN3PPS3_MASK                          0x8
#define _CLCIN3PPS_CLCIN3PPS4_POSN                          0x4
#define _CLCIN3PPS_CLCIN3PPS4_POSITION                      0x4
#define _CLCIN3PPS_CLCIN3PPS4_SIZE                          0x1
#define _CLCIN3PPS_CLCIN3PPS4_LENGTH                        0x1
#define _CLCIN3PPS_CLCIN3PPS4_MASK                          0x10

// Register: SMT2SIGPPS
extern volatile unsigned char           SMT2SIGPPS          @ 0xE2C;
#ifndef _LIB_BUILD
asm("SMT2SIGPPS equ 0E2Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2SIGPPS0            :1;
        unsigned SMT2SIGPPS1            :1;
        unsigned SMT2SIGPPS2            :1;
        unsigned SMT2SIGPPS3            :1;
        unsigned SMT2SIGPPS4            :1;
    };
} SMT2SIGPPSbits_t;
extern volatile SMT2SIGPPSbits_t SMT2SIGPPSbits @ 0xE2C;
// bitfield macros
#define _SMT2SIGPPS_SMT2SIGPPS0_POSN                        0x0
#define _SMT2SIGPPS_SMT2SIGPPS0_POSITION                    0x0
#define _SMT2SIGPPS_SMT2SIGPPS0_SIZE                        0x1
#define _SMT2SIGPPS_SMT2SIGPPS0_LENGTH                      0x1
#define _SMT2SIGPPS_SMT2SIGPPS0_MASK                        0x1
#define _SMT2SIGPPS_SMT2SIGPPS1_POSN                        0x1
#define _SMT2SIGPPS_SMT2SIGPPS1_POSITION                    0x1
#define _SMT2SIGPPS_SMT2SIGPPS1_SIZE                        0x1
#define _SMT2SIGPPS_SMT2SIGPPS1_LENGTH                      0x1
#define _SMT2SIGPPS_SMT2SIGPPS1_MASK                        0x2
#define _SMT2SIGPPS_SMT2SIGPPS2_POSN                        0x2
#define _SMT2SIGPPS_SMT2SIGPPS2_POSITION                    0x2
#define _SMT2SIGPPS_SMT2SIGPPS2_SIZE                        0x1
#define _SMT2SIGPPS_SMT2SIGPPS2_LENGTH                      0x1
#define _SMT2SIGPPS_SMT2SIGPPS2_MASK                        0x4
#define _SMT2SIGPPS_SMT2SIGPPS3_POSN                        0x3
#define _SMT2SIGPPS_SMT2SIGPPS3_POSITION                    0x3
#define _SMT2SIGPPS_SMT2SIGPPS3_SIZE                        0x1
#define _SMT2SIGPPS_SMT2SIGPPS3_LENGTH                      0x1
#define _SMT2SIGPPS_SMT2SIGPPS3_MASK                        0x8
#define _SMT2SIGPPS_SMT2SIGPPS4_POSN                        0x4
#define _SMT2SIGPPS_SMT2SIGPPS4_POSITION                    0x4
#define _SMT2SIGPPS_SMT2SIGPPS4_SIZE                        0x1
#define _SMT2SIGPPS_SMT2SIGPPS4_LENGTH                      0x1
#define _SMT2SIGPPS_SMT2SIGPPS4_MASK                        0x10

// Register: SMT2WINPPS
extern volatile unsigned char           SMT2WINPPS          @ 0xE2D;
#ifndef _LIB_BUILD
asm("SMT2WINPPS equ 0E2Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned SMT2WINPPS0            :1;
        unsigned SMT2WINPPS1            :1;
        unsigned SMT2WINPPS2            :1;
        unsigned SMT2WINPPS3            :1;
        unsigned SMT2WINPPS4            :1;
    };
} SMT2WINPPSbits_t;
extern volatile SMT2WINPPSbits_t SMT2WINPPSbits @ 0xE2D;
// bitfield macros
#define _SMT2WINPPS_SMT2WINPPS0_POSN                        0x0
#define _SMT2WINPPS_SMT2WINPPS0_POSITION                    0x0
#define _SMT2WINPPS_SMT2WINPPS0_SIZE                        0x1
#define _SMT2WINPPS_SMT2WINPPS0_LENGTH                      0x1
#define _SMT2WINPPS_SMT2WINPPS0_MASK                        0x1
#define _SMT2WINPPS_SMT2WINPPS1_POSN                        0x1
#define _SMT2WINPPS_SMT2WINPPS1_POSITION                    0x1
#define _SMT2WINPPS_SMT2WINPPS1_SIZE                        0x1
#define _SMT2WINPPS_SMT2WINPPS1_LENGTH                      0x1
#define _SMT2WINPPS_SMT2WINPPS1_MASK                        0x2
#define _SMT2WINPPS_SMT2WINPPS2_POSN                        0x2
#define _SMT2WINPPS_SMT2WINPPS2_POSITION                    0x2
#define _SMT2WINPPS_SMT2WINPPS2_SIZE                        0x1
#define _SMT2WINPPS_SMT2WINPPS2_LENGTH                      0x1
#define _SMT2WINPPS_SMT2WINPPS2_MASK                        0x4
#define _SMT2WINPPS_SMT2WINPPS3_POSN                        0x3
#define _SMT2WINPPS_SMT2WINPPS3_POSITION                    0x3
#define _SMT2WINPPS_SMT2WINPPS3_SIZE                        0x1
#define _SMT2WINPPS_SMT2WINPPS3_LENGTH                      0x1
#define _SMT2WINPPS_SMT2WINPPS3_MASK                        0x8
#define _SMT2WINPPS_SMT2WINPPS4_POSN                        0x4
#define _SMT2WINPPS_SMT2WINPPS4_POSITION                    0x4
#define _SMT2WINPPS_SMT2WINPPS4_SIZE                        0x1
#define _SMT2WINPPS_SMT2WINPPS4_LENGTH                      0x1
#define _SMT2WINPPS_SMT2WINPPS4_MASK                        0x10

// Register: ATCC3PPS
extern volatile unsigned char           ATCC3PPS            @ 0xE2E;
#ifndef _LIB_BUILD
asm("ATCC3PPS equ 0E2Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned ATCC3PPS0              :1;
        unsigned ATCC3PPS1              :1;
        unsigned ATCC3PPS2              :1;
        unsigned ATCC3PPS3              :1;
        unsigned ATCC3PPS4              :1;
    };
} ATCC3PPSbits_t;
extern volatile ATCC3PPSbits_t ATCC3PPSbits @ 0xE2E;
// bitfield macros
#define _ATCC3PPS_ATCC3PPS0_POSN                            0x0
#define _ATCC3PPS_ATCC3PPS0_POSITION                        0x0
#define _ATCC3PPS_ATCC3PPS0_SIZE                            0x1
#define _ATCC3PPS_ATCC3PPS0_LENGTH                          0x1
#define _ATCC3PPS_ATCC3PPS0_MASK                            0x1
#define _ATCC3PPS_ATCC3PPS1_POSN                            0x1
#define _ATCC3PPS_ATCC3PPS1_POSITION                        0x1
#define _ATCC3PPS_ATCC3PPS1_SIZE                            0x1
#define _ATCC3PPS_ATCC3PPS1_LENGTH                          0x1
#define _ATCC3PPS_ATCC3PPS1_MASK                            0x2
#define _ATCC3PPS_ATCC3PPS2_POSN                            0x2
#define _ATCC3PPS_ATCC3PPS2_POSITION                        0x2
#define _ATCC3PPS_ATCC3PPS2_SIZE                            0x1
#define _ATCC3PPS_ATCC3PPS2_LENGTH                          0x1
#define _ATCC3PPS_ATCC3PPS2_MASK                            0x4
#define _ATCC3PPS_ATCC3PPS3_POSN                            0x3
#define _ATCC3PPS_ATCC3PPS3_POSITION                        0x3
#define _ATCC3PPS_ATCC3PPS3_SIZE                            0x1
#define _ATCC3PPS_ATCC3PPS3_LENGTH                          0x1
#define _ATCC3PPS_ATCC3PPS3_MASK                            0x8
#define _ATCC3PPS_ATCC3PPS4_POSN                            0x4
#define _ATCC3PPS_ATCC3PPS4_POSITION                        0x4
#define _ATCC3PPS_ATCC3PPS4_SIZE                            0x1
#define _ATCC3PPS_ATCC3PPS4_LENGTH                          0x1
#define _ATCC3PPS_ATCC3PPS4_MASK                            0x10

// Register: RA0PPS
extern volatile unsigned char           RA0PPS              @ 0xE90;
#ifndef _LIB_BUILD
asm("RA0PPS equ 0E90h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RA0PPS0                :1;
        unsigned RA0PPS1                :1;
        unsigned RA0PPS2                :1;
        unsigned RA0PPS3                :1;
        unsigned RA0PPS4                :1;
    };
} RA0PPSbits_t;
extern volatile RA0PPSbits_t RA0PPSbits @ 0xE90;
// bitfield macros
#define _RA0PPS_RA0PPS0_POSN                                0x0
#define _RA0PPS_RA0PPS0_POSITION                            0x0
#define _RA0PPS_RA0PPS0_SIZE                                0x1
#define _RA0PPS_RA0PPS0_LENGTH                              0x1
#define _RA0PPS_RA0PPS0_MASK                                0x1
#define _RA0PPS_RA0PPS1_POSN                                0x1
#define _RA0PPS_RA0PPS1_POSITION                            0x1
#define _RA0PPS_RA0PPS1_SIZE                                0x1
#define _RA0PPS_RA0PPS1_LENGTH                              0x1
#define _RA0PPS_RA0PPS1_MASK                                0x2
#define _RA0PPS_RA0PPS2_POSN                                0x2
#define _RA0PPS_RA0PPS2_POSITION                            0x2
#define _RA0PPS_RA0PPS2_SIZE                                0x1
#define _RA0PPS_RA0PPS2_LENGTH                              0x1
#define _RA0PPS_RA0PPS2_MASK                                0x4
#define _RA0PPS_RA0PPS3_POSN                                0x3
#define _RA0PPS_RA0PPS3_POSITION                            0x3
#define _RA0PPS_RA0PPS3_SIZE                                0x1
#define _RA0PPS_RA0PPS3_LENGTH                              0x1
#define _RA0PPS_RA0PPS3_MASK                                0x8
#define _RA0PPS_RA0PPS4_POSN                                0x4
#define _RA0PPS_RA0PPS4_POSITION                            0x4
#define _RA0PPS_RA0PPS4_SIZE                                0x1
#define _RA0PPS_RA0PPS4_LENGTH                              0x1
#define _RA0PPS_RA0PPS4_MASK                                0x10

// Register: RA1PPS
extern volatile unsigned char           RA1PPS              @ 0xE91;
#ifndef _LIB_BUILD
asm("RA1PPS equ 0E91h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RA1PPS0                :1;
        unsigned RA1PPS1                :1;
        unsigned RA1PPS2                :1;
        unsigned RA1PPS3                :1;
        unsigned RA1PPS4                :1;
    };
} RA1PPSbits_t;
extern volatile RA1PPSbits_t RA1PPSbits @ 0xE91;
// bitfield macros
#define _RA1PPS_RA1PPS0_POSN                                0x0
#define _RA1PPS_RA1PPS0_POSITION                            0x0
#define _RA1PPS_RA1PPS0_SIZE                                0x1
#define _RA1PPS_RA1PPS0_LENGTH                              0x1
#define _RA1PPS_RA1PPS0_MASK                                0x1
#define _RA1PPS_RA1PPS1_POSN                                0x1
#define _RA1PPS_RA1PPS1_POSITION                            0x1
#define _RA1PPS_RA1PPS1_SIZE                                0x1
#define _RA1PPS_RA1PPS1_LENGTH                              0x1
#define _RA1PPS_RA1PPS1_MASK                                0x2
#define _RA1PPS_RA1PPS2_POSN                                0x2
#define _RA1PPS_RA1PPS2_POSITION                            0x2
#define _RA1PPS_RA1PPS2_SIZE                                0x1
#define _RA1PPS_RA1PPS2_LENGTH                              0x1
#define _RA1PPS_RA1PPS2_MASK                                0x4
#define _RA1PPS_RA1PPS3_POSN                                0x3
#define _RA1PPS_RA1PPS3_POSITION                            0x3
#define _RA1PPS_RA1PPS3_SIZE                                0x1
#define _RA1PPS_RA1PPS3_LENGTH                              0x1
#define _RA1PPS_RA1PPS3_MASK                                0x8
#define _RA1PPS_RA1PPS4_POSN                                0x4
#define _RA1PPS_RA1PPS4_POSITION                            0x4
#define _RA1PPS_RA1PPS4_SIZE                                0x1
#define _RA1PPS_RA1PPS4_LENGTH                              0x1
#define _RA1PPS_RA1PPS4_MASK                                0x10

// Register: RA2PPS
extern volatile unsigned char           RA2PPS              @ 0xE92;
#ifndef _LIB_BUILD
asm("RA2PPS equ 0E92h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RA2PPS0                :1;
        unsigned RA2PPS1                :1;
        unsigned RA2PPS2                :1;
        unsigned RA2PPS3                :1;
        unsigned RA2PPS4                :1;
    };
} RA2PPSbits_t;
extern volatile RA2PPSbits_t RA2PPSbits @ 0xE92;
// bitfield macros
#define _RA2PPS_RA2PPS0_POSN                                0x0
#define _RA2PPS_RA2PPS0_POSITION                            0x0
#define _RA2PPS_RA2PPS0_SIZE                                0x1
#define _RA2PPS_RA2PPS0_LENGTH                              0x1
#define _RA2PPS_RA2PPS0_MASK                                0x1
#define _RA2PPS_RA2PPS1_POSN                                0x1
#define _RA2PPS_RA2PPS1_POSITION                            0x1
#define _RA2PPS_RA2PPS1_SIZE                                0x1
#define _RA2PPS_RA2PPS1_LENGTH                              0x1
#define _RA2PPS_RA2PPS1_MASK                                0x2
#define _RA2PPS_RA2PPS2_POSN                                0x2
#define _RA2PPS_RA2PPS2_POSITION                            0x2
#define _RA2PPS_RA2PPS2_SIZE                                0x1
#define _RA2PPS_RA2PPS2_LENGTH                              0x1
#define _RA2PPS_RA2PPS2_MASK                                0x4
#define _RA2PPS_RA2PPS3_POSN                                0x3
#define _RA2PPS_RA2PPS3_POSITION                            0x3
#define _RA2PPS_RA2PPS3_SIZE                                0x1
#define _RA2PPS_RA2PPS3_LENGTH                              0x1
#define _RA2PPS_RA2PPS3_MASK                                0x8
#define _RA2PPS_RA2PPS4_POSN                                0x4
#define _RA2PPS_RA2PPS4_POSITION                            0x4
#define _RA2PPS_RA2PPS4_SIZE                                0x1
#define _RA2PPS_RA2PPS4_LENGTH                              0x1
#define _RA2PPS_RA2PPS4_MASK                                0x10

// Register: RA4PPS
extern volatile unsigned char           RA4PPS              @ 0xE94;
#ifndef _LIB_BUILD
asm("RA4PPS equ 0E94h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RA4PPS0                :1;
        unsigned RA4PPS1                :1;
        unsigned RA4PPS2                :1;
        unsigned RA4PPS3                :1;
        unsigned RA4PPS4                :1;
    };
} RA4PPSbits_t;
extern volatile RA4PPSbits_t RA4PPSbits @ 0xE94;
// bitfield macros
#define _RA4PPS_RA4PPS0_POSN                                0x0
#define _RA4PPS_RA4PPS0_POSITION                            0x0
#define _RA4PPS_RA4PPS0_SIZE                                0x1
#define _RA4PPS_RA4PPS0_LENGTH                              0x1
#define _RA4PPS_RA4PPS0_MASK                                0x1
#define _RA4PPS_RA4PPS1_POSN                                0x1
#define _RA4PPS_RA4PPS1_POSITION                            0x1
#define _RA4PPS_RA4PPS1_SIZE                                0x1
#define _RA4PPS_RA4PPS1_LENGTH                              0x1
#define _RA4PPS_RA4PPS1_MASK                                0x2
#define _RA4PPS_RA4PPS2_POSN                                0x2
#define _RA4PPS_RA4PPS2_POSITION                            0x2
#define _RA4PPS_RA4PPS2_SIZE                                0x1
#define _RA4PPS_RA4PPS2_LENGTH                              0x1
#define _RA4PPS_RA4PPS2_MASK                                0x4
#define _RA4PPS_RA4PPS3_POSN                                0x3
#define _RA4PPS_RA4PPS3_POSITION                            0x3
#define _RA4PPS_RA4PPS3_SIZE                                0x1
#define _RA4PPS_RA4PPS3_LENGTH                              0x1
#define _RA4PPS_RA4PPS3_MASK                                0x8
#define _RA4PPS_RA4PPS4_POSN                                0x4
#define _RA4PPS_RA4PPS4_POSITION                            0x4
#define _RA4PPS_RA4PPS4_SIZE                                0x1
#define _RA4PPS_RA4PPS4_LENGTH                              0x1
#define _RA4PPS_RA4PPS4_MASK                                0x10

// Register: RA5PPS
extern volatile unsigned char           RA5PPS              @ 0xE95;
#ifndef _LIB_BUILD
asm("RA5PPS equ 0E95h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RA5PPS0                :1;
        unsigned RA5PPS1                :1;
        unsigned RA5PPS2                :1;
        unsigned RA5PPS3                :1;
        unsigned RA5PPS4                :1;
    };
} RA5PPSbits_t;
extern volatile RA5PPSbits_t RA5PPSbits @ 0xE95;
// bitfield macros
#define _RA5PPS_RA5PPS0_POSN                                0x0
#define _RA5PPS_RA5PPS0_POSITION                            0x0
#define _RA5PPS_RA5PPS0_SIZE                                0x1
#define _RA5PPS_RA5PPS0_LENGTH                              0x1
#define _RA5PPS_RA5PPS0_MASK                                0x1
#define _RA5PPS_RA5PPS1_POSN                                0x1
#define _RA5PPS_RA5PPS1_POSITION                            0x1
#define _RA5PPS_RA5PPS1_SIZE                                0x1
#define _RA5PPS_RA5PPS1_LENGTH                              0x1
#define _RA5PPS_RA5PPS1_MASK                                0x2
#define _RA5PPS_RA5PPS2_POSN                                0x2
#define _RA5PPS_RA5PPS2_POSITION                            0x2
#define _RA5PPS_RA5PPS2_SIZE                                0x1
#define _RA5PPS_RA5PPS2_LENGTH                              0x1
#define _RA5PPS_RA5PPS2_MASK                                0x4
#define _RA5PPS_RA5PPS3_POSN                                0x3
#define _RA5PPS_RA5PPS3_POSITION                            0x3
#define _RA5PPS_RA5PPS3_SIZE                                0x1
#define _RA5PPS_RA5PPS3_LENGTH                              0x1
#define _RA5PPS_RA5PPS3_MASK                                0x8
#define _RA5PPS_RA5PPS4_POSN                                0x4
#define _RA5PPS_RA5PPS4_POSITION                            0x4
#define _RA5PPS_RA5PPS4_SIZE                                0x1
#define _RA5PPS_RA5PPS4_LENGTH                              0x1
#define _RA5PPS_RA5PPS4_MASK                                0x10

// Register: RB4PPS
extern volatile unsigned char           RB4PPS              @ 0xE9C;
#ifndef _LIB_BUILD
asm("RB4PPS equ 0E9Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RB4PPS0                :1;
        unsigned RB4PPS1                :1;
        unsigned RB4PPS2                :1;
        unsigned RB4PPS3                :1;
        unsigned RB4PPS4                :1;
    };
} RB4PPSbits_t;
extern volatile RB4PPSbits_t RB4PPSbits @ 0xE9C;
// bitfield macros
#define _RB4PPS_RB4PPS0_POSN                                0x0
#define _RB4PPS_RB4PPS0_POSITION                            0x0
#define _RB4PPS_RB4PPS0_SIZE                                0x1
#define _RB4PPS_RB4PPS0_LENGTH                              0x1
#define _RB4PPS_RB4PPS0_MASK                                0x1
#define _RB4PPS_RB4PPS1_POSN                                0x1
#define _RB4PPS_RB4PPS1_POSITION                            0x1
#define _RB4PPS_RB4PPS1_SIZE                                0x1
#define _RB4PPS_RB4PPS1_LENGTH                              0x1
#define _RB4PPS_RB4PPS1_MASK                                0x2
#define _RB4PPS_RB4PPS2_POSN                                0x2
#define _RB4PPS_RB4PPS2_POSITION                            0x2
#define _RB4PPS_RB4PPS2_SIZE                                0x1
#define _RB4PPS_RB4PPS2_LENGTH                              0x1
#define _RB4PPS_RB4PPS2_MASK                                0x4
#define _RB4PPS_RB4PPS3_POSN                                0x3
#define _RB4PPS_RB4PPS3_POSITION                            0x3
#define _RB4PPS_RB4PPS3_SIZE                                0x1
#define _RB4PPS_RB4PPS3_LENGTH                              0x1
#define _RB4PPS_RB4PPS3_MASK                                0x8
#define _RB4PPS_RB4PPS4_POSN                                0x4
#define _RB4PPS_RB4PPS4_POSITION                            0x4
#define _RB4PPS_RB4PPS4_SIZE                                0x1
#define _RB4PPS_RB4PPS4_LENGTH                              0x1
#define _RB4PPS_RB4PPS4_MASK                                0x10

// Register: RB5PPS
extern volatile unsigned char           RB5PPS              @ 0xE9D;
#ifndef _LIB_BUILD
asm("RB5PPS equ 0E9Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RB5PPS0                :1;
        unsigned RB5PPS1                :1;
        unsigned RB5PPS2                :1;
        unsigned RB5PPS3                :1;
        unsigned RB5PPS4                :1;
    };
} RB5PPSbits_t;
extern volatile RB5PPSbits_t RB5PPSbits @ 0xE9D;
// bitfield macros
#define _RB5PPS_RB5PPS0_POSN                                0x0
#define _RB5PPS_RB5PPS0_POSITION                            0x0
#define _RB5PPS_RB5PPS0_SIZE                                0x1
#define _RB5PPS_RB5PPS0_LENGTH                              0x1
#define _RB5PPS_RB5PPS0_MASK                                0x1
#define _RB5PPS_RB5PPS1_POSN                                0x1
#define _RB5PPS_RB5PPS1_POSITION                            0x1
#define _RB5PPS_RB5PPS1_SIZE                                0x1
#define _RB5PPS_RB5PPS1_LENGTH                              0x1
#define _RB5PPS_RB5PPS1_MASK                                0x2
#define _RB5PPS_RB5PPS2_POSN                                0x2
#define _RB5PPS_RB5PPS2_POSITION                            0x2
#define _RB5PPS_RB5PPS2_SIZE                                0x1
#define _RB5PPS_RB5PPS2_LENGTH                              0x1
#define _RB5PPS_RB5PPS2_MASK                                0x4
#define _RB5PPS_RB5PPS3_POSN                                0x3
#define _RB5PPS_RB5PPS3_POSITION                            0x3
#define _RB5PPS_RB5PPS3_SIZE                                0x1
#define _RB5PPS_RB5PPS3_LENGTH                              0x1
#define _RB5PPS_RB5PPS3_MASK                                0x8
#define _RB5PPS_RB5PPS4_POSN                                0x4
#define _RB5PPS_RB5PPS4_POSITION                            0x4
#define _RB5PPS_RB5PPS4_SIZE                                0x1
#define _RB5PPS_RB5PPS4_LENGTH                              0x1
#define _RB5PPS_RB5PPS4_MASK                                0x10

// Register: RB6PPS
extern volatile unsigned char           RB6PPS              @ 0xE9E;
#ifndef _LIB_BUILD
asm("RB6PPS equ 0E9Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RB6PPS0                :1;
        unsigned RB6PPS1                :1;
        unsigned RB6PPS2                :1;
        unsigned RB6PPS3                :1;
        unsigned RB6PPS4                :1;
    };
} RB6PPSbits_t;
extern volatile RB6PPSbits_t RB6PPSbits @ 0xE9E;
// bitfield macros
#define _RB6PPS_RB6PPS0_POSN                                0x0
#define _RB6PPS_RB6PPS0_POSITION                            0x0
#define _RB6PPS_RB6PPS0_SIZE                                0x1
#define _RB6PPS_RB6PPS0_LENGTH                              0x1
#define _RB6PPS_RB6PPS0_MASK                                0x1
#define _RB6PPS_RB6PPS1_POSN                                0x1
#define _RB6PPS_RB6PPS1_POSITION                            0x1
#define _RB6PPS_RB6PPS1_SIZE                                0x1
#define _RB6PPS_RB6PPS1_LENGTH                              0x1
#define _RB6PPS_RB6PPS1_MASK                                0x2
#define _RB6PPS_RB6PPS2_POSN                                0x2
#define _RB6PPS_RB6PPS2_POSITION                            0x2
#define _RB6PPS_RB6PPS2_SIZE                                0x1
#define _RB6PPS_RB6PPS2_LENGTH                              0x1
#define _RB6PPS_RB6PPS2_MASK                                0x4
#define _RB6PPS_RB6PPS3_POSN                                0x3
#define _RB6PPS_RB6PPS3_POSITION                            0x3
#define _RB6PPS_RB6PPS3_SIZE                                0x1
#define _RB6PPS_RB6PPS3_LENGTH                              0x1
#define _RB6PPS_RB6PPS3_MASK                                0x8
#define _RB6PPS_RB6PPS4_POSN                                0x4
#define _RB6PPS_RB6PPS4_POSITION                            0x4
#define _RB6PPS_RB6PPS4_SIZE                                0x1
#define _RB6PPS_RB6PPS4_LENGTH                              0x1
#define _RB6PPS_RB6PPS4_MASK                                0x10

// Register: RB7PPS
extern volatile unsigned char           RB7PPS              @ 0xE9F;
#ifndef _LIB_BUILD
asm("RB7PPS equ 0E9Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RB7PPS0                :1;
        unsigned RB7PPS1                :1;
        unsigned RB7PPS2                :1;
        unsigned RB7PPS3                :1;
        unsigned RB7PPS4                :1;
    };
} RB7PPSbits_t;
extern volatile RB7PPSbits_t RB7PPSbits @ 0xE9F;
// bitfield macros
#define _RB7PPS_RB7PPS0_POSN                                0x0
#define _RB7PPS_RB7PPS0_POSITION                            0x0
#define _RB7PPS_RB7PPS0_SIZE                                0x1
#define _RB7PPS_RB7PPS0_LENGTH                              0x1
#define _RB7PPS_RB7PPS0_MASK                                0x1
#define _RB7PPS_RB7PPS1_POSN                                0x1
#define _RB7PPS_RB7PPS1_POSITION                            0x1
#define _RB7PPS_RB7PPS1_SIZE                                0x1
#define _RB7PPS_RB7PPS1_LENGTH                              0x1
#define _RB7PPS_RB7PPS1_MASK                                0x2
#define _RB7PPS_RB7PPS2_POSN                                0x2
#define _RB7PPS_RB7PPS2_POSITION                            0x2
#define _RB7PPS_RB7PPS2_SIZE                                0x1
#define _RB7PPS_RB7PPS2_LENGTH                              0x1
#define _RB7PPS_RB7PPS2_MASK                                0x4
#define _RB7PPS_RB7PPS3_POSN                                0x3
#define _RB7PPS_RB7PPS3_POSITION                            0x3
#define _RB7PPS_RB7PPS3_SIZE                                0x1
#define _RB7PPS_RB7PPS3_LENGTH                              0x1
#define _RB7PPS_RB7PPS3_MASK                                0x8
#define _RB7PPS_RB7PPS4_POSN                                0x4
#define _RB7PPS_RB7PPS4_POSITION                            0x4
#define _RB7PPS_RB7PPS4_SIZE                                0x1
#define _RB7PPS_RB7PPS4_LENGTH                              0x1
#define _RB7PPS_RB7PPS4_MASK                                0x10

// Register: RC0PPS
extern volatile unsigned char           RC0PPS              @ 0xEA0;
#ifndef _LIB_BUILD
asm("RC0PPS equ 0EA0h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RC0PPS0                :1;
        unsigned RC0PPS1                :1;
        unsigned RC0PPS2                :1;
        unsigned RC0PPS3                :1;
        unsigned RC0PPS4                :1;
    };
} RC0PPSbits_t;
extern volatile RC0PPSbits_t RC0PPSbits @ 0xEA0;
// bitfield macros
#define _RC0PPS_RC0PPS0_POSN                                0x0
#define _RC0PPS_RC0PPS0_POSITION                            0x0
#define _RC0PPS_RC0PPS0_SIZE                                0x1
#define _RC0PPS_RC0PPS0_LENGTH                              0x1
#define _RC0PPS_RC0PPS0_MASK                                0x1
#define _RC0PPS_RC0PPS1_POSN                                0x1
#define _RC0PPS_RC0PPS1_POSITION                            0x1
#define _RC0PPS_RC0PPS1_SIZE                                0x1
#define _RC0PPS_RC0PPS1_LENGTH                              0x1
#define _RC0PPS_RC0PPS1_MASK                                0x2
#define _RC0PPS_RC0PPS2_POSN                                0x2
#define _RC0PPS_RC0PPS2_POSITION                            0x2
#define _RC0PPS_RC0PPS2_SIZE                                0x1
#define _RC0PPS_RC0PPS2_LENGTH                              0x1
#define _RC0PPS_RC0PPS2_MASK                                0x4
#define _RC0PPS_RC0PPS3_POSN                                0x3
#define _RC0PPS_RC0PPS3_POSITION                            0x3
#define _RC0PPS_RC0PPS3_SIZE                                0x1
#define _RC0PPS_RC0PPS3_LENGTH                              0x1
#define _RC0PPS_RC0PPS3_MASK                                0x8
#define _RC0PPS_RC0PPS4_POSN                                0x4
#define _RC0PPS_RC0PPS4_POSITION                            0x4
#define _RC0PPS_RC0PPS4_SIZE                                0x1
#define _RC0PPS_RC0PPS4_LENGTH                              0x1
#define _RC0PPS_RC0PPS4_MASK                                0x10

// Register: RC1PPS
extern volatile unsigned char           RC1PPS              @ 0xEA1;
#ifndef _LIB_BUILD
asm("RC1PPS equ 0EA1h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RC1PPS0                :1;
        unsigned RC1PPS1                :1;
        unsigned RC1PPS2                :1;
        unsigned RC1PPS3                :1;
        unsigned RC1PPS4                :1;
    };
} RC1PPSbits_t;
extern volatile RC1PPSbits_t RC1PPSbits @ 0xEA1;
// bitfield macros
#define _RC1PPS_RC1PPS0_POSN                                0x0
#define _RC1PPS_RC1PPS0_POSITION                            0x0
#define _RC1PPS_RC1PPS0_SIZE                                0x1
#define _RC1PPS_RC1PPS0_LENGTH                              0x1
#define _RC1PPS_RC1PPS0_MASK                                0x1
#define _RC1PPS_RC1PPS1_POSN                                0x1
#define _RC1PPS_RC1PPS1_POSITION                            0x1
#define _RC1PPS_RC1PPS1_SIZE                                0x1
#define _RC1PPS_RC1PPS1_LENGTH                              0x1
#define _RC1PPS_RC1PPS1_MASK                                0x2
#define _RC1PPS_RC1PPS2_POSN                                0x2
#define _RC1PPS_RC1PPS2_POSITION                            0x2
#define _RC1PPS_RC1PPS2_SIZE                                0x1
#define _RC1PPS_RC1PPS2_LENGTH                              0x1
#define _RC1PPS_RC1PPS2_MASK                                0x4
#define _RC1PPS_RC1PPS3_POSN                                0x3
#define _RC1PPS_RC1PPS3_POSITION                            0x3
#define _RC1PPS_RC1PPS3_SIZE                                0x1
#define _RC1PPS_RC1PPS3_LENGTH                              0x1
#define _RC1PPS_RC1PPS3_MASK                                0x8
#define _RC1PPS_RC1PPS4_POSN                                0x4
#define _RC1PPS_RC1PPS4_POSITION                            0x4
#define _RC1PPS_RC1PPS4_SIZE                                0x1
#define _RC1PPS_RC1PPS4_LENGTH                              0x1
#define _RC1PPS_RC1PPS4_MASK                                0x10

// Register: RC2PPS
extern volatile unsigned char           RC2PPS              @ 0xEA2;
#ifndef _LIB_BUILD
asm("RC2PPS equ 0EA2h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RC2PPS0                :1;
        unsigned RC2PPS1                :1;
        unsigned RC2PPS2                :1;
        unsigned RC2PPS3                :1;
        unsigned RC2PPS4                :1;
    };
} RC2PPSbits_t;
extern volatile RC2PPSbits_t RC2PPSbits @ 0xEA2;
// bitfield macros
#define _RC2PPS_RC2PPS0_POSN                                0x0
#define _RC2PPS_RC2PPS0_POSITION                            0x0
#define _RC2PPS_RC2PPS0_SIZE                                0x1
#define _RC2PPS_RC2PPS0_LENGTH                              0x1
#define _RC2PPS_RC2PPS0_MASK                                0x1
#define _RC2PPS_RC2PPS1_POSN                                0x1
#define _RC2PPS_RC2PPS1_POSITION                            0x1
#define _RC2PPS_RC2PPS1_SIZE                                0x1
#define _RC2PPS_RC2PPS1_LENGTH                              0x1
#define _RC2PPS_RC2PPS1_MASK                                0x2
#define _RC2PPS_RC2PPS2_POSN                                0x2
#define _RC2PPS_RC2PPS2_POSITION                            0x2
#define _RC2PPS_RC2PPS2_SIZE                                0x1
#define _RC2PPS_RC2PPS2_LENGTH                              0x1
#define _RC2PPS_RC2PPS2_MASK                                0x4
#define _RC2PPS_RC2PPS3_POSN                                0x3
#define _RC2PPS_RC2PPS3_POSITION                            0x3
#define _RC2PPS_RC2PPS3_SIZE                                0x1
#define _RC2PPS_RC2PPS3_LENGTH                              0x1
#define _RC2PPS_RC2PPS3_MASK                                0x8
#define _RC2PPS_RC2PPS4_POSN                                0x4
#define _RC2PPS_RC2PPS4_POSITION                            0x4
#define _RC2PPS_RC2PPS4_SIZE                                0x1
#define _RC2PPS_RC2PPS4_LENGTH                              0x1
#define _RC2PPS_RC2PPS4_MASK                                0x10

// Register: RC3PPS
extern volatile unsigned char           RC3PPS              @ 0xEA3;
#ifndef _LIB_BUILD
asm("RC3PPS equ 0EA3h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RC3PPS0                :1;
        unsigned RC3PPS1                :1;
        unsigned RC3PPS2                :1;
        unsigned RC3PPS3                :1;
        unsigned RC3PPS4                :1;
    };
} RC3PPSbits_t;
extern volatile RC3PPSbits_t RC3PPSbits @ 0xEA3;
// bitfield macros
#define _RC3PPS_RC3PPS0_POSN                                0x0
#define _RC3PPS_RC3PPS0_POSITION                            0x0
#define _RC3PPS_RC3PPS0_SIZE                                0x1
#define _RC3PPS_RC3PPS0_LENGTH                              0x1
#define _RC3PPS_RC3PPS0_MASK                                0x1
#define _RC3PPS_RC3PPS1_POSN                                0x1
#define _RC3PPS_RC3PPS1_POSITION                            0x1
#define _RC3PPS_RC3PPS1_SIZE                                0x1
#define _RC3PPS_RC3PPS1_LENGTH                              0x1
#define _RC3PPS_RC3PPS1_MASK                                0x2
#define _RC3PPS_RC3PPS2_POSN                                0x2
#define _RC3PPS_RC3PPS2_POSITION                            0x2
#define _RC3PPS_RC3PPS2_SIZE                                0x1
#define _RC3PPS_RC3PPS2_LENGTH                              0x1
#define _RC3PPS_RC3PPS2_MASK                                0x4
#define _RC3PPS_RC3PPS3_POSN                                0x3
#define _RC3PPS_RC3PPS3_POSITION                            0x3
#define _RC3PPS_RC3PPS3_SIZE                                0x1
#define _RC3PPS_RC3PPS3_LENGTH                              0x1
#define _RC3PPS_RC3PPS3_MASK                                0x8
#define _RC3PPS_RC3PPS4_POSN                                0x4
#define _RC3PPS_RC3PPS4_POSITION                            0x4
#define _RC3PPS_RC3PPS4_SIZE                                0x1
#define _RC3PPS_RC3PPS4_LENGTH                              0x1
#define _RC3PPS_RC3PPS4_MASK                                0x10

// Register: RC4PPS
extern volatile unsigned char           RC4PPS              @ 0xEA4;
#ifndef _LIB_BUILD
asm("RC4PPS equ 0EA4h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RC4PPS0                :1;
        unsigned RC4PPS1                :1;
        unsigned RC4PPS2                :1;
        unsigned RC4PPS3                :1;
        unsigned RC4PPS4                :1;
    };
} RC4PPSbits_t;
extern volatile RC4PPSbits_t RC4PPSbits @ 0xEA4;
// bitfield macros
#define _RC4PPS_RC4PPS0_POSN                                0x0
#define _RC4PPS_RC4PPS0_POSITION                            0x0
#define _RC4PPS_RC4PPS0_SIZE                                0x1
#define _RC4PPS_RC4PPS0_LENGTH                              0x1
#define _RC4PPS_RC4PPS0_MASK                                0x1
#define _RC4PPS_RC4PPS1_POSN                                0x1
#define _RC4PPS_RC4PPS1_POSITION                            0x1
#define _RC4PPS_RC4PPS1_SIZE                                0x1
#define _RC4PPS_RC4PPS1_LENGTH                              0x1
#define _RC4PPS_RC4PPS1_MASK                                0x2
#define _RC4PPS_RC4PPS2_POSN                                0x2
#define _RC4PPS_RC4PPS2_POSITION                            0x2
#define _RC4PPS_RC4PPS2_SIZE                                0x1
#define _RC4PPS_RC4PPS2_LENGTH                              0x1
#define _RC4PPS_RC4PPS2_MASK                                0x4
#define _RC4PPS_RC4PPS3_POSN                                0x3
#define _RC4PPS_RC4PPS3_POSITION                            0x3
#define _RC4PPS_RC4PPS3_SIZE                                0x1
#define _RC4PPS_RC4PPS3_LENGTH                              0x1
#define _RC4PPS_RC4PPS3_MASK                                0x8
#define _RC4PPS_RC4PPS4_POSN                                0x4
#define _RC4PPS_RC4PPS4_POSITION                            0x4
#define _RC4PPS_RC4PPS4_SIZE                                0x1
#define _RC4PPS_RC4PPS4_LENGTH                              0x1
#define _RC4PPS_RC4PPS4_MASK                                0x10

// Register: RC5PPS
extern volatile unsigned char           RC5PPS              @ 0xEA5;
#ifndef _LIB_BUILD
asm("RC5PPS equ 0EA5h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RC5PPS0                :1;
        unsigned RC5PPS1                :1;
        unsigned RC5PPS2                :1;
        unsigned RC5PPS3                :1;
        unsigned RC5PPS4                :1;
    };
} RC5PPSbits_t;
extern volatile RC5PPSbits_t RC5PPSbits @ 0xEA5;
// bitfield macros
#define _RC5PPS_RC5PPS0_POSN                                0x0
#define _RC5PPS_RC5PPS0_POSITION                            0x0
#define _RC5PPS_RC5PPS0_SIZE                                0x1
#define _RC5PPS_RC5PPS0_LENGTH                              0x1
#define _RC5PPS_RC5PPS0_MASK                                0x1
#define _RC5PPS_RC5PPS1_POSN                                0x1
#define _RC5PPS_RC5PPS1_POSITION                            0x1
#define _RC5PPS_RC5PPS1_SIZE                                0x1
#define _RC5PPS_RC5PPS1_LENGTH                              0x1
#define _RC5PPS_RC5PPS1_MASK                                0x2
#define _RC5PPS_RC5PPS2_POSN                                0x2
#define _RC5PPS_RC5PPS2_POSITION                            0x2
#define _RC5PPS_RC5PPS2_SIZE                                0x1
#define _RC5PPS_RC5PPS2_LENGTH                              0x1
#define _RC5PPS_RC5PPS2_MASK                                0x4
#define _RC5PPS_RC5PPS3_POSN                                0x3
#define _RC5PPS_RC5PPS3_POSITION                            0x3
#define _RC5PPS_RC5PPS3_SIZE                                0x1
#define _RC5PPS_RC5PPS3_LENGTH                              0x1
#define _RC5PPS_RC5PPS3_MASK                                0x8
#define _RC5PPS_RC5PPS4_POSN                                0x4
#define _RC5PPS_RC5PPS4_POSITION                            0x4
#define _RC5PPS_RC5PPS4_SIZE                                0x1
#define _RC5PPS_RC5PPS4_LENGTH                              0x1
#define _RC5PPS_RC5PPS4_MASK                                0x10

// Register: RC6PPS
extern volatile unsigned char           RC6PPS              @ 0xEA6;
#ifndef _LIB_BUILD
asm("RC6PPS equ 0EA6h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RC6PPS0                :1;
        unsigned RC6PPS1                :1;
        unsigned RC6PPS2                :1;
        unsigned RC6PPS3                :1;
        unsigned RC6PPS4                :1;
    };
} RC6PPSbits_t;
extern volatile RC6PPSbits_t RC6PPSbits @ 0xEA6;
// bitfield macros
#define _RC6PPS_RC6PPS0_POSN                                0x0
#define _RC6PPS_RC6PPS0_POSITION                            0x0
#define _RC6PPS_RC6PPS0_SIZE                                0x1
#define _RC6PPS_RC6PPS0_LENGTH                              0x1
#define _RC6PPS_RC6PPS0_MASK                                0x1
#define _RC6PPS_RC6PPS1_POSN                                0x1
#define _RC6PPS_RC6PPS1_POSITION                            0x1
#define _RC6PPS_RC6PPS1_SIZE                                0x1
#define _RC6PPS_RC6PPS1_LENGTH                              0x1
#define _RC6PPS_RC6PPS1_MASK                                0x2
#define _RC6PPS_RC6PPS2_POSN                                0x2
#define _RC6PPS_RC6PPS2_POSITION                            0x2
#define _RC6PPS_RC6PPS2_SIZE                                0x1
#define _RC6PPS_RC6PPS2_LENGTH                              0x1
#define _RC6PPS_RC6PPS2_MASK                                0x4
#define _RC6PPS_RC6PPS3_POSN                                0x3
#define _RC6PPS_RC6PPS3_POSITION                            0x3
#define _RC6PPS_RC6PPS3_SIZE                                0x1
#define _RC6PPS_RC6PPS3_LENGTH                              0x1
#define _RC6PPS_RC6PPS3_MASK                                0x8
#define _RC6PPS_RC6PPS4_POSN                                0x4
#define _RC6PPS_RC6PPS4_POSITION                            0x4
#define _RC6PPS_RC6PPS4_SIZE                                0x1
#define _RC6PPS_RC6PPS4_LENGTH                              0x1
#define _RC6PPS_RC6PPS4_MASK                                0x10

// Register: RC7PPS
extern volatile unsigned char           RC7PPS              @ 0xEA7;
#ifndef _LIB_BUILD
asm("RC7PPS equ 0EA7h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned RC7PPS0                :1;
        unsigned RC7PPS1                :1;
        unsigned RC7PPS2                :1;
        unsigned RC7PPS3                :1;
        unsigned RC7PPS4                :1;
    };
} RC7PPSbits_t;
extern volatile RC7PPSbits_t RC7PPSbits @ 0xEA7;
// bitfield macros
#define _RC7PPS_RC7PPS0_POSN                                0x0
#define _RC7PPS_RC7PPS0_POSITION                            0x0
#define _RC7PPS_RC7PPS0_SIZE                                0x1
#define _RC7PPS_RC7PPS0_LENGTH                              0x1
#define _RC7PPS_RC7PPS0_MASK                                0x1
#define _RC7PPS_RC7PPS1_POSN                                0x1
#define _RC7PPS_RC7PPS1_POSITION                            0x1
#define _RC7PPS_RC7PPS1_SIZE                                0x1
#define _RC7PPS_RC7PPS1_LENGTH                              0x1
#define _RC7PPS_RC7PPS1_MASK                                0x2
#define _RC7PPS_RC7PPS2_POSN                                0x2
#define _RC7PPS_RC7PPS2_POSITION                            0x2
#define _RC7PPS_RC7PPS2_SIZE                                0x1
#define _RC7PPS_RC7PPS2_LENGTH                              0x1
#define _RC7PPS_RC7PPS2_MASK                                0x4
#define _RC7PPS_RC7PPS3_POSN                                0x3
#define _RC7PPS_RC7PPS3_POSITION                            0x3
#define _RC7PPS_RC7PPS3_SIZE                                0x1
#define _RC7PPS_RC7PPS3_LENGTH                              0x1
#define _RC7PPS_RC7PPS3_MASK                                0x8
#define _RC7PPS_RC7PPS4_POSN                                0x4
#define _RC7PPS_RC7PPS4_POSITION                            0x4
#define _RC7PPS_RC7PPS4_SIZE                                0x1
#define _RC7PPS_RC7PPS4_LENGTH                              0x1
#define _RC7PPS_RC7PPS4_MASK                                0x10

// Register: CLCDATA
extern volatile unsigned char           CLCDATA             @ 0xF0F;
#ifndef _LIB_BUILD
asm("CLCDATA equ 0F0Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned MLC1OUT                :1;
        unsigned MLC2OUT                :1;
        unsigned MLC3OUT                :1;
        unsigned MLC4OUT                :1;
    };
} CLCDATAbits_t;
extern volatile CLCDATAbits_t CLCDATAbits @ 0xF0F;
// bitfield macros
#define _CLCDATA_MLC1OUT_POSN                               0x0
#define _CLCDATA_MLC1OUT_POSITION                           0x0
#define _CLCDATA_MLC1OUT_SIZE                               0x1
#define _CLCDATA_MLC1OUT_LENGTH                             0x1
#define _CLCDATA_MLC1OUT_MASK                               0x1
#define _CLCDATA_MLC2OUT_POSN                               0x1
#define _CLCDATA_MLC2OUT_POSITION                           0x1
#define _CLCDATA_MLC2OUT_SIZE                               0x1
#define _CLCDATA_MLC2OUT_LENGTH                             0x1
#define _CLCDATA_MLC2OUT_MASK                               0x2
#define _CLCDATA_MLC3OUT_POSN                               0x2
#define _CLCDATA_MLC3OUT_POSITION                           0x2
#define _CLCDATA_MLC3OUT_SIZE                               0x1
#define _CLCDATA_MLC3OUT_LENGTH                             0x1
#define _CLCDATA_MLC3OUT_MASK                               0x4
#define _CLCDATA_MLC4OUT_POSN                               0x3
#define _CLCDATA_MLC4OUT_POSITION                           0x3
#define _CLCDATA_MLC4OUT_SIZE                               0x1
#define _CLCDATA_MLC4OUT_LENGTH                             0x1
#define _CLCDATA_MLC4OUT_MASK                               0x8

// Register: CLC1CON
extern volatile unsigned char           CLC1CON             @ 0xF10;
#ifndef _LIB_BUILD
asm("CLC1CON equ 0F10h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC1MODE                :3;
        unsigned LC1INTN                :1;
        unsigned LC1INTP                :1;
        unsigned LC1OUT                 :1;
        unsigned                        :1;
        unsigned LC1EN                  :1;
    };
    struct {
        unsigned LC1MODE0               :1;
        unsigned LC1MODE1               :1;
        unsigned LC1MODE2               :1;
    };
    struct {
        unsigned MODE                   :3;
        unsigned INTN                   :1;
        unsigned INTP                   :1;
        unsigned OUT                    :1;
        unsigned                        :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
    };
} CLC1CONbits_t;
extern volatile CLC1CONbits_t CLC1CONbits @ 0xF10;
// bitfield macros
#define _CLC1CON_LC1MODE_POSN                               0x0
#define _CLC1CON_LC1MODE_POSITION                           0x0
#define _CLC1CON_LC1MODE_SIZE                               0x3
#define _CLC1CON_LC1MODE_LENGTH                             0x3
#define _CLC1CON_LC1MODE_MASK                               0x7
#define _CLC1CON_LC1INTN_POSN                               0x3
#define _CLC1CON_LC1INTN_POSITION                           0x3
#define _CLC1CON_LC1INTN_SIZE                               0x1
#define _CLC1CON_LC1INTN_LENGTH                             0x1
#define _CLC1CON_LC1INTN_MASK                               0x8
#define _CLC1CON_LC1INTP_POSN                               0x4
#define _CLC1CON_LC1INTP_POSITION                           0x4
#define _CLC1CON_LC1INTP_SIZE                               0x1
#define _CLC1CON_LC1INTP_LENGTH                             0x1
#define _CLC1CON_LC1INTP_MASK                               0x10
#define _CLC1CON_LC1OUT_POSN                                0x5
#define _CLC1CON_LC1OUT_POSITION                            0x5
#define _CLC1CON_LC1OUT_SIZE                                0x1
#define _CLC1CON_LC1OUT_LENGTH                              0x1
#define _CLC1CON_LC1OUT_MASK                                0x20
#define _CLC1CON_LC1EN_POSN                                 0x7
#define _CLC1CON_LC1EN_POSITION                             0x7
#define _CLC1CON_LC1EN_SIZE                                 0x1
#define _CLC1CON_LC1EN_LENGTH                               0x1
#define _CLC1CON_LC1EN_MASK                                 0x80
#define _CLC1CON_LC1MODE0_POSN                              0x0
#define _CLC1CON_LC1MODE0_POSITION                          0x0
#define _CLC1CON_LC1MODE0_SIZE                              0x1
#define _CLC1CON_LC1MODE0_LENGTH                            0x1
#define _CLC1CON_LC1MODE0_MASK                              0x1
#define _CLC1CON_LC1MODE1_POSN                              0x1
#define _CLC1CON_LC1MODE1_POSITION                          0x1
#define _CLC1CON_LC1MODE1_SIZE                              0x1
#define _CLC1CON_LC1MODE1_LENGTH                            0x1
#define _CLC1CON_LC1MODE1_MASK                              0x2
#define _CLC1CON_LC1MODE2_POSN                              0x2
#define _CLC1CON_LC1MODE2_POSITION                          0x2
#define _CLC1CON_LC1MODE2_SIZE                              0x1
#define _CLC1CON_LC1MODE2_LENGTH                            0x1
#define _CLC1CON_LC1MODE2_MASK                              0x4
#define _CLC1CON_MODE_POSN                                  0x0
#define _CLC1CON_MODE_POSITION                              0x0
#define _CLC1CON_MODE_SIZE                                  0x3
#define _CLC1CON_MODE_LENGTH                                0x3
#define _CLC1CON_MODE_MASK                                  0x7
#define _CLC1CON_INTN_POSN                                  0x3
#define _CLC1CON_INTN_POSITION                              0x3
#define _CLC1CON_INTN_SIZE                                  0x1
#define _CLC1CON_INTN_LENGTH                                0x1
#define _CLC1CON_INTN_MASK                                  0x8
#define _CLC1CON_INTP_POSN                                  0x4
#define _CLC1CON_INTP_POSITION                              0x4
#define _CLC1CON_INTP_SIZE                                  0x1
#define _CLC1CON_INTP_LENGTH                                0x1
#define _CLC1CON_INTP_MASK                                  0x10
#define _CLC1CON_OUT_POSN                                   0x5
#define _CLC1CON_OUT_POSITION                               0x5
#define _CLC1CON_OUT_SIZE                                   0x1
#define _CLC1CON_OUT_LENGTH                                 0x1
#define _CLC1CON_OUT_MASK                                   0x20
#define _CLC1CON_EN_POSN                                    0x7
#define _CLC1CON_EN_POSITION                                0x7
#define _CLC1CON_EN_SIZE                                    0x1
#define _CLC1CON_EN_LENGTH                                  0x1
#define _CLC1CON_EN_MASK                                    0x80
#define _CLC1CON_MODE0_POSN                                 0x0
#define _CLC1CON_MODE0_POSITION                             0x0
#define _CLC1CON_MODE0_SIZE                                 0x1
#define _CLC1CON_MODE0_LENGTH                               0x1
#define _CLC1CON_MODE0_MASK                                 0x1
#define _CLC1CON_MODE1_POSN                                 0x1
#define _CLC1CON_MODE1_POSITION                             0x1
#define _CLC1CON_MODE1_SIZE                                 0x1
#define _CLC1CON_MODE1_LENGTH                               0x1
#define _CLC1CON_MODE1_MASK                                 0x2
#define _CLC1CON_MODE2_POSN                                 0x2
#define _CLC1CON_MODE2_POSITION                             0x2
#define _CLC1CON_MODE2_SIZE                                 0x1
#define _CLC1CON_MODE2_LENGTH                               0x1
#define _CLC1CON_MODE2_MASK                                 0x4

// Register: CLC1POL
extern volatile unsigned char           CLC1POL             @ 0xF11;
#ifndef _LIB_BUILD
asm("CLC1POL equ 0F11h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC1G1POL               :1;
        unsigned LC1G2POL               :1;
        unsigned LC1G3POL               :1;
        unsigned LC1G4POL               :1;
        unsigned                        :3;
        unsigned LC1POL                 :1;
    };
    struct {
        unsigned G1POL                  :1;
        unsigned G2POL                  :1;
        unsigned G3POL                  :1;
        unsigned G4POL                  :1;
        unsigned                        :3;
        unsigned POL                    :1;
    };
} CLC1POLbits_t;
extern volatile CLC1POLbits_t CLC1POLbits @ 0xF11;
// bitfield macros
#define _CLC1POL_LC1G1POL_POSN                              0x0
#define _CLC1POL_LC1G1POL_POSITION                          0x0
#define _CLC1POL_LC1G1POL_SIZE                              0x1
#define _CLC1POL_LC1G1POL_LENGTH                            0x1
#define _CLC1POL_LC1G1POL_MASK                              0x1
#define _CLC1POL_LC1G2POL_POSN                              0x1
#define _CLC1POL_LC1G2POL_POSITION                          0x1
#define _CLC1POL_LC1G2POL_SIZE                              0x1
#define _CLC1POL_LC1G2POL_LENGTH                            0x1
#define _CLC1POL_LC1G2POL_MASK                              0x2
#define _CLC1POL_LC1G3POL_POSN                              0x2
#define _CLC1POL_LC1G3POL_POSITION                          0x2
#define _CLC1POL_LC1G3POL_SIZE                              0x1
#define _CLC1POL_LC1G3POL_LENGTH                            0x1
#define _CLC1POL_LC1G3POL_MASK                              0x4
#define _CLC1POL_LC1G4POL_POSN                              0x3
#define _CLC1POL_LC1G4POL_POSITION                          0x3
#define _CLC1POL_LC1G4POL_SIZE                              0x1
#define _CLC1POL_LC1G4POL_LENGTH                            0x1
#define _CLC1POL_LC1G4POL_MASK                              0x8
#define _CLC1POL_LC1POL_POSN                                0x7
#define _CLC1POL_LC1POL_POSITION                            0x7
#define _CLC1POL_LC1POL_SIZE                                0x1
#define _CLC1POL_LC1POL_LENGTH                              0x1
#define _CLC1POL_LC1POL_MASK                                0x80
#define _CLC1POL_G1POL_POSN                                 0x0
#define _CLC1POL_G1POL_POSITION                             0x0
#define _CLC1POL_G1POL_SIZE                                 0x1
#define _CLC1POL_G1POL_LENGTH                               0x1
#define _CLC1POL_G1POL_MASK                                 0x1
#define _CLC1POL_G2POL_POSN                                 0x1
#define _CLC1POL_G2POL_POSITION                             0x1
#define _CLC1POL_G2POL_SIZE                                 0x1
#define _CLC1POL_G2POL_LENGTH                               0x1
#define _CLC1POL_G2POL_MASK                                 0x2
#define _CLC1POL_G3POL_POSN                                 0x2
#define _CLC1POL_G3POL_POSITION                             0x2
#define _CLC1POL_G3POL_SIZE                                 0x1
#define _CLC1POL_G3POL_LENGTH                               0x1
#define _CLC1POL_G3POL_MASK                                 0x4
#define _CLC1POL_G4POL_POSN                                 0x3
#define _CLC1POL_G4POL_POSITION                             0x3
#define _CLC1POL_G4POL_SIZE                                 0x1
#define _CLC1POL_G4POL_LENGTH                               0x1
#define _CLC1POL_G4POL_MASK                                 0x8
#define _CLC1POL_POL_POSN                                   0x7
#define _CLC1POL_POL_POSITION                               0x7
#define _CLC1POL_POL_SIZE                                   0x1
#define _CLC1POL_POL_LENGTH                                 0x1
#define _CLC1POL_POL_MASK                                   0x80

// Register: CLC1SEL0
extern volatile unsigned char           CLC1SEL0            @ 0xF12;
#ifndef _LIB_BUILD
asm("CLC1SEL0 equ 0F12h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC1D1S0                :1;
        unsigned LC1D1S1                :1;
        unsigned LC1D1S2                :1;
        unsigned LC1D1S3                :1;
        unsigned LC1D1S4                :1;
        unsigned LC1D1S5                :1;
    };
    struct {
        unsigned LC1D1S                 :8;
    };
    struct {
        unsigned D1S                    :8;
    };
    struct {
        unsigned D1S0                   :1;
        unsigned D1S1                   :1;
        unsigned D1S2                   :1;
        unsigned D1S3                   :1;
        unsigned D1S4                   :1;
        unsigned D1S5                   :1;
    };
} CLC1SEL0bits_t;
extern volatile CLC1SEL0bits_t CLC1SEL0bits @ 0xF12;
// bitfield macros
#define _CLC1SEL0_LC1D1S0_POSN                              0x0
#define _CLC1SEL0_LC1D1S0_POSITION                          0x0
#define _CLC1SEL0_LC1D1S0_SIZE                              0x1
#define _CLC1SEL0_LC1D1S0_LENGTH                            0x1
#define _CLC1SEL0_LC1D1S0_MASK                              0x1
#define _CLC1SEL0_LC1D1S1_POSN                              0x1
#define _CLC1SEL0_LC1D1S1_POSITION                          0x1
#define _CLC1SEL0_LC1D1S1_SIZE                              0x1
#define _CLC1SEL0_LC1D1S1_LENGTH                            0x1
#define _CLC1SEL0_LC1D1S1_MASK                              0x2
#define _CLC1SEL0_LC1D1S2_POSN                              0x2
#define _CLC1SEL0_LC1D1S2_POSITION                          0x2
#define _CLC1SEL0_LC1D1S2_SIZE                              0x1
#define _CLC1SEL0_LC1D1S2_LENGTH                            0x1
#define _CLC1SEL0_LC1D1S2_MASK                              0x4
#define _CLC1SEL0_LC1D1S3_POSN                              0x3
#define _CLC1SEL0_LC1D1S3_POSITION                          0x3
#define _CLC1SEL0_LC1D1S3_SIZE                              0x1
#define _CLC1SEL0_LC1D1S3_LENGTH                            0x1
#define _CLC1SEL0_LC1D1S3_MASK                              0x8
#define _CLC1SEL0_LC1D1S4_POSN                              0x4
#define _CLC1SEL0_LC1D1S4_POSITION                          0x4
#define _CLC1SEL0_LC1D1S4_SIZE                              0x1
#define _CLC1SEL0_LC1D1S4_LENGTH                            0x1
#define _CLC1SEL0_LC1D1S4_MASK                              0x10
#define _CLC1SEL0_LC1D1S5_POSN                              0x5
#define _CLC1SEL0_LC1D1S5_POSITION                          0x5
#define _CLC1SEL0_LC1D1S5_SIZE                              0x1
#define _CLC1SEL0_LC1D1S5_LENGTH                            0x1
#define _CLC1SEL0_LC1D1S5_MASK                              0x20
#define _CLC1SEL0_LC1D1S_POSN                               0x0
#define _CLC1SEL0_LC1D1S_POSITION                           0x0
#define _CLC1SEL0_LC1D1S_SIZE                               0x8
#define _CLC1SEL0_LC1D1S_LENGTH                             0x8
#define _CLC1SEL0_LC1D1S_MASK                               0xFF
#define _CLC1SEL0_D1S_POSN                                  0x0
#define _CLC1SEL0_D1S_POSITION                              0x0
#define _CLC1SEL0_D1S_SIZE                                  0x8
#define _CLC1SEL0_D1S_LENGTH                                0x8
#define _CLC1SEL0_D1S_MASK                                  0xFF
#define _CLC1SEL0_D1S0_POSN                                 0x0
#define _CLC1SEL0_D1S0_POSITION                             0x0
#define _CLC1SEL0_D1S0_SIZE                                 0x1
#define _CLC1SEL0_D1S0_LENGTH                               0x1
#define _CLC1SEL0_D1S0_MASK                                 0x1
#define _CLC1SEL0_D1S1_POSN                                 0x1
#define _CLC1SEL0_D1S1_POSITION                             0x1
#define _CLC1SEL0_D1S1_SIZE                                 0x1
#define _CLC1SEL0_D1S1_LENGTH                               0x1
#define _CLC1SEL0_D1S1_MASK                                 0x2
#define _CLC1SEL0_D1S2_POSN                                 0x2
#define _CLC1SEL0_D1S2_POSITION                             0x2
#define _CLC1SEL0_D1S2_SIZE                                 0x1
#define _CLC1SEL0_D1S2_LENGTH                               0x1
#define _CLC1SEL0_D1S2_MASK                                 0x4
#define _CLC1SEL0_D1S3_POSN                                 0x3
#define _CLC1SEL0_D1S3_POSITION                             0x3
#define _CLC1SEL0_D1S3_SIZE                                 0x1
#define _CLC1SEL0_D1S3_LENGTH                               0x1
#define _CLC1SEL0_D1S3_MASK                                 0x8
#define _CLC1SEL0_D1S4_POSN                                 0x4
#define _CLC1SEL0_D1S4_POSITION                             0x4
#define _CLC1SEL0_D1S4_SIZE                                 0x1
#define _CLC1SEL0_D1S4_LENGTH                               0x1
#define _CLC1SEL0_D1S4_MASK                                 0x10
#define _CLC1SEL0_D1S5_POSN                                 0x5
#define _CLC1SEL0_D1S5_POSITION                             0x5
#define _CLC1SEL0_D1S5_SIZE                                 0x1
#define _CLC1SEL0_D1S5_LENGTH                               0x1
#define _CLC1SEL0_D1S5_MASK                                 0x20

// Register: CLC1SEL1
extern volatile unsigned char           CLC1SEL1            @ 0xF13;
#ifndef _LIB_BUILD
asm("CLC1SEL1 equ 0F13h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC1D2S0                :1;
        unsigned LC1D2S1                :1;
        unsigned LC1D2S2                :1;
        unsigned LC1D2S3                :1;
        unsigned LC1D2S4                :1;
        unsigned LC1D2S5                :1;
    };
    struct {
        unsigned LC1D2S                 :8;
    };
    struct {
        unsigned D2S                    :8;
    };
    struct {
        unsigned D2S0                   :1;
        unsigned D2S1                   :1;
        unsigned D2S2                   :1;
        unsigned D2S3                   :1;
        unsigned D2S4                   :1;
        unsigned D2S5                   :1;
    };
} CLC1SEL1bits_t;
extern volatile CLC1SEL1bits_t CLC1SEL1bits @ 0xF13;
// bitfield macros
#define _CLC1SEL1_LC1D2S0_POSN                              0x0
#define _CLC1SEL1_LC1D2S0_POSITION                          0x0
#define _CLC1SEL1_LC1D2S0_SIZE                              0x1
#define _CLC1SEL1_LC1D2S0_LENGTH                            0x1
#define _CLC1SEL1_LC1D2S0_MASK                              0x1
#define _CLC1SEL1_LC1D2S1_POSN                              0x1
#define _CLC1SEL1_LC1D2S1_POSITION                          0x1
#define _CLC1SEL1_LC1D2S1_SIZE                              0x1
#define _CLC1SEL1_LC1D2S1_LENGTH                            0x1
#define _CLC1SEL1_LC1D2S1_MASK                              0x2
#define _CLC1SEL1_LC1D2S2_POSN                              0x2
#define _CLC1SEL1_LC1D2S2_POSITION                          0x2
#define _CLC1SEL1_LC1D2S2_SIZE                              0x1
#define _CLC1SEL1_LC1D2S2_LENGTH                            0x1
#define _CLC1SEL1_LC1D2S2_MASK                              0x4
#define _CLC1SEL1_LC1D2S3_POSN                              0x3
#define _CLC1SEL1_LC1D2S3_POSITION                          0x3
#define _CLC1SEL1_LC1D2S3_SIZE                              0x1
#define _CLC1SEL1_LC1D2S3_LENGTH                            0x1
#define _CLC1SEL1_LC1D2S3_MASK                              0x8
#define _CLC1SEL1_LC1D2S4_POSN                              0x4
#define _CLC1SEL1_LC1D2S4_POSITION                          0x4
#define _CLC1SEL1_LC1D2S4_SIZE                              0x1
#define _CLC1SEL1_LC1D2S4_LENGTH                            0x1
#define _CLC1SEL1_LC1D2S4_MASK                              0x10
#define _CLC1SEL1_LC1D2S5_POSN                              0x5
#define _CLC1SEL1_LC1D2S5_POSITION                          0x5
#define _CLC1SEL1_LC1D2S5_SIZE                              0x1
#define _CLC1SEL1_LC1D2S5_LENGTH                            0x1
#define _CLC1SEL1_LC1D2S5_MASK                              0x20
#define _CLC1SEL1_LC1D2S_POSN                               0x0
#define _CLC1SEL1_LC1D2S_POSITION                           0x0
#define _CLC1SEL1_LC1D2S_SIZE                               0x8
#define _CLC1SEL1_LC1D2S_LENGTH                             0x8
#define _CLC1SEL1_LC1D2S_MASK                               0xFF
#define _CLC1SEL1_D2S_POSN                                  0x0
#define _CLC1SEL1_D2S_POSITION                              0x0
#define _CLC1SEL1_D2S_SIZE                                  0x8
#define _CLC1SEL1_D2S_LENGTH                                0x8
#define _CLC1SEL1_D2S_MASK                                  0xFF
#define _CLC1SEL1_D2S0_POSN                                 0x0
#define _CLC1SEL1_D2S0_POSITION                             0x0
#define _CLC1SEL1_D2S0_SIZE                                 0x1
#define _CLC1SEL1_D2S0_LENGTH                               0x1
#define _CLC1SEL1_D2S0_MASK                                 0x1
#define _CLC1SEL1_D2S1_POSN                                 0x1
#define _CLC1SEL1_D2S1_POSITION                             0x1
#define _CLC1SEL1_D2S1_SIZE                                 0x1
#define _CLC1SEL1_D2S1_LENGTH                               0x1
#define _CLC1SEL1_D2S1_MASK                                 0x2
#define _CLC1SEL1_D2S2_POSN                                 0x2
#define _CLC1SEL1_D2S2_POSITION                             0x2
#define _CLC1SEL1_D2S2_SIZE                                 0x1
#define _CLC1SEL1_D2S2_LENGTH                               0x1
#define _CLC1SEL1_D2S2_MASK                                 0x4
#define _CLC1SEL1_D2S3_POSN                                 0x3
#define _CLC1SEL1_D2S3_POSITION                             0x3
#define _CLC1SEL1_D2S3_SIZE                                 0x1
#define _CLC1SEL1_D2S3_LENGTH                               0x1
#define _CLC1SEL1_D2S3_MASK                                 0x8
#define _CLC1SEL1_D2S4_POSN                                 0x4
#define _CLC1SEL1_D2S4_POSITION                             0x4
#define _CLC1SEL1_D2S4_SIZE                                 0x1
#define _CLC1SEL1_D2S4_LENGTH                               0x1
#define _CLC1SEL1_D2S4_MASK                                 0x10
#define _CLC1SEL1_D2S5_POSN                                 0x5
#define _CLC1SEL1_D2S5_POSITION                             0x5
#define _CLC1SEL1_D2S5_SIZE                                 0x1
#define _CLC1SEL1_D2S5_LENGTH                               0x1
#define _CLC1SEL1_D2S5_MASK                                 0x20

// Register: CLC1SEL2
extern volatile unsigned char           CLC1SEL2            @ 0xF14;
#ifndef _LIB_BUILD
asm("CLC1SEL2 equ 0F14h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC1D3S0                :1;
        unsigned LC1D3S1                :1;
        unsigned LC1D3S2                :1;
        unsigned LC1D3S3                :1;
        unsigned LC1D3S4                :1;
        unsigned LC1D3S5                :1;
    };
    struct {
        unsigned LC1D3S                 :8;
    };
    struct {
        unsigned D3S                    :8;
    };
    struct {
        unsigned D3S0                   :1;
        unsigned D3S1                   :1;
        unsigned D3S2                   :1;
        unsigned D3S3                   :1;
        unsigned D3S4                   :1;
        unsigned D3S5                   :1;
    };
} CLC1SEL2bits_t;
extern volatile CLC1SEL2bits_t CLC1SEL2bits @ 0xF14;
// bitfield macros
#define _CLC1SEL2_LC1D3S0_POSN                              0x0
#define _CLC1SEL2_LC1D3S0_POSITION                          0x0
#define _CLC1SEL2_LC1D3S0_SIZE                              0x1
#define _CLC1SEL2_LC1D3S0_LENGTH                            0x1
#define _CLC1SEL2_LC1D3S0_MASK                              0x1
#define _CLC1SEL2_LC1D3S1_POSN                              0x1
#define _CLC1SEL2_LC1D3S1_POSITION                          0x1
#define _CLC1SEL2_LC1D3S1_SIZE                              0x1
#define _CLC1SEL2_LC1D3S1_LENGTH                            0x1
#define _CLC1SEL2_LC1D3S1_MASK                              0x2
#define _CLC1SEL2_LC1D3S2_POSN                              0x2
#define _CLC1SEL2_LC1D3S2_POSITION                          0x2
#define _CLC1SEL2_LC1D3S2_SIZE                              0x1
#define _CLC1SEL2_LC1D3S2_LENGTH                            0x1
#define _CLC1SEL2_LC1D3S2_MASK                              0x4
#define _CLC1SEL2_LC1D3S3_POSN                              0x3
#define _CLC1SEL2_LC1D3S3_POSITION                          0x3
#define _CLC1SEL2_LC1D3S3_SIZE                              0x1
#define _CLC1SEL2_LC1D3S3_LENGTH                            0x1
#define _CLC1SEL2_LC1D3S3_MASK                              0x8
#define _CLC1SEL2_LC1D3S4_POSN                              0x4
#define _CLC1SEL2_LC1D3S4_POSITION                          0x4
#define _CLC1SEL2_LC1D3S4_SIZE                              0x1
#define _CLC1SEL2_LC1D3S4_LENGTH                            0x1
#define _CLC1SEL2_LC1D3S4_MASK                              0x10
#define _CLC1SEL2_LC1D3S5_POSN                              0x5
#define _CLC1SEL2_LC1D3S5_POSITION                          0x5
#define _CLC1SEL2_LC1D3S5_SIZE                              0x1
#define _CLC1SEL2_LC1D3S5_LENGTH                            0x1
#define _CLC1SEL2_LC1D3S5_MASK                              0x20
#define _CLC1SEL2_LC1D3S_POSN                               0x0
#define _CLC1SEL2_LC1D3S_POSITION                           0x0
#define _CLC1SEL2_LC1D3S_SIZE                               0x8
#define _CLC1SEL2_LC1D3S_LENGTH                             0x8
#define _CLC1SEL2_LC1D3S_MASK                               0xFF
#define _CLC1SEL2_D3S_POSN                                  0x0
#define _CLC1SEL2_D3S_POSITION                              0x0
#define _CLC1SEL2_D3S_SIZE                                  0x8
#define _CLC1SEL2_D3S_LENGTH                                0x8
#define _CLC1SEL2_D3S_MASK                                  0xFF
#define _CLC1SEL2_D3S0_POSN                                 0x0
#define _CLC1SEL2_D3S0_POSITION                             0x0
#define _CLC1SEL2_D3S0_SIZE                                 0x1
#define _CLC1SEL2_D3S0_LENGTH                               0x1
#define _CLC1SEL2_D3S0_MASK                                 0x1
#define _CLC1SEL2_D3S1_POSN                                 0x1
#define _CLC1SEL2_D3S1_POSITION                             0x1
#define _CLC1SEL2_D3S1_SIZE                                 0x1
#define _CLC1SEL2_D3S1_LENGTH                               0x1
#define _CLC1SEL2_D3S1_MASK                                 0x2
#define _CLC1SEL2_D3S2_POSN                                 0x2
#define _CLC1SEL2_D3S2_POSITION                             0x2
#define _CLC1SEL2_D3S2_SIZE                                 0x1
#define _CLC1SEL2_D3S2_LENGTH                               0x1
#define _CLC1SEL2_D3S2_MASK                                 0x4
#define _CLC1SEL2_D3S3_POSN                                 0x3
#define _CLC1SEL2_D3S3_POSITION                             0x3
#define _CLC1SEL2_D3S3_SIZE                                 0x1
#define _CLC1SEL2_D3S3_LENGTH                               0x1
#define _CLC1SEL2_D3S3_MASK                                 0x8
#define _CLC1SEL2_D3S4_POSN                                 0x4
#define _CLC1SEL2_D3S4_POSITION                             0x4
#define _CLC1SEL2_D3S4_SIZE                                 0x1
#define _CLC1SEL2_D3S4_LENGTH                               0x1
#define _CLC1SEL2_D3S4_MASK                                 0x10
#define _CLC1SEL2_D3S5_POSN                                 0x5
#define _CLC1SEL2_D3S5_POSITION                             0x5
#define _CLC1SEL2_D3S5_SIZE                                 0x1
#define _CLC1SEL2_D3S5_LENGTH                               0x1
#define _CLC1SEL2_D3S5_MASK                                 0x20

// Register: CLC1SEL3
extern volatile unsigned char           CLC1SEL3            @ 0xF15;
#ifndef _LIB_BUILD
asm("CLC1SEL3 equ 0F15h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC1D4S0                :1;
        unsigned LC1D4S1                :1;
        unsigned LC1D4S2                :1;
        unsigned LC1D4S3                :1;
        unsigned LC1D4S4                :1;
        unsigned LC1D4S5                :1;
    };
    struct {
        unsigned LC1D4S                 :8;
    };
    struct {
        unsigned D4S                    :8;
    };
    struct {
        unsigned D4S0                   :1;
        unsigned D4S1                   :1;
        unsigned D4S2                   :1;
        unsigned D4S3                   :1;
        unsigned D4S4                   :1;
        unsigned D4S5                   :1;
    };
} CLC1SEL3bits_t;
extern volatile CLC1SEL3bits_t CLC1SEL3bits @ 0xF15;
// bitfield macros
#define _CLC1SEL3_LC1D4S0_POSN                              0x0
#define _CLC1SEL3_LC1D4S0_POSITION                          0x0
#define _CLC1SEL3_LC1D4S0_SIZE                              0x1
#define _CLC1SEL3_LC1D4S0_LENGTH                            0x1
#define _CLC1SEL3_LC1D4S0_MASK                              0x1
#define _CLC1SEL3_LC1D4S1_POSN                              0x1
#define _CLC1SEL3_LC1D4S1_POSITION                          0x1
#define _CLC1SEL3_LC1D4S1_SIZE                              0x1
#define _CLC1SEL3_LC1D4S1_LENGTH                            0x1
#define _CLC1SEL3_LC1D4S1_MASK                              0x2
#define _CLC1SEL3_LC1D4S2_POSN                              0x2
#define _CLC1SEL3_LC1D4S2_POSITION                          0x2
#define _CLC1SEL3_LC1D4S2_SIZE                              0x1
#define _CLC1SEL3_LC1D4S2_LENGTH                            0x1
#define _CLC1SEL3_LC1D4S2_MASK                              0x4
#define _CLC1SEL3_LC1D4S3_POSN                              0x3
#define _CLC1SEL3_LC1D4S3_POSITION                          0x3
#define _CLC1SEL3_LC1D4S3_SIZE                              0x1
#define _CLC1SEL3_LC1D4S3_LENGTH                            0x1
#define _CLC1SEL3_LC1D4S3_MASK                              0x8
#define _CLC1SEL3_LC1D4S4_POSN                              0x4
#define _CLC1SEL3_LC1D4S4_POSITION                          0x4
#define _CLC1SEL3_LC1D4S4_SIZE                              0x1
#define _CLC1SEL3_LC1D4S4_LENGTH                            0x1
#define _CLC1SEL3_LC1D4S4_MASK                              0x10
#define _CLC1SEL3_LC1D4S5_POSN                              0x5
#define _CLC1SEL3_LC1D4S5_POSITION                          0x5
#define _CLC1SEL3_LC1D4S5_SIZE                              0x1
#define _CLC1SEL3_LC1D4S5_LENGTH                            0x1
#define _CLC1SEL3_LC1D4S5_MASK                              0x20
#define _CLC1SEL3_LC1D4S_POSN                               0x0
#define _CLC1SEL3_LC1D4S_POSITION                           0x0
#define _CLC1SEL3_LC1D4S_SIZE                               0x8
#define _CLC1SEL3_LC1D4S_LENGTH                             0x8
#define _CLC1SEL3_LC1D4S_MASK                               0xFF
#define _CLC1SEL3_D4S_POSN                                  0x0
#define _CLC1SEL3_D4S_POSITION                              0x0
#define _CLC1SEL3_D4S_SIZE                                  0x8
#define _CLC1SEL3_D4S_LENGTH                                0x8
#define _CLC1SEL3_D4S_MASK                                  0xFF
#define _CLC1SEL3_D4S0_POSN                                 0x0
#define _CLC1SEL3_D4S0_POSITION                             0x0
#define _CLC1SEL3_D4S0_SIZE                                 0x1
#define _CLC1SEL3_D4S0_LENGTH                               0x1
#define _CLC1SEL3_D4S0_MASK                                 0x1
#define _CLC1SEL3_D4S1_POSN                                 0x1
#define _CLC1SEL3_D4S1_POSITION                             0x1
#define _CLC1SEL3_D4S1_SIZE                                 0x1
#define _CLC1SEL3_D4S1_LENGTH                               0x1
#define _CLC1SEL3_D4S1_MASK                                 0x2
#define _CLC1SEL3_D4S2_POSN                                 0x2
#define _CLC1SEL3_D4S2_POSITION                             0x2
#define _CLC1SEL3_D4S2_SIZE                                 0x1
#define _CLC1SEL3_D4S2_LENGTH                               0x1
#define _CLC1SEL3_D4S2_MASK                                 0x4
#define _CLC1SEL3_D4S3_POSN                                 0x3
#define _CLC1SEL3_D4S3_POSITION                             0x3
#define _CLC1SEL3_D4S3_SIZE                                 0x1
#define _CLC1SEL3_D4S3_LENGTH                               0x1
#define _CLC1SEL3_D4S3_MASK                                 0x8
#define _CLC1SEL3_D4S4_POSN                                 0x4
#define _CLC1SEL3_D4S4_POSITION                             0x4
#define _CLC1SEL3_D4S4_SIZE                                 0x1
#define _CLC1SEL3_D4S4_LENGTH                               0x1
#define _CLC1SEL3_D4S4_MASK                                 0x10
#define _CLC1SEL3_D4S5_POSN                                 0x5
#define _CLC1SEL3_D4S5_POSITION                             0x5
#define _CLC1SEL3_D4S5_SIZE                                 0x1
#define _CLC1SEL3_D4S5_LENGTH                               0x1
#define _CLC1SEL3_D4S5_MASK                                 0x20

// Register: CLC1GLS0
extern volatile unsigned char           CLC1GLS0            @ 0xF16;
#ifndef _LIB_BUILD
asm("CLC1GLS0 equ 0F16h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC1G1D1N               :1;
        unsigned LC1G1D1T               :1;
        unsigned LC1G1D2N               :1;
        unsigned LC1G1D2T               :1;
        unsigned LC1G1D3N               :1;
        unsigned LC1G1D3T               :1;
        unsigned LC1G1D4N               :1;
        unsigned LC1G1D4T               :1;
    };
    struct {
        unsigned D1N                    :1;
        unsigned D1T                    :1;
        unsigned D2N                    :1;
        unsigned D2T                    :1;
        unsigned D3N                    :1;
        unsigned D3T                    :1;
        unsigned D4N                    :1;
        unsigned D4T                    :1;
    };
} CLC1GLS0bits_t;
extern volatile CLC1GLS0bits_t CLC1GLS0bits @ 0xF16;
// bitfield macros
#define _CLC1GLS0_LC1G1D1N_POSN                             0x0
#define _CLC1GLS0_LC1G1D1N_POSITION                         0x0
#define _CLC1GLS0_LC1G1D1N_SIZE                             0x1
#define _CLC1GLS0_LC1G1D1N_LENGTH                           0x1
#define _CLC1GLS0_LC1G1D1N_MASK                             0x1
#define _CLC1GLS0_LC1G1D1T_POSN                             0x1
#define _CLC1GLS0_LC1G1D1T_POSITION                         0x1
#define _CLC1GLS0_LC1G1D1T_SIZE                             0x1
#define _CLC1GLS0_LC1G1D1T_LENGTH                           0x1
#define _CLC1GLS0_LC1G1D1T_MASK                             0x2
#define _CLC1GLS0_LC1G1D2N_POSN                             0x2
#define _CLC1GLS0_LC1G1D2N_POSITION                         0x2
#define _CLC1GLS0_LC1G1D2N_SIZE                             0x1
#define _CLC1GLS0_LC1G1D2N_LENGTH                           0x1
#define _CLC1GLS0_LC1G1D2N_MASK                             0x4
#define _CLC1GLS0_LC1G1D2T_POSN                             0x3
#define _CLC1GLS0_LC1G1D2T_POSITION                         0x3
#define _CLC1GLS0_LC1G1D2T_SIZE                             0x1
#define _CLC1GLS0_LC1G1D2T_LENGTH                           0x1
#define _CLC1GLS0_LC1G1D2T_MASK                             0x8
#define _CLC1GLS0_LC1G1D3N_POSN                             0x4
#define _CLC1GLS0_LC1G1D3N_POSITION                         0x4
#define _CLC1GLS0_LC1G1D3N_SIZE                             0x1
#define _CLC1GLS0_LC1G1D3N_LENGTH                           0x1
#define _CLC1GLS0_LC1G1D3N_MASK                             0x10
#define _CLC1GLS0_LC1G1D3T_POSN                             0x5
#define _CLC1GLS0_LC1G1D3T_POSITION                         0x5
#define _CLC1GLS0_LC1G1D3T_SIZE                             0x1
#define _CLC1GLS0_LC1G1D3T_LENGTH                           0x1
#define _CLC1GLS0_LC1G1D3T_MASK                             0x20
#define _CLC1GLS0_LC1G1D4N_POSN                             0x6
#define _CLC1GLS0_LC1G1D4N_POSITION                         0x6
#define _CLC1GLS0_LC1G1D4N_SIZE                             0x1
#define _CLC1GLS0_LC1G1D4N_LENGTH                           0x1
#define _CLC1GLS0_LC1G1D4N_MASK                             0x40
#define _CLC1GLS0_LC1G1D4T_POSN                             0x7
#define _CLC1GLS0_LC1G1D4T_POSITION                         0x7
#define _CLC1GLS0_LC1G1D4T_SIZE                             0x1
#define _CLC1GLS0_LC1G1D4T_LENGTH                           0x1
#define _CLC1GLS0_LC1G1D4T_MASK                             0x80
#define _CLC1GLS0_D1N_POSN                                  0x0
#define _CLC1GLS0_D1N_POSITION                              0x0
#define _CLC1GLS0_D1N_SIZE                                  0x1
#define _CLC1GLS0_D1N_LENGTH                                0x1
#define _CLC1GLS0_D1N_MASK                                  0x1
#define _CLC1GLS0_D1T_POSN                                  0x1
#define _CLC1GLS0_D1T_POSITION                              0x1
#define _CLC1GLS0_D1T_SIZE                                  0x1
#define _CLC1GLS0_D1T_LENGTH                                0x1
#define _CLC1GLS0_D1T_MASK                                  0x2
#define _CLC1GLS0_D2N_POSN                                  0x2
#define _CLC1GLS0_D2N_POSITION                              0x2
#define _CLC1GLS0_D2N_SIZE                                  0x1
#define _CLC1GLS0_D2N_LENGTH                                0x1
#define _CLC1GLS0_D2N_MASK                                  0x4
#define _CLC1GLS0_D2T_POSN                                  0x3
#define _CLC1GLS0_D2T_POSITION                              0x3
#define _CLC1GLS0_D2T_SIZE                                  0x1
#define _CLC1GLS0_D2T_LENGTH                                0x1
#define _CLC1GLS0_D2T_MASK                                  0x8
#define _CLC1GLS0_D3N_POSN                                  0x4
#define _CLC1GLS0_D3N_POSITION                              0x4
#define _CLC1GLS0_D3N_SIZE                                  0x1
#define _CLC1GLS0_D3N_LENGTH                                0x1
#define _CLC1GLS0_D3N_MASK                                  0x10
#define _CLC1GLS0_D3T_POSN                                  0x5
#define _CLC1GLS0_D3T_POSITION                              0x5
#define _CLC1GLS0_D3T_SIZE                                  0x1
#define _CLC1GLS0_D3T_LENGTH                                0x1
#define _CLC1GLS0_D3T_MASK                                  0x20
#define _CLC1GLS0_D4N_POSN                                  0x6
#define _CLC1GLS0_D4N_POSITION                              0x6
#define _CLC1GLS0_D4N_SIZE                                  0x1
#define _CLC1GLS0_D4N_LENGTH                                0x1
#define _CLC1GLS0_D4N_MASK                                  0x40
#define _CLC1GLS0_D4T_POSN                                  0x7
#define _CLC1GLS0_D4T_POSITION                              0x7
#define _CLC1GLS0_D4T_SIZE                                  0x1
#define _CLC1GLS0_D4T_LENGTH                                0x1
#define _CLC1GLS0_D4T_MASK                                  0x80

// Register: CLC1GLS1
extern volatile unsigned char           CLC1GLS1            @ 0xF17;
#ifndef _LIB_BUILD
asm("CLC1GLS1 equ 0F17h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC1G2D1N               :1;
        unsigned LC1G2D1T               :1;
        unsigned LC1G2D2N               :1;
        unsigned LC1G2D2T               :1;
        unsigned LC1G2D3N               :1;
        unsigned LC1G2D3T               :1;
        unsigned LC1G2D4N               :1;
        unsigned LC1G2D4T               :1;
    };
    struct {
        unsigned D1N                    :1;
        unsigned D1T                    :1;
        unsigned D2N                    :1;
        unsigned D2T                    :1;
        unsigned D3N                    :1;
        unsigned D3T                    :1;
        unsigned D4N                    :1;
        unsigned D4T                    :1;
    };
} CLC1GLS1bits_t;
extern volatile CLC1GLS1bits_t CLC1GLS1bits @ 0xF17;
// bitfield macros
#define _CLC1GLS1_LC1G2D1N_POSN                             0x0
#define _CLC1GLS1_LC1G2D1N_POSITION                         0x0
#define _CLC1GLS1_LC1G2D1N_SIZE                             0x1
#define _CLC1GLS1_LC1G2D1N_LENGTH                           0x1
#define _CLC1GLS1_LC1G2D1N_MASK                             0x1
#define _CLC1GLS1_LC1G2D1T_POSN                             0x1
#define _CLC1GLS1_LC1G2D1T_POSITION                         0x1
#define _CLC1GLS1_LC1G2D1T_SIZE                             0x1
#define _CLC1GLS1_LC1G2D1T_LENGTH                           0x1
#define _CLC1GLS1_LC1G2D1T_MASK                             0x2
#define _CLC1GLS1_LC1G2D2N_POSN                             0x2
#define _CLC1GLS1_LC1G2D2N_POSITION                         0x2
#define _CLC1GLS1_LC1G2D2N_SIZE                             0x1
#define _CLC1GLS1_LC1G2D2N_LENGTH                           0x1
#define _CLC1GLS1_LC1G2D2N_MASK                             0x4
#define _CLC1GLS1_LC1G2D2T_POSN                             0x3
#define _CLC1GLS1_LC1G2D2T_POSITION                         0x3
#define _CLC1GLS1_LC1G2D2T_SIZE                             0x1
#define _CLC1GLS1_LC1G2D2T_LENGTH                           0x1
#define _CLC1GLS1_LC1G2D2T_MASK                             0x8
#define _CLC1GLS1_LC1G2D3N_POSN                             0x4
#define _CLC1GLS1_LC1G2D3N_POSITION                         0x4
#define _CLC1GLS1_LC1G2D3N_SIZE                             0x1
#define _CLC1GLS1_LC1G2D3N_LENGTH                           0x1
#define _CLC1GLS1_LC1G2D3N_MASK                             0x10
#define _CLC1GLS1_LC1G2D3T_POSN                             0x5
#define _CLC1GLS1_LC1G2D3T_POSITION                         0x5
#define _CLC1GLS1_LC1G2D3T_SIZE                             0x1
#define _CLC1GLS1_LC1G2D3T_LENGTH                           0x1
#define _CLC1GLS1_LC1G2D3T_MASK                             0x20
#define _CLC1GLS1_LC1G2D4N_POSN                             0x6
#define _CLC1GLS1_LC1G2D4N_POSITION                         0x6
#define _CLC1GLS1_LC1G2D4N_SIZE                             0x1
#define _CLC1GLS1_LC1G2D4N_LENGTH                           0x1
#define _CLC1GLS1_LC1G2D4N_MASK                             0x40
#define _CLC1GLS1_LC1G2D4T_POSN                             0x7
#define _CLC1GLS1_LC1G2D4T_POSITION                         0x7
#define _CLC1GLS1_LC1G2D4T_SIZE                             0x1
#define _CLC1GLS1_LC1G2D4T_LENGTH                           0x1
#define _CLC1GLS1_LC1G2D4T_MASK                             0x80
#define _CLC1GLS1_D1N_POSN                                  0x0
#define _CLC1GLS1_D1N_POSITION                              0x0
#define _CLC1GLS1_D1N_SIZE                                  0x1
#define _CLC1GLS1_D1N_LENGTH                                0x1
#define _CLC1GLS1_D1N_MASK                                  0x1
#define _CLC1GLS1_D1T_POSN                                  0x1
#define _CLC1GLS1_D1T_POSITION                              0x1
#define _CLC1GLS1_D1T_SIZE                                  0x1
#define _CLC1GLS1_D1T_LENGTH                                0x1
#define _CLC1GLS1_D1T_MASK                                  0x2
#define _CLC1GLS1_D2N_POSN                                  0x2
#define _CLC1GLS1_D2N_POSITION                              0x2
#define _CLC1GLS1_D2N_SIZE                                  0x1
#define _CLC1GLS1_D2N_LENGTH                                0x1
#define _CLC1GLS1_D2N_MASK                                  0x4
#define _CLC1GLS1_D2T_POSN                                  0x3
#define _CLC1GLS1_D2T_POSITION                              0x3
#define _CLC1GLS1_D2T_SIZE                                  0x1
#define _CLC1GLS1_D2T_LENGTH                                0x1
#define _CLC1GLS1_D2T_MASK                                  0x8
#define _CLC1GLS1_D3N_POSN                                  0x4
#define _CLC1GLS1_D3N_POSITION                              0x4
#define _CLC1GLS1_D3N_SIZE                                  0x1
#define _CLC1GLS1_D3N_LENGTH                                0x1
#define _CLC1GLS1_D3N_MASK                                  0x10
#define _CLC1GLS1_D3T_POSN                                  0x5
#define _CLC1GLS1_D3T_POSITION                              0x5
#define _CLC1GLS1_D3T_SIZE                                  0x1
#define _CLC1GLS1_D3T_LENGTH                                0x1
#define _CLC1GLS1_D3T_MASK                                  0x20
#define _CLC1GLS1_D4N_POSN                                  0x6
#define _CLC1GLS1_D4N_POSITION                              0x6
#define _CLC1GLS1_D4N_SIZE                                  0x1
#define _CLC1GLS1_D4N_LENGTH                                0x1
#define _CLC1GLS1_D4N_MASK                                  0x40
#define _CLC1GLS1_D4T_POSN                                  0x7
#define _CLC1GLS1_D4T_POSITION                              0x7
#define _CLC1GLS1_D4T_SIZE                                  0x1
#define _CLC1GLS1_D4T_LENGTH                                0x1
#define _CLC1GLS1_D4T_MASK                                  0x80

// Register: CLC1GLS2
extern volatile unsigned char           CLC1GLS2            @ 0xF18;
#ifndef _LIB_BUILD
asm("CLC1GLS2 equ 0F18h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC1G3D1N               :1;
        unsigned LC1G3D1T               :1;
        unsigned LC1G3D2N               :1;
        unsigned LC1G3D2T               :1;
        unsigned LC1G3D3N               :1;
        unsigned LC1G3D3T               :1;
        unsigned LC1G3D4N               :1;
        unsigned LC1G3D4T               :1;
    };
    struct {
        unsigned D1N                    :1;
        unsigned D1T                    :1;
        unsigned D2N                    :1;
        unsigned D2T                    :1;
        unsigned D3N                    :1;
        unsigned D3T                    :1;
        unsigned D4N                    :1;
        unsigned D4T                    :1;
    };
} CLC1GLS2bits_t;
extern volatile CLC1GLS2bits_t CLC1GLS2bits @ 0xF18;
// bitfield macros
#define _CLC1GLS2_LC1G3D1N_POSN                             0x0
#define _CLC1GLS2_LC1G3D1N_POSITION                         0x0
#define _CLC1GLS2_LC1G3D1N_SIZE                             0x1
#define _CLC1GLS2_LC1G3D1N_LENGTH                           0x1
#define _CLC1GLS2_LC1G3D1N_MASK                             0x1
#define _CLC1GLS2_LC1G3D1T_POSN                             0x1
#define _CLC1GLS2_LC1G3D1T_POSITION                         0x1
#define _CLC1GLS2_LC1G3D1T_SIZE                             0x1
#define _CLC1GLS2_LC1G3D1T_LENGTH                           0x1
#define _CLC1GLS2_LC1G3D1T_MASK                             0x2
#define _CLC1GLS2_LC1G3D2N_POSN                             0x2
#define _CLC1GLS2_LC1G3D2N_POSITION                         0x2
#define _CLC1GLS2_LC1G3D2N_SIZE                             0x1
#define _CLC1GLS2_LC1G3D2N_LENGTH                           0x1
#define _CLC1GLS2_LC1G3D2N_MASK                             0x4
#define _CLC1GLS2_LC1G3D2T_POSN                             0x3
#define _CLC1GLS2_LC1G3D2T_POSITION                         0x3
#define _CLC1GLS2_LC1G3D2T_SIZE                             0x1
#define _CLC1GLS2_LC1G3D2T_LENGTH                           0x1
#define _CLC1GLS2_LC1G3D2T_MASK                             0x8
#define _CLC1GLS2_LC1G3D3N_POSN                             0x4
#define _CLC1GLS2_LC1G3D3N_POSITION                         0x4
#define _CLC1GLS2_LC1G3D3N_SIZE                             0x1
#define _CLC1GLS2_LC1G3D3N_LENGTH                           0x1
#define _CLC1GLS2_LC1G3D3N_MASK                             0x10
#define _CLC1GLS2_LC1G3D3T_POSN                             0x5
#define _CLC1GLS2_LC1G3D3T_POSITION                         0x5
#define _CLC1GLS2_LC1G3D3T_SIZE                             0x1
#define _CLC1GLS2_LC1G3D3T_LENGTH                           0x1
#define _CLC1GLS2_LC1G3D3T_MASK                             0x20
#define _CLC1GLS2_LC1G3D4N_POSN                             0x6
#define _CLC1GLS2_LC1G3D4N_POSITION                         0x6
#define _CLC1GLS2_LC1G3D4N_SIZE                             0x1
#define _CLC1GLS2_LC1G3D4N_LENGTH                           0x1
#define _CLC1GLS2_LC1G3D4N_MASK                             0x40
#define _CLC1GLS2_LC1G3D4T_POSN                             0x7
#define _CLC1GLS2_LC1G3D4T_POSITION                         0x7
#define _CLC1GLS2_LC1G3D4T_SIZE                             0x1
#define _CLC1GLS2_LC1G3D4T_LENGTH                           0x1
#define _CLC1GLS2_LC1G3D4T_MASK                             0x80
#define _CLC1GLS2_D1N_POSN                                  0x0
#define _CLC1GLS2_D1N_POSITION                              0x0
#define _CLC1GLS2_D1N_SIZE                                  0x1
#define _CLC1GLS2_D1N_LENGTH                                0x1
#define _CLC1GLS2_D1N_MASK                                  0x1
#define _CLC1GLS2_D1T_POSN                                  0x1
#define _CLC1GLS2_D1T_POSITION                              0x1
#define _CLC1GLS2_D1T_SIZE                                  0x1
#define _CLC1GLS2_D1T_LENGTH                                0x1
#define _CLC1GLS2_D1T_MASK                                  0x2
#define _CLC1GLS2_D2N_POSN                                  0x2
#define _CLC1GLS2_D2N_POSITION                              0x2
#define _CLC1GLS2_D2N_SIZE                                  0x1
#define _CLC1GLS2_D2N_LENGTH                                0x1
#define _CLC1GLS2_D2N_MASK                                  0x4
#define _CLC1GLS2_D2T_POSN                                  0x3
#define _CLC1GLS2_D2T_POSITION                              0x3
#define _CLC1GLS2_D2T_SIZE                                  0x1
#define _CLC1GLS2_D2T_LENGTH                                0x1
#define _CLC1GLS2_D2T_MASK                                  0x8
#define _CLC1GLS2_D3N_POSN                                  0x4
#define _CLC1GLS2_D3N_POSITION                              0x4
#define _CLC1GLS2_D3N_SIZE                                  0x1
#define _CLC1GLS2_D3N_LENGTH                                0x1
#define _CLC1GLS2_D3N_MASK                                  0x10
#define _CLC1GLS2_D3T_POSN                                  0x5
#define _CLC1GLS2_D3T_POSITION                              0x5
#define _CLC1GLS2_D3T_SIZE                                  0x1
#define _CLC1GLS2_D3T_LENGTH                                0x1
#define _CLC1GLS2_D3T_MASK                                  0x20
#define _CLC1GLS2_D4N_POSN                                  0x6
#define _CLC1GLS2_D4N_POSITION                              0x6
#define _CLC1GLS2_D4N_SIZE                                  0x1
#define _CLC1GLS2_D4N_LENGTH                                0x1
#define _CLC1GLS2_D4N_MASK                                  0x40
#define _CLC1GLS2_D4T_POSN                                  0x7
#define _CLC1GLS2_D4T_POSITION                              0x7
#define _CLC1GLS2_D4T_SIZE                                  0x1
#define _CLC1GLS2_D4T_LENGTH                                0x1
#define _CLC1GLS2_D4T_MASK                                  0x80

// Register: CLC1GLS3
extern volatile unsigned char           CLC1GLS3            @ 0xF19;
#ifndef _LIB_BUILD
asm("CLC1GLS3 equ 0F19h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC1G4D1N               :1;
        unsigned LC1G4D1T               :1;
        unsigned LC1G4D2N               :1;
        unsigned LC1G4D2T               :1;
        unsigned LC1G4D3N               :1;
        unsigned LC1G4D3T               :1;
        unsigned LC1G4D4N               :1;
        unsigned LC1G4D4T               :1;
    };
    struct {
        unsigned G4D1N                  :1;
        unsigned G4D1T                  :1;
        unsigned G4D2N                  :1;
        unsigned G4D2T                  :1;
        unsigned G4D3N                  :1;
        unsigned G4D3T                  :1;
        unsigned G4D4N                  :1;
        unsigned G4D4T                  :1;
    };
} CLC1GLS3bits_t;
extern volatile CLC1GLS3bits_t CLC1GLS3bits @ 0xF19;
// bitfield macros
#define _CLC1GLS3_LC1G4D1N_POSN                             0x0
#define _CLC1GLS3_LC1G4D1N_POSITION                         0x0
#define _CLC1GLS3_LC1G4D1N_SIZE                             0x1
#define _CLC1GLS3_LC1G4D1N_LENGTH                           0x1
#define _CLC1GLS3_LC1G4D1N_MASK                             0x1
#define _CLC1GLS3_LC1G4D1T_POSN                             0x1
#define _CLC1GLS3_LC1G4D1T_POSITION                         0x1
#define _CLC1GLS3_LC1G4D1T_SIZE                             0x1
#define _CLC1GLS3_LC1G4D1T_LENGTH                           0x1
#define _CLC1GLS3_LC1G4D1T_MASK                             0x2
#define _CLC1GLS3_LC1G4D2N_POSN                             0x2
#define _CLC1GLS3_LC1G4D2N_POSITION                         0x2
#define _CLC1GLS3_LC1G4D2N_SIZE                             0x1
#define _CLC1GLS3_LC1G4D2N_LENGTH                           0x1
#define _CLC1GLS3_LC1G4D2N_MASK                             0x4
#define _CLC1GLS3_LC1G4D2T_POSN                             0x3
#define _CLC1GLS3_LC1G4D2T_POSITION                         0x3
#define _CLC1GLS3_LC1G4D2T_SIZE                             0x1
#define _CLC1GLS3_LC1G4D2T_LENGTH                           0x1
#define _CLC1GLS3_LC1G4D2T_MASK                             0x8
#define _CLC1GLS3_LC1G4D3N_POSN                             0x4
#define _CLC1GLS3_LC1G4D3N_POSITION                         0x4
#define _CLC1GLS3_LC1G4D3N_SIZE                             0x1
#define _CLC1GLS3_LC1G4D3N_LENGTH                           0x1
#define _CLC1GLS3_LC1G4D3N_MASK                             0x10
#define _CLC1GLS3_LC1G4D3T_POSN                             0x5
#define _CLC1GLS3_LC1G4D3T_POSITION                         0x5
#define _CLC1GLS3_LC1G4D3T_SIZE                             0x1
#define _CLC1GLS3_LC1G4D3T_LENGTH                           0x1
#define _CLC1GLS3_LC1G4D3T_MASK                             0x20
#define _CLC1GLS3_LC1G4D4N_POSN                             0x6
#define _CLC1GLS3_LC1G4D4N_POSITION                         0x6
#define _CLC1GLS3_LC1G4D4N_SIZE                             0x1
#define _CLC1GLS3_LC1G4D4N_LENGTH                           0x1
#define _CLC1GLS3_LC1G4D4N_MASK                             0x40
#define _CLC1GLS3_LC1G4D4T_POSN                             0x7
#define _CLC1GLS3_LC1G4D4T_POSITION                         0x7
#define _CLC1GLS3_LC1G4D4T_SIZE                             0x1
#define _CLC1GLS3_LC1G4D4T_LENGTH                           0x1
#define _CLC1GLS3_LC1G4D4T_MASK                             0x80
#define _CLC1GLS3_G4D1N_POSN                                0x0
#define _CLC1GLS3_G4D1N_POSITION                            0x0
#define _CLC1GLS3_G4D1N_SIZE                                0x1
#define _CLC1GLS3_G4D1N_LENGTH                              0x1
#define _CLC1GLS3_G4D1N_MASK                                0x1
#define _CLC1GLS3_G4D1T_POSN                                0x1
#define _CLC1GLS3_G4D1T_POSITION                            0x1
#define _CLC1GLS3_G4D1T_SIZE                                0x1
#define _CLC1GLS3_G4D1T_LENGTH                              0x1
#define _CLC1GLS3_G4D1T_MASK                                0x2
#define _CLC1GLS3_G4D2N_POSN                                0x2
#define _CLC1GLS3_G4D2N_POSITION                            0x2
#define _CLC1GLS3_G4D2N_SIZE                                0x1
#define _CLC1GLS3_G4D2N_LENGTH                              0x1
#define _CLC1GLS3_G4D2N_MASK                                0x4
#define _CLC1GLS3_G4D2T_POSN                                0x3
#define _CLC1GLS3_G4D2T_POSITION                            0x3
#define _CLC1GLS3_G4D2T_SIZE                                0x1
#define _CLC1GLS3_G4D2T_LENGTH                              0x1
#define _CLC1GLS3_G4D2T_MASK                                0x8
#define _CLC1GLS3_G4D3N_POSN                                0x4
#define _CLC1GLS3_G4D3N_POSITION                            0x4
#define _CLC1GLS3_G4D3N_SIZE                                0x1
#define _CLC1GLS3_G4D3N_LENGTH                              0x1
#define _CLC1GLS3_G4D3N_MASK                                0x10
#define _CLC1GLS3_G4D3T_POSN                                0x5
#define _CLC1GLS3_G4D3T_POSITION                            0x5
#define _CLC1GLS3_G4D3T_SIZE                                0x1
#define _CLC1GLS3_G4D3T_LENGTH                              0x1
#define _CLC1GLS3_G4D3T_MASK                                0x20
#define _CLC1GLS3_G4D4N_POSN                                0x6
#define _CLC1GLS3_G4D4N_POSITION                            0x6
#define _CLC1GLS3_G4D4N_SIZE                                0x1
#define _CLC1GLS3_G4D4N_LENGTH                              0x1
#define _CLC1GLS3_G4D4N_MASK                                0x40
#define _CLC1GLS3_G4D4T_POSN                                0x7
#define _CLC1GLS3_G4D4T_POSITION                            0x7
#define _CLC1GLS3_G4D4T_SIZE                                0x1
#define _CLC1GLS3_G4D4T_LENGTH                              0x1
#define _CLC1GLS3_G4D4T_MASK                                0x80

// Register: CLC2CON
extern volatile unsigned char           CLC2CON             @ 0xF1A;
#ifndef _LIB_BUILD
asm("CLC2CON equ 0F1Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC2MODE                :3;
        unsigned LC2INTN                :1;
        unsigned LC2INTP                :1;
        unsigned LC2OUT                 :1;
        unsigned                        :1;
        unsigned LC2EN                  :1;
    };
    struct {
        unsigned LC2MODE0               :1;
        unsigned LC2MODE1               :1;
        unsigned LC2MODE2               :1;
    };
    struct {
        unsigned MODE                   :3;
        unsigned INTN                   :1;
        unsigned INTP                   :1;
        unsigned OUT                    :1;
        unsigned                        :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
    };
} CLC2CONbits_t;
extern volatile CLC2CONbits_t CLC2CONbits @ 0xF1A;
// bitfield macros
#define _CLC2CON_LC2MODE_POSN                               0x0
#define _CLC2CON_LC2MODE_POSITION                           0x0
#define _CLC2CON_LC2MODE_SIZE                               0x3
#define _CLC2CON_LC2MODE_LENGTH                             0x3
#define _CLC2CON_LC2MODE_MASK                               0x7
#define _CLC2CON_LC2INTN_POSN                               0x3
#define _CLC2CON_LC2INTN_POSITION                           0x3
#define _CLC2CON_LC2INTN_SIZE                               0x1
#define _CLC2CON_LC2INTN_LENGTH                             0x1
#define _CLC2CON_LC2INTN_MASK                               0x8
#define _CLC2CON_LC2INTP_POSN                               0x4
#define _CLC2CON_LC2INTP_POSITION                           0x4
#define _CLC2CON_LC2INTP_SIZE                               0x1
#define _CLC2CON_LC2INTP_LENGTH                             0x1
#define _CLC2CON_LC2INTP_MASK                               0x10
#define _CLC2CON_LC2OUT_POSN                                0x5
#define _CLC2CON_LC2OUT_POSITION                            0x5
#define _CLC2CON_LC2OUT_SIZE                                0x1
#define _CLC2CON_LC2OUT_LENGTH                              0x1
#define _CLC2CON_LC2OUT_MASK                                0x20
#define _CLC2CON_LC2EN_POSN                                 0x7
#define _CLC2CON_LC2EN_POSITION                             0x7
#define _CLC2CON_LC2EN_SIZE                                 0x1
#define _CLC2CON_LC2EN_LENGTH                               0x1
#define _CLC2CON_LC2EN_MASK                                 0x80
#define _CLC2CON_LC2MODE0_POSN                              0x0
#define _CLC2CON_LC2MODE0_POSITION                          0x0
#define _CLC2CON_LC2MODE0_SIZE                              0x1
#define _CLC2CON_LC2MODE0_LENGTH                            0x1
#define _CLC2CON_LC2MODE0_MASK                              0x1
#define _CLC2CON_LC2MODE1_POSN                              0x1
#define _CLC2CON_LC2MODE1_POSITION                          0x1
#define _CLC2CON_LC2MODE1_SIZE                              0x1
#define _CLC2CON_LC2MODE1_LENGTH                            0x1
#define _CLC2CON_LC2MODE1_MASK                              0x2
#define _CLC2CON_LC2MODE2_POSN                              0x2
#define _CLC2CON_LC2MODE2_POSITION                          0x2
#define _CLC2CON_LC2MODE2_SIZE                              0x1
#define _CLC2CON_LC2MODE2_LENGTH                            0x1
#define _CLC2CON_LC2MODE2_MASK                              0x4
#define _CLC2CON_MODE_POSN                                  0x0
#define _CLC2CON_MODE_POSITION                              0x0
#define _CLC2CON_MODE_SIZE                                  0x3
#define _CLC2CON_MODE_LENGTH                                0x3
#define _CLC2CON_MODE_MASK                                  0x7
#define _CLC2CON_INTN_POSN                                  0x3
#define _CLC2CON_INTN_POSITION                              0x3
#define _CLC2CON_INTN_SIZE                                  0x1
#define _CLC2CON_INTN_LENGTH                                0x1
#define _CLC2CON_INTN_MASK                                  0x8
#define _CLC2CON_INTP_POSN                                  0x4
#define _CLC2CON_INTP_POSITION                              0x4
#define _CLC2CON_INTP_SIZE                                  0x1
#define _CLC2CON_INTP_LENGTH                                0x1
#define _CLC2CON_INTP_MASK                                  0x10
#define _CLC2CON_OUT_POSN                                   0x5
#define _CLC2CON_OUT_POSITION                               0x5
#define _CLC2CON_OUT_SIZE                                   0x1
#define _CLC2CON_OUT_LENGTH                                 0x1
#define _CLC2CON_OUT_MASK                                   0x20
#define _CLC2CON_EN_POSN                                    0x7
#define _CLC2CON_EN_POSITION                                0x7
#define _CLC2CON_EN_SIZE                                    0x1
#define _CLC2CON_EN_LENGTH                                  0x1
#define _CLC2CON_EN_MASK                                    0x80
#define _CLC2CON_MODE0_POSN                                 0x0
#define _CLC2CON_MODE0_POSITION                             0x0
#define _CLC2CON_MODE0_SIZE                                 0x1
#define _CLC2CON_MODE0_LENGTH                               0x1
#define _CLC2CON_MODE0_MASK                                 0x1
#define _CLC2CON_MODE1_POSN                                 0x1
#define _CLC2CON_MODE1_POSITION                             0x1
#define _CLC2CON_MODE1_SIZE                                 0x1
#define _CLC2CON_MODE1_LENGTH                               0x1
#define _CLC2CON_MODE1_MASK                                 0x2
#define _CLC2CON_MODE2_POSN                                 0x2
#define _CLC2CON_MODE2_POSITION                             0x2
#define _CLC2CON_MODE2_SIZE                                 0x1
#define _CLC2CON_MODE2_LENGTH                               0x1
#define _CLC2CON_MODE2_MASK                                 0x4

// Register: CLC2POL
extern volatile unsigned char           CLC2POL             @ 0xF1B;
#ifndef _LIB_BUILD
asm("CLC2POL equ 0F1Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC2G1POL               :1;
        unsigned LC2G2POL               :1;
        unsigned LC2G3POL               :1;
        unsigned LC2G4POL               :1;
        unsigned                        :3;
        unsigned LC2POL                 :1;
    };
    struct {
        unsigned G1POL                  :1;
        unsigned G2POL                  :1;
        unsigned G3POL                  :1;
        unsigned G4POL                  :1;
        unsigned                        :3;
        unsigned POL                    :1;
    };
} CLC2POLbits_t;
extern volatile CLC2POLbits_t CLC2POLbits @ 0xF1B;
// bitfield macros
#define _CLC2POL_LC2G1POL_POSN                              0x0
#define _CLC2POL_LC2G1POL_POSITION                          0x0
#define _CLC2POL_LC2G1POL_SIZE                              0x1
#define _CLC2POL_LC2G1POL_LENGTH                            0x1
#define _CLC2POL_LC2G1POL_MASK                              0x1
#define _CLC2POL_LC2G2POL_POSN                              0x1
#define _CLC2POL_LC2G2POL_POSITION                          0x1
#define _CLC2POL_LC2G2POL_SIZE                              0x1
#define _CLC2POL_LC2G2POL_LENGTH                            0x1
#define _CLC2POL_LC2G2POL_MASK                              0x2
#define _CLC2POL_LC2G3POL_POSN                              0x2
#define _CLC2POL_LC2G3POL_POSITION                          0x2
#define _CLC2POL_LC2G3POL_SIZE                              0x1
#define _CLC2POL_LC2G3POL_LENGTH                            0x1
#define _CLC2POL_LC2G3POL_MASK                              0x4
#define _CLC2POL_LC2G4POL_POSN                              0x3
#define _CLC2POL_LC2G4POL_POSITION                          0x3
#define _CLC2POL_LC2G4POL_SIZE                              0x1
#define _CLC2POL_LC2G4POL_LENGTH                            0x1
#define _CLC2POL_LC2G4POL_MASK                              0x8
#define _CLC2POL_LC2POL_POSN                                0x7
#define _CLC2POL_LC2POL_POSITION                            0x7
#define _CLC2POL_LC2POL_SIZE                                0x1
#define _CLC2POL_LC2POL_LENGTH                              0x1
#define _CLC2POL_LC2POL_MASK                                0x80
#define _CLC2POL_G1POL_POSN                                 0x0
#define _CLC2POL_G1POL_POSITION                             0x0
#define _CLC2POL_G1POL_SIZE                                 0x1
#define _CLC2POL_G1POL_LENGTH                               0x1
#define _CLC2POL_G1POL_MASK                                 0x1
#define _CLC2POL_G2POL_POSN                                 0x1
#define _CLC2POL_G2POL_POSITION                             0x1
#define _CLC2POL_G2POL_SIZE                                 0x1
#define _CLC2POL_G2POL_LENGTH                               0x1
#define _CLC2POL_G2POL_MASK                                 0x2
#define _CLC2POL_G3POL_POSN                                 0x2
#define _CLC2POL_G3POL_POSITION                             0x2
#define _CLC2POL_G3POL_SIZE                                 0x1
#define _CLC2POL_G3POL_LENGTH                               0x1
#define _CLC2POL_G3POL_MASK                                 0x4
#define _CLC2POL_G4POL_POSN                                 0x3
#define _CLC2POL_G4POL_POSITION                             0x3
#define _CLC2POL_G4POL_SIZE                                 0x1
#define _CLC2POL_G4POL_LENGTH                               0x1
#define _CLC2POL_G4POL_MASK                                 0x8
#define _CLC2POL_POL_POSN                                   0x7
#define _CLC2POL_POL_POSITION                               0x7
#define _CLC2POL_POL_SIZE                                   0x1
#define _CLC2POL_POL_LENGTH                                 0x1
#define _CLC2POL_POL_MASK                                   0x80

// Register: CLC2SEL0
extern volatile unsigned char           CLC2SEL0            @ 0xF1C;
#ifndef _LIB_BUILD
asm("CLC2SEL0 equ 0F1Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC2D1S0                :1;
        unsigned LC2D1S1                :1;
        unsigned LC2D1S2                :1;
        unsigned LC2D1S3                :1;
        unsigned LC2D1S4                :1;
        unsigned LC2D1S5                :1;
    };
    struct {
        unsigned LC2D1S                 :8;
    };
    struct {
        unsigned D1S                    :8;
    };
    struct {
        unsigned D1S0                   :1;
        unsigned D1S1                   :1;
        unsigned D1S2                   :1;
        unsigned D1S3                   :1;
        unsigned D1S4                   :1;
        unsigned D1S5                   :1;
    };
} CLC2SEL0bits_t;
extern volatile CLC2SEL0bits_t CLC2SEL0bits @ 0xF1C;
// bitfield macros
#define _CLC2SEL0_LC2D1S0_POSN                              0x0
#define _CLC2SEL0_LC2D1S0_POSITION                          0x0
#define _CLC2SEL0_LC2D1S0_SIZE                              0x1
#define _CLC2SEL0_LC2D1S0_LENGTH                            0x1
#define _CLC2SEL0_LC2D1S0_MASK                              0x1
#define _CLC2SEL0_LC2D1S1_POSN                              0x1
#define _CLC2SEL0_LC2D1S1_POSITION                          0x1
#define _CLC2SEL0_LC2D1S1_SIZE                              0x1
#define _CLC2SEL0_LC2D1S1_LENGTH                            0x1
#define _CLC2SEL0_LC2D1S1_MASK                              0x2
#define _CLC2SEL0_LC2D1S2_POSN                              0x2
#define _CLC2SEL0_LC2D1S2_POSITION                          0x2
#define _CLC2SEL0_LC2D1S2_SIZE                              0x1
#define _CLC2SEL0_LC2D1S2_LENGTH                            0x1
#define _CLC2SEL0_LC2D1S2_MASK                              0x4
#define _CLC2SEL0_LC2D1S3_POSN                              0x3
#define _CLC2SEL0_LC2D1S3_POSITION                          0x3
#define _CLC2SEL0_LC2D1S3_SIZE                              0x1
#define _CLC2SEL0_LC2D1S3_LENGTH                            0x1
#define _CLC2SEL0_LC2D1S3_MASK                              0x8
#define _CLC2SEL0_LC2D1S4_POSN                              0x4
#define _CLC2SEL0_LC2D1S4_POSITION                          0x4
#define _CLC2SEL0_LC2D1S4_SIZE                              0x1
#define _CLC2SEL0_LC2D1S4_LENGTH                            0x1
#define _CLC2SEL0_LC2D1S4_MASK                              0x10
#define _CLC2SEL0_LC2D1S5_POSN                              0x5
#define _CLC2SEL0_LC2D1S5_POSITION                          0x5
#define _CLC2SEL0_LC2D1S5_SIZE                              0x1
#define _CLC2SEL0_LC2D1S5_LENGTH                            0x1
#define _CLC2SEL0_LC2D1S5_MASK                              0x20
#define _CLC2SEL0_LC2D1S_POSN                               0x0
#define _CLC2SEL0_LC2D1S_POSITION                           0x0
#define _CLC2SEL0_LC2D1S_SIZE                               0x8
#define _CLC2SEL0_LC2D1S_LENGTH                             0x8
#define _CLC2SEL0_LC2D1S_MASK                               0xFF
#define _CLC2SEL0_D1S_POSN                                  0x0
#define _CLC2SEL0_D1S_POSITION                              0x0
#define _CLC2SEL0_D1S_SIZE                                  0x8
#define _CLC2SEL0_D1S_LENGTH                                0x8
#define _CLC2SEL0_D1S_MASK                                  0xFF
#define _CLC2SEL0_D1S0_POSN                                 0x0
#define _CLC2SEL0_D1S0_POSITION                             0x0
#define _CLC2SEL0_D1S0_SIZE                                 0x1
#define _CLC2SEL0_D1S0_LENGTH                               0x1
#define _CLC2SEL0_D1S0_MASK                                 0x1
#define _CLC2SEL0_D1S1_POSN                                 0x1
#define _CLC2SEL0_D1S1_POSITION                             0x1
#define _CLC2SEL0_D1S1_SIZE                                 0x1
#define _CLC2SEL0_D1S1_LENGTH                               0x1
#define _CLC2SEL0_D1S1_MASK                                 0x2
#define _CLC2SEL0_D1S2_POSN                                 0x2
#define _CLC2SEL0_D1S2_POSITION                             0x2
#define _CLC2SEL0_D1S2_SIZE                                 0x1
#define _CLC2SEL0_D1S2_LENGTH                               0x1
#define _CLC2SEL0_D1S2_MASK                                 0x4
#define _CLC2SEL0_D1S3_POSN                                 0x3
#define _CLC2SEL0_D1S3_POSITION                             0x3
#define _CLC2SEL0_D1S3_SIZE                                 0x1
#define _CLC2SEL0_D1S3_LENGTH                               0x1
#define _CLC2SEL0_D1S3_MASK                                 0x8
#define _CLC2SEL0_D1S4_POSN                                 0x4
#define _CLC2SEL0_D1S4_POSITION                             0x4
#define _CLC2SEL0_D1S4_SIZE                                 0x1
#define _CLC2SEL0_D1S4_LENGTH                               0x1
#define _CLC2SEL0_D1S4_MASK                                 0x10
#define _CLC2SEL0_D1S5_POSN                                 0x5
#define _CLC2SEL0_D1S5_POSITION                             0x5
#define _CLC2SEL0_D1S5_SIZE                                 0x1
#define _CLC2SEL0_D1S5_LENGTH                               0x1
#define _CLC2SEL0_D1S5_MASK                                 0x20

// Register: CLC2SEL1
extern volatile unsigned char           CLC2SEL1            @ 0xF1D;
#ifndef _LIB_BUILD
asm("CLC2SEL1 equ 0F1Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC2D2S0                :1;
        unsigned LC2D2S1                :1;
        unsigned LC2D2S2                :1;
        unsigned LC2D2S3                :1;
        unsigned LC2D2S4                :1;
        unsigned LC2D2S5                :1;
    };
    struct {
        unsigned LC2D2S                 :8;
    };
    struct {
        unsigned D2S                    :8;
    };
    struct {
        unsigned D2S0                   :1;
        unsigned D2S1                   :1;
        unsigned D2S2                   :1;
        unsigned D2S3                   :1;
        unsigned D2S4                   :1;
        unsigned D2S5                   :1;
    };
} CLC2SEL1bits_t;
extern volatile CLC2SEL1bits_t CLC2SEL1bits @ 0xF1D;
// bitfield macros
#define _CLC2SEL1_LC2D2S0_POSN                              0x0
#define _CLC2SEL1_LC2D2S0_POSITION                          0x0
#define _CLC2SEL1_LC2D2S0_SIZE                              0x1
#define _CLC2SEL1_LC2D2S0_LENGTH                            0x1
#define _CLC2SEL1_LC2D2S0_MASK                              0x1
#define _CLC2SEL1_LC2D2S1_POSN                              0x1
#define _CLC2SEL1_LC2D2S1_POSITION                          0x1
#define _CLC2SEL1_LC2D2S1_SIZE                              0x1
#define _CLC2SEL1_LC2D2S1_LENGTH                            0x1
#define _CLC2SEL1_LC2D2S1_MASK                              0x2
#define _CLC2SEL1_LC2D2S2_POSN                              0x2
#define _CLC2SEL1_LC2D2S2_POSITION                          0x2
#define _CLC2SEL1_LC2D2S2_SIZE                              0x1
#define _CLC2SEL1_LC2D2S2_LENGTH                            0x1
#define _CLC2SEL1_LC2D2S2_MASK                              0x4
#define _CLC2SEL1_LC2D2S3_POSN                              0x3
#define _CLC2SEL1_LC2D2S3_POSITION                          0x3
#define _CLC2SEL1_LC2D2S3_SIZE                              0x1
#define _CLC2SEL1_LC2D2S3_LENGTH                            0x1
#define _CLC2SEL1_LC2D2S3_MASK                              0x8
#define _CLC2SEL1_LC2D2S4_POSN                              0x4
#define _CLC2SEL1_LC2D2S4_POSITION                          0x4
#define _CLC2SEL1_LC2D2S4_SIZE                              0x1
#define _CLC2SEL1_LC2D2S4_LENGTH                            0x1
#define _CLC2SEL1_LC2D2S4_MASK                              0x10
#define _CLC2SEL1_LC2D2S5_POSN                              0x5
#define _CLC2SEL1_LC2D2S5_POSITION                          0x5
#define _CLC2SEL1_LC2D2S5_SIZE                              0x1
#define _CLC2SEL1_LC2D2S5_LENGTH                            0x1
#define _CLC2SEL1_LC2D2S5_MASK                              0x20
#define _CLC2SEL1_LC2D2S_POSN                               0x0
#define _CLC2SEL1_LC2D2S_POSITION                           0x0
#define _CLC2SEL1_LC2D2S_SIZE                               0x8
#define _CLC2SEL1_LC2D2S_LENGTH                             0x8
#define _CLC2SEL1_LC2D2S_MASK                               0xFF
#define _CLC2SEL1_D2S_POSN                                  0x0
#define _CLC2SEL1_D2S_POSITION                              0x0
#define _CLC2SEL1_D2S_SIZE                                  0x8
#define _CLC2SEL1_D2S_LENGTH                                0x8
#define _CLC2SEL1_D2S_MASK                                  0xFF
#define _CLC2SEL1_D2S0_POSN                                 0x0
#define _CLC2SEL1_D2S0_POSITION                             0x0
#define _CLC2SEL1_D2S0_SIZE                                 0x1
#define _CLC2SEL1_D2S0_LENGTH                               0x1
#define _CLC2SEL1_D2S0_MASK                                 0x1
#define _CLC2SEL1_D2S1_POSN                                 0x1
#define _CLC2SEL1_D2S1_POSITION                             0x1
#define _CLC2SEL1_D2S1_SIZE                                 0x1
#define _CLC2SEL1_D2S1_LENGTH                               0x1
#define _CLC2SEL1_D2S1_MASK                                 0x2
#define _CLC2SEL1_D2S2_POSN                                 0x2
#define _CLC2SEL1_D2S2_POSITION                             0x2
#define _CLC2SEL1_D2S2_SIZE                                 0x1
#define _CLC2SEL1_D2S2_LENGTH                               0x1
#define _CLC2SEL1_D2S2_MASK                                 0x4
#define _CLC2SEL1_D2S3_POSN                                 0x3
#define _CLC2SEL1_D2S3_POSITION                             0x3
#define _CLC2SEL1_D2S3_SIZE                                 0x1
#define _CLC2SEL1_D2S3_LENGTH                               0x1
#define _CLC2SEL1_D2S3_MASK                                 0x8
#define _CLC2SEL1_D2S4_POSN                                 0x4
#define _CLC2SEL1_D2S4_POSITION                             0x4
#define _CLC2SEL1_D2S4_SIZE                                 0x1
#define _CLC2SEL1_D2S4_LENGTH                               0x1
#define _CLC2SEL1_D2S4_MASK                                 0x10
#define _CLC2SEL1_D2S5_POSN                                 0x5
#define _CLC2SEL1_D2S5_POSITION                             0x5
#define _CLC2SEL1_D2S5_SIZE                                 0x1
#define _CLC2SEL1_D2S5_LENGTH                               0x1
#define _CLC2SEL1_D2S5_MASK                                 0x20

// Register: CLC2SEL2
extern volatile unsigned char           CLC2SEL2            @ 0xF1E;
#ifndef _LIB_BUILD
asm("CLC2SEL2 equ 0F1Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC2D3S0                :1;
        unsigned LC2D3S1                :1;
        unsigned LC2D3S2                :1;
        unsigned LC2D3S3                :1;
        unsigned LC2D3S4                :1;
        unsigned LC2D3S5                :1;
    };
    struct {
        unsigned LC2D3S                 :8;
    };
    struct {
        unsigned D3S                    :8;
    };
    struct {
        unsigned D3S0                   :1;
        unsigned D3S1                   :1;
        unsigned D3S2                   :1;
        unsigned D3S3                   :1;
        unsigned D3S4                   :1;
        unsigned D3S5                   :1;
    };
} CLC2SEL2bits_t;
extern volatile CLC2SEL2bits_t CLC2SEL2bits @ 0xF1E;
// bitfield macros
#define _CLC2SEL2_LC2D3S0_POSN                              0x0
#define _CLC2SEL2_LC2D3S0_POSITION                          0x0
#define _CLC2SEL2_LC2D3S0_SIZE                              0x1
#define _CLC2SEL2_LC2D3S0_LENGTH                            0x1
#define _CLC2SEL2_LC2D3S0_MASK                              0x1
#define _CLC2SEL2_LC2D3S1_POSN                              0x1
#define _CLC2SEL2_LC2D3S1_POSITION                          0x1
#define _CLC2SEL2_LC2D3S1_SIZE                              0x1
#define _CLC2SEL2_LC2D3S1_LENGTH                            0x1
#define _CLC2SEL2_LC2D3S1_MASK                              0x2
#define _CLC2SEL2_LC2D3S2_POSN                              0x2
#define _CLC2SEL2_LC2D3S2_POSITION                          0x2
#define _CLC2SEL2_LC2D3S2_SIZE                              0x1
#define _CLC2SEL2_LC2D3S2_LENGTH                            0x1
#define _CLC2SEL2_LC2D3S2_MASK                              0x4
#define _CLC2SEL2_LC2D3S3_POSN                              0x3
#define _CLC2SEL2_LC2D3S3_POSITION                          0x3
#define _CLC2SEL2_LC2D3S3_SIZE                              0x1
#define _CLC2SEL2_LC2D3S3_LENGTH                            0x1
#define _CLC2SEL2_LC2D3S3_MASK                              0x8
#define _CLC2SEL2_LC2D3S4_POSN                              0x4
#define _CLC2SEL2_LC2D3S4_POSITION                          0x4
#define _CLC2SEL2_LC2D3S4_SIZE                              0x1
#define _CLC2SEL2_LC2D3S4_LENGTH                            0x1
#define _CLC2SEL2_LC2D3S4_MASK                              0x10
#define _CLC2SEL2_LC2D3S5_POSN                              0x5
#define _CLC2SEL2_LC2D3S5_POSITION                          0x5
#define _CLC2SEL2_LC2D3S5_SIZE                              0x1
#define _CLC2SEL2_LC2D3S5_LENGTH                            0x1
#define _CLC2SEL2_LC2D3S5_MASK                              0x20
#define _CLC2SEL2_LC2D3S_POSN                               0x0
#define _CLC2SEL2_LC2D3S_POSITION                           0x0
#define _CLC2SEL2_LC2D3S_SIZE                               0x8
#define _CLC2SEL2_LC2D3S_LENGTH                             0x8
#define _CLC2SEL2_LC2D3S_MASK                               0xFF
#define _CLC2SEL2_D3S_POSN                                  0x0
#define _CLC2SEL2_D3S_POSITION                              0x0
#define _CLC2SEL2_D3S_SIZE                                  0x8
#define _CLC2SEL2_D3S_LENGTH                                0x8
#define _CLC2SEL2_D3S_MASK                                  0xFF
#define _CLC2SEL2_D3S0_POSN                                 0x0
#define _CLC2SEL2_D3S0_POSITION                             0x0
#define _CLC2SEL2_D3S0_SIZE                                 0x1
#define _CLC2SEL2_D3S0_LENGTH                               0x1
#define _CLC2SEL2_D3S0_MASK                                 0x1
#define _CLC2SEL2_D3S1_POSN                                 0x1
#define _CLC2SEL2_D3S1_POSITION                             0x1
#define _CLC2SEL2_D3S1_SIZE                                 0x1
#define _CLC2SEL2_D3S1_LENGTH                               0x1
#define _CLC2SEL2_D3S1_MASK                                 0x2
#define _CLC2SEL2_D3S2_POSN                                 0x2
#define _CLC2SEL2_D3S2_POSITION                             0x2
#define _CLC2SEL2_D3S2_SIZE                                 0x1
#define _CLC2SEL2_D3S2_LENGTH                               0x1
#define _CLC2SEL2_D3S2_MASK                                 0x4
#define _CLC2SEL2_D3S3_POSN                                 0x3
#define _CLC2SEL2_D3S3_POSITION                             0x3
#define _CLC2SEL2_D3S3_SIZE                                 0x1
#define _CLC2SEL2_D3S3_LENGTH                               0x1
#define _CLC2SEL2_D3S3_MASK                                 0x8
#define _CLC2SEL2_D3S4_POSN                                 0x4
#define _CLC2SEL2_D3S4_POSITION                             0x4
#define _CLC2SEL2_D3S4_SIZE                                 0x1
#define _CLC2SEL2_D3S4_LENGTH                               0x1
#define _CLC2SEL2_D3S4_MASK                                 0x10
#define _CLC2SEL2_D3S5_POSN                                 0x5
#define _CLC2SEL2_D3S5_POSITION                             0x5
#define _CLC2SEL2_D3S5_SIZE                                 0x1
#define _CLC2SEL2_D3S5_LENGTH                               0x1
#define _CLC2SEL2_D3S5_MASK                                 0x20

// Register: CLC2SEL3
extern volatile unsigned char           CLC2SEL3            @ 0xF1F;
#ifndef _LIB_BUILD
asm("CLC2SEL3 equ 0F1Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC2D4S0                :1;
        unsigned LC2D4S1                :1;
        unsigned LC2D4S2                :1;
        unsigned LC2D4S3                :1;
        unsigned LC2D4S4                :1;
        unsigned LC2D4S5                :1;
    };
    struct {
        unsigned LC2D4S                 :8;
    };
    struct {
        unsigned D4S                    :8;
    };
    struct {
        unsigned D4S0                   :1;
        unsigned D4S1                   :1;
        unsigned D4S2                   :1;
        unsigned D4S3                   :1;
        unsigned D4S4                   :1;
        unsigned D4S5                   :1;
    };
} CLC2SEL3bits_t;
extern volatile CLC2SEL3bits_t CLC2SEL3bits @ 0xF1F;
// bitfield macros
#define _CLC2SEL3_LC2D4S0_POSN                              0x0
#define _CLC2SEL3_LC2D4S0_POSITION                          0x0
#define _CLC2SEL3_LC2D4S0_SIZE                              0x1
#define _CLC2SEL3_LC2D4S0_LENGTH                            0x1
#define _CLC2SEL3_LC2D4S0_MASK                              0x1
#define _CLC2SEL3_LC2D4S1_POSN                              0x1
#define _CLC2SEL3_LC2D4S1_POSITION                          0x1
#define _CLC2SEL3_LC2D4S1_SIZE                              0x1
#define _CLC2SEL3_LC2D4S1_LENGTH                            0x1
#define _CLC2SEL3_LC2D4S1_MASK                              0x2
#define _CLC2SEL3_LC2D4S2_POSN                              0x2
#define _CLC2SEL3_LC2D4S2_POSITION                          0x2
#define _CLC2SEL3_LC2D4S2_SIZE                              0x1
#define _CLC2SEL3_LC2D4S2_LENGTH                            0x1
#define _CLC2SEL3_LC2D4S2_MASK                              0x4
#define _CLC2SEL3_LC2D4S3_POSN                              0x3
#define _CLC2SEL3_LC2D4S3_POSITION                          0x3
#define _CLC2SEL3_LC2D4S3_SIZE                              0x1
#define _CLC2SEL3_LC2D4S3_LENGTH                            0x1
#define _CLC2SEL3_LC2D4S3_MASK                              0x8
#define _CLC2SEL3_LC2D4S4_POSN                              0x4
#define _CLC2SEL3_LC2D4S4_POSITION                          0x4
#define _CLC2SEL3_LC2D4S4_SIZE                              0x1
#define _CLC2SEL3_LC2D4S4_LENGTH                            0x1
#define _CLC2SEL3_LC2D4S4_MASK                              0x10
#define _CLC2SEL3_LC2D4S5_POSN                              0x5
#define _CLC2SEL3_LC2D4S5_POSITION                          0x5
#define _CLC2SEL3_LC2D4S5_SIZE                              0x1
#define _CLC2SEL3_LC2D4S5_LENGTH                            0x1
#define _CLC2SEL3_LC2D4S5_MASK                              0x20
#define _CLC2SEL3_LC2D4S_POSN                               0x0
#define _CLC2SEL3_LC2D4S_POSITION                           0x0
#define _CLC2SEL3_LC2D4S_SIZE                               0x8
#define _CLC2SEL3_LC2D4S_LENGTH                             0x8
#define _CLC2SEL3_LC2D4S_MASK                               0xFF
#define _CLC2SEL3_D4S_POSN                                  0x0
#define _CLC2SEL3_D4S_POSITION                              0x0
#define _CLC2SEL3_D4S_SIZE                                  0x8
#define _CLC2SEL3_D4S_LENGTH                                0x8
#define _CLC2SEL3_D4S_MASK                                  0xFF
#define _CLC2SEL3_D4S0_POSN                                 0x0
#define _CLC2SEL3_D4S0_POSITION                             0x0
#define _CLC2SEL3_D4S0_SIZE                                 0x1
#define _CLC2SEL3_D4S0_LENGTH                               0x1
#define _CLC2SEL3_D4S0_MASK                                 0x1
#define _CLC2SEL3_D4S1_POSN                                 0x1
#define _CLC2SEL3_D4S1_POSITION                             0x1
#define _CLC2SEL3_D4S1_SIZE                                 0x1
#define _CLC2SEL3_D4S1_LENGTH                               0x1
#define _CLC2SEL3_D4S1_MASK                                 0x2
#define _CLC2SEL3_D4S2_POSN                                 0x2
#define _CLC2SEL3_D4S2_POSITION                             0x2
#define _CLC2SEL3_D4S2_SIZE                                 0x1
#define _CLC2SEL3_D4S2_LENGTH                               0x1
#define _CLC2SEL3_D4S2_MASK                                 0x4
#define _CLC2SEL3_D4S3_POSN                                 0x3
#define _CLC2SEL3_D4S3_POSITION                             0x3
#define _CLC2SEL3_D4S3_SIZE                                 0x1
#define _CLC2SEL3_D4S3_LENGTH                               0x1
#define _CLC2SEL3_D4S3_MASK                                 0x8
#define _CLC2SEL3_D4S4_POSN                                 0x4
#define _CLC2SEL3_D4S4_POSITION                             0x4
#define _CLC2SEL3_D4S4_SIZE                                 0x1
#define _CLC2SEL3_D4S4_LENGTH                               0x1
#define _CLC2SEL3_D4S4_MASK                                 0x10
#define _CLC2SEL3_D4S5_POSN                                 0x5
#define _CLC2SEL3_D4S5_POSITION                             0x5
#define _CLC2SEL3_D4S5_SIZE                                 0x1
#define _CLC2SEL3_D4S5_LENGTH                               0x1
#define _CLC2SEL3_D4S5_MASK                                 0x20

// Register: CLC2GLS0
extern volatile unsigned char           CLC2GLS0            @ 0xF20;
#ifndef _LIB_BUILD
asm("CLC2GLS0 equ 0F20h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC2G1D1N               :1;
        unsigned LC2G1D1T               :1;
        unsigned LC2G1D2N               :1;
        unsigned LC2G1D2T               :1;
        unsigned LC2G1D3N               :1;
        unsigned LC2G1D3T               :1;
        unsigned LC2G1D4N               :1;
        unsigned LC2G1D4T               :1;
    };
    struct {
        unsigned D1N                    :1;
        unsigned D1T                    :1;
        unsigned D2N                    :1;
        unsigned D2T                    :1;
        unsigned D3N                    :1;
        unsigned D3T                    :1;
        unsigned D4N                    :1;
        unsigned D4T                    :1;
    };
} CLC2GLS0bits_t;
extern volatile CLC2GLS0bits_t CLC2GLS0bits @ 0xF20;
// bitfield macros
#define _CLC2GLS0_LC2G1D1N_POSN                             0x0
#define _CLC2GLS0_LC2G1D1N_POSITION                         0x0
#define _CLC2GLS0_LC2G1D1N_SIZE                             0x1
#define _CLC2GLS0_LC2G1D1N_LENGTH                           0x1
#define _CLC2GLS0_LC2G1D1N_MASK                             0x1
#define _CLC2GLS0_LC2G1D1T_POSN                             0x1
#define _CLC2GLS0_LC2G1D1T_POSITION                         0x1
#define _CLC2GLS0_LC2G1D1T_SIZE                             0x1
#define _CLC2GLS0_LC2G1D1T_LENGTH                           0x1
#define _CLC2GLS0_LC2G1D1T_MASK                             0x2
#define _CLC2GLS0_LC2G1D2N_POSN                             0x2
#define _CLC2GLS0_LC2G1D2N_POSITION                         0x2
#define _CLC2GLS0_LC2G1D2N_SIZE                             0x1
#define _CLC2GLS0_LC2G1D2N_LENGTH                           0x1
#define _CLC2GLS0_LC2G1D2N_MASK                             0x4
#define _CLC2GLS0_LC2G1D2T_POSN                             0x3
#define _CLC2GLS0_LC2G1D2T_POSITION                         0x3
#define _CLC2GLS0_LC2G1D2T_SIZE                             0x1
#define _CLC2GLS0_LC2G1D2T_LENGTH                           0x1
#define _CLC2GLS0_LC2G1D2T_MASK                             0x8
#define _CLC2GLS0_LC2G1D3N_POSN                             0x4
#define _CLC2GLS0_LC2G1D3N_POSITION                         0x4
#define _CLC2GLS0_LC2G1D3N_SIZE                             0x1
#define _CLC2GLS0_LC2G1D3N_LENGTH                           0x1
#define _CLC2GLS0_LC2G1D3N_MASK                             0x10
#define _CLC2GLS0_LC2G1D3T_POSN                             0x5
#define _CLC2GLS0_LC2G1D3T_POSITION                         0x5
#define _CLC2GLS0_LC2G1D3T_SIZE                             0x1
#define _CLC2GLS0_LC2G1D3T_LENGTH                           0x1
#define _CLC2GLS0_LC2G1D3T_MASK                             0x20
#define _CLC2GLS0_LC2G1D4N_POSN                             0x6
#define _CLC2GLS0_LC2G1D4N_POSITION                         0x6
#define _CLC2GLS0_LC2G1D4N_SIZE                             0x1
#define _CLC2GLS0_LC2G1D4N_LENGTH                           0x1
#define _CLC2GLS0_LC2G1D4N_MASK                             0x40
#define _CLC2GLS0_LC2G1D4T_POSN                             0x7
#define _CLC2GLS0_LC2G1D4T_POSITION                         0x7
#define _CLC2GLS0_LC2G1D4T_SIZE                             0x1
#define _CLC2GLS0_LC2G1D4T_LENGTH                           0x1
#define _CLC2GLS0_LC2G1D4T_MASK                             0x80
#define _CLC2GLS0_D1N_POSN                                  0x0
#define _CLC2GLS0_D1N_POSITION                              0x0
#define _CLC2GLS0_D1N_SIZE                                  0x1
#define _CLC2GLS0_D1N_LENGTH                                0x1
#define _CLC2GLS0_D1N_MASK                                  0x1
#define _CLC2GLS0_D1T_POSN                                  0x1
#define _CLC2GLS0_D1T_POSITION                              0x1
#define _CLC2GLS0_D1T_SIZE                                  0x1
#define _CLC2GLS0_D1T_LENGTH                                0x1
#define _CLC2GLS0_D1T_MASK                                  0x2
#define _CLC2GLS0_D2N_POSN                                  0x2
#define _CLC2GLS0_D2N_POSITION                              0x2
#define _CLC2GLS0_D2N_SIZE                                  0x1
#define _CLC2GLS0_D2N_LENGTH                                0x1
#define _CLC2GLS0_D2N_MASK                                  0x4
#define _CLC2GLS0_D2T_POSN                                  0x3
#define _CLC2GLS0_D2T_POSITION                              0x3
#define _CLC2GLS0_D2T_SIZE                                  0x1
#define _CLC2GLS0_D2T_LENGTH                                0x1
#define _CLC2GLS0_D2T_MASK                                  0x8
#define _CLC2GLS0_D3N_POSN                                  0x4
#define _CLC2GLS0_D3N_POSITION                              0x4
#define _CLC2GLS0_D3N_SIZE                                  0x1
#define _CLC2GLS0_D3N_LENGTH                                0x1
#define _CLC2GLS0_D3N_MASK                                  0x10
#define _CLC2GLS0_D3T_POSN                                  0x5
#define _CLC2GLS0_D3T_POSITION                              0x5
#define _CLC2GLS0_D3T_SIZE                                  0x1
#define _CLC2GLS0_D3T_LENGTH                                0x1
#define _CLC2GLS0_D3T_MASK                                  0x20
#define _CLC2GLS0_D4N_POSN                                  0x6
#define _CLC2GLS0_D4N_POSITION                              0x6
#define _CLC2GLS0_D4N_SIZE                                  0x1
#define _CLC2GLS0_D4N_LENGTH                                0x1
#define _CLC2GLS0_D4N_MASK                                  0x40
#define _CLC2GLS0_D4T_POSN                                  0x7
#define _CLC2GLS0_D4T_POSITION                              0x7
#define _CLC2GLS0_D4T_SIZE                                  0x1
#define _CLC2GLS0_D4T_LENGTH                                0x1
#define _CLC2GLS0_D4T_MASK                                  0x80

// Register: CLC2GLS1
extern volatile unsigned char           CLC2GLS1            @ 0xF21;
#ifndef _LIB_BUILD
asm("CLC2GLS1 equ 0F21h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC2G2D1N               :1;
        unsigned LC2G2D1T               :1;
        unsigned LC2G2D2N               :1;
        unsigned LC2G2D2T               :1;
        unsigned LC2G2D3N               :1;
        unsigned LC2G2D3T               :1;
        unsigned LC2G2D4N               :1;
        unsigned LC2G2D4T               :1;
    };
    struct {
        unsigned D1N                    :1;
        unsigned D1T                    :1;
        unsigned D2N                    :1;
        unsigned D2T                    :1;
        unsigned D3N                    :1;
        unsigned D3T                    :1;
        unsigned D4N                    :1;
        unsigned D4T                    :1;
    };
} CLC2GLS1bits_t;
extern volatile CLC2GLS1bits_t CLC2GLS1bits @ 0xF21;
// bitfield macros
#define _CLC2GLS1_LC2G2D1N_POSN                             0x0
#define _CLC2GLS1_LC2G2D1N_POSITION                         0x0
#define _CLC2GLS1_LC2G2D1N_SIZE                             0x1
#define _CLC2GLS1_LC2G2D1N_LENGTH                           0x1
#define _CLC2GLS1_LC2G2D1N_MASK                             0x1
#define _CLC2GLS1_LC2G2D1T_POSN                             0x1
#define _CLC2GLS1_LC2G2D1T_POSITION                         0x1
#define _CLC2GLS1_LC2G2D1T_SIZE                             0x1
#define _CLC2GLS1_LC2G2D1T_LENGTH                           0x1
#define _CLC2GLS1_LC2G2D1T_MASK                             0x2
#define _CLC2GLS1_LC2G2D2N_POSN                             0x2
#define _CLC2GLS1_LC2G2D2N_POSITION                         0x2
#define _CLC2GLS1_LC2G2D2N_SIZE                             0x1
#define _CLC2GLS1_LC2G2D2N_LENGTH                           0x1
#define _CLC2GLS1_LC2G2D2N_MASK                             0x4
#define _CLC2GLS1_LC2G2D2T_POSN                             0x3
#define _CLC2GLS1_LC2G2D2T_POSITION                         0x3
#define _CLC2GLS1_LC2G2D2T_SIZE                             0x1
#define _CLC2GLS1_LC2G2D2T_LENGTH                           0x1
#define _CLC2GLS1_LC2G2D2T_MASK                             0x8
#define _CLC2GLS1_LC2G2D3N_POSN                             0x4
#define _CLC2GLS1_LC2G2D3N_POSITION                         0x4
#define _CLC2GLS1_LC2G2D3N_SIZE                             0x1
#define _CLC2GLS1_LC2G2D3N_LENGTH                           0x1
#define _CLC2GLS1_LC2G2D3N_MASK                             0x10
#define _CLC2GLS1_LC2G2D3T_POSN                             0x5
#define _CLC2GLS1_LC2G2D3T_POSITION                         0x5
#define _CLC2GLS1_LC2G2D3T_SIZE                             0x1
#define _CLC2GLS1_LC2G2D3T_LENGTH                           0x1
#define _CLC2GLS1_LC2G2D3T_MASK                             0x20
#define _CLC2GLS1_LC2G2D4N_POSN                             0x6
#define _CLC2GLS1_LC2G2D4N_POSITION                         0x6
#define _CLC2GLS1_LC2G2D4N_SIZE                             0x1
#define _CLC2GLS1_LC2G2D4N_LENGTH                           0x1
#define _CLC2GLS1_LC2G2D4N_MASK                             0x40
#define _CLC2GLS1_LC2G2D4T_POSN                             0x7
#define _CLC2GLS1_LC2G2D4T_POSITION                         0x7
#define _CLC2GLS1_LC2G2D4T_SIZE                             0x1
#define _CLC2GLS1_LC2G2D4T_LENGTH                           0x1
#define _CLC2GLS1_LC2G2D4T_MASK                             0x80
#define _CLC2GLS1_D1N_POSN                                  0x0
#define _CLC2GLS1_D1N_POSITION                              0x0
#define _CLC2GLS1_D1N_SIZE                                  0x1
#define _CLC2GLS1_D1N_LENGTH                                0x1
#define _CLC2GLS1_D1N_MASK                                  0x1
#define _CLC2GLS1_D1T_POSN                                  0x1
#define _CLC2GLS1_D1T_POSITION                              0x1
#define _CLC2GLS1_D1T_SIZE                                  0x1
#define _CLC2GLS1_D1T_LENGTH                                0x1
#define _CLC2GLS1_D1T_MASK                                  0x2
#define _CLC2GLS1_D2N_POSN                                  0x2
#define _CLC2GLS1_D2N_POSITION                              0x2
#define _CLC2GLS1_D2N_SIZE                                  0x1
#define _CLC2GLS1_D2N_LENGTH                                0x1
#define _CLC2GLS1_D2N_MASK                                  0x4
#define _CLC2GLS1_D2T_POSN                                  0x3
#define _CLC2GLS1_D2T_POSITION                              0x3
#define _CLC2GLS1_D2T_SIZE                                  0x1
#define _CLC2GLS1_D2T_LENGTH                                0x1
#define _CLC2GLS1_D2T_MASK                                  0x8
#define _CLC2GLS1_D3N_POSN                                  0x4
#define _CLC2GLS1_D3N_POSITION                              0x4
#define _CLC2GLS1_D3N_SIZE                                  0x1
#define _CLC2GLS1_D3N_LENGTH                                0x1
#define _CLC2GLS1_D3N_MASK                                  0x10
#define _CLC2GLS1_D3T_POSN                                  0x5
#define _CLC2GLS1_D3T_POSITION                              0x5
#define _CLC2GLS1_D3T_SIZE                                  0x1
#define _CLC2GLS1_D3T_LENGTH                                0x1
#define _CLC2GLS1_D3T_MASK                                  0x20
#define _CLC2GLS1_D4N_POSN                                  0x6
#define _CLC2GLS1_D4N_POSITION                              0x6
#define _CLC2GLS1_D4N_SIZE                                  0x1
#define _CLC2GLS1_D4N_LENGTH                                0x1
#define _CLC2GLS1_D4N_MASK                                  0x40
#define _CLC2GLS1_D4T_POSN                                  0x7
#define _CLC2GLS1_D4T_POSITION                              0x7
#define _CLC2GLS1_D4T_SIZE                                  0x1
#define _CLC2GLS1_D4T_LENGTH                                0x1
#define _CLC2GLS1_D4T_MASK                                  0x80

// Register: CLC2GLS2
extern volatile unsigned char           CLC2GLS2            @ 0xF22;
#ifndef _LIB_BUILD
asm("CLC2GLS2 equ 0F22h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC2G3D1N               :1;
        unsigned LC2G3D1T               :1;
        unsigned LC2G3D2N               :1;
        unsigned LC2G3D2T               :1;
        unsigned LC2G3D3N               :1;
        unsigned LC2G3D3T               :1;
        unsigned LC2G3D4N               :1;
        unsigned LC2G3D4T               :1;
    };
    struct {
        unsigned D1N                    :1;
        unsigned D1T                    :1;
        unsigned D2N                    :1;
        unsigned D2T                    :1;
        unsigned D3N                    :1;
        unsigned D3T                    :1;
        unsigned D4N                    :1;
        unsigned D4T                    :1;
    };
} CLC2GLS2bits_t;
extern volatile CLC2GLS2bits_t CLC2GLS2bits @ 0xF22;
// bitfield macros
#define _CLC2GLS2_LC2G3D1N_POSN                             0x0
#define _CLC2GLS2_LC2G3D1N_POSITION                         0x0
#define _CLC2GLS2_LC2G3D1N_SIZE                             0x1
#define _CLC2GLS2_LC2G3D1N_LENGTH                           0x1
#define _CLC2GLS2_LC2G3D1N_MASK                             0x1
#define _CLC2GLS2_LC2G3D1T_POSN                             0x1
#define _CLC2GLS2_LC2G3D1T_POSITION                         0x1
#define _CLC2GLS2_LC2G3D1T_SIZE                             0x1
#define _CLC2GLS2_LC2G3D1T_LENGTH                           0x1
#define _CLC2GLS2_LC2G3D1T_MASK                             0x2
#define _CLC2GLS2_LC2G3D2N_POSN                             0x2
#define _CLC2GLS2_LC2G3D2N_POSITION                         0x2
#define _CLC2GLS2_LC2G3D2N_SIZE                             0x1
#define _CLC2GLS2_LC2G3D2N_LENGTH                           0x1
#define _CLC2GLS2_LC2G3D2N_MASK                             0x4
#define _CLC2GLS2_LC2G3D2T_POSN                             0x3
#define _CLC2GLS2_LC2G3D2T_POSITION                         0x3
#define _CLC2GLS2_LC2G3D2T_SIZE                             0x1
#define _CLC2GLS2_LC2G3D2T_LENGTH                           0x1
#define _CLC2GLS2_LC2G3D2T_MASK                             0x8
#define _CLC2GLS2_LC2G3D3N_POSN                             0x4
#define _CLC2GLS2_LC2G3D3N_POSITION                         0x4
#define _CLC2GLS2_LC2G3D3N_SIZE                             0x1
#define _CLC2GLS2_LC2G3D3N_LENGTH                           0x1
#define _CLC2GLS2_LC2G3D3N_MASK                             0x10
#define _CLC2GLS2_LC2G3D3T_POSN                             0x5
#define _CLC2GLS2_LC2G3D3T_POSITION                         0x5
#define _CLC2GLS2_LC2G3D3T_SIZE                             0x1
#define _CLC2GLS2_LC2G3D3T_LENGTH                           0x1
#define _CLC2GLS2_LC2G3D3T_MASK                             0x20
#define _CLC2GLS2_LC2G3D4N_POSN                             0x6
#define _CLC2GLS2_LC2G3D4N_POSITION                         0x6
#define _CLC2GLS2_LC2G3D4N_SIZE                             0x1
#define _CLC2GLS2_LC2G3D4N_LENGTH                           0x1
#define _CLC2GLS2_LC2G3D4N_MASK                             0x40
#define _CLC2GLS2_LC2G3D4T_POSN                             0x7
#define _CLC2GLS2_LC2G3D4T_POSITION                         0x7
#define _CLC2GLS2_LC2G3D4T_SIZE                             0x1
#define _CLC2GLS2_LC2G3D4T_LENGTH                           0x1
#define _CLC2GLS2_LC2G3D4T_MASK                             0x80
#define _CLC2GLS2_D1N_POSN                                  0x0
#define _CLC2GLS2_D1N_POSITION                              0x0
#define _CLC2GLS2_D1N_SIZE                                  0x1
#define _CLC2GLS2_D1N_LENGTH                                0x1
#define _CLC2GLS2_D1N_MASK                                  0x1
#define _CLC2GLS2_D1T_POSN                                  0x1
#define _CLC2GLS2_D1T_POSITION                              0x1
#define _CLC2GLS2_D1T_SIZE                                  0x1
#define _CLC2GLS2_D1T_LENGTH                                0x1
#define _CLC2GLS2_D1T_MASK                                  0x2
#define _CLC2GLS2_D2N_POSN                                  0x2
#define _CLC2GLS2_D2N_POSITION                              0x2
#define _CLC2GLS2_D2N_SIZE                                  0x1
#define _CLC2GLS2_D2N_LENGTH                                0x1
#define _CLC2GLS2_D2N_MASK                                  0x4
#define _CLC2GLS2_D2T_POSN                                  0x3
#define _CLC2GLS2_D2T_POSITION                              0x3
#define _CLC2GLS2_D2T_SIZE                                  0x1
#define _CLC2GLS2_D2T_LENGTH                                0x1
#define _CLC2GLS2_D2T_MASK                                  0x8
#define _CLC2GLS2_D3N_POSN                                  0x4
#define _CLC2GLS2_D3N_POSITION                              0x4
#define _CLC2GLS2_D3N_SIZE                                  0x1
#define _CLC2GLS2_D3N_LENGTH                                0x1
#define _CLC2GLS2_D3N_MASK                                  0x10
#define _CLC2GLS2_D3T_POSN                                  0x5
#define _CLC2GLS2_D3T_POSITION                              0x5
#define _CLC2GLS2_D3T_SIZE                                  0x1
#define _CLC2GLS2_D3T_LENGTH                                0x1
#define _CLC2GLS2_D3T_MASK                                  0x20
#define _CLC2GLS2_D4N_POSN                                  0x6
#define _CLC2GLS2_D4N_POSITION                              0x6
#define _CLC2GLS2_D4N_SIZE                                  0x1
#define _CLC2GLS2_D4N_LENGTH                                0x1
#define _CLC2GLS2_D4N_MASK                                  0x40
#define _CLC2GLS2_D4T_POSN                                  0x7
#define _CLC2GLS2_D4T_POSITION                              0x7
#define _CLC2GLS2_D4T_SIZE                                  0x1
#define _CLC2GLS2_D4T_LENGTH                                0x1
#define _CLC2GLS2_D4T_MASK                                  0x80

// Register: CLC2GLS3
extern volatile unsigned char           CLC2GLS3            @ 0xF23;
#ifndef _LIB_BUILD
asm("CLC2GLS3 equ 0F23h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC2G4D1N               :1;
        unsigned LC2G4D1T               :1;
        unsigned LC2G4D2N               :1;
        unsigned LC2G4D2T               :1;
        unsigned LC2G4D3N               :1;
        unsigned LC2G4D3T               :1;
        unsigned LC2G4D4N               :1;
        unsigned LC2G4D4T               :1;
    };
    struct {
        unsigned G4D1N                  :1;
        unsigned G4D1T                  :1;
        unsigned G4D2N                  :1;
        unsigned G4D2T                  :1;
        unsigned G4D3N                  :1;
        unsigned G4D3T                  :1;
        unsigned G4D4N                  :1;
        unsigned G4D4T                  :1;
    };
} CLC2GLS3bits_t;
extern volatile CLC2GLS3bits_t CLC2GLS3bits @ 0xF23;
// bitfield macros
#define _CLC2GLS3_LC2G4D1N_POSN                             0x0
#define _CLC2GLS3_LC2G4D1N_POSITION                         0x0
#define _CLC2GLS3_LC2G4D1N_SIZE                             0x1
#define _CLC2GLS3_LC2G4D1N_LENGTH                           0x1
#define _CLC2GLS3_LC2G4D1N_MASK                             0x1
#define _CLC2GLS3_LC2G4D1T_POSN                             0x1
#define _CLC2GLS3_LC2G4D1T_POSITION                         0x1
#define _CLC2GLS3_LC2G4D1T_SIZE                             0x1
#define _CLC2GLS3_LC2G4D1T_LENGTH                           0x1
#define _CLC2GLS3_LC2G4D1T_MASK                             0x2
#define _CLC2GLS3_LC2G4D2N_POSN                             0x2
#define _CLC2GLS3_LC2G4D2N_POSITION                         0x2
#define _CLC2GLS3_LC2G4D2N_SIZE                             0x1
#define _CLC2GLS3_LC2G4D2N_LENGTH                           0x1
#define _CLC2GLS3_LC2G4D2N_MASK                             0x4
#define _CLC2GLS3_LC2G4D2T_POSN                             0x3
#define _CLC2GLS3_LC2G4D2T_POSITION                         0x3
#define _CLC2GLS3_LC2G4D2T_SIZE                             0x1
#define _CLC2GLS3_LC2G4D2T_LENGTH                           0x1
#define _CLC2GLS3_LC2G4D2T_MASK                             0x8
#define _CLC2GLS3_LC2G4D3N_POSN                             0x4
#define _CLC2GLS3_LC2G4D3N_POSITION                         0x4
#define _CLC2GLS3_LC2G4D3N_SIZE                             0x1
#define _CLC2GLS3_LC2G4D3N_LENGTH                           0x1
#define _CLC2GLS3_LC2G4D3N_MASK                             0x10
#define _CLC2GLS3_LC2G4D3T_POSN                             0x5
#define _CLC2GLS3_LC2G4D3T_POSITION                         0x5
#define _CLC2GLS3_LC2G4D3T_SIZE                             0x1
#define _CLC2GLS3_LC2G4D3T_LENGTH                           0x1
#define _CLC2GLS3_LC2G4D3T_MASK                             0x20
#define _CLC2GLS3_LC2G4D4N_POSN                             0x6
#define _CLC2GLS3_LC2G4D4N_POSITION                         0x6
#define _CLC2GLS3_LC2G4D4N_SIZE                             0x1
#define _CLC2GLS3_LC2G4D4N_LENGTH                           0x1
#define _CLC2GLS3_LC2G4D4N_MASK                             0x40
#define _CLC2GLS3_LC2G4D4T_POSN                             0x7
#define _CLC2GLS3_LC2G4D4T_POSITION                         0x7
#define _CLC2GLS3_LC2G4D4T_SIZE                             0x1
#define _CLC2GLS3_LC2G4D4T_LENGTH                           0x1
#define _CLC2GLS3_LC2G4D4T_MASK                             0x80
#define _CLC2GLS3_G4D1N_POSN                                0x0
#define _CLC2GLS3_G4D1N_POSITION                            0x0
#define _CLC2GLS3_G4D1N_SIZE                                0x1
#define _CLC2GLS3_G4D1N_LENGTH                              0x1
#define _CLC2GLS3_G4D1N_MASK                                0x1
#define _CLC2GLS3_G4D1T_POSN                                0x1
#define _CLC2GLS3_G4D1T_POSITION                            0x1
#define _CLC2GLS3_G4D1T_SIZE                                0x1
#define _CLC2GLS3_G4D1T_LENGTH                              0x1
#define _CLC2GLS3_G4D1T_MASK                                0x2
#define _CLC2GLS3_G4D2N_POSN                                0x2
#define _CLC2GLS3_G4D2N_POSITION                            0x2
#define _CLC2GLS3_G4D2N_SIZE                                0x1
#define _CLC2GLS3_G4D2N_LENGTH                              0x1
#define _CLC2GLS3_G4D2N_MASK                                0x4
#define _CLC2GLS3_G4D2T_POSN                                0x3
#define _CLC2GLS3_G4D2T_POSITION                            0x3
#define _CLC2GLS3_G4D2T_SIZE                                0x1
#define _CLC2GLS3_G4D2T_LENGTH                              0x1
#define _CLC2GLS3_G4D2T_MASK                                0x8
#define _CLC2GLS3_G4D3N_POSN                                0x4
#define _CLC2GLS3_G4D3N_POSITION                            0x4
#define _CLC2GLS3_G4D3N_SIZE                                0x1
#define _CLC2GLS3_G4D3N_LENGTH                              0x1
#define _CLC2GLS3_G4D3N_MASK                                0x10
#define _CLC2GLS3_G4D3T_POSN                                0x5
#define _CLC2GLS3_G4D3T_POSITION                            0x5
#define _CLC2GLS3_G4D3T_SIZE                                0x1
#define _CLC2GLS3_G4D3T_LENGTH                              0x1
#define _CLC2GLS3_G4D3T_MASK                                0x20
#define _CLC2GLS3_G4D4N_POSN                                0x6
#define _CLC2GLS3_G4D4N_POSITION                            0x6
#define _CLC2GLS3_G4D4N_SIZE                                0x1
#define _CLC2GLS3_G4D4N_LENGTH                              0x1
#define _CLC2GLS3_G4D4N_MASK                                0x40
#define _CLC2GLS3_G4D4T_POSN                                0x7
#define _CLC2GLS3_G4D4T_POSITION                            0x7
#define _CLC2GLS3_G4D4T_SIZE                                0x1
#define _CLC2GLS3_G4D4T_LENGTH                              0x1
#define _CLC2GLS3_G4D4T_MASK                                0x80

// Register: CLC3CON
extern volatile unsigned char           CLC3CON             @ 0xF24;
#ifndef _LIB_BUILD
asm("CLC3CON equ 0F24h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC3MODE                :3;
        unsigned LC3INTN                :1;
        unsigned LC3INTP                :1;
        unsigned LC3OUT                 :1;
        unsigned                        :1;
        unsigned LC3EN                  :1;
    };
    struct {
        unsigned LC3MODE0               :1;
        unsigned LC3MODE1               :1;
        unsigned LC3MODE2               :1;
    };
    struct {
        unsigned MODE                   :3;
        unsigned INTN                   :1;
        unsigned INTP                   :1;
        unsigned OUT                    :1;
        unsigned                        :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
    };
} CLC3CONbits_t;
extern volatile CLC3CONbits_t CLC3CONbits @ 0xF24;
// bitfield macros
#define _CLC3CON_LC3MODE_POSN                               0x0
#define _CLC3CON_LC3MODE_POSITION                           0x0
#define _CLC3CON_LC3MODE_SIZE                               0x3
#define _CLC3CON_LC3MODE_LENGTH                             0x3
#define _CLC3CON_LC3MODE_MASK                               0x7
#define _CLC3CON_LC3INTN_POSN                               0x3
#define _CLC3CON_LC3INTN_POSITION                           0x3
#define _CLC3CON_LC3INTN_SIZE                               0x1
#define _CLC3CON_LC3INTN_LENGTH                             0x1
#define _CLC3CON_LC3INTN_MASK                               0x8
#define _CLC3CON_LC3INTP_POSN                               0x4
#define _CLC3CON_LC3INTP_POSITION                           0x4
#define _CLC3CON_LC3INTP_SIZE                               0x1
#define _CLC3CON_LC3INTP_LENGTH                             0x1
#define _CLC3CON_LC3INTP_MASK                               0x10
#define _CLC3CON_LC3OUT_POSN                                0x5
#define _CLC3CON_LC3OUT_POSITION                            0x5
#define _CLC3CON_LC3OUT_SIZE                                0x1
#define _CLC3CON_LC3OUT_LENGTH                              0x1
#define _CLC3CON_LC3OUT_MASK                                0x20
#define _CLC3CON_LC3EN_POSN                                 0x7
#define _CLC3CON_LC3EN_POSITION                             0x7
#define _CLC3CON_LC3EN_SIZE                                 0x1
#define _CLC3CON_LC3EN_LENGTH                               0x1
#define _CLC3CON_LC3EN_MASK                                 0x80
#define _CLC3CON_LC3MODE0_POSN                              0x0
#define _CLC3CON_LC3MODE0_POSITION                          0x0
#define _CLC3CON_LC3MODE0_SIZE                              0x1
#define _CLC3CON_LC3MODE0_LENGTH                            0x1
#define _CLC3CON_LC3MODE0_MASK                              0x1
#define _CLC3CON_LC3MODE1_POSN                              0x1
#define _CLC3CON_LC3MODE1_POSITION                          0x1
#define _CLC3CON_LC3MODE1_SIZE                              0x1
#define _CLC3CON_LC3MODE1_LENGTH                            0x1
#define _CLC3CON_LC3MODE1_MASK                              0x2
#define _CLC3CON_LC3MODE2_POSN                              0x2
#define _CLC3CON_LC3MODE2_POSITION                          0x2
#define _CLC3CON_LC3MODE2_SIZE                              0x1
#define _CLC3CON_LC3MODE2_LENGTH                            0x1
#define _CLC3CON_LC3MODE2_MASK                              0x4
#define _CLC3CON_MODE_POSN                                  0x0
#define _CLC3CON_MODE_POSITION                              0x0
#define _CLC3CON_MODE_SIZE                                  0x3
#define _CLC3CON_MODE_LENGTH                                0x3
#define _CLC3CON_MODE_MASK                                  0x7
#define _CLC3CON_INTN_POSN                                  0x3
#define _CLC3CON_INTN_POSITION                              0x3
#define _CLC3CON_INTN_SIZE                                  0x1
#define _CLC3CON_INTN_LENGTH                                0x1
#define _CLC3CON_INTN_MASK                                  0x8
#define _CLC3CON_INTP_POSN                                  0x4
#define _CLC3CON_INTP_POSITION                              0x4
#define _CLC3CON_INTP_SIZE                                  0x1
#define _CLC3CON_INTP_LENGTH                                0x1
#define _CLC3CON_INTP_MASK                                  0x10
#define _CLC3CON_OUT_POSN                                   0x5
#define _CLC3CON_OUT_POSITION                               0x5
#define _CLC3CON_OUT_SIZE                                   0x1
#define _CLC3CON_OUT_LENGTH                                 0x1
#define _CLC3CON_OUT_MASK                                   0x20
#define _CLC3CON_EN_POSN                                    0x7
#define _CLC3CON_EN_POSITION                                0x7
#define _CLC3CON_EN_SIZE                                    0x1
#define _CLC3CON_EN_LENGTH                                  0x1
#define _CLC3CON_EN_MASK                                    0x80
#define _CLC3CON_MODE0_POSN                                 0x0
#define _CLC3CON_MODE0_POSITION                             0x0
#define _CLC3CON_MODE0_SIZE                                 0x1
#define _CLC3CON_MODE0_LENGTH                               0x1
#define _CLC3CON_MODE0_MASK                                 0x1
#define _CLC3CON_MODE1_POSN                                 0x1
#define _CLC3CON_MODE1_POSITION                             0x1
#define _CLC3CON_MODE1_SIZE                                 0x1
#define _CLC3CON_MODE1_LENGTH                               0x1
#define _CLC3CON_MODE1_MASK                                 0x2
#define _CLC3CON_MODE2_POSN                                 0x2
#define _CLC3CON_MODE2_POSITION                             0x2
#define _CLC3CON_MODE2_SIZE                                 0x1
#define _CLC3CON_MODE2_LENGTH                               0x1
#define _CLC3CON_MODE2_MASK                                 0x4

// Register: CLC3POL
extern volatile unsigned char           CLC3POL             @ 0xF25;
#ifndef _LIB_BUILD
asm("CLC3POL equ 0F25h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC3G1POL               :1;
        unsigned LC3G2POL               :1;
        unsigned LC3G3POL               :1;
        unsigned LC3G4POL               :1;
        unsigned                        :3;
        unsigned LC3POL                 :1;
    };
    struct {
        unsigned G1POL                  :1;
        unsigned G2POL                  :1;
        unsigned G3POL                  :1;
        unsigned G4POL                  :1;
        unsigned                        :3;
        unsigned POL                    :1;
    };
} CLC3POLbits_t;
extern volatile CLC3POLbits_t CLC3POLbits @ 0xF25;
// bitfield macros
#define _CLC3POL_LC3G1POL_POSN                              0x0
#define _CLC3POL_LC3G1POL_POSITION                          0x0
#define _CLC3POL_LC3G1POL_SIZE                              0x1
#define _CLC3POL_LC3G1POL_LENGTH                            0x1
#define _CLC3POL_LC3G1POL_MASK                              0x1
#define _CLC3POL_LC3G2POL_POSN                              0x1
#define _CLC3POL_LC3G2POL_POSITION                          0x1
#define _CLC3POL_LC3G2POL_SIZE                              0x1
#define _CLC3POL_LC3G2POL_LENGTH                            0x1
#define _CLC3POL_LC3G2POL_MASK                              0x2
#define _CLC3POL_LC3G3POL_POSN                              0x2
#define _CLC3POL_LC3G3POL_POSITION                          0x2
#define _CLC3POL_LC3G3POL_SIZE                              0x1
#define _CLC3POL_LC3G3POL_LENGTH                            0x1
#define _CLC3POL_LC3G3POL_MASK                              0x4
#define _CLC3POL_LC3G4POL_POSN                              0x3
#define _CLC3POL_LC3G4POL_POSITION                          0x3
#define _CLC3POL_LC3G4POL_SIZE                              0x1
#define _CLC3POL_LC3G4POL_LENGTH                            0x1
#define _CLC3POL_LC3G4POL_MASK                              0x8
#define _CLC3POL_LC3POL_POSN                                0x7
#define _CLC3POL_LC3POL_POSITION                            0x7
#define _CLC3POL_LC3POL_SIZE                                0x1
#define _CLC3POL_LC3POL_LENGTH                              0x1
#define _CLC3POL_LC3POL_MASK                                0x80
#define _CLC3POL_G1POL_POSN                                 0x0
#define _CLC3POL_G1POL_POSITION                             0x0
#define _CLC3POL_G1POL_SIZE                                 0x1
#define _CLC3POL_G1POL_LENGTH                               0x1
#define _CLC3POL_G1POL_MASK                                 0x1
#define _CLC3POL_G2POL_POSN                                 0x1
#define _CLC3POL_G2POL_POSITION                             0x1
#define _CLC3POL_G2POL_SIZE                                 0x1
#define _CLC3POL_G2POL_LENGTH                               0x1
#define _CLC3POL_G2POL_MASK                                 0x2
#define _CLC3POL_G3POL_POSN                                 0x2
#define _CLC3POL_G3POL_POSITION                             0x2
#define _CLC3POL_G3POL_SIZE                                 0x1
#define _CLC3POL_G3POL_LENGTH                               0x1
#define _CLC3POL_G3POL_MASK                                 0x4
#define _CLC3POL_G4POL_POSN                                 0x3
#define _CLC3POL_G4POL_POSITION                             0x3
#define _CLC3POL_G4POL_SIZE                                 0x1
#define _CLC3POL_G4POL_LENGTH                               0x1
#define _CLC3POL_G4POL_MASK                                 0x8
#define _CLC3POL_POL_POSN                                   0x7
#define _CLC3POL_POL_POSITION                               0x7
#define _CLC3POL_POL_SIZE                                   0x1
#define _CLC3POL_POL_LENGTH                                 0x1
#define _CLC3POL_POL_MASK                                   0x80

// Register: CLC3SEL0
extern volatile unsigned char           CLC3SEL0            @ 0xF26;
#ifndef _LIB_BUILD
asm("CLC3SEL0 equ 0F26h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC3D1S0                :1;
        unsigned LC3D1S1                :1;
        unsigned LC3D1S2                :1;
        unsigned LC3D1S3                :1;
        unsigned LC3D1S4                :1;
        unsigned LC3D1S5                :1;
    };
    struct {
        unsigned LC3D1S                 :8;
    };
    struct {
        unsigned D1S                    :8;
    };
    struct {
        unsigned D1S0                   :1;
        unsigned D1S1                   :1;
        unsigned D1S2                   :1;
        unsigned D1S3                   :1;
        unsigned D1S4                   :1;
        unsigned D1S5                   :1;
    };
} CLC3SEL0bits_t;
extern volatile CLC3SEL0bits_t CLC3SEL0bits @ 0xF26;
// bitfield macros
#define _CLC3SEL0_LC3D1S0_POSN                              0x0
#define _CLC3SEL0_LC3D1S0_POSITION                          0x0
#define _CLC3SEL0_LC3D1S0_SIZE                              0x1
#define _CLC3SEL0_LC3D1S0_LENGTH                            0x1
#define _CLC3SEL0_LC3D1S0_MASK                              0x1
#define _CLC3SEL0_LC3D1S1_POSN                              0x1
#define _CLC3SEL0_LC3D1S1_POSITION                          0x1
#define _CLC3SEL0_LC3D1S1_SIZE                              0x1
#define _CLC3SEL0_LC3D1S1_LENGTH                            0x1
#define _CLC3SEL0_LC3D1S1_MASK                              0x2
#define _CLC3SEL0_LC3D1S2_POSN                              0x2
#define _CLC3SEL0_LC3D1S2_POSITION                          0x2
#define _CLC3SEL0_LC3D1S2_SIZE                              0x1
#define _CLC3SEL0_LC3D1S2_LENGTH                            0x1
#define _CLC3SEL0_LC3D1S2_MASK                              0x4
#define _CLC3SEL0_LC3D1S3_POSN                              0x3
#define _CLC3SEL0_LC3D1S3_POSITION                          0x3
#define _CLC3SEL0_LC3D1S3_SIZE                              0x1
#define _CLC3SEL0_LC3D1S3_LENGTH                            0x1
#define _CLC3SEL0_LC3D1S3_MASK                              0x8
#define _CLC3SEL0_LC3D1S4_POSN                              0x4
#define _CLC3SEL0_LC3D1S4_POSITION                          0x4
#define _CLC3SEL0_LC3D1S4_SIZE                              0x1
#define _CLC3SEL0_LC3D1S4_LENGTH                            0x1
#define _CLC3SEL0_LC3D1S4_MASK                              0x10
#define _CLC3SEL0_LC3D1S5_POSN                              0x5
#define _CLC3SEL0_LC3D1S5_POSITION                          0x5
#define _CLC3SEL0_LC3D1S5_SIZE                              0x1
#define _CLC3SEL0_LC3D1S5_LENGTH                            0x1
#define _CLC3SEL0_LC3D1S5_MASK                              0x20
#define _CLC3SEL0_LC3D1S_POSN                               0x0
#define _CLC3SEL0_LC3D1S_POSITION                           0x0
#define _CLC3SEL0_LC3D1S_SIZE                               0x8
#define _CLC3SEL0_LC3D1S_LENGTH                             0x8
#define _CLC3SEL0_LC3D1S_MASK                               0xFF
#define _CLC3SEL0_D1S_POSN                                  0x0
#define _CLC3SEL0_D1S_POSITION                              0x0
#define _CLC3SEL0_D1S_SIZE                                  0x8
#define _CLC3SEL0_D1S_LENGTH                                0x8
#define _CLC3SEL0_D1S_MASK                                  0xFF
#define _CLC3SEL0_D1S0_POSN                                 0x0
#define _CLC3SEL0_D1S0_POSITION                             0x0
#define _CLC3SEL0_D1S0_SIZE                                 0x1
#define _CLC3SEL0_D1S0_LENGTH                               0x1
#define _CLC3SEL0_D1S0_MASK                                 0x1
#define _CLC3SEL0_D1S1_POSN                                 0x1
#define _CLC3SEL0_D1S1_POSITION                             0x1
#define _CLC3SEL0_D1S1_SIZE                                 0x1
#define _CLC3SEL0_D1S1_LENGTH                               0x1
#define _CLC3SEL0_D1S1_MASK                                 0x2
#define _CLC3SEL0_D1S2_POSN                                 0x2
#define _CLC3SEL0_D1S2_POSITION                             0x2
#define _CLC3SEL0_D1S2_SIZE                                 0x1
#define _CLC3SEL0_D1S2_LENGTH                               0x1
#define _CLC3SEL0_D1S2_MASK                                 0x4
#define _CLC3SEL0_D1S3_POSN                                 0x3
#define _CLC3SEL0_D1S3_POSITION                             0x3
#define _CLC3SEL0_D1S3_SIZE                                 0x1
#define _CLC3SEL0_D1S3_LENGTH                               0x1
#define _CLC3SEL0_D1S3_MASK                                 0x8
#define _CLC3SEL0_D1S4_POSN                                 0x4
#define _CLC3SEL0_D1S4_POSITION                             0x4
#define _CLC3SEL0_D1S4_SIZE                                 0x1
#define _CLC3SEL0_D1S4_LENGTH                               0x1
#define _CLC3SEL0_D1S4_MASK                                 0x10
#define _CLC3SEL0_D1S5_POSN                                 0x5
#define _CLC3SEL0_D1S5_POSITION                             0x5
#define _CLC3SEL0_D1S5_SIZE                                 0x1
#define _CLC3SEL0_D1S5_LENGTH                               0x1
#define _CLC3SEL0_D1S5_MASK                                 0x20

// Register: CLC3SEL1
extern volatile unsigned char           CLC3SEL1            @ 0xF27;
#ifndef _LIB_BUILD
asm("CLC3SEL1 equ 0F27h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC3D2S0                :1;
        unsigned LC3D2S1                :1;
        unsigned LC3D2S2                :1;
        unsigned LC3D2S3                :1;
        unsigned LC3D2S4                :1;
        unsigned LC3D2S5                :1;
    };
    struct {
        unsigned LC3D2S                 :8;
    };
    struct {
        unsigned D2S                    :8;
    };
    struct {
        unsigned D2S0                   :1;
        unsigned D2S1                   :1;
        unsigned D2S2                   :1;
        unsigned D2S3                   :1;
        unsigned D2S4                   :1;
        unsigned D2S5                   :1;
    };
} CLC3SEL1bits_t;
extern volatile CLC3SEL1bits_t CLC3SEL1bits @ 0xF27;
// bitfield macros
#define _CLC3SEL1_LC3D2S0_POSN                              0x0
#define _CLC3SEL1_LC3D2S0_POSITION                          0x0
#define _CLC3SEL1_LC3D2S0_SIZE                              0x1
#define _CLC3SEL1_LC3D2S0_LENGTH                            0x1
#define _CLC3SEL1_LC3D2S0_MASK                              0x1
#define _CLC3SEL1_LC3D2S1_POSN                              0x1
#define _CLC3SEL1_LC3D2S1_POSITION                          0x1
#define _CLC3SEL1_LC3D2S1_SIZE                              0x1
#define _CLC3SEL1_LC3D2S1_LENGTH                            0x1
#define _CLC3SEL1_LC3D2S1_MASK                              0x2
#define _CLC3SEL1_LC3D2S2_POSN                              0x2
#define _CLC3SEL1_LC3D2S2_POSITION                          0x2
#define _CLC3SEL1_LC3D2S2_SIZE                              0x1
#define _CLC3SEL1_LC3D2S2_LENGTH                            0x1
#define _CLC3SEL1_LC3D2S2_MASK                              0x4
#define _CLC3SEL1_LC3D2S3_POSN                              0x3
#define _CLC3SEL1_LC3D2S3_POSITION                          0x3
#define _CLC3SEL1_LC3D2S3_SIZE                              0x1
#define _CLC3SEL1_LC3D2S3_LENGTH                            0x1
#define _CLC3SEL1_LC3D2S3_MASK                              0x8
#define _CLC3SEL1_LC3D2S4_POSN                              0x4
#define _CLC3SEL1_LC3D2S4_POSITION                          0x4
#define _CLC3SEL1_LC3D2S4_SIZE                              0x1
#define _CLC3SEL1_LC3D2S4_LENGTH                            0x1
#define _CLC3SEL1_LC3D2S4_MASK                              0x10
#define _CLC3SEL1_LC3D2S5_POSN                              0x5
#define _CLC3SEL1_LC3D2S5_POSITION                          0x5
#define _CLC3SEL1_LC3D2S5_SIZE                              0x1
#define _CLC3SEL1_LC3D2S5_LENGTH                            0x1
#define _CLC3SEL1_LC3D2S5_MASK                              0x20
#define _CLC3SEL1_LC3D2S_POSN                               0x0
#define _CLC3SEL1_LC3D2S_POSITION                           0x0
#define _CLC3SEL1_LC3D2S_SIZE                               0x8
#define _CLC3SEL1_LC3D2S_LENGTH                             0x8
#define _CLC3SEL1_LC3D2S_MASK                               0xFF
#define _CLC3SEL1_D2S_POSN                                  0x0
#define _CLC3SEL1_D2S_POSITION                              0x0
#define _CLC3SEL1_D2S_SIZE                                  0x8
#define _CLC3SEL1_D2S_LENGTH                                0x8
#define _CLC3SEL1_D2S_MASK                                  0xFF
#define _CLC3SEL1_D2S0_POSN                                 0x0
#define _CLC3SEL1_D2S0_POSITION                             0x0
#define _CLC3SEL1_D2S0_SIZE                                 0x1
#define _CLC3SEL1_D2S0_LENGTH                               0x1
#define _CLC3SEL1_D2S0_MASK                                 0x1
#define _CLC3SEL1_D2S1_POSN                                 0x1
#define _CLC3SEL1_D2S1_POSITION                             0x1
#define _CLC3SEL1_D2S1_SIZE                                 0x1
#define _CLC3SEL1_D2S1_LENGTH                               0x1
#define _CLC3SEL1_D2S1_MASK                                 0x2
#define _CLC3SEL1_D2S2_POSN                                 0x2
#define _CLC3SEL1_D2S2_POSITION                             0x2
#define _CLC3SEL1_D2S2_SIZE                                 0x1
#define _CLC3SEL1_D2S2_LENGTH                               0x1
#define _CLC3SEL1_D2S2_MASK                                 0x4
#define _CLC3SEL1_D2S3_POSN                                 0x3
#define _CLC3SEL1_D2S3_POSITION                             0x3
#define _CLC3SEL1_D2S3_SIZE                                 0x1
#define _CLC3SEL1_D2S3_LENGTH                               0x1
#define _CLC3SEL1_D2S3_MASK                                 0x8
#define _CLC3SEL1_D2S4_POSN                                 0x4
#define _CLC3SEL1_D2S4_POSITION                             0x4
#define _CLC3SEL1_D2S4_SIZE                                 0x1
#define _CLC3SEL1_D2S4_LENGTH                               0x1
#define _CLC3SEL1_D2S4_MASK                                 0x10
#define _CLC3SEL1_D2S5_POSN                                 0x5
#define _CLC3SEL1_D2S5_POSITION                             0x5
#define _CLC3SEL1_D2S5_SIZE                                 0x1
#define _CLC3SEL1_D2S5_LENGTH                               0x1
#define _CLC3SEL1_D2S5_MASK                                 0x20

// Register: CLC3SEL2
extern volatile unsigned char           CLC3SEL2            @ 0xF28;
#ifndef _LIB_BUILD
asm("CLC3SEL2 equ 0F28h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC3D3S0                :1;
        unsigned LC3D3S1                :1;
        unsigned LC3D3S2                :1;
        unsigned LC3D3S3                :1;
        unsigned LC3D3S4                :1;
        unsigned LC3D3S5                :1;
    };
    struct {
        unsigned LC3D3S                 :8;
    };
    struct {
        unsigned D3S                    :8;
    };
    struct {
        unsigned D3S0                   :1;
        unsigned D3S1                   :1;
        unsigned D3S2                   :1;
        unsigned D3S3                   :1;
        unsigned D3S4                   :1;
        unsigned D3S5                   :1;
    };
} CLC3SEL2bits_t;
extern volatile CLC3SEL2bits_t CLC3SEL2bits @ 0xF28;
// bitfield macros
#define _CLC3SEL2_LC3D3S0_POSN                              0x0
#define _CLC3SEL2_LC3D3S0_POSITION                          0x0
#define _CLC3SEL2_LC3D3S0_SIZE                              0x1
#define _CLC3SEL2_LC3D3S0_LENGTH                            0x1
#define _CLC3SEL2_LC3D3S0_MASK                              0x1
#define _CLC3SEL2_LC3D3S1_POSN                              0x1
#define _CLC3SEL2_LC3D3S1_POSITION                          0x1
#define _CLC3SEL2_LC3D3S1_SIZE                              0x1
#define _CLC3SEL2_LC3D3S1_LENGTH                            0x1
#define _CLC3SEL2_LC3D3S1_MASK                              0x2
#define _CLC3SEL2_LC3D3S2_POSN                              0x2
#define _CLC3SEL2_LC3D3S2_POSITION                          0x2
#define _CLC3SEL2_LC3D3S2_SIZE                              0x1
#define _CLC3SEL2_LC3D3S2_LENGTH                            0x1
#define _CLC3SEL2_LC3D3S2_MASK                              0x4
#define _CLC3SEL2_LC3D3S3_POSN                              0x3
#define _CLC3SEL2_LC3D3S3_POSITION                          0x3
#define _CLC3SEL2_LC3D3S3_SIZE                              0x1
#define _CLC3SEL2_LC3D3S3_LENGTH                            0x1
#define _CLC3SEL2_LC3D3S3_MASK                              0x8
#define _CLC3SEL2_LC3D3S4_POSN                              0x4
#define _CLC3SEL2_LC3D3S4_POSITION                          0x4
#define _CLC3SEL2_LC3D3S4_SIZE                              0x1
#define _CLC3SEL2_LC3D3S4_LENGTH                            0x1
#define _CLC3SEL2_LC3D3S4_MASK                              0x10
#define _CLC3SEL2_LC3D3S5_POSN                              0x5
#define _CLC3SEL2_LC3D3S5_POSITION                          0x5
#define _CLC3SEL2_LC3D3S5_SIZE                              0x1
#define _CLC3SEL2_LC3D3S5_LENGTH                            0x1
#define _CLC3SEL2_LC3D3S5_MASK                              0x20
#define _CLC3SEL2_LC3D3S_POSN                               0x0
#define _CLC3SEL2_LC3D3S_POSITION                           0x0
#define _CLC3SEL2_LC3D3S_SIZE                               0x8
#define _CLC3SEL2_LC3D3S_LENGTH                             0x8
#define _CLC3SEL2_LC3D3S_MASK                               0xFF
#define _CLC3SEL2_D3S_POSN                                  0x0
#define _CLC3SEL2_D3S_POSITION                              0x0
#define _CLC3SEL2_D3S_SIZE                                  0x8
#define _CLC3SEL2_D3S_LENGTH                                0x8
#define _CLC3SEL2_D3S_MASK                                  0xFF
#define _CLC3SEL2_D3S0_POSN                                 0x0
#define _CLC3SEL2_D3S0_POSITION                             0x0
#define _CLC3SEL2_D3S0_SIZE                                 0x1
#define _CLC3SEL2_D3S0_LENGTH                               0x1
#define _CLC3SEL2_D3S0_MASK                                 0x1
#define _CLC3SEL2_D3S1_POSN                                 0x1
#define _CLC3SEL2_D3S1_POSITION                             0x1
#define _CLC3SEL2_D3S1_SIZE                                 0x1
#define _CLC3SEL2_D3S1_LENGTH                               0x1
#define _CLC3SEL2_D3S1_MASK                                 0x2
#define _CLC3SEL2_D3S2_POSN                                 0x2
#define _CLC3SEL2_D3S2_POSITION                             0x2
#define _CLC3SEL2_D3S2_SIZE                                 0x1
#define _CLC3SEL2_D3S2_LENGTH                               0x1
#define _CLC3SEL2_D3S2_MASK                                 0x4
#define _CLC3SEL2_D3S3_POSN                                 0x3
#define _CLC3SEL2_D3S3_POSITION                             0x3
#define _CLC3SEL2_D3S3_SIZE                                 0x1
#define _CLC3SEL2_D3S3_LENGTH                               0x1
#define _CLC3SEL2_D3S3_MASK                                 0x8
#define _CLC3SEL2_D3S4_POSN                                 0x4
#define _CLC3SEL2_D3S4_POSITION                             0x4
#define _CLC3SEL2_D3S4_SIZE                                 0x1
#define _CLC3SEL2_D3S4_LENGTH                               0x1
#define _CLC3SEL2_D3S4_MASK                                 0x10
#define _CLC3SEL2_D3S5_POSN                                 0x5
#define _CLC3SEL2_D3S5_POSITION                             0x5
#define _CLC3SEL2_D3S5_SIZE                                 0x1
#define _CLC3SEL2_D3S5_LENGTH                               0x1
#define _CLC3SEL2_D3S5_MASK                                 0x20

// Register: CLC3SEL3
extern volatile unsigned char           CLC3SEL3            @ 0xF29;
#ifndef _LIB_BUILD
asm("CLC3SEL3 equ 0F29h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC3D4S0                :1;
        unsigned LC3D4S1                :1;
        unsigned LC3D4S2                :1;
        unsigned LC3D4S3                :1;
        unsigned LC3D4S4                :1;
        unsigned LC3D4S5                :1;
    };
    struct {
        unsigned LC3D4S                 :8;
    };
    struct {
        unsigned D4S                    :8;
    };
    struct {
        unsigned D4S0                   :1;
        unsigned D4S1                   :1;
        unsigned D4S2                   :1;
        unsigned D4S3                   :1;
        unsigned D4S4                   :1;
        unsigned D4S5                   :1;
    };
} CLC3SEL3bits_t;
extern volatile CLC3SEL3bits_t CLC3SEL3bits @ 0xF29;
// bitfield macros
#define _CLC3SEL3_LC3D4S0_POSN                              0x0
#define _CLC3SEL3_LC3D4S0_POSITION                          0x0
#define _CLC3SEL3_LC3D4S0_SIZE                              0x1
#define _CLC3SEL3_LC3D4S0_LENGTH                            0x1
#define _CLC3SEL3_LC3D4S0_MASK                              0x1
#define _CLC3SEL3_LC3D4S1_POSN                              0x1
#define _CLC3SEL3_LC3D4S1_POSITION                          0x1
#define _CLC3SEL3_LC3D4S1_SIZE                              0x1
#define _CLC3SEL3_LC3D4S1_LENGTH                            0x1
#define _CLC3SEL3_LC3D4S1_MASK                              0x2
#define _CLC3SEL3_LC3D4S2_POSN                              0x2
#define _CLC3SEL3_LC3D4S2_POSITION                          0x2
#define _CLC3SEL3_LC3D4S2_SIZE                              0x1
#define _CLC3SEL3_LC3D4S2_LENGTH                            0x1
#define _CLC3SEL3_LC3D4S2_MASK                              0x4
#define _CLC3SEL3_LC3D4S3_POSN                              0x3
#define _CLC3SEL3_LC3D4S3_POSITION                          0x3
#define _CLC3SEL3_LC3D4S3_SIZE                              0x1
#define _CLC3SEL3_LC3D4S3_LENGTH                            0x1
#define _CLC3SEL3_LC3D4S3_MASK                              0x8
#define _CLC3SEL3_LC3D4S4_POSN                              0x4
#define _CLC3SEL3_LC3D4S4_POSITION                          0x4
#define _CLC3SEL3_LC3D4S4_SIZE                              0x1
#define _CLC3SEL3_LC3D4S4_LENGTH                            0x1
#define _CLC3SEL3_LC3D4S4_MASK                              0x10
#define _CLC3SEL3_LC3D4S5_POSN                              0x5
#define _CLC3SEL3_LC3D4S5_POSITION                          0x5
#define _CLC3SEL3_LC3D4S5_SIZE                              0x1
#define _CLC3SEL3_LC3D4S5_LENGTH                            0x1
#define _CLC3SEL3_LC3D4S5_MASK                              0x20
#define _CLC3SEL3_LC3D4S_POSN                               0x0
#define _CLC3SEL3_LC3D4S_POSITION                           0x0
#define _CLC3SEL3_LC3D4S_SIZE                               0x8
#define _CLC3SEL3_LC3D4S_LENGTH                             0x8
#define _CLC3SEL3_LC3D4S_MASK                               0xFF
#define _CLC3SEL3_D4S_POSN                                  0x0
#define _CLC3SEL3_D4S_POSITION                              0x0
#define _CLC3SEL3_D4S_SIZE                                  0x8
#define _CLC3SEL3_D4S_LENGTH                                0x8
#define _CLC3SEL3_D4S_MASK                                  0xFF
#define _CLC3SEL3_D4S0_POSN                                 0x0
#define _CLC3SEL3_D4S0_POSITION                             0x0
#define _CLC3SEL3_D4S0_SIZE                                 0x1
#define _CLC3SEL3_D4S0_LENGTH                               0x1
#define _CLC3SEL3_D4S0_MASK                                 0x1
#define _CLC3SEL3_D4S1_POSN                                 0x1
#define _CLC3SEL3_D4S1_POSITION                             0x1
#define _CLC3SEL3_D4S1_SIZE                                 0x1
#define _CLC3SEL3_D4S1_LENGTH                               0x1
#define _CLC3SEL3_D4S1_MASK                                 0x2
#define _CLC3SEL3_D4S2_POSN                                 0x2
#define _CLC3SEL3_D4S2_POSITION                             0x2
#define _CLC3SEL3_D4S2_SIZE                                 0x1
#define _CLC3SEL3_D4S2_LENGTH                               0x1
#define _CLC3SEL3_D4S2_MASK                                 0x4
#define _CLC3SEL3_D4S3_POSN                                 0x3
#define _CLC3SEL3_D4S3_POSITION                             0x3
#define _CLC3SEL3_D4S3_SIZE                                 0x1
#define _CLC3SEL3_D4S3_LENGTH                               0x1
#define _CLC3SEL3_D4S3_MASK                                 0x8
#define _CLC3SEL3_D4S4_POSN                                 0x4
#define _CLC3SEL3_D4S4_POSITION                             0x4
#define _CLC3SEL3_D4S4_SIZE                                 0x1
#define _CLC3SEL3_D4S4_LENGTH                               0x1
#define _CLC3SEL3_D4S4_MASK                                 0x10
#define _CLC3SEL3_D4S5_POSN                                 0x5
#define _CLC3SEL3_D4S5_POSITION                             0x5
#define _CLC3SEL3_D4S5_SIZE                                 0x1
#define _CLC3SEL3_D4S5_LENGTH                               0x1
#define _CLC3SEL3_D4S5_MASK                                 0x20

// Register: CLC3GLS0
extern volatile unsigned char           CLC3GLS0            @ 0xF2A;
#ifndef _LIB_BUILD
asm("CLC3GLS0 equ 0F2Ah");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC3G1D1N               :1;
        unsigned LC3G1D1T               :1;
        unsigned LC3G1D2N               :1;
        unsigned LC3G1D2T               :1;
        unsigned LC3G1D3N               :1;
        unsigned LC3G1D3T               :1;
        unsigned LC3G1D4N               :1;
        unsigned LC3G1D4T               :1;
    };
    struct {
        unsigned D1N                    :1;
        unsigned D1T                    :1;
        unsigned D2N                    :1;
        unsigned D2T                    :1;
        unsigned D3N                    :1;
        unsigned D3T                    :1;
        unsigned D4N                    :1;
        unsigned D4T                    :1;
    };
} CLC3GLS0bits_t;
extern volatile CLC3GLS0bits_t CLC3GLS0bits @ 0xF2A;
// bitfield macros
#define _CLC3GLS0_LC3G1D1N_POSN                             0x0
#define _CLC3GLS0_LC3G1D1N_POSITION                         0x0
#define _CLC3GLS0_LC3G1D1N_SIZE                             0x1
#define _CLC3GLS0_LC3G1D1N_LENGTH                           0x1
#define _CLC3GLS0_LC3G1D1N_MASK                             0x1
#define _CLC3GLS0_LC3G1D1T_POSN                             0x1
#define _CLC3GLS0_LC3G1D1T_POSITION                         0x1
#define _CLC3GLS0_LC3G1D1T_SIZE                             0x1
#define _CLC3GLS0_LC3G1D1T_LENGTH                           0x1
#define _CLC3GLS0_LC3G1D1T_MASK                             0x2
#define _CLC3GLS0_LC3G1D2N_POSN                             0x2
#define _CLC3GLS0_LC3G1D2N_POSITION                         0x2
#define _CLC3GLS0_LC3G1D2N_SIZE                             0x1
#define _CLC3GLS0_LC3G1D2N_LENGTH                           0x1
#define _CLC3GLS0_LC3G1D2N_MASK                             0x4
#define _CLC3GLS0_LC3G1D2T_POSN                             0x3
#define _CLC3GLS0_LC3G1D2T_POSITION                         0x3
#define _CLC3GLS0_LC3G1D2T_SIZE                             0x1
#define _CLC3GLS0_LC3G1D2T_LENGTH                           0x1
#define _CLC3GLS0_LC3G1D2T_MASK                             0x8
#define _CLC3GLS0_LC3G1D3N_POSN                             0x4
#define _CLC3GLS0_LC3G1D3N_POSITION                         0x4
#define _CLC3GLS0_LC3G1D3N_SIZE                             0x1
#define _CLC3GLS0_LC3G1D3N_LENGTH                           0x1
#define _CLC3GLS0_LC3G1D3N_MASK                             0x10
#define _CLC3GLS0_LC3G1D3T_POSN                             0x5
#define _CLC3GLS0_LC3G1D3T_POSITION                         0x5
#define _CLC3GLS0_LC3G1D3T_SIZE                             0x1
#define _CLC3GLS0_LC3G1D3T_LENGTH                           0x1
#define _CLC3GLS0_LC3G1D3T_MASK                             0x20
#define _CLC3GLS0_LC3G1D4N_POSN                             0x6
#define _CLC3GLS0_LC3G1D4N_POSITION                         0x6
#define _CLC3GLS0_LC3G1D4N_SIZE                             0x1
#define _CLC3GLS0_LC3G1D4N_LENGTH                           0x1
#define _CLC3GLS0_LC3G1D4N_MASK                             0x40
#define _CLC3GLS0_LC3G1D4T_POSN                             0x7
#define _CLC3GLS0_LC3G1D4T_POSITION                         0x7
#define _CLC3GLS0_LC3G1D4T_SIZE                             0x1
#define _CLC3GLS0_LC3G1D4T_LENGTH                           0x1
#define _CLC3GLS0_LC3G1D4T_MASK                             0x80
#define _CLC3GLS0_D1N_POSN                                  0x0
#define _CLC3GLS0_D1N_POSITION                              0x0
#define _CLC3GLS0_D1N_SIZE                                  0x1
#define _CLC3GLS0_D1N_LENGTH                                0x1
#define _CLC3GLS0_D1N_MASK                                  0x1
#define _CLC3GLS0_D1T_POSN                                  0x1
#define _CLC3GLS0_D1T_POSITION                              0x1
#define _CLC3GLS0_D1T_SIZE                                  0x1
#define _CLC3GLS0_D1T_LENGTH                                0x1
#define _CLC3GLS0_D1T_MASK                                  0x2
#define _CLC3GLS0_D2N_POSN                                  0x2
#define _CLC3GLS0_D2N_POSITION                              0x2
#define _CLC3GLS0_D2N_SIZE                                  0x1
#define _CLC3GLS0_D2N_LENGTH                                0x1
#define _CLC3GLS0_D2N_MASK                                  0x4
#define _CLC3GLS0_D2T_POSN                                  0x3
#define _CLC3GLS0_D2T_POSITION                              0x3
#define _CLC3GLS0_D2T_SIZE                                  0x1
#define _CLC3GLS0_D2T_LENGTH                                0x1
#define _CLC3GLS0_D2T_MASK                                  0x8
#define _CLC3GLS0_D3N_POSN                                  0x4
#define _CLC3GLS0_D3N_POSITION                              0x4
#define _CLC3GLS0_D3N_SIZE                                  0x1
#define _CLC3GLS0_D3N_LENGTH                                0x1
#define _CLC3GLS0_D3N_MASK                                  0x10
#define _CLC3GLS0_D3T_POSN                                  0x5
#define _CLC3GLS0_D3T_POSITION                              0x5
#define _CLC3GLS0_D3T_SIZE                                  0x1
#define _CLC3GLS0_D3T_LENGTH                                0x1
#define _CLC3GLS0_D3T_MASK                                  0x20
#define _CLC3GLS0_D4N_POSN                                  0x6
#define _CLC3GLS0_D4N_POSITION                              0x6
#define _CLC3GLS0_D4N_SIZE                                  0x1
#define _CLC3GLS0_D4N_LENGTH                                0x1
#define _CLC3GLS0_D4N_MASK                                  0x40
#define _CLC3GLS0_D4T_POSN                                  0x7
#define _CLC3GLS0_D4T_POSITION                              0x7
#define _CLC3GLS0_D4T_SIZE                                  0x1
#define _CLC3GLS0_D4T_LENGTH                                0x1
#define _CLC3GLS0_D4T_MASK                                  0x80

// Register: CLC3GLS1
extern volatile unsigned char           CLC3GLS1            @ 0xF2B;
#ifndef _LIB_BUILD
asm("CLC3GLS1 equ 0F2Bh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC3G2D1N               :1;
        unsigned LC3G2D1T               :1;
        unsigned LC3G2D2N               :1;
        unsigned LC3G2D2T               :1;
        unsigned LC3G2D3N               :1;
        unsigned LC3G2D3T               :1;
        unsigned LC3G2D4N               :1;
        unsigned LC3G2D4T               :1;
    };
    struct {
        unsigned D1N                    :1;
        unsigned D1T                    :1;
        unsigned D2N                    :1;
        unsigned D2T                    :1;
        unsigned D3N                    :1;
        unsigned D3T                    :1;
        unsigned D4N                    :1;
        unsigned D4T                    :1;
    };
} CLC3GLS1bits_t;
extern volatile CLC3GLS1bits_t CLC3GLS1bits @ 0xF2B;
// bitfield macros
#define _CLC3GLS1_LC3G2D1N_POSN                             0x0
#define _CLC3GLS1_LC3G2D1N_POSITION                         0x0
#define _CLC3GLS1_LC3G2D1N_SIZE                             0x1
#define _CLC3GLS1_LC3G2D1N_LENGTH                           0x1
#define _CLC3GLS1_LC3G2D1N_MASK                             0x1
#define _CLC3GLS1_LC3G2D1T_POSN                             0x1
#define _CLC3GLS1_LC3G2D1T_POSITION                         0x1
#define _CLC3GLS1_LC3G2D1T_SIZE                             0x1
#define _CLC3GLS1_LC3G2D1T_LENGTH                           0x1
#define _CLC3GLS1_LC3G2D1T_MASK                             0x2
#define _CLC3GLS1_LC3G2D2N_POSN                             0x2
#define _CLC3GLS1_LC3G2D2N_POSITION                         0x2
#define _CLC3GLS1_LC3G2D2N_SIZE                             0x1
#define _CLC3GLS1_LC3G2D2N_LENGTH                           0x1
#define _CLC3GLS1_LC3G2D2N_MASK                             0x4
#define _CLC3GLS1_LC3G2D2T_POSN                             0x3
#define _CLC3GLS1_LC3G2D2T_POSITION                         0x3
#define _CLC3GLS1_LC3G2D2T_SIZE                             0x1
#define _CLC3GLS1_LC3G2D2T_LENGTH                           0x1
#define _CLC3GLS1_LC3G2D2T_MASK                             0x8
#define _CLC3GLS1_LC3G2D3N_POSN                             0x4
#define _CLC3GLS1_LC3G2D3N_POSITION                         0x4
#define _CLC3GLS1_LC3G2D3N_SIZE                             0x1
#define _CLC3GLS1_LC3G2D3N_LENGTH                           0x1
#define _CLC3GLS1_LC3G2D3N_MASK                             0x10
#define _CLC3GLS1_LC3G2D3T_POSN                             0x5
#define _CLC3GLS1_LC3G2D3T_POSITION                         0x5
#define _CLC3GLS1_LC3G2D3T_SIZE                             0x1
#define _CLC3GLS1_LC3G2D3T_LENGTH                           0x1
#define _CLC3GLS1_LC3G2D3T_MASK                             0x20
#define _CLC3GLS1_LC3G2D4N_POSN                             0x6
#define _CLC3GLS1_LC3G2D4N_POSITION                         0x6
#define _CLC3GLS1_LC3G2D4N_SIZE                             0x1
#define _CLC3GLS1_LC3G2D4N_LENGTH                           0x1
#define _CLC3GLS1_LC3G2D4N_MASK                             0x40
#define _CLC3GLS1_LC3G2D4T_POSN                             0x7
#define _CLC3GLS1_LC3G2D4T_POSITION                         0x7
#define _CLC3GLS1_LC3G2D4T_SIZE                             0x1
#define _CLC3GLS1_LC3G2D4T_LENGTH                           0x1
#define _CLC3GLS1_LC3G2D4T_MASK                             0x80
#define _CLC3GLS1_D1N_POSN                                  0x0
#define _CLC3GLS1_D1N_POSITION                              0x0
#define _CLC3GLS1_D1N_SIZE                                  0x1
#define _CLC3GLS1_D1N_LENGTH                                0x1
#define _CLC3GLS1_D1N_MASK                                  0x1
#define _CLC3GLS1_D1T_POSN                                  0x1
#define _CLC3GLS1_D1T_POSITION                              0x1
#define _CLC3GLS1_D1T_SIZE                                  0x1
#define _CLC3GLS1_D1T_LENGTH                                0x1
#define _CLC3GLS1_D1T_MASK                                  0x2
#define _CLC3GLS1_D2N_POSN                                  0x2
#define _CLC3GLS1_D2N_POSITION                              0x2
#define _CLC3GLS1_D2N_SIZE                                  0x1
#define _CLC3GLS1_D2N_LENGTH                                0x1
#define _CLC3GLS1_D2N_MASK                                  0x4
#define _CLC3GLS1_D2T_POSN                                  0x3
#define _CLC3GLS1_D2T_POSITION                              0x3
#define _CLC3GLS1_D2T_SIZE                                  0x1
#define _CLC3GLS1_D2T_LENGTH                                0x1
#define _CLC3GLS1_D2T_MASK                                  0x8
#define _CLC3GLS1_D3N_POSN                                  0x4
#define _CLC3GLS1_D3N_POSITION                              0x4
#define _CLC3GLS1_D3N_SIZE                                  0x1
#define _CLC3GLS1_D3N_LENGTH                                0x1
#define _CLC3GLS1_D3N_MASK                                  0x10
#define _CLC3GLS1_D3T_POSN                                  0x5
#define _CLC3GLS1_D3T_POSITION                              0x5
#define _CLC3GLS1_D3T_SIZE                                  0x1
#define _CLC3GLS1_D3T_LENGTH                                0x1
#define _CLC3GLS1_D3T_MASK                                  0x20
#define _CLC3GLS1_D4N_POSN                                  0x6
#define _CLC3GLS1_D4N_POSITION                              0x6
#define _CLC3GLS1_D4N_SIZE                                  0x1
#define _CLC3GLS1_D4N_LENGTH                                0x1
#define _CLC3GLS1_D4N_MASK                                  0x40
#define _CLC3GLS1_D4T_POSN                                  0x7
#define _CLC3GLS1_D4T_POSITION                              0x7
#define _CLC3GLS1_D4T_SIZE                                  0x1
#define _CLC3GLS1_D4T_LENGTH                                0x1
#define _CLC3GLS1_D4T_MASK                                  0x80

// Register: CLC3GLS2
extern volatile unsigned char           CLC3GLS2            @ 0xF2C;
#ifndef _LIB_BUILD
asm("CLC3GLS2 equ 0F2Ch");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC3G3D1N               :1;
        unsigned LC3G3D1T               :1;
        unsigned LC3G3D2N               :1;
        unsigned LC3G3D2T               :1;
        unsigned LC3G3D3N               :1;
        unsigned LC3G3D3T               :1;
        unsigned LC3G3D4N               :1;
        unsigned LC3G3D4T               :1;
    };
    struct {
        unsigned D1N                    :1;
        unsigned D1T                    :1;
        unsigned D2N                    :1;
        unsigned D2T                    :1;
        unsigned D3N                    :1;
        unsigned D3T                    :1;
        unsigned D4N                    :1;
        unsigned D4T                    :1;
    };
} CLC3GLS2bits_t;
extern volatile CLC3GLS2bits_t CLC3GLS2bits @ 0xF2C;
// bitfield macros
#define _CLC3GLS2_LC3G3D1N_POSN                             0x0
#define _CLC3GLS2_LC3G3D1N_POSITION                         0x0
#define _CLC3GLS2_LC3G3D1N_SIZE                             0x1
#define _CLC3GLS2_LC3G3D1N_LENGTH                           0x1
#define _CLC3GLS2_LC3G3D1N_MASK                             0x1
#define _CLC3GLS2_LC3G3D1T_POSN                             0x1
#define _CLC3GLS2_LC3G3D1T_POSITION                         0x1
#define _CLC3GLS2_LC3G3D1T_SIZE                             0x1
#define _CLC3GLS2_LC3G3D1T_LENGTH                           0x1
#define _CLC3GLS2_LC3G3D1T_MASK                             0x2
#define _CLC3GLS2_LC3G3D2N_POSN                             0x2
#define _CLC3GLS2_LC3G3D2N_POSITION                         0x2
#define _CLC3GLS2_LC3G3D2N_SIZE                             0x1
#define _CLC3GLS2_LC3G3D2N_LENGTH                           0x1
#define _CLC3GLS2_LC3G3D2N_MASK                             0x4
#define _CLC3GLS2_LC3G3D2T_POSN                             0x3
#define _CLC3GLS2_LC3G3D2T_POSITION                         0x3
#define _CLC3GLS2_LC3G3D2T_SIZE                             0x1
#define _CLC3GLS2_LC3G3D2T_LENGTH                           0x1
#define _CLC3GLS2_LC3G3D2T_MASK                             0x8
#define _CLC3GLS2_LC3G3D3N_POSN                             0x4
#define _CLC3GLS2_LC3G3D3N_POSITION                         0x4
#define _CLC3GLS2_LC3G3D3N_SIZE                             0x1
#define _CLC3GLS2_LC3G3D3N_LENGTH                           0x1
#define _CLC3GLS2_LC3G3D3N_MASK                             0x10
#define _CLC3GLS2_LC3G3D3T_POSN                             0x5
#define _CLC3GLS2_LC3G3D3T_POSITION                         0x5
#define _CLC3GLS2_LC3G3D3T_SIZE                             0x1
#define _CLC3GLS2_LC3G3D3T_LENGTH                           0x1
#define _CLC3GLS2_LC3G3D3T_MASK                             0x20
#define _CLC3GLS2_LC3G3D4N_POSN                             0x6
#define _CLC3GLS2_LC3G3D4N_POSITION                         0x6
#define _CLC3GLS2_LC3G3D4N_SIZE                             0x1
#define _CLC3GLS2_LC3G3D4N_LENGTH                           0x1
#define _CLC3GLS2_LC3G3D4N_MASK                             0x40
#define _CLC3GLS2_LC3G3D4T_POSN                             0x7
#define _CLC3GLS2_LC3G3D4T_POSITION                         0x7
#define _CLC3GLS2_LC3G3D4T_SIZE                             0x1
#define _CLC3GLS2_LC3G3D4T_LENGTH                           0x1
#define _CLC3GLS2_LC3G3D4T_MASK                             0x80
#define _CLC3GLS2_D1N_POSN                                  0x0
#define _CLC3GLS2_D1N_POSITION                              0x0
#define _CLC3GLS2_D1N_SIZE                                  0x1
#define _CLC3GLS2_D1N_LENGTH                                0x1
#define _CLC3GLS2_D1N_MASK                                  0x1
#define _CLC3GLS2_D1T_POSN                                  0x1
#define _CLC3GLS2_D1T_POSITION                              0x1
#define _CLC3GLS2_D1T_SIZE                                  0x1
#define _CLC3GLS2_D1T_LENGTH                                0x1
#define _CLC3GLS2_D1T_MASK                                  0x2
#define _CLC3GLS2_D2N_POSN                                  0x2
#define _CLC3GLS2_D2N_POSITION                              0x2
#define _CLC3GLS2_D2N_SIZE                                  0x1
#define _CLC3GLS2_D2N_LENGTH                                0x1
#define _CLC3GLS2_D2N_MASK                                  0x4
#define _CLC3GLS2_D2T_POSN                                  0x3
#define _CLC3GLS2_D2T_POSITION                              0x3
#define _CLC3GLS2_D2T_SIZE                                  0x1
#define _CLC3GLS2_D2T_LENGTH                                0x1
#define _CLC3GLS2_D2T_MASK                                  0x8
#define _CLC3GLS2_D3N_POSN                                  0x4
#define _CLC3GLS2_D3N_POSITION                              0x4
#define _CLC3GLS2_D3N_SIZE                                  0x1
#define _CLC3GLS2_D3N_LENGTH                                0x1
#define _CLC3GLS2_D3N_MASK                                  0x10
#define _CLC3GLS2_D3T_POSN                                  0x5
#define _CLC3GLS2_D3T_POSITION                              0x5
#define _CLC3GLS2_D3T_SIZE                                  0x1
#define _CLC3GLS2_D3T_LENGTH                                0x1
#define _CLC3GLS2_D3T_MASK                                  0x20
#define _CLC3GLS2_D4N_POSN                                  0x6
#define _CLC3GLS2_D4N_POSITION                              0x6
#define _CLC3GLS2_D4N_SIZE                                  0x1
#define _CLC3GLS2_D4N_LENGTH                                0x1
#define _CLC3GLS2_D4N_MASK                                  0x40
#define _CLC3GLS2_D4T_POSN                                  0x7
#define _CLC3GLS2_D4T_POSITION                              0x7
#define _CLC3GLS2_D4T_SIZE                                  0x1
#define _CLC3GLS2_D4T_LENGTH                                0x1
#define _CLC3GLS2_D4T_MASK                                  0x80

// Register: CLC3GLS3
extern volatile unsigned char           CLC3GLS3            @ 0xF2D;
#ifndef _LIB_BUILD
asm("CLC3GLS3 equ 0F2Dh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC3G4D1N               :1;
        unsigned LC3G4D1T               :1;
        unsigned LC3G4D2N               :1;
        unsigned LC3G4D2T               :1;
        unsigned LC3G4D3N               :1;
        unsigned LC3G4D3T               :1;
        unsigned LC3G4D4N               :1;
        unsigned LC3G4D4T               :1;
    };
    struct {
        unsigned G4D1N                  :1;
        unsigned G4D1T                  :1;
        unsigned G4D2N                  :1;
        unsigned G4D2T                  :1;
        unsigned G4D3N                  :1;
        unsigned G4D3T                  :1;
        unsigned G4D4N                  :1;
        unsigned G4D4T                  :1;
    };
} CLC3GLS3bits_t;
extern volatile CLC3GLS3bits_t CLC3GLS3bits @ 0xF2D;
// bitfield macros
#define _CLC3GLS3_LC3G4D1N_POSN                             0x0
#define _CLC3GLS3_LC3G4D1N_POSITION                         0x0
#define _CLC3GLS3_LC3G4D1N_SIZE                             0x1
#define _CLC3GLS3_LC3G4D1N_LENGTH                           0x1
#define _CLC3GLS3_LC3G4D1N_MASK                             0x1
#define _CLC3GLS3_LC3G4D1T_POSN                             0x1
#define _CLC3GLS3_LC3G4D1T_POSITION                         0x1
#define _CLC3GLS3_LC3G4D1T_SIZE                             0x1
#define _CLC3GLS3_LC3G4D1T_LENGTH                           0x1
#define _CLC3GLS3_LC3G4D1T_MASK                             0x2
#define _CLC3GLS3_LC3G4D2N_POSN                             0x2
#define _CLC3GLS3_LC3G4D2N_POSITION                         0x2
#define _CLC3GLS3_LC3G4D2N_SIZE                             0x1
#define _CLC3GLS3_LC3G4D2N_LENGTH                           0x1
#define _CLC3GLS3_LC3G4D2N_MASK                             0x4
#define _CLC3GLS3_LC3G4D2T_POSN                             0x3
#define _CLC3GLS3_LC3G4D2T_POSITION                         0x3
#define _CLC3GLS3_LC3G4D2T_SIZE                             0x1
#define _CLC3GLS3_LC3G4D2T_LENGTH                           0x1
#define _CLC3GLS3_LC3G4D2T_MASK                             0x8
#define _CLC3GLS3_LC3G4D3N_POSN                             0x4
#define _CLC3GLS3_LC3G4D3N_POSITION                         0x4
#define _CLC3GLS3_LC3G4D3N_SIZE                             0x1
#define _CLC3GLS3_LC3G4D3N_LENGTH                           0x1
#define _CLC3GLS3_LC3G4D3N_MASK                             0x10
#define _CLC3GLS3_LC3G4D3T_POSN                             0x5
#define _CLC3GLS3_LC3G4D3T_POSITION                         0x5
#define _CLC3GLS3_LC3G4D3T_SIZE                             0x1
#define _CLC3GLS3_LC3G4D3T_LENGTH                           0x1
#define _CLC3GLS3_LC3G4D3T_MASK                             0x20
#define _CLC3GLS3_LC3G4D4N_POSN                             0x6
#define _CLC3GLS3_LC3G4D4N_POSITION                         0x6
#define _CLC3GLS3_LC3G4D4N_SIZE                             0x1
#define _CLC3GLS3_LC3G4D4N_LENGTH                           0x1
#define _CLC3GLS3_LC3G4D4N_MASK                             0x40
#define _CLC3GLS3_LC3G4D4T_POSN                             0x7
#define _CLC3GLS3_LC3G4D4T_POSITION                         0x7
#define _CLC3GLS3_LC3G4D4T_SIZE                             0x1
#define _CLC3GLS3_LC3G4D4T_LENGTH                           0x1
#define _CLC3GLS3_LC3G4D4T_MASK                             0x80
#define _CLC3GLS3_G4D1N_POSN                                0x0
#define _CLC3GLS3_G4D1N_POSITION                            0x0
#define _CLC3GLS3_G4D1N_SIZE                                0x1
#define _CLC3GLS3_G4D1N_LENGTH                              0x1
#define _CLC3GLS3_G4D1N_MASK                                0x1
#define _CLC3GLS3_G4D1T_POSN                                0x1
#define _CLC3GLS3_G4D1T_POSITION                            0x1
#define _CLC3GLS3_G4D1T_SIZE                                0x1
#define _CLC3GLS3_G4D1T_LENGTH                              0x1
#define _CLC3GLS3_G4D1T_MASK                                0x2
#define _CLC3GLS3_G4D2N_POSN                                0x2
#define _CLC3GLS3_G4D2N_POSITION                            0x2
#define _CLC3GLS3_G4D2N_SIZE                                0x1
#define _CLC3GLS3_G4D2N_LENGTH                              0x1
#define _CLC3GLS3_G4D2N_MASK                                0x4
#define _CLC3GLS3_G4D2T_POSN                                0x3
#define _CLC3GLS3_G4D2T_POSITION                            0x3
#define _CLC3GLS3_G4D2T_SIZE                                0x1
#define _CLC3GLS3_G4D2T_LENGTH                              0x1
#define _CLC3GLS3_G4D2T_MASK                                0x8
#define _CLC3GLS3_G4D3N_POSN                                0x4
#define _CLC3GLS3_G4D3N_POSITION                            0x4
#define _CLC3GLS3_G4D3N_SIZE                                0x1
#define _CLC3GLS3_G4D3N_LENGTH                              0x1
#define _CLC3GLS3_G4D3N_MASK                                0x10
#define _CLC3GLS3_G4D3T_POSN                                0x5
#define _CLC3GLS3_G4D3T_POSITION                            0x5
#define _CLC3GLS3_G4D3T_SIZE                                0x1
#define _CLC3GLS3_G4D3T_LENGTH                              0x1
#define _CLC3GLS3_G4D3T_MASK                                0x20
#define _CLC3GLS3_G4D4N_POSN                                0x6
#define _CLC3GLS3_G4D4N_POSITION                            0x6
#define _CLC3GLS3_G4D4N_SIZE                                0x1
#define _CLC3GLS3_G4D4N_LENGTH                              0x1
#define _CLC3GLS3_G4D4N_MASK                                0x40
#define _CLC3GLS3_G4D4T_POSN                                0x7
#define _CLC3GLS3_G4D4T_POSITION                            0x7
#define _CLC3GLS3_G4D4T_SIZE                                0x1
#define _CLC3GLS3_G4D4T_LENGTH                              0x1
#define _CLC3GLS3_G4D4T_MASK                                0x80

// Register: CLC4CON
extern volatile unsigned char           CLC4CON             @ 0xF2E;
#ifndef _LIB_BUILD
asm("CLC4CON equ 0F2Eh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC4MODE                :3;
        unsigned LC4INTN                :1;
        unsigned LC4INTP                :1;
        unsigned LC4OUT                 :1;
        unsigned                        :1;
        unsigned LC4EN                  :1;
    };
    struct {
        unsigned LC4MODE0               :1;
        unsigned LC4MODE1               :1;
        unsigned LC4MODE2               :1;
    };
    struct {
        unsigned MODE                   :3;
        unsigned INTN                   :1;
        unsigned INTP                   :1;
        unsigned OUT                    :1;
        unsigned                        :1;
        unsigned EN                     :1;
    };
    struct {
        unsigned MODE0                  :1;
        unsigned MODE1                  :1;
        unsigned MODE2                  :1;
    };
} CLC4CONbits_t;
extern volatile CLC4CONbits_t CLC4CONbits @ 0xF2E;
// bitfield macros
#define _CLC4CON_LC4MODE_POSN                               0x0
#define _CLC4CON_LC4MODE_POSITION                           0x0
#define _CLC4CON_LC4MODE_SIZE                               0x3
#define _CLC4CON_LC4MODE_LENGTH                             0x3
#define _CLC4CON_LC4MODE_MASK                               0x7
#define _CLC4CON_LC4INTN_POSN                               0x3
#define _CLC4CON_LC4INTN_POSITION                           0x3
#define _CLC4CON_LC4INTN_SIZE                               0x1
#define _CLC4CON_LC4INTN_LENGTH                             0x1
#define _CLC4CON_LC4INTN_MASK                               0x8
#define _CLC4CON_LC4INTP_POSN                               0x4
#define _CLC4CON_LC4INTP_POSITION                           0x4
#define _CLC4CON_LC4INTP_SIZE                               0x1
#define _CLC4CON_LC4INTP_LENGTH                             0x1
#define _CLC4CON_LC4INTP_MASK                               0x10
#define _CLC4CON_LC4OUT_POSN                                0x5
#define _CLC4CON_LC4OUT_POSITION                            0x5
#define _CLC4CON_LC4OUT_SIZE                                0x1
#define _CLC4CON_LC4OUT_LENGTH                              0x1
#define _CLC4CON_LC4OUT_MASK                                0x20
#define _CLC4CON_LC4EN_POSN                                 0x7
#define _CLC4CON_LC4EN_POSITION                             0x7
#define _CLC4CON_LC4EN_SIZE                                 0x1
#define _CLC4CON_LC4EN_LENGTH                               0x1
#define _CLC4CON_LC4EN_MASK                                 0x80
#define _CLC4CON_LC4MODE0_POSN                              0x0
#define _CLC4CON_LC4MODE0_POSITION                          0x0
#define _CLC4CON_LC4MODE0_SIZE                              0x1
#define _CLC4CON_LC4MODE0_LENGTH                            0x1
#define _CLC4CON_LC4MODE0_MASK                              0x1
#define _CLC4CON_LC4MODE1_POSN                              0x1
#define _CLC4CON_LC4MODE1_POSITION                          0x1
#define _CLC4CON_LC4MODE1_SIZE                              0x1
#define _CLC4CON_LC4MODE1_LENGTH                            0x1
#define _CLC4CON_LC4MODE1_MASK                              0x2
#define _CLC4CON_LC4MODE2_POSN                              0x2
#define _CLC4CON_LC4MODE2_POSITION                          0x2
#define _CLC4CON_LC4MODE2_SIZE                              0x1
#define _CLC4CON_LC4MODE2_LENGTH                            0x1
#define _CLC4CON_LC4MODE2_MASK                              0x4
#define _CLC4CON_MODE_POSN                                  0x0
#define _CLC4CON_MODE_POSITION                              0x0
#define _CLC4CON_MODE_SIZE                                  0x3
#define _CLC4CON_MODE_LENGTH                                0x3
#define _CLC4CON_MODE_MASK                                  0x7
#define _CLC4CON_INTN_POSN                                  0x3
#define _CLC4CON_INTN_POSITION                              0x3
#define _CLC4CON_INTN_SIZE                                  0x1
#define _CLC4CON_INTN_LENGTH                                0x1
#define _CLC4CON_INTN_MASK                                  0x8
#define _CLC4CON_INTP_POSN                                  0x4
#define _CLC4CON_INTP_POSITION                              0x4
#define _CLC4CON_INTP_SIZE                                  0x1
#define _CLC4CON_INTP_LENGTH                                0x1
#define _CLC4CON_INTP_MASK                                  0x10
#define _CLC4CON_OUT_POSN                                   0x5
#define _CLC4CON_OUT_POSITION                               0x5
#define _CLC4CON_OUT_SIZE                                   0x1
#define _CLC4CON_OUT_LENGTH                                 0x1
#define _CLC4CON_OUT_MASK                                   0x20
#define _CLC4CON_EN_POSN                                    0x7
#define _CLC4CON_EN_POSITION                                0x7
#define _CLC4CON_EN_SIZE                                    0x1
#define _CLC4CON_EN_LENGTH                                  0x1
#define _CLC4CON_EN_MASK                                    0x80
#define _CLC4CON_MODE0_POSN                                 0x0
#define _CLC4CON_MODE0_POSITION                             0x0
#define _CLC4CON_MODE0_SIZE                                 0x1
#define _CLC4CON_MODE0_LENGTH                               0x1
#define _CLC4CON_MODE0_MASK                                 0x1
#define _CLC4CON_MODE1_POSN                                 0x1
#define _CLC4CON_MODE1_POSITION                             0x1
#define _CLC4CON_MODE1_SIZE                                 0x1
#define _CLC4CON_MODE1_LENGTH                               0x1
#define _CLC4CON_MODE1_MASK                                 0x2
#define _CLC4CON_MODE2_POSN                                 0x2
#define _CLC4CON_MODE2_POSITION                             0x2
#define _CLC4CON_MODE2_SIZE                                 0x1
#define _CLC4CON_MODE2_LENGTH                               0x1
#define _CLC4CON_MODE2_MASK                                 0x4

// Register: CLC4POL
extern volatile unsigned char           CLC4POL             @ 0xF2F;
#ifndef _LIB_BUILD
asm("CLC4POL equ 0F2Fh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC4G1POL               :1;
        unsigned LC4G2POL               :1;
        unsigned LC4G3POL               :1;
        unsigned LC4G4POL               :1;
        unsigned                        :3;
        unsigned LC4POL                 :1;
    };
    struct {
        unsigned G1POL                  :1;
        unsigned G2POL                  :1;
        unsigned G3POL                  :1;
        unsigned G4POL                  :1;
        unsigned                        :3;
        unsigned POL                    :1;
    };
} CLC4POLbits_t;
extern volatile CLC4POLbits_t CLC4POLbits @ 0xF2F;
// bitfield macros
#define _CLC4POL_LC4G1POL_POSN                              0x0
#define _CLC4POL_LC4G1POL_POSITION                          0x0
#define _CLC4POL_LC4G1POL_SIZE                              0x1
#define _CLC4POL_LC4G1POL_LENGTH                            0x1
#define _CLC4POL_LC4G1POL_MASK                              0x1
#define _CLC4POL_LC4G2POL_POSN                              0x1
#define _CLC4POL_LC4G2POL_POSITION                          0x1
#define _CLC4POL_LC4G2POL_SIZE                              0x1
#define _CLC4POL_LC4G2POL_LENGTH                            0x1
#define _CLC4POL_LC4G2POL_MASK                              0x2
#define _CLC4POL_LC4G3POL_POSN                              0x2
#define _CLC4POL_LC4G3POL_POSITION                          0x2
#define _CLC4POL_LC4G3POL_SIZE                              0x1
#define _CLC4POL_LC4G3POL_LENGTH                            0x1
#define _CLC4POL_LC4G3POL_MASK                              0x4
#define _CLC4POL_LC4G4POL_POSN                              0x3
#define _CLC4POL_LC4G4POL_POSITION                          0x3
#define _CLC4POL_LC4G4POL_SIZE                              0x1
#define _CLC4POL_LC4G4POL_LENGTH                            0x1
#define _CLC4POL_LC4G4POL_MASK                              0x8
#define _CLC4POL_LC4POL_POSN                                0x7
#define _CLC4POL_LC4POL_POSITION                            0x7
#define _CLC4POL_LC4POL_SIZE                                0x1
#define _CLC4POL_LC4POL_LENGTH                              0x1
#define _CLC4POL_LC4POL_MASK                                0x80
#define _CLC4POL_G1POL_POSN                                 0x0
#define _CLC4POL_G1POL_POSITION                             0x0
#define _CLC4POL_G1POL_SIZE                                 0x1
#define _CLC4POL_G1POL_LENGTH                               0x1
#define _CLC4POL_G1POL_MASK                                 0x1
#define _CLC4POL_G2POL_POSN                                 0x1
#define _CLC4POL_G2POL_POSITION                             0x1
#define _CLC4POL_G2POL_SIZE                                 0x1
#define _CLC4POL_G2POL_LENGTH                               0x1
#define _CLC4POL_G2POL_MASK                                 0x2
#define _CLC4POL_G3POL_POSN                                 0x2
#define _CLC4POL_G3POL_POSITION                             0x2
#define _CLC4POL_G3POL_SIZE                                 0x1
#define _CLC4POL_G3POL_LENGTH                               0x1
#define _CLC4POL_G3POL_MASK                                 0x4
#define _CLC4POL_G4POL_POSN                                 0x3
#define _CLC4POL_G4POL_POSITION                             0x3
#define _CLC4POL_G4POL_SIZE                                 0x1
#define _CLC4POL_G4POL_LENGTH                               0x1
#define _CLC4POL_G4POL_MASK                                 0x8
#define _CLC4POL_POL_POSN                                   0x7
#define _CLC4POL_POL_POSITION                               0x7
#define _CLC4POL_POL_SIZE                                   0x1
#define _CLC4POL_POL_LENGTH                                 0x1
#define _CLC4POL_POL_MASK                                   0x80

// Register: CLC4SEL0
extern volatile unsigned char           CLC4SEL0            @ 0xF30;
#ifndef _LIB_BUILD
asm("CLC4SEL0 equ 0F30h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC4D1S0                :1;
        unsigned LC4D1S1                :1;
        unsigned LC4D1S2                :1;
        unsigned LC4D1S3                :1;
        unsigned LC4D1S4                :1;
        unsigned LC4D1S5                :1;
    };
    struct {
        unsigned LC4D1S                 :8;
    };
    struct {
        unsigned D1S                    :8;
    };
    struct {
        unsigned D1S0                   :1;
        unsigned D1S1                   :1;
        unsigned D1S2                   :1;
        unsigned D1S3                   :1;
        unsigned D1S4                   :1;
        unsigned D1S5                   :1;
    };
} CLC4SEL0bits_t;
extern volatile CLC4SEL0bits_t CLC4SEL0bits @ 0xF30;
// bitfield macros
#define _CLC4SEL0_LC4D1S0_POSN                              0x0
#define _CLC4SEL0_LC4D1S0_POSITION                          0x0
#define _CLC4SEL0_LC4D1S0_SIZE                              0x1
#define _CLC4SEL0_LC4D1S0_LENGTH                            0x1
#define _CLC4SEL0_LC4D1S0_MASK                              0x1
#define _CLC4SEL0_LC4D1S1_POSN                              0x1
#define _CLC4SEL0_LC4D1S1_POSITION                          0x1
#define _CLC4SEL0_LC4D1S1_SIZE                              0x1
#define _CLC4SEL0_LC4D1S1_LENGTH                            0x1
#define _CLC4SEL0_LC4D1S1_MASK                              0x2
#define _CLC4SEL0_LC4D1S2_POSN                              0x2
#define _CLC4SEL0_LC4D1S2_POSITION                          0x2
#define _CLC4SEL0_LC4D1S2_SIZE                              0x1
#define _CLC4SEL0_LC4D1S2_LENGTH                            0x1
#define _CLC4SEL0_LC4D1S2_MASK                              0x4
#define _CLC4SEL0_LC4D1S3_POSN                              0x3
#define _CLC4SEL0_LC4D1S3_POSITION                          0x3
#define _CLC4SEL0_LC4D1S3_SIZE                              0x1
#define _CLC4SEL0_LC4D1S3_LENGTH                            0x1
#define _CLC4SEL0_LC4D1S3_MASK                              0x8
#define _CLC4SEL0_LC4D1S4_POSN                              0x4
#define _CLC4SEL0_LC4D1S4_POSITION                          0x4
#define _CLC4SEL0_LC4D1S4_SIZE                              0x1
#define _CLC4SEL0_LC4D1S4_LENGTH                            0x1
#define _CLC4SEL0_LC4D1S4_MASK                              0x10
#define _CLC4SEL0_LC4D1S5_POSN                              0x5
#define _CLC4SEL0_LC4D1S5_POSITION                          0x5
#define _CLC4SEL0_LC4D1S5_SIZE                              0x1
#define _CLC4SEL0_LC4D1S5_LENGTH                            0x1
#define _CLC4SEL0_LC4D1S5_MASK                              0x20
#define _CLC4SEL0_LC4D1S_POSN                               0x0
#define _CLC4SEL0_LC4D1S_POSITION                           0x0
#define _CLC4SEL0_LC4D1S_SIZE                               0x8
#define _CLC4SEL0_LC4D1S_LENGTH                             0x8
#define _CLC4SEL0_LC4D1S_MASK                               0xFF
#define _CLC4SEL0_D1S_POSN                                  0x0
#define _CLC4SEL0_D1S_POSITION                              0x0
#define _CLC4SEL0_D1S_SIZE                                  0x8
#define _CLC4SEL0_D1S_LENGTH                                0x8
#define _CLC4SEL0_D1S_MASK                                  0xFF
#define _CLC4SEL0_D1S0_POSN                                 0x0
#define _CLC4SEL0_D1S0_POSITION                             0x0
#define _CLC4SEL0_D1S0_SIZE                                 0x1
#define _CLC4SEL0_D1S0_LENGTH                               0x1
#define _CLC4SEL0_D1S0_MASK                                 0x1
#define _CLC4SEL0_D1S1_POSN                                 0x1
#define _CLC4SEL0_D1S1_POSITION                             0x1
#define _CLC4SEL0_D1S1_SIZE                                 0x1
#define _CLC4SEL0_D1S1_LENGTH                               0x1
#define _CLC4SEL0_D1S1_MASK                                 0x2
#define _CLC4SEL0_D1S2_POSN                                 0x2
#define _CLC4SEL0_D1S2_POSITION                             0x2
#define _CLC4SEL0_D1S2_SIZE                                 0x1
#define _CLC4SEL0_D1S2_LENGTH                               0x1
#define _CLC4SEL0_D1S2_MASK                                 0x4
#define _CLC4SEL0_D1S3_POSN                                 0x3
#define _CLC4SEL0_D1S3_POSITION                             0x3
#define _CLC4SEL0_D1S3_SIZE                                 0x1
#define _CLC4SEL0_D1S3_LENGTH                               0x1
#define _CLC4SEL0_D1S3_MASK                                 0x8
#define _CLC4SEL0_D1S4_POSN                                 0x4
#define _CLC4SEL0_D1S4_POSITION                             0x4
#define _CLC4SEL0_D1S4_SIZE                                 0x1
#define _CLC4SEL0_D1S4_LENGTH                               0x1
#define _CLC4SEL0_D1S4_MASK                                 0x10
#define _CLC4SEL0_D1S5_POSN                                 0x5
#define _CLC4SEL0_D1S5_POSITION                             0x5
#define _CLC4SEL0_D1S5_SIZE                                 0x1
#define _CLC4SEL0_D1S5_LENGTH                               0x1
#define _CLC4SEL0_D1S5_MASK                                 0x20

// Register: CLC4SEL1
extern volatile unsigned char           CLC4SEL1            @ 0xF31;
#ifndef _LIB_BUILD
asm("CLC4SEL1 equ 0F31h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC4D2S0                :1;
        unsigned LC4D2S1                :1;
        unsigned LC4D2S2                :1;
        unsigned LC4D2S3                :1;
        unsigned LC4D2S4                :1;
        unsigned LC4D2S5                :1;
    };
    struct {
        unsigned LC4D2S                 :8;
    };
    struct {
        unsigned D2S                    :8;
    };
    struct {
        unsigned D2S0                   :1;
        unsigned D2S1                   :1;
        unsigned D2S2                   :1;
        unsigned D2S3                   :1;
        unsigned D2S4                   :1;
        unsigned D2S5                   :1;
    };
} CLC4SEL1bits_t;
extern volatile CLC4SEL1bits_t CLC4SEL1bits @ 0xF31;
// bitfield macros
#define _CLC4SEL1_LC4D2S0_POSN                              0x0
#define _CLC4SEL1_LC4D2S0_POSITION                          0x0
#define _CLC4SEL1_LC4D2S0_SIZE                              0x1
#define _CLC4SEL1_LC4D2S0_LENGTH                            0x1
#define _CLC4SEL1_LC4D2S0_MASK                              0x1
#define _CLC4SEL1_LC4D2S1_POSN                              0x1
#define _CLC4SEL1_LC4D2S1_POSITION                          0x1
#define _CLC4SEL1_LC4D2S1_SIZE                              0x1
#define _CLC4SEL1_LC4D2S1_LENGTH                            0x1
#define _CLC4SEL1_LC4D2S1_MASK                              0x2
#define _CLC4SEL1_LC4D2S2_POSN                              0x2
#define _CLC4SEL1_LC4D2S2_POSITION                          0x2
#define _CLC4SEL1_LC4D2S2_SIZE                              0x1
#define _CLC4SEL1_LC4D2S2_LENGTH                            0x1
#define _CLC4SEL1_LC4D2S2_MASK                              0x4
#define _CLC4SEL1_LC4D2S3_POSN                              0x3
#define _CLC4SEL1_LC4D2S3_POSITION                          0x3
#define _CLC4SEL1_LC4D2S3_SIZE                              0x1
#define _CLC4SEL1_LC4D2S3_LENGTH                            0x1
#define _CLC4SEL1_LC4D2S3_MASK                              0x8
#define _CLC4SEL1_LC4D2S4_POSN                              0x4
#define _CLC4SEL1_LC4D2S4_POSITION                          0x4
#define _CLC4SEL1_LC4D2S4_SIZE                              0x1
#define _CLC4SEL1_LC4D2S4_LENGTH                            0x1
#define _CLC4SEL1_LC4D2S4_MASK                              0x10
#define _CLC4SEL1_LC4D2S5_POSN                              0x5
#define _CLC4SEL1_LC4D2S5_POSITION                          0x5
#define _CLC4SEL1_LC4D2S5_SIZE                              0x1
#define _CLC4SEL1_LC4D2S5_LENGTH                            0x1
#define _CLC4SEL1_LC4D2S5_MASK                              0x20
#define _CLC4SEL1_LC4D2S_POSN                               0x0
#define _CLC4SEL1_LC4D2S_POSITION                           0x0
#define _CLC4SEL1_LC4D2S_SIZE                               0x8
#define _CLC4SEL1_LC4D2S_LENGTH                             0x8
#define _CLC4SEL1_LC4D2S_MASK                               0xFF
#define _CLC4SEL1_D2S_POSN                                  0x0
#define _CLC4SEL1_D2S_POSITION                              0x0
#define _CLC4SEL1_D2S_SIZE                                  0x8
#define _CLC4SEL1_D2S_LENGTH                                0x8
#define _CLC4SEL1_D2S_MASK                                  0xFF
#define _CLC4SEL1_D2S0_POSN                                 0x0
#define _CLC4SEL1_D2S0_POSITION                             0x0
#define _CLC4SEL1_D2S0_SIZE                                 0x1
#define _CLC4SEL1_D2S0_LENGTH                               0x1
#define _CLC4SEL1_D2S0_MASK                                 0x1
#define _CLC4SEL1_D2S1_POSN                                 0x1
#define _CLC4SEL1_D2S1_POSITION                             0x1
#define _CLC4SEL1_D2S1_SIZE                                 0x1
#define _CLC4SEL1_D2S1_LENGTH                               0x1
#define _CLC4SEL1_D2S1_MASK                                 0x2
#define _CLC4SEL1_D2S2_POSN                                 0x2
#define _CLC4SEL1_D2S2_POSITION                             0x2
#define _CLC4SEL1_D2S2_SIZE                                 0x1
#define _CLC4SEL1_D2S2_LENGTH                               0x1
#define _CLC4SEL1_D2S2_MASK                                 0x4
#define _CLC4SEL1_D2S3_POSN                                 0x3
#define _CLC4SEL1_D2S3_POSITION                             0x3
#define _CLC4SEL1_D2S3_SIZE                                 0x1
#define _CLC4SEL1_D2S3_LENGTH                               0x1
#define _CLC4SEL1_D2S3_MASK                                 0x8
#define _CLC4SEL1_D2S4_POSN                                 0x4
#define _CLC4SEL1_D2S4_POSITION                             0x4
#define _CLC4SEL1_D2S4_SIZE                                 0x1
#define _CLC4SEL1_D2S4_LENGTH                               0x1
#define _CLC4SEL1_D2S4_MASK                                 0x10
#define _CLC4SEL1_D2S5_POSN                                 0x5
#define _CLC4SEL1_D2S5_POSITION                             0x5
#define _CLC4SEL1_D2S5_SIZE                                 0x1
#define _CLC4SEL1_D2S5_LENGTH                               0x1
#define _CLC4SEL1_D2S5_MASK                                 0x20

// Register: CLC4SEL2
extern volatile unsigned char           CLC4SEL2            @ 0xF32;
#ifndef _LIB_BUILD
asm("CLC4SEL2 equ 0F32h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC4D3S0                :1;
        unsigned LC4D3S1                :1;
        unsigned LC4D3S2                :1;
        unsigned LC4D3S3                :1;
        unsigned LC4D3S4                :1;
        unsigned LC4D3S5                :1;
    };
    struct {
        unsigned LC4D3S                 :8;
    };
    struct {
        unsigned D3S                    :8;
    };
    struct {
        unsigned D3S0                   :1;
        unsigned D3S1                   :1;
        unsigned D3S2                   :1;
        unsigned D3S3                   :1;
        unsigned D3S4                   :1;
        unsigned D3S5                   :1;
    };
} CLC4SEL2bits_t;
extern volatile CLC4SEL2bits_t CLC4SEL2bits @ 0xF32;
// bitfield macros
#define _CLC4SEL2_LC4D3S0_POSN                              0x0
#define _CLC4SEL2_LC4D3S0_POSITION                          0x0
#define _CLC4SEL2_LC4D3S0_SIZE                              0x1
#define _CLC4SEL2_LC4D3S0_LENGTH                            0x1
#define _CLC4SEL2_LC4D3S0_MASK                              0x1
#define _CLC4SEL2_LC4D3S1_POSN                              0x1
#define _CLC4SEL2_LC4D3S1_POSITION                          0x1
#define _CLC4SEL2_LC4D3S1_SIZE                              0x1
#define _CLC4SEL2_LC4D3S1_LENGTH                            0x1
#define _CLC4SEL2_LC4D3S1_MASK                              0x2
#define _CLC4SEL2_LC4D3S2_POSN                              0x2
#define _CLC4SEL2_LC4D3S2_POSITION                          0x2
#define _CLC4SEL2_LC4D3S2_SIZE                              0x1
#define _CLC4SEL2_LC4D3S2_LENGTH                            0x1
#define _CLC4SEL2_LC4D3S2_MASK                              0x4
#define _CLC4SEL2_LC4D3S3_POSN                              0x3
#define _CLC4SEL2_LC4D3S3_POSITION                          0x3
#define _CLC4SEL2_LC4D3S3_SIZE                              0x1
#define _CLC4SEL2_LC4D3S3_LENGTH                            0x1
#define _CLC4SEL2_LC4D3S3_MASK                              0x8
#define _CLC4SEL2_LC4D3S4_POSN                              0x4
#define _CLC4SEL2_LC4D3S4_POSITION                          0x4
#define _CLC4SEL2_LC4D3S4_SIZE                              0x1
#define _CLC4SEL2_LC4D3S4_LENGTH                            0x1
#define _CLC4SEL2_LC4D3S4_MASK                              0x10
#define _CLC4SEL2_LC4D3S5_POSN                              0x5
#define _CLC4SEL2_LC4D3S5_POSITION                          0x5
#define _CLC4SEL2_LC4D3S5_SIZE                              0x1
#define _CLC4SEL2_LC4D3S5_LENGTH                            0x1
#define _CLC4SEL2_LC4D3S5_MASK                              0x20
#define _CLC4SEL2_LC4D3S_POSN                               0x0
#define _CLC4SEL2_LC4D3S_POSITION                           0x0
#define _CLC4SEL2_LC4D3S_SIZE                               0x8
#define _CLC4SEL2_LC4D3S_LENGTH                             0x8
#define _CLC4SEL2_LC4D3S_MASK                               0xFF
#define _CLC4SEL2_D3S_POSN                                  0x0
#define _CLC4SEL2_D3S_POSITION                              0x0
#define _CLC4SEL2_D3S_SIZE                                  0x8
#define _CLC4SEL2_D3S_LENGTH                                0x8
#define _CLC4SEL2_D3S_MASK                                  0xFF
#define _CLC4SEL2_D3S0_POSN                                 0x0
#define _CLC4SEL2_D3S0_POSITION                             0x0
#define _CLC4SEL2_D3S0_SIZE                                 0x1
#define _CLC4SEL2_D3S0_LENGTH                               0x1
#define _CLC4SEL2_D3S0_MASK                                 0x1
#define _CLC4SEL2_D3S1_POSN                                 0x1
#define _CLC4SEL2_D3S1_POSITION                             0x1
#define _CLC4SEL2_D3S1_SIZE                                 0x1
#define _CLC4SEL2_D3S1_LENGTH                               0x1
#define _CLC4SEL2_D3S1_MASK                                 0x2
#define _CLC4SEL2_D3S2_POSN                                 0x2
#define _CLC4SEL2_D3S2_POSITION                             0x2
#define _CLC4SEL2_D3S2_SIZE                                 0x1
#define _CLC4SEL2_D3S2_LENGTH                               0x1
#define _CLC4SEL2_D3S2_MASK                                 0x4
#define _CLC4SEL2_D3S3_POSN                                 0x3
#define _CLC4SEL2_D3S3_POSITION                             0x3
#define _CLC4SEL2_D3S3_SIZE                                 0x1
#define _CLC4SEL2_D3S3_LENGTH                               0x1
#define _CLC4SEL2_D3S3_MASK                                 0x8
#define _CLC4SEL2_D3S4_POSN                                 0x4
#define _CLC4SEL2_D3S4_POSITION                             0x4
#define _CLC4SEL2_D3S4_SIZE                                 0x1
#define _CLC4SEL2_D3S4_LENGTH                               0x1
#define _CLC4SEL2_D3S4_MASK                                 0x10
#define _CLC4SEL2_D3S5_POSN                                 0x5
#define _CLC4SEL2_D3S5_POSITION                             0x5
#define _CLC4SEL2_D3S5_SIZE                                 0x1
#define _CLC4SEL2_D3S5_LENGTH                               0x1
#define _CLC4SEL2_D3S5_MASK                                 0x20

// Register: CLC4SEL3
extern volatile unsigned char           CLC4SEL3            @ 0xF33;
#ifndef _LIB_BUILD
asm("CLC4SEL3 equ 0F33h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC4D4S0                :1;
        unsigned LC4D4S1                :1;
        unsigned LC4D4S2                :1;
        unsigned LC4D4S3                :1;
        unsigned LC4D4S4                :1;
        unsigned LC4D4S5                :1;
    };
    struct {
        unsigned LC4D4S                 :8;
    };
    struct {
        unsigned D4S                    :8;
    };
    struct {
        unsigned D4S0                   :1;
        unsigned D4S1                   :1;
        unsigned D4S2                   :1;
        unsigned D4S3                   :1;
        unsigned D4S4                   :1;
        unsigned D4S5                   :1;
    };
} CLC4SEL3bits_t;
extern volatile CLC4SEL3bits_t CLC4SEL3bits @ 0xF33;
// bitfield macros
#define _CLC4SEL3_LC4D4S0_POSN                              0x0
#define _CLC4SEL3_LC4D4S0_POSITION                          0x0
#define _CLC4SEL3_LC4D4S0_SIZE                              0x1
#define _CLC4SEL3_LC4D4S0_LENGTH                            0x1
#define _CLC4SEL3_LC4D4S0_MASK                              0x1
#define _CLC4SEL3_LC4D4S1_POSN                              0x1
#define _CLC4SEL3_LC4D4S1_POSITION                          0x1
#define _CLC4SEL3_LC4D4S1_SIZE                              0x1
#define _CLC4SEL3_LC4D4S1_LENGTH                            0x1
#define _CLC4SEL3_LC4D4S1_MASK                              0x2
#define _CLC4SEL3_LC4D4S2_POSN                              0x2
#define _CLC4SEL3_LC4D4S2_POSITION                          0x2
#define _CLC4SEL3_LC4D4S2_SIZE                              0x1
#define _CLC4SEL3_LC4D4S2_LENGTH                            0x1
#define _CLC4SEL3_LC4D4S2_MASK                              0x4
#define _CLC4SEL3_LC4D4S3_POSN                              0x3
#define _CLC4SEL3_LC4D4S3_POSITION                          0x3
#define _CLC4SEL3_LC4D4S3_SIZE                              0x1
#define _CLC4SEL3_LC4D4S3_LENGTH                            0x1
#define _CLC4SEL3_LC4D4S3_MASK                              0x8
#define _CLC4SEL3_LC4D4S4_POSN                              0x4
#define _CLC4SEL3_LC4D4S4_POSITION                          0x4
#define _CLC4SEL3_LC4D4S4_SIZE                              0x1
#define _CLC4SEL3_LC4D4S4_LENGTH                            0x1
#define _CLC4SEL3_LC4D4S4_MASK                              0x10
#define _CLC4SEL3_LC4D4S5_POSN                              0x5
#define _CLC4SEL3_LC4D4S5_POSITION                          0x5
#define _CLC4SEL3_LC4D4S5_SIZE                              0x1
#define _CLC4SEL3_LC4D4S5_LENGTH                            0x1
#define _CLC4SEL3_LC4D4S5_MASK                              0x20
#define _CLC4SEL3_LC4D4S_POSN                               0x0
#define _CLC4SEL3_LC4D4S_POSITION                           0x0
#define _CLC4SEL3_LC4D4S_SIZE                               0x8
#define _CLC4SEL3_LC4D4S_LENGTH                             0x8
#define _CLC4SEL3_LC4D4S_MASK                               0xFF
#define _CLC4SEL3_D4S_POSN                                  0x0
#define _CLC4SEL3_D4S_POSITION                              0x0
#define _CLC4SEL3_D4S_SIZE                                  0x8
#define _CLC4SEL3_D4S_LENGTH                                0x8
#define _CLC4SEL3_D4S_MASK                                  0xFF
#define _CLC4SEL3_D4S0_POSN                                 0x0
#define _CLC4SEL3_D4S0_POSITION                             0x0
#define _CLC4SEL3_D4S0_SIZE                                 0x1
#define _CLC4SEL3_D4S0_LENGTH                               0x1
#define _CLC4SEL3_D4S0_MASK                                 0x1
#define _CLC4SEL3_D4S1_POSN                                 0x1
#define _CLC4SEL3_D4S1_POSITION                             0x1
#define _CLC4SEL3_D4S1_SIZE                                 0x1
#define _CLC4SEL3_D4S1_LENGTH                               0x1
#define _CLC4SEL3_D4S1_MASK                                 0x2
#define _CLC4SEL3_D4S2_POSN                                 0x2
#define _CLC4SEL3_D4S2_POSITION                             0x2
#define _CLC4SEL3_D4S2_SIZE                                 0x1
#define _CLC4SEL3_D4S2_LENGTH                               0x1
#define _CLC4SEL3_D4S2_MASK                                 0x4
#define _CLC4SEL3_D4S3_POSN                                 0x3
#define _CLC4SEL3_D4S3_POSITION                             0x3
#define _CLC4SEL3_D4S3_SIZE                                 0x1
#define _CLC4SEL3_D4S3_LENGTH                               0x1
#define _CLC4SEL3_D4S3_MASK                                 0x8
#define _CLC4SEL3_D4S4_POSN                                 0x4
#define _CLC4SEL3_D4S4_POSITION                             0x4
#define _CLC4SEL3_D4S4_SIZE                                 0x1
#define _CLC4SEL3_D4S4_LENGTH                               0x1
#define _CLC4SEL3_D4S4_MASK                                 0x10
#define _CLC4SEL3_D4S5_POSN                                 0x5
#define _CLC4SEL3_D4S5_POSITION                             0x5
#define _CLC4SEL3_D4S5_SIZE                                 0x1
#define _CLC4SEL3_D4S5_LENGTH                               0x1
#define _CLC4SEL3_D4S5_MASK                                 0x20

// Register: CLC4GLS0
extern volatile unsigned char           CLC4GLS0            @ 0xF34;
#ifndef _LIB_BUILD
asm("CLC4GLS0 equ 0F34h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC4G1D1N               :1;
        unsigned LC4G1D1T               :1;
        unsigned LC4G1D2N               :1;
        unsigned LC4G1D2T               :1;
        unsigned LC4G1D3N               :1;
        unsigned LC4G1D3T               :1;
        unsigned LC4G1D4N               :1;
        unsigned LC4G1D4T               :1;
    };
    struct {
        unsigned D1N                    :1;
        unsigned D1T                    :1;
        unsigned D2N                    :1;
        unsigned D2T                    :1;
        unsigned D3N                    :1;
        unsigned D3T                    :1;
        unsigned D4N                    :1;
        unsigned D4T                    :1;
    };
} CLC4GLS0bits_t;
extern volatile CLC4GLS0bits_t CLC4GLS0bits @ 0xF34;
// bitfield macros
#define _CLC4GLS0_LC4G1D1N_POSN                             0x0
#define _CLC4GLS0_LC4G1D1N_POSITION                         0x0
#define _CLC4GLS0_LC4G1D1N_SIZE                             0x1
#define _CLC4GLS0_LC4G1D1N_LENGTH                           0x1
#define _CLC4GLS0_LC4G1D1N_MASK                             0x1
#define _CLC4GLS0_LC4G1D1T_POSN                             0x1
#define _CLC4GLS0_LC4G1D1T_POSITION                         0x1
#define _CLC4GLS0_LC4G1D1T_SIZE                             0x1
#define _CLC4GLS0_LC4G1D1T_LENGTH                           0x1
#define _CLC4GLS0_LC4G1D1T_MASK                             0x2
#define _CLC4GLS0_LC4G1D2N_POSN                             0x2
#define _CLC4GLS0_LC4G1D2N_POSITION                         0x2
#define _CLC4GLS0_LC4G1D2N_SIZE                             0x1
#define _CLC4GLS0_LC4G1D2N_LENGTH                           0x1
#define _CLC4GLS0_LC4G1D2N_MASK                             0x4
#define _CLC4GLS0_LC4G1D2T_POSN                             0x3
#define _CLC4GLS0_LC4G1D2T_POSITION                         0x3
#define _CLC4GLS0_LC4G1D2T_SIZE                             0x1
#define _CLC4GLS0_LC4G1D2T_LENGTH                           0x1
#define _CLC4GLS0_LC4G1D2T_MASK                             0x8
#define _CLC4GLS0_LC4G1D3N_POSN                             0x4
#define _CLC4GLS0_LC4G1D3N_POSITION                         0x4
#define _CLC4GLS0_LC4G1D3N_SIZE                             0x1
#define _CLC4GLS0_LC4G1D3N_LENGTH                           0x1
#define _CLC4GLS0_LC4G1D3N_MASK                             0x10
#define _CLC4GLS0_LC4G1D3T_POSN                             0x5
#define _CLC4GLS0_LC4G1D3T_POSITION                         0x5
#define _CLC4GLS0_LC4G1D3T_SIZE                             0x1
#define _CLC4GLS0_LC4G1D3T_LENGTH                           0x1
#define _CLC4GLS0_LC4G1D3T_MASK                             0x20
#define _CLC4GLS0_LC4G1D4N_POSN                             0x6
#define _CLC4GLS0_LC4G1D4N_POSITION                         0x6
#define _CLC4GLS0_LC4G1D4N_SIZE                             0x1
#define _CLC4GLS0_LC4G1D4N_LENGTH                           0x1
#define _CLC4GLS0_LC4G1D4N_MASK                             0x40
#define _CLC4GLS0_LC4G1D4T_POSN                             0x7
#define _CLC4GLS0_LC4G1D4T_POSITION                         0x7
#define _CLC4GLS0_LC4G1D4T_SIZE                             0x1
#define _CLC4GLS0_LC4G1D4T_LENGTH                           0x1
#define _CLC4GLS0_LC4G1D4T_MASK                             0x80
#define _CLC4GLS0_D1N_POSN                                  0x0
#define _CLC4GLS0_D1N_POSITION                              0x0
#define _CLC4GLS0_D1N_SIZE                                  0x1
#define _CLC4GLS0_D1N_LENGTH                                0x1
#define _CLC4GLS0_D1N_MASK                                  0x1
#define _CLC4GLS0_D1T_POSN                                  0x1
#define _CLC4GLS0_D1T_POSITION                              0x1
#define _CLC4GLS0_D1T_SIZE                                  0x1
#define _CLC4GLS0_D1T_LENGTH                                0x1
#define _CLC4GLS0_D1T_MASK                                  0x2
#define _CLC4GLS0_D2N_POSN                                  0x2
#define _CLC4GLS0_D2N_POSITION                              0x2
#define _CLC4GLS0_D2N_SIZE                                  0x1
#define _CLC4GLS0_D2N_LENGTH                                0x1
#define _CLC4GLS0_D2N_MASK                                  0x4
#define _CLC4GLS0_D2T_POSN                                  0x3
#define _CLC4GLS0_D2T_POSITION                              0x3
#define _CLC4GLS0_D2T_SIZE                                  0x1
#define _CLC4GLS0_D2T_LENGTH                                0x1
#define _CLC4GLS0_D2T_MASK                                  0x8
#define _CLC4GLS0_D3N_POSN                                  0x4
#define _CLC4GLS0_D3N_POSITION                              0x4
#define _CLC4GLS0_D3N_SIZE                                  0x1
#define _CLC4GLS0_D3N_LENGTH                                0x1
#define _CLC4GLS0_D3N_MASK                                  0x10
#define _CLC4GLS0_D3T_POSN                                  0x5
#define _CLC4GLS0_D3T_POSITION                              0x5
#define _CLC4GLS0_D3T_SIZE                                  0x1
#define _CLC4GLS0_D3T_LENGTH                                0x1
#define _CLC4GLS0_D3T_MASK                                  0x20
#define _CLC4GLS0_D4N_POSN                                  0x6
#define _CLC4GLS0_D4N_POSITION                              0x6
#define _CLC4GLS0_D4N_SIZE                                  0x1
#define _CLC4GLS0_D4N_LENGTH                                0x1
#define _CLC4GLS0_D4N_MASK                                  0x40
#define _CLC4GLS0_D4T_POSN                                  0x7
#define _CLC4GLS0_D4T_POSITION                              0x7
#define _CLC4GLS0_D4T_SIZE                                  0x1
#define _CLC4GLS0_D4T_LENGTH                                0x1
#define _CLC4GLS0_D4T_MASK                                  0x80

// Register: CLC4GLS1
extern volatile unsigned char           CLC4GLS1            @ 0xF35;
#ifndef _LIB_BUILD
asm("CLC4GLS1 equ 0F35h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC4G2D1N               :1;
        unsigned LC4G2D1T               :1;
        unsigned LC4G2D2N               :1;
        unsigned LC4G2D2T               :1;
        unsigned LC4G2D3N               :1;
        unsigned LC4G2D3T               :1;
        unsigned LC4G2D4N               :1;
        unsigned LC4G2D4T               :1;
    };
    struct {
        unsigned D1N                    :1;
        unsigned D1T                    :1;
        unsigned D2N                    :1;
        unsigned D2T                    :1;
        unsigned D3N                    :1;
        unsigned D3T                    :1;
        unsigned D4N                    :1;
        unsigned D4T                    :1;
    };
} CLC4GLS1bits_t;
extern volatile CLC4GLS1bits_t CLC4GLS1bits @ 0xF35;
// bitfield macros
#define _CLC4GLS1_LC4G2D1N_POSN                             0x0
#define _CLC4GLS1_LC4G2D1N_POSITION                         0x0
#define _CLC4GLS1_LC4G2D1N_SIZE                             0x1
#define _CLC4GLS1_LC4G2D1N_LENGTH                           0x1
#define _CLC4GLS1_LC4G2D1N_MASK                             0x1
#define _CLC4GLS1_LC4G2D1T_POSN                             0x1
#define _CLC4GLS1_LC4G2D1T_POSITION                         0x1
#define _CLC4GLS1_LC4G2D1T_SIZE                             0x1
#define _CLC4GLS1_LC4G2D1T_LENGTH                           0x1
#define _CLC4GLS1_LC4G2D1T_MASK                             0x2
#define _CLC4GLS1_LC4G2D2N_POSN                             0x2
#define _CLC4GLS1_LC4G2D2N_POSITION                         0x2
#define _CLC4GLS1_LC4G2D2N_SIZE                             0x1
#define _CLC4GLS1_LC4G2D2N_LENGTH                           0x1
#define _CLC4GLS1_LC4G2D2N_MASK                             0x4
#define _CLC4GLS1_LC4G2D2T_POSN                             0x3
#define _CLC4GLS1_LC4G2D2T_POSITION                         0x3
#define _CLC4GLS1_LC4G2D2T_SIZE                             0x1
#define _CLC4GLS1_LC4G2D2T_LENGTH                           0x1
#define _CLC4GLS1_LC4G2D2T_MASK                             0x8
#define _CLC4GLS1_LC4G2D3N_POSN                             0x4
#define _CLC4GLS1_LC4G2D3N_POSITION                         0x4
#define _CLC4GLS1_LC4G2D3N_SIZE                             0x1
#define _CLC4GLS1_LC4G2D3N_LENGTH                           0x1
#define _CLC4GLS1_LC4G2D3N_MASK                             0x10
#define _CLC4GLS1_LC4G2D3T_POSN                             0x5
#define _CLC4GLS1_LC4G2D3T_POSITION                         0x5
#define _CLC4GLS1_LC4G2D3T_SIZE                             0x1
#define _CLC4GLS1_LC4G2D3T_LENGTH                           0x1
#define _CLC4GLS1_LC4G2D3T_MASK                             0x20
#define _CLC4GLS1_LC4G2D4N_POSN                             0x6
#define _CLC4GLS1_LC4G2D4N_POSITION                         0x6
#define _CLC4GLS1_LC4G2D4N_SIZE                             0x1
#define _CLC4GLS1_LC4G2D4N_LENGTH                           0x1
#define _CLC4GLS1_LC4G2D4N_MASK                             0x40
#define _CLC4GLS1_LC4G2D4T_POSN                             0x7
#define _CLC4GLS1_LC4G2D4T_POSITION                         0x7
#define _CLC4GLS1_LC4G2D4T_SIZE                             0x1
#define _CLC4GLS1_LC4G2D4T_LENGTH                           0x1
#define _CLC4GLS1_LC4G2D4T_MASK                             0x80
#define _CLC4GLS1_D1N_POSN                                  0x0
#define _CLC4GLS1_D1N_POSITION                              0x0
#define _CLC4GLS1_D1N_SIZE                                  0x1
#define _CLC4GLS1_D1N_LENGTH                                0x1
#define _CLC4GLS1_D1N_MASK                                  0x1
#define _CLC4GLS1_D1T_POSN                                  0x1
#define _CLC4GLS1_D1T_POSITION                              0x1
#define _CLC4GLS1_D1T_SIZE                                  0x1
#define _CLC4GLS1_D1T_LENGTH                                0x1
#define _CLC4GLS1_D1T_MASK                                  0x2
#define _CLC4GLS1_D2N_POSN                                  0x2
#define _CLC4GLS1_D2N_POSITION                              0x2
#define _CLC4GLS1_D2N_SIZE                                  0x1
#define _CLC4GLS1_D2N_LENGTH                                0x1
#define _CLC4GLS1_D2N_MASK                                  0x4
#define _CLC4GLS1_D2T_POSN                                  0x3
#define _CLC4GLS1_D2T_POSITION                              0x3
#define _CLC4GLS1_D2T_SIZE                                  0x1
#define _CLC4GLS1_D2T_LENGTH                                0x1
#define _CLC4GLS1_D2T_MASK                                  0x8
#define _CLC4GLS1_D3N_POSN                                  0x4
#define _CLC4GLS1_D3N_POSITION                              0x4
#define _CLC4GLS1_D3N_SIZE                                  0x1
#define _CLC4GLS1_D3N_LENGTH                                0x1
#define _CLC4GLS1_D3N_MASK                                  0x10
#define _CLC4GLS1_D3T_POSN                                  0x5
#define _CLC4GLS1_D3T_POSITION                              0x5
#define _CLC4GLS1_D3T_SIZE                                  0x1
#define _CLC4GLS1_D3T_LENGTH                                0x1
#define _CLC4GLS1_D3T_MASK                                  0x20
#define _CLC4GLS1_D4N_POSN                                  0x6
#define _CLC4GLS1_D4N_POSITION                              0x6
#define _CLC4GLS1_D4N_SIZE                                  0x1
#define _CLC4GLS1_D4N_LENGTH                                0x1
#define _CLC4GLS1_D4N_MASK                                  0x40
#define _CLC4GLS1_D4T_POSN                                  0x7
#define _CLC4GLS1_D4T_POSITION                              0x7
#define _CLC4GLS1_D4T_SIZE                                  0x1
#define _CLC4GLS1_D4T_LENGTH                                0x1
#define _CLC4GLS1_D4T_MASK                                  0x80

// Register: CLC4GLS2
extern volatile unsigned char           CLC4GLS2            @ 0xF36;
#ifndef _LIB_BUILD
asm("CLC4GLS2 equ 0F36h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC4G3D1N               :1;
        unsigned LC4G3D1T               :1;
        unsigned LC4G3D2N               :1;
        unsigned LC4G3D2T               :1;
        unsigned LC4G3D3N               :1;
        unsigned LC4G3D3T               :1;
        unsigned LC4G3D4N               :1;
        unsigned LC4G3D4T               :1;
    };
    struct {
        unsigned D1N                    :1;
        unsigned D1T                    :1;
        unsigned D2N                    :1;
        unsigned D2T                    :1;
        unsigned D3N                    :1;
        unsigned D3T                    :1;
        unsigned D4N                    :1;
        unsigned D4T                    :1;
    };
} CLC4GLS2bits_t;
extern volatile CLC4GLS2bits_t CLC4GLS2bits @ 0xF36;
// bitfield macros
#define _CLC4GLS2_LC4G3D1N_POSN                             0x0
#define _CLC4GLS2_LC4G3D1N_POSITION                         0x0
#define _CLC4GLS2_LC4G3D1N_SIZE                             0x1
#define _CLC4GLS2_LC4G3D1N_LENGTH                           0x1
#define _CLC4GLS2_LC4G3D1N_MASK                             0x1
#define _CLC4GLS2_LC4G3D1T_POSN                             0x1
#define _CLC4GLS2_LC4G3D1T_POSITION                         0x1
#define _CLC4GLS2_LC4G3D1T_SIZE                             0x1
#define _CLC4GLS2_LC4G3D1T_LENGTH                           0x1
#define _CLC4GLS2_LC4G3D1T_MASK                             0x2
#define _CLC4GLS2_LC4G3D2N_POSN                             0x2
#define _CLC4GLS2_LC4G3D2N_POSITION                         0x2
#define _CLC4GLS2_LC4G3D2N_SIZE                             0x1
#define _CLC4GLS2_LC4G3D2N_LENGTH                           0x1
#define _CLC4GLS2_LC4G3D2N_MASK                             0x4
#define _CLC4GLS2_LC4G3D2T_POSN                             0x3
#define _CLC4GLS2_LC4G3D2T_POSITION                         0x3
#define _CLC4GLS2_LC4G3D2T_SIZE                             0x1
#define _CLC4GLS2_LC4G3D2T_LENGTH                           0x1
#define _CLC4GLS2_LC4G3D2T_MASK                             0x8
#define _CLC4GLS2_LC4G3D3N_POSN                             0x4
#define _CLC4GLS2_LC4G3D3N_POSITION                         0x4
#define _CLC4GLS2_LC4G3D3N_SIZE                             0x1
#define _CLC4GLS2_LC4G3D3N_LENGTH                           0x1
#define _CLC4GLS2_LC4G3D3N_MASK                             0x10
#define _CLC4GLS2_LC4G3D3T_POSN                             0x5
#define _CLC4GLS2_LC4G3D3T_POSITION                         0x5
#define _CLC4GLS2_LC4G3D3T_SIZE                             0x1
#define _CLC4GLS2_LC4G3D3T_LENGTH                           0x1
#define _CLC4GLS2_LC4G3D3T_MASK                             0x20
#define _CLC4GLS2_LC4G3D4N_POSN                             0x6
#define _CLC4GLS2_LC4G3D4N_POSITION                         0x6
#define _CLC4GLS2_LC4G3D4N_SIZE                             0x1
#define _CLC4GLS2_LC4G3D4N_LENGTH                           0x1
#define _CLC4GLS2_LC4G3D4N_MASK                             0x40
#define _CLC4GLS2_LC4G3D4T_POSN                             0x7
#define _CLC4GLS2_LC4G3D4T_POSITION                         0x7
#define _CLC4GLS2_LC4G3D4T_SIZE                             0x1
#define _CLC4GLS2_LC4G3D4T_LENGTH                           0x1
#define _CLC4GLS2_LC4G3D4T_MASK                             0x80
#define _CLC4GLS2_D1N_POSN                                  0x0
#define _CLC4GLS2_D1N_POSITION                              0x0
#define _CLC4GLS2_D1N_SIZE                                  0x1
#define _CLC4GLS2_D1N_LENGTH                                0x1
#define _CLC4GLS2_D1N_MASK                                  0x1
#define _CLC4GLS2_D1T_POSN                                  0x1
#define _CLC4GLS2_D1T_POSITION                              0x1
#define _CLC4GLS2_D1T_SIZE                                  0x1
#define _CLC4GLS2_D1T_LENGTH                                0x1
#define _CLC4GLS2_D1T_MASK                                  0x2
#define _CLC4GLS2_D2N_POSN                                  0x2
#define _CLC4GLS2_D2N_POSITION                              0x2
#define _CLC4GLS2_D2N_SIZE                                  0x1
#define _CLC4GLS2_D2N_LENGTH                                0x1
#define _CLC4GLS2_D2N_MASK                                  0x4
#define _CLC4GLS2_D2T_POSN                                  0x3
#define _CLC4GLS2_D2T_POSITION                              0x3
#define _CLC4GLS2_D2T_SIZE                                  0x1
#define _CLC4GLS2_D2T_LENGTH                                0x1
#define _CLC4GLS2_D2T_MASK                                  0x8
#define _CLC4GLS2_D3N_POSN                                  0x4
#define _CLC4GLS2_D3N_POSITION                              0x4
#define _CLC4GLS2_D3N_SIZE                                  0x1
#define _CLC4GLS2_D3N_LENGTH                                0x1
#define _CLC4GLS2_D3N_MASK                                  0x10
#define _CLC4GLS2_D3T_POSN                                  0x5
#define _CLC4GLS2_D3T_POSITION                              0x5
#define _CLC4GLS2_D3T_SIZE                                  0x1
#define _CLC4GLS2_D3T_LENGTH                                0x1
#define _CLC4GLS2_D3T_MASK                                  0x20
#define _CLC4GLS2_D4N_POSN                                  0x6
#define _CLC4GLS2_D4N_POSITION                              0x6
#define _CLC4GLS2_D4N_SIZE                                  0x1
#define _CLC4GLS2_D4N_LENGTH                                0x1
#define _CLC4GLS2_D4N_MASK                                  0x40
#define _CLC4GLS2_D4T_POSN                                  0x7
#define _CLC4GLS2_D4T_POSITION                              0x7
#define _CLC4GLS2_D4T_SIZE                                  0x1
#define _CLC4GLS2_D4T_LENGTH                                0x1
#define _CLC4GLS2_D4T_MASK                                  0x80

// Register: CLC4GLS3
extern volatile unsigned char           CLC4GLS3            @ 0xF37;
#ifndef _LIB_BUILD
asm("CLC4GLS3 equ 0F37h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned LC4G4D1N               :1;
        unsigned LC4G4D1T               :1;
        unsigned LC4G4D2N               :1;
        unsigned LC4G4D2T               :1;
        unsigned LC4G4D3N               :1;
        unsigned LC4G4D3T               :1;
        unsigned LC4G4D4N               :1;
        unsigned LC4G4D4T               :1;
    };
    struct {
        unsigned G4D1N                  :1;
        unsigned G4D1T                  :1;
        unsigned G4D2N                  :1;
        unsigned G4D2T                  :1;
        unsigned G4D3N                  :1;
        unsigned G4D3T                  :1;
        unsigned G4D4N                  :1;
        unsigned G4D4T                  :1;
    };
} CLC4GLS3bits_t;
extern volatile CLC4GLS3bits_t CLC4GLS3bits @ 0xF37;
// bitfield macros
#define _CLC4GLS3_LC4G4D1N_POSN                             0x0
#define _CLC4GLS3_LC4G4D1N_POSITION                         0x0
#define _CLC4GLS3_LC4G4D1N_SIZE                             0x1
#define _CLC4GLS3_LC4G4D1N_LENGTH                           0x1
#define _CLC4GLS3_LC4G4D1N_MASK                             0x1
#define _CLC4GLS3_LC4G4D1T_POSN                             0x1
#define _CLC4GLS3_LC4G4D1T_POSITION                         0x1
#define _CLC4GLS3_LC4G4D1T_SIZE                             0x1
#define _CLC4GLS3_LC4G4D1T_LENGTH                           0x1
#define _CLC4GLS3_LC4G4D1T_MASK                             0x2
#define _CLC4GLS3_LC4G4D2N_POSN                             0x2
#define _CLC4GLS3_LC4G4D2N_POSITION                         0x2
#define _CLC4GLS3_LC4G4D2N_SIZE                             0x1
#define _CLC4GLS3_LC4G4D2N_LENGTH                           0x1
#define _CLC4GLS3_LC4G4D2N_MASK                             0x4
#define _CLC4GLS3_LC4G4D2T_POSN                             0x3
#define _CLC4GLS3_LC4G4D2T_POSITION                         0x3
#define _CLC4GLS3_LC4G4D2T_SIZE                             0x1
#define _CLC4GLS3_LC4G4D2T_LENGTH                           0x1
#define _CLC4GLS3_LC4G4D2T_MASK                             0x8
#define _CLC4GLS3_LC4G4D3N_POSN                             0x4
#define _CLC4GLS3_LC4G4D3N_POSITION                         0x4
#define _CLC4GLS3_LC4G4D3N_SIZE                             0x1
#define _CLC4GLS3_LC4G4D3N_LENGTH                           0x1
#define _CLC4GLS3_LC4G4D3N_MASK                             0x10
#define _CLC4GLS3_LC4G4D3T_POSN                             0x5
#define _CLC4GLS3_LC4G4D3T_POSITION                         0x5
#define _CLC4GLS3_LC4G4D3T_SIZE                             0x1
#define _CLC4GLS3_LC4G4D3T_LENGTH                           0x1
#define _CLC4GLS3_LC4G4D3T_MASK                             0x20
#define _CLC4GLS3_LC4G4D4N_POSN                             0x6
#define _CLC4GLS3_LC4G4D4N_POSITION                         0x6
#define _CLC4GLS3_LC4G4D4N_SIZE                             0x1
#define _CLC4GLS3_LC4G4D4N_LENGTH                           0x1
#define _CLC4GLS3_LC4G4D4N_MASK                             0x40
#define _CLC4GLS3_LC4G4D4T_POSN                             0x7
#define _CLC4GLS3_LC4G4D4T_POSITION                         0x7
#define _CLC4GLS3_LC4G4D4T_SIZE                             0x1
#define _CLC4GLS3_LC4G4D4T_LENGTH                           0x1
#define _CLC4GLS3_LC4G4D4T_MASK                             0x80
#define _CLC4GLS3_G4D1N_POSN                                0x0
#define _CLC4GLS3_G4D1N_POSITION                            0x0
#define _CLC4GLS3_G4D1N_SIZE                                0x1
#define _CLC4GLS3_G4D1N_LENGTH                              0x1
#define _CLC4GLS3_G4D1N_MASK                                0x1
#define _CLC4GLS3_G4D1T_POSN                                0x1
#define _CLC4GLS3_G4D1T_POSITION                            0x1
#define _CLC4GLS3_G4D1T_SIZE                                0x1
#define _CLC4GLS3_G4D1T_LENGTH                              0x1
#define _CLC4GLS3_G4D1T_MASK                                0x2
#define _CLC4GLS3_G4D2N_POSN                                0x2
#define _CLC4GLS3_G4D2N_POSITION                            0x2
#define _CLC4GLS3_G4D2N_SIZE                                0x1
#define _CLC4GLS3_G4D2N_LENGTH                              0x1
#define _CLC4GLS3_G4D2N_MASK                                0x4
#define _CLC4GLS3_G4D2T_POSN                                0x3
#define _CLC4GLS3_G4D2T_POSITION                            0x3
#define _CLC4GLS3_G4D2T_SIZE                                0x1
#define _CLC4GLS3_G4D2T_LENGTH                              0x1
#define _CLC4GLS3_G4D2T_MASK                                0x8
#define _CLC4GLS3_G4D3N_POSN                                0x4
#define _CLC4GLS3_G4D3N_POSITION                            0x4
#define _CLC4GLS3_G4D3N_SIZE                                0x1
#define _CLC4GLS3_G4D3N_LENGTH                              0x1
#define _CLC4GLS3_G4D3N_MASK                                0x10
#define _CLC4GLS3_G4D3T_POSN                                0x5
#define _CLC4GLS3_G4D3T_POSITION                            0x5
#define _CLC4GLS3_G4D3T_SIZE                                0x1
#define _CLC4GLS3_G4D3T_LENGTH                              0x1
#define _CLC4GLS3_G4D3T_MASK                                0x20
#define _CLC4GLS3_G4D4N_POSN                                0x6
#define _CLC4GLS3_G4D4N_POSITION                            0x6
#define _CLC4GLS3_G4D4N_SIZE                                0x1
#define _CLC4GLS3_G4D4N_LENGTH                              0x1
#define _CLC4GLS3_G4D4N_MASK                                0x40
#define _CLC4GLS3_G4D4T_POSN                                0x7
#define _CLC4GLS3_G4D4T_POSITION                            0x7
#define _CLC4GLS3_G4D4T_SIZE                                0x1
#define _CLC4GLS3_G4D4T_LENGTH                              0x1
#define _CLC4GLS3_G4D4T_MASK                                0x80

// Register: STATUS_SHAD
extern volatile unsigned char           STATUS_SHAD         @ 0xFE4;
#ifndef _LIB_BUILD
asm("STATUS_SHAD equ 0FE4h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned C_SHAD                 :1;
        unsigned DC_SHAD                :1;
        unsigned Z_SHAD                 :1;
    };
} STATUS_SHADbits_t;
extern volatile STATUS_SHADbits_t STATUS_SHADbits @ 0xFE4;
// bitfield macros
#define _STATUS_SHAD_C_SHAD_POSN                            0x0
#define _STATUS_SHAD_C_SHAD_POSITION                        0x0
#define _STATUS_SHAD_C_SHAD_SIZE                            0x1
#define _STATUS_SHAD_C_SHAD_LENGTH                          0x1
#define _STATUS_SHAD_C_SHAD_MASK                            0x1
#define _STATUS_SHAD_DC_SHAD_POSN                           0x1
#define _STATUS_SHAD_DC_SHAD_POSITION                       0x1
#define _STATUS_SHAD_DC_SHAD_SIZE                           0x1
#define _STATUS_SHAD_DC_SHAD_LENGTH                         0x1
#define _STATUS_SHAD_DC_SHAD_MASK                           0x2
#define _STATUS_SHAD_Z_SHAD_POSN                            0x2
#define _STATUS_SHAD_Z_SHAD_POSITION                        0x2
#define _STATUS_SHAD_Z_SHAD_SIZE                            0x1
#define _STATUS_SHAD_Z_SHAD_LENGTH                          0x1
#define _STATUS_SHAD_Z_SHAD_MASK                            0x4

// Register: WREG_SHAD
extern volatile unsigned char           WREG_SHAD           @ 0xFE5;
#ifndef _LIB_BUILD
asm("WREG_SHAD equ 0FE5h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned WREG_SHAD              :8;
    };
} WREG_SHADbits_t;
extern volatile WREG_SHADbits_t WREG_SHADbits @ 0xFE5;
// bitfield macros
#define _WREG_SHAD_WREG_SHAD_POSN                           0x0
#define _WREG_SHAD_WREG_SHAD_POSITION                       0x0
#define _WREG_SHAD_WREG_SHAD_SIZE                           0x8
#define _WREG_SHAD_WREG_SHAD_LENGTH                         0x8
#define _WREG_SHAD_WREG_SHAD_MASK                           0xFF

// Register: BSR_SHAD
extern volatile unsigned char           BSR_SHAD            @ 0xFE6;
#ifndef _LIB_BUILD
asm("BSR_SHAD equ 0FE6h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned BSR_SHAD               :5;
    };
} BSR_SHADbits_t;
extern volatile BSR_SHADbits_t BSR_SHADbits @ 0xFE6;
// bitfield macros
#define _BSR_SHAD_BSR_SHAD_POSN                             0x0
#define _BSR_SHAD_BSR_SHAD_POSITION                         0x0
#define _BSR_SHAD_BSR_SHAD_SIZE                             0x5
#define _BSR_SHAD_BSR_SHAD_LENGTH                           0x5
#define _BSR_SHAD_BSR_SHAD_MASK                             0x1F

// Register: PCLATH_SHAD
extern volatile unsigned char           PCLATH_SHAD         @ 0xFE7;
#ifndef _LIB_BUILD
asm("PCLATH_SHAD equ 0FE7h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned PCLATH_SHAD            :7;
    };
} PCLATH_SHADbits_t;
extern volatile PCLATH_SHADbits_t PCLATH_SHADbits @ 0xFE7;
// bitfield macros
#define _PCLATH_SHAD_PCLATH_SHAD_POSN                       0x0
#define _PCLATH_SHAD_PCLATH_SHAD_POSITION                   0x0
#define _PCLATH_SHAD_PCLATH_SHAD_SIZE                       0x7
#define _PCLATH_SHAD_PCLATH_SHAD_LENGTH                     0x7
#define _PCLATH_SHAD_PCLATH_SHAD_MASK                       0x7F

// Register: FSR0L_SHAD
extern volatile unsigned char           FSR0L_SHAD          @ 0xFE8;
#ifndef _LIB_BUILD
asm("FSR0L_SHAD equ 0FE8h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned FSR0L_SHAD             :8;
    };
} FSR0L_SHADbits_t;
extern volatile FSR0L_SHADbits_t FSR0L_SHADbits @ 0xFE8;
// bitfield macros
#define _FSR0L_SHAD_FSR0L_SHAD_POSN                         0x0
#define _FSR0L_SHAD_FSR0L_SHAD_POSITION                     0x0
#define _FSR0L_SHAD_FSR0L_SHAD_SIZE                         0x8
#define _FSR0L_SHAD_FSR0L_SHAD_LENGTH                       0x8
#define _FSR0L_SHAD_FSR0L_SHAD_MASK                         0xFF

// Register: FSR0H_SHAD
extern volatile unsigned char           FSR0H_SHAD          @ 0xFE9;
#ifndef _LIB_BUILD
asm("FSR0H_SHAD equ 0FE9h");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned FSR0H_SHAD             :8;
    };
} FSR0H_SHADbits_t;
extern volatile FSR0H_SHADbits_t FSR0H_SHADbits @ 0xFE9;
// bitfield macros
#define _FSR0H_SHAD_FSR0H_SHAD_POSN                         0x0
#define _FSR0H_SHAD_FSR0H_SHAD_POSITION                     0x0
#define _FSR0H_SHAD_FSR0H_SHAD_SIZE                         0x8
#define _FSR0H_SHAD_FSR0H_SHAD_LENGTH                       0x8
#define _FSR0H_SHAD_FSR0H_SHAD_MASK                         0xFF

// Register: FSR1L_SHAD
extern volatile unsigned char           FSR1L_SHAD          @ 0xFEA;
#ifndef _LIB_BUILD
asm("FSR1L_SHAD equ 0FEAh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned FSR1L_SHAD             :8;
    };
} FSR1L_SHADbits_t;
extern volatile FSR1L_SHADbits_t FSR1L_SHADbits @ 0xFEA;
// bitfield macros
#define _FSR1L_SHAD_FSR1L_SHAD_POSN                         0x0
#define _FSR1L_SHAD_FSR1L_SHAD_POSITION                     0x0
#define _FSR1L_SHAD_FSR1L_SHAD_SIZE                         0x8
#define _FSR1L_SHAD_FSR1L_SHAD_LENGTH                       0x8
#define _FSR1L_SHAD_FSR1L_SHAD_MASK                         0xFF

// Register: FSR1H_SHAD
extern volatile unsigned char           FSR1H_SHAD          @ 0xFEB;
#ifndef _LIB_BUILD
asm("FSR1H_SHAD equ 0FEBh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned FSR1H_SHAD             :8;
    };
} FSR1H_SHADbits_t;
extern volatile FSR1H_SHADbits_t FSR1H_SHADbits @ 0xFEB;
// bitfield macros
#define _FSR1H_SHAD_FSR1H_SHAD_POSN                         0x0
#define _FSR1H_SHAD_FSR1H_SHAD_POSITION                     0x0
#define _FSR1H_SHAD_FSR1H_SHAD_SIZE                         0x8
#define _FSR1H_SHAD_FSR1H_SHAD_LENGTH                       0x8
#define _FSR1H_SHAD_FSR1H_SHAD_MASK                         0xFF

// Register: STKPTR
extern volatile unsigned char           STKPTR              @ 0xFED;
#ifndef _LIB_BUILD
asm("STKPTR equ 0FEDh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned STKPTR                 :5;
    };
} STKPTRbits_t;
extern volatile STKPTRbits_t STKPTRbits @ 0xFED;
// bitfield macros
#define _STKPTR_STKPTR_POSN                                 0x0
#define _STKPTR_STKPTR_POSITION                             0x0
#define _STKPTR_STKPTR_SIZE                                 0x5
#define _STKPTR_STKPTR_LENGTH                               0x5
#define _STKPTR_STKPTR_MASK                                 0x1F

// Register: TOSL
extern volatile unsigned char           TOSL                @ 0xFEE;
#ifndef _LIB_BUILD
asm("TOSL equ 0FEEh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TOSL                   :8;
    };
} TOSLbits_t;
extern volatile TOSLbits_t TOSLbits @ 0xFEE;
// bitfield macros
#define _TOSL_TOSL_POSN                                     0x0
#define _TOSL_TOSL_POSITION                                 0x0
#define _TOSL_TOSL_SIZE                                     0x8
#define _TOSL_TOSL_LENGTH                                   0x8
#define _TOSL_TOSL_MASK                                     0xFF

// Register: TOSH
extern volatile unsigned char           TOSH                @ 0xFEF;
#ifndef _LIB_BUILD
asm("TOSH equ 0FEFh");
#endif
// bitfield definitions
typedef union {
    struct {
        unsigned TOSH                   :7;
    };
} TOSHbits_t;
extern volatile TOSHbits_t TOSHbits @ 0xFEF;
// bitfield macros
#define _TOSH_TOSH_POSN                                     0x0
#define _TOSH_TOSH_POSITION                                 0x0
#define _TOSH_TOSH_SIZE                                     0x7
#define _TOSH_TOSH_LENGTH                                   0x7
#define _TOSH_TOSH_MASK                                     0x7F

/*
 * Bit Definitions
 */
#define _DEPRECATED __attribute__((__deprecated__))
#ifndef BANKMASK
#define BANKMASK(addr) ((addr)&07Fh)
#endif
extern volatile __bit                   ABDEN               @ (((unsigned) &BAUD1CON)*8) + 0;
#define                                 ABDEN_bit           BANKMASK(BAUD1CON), 0
extern volatile __bit                   ABDOVF              @ (((unsigned) &BAUD1CON)*8) + 7;
#define                                 ABDOVF_bit          BANKMASK(BAUD1CON), 7
extern volatile __bit                   ACC16               @ (((unsigned) &PID1ACCHL)*8) + 0;
#define                                 ACC16_bit           BANKMASK(PID1ACCHL), 0
extern volatile __bit                   ACC17               @ (((unsigned) &PID1ACCHL)*8) + 1;
#define                                 ACC17_bit           BANKMASK(PID1ACCHL), 1
extern volatile __bit                   ACC18               @ (((unsigned) &PID1ACCHL)*8) + 2;
#define                                 ACC18_bit           BANKMASK(PID1ACCHL), 2
extern volatile __bit                   ACC19               @ (((unsigned) &PID1ACCHL)*8) + 3;
#define                                 ACC19_bit           BANKMASK(PID1ACCHL), 3
extern volatile __bit                   ACC20               @ (((unsigned) &PID1ACCHL)*8) + 4;
#define                                 ACC20_bit           BANKMASK(PID1ACCHL), 4
extern volatile __bit                   ACC21               @ (((unsigned) &PID1ACCHL)*8) + 5;
#define                                 ACC21_bit           BANKMASK(PID1ACCHL), 5
extern volatile __bit                   ACC22               @ (((unsigned) &PID1ACCHL)*8) + 6;
#define                                 ACC22_bit           BANKMASK(PID1ACCHL), 6
extern volatile __bit                   ACC23               @ (((unsigned) &PID1ACCHL)*8) + 7;
#define                                 ACC23_bit           BANKMASK(PID1ACCHL), 7
extern volatile __bit                   ACC24               @ (((unsigned) &PID1ACCHH)*8) + 0;
#define                                 ACC24_bit           BANKMASK(PID1ACCHH), 0
extern volatile __bit                   ACC25               @ (((unsigned) &PID1ACCHH)*8) + 1;
#define                                 ACC25_bit           BANKMASK(PID1ACCHH), 1
extern volatile __bit                   ACC26               @ (((unsigned) &PID1ACCHH)*8) + 2;
#define                                 ACC26_bit           BANKMASK(PID1ACCHH), 2
extern volatile __bit                   ACC27               @ (((unsigned) &PID1ACCHH)*8) + 3;
#define                                 ACC27_bit           BANKMASK(PID1ACCHH), 3
extern volatile __bit                   ACC28               @ (((unsigned) &PID1ACCHH)*8) + 4;
#define                                 ACC28_bit           BANKMASK(PID1ACCHH), 4
extern volatile __bit                   ACC29               @ (((unsigned) &PID1ACCHH)*8) + 5;
#define                                 ACC29_bit           BANKMASK(PID1ACCHH), 5
extern volatile __bit                   ACC30               @ (((unsigned) &PID1ACCHH)*8) + 6;
#define                                 ACC30_bit           BANKMASK(PID1ACCHH), 6
extern volatile __bit                   ACC31               @ (((unsigned) &PID1ACCHH)*8) + 7;
#define                                 ACC31_bit           BANKMASK(PID1ACCHH), 7
extern volatile __bit                   ACC32               @ (((unsigned) &PID1ACCU)*8) + 0;
#define                                 ACC32_bit           BANKMASK(PID1ACCU), 0
extern volatile __bit                   ACC33               @ (((unsigned) &PID1ACCU)*8) + 1;
#define                                 ACC33_bit           BANKMASK(PID1ACCU), 1
extern volatile __bit                   ACC34               @ (((unsigned) &PID1ACCU)*8) + 2;
#define                                 ACC34_bit           BANKMASK(PID1ACCU), 2
extern volatile __bit                   ACCM                @ (((unsigned) &CRCCON0)*8) + 4;
#define                                 ACCM_bit            BANKMASK(CRCCON0), 4
extern volatile __bit                   ACCS                @ (((unsigned) &AT1CON1)*8) + 1;
#define                                 ACCS_bit            BANKMASK(AT1CON1), 1
extern volatile __bit                   ACKDT               @ (((unsigned) &SSP1CON2)*8) + 5;
#define                                 ACKDT_bit           BANKMASK(SSP1CON2), 5
extern volatile __bit                   ACKEN               @ (((unsigned) &SSP1CON2)*8) + 4;
#define                                 ACKEN_bit           BANKMASK(SSP1CON2), 4
extern volatile __bit                   ACKSTAT             @ (((unsigned) &SSP1CON2)*8) + 6;
#define                                 ACKSTAT_bit         BANKMASK(SSP1CON2), 6
extern volatile __bit                   ACKTIM              @ (((unsigned) &SSP1CON3)*8) + 7;
#define                                 ACKTIM_bit          BANKMASK(SSP1CON3), 7
extern volatile __bit                   ADCS0               @ (((unsigned) &ADCON1)*8) + 4;
#define                                 ADCS0_bit           BANKMASK(ADCON1), 4
extern volatile __bit                   ADCS1               @ (((unsigned) &ADCON1)*8) + 5;
#define                                 ADCS1_bit           BANKMASK(ADCON1), 5
extern volatile __bit                   ADCS2               @ (((unsigned) &ADCON1)*8) + 6;
#define                                 ADCS2_bit           BANKMASK(ADCON1), 6
extern volatile __bit                   ADD0                @ (((unsigned) &SSP1ADD)*8) + 0;
#define                                 ADD0_bit            BANKMASK(SSP1ADD), 0
extern volatile __bit                   ADD1                @ (((unsigned) &SSP1ADD)*8) + 1;
#define                                 ADD1_bit            BANKMASK(SSP1ADD), 1
extern volatile __bit                   ADD2                @ (((unsigned) &SSP1ADD)*8) + 2;
#define                                 ADD2_bit            BANKMASK(SSP1ADD), 2
extern volatile __bit                   ADD3                @ (((unsigned) &SSP1ADD)*8) + 3;
#define                                 ADD3_bit            BANKMASK(SSP1ADD), 3
extern volatile __bit                   ADD4                @ (((unsigned) &SSP1ADD)*8) + 4;
#define                                 ADD4_bit            BANKMASK(SSP1ADD), 4
extern volatile __bit                   ADD5                @ (((unsigned) &SSP1ADD)*8) + 5;
#define                                 ADD5_bit            BANKMASK(SSP1ADD), 5
extern volatile __bit                   ADD6                @ (((unsigned) &SSP1ADD)*8) + 6;
#define                                 ADD6_bit            BANKMASK(SSP1ADD), 6
extern volatile __bit                   ADD7                @ (((unsigned) &SSP1ADD)*8) + 7;
#define                                 ADD7_bit            BANKMASK(SSP1ADD), 7
extern volatile __bit                   ADDEN               @ (((unsigned) &RC1STA)*8) + 3;
#define                                 ADDEN_bit           BANKMASK(RC1STA), 3
extern volatile __bit                   ADFM                @ (((unsigned) &ADCON1)*8) + 7;
#define                                 ADFM_bit            BANKMASK(ADCON1), 7
extern volatile __bit                   ADFVR0              @ (((unsigned) &FVRCON)*8) + 0;
#define                                 ADFVR0_bit          BANKMASK(FVRCON), 0
extern volatile __bit                   ADFVR1              @ (((unsigned) &FVRCON)*8) + 1;
#define                                 ADFVR1_bit          BANKMASK(FVRCON), 1
extern volatile __bit                   ADGO                @ (((unsigned) &ADCON0)*8) + 1;
#define                                 ADGO_bit            BANKMASK(ADCON0), 1
extern volatile __bit                   ADIE                @ (((unsigned) &PIE1)*8) + 6;
#define                                 ADIE_bit            BANKMASK(PIE1), 6
extern volatile __bit                   ADIF                @ (((unsigned) &PIR1)*8) + 6;
#define                                 ADIF_bit            BANKMASK(PIR1), 6
extern volatile __bit                   ADON                @ (((unsigned) &ADCON0)*8) + 0;
#define                                 ADON_bit            BANKMASK(ADCON0), 0
extern volatile __bit                   ADPREF0             @ (((unsigned) &ADCON1)*8) + 0;
#define                                 ADPREF0_bit         BANKMASK(ADCON1), 0
extern volatile __bit                   ADPREF1             @ (((unsigned) &ADCON1)*8) + 1;
#define                                 ADPREF1_bit         BANKMASK(ADCON1), 1
extern volatile __bit                   AHEN                @ (((unsigned) &SSP1CON3)*8) + 1;
#define                                 AHEN_bit            BANKMASK(SSP1CON3), 1
extern volatile __bit                   ANSA0               @ (((unsigned) &ANSELA)*8) + 0;
#define                                 ANSA0_bit           BANKMASK(ANSELA), 0
extern volatile __bit                   ANSA1               @ (((unsigned) &ANSELA)*8) + 1;
#define                                 ANSA1_bit           BANKMASK(ANSELA), 1
extern volatile __bit                   ANSA2               @ (((unsigned) &ANSELA)*8) + 2;
#define                                 ANSA2_bit           BANKMASK(ANSELA), 2
extern volatile __bit                   ANSA4               @ (((unsigned) &ANSELA)*8) + 4;
#define                                 ANSA4_bit           BANKMASK(ANSELA), 4
extern volatile __bit                   ANSB4               @ (((unsigned) &ANSELB)*8) + 4;
#define                                 ANSB4_bit           BANKMASK(ANSELB), 4
extern volatile __bit                   ANSB5               @ (((unsigned) &ANSELB)*8) + 5;
#define                                 ANSB5_bit           BANKMASK(ANSELB), 5
extern volatile __bit                   ANSB6               @ (((unsigned) &ANSELB)*8) + 6;
#define                                 ANSB6_bit           BANKMASK(ANSELB), 6
extern volatile __bit                   ANSB7               @ (((unsigned) &ANSELB)*8) + 7;
#define                                 ANSB7_bit           BANKMASK(ANSELB), 7
extern volatile __bit                   ANSC0               @ (((unsigned) &ANSELC)*8) + 0;
#define                                 ANSC0_bit           BANKMASK(ANSELC), 0
extern volatile __bit                   ANSC1               @ (((unsigned) &ANSELC)*8) + 1;
#define                                 ANSC1_bit           BANKMASK(ANSELC), 1
extern volatile __bit                   ANSC2               @ (((unsigned) &ANSELC)*8) + 2;
#define                                 ANSC2_bit           BANKMASK(ANSELC), 2
extern volatile __bit                   ANSC3               @ (((unsigned) &ANSELC)*8) + 3;
#define                                 ANSC3_bit           BANKMASK(ANSELC), 3
extern volatile __bit                   ANSC6               @ (((unsigned) &ANSELC)*8) + 6;
#define                                 ANSC6_bit           BANKMASK(ANSELC), 6
extern volatile __bit                   ANSC7               @ (((unsigned) &ANSELC)*8) + 7;
#define                                 ANSC7_bit           BANKMASK(ANSELC), 7
extern volatile __bit                   APMOD               @ (((unsigned) &AT1CON0)*8) + 1;
#define                                 APMOD_bit           BANKMASK(AT1CON0), 1
extern volatile __bit                   AT1ACCS             @ (((unsigned) &AT1CON1)*8) + 1;
#define                                 AT1ACCS_bit         BANKMASK(AT1CON1), 1
extern volatile __bit                   AT1APMOD            @ (((unsigned) &AT1CON0)*8) + 1;
#define                                 AT1APMOD_bit        BANKMASK(AT1CON0), 1
extern volatile __bit                   AT1CAP1P            @ (((unsigned) &AT1CCON1)*8) + 3;
#define                                 AT1CAP1P_bit        BANKMASK(AT1CCON1), 3
extern volatile __bit                   AT1CAP2P            @ (((unsigned) &AT1CCON2)*8) + 3;
#define                                 AT1CAP2P_bit        BANKMASK(AT1CCON2), 3
extern volatile __bit                   AT1CAP3P            @ (((unsigned) &AT1CCON3)*8) + 3;
#define                                 AT1CAP3P_bit        BANKMASK(AT1CCON3), 3
extern volatile __bit                   AT1CC10             @ (((unsigned) &AT1CC1L)*8) + 0;
#define                                 AT1CC10_bit         BANKMASK(AT1CC1L), 0
extern volatile __bit                   AT1CC11             @ (((unsigned) &AT1CC1L)*8) + 1;
#define                                 AT1CC11_bit         BANKMASK(AT1CC1L), 1
extern volatile __bit                   AT1CC12             @ (((unsigned) &AT1CC1L)*8) + 2;
#define                                 AT1CC12_bit         BANKMASK(AT1CC1L), 2
extern volatile __bit                   AT1CC13             @ (((unsigned) &AT1CC1L)*8) + 3;
#define                                 AT1CC13_bit         BANKMASK(AT1CC1L), 3
extern volatile __bit                   AT1CC14             @ (((unsigned) &AT1CC1L)*8) + 4;
#define                                 AT1CC14_bit         BANKMASK(AT1CC1L), 4
extern volatile __bit                   AT1CC15             @ (((unsigned) &AT1CC1L)*8) + 5;
#define                                 AT1CC15_bit         BANKMASK(AT1CC1L), 5
extern volatile __bit                   AT1CC16             @ (((unsigned) &AT1CC1L)*8) + 6;
#define                                 AT1CC16_bit         BANKMASK(AT1CC1L), 6
extern volatile __bit                   AT1CC17             @ (((unsigned) &AT1CC1L)*8) + 7;
#define                                 AT1CC17_bit         BANKMASK(AT1CC1L), 7
extern volatile __bit                   AT1CC18             @ (((unsigned) &AT1CC1H)*8) + 0;
#define                                 AT1CC18_bit         BANKMASK(AT1CC1H), 0
extern volatile __bit                   AT1CC19             @ (((unsigned) &AT1CC1H)*8) + 1;
#define                                 AT1CC19_bit         BANKMASK(AT1CC1H), 1
extern volatile __bit                   AT1CC1EN            @ (((unsigned) &AT1CCON1)*8) + 7;
#define                                 AT1CC1EN_bit        BANKMASK(AT1CCON1), 7
extern volatile __bit                   AT1CC1IE            @ (((unsigned) &AT1IE1)*8) + 0;
#define                                 AT1CC1IE_bit        BANKMASK(AT1IE1), 0
extern volatile __bit                   AT1CC1IF            @ (((unsigned) &AT1IR1)*8) + 0;
#define                                 AT1CC1IF_bit        BANKMASK(AT1IR1), 0
extern volatile __bit                   AT1CC1MODE          @ (((unsigned) &AT1CCON1)*8) + 0;
#define                                 AT1CC1MODE_bit      BANKMASK(AT1CCON1), 0
extern volatile __bit                   AT1CC1POL           @ (((unsigned) &AT1CCON1)*8) + 4;
#define                                 AT1CC1POL_bit       BANKMASK(AT1CCON1), 4
extern volatile __bit                   AT1CC20             @ (((unsigned) &AT1CC2L)*8) + 0;
#define                                 AT1CC20_bit         BANKMASK(AT1CC2L), 0
extern volatile __bit                   AT1CC21             @ (((unsigned) &AT1CC2L)*8) + 1;
#define                                 AT1CC21_bit         BANKMASK(AT1CC2L), 1
extern volatile __bit                   AT1CC22             @ (((unsigned) &AT1CC2L)*8) + 2;
#define                                 AT1CC22_bit         BANKMASK(AT1CC2L), 2
extern volatile __bit                   AT1CC23             @ (((unsigned) &AT1CC2L)*8) + 3;
#define                                 AT1CC23_bit         BANKMASK(AT1CC2L), 3
extern volatile __bit                   AT1CC24             @ (((unsigned) &AT1CC2L)*8) + 4;
#define                                 AT1CC24_bit         BANKMASK(AT1CC2L), 4
extern volatile __bit                   AT1CC25             @ (((unsigned) &AT1CC2L)*8) + 5;
#define                                 AT1CC25_bit         BANKMASK(AT1CC2L), 5
extern volatile __bit                   AT1CC26             @ (((unsigned) &AT1CC2L)*8) + 6;
#define                                 AT1CC26_bit         BANKMASK(AT1CC2L), 6
extern volatile __bit                   AT1CC27             @ (((unsigned) &AT1CC2L)*8) + 7;
#define                                 AT1CC27_bit         BANKMASK(AT1CC2L), 7
extern volatile __bit                   AT1CC28             @ (((unsigned) &AT1CC2H)*8) + 0;
#define                                 AT1CC28_bit         BANKMASK(AT1CC2H), 0
extern volatile __bit                   AT1CC29             @ (((unsigned) &AT1CC2H)*8) + 1;
#define                                 AT1CC29_bit         BANKMASK(AT1CC2H), 1
extern volatile __bit                   AT1CC2EN            @ (((unsigned) &AT1CCON2)*8) + 7;
#define                                 AT1CC2EN_bit        BANKMASK(AT1CCON2), 7
extern volatile __bit                   AT1CC2IE            @ (((unsigned) &AT1IE1)*8) + 1;
#define                                 AT1CC2IE_bit        BANKMASK(AT1IE1), 1
extern volatile __bit                   AT1CC2IF            @ (((unsigned) &AT1IR1)*8) + 1;
#define                                 AT1CC2IF_bit        BANKMASK(AT1IR1), 1
extern volatile __bit                   AT1CC2MODE          @ (((unsigned) &AT1CCON2)*8) + 0;
#define                                 AT1CC2MODE_bit      BANKMASK(AT1CCON2), 0
extern volatile __bit                   AT1CC2POL           @ (((unsigned) &AT1CCON2)*8) + 4;
#define                                 AT1CC2POL_bit       BANKMASK(AT1CCON2), 4
extern volatile __bit                   AT1CC30             @ (((unsigned) &AT1CC3L)*8) + 0;
#define                                 AT1CC30_bit         BANKMASK(AT1CC3L), 0
extern volatile __bit                   AT1CC31             @ (((unsigned) &AT1CC3L)*8) + 1;
#define                                 AT1CC31_bit         BANKMASK(AT1CC3L), 1
extern volatile __bit                   AT1CC32             @ (((unsigned) &AT1CC3L)*8) + 2;
#define                                 AT1CC32_bit         BANKMASK(AT1CC3L), 2
extern volatile __bit                   AT1CC33             @ (((unsigned) &AT1CC3L)*8) + 3;
#define                                 AT1CC33_bit         BANKMASK(AT1CC3L), 3
extern volatile __bit                   AT1CC34             @ (((unsigned) &AT1CC3L)*8) + 4;
#define                                 AT1CC34_bit         BANKMASK(AT1CC3L), 4
extern volatile __bit                   AT1CC35             @ (((unsigned) &AT1CC3L)*8) + 5;
#define                                 AT1CC35_bit         BANKMASK(AT1CC3L), 5
extern volatile __bit                   AT1CC36             @ (((unsigned) &AT1CC3L)*8) + 6;
#define                                 AT1CC36_bit         BANKMASK(AT1CC3L), 6
extern volatile __bit                   AT1CC37             @ (((unsigned) &AT1CC3L)*8) + 7;
#define                                 AT1CC37_bit         BANKMASK(AT1CC3L), 7
extern volatile __bit                   AT1CC38             @ (((unsigned) &AT1CC3H)*8) + 0;
#define                                 AT1CC38_bit         BANKMASK(AT1CC3H), 0
extern volatile __bit                   AT1CC39             @ (((unsigned) &AT1CC3H)*8) + 1;
#define                                 AT1CC39_bit         BANKMASK(AT1CC3H), 1
extern volatile __bit                   AT1CC3EN            @ (((unsigned) &AT1CCON3)*8) + 7;
#define                                 AT1CC3EN_bit        BANKMASK(AT1CCON3), 7
extern volatile __bit                   AT1CC3IE            @ (((unsigned) &AT1IE1)*8) + 2;
#define                                 AT1CC3IE_bit        BANKMASK(AT1IE1), 2
extern volatile __bit                   AT1CC3IF            @ (((unsigned) &AT1IR1)*8) + 2;
#define                                 AT1CC3IF_bit        BANKMASK(AT1IR1), 2
extern volatile __bit                   AT1CC3MODE          @ (((unsigned) &AT1CCON3)*8) + 0;
#define                                 AT1CC3MODE_bit      BANKMASK(AT1CCON3), 0
extern volatile __bit                   AT1CC3POL           @ (((unsigned) &AT1CCON3)*8) + 4;
#define                                 AT1CC3POL_bit       BANKMASK(AT1CCON3), 4
extern volatile __bit                   AT1CP1S0            @ (((unsigned) &AT1CSEL1)*8) + 0;
#define                                 AT1CP1S0_bit        BANKMASK(AT1CSEL1), 0
extern volatile __bit                   AT1CP1S1            @ (((unsigned) &AT1CSEL1)*8) + 1;
#define                                 AT1CP1S1_bit        BANKMASK(AT1CSEL1), 1
extern volatile __bit                   AT1CP1S2            @ (((unsigned) &AT1CSEL1)*8) + 2;
#define                                 AT1CP1S2_bit        BANKMASK(AT1CSEL1), 2
extern volatile __bit                   AT1CP2S0            @ (((unsigned) &AT1CSEL2)*8) + 0;
#define                                 AT1CP2S0_bit        BANKMASK(AT1CSEL2), 0
extern volatile __bit                   AT1CP2S1            @ (((unsigned) &AT1CSEL2)*8) + 1;
#define                                 AT1CP2S1_bit        BANKMASK(AT1CSEL2), 1
extern volatile __bit                   AT1CP2S2            @ (((unsigned) &AT1CSEL2)*8) + 2;
#define                                 AT1CP2S2_bit        BANKMASK(AT1CSEL2), 2
extern volatile __bit                   AT1CP3S0            @ (((unsigned) &AT1CSEL3)*8) + 0;
#define                                 AT1CP3S0_bit        BANKMASK(AT1CSEL3), 0
extern volatile __bit                   AT1CP3S1            @ (((unsigned) &AT1CSEL3)*8) + 1;
#define                                 AT1CP3S1_bit        BANKMASK(AT1CSEL3), 1
extern volatile __bit                   AT1CP3S2            @ (((unsigned) &AT1CSEL3)*8) + 2;
#define                                 AT1CP3S2_bit        BANKMASK(AT1CSEL3), 2
extern volatile __bit                   AT1CS               @ (((unsigned) &AT1CLK)*8) + 0;
#define                                 AT1CS_bit           BANKMASK(AT1CLK), 0
extern volatile __bit                   AT1CS0              @ (((unsigned) &AT1CLK)*8) + 0;
#define                                 AT1CS0_bit          BANKMASK(AT1CLK), 0
extern volatile __bit                   AT1EN               @ (((unsigned) &AT1CON0)*8) + 7;
#define                                 AT1EN_bit           BANKMASK(AT1CON0), 7
extern volatile __bit                   AT1ERR0             @ (((unsigned) &AT1ERRL)*8) + 0;
#define                                 AT1ERR0_bit         BANKMASK(AT1ERRL), 0
extern volatile __bit                   AT1ERR1             @ (((unsigned) &AT1ERRL)*8) + 1;
#define                                 AT1ERR1_bit         BANKMASK(AT1ERRL), 1
extern volatile __bit                   AT1ERR10            @ (((unsigned) &AT1ERRH)*8) + 2;
#define                                 AT1ERR10_bit        BANKMASK(AT1ERRH), 2
extern volatile __bit                   AT1ERR11            @ (((unsigned) &AT1ERRH)*8) + 3;
#define                                 AT1ERR11_bit        BANKMASK(AT1ERRH), 3
extern volatile __bit                   AT1ERR12            @ (((unsigned) &AT1ERRH)*8) + 4;
#define                                 AT1ERR12_bit        BANKMASK(AT1ERRH), 4
extern volatile __bit                   AT1ERR13            @ (((unsigned) &AT1ERRH)*8) + 5;
#define                                 AT1ERR13_bit        BANKMASK(AT1ERRH), 5
extern volatile __bit                   AT1ERR14            @ (((unsigned) &AT1ERRH)*8) + 6;
#define                                 AT1ERR14_bit        BANKMASK(AT1ERRH), 6
extern volatile __bit                   AT1ERR15            @ (((unsigned) &AT1ERRH)*8) + 7;
#define                                 AT1ERR15_bit        BANKMASK(AT1ERRH), 7
extern volatile __bit                   AT1ERR2             @ (((unsigned) &AT1ERRL)*8) + 2;
#define                                 AT1ERR2_bit         BANKMASK(AT1ERRL), 2
extern volatile __bit                   AT1ERR3             @ (((unsigned) &AT1ERRL)*8) + 3;
#define                                 AT1ERR3_bit         BANKMASK(AT1ERRL), 3
extern volatile __bit                   AT1ERR4             @ (((unsigned) &AT1ERRL)*8) + 4;
#define                                 AT1ERR4_bit         BANKMASK(AT1ERRL), 4
extern volatile __bit                   AT1ERR5             @ (((unsigned) &AT1ERRL)*8) + 5;
#define                                 AT1ERR5_bit         BANKMASK(AT1ERRL), 5
extern volatile __bit                   AT1ERR6             @ (((unsigned) &AT1ERRL)*8) + 6;
#define                                 AT1ERR6_bit         BANKMASK(AT1ERRL), 6
extern volatile __bit                   AT1ERR7             @ (((unsigned) &AT1ERRL)*8) + 7;
#define                                 AT1ERR7_bit         BANKMASK(AT1ERRL), 7
extern volatile __bit                   AT1ERR8             @ (((unsigned) &AT1ERRH)*8) + 0;
#define                                 AT1ERR8_bit         BANKMASK(AT1ERRH), 0
extern volatile __bit                   AT1ERR9             @ (((unsigned) &AT1ERRH)*8) + 1;
#define                                 AT1ERR9_bit         BANKMASK(AT1ERRH), 1
extern volatile __bit                   AT1IE               @ (((unsigned) &PIE5)*8) + 2;
#define                                 AT1IE_bit           BANKMASK(PIE5), 2
extern volatile __bit                   AT1IF               @ (((unsigned) &PIR5)*8) + 2;
#define                                 AT1IF_bit           BANKMASK(PIR5), 2
extern volatile __bit                   AT1MISS0            @ (((unsigned) &AT1MISSL)*8) + 0;
#define                                 AT1MISS0_bit        BANKMASK(AT1MISSL), 0
extern volatile __bit                   AT1MISS1            @ (((unsigned) &AT1MISSL)*8) + 1;
#define                                 AT1MISS1_bit        BANKMASK(AT1MISSL), 1
extern volatile __bit                   AT1MISS10           @ (((unsigned) &AT1MISSH)*8) + 2;
#define                                 AT1MISS10_bit       BANKMASK(AT1MISSH), 2
extern volatile __bit                   AT1MISS11           @ (((unsigned) &AT1MISSH)*8) + 3;
#define                                 AT1MISS11_bit       BANKMASK(AT1MISSH), 3
extern volatile __bit                   AT1MISS12           @ (((unsigned) &AT1MISSH)*8) + 4;
#define                                 AT1MISS12_bit       BANKMASK(AT1MISSH), 4
extern volatile __bit                   AT1MISS13           @ (((unsigned) &AT1MISSH)*8) + 5;
#define                                 AT1MISS13_bit       BANKMASK(AT1MISSH), 5
extern volatile __bit                   AT1MISS14           @ (((unsigned) &AT1MISSH)*8) + 6;
#define                                 AT1MISS14_bit       BANKMASK(AT1MISSH), 6
extern volatile __bit                   AT1MISS15           @ (((unsigned) &AT1MISSH)*8) + 7;
#define                                 AT1MISS15_bit       BANKMASK(AT1MISSH), 7
extern volatile __bit                   AT1MISS2            @ (((unsigned) &AT1MISSL)*8) + 2;
#define                                 AT1MISS2_bit        BANKMASK(AT1MISSL), 2
extern volatile __bit                   AT1MISS3            @ (((unsigned) &AT1MISSL)*8) + 3;
#define                                 AT1MISS3_bit        BANKMASK(AT1MISSL), 3
extern volatile __bit                   AT1MISS4            @ (((unsigned) &AT1MISSL)*8) + 4;
#define                                 AT1MISS4_bit        BANKMASK(AT1MISSL), 4
extern volatile __bit                   AT1MISS5            @ (((unsigned) &AT1MISSL)*8) + 5;
#define                                 AT1MISS5_bit        BANKMASK(AT1MISSL), 5
extern volatile __bit                   AT1MISS6            @ (((unsigned) &AT1MISSL)*8) + 6;
#define                                 AT1MISS6_bit        BANKMASK(AT1MISSL), 6
extern volatile __bit                   AT1MISS7            @ (((unsigned) &AT1MISSL)*8) + 7;
#define                                 AT1MISS7_bit        BANKMASK(AT1MISSL), 7
extern volatile __bit                   AT1MISS8            @ (((unsigned) &AT1MISSH)*8) + 0;
#define                                 AT1MISS8_bit        BANKMASK(AT1MISSH), 0
extern volatile __bit                   AT1MISS9            @ (((unsigned) &AT1MISSH)*8) + 1;
#define                                 AT1MISS9_bit        BANKMASK(AT1MISSH), 1
extern volatile __bit                   AT1MISSIE           @ (((unsigned) &AT1IE0)*8) + 1;
#define                                 AT1MISSIE_bit       BANKMASK(AT1IE0), 1
extern volatile __bit                   AT1MISSIF           @ (((unsigned) &AT1IR0)*8) + 1;
#define                                 AT1MISSIF_bit       BANKMASK(AT1IR0), 1
extern volatile __bit                   AT1MODE             @ (((unsigned) &AT1CON0)*8) + 0;
#define                                 AT1MODE_bit         BANKMASK(AT1CON0), 0
extern volatile __bit                   AT1MPP              @ (((unsigned) &AT1CON1)*8) + 2;
#define                                 AT1MPP_bit          BANKMASK(AT1CON1), 2
extern volatile __bit                   AT1PER0             @ (((unsigned) &AT1PERL)*8) + 0;
#define                                 AT1PER0_bit         BANKMASK(AT1PERL), 0
extern volatile __bit                   AT1PER1             @ (((unsigned) &AT1PERL)*8) + 1;
#define                                 AT1PER1_bit         BANKMASK(AT1PERL), 1
extern volatile __bit                   AT1PER10            @ (((unsigned) &AT1PERH)*8) + 2;
#define                                 AT1PER10_bit        BANKMASK(AT1PERH), 2
extern volatile __bit                   AT1PER11            @ (((unsigned) &AT1PERH)*8) + 3;
#define                                 AT1PER11_bit        BANKMASK(AT1PERH), 3
extern volatile __bit                   AT1PER12            @ (((unsigned) &AT1PERH)*8) + 4;
#define                                 AT1PER12_bit        BANKMASK(AT1PERH), 4
extern volatile __bit                   AT1PER13            @ (((unsigned) &AT1PERH)*8) + 5;
#define                                 AT1PER13_bit        BANKMASK(AT1PERH), 5
extern volatile __bit                   AT1PER14            @ (((unsigned) &AT1PERH)*8) + 6;
#define                                 AT1PER14_bit        BANKMASK(AT1PERH), 6
extern volatile __bit                   AT1PER2             @ (((unsigned) &AT1PERL)*8) + 2;
#define                                 AT1PER2_bit         BANKMASK(AT1PERL), 2
extern volatile __bit                   AT1PER3             @ (((unsigned) &AT1PERL)*8) + 3;
#define                                 AT1PER3_bit         BANKMASK(AT1PERL), 3
extern volatile __bit                   AT1PER4             @ (((unsigned) &AT1PERL)*8) + 4;
#define                                 AT1PER4_bit         BANKMASK(AT1PERL), 4
extern volatile __bit                   AT1PER5             @ (((unsigned) &AT1PERL)*8) + 5;
#define                                 AT1PER5_bit         BANKMASK(AT1PERL), 5
extern volatile __bit                   AT1PER6             @ (((unsigned) &AT1PERL)*8) + 6;
#define                                 AT1PER6_bit         BANKMASK(AT1PERL), 6
extern volatile __bit                   AT1PER7             @ (((unsigned) &AT1PERL)*8) + 7;
#define                                 AT1PER7_bit         BANKMASK(AT1PERL), 7
extern volatile __bit                   AT1PER8             @ (((unsigned) &AT1PERH)*8) + 0;
#define                                 AT1PER8_bit         BANKMASK(AT1PERH), 0
extern volatile __bit                   AT1PER9             @ (((unsigned) &AT1PERH)*8) + 1;
#define                                 AT1PER9_bit         BANKMASK(AT1PERH), 1
extern volatile __bit                   AT1PERIE            @ (((unsigned) &AT1IE0)*8) + 0;
#define                                 AT1PERIE_bit        BANKMASK(AT1IE0), 0
extern volatile __bit                   AT1PERIF            @ (((unsigned) &AT1IR0)*8) + 0;
#define                                 AT1PERIF_bit        BANKMASK(AT1IR0), 0
extern volatile __bit                   AT1PHP              @ (((unsigned) &AT1CON1)*8) + 6;
#define                                 AT1PHP_bit          BANKMASK(AT1CON1), 6
extern volatile __bit                   AT1PHS0             @ (((unsigned) &AT1PHSL)*8) + 0;
#define                                 AT1PHS0_bit         BANKMASK(AT1PHSL), 0
extern volatile __bit                   AT1PHS1             @ (((unsigned) &AT1PHSL)*8) + 1;
#define                                 AT1PHS1_bit         BANKMASK(AT1PHSL), 1
extern volatile __bit                   AT1PHS2             @ (((unsigned) &AT1PHSL)*8) + 2;
#define                                 AT1PHS2_bit         BANKMASK(AT1PHSL), 2
extern volatile __bit                   AT1PHS3             @ (((unsigned) &AT1PHSL)*8) + 3;
#define                                 AT1PHS3_bit         BANKMASK(AT1PHSL), 3
extern volatile __bit                   AT1PHS4             @ (((unsigned) &AT1PHSL)*8) + 4;
#define                                 AT1PHS4_bit         BANKMASK(AT1PHSL), 4
extern volatile __bit                   AT1PHS5             @ (((unsigned) &AT1PHSL)*8) + 5;
#define                                 AT1PHS5_bit         BANKMASK(AT1PHSL), 5
extern volatile __bit                   AT1PHS6             @ (((unsigned) &AT1PHSL)*8) + 6;
#define                                 AT1PHS6_bit         BANKMASK(AT1PHSL), 6
extern volatile __bit                   AT1PHS7             @ (((unsigned) &AT1PHSL)*8) + 7;
#define                                 AT1PHS7_bit         BANKMASK(AT1PHSL), 7
extern volatile __bit                   AT1PHS8             @ (((unsigned) &AT1PHSH)*8) + 0;
#define                                 AT1PHS8_bit         BANKMASK(AT1PHSH), 0
extern volatile __bit                   AT1PHS9             @ (((unsigned) &AT1PHSH)*8) + 1;
#define                                 AT1PHS9_bit         BANKMASK(AT1PHSH), 1
extern volatile __bit                   AT1PHSIE            @ (((unsigned) &AT1IE0)*8) + 2;
#define                                 AT1PHSIE_bit        BANKMASK(AT1IE0), 2
extern volatile __bit                   AT1PHSIF            @ (((unsigned) &AT1IR0)*8) + 2;
#define                                 AT1PHSIF_bit        BANKMASK(AT1IR0), 2
extern volatile __bit                   AT1POL              @ (((unsigned) &AT1CON0)*8) + 3;
#define                                 AT1POL_bit          BANKMASK(AT1CON0), 3
extern volatile __bit                   AT1POV              @ (((unsigned) &AT1PERH)*8) + 7;
#define                                 AT1POV_bit          BANKMASK(AT1PERH), 7
extern volatile __bit                   AT1PREC             @ (((unsigned) &AT1CON0)*8) + 6;
#define                                 AT1PREC_bit         BANKMASK(AT1CON0), 6
extern volatile __bit                   AT1PRP              @ (((unsigned) &AT1CON1)*8) + 4;
#define                                 AT1PRP_bit          BANKMASK(AT1CON1), 4
extern volatile __bit                   AT1PS0              @ (((unsigned) &AT1CON0)*8) + 4;
#define                                 AT1PS0_bit          BANKMASK(AT1CON0), 4
extern volatile __bit                   AT1PS1              @ (((unsigned) &AT1CON0)*8) + 5;
#define                                 AT1PS1_bit          BANKMASK(AT1CON0), 5
extern volatile __bit                   AT1RES0             @ (((unsigned) &AT1RESL)*8) + 0;
#define                                 AT1RES0_bit         BANKMASK(AT1RESL), 0
extern volatile __bit                   AT1RES1             @ (((unsigned) &AT1RESL)*8) + 1;
#define                                 AT1RES1_bit         BANKMASK(AT1RESL), 1
extern volatile __bit                   AT1RES2             @ (((unsigned) &AT1RESL)*8) + 2;
#define                                 AT1RES2_bit         BANKMASK(AT1RESL), 2
extern volatile __bit                   AT1RES3             @ (((unsigned) &AT1RESL)*8) + 3;
#define                                 AT1RES3_bit         BANKMASK(AT1RESL), 3
extern volatile __bit                   AT1RES4             @ (((unsigned) &AT1RESL)*8) + 4;
#define                                 AT1RES4_bit         BANKMASK(AT1RESL), 4
extern volatile __bit                   AT1RES5             @ (((unsigned) &AT1RESL)*8) + 5;
#define                                 AT1RES5_bit         BANKMASK(AT1RESL), 5
extern volatile __bit                   AT1RES6             @ (((unsigned) &AT1RESL)*8) + 6;
#define                                 AT1RES6_bit         BANKMASK(AT1RESL), 6
extern volatile __bit                   AT1RES7             @ (((unsigned) &AT1RESL)*8) + 7;
#define                                 AT1RES7_bit         BANKMASK(AT1RESL), 7
extern volatile __bit                   AT1RES8             @ (((unsigned) &AT1RESH)*8) + 0;
#define                                 AT1RES8_bit         BANKMASK(AT1RESH), 0
extern volatile __bit                   AT1RES9             @ (((unsigned) &AT1RESH)*8) + 1;
#define                                 AT1RES9_bit         BANKMASK(AT1RESH), 1
extern volatile __bit                   AT1SSEL0            @ (((unsigned) &AT1SIG)*8) + 0;
#define                                 AT1SSEL0_bit        BANKMASK(AT1SIG), 0
extern volatile __bit                   AT1SSEL1            @ (((unsigned) &AT1SIG)*8) + 1;
#define                                 AT1SSEL1_bit        BANKMASK(AT1SIG), 1
extern volatile __bit                   AT1SSEL2            @ (((unsigned) &AT1SIG)*8) + 2;
#define                                 AT1SSEL2_bit        BANKMASK(AT1SIG), 2
extern volatile __bit                   AT1STPT0            @ (((unsigned) &AT1STPTL)*8) + 0;
#define                                 AT1STPT0_bit        BANKMASK(AT1STPTL), 0
extern volatile __bit                   AT1STPT1            @ (((unsigned) &AT1STPTL)*8) + 1;
#define                                 AT1STPT1_bit        BANKMASK(AT1STPTL), 1
extern volatile __bit                   AT1STPT10           @ (((unsigned) &AT1STPTH)*8) + 2;
#define                                 AT1STPT10_bit       BANKMASK(AT1STPTH), 2
extern volatile __bit                   AT1STPT11           @ (((unsigned) &AT1STPTH)*8) + 3;
#define                                 AT1STPT11_bit       BANKMASK(AT1STPTH), 3
extern volatile __bit                   AT1STPT12           @ (((unsigned) &AT1STPTH)*8) + 4;
#define                                 AT1STPT12_bit       BANKMASK(AT1STPTH), 4
extern volatile __bit                   AT1STPT13           @ (((unsigned) &AT1STPTH)*8) + 5;
#define                                 AT1STPT13_bit       BANKMASK(AT1STPTH), 5
extern volatile __bit                   AT1STPT14           @ (((unsigned) &AT1STPTH)*8) + 6;
#define                                 AT1STPT14_bit       BANKMASK(AT1STPTH), 6
extern volatile __bit                   AT1STPT2            @ (((unsigned) &AT1STPTL)*8) + 2;
#define                                 AT1STPT2_bit        BANKMASK(AT1STPTL), 2
extern volatile __bit                   AT1STPT3            @ (((unsigned) &AT1STPTL)*8) + 3;
#define                                 AT1STPT3_bit        BANKMASK(AT1STPTL), 3
extern volatile __bit                   AT1STPT4            @ (((unsigned) &AT1STPTL)*8) + 4;
#define                                 AT1STPT4_bit        BANKMASK(AT1STPTL), 4
extern volatile __bit                   AT1STPT5            @ (((unsigned) &AT1STPTL)*8) + 5;
#define                                 AT1STPT5_bit        BANKMASK(AT1STPTL), 5
extern volatile __bit                   AT1STPT6            @ (((unsigned) &AT1STPTL)*8) + 6;
#define                                 AT1STPT6_bit        BANKMASK(AT1STPTL), 6
extern volatile __bit                   AT1STPT7            @ (((unsigned) &AT1STPTL)*8) + 7;
#define                                 AT1STPT7_bit        BANKMASK(AT1STPTL), 7
extern volatile __bit                   AT1STPT8            @ (((unsigned) &AT1STPTH)*8) + 0;
#define                                 AT1STPT8_bit        BANKMASK(AT1STPTH), 0
extern volatile __bit                   AT1STPT9            @ (((unsigned) &AT1STPTH)*8) + 1;
#define                                 AT1STPT9_bit        BANKMASK(AT1STPTH), 1
extern volatile __bit                   AT1VALID            @ (((unsigned) &AT1CON1)*8) + 0;
#define                                 AT1VALID_bit        BANKMASK(AT1CON1), 0
extern volatile __bit                   ATCC1PPS0           @ (((unsigned) &ATCC1PPS)*8) + 0;
#define                                 ATCC1PPS0_bit       BANKMASK(ATCC1PPS), 0
extern volatile __bit                   ATCC1PPS1           @ (((unsigned) &ATCC1PPS)*8) + 1;
#define                                 ATCC1PPS1_bit       BANKMASK(ATCC1PPS), 1
extern volatile __bit                   ATCC1PPS2           @ (((unsigned) &ATCC1PPS)*8) + 2;
#define                                 ATCC1PPS2_bit       BANKMASK(ATCC1PPS), 2
extern volatile __bit                   ATCC1PPS3           @ (((unsigned) &ATCC1PPS)*8) + 3;
#define                                 ATCC1PPS3_bit       BANKMASK(ATCC1PPS), 3
extern volatile __bit                   ATCC1PPS4           @ (((unsigned) &ATCC1PPS)*8) + 4;
#define                                 ATCC1PPS4_bit       BANKMASK(ATCC1PPS), 4
extern volatile __bit                   ATCC2PPS0           @ (((unsigned) &ATCC2PPS)*8) + 0;
#define                                 ATCC2PPS0_bit       BANKMASK(ATCC2PPS), 0
extern volatile __bit                   ATCC2PPS1           @ (((unsigned) &ATCC2PPS)*8) + 1;
#define                                 ATCC2PPS1_bit       BANKMASK(ATCC2PPS), 1
extern volatile __bit                   ATCC2PPS2           @ (((unsigned) &ATCC2PPS)*8) + 2;
#define                                 ATCC2PPS2_bit       BANKMASK(ATCC2PPS), 2
extern volatile __bit                   ATCC2PPS3           @ (((unsigned) &ATCC2PPS)*8) + 3;
#define                                 ATCC2PPS3_bit       BANKMASK(ATCC2PPS), 3
extern volatile __bit                   ATCC2PPS4           @ (((unsigned) &ATCC2PPS)*8) + 4;
#define                                 ATCC2PPS4_bit       BANKMASK(ATCC2PPS), 4
extern volatile __bit                   ATCC3PPS0           @ (((unsigned) &ATCC3PPS)*8) + 0;
#define                                 ATCC3PPS0_bit       BANKMASK(ATCC3PPS), 0
extern volatile __bit                   ATCC3PPS1           @ (((unsigned) &ATCC3PPS)*8) + 1;
#define                                 ATCC3PPS1_bit       BANKMASK(ATCC3PPS), 1
extern volatile __bit                   ATCC3PPS2           @ (((unsigned) &ATCC3PPS)*8) + 2;
#define                                 ATCC3PPS2_bit       BANKMASK(ATCC3PPS), 2
extern volatile __bit                   ATCC3PPS3           @ (((unsigned) &ATCC3PPS)*8) + 3;
#define                                 ATCC3PPS3_bit       BANKMASK(ATCC3PPS), 3
extern volatile __bit                   ATCC3PPS4           @ (((unsigned) &ATCC3PPS)*8) + 4;
#define                                 ATCC3PPS4_bit       BANKMASK(ATCC3PPS), 4
extern volatile __bit                   ATINPPS0            @ (((unsigned) &ATINPPS)*8) + 0;
#define                                 ATINPPS0_bit        BANKMASK(ATINPPS), 0
extern volatile __bit                   ATINPPS1            @ (((unsigned) &ATINPPS)*8) + 1;
#define                                 ATINPPS1_bit        BANKMASK(ATINPPS), 1
extern volatile __bit                   ATINPPS2            @ (((unsigned) &ATINPPS)*8) + 2;
#define                                 ATINPPS2_bit        BANKMASK(ATINPPS), 2
extern volatile __bit                   ATINPPS3            @ (((unsigned) &ATINPPS)*8) + 3;
#define                                 ATINPPS3_bit        BANKMASK(ATINPPS), 3
extern volatile __bit                   ATINPPS4            @ (((unsigned) &ATINPPS)*8) + 4;
#define                                 ATINPPS4_bit        BANKMASK(ATINPPS), 4
extern volatile __bit                   BCL1IE              @ (((unsigned) &PIE2)*8) + 3;
#define                                 BCL1IE_bit          BANKMASK(PIE2), 3
extern volatile __bit                   BCL1IF              @ (((unsigned) &PIR2)*8) + 3;
#define                                 BCL1IF_bit          BANKMASK(PIR2), 3
extern volatile __bit                   BF                  @ (((unsigned) &SSP1STAT)*8) + 0;
#define                                 BF_bit              BANKMASK(SSP1STAT), 0
extern volatile __bit                   BOEN                @ (((unsigned) &SSP1CON3)*8) + 4;
#define                                 BOEN_bit            BANKMASK(SSP1CON3), 4
extern volatile __bit                   BORFS               @ (((unsigned) &BORCON)*8) + 6;
#define                                 BORFS_bit           BANKMASK(BORCON), 6
extern volatile __bit                   BORRDY              @ (((unsigned) &BORCON)*8) + 0;
#define                                 BORRDY_bit          BANKMASK(BORCON), 0
extern volatile __bit                   BRG16               @ (((unsigned) &BAUD1CON)*8) + 3;
#define                                 BRG16_bit           BANKMASK(BAUD1CON), 3
extern volatile __bit                   BRGH                @ (((unsigned) &TX1STA)*8) + 2;
#define                                 BRGH_bit            BANKMASK(TX1STA), 2
extern volatile __bit                   BSR0                @ (((unsigned) &BSR)*8) + 0;
#define                                 BSR0_bit            BANKMASK(BSR), 0
extern volatile __bit                   BSR1                @ (((unsigned) &BSR)*8) + 1;
#define                                 BSR1_bit            BANKMASK(BSR), 1
extern volatile __bit                   BSR2                @ (((unsigned) &BSR)*8) + 2;
#define                                 BSR2_bit            BANKMASK(BSR), 2
extern volatile __bit                   BSR3                @ (((unsigned) &BSR)*8) + 3;
#define                                 BSR3_bit            BANKMASK(BSR), 3
extern volatile __bit                   BSR4                @ (((unsigned) &BSR)*8) + 4;
#define                                 BSR4_bit            BANKMASK(BSR), 4
extern volatile __bit                   BUF0                @ (((unsigned) &SSP1BUF)*8) + 0;
#define                                 BUF0_bit            BANKMASK(SSP1BUF), 0
extern volatile __bit                   BUF1                @ (((unsigned) &SSP1BUF)*8) + 1;
#define                                 BUF1_bit            BANKMASK(SSP1BUF), 1
extern volatile __bit                   BUF2                @ (((unsigned) &SSP1BUF)*8) + 2;
#define                                 BUF2_bit            BANKMASK(SSP1BUF), 2
extern volatile __bit                   BUF3                @ (((unsigned) &SSP1BUF)*8) + 3;
#define                                 BUF3_bit            BANKMASK(SSP1BUF), 3
extern volatile __bit                   BUF4                @ (((unsigned) &SSP1BUF)*8) + 4;
#define                                 BUF4_bit            BANKMASK(SSP1BUF), 4
extern volatile __bit                   BUF5                @ (((unsigned) &SSP1BUF)*8) + 5;
#define                                 BUF5_bit            BANKMASK(SSP1BUF), 5
extern volatile __bit                   BUF6                @ (((unsigned) &SSP1BUF)*8) + 6;
#define                                 BUF6_bit            BANKMASK(SSP1BUF), 6
extern volatile __bit                   BUF7                @ (((unsigned) &SSP1BUF)*8) + 7;
#define                                 BUF7_bit            BANKMASK(SSP1BUF), 7
extern volatile __bit                   C1AS                @ (((unsigned) &CWG1AS1)*8) + 1;
#define                                 C1AS_bit            BANKMASK(CWG1AS1), 1
extern volatile __bit                   C1HYS               @ (((unsigned) &CM1CON0)*8) + 1;
#define                                 C1HYS_bit           BANKMASK(CM1CON0), 1
extern volatile __bit                   C1IE                @ (((unsigned) &PIE2)*8) + 5;
#define                                 C1IE_bit            BANKMASK(PIE2), 5
extern volatile __bit                   C1IF                @ (((unsigned) &PIR2)*8) + 5;
#define                                 C1IF_bit            BANKMASK(PIR2), 5
extern volatile __bit                   C1INTN              @ (((unsigned) &CM1CON1)*8) + 6;
#define                                 C1INTN_bit          BANKMASK(CM1CON1), 6
extern volatile __bit                   C1INTP              @ (((unsigned) &CM1CON1)*8) + 7;
#define                                 C1INTP_bit          BANKMASK(CM1CON1), 7
extern volatile __bit                   C1NCH0              @ (((unsigned) &CM1CON1)*8) + 0;
#define                                 C1NCH0_bit          BANKMASK(CM1CON1), 0
extern volatile __bit                   C1NCH1              @ (((unsigned) &CM1CON1)*8) + 1;
#define                                 C1NCH1_bit          BANKMASK(CM1CON1), 1
extern volatile __bit                   C1NCH2              @ (((unsigned) &CM1CON1)*8) + 2;
#define                                 C1NCH2_bit          BANKMASK(CM1CON1), 2
extern volatile __bit                   C1ON                @ (((unsigned) &CM1CON0)*8) + 7;
#define                                 C1ON_bit            BANKMASK(CM1CON0), 7
extern volatile __bit                   C1OUT               @ (((unsigned) &CM1CON0)*8) + 6;
#define                                 C1OUT_bit           BANKMASK(CM1CON0), 6
extern volatile __bit                   C1PCH0              @ (((unsigned) &CM1CON1)*8) + 4;
#define                                 C1PCH0_bit          BANKMASK(CM1CON1), 4
extern volatile __bit                   C1PCH1              @ (((unsigned) &CM1CON1)*8) + 5;
#define                                 C1PCH1_bit          BANKMASK(CM1CON1), 5
extern volatile __bit                   C1POL               @ (((unsigned) &CM1CON0)*8) + 4;
#define                                 C1POL_bit           BANKMASK(CM1CON0), 4
extern volatile __bit                   C1SP                @ (((unsigned) &CM1CON0)*8) + 2;
#define                                 C1SP_bit            BANKMASK(CM1CON0), 2
extern volatile __bit                   C1SYNC              @ (((unsigned) &CM1CON0)*8) + 0;
#define                                 C1SYNC_bit          BANKMASK(CM1CON0), 0
extern volatile __bit                   C2AS                @ (((unsigned) &CWG1AS1)*8) + 2;
#define                                 C2AS_bit            BANKMASK(CWG1AS1), 2
extern volatile __bit                   C2HYS               @ (((unsigned) &CM2CON0)*8) + 1;
#define                                 C2HYS_bit           BANKMASK(CM2CON0), 1
extern volatile __bit                   C2IE                @ (((unsigned) &PIE2)*8) + 6;
#define                                 C2IE_bit            BANKMASK(PIE2), 6
extern volatile __bit                   C2IF                @ (((unsigned) &PIR2)*8) + 6;
#define                                 C2IF_bit            BANKMASK(PIR2), 6
extern volatile __bit                   C2INTN              @ (((unsigned) &CM2CON1)*8) + 6;
#define                                 C2INTN_bit          BANKMASK(CM2CON1), 6
extern volatile __bit                   C2INTP              @ (((unsigned) &CM2CON1)*8) + 7;
#define                                 C2INTP_bit          BANKMASK(CM2CON1), 7
extern volatile __bit                   C2NCH0              @ (((unsigned) &CM2CON1)*8) + 0;
#define                                 C2NCH0_bit          BANKMASK(CM2CON1), 0
extern volatile __bit                   C2NCH1              @ (((unsigned) &CM2CON1)*8) + 1;
#define                                 C2NCH1_bit          BANKMASK(CM2CON1), 1
extern volatile __bit                   C2NCH2              @ (((unsigned) &CM2CON1)*8) + 2;
#define                                 C2NCH2_bit          BANKMASK(CM2CON1), 2
extern volatile __bit                   C2ON                @ (((unsigned) &CM2CON0)*8) + 7;
#define                                 C2ON_bit            BANKMASK(CM2CON0), 7
extern volatile __bit                   C2OUT               @ (((unsigned) &CM2CON0)*8) + 6;
#define                                 C2OUT_bit           BANKMASK(CM2CON0), 6
extern volatile __bit                   C2PCH0              @ (((unsigned) &CM2CON1)*8) + 4;
#define                                 C2PCH0_bit          BANKMASK(CM2CON1), 4
extern volatile __bit                   C2PCH1              @ (((unsigned) &CM2CON1)*8) + 5;
#define                                 C2PCH1_bit          BANKMASK(CM2CON1), 5
extern volatile __bit                   C2POL               @ (((unsigned) &CM2CON0)*8) + 4;
#define                                 C2POL_bit           BANKMASK(CM2CON0), 4
extern volatile __bit                   C2SP                @ (((unsigned) &CM2CON0)*8) + 2;
#define                                 C2SP_bit            BANKMASK(CM2CON0), 2
extern volatile __bit                   C2SYNC              @ (((unsigned) &CM2CON0)*8) + 0;
#define                                 C2SYNC_bit          BANKMASK(CM2CON0), 0
extern volatile __bit                   CAP1P               @ (((unsigned) &AT1CCON1)*8) + 3;
#define                                 CAP1P_bit           BANKMASK(AT1CCON1), 3
extern volatile __bit                   CAP2P               @ (((unsigned) &AT1CCON2)*8) + 3;
#define                                 CAP2P_bit           BANKMASK(AT1CCON2), 3
extern volatile __bit                   CAP3P               @ (((unsigned) &AT1CCON3)*8) + 3;
#define                                 CAP3P_bit           BANKMASK(AT1CCON3), 3
extern volatile __bit                   CARRY               @ (((unsigned) &STATUS)*8) + 0;
#define                                 CARRY_bit           BANKMASK(STATUS), 0
extern volatile __bit                   CC10                @ (((unsigned) &AT1CC1L)*8) + 0;
#define                                 CC10_bit            BANKMASK(AT1CC1L), 0
extern volatile __bit                   CC11                @ (((unsigned) &AT1CC1L)*8) + 1;
#define                                 CC11_bit            BANKMASK(AT1CC1L), 1
extern volatile __bit                   CC12                @ (((unsigned) &AT1CC1L)*8) + 2;
#define                                 CC12_bit            BANKMASK(AT1CC1L), 2
extern volatile __bit                   CC14                @ (((unsigned) &AT1CC1L)*8) + 4;
#define                                 CC14_bit            BANKMASK(AT1CC1L), 4
extern volatile __bit                   CC15                @ (((unsigned) &AT1CC1L)*8) + 5;
#define                                 CC15_bit            BANKMASK(AT1CC1L), 5
extern volatile __bit                   CC16                @ (((unsigned) &AT1CC1L)*8) + 6;
#define                                 CC16_bit            BANKMASK(AT1CC1L), 6
extern volatile __bit                   CC17                @ (((unsigned) &AT1CC1L)*8) + 7;
#define                                 CC17_bit            BANKMASK(AT1CC1L), 7
extern volatile __bit                   CC18                @ (((unsigned) &AT1CC1H)*8) + 0;
#define                                 CC18_bit            BANKMASK(AT1CC1H), 0
extern volatile __bit                   CC19                @ (((unsigned) &AT1CC1H)*8) + 1;
#define                                 CC19_bit            BANKMASK(AT1CC1H), 1
extern volatile __bit                   CC1EN               @ (((unsigned) &AT1CCON1)*8) + 7;
#define                                 CC1EN_bit           BANKMASK(AT1CCON1), 7
extern volatile __bit                   CC1MODE             @ (((unsigned) &AT1CCON1)*8) + 0;
#define                                 CC1MODE_bit         BANKMASK(AT1CCON1), 0
extern volatile __bit                   CC1POL              @ (((unsigned) &AT1CCON1)*8) + 4;
#define                                 CC1POL_bit          BANKMASK(AT1CCON1), 4
extern volatile __bit                   CC20                @ (((unsigned) &AT1CC2L)*8) + 0;
#define                                 CC20_bit            BANKMASK(AT1CC2L), 0
extern volatile __bit                   CC21                @ (((unsigned) &AT1CC2L)*8) + 1;
#define                                 CC21_bit            BANKMASK(AT1CC2L), 1
extern volatile __bit                   CC22                @ (((unsigned) &AT1CC2L)*8) + 2;
#define                                 CC22_bit            BANKMASK(AT1CC2L), 2
extern volatile __bit                   CC24                @ (((unsigned) &AT1CC2L)*8) + 4;
#define                                 CC24_bit            BANKMASK(AT1CC2L), 4
extern volatile __bit                   CC26                @ (((unsigned) &AT1CC2L)*8) + 6;
#define                                 CC26_bit            BANKMASK(AT1CC2L), 6
extern volatile __bit                   CC27                @ (((unsigned) &AT1CC2L)*8) + 7;
#define                                 CC27_bit            BANKMASK(AT1CC2L), 7
extern volatile __bit                   CC28                @ (((unsigned) &AT1CC2H)*8) + 0;
#define                                 CC28_bit            BANKMASK(AT1CC2H), 0
extern volatile __bit                   CC29                @ (((unsigned) &AT1CC2H)*8) + 1;
#define                                 CC29_bit            BANKMASK(AT1CC2H), 1
extern volatile __bit                   CC2EN               @ (((unsigned) &AT1CCON2)*8) + 7;
#define                                 CC2EN_bit           BANKMASK(AT1CCON2), 7
extern volatile __bit                   CC2MODE             @ (((unsigned) &AT1CCON2)*8) + 0;
#define                                 CC2MODE_bit         BANKMASK(AT1CCON2), 0
extern volatile __bit                   CC2POL              @ (((unsigned) &AT1CCON2)*8) + 4;
#define                                 CC2POL_bit          BANKMASK(AT1CCON2), 4
extern volatile __bit                   CC30                @ (((unsigned) &AT1CC3L)*8) + 0;
#define                                 CC30_bit            BANKMASK(AT1CC3L), 0
extern volatile __bit                   CC31                @ (((unsigned) &AT1CC3L)*8) + 1;
#define                                 CC31_bit            BANKMASK(AT1CC3L), 1
extern volatile __bit                   CC32                @ (((unsigned) &AT1CC3L)*8) + 2;
#define                                 CC32_bit            BANKMASK(AT1CC3L), 2
extern volatile __bit                   CC33                @ (((unsigned) &AT1CC3L)*8) + 3;
#define                                 CC33_bit            BANKMASK(AT1CC3L), 3
extern volatile __bit                   CC34                @ (((unsigned) &AT1CC3L)*8) + 4;
#define                                 CC34_bit            BANKMASK(AT1CC3L), 4
extern volatile __bit                   CC35                @ (((unsigned) &AT1CC3L)*8) + 5;
#define                                 CC35_bit            BANKMASK(AT1CC3L), 5
extern volatile __bit                   CC36                @ (((unsigned) &AT1CC3L)*8) + 6;
#define                                 CC36_bit            BANKMASK(AT1CC3L), 6
extern volatile __bit                   CC37                @ (((unsigned) &AT1CC3L)*8) + 7;
#define                                 CC37_bit            BANKMASK(AT1CC3L), 7
extern volatile __bit                   CC38                @ (((unsigned) &AT1CC3H)*8) + 0;
#define                                 CC38_bit            BANKMASK(AT1CC3H), 0
extern volatile __bit                   CC39                @ (((unsigned) &AT1CC3H)*8) + 1;
#define                                 CC39_bit            BANKMASK(AT1CC3H), 1
extern volatile __bit                   CC3EN               @ (((unsigned) &AT1CCON3)*8) + 7;
#define                                 CC3EN_bit           BANKMASK(AT1CCON3), 7
extern volatile __bit                   CC3MODE             @ (((unsigned) &AT1CCON3)*8) + 0;
#define                                 CC3MODE_bit         BANKMASK(AT1CCON3), 0
extern volatile __bit                   CC3POL              @ (((unsigned) &AT1CCON3)*8) + 4;
#define                                 CC3POL_bit          BANKMASK(AT1CCON3), 4
extern volatile __bit                   CCP1CTS0            @ (((unsigned) &CCP1CAP)*8) + 0;
#define                                 CCP1CTS0_bit        BANKMASK(CCP1CAP), 0
extern volatile __bit                   CCP1CTS1            @ (((unsigned) &CCP1CAP)*8) + 1;
#define                                 CCP1CTS1_bit        BANKMASK(CCP1CAP), 1
extern volatile __bit                   CCP1CTS2            @ (((unsigned) &CCP1CAP)*8) + 2;
#define                                 CCP1CTS2_bit        BANKMASK(CCP1CAP), 2
extern volatile __bit                   CCP1EN              @ (((unsigned) &CCP1CON)*8) + 7;
#define                                 CCP1EN_bit          BANKMASK(CCP1CON), 7
extern volatile __bit                   CCP1FMT             @ (((unsigned) &CCP1CON)*8) + 4;
#define                                 CCP1FMT_bit         BANKMASK(CCP1CON), 4
extern volatile __bit                   CCP1IE              @ (((unsigned) &PIE1)*8) + 2;
#define                                 CCP1IE_bit          BANKMASK(PIE1), 2
extern volatile __bit                   CCP1IF              @ (((unsigned) &PIR1)*8) + 2;
#define                                 CCP1IF_bit          BANKMASK(PIR1), 2
extern volatile __bit                   CCP1MODE0           @ (((unsigned) &CCP1CON)*8) + 0;
#define                                 CCP1MODE0_bit       BANKMASK(CCP1CON), 0
extern volatile __bit                   CCP1MODE1           @ (((unsigned) &CCP1CON)*8) + 1;
#define                                 CCP1MODE1_bit       BANKMASK(CCP1CON), 1
extern volatile __bit                   CCP1MODE2           @ (((unsigned) &CCP1CON)*8) + 2;
#define                                 CCP1MODE2_bit       BANKMASK(CCP1CON), 2
extern volatile __bit                   CCP1MODE3           @ (((unsigned) &CCP1CON)*8) + 3;
#define                                 CCP1MODE3_bit       BANKMASK(CCP1CON), 3
extern volatile __bit                   CCP1OUT             @ (((unsigned) &CCP1CON)*8) + 5;
#define                                 CCP1OUT_bit         BANKMASK(CCP1CON), 5
extern volatile __bit                   CCP1PPS0            @ (((unsigned) &CCP1PPS)*8) + 0;
#define                                 CCP1PPS0_bit        BANKMASK(CCP1PPS), 0
extern volatile __bit                   CCP1PPS1            @ (((unsigned) &CCP1PPS)*8) + 1;
#define                                 CCP1PPS1_bit        BANKMASK(CCP1PPS), 1
extern volatile __bit                   CCP1PPS2            @ (((unsigned) &CCP1PPS)*8) + 2;
#define                                 CCP1PPS2_bit        BANKMASK(CCP1PPS), 2
extern volatile __bit                   CCP1PPS3            @ (((unsigned) &CCP1PPS)*8) + 3;
#define                                 CCP1PPS3_bit        BANKMASK(CCP1PPS), 3
extern volatile __bit                   CCP1PPS4            @ (((unsigned) &CCP1PPS)*8) + 4;
#define                                 CCP1PPS4_bit        BANKMASK(CCP1PPS), 4
extern volatile __bit                   CCP1TSEL0           @ (((unsigned) &CCPTMRS)*8) + 0;
#define                                 CCP1TSEL0_bit       BANKMASK(CCPTMRS), 0
extern volatile __bit                   CCP1TSEL1           @ (((unsigned) &CCPTMRS)*8) + 1;
#define                                 CCP1TSEL1_bit       BANKMASK(CCPTMRS), 1
extern volatile __bit                   CCP2CTS0            @ (((unsigned) &CCP2CAP)*8) + 0;
#define                                 CCP2CTS0_bit        BANKMASK(CCP2CAP), 0
extern volatile __bit                   CCP2CTS1            @ (((unsigned) &CCP2CAP)*8) + 1;
#define                                 CCP2CTS1_bit        BANKMASK(CCP2CAP), 1
extern volatile __bit                   CCP2CTS2            @ (((unsigned) &CCP2CAP)*8) + 2;
#define                                 CCP2CTS2_bit        BANKMASK(CCP2CAP), 2
extern volatile __bit                   CCP2EN              @ (((unsigned) &CCP2CON)*8) + 7;
#define                                 CCP2EN_bit          BANKMASK(CCP2CON), 7
extern volatile __bit                   CCP2FMT             @ (((unsigned) &CCP2CON)*8) + 4;
#define                                 CCP2FMT_bit         BANKMASK(CCP2CON), 4
extern volatile __bit                   CCP2IE              @ (((unsigned) &PIE2)*8) + 0;
#define                                 CCP2IE_bit          BANKMASK(PIE2), 0
extern volatile __bit                   CCP2IF              @ (((unsigned) &PIR2)*8) + 0;
#define                                 CCP2IF_bit          BANKMASK(PIR2), 0
extern volatile __bit                   CCP2MODE0           @ (((unsigned) &CCP2CON)*8) + 0;
#define                                 CCP2MODE0_bit       BANKMASK(CCP2CON), 0
extern volatile __bit                   CCP2MODE1           @ (((unsigned) &CCP2CON)*8) + 1;
#define                                 CCP2MODE1_bit       BANKMASK(CCP2CON), 1
extern volatile __bit                   CCP2MODE2           @ (((unsigned) &CCP2CON)*8) + 2;
#define                                 CCP2MODE2_bit       BANKMASK(CCP2CON), 2
extern volatile __bit                   CCP2MODE3           @ (((unsigned) &CCP2CON)*8) + 3;
#define                                 CCP2MODE3_bit       BANKMASK(CCP2CON), 3
extern volatile __bit                   CCP2OUT             @ (((unsigned) &CCP2CON)*8) + 5;
#define                                 CCP2OUT_bit         BANKMASK(CCP2CON), 5
extern volatile __bit                   CCP2PPS0            @ (((unsigned) &CCP2PPS)*8) + 0;
#define                                 CCP2PPS0_bit        BANKMASK(CCP2PPS), 0
extern volatile __bit                   CCP2PPS1            @ (((unsigned) &CCP2PPS)*8) + 1;
#define                                 CCP2PPS1_bit        BANKMASK(CCP2PPS), 1
extern volatile __bit                   CCP2PPS2            @ (((unsigned) &CCP2PPS)*8) + 2;
#define                                 CCP2PPS2_bit        BANKMASK(CCP2PPS), 2
extern volatile __bit                   CCP2PPS3            @ (((unsigned) &CCP2PPS)*8) + 3;
#define                                 CCP2PPS3_bit        BANKMASK(CCP2PPS), 3
extern volatile __bit                   CCP2PPS4            @ (((unsigned) &CCP2PPS)*8) + 4;
#define                                 CCP2PPS4_bit        BANKMASK(CCP2PPS), 4
extern volatile __bit                   CCP2TSEL0           @ (((unsigned) &CCPTMRS)*8) + 2;
#define                                 CCP2TSEL0_bit       BANKMASK(CCPTMRS), 2
extern volatile __bit                   CCP2TSEL1           @ (((unsigned) &CCPTMRS)*8) + 3;
#define                                 CCP2TSEL1_bit       BANKMASK(CCPTMRS), 3
extern volatile __bit                   CCW5                @ (((unsigned) &AT1CC2L)*8) + 5;
#define                                 CCW5_bit            BANKMASK(AT1CC2L), 5
extern volatile __bit                   CDAFVR0             @ (((unsigned) &FVRCON)*8) + 2;
#define                                 CDAFVR0_bit         BANKMASK(FVRCON), 2
extern volatile __bit                   CDAFVR1             @ (((unsigned) &FVRCON)*8) + 3;
#define                                 CDAFVR1_bit         BANKMASK(FVRCON), 3
extern volatile __bit                   CFGS                @ (((unsigned) &PMCON1)*8) + 6;
#define                                 CFGS_bit            BANKMASK(PMCON1), 6
extern volatile __bit                   CHS0                @ (((unsigned) &ADCON0)*8) + 2;
#define                                 CHS0_bit            BANKMASK(ADCON0), 2
extern volatile __bit                   CHS1                @ (((unsigned) &ADCON0)*8) + 3;
#define                                 CHS1_bit            BANKMASK(ADCON0), 3
extern volatile __bit                   CHS2                @ (((unsigned) &ADCON0)*8) + 4;
#define                                 CHS2_bit            BANKMASK(ADCON0), 4
extern volatile __bit                   CHS3                @ (((unsigned) &ADCON0)*8) + 5;
#define                                 CHS3_bit            BANKMASK(ADCON0), 5
extern volatile __bit                   CHS4                @ (((unsigned) &ADCON0)*8) + 6;
#define                                 CHS4_bit            BANKMASK(ADCON0), 6
extern volatile __bit                   CKE                 @ (((unsigned) &SSP1STAT)*8) + 6;
#define                                 CKE_bit             BANKMASK(SSP1STAT), 6
extern volatile __bit                   CKP                 @ (((unsigned) &SSP1CON1)*8) + 4;
#define                                 CKP_bit             BANKMASK(SSP1CON1), 4
extern volatile __bit                   CKPPS0              @ (((unsigned) &CKPPS)*8) + 0;
#define                                 CKPPS0_bit          BANKMASK(CKPPS), 0
extern volatile __bit                   CKPPS1              @ (((unsigned) &CKPPS)*8) + 1;
#define                                 CKPPS1_bit          BANKMASK(CKPPS), 1
extern volatile __bit                   CKPPS2              @ (((unsigned) &CKPPS)*8) + 2;
#define                                 CKPPS2_bit          BANKMASK(CKPPS), 2
extern volatile __bit                   CKPPS3              @ (((unsigned) &CKPPS)*8) + 3;
#define                                 CKPPS3_bit          BANKMASK(CKPPS), 3
extern volatile __bit                   CKPPS4              @ (((unsigned) &CKPPS)*8) + 4;
#define                                 CKPPS4_bit          BANKMASK(CKPPS), 4
extern volatile __bit                   CLC1IE              @ (((unsigned) &PIE3)*8) + 0;
#define                                 CLC1IE_bit          BANKMASK(PIE3), 0
extern volatile __bit                   CLC1IF              @ (((unsigned) &PIR3)*8) + 0;
#define                                 CLC1IF_bit          BANKMASK(PIR3), 0
extern volatile __bit                   CLC2IE              @ (((unsigned) &PIE3)*8) + 1;
#define                                 CLC2IE_bit          BANKMASK(PIE3), 1
extern volatile __bit                   CLC2IF              @ (((unsigned) &PIR3)*8) + 1;
#define                                 CLC2IF_bit          BANKMASK(PIR3), 1
extern volatile __bit                   CLC3IE              @ (((unsigned) &PIE3)*8) + 2;
#define                                 CLC3IE_bit          BANKMASK(PIE3), 2
extern volatile __bit                   CLC3IF              @ (((unsigned) &PIR3)*8) + 2;
#define                                 CLC3IF_bit          BANKMASK(PIR3), 2
extern volatile __bit                   CLC4IE              @ (((unsigned) &PIE3)*8) + 3;
#define                                 CLC4IE_bit          BANKMASK(PIE3), 3
extern volatile __bit                   CLC4IF              @ (((unsigned) &PIR3)*8) + 3;
#define                                 CLC4IF_bit          BANKMASK(PIR3), 3
extern volatile __bit                   CLCIN0PPS0          @ (((unsigned) &CLCIN0PPS)*8) + 0;
#define                                 CLCIN0PPS0_bit      BANKMASK(CLCIN0PPS), 0
extern volatile __bit                   CLCIN0PPS1          @ (((unsigned) &CLCIN0PPS)*8) + 1;
#define                                 CLCIN0PPS1_bit      BANKMASK(CLCIN0PPS), 1
extern volatile __bit                   CLCIN0PPS2          @ (((unsigned) &CLCIN0PPS)*8) + 2;
#define                                 CLCIN0PPS2_bit      BANKMASK(CLCIN0PPS), 2
extern volatile __bit                   CLCIN0PPS3          @ (((unsigned) &CLCIN0PPS)*8) + 3;
#define                                 CLCIN0PPS3_bit      BANKMASK(CLCIN0PPS), 3
extern volatile __bit                   CLCIN0PPS4          @ (((unsigned) &CLCIN0PPS)*8) + 4;
#define                                 CLCIN0PPS4_bit      BANKMASK(CLCIN0PPS), 4
extern volatile __bit                   CLCIN1PPS0          @ (((unsigned) &CLCIN1PPS)*8) + 0;
#define                                 CLCIN1PPS0_bit      BANKMASK(CLCIN1PPS), 0
extern volatile __bit                   CLCIN1PPS1          @ (((unsigned) &CLCIN1PPS)*8) + 1;
#define                                 CLCIN1PPS1_bit      BANKMASK(CLCIN1PPS), 1
extern volatile __bit                   CLCIN1PPS2          @ (((unsigned) &CLCIN1PPS)*8) + 2;
#define                                 CLCIN1PPS2_bit      BANKMASK(CLCIN1PPS), 2
extern volatile __bit                   CLCIN1PPS3          @ (((unsigned) &CLCIN1PPS)*8) + 3;
#define                                 CLCIN1PPS3_bit      BANKMASK(CLCIN1PPS), 3
extern volatile __bit                   CLCIN1PPS4          @ (((unsigned) &CLCIN1PPS)*8) + 4;
#define                                 CLCIN1PPS4_bit      BANKMASK(CLCIN1PPS), 4
extern volatile __bit                   CLCIN2PPS0          @ (((unsigned) &CLCIN2PPS)*8) + 0;
#define                                 CLCIN2PPS0_bit      BANKMASK(CLCIN2PPS), 0
extern volatile __bit                   CLCIN2PPS1          @ (((unsigned) &CLCIN2PPS)*8) + 1;
#define                                 CLCIN2PPS1_bit      BANKMASK(CLCIN2PPS), 1
extern volatile __bit                   CLCIN2PPS2          @ (((unsigned) &CLCIN2PPS)*8) + 2;
#define                                 CLCIN2PPS2_bit      BANKMASK(CLCIN2PPS), 2
extern volatile __bit                   CLCIN2PPS3          @ (((unsigned) &CLCIN2PPS)*8) + 3;
#define                                 CLCIN2PPS3_bit      BANKMASK(CLCIN2PPS), 3
extern volatile __bit                   CLCIN2PPS4          @ (((unsigned) &CLCIN2PPS)*8) + 4;
#define                                 CLCIN2PPS4_bit      BANKMASK(CLCIN2PPS), 4
extern volatile __bit                   CLCIN3PPS0          @ (((unsigned) &CLCIN3PPS)*8) + 0;
#define                                 CLCIN3PPS0_bit      BANKMASK(CLCIN3PPS), 0
extern volatile __bit                   CLCIN3PPS1          @ (((unsigned) &CLCIN3PPS)*8) + 1;
#define                                 CLCIN3PPS1_bit      BANKMASK(CLCIN3PPS), 1
extern volatile __bit                   CLCIN3PPS2          @ (((unsigned) &CLCIN3PPS)*8) + 2;
#define                                 CLCIN3PPS2_bit      BANKMASK(CLCIN3PPS), 2
extern volatile __bit                   CLCIN3PPS3          @ (((unsigned) &CLCIN3PPS)*8) + 3;
#define                                 CLCIN3PPS3_bit      BANKMASK(CLCIN3PPS), 3
extern volatile __bit                   CLCIN3PPS4          @ (((unsigned) &CLCIN3PPS)*8) + 4;
#define                                 CLCIN3PPS4_bit      BANKMASK(CLCIN3PPS), 4
extern volatile __bit                   CP1S0               @ (((unsigned) &AT1CSEL1)*8) + 0;
#define                                 CP1S0_bit           BANKMASK(AT1CSEL1), 0
extern volatile __bit                   CP1S1               @ (((unsigned) &AT1CSEL1)*8) + 1;
#define                                 CP1S1_bit           BANKMASK(AT1CSEL1), 1
extern volatile __bit                   CP1S2               @ (((unsigned) &AT1CSEL1)*8) + 2;
#define                                 CP1S2_bit           BANKMASK(AT1CSEL1), 2
extern volatile __bit                   CP2S0               @ (((unsigned) &AT1CSEL2)*8) + 0;
#define                                 CP2S0_bit           BANKMASK(AT1CSEL2), 0
extern volatile __bit                   CP2S1               @ (((unsigned) &AT1CSEL2)*8) + 1;
#define                                 CP2S1_bit           BANKMASK(AT1CSEL2), 1
extern volatile __bit                   CP2S2               @ (((unsigned) &AT1CSEL2)*8) + 2;
#define                                 CP2S2_bit           BANKMASK(AT1CSEL2), 2
extern volatile __bit                   CP3S0               @ (((unsigned) &AT1CSEL3)*8) + 0;
#define                                 CP3S0_bit           BANKMASK(AT1CSEL3), 0
extern volatile __bit                   CP3S1               @ (((unsigned) &AT1CSEL3)*8) + 1;
#define                                 CP3S1_bit           BANKMASK(AT1CSEL3), 1
extern volatile __bit                   CP3S2               @ (((unsigned) &AT1CSEL3)*8) + 2;
#define                                 CP3S2_bit           BANKMASK(AT1CSEL3), 2
extern volatile __bit                   CRCACC0             @ (((unsigned) &CRCACCL)*8) + 0;
#define                                 CRCACC0_bit         BANKMASK(CRCACCL), 0
extern volatile __bit                   CRCACC1             @ (((unsigned) &CRCACCL)*8) + 1;
#define                                 CRCACC1_bit         BANKMASK(CRCACCL), 1
extern volatile __bit                   CRCACC10            @ (((unsigned) &CRCACCH)*8) + 2;
#define                                 CRCACC10_bit        BANKMASK(CRCACCH), 2
extern volatile __bit                   CRCACC11            @ (((unsigned) &CRCACCH)*8) + 3;
#define                                 CRCACC11_bit        BANKMASK(CRCACCH), 3
extern volatile __bit                   CRCACC12            @ (((unsigned) &CRCACCH)*8) + 4;
#define                                 CRCACC12_bit        BANKMASK(CRCACCH), 4
extern volatile __bit                   CRCACC13            @ (((unsigned) &CRCACCH)*8) + 5;
#define                                 CRCACC13_bit        BANKMASK(CRCACCH), 5
extern volatile __bit                   CRCACC14            @ (((unsigned) &CRCACCH)*8) + 6;
#define                                 CRCACC14_bit        BANKMASK(CRCACCH), 6
extern volatile __bit                   CRCACC15            @ (((unsigned) &CRCACCH)*8) + 7;
#define                                 CRCACC15_bit        BANKMASK(CRCACCH), 7
extern volatile __bit                   CRCACC2             @ (((unsigned) &CRCACCL)*8) + 2;
#define                                 CRCACC2_bit         BANKMASK(CRCACCL), 2
extern volatile __bit                   CRCACC3             @ (((unsigned) &CRCACCL)*8) + 3;
#define                                 CRCACC3_bit         BANKMASK(CRCACCL), 3
extern volatile __bit                   CRCACC4             @ (((unsigned) &CRCACCL)*8) + 4;
#define                                 CRCACC4_bit         BANKMASK(CRCACCL), 4
extern volatile __bit                   CRCACC5             @ (((unsigned) &CRCACCL)*8) + 5;
#define                                 CRCACC5_bit         BANKMASK(CRCACCL), 5
extern volatile __bit                   CRCACC6             @ (((unsigned) &CRCACCL)*8) + 6;
#define                                 CRCACC6_bit         BANKMASK(CRCACCL), 6
extern volatile __bit                   CRCACC7             @ (((unsigned) &CRCACCL)*8) + 7;
#define                                 CRCACC7_bit         BANKMASK(CRCACCL), 7
extern volatile __bit                   CRCACC8             @ (((unsigned) &CRCACCH)*8) + 0;
#define                                 CRCACC8_bit         BANKMASK(CRCACCH), 0
extern volatile __bit                   CRCACC9             @ (((unsigned) &CRCACCH)*8) + 1;
#define                                 CRCACC9_bit         BANKMASK(CRCACCH), 1
extern volatile __bit                   CRCACCM             @ (((unsigned) &CRCCON0)*8) + 4;
#define                                 CRCACCM_bit         BANKMASK(CRCCON0), 4
extern volatile __bit                   CRCBUSY             @ (((unsigned) &CRCCON0)*8) + 5;
#define                                 CRCBUSY_bit         BANKMASK(CRCCON0), 5
extern volatile __bit                   CRCDAT0             @ (((unsigned) &CRCDATL)*8) + 0;
#define                                 CRCDAT0_bit         BANKMASK(CRCDATL), 0
extern volatile __bit                   CRCDAT1             @ (((unsigned) &CRCDATL)*8) + 1;
#define                                 CRCDAT1_bit         BANKMASK(CRCDATL), 1
extern volatile __bit                   CRCDAT10            @ (((unsigned) &CRCDATH)*8) + 2;
#define                                 CRCDAT10_bit        BANKMASK(CRCDATH), 2
extern volatile __bit                   CRCDAT11            @ (((unsigned) &CRCDATH)*8) + 3;
#define                                 CRCDAT11_bit        BANKMASK(CRCDATH), 3
extern volatile __bit                   CRCDAT12            @ (((unsigned) &CRCDATH)*8) + 4;
#define                                 CRCDAT12_bit        BANKMASK(CRCDATH), 4
extern volatile __bit                   CRCDAT13            @ (((unsigned) &CRCDATH)*8) + 5;
#define                                 CRCDAT13_bit        BANKMASK(CRCDATH), 5
extern volatile __bit                   CRCDAT14            @ (((unsigned) &CRCDATH)*8) + 6;
#define                                 CRCDAT14_bit        BANKMASK(CRCDATH), 6
extern volatile __bit                   CRCDAT15            @ (((unsigned) &CRCDATH)*8) + 7;
#define                                 CRCDAT15_bit        BANKMASK(CRCDATH), 7
extern volatile __bit                   CRCDAT2             @ (((unsigned) &CRCDATL)*8) + 2;
#define                                 CRCDAT2_bit         BANKMASK(CRCDATL), 2
extern volatile __bit                   CRCDAT3             @ (((unsigned) &CRCDATL)*8) + 3;
#define                                 CRCDAT3_bit         BANKMASK(CRCDATL), 3
extern volatile __bit                   CRCDAT4             @ (((unsigned) &CRCDATL)*8) + 4;
#define                                 CRCDAT4_bit         BANKMASK(CRCDATL), 4
extern volatile __bit                   CRCDAT5             @ (((unsigned) &CRCDATL)*8) + 5;
#define                                 CRCDAT5_bit         BANKMASK(CRCDATL), 5
extern volatile __bit                   CRCDAT6             @ (((unsigned) &CRCDATL)*8) + 6;
#define                                 CRCDAT6_bit         BANKMASK(CRCDATL), 6
extern volatile __bit                   CRCDAT8             @ (((unsigned) &CRCDATH)*8) + 0;
#define                                 CRCDAT8_bit         BANKMASK(CRCDATH), 0
extern volatile __bit                   CRCDAT9             @ (((unsigned) &CRCDATH)*8) + 1;
#define                                 CRCDAT9_bit         BANKMASK(CRCDATH), 1
extern volatile __bit                   CRCDLEN0            @ (((unsigned) &CRCCON1)*8) + 4;
#define                                 CRCDLEN0_bit        BANKMASK(CRCCON1), 4
extern volatile __bit                   CRCDLEN1            @ (((unsigned) &CRCCON1)*8) + 5;
#define                                 CRCDLEN1_bit        BANKMASK(CRCCON1), 5
extern volatile __bit                   CRCDLEN2            @ (((unsigned) &CRCCON1)*8) + 6;
#define                                 CRCDLEN2_bit        BANKMASK(CRCCON1), 6
extern volatile __bit                   CRCDLEN3            @ (((unsigned) &CRCCON1)*8) + 7;
#define                                 CRCDLEN3_bit        BANKMASK(CRCCON1), 7
extern volatile __bit                   CRCEN               @ (((unsigned) &CRCCON0)*8) + 7;
#define                                 CRCEN_bit           BANKMASK(CRCCON0), 7
extern volatile __bit                   CRCFULL             @ (((unsigned) &CRCCON0)*8) + 0;
#define                                 CRCFULL_bit         BANKMASK(CRCCON0), 0
extern volatile __bit                   CRCGO               @ (((unsigned) &CRCCON0)*8) + 6;
#define                                 CRCGO_bit           BANKMASK(CRCCON0), 6
extern volatile __bit                   CRCIE               @ (((unsigned) &PIE4)*8) + 6;
#define                                 CRCIE_bit           BANKMASK(PIE4), 6
extern volatile __bit                   CRCIF               @ (((unsigned) &PIR4)*8) + 6;
#define                                 CRCIF_bit           BANKMASK(PIR4), 6
extern volatile __bit                   CRCPLEN0            @ (((unsigned) &CRCCON1)*8) + 0;
#define                                 CRCPLEN0_bit        BANKMASK(CRCCON1), 0
extern volatile __bit                   CRCPLEN1            @ (((unsigned) &CRCCON1)*8) + 1;
#define                                 CRCPLEN1_bit        BANKMASK(CRCCON1), 1
extern volatile __bit                   CRCPLEN2            @ (((unsigned) &CRCCON1)*8) + 2;
#define                                 CRCPLEN2_bit        BANKMASK(CRCCON1), 2
extern volatile __bit                   CRCPLEN3            @ (((unsigned) &CRCCON1)*8) + 3;
#define                                 CRCPLEN3_bit        BANKMASK(CRCCON1), 3
extern volatile __bit                   CRCSHIFT0           @ (((unsigned) &CRCSHIFTL)*8) + 0;
#define                                 CRCSHIFT0_bit       BANKMASK(CRCSHIFTL), 0
extern volatile __bit                   CRCSHIFT1           @ (((unsigned) &CRCSHIFTL)*8) + 1;
#define                                 CRCSHIFT1_bit       BANKMASK(CRCSHIFTL), 1
extern volatile __bit                   CRCSHIFT10          @ (((unsigned) &CRCSHIFTH)*8) + 2;
#define                                 CRCSHIFT10_bit      BANKMASK(CRCSHIFTH), 2
extern volatile __bit                   CRCSHIFT11          @ (((unsigned) &CRCSHIFTH)*8) + 3;
#define                                 CRCSHIFT11_bit      BANKMASK(CRCSHIFTH), 3
extern volatile __bit                   CRCSHIFT12          @ (((unsigned) &CRCSHIFTH)*8) + 4;
#define                                 CRCSHIFT12_bit      BANKMASK(CRCSHIFTH), 4
extern volatile __bit                   CRCSHIFT13          @ (((unsigned) &CRCSHIFTH)*8) + 5;
#define                                 CRCSHIFT13_bit      BANKMASK(CRCSHIFTH), 5
extern volatile __bit                   CRCSHIFT14          @ (((unsigned) &CRCSHIFTH)*8) + 6;
#define                                 CRCSHIFT14_bit      BANKMASK(CRCSHIFTH), 6
extern volatile __bit                   CRCSHIFT15          @ (((unsigned) &CRCSHIFTH)*8) + 7;
#define                                 CRCSHIFT15_bit      BANKMASK(CRCSHIFTH), 7
extern volatile __bit                   CRCSHIFT2           @ (((unsigned) &CRCSHIFTL)*8) + 2;
#define                                 CRCSHIFT2_bit       BANKMASK(CRCSHIFTL), 2
extern volatile __bit                   CRCSHIFT3           @ (((unsigned) &CRCSHIFTL)*8) + 3;
#define                                 CRCSHIFT3_bit       BANKMASK(CRCSHIFTL), 3
extern volatile __bit                   CRCSHIFT4           @ (((unsigned) &CRCSHIFTL)*8) + 4;
#define                                 CRCSHIFT4_bit       BANKMASK(CRCSHIFTL), 4
extern volatile __bit                   CRCSHIFT5           @ (((unsigned) &CRCSHIFTL)*8) + 5;
#define                                 CRCSHIFT5_bit       BANKMASK(CRCSHIFTL), 5
extern volatile __bit                   CRCSHIFT6           @ (((unsigned) &CRCSHIFTL)*8) + 6;
#define                                 CRCSHIFT6_bit       BANKMASK(CRCSHIFTL), 6
extern volatile __bit                   CRCSHIFT7           @ (((unsigned) &CRCSHIFTL)*8) + 7;
#define                                 CRCSHIFT7_bit       BANKMASK(CRCSHIFTL), 7
extern volatile __bit                   CRCSHIFT8           @ (((unsigned) &CRCSHIFTH)*8) + 0;
#define                                 CRCSHIFT8_bit       BANKMASK(CRCSHIFTH), 0
extern volatile __bit                   CRCSHIFT9           @ (((unsigned) &CRCSHIFTH)*8) + 1;
#define                                 CRCSHIFT9_bit       BANKMASK(CRCSHIFTH), 1
extern volatile __bit                   CRCSHIFTM           @ (((unsigned) &CRCCON0)*8) + 1;
#define                                 CRCSHIFTM_bit       BANKMASK(CRCCON0), 1
extern volatile __bit                   CRCXOR1             @ (((unsigned) &CRCXORL)*8) + 1;
#define                                 CRCXOR1_bit         BANKMASK(CRCXORL), 1
extern volatile __bit                   CRCXOR10            @ (((unsigned) &CRCXORH)*8) + 2;
#define                                 CRCXOR10_bit        BANKMASK(CRCXORH), 2
extern volatile __bit                   CRCXOR11            @ (((unsigned) &CRCXORH)*8) + 3;
#define                                 CRCXOR11_bit        BANKMASK(CRCXORH), 3
extern volatile __bit                   CRCXOR12            @ (((unsigned) &CRCXORH)*8) + 4;
#define                                 CRCXOR12_bit        BANKMASK(CRCXORH), 4
extern volatile __bit                   CRCXOR13            @ (((unsigned) &CRCXORH)*8) + 5;
#define                                 CRCXOR13_bit        BANKMASK(CRCXORH), 5
extern volatile __bit                   CRCXOR14            @ (((unsigned) &CRCXORH)*8) + 6;
#define                                 CRCXOR14_bit        BANKMASK(CRCXORH), 6
extern volatile __bit                   CRCXOR15            @ (((unsigned) &CRCXORH)*8) + 7;
#define                                 CRCXOR15_bit        BANKMASK(CRCXORH), 7
extern volatile __bit                   CRCXOR2             @ (((unsigned) &CRCXORL)*8) + 2;
#define                                 CRCXOR2_bit         BANKMASK(CRCXORL), 2
extern volatile __bit                   CRCXOR3             @ (((unsigned) &CRCXORL)*8) + 3;
#define                                 CRCXOR3_bit         BANKMASK(CRCXORL), 3
extern volatile __bit                   CRCXOR4             @ (((unsigned) &CRCXORL)*8) + 4;
#define                                 CRCXOR4_bit         BANKMASK(CRCXORL), 4
extern volatile __bit                   CRCXOR5             @ (((unsigned) &CRCXORL)*8) + 5;
#define                                 CRCXOR5_bit         BANKMASK(CRCXORL), 5
extern volatile __bit                   CRCXOR6             @ (((unsigned) &CRCXORL)*8) + 6;
#define                                 CRCXOR6_bit         BANKMASK(CRCXORL), 6
extern volatile __bit                   CRCXOR7             @ (((unsigned) &CRCXORL)*8) + 7;
#define                                 CRCXOR7_bit         BANKMASK(CRCXORL), 7
extern volatile __bit                   CRCXOR8             @ (((unsigned) &CRCXORH)*8) + 0;
#define                                 CRCXOR8_bit         BANKMASK(CRCXORH), 0
extern volatile __bit                   CRCXOR9             @ (((unsigned) &CRCXORH)*8) + 1;
#define                                 CRCXOR9_bit         BANKMASK(CRCXORH), 1
extern volatile __bit                   CRDCDAT7            @ (((unsigned) &CRCDATL)*8) + 7;
#define                                 CRDCDAT7_bit        BANKMASK(CRCDATL), 7
extern volatile __bit                   CREN                @ (((unsigned) &RC1STA)*8) + 4;
#define                                 CREN_bit            BANKMASK(RC1STA), 4
extern volatile __bit                   CSRC                @ (((unsigned) &TX1STA)*8) + 7;
#define                                 CSRC_bit            BANKMASK(TX1STA), 7
extern volatile __bit                   CWG1C1AS            @ (((unsigned) &CWG1AS1)*8) + 1;
#define                                 CWG1C1AS_bit        BANKMASK(CWG1AS1), 1
extern volatile __bit                   CWG1C2AS            @ (((unsigned) &CWG1AS1)*8) + 2;
#define                                 CWG1C2AS_bit        BANKMASK(CWG1AS1), 2
extern volatile __bit                   CWG1CS              @ (((unsigned) &CWG1CLKCON)*8) + 0;
#define                                 CWG1CS_bit          BANKMASK(CWG1CLKCON), 0
extern volatile __bit                   CWG1DBF0            @ (((unsigned) &CWG1DBF)*8) + 0;
#define                                 CWG1DBF0_bit        BANKMASK(CWG1DBF), 0
extern volatile __bit                   CWG1DBF1            @ (((unsigned) &CWG1DBF)*8) + 1;
#define                                 CWG1DBF1_bit        BANKMASK(CWG1DBF), 1
extern volatile __bit                   CWG1DBF2            @ (((unsigned) &CWG1DBF)*8) + 2;
#define                                 CWG1DBF2_bit        BANKMASK(CWG1DBF), 2
extern volatile __bit                   CWG1DBF3            @ (((unsigned) &CWG1DBF)*8) + 3;
#define                                 CWG1DBF3_bit        BANKMASK(CWG1DBF), 3
extern volatile __bit                   CWG1DBF4            @ (((unsigned) &CWG1DBF)*8) + 4;
#define                                 CWG1DBF4_bit        BANKMASK(CWG1DBF), 4
extern volatile __bit                   CWG1DBF5            @ (((unsigned) &CWG1DBF)*8) + 5;
#define                                 CWG1DBF5_bit        BANKMASK(CWG1DBF), 5
extern volatile __bit                   CWG1DBR0            @ (((unsigned) &CWG1DBR)*8) + 0;
#define                                 CWG1DBR0_bit        BANKMASK(CWG1DBR), 0
extern volatile __bit                   CWG1DBR1            @ (((unsigned) &CWG1DBR)*8) + 1;
#define                                 CWG1DBR1_bit        BANKMASK(CWG1DBR), 1
extern volatile __bit                   CWG1DBR2            @ (((unsigned) &CWG1DBR)*8) + 2;
#define                                 CWG1DBR2_bit        BANKMASK(CWG1DBR), 2
extern volatile __bit                   CWG1DBR3            @ (((unsigned) &CWG1DBR)*8) + 3;
#define                                 CWG1DBR3_bit        BANKMASK(CWG1DBR), 3
extern volatile __bit                   CWG1DBR4            @ (((unsigned) &CWG1DBR)*8) + 4;
#define                                 CWG1DBR4_bit        BANKMASK(CWG1DBR), 4
extern volatile __bit                   CWG1DBR5            @ (((unsigned) &CWG1DBR)*8) + 5;
#define                                 CWG1DBR5_bit        BANKMASK(CWG1DBR), 5
extern volatile __bit                   CWG1EN              @ (((unsigned) &CWG1CON0)*8) + 7;
#define                                 CWG1EN_bit          BANKMASK(CWG1CON0), 7
extern volatile __bit                   CWG1IN              @ (((unsigned) &CWG1CON1)*8) + 5;
#define                                 CWG1IN_bit          BANKMASK(CWG1CON1), 5
extern volatile __bit                   CWG1INAS            @ (((unsigned) &CWG1AS1)*8) + 0;
#define                                 CWG1INAS_bit        BANKMASK(CWG1AS1), 0
extern volatile __bit                   CWG1IS0             @ (((unsigned) &CWG1ISM)*8) + 0;
#define                                 CWG1IS0_bit         BANKMASK(CWG1ISM), 0
extern volatile __bit                   CWG1IS1             @ (((unsigned) &CWG1ISM)*8) + 1;
#define                                 CWG1IS1_bit         BANKMASK(CWG1ISM), 1
extern volatile __bit                   CWG1IS2             @ (((unsigned) &CWG1ISM)*8) + 2;
#define                                 CWG1IS2_bit         BANKMASK(CWG1ISM), 2
extern volatile __bit                   CWG1IS3             @ (((unsigned) &CWG1ISM)*8) + 3;
#define                                 CWG1IS3_bit         BANKMASK(CWG1ISM), 3
extern volatile __bit                   CWG1LD              @ (((unsigned) &CWG1CON0)*8) + 6;
#define                                 CWG1LD_bit          BANKMASK(CWG1CON0), 6
extern volatile __bit                   CWG1LSAC0           @ (((unsigned) &CWG1AS0)*8) + 2;
#define                                 CWG1LSAC0_bit       BANKMASK(CWG1AS0), 2
extern volatile __bit                   CWG1LSAC1           @ (((unsigned) &CWG1AS0)*8) + 3;
#define                                 CWG1LSAC1_bit       BANKMASK(CWG1AS0), 3
extern volatile __bit                   CWG1LSBD0           @ (((unsigned) &CWG1AS0)*8) + 4;
#define                                 CWG1LSBD0_bit       BANKMASK(CWG1AS0), 4
extern volatile __bit                   CWG1LSBD1           @ (((unsigned) &CWG1AS0)*8) + 5;
#define                                 CWG1LSBD1_bit       BANKMASK(CWG1AS0), 5
extern volatile __bit                   CWG1MODE0           @ (((unsigned) &CWG1CON0)*8) + 0;
#define                                 CWG1MODE0_bit       BANKMASK(CWG1CON0), 0
extern volatile __bit                   CWG1MODE1           @ (((unsigned) &CWG1CON0)*8) + 1;
#define                                 CWG1MODE1_bit       BANKMASK(CWG1CON0), 1
extern volatile __bit                   CWG1MODE2           @ (((unsigned) &CWG1CON0)*8) + 2;
#define                                 CWG1MODE2_bit       BANKMASK(CWG1CON0), 2
extern volatile __bit                   CWG1OVRA            @ (((unsigned) &CWG1OCON0)*8) + 4;
#define                                 CWG1OVRA_bit        BANKMASK(CWG1OCON0), 4
extern volatile __bit                   CWG1OVRB            @ (((unsigned) &CWG1OCON0)*8) + 5;
#define                                 CWG1OVRB_bit        BANKMASK(CWG1OCON0), 5
extern volatile __bit                   CWG1OVRC            @ (((unsigned) &CWG1OCON0)*8) + 6;
#define                                 CWG1OVRC_bit        BANKMASK(CWG1OCON0), 6
extern volatile __bit                   CWG1OVRD            @ (((unsigned) &CWG1OCON0)*8) + 7;
#define                                 CWG1OVRD_bit        BANKMASK(CWG1OCON0), 7
extern volatile __bit                   CWG1POLA            @ (((unsigned) &CWG1CON1)*8) + 0;
#define                                 CWG1POLA_bit        BANKMASK(CWG1CON1), 0
extern volatile __bit                   CWG1POLB            @ (((unsigned) &CWG1CON1)*8) + 1;
#define                                 CWG1POLB_bit        BANKMASK(CWG1CON1), 1
extern volatile __bit                   CWG1POLC            @ (((unsigned) &CWG1CON1)*8) + 2;
#define                                 CWG1POLC_bit        BANKMASK(CWG1CON1), 2
extern volatile __bit                   CWG1POLD            @ (((unsigned) &CWG1CON1)*8) + 3;
#define                                 CWG1POLD_bit        BANKMASK(CWG1CON1), 3
extern volatile __bit                   CWG1REN             @ (((unsigned) &CWG1AS0)*8) + 6;
#define                                 CWG1REN_bit         BANKMASK(CWG1AS0), 6
extern volatile __bit                   CWG1SHUTDOWN        @ (((unsigned) &CWG1AS0)*8) + 7;
#define                                 CWG1SHUTDOWN_bit    BANKMASK(CWG1AS0), 7
extern volatile __bit                   CWG1STRA            @ (((unsigned) &CWG1OCON0)*8) + 0;
#define                                 CWG1STRA_bit        BANKMASK(CWG1OCON0), 0
extern volatile __bit                   CWG1STRB            @ (((unsigned) &CWG1OCON0)*8) + 1;
#define                                 CWG1STRB_bit        BANKMASK(CWG1OCON0), 1
extern volatile __bit                   CWG1STRC            @ (((unsigned) &CWG1OCON0)*8) + 2;
#define                                 CWG1STRC_bit        BANKMASK(CWG1OCON0), 2
extern volatile __bit                   CWG1STRD            @ (((unsigned) &CWG1OCON0)*8) + 3;
#define                                 CWG1STRD_bit        BANKMASK(CWG1OCON0), 3
extern volatile __bit                   CWG1TMR2AS          @ (((unsigned) &CWG1AS1)*8) + 4;
#define                                 CWG1TMR2AS_bit      BANKMASK(CWG1AS1), 4
extern volatile __bit                   CWG1TMR4AS          @ (((unsigned) &CWG1AS1)*8) + 5;
#define                                 CWG1TMR4AS_bit      BANKMASK(CWG1AS1), 5
extern volatile __bit                   CWG1TMR6AS          @ (((unsigned) &CWG1AS1)*8) + 6;
#define                                 CWG1TMR6AS_bit      BANKMASK(CWG1AS1), 6
extern volatile __bit                   CWGIE               @ (((unsigned) &PIE3)*8) + 5;
#define                                 CWGIE_bit           BANKMASK(PIE3), 5
extern volatile __bit                   CWGIF               @ (((unsigned) &PIR3)*8) + 5;
#define                                 CWGIF_bit           BANKMASK(PIR3), 5
extern volatile __bit                   CWGINPPS0           @ (((unsigned) &CWGINPPS)*8) + 0;
#define                                 CWGINPPS0_bit       BANKMASK(CWGINPPS), 0
extern volatile __bit                   CWGINPPS1           @ (((unsigned) &CWGINPPS)*8) + 1;
#define                                 CWGINPPS1_bit       BANKMASK(CWGINPPS), 1
extern volatile __bit                   CWGINPPS2           @ (((unsigned) &CWGINPPS)*8) + 2;
#define                                 CWGINPPS2_bit       BANKMASK(CWGINPPS), 2
extern volatile __bit                   CWGINPPS3           @ (((unsigned) &CWGINPPS)*8) + 3;
#define                                 CWGINPPS3_bit       BANKMASK(CWGINPPS), 3
extern volatile __bit                   CWGINPPS4           @ (((unsigned) &CWGINPPS)*8) + 4;
#define                                 CWGINPPS4_bit       BANKMASK(CWGINPPS), 4
extern volatile __bit                   C_SHAD              @ (((unsigned) &STATUS_SHAD)*8) + 0;
#define                                 C_SHAD_bit          BANKMASK(STATUS_SHAD), 0
extern volatile __bit                   D1PSS0              @ (((unsigned) &DAC1CON0)*8) + 2;
#define                                 D1PSS0_bit          BANKMASK(DAC1CON0), 2
extern volatile __bit                   D1PSS1              @ (((unsigned) &DAC1CON0)*8) + 3;
#define                                 D1PSS1_bit          BANKMASK(DAC1CON0), 3
extern volatile __bit                   DAC1EN              @ (((unsigned) &DAC1CON0)*8) + 7;
#define                                 DAC1EN_bit          BANKMASK(DAC1CON0), 7
extern volatile __bit                   DAC1OE              @ (((unsigned) &DAC1CON0)*8) + 5;
#define                                 DAC1OE_bit          BANKMASK(DAC1CON0), 5
extern volatile __bit                   DAC1R0              @ (((unsigned) &DAC1CON1)*8) + 0;
#define                                 DAC1R0_bit          BANKMASK(DAC1CON1), 0
extern volatile __bit                   DAC1R1              @ (((unsigned) &DAC1CON1)*8) + 1;
#define                                 DAC1R1_bit          BANKMASK(DAC1CON1), 1
extern volatile __bit                   DAC1R2              @ (((unsigned) &DAC1CON1)*8) + 2;
#define                                 DAC1R2_bit          BANKMASK(DAC1CON1), 2
extern volatile __bit                   DAC1R3              @ (((unsigned) &DAC1CON1)*8) + 3;
#define                                 DAC1R3_bit          BANKMASK(DAC1CON1), 3
extern volatile __bit                   DAC1R4              @ (((unsigned) &DAC1CON1)*8) + 4;
#define                                 DAC1R4_bit          BANKMASK(DAC1CON1), 4
extern volatile __bit                   DAC1R5              @ (((unsigned) &DAC1CON1)*8) + 5;
#define                                 DAC1R5_bit          BANKMASK(DAC1CON1), 5
extern volatile __bit                   DAC1R6              @ (((unsigned) &DAC1CON1)*8) + 6;
#define                                 DAC1R6_bit          BANKMASK(DAC1CON1), 6
extern volatile __bit                   DAC1R7              @ (((unsigned) &DAC1CON1)*8) + 7;
#define                                 DAC1R7_bit          BANKMASK(DAC1CON1), 7
extern volatile __bit                   DAT0                @ (((unsigned) &CRCDATL)*8) + 0;
#define                                 DAT0_bit            BANKMASK(CRCDATL), 0
extern volatile __bit                   DAT1                @ (((unsigned) &CRCDATL)*8) + 1;
#define                                 DAT1_bit            BANKMASK(CRCDATL), 1
extern volatile __bit                   DAT10               @ (((unsigned) &CRCDATH)*8) + 2;
#define                                 DAT10_bit           BANKMASK(CRCDATH), 2
extern volatile __bit                   DAT11               @ (((unsigned) &CRCDATH)*8) + 3;
#define                                 DAT11_bit           BANKMASK(CRCDATH), 3
extern volatile __bit                   DAT12               @ (((unsigned) &CRCDATH)*8) + 4;
#define                                 DAT12_bit           BANKMASK(CRCDATH), 4
extern volatile __bit                   DAT13               @ (((unsigned) &CRCDATH)*8) + 5;
#define                                 DAT13_bit           BANKMASK(CRCDATH), 5
extern volatile __bit                   DAT14               @ (((unsigned) &CRCDATH)*8) + 6;
#define                                 DAT14_bit           BANKMASK(CRCDATH), 6
extern volatile __bit                   DAT15               @ (((unsigned) &CRCDATH)*8) + 7;
#define                                 DAT15_bit           BANKMASK(CRCDATH), 7
extern volatile __bit                   DAT2                @ (((unsigned) &CRCDATL)*8) + 2;
#define                                 DAT2_bit            BANKMASK(CRCDATL), 2
extern volatile __bit                   DAT3                @ (((unsigned) &CRCDATL)*8) + 3;
#define                                 DAT3_bit            BANKMASK(CRCDATL), 3
extern volatile __bit                   DAT4                @ (((unsigned) &CRCDATL)*8) + 4;
#define                                 DAT4_bit            BANKMASK(CRCDATL), 4
extern volatile __bit                   DAT5                @ (((unsigned) &CRCDATL)*8) + 5;
#define                                 DAT5_bit            BANKMASK(CRCDATL), 5
extern volatile __bit                   DAT6                @ (((unsigned) &CRCDATL)*8) + 6;
#define                                 DAT6_bit            BANKMASK(CRCDATL), 6
extern volatile __bit                   DAT7                @ (((unsigned) &CRCDATL)*8) + 7;
#define                                 DAT7_bit            BANKMASK(CRCDATL), 7
extern volatile __bit                   DAT8                @ (((unsigned) &CRCDATH)*8) + 0;
#define                                 DAT8_bit            BANKMASK(CRCDATH), 0
extern volatile __bit                   DAT9                @ (((unsigned) &CRCDATH)*8) + 1;
#define                                 DAT9_bit            BANKMASK(CRCDATH), 1
extern volatile __bit                   DBF0                @ (((unsigned) &CWG1DBF)*8) + 0;
#define                                 DBF0_bit            BANKMASK(CWG1DBF), 0
extern volatile __bit                   DBF1                @ (((unsigned) &CWG1DBF)*8) + 1;
#define                                 DBF1_bit            BANKMASK(CWG1DBF), 1
extern volatile __bit                   DBF2                @ (((unsigned) &CWG1DBF)*8) + 2;
#define                                 DBF2_bit            BANKMASK(CWG1DBF), 2
extern volatile __bit                   DBF3                @ (((unsigned) &CWG1DBF)*8) + 3;
#define                                 DBF3_bit            BANKMASK(CWG1DBF), 3
extern volatile __bit                   DBF4                @ (((unsigned) &CWG1DBF)*8) + 4;
#define                                 DBF4_bit            BANKMASK(CWG1DBF), 4
extern volatile __bit                   DBF5                @ (((unsigned) &CWG1DBF)*8) + 5;
#define                                 DBF5_bit            BANKMASK(CWG1DBF), 5
extern volatile __bit                   DBR0                @ (((unsigned) &CWG1DBR)*8) + 0;
#define                                 DBR0_bit            BANKMASK(CWG1DBR), 0
extern volatile __bit                   DBR1                @ (((unsigned) &CWG1DBR)*8) + 1;
#define                                 DBR1_bit            BANKMASK(CWG1DBR), 1
extern volatile __bit                   DBR2                @ (((unsigned) &CWG1DBR)*8) + 2;
#define                                 DBR2_bit            BANKMASK(CWG1DBR), 2
extern volatile __bit                   DBR3                @ (((unsigned) &CWG1DBR)*8) + 3;
#define                                 DBR3_bit            BANKMASK(CWG1DBR), 3
extern volatile __bit                   DBR4                @ (((unsigned) &CWG1DBR)*8) + 4;
#define                                 DBR4_bit            BANKMASK(CWG1DBR), 4
extern volatile __bit                   DBR5                @ (((unsigned) &CWG1DBR)*8) + 5;
#define                                 DBR5_bit            BANKMASK(CWG1DBR), 5
extern volatile __bit                   DC                  @ (((unsigned) &STATUS)*8) + 1;
#define                                 DC_bit              BANKMASK(STATUS), 1
extern volatile __bit                   DC_SHAD             @ (((unsigned) &STATUS_SHAD)*8) + 1;
#define                                 DC_SHAD_bit         BANKMASK(STATUS_SHAD), 1
extern volatile __bit                   DHEN                @ (((unsigned) &SSP1CON3)*8) + 0;
#define                                 DHEN_bit            BANKMASK(SSP1CON3), 0
extern volatile __bit                   DLEN0               @ (((unsigned) &CRCCON1)*8) + 4;
#define                                 DLEN0_bit           BANKMASK(CRCCON1), 4
extern volatile __bit                   DLEN1               @ (((unsigned) &CRCCON1)*8) + 5;
#define                                 DLEN1_bit           BANKMASK(CRCCON1), 5
extern volatile __bit                   DLEN2               @ (((unsigned) &CRCCON1)*8) + 6;
#define                                 DLEN2_bit           BANKMASK(CRCCON1), 6
extern volatile __bit                   DLEN3               @ (((unsigned) &CRCCON1)*8) + 7;
#define                                 DLEN3_bit           BANKMASK(CRCCON1), 7
extern volatile __bit                   D_nA                @ (((unsigned) &SSP1STAT)*8) + 5;
#define                                 D_nA_bit            BANKMASK(SSP1STAT), 5
extern volatile __bit                   ERR0                @ (((unsigned) &AT1ERRL)*8) + 0;
#define                                 ERR0_bit            BANKMASK(AT1ERRL), 0
extern volatile __bit                   ERR1                @ (((unsigned) &AT1ERRL)*8) + 1;
#define                                 ERR1_bit            BANKMASK(AT1ERRL), 1
extern volatile __bit                   ERR10               @ (((unsigned) &AT1ERRH)*8) + 2;
#define                                 ERR10_bit           BANKMASK(AT1ERRH), 2
extern volatile __bit                   ERR11               @ (((unsigned) &AT1ERRH)*8) + 3;
#define                                 ERR11_bit           BANKMASK(AT1ERRH), 3
extern volatile __bit                   ERR12               @ (((unsigned) &AT1ERRH)*8) + 4;
#define                                 ERR12_bit           BANKMASK(AT1ERRH), 4
extern volatile __bit                   ERR13               @ (((unsigned) &AT1ERRH)*8) + 5;
#define                                 ERR13_bit           BANKMASK(AT1ERRH), 5
extern volatile __bit                   ERR14               @ (((unsigned) &AT1ERRH)*8) + 6;
#define                                 ERR14_bit           BANKMASK(AT1ERRH), 6
extern volatile __bit                   ERR15               @ (((unsigned) &AT1ERRH)*8) + 7;
#define                                 ERR15_bit           BANKMASK(AT1ERRH), 7
extern volatile __bit                   ERR2                @ (((unsigned) &AT1ERRL)*8) + 2;
#define                                 ERR2_bit            BANKMASK(AT1ERRL), 2
extern volatile __bit                   ERR3                @ (((unsigned) &AT1ERRL)*8) + 3;
#define                                 ERR3_bit            BANKMASK(AT1ERRL), 3
extern volatile __bit                   ERR4                @ (((unsigned) &AT1ERRL)*8) + 4;
#define                                 ERR4_bit            BANKMASK(AT1ERRL), 4
extern volatile __bit                   ERR5                @ (((unsigned) &AT1ERRL)*8) + 5;
#define                                 ERR5_bit            BANKMASK(AT1ERRL), 5
extern volatile __bit                   ERR6                @ (((unsigned) &AT1ERRL)*8) + 6;
#define                                 ERR6_bit            BANKMASK(AT1ERRL), 6
extern volatile __bit                   ERR7                @ (((unsigned) &AT1ERRL)*8) + 7;
#define                                 ERR7_bit            BANKMASK(AT1ERRL), 7
extern volatile __bit                   ERR8                @ (((unsigned) &AT1ERRH)*8) + 0;
#define                                 ERR8_bit            BANKMASK(AT1ERRH), 0
extern volatile __bit                   ERR9                @ (((unsigned) &AT1ERRH)*8) + 1;
#define                                 ERR9_bit            BANKMASK(AT1ERRH), 1
extern volatile __bit                   ERRH0               @ (((unsigned) &AT1ERRH)*8) + 0;
#define                                 ERRH0_bit           BANKMASK(AT1ERRH), 0
extern volatile __bit                   ERRH1               @ (((unsigned) &AT1ERRH)*8) + 1;
#define                                 ERRH1_bit           BANKMASK(AT1ERRH), 1
extern volatile __bit                   ERRH2               @ (((unsigned) &AT1ERRH)*8) + 2;
#define                                 ERRH2_bit           BANKMASK(AT1ERRH), 2
extern volatile __bit                   ERRH3               @ (((unsigned) &AT1ERRH)*8) + 3;
#define                                 ERRH3_bit           BANKMASK(AT1ERRH), 3
extern volatile __bit                   ERRH4               @ (((unsigned) &AT1ERRH)*8) + 4;
#define                                 ERRH4_bit           BANKMASK(AT1ERRH), 4
extern volatile __bit                   ERRH5               @ (((unsigned) &AT1ERRH)*8) + 5;
#define                                 ERRH5_bit           BANKMASK(AT1ERRH), 5
extern volatile __bit                   ERRH6               @ (((unsigned) &AT1ERRH)*8) + 6;
#define                                 ERRH6_bit           BANKMASK(AT1ERRH), 6
extern volatile __bit                   ERRH7               @ (((unsigned) &AT1ERRH)*8) + 7;
#define                                 ERRH7_bit           BANKMASK(AT1ERRH), 7
extern volatile __bit                   ERRL0               @ (((unsigned) &AT1ERRL)*8) + 0;
#define                                 ERRL0_bit           BANKMASK(AT1ERRL), 0
extern volatile __bit                   ERRL1               @ (((unsigned) &AT1ERRL)*8) + 1;
#define                                 ERRL1_bit           BANKMASK(AT1ERRL), 1
extern volatile __bit                   ERRL2               @ (((unsigned) &AT1ERRL)*8) + 2;
#define                                 ERRL2_bit           BANKMASK(AT1ERRL), 2
extern volatile __bit                   ERRL3               @ (((unsigned) &AT1ERRL)*8) + 3;
#define                                 ERRL3_bit           BANKMASK(AT1ERRL), 3
extern volatile __bit                   ERRL4               @ (((unsigned) &AT1ERRL)*8) + 4;
#define                                 ERRL4_bit           BANKMASK(AT1ERRL), 4
extern volatile __bit                   ERRL5               @ (((unsigned) &AT1ERRL)*8) + 5;
#define                                 ERRL5_bit           BANKMASK(AT1ERRL), 5
extern volatile __bit                   ERRL6               @ (((unsigned) &AT1ERRL)*8) + 6;
#define                                 ERRL6_bit           BANKMASK(AT1ERRL), 6
extern volatile __bit                   ERRL7               @ (((unsigned) &AT1ERRL)*8) + 7;
#define                                 ERRL7_bit           BANKMASK(AT1ERRL), 7
extern volatile __bit                   FERR                @ (((unsigned) &RC1STA)*8) + 2;
#define                                 FERR_bit            BANKMASK(RC1STA), 2
extern volatile __bit                   FREE                @ (((unsigned) &PMCON1)*8) + 4;
#define                                 FREE_bit            BANKMASK(PMCON1), 4
extern volatile __bit                   FULL                @ (((unsigned) &CRCCON0)*8) + 0;
#define                                 FULL_bit            BANKMASK(CRCCON0), 0
extern volatile __bit                   FVREN               @ (((unsigned) &FVRCON)*8) + 7;
#define                                 FVREN_bit           BANKMASK(FVRCON), 7
extern volatile __bit                   FVRRDY              @ (((unsigned) &FVRCON)*8) + 6;
#define                                 FVRRDY_bit          BANKMASK(FVRCON), 6
extern volatile __bit                   G1EN                @ (((unsigned) &CWG1CON0)*8) + 7;
#define                                 G1EN_bit            BANKMASK(CWG1CON0), 7
extern volatile __bit                   GCEN                @ (((unsigned) &SSP1CON2)*8) + 7;
#define                                 GCEN_bit            BANKMASK(SSP1CON2), 7
extern volatile __bit                   GIE                 @ (((unsigned) &INTCON)*8) + 7;
#define                                 GIE_bit             BANKMASK(INTCON), 7
extern volatile __bit                   GO                  @ (((unsigned) &ADCON0)*8) + 1;
#define                                 GO_bit              BANKMASK(ADCON0), 1
extern volatile __bit                   GO_nDONE            @ (((unsigned) &ADCON0)*8) + 1;
#define                                 GO_nDONE_bit        BANKMASK(ADCON0), 1
extern volatile __bit                   HADR0               @ (((unsigned) &SCANHADRL)*8) + 0;
#define                                 HADR0_bit           BANKMASK(SCANHADRL), 0
extern volatile __bit                   HADR1               @ (((unsigned) &SCANHADRL)*8) + 1;
#define                                 HADR1_bit           BANKMASK(SCANHADRL), 1
extern volatile __bit                   HADR10              @ (((unsigned) &SCANHADRH)*8) + 2;
#define                                 HADR10_bit          BANKMASK(SCANHADRH), 2
extern volatile __bit                   HADR11              @ (((unsigned) &SCANHADRH)*8) + 3;
#define                                 HADR11_bit          BANKMASK(SCANHADRH), 3
extern volatile __bit                   HADR12              @ (((unsigned) &SCANHADRH)*8) + 4;
#define                                 HADR12_bit          BANKMASK(SCANHADRH), 4
extern volatile __bit                   HADR13              @ (((unsigned) &SCANHADRH)*8) + 5;
#define                                 HADR13_bit          BANKMASK(SCANHADRH), 5
extern volatile __bit                   HADR14              @ (((unsigned) &SCANHADRH)*8) + 6;
#define                                 HADR14_bit          BANKMASK(SCANHADRH), 6
extern volatile __bit                   HADR15              @ (((unsigned) &SCANHADRH)*8) + 7;
#define                                 HADR15_bit          BANKMASK(SCANHADRH), 7
extern volatile __bit                   HADR3               @ (((unsigned) &SCANHADRL)*8) + 3;
#define                                 HADR3_bit           BANKMASK(SCANHADRL), 3
extern volatile __bit                   HADR4               @ (((unsigned) &SCANHADRL)*8) + 4;
#define                                 HADR4_bit           BANKMASK(SCANHADRL), 4
extern volatile __bit                   HADR5               @ (((unsigned) &SCANHADRL)*8) + 5;
#define                                 HADR5_bit           BANKMASK(SCANHADRL), 5
extern volatile __bit                   HADR6               @ (((unsigned) &SCANHADRL)*8) + 6;
#define                                 HADR6_bit           BANKMASK(SCANHADRL), 6
extern volatile __bit                   HADR7               @ (((unsigned) &SCANHADRL)*8) + 7;
#define                                 HADR7_bit           BANKMASK(SCANHADRL), 7
extern volatile __bit                   HADR8               @ (((unsigned) &SCANHADRH)*8) + 0;
#define                                 HADR8_bit           BANKMASK(SCANHADRH), 0
extern volatile __bit                   HADR9               @ (((unsigned) &SCANHADRH)*8) + 1;
#define                                 HADR9_bit           BANKMASK(SCANHADRH), 1
extern volatile __bit                   HARD2               @ (((unsigned) &SCANHADRL)*8) + 2;
#define                                 HARD2_bit           BANKMASK(SCANHADRL), 2
extern volatile __bit                   HFIOFL              @ (((unsigned) &OSCSTAT)*8) + 3;
#define                                 HFIOFL_bit          BANKMASK(OSCSTAT), 3
extern volatile __bit                   HFIOFR              @ (((unsigned) &OSCSTAT)*8) + 4;
#define                                 HFIOFR_bit          BANKMASK(OSCSTAT), 4
extern volatile __bit                   HFIOFS              @ (((unsigned) &OSCSTAT)*8) + 0;
#define                                 HFIOFS_bit          BANKMASK(OSCSTAT), 0
extern volatile __bit                   HIDC4               @ (((unsigned) &HIDRVC)*8) + 4;
#define                                 HIDC4_bit           BANKMASK(HIDRVC), 4
extern volatile __bit                   HIDC5               @ (((unsigned) &HIDRVC)*8) + 5;
#define                                 HIDC5_bit           BANKMASK(HIDRVC), 5
extern volatile __bit                   IN                  @ (((unsigned) &CWG1CON1)*8) + 5;
#define                                 IN_bit              BANKMASK(CWG1CON1), 5
extern volatile __bit                   IN0                 @ (((unsigned) &PID1INL)*8) + 0;
#define                                 IN0_bit             BANKMASK(PID1INL), 0
extern volatile __bit                   IN1                 @ (((unsigned) &PID1INL)*8) + 1;
#define                                 IN1_bit             BANKMASK(PID1INL), 1
extern volatile __bit                   IN10                @ (((unsigned) &PID1INH)*8) + 2;
#define                                 IN10_bit            BANKMASK(PID1INH), 2
extern volatile __bit                   IN11                @ (((unsigned) &PID1INH)*8) + 3;
#define                                 IN11_bit            BANKMASK(PID1INH), 3
extern volatile __bit                   IN12                @ (((unsigned) &PID1INH)*8) + 4;
#define                                 IN12_bit            BANKMASK(PID1INH), 4
extern volatile __bit                   IN13                @ (((unsigned) &PID1INH)*8) + 5;
#define                                 IN13_bit            BANKMASK(PID1INH), 5
extern volatile __bit                   IN14                @ (((unsigned) &PID1INH)*8) + 6;
#define                                 IN14_bit            BANKMASK(PID1INH), 6
extern volatile __bit                   IN15                @ (((unsigned) &PID1INH)*8) + 7;
#define                                 IN15_bit            BANKMASK(PID1INH), 7
extern volatile __bit                   IN2                 @ (((unsigned) &PID1INL)*8) + 2;
#define                                 IN2_bit             BANKMASK(PID1INL), 2
extern volatile __bit                   IN3                 @ (((unsigned) &PID1INL)*8) + 3;
#define                                 IN3_bit             BANKMASK(PID1INL), 3
extern volatile __bit                   IN4                 @ (((unsigned) &PID1INL)*8) + 4;
#define                                 IN4_bit             BANKMASK(PID1INL), 4
extern volatile __bit                   IN5                 @ (((unsigned) &PID1INL)*8) + 5;
#define                                 IN5_bit             BANKMASK(PID1INL), 5
extern volatile __bit                   IN6                 @ (((unsigned) &PID1INL)*8) + 6;
#define                                 IN6_bit             BANKMASK(PID1INL), 6
extern volatile __bit                   IN7                 @ (((unsigned) &PID1INL)*8) + 7;
#define                                 IN7_bit             BANKMASK(PID1INL), 7
extern volatile __bit                   IN8                 @ (((unsigned) &PID1INH)*8) + 0;
#define                                 IN8_bit             BANKMASK(PID1INH), 0
extern volatile __bit                   IN9                 @ (((unsigned) &PID1INH)*8) + 1;
#define                                 IN9_bit             BANKMASK(PID1INH), 1
extern volatile __bit                   INAS                @ (((unsigned) &CWG1AS1)*8) + 0;
#define                                 INAS_bit            BANKMASK(CWG1AS1), 0
extern volatile __bit                   INLVLA0             @ (((unsigned) &INLVLA)*8) + 0;
#define                                 INLVLA0_bit         BANKMASK(INLVLA), 0
extern volatile __bit                   INLVLA1             @ (((unsigned) &INLVLA)*8) + 1;
#define                                 INLVLA1_bit         BANKMASK(INLVLA), 1
extern volatile __bit                   INLVLA2             @ (((unsigned) &INLVLA)*8) + 2;
#define                                 INLVLA2_bit         BANKMASK(INLVLA), 2
extern volatile __bit                   INLVLA3             @ (((unsigned) &INLVLA)*8) + 3;
#define                                 INLVLA3_bit         BANKMASK(INLVLA), 3
extern volatile __bit                   INLVLA4             @ (((unsigned) &INLVLA)*8) + 4;
#define                                 INLVLA4_bit         BANKMASK(INLVLA), 4
extern volatile __bit                   INLVLA5             @ (((unsigned) &INLVLA)*8) + 5;
#define                                 INLVLA5_bit         BANKMASK(INLVLA), 5
extern volatile __bit                   INLVLB4             @ (((unsigned) &INLVLB)*8) + 4;
#define                                 INLVLB4_bit         BANKMASK(INLVLB), 4
extern volatile __bit                   INLVLB5             @ (((unsigned) &INLVLB)*8) + 5;
#define                                 INLVLB5_bit         BANKMASK(INLVLB), 5
extern volatile __bit                   INLVLB6             @ (((unsigned) &INLVLB)*8) + 6;
#define                                 INLVLB6_bit         BANKMASK(INLVLB), 6
extern volatile __bit                   INLVLB7             @ (((unsigned) &INLVLB)*8) + 7;
#define                                 INLVLB7_bit         BANKMASK(INLVLB), 7
extern volatile __bit                   INLVLC0             @ (((unsigned) &INLVLC)*8) + 0;
#define                                 INLVLC0_bit         BANKMASK(INLVLC), 0
extern volatile __bit                   INLVLC1             @ (((unsigned) &INLVLC)*8) + 1;
#define                                 INLVLC1_bit         BANKMASK(INLVLC), 1
extern volatile __bit                   INLVLC2             @ (((unsigned) &INLVLC)*8) + 2;
#define                                 INLVLC2_bit         BANKMASK(INLVLC), 2
extern volatile __bit                   INLVLC3             @ (((unsigned) &INLVLC)*8) + 3;
#define                                 INLVLC3_bit         BANKMASK(INLVLC), 3
extern volatile __bit                   INLVLC4             @ (((unsigned) &INLVLC)*8) + 4;
#define                                 INLVLC4_bit         BANKMASK(INLVLC), 4
extern volatile __bit                   INLVLC5             @ (((unsigned) &INLVLC)*8) + 5;
#define                                 INLVLC5_bit         BANKMASK(INLVLC), 5
extern volatile __bit                   INLVLC6             @ (((unsigned) &INLVLC)*8) + 6;
#define                                 INLVLC6_bit         BANKMASK(INLVLC), 6
extern volatile __bit                   INLVLC7             @ (((unsigned) &INLVLC)*8) + 7;
#define                                 INLVLC7_bit         BANKMASK(INLVLC), 7
extern volatile __bit                   INTE                @ (((unsigned) &INTCON)*8) + 4;
#define                                 INTE_bit            BANKMASK(INTCON), 4
extern volatile __bit                   INTEDG              @ (((unsigned) &OPTION_REG)*8) + 6;
#define                                 INTEDG_bit          BANKMASK(OPTION_REG), 6
extern volatile __bit                   INTF                @ (((unsigned) &INTCON)*8) + 1;
#define                                 INTF_bit            BANKMASK(INTCON), 1
extern volatile __bit                   INTM                @ (((unsigned) &SCANCON0)*8) + 3;
#define                                 INTM_bit            BANKMASK(SCANCON0), 3
extern volatile __bit                   INTPPS0             @ (((unsigned) &INTPPS)*8) + 0;
#define                                 INTPPS0_bit         BANKMASK(INTPPS), 0
extern volatile __bit                   INTPPS1             @ (((unsigned) &INTPPS)*8) + 1;
#define                                 INTPPS1_bit         BANKMASK(INTPPS), 1
extern volatile __bit                   INTPPS2             @ (((unsigned) &INTPPS)*8) + 2;
#define                                 INTPPS2_bit         BANKMASK(INTPPS), 2
extern volatile __bit                   INTPPS3             @ (((unsigned) &INTPPS)*8) + 3;
#define                                 INTPPS3_bit         BANKMASK(INTPPS), 3
extern volatile __bit                   INTPPS4             @ (((unsigned) &INTPPS)*8) + 4;
#define                                 INTPPS4_bit         BANKMASK(INTPPS), 4
extern volatile __bit                   INVALID             @ (((unsigned) &SCANCON0)*8) + 4;
#define                                 INVALID_bit         BANKMASK(SCANCON0), 4
extern volatile __bit                   IOCAF0              @ (((unsigned) &IOCAF)*8) + 0;
#define                                 IOCAF0_bit          BANKMASK(IOCAF), 0
extern volatile __bit                   IOCAF1              @ (((unsigned) &IOCAF)*8) + 1;
#define                                 IOCAF1_bit          BANKMASK(IOCAF), 1
extern volatile __bit                   IOCAF2              @ (((unsigned) &IOCAF)*8) + 2;
#define                                 IOCAF2_bit          BANKMASK(IOCAF), 2
extern volatile __bit                   IOCAF3              @ (((unsigned) &IOCAF)*8) + 3;
#define                                 IOCAF3_bit          BANKMASK(IOCAF), 3
extern volatile __bit                   IOCAF4              @ (((unsigned) &IOCAF)*8) + 4;
#define                                 IOCAF4_bit          BANKMASK(IOCAF), 4
extern volatile __bit                   IOCAF5              @ (((unsigned) &IOCAF)*8) + 5;
#define                                 IOCAF5_bit          BANKMASK(IOCAF), 5
extern volatile __bit                   IOCAN0              @ (((unsigned) &IOCAN)*8) + 0;
#define                                 IOCAN0_bit          BANKMASK(IOCAN), 0
extern volatile __bit                   IOCAN1              @ (((unsigned) &IOCAN)*8) + 1;
#define                                 IOCAN1_bit          BANKMASK(IOCAN), 1
extern volatile __bit                   IOCAN2              @ (((unsigned) &IOCAN)*8) + 2;
#define                                 IOCAN2_bit          BANKMASK(IOCAN), 2
extern volatile __bit                   IOCAN3              @ (((unsigned) &IOCAN)*8) + 3;
#define                                 IOCAN3_bit          BANKMASK(IOCAN), 3
extern volatile __bit                   IOCAN4              @ (((unsigned) &IOCAN)*8) + 4;
#define                                 IOCAN4_bit          BANKMASK(IOCAN), 4
extern volatile __bit                   IOCAN5              @ (((unsigned) &IOCAN)*8) + 5;
#define                                 IOCAN5_bit          BANKMASK(IOCAN), 5
extern volatile __bit                   IOCAP0              @ (((unsigned) &IOCAP)*8) + 0;
#define                                 IOCAP0_bit          BANKMASK(IOCAP), 0
extern volatile __bit                   IOCAP1              @ (((unsigned) &IOCAP)*8) + 1;
#define                                 IOCAP1_bit          BANKMASK(IOCAP), 1
extern volatile __bit                   IOCAP2              @ (((unsigned) &IOCAP)*8) + 2;
#define                                 IOCAP2_bit          BANKMASK(IOCAP), 2
extern volatile __bit                   IOCAP3              @ (((unsigned) &IOCAP)*8) + 3;
#define                                 IOCAP3_bit          BANKMASK(IOCAP), 3
extern volatile __bit                   IOCAP4              @ (((unsigned) &IOCAP)*8) + 4;
#define                                 IOCAP4_bit          BANKMASK(IOCAP), 4
extern volatile __bit                   IOCAP5              @ (((unsigned) &IOCAP)*8) + 5;
#define                                 IOCAP5_bit          BANKMASK(IOCAP), 5
extern volatile __bit                   IOCBF4              @ (((unsigned) &IOCBF)*8) + 4;
#define                                 IOCBF4_bit          BANKMASK(IOCBF), 4
extern volatile __bit                   IOCBF5              @ (((unsigned) &IOCBF)*8) + 5;
#define                                 IOCBF5_bit          BANKMASK(IOCBF), 5
extern volatile __bit                   IOCBF6              @ (((unsigned) &IOCBF)*8) + 6;
#define                                 IOCBF6_bit          BANKMASK(IOCBF), 6
extern volatile __bit                   IOCBF7              @ (((unsigned) &IOCBF)*8) + 7;
#define                                 IOCBF7_bit          BANKMASK(IOCBF), 7
extern volatile __bit                   IOCBN4              @ (((unsigned) &IOCBN)*8) + 4;
#define                                 IOCBN4_bit          BANKMASK(IOCBN), 4
extern volatile __bit                   IOCBN5              @ (((unsigned) &IOCBN)*8) + 5;
#define                                 IOCBN5_bit          BANKMASK(IOCBN), 5
extern volatile __bit                   IOCBN6              @ (((unsigned) &IOCBN)*8) + 6;
#define                                 IOCBN6_bit          BANKMASK(IOCBN), 6
extern volatile __bit                   IOCBN7              @ (((unsigned) &IOCBN)*8) + 7;
#define                                 IOCBN7_bit          BANKMASK(IOCBN), 7
extern volatile __bit                   IOCBP4              @ (((unsigned) &IOCBP)*8) + 4;
#define                                 IOCBP4_bit          BANKMASK(IOCBP), 4
extern volatile __bit                   IOCBP5              @ (((unsigned) &IOCBP)*8) + 5;
#define                                 IOCBP5_bit          BANKMASK(IOCBP), 5
extern volatile __bit                   IOCBP6              @ (((unsigned) &IOCBP)*8) + 6;
#define                                 IOCBP6_bit          BANKMASK(IOCBP), 6
extern volatile __bit                   IOCBP7              @ (((unsigned) &IOCBP)*8) + 7;
#define                                 IOCBP7_bit          BANKMASK(IOCBP), 7
extern volatile __bit                   IOCCF0              @ (((unsigned) &IOCCF)*8) + 0;
#define                                 IOCCF0_bit          BANKMASK(IOCCF), 0
extern volatile __bit                   IOCCF1              @ (((unsigned) &IOCCF)*8) + 1;
#define                                 IOCCF1_bit          BANKMASK(IOCCF), 1
extern volatile __bit                   IOCCF2              @ (((unsigned) &IOCCF)*8) + 2;
#define                                 IOCCF2_bit          BANKMASK(IOCCF), 2
extern volatile __bit                   IOCCF3              @ (((unsigned) &IOCCF)*8) + 3;
#define                                 IOCCF3_bit          BANKMASK(IOCCF), 3
extern volatile __bit                   IOCCF4              @ (((unsigned) &IOCCF)*8) + 4;
#define                                 IOCCF4_bit          BANKMASK(IOCCF), 4
extern volatile __bit                   IOCCF5              @ (((unsigned) &IOCCF)*8) + 5;
#define                                 IOCCF5_bit          BANKMASK(IOCCF), 5
extern volatile __bit                   IOCCF6              @ (((unsigned) &IOCCF)*8) + 6;
#define                                 IOCCF6_bit          BANKMASK(IOCCF), 6
extern volatile __bit                   IOCCF7              @ (((unsigned) &IOCCF)*8) + 7;
#define                                 IOCCF7_bit          BANKMASK(IOCCF), 7
extern volatile __bit                   IOCCN0              @ (((unsigned) &IOCCN)*8) + 0;
#define                                 IOCCN0_bit          BANKMASK(IOCCN), 0
extern volatile __bit                   IOCCN1              @ (((unsigned) &IOCCN)*8) + 1;
#define                                 IOCCN1_bit          BANKMASK(IOCCN), 1
extern volatile __bit                   IOCCN2              @ (((unsigned) &IOCCN)*8) + 2;
#define                                 IOCCN2_bit          BANKMASK(IOCCN), 2
extern volatile __bit                   IOCCN3              @ (((unsigned) &IOCCN)*8) + 3;
#define                                 IOCCN3_bit          BANKMASK(IOCCN), 3
extern volatile __bit                   IOCCN4              @ (((unsigned) &IOCCN)*8) + 4;
#define                                 IOCCN4_bit          BANKMASK(IOCCN), 4
extern volatile __bit                   IOCCN5              @ (((unsigned) &IOCCN)*8) + 5;
#define                                 IOCCN5_bit          BANKMASK(IOCCN), 5
extern volatile __bit                   IOCCN6              @ (((unsigned) &IOCCN)*8) + 6;
#define                                 IOCCN6_bit          BANKMASK(IOCCN), 6
extern volatile __bit                   IOCCN7              @ (((unsigned) &IOCCN)*8) + 7;
#define                                 IOCCN7_bit          BANKMASK(IOCCN), 7
extern volatile __bit                   IOCCP0              @ (((unsigned) &IOCCP)*8) + 0;
#define                                 IOCCP0_bit          BANKMASK(IOCCP), 0
extern volatile __bit                   IOCCP1              @ (((unsigned) &IOCCP)*8) + 1;
#define                                 IOCCP1_bit          BANKMASK(IOCCP), 1
extern volatile __bit                   IOCCP2              @ (((unsigned) &IOCCP)*8) + 2;
#define                                 IOCCP2_bit          BANKMASK(IOCCP), 2
extern volatile __bit                   IOCCP3              @ (((unsigned) &IOCCP)*8) + 3;
#define                                 IOCCP3_bit          BANKMASK(IOCCP), 3
extern volatile __bit                   IOCCP4              @ (((unsigned) &IOCCP)*8) + 4;
#define                                 IOCCP4_bit          BANKMASK(IOCCP), 4
extern volatile __bit                   IOCCP5              @ (((unsigned) &IOCCP)*8) + 5;
#define                                 IOCCP5_bit          BANKMASK(IOCCP), 5
extern volatile __bit                   IOCCP6              @ (((unsigned) &IOCCP)*8) + 6;
#define                                 IOCCP6_bit          BANKMASK(IOCCP), 6
extern volatile __bit                   IOCCP7              @ (((unsigned) &IOCCP)*8) + 7;
#define                                 IOCCP7_bit          BANKMASK(IOCCP), 7
extern volatile __bit                   IOCIE               @ (((unsigned) &INTCON)*8) + 3;
#define                                 IOCIE_bit           BANKMASK(INTCON), 3
extern volatile __bit                   IOCIF               @ (((unsigned) &INTCON)*8) + 0;
#define                                 IOCIF_bit           BANKMASK(INTCON), 0
extern volatile __bit                   IRCF0               @ (((unsigned) &OSCCON)*8) + 3;
#define                                 IRCF0_bit           BANKMASK(OSCCON), 3
extern volatile __bit                   IRCF1               @ (((unsigned) &OSCCON)*8) + 4;
#define                                 IRCF1_bit           BANKMASK(OSCCON), 4
extern volatile __bit                   IRCF2               @ (((unsigned) &OSCCON)*8) + 5;
#define                                 IRCF2_bit           BANKMASK(OSCCON), 5
extern volatile __bit                   IRCF3               @ (((unsigned) &OSCCON)*8) + 6;
#define                                 IRCF3_bit           BANKMASK(OSCCON), 6
extern volatile __bit                   IS0                 @ (((unsigned) &CWG1ISM)*8) + 0;
#define                                 IS0_bit             BANKMASK(CWG1ISM), 0
extern volatile __bit                   IS1                 @ (((unsigned) &CWG1ISM)*8) + 1;
#define                                 IS1_bit             BANKMASK(CWG1ISM), 1
extern volatile __bit                   IS2                 @ (((unsigned) &CWG1ISM)*8) + 2;
#define                                 IS2_bit             BANKMASK(CWG1ISM), 2
extern volatile __bit                   IS3                 @ (((unsigned) &CWG1ISM)*8) + 3;
#define                                 IS3_bit             BANKMASK(CWG1ISM), 3
extern volatile __bit                   K10                 @ (((unsigned) &PID1K1L)*8) + 0;
#define                                 K10_bit             BANKMASK(PID1K1L), 0
extern volatile __bit                   K11                 @ (((unsigned) &PID1K1L)*8) + 1;
#define                                 K11_bit             BANKMASK(PID1K1L), 1
extern volatile __bit                   K110                @ (((unsigned) &PID1K1H)*8) + 2;
#define                                 K110_bit            BANKMASK(PID1K1H), 2
extern volatile __bit                   K111                @ (((unsigned) &PID1K1H)*8) + 3;
#define                                 K111_bit            BANKMASK(PID1K1H), 3
extern volatile __bit                   K112                @ (((unsigned) &PID1K1H)*8) + 4;
#define                                 K112_bit            BANKMASK(PID1K1H), 4
extern volatile __bit                   K113                @ (((unsigned) &PID1K1H)*8) + 5;
#define                                 K113_bit            BANKMASK(PID1K1H), 5
extern volatile __bit                   K114                @ (((unsigned) &PID1K1H)*8) + 6;
#define                                 K114_bit            BANKMASK(PID1K1H), 6
extern volatile __bit                   K115                @ (((unsigned) &PID1K1H)*8) + 7;
#define                                 K115_bit            BANKMASK(PID1K1H), 7
extern volatile __bit                   K12                 @ (((unsigned) &PID1K1L)*8) + 2;
#define                                 K12_bit             BANKMASK(PID1K1L), 2
extern volatile __bit                   K13                 @ (((unsigned) &PID1K1L)*8) + 3;
#define                                 K13_bit             BANKMASK(PID1K1L), 3
extern volatile __bit                   K14                 @ (((unsigned) &PID1K1L)*8) + 4;
#define                                 K14_bit             BANKMASK(PID1K1L), 4
extern volatile __bit                   K15                 @ (((unsigned) &PID1K1L)*8) + 5;
#define                                 K15_bit             BANKMASK(PID1K1L), 5
extern volatile __bit                   K16                 @ (((unsigned) &PID1K1L)*8) + 6;
#define                                 K16_bit             BANKMASK(PID1K1L), 6
extern volatile __bit                   K17                 @ (((unsigned) &PID1K1L)*8) + 7;
#define                                 K17_bit             BANKMASK(PID1K1L), 7
extern volatile __bit                   K18                 @ (((unsigned) &PID1K1H)*8) + 0;
#define                                 K18_bit             BANKMASK(PID1K1H), 0
extern volatile __bit                   K19                 @ (((unsigned) &PID1K1H)*8) + 1;
#define                                 K19_bit             BANKMASK(PID1K1H), 1
extern volatile __bit                   K20                 @ (((unsigned) &PID1K2L)*8) + 0;
#define                                 K20_bit             BANKMASK(PID1K2L), 0
extern volatile __bit                   K21                 @ (((unsigned) &PID1K2L)*8) + 1;
#define                                 K21_bit             BANKMASK(PID1K2L), 1
extern volatile __bit                   K210                @ (((unsigned) &PID1K2H)*8) + 2;
#define                                 K210_bit            BANKMASK(PID1K2H), 2
extern volatile __bit                   K211                @ (((unsigned) &PID1K2H)*8) + 3;
#define                                 K211_bit            BANKMASK(PID1K2H), 3
extern volatile __bit                   K212                @ (((unsigned) &PID1K2H)*8) + 4;
#define                                 K212_bit            BANKMASK(PID1K2H), 4
extern volatile __bit                   K213                @ (((unsigned) &PID1K2H)*8) + 5;
#define                                 K213_bit            BANKMASK(PID1K2H), 5
extern volatile __bit                   K214                @ (((unsigned) &PID1K2H)*8) + 6;
#define                                 K214_bit            BANKMASK(PID1K2H), 6
extern volatile __bit                   K215                @ (((unsigned) &PID1K2H)*8) + 7;
#define                                 K215_bit            BANKMASK(PID1K2H), 7
extern volatile __bit                   K22                 @ (((unsigned) &PID1K2L)*8) + 2;
#define                                 K22_bit             BANKMASK(PID1K2L), 2
extern volatile __bit                   K23                 @ (((unsigned) &PID1K2L)*8) + 3;
#define                                 K23_bit             BANKMASK(PID1K2L), 3
extern volatile __bit                   K24                 @ (((unsigned) &PID1K2L)*8) + 4;
#define                                 K24_bit             BANKMASK(PID1K2L), 4
extern volatile __bit                   K25                 @ (((unsigned) &PID1K2L)*8) + 5;
#define                                 K25_bit             BANKMASK(PID1K2L), 5
extern volatile __bit                   K26                 @ (((unsigned) &PID1K2L)*8) + 6;
#define                                 K26_bit             BANKMASK(PID1K2L), 6
extern volatile __bit                   K27                 @ (((unsigned) &PID1K2L)*8) + 7;
#define                                 K27_bit             BANKMASK(PID1K2L), 7
extern volatile __bit                   K28                 @ (((unsigned) &PID1K2H)*8) + 0;
#define                                 K28_bit             BANKMASK(PID1K2H), 0
extern volatile __bit                   K29                 @ (((unsigned) &PID1K2H)*8) + 1;
#define                                 K29_bit             BANKMASK(PID1K2H), 1
extern volatile __bit                   K30                 @ (((unsigned) &PID1K3L)*8) + 0;
#define                                 K30_bit             BANKMASK(PID1K3L), 0
extern volatile __bit                   K31                 @ (((unsigned) &PID1K3L)*8) + 1;
#define                                 K31_bit             BANKMASK(PID1K3L), 1
extern volatile __bit                   K310                @ (((unsigned) &PID1K3H)*8) + 2;
#define                                 K310_bit            BANKMASK(PID1K3H), 2
extern volatile __bit                   K311                @ (((unsigned) &PID1K3H)*8) + 3;
#define                                 K311_bit            BANKMASK(PID1K3H), 3
extern volatile __bit                   K312                @ (((unsigned) &PID1K3H)*8) + 4;
#define                                 K312_bit            BANKMASK(PID1K3H), 4
extern volatile __bit                   K313                @ (((unsigned) &PID1K3H)*8) + 5;
#define                                 K313_bit            BANKMASK(PID1K3H), 5
extern volatile __bit                   K314                @ (((unsigned) &PID1K3H)*8) + 6;
#define                                 K314_bit            BANKMASK(PID1K3H), 6
extern volatile __bit                   K315                @ (((unsigned) &PID1K3H)*8) + 7;
#define                                 K315_bit            BANKMASK(PID1K3H), 7
extern volatile __bit                   K32                 @ (((unsigned) &PID1K3L)*8) + 2;
#define                                 K32_bit             BANKMASK(PID1K3L), 2
extern volatile __bit                   K33                 @ (((unsigned) &PID1K3L)*8) + 3;
#define                                 K33_bit             BANKMASK(PID1K3L), 3
extern volatile __bit                   K34                 @ (((unsigned) &PID1K3L)*8) + 4;
#define                                 K34_bit             BANKMASK(PID1K3L), 4
extern volatile __bit                   K35                 @ (((unsigned) &PID1K3L)*8) + 5;
#define                                 K35_bit             BANKMASK(PID1K3L), 5
extern volatile __bit                   K36                 @ (((unsigned) &PID1K3L)*8) + 6;
#define                                 K36_bit             BANKMASK(PID1K3L), 6
extern volatile __bit                   K37                 @ (((unsigned) &PID1K3L)*8) + 7;
#define                                 K37_bit             BANKMASK(PID1K3L), 7
extern volatile __bit                   K38                 @ (((unsigned) &PID1K3H)*8) + 0;
#define                                 K38_bit             BANKMASK(PID1K3H), 0
extern volatile __bit                   K39                 @ (((unsigned) &PID1K3H)*8) + 1;
#define                                 K39_bit             BANKMASK(PID1K3H), 1
extern volatile __bit                   LADR10              @ (((unsigned) &SCANLADRH)*8) + 2;
#define                                 LADR10_bit          BANKMASK(SCANLADRH), 2
extern volatile __bit                   LADR11              @ (((unsigned) &SCANLADRH)*8) + 3;
#define                                 LADR11_bit          BANKMASK(SCANLADRH), 3
extern volatile __bit                   LADR12              @ (((unsigned) &SCANLADRH)*8) + 4;
#define                                 LADR12_bit          BANKMASK(SCANLADRH), 4
extern volatile __bit                   LADR13              @ (((unsigned) &SCANLADRH)*8) + 5;
#define                                 LADR13_bit          BANKMASK(SCANLADRH), 5
extern volatile __bit                   LADR14              @ (((unsigned) &SCANLADRH)*8) + 6;
#define                                 LADR14_bit          BANKMASK(SCANLADRH), 6
extern volatile __bit                   LADR15              @ (((unsigned) &SCANLADRH)*8) + 7;
#define                                 LADR15_bit          BANKMASK(SCANLADRH), 7
extern volatile __bit                   LADR2               @ (((unsigned) &SCANLADRL)*8) + 2;
#define                                 LADR2_bit           BANKMASK(SCANLADRL), 2
extern volatile __bit                   LADR3               @ (((unsigned) &SCANLADRL)*8) + 3;
#define                                 LADR3_bit           BANKMASK(SCANLADRL), 3
extern volatile __bit                   LADR4               @ (((unsigned) &SCANLADRL)*8) + 4;
#define                                 LADR4_bit           BANKMASK(SCANLADRL), 4
extern volatile __bit                   LADR5               @ (((unsigned) &SCANLADRL)*8) + 5;
#define                                 LADR5_bit           BANKMASK(SCANLADRL), 5
extern volatile __bit                   LADR6               @ (((unsigned) &SCANLADRL)*8) + 6;
#define                                 LADR6_bit           BANKMASK(SCANLADRL), 6
extern volatile __bit                   LADR7               @ (((unsigned) &SCANLADRL)*8) + 7;
#define                                 LADR7_bit           BANKMASK(SCANLADRL), 7
extern volatile __bit                   LADR8               @ (((unsigned) &SCANLADRH)*8) + 0;
#define                                 LADR8_bit           BANKMASK(SCANLADRH), 0
extern volatile __bit                   LADR9               @ (((unsigned) &SCANLADRH)*8) + 1;
#define                                 LADR9_bit           BANKMASK(SCANLADRH), 1
extern volatile __bit                   LATA0               @ (((unsigned) &LATA)*8) + 0;
#define                                 LATA0_bit           BANKMASK(LATA), 0
extern volatile __bit                   LATA1               @ (((unsigned) &LATA)*8) + 1;
#define                                 LATA1_bit           BANKMASK(LATA), 1
extern volatile __bit                   LATA2               @ (((unsigned) &LATA)*8) + 2;
#define                                 LATA2_bit           BANKMASK(LATA), 2
extern volatile __bit                   LATA3               @ (((unsigned) &LATA)*8) + 3;
#define                                 LATA3_bit           BANKMASK(LATA), 3
extern volatile __bit                   LATA4               @ (((unsigned) &LATA)*8) + 4;
#define                                 LATA4_bit           BANKMASK(LATA), 4
extern volatile __bit                   LATA5               @ (((unsigned) &LATA)*8) + 5;
#define                                 LATA5_bit           BANKMASK(LATA), 5
extern volatile __bit                   LATB4               @ (((unsigned) &LATB)*8) + 4;
#define                                 LATB4_bit           BANKMASK(LATB), 4
extern volatile __bit                   LATB5               @ (((unsigned) &LATB)*8) + 5;
#define                                 LATB5_bit           BANKMASK(LATB), 5
extern volatile __bit                   LATB6               @ (((unsigned) &LATB)*8) + 6;
#define                                 LATB6_bit           BANKMASK(LATB), 6
extern volatile __bit                   LATB7               @ (((unsigned) &LATB)*8) + 7;
#define                                 LATB7_bit           BANKMASK(LATB), 7
extern volatile __bit                   LATC0               @ (((unsigned) &LATC)*8) + 0;
#define                                 LATC0_bit           BANKMASK(LATC), 0
extern volatile __bit                   LATC1               @ (((unsigned) &LATC)*8) + 1;
#define                                 LATC1_bit           BANKMASK(LATC), 1
extern volatile __bit                   LATC2               @ (((unsigned) &LATC)*8) + 2;
#define                                 LATC2_bit           BANKMASK(LATC), 2
extern volatile __bit                   LATC3               @ (((unsigned) &LATC)*8) + 3;
#define                                 LATC3_bit           BANKMASK(LATC), 3
extern volatile __bit                   LATC4               @ (((unsigned) &LATC)*8) + 4;
#define                                 LATC4_bit           BANKMASK(LATC), 4
extern volatile __bit                   LATC5               @ (((unsigned) &LATC)*8) + 5;
#define                                 LATC5_bit           BANKMASK(LATC), 5
extern volatile __bit                   LATC6               @ (((unsigned) &LATC)*8) + 6;
#define                                 LATC6_bit           BANKMASK(LATC), 6
extern volatile __bit                   LATC7               @ (((unsigned) &LATC)*8) + 7;
#define                                 LATC7_bit           BANKMASK(LATC), 7
extern volatile __bit                   LC1D1S0             @ (((unsigned) &CLC1SEL0)*8) + 0;
#define                                 LC1D1S0_bit         BANKMASK(CLC1SEL0), 0
extern volatile __bit                   LC1D1S1             @ (((unsigned) &CLC1SEL0)*8) + 1;
#define                                 LC1D1S1_bit         BANKMASK(CLC1SEL0), 1
extern volatile __bit                   LC1D1S2             @ (((unsigned) &CLC1SEL0)*8) + 2;
#define                                 LC1D1S2_bit         BANKMASK(CLC1SEL0), 2
extern volatile __bit                   LC1D1S3             @ (((unsigned) &CLC1SEL0)*8) + 3;
#define                                 LC1D1S3_bit         BANKMASK(CLC1SEL0), 3
extern volatile __bit                   LC1D1S4             @ (((unsigned) &CLC1SEL0)*8) + 4;
#define                                 LC1D1S4_bit         BANKMASK(CLC1SEL0), 4
extern volatile __bit                   LC1D1S5             @ (((unsigned) &CLC1SEL0)*8) + 5;
#define                                 LC1D1S5_bit         BANKMASK(CLC1SEL0), 5
extern volatile __bit                   LC1D2S0             @ (((unsigned) &CLC1SEL1)*8) + 0;
#define                                 LC1D2S0_bit         BANKMASK(CLC1SEL1), 0
extern volatile __bit                   LC1D2S1             @ (((unsigned) &CLC1SEL1)*8) + 1;
#define                                 LC1D2S1_bit         BANKMASK(CLC1SEL1), 1
extern volatile __bit                   LC1D2S2             @ (((unsigned) &CLC1SEL1)*8) + 2;
#define                                 LC1D2S2_bit         BANKMASK(CLC1SEL1), 2
extern volatile __bit                   LC1D2S3             @ (((unsigned) &CLC1SEL1)*8) + 3;
#define                                 LC1D2S3_bit         BANKMASK(CLC1SEL1), 3
extern volatile __bit                   LC1D2S4             @ (((unsigned) &CLC1SEL1)*8) + 4;
#define                                 LC1D2S4_bit         BANKMASK(CLC1SEL1), 4
extern volatile __bit                   LC1D2S5             @ (((unsigned) &CLC1SEL1)*8) + 5;
#define                                 LC1D2S5_bit         BANKMASK(CLC1SEL1), 5
extern volatile __bit                   LC1D3S0             @ (((unsigned) &CLC1SEL2)*8) + 0;
#define                                 LC1D3S0_bit         BANKMASK(CLC1SEL2), 0
extern volatile __bit                   LC1D3S1             @ (((unsigned) &CLC1SEL2)*8) + 1;
#define                                 LC1D3S1_bit         BANKMASK(CLC1SEL2), 1
extern volatile __bit                   LC1D3S2             @ (((unsigned) &CLC1SEL2)*8) + 2;
#define                                 LC1D3S2_bit         BANKMASK(CLC1SEL2), 2
extern volatile __bit                   LC1D3S3             @ (((unsigned) &CLC1SEL2)*8) + 3;
#define                                 LC1D3S3_bit         BANKMASK(CLC1SEL2), 3
extern volatile __bit                   LC1D3S4             @ (((unsigned) &CLC1SEL2)*8) + 4;
#define                                 LC1D3S4_bit         BANKMASK(CLC1SEL2), 4
extern volatile __bit                   LC1D3S5             @ (((unsigned) &CLC1SEL2)*8) + 5;
#define                                 LC1D3S5_bit         BANKMASK(CLC1SEL2), 5
extern volatile __bit                   LC1D4S0             @ (((unsigned) &CLC1SEL3)*8) + 0;
#define                                 LC1D4S0_bit         BANKMASK(CLC1SEL3), 0
extern volatile __bit                   LC1D4S1             @ (((unsigned) &CLC1SEL3)*8) + 1;
#define                                 LC1D4S1_bit         BANKMASK(CLC1SEL3), 1
extern volatile __bit                   LC1D4S2             @ (((unsigned) &CLC1SEL3)*8) + 2;
#define                                 LC1D4S2_bit         BANKMASK(CLC1SEL3), 2
extern volatile __bit                   LC1D4S3             @ (((unsigned) &CLC1SEL3)*8) + 3;
#define                                 LC1D4S3_bit         BANKMASK(CLC1SEL3), 3
extern volatile __bit                   LC1D4S4             @ (((unsigned) &CLC1SEL3)*8) + 4;
#define                                 LC1D4S4_bit         BANKMASK(CLC1SEL3), 4
extern volatile __bit                   LC1D4S5             @ (((unsigned) &CLC1SEL3)*8) + 5;
#define                                 LC1D4S5_bit         BANKMASK(CLC1SEL3), 5
extern volatile __bit                   LC1EN               @ (((unsigned) &CLC1CON)*8) + 7;
#define                                 LC1EN_bit           BANKMASK(CLC1CON), 7
extern volatile __bit                   LC1G1D1N            @ (((unsigned) &CLC1GLS0)*8) + 0;
#define                                 LC1G1D1N_bit        BANKMASK(CLC1GLS0), 0
extern volatile __bit                   LC1G1D1T            @ (((unsigned) &CLC1GLS0)*8) + 1;
#define                                 LC1G1D1T_bit        BANKMASK(CLC1GLS0), 1
extern volatile __bit                   LC1G1D2N            @ (((unsigned) &CLC1GLS0)*8) + 2;
#define                                 LC1G1D2N_bit        BANKMASK(CLC1GLS0), 2
extern volatile __bit                   LC1G1D2T            @ (((unsigned) &CLC1GLS0)*8) + 3;
#define                                 LC1G1D2T_bit        BANKMASK(CLC1GLS0), 3
extern volatile __bit                   LC1G1D3N            @ (((unsigned) &CLC1GLS0)*8) + 4;
#define                                 LC1G1D3N_bit        BANKMASK(CLC1GLS0), 4
extern volatile __bit                   LC1G1D3T            @ (((unsigned) &CLC1GLS0)*8) + 5;
#define                                 LC1G1D3T_bit        BANKMASK(CLC1GLS0), 5
extern volatile __bit                   LC1G1D4N            @ (((unsigned) &CLC1GLS0)*8) + 6;
#define                                 LC1G1D4N_bit        BANKMASK(CLC1GLS0), 6
extern volatile __bit                   LC1G1D4T            @ (((unsigned) &CLC1GLS0)*8) + 7;
#define                                 LC1G1D4T_bit        BANKMASK(CLC1GLS0), 7
extern volatile __bit                   LC1G1POL            @ (((unsigned) &CLC1POL)*8) + 0;
#define                                 LC1G1POL_bit        BANKMASK(CLC1POL), 0
extern volatile __bit                   LC1G2D1N            @ (((unsigned) &CLC1GLS1)*8) + 0;
#define                                 LC1G2D1N_bit        BANKMASK(CLC1GLS1), 0
extern volatile __bit                   LC1G2D1T            @ (((unsigned) &CLC1GLS1)*8) + 1;
#define                                 LC1G2D1T_bit        BANKMASK(CLC1GLS1), 1
extern volatile __bit                   LC1G2D2N            @ (((unsigned) &CLC1GLS1)*8) + 2;
#define                                 LC1G2D2N_bit        BANKMASK(CLC1GLS1), 2
extern volatile __bit                   LC1G2D2T            @ (((unsigned) &CLC1GLS1)*8) + 3;
#define                                 LC1G2D2T_bit        BANKMASK(CLC1GLS1), 3
extern volatile __bit                   LC1G2D3N            @ (((unsigned) &CLC1GLS1)*8) + 4;
#define                                 LC1G2D3N_bit        BANKMASK(CLC1GLS1), 4
extern volatile __bit                   LC1G2D3T            @ (((unsigned) &CLC1GLS1)*8) + 5;
#define                                 LC1G2D3T_bit        BANKMASK(CLC1GLS1), 5
extern volatile __bit                   LC1G2D4N            @ (((unsigned) &CLC1GLS1)*8) + 6;
#define                                 LC1G2D4N_bit        BANKMASK(CLC1GLS1), 6
extern volatile __bit                   LC1G2D4T            @ (((unsigned) &CLC1GLS1)*8) + 7;
#define                                 LC1G2D4T_bit        BANKMASK(CLC1GLS1), 7
extern volatile __bit                   LC1G2POL            @ (((unsigned) &CLC1POL)*8) + 1;
#define                                 LC1G2POL_bit        BANKMASK(CLC1POL), 1
extern volatile __bit                   LC1G3D1N            @ (((unsigned) &CLC1GLS2)*8) + 0;
#define                                 LC1G3D1N_bit        BANKMASK(CLC1GLS2), 0
extern volatile __bit                   LC1G3D1T            @ (((unsigned) &CLC1GLS2)*8) + 1;
#define                                 LC1G3D1T_bit        BANKMASK(CLC1GLS2), 1
extern volatile __bit                   LC1G3D2N            @ (((unsigned) &CLC1GLS2)*8) + 2;
#define                                 LC1G3D2N_bit        BANKMASK(CLC1GLS2), 2
extern volatile __bit                   LC1G3D2T            @ (((unsigned) &CLC1GLS2)*8) + 3;
#define                                 LC1G3D2T_bit        BANKMASK(CLC1GLS2), 3
extern volatile __bit                   LC1G3D3N            @ (((unsigned) &CLC1GLS2)*8) + 4;
#define                                 LC1G3D3N_bit        BANKMASK(CLC1GLS2), 4
extern volatile __bit                   LC1G3D3T            @ (((unsigned) &CLC1GLS2)*8) + 5;
#define                                 LC1G3D3T_bit        BANKMASK(CLC1GLS2), 5
extern volatile __bit                   LC1G3D4N            @ (((unsigned) &CLC1GLS2)*8) + 6;
#define                                 LC1G3D4N_bit        BANKMASK(CLC1GLS2), 6
extern volatile __bit                   LC1G3D4T            @ (((unsigned) &CLC1GLS2)*8) + 7;
#define                                 LC1G3D4T_bit        BANKMASK(CLC1GLS2), 7
extern volatile __bit                   LC1G3POL            @ (((unsigned) &CLC1POL)*8) + 2;
#define                                 LC1G3POL_bit        BANKMASK(CLC1POL), 2
extern volatile __bit                   LC1G4D1N            @ (((unsigned) &CLC1GLS3)*8) + 0;
#define                                 LC1G4D1N_bit        BANKMASK(CLC1GLS3), 0
extern volatile __bit                   LC1G4D1T            @ (((unsigned) &CLC1GLS3)*8) + 1;
#define                                 LC1G4D1T_bit        BANKMASK(CLC1GLS3), 1
extern volatile __bit                   LC1G4D2N            @ (((unsigned) &CLC1GLS3)*8) + 2;
#define                                 LC1G4D2N_bit        BANKMASK(CLC1GLS3), 2
extern volatile __bit                   LC1G4D2T            @ (((unsigned) &CLC1GLS3)*8) + 3;
#define                                 LC1G4D2T_bit        BANKMASK(CLC1GLS3), 3
extern volatile __bit                   LC1G4D3N            @ (((unsigned) &CLC1GLS3)*8) + 4;
#define                                 LC1G4D3N_bit        BANKMASK(CLC1GLS3), 4
extern volatile __bit                   LC1G4D3T            @ (((unsigned) &CLC1GLS3)*8) + 5;
#define                                 LC1G4D3T_bit        BANKMASK(CLC1GLS3), 5
extern volatile __bit                   LC1G4D4N            @ (((unsigned) &CLC1GLS3)*8) + 6;
#define                                 LC1G4D4N_bit        BANKMASK(CLC1GLS3), 6
extern volatile __bit                   LC1G4D4T            @ (((unsigned) &CLC1GLS3)*8) + 7;
#define                                 LC1G4D4T_bit        BANKMASK(CLC1GLS3), 7
extern volatile __bit                   LC1G4POL            @ (((unsigned) &CLC1POL)*8) + 3;
#define                                 LC1G4POL_bit        BANKMASK(CLC1POL), 3
extern volatile __bit                   LC1INTN             @ (((unsigned) &CLC1CON)*8) + 3;
#define                                 LC1INTN_bit         BANKMASK(CLC1CON), 3
extern volatile __bit                   LC1INTP             @ (((unsigned) &CLC1CON)*8) + 4;
#define                                 LC1INTP_bit         BANKMASK(CLC1CON), 4
extern volatile __bit                   LC1MODE0            @ (((unsigned) &CLC1CON)*8) + 0;
#define                                 LC1MODE0_bit        BANKMASK(CLC1CON), 0
extern volatile __bit                   LC1MODE1            @ (((unsigned) &CLC1CON)*8) + 1;
#define                                 LC1MODE1_bit        BANKMASK(CLC1CON), 1
extern volatile __bit                   LC1MODE2            @ (((unsigned) &CLC1CON)*8) + 2;
#define                                 LC1MODE2_bit        BANKMASK(CLC1CON), 2
extern volatile __bit                   LC1OUT              @ (((unsigned) &CLC1CON)*8) + 5;
#define                                 LC1OUT_bit          BANKMASK(CLC1CON), 5
extern volatile __bit                   LC1POL              @ (((unsigned) &CLC1POL)*8) + 7;
#define                                 LC1POL_bit          BANKMASK(CLC1POL), 7
extern volatile __bit                   LC2D1S0             @ (((unsigned) &CLC2SEL0)*8) + 0;
#define                                 LC2D1S0_bit         BANKMASK(CLC2SEL0), 0
extern volatile __bit                   LC2D1S1             @ (((unsigned) &CLC2SEL0)*8) + 1;
#define                                 LC2D1S1_bit         BANKMASK(CLC2SEL0), 1
extern volatile __bit                   LC2D1S2             @ (((unsigned) &CLC2SEL0)*8) + 2;
#define                                 LC2D1S2_bit         BANKMASK(CLC2SEL0), 2
extern volatile __bit                   LC2D1S3             @ (((unsigned) &CLC2SEL0)*8) + 3;
#define                                 LC2D1S3_bit         BANKMASK(CLC2SEL0), 3
extern volatile __bit                   LC2D1S4             @ (((unsigned) &CLC2SEL0)*8) + 4;
#define                                 LC2D1S4_bit         BANKMASK(CLC2SEL0), 4
extern volatile __bit                   LC2D1S5             @ (((unsigned) &CLC2SEL0)*8) + 5;
#define                                 LC2D1S5_bit         BANKMASK(CLC2SEL0), 5
extern volatile __bit                   LC2D2S0             @ (((unsigned) &CLC2SEL1)*8) + 0;
#define                                 LC2D2S0_bit         BANKMASK(CLC2SEL1), 0
extern volatile __bit                   LC2D2S1             @ (((unsigned) &CLC2SEL1)*8) + 1;
#define                                 LC2D2S1_bit         BANKMASK(CLC2SEL1), 1
extern volatile __bit                   LC2D2S2             @ (((unsigned) &CLC2SEL1)*8) + 2;
#define                                 LC2D2S2_bit         BANKMASK(CLC2SEL1), 2
extern volatile __bit                   LC2D2S3             @ (((unsigned) &CLC2SEL1)*8) + 3;
#define                                 LC2D2S3_bit         BANKMASK(CLC2SEL1), 3
extern volatile __bit                   LC2D2S4             @ (((unsigned) &CLC2SEL1)*8) + 4;
#define                                 LC2D2S4_bit         BANKMASK(CLC2SEL1), 4
extern volatile __bit                   LC2D2S5             @ (((unsigned) &CLC2SEL1)*8) + 5;
#define                                 LC2D2S5_bit         BANKMASK(CLC2SEL1), 5
extern volatile __bit                   LC2D3S0             @ (((unsigned) &CLC2SEL2)*8) + 0;
#define                                 LC2D3S0_bit         BANKMASK(CLC2SEL2), 0
extern volatile __bit                   LC2D3S1             @ (((unsigned) &CLC2SEL2)*8) + 1;
#define                                 LC2D3S1_bit         BANKMASK(CLC2SEL2), 1
extern volatile __bit                   LC2D3S2             @ (((unsigned) &CLC2SEL2)*8) + 2;
#define                                 LC2D3S2_bit         BANKMASK(CLC2SEL2), 2
extern volatile __bit                   LC2D3S3             @ (((unsigned) &CLC2SEL2)*8) + 3;
#define                                 LC2D3S3_bit         BANKMASK(CLC2SEL2), 3
extern volatile __bit                   LC2D3S4             @ (((unsigned) &CLC2SEL2)*8) + 4;
#define                                 LC2D3S4_bit         BANKMASK(CLC2SEL2), 4
extern volatile __bit                   LC2D3S5             @ (((unsigned) &CLC2SEL2)*8) + 5;
#define                                 LC2D3S5_bit         BANKMASK(CLC2SEL2), 5
extern volatile __bit                   LC2D4S0             @ (((unsigned) &CLC2SEL3)*8) + 0;
#define                                 LC2D4S0_bit         BANKMASK(CLC2SEL3), 0
extern volatile __bit                   LC2D4S1             @ (((unsigned) &CLC2SEL3)*8) + 1;
#define                                 LC2D4S1_bit         BANKMASK(CLC2SEL3), 1
extern volatile __bit                   LC2D4S2             @ (((unsigned) &CLC2SEL3)*8) + 2;
#define                                 LC2D4S2_bit         BANKMASK(CLC2SEL3), 2
extern volatile __bit                   LC2D4S3             @ (((unsigned) &CLC2SEL3)*8) + 3;
#define                                 LC2D4S3_bit         BANKMASK(CLC2SEL3), 3
extern volatile __bit                   LC2D4S4             @ (((unsigned) &CLC2SEL3)*8) + 4;
#define                                 LC2D4S4_bit         BANKMASK(CLC2SEL3), 4
extern volatile __bit                   LC2D4S5             @ (((unsigned) &CLC2SEL3)*8) + 5;
#define                                 LC2D4S5_bit         BANKMASK(CLC2SEL3), 5
extern volatile __bit                   LC2EN               @ (((unsigned) &CLC2CON)*8) + 7;
#define                                 LC2EN_bit           BANKMASK(CLC2CON), 7
extern volatile __bit                   LC2G1D1N            @ (((unsigned) &CLC2GLS0)*8) + 0;
#define                                 LC2G1D1N_bit        BANKMASK(CLC2GLS0), 0
extern volatile __bit                   LC2G1D1T            @ (((unsigned) &CLC2GLS0)*8) + 1;
#define                                 LC2G1D1T_bit        BANKMASK(CLC2GLS0), 1
extern volatile __bit                   LC2G1D2N            @ (((unsigned) &CLC2GLS0)*8) + 2;
#define                                 LC2G1D2N_bit        BANKMASK(CLC2GLS0), 2
extern volatile __bit                   LC2G1D2T            @ (((unsigned) &CLC2GLS0)*8) + 3;
#define                                 LC2G1D2T_bit        BANKMASK(CLC2GLS0), 3
extern volatile __bit                   LC2G1D3N            @ (((unsigned) &CLC2GLS0)*8) + 4;
#define                                 LC2G1D3N_bit        BANKMASK(CLC2GLS0), 4
extern volatile __bit                   LC2G1D3T            @ (((unsigned) &CLC2GLS0)*8) + 5;
#define                                 LC2G1D3T_bit        BANKMASK(CLC2GLS0), 5
extern volatile __bit                   LC2G1D4N            @ (((unsigned) &CLC2GLS0)*8) + 6;
#define                                 LC2G1D4N_bit        BANKMASK(CLC2GLS0), 6
extern volatile __bit                   LC2G1D4T            @ (((unsigned) &CLC2GLS0)*8) + 7;
#define                                 LC2G1D4T_bit        BANKMASK(CLC2GLS0), 7
extern volatile __bit                   LC2G1POL            @ (((unsigned) &CLC2POL)*8) + 0;
#define                                 LC2G1POL_bit        BANKMASK(CLC2POL), 0
extern volatile __bit                   LC2G2D1N            @ (((unsigned) &CLC2GLS1)*8) + 0;
#define                                 LC2G2D1N_bit        BANKMASK(CLC2GLS1), 0
extern volatile __bit                   LC2G2D1T            @ (((unsigned) &CLC2GLS1)*8) + 1;
#define                                 LC2G2D1T_bit        BANKMASK(CLC2GLS1), 1
extern volatile __bit                   LC2G2D2N            @ (((unsigned) &CLC2GLS1)*8) + 2;
#define                                 LC2G2D2N_bit        BANKMASK(CLC2GLS1), 2
extern volatile __bit                   LC2G2D2T            @ (((unsigned) &CLC2GLS1)*8) + 3;
#define                                 LC2G2D2T_bit        BANKMASK(CLC2GLS1), 3
extern volatile __bit                   LC2G2D3N            @ (((unsigned) &CLC2GLS1)*8) + 4;
#define                                 LC2G2D3N_bit        BANKMASK(CLC2GLS1), 4
extern volatile __bit                   LC2G2D3T            @ (((unsigned) &CLC2GLS1)*8) + 5;
#define                                 LC2G2D3T_bit        BANKMASK(CLC2GLS1), 5
extern volatile __bit                   LC2G2D4N            @ (((unsigned) &CLC2GLS1)*8) + 6;
#define                                 LC2G2D4N_bit        BANKMASK(CLC2GLS1), 6
extern volatile __bit                   LC2G2D4T            @ (((unsigned) &CLC2GLS1)*8) + 7;
#define                                 LC2G2D4T_bit        BANKMASK(CLC2GLS1), 7
extern volatile __bit                   LC2G2POL            @ (((unsigned) &CLC2POL)*8) + 1;
#define                                 LC2G2POL_bit        BANKMASK(CLC2POL), 1
extern volatile __bit                   LC2G3D1N            @ (((unsigned) &CLC2GLS2)*8) + 0;
#define                                 LC2G3D1N_bit        BANKMASK(CLC2GLS2), 0
extern volatile __bit                   LC2G3D1T            @ (((unsigned) &CLC2GLS2)*8) + 1;
#define                                 LC2G3D1T_bit        BANKMASK(CLC2GLS2), 1
extern volatile __bit                   LC2G3D2N            @ (((unsigned) &CLC2GLS2)*8) + 2;
#define                                 LC2G3D2N_bit        BANKMASK(CLC2GLS2), 2
extern volatile __bit                   LC2G3D2T            @ (((unsigned) &CLC2GLS2)*8) + 3;
#define                                 LC2G3D2T_bit        BANKMASK(CLC2GLS2), 3
extern volatile __bit                   LC2G3D3N            @ (((unsigned) &CLC2GLS2)*8) + 4;
#define                                 LC2G3D3N_bit        BANKMASK(CLC2GLS2), 4
extern volatile __bit                   LC2G3D3T            @ (((unsigned) &CLC2GLS2)*8) + 5;
#define                                 LC2G3D3T_bit        BANKMASK(CLC2GLS2), 5
extern volatile __bit                   LC2G3D4N            @ (((unsigned) &CLC2GLS2)*8) + 6;
#define                                 LC2G3D4N_bit        BANKMASK(CLC2GLS2), 6
extern volatile __bit                   LC2G3D4T            @ (((unsigned) &CLC2GLS2)*8) + 7;
#define                                 LC2G3D4T_bit        BANKMASK(CLC2GLS2), 7
extern volatile __bit                   LC2G3POL            @ (((unsigned) &CLC2POL)*8) + 2;
#define                                 LC2G3POL_bit        BANKMASK(CLC2POL), 2
extern volatile __bit                   LC2G4D1N            @ (((unsigned) &CLC2GLS3)*8) + 0;
#define                                 LC2G4D1N_bit        BANKMASK(CLC2GLS3), 0
extern volatile __bit                   LC2G4D1T            @ (((unsigned) &CLC2GLS3)*8) + 1;
#define                                 LC2G4D1T_bit        BANKMASK(CLC2GLS3), 1
extern volatile __bit                   LC2G4D2N            @ (((unsigned) &CLC2GLS3)*8) + 2;
#define                                 LC2G4D2N_bit        BANKMASK(CLC2GLS3), 2
extern volatile __bit                   LC2G4D2T            @ (((unsigned) &CLC2GLS3)*8) + 3;
#define                                 LC2G4D2T_bit        BANKMASK(CLC2GLS3), 3
extern volatile __bit                   LC2G4D3N            @ (((unsigned) &CLC2GLS3)*8) + 4;
#define                                 LC2G4D3N_bit        BANKMASK(CLC2GLS3), 4
extern volatile __bit                   LC2G4D3T            @ (((unsigned) &CLC2GLS3)*8) + 5;
#define                                 LC2G4D3T_bit        BANKMASK(CLC2GLS3), 5
extern volatile __bit                   LC2G4D4N            @ (((unsigned) &CLC2GLS3)*8) + 6;
#define                                 LC2G4D4N_bit        BANKMASK(CLC2GLS3), 6
extern volatile __bit                   LC2G4D4T            @ (((unsigned) &CLC2GLS3)*8) + 7;
#define                                 LC2G4D4T_bit        BANKMASK(CLC2GLS3), 7
extern volatile __bit                   LC2G4POL            @ (((unsigned) &CLC2POL)*8) + 3;
#define                                 LC2G4POL_bit        BANKMASK(CLC2POL), 3
extern volatile __bit                   LC2INTN             @ (((unsigned) &CLC2CON)*8) + 3;
#define                                 LC2INTN_bit         BANKMASK(CLC2CON), 3
extern volatile __bit                   LC2INTP             @ (((unsigned) &CLC2CON)*8) + 4;
#define                                 LC2INTP_bit         BANKMASK(CLC2CON), 4
extern volatile __bit                   LC2MODE0            @ (((unsigned) &CLC2CON)*8) + 0;
#define                                 LC2MODE0_bit        BANKMASK(CLC2CON), 0
extern volatile __bit                   LC2MODE1            @ (((unsigned) &CLC2CON)*8) + 1;
#define                                 LC2MODE1_bit        BANKMASK(CLC2CON), 1
extern volatile __bit                   LC2MODE2            @ (((unsigned) &CLC2CON)*8) + 2;
#define                                 LC2MODE2_bit        BANKMASK(CLC2CON), 2
extern volatile __bit                   LC2OUT              @ (((unsigned) &CLC2CON)*8) + 5;
#define                                 LC2OUT_bit          BANKMASK(CLC2CON), 5
extern volatile __bit                   LC2POL              @ (((unsigned) &CLC2POL)*8) + 7;
#define                                 LC2POL_bit          BANKMASK(CLC2POL), 7
extern volatile __bit                   LC3D1S0             @ (((unsigned) &CLC3SEL0)*8) + 0;
#define                                 LC3D1S0_bit         BANKMASK(CLC3SEL0), 0
extern volatile __bit                   LC3D1S1             @ (((unsigned) &CLC3SEL0)*8) + 1;
#define                                 LC3D1S1_bit         BANKMASK(CLC3SEL0), 1
extern volatile __bit                   LC3D1S2             @ (((unsigned) &CLC3SEL0)*8) + 2;
#define                                 LC3D1S2_bit         BANKMASK(CLC3SEL0), 2
extern volatile __bit                   LC3D1S3             @ (((unsigned) &CLC3SEL0)*8) + 3;
#define                                 LC3D1S3_bit         BANKMASK(CLC3SEL0), 3
extern volatile __bit                   LC3D1S4             @ (((unsigned) &CLC3SEL0)*8) + 4;
#define                                 LC3D1S4_bit         BANKMASK(CLC3SEL0), 4
extern volatile __bit                   LC3D1S5             @ (((unsigned) &CLC3SEL0)*8) + 5;
#define                                 LC3D1S5_bit         BANKMASK(CLC3SEL0), 5
extern volatile __bit                   LC3D2S0             @ (((unsigned) &CLC3SEL1)*8) + 0;
#define                                 LC3D2S0_bit         BANKMASK(CLC3SEL1), 0
extern volatile __bit                   LC3D2S1             @ (((unsigned) &CLC3SEL1)*8) + 1;
#define                                 LC3D2S1_bit         BANKMASK(CLC3SEL1), 1
extern volatile __bit                   LC3D2S2             @ (((unsigned) &CLC3SEL1)*8) + 2;
#define                                 LC3D2S2_bit         BANKMASK(CLC3SEL1), 2
extern volatile __bit                   LC3D2S3             @ (((unsigned) &CLC3SEL1)*8) + 3;
#define                                 LC3D2S3_bit         BANKMASK(CLC3SEL1), 3
extern volatile __bit                   LC3D2S4             @ (((unsigned) &CLC3SEL1)*8) + 4;
#define                                 LC3D2S4_bit         BANKMASK(CLC3SEL1), 4
extern volatile __bit                   LC3D2S5             @ (((unsigned) &CLC3SEL1)*8) + 5;
#define                                 LC3D2S5_bit         BANKMASK(CLC3SEL1), 5
extern volatile __bit                   LC3D3S0             @ (((unsigned) &CLC3SEL2)*8) + 0;
#define                                 LC3D3S0_bit         BANKMASK(CLC3SEL2), 0
extern volatile __bit                   LC3D3S1             @ (((unsigned) &CLC3SEL2)*8) + 1;
#define                                 LC3D3S1_bit         BANKMASK(CLC3SEL2), 1
extern volatile __bit                   LC3D3S2             @ (((unsigned) &CLC3SEL2)*8) + 2;
#define                                 LC3D3S2_bit         BANKMASK(CLC3SEL2), 2
extern volatile __bit                   LC3D3S3             @ (((unsigned) &CLC3SEL2)*8) + 3;
#define                                 LC3D3S3_bit         BANKMASK(CLC3SEL2), 3
extern volatile __bit                   LC3D3S4             @ (((unsigned) &CLC3SEL2)*8) + 4;
#define                                 LC3D3S4_bit         BANKMASK(CLC3SEL2), 4
extern volatile __bit                   LC3D3S5             @ (((unsigned) &CLC3SEL2)*8) + 5;
#define                                 LC3D3S5_bit         BANKMASK(CLC3SEL2), 5
extern volatile __bit                   LC3D4S0             @ (((unsigned) &CLC3SEL3)*8) + 0;
#define                                 LC3D4S0_bit         BANKMASK(CLC3SEL3), 0
extern volatile __bit                   LC3D4S1             @ (((unsigned) &CLC3SEL3)*8) + 1;
#define                                 LC3D4S1_bit         BANKMASK(CLC3SEL3), 1
extern volatile __bit                   LC3D4S2             @ (((unsigned) &CLC3SEL3)*8) + 2;
#define                                 LC3D4S2_bit         BANKMASK(CLC3SEL3), 2
extern volatile __bit                   LC3D4S3             @ (((unsigned) &CLC3SEL3)*8) + 3;
#define                                 LC3D4S3_bit         BANKMASK(CLC3SEL3), 3
extern volatile __bit                   LC3D4S4             @ (((unsigned) &CLC3SEL3)*8) + 4;
#define                                 LC3D4S4_bit         BANKMASK(CLC3SEL3), 4
extern volatile __bit                   LC3D4S5             @ (((unsigned) &CLC3SEL3)*8) + 5;
#define                                 LC3D4S5_bit         BANKMASK(CLC3SEL3), 5
extern volatile __bit                   LC3EN               @ (((unsigned) &CLC3CON)*8) + 7;
#define                                 LC3EN_bit           BANKMASK(CLC3CON), 7
extern volatile __bit                   LC3G1D1N            @ (((unsigned) &CLC3GLS0)*8) + 0;
#define                                 LC3G1D1N_bit        BANKMASK(CLC3GLS0), 0
extern volatile __bit                   LC3G1D1T            @ (((unsigned) &CLC3GLS0)*8) + 1;
#define                                 LC3G1D1T_bit        BANKMASK(CLC3GLS0), 1
extern volatile __bit                   LC3G1D2N            @ (((unsigned) &CLC3GLS0)*8) + 2;
#define                                 LC3G1D2N_bit        BANKMASK(CLC3GLS0), 2
extern volatile __bit                   LC3G1D2T            @ (((unsigned) &CLC3GLS0)*8) + 3;
#define                                 LC3G1D2T_bit        BANKMASK(CLC3GLS0), 3
extern volatile __bit                   LC3G1D3N            @ (((unsigned) &CLC3GLS0)*8) + 4;
#define                                 LC3G1D3N_bit        BANKMASK(CLC3GLS0), 4
extern volatile __bit                   LC3G1D3T            @ (((unsigned) &CLC3GLS0)*8) + 5;
#define                                 LC3G1D3T_bit        BANKMASK(CLC3GLS0), 5
extern volatile __bit                   LC3G1D4N            @ (((unsigned) &CLC3GLS0)*8) + 6;
#define                                 LC3G1D4N_bit        BANKMASK(CLC3GLS0), 6
extern volatile __bit                   LC3G1D4T            @ (((unsigned) &CLC3GLS0)*8) + 7;
#define                                 LC3G1D4T_bit        BANKMASK(CLC3GLS0), 7
extern volatile __bit                   LC3G1POL            @ (((unsigned) &CLC3POL)*8) + 0;
#define                                 LC3G1POL_bit        BANKMASK(CLC3POL), 0
extern volatile __bit                   LC3G2D1N            @ (((unsigned) &CLC3GLS1)*8) + 0;
#define                                 LC3G2D1N_bit        BANKMASK(CLC3GLS1), 0
extern volatile __bit                   LC3G2D1T            @ (((unsigned) &CLC3GLS1)*8) + 1;
#define                                 LC3G2D1T_bit        BANKMASK(CLC3GLS1), 1
extern volatile __bit                   LC3G2D2N            @ (((unsigned) &CLC3GLS1)*8) + 2;
#define                                 LC3G2D2N_bit        BANKMASK(CLC3GLS1), 2
extern volatile __bit                   LC3G2D2T            @ (((unsigned) &CLC3GLS1)*8) + 3;
#define                                 LC3G2D2T_bit        BANKMASK(CLC3GLS1), 3
extern volatile __bit                   LC3G2D3N            @ (((unsigned) &CLC3GLS1)*8) + 4;
#define                                 LC3G2D3N_bit        BANKMASK(CLC3GLS1), 4
extern volatile __bit                   LC3G2D3T            @ (((unsigned) &CLC3GLS1)*8) + 5;
#define                                 LC3G2D3T_bit        BANKMASK(CLC3GLS1), 5
extern volatile __bit                   LC3G2D4N            @ (((unsigned) &CLC3GLS1)*8) + 6;
#define                                 LC3G2D4N_bit        BANKMASK(CLC3GLS1), 6
extern volatile __bit                   LC3G2D4T            @ (((unsigned) &CLC3GLS1)*8) + 7;
#define                                 LC3G2D4T_bit        BANKMASK(CLC3GLS1), 7
extern volatile __bit                   LC3G2POL            @ (((unsigned) &CLC3POL)*8) + 1;
#define                                 LC3G2POL_bit        BANKMASK(CLC3POL), 1
extern volatile __bit                   LC3G3D1N            @ (((unsigned) &CLC3GLS2)*8) + 0;
#define                                 LC3G3D1N_bit        BANKMASK(CLC3GLS2), 0
extern volatile __bit                   LC3G3D1T            @ (((unsigned) &CLC3GLS2)*8) + 1;
#define                                 LC3G3D1T_bit        BANKMASK(CLC3GLS2), 1
extern volatile __bit                   LC3G3D2N            @ (((unsigned) &CLC3GLS2)*8) + 2;
#define                                 LC3G3D2N_bit        BANKMASK(CLC3GLS2), 2
extern volatile __bit                   LC3G3D2T            @ (((unsigned) &CLC3GLS2)*8) + 3;
#define                                 LC3G3D2T_bit        BANKMASK(CLC3GLS2), 3
extern volatile __bit                   LC3G3D3N            @ (((unsigned) &CLC3GLS2)*8) + 4;
#define                                 LC3G3D3N_bit        BANKMASK(CLC3GLS2), 4
extern volatile __bit                   LC3G3D3T            @ (((unsigned) &CLC3GLS2)*8) + 5;
#define                                 LC3G3D3T_bit        BANKMASK(CLC3GLS2), 5
extern volatile __bit                   LC3G3D4N            @ (((unsigned) &CLC3GLS2)*8) + 6;
#define                                 LC3G3D4N_bit        BANKMASK(CLC3GLS2), 6
extern volatile __bit                   LC3G3D4T            @ (((unsigned) &CLC3GLS2)*8) + 7;
#define                                 LC3G3D4T_bit        BANKMASK(CLC3GLS2), 7
extern volatile __bit                   LC3G3POL            @ (((unsigned) &CLC3POL)*8) + 2;
#define                                 LC3G3POL_bit        BANKMASK(CLC3POL), 2
extern volatile __bit                   LC3G4D1N            @ (((unsigned) &CLC3GLS3)*8) + 0;
#define                                 LC3G4D1N_bit        BANKMASK(CLC3GLS3), 0
extern volatile __bit                   LC3G4D1T            @ (((unsigned) &CLC3GLS3)*8) + 1;
#define                                 LC3G4D1T_bit        BANKMASK(CLC3GLS3), 1
extern volatile __bit                   LC3G4D2N            @ (((unsigned) &CLC3GLS3)*8) + 2;
#define                                 LC3G4D2N_bit        BANKMASK(CLC3GLS3), 2
extern volatile __bit                   LC3G4D2T            @ (((unsigned) &CLC3GLS3)*8) + 3;
#define                                 LC3G4D2T_bit        BANKMASK(CLC3GLS3), 3
extern volatile __bit                   LC3G4D3N            @ (((unsigned) &CLC3GLS3)*8) + 4;
#define                                 LC3G4D3N_bit        BANKMASK(CLC3GLS3), 4
extern volatile __bit                   LC3G4D3T            @ (((unsigned) &CLC3GLS3)*8) + 5;
#define                                 LC3G4D3T_bit        BANKMASK(CLC3GLS3), 5
extern volatile __bit                   LC3G4D4N            @ (((unsigned) &CLC3GLS3)*8) + 6;
#define                                 LC3G4D4N_bit        BANKMASK(CLC3GLS3), 6
extern volatile __bit                   LC3G4D4T            @ (((unsigned) &CLC3GLS3)*8) + 7;
#define                                 LC3G4D4T_bit        BANKMASK(CLC3GLS3), 7
extern volatile __bit                   LC3G4POL            @ (((unsigned) &CLC3POL)*8) + 3;
#define                                 LC3G4POL_bit        BANKMASK(CLC3POL), 3
extern volatile __bit                   LC3INTN             @ (((unsigned) &CLC3CON)*8) + 3;
#define                                 LC3INTN_bit         BANKMASK(CLC3CON), 3
extern volatile __bit                   LC3INTP             @ (((unsigned) &CLC3CON)*8) + 4;
#define                                 LC3INTP_bit         BANKMASK(CLC3CON), 4
extern volatile __bit                   LC3MODE0            @ (((unsigned) &CLC3CON)*8) + 0;
#define                                 LC3MODE0_bit        BANKMASK(CLC3CON), 0
extern volatile __bit                   LC3MODE1            @ (((unsigned) &CLC3CON)*8) + 1;
#define                                 LC3MODE1_bit        BANKMASK(CLC3CON), 1
extern volatile __bit                   LC3MODE2            @ (((unsigned) &CLC3CON)*8) + 2;
#define                                 LC3MODE2_bit        BANKMASK(CLC3CON), 2
extern volatile __bit                   LC3OUT              @ (((unsigned) &CLC3CON)*8) + 5;
#define                                 LC3OUT_bit          BANKMASK(CLC3CON), 5
extern volatile __bit                   LC3POL              @ (((unsigned) &CLC3POL)*8) + 7;
#define                                 LC3POL_bit          BANKMASK(CLC3POL), 7
extern volatile __bit                   LC4D1S0             @ (((unsigned) &CLC4SEL0)*8) + 0;
#define                                 LC4D1S0_bit         BANKMASK(CLC4SEL0), 0
extern volatile __bit                   LC4D1S1             @ (((unsigned) &CLC4SEL0)*8) + 1;
#define                                 LC4D1S1_bit         BANKMASK(CLC4SEL0), 1
extern volatile __bit                   LC4D1S2             @ (((unsigned) &CLC4SEL0)*8) + 2;
#define                                 LC4D1S2_bit         BANKMASK(CLC4SEL0), 2
extern volatile __bit                   LC4D1S3             @ (((unsigned) &CLC4SEL0)*8) + 3;
#define                                 LC4D1S3_bit         BANKMASK(CLC4SEL0), 3
extern volatile __bit                   LC4D1S4             @ (((unsigned) &CLC4SEL0)*8) + 4;
#define                                 LC4D1S4_bit         BANKMASK(CLC4SEL0), 4
extern volatile __bit                   LC4D1S5             @ (((unsigned) &CLC4SEL0)*8) + 5;
#define                                 LC4D1S5_bit         BANKMASK(CLC4SEL0), 5
extern volatile __bit                   LC4D2S0             @ (((unsigned) &CLC4SEL1)*8) + 0;
#define                                 LC4D2S0_bit         BANKMASK(CLC4SEL1), 0
extern volatile __bit                   LC4D2S1             @ (((unsigned) &CLC4SEL1)*8) + 1;
#define                                 LC4D2S1_bit         BANKMASK(CLC4SEL1), 1
extern volatile __bit                   LC4D2S2             @ (((unsigned) &CLC4SEL1)*8) + 2;
#define                                 LC4D2S2_bit         BANKMASK(CLC4SEL1), 2
extern volatile __bit                   LC4D2S3             @ (((unsigned) &CLC4SEL1)*8) + 3;
#define                                 LC4D2S3_bit         BANKMASK(CLC4SEL1), 3
extern volatile __bit                   LC4D2S4             @ (((unsigned) &CLC4SEL1)*8) + 4;
#define                                 LC4D2S4_bit         BANKMASK(CLC4SEL1), 4
extern volatile __bit                   LC4D2S5             @ (((unsigned) &CLC4SEL1)*8) + 5;
#define                                 LC4D2S5_bit         BANKMASK(CLC4SEL1), 5
extern volatile __bit                   LC4D3S0             @ (((unsigned) &CLC4SEL2)*8) + 0;
#define                                 LC4D3S0_bit         BANKMASK(CLC4SEL2), 0
extern volatile __bit                   LC4D3S1             @ (((unsigned) &CLC4SEL2)*8) + 1;
#define                                 LC4D3S1_bit         BANKMASK(CLC4SEL2), 1
extern volatile __bit                   LC4D3S2             @ (((unsigned) &CLC4SEL2)*8) + 2;
#define                                 LC4D3S2_bit         BANKMASK(CLC4SEL2), 2
extern volatile __bit                   LC4D3S3             @ (((unsigned) &CLC4SEL2)*8) + 3;
#define                                 LC4D3S3_bit         BANKMASK(CLC4SEL2), 3
extern volatile __bit                   LC4D3S4             @ (((unsigned) &CLC4SEL2)*8) + 4;
#define                                 LC4D3S4_bit         BANKMASK(CLC4SEL2), 4
extern volatile __bit                   LC4D3S5             @ (((unsigned) &CLC4SEL2)*8) + 5;
#define                                 LC4D3S5_bit         BANKMASK(CLC4SEL2), 5
extern volatile __bit                   LC4D4S0             @ (((unsigned) &CLC4SEL3)*8) + 0;
#define                                 LC4D4S0_bit         BANKMASK(CLC4SEL3), 0
extern volatile __bit                   LC4D4S1             @ (((unsigned) &CLC4SEL3)*8) + 1;
#define                                 LC4D4S1_bit         BANKMASK(CLC4SEL3), 1
extern volatile __bit                   LC4D4S2             @ (((unsigned) &CLC4SEL3)*8) + 2;
#define                                 LC4D4S2_bit         BANKMASK(CLC4SEL3), 2
extern volatile __bit                   LC4D4S3             @ (((unsigned) &CLC4SEL3)*8) + 3;
#define                                 LC4D4S3_bit         BANKMASK(CLC4SEL3), 3
extern volatile __bit                   LC4D4S4             @ (((unsigned) &CLC4SEL3)*8) + 4;
#define                                 LC4D4S4_bit         BANKMASK(CLC4SEL3), 4
extern volatile __bit                   LC4D4S5             @ (((unsigned) &CLC4SEL3)*8) + 5;
#define                                 LC4D4S5_bit         BANKMASK(CLC4SEL3), 5
extern volatile __bit                   LC4EN               @ (((unsigned) &CLC4CON)*8) + 7;
#define                                 LC4EN_bit           BANKMASK(CLC4CON), 7
extern volatile __bit                   LC4G1D1N            @ (((unsigned) &CLC4GLS0)*8) + 0;
#define                                 LC4G1D1N_bit        BANKMASK(CLC4GLS0), 0
extern volatile __bit                   LC4G1D1T            @ (((unsigned) &CLC4GLS0)*8) + 1;
#define                                 LC4G1D1T_bit        BANKMASK(CLC4GLS0), 1
extern volatile __bit                   LC4G1D2N            @ (((unsigned) &CLC4GLS0)*8) + 2;
#define                                 LC4G1D2N_bit        BANKMASK(CLC4GLS0), 2
extern volatile __bit                   LC4G1D2T            @ (((unsigned) &CLC4GLS0)*8) + 3;
#define                                 LC4G1D2T_bit        BANKMASK(CLC4GLS0), 3
extern volatile __bit                   LC4G1D3N            @ (((unsigned) &CLC4GLS0)*8) + 4;
#define                                 LC4G1D3N_bit        BANKMASK(CLC4GLS0), 4
extern volatile __bit                   LC4G1D3T            @ (((unsigned) &CLC4GLS0)*8) + 5;
#define                                 LC4G1D3T_bit        BANKMASK(CLC4GLS0), 5
extern volatile __bit                   LC4G1D4N            @ (((unsigned) &CLC4GLS0)*8) + 6;
#define                                 LC4G1D4N_bit        BANKMASK(CLC4GLS0), 6
extern volatile __bit                   LC4G1D4T            @ (((unsigned) &CLC4GLS0)*8) + 7;
#define                                 LC4G1D4T_bit        BANKMASK(CLC4GLS0), 7
extern volatile __bit                   LC4G1POL            @ (((unsigned) &CLC4POL)*8) + 0;
#define                                 LC4G1POL_bit        BANKMASK(CLC4POL), 0
extern volatile __bit                   LC4G2D1N            @ (((unsigned) &CLC4GLS1)*8) + 0;
#define                                 LC4G2D1N_bit        BANKMASK(CLC4GLS1), 0
extern volatile __bit                   LC4G2D1T            @ (((unsigned) &CLC4GLS1)*8) + 1;
#define                                 LC4G2D1T_bit        BANKMASK(CLC4GLS1), 1
extern volatile __bit                   LC4G2D2N            @ (((unsigned) &CLC4GLS1)*8) + 2;
#define                                 LC4G2D2N_bit        BANKMASK(CLC4GLS1), 2
extern volatile __bit                   LC4G2D2T            @ (((unsigned) &CLC4GLS1)*8) + 3;
#define                                 LC4G2D2T_bit        BANKMASK(CLC4GLS1), 3
extern volatile __bit                   LC4G2D3N            @ (((unsigned) &CLC4GLS1)*8) + 4;
#define                                 LC4G2D3N_bit        BANKMASK(CLC4GLS1), 4
extern volatile __bit                   LC4G2D3T            @ (((unsigned) &CLC4GLS1)*8) + 5;
#define                                 LC4G2D3T_bit        BANKMASK(CLC4GLS1), 5
extern volatile __bit                   LC4G2D4N            @ (((unsigned) &CLC4GLS1)*8) + 6;
#define                                 LC4G2D4N_bit        BANKMASK(CLC4GLS1), 6
extern volatile __bit                   LC4G2D4T            @ (((unsigned) &CLC4GLS1)*8) + 7;
#define                                 LC4G2D4T_bit        BANKMASK(CLC4GLS1), 7
extern volatile __bit                   LC4G2POL            @ (((unsigned) &CLC4POL)*8) + 1;
#define                                 LC4G2POL_bit        BANKMASK(CLC4POL), 1
extern volatile __bit                   LC4G3D1N            @ (((unsigned) &CLC4GLS2)*8) + 0;
#define                                 LC4G3D1N_bit        BANKMASK(CLC4GLS2), 0
extern volatile __bit                   LC4G3D1T            @ (((unsigned) &CLC4GLS2)*8) + 1;
#define                                 LC4G3D1T_bit        BANKMASK(CLC4GLS2), 1
extern volatile __bit                   LC4G3D2N            @ (((unsigned) &CLC4GLS2)*8) + 2;
#define                                 LC4G3D2N_bit        BANKMASK(CLC4GLS2), 2
extern volatile __bit                   LC4G3D2T            @ (((unsigned) &CLC4GLS2)*8) + 3;
#define                                 LC4G3D2T_bit        BANKMASK(CLC4GLS2), 3
extern volatile __bit                   LC4G3D3N            @ (((unsigned) &CLC4GLS2)*8) + 4;
#define                                 LC4G3D3N_bit        BANKMASK(CLC4GLS2), 4
extern volatile __bit                   LC4G3D3T            @ (((unsigned) &CLC4GLS2)*8) + 5;
#define                                 LC4G3D3T_bit        BANKMASK(CLC4GLS2), 5
extern volatile __bit                   LC4G3D4N            @ (((unsigned) &CLC4GLS2)*8) + 6;
#define                                 LC4G3D4N_bit        BANKMASK(CLC4GLS2), 6
extern volatile __bit                   LC4G3D4T            @ (((unsigned) &CLC4GLS2)*8) + 7;
#define                                 LC4G3D4T_bit        BANKMASK(CLC4GLS2), 7
extern volatile __bit                   LC4G3POL            @ (((unsigned) &CLC4POL)*8) + 2;
#define                                 LC4G3POL_bit        BANKMASK(CLC4POL), 2
extern volatile __bit                   LC4G4D1N            @ (((unsigned) &CLC4GLS3)*8) + 0;
#define                                 LC4G4D1N_bit        BANKMASK(CLC4GLS3), 0
extern volatile __bit                   LC4G4D1T            @ (((unsigned) &CLC4GLS3)*8) + 1;
#define                                 LC4G4D1T_bit        BANKMASK(CLC4GLS3), 1
extern volatile __bit                   LC4G4D2N            @ (((unsigned) &CLC4GLS3)*8) + 2;
#define                                 LC4G4D2N_bit        BANKMASK(CLC4GLS3), 2
extern volatile __bit                   LC4G4D2T            @ (((unsigned) &CLC4GLS3)*8) + 3;
#define                                 LC4G4D2T_bit        BANKMASK(CLC4GLS3), 3
extern volatile __bit                   LC4G4D3N            @ (((unsigned) &CLC4GLS3)*8) + 4;
#define                                 LC4G4D3N_bit        BANKMASK(CLC4GLS3), 4
extern volatile __bit                   LC4G4D3T            @ (((unsigned) &CLC4GLS3)*8) + 5;
#define                                 LC4G4D3T_bit        BANKMASK(CLC4GLS3), 5
extern volatile __bit                   LC4G4D4N            @ (((unsigned) &CLC4GLS3)*8) + 6;
#define                                 LC4G4D4N_bit        BANKMASK(CLC4GLS3), 6
extern volatile __bit                   LC4G4D4T            @ (((unsigned) &CLC4GLS3)*8) + 7;
#define                                 LC4G4D4T_bit        BANKMASK(CLC4GLS3), 7
extern volatile __bit                   LC4G4POL            @ (((unsigned) &CLC4POL)*8) + 3;
#define                                 LC4G4POL_bit        BANKMASK(CLC4POL), 3
extern volatile __bit                   LC4INTN             @ (((unsigned) &CLC4CON)*8) + 3;
#define                                 LC4INTN_bit         BANKMASK(CLC4CON), 3
extern volatile __bit                   LC4INTP             @ (((unsigned) &CLC4CON)*8) + 4;
#define                                 LC4INTP_bit         BANKMASK(CLC4CON), 4
extern volatile __bit                   LC4MODE0            @ (((unsigned) &CLC4CON)*8) + 0;
#define                                 LC4MODE0_bit        BANKMASK(CLC4CON), 0
extern volatile __bit                   LC4MODE1            @ (((unsigned) &CLC4CON)*8) + 1;
#define                                 LC4MODE1_bit        BANKMASK(CLC4CON), 1
extern volatile __bit                   LC4MODE2            @ (((unsigned) &CLC4CON)*8) + 2;
#define                                 LC4MODE2_bit        BANKMASK(CLC4CON), 2
extern volatile __bit                   LC4OUT              @ (((unsigned) &CLC4CON)*8) + 5;
#define                                 LC4OUT_bit          BANKMASK(CLC4CON), 5
extern volatile __bit                   LC4POL              @ (((unsigned) &CLC4POL)*8) + 7;
#define                                 LC4POL_bit          BANKMASK(CLC4POL), 7
extern volatile __bit                   LD                  @ (((unsigned) &CWG1CON0)*8) + 6;
#define                                 LD_bit              BANKMASK(CWG1CON0), 6
extern volatile __bit                   LDAR0               @ (((unsigned) &SCANLADRL)*8) + 0;
#define                                 LDAR0_bit           BANKMASK(SCANLADRL), 0
extern volatile __bit                   LDAR1               @ (((unsigned) &SCANLADRL)*8) + 1;
#define                                 LDAR1_bit           BANKMASK(SCANLADRL), 1
extern volatile __bit                   LFIOFR              @ (((unsigned) &OSCSTAT)*8) + 1;
#define                                 LFIOFR_bit          BANKMASK(OSCSTAT), 1
extern volatile __bit                   LSAC0               @ (((unsigned) &CWG1AS0)*8) + 2;
#define                                 LSAC0_bit           BANKMASK(CWG1AS0), 2
extern volatile __bit                   LSAC1               @ (((unsigned) &CWG1AS0)*8) + 3;
#define                                 LSAC1_bit           BANKMASK(CWG1AS0), 3
extern volatile __bit                   LSBD0               @ (((unsigned) &CWG1AS0)*8) + 4;
#define                                 LSBD0_bit           BANKMASK(CWG1AS0), 4
extern volatile __bit                   LSBD1               @ (((unsigned) &CWG1AS0)*8) + 5;
#define                                 LSBD1_bit           BANKMASK(CWG1AS0), 5
extern volatile __bit                   LWLO                @ (((unsigned) &PMCON1)*8) + 5;
#define                                 LWLO_bit            BANKMASK(PMCON1), 5
extern volatile __bit                   MC1OUT              @ (((unsigned) &CMOUT)*8) + 0;
#define                                 MC1OUT_bit          BANKMASK(CMOUT), 0
extern volatile __bit                   MC2OUT              @ (((unsigned) &CMOUT)*8) + 1;
#define                                 MC2OUT_bit          BANKMASK(CMOUT), 1
extern volatile __bit                   MFIOFR              @ (((unsigned) &OSCSTAT)*8) + 2;
#define                                 MFIOFR_bit          BANKMASK(OSCSTAT), 2
extern volatile __bit                   MISS0               @ (((unsigned) &AT1MISSL)*8) + 0;
#define                                 MISS0_bit           BANKMASK(AT1MISSL), 0
extern volatile __bit                   MISS1               @ (((unsigned) &AT1MISSL)*8) + 1;
#define                                 MISS1_bit           BANKMASK(AT1MISSL), 1
extern volatile __bit                   MISS10              @ (((unsigned) &AT1MISSH)*8) + 2;
#define                                 MISS10_bit          BANKMASK(AT1MISSH), 2
extern volatile __bit                   MISS11              @ (((unsigned) &AT1MISSH)*8) + 3;
#define                                 MISS11_bit          BANKMASK(AT1MISSH), 3
extern volatile __bit                   MISS12              @ (((unsigned) &AT1MISSH)*8) + 4;
#define                                 MISS12_bit          BANKMASK(AT1MISSH), 4
extern volatile __bit                   MISS13              @ (((unsigned) &AT1MISSH)*8) + 5;
#define                                 MISS13_bit          BANKMASK(AT1MISSH), 5
extern volatile __bit                   MISS14              @ (((unsigned) &AT1MISSH)*8) + 6;
#define                                 MISS14_bit          BANKMASK(AT1MISSH), 6
extern volatile __bit                   MISS15              @ (((unsigned) &AT1MISSH)*8) + 7;
#define                                 MISS15_bit          BANKMASK(AT1MISSH), 7
extern volatile __bit                   MISS2               @ (((unsigned) &AT1MISSL)*8) + 2;
#define                                 MISS2_bit           BANKMASK(AT1MISSL), 2
extern volatile __bit                   MISS3               @ (((unsigned) &AT1MISSL)*8) + 3;
#define                                 MISS3_bit           BANKMASK(AT1MISSL), 3
extern volatile __bit                   MISS4               @ (((unsigned) &AT1MISSL)*8) + 4;
#define                                 MISS4_bit           BANKMASK(AT1MISSL), 4
extern volatile __bit                   MISS5               @ (((unsigned) &AT1MISSL)*8) + 5;
#define                                 MISS5_bit           BANKMASK(AT1MISSL), 5
extern volatile __bit                   MISS6               @ (((unsigned) &AT1MISSL)*8) + 6;
#define                                 MISS6_bit           BANKMASK(AT1MISSL), 6
extern volatile __bit                   MISS7               @ (((unsigned) &AT1MISSL)*8) + 7;
#define                                 MISS7_bit           BANKMASK(AT1MISSL), 7
extern volatile __bit                   MISS8               @ (((unsigned) &AT1MISSH)*8) + 0;
#define                                 MISS8_bit           BANKMASK(AT1MISSH), 0
extern volatile __bit                   MISS9               @ (((unsigned) &AT1MISSH)*8) + 1;
#define                                 MISS9_bit           BANKMASK(AT1MISSH), 1
extern volatile __bit                   MLC1OUT             @ (((unsigned) &CLCDATA)*8) + 0;
#define                                 MLC1OUT_bit         BANKMASK(CLCDATA), 0
extern volatile __bit                   MLC2OUT             @ (((unsigned) &CLCDATA)*8) + 1;
#define                                 MLC2OUT_bit         BANKMASK(CLCDATA), 1
extern volatile __bit                   MLC3OUT             @ (((unsigned) &CLCDATA)*8) + 2;
#define                                 MLC3OUT_bit         BANKMASK(CLCDATA), 2
extern volatile __bit                   MLC4OUT             @ (((unsigned) &CLCDATA)*8) + 3;
#define                                 MLC4OUT_bit         BANKMASK(CLCDATA), 3
extern volatile __bit                   MODE                @ (((unsigned) &AT1CON0)*8) + 0;
#define                                 MODE_bit            BANKMASK(AT1CON0), 0
extern volatile __bit                   MPP                 @ (((unsigned) &AT1CON1)*8) + 2;
#define                                 MPP_bit             BANKMASK(AT1CON1), 2
extern volatile __bit                   MSK0                @ (((unsigned) &SSP1MSK)*8) + 0;
#define                                 MSK0_bit            BANKMASK(SSP1MSK), 0
extern volatile __bit                   MSK1                @ (((unsigned) &SSP1MSK)*8) + 1;
#define                                 MSK1_bit            BANKMASK(SSP1MSK), 1
extern volatile __bit                   MSK2                @ (((unsigned) &SSP1MSK)*8) + 2;
#define                                 MSK2_bit            BANKMASK(SSP1MSK), 2
extern volatile __bit                   MSK3                @ (((unsigned) &SSP1MSK)*8) + 3;
#define                                 MSK3_bit            BANKMASK(SSP1MSK), 3
extern volatile __bit                   MSK4                @ (((unsigned) &SSP1MSK)*8) + 4;
#define                                 MSK4_bit            BANKMASK(SSP1MSK), 4
extern volatile __bit                   MSK5                @ (((unsigned) &SSP1MSK)*8) + 5;
#define                                 MSK5_bit            BANKMASK(SSP1MSK), 5
extern volatile __bit                   MSK6                @ (((unsigned) &SSP1MSK)*8) + 6;
#define                                 MSK6_bit            BANKMASK(SSP1MSK), 6
extern volatile __bit                   MSK7                @ (((unsigned) &SSP1MSK)*8) + 7;
#define                                 MSK7_bit            BANKMASK(SSP1MSK), 7
extern volatile __bit                   ODA0                @ (((unsigned) &ODCONA)*8) + 0;
#define                                 ODA0_bit            BANKMASK(ODCONA), 0
extern volatile __bit                   ODA1                @ (((unsigned) &ODCONA)*8) + 1;
#define                                 ODA1_bit            BANKMASK(ODCONA), 1
extern volatile __bit                   ODA2                @ (((unsigned) &ODCONA)*8) + 2;
#define                                 ODA2_bit            BANKMASK(ODCONA), 2
extern volatile __bit                   ODA4                @ (((unsigned) &ODCONA)*8) + 4;
#define                                 ODA4_bit            BANKMASK(ODCONA), 4
extern volatile __bit                   ODA5                @ (((unsigned) &ODCONA)*8) + 5;
#define                                 ODA5_bit            BANKMASK(ODCONA), 5
extern volatile __bit                   ODB4                @ (((unsigned) &ODCONB)*8) + 4;
#define                                 ODB4_bit            BANKMASK(ODCONB), 4
extern volatile __bit                   ODB5                @ (((unsigned) &ODCONB)*8) + 5;
#define                                 ODB5_bit            BANKMASK(ODCONB), 5
extern volatile __bit                   ODB6                @ (((unsigned) &ODCONB)*8) + 6;
#define                                 ODB6_bit            BANKMASK(ODCONB), 6
extern volatile __bit                   ODB7                @ (((unsigned) &ODCONB)*8) + 7;
#define                                 ODB7_bit            BANKMASK(ODCONB), 7
extern volatile __bit                   ODC0                @ (((unsigned) &ODCONC)*8) + 0;
#define                                 ODC0_bit            BANKMASK(ODCONC), 0
extern volatile __bit                   ODC1                @ (((unsigned) &ODCONC)*8) + 1;
#define                                 ODC1_bit            BANKMASK(ODCONC), 1
extern volatile __bit                   ODC2                @ (((unsigned) &ODCONC)*8) + 2;
#define                                 ODC2_bit            BANKMASK(ODCONC), 2
extern volatile __bit                   ODC3                @ (((unsigned) &ODCONC)*8) + 3;
#define                                 ODC3_bit            BANKMASK(ODCONC), 3
extern volatile __bit                   ODC4                @ (((unsigned) &ODCONC)*8) + 4;
#define                                 ODC4_bit            BANKMASK(ODCONC), 4
extern volatile __bit                   ODC5                @ (((unsigned) &ODCONC)*8) + 5;
#define                                 ODC5_bit            BANKMASK(ODCONC), 5
extern volatile __bit                   ODC6                @ (((unsigned) &ODCONC)*8) + 6;
#define                                 ODC6_bit            BANKMASK(ODCONC), 6
extern volatile __bit                   ODC7                @ (((unsigned) &ODCONC)*8) + 7;
#define                                 ODC7_bit            BANKMASK(ODCONC), 7
extern volatile __bit                   OERR                @ (((unsigned) &RC1STA)*8) + 1;
#define                                 OERR_bit            BANKMASK(RC1STA), 1
extern volatile __bit                   OSCFIE              @ (((unsigned) &PIE2)*8) + 7;
#define                                 OSCFIE_bit          BANKMASK(PIE2), 7
extern volatile __bit                   OSFIF               @ (((unsigned) &PIR2)*8) + 7;
#define                                 OSFIF_bit           BANKMASK(PIR2), 7
extern volatile __bit                   OSTS                @ (((unsigned) &OSCSTAT)*8) + 5;
#define                                 OSTS_bit            BANKMASK(OSCSTAT), 5
extern volatile __bit                   OUT0                @ (((unsigned) &PID1OUTLL)*8) + 0;
#define                                 OUT0_bit            BANKMASK(PID1OUTLL), 0
extern volatile __bit                   OUT1                @ (((unsigned) &PID1OUTLL)*8) + 1;
#define                                 OUT1_bit            BANKMASK(PID1OUTLL), 1
extern volatile __bit                   OUT10               @ (((unsigned) &PID1OUTLH)*8) + 2;
#define                                 OUT10_bit           BANKMASK(PID1OUTLH), 2
extern volatile __bit                   OUT11               @ (((unsigned) &PID1OUTLH)*8) + 3;
#define                                 OUT11_bit           BANKMASK(PID1OUTLH), 3
extern volatile __bit                   OUT12               @ (((unsigned) &PID1OUTLH)*8) + 4;
#define                                 OUT12_bit           BANKMASK(PID1OUTLH), 4
extern volatile __bit                   OUT13               @ (((unsigned) &PID1OUTLH)*8) + 5;
#define                                 OUT13_bit           BANKMASK(PID1OUTLH), 5
extern volatile __bit                   OUT14               @ (((unsigned) &PID1OUTLH)*8) + 6;
#define                                 OUT14_bit           BANKMASK(PID1OUTLH), 6
extern volatile __bit                   OUT15               @ (((unsigned) &PID1OUTLH)*8) + 7;
#define                                 OUT15_bit           BANKMASK(PID1OUTLH), 7
extern volatile __bit                   OUT16               @ (((unsigned) &PID1OUTHL)*8) + 0;
#define                                 OUT16_bit           BANKMASK(PID1OUTHL), 0
extern volatile __bit                   OUT17               @ (((unsigned) &PID1OUTHL)*8) + 1;
#define                                 OUT17_bit           BANKMASK(PID1OUTHL), 1
extern volatile __bit                   OUT18               @ (((unsigned) &PID1OUTHL)*8) + 2;
#define                                 OUT18_bit           BANKMASK(PID1OUTHL), 2
extern volatile __bit                   OUT19               @ (((unsigned) &PID1OUTHL)*8) + 3;
#define                                 OUT19_bit           BANKMASK(PID1OUTHL), 3
extern volatile __bit                   OUT2                @ (((unsigned) &PID1OUTLL)*8) + 2;
#define                                 OUT2_bit            BANKMASK(PID1OUTLL), 2
extern volatile __bit                   OUT20               @ (((unsigned) &PID1OUTHL)*8) + 4;
#define                                 OUT20_bit           BANKMASK(PID1OUTHL), 4
extern volatile __bit                   OUT21               @ (((unsigned) &PID1OUTHL)*8) + 5;
#define                                 OUT21_bit           BANKMASK(PID1OUTHL), 5
extern volatile __bit                   OUT22               @ (((unsigned) &PID1OUTHL)*8) + 6;
#define                                 OUT22_bit           BANKMASK(PID1OUTHL), 6
extern volatile __bit                   OUT23               @ (((unsigned) &PID1OUTHL)*8) + 7;
#define                                 OUT23_bit           BANKMASK(PID1OUTHL), 7
extern volatile __bit                   OUT24               @ (((unsigned) &PID1OUTHH)*8) + 0;
#define                                 OUT24_bit           BANKMASK(PID1OUTHH), 0
extern volatile __bit                   OUT25               @ (((unsigned) &PID1OUTHH)*8) + 1;
#define                                 OUT25_bit           BANKMASK(PID1OUTHH), 1
extern volatile __bit                   OUT26               @ (((unsigned) &PID1OUTHH)*8) + 2;
#define                                 OUT26_bit           BANKMASK(PID1OUTHH), 2
extern volatile __bit                   OUT27               @ (((unsigned) &PID1OUTHH)*8) + 3;
#define                                 OUT27_bit           BANKMASK(PID1OUTHH), 3
extern volatile __bit                   OUT28               @ (((unsigned) &PID1OUTHH)*8) + 4;
#define                                 OUT28_bit           BANKMASK(PID1OUTHH), 4
extern volatile __bit                   OUT29               @ (((unsigned) &PID1OUTHH)*8) + 5;
#define                                 OUT29_bit           BANKMASK(PID1OUTHH), 5
extern volatile __bit                   OUT3                @ (((unsigned) &PID1OUTLL)*8) + 3;
#define                                 OUT3_bit            BANKMASK(PID1OUTLL), 3
extern volatile __bit                   OUT30               @ (((unsigned) &PID1OUTHH)*8) + 6;
#define                                 OUT30_bit           BANKMASK(PID1OUTHH), 6
extern volatile __bit                   OUT31               @ (((unsigned) &PID1OUTHH)*8) + 7;
#define                                 OUT31_bit           BANKMASK(PID1OUTHH), 7
extern volatile __bit                   OUT32               @ (((unsigned) &PID1OUTU)*8) + 0;
#define                                 OUT32_bit           BANKMASK(PID1OUTU), 0
extern volatile __bit                   OUT33               @ (((unsigned) &PID1OUTU)*8) + 1;
#define                                 OUT33_bit           BANKMASK(PID1OUTU), 1
extern volatile __bit                   OUT34               @ (((unsigned) &PID1OUTU)*8) + 2;
#define                                 OUT34_bit           BANKMASK(PID1OUTU), 2
extern volatile __bit                   OUT35               @ (((unsigned) &PID1OUTU)*8) + 3;
#define                                 OUT35_bit           BANKMASK(PID1OUTU), 3
extern volatile __bit                   OUT4                @ (((unsigned) &PID1OUTLL)*8) + 4;
#define                                 OUT4_bit            BANKMASK(PID1OUTLL), 4
extern volatile __bit                   OUT5                @ (((unsigned) &PID1OUTLL)*8) + 5;
#define                                 OUT5_bit            BANKMASK(PID1OUTLL), 5
extern volatile __bit                   OUT6                @ (((unsigned) &PID1OUTLL)*8) + 6;
#define                                 OUT6_bit            BANKMASK(PID1OUTLL), 6
extern volatile __bit                   OUT7                @ (((unsigned) &PID1OUTLL)*8) + 7;
#define                                 OUT7_bit            BANKMASK(PID1OUTLL), 7
extern volatile __bit                   OUT8                @ (((unsigned) &PID1OUTLH)*8) + 0;
#define                                 OUT8_bit            BANKMASK(PID1OUTLH), 0
extern volatile __bit                   OUT9                @ (((unsigned) &PID1OUTLH)*8) + 1;
#define                                 OUT9_bit            BANKMASK(PID1OUTLH), 1
extern volatile __bit                   OVRA                @ (((unsigned) &CWG1OCON0)*8) + 4;
#define                                 OVRA_bit            BANKMASK(CWG1OCON0), 4
extern volatile __bit                   OVRB                @ (((unsigned) &CWG1OCON0)*8) + 5;
#define                                 OVRB_bit            BANKMASK(CWG1OCON0), 5
extern volatile __bit                   OVRC                @ (((unsigned) &CWG1OCON0)*8) + 6;
#define                                 OVRC_bit            BANKMASK(CWG1OCON0), 6
extern volatile __bit                   OVRD                @ (((unsigned) &CWG1OCON0)*8) + 7;
#define                                 OVRD_bit            BANKMASK(CWG1OCON0), 7
extern volatile __bit                   P3TSEL0             @ (((unsigned) &CCPTMRS)*8) + 4;
#define                                 P3TSEL0_bit         BANKMASK(CCPTMRS), 4
extern volatile __bit                   P3TSEL1             @ (((unsigned) &CCPTMRS)*8) + 5;
#define                                 P3TSEL1_bit         BANKMASK(CCPTMRS), 5
extern volatile __bit                   P4TSEL0             @ (((unsigned) &CCPTMRS)*8) + 6;
#define                                 P4TSEL0_bit         BANKMASK(CCPTMRS), 6
extern volatile __bit                   P4TSEL1             @ (((unsigned) &CCPTMRS)*8) + 7;
#define                                 P4TSEL1_bit         BANKMASK(CCPTMRS), 7
extern volatile __bit                   PCIE                @ (((unsigned) &SSP1CON3)*8) + 6;
#define                                 PCIE_bit            BANKMASK(SSP1CON3), 6
extern volatile __bit                   PEIE                @ (((unsigned) &INTCON)*8) + 6;
#define                                 PEIE_bit            BANKMASK(INTCON), 6
extern volatile __bit                   PEN                 @ (((unsigned) &SSP1CON2)*8) + 2;
#define                                 PEN_bit             BANKMASK(SSP1CON2), 2
extern volatile __bit                   PER0                @ (((unsigned) &AT1PERL)*8) + 0;
#define                                 PER0_bit            BANKMASK(AT1PERL), 0
extern volatile __bit                   PER1                @ (((unsigned) &AT1PERL)*8) + 1;
#define                                 PER1_bit            BANKMASK(AT1PERL), 1
extern volatile __bit                   PER10               @ (((unsigned) &AT1PERH)*8) + 2;
#define                                 PER10_bit           BANKMASK(AT1PERH), 2
extern volatile __bit                   PER11               @ (((unsigned) &AT1PERH)*8) + 3;
#define                                 PER11_bit           BANKMASK(AT1PERH), 3
extern volatile __bit                   PER12               @ (((unsigned) &AT1PERH)*8) + 4;
#define                                 PER12_bit           BANKMASK(AT1PERH), 4
extern volatile __bit                   PER13               @ (((unsigned) &AT1PERH)*8) + 5;
#define                                 PER13_bit           BANKMASK(AT1PERH), 5
extern volatile __bit                   PER14               @ (((unsigned) &AT1PERH)*8) + 6;
#define                                 PER14_bit           BANKMASK(AT1PERH), 6
extern volatile __bit                   PER15               @ (((unsigned) &AT1PERH)*8) + 7;
#define                                 PER15_bit           BANKMASK(AT1PERH), 7
extern volatile __bit                   PER2                @ (((unsigned) &AT1PERL)*8) + 2;
#define                                 PER2_bit            BANKMASK(AT1PERL), 2
extern volatile __bit                   PER3                @ (((unsigned) &AT1PERL)*8) + 3;
#define                                 PER3_bit            BANKMASK(AT1PERL), 3
extern volatile __bit                   PER4                @ (((unsigned) &AT1PERL)*8) + 4;
#define                                 PER4_bit            BANKMASK(AT1PERL), 4
extern volatile __bit                   PER5                @ (((unsigned) &AT1PERL)*8) + 5;
#define                                 PER5_bit            BANKMASK(AT1PERL), 5
extern volatile __bit                   PER6                @ (((unsigned) &AT1PERL)*8) + 6;
#define                                 PER6_bit            BANKMASK(AT1PERL), 6
extern volatile __bit                   PER7                @ (((unsigned) &AT1PERL)*8) + 7;
#define                                 PER7_bit            BANKMASK(AT1PERL), 7
extern volatile __bit                   PER8                @ (((unsigned) &AT1PERH)*8) + 0;
#define                                 PER8_bit            BANKMASK(AT1PERH), 0
extern volatile __bit                   PER9                @ (((unsigned) &AT1PERH)*8) + 1;
#define                                 PER9_bit            BANKMASK(AT1PERH), 1
extern volatile __bit                   PERH0               @ (((unsigned) &AT1PERH)*8) + 0;
#define                                 PERH0_bit           BANKMASK(AT1PERH), 0
extern volatile __bit                   PERH1               @ (((unsigned) &AT1PERH)*8) + 1;
#define                                 PERH1_bit           BANKMASK(AT1PERH), 1
extern volatile __bit                   PERH2               @ (((unsigned) &AT1PERH)*8) + 2;
#define                                 PERH2_bit           BANKMASK(AT1PERH), 2
extern volatile __bit                   PERH3               @ (((unsigned) &AT1PERH)*8) + 3;
#define                                 PERH3_bit           BANKMASK(AT1PERH), 3
extern volatile __bit                   PERH4               @ (((unsigned) &AT1PERH)*8) + 4;
#define                                 PERH4_bit           BANKMASK(AT1PERH), 4
extern volatile __bit                   PERH5               @ (((unsigned) &AT1PERH)*8) + 5;
#define                                 PERH5_bit           BANKMASK(AT1PERH), 5
extern volatile __bit                   PERH6               @ (((unsigned) &AT1PERH)*8) + 6;
#define                                 PERH6_bit           BANKMASK(AT1PERH), 6
extern volatile __bit                   PERH7               @ (((unsigned) &AT1PERH)*8) + 7;
#define                                 PERH7_bit           BANKMASK(AT1PERH), 7
extern volatile __bit                   PERL0               @ (((unsigned) &AT1PERL)*8) + 0;
#define                                 PERL0_bit           BANKMASK(AT1PERL), 0
extern volatile __bit                   PERL1               @ (((unsigned) &AT1PERL)*8) + 1;
#define                                 PERL1_bit           BANKMASK(AT1PERL), 1
extern volatile __bit                   PERL2               @ (((unsigned) &AT1PERL)*8) + 2;
#define                                 PERL2_bit           BANKMASK(AT1PERL), 2
extern volatile __bit                   PERL3               @ (((unsigned) &AT1PERL)*8) + 3;
#define                                 PERL3_bit           BANKMASK(AT1PERL), 3
extern volatile __bit                   PERL4               @ (((unsigned) &AT1PERL)*8) + 4;
#define                                 PERL4_bit           BANKMASK(AT1PERL), 4
extern volatile __bit                   PERL5               @ (((unsigned) &AT1PERL)*8) + 5;
#define                                 PERL5_bit           BANKMASK(AT1PERL), 5
extern volatile __bit                   PERL6               @ (((unsigned) &AT1PERL)*8) + 6;
#define                                 PERL6_bit           BANKMASK(AT1PERL), 6
extern volatile __bit                   PERL7               @ (((unsigned) &AT1PERL)*8) + 7;
#define                                 PERL7_bit           BANKMASK(AT1PERL), 7
extern volatile __bit                   PHP                 @ (((unsigned) &AT1CON1)*8) + 6;
#define                                 PHP_bit             BANKMASK(AT1CON1), 6
extern volatile __bit                   PHS0                @ (((unsigned) &AT1PHSL)*8) + 0;
#define                                 PHS0_bit            BANKMASK(AT1PHSL), 0
extern volatile __bit                   PHS1                @ (((unsigned) &AT1PHSL)*8) + 1;
#define                                 PHS1_bit            BANKMASK(AT1PHSL), 1
extern volatile __bit                   PHS2                @ (((unsigned) &AT1PHSL)*8) + 2;
#define                                 PHS2_bit            BANKMASK(AT1PHSL), 2
extern volatile __bit                   PHS3                @ (((unsigned) &AT1PHSL)*8) + 3;
#define                                 PHS3_bit            BANKMASK(AT1PHSL), 3
extern volatile __bit                   PHS4                @ (((unsigned) &AT1PHSL)*8) + 4;
#define                                 PHS4_bit            BANKMASK(AT1PHSL), 4
extern volatile __bit                   PHS5                @ (((unsigned) &AT1PHSL)*8) + 5;
#define                                 PHS5_bit            BANKMASK(AT1PHSL), 5
extern volatile __bit                   PHS6                @ (((unsigned) &AT1PHSL)*8) + 6;
#define                                 PHS6_bit            BANKMASK(AT1PHSL), 6
extern volatile __bit                   PHS7                @ (((unsigned) &AT1PHSL)*8) + 7;
#define                                 PHS7_bit            BANKMASK(AT1PHSL), 7
extern volatile __bit                   PHS8                @ (((unsigned) &AT1PHSH)*8) + 0;
#define                                 PHS8_bit            BANKMASK(AT1PHSH), 0
extern volatile __bit                   PHS9                @ (((unsigned) &AT1PHSH)*8) + 1;
#define                                 PHS9_bit            BANKMASK(AT1PHSH), 1
extern volatile __bit                   PHSL8               @ (((unsigned) &AT1PHSH)*8) + 0;
#define                                 PHSL8_bit           BANKMASK(AT1PHSH), 0
extern volatile __bit                   PHSL9               @ (((unsigned) &AT1PHSH)*8) + 1;
#define                                 PHSL9_bit           BANKMASK(AT1PHSH), 1
extern volatile __bit                   PID1ACC0            @ (((unsigned) &PID1ACCLL)*8) + 0;
#define                                 PID1ACC0_bit        BANKMASK(PID1ACCLL), 0
extern volatile __bit                   PID1ACC1            @ (((unsigned) &PID1ACCLL)*8) + 1;
#define                                 PID1ACC1_bit        BANKMASK(PID1ACCLL), 1
extern volatile __bit                   PID1ACC10           @ (((unsigned) &PID1ACCLH)*8) + 2;
#define                                 PID1ACC10_bit       BANKMASK(PID1ACCLH), 2
extern volatile __bit                   PID1ACC11           @ (((unsigned) &PID1ACCLH)*8) + 3;
#define                                 PID1ACC11_bit       BANKMASK(PID1ACCLH), 3
extern volatile __bit                   PID1ACC12           @ (((unsigned) &PID1ACCLH)*8) + 4;
#define                                 PID1ACC12_bit       BANKMASK(PID1ACCLH), 4
extern volatile __bit                   PID1ACC13           @ (((unsigned) &PID1ACCLH)*8) + 5;
#define                                 PID1ACC13_bit       BANKMASK(PID1ACCLH), 5
extern volatile __bit                   PID1ACC14           @ (((unsigned) &PID1ACCLH)*8) + 6;
#define                                 PID1ACC14_bit       BANKMASK(PID1ACCLH), 6
extern volatile __bit                   PID1ACC15           @ (((unsigned) &PID1ACCLH)*8) + 7;
#define                                 PID1ACC15_bit       BANKMASK(PID1ACCLH), 7
extern volatile __bit                   PID1ACC16           @ (((unsigned) &PID1ACCHL)*8) + 0;
#define                                 PID1ACC16_bit       BANKMASK(PID1ACCHL), 0
extern volatile __bit                   PID1ACC17           @ (((unsigned) &PID1ACCHL)*8) + 1;
#define                                 PID1ACC17_bit       BANKMASK(PID1ACCHL), 1
extern volatile __bit                   PID1ACC18           @ (((unsigned) &PID1ACCHL)*8) + 2;
#define                                 PID1ACC18_bit       BANKMASK(PID1ACCHL), 2
extern volatile __bit                   PID1ACC19           @ (((unsigned) &PID1ACCHL)*8) + 3;
#define                                 PID1ACC19_bit       BANKMASK(PID1ACCHL), 3
extern volatile __bit                   PID1ACC2            @ (((unsigned) &PID1ACCLL)*8) + 2;
#define                                 PID1ACC2_bit        BANKMASK(PID1ACCLL), 2
extern volatile __bit                   PID1ACC20           @ (((unsigned) &PID1ACCHL)*8) + 4;
#define                                 PID1ACC20_bit       BANKMASK(PID1ACCHL), 4
extern volatile __bit                   PID1ACC21           @ (((unsigned) &PID1ACCHL)*8) + 5;
#define                                 PID1ACC21_bit       BANKMASK(PID1ACCHL), 5
extern volatile __bit                   PID1ACC22           @ (((unsigned) &PID1ACCHL)*8) + 6;
#define                                 PID1ACC22_bit       BANKMASK(PID1ACCHL), 6
extern volatile __bit                   PID1ACC23           @ (((unsigned) &PID1ACCHL)*8) + 7;
#define                                 PID1ACC23_bit       BANKMASK(PID1ACCHL), 7
extern volatile __bit                   PID1ACC24           @ (((unsigned) &PID1ACCHH)*8) + 0;
#define                                 PID1ACC24_bit       BANKMASK(PID1ACCHH), 0
extern volatile __bit                   PID1ACC25           @ (((unsigned) &PID1ACCHH)*8) + 1;
#define                                 PID1ACC25_bit       BANKMASK(PID1ACCHH), 1
extern volatile __bit                   PID1ACC26           @ (((unsigned) &PID1ACCHH)*8) + 2;
#define                                 PID1ACC26_bit       BANKMASK(PID1ACCHH), 2
extern volatile __bit                   PID1ACC27           @ (((unsigned) &PID1ACCHH)*8) + 3;
#define                                 PID1ACC27_bit       BANKMASK(PID1ACCHH), 3
extern volatile __bit                   PID1ACC28           @ (((unsigned) &PID1ACCHH)*8) + 4;
#define                                 PID1ACC28_bit       BANKMASK(PID1ACCHH), 4
extern volatile __bit                   PID1ACC29           @ (((unsigned) &PID1ACCHH)*8) + 5;
#define                                 PID1ACC29_bit       BANKMASK(PID1ACCHH), 5
extern volatile __bit                   PID1ACC3            @ (((unsigned) &PID1ACCLL)*8) + 3;
#define                                 PID1ACC3_bit        BANKMASK(PID1ACCLL), 3
extern volatile __bit                   PID1ACC30           @ (((unsigned) &PID1ACCHH)*8) + 6;
#define                                 PID1ACC30_bit       BANKMASK(PID1ACCHH), 6
extern volatile __bit                   PID1ACC31           @ (((unsigned) &PID1ACCHH)*8) + 7;
#define                                 PID1ACC31_bit       BANKMASK(PID1ACCHH), 7
extern volatile __bit                   PID1ACC32           @ (((unsigned) &PID1ACCU)*8) + 0;
#define                                 PID1ACC32_bit       BANKMASK(PID1ACCU), 0
extern volatile __bit                   PID1ACC33           @ (((unsigned) &PID1ACCU)*8) + 1;
#define                                 PID1ACC33_bit       BANKMASK(PID1ACCU), 1
extern volatile __bit                   PID1ACC34           @ (((unsigned) &PID1ACCU)*8) + 2;
#define                                 PID1ACC34_bit       BANKMASK(PID1ACCU), 2
extern volatile __bit                   PID1ACC4            @ (((unsigned) &PID1ACCLL)*8) + 4;
#define                                 PID1ACC4_bit        BANKMASK(PID1ACCLL), 4
extern volatile __bit                   PID1ACC5            @ (((unsigned) &PID1ACCLL)*8) + 5;
#define                                 PID1ACC5_bit        BANKMASK(PID1ACCLL), 5
extern volatile __bit                   PID1ACC6            @ (((unsigned) &PID1ACCLL)*8) + 6;
#define                                 PID1ACC6_bit        BANKMASK(PID1ACCLL), 6
extern volatile __bit                   PID1ACC7            @ (((unsigned) &PID1ACCLL)*8) + 7;
#define                                 PID1ACC7_bit        BANKMASK(PID1ACCLL), 7
extern volatile __bit                   PID1ACC8            @ (((unsigned) &PID1ACCLH)*8) + 0;
#define                                 PID1ACC8_bit        BANKMASK(PID1ACCLH), 0
extern volatile __bit                   PID1ACC9            @ (((unsigned) &PID1ACCLH)*8) + 1;
#define                                 PID1ACC9_bit        BANKMASK(PID1ACCLH), 1
extern volatile __bit                   PID1BUSY            @ (((unsigned) &PID1CON)*8) + 6;
#define                                 PID1BUSY_bit        BANKMASK(PID1CON), 6
extern volatile __bit                   PID1DIE             @ (((unsigned) &PIE5)*8) + 0;
#define                                 PID1DIE_bit         BANKMASK(PIE5), 0
extern volatile __bit                   PID1DIF             @ (((unsigned) &PIR5)*8) + 0;
#define                                 PID1DIF_bit         BANKMASK(PIR5), 0
extern volatile __bit                   PID1EIE             @ (((unsigned) &PIE5)*8) + 1;
#define                                 PID1EIE_bit         BANKMASK(PIE5), 1
extern volatile __bit                   PID1EIF             @ (((unsigned) &PIR5)*8) + 1;
#define                                 PID1EIF_bit         BANKMASK(PIR5), 1
extern volatile __bit                   PID1EN              @ (((unsigned) &PID1CON)*8) + 7;
#define                                 PID1EN_bit          BANKMASK(PID1CON), 7
extern volatile __bit                   PID1IN0             @ (((unsigned) &PID1INL)*8) + 0;
#define                                 PID1IN0_bit         BANKMASK(PID1INL), 0
extern volatile __bit                   PID1IN1             @ (((unsigned) &PID1INL)*8) + 1;
#define                                 PID1IN1_bit         BANKMASK(PID1INL), 1
extern volatile __bit                   PID1IN10            @ (((unsigned) &PID1INH)*8) + 2;
#define                                 PID1IN10_bit        BANKMASK(PID1INH), 2
extern volatile __bit                   PID1IN11            @ (((unsigned) &PID1INH)*8) + 3;
#define                                 PID1IN11_bit        BANKMASK(PID1INH), 3
extern volatile __bit                   PID1IN12            @ (((unsigned) &PID1INH)*8) + 4;
#define                                 PID1IN12_bit        BANKMASK(PID1INH), 4
extern volatile __bit                   PID1IN13            @ (((unsigned) &PID1INH)*8) + 5;
#define                                 PID1IN13_bit        BANKMASK(PID1INH), 5
extern volatile __bit                   PID1IN14            @ (((unsigned) &PID1INH)*8) + 6;
#define                                 PID1IN14_bit        BANKMASK(PID1INH), 6
extern volatile __bit                   PID1IN15            @ (((unsigned) &PID1INH)*8) + 7;
#define                                 PID1IN15_bit        BANKMASK(PID1INH), 7
extern volatile __bit                   PID1IN2             @ (((unsigned) &PID1INL)*8) + 2;
#define                                 PID1IN2_bit         BANKMASK(PID1INL), 2
extern volatile __bit                   PID1IN3             @ (((unsigned) &PID1INL)*8) + 3;
#define                                 PID1IN3_bit         BANKMASK(PID1INL), 3
extern volatile __bit                   PID1IN4             @ (((unsigned) &PID1INL)*8) + 4;
#define                                 PID1IN4_bit         BANKMASK(PID1INL), 4
extern volatile __bit                   PID1IN5             @ (((unsigned) &PID1INL)*8) + 5;
#define                                 PID1IN5_bit         BANKMASK(PID1INL), 5
extern volatile __bit                   PID1IN6             @ (((unsigned) &PID1INL)*8) + 6;
#define                                 PID1IN6_bit         BANKMASK(PID1INL), 6
extern volatile __bit                   PID1IN7             @ (((unsigned) &PID1INL)*8) + 7;
#define                                 PID1IN7_bit         BANKMASK(PID1INL), 7
extern volatile __bit                   PID1IN8             @ (((unsigned) &PID1INH)*8) + 0;
#define                                 PID1IN8_bit         BANKMASK(PID1INH), 0
extern volatile __bit                   PID1IN9             @ (((unsigned) &PID1INH)*8) + 1;
#define                                 PID1IN9_bit         BANKMASK(PID1INH), 1
extern volatile __bit                   PID1K10             @ (((unsigned) &PID1K1L)*8) + 0;
#define                                 PID1K10_bit         BANKMASK(PID1K1L), 0
extern volatile __bit                   PID1K11             @ (((unsigned) &PID1K1L)*8) + 1;
#define                                 PID1K11_bit         BANKMASK(PID1K1L), 1
extern volatile __bit                   PID1K110            @ (((unsigned) &PID1K1H)*8) + 2;
#define                                 PID1K110_bit        BANKMASK(PID1K1H), 2
extern volatile __bit                   PID1K111            @ (((unsigned) &PID1K1H)*8) + 3;
#define                                 PID1K111_bit        BANKMASK(PID1K1H), 3
extern volatile __bit                   PID1K112            @ (((unsigned) &PID1K1H)*8) + 4;
#define                                 PID1K112_bit        BANKMASK(PID1K1H), 4
extern volatile __bit                   PID1K113            @ (((unsigned) &PID1K1H)*8) + 5;
#define                                 PID1K113_bit        BANKMASK(PID1K1H), 5
extern volatile __bit                   PID1K114            @ (((unsigned) &PID1K1H)*8) + 6;
#define                                 PID1K114_bit        BANKMASK(PID1K1H), 6
extern volatile __bit                   PID1K115            @ (((unsigned) &PID1K1H)*8) + 7;
#define                                 PID1K115_bit        BANKMASK(PID1K1H), 7
extern volatile __bit                   PID1K12             @ (((unsigned) &PID1K1L)*8) + 2;
#define                                 PID1K12_bit         BANKMASK(PID1K1L), 2
extern volatile __bit                   PID1K13             @ (((unsigned) &PID1K1L)*8) + 3;
#define                                 PID1K13_bit         BANKMASK(PID1K1L), 3
extern volatile __bit                   PID1K14             @ (((unsigned) &PID1K1L)*8) + 4;
#define                                 PID1K14_bit         BANKMASK(PID1K1L), 4
extern volatile __bit                   PID1K15             @ (((unsigned) &PID1K1L)*8) + 5;
#define                                 PID1K15_bit         BANKMASK(PID1K1L), 5
extern volatile __bit                   PID1K16             @ (((unsigned) &PID1K1L)*8) + 6;
#define                                 PID1K16_bit         BANKMASK(PID1K1L), 6
extern volatile __bit                   PID1K17             @ (((unsigned) &PID1K1L)*8) + 7;
#define                                 PID1K17_bit         BANKMASK(PID1K1L), 7
extern volatile __bit                   PID1K18             @ (((unsigned) &PID1K1H)*8) + 0;
#define                                 PID1K18_bit         BANKMASK(PID1K1H), 0
extern volatile __bit                   PID1K19             @ (((unsigned) &PID1K1H)*8) + 1;
#define                                 PID1K19_bit         BANKMASK(PID1K1H), 1
extern volatile __bit                   PID1K20             @ (((unsigned) &PID1K2L)*8) + 0;
#define                                 PID1K20_bit         BANKMASK(PID1K2L), 0
extern volatile __bit                   PID1K21             @ (((unsigned) &PID1K2L)*8) + 1;
#define                                 PID1K21_bit         BANKMASK(PID1K2L), 1
extern volatile __bit                   PID1K210            @ (((unsigned) &PID1K2H)*8) + 2;
#define                                 PID1K210_bit        BANKMASK(PID1K2H), 2
extern volatile __bit                   PID1K211            @ (((unsigned) &PID1K2H)*8) + 3;
#define                                 PID1K211_bit        BANKMASK(PID1K2H), 3
extern volatile __bit                   PID1K212            @ (((unsigned) &PID1K2H)*8) + 4;
#define                                 PID1K212_bit        BANKMASK(PID1K2H), 4
extern volatile __bit                   PID1K213            @ (((unsigned) &PID1K2H)*8) + 5;
#define                                 PID1K213_bit        BANKMASK(PID1K2H), 5
extern volatile __bit                   PID1K214            @ (((unsigned) &PID1K2H)*8) + 6;
#define                                 PID1K214_bit        BANKMASK(PID1K2H), 6
extern volatile __bit                   PID1K215            @ (((unsigned) &PID1K2H)*8) + 7;
#define                                 PID1K215_bit        BANKMASK(PID1K2H), 7
extern volatile __bit                   PID1K22             @ (((unsigned) &PID1K2L)*8) + 2;
#define                                 PID1K22_bit         BANKMASK(PID1K2L), 2
extern volatile __bit                   PID1K23             @ (((unsigned) &PID1K2L)*8) + 3;
#define                                 PID1K23_bit         BANKMASK(PID1K2L), 3
extern volatile __bit                   PID1K24             @ (((unsigned) &PID1K2L)*8) + 4;
#define                                 PID1K24_bit         BANKMASK(PID1K2L), 4
extern volatile __bit                   PID1K25             @ (((unsigned) &PID1K2L)*8) + 5;
#define                                 PID1K25_bit         BANKMASK(PID1K2L), 5
extern volatile __bit                   PID1K26             @ (((unsigned) &PID1K2L)*8) + 6;
#define                                 PID1K26_bit         BANKMASK(PID1K2L), 6
extern volatile __bit                   PID1K27             @ (((unsigned) &PID1K2L)*8) + 7;
#define                                 PID1K27_bit         BANKMASK(PID1K2L), 7
extern volatile __bit                   PID1K28             @ (((unsigned) &PID1K2H)*8) + 0;
#define                                 PID1K28_bit         BANKMASK(PID1K2H), 0
extern volatile __bit                   PID1K29             @ (((unsigned) &PID1K2H)*8) + 1;
#define                                 PID1K29_bit         BANKMASK(PID1K2H), 1
extern volatile __bit                   PID1K30             @ (((unsigned) &PID1K3L)*8) + 0;
#define                                 PID1K30_bit         BANKMASK(PID1K3L), 0
extern volatile __bit                   PID1K31             @ (((unsigned) &PID1K3L)*8) + 1;
#define                                 PID1K31_bit         BANKMASK(PID1K3L), 1
extern volatile __bit                   PID1K310            @ (((unsigned) &PID1K3H)*8) + 2;
#define                                 PID1K310_bit        BANKMASK(PID1K3H), 2
extern volatile __bit                   PID1K311            @ (((unsigned) &PID1K3H)*8) + 3;
#define                                 PID1K311_bit        BANKMASK(PID1K3H), 3
extern volatile __bit                   PID1K312            @ (((unsigned) &PID1K3H)*8) + 4;
#define                                 PID1K312_bit        BANKMASK(PID1K3H), 4
extern volatile __bit                   PID1K313            @ (((unsigned) &PID1K3H)*8) + 5;
#define                                 PID1K313_bit        BANKMASK(PID1K3H), 5
extern volatile __bit                   PID1K314            @ (((unsigned) &PID1K3H)*8) + 6;
#define                                 PID1K314_bit        BANKMASK(PID1K3H), 6
extern volatile __bit                   PID1K315            @ (((unsigned) &PID1K3H)*8) + 7;
#define                                 PID1K315_bit        BANKMASK(PID1K3H), 7
extern volatile __bit                   PID1K32             @ (((unsigned) &PID1K3L)*8) + 2;
#define                                 PID1K32_bit         BANKMASK(PID1K3L), 2
extern volatile __bit                   PID1K33             @ (((unsigned) &PID1K3L)*8) + 3;
#define                                 PID1K33_bit         BANKMASK(PID1K3L), 3
extern volatile __bit                   PID1K34             @ (((unsigned) &PID1K3L)*8) + 4;
#define                                 PID1K34_bit         BANKMASK(PID1K3L), 4
extern volatile __bit                   PID1K35             @ (((unsigned) &PID1K3L)*8) + 5;
#define                                 PID1K35_bit         BANKMASK(PID1K3L), 5
extern volatile __bit                   PID1K36             @ (((unsigned) &PID1K3L)*8) + 6;
#define                                 PID1K36_bit         BANKMASK(PID1K3L), 6
extern volatile __bit                   PID1K37             @ (((unsigned) &PID1K3L)*8) + 7;
#define                                 PID1K37_bit         BANKMASK(PID1K3L), 7
extern volatile __bit                   PID1K38             @ (((unsigned) &PID1K3H)*8) + 0;
#define                                 PID1K38_bit         BANKMASK(PID1K3H), 0
extern volatile __bit                   PID1K39             @ (((unsigned) &PID1K3H)*8) + 1;
#define                                 PID1K39_bit         BANKMASK(PID1K3H), 1
extern volatile __bit                   PID1MODE0           @ (((unsigned) &PID1CON)*8) + 0;
#define                                 PID1MODE0_bit       BANKMASK(PID1CON), 0
extern volatile __bit                   PID1MODE1           @ (((unsigned) &PID1CON)*8) + 1;
#define                                 PID1MODE1_bit       BANKMASK(PID1CON), 1
extern volatile __bit                   PID1MODE2           @ (((unsigned) &PID1CON)*8) + 2;
#define                                 PID1MODE2_bit       BANKMASK(PID1CON), 2
extern volatile __bit                   PID1OUT0            @ (((unsigned) &PID1OUTLL)*8) + 0;
#define                                 PID1OUT0_bit        BANKMASK(PID1OUTLL), 0
extern volatile __bit                   PID1OUT1            @ (((unsigned) &PID1OUTLL)*8) + 1;
#define                                 PID1OUT1_bit        BANKMASK(PID1OUTLL), 1
extern volatile __bit                   PID1OUT10           @ (((unsigned) &PID1OUTLH)*8) + 2;
#define                                 PID1OUT10_bit       BANKMASK(PID1OUTLH), 2
extern volatile __bit                   PID1OUT11           @ (((unsigned) &PID1OUTLH)*8) + 3;
#define                                 PID1OUT11_bit       BANKMASK(PID1OUTLH), 3
extern volatile __bit                   PID1OUT12           @ (((unsigned) &PID1OUTLH)*8) + 4;
#define                                 PID1OUT12_bit       BANKMASK(PID1OUTLH), 4
extern volatile __bit                   PID1OUT13           @ (((unsigned) &PID1OUTLH)*8) + 5;
#define                                 PID1OUT13_bit       BANKMASK(PID1OUTLH), 5
extern volatile __bit                   PID1OUT14           @ (((unsigned) &PID1OUTLH)*8) + 6;
#define                                 PID1OUT14_bit       BANKMASK(PID1OUTLH), 6
extern volatile __bit                   PID1OUT15           @ (((unsigned) &PID1OUTLH)*8) + 7;
#define                                 PID1OUT15_bit       BANKMASK(PID1OUTLH), 7
extern volatile __bit                   PID1OUT16           @ (((unsigned) &PID1OUTHL)*8) + 0;
#define                                 PID1OUT16_bit       BANKMASK(PID1OUTHL), 0
extern volatile __bit                   PID1OUT17           @ (((unsigned) &PID1OUTHL)*8) + 1;
#define                                 PID1OUT17_bit       BANKMASK(PID1OUTHL), 1
extern volatile __bit                   PID1OUT18           @ (((unsigned) &PID1OUTHL)*8) + 2;
#define                                 PID1OUT18_bit       BANKMASK(PID1OUTHL), 2
extern volatile __bit                   PID1OUT19           @ (((unsigned) &PID1OUTHL)*8) + 3;
#define                                 PID1OUT19_bit       BANKMASK(PID1OUTHL), 3
extern volatile __bit                   PID1OUT2            @ (((unsigned) &PID1OUTLL)*8) + 2;
#define                                 PID1OUT2_bit        BANKMASK(PID1OUTLL), 2
extern volatile __bit                   PID1OUT20           @ (((unsigned) &PID1OUTHL)*8) + 4;
#define                                 PID1OUT20_bit       BANKMASK(PID1OUTHL), 4
extern volatile __bit                   PID1OUT21           @ (((unsigned) &PID1OUTHL)*8) + 5;
#define                                 PID1OUT21_bit       BANKMASK(PID1OUTHL), 5
extern volatile __bit                   PID1OUT22           @ (((unsigned) &PID1OUTHL)*8) + 6;
#define                                 PID1OUT22_bit       BANKMASK(PID1OUTHL), 6
extern volatile __bit                   PID1OUT23           @ (((unsigned) &PID1OUTHL)*8) + 7;
#define                                 PID1OUT23_bit       BANKMASK(PID1OUTHL), 7
extern volatile __bit                   PID1OUT24           @ (((unsigned) &PID1OUTHH)*8) + 0;
#define                                 PID1OUT24_bit       BANKMASK(PID1OUTHH), 0
extern volatile __bit                   PID1OUT25           @ (((unsigned) &PID1OUTHH)*8) + 1;
#define                                 PID1OUT25_bit       BANKMASK(PID1OUTHH), 1
extern volatile __bit                   PID1OUT26           @ (((unsigned) &PID1OUTHH)*8) + 2;
#define                                 PID1OUT26_bit       BANKMASK(PID1OUTHH), 2
extern volatile __bit                   PID1OUT27           @ (((unsigned) &PID1OUTHH)*8) + 3;
#define                                 PID1OUT27_bit       BANKMASK(PID1OUTHH), 3
extern volatile __bit                   PID1OUT28           @ (((unsigned) &PID1OUTHH)*8) + 4;
#define                                 PID1OUT28_bit       BANKMASK(PID1OUTHH), 4
extern volatile __bit                   PID1OUT29           @ (((unsigned) &PID1OUTHH)*8) + 5;
#define                                 PID1OUT29_bit       BANKMASK(PID1OUTHH), 5
extern volatile __bit                   PID1OUT3            @ (((unsigned) &PID1OUTLL)*8) + 3;
#define                                 PID1OUT3_bit        BANKMASK(PID1OUTLL), 3
extern volatile __bit                   PID1OUT30           @ (((unsigned) &PID1OUTHH)*8) + 6;
#define                                 PID1OUT30_bit       BANKMASK(PID1OUTHH), 6
extern volatile __bit                   PID1OUT31           @ (((unsigned) &PID1OUTHH)*8) + 7;
#define                                 PID1OUT31_bit       BANKMASK(PID1OUTHH), 7
extern volatile __bit                   PID1OUT32           @ (((unsigned) &PID1OUTU)*8) + 0;
#define                                 PID1OUT32_bit       BANKMASK(PID1OUTU), 0
extern volatile __bit                   PID1OUT33           @ (((unsigned) &PID1OUTU)*8) + 1;
#define                                 PID1OUT33_bit       BANKMASK(PID1OUTU), 1
extern volatile __bit                   PID1OUT34           @ (((unsigned) &PID1OUTU)*8) + 2;
#define                                 PID1OUT34_bit       BANKMASK(PID1OUTU), 2
extern volatile __bit                   PID1OUT35           @ (((unsigned) &PID1OUTU)*8) + 3;
#define                                 PID1OUT35_bit       BANKMASK(PID1OUTU), 3
extern volatile __bit                   PID1OUT4            @ (((unsigned) &PID1OUTLL)*8) + 4;
#define                                 PID1OUT4_bit        BANKMASK(PID1OUTLL), 4
extern volatile __bit                   PID1OUT5            @ (((unsigned) &PID1OUTLL)*8) + 5;
#define                                 PID1OUT5_bit        BANKMASK(PID1OUTLL), 5
extern volatile __bit                   PID1OUT6            @ (((unsigned) &PID1OUTLL)*8) + 6;
#define                                 PID1OUT6_bit        BANKMASK(PID1OUTLL), 6
extern volatile __bit                   PID1OUT7            @ (((unsigned) &PID1OUTLL)*8) + 7;
#define                                 PID1OUT7_bit        BANKMASK(PID1OUTLL), 7
extern volatile __bit                   PID1OUT8            @ (((unsigned) &PID1OUTLH)*8) + 0;
#define                                 PID1OUT8_bit        BANKMASK(PID1OUTLH), 0
extern volatile __bit                   PID1OUT9            @ (((unsigned) &PID1OUTLH)*8) + 1;
#define                                 PID1OUT9_bit        BANKMASK(PID1OUTLH), 1
extern volatile __bit                   PID1SET0            @ (((unsigned) &PID1SETL)*8) + 0;
#define                                 PID1SET0_bit        BANKMASK(PID1SETL), 0
extern volatile __bit                   PID1SET1            @ (((unsigned) &PID1SETL)*8) + 1;
#define                                 PID1SET1_bit        BANKMASK(PID1SETL), 1
extern volatile __bit                   PID1SET10           @ (((unsigned) &PID1SETH)*8) + 2;
#define                                 PID1SET10_bit       BANKMASK(PID1SETH), 2
extern volatile __bit                   PID1SET11           @ (((unsigned) &PID1SETH)*8) + 3;
#define                                 PID1SET11_bit       BANKMASK(PID1SETH), 3
extern volatile __bit                   PID1SET12           @ (((unsigned) &PID1SETH)*8) + 4;
#define                                 PID1SET12_bit       BANKMASK(PID1SETH), 4
extern volatile __bit                   PID1SET13           @ (((unsigned) &PID1SETH)*8) + 5;
#define                                 PID1SET13_bit       BANKMASK(PID1SETH), 5
extern volatile __bit                   PID1SET14           @ (((unsigned) &PID1SETH)*8) + 6;
#define                                 PID1SET14_bit       BANKMASK(PID1SETH), 6
extern volatile __bit                   PID1SET15           @ (((unsigned) &PID1SETH)*8) + 7;
#define                                 PID1SET15_bit       BANKMASK(PID1SETH), 7
extern volatile __bit                   PID1SET2            @ (((unsigned) &PID1SETL)*8) + 2;
#define                                 PID1SET2_bit        BANKMASK(PID1SETL), 2
extern volatile __bit                   PID1SET3            @ (((unsigned) &PID1SETL)*8) + 3;
#define                                 PID1SET3_bit        BANKMASK(PID1SETL), 3
extern volatile __bit                   PID1SET4            @ (((unsigned) &PID1SETL)*8) + 4;
#define                                 PID1SET4_bit        BANKMASK(PID1SETL), 4
extern volatile __bit                   PID1SET5            @ (((unsigned) &PID1SETL)*8) + 5;
#define                                 PID1SET5_bit        BANKMASK(PID1SETL), 5
extern volatile __bit                   PID1SET6            @ (((unsigned) &PID1SETL)*8) + 6;
#define                                 PID1SET6_bit        BANKMASK(PID1SETL), 6
extern volatile __bit                   PID1SET7            @ (((unsigned) &PID1SETL)*8) + 7;
#define                                 PID1SET7_bit        BANKMASK(PID1SETL), 7
extern volatile __bit                   PID1SET8            @ (((unsigned) &PID1SETH)*8) + 0;
#define                                 PID1SET8_bit        BANKMASK(PID1SETH), 0
extern volatile __bit                   PID1SET9            @ (((unsigned) &PID1SETH)*8) + 1;
#define                                 PID1SET9_bit        BANKMASK(PID1SETH), 1
extern volatile __bit                   PID1Z10             @ (((unsigned) &PID1Z1L)*8) + 0;
#define                                 PID1Z10_bit         BANKMASK(PID1Z1L), 0
extern volatile __bit                   PID1Z11             @ (((unsigned) &PID1Z1L)*8) + 1;
#define                                 PID1Z11_bit         BANKMASK(PID1Z1L), 1
extern volatile __bit                   PID1Z110            @ (((unsigned) &PID1Z1H)*8) + 2;
#define                                 PID1Z110_bit        BANKMASK(PID1Z1H), 2
extern volatile __bit                   PID1Z111            @ (((unsigned) &PID1Z1H)*8) + 3;
#define                                 PID1Z111_bit        BANKMASK(PID1Z1H), 3
extern volatile __bit                   PID1Z112            @ (((unsigned) &PID1Z1H)*8) + 4;
#define                                 PID1Z112_bit        BANKMASK(PID1Z1H), 4
extern volatile __bit                   PID1Z113            @ (((unsigned) &PID1Z1H)*8) + 5;
#define                                 PID1Z113_bit        BANKMASK(PID1Z1H), 5
extern volatile __bit                   PID1Z114            @ (((unsigned) &PID1Z1H)*8) + 6;
#define                                 PID1Z114_bit        BANKMASK(PID1Z1H), 6
extern volatile __bit                   PID1Z115            @ (((unsigned) &PID1Z1H)*8) + 7;
#define                                 PID1Z115_bit        BANKMASK(PID1Z1H), 7
extern volatile __bit                   PID1Z116            @ (((unsigned) &PID1Z1U)*8) + 0;
#define                                 PID1Z116_bit        BANKMASK(PID1Z1U), 0
extern volatile __bit                   PID1Z12             @ (((unsigned) &PID1Z1L)*8) + 2;
#define                                 PID1Z12_bit         BANKMASK(PID1Z1L), 2
extern volatile __bit                   PID1Z13             @ (((unsigned) &PID1Z1L)*8) + 3;
#define                                 PID1Z13_bit         BANKMASK(PID1Z1L), 3
extern volatile __bit                   PID1Z14             @ (((unsigned) &PID1Z1L)*8) + 4;
#define                                 PID1Z14_bit         BANKMASK(PID1Z1L), 4
extern volatile __bit                   PID1Z15             @ (((unsigned) &PID1Z1L)*8) + 5;
#define                                 PID1Z15_bit         BANKMASK(PID1Z1L), 5
extern volatile __bit                   PID1Z16             @ (((unsigned) &PID1Z1L)*8) + 6;
#define                                 PID1Z16_bit         BANKMASK(PID1Z1L), 6
extern volatile __bit                   PID1Z17             @ (((unsigned) &PID1Z1L)*8) + 7;
#define                                 PID1Z17_bit         BANKMASK(PID1Z1L), 7
extern volatile __bit                   PID1Z18             @ (((unsigned) &PID1Z1H)*8) + 0;
#define                                 PID1Z18_bit         BANKMASK(PID1Z1H), 0
extern volatile __bit                   PID1Z19             @ (((unsigned) &PID1Z1H)*8) + 1;
#define                                 PID1Z19_bit         BANKMASK(PID1Z1H), 1
extern volatile __bit                   PID1Z20             @ (((unsigned) &PID1Z2L)*8) + 0;
#define                                 PID1Z20_bit         BANKMASK(PID1Z2L), 0
extern volatile __bit                   PID1Z21             @ (((unsigned) &PID1Z2L)*8) + 1;
#define                                 PID1Z21_bit         BANKMASK(PID1Z2L), 1
extern volatile __bit                   PID1Z210            @ (((unsigned) &PID1Z2H)*8) + 2;
#define                                 PID1Z210_bit        BANKMASK(PID1Z2H), 2
extern volatile __bit                   PID1Z211            @ (((unsigned) &PID1Z2H)*8) + 3;
#define                                 PID1Z211_bit        BANKMASK(PID1Z2H), 3
extern volatile __bit                   PID1Z212            @ (((unsigned) &PID1Z2H)*8) + 4;
#define                                 PID1Z212_bit        BANKMASK(PID1Z2H), 4
extern volatile __bit                   PID1Z213            @ (((unsigned) &PID1Z2H)*8) + 5;
#define                                 PID1Z213_bit        BANKMASK(PID1Z2H), 5
extern volatile __bit                   PID1Z214            @ (((unsigned) &PID1Z2H)*8) + 6;
#define                                 PID1Z214_bit        BANKMASK(PID1Z2H), 6
extern volatile __bit                   PID1Z215            @ (((unsigned) &PID1Z2H)*8) + 7;
#define                                 PID1Z215_bit        BANKMASK(PID1Z2H), 7
extern volatile __bit                   PID1Z216            @ (((unsigned) &PID1Z2U)*8) + 0;
#define                                 PID1Z216_bit        BANKMASK(PID1Z2U), 0
extern volatile __bit                   PID1Z22             @ (((unsigned) &PID1Z2L)*8) + 2;
#define                                 PID1Z22_bit         BANKMASK(PID1Z2L), 2
extern volatile __bit                   PID1Z23             @ (((unsigned) &PID1Z2L)*8) + 3;
#define                                 PID1Z23_bit         BANKMASK(PID1Z2L), 3
extern volatile __bit                   PID1Z24             @ (((unsigned) &PID1Z2L)*8) + 4;
#define                                 PID1Z24_bit         BANKMASK(PID1Z2L), 4
extern volatile __bit                   PID1Z25             @ (((unsigned) &PID1Z2L)*8) + 5;
#define                                 PID1Z25_bit         BANKMASK(PID1Z2L), 5
extern volatile __bit                   PID1Z26             @ (((unsigned) &PID1Z2L)*8) + 6;
#define                                 PID1Z26_bit         BANKMASK(PID1Z2L), 6
extern volatile __bit                   PID1Z27             @ (((unsigned) &PID1Z2L)*8) + 7;
#define                                 PID1Z27_bit         BANKMASK(PID1Z2L), 7
extern volatile __bit                   PID1Z28             @ (((unsigned) &PID1Z2H)*8) + 0;
#define                                 PID1Z28_bit         BANKMASK(PID1Z2H), 0
extern volatile __bit                   PID1Z29             @ (((unsigned) &PID1Z2H)*8) + 1;
#define                                 PID1Z29_bit         BANKMASK(PID1Z2H), 1
extern volatile __bit                   PLEN0               @ (((unsigned) &CRCCON1)*8) + 0;
#define                                 PLEN0_bit           BANKMASK(CRCCON1), 0
extern volatile __bit                   PLEN1               @ (((unsigned) &CRCCON1)*8) + 1;
#define                                 PLEN1_bit           BANKMASK(CRCCON1), 1
extern volatile __bit                   PLEN2               @ (((unsigned) &CRCCON1)*8) + 2;
#define                                 PLEN2_bit           BANKMASK(CRCCON1), 2
extern volatile __bit                   PLEN3               @ (((unsigned) &CRCCON1)*8) + 3;
#define                                 PLEN3_bit           BANKMASK(CRCCON1), 3
extern volatile __bit                   PLLR                @ (((unsigned) &OSCSTAT)*8) + 6;
#define                                 PLLR_bit            BANKMASK(OSCSTAT), 6
extern volatile __bit                   POLA                @ (((unsigned) &CWG1CON1)*8) + 0;
#define                                 POLA_bit            BANKMASK(CWG1CON1), 0
extern volatile __bit                   POLB                @ (((unsigned) &CWG1CON1)*8) + 1;
#define                                 POLB_bit            BANKMASK(CWG1CON1), 1
extern volatile __bit                   POLC                @ (((unsigned) &CWG1CON1)*8) + 2;
#define                                 POLC_bit            BANKMASK(CWG1CON1), 2
extern volatile __bit                   POLD                @ (((unsigned) &CWG1CON1)*8) + 3;
#define                                 POLD_bit            BANKMASK(CWG1CON1), 3
extern volatile __bit                   PPSLOCKED           @ (((unsigned) &PPSLOCK)*8) + 0;
#define                                 PPSLOCKED_bit       BANKMASK(PPSLOCK), 0
extern volatile __bit                   PREC                @ (((unsigned) &AT1CON0)*8) + 6;
#define                                 PREC_bit            BANKMASK(AT1CON0), 6
extern volatile __bit                   PRP                 @ (((unsigned) &AT1CON1)*8) + 4;
#define                                 PRP_bit             BANKMASK(AT1CON1), 4
extern volatile __bit                   PS2                 @ (((unsigned) &OPTION_REG)*8) + 2;
#define                                 PS2_bit             BANKMASK(OPTION_REG), 2
extern volatile __bit                   PSA                 @ (((unsigned) &OPTION_REG)*8) + 3;
#define                                 PSA_bit             BANKMASK(OPTION_REG), 3
extern volatile __bit                   PSCNT0              @ (((unsigned) &WDTPSL)*8) + 0;
#define                                 PSCNT0_bit          BANKMASK(WDTPSL), 0
extern volatile __bit                   PSCNT1              @ (((unsigned) &WDTPSL)*8) + 1;
#define                                 PSCNT1_bit          BANKMASK(WDTPSL), 1
extern volatile __bit                   PSCNT10             @ (((unsigned) &WDTPSH)*8) + 2;
#define                                 PSCNT10_bit         BANKMASK(WDTPSH), 2
extern volatile __bit                   PSCNT11             @ (((unsigned) &WDTPSH)*8) + 3;
#define                                 PSCNT11_bit         BANKMASK(WDTPSH), 3
extern volatile __bit                   PSCNT12             @ (((unsigned) &WDTPSH)*8) + 4;
#define                                 PSCNT12_bit         BANKMASK(WDTPSH), 4
extern volatile __bit                   PSCNT13             @ (((unsigned) &WDTPSH)*8) + 5;
#define                                 PSCNT13_bit         BANKMASK(WDTPSH), 5
extern volatile __bit                   PSCNT14             @ (((unsigned) &WDTPSH)*8) + 6;
#define                                 PSCNT14_bit         BANKMASK(WDTPSH), 6
extern volatile __bit                   PSCNT15             @ (((unsigned) &WDTPSH)*8) + 7;
#define                                 PSCNT15_bit         BANKMASK(WDTPSH), 7
extern volatile __bit                   PSCNT16             @ (((unsigned) &WDTTMR)*8) + 0;
#define                                 PSCNT16_bit         BANKMASK(WDTTMR), 0
extern volatile __bit                   PSCNT17             @ (((unsigned) &WDTTMR)*8) + 1;
#define                                 PSCNT17_bit         BANKMASK(WDTTMR), 1
extern volatile __bit                   PSCNT2              @ (((unsigned) &WDTPSL)*8) + 2;
#define                                 PSCNT2_bit          BANKMASK(WDTPSL), 2
extern volatile __bit                   PSCNT3              @ (((unsigned) &WDTPSL)*8) + 3;
#define                                 PSCNT3_bit          BANKMASK(WDTPSL), 3
extern volatile __bit                   PSCNT4              @ (((unsigned) &WDTPSL)*8) + 4;
#define                                 PSCNT4_bit          BANKMASK(WDTPSL), 4
extern volatile __bit                   PSCNT5              @ (((unsigned) &WDTPSL)*8) + 5;
#define                                 PSCNT5_bit          BANKMASK(WDTPSL), 5
extern volatile __bit                   PSCNT6              @ (((unsigned) &WDTPSL)*8) + 6;
#define                                 PSCNT6_bit          BANKMASK(WDTPSL), 6
extern volatile __bit                   PSCNT7              @ (((unsigned) &WDTPSL)*8) + 7;
#define                                 PSCNT7_bit          BANKMASK(WDTPSL), 7
extern volatile __bit                   PSCNT8              @ (((unsigned) &WDTPSH)*8) + 0;
#define                                 PSCNT8_bit          BANKMASK(WDTPSH), 0
extern volatile __bit                   PSCNT9              @ (((unsigned) &WDTPSH)*8) + 1;
#define                                 PSCNT9_bit          BANKMASK(WDTPSH), 1
extern volatile __bit                   PWM3DC0             @ (((unsigned) &PWM3DCL)*8) + 6;
#define                                 PWM3DC0_bit         BANKMASK(PWM3DCL), 6
extern volatile __bit                   PWM3DC1             @ (((unsigned) &PWM3DCL)*8) + 7;
#define                                 PWM3DC1_bit         BANKMASK(PWM3DCL), 7
extern volatile __bit                   PWM3DC2             @ (((unsigned) &PWM3DCH)*8) + 0;
#define                                 PWM3DC2_bit         BANKMASK(PWM3DCH), 0
extern volatile __bit                   PWM3DC3             @ (((unsigned) &PWM3DCH)*8) + 1;
#define                                 PWM3DC3_bit         BANKMASK(PWM3DCH), 1
extern volatile __bit                   PWM3DC4             @ (((unsigned) &PWM3DCH)*8) + 2;
#define                                 PWM3DC4_bit         BANKMASK(PWM3DCH), 2
extern volatile __bit                   PWM3DC5             @ (((unsigned) &PWM3DCH)*8) + 3;
#define                                 PWM3DC5_bit         BANKMASK(PWM3DCH), 3
extern volatile __bit                   PWM3DC6             @ (((unsigned) &PWM3DCH)*8) + 4;
#define                                 PWM3DC6_bit         BANKMASK(PWM3DCH), 4
extern volatile __bit                   PWM3DC7             @ (((unsigned) &PWM3DCH)*8) + 5;
#define                                 PWM3DC7_bit         BANKMASK(PWM3DCH), 5
extern volatile __bit                   PWM3DC8             @ (((unsigned) &PWM3DCH)*8) + 6;
#define                                 PWM3DC8_bit         BANKMASK(PWM3DCH), 6
extern volatile __bit                   PWM3DC9             @ (((unsigned) &PWM3DCH)*8) + 7;
#define                                 PWM3DC9_bit         BANKMASK(PWM3DCH), 7
extern volatile __bit                   PWM3EN              @ (((unsigned) &PWM3CON)*8) + 7;
#define                                 PWM3EN_bit          BANKMASK(PWM3CON), 7
extern volatile __bit                   PWM3OUT             @ (((unsigned) &PWM3CON)*8) + 5;
#define                                 PWM3OUT_bit         BANKMASK(PWM3CON), 5
extern volatile __bit                   PWM3POL             @ (((unsigned) &PWM3CON)*8) + 4;
#define                                 PWM3POL_bit         BANKMASK(PWM3CON), 4
extern volatile __bit                   PWM4DC0             @ (((unsigned) &PWM4DCL)*8) + 6;
#define                                 PWM4DC0_bit         BANKMASK(PWM4DCL), 6
extern volatile __bit                   PWM4DC1             @ (((unsigned) &PWM4DCL)*8) + 7;
#define                                 PWM4DC1_bit         BANKMASK(PWM4DCL), 7
extern volatile __bit                   PWM4DC2             @ (((unsigned) &PWM4DCH)*8) + 0;
#define                                 PWM4DC2_bit         BANKMASK(PWM4DCH), 0
extern volatile __bit                   PWM4DC3             @ (((unsigned) &PWM4DCH)*8) + 1;
#define                                 PWM4DC3_bit         BANKMASK(PWM4DCH), 1
extern volatile __bit                   PWM4DC4             @ (((unsigned) &PWM4DCH)*8) + 2;
#define                                 PWM4DC4_bit         BANKMASK(PWM4DCH), 2
extern volatile __bit                   PWM4DC5             @ (((unsigned) &PWM4DCH)*8) + 3;
#define                                 PWM4DC5_bit         BANKMASK(PWM4DCH), 3
extern volatile __bit                   PWM4DC6             @ (((unsigned) &PWM4DCH)*8) + 4;
#define                                 PWM4DC6_bit         BANKMASK(PWM4DCH), 4
extern volatile __bit                   PWM4DC7             @ (((unsigned) &PWM4DCH)*8) + 5;
#define                                 PWM4DC7_bit         BANKMASK(PWM4DCH), 5
extern volatile __bit                   PWM4DC8             @ (((unsigned) &PWM4DCH)*8) + 6;
#define                                 PWM4DC8_bit         BANKMASK(PWM4DCH), 6
extern volatile __bit                   PWM4DC9             @ (((unsigned) &PWM4DCH)*8) + 7;
#define                                 PWM4DC9_bit         BANKMASK(PWM4DCH), 7
extern volatile __bit                   PWM4EN              @ (((unsigned) &PWM4CON)*8) + 7;
#define                                 PWM4EN_bit          BANKMASK(PWM4CON), 7
extern volatile __bit                   PWM4OUT             @ (((unsigned) &PWM4CON)*8) + 5;
#define                                 PWM4OUT_bit         BANKMASK(PWM4CON), 5
extern volatile __bit                   PWM4POL             @ (((unsigned) &PWM4CON)*8) + 4;
#define                                 PWM4POL_bit         BANKMASK(PWM4CON), 4
extern volatile __bit                   RA0                 @ (((unsigned) &PORTA)*8) + 0;
#define                                 RA0_bit             BANKMASK(PORTA), 0
extern volatile __bit                   RA0PPS0             @ (((unsigned) &RA0PPS)*8) + 0;
#define                                 RA0PPS0_bit         BANKMASK(RA0PPS), 0
extern volatile __bit                   RA0PPS1             @ (((unsigned) &RA0PPS)*8) + 1;
#define                                 RA0PPS1_bit         BANKMASK(RA0PPS), 1
extern volatile __bit                   RA0PPS2             @ (((unsigned) &RA0PPS)*8) + 2;
#define                                 RA0PPS2_bit         BANKMASK(RA0PPS), 2
extern volatile __bit                   RA0PPS3             @ (((unsigned) &RA0PPS)*8) + 3;
#define                                 RA0PPS3_bit         BANKMASK(RA0PPS), 3
extern volatile __bit                   RA0PPS4             @ (((unsigned) &RA0PPS)*8) + 4;
#define                                 RA0PPS4_bit         BANKMASK(RA0PPS), 4
extern volatile __bit                   RA1                 @ (((unsigned) &PORTA)*8) + 1;
#define                                 RA1_bit             BANKMASK(PORTA), 1
extern volatile __bit                   RA1PPS0             @ (((unsigned) &RA1PPS)*8) + 0;
#define                                 RA1PPS0_bit         BANKMASK(RA1PPS), 0
extern volatile __bit                   RA1PPS1             @ (((unsigned) &RA1PPS)*8) + 1;
#define                                 RA1PPS1_bit         BANKMASK(RA1PPS), 1
extern volatile __bit                   RA1PPS2             @ (((unsigned) &RA1PPS)*8) + 2;
#define                                 RA1PPS2_bit         BANKMASK(RA1PPS), 2
extern volatile __bit                   RA1PPS3             @ (((unsigned) &RA1PPS)*8) + 3;
#define                                 RA1PPS3_bit         BANKMASK(RA1PPS), 3
extern volatile __bit                   RA1PPS4             @ (((unsigned) &RA1PPS)*8) + 4;
#define                                 RA1PPS4_bit         BANKMASK(RA1PPS), 4
extern volatile __bit                   RA2                 @ (((unsigned) &PORTA)*8) + 2;
#define                                 RA2_bit             BANKMASK(PORTA), 2
extern volatile __bit                   RA2PPS0             @ (((unsigned) &RA2PPS)*8) + 0;
#define                                 RA2PPS0_bit         BANKMASK(RA2PPS), 0
extern volatile __bit                   RA2PPS1             @ (((unsigned) &RA2PPS)*8) + 1;
#define                                 RA2PPS1_bit         BANKMASK(RA2PPS), 1
extern volatile __bit                   RA2PPS2             @ (((unsigned) &RA2PPS)*8) + 2;
#define                                 RA2PPS2_bit         BANKMASK(RA2PPS), 2
extern volatile __bit                   RA2PPS3             @ (((unsigned) &RA2PPS)*8) + 3;
#define                                 RA2PPS3_bit         BANKMASK(RA2PPS), 3
extern volatile __bit                   RA2PPS4             @ (((unsigned) &RA2PPS)*8) + 4;
#define                                 RA2PPS4_bit         BANKMASK(RA2PPS), 4
extern volatile __bit                   RA3                 @ (((unsigned) &PORTA)*8) + 3;
#define                                 RA3_bit             BANKMASK(PORTA), 3
extern volatile __bit                   RA4                 @ (((unsigned) &PORTA)*8) + 4;
#define                                 RA4_bit             BANKMASK(PORTA), 4
extern volatile __bit                   RA4PPS0             @ (((unsigned) &RA4PPS)*8) + 0;
#define                                 RA4PPS0_bit         BANKMASK(RA4PPS), 0
extern volatile __bit                   RA4PPS1             @ (((unsigned) &RA4PPS)*8) + 1;
#define                                 RA4PPS1_bit         BANKMASK(RA4PPS), 1
extern volatile __bit                   RA4PPS2             @ (((unsigned) &RA4PPS)*8) + 2;
#define                                 RA4PPS2_bit         BANKMASK(RA4PPS), 2
extern volatile __bit                   RA4PPS3             @ (((unsigned) &RA4PPS)*8) + 3;
#define                                 RA4PPS3_bit         BANKMASK(RA4PPS), 3
extern volatile __bit                   RA4PPS4             @ (((unsigned) &RA4PPS)*8) + 4;
#define                                 RA4PPS4_bit         BANKMASK(RA4PPS), 4
extern volatile __bit                   RA5                 @ (((unsigned) &PORTA)*8) + 5;
#define                                 RA5_bit             BANKMASK(PORTA), 5
extern volatile __bit                   RA5PPS0             @ (((unsigned) &RA5PPS)*8) + 0;
#define                                 RA5PPS0_bit         BANKMASK(RA5PPS), 0
extern volatile __bit                   RA5PPS1             @ (((unsigned) &RA5PPS)*8) + 1;
#define                                 RA5PPS1_bit         BANKMASK(RA5PPS), 1
extern volatile __bit                   RA5PPS2             @ (((unsigned) &RA5PPS)*8) + 2;
#define                                 RA5PPS2_bit         BANKMASK(RA5PPS), 2
extern volatile __bit                   RA5PPS3             @ (((unsigned) &RA5PPS)*8) + 3;
#define                                 RA5PPS3_bit         BANKMASK(RA5PPS), 3
extern volatile __bit                   RA5PPS4             @ (((unsigned) &RA5PPS)*8) + 4;
#define                                 RA5PPS4_bit         BANKMASK(RA5PPS), 4
extern volatile __bit                   RB4                 @ (((unsigned) &PORTB)*8) + 4;
#define                                 RB4_bit             BANKMASK(PORTB), 4
extern volatile __bit                   RB4PPS0             @ (((unsigned) &RB4PPS)*8) + 0;
#define                                 RB4PPS0_bit         BANKMASK(RB4PPS), 0
extern volatile __bit                   RB4PPS1             @ (((unsigned) &RB4PPS)*8) + 1;
#define                                 RB4PPS1_bit         BANKMASK(RB4PPS), 1
extern volatile __bit                   RB4PPS2             @ (((unsigned) &RB4PPS)*8) + 2;
#define                                 RB4PPS2_bit         BANKMASK(RB4PPS), 2
extern volatile __bit                   RB4PPS3             @ (((unsigned) &RB4PPS)*8) + 3;
#define                                 RB4PPS3_bit         BANKMASK(RB4PPS), 3
extern volatile __bit                   RB4PPS4             @ (((unsigned) &RB4PPS)*8) + 4;
#define                                 RB4PPS4_bit         BANKMASK(RB4PPS), 4
extern volatile __bit                   RB5                 @ (((unsigned) &PORTB)*8) + 5;
#define                                 RB5_bit             BANKMASK(PORTB), 5
extern volatile __bit                   RB5PPS0             @ (((unsigned) &RB5PPS)*8) + 0;
#define                                 RB5PPS0_bit         BANKMASK(RB5PPS), 0
extern volatile __bit                   RB5PPS1             @ (((unsigned) &RB5PPS)*8) + 1;
#define                                 RB5PPS1_bit         BANKMASK(RB5PPS), 1
extern volatile __bit                   RB5PPS2             @ (((unsigned) &RB5PPS)*8) + 2;
#define                                 RB5PPS2_bit         BANKMASK(RB5PPS), 2
extern volatile __bit                   RB5PPS3             @ (((unsigned) &RB5PPS)*8) + 3;
#define                                 RB5PPS3_bit         BANKMASK(RB5PPS), 3
extern volatile __bit                   RB5PPS4             @ (((unsigned) &RB5PPS)*8) + 4;
#define                                 RB5PPS4_bit         BANKMASK(RB5PPS), 4
extern volatile __bit                   RB6                 @ (((unsigned) &PORTB)*8) + 6;
#define                                 RB6_bit             BANKMASK(PORTB), 6
extern volatile __bit                   RB6PPS0             @ (((unsigned) &RB6PPS)*8) + 0;
#define                                 RB6PPS0_bit         BANKMASK(RB6PPS), 0
extern volatile __bit                   RB6PPS1             @ (((unsigned) &RB6PPS)*8) + 1;
#define                                 RB6PPS1_bit         BANKMASK(RB6PPS), 1
extern volatile __bit                   RB6PPS2             @ (((unsigned) &RB6PPS)*8) + 2;
#define                                 RB6PPS2_bit         BANKMASK(RB6PPS), 2
extern volatile __bit                   RB6PPS3             @ (((unsigned) &RB6PPS)*8) + 3;
#define                                 RB6PPS3_bit         BANKMASK(RB6PPS), 3
extern volatile __bit                   RB6PPS4             @ (((unsigned) &RB6PPS)*8) + 4;
#define                                 RB6PPS4_bit         BANKMASK(RB6PPS), 4
extern volatile __bit                   RB7                 @ (((unsigned) &PORTB)*8) + 7;
#define                                 RB7_bit             BANKMASK(PORTB), 7
extern volatile __bit                   RB7PPS0             @ (((unsigned) &RB7PPS)*8) + 0;
#define                                 RB7PPS0_bit         BANKMASK(RB7PPS), 0
extern volatile __bit                   RB7PPS1             @ (((unsigned) &RB7PPS)*8) + 1;
#define                                 RB7PPS1_bit         BANKMASK(RB7PPS), 1
extern volatile __bit                   RB7PPS2             @ (((unsigned) &RB7PPS)*8) + 2;
#define                                 RB7PPS2_bit         BANKMASK(RB7PPS), 2
extern volatile __bit                   RB7PPS3             @ (((unsigned) &RB7PPS)*8) + 3;
#define                                 RB7PPS3_bit         BANKMASK(RB7PPS), 3
extern volatile __bit                   RB7PPS4             @ (((unsigned) &RB7PPS)*8) + 4;
#define                                 RB7PPS4_bit         BANKMASK(RB7PPS), 4
extern volatile __bit                   RC0                 @ (((unsigned) &PORTC)*8) + 0;
#define                                 RC0_bit             BANKMASK(PORTC), 0
extern volatile __bit                   RC0PPS0             @ (((unsigned) &RC0PPS)*8) + 0;
#define                                 RC0PPS0_bit         BANKMASK(RC0PPS), 0
extern volatile __bit                   RC0PPS1             @ (((unsigned) &RC0PPS)*8) + 1;
#define                                 RC0PPS1_bit         BANKMASK(RC0PPS), 1
extern volatile __bit                   RC0PPS2             @ (((unsigned) &RC0PPS)*8) + 2;
#define                                 RC0PPS2_bit         BANKMASK(RC0PPS), 2
extern volatile __bit                   RC0PPS3             @ (((unsigned) &RC0PPS)*8) + 3;
#define                                 RC0PPS3_bit         BANKMASK(RC0PPS), 3
extern volatile __bit                   RC0PPS4             @ (((unsigned) &RC0PPS)*8) + 4;
#define                                 RC0PPS4_bit         BANKMASK(RC0PPS), 4
extern volatile __bit                   RC1                 @ (((unsigned) &PORTC)*8) + 1;
#define                                 RC1_bit             BANKMASK(PORTC), 1
extern volatile __bit                   RC1PPS0             @ (((unsigned) &RC1PPS)*8) + 0;
#define                                 RC1PPS0_bit         BANKMASK(RC1PPS), 0
extern volatile __bit                   RC1PPS1             @ (((unsigned) &RC1PPS)*8) + 1;
#define                                 RC1PPS1_bit         BANKMASK(RC1PPS), 1
extern volatile __bit                   RC1PPS2             @ (((unsigned) &RC1PPS)*8) + 2;
#define                                 RC1PPS2_bit         BANKMASK(RC1PPS), 2
extern volatile __bit                   RC1PPS3             @ (((unsigned) &RC1PPS)*8) + 3;
#define                                 RC1PPS3_bit         BANKMASK(RC1PPS), 3
extern volatile __bit                   RC1PPS4             @ (((unsigned) &RC1PPS)*8) + 4;
#define                                 RC1PPS4_bit         BANKMASK(RC1PPS), 4
extern volatile __bit                   RC2                 @ (((unsigned) &PORTC)*8) + 2;
#define                                 RC2_bit             BANKMASK(PORTC), 2
extern volatile __bit                   RC2PPS0             @ (((unsigned) &RC2PPS)*8) + 0;
#define                                 RC2PPS0_bit         BANKMASK(RC2PPS), 0
extern volatile __bit                   RC2PPS1             @ (((unsigned) &RC2PPS)*8) + 1;
#define                                 RC2PPS1_bit         BANKMASK(RC2PPS), 1
extern volatile __bit                   RC2PPS2             @ (((unsigned) &RC2PPS)*8) + 2;
#define                                 RC2PPS2_bit         BANKMASK(RC2PPS), 2
extern volatile __bit                   RC2PPS3             @ (((unsigned) &RC2PPS)*8) + 3;
#define                                 RC2PPS3_bit         BANKMASK(RC2PPS), 3
extern volatile __bit                   RC2PPS4             @ (((unsigned) &RC2PPS)*8) + 4;
#define                                 RC2PPS4_bit         BANKMASK(RC2PPS), 4
extern volatile __bit                   RC3                 @ (((unsigned) &PORTC)*8) + 3;
#define                                 RC3_bit             BANKMASK(PORTC), 3
extern volatile __bit                   RC3PPS0             @ (((unsigned) &RC3PPS)*8) + 0;
#define                                 RC3PPS0_bit         BANKMASK(RC3PPS), 0
extern volatile __bit                   RC3PPS1             @ (((unsigned) &RC3PPS)*8) + 1;
#define                                 RC3PPS1_bit         BANKMASK(RC3PPS), 1
extern volatile __bit                   RC3PPS2             @ (((unsigned) &RC3PPS)*8) + 2;
#define                                 RC3PPS2_bit         BANKMASK(RC3PPS), 2
extern volatile __bit                   RC3PPS3             @ (((unsigned) &RC3PPS)*8) + 3;
#define                                 RC3PPS3_bit         BANKMASK(RC3PPS), 3
extern volatile __bit                   RC3PPS4             @ (((unsigned) &RC3PPS)*8) + 4;
#define                                 RC3PPS4_bit         BANKMASK(RC3PPS), 4
extern volatile __bit                   RC4                 @ (((unsigned) &PORTC)*8) + 4;
#define                                 RC4_bit             BANKMASK(PORTC), 4
extern volatile __bit                   RC4PPS0             @ (((unsigned) &RC4PPS)*8) + 0;
#define                                 RC4PPS0_bit         BANKMASK(RC4PPS), 0
extern volatile __bit                   RC4PPS1             @ (((unsigned) &RC4PPS)*8) + 1;
#define                                 RC4PPS1_bit         BANKMASK(RC4PPS), 1
extern volatile __bit                   RC4PPS2             @ (((unsigned) &RC4PPS)*8) + 2;
#define                                 RC4PPS2_bit         BANKMASK(RC4PPS), 2
extern volatile __bit                   RC4PPS3             @ (((unsigned) &RC4PPS)*8) + 3;
#define                                 RC4PPS3_bit         BANKMASK(RC4PPS), 3
extern volatile __bit                   RC4PPS4             @ (((unsigned) &RC4PPS)*8) + 4;
#define                                 RC4PPS4_bit         BANKMASK(RC4PPS), 4
extern volatile __bit                   RC5                 @ (((unsigned) &PORTC)*8) + 5;
#define                                 RC5_bit             BANKMASK(PORTC), 5
extern volatile __bit                   RC5PPS0             @ (((unsigned) &RC5PPS)*8) + 0;
#define                                 RC5PPS0_bit         BANKMASK(RC5PPS), 0
extern volatile __bit                   RC5PPS1             @ (((unsigned) &RC5PPS)*8) + 1;
#define                                 RC5PPS1_bit         BANKMASK(RC5PPS), 1
extern volatile __bit                   RC5PPS2             @ (((unsigned) &RC5PPS)*8) + 2;
#define                                 RC5PPS2_bit         BANKMASK(RC5PPS), 2
extern volatile __bit                   RC5PPS3             @ (((unsigned) &RC5PPS)*8) + 3;
#define                                 RC5PPS3_bit         BANKMASK(RC5PPS), 3
extern volatile __bit                   RC5PPS4             @ (((unsigned) &RC5PPS)*8) + 4;
#define                                 RC5PPS4_bit         BANKMASK(RC5PPS), 4
extern volatile __bit                   RC6                 @ (((unsigned) &PORTC)*8) + 6;
#define                                 RC6_bit             BANKMASK(PORTC), 6
extern volatile __bit                   RC6PPS0             @ (((unsigned) &RC6PPS)*8) + 0;
#define                                 RC6PPS0_bit         BANKMASK(RC6PPS), 0
extern volatile __bit                   RC6PPS1             @ (((unsigned) &RC6PPS)*8) + 1;
#define                                 RC6PPS1_bit         BANKMASK(RC6PPS), 1
extern volatile __bit                   RC6PPS2             @ (((unsigned) &RC6PPS)*8) + 2;
#define                                 RC6PPS2_bit         BANKMASK(RC6PPS), 2
extern volatile __bit                   RC6PPS3             @ (((unsigned) &RC6PPS)*8) + 3;
#define                                 RC6PPS3_bit         BANKMASK(RC6PPS), 3
extern volatile __bit                   RC6PPS4             @ (((unsigned) &RC6PPS)*8) + 4;
#define                                 RC6PPS4_bit         BANKMASK(RC6PPS), 4
extern volatile __bit                   RC7                 @ (((unsigned) &PORTC)*8) + 7;
#define                                 RC7_bit             BANKMASK(PORTC), 7
extern volatile __bit                   RC7PPS0             @ (((unsigned) &RC7PPS)*8) + 0;
#define                                 RC7PPS0_bit         BANKMASK(RC7PPS), 0
extern volatile __bit                   RC7PPS1             @ (((unsigned) &RC7PPS)*8) + 1;
#define                                 RC7PPS1_bit         BANKMASK(RC7PPS), 1
extern volatile __bit                   RC7PPS2             @ (((unsigned) &RC7PPS)*8) + 2;
#define                                 RC7PPS2_bit         BANKMASK(RC7PPS), 2
extern volatile __bit                   RC7PPS3             @ (((unsigned) &RC7PPS)*8) + 3;
#define                                 RC7PPS3_bit         BANKMASK(RC7PPS), 3
extern volatile __bit                   RC7PPS4             @ (((unsigned) &RC7PPS)*8) + 4;
#define                                 RC7PPS4_bit         BANKMASK(RC7PPS), 4
extern volatile __bit                   RCEN                @ (((unsigned) &SSP1CON2)*8) + 3;
#define                                 RCEN_bit            BANKMASK(SSP1CON2), 3
extern volatile __bit                   RCIDL               @ (((unsigned) &BAUD1CON)*8) + 6;
#define                                 RCIDL_bit           BANKMASK(BAUD1CON), 6
extern volatile __bit                   RCIE                @ (((unsigned) &PIE1)*8) + 5;
#define                                 RCIE_bit            BANKMASK(PIE1), 5
extern volatile __bit                   RCIF                @ (((unsigned) &PIR1)*8) + 5;
#define                                 RCIF_bit            BANKMASK(PIR1), 5
extern volatile __bit                   RD                  @ (((unsigned) &PMCON1)*8) + 0;
#define                                 RD_bit              BANKMASK(PMCON1), 0
extern volatile __bit                   REN                 @ (((unsigned) &CWG1AS0)*8) + 6;
#define                                 REN_bit             BANKMASK(CWG1AS0), 6
extern volatile __bit                   RES0                @ (((unsigned) &AT1RESL)*8) + 0;
#define                                 RES0_bit            BANKMASK(AT1RESL), 0
extern volatile __bit                   RES1                @ (((unsigned) &AT1RESL)*8) + 1;
#define                                 RES1_bit            BANKMASK(AT1RESL), 1
extern volatile __bit                   RES2                @ (((unsigned) &AT1RESL)*8) + 2;
#define                                 RES2_bit            BANKMASK(AT1RESL), 2
extern volatile __bit                   RES3                @ (((unsigned) &AT1RESL)*8) + 3;
#define                                 RES3_bit            BANKMASK(AT1RESL), 3
extern volatile __bit                   RES4                @ (((unsigned) &AT1RESL)*8) + 4;
#define                                 RES4_bit            BANKMASK(AT1RESL), 4
extern volatile __bit                   RES5                @ (((unsigned) &AT1RESL)*8) + 5;
#define                                 RES5_bit            BANKMASK(AT1RESL), 5
extern volatile __bit                   RES6                @ (((unsigned) &AT1RESL)*8) + 6;
#define                                 RES6_bit            BANKMASK(AT1RESL), 6
extern volatile __bit                   RES7                @ (((unsigned) &AT1RESL)*8) + 7;
#define                                 RES7_bit            BANKMASK(AT1RESL), 7
extern volatile __bit                   RES8                @ (((unsigned) &AT1RESH)*8) + 0;
#define                                 RES8_bit            BANKMASK(AT1RESH), 0
extern volatile __bit                   RES9                @ (((unsigned) &AT1RESH)*8) + 1;
#define                                 RES9_bit            BANKMASK(AT1RESH), 1
extern volatile __bit                   RSEN                @ (((unsigned) &SSP1CON2)*8) + 1;
#define                                 RSEN_bit            BANKMASK(SSP1CON2), 1
extern volatile __bit                   RX9                 @ (((unsigned) &RC1STA)*8) + 6;
#define                                 RX9_bit             BANKMASK(RC1STA), 6
extern volatile __bit                   RX9D                @ (((unsigned) &RC1STA)*8) + 0;
#define                                 RX9D_bit            BANKMASK(RC1STA), 0
extern volatile __bit                   RXPPS0              @ (((unsigned) &RXPPS)*8) + 0;
#define                                 RXPPS0_bit          BANKMASK(RXPPS), 0
extern volatile __bit                   RXPPS1              @ (((unsigned) &RXPPS)*8) + 1;
#define                                 RXPPS1_bit          BANKMASK(RXPPS), 1
extern volatile __bit                   RXPPS2              @ (((unsigned) &RXPPS)*8) + 2;
#define                                 RXPPS2_bit          BANKMASK(RXPPS), 2
extern volatile __bit                   RXPPS3              @ (((unsigned) &RXPPS)*8) + 3;
#define                                 RXPPS3_bit          BANKMASK(RXPPS), 3
extern volatile __bit                   RXPPS4              @ (((unsigned) &RXPPS)*8) + 4;
#define                                 RXPPS4_bit          BANKMASK(RXPPS), 4
extern volatile __bit                   R_nW                @ (((unsigned) &SSP1STAT)*8) + 2;
#define                                 R_nW_bit            BANKMASK(SSP1STAT), 2
extern volatile __bit                   SBCDE               @ (((unsigned) &SSP1CON3)*8) + 2;
#define                                 SBCDE_bit           BANKMASK(SSP1CON3), 2
extern volatile __bit                   SBOREN              @ (((unsigned) &BORCON)*8) + 7;
#define                                 SBOREN_bit          BANKMASK(BORCON), 7
extern volatile __bit                   SCANBUSY            @ (((unsigned) &SCANCON0)*8) + 5;
#define                                 SCANBUSY_bit        BANKMASK(SCANCON0), 5
extern volatile __bit                   SCANEN              @ (((unsigned) &SCANCON0)*8) + 7;
#define                                 SCANEN_bit          BANKMASK(SCANCON0), 7
extern volatile __bit                   SCANGO              @ (((unsigned) &SCANCON0)*8) + 6;
#define                                 SCANGO_bit          BANKMASK(SCANCON0), 6
extern volatile __bit                   SCANHADR0           @ (((unsigned) &SCANHADRL)*8) + 0;
#define                                 SCANHADR0_bit       BANKMASK(SCANHADRL), 0
extern volatile __bit                   SCANHADR1           @ (((unsigned) &SCANHADRL)*8) + 1;
#define                                 SCANHADR1_bit       BANKMASK(SCANHADRL), 1
extern volatile __bit                   SCANHADR10          @ (((unsigned) &SCANHADRH)*8) + 2;
#define                                 SCANHADR10_bit      BANKMASK(SCANHADRH), 2
extern volatile __bit                   SCANHADR11          @ (((unsigned) &SCANHADRH)*8) + 3;
#define                                 SCANHADR11_bit      BANKMASK(SCANHADRH), 3
extern volatile __bit                   SCANHADR12          @ (((unsigned) &SCANHADRH)*8) + 4;
#define                                 SCANHADR12_bit      BANKMASK(SCANHADRH), 4
extern volatile __bit                   SCANHADR13          @ (((unsigned) &SCANHADRH)*8) + 5;
#define                                 SCANHADR13_bit      BANKMASK(SCANHADRH), 5
extern volatile __bit                   SCANHADR14          @ (((unsigned) &SCANHADRH)*8) + 6;
#define                                 SCANHADR14_bit      BANKMASK(SCANHADRH), 6
extern volatile __bit                   SCANHADR15          @ (((unsigned) &SCANHADRH)*8) + 7;
#define                                 SCANHADR15_bit      BANKMASK(SCANHADRH), 7
extern volatile __bit                   SCANHADR2           @ (((unsigned) &SCANHADRL)*8) + 2;
#define                                 SCANHADR2_bit       BANKMASK(SCANHADRL), 2
extern volatile __bit                   SCANHADR3           @ (((unsigned) &SCANHADRL)*8) + 3;
#define                                 SCANHADR3_bit       BANKMASK(SCANHADRL), 3
extern volatile __bit                   SCANHADR4           @ (((unsigned) &SCANHADRL)*8) + 4;
#define                                 SCANHADR4_bit       BANKMASK(SCANHADRL), 4
extern volatile __bit                   SCANHADR5           @ (((unsigned) &SCANHADRL)*8) + 5;
#define                                 SCANHADR5_bit       BANKMASK(SCANHADRL), 5
extern volatile __bit                   SCANHADR6           @ (((unsigned) &SCANHADRL)*8) + 6;
#define                                 SCANHADR6_bit       BANKMASK(SCANHADRL), 6
extern volatile __bit                   SCANHADR7           @ (((unsigned) &SCANHADRL)*8) + 7;
#define                                 SCANHADR7_bit       BANKMASK(SCANHADRL), 7
extern volatile __bit                   SCANHADR8           @ (((unsigned) &SCANHADRH)*8) + 0;
#define                                 SCANHADR8_bit       BANKMASK(SCANHADRH), 0
extern volatile __bit                   SCANHADR9           @ (((unsigned) &SCANHADRH)*8) + 1;
#define                                 SCANHADR9_bit       BANKMASK(SCANHADRH), 1
extern volatile __bit                   SCANIE              @ (((unsigned) &PIE4)*8) + 7;
#define                                 SCANIE_bit          BANKMASK(PIE4), 7
extern volatile __bit                   SCANIF              @ (((unsigned) &PIR4)*8) + 7;
#define                                 SCANIF_bit          BANKMASK(PIR4), 7
extern volatile __bit                   SCANINTM            @ (((unsigned) &SCANCON0)*8) + 3;
#define                                 SCANINTM_bit        BANKMASK(SCANCON0), 3
extern volatile __bit                   SCANINVALID         @ (((unsigned) &SCANCON0)*8) + 4;
#define                                 SCANINVALID_bit     BANKMASK(SCANCON0), 4
extern volatile __bit                   SCANLADR0           @ (((unsigned) &SCANLADRL)*8) + 0;
#define                                 SCANLADR0_bit       BANKMASK(SCANLADRL), 0
extern volatile __bit                   SCANLADR1           @ (((unsigned) &SCANLADRL)*8) + 1;
#define                                 SCANLADR1_bit       BANKMASK(SCANLADRL), 1
extern volatile __bit                   SCANLADR10          @ (((unsigned) &SCANLADRH)*8) + 2;
#define                                 SCANLADR10_bit      BANKMASK(SCANLADRH), 2
extern volatile __bit                   SCANLADR11          @ (((unsigned) &SCANLADRH)*8) + 3;
#define                                 SCANLADR11_bit      BANKMASK(SCANLADRH), 3
extern volatile __bit                   SCANLADR12          @ (((unsigned) &SCANLADRH)*8) + 4;
#define                                 SCANLADR12_bit      BANKMASK(SCANLADRH), 4
extern volatile __bit                   SCANLADR13          @ (((unsigned) &SCANLADRH)*8) + 5;
#define                                 SCANLADR13_bit      BANKMASK(SCANLADRH), 5
extern volatile __bit                   SCANLADR14          @ (((unsigned) &SCANLADRH)*8) + 6;
#define                                 SCANLADR14_bit      BANKMASK(SCANLADRH), 6
extern volatile __bit                   SCANLADR15          @ (((unsigned) &SCANLADRH)*8) + 7;
#define                                 SCANLADR15_bit      BANKMASK(SCANLADRH), 7
extern volatile __bit                   SCANLADR2           @ (((unsigned) &SCANLADRL)*8) + 2;
#define                                 SCANLADR2_bit       BANKMASK(SCANLADRL), 2
extern volatile __bit                   SCANLADR3           @ (((unsigned) &SCANLADRL)*8) + 3;
#define                                 SCANLADR3_bit       BANKMASK(SCANLADRL), 3
extern volatile __bit                   SCANLADR4           @ (((unsigned) &SCANLADRL)*8) + 4;
#define                                 SCANLADR4_bit       BANKMASK(SCANLADRL), 4
extern volatile __bit                   SCANLADR5           @ (((unsigned) &SCANLADRL)*8) + 5;
#define                                 SCANLADR5_bit       BANKMASK(SCANLADRL), 5
extern volatile __bit                   SCANLADR6           @ (((unsigned) &SCANLADRL)*8) + 6;
#define                                 SCANLADR6_bit       BANKMASK(SCANLADRL), 6
extern volatile __bit                   SCANLADR7           @ (((unsigned) &SCANLADRL)*8) + 7;
#define                                 SCANLADR7_bit       BANKMASK(SCANLADRL), 7
extern volatile __bit                   SCANLADR8           @ (((unsigned) &SCANLADRH)*8) + 0;
#define                                 SCANLADR8_bit       BANKMASK(SCANLADRH), 0
extern volatile __bit                   SCANLADR9           @ (((unsigned) &SCANLADRH)*8) + 1;
#define                                 SCANLADR9_bit       BANKMASK(SCANLADRH), 1
extern volatile __bit                   SCANMODE0           @ (((unsigned) &SCANCON0)*8) + 0;
#define                                 SCANMODE0_bit       BANKMASK(SCANCON0), 0
extern volatile __bit                   SCANMODE1           @ (((unsigned) &SCANCON0)*8) + 1;
#define                                 SCANMODE1_bit       BANKMASK(SCANCON0), 1
extern volatile __bit                   SCANTSEL0           @ (((unsigned) &SCANTRIG)*8) + 0;
#define                                 SCANTSEL0_bit       BANKMASK(SCANTRIG), 0
extern volatile __bit                   SCANTSEL1           @ (((unsigned) &SCANTRIG)*8) + 1;
#define                                 SCANTSEL1_bit       BANKMASK(SCANTRIG), 1
extern volatile __bit                   SCANTSEL2           @ (((unsigned) &SCANTRIG)*8) + 2;
#define                                 SCANTSEL2_bit       BANKMASK(SCANTRIG), 2
extern volatile __bit                   SCANTSEL3           @ (((unsigned) &SCANTRIG)*8) + 3;
#define                                 SCANTSEL3_bit       BANKMASK(SCANTRIG), 3
extern volatile __bit                   SCIE                @ (((unsigned) &SSP1CON3)*8) + 5;
#define                                 SCIE_bit            BANKMASK(SSP1CON3), 5
extern volatile __bit                   SCKP                @ (((unsigned) &BAUD1CON)*8) + 4;
#define                                 SCKP_bit            BANKMASK(BAUD1CON), 4
extern volatile __bit                   SCS0                @ (((unsigned) &OSCCON)*8) + 0;
#define                                 SCS0_bit            BANKMASK(OSCCON), 0
extern volatile __bit                   SCS1                @ (((unsigned) &OSCCON)*8) + 1;
#define                                 SCS1_bit            BANKMASK(OSCCON), 1
extern volatile __bit                   SDAHT               @ (((unsigned) &SSP1CON3)*8) + 3;
#define                                 SDAHT_bit           BANKMASK(SSP1CON3), 3
extern volatile __bit                   SENDB               @ (((unsigned) &TX1STA)*8) + 3;
#define                                 SENDB_bit           BANKMASK(TX1STA), 3
extern volatile __bit                   SET0                @ (((unsigned) &PID1SETL)*8) + 0;
#define                                 SET0_bit            BANKMASK(PID1SETL), 0
extern volatile __bit                   SET1                @ (((unsigned) &PID1SETL)*8) + 1;
#define                                 SET1_bit            BANKMASK(PID1SETL), 1
extern volatile __bit                   SET10               @ (((unsigned) &PID1SETH)*8) + 2;
#define                                 SET10_bit           BANKMASK(PID1SETH), 2
extern volatile __bit                   SET11               @ (((unsigned) &PID1SETH)*8) + 3;
#define                                 SET11_bit           BANKMASK(PID1SETH), 3
extern volatile __bit                   SET12               @ (((unsigned) &PID1SETH)*8) + 4;
#define                                 SET12_bit           BANKMASK(PID1SETH), 4
extern volatile __bit                   SET13               @ (((unsigned) &PID1SETH)*8) + 5;
#define                                 SET13_bit           BANKMASK(PID1SETH), 5
extern volatile __bit                   SET14               @ (((unsigned) &PID1SETH)*8) + 6;
#define                                 SET14_bit           BANKMASK(PID1SETH), 6
extern volatile __bit                   SET15               @ (((unsigned) &PID1SETH)*8) + 7;
#define                                 SET15_bit           BANKMASK(PID1SETH), 7
extern volatile __bit                   SET2                @ (((unsigned) &PID1SETL)*8) + 2;
#define                                 SET2_bit            BANKMASK(PID1SETL), 2
extern volatile __bit                   SET3                @ (((unsigned) &PID1SETL)*8) + 3;
#define                                 SET3_bit            BANKMASK(PID1SETL), 3
extern volatile __bit                   SET4                @ (((unsigned) &PID1SETL)*8) + 4;
#define                                 SET4_bit            BANKMASK(PID1SETL), 4
extern volatile __bit                   SET5                @ (((unsigned) &PID1SETL)*8) + 5;
#define                                 SET5_bit            BANKMASK(PID1SETL), 5
extern volatile __bit                   SET6                @ (((unsigned) &PID1SETL)*8) + 6;
#define                                 SET6_bit            BANKMASK(PID1SETL), 6
extern volatile __bit                   SET7                @ (((unsigned) &PID1SETL)*8) + 7;
#define                                 SET7_bit            BANKMASK(PID1SETL), 7
extern volatile __bit                   SET8                @ (((unsigned) &PID1SETH)*8) + 0;
#define                                 SET8_bit            BANKMASK(PID1SETH), 0
extern volatile __bit                   SET9                @ (((unsigned) &PID1SETH)*8) + 1;
#define                                 SET9_bit            BANKMASK(PID1SETH), 1
extern volatile __bit                   SHIFT0              @ (((unsigned) &CRCSHIFTL)*8) + 0;
#define                                 SHIFT0_bit          BANKMASK(CRCSHIFTL), 0
extern volatile __bit                   SHIFT1              @ (((unsigned) &CRCSHIFTL)*8) + 1;
#define                                 SHIFT1_bit          BANKMASK(CRCSHIFTL), 1
extern volatile __bit                   SHIFT10             @ (((unsigned) &CRCSHIFTH)*8) + 2;
#define                                 SHIFT10_bit         BANKMASK(CRCSHIFTH), 2
extern volatile __bit                   SHIFT11             @ (((unsigned) &CRCSHIFTH)*8) + 3;
#define                                 SHIFT11_bit         BANKMASK(CRCSHIFTH), 3
extern volatile __bit                   SHIFT12             @ (((unsigned) &CRCSHIFTH)*8) + 4;
#define                                 SHIFT12_bit         BANKMASK(CRCSHIFTH), 4
extern volatile __bit                   SHIFT13             @ (((unsigned) &CRCSHIFTH)*8) + 5;
#define                                 SHIFT13_bit         BANKMASK(CRCSHIFTH), 5
extern volatile __bit                   SHIFT14             @ (((unsigned) &CRCSHIFTH)*8) + 6;
#define                                 SHIFT14_bit         BANKMASK(CRCSHIFTH), 6
extern volatile __bit                   SHIFT15             @ (((unsigned) &CRCSHIFTH)*8) + 7;
#define                                 SHIFT15_bit         BANKMASK(CRCSHIFTH), 7
extern volatile __bit                   SHIFT2              @ (((unsigned) &CRCSHIFTL)*8) + 2;
#define                                 SHIFT2_bit          BANKMASK(CRCSHIFTL), 2
extern volatile __bit                   SHIFT3              @ (((unsigned) &CRCSHIFTL)*8) + 3;
#define                                 SHIFT3_bit          BANKMASK(CRCSHIFTL), 3
extern volatile __bit                   SHIFT4              @ (((unsigned) &CRCSHIFTL)*8) + 4;
#define                                 SHIFT4_bit          BANKMASK(CRCSHIFTL), 4
extern volatile __bit                   SHIFT5              @ (((unsigned) &CRCSHIFTL)*8) + 5;
#define                                 SHIFT5_bit          BANKMASK(CRCSHIFTL), 5
extern volatile __bit                   SHIFT6              @ (((unsigned) &CRCSHIFTL)*8) + 6;
#define                                 SHIFT6_bit          BANKMASK(CRCSHIFTL), 6
extern volatile __bit                   SHIFT7              @ (((unsigned) &CRCSHIFTL)*8) + 7;
#define                                 SHIFT7_bit          BANKMASK(CRCSHIFTL), 7
extern volatile __bit                   SHIFT8              @ (((unsigned) &CRCSHIFTH)*8) + 0;
#define                                 SHIFT8_bit          BANKMASK(CRCSHIFTH), 0
extern volatile __bit                   SHIFT9              @ (((unsigned) &CRCSHIFTH)*8) + 1;
#define                                 SHIFT9_bit          BANKMASK(CRCSHIFTH), 1
extern volatile __bit                   SHIFTM              @ (((unsigned) &CRCCON0)*8) + 1;
#define                                 SHIFTM_bit          BANKMASK(CRCCON0), 1
extern volatile __bit                   SHUTDOWN            @ (((unsigned) &CWG1AS0)*8) + 7;
#define                                 SHUTDOWN_bit        BANKMASK(CWG1AS0), 7
extern volatile __bit                   SLRA0               @ (((unsigned) &SLRCONA)*8) + 0;
#define                                 SLRA0_bit           BANKMASK(SLRCONA), 0
extern volatile __bit                   SLRA1               @ (((unsigned) &SLRCONA)*8) + 1;
#define                                 SLRA1_bit           BANKMASK(SLRCONA), 1
extern volatile __bit                   SLRA2               @ (((unsigned) &SLRCONA)*8) + 2;
#define                                 SLRA2_bit           BANKMASK(SLRCONA), 2
extern volatile __bit                   SLRA4               @ (((unsigned) &SLRCONA)*8) + 4;
#define                                 SLRA4_bit           BANKMASK(SLRCONA), 4
extern volatile __bit                   SLRA5               @ (((unsigned) &SLRCONA)*8) + 5;
#define                                 SLRA5_bit           BANKMASK(SLRCONA), 5
extern volatile __bit                   SLRB4               @ (((unsigned) &SLRCONB)*8) + 4;
#define                                 SLRB4_bit           BANKMASK(SLRCONB), 4
extern volatile __bit                   SLRB5               @ (((unsigned) &SLRCONB)*8) + 5;
#define                                 SLRB5_bit           BANKMASK(SLRCONB), 5
extern volatile __bit                   SLRB6               @ (((unsigned) &SLRCONB)*8) + 6;
#define                                 SLRB6_bit           BANKMASK(SLRCONB), 6
extern volatile __bit                   SLRB7               @ (((unsigned) &SLRCONB)*8) + 7;
#define                                 SLRB7_bit           BANKMASK(SLRCONB), 7
extern volatile __bit                   SLRC0               @ (((unsigned) &SLRCONC)*8) + 0;
#define                                 SLRC0_bit           BANKMASK(SLRCONC), 0
extern volatile __bit                   SLRC1               @ (((unsigned) &SLRCONC)*8) + 1;
#define                                 SLRC1_bit           BANKMASK(SLRCONC), 1
extern volatile __bit                   SLRC2               @ (((unsigned) &SLRCONC)*8) + 2;
#define                                 SLRC2_bit           BANKMASK(SLRCONC), 2
extern volatile __bit                   SLRC3               @ (((unsigned) &SLRCONC)*8) + 3;
#define                                 SLRC3_bit           BANKMASK(SLRCONC), 3
extern volatile __bit                   SLRC4               @ (((unsigned) &SLRCONC)*8) + 4;
#define                                 SLRC4_bit           BANKMASK(SLRCONC), 4
extern volatile __bit                   SLRC5               @ (((unsigned) &SLRCONC)*8) + 5;
#define                                 SLRC5_bit           BANKMASK(SLRCONC), 5
extern volatile __bit                   SLRC6               @ (((unsigned) &SLRCONC)*8) + 6;
#define                                 SLRC6_bit           BANKMASK(SLRCONC), 6
extern volatile __bit                   SLRC7               @ (((unsigned) &SLRCONC)*8) + 7;
#define                                 SLRC7_bit           BANKMASK(SLRCONC), 7
extern volatile __bit                   SMP                 @ (((unsigned) &SSP1STAT)*8) + 7;
#define                                 SMP_bit             BANKMASK(SSP1STAT), 7
extern volatile __bit                   SMT1AS              @ (((unsigned) &SMT1STAT)*8) + 0;
#define                                 SMT1AS_bit          BANKMASK(SMT1STAT), 0
extern volatile __bit                   SMT1CPR0            @ (((unsigned) &SMT1CPRL)*8) + 0;
#define                                 SMT1CPR0_bit        BANKMASK(SMT1CPRL), 0
extern volatile __bit                   SMT1CPR1            @ (((unsigned) &SMT1CPRL)*8) + 1;
#define                                 SMT1CPR1_bit        BANKMASK(SMT1CPRL), 1
extern volatile __bit                   SMT1CPR10           @ (((unsigned) &SMT1CPRH)*8) + 2;
#define                                 SMT1CPR10_bit       BANKMASK(SMT1CPRH), 2
extern volatile __bit                   SMT1CPR11           @ (((unsigned) &SMT1CPRH)*8) + 3;
#define                                 SMT1CPR11_bit       BANKMASK(SMT1CPRH), 3
extern volatile __bit                   SMT1CPR12           @ (((unsigned) &SMT1CPRH)*8) + 4;
#define                                 SMT1CPR12_bit       BANKMASK(SMT1CPRH), 4
extern volatile __bit                   SMT1CPR13           @ (((unsigned) &SMT1CPRH)*8) + 5;
#define                                 SMT1CPR13_bit       BANKMASK(SMT1CPRH), 5
extern volatile __bit                   SMT1CPR14           @ (((unsigned) &SMT1CPRH)*8) + 6;
#define                                 SMT1CPR14_bit       BANKMASK(SMT1CPRH), 6
extern volatile __bit                   SMT1CPR15           @ (((unsigned) &SMT1CPRH)*8) + 7;
#define                                 SMT1CPR15_bit       BANKMASK(SMT1CPRH), 7
extern volatile __bit                   SMT1CPR16           @ (((unsigned) &SMT1CPRU)*8) + 0;
#define                                 SMT1CPR16_bit       BANKMASK(SMT1CPRU), 0
extern volatile __bit                   SMT1CPR17           @ (((unsigned) &SMT1CPRU)*8) + 1;
#define                                 SMT1CPR17_bit       BANKMASK(SMT1CPRU), 1
extern volatile __bit                   SMT1CPR18           @ (((unsigned) &SMT1CPRU)*8) + 2;
#define                                 SMT1CPR18_bit       BANKMASK(SMT1CPRU), 2
extern volatile __bit                   SMT1CPR19           @ (((unsigned) &SMT1CPRU)*8) + 3;
#define                                 SMT1CPR19_bit       BANKMASK(SMT1CPRU), 3
extern volatile __bit                   SMT1CPR2            @ (((unsigned) &SMT1CPRL)*8) + 2;
#define                                 SMT1CPR2_bit        BANKMASK(SMT1CPRL), 2
extern volatile __bit                   SMT1CPR20           @ (((unsigned) &SMT1CPRU)*8) + 4;
#define                                 SMT1CPR20_bit       BANKMASK(SMT1CPRU), 4
extern volatile __bit                   SMT1CPR21           @ (((unsigned) &SMT1CPRU)*8) + 5;
#define                                 SMT1CPR21_bit       BANKMASK(SMT1CPRU), 5
extern volatile __bit                   SMT1CPR22           @ (((unsigned) &SMT1CPRU)*8) + 6;
#define                                 SMT1CPR22_bit       BANKMASK(SMT1CPRU), 6
extern volatile __bit                   SMT1CPR23           @ (((unsigned) &SMT1CPRU)*8) + 7;
#define                                 SMT1CPR23_bit       BANKMASK(SMT1CPRU), 7
extern volatile __bit                   SMT1CPR3            @ (((unsigned) &SMT1CPRL)*8) + 3;
#define                                 SMT1CPR3_bit        BANKMASK(SMT1CPRL), 3
extern volatile __bit                   SMT1CPR4            @ (((unsigned) &SMT1CPRL)*8) + 4;
#define                                 SMT1CPR4_bit        BANKMASK(SMT1CPRL), 4
extern volatile __bit                   SMT1CPR5            @ (((unsigned) &SMT1CPRL)*8) + 5;
#define                                 SMT1CPR5_bit        BANKMASK(SMT1CPRL), 5
extern volatile __bit                   SMT1CPR6            @ (((unsigned) &SMT1CPRL)*8) + 6;
#define                                 SMT1CPR6_bit        BANKMASK(SMT1CPRL), 6
extern volatile __bit                   SMT1CPR7            @ (((unsigned) &SMT1CPRL)*8) + 7;
#define                                 SMT1CPR7_bit        BANKMASK(SMT1CPRL), 7
extern volatile __bit                   SMT1CPR8            @ (((unsigned) &SMT1CPRH)*8) + 0;
#define                                 SMT1CPR8_bit        BANKMASK(SMT1CPRH), 0
extern volatile __bit                   SMT1CPR9            @ (((unsigned) &SMT1CPRH)*8) + 1;
#define                                 SMT1CPR9_bit        BANKMASK(SMT1CPRH), 1
extern volatile __bit                   SMT1CPRUP           @ (((unsigned) &SMT1STAT)*8) + 7;
#define                                 SMT1CPRUP_bit       BANKMASK(SMT1STAT), 7
extern volatile __bit                   SMT1CPW0            @ (((unsigned) &SMT1CPWL)*8) + 0;
#define                                 SMT1CPW0_bit        BANKMASK(SMT1CPWL), 0
extern volatile __bit                   SMT1CPW1            @ (((unsigned) &SMT1CPWL)*8) + 1;
#define                                 SMT1CPW1_bit        BANKMASK(SMT1CPWL), 1
extern volatile __bit                   SMT1CPW10           @ (((unsigned) &SMT1CPWH)*8) + 2;
#define                                 SMT1CPW10_bit       BANKMASK(SMT1CPWH), 2
extern volatile __bit                   SMT1CPW11           @ (((unsigned) &SMT1CPWH)*8) + 3;
#define                                 SMT1CPW11_bit       BANKMASK(SMT1CPWH), 3
extern volatile __bit                   SMT1CPW12           @ (((unsigned) &SMT1CPWH)*8) + 4;
#define                                 SMT1CPW12_bit       BANKMASK(SMT1CPWH), 4
extern volatile __bit                   SMT1CPW13           @ (((unsigned) &SMT1CPWH)*8) + 5;
#define                                 SMT1CPW13_bit       BANKMASK(SMT1CPWH), 5
extern volatile __bit                   SMT1CPW14           @ (((unsigned) &SMT1CPWH)*8) + 6;
#define                                 SMT1CPW14_bit       BANKMASK(SMT1CPWH), 6
extern volatile __bit                   SMT1CPW15           @ (((unsigned) &SMT1CPWH)*8) + 7;
#define                                 SMT1CPW15_bit       BANKMASK(SMT1CPWH), 7
extern volatile __bit                   SMT1CPW16           @ (((unsigned) &SMT1CPWU)*8) + 0;
#define                                 SMT1CPW16_bit       BANKMASK(SMT1CPWU), 0
extern volatile __bit                   SMT1CPW17           @ (((unsigned) &SMT1CPWU)*8) + 1;
#define                                 SMT1CPW17_bit       BANKMASK(SMT1CPWU), 1
extern volatile __bit                   SMT1CPW18           @ (((unsigned) &SMT1CPWU)*8) + 2;
#define                                 SMT1CPW18_bit       BANKMASK(SMT1CPWU), 2
extern volatile __bit                   SMT1CPW19           @ (((unsigned) &SMT1CPWU)*8) + 3;
#define                                 SMT1CPW19_bit       BANKMASK(SMT1CPWU), 3
extern volatile __bit                   SMT1CPW2            @ (((unsigned) &SMT1CPWL)*8) + 2;
#define                                 SMT1CPW2_bit        BANKMASK(SMT1CPWL), 2
extern volatile __bit                   SMT1CPW20           @ (((unsigned) &SMT1CPWU)*8) + 4;
#define                                 SMT1CPW20_bit       BANKMASK(SMT1CPWU), 4
extern volatile __bit                   SMT1CPW21           @ (((unsigned) &SMT1CPWU)*8) + 5;
#define                                 SMT1CPW21_bit       BANKMASK(SMT1CPWU), 5
extern volatile __bit                   SMT1CPW22           @ (((unsigned) &SMT1CPWU)*8) + 6;
#define                                 SMT1CPW22_bit       BANKMASK(SMT1CPWU), 6
extern volatile __bit                   SMT1CPW23           @ (((unsigned) &SMT1CPWU)*8) + 7;
#define                                 SMT1CPW23_bit       BANKMASK(SMT1CPWU), 7
extern volatile __bit                   SMT1CPW3            @ (((unsigned) &SMT1CPWL)*8) + 3;
#define                                 SMT1CPW3_bit        BANKMASK(SMT1CPWL), 3
extern volatile __bit                   SMT1CPW4            @ (((unsigned) &SMT1CPWL)*8) + 4;
#define                                 SMT1CPW4_bit        BANKMASK(SMT1CPWL), 4
extern volatile __bit                   SMT1CPW5            @ (((unsigned) &SMT1CPWL)*8) + 5;
#define                                 SMT1CPW5_bit        BANKMASK(SMT1CPWL), 5
extern volatile __bit                   SMT1CPW6            @ (((unsigned) &SMT1CPWL)*8) + 6;
#define                                 SMT1CPW6_bit        BANKMASK(SMT1CPWL), 6
extern volatile __bit                   SMT1CPW7            @ (((unsigned) &SMT1CPWL)*8) + 7;
#define                                 SMT1CPW7_bit        BANKMASK(SMT1CPWL), 7
extern volatile __bit                   SMT1CPW8            @ (((unsigned) &SMT1CPWH)*8) + 0;
#define                                 SMT1CPW8_bit        BANKMASK(SMT1CPWH), 0
extern volatile __bit                   SMT1CPW9            @ (((unsigned) &SMT1CPWH)*8) + 1;
#define                                 SMT1CPW9_bit        BANKMASK(SMT1CPWH), 1
extern volatile __bit                   SMT1CPWUP           @ (((unsigned) &SMT1STAT)*8) + 6;
#define                                 SMT1CPWUP_bit       BANKMASK(SMT1STAT), 6
extern volatile __bit                   SMT1CSEL0           @ (((unsigned) &SMT1CLK)*8) + 0;
#define                                 SMT1CSEL0_bit       BANKMASK(SMT1CLK), 0
extern volatile __bit                   SMT1CSEL1           @ (((unsigned) &SMT1CLK)*8) + 1;
#define                                 SMT1CSEL1_bit       BANKMASK(SMT1CLK), 1
extern volatile __bit                   SMT1CSEL2           @ (((unsigned) &SMT1CLK)*8) + 2;
#define                                 SMT1CSEL2_bit       BANKMASK(SMT1CLK), 2
extern volatile __bit                   SMT1GO              @ (((unsigned) &SMT1CON1)*8) + 7;
#define                                 SMT1GO_bit          BANKMASK(SMT1CON1), 7
extern volatile __bit                   SMT1IE              @ (((unsigned) &PIE4)*8) + 0;
#define                                 SMT1IE_bit          BANKMASK(PIE4), 0
extern volatile __bit                   SMT1IF              @ (((unsigned) &PIR4)*8) + 0;
#define                                 SMT1IF_bit          BANKMASK(PIR4), 0
extern volatile __bit                   SMT1MODE0           @ (((unsigned) &SMT1CON1)*8) + 0;
#define                                 SMT1MODE0_bit       BANKMASK(SMT1CON1), 0
extern volatile __bit                   SMT1MODE1           @ (((unsigned) &SMT1CON1)*8) + 1;
#define                                 SMT1MODE1_bit       BANKMASK(SMT1CON1), 1
extern volatile __bit                   SMT1MODE2           @ (((unsigned) &SMT1CON1)*8) + 2;
#define                                 SMT1MODE2_bit       BANKMASK(SMT1CON1), 2
extern volatile __bit                   SMT1MODE3           @ (((unsigned) &SMT1CON1)*8) + 3;
#define                                 SMT1MODE3_bit       BANKMASK(SMT1CON1), 3
extern volatile __bit                   SMT1PR0             @ (((unsigned) &SMT1PRL)*8) + 0;
#define                                 SMT1PR0_bit         BANKMASK(SMT1PRL), 0
extern volatile __bit                   SMT1PR1             @ (((unsigned) &SMT1PRL)*8) + 1;
#define                                 SMT1PR1_bit         BANKMASK(SMT1PRL), 1
extern volatile __bit                   SMT1PR10            @ (((unsigned) &SMT1PRH)*8) + 2;
#define                                 SMT1PR10_bit        BANKMASK(SMT1PRH), 2
extern volatile __bit                   SMT1PR11            @ (((unsigned) &SMT1PRH)*8) + 3;
#define                                 SMT1PR11_bit        BANKMASK(SMT1PRH), 3
extern volatile __bit                   SMT1PR12            @ (((unsigned) &SMT1PRH)*8) + 4;
#define                                 SMT1PR12_bit        BANKMASK(SMT1PRH), 4
extern volatile __bit                   SMT1PR13            @ (((unsigned) &SMT1PRH)*8) + 5;
#define                                 SMT1PR13_bit        BANKMASK(SMT1PRH), 5
extern volatile __bit                   SMT1PR14            @ (((unsigned) &SMT1PRH)*8) + 6;
#define                                 SMT1PR14_bit        BANKMASK(SMT1PRH), 6
extern volatile __bit                   SMT1PR15            @ (((unsigned) &SMT1PRH)*8) + 7;
#define                                 SMT1PR15_bit        BANKMASK(SMT1PRH), 7
extern volatile __bit                   SMT1PR16            @ (((unsigned) &SMT1PRU)*8) + 0;
#define                                 SMT1PR16_bit        BANKMASK(SMT1PRU), 0
extern volatile __bit                   SMT1PR17            @ (((unsigned) &SMT1PRU)*8) + 1;
#define                                 SMT1PR17_bit        BANKMASK(SMT1PRU), 1
extern volatile __bit                   SMT1PR18            @ (((unsigned) &SMT1PRU)*8) + 2;
#define                                 SMT1PR18_bit        BANKMASK(SMT1PRU), 2
extern volatile __bit                   SMT1PR19            @ (((unsigned) &SMT1PRU)*8) + 3;
#define                                 SMT1PR19_bit        BANKMASK(SMT1PRU), 3
extern volatile __bit                   SMT1PR2             @ (((unsigned) &SMT1PRL)*8) + 2;
#define                                 SMT1PR2_bit         BANKMASK(SMT1PRL), 2
extern volatile __bit                   SMT1PR20            @ (((unsigned) &SMT1PRU)*8) + 4;
#define                                 SMT1PR20_bit        BANKMASK(SMT1PRU), 4
extern volatile __bit                   SMT1PR21            @ (((unsigned) &SMT1PRU)*8) + 5;
#define                                 SMT1PR21_bit        BANKMASK(SMT1PRU), 5
extern volatile __bit                   SMT1PR22            @ (((unsigned) &SMT1PRU)*8) + 6;
#define                                 SMT1PR22_bit        BANKMASK(SMT1PRU), 6
extern volatile __bit                   SMT1PR23            @ (((unsigned) &SMT1PRU)*8) + 7;
#define                                 SMT1PR23_bit        BANKMASK(SMT1PRU), 7
extern volatile __bit                   SMT1PR3             @ (((unsigned) &SMT1PRL)*8) + 3;
#define                                 SMT1PR3_bit         BANKMASK(SMT1PRL), 3
extern volatile __bit                   SMT1PR4             @ (((unsigned) &SMT1PRL)*8) + 4;
#define                                 SMT1PR4_bit         BANKMASK(SMT1PRL), 4
extern volatile __bit                   SMT1PR5             @ (((unsigned) &SMT1PRL)*8) + 5;
#define                                 SMT1PR5_bit         BANKMASK(SMT1PRL), 5
extern volatile __bit                   SMT1PR6             @ (((unsigned) &SMT1PRL)*8) + 6;
#define                                 SMT1PR6_bit         BANKMASK(SMT1PRL), 6
extern volatile __bit                   SMT1PR7             @ (((unsigned) &SMT1PRL)*8) + 7;
#define                                 SMT1PR7_bit         BANKMASK(SMT1PRL), 7
extern volatile __bit                   SMT1PR8             @ (((unsigned) &SMT1PRH)*8) + 0;
#define                                 SMT1PR8_bit         BANKMASK(SMT1PRH), 0
extern volatile __bit                   SMT1PR9             @ (((unsigned) &SMT1PRH)*8) + 1;
#define                                 SMT1PR9_bit         BANKMASK(SMT1PRH), 1
extern volatile __bit                   SMT1PRAIE           @ (((unsigned) &PIE4)*8) + 1;
#define                                 SMT1PRAIE_bit       BANKMASK(PIE4), 1
extern volatile __bit                   SMT1PRAIF           @ (((unsigned) &PIR4)*8) + 1;
#define                                 SMT1PRAIF_bit       BANKMASK(PIR4), 1
extern volatile __bit                   SMT1PS0             @ (((unsigned) &SMT1CON0)*8) + 0;
#define                                 SMT1PS0_bit         BANKMASK(SMT1CON0), 0
extern volatile __bit                   SMT1PS1             @ (((unsigned) &SMT1CON0)*8) + 1;
#define                                 SMT1PS1_bit         BANKMASK(SMT1CON0), 1
extern volatile __bit                   SMT1PWAIE           @ (((unsigned) &PIE4)*8) + 2;
#define                                 SMT1PWAIE_bit       BANKMASK(PIE4), 2
extern volatile __bit                   SMT1PWAIF           @ (((unsigned) &PIR4)*8) + 2;
#define                                 SMT1PWAIF_bit       BANKMASK(PIR4), 2
extern volatile __bit                   SMT1REPEAT          @ (((unsigned) &SMT1CON1)*8) + 6;
#define                                 SMT1REPEAT_bit      BANKMASK(SMT1CON1), 6
extern volatile __bit                   SMT1RESET           @ (((unsigned) &SMT1STAT)*8) + 5;
#define                                 SMT1RESET_bit       BANKMASK(SMT1STAT), 5
extern volatile __bit                   SMT1SIGPPS0         @ (((unsigned) &SMT1SIGPPS)*8) + 0;
#define                                 SMT1SIGPPS0_bit     BANKMASK(SMT1SIGPPS), 0
extern volatile __bit                   SMT1SIGPPS1         @ (((unsigned) &SMT1SIGPPS)*8) + 1;
#define                                 SMT1SIGPPS1_bit     BANKMASK(SMT1SIGPPS), 1
extern volatile __bit                   SMT1SIGPPS2         @ (((unsigned) &SMT1SIGPPS)*8) + 2;
#define                                 SMT1SIGPPS2_bit     BANKMASK(SMT1SIGPPS), 2
extern volatile __bit                   SMT1SIGPPS3         @ (((unsigned) &SMT1SIGPPS)*8) + 3;
#define                                 SMT1SIGPPS3_bit     BANKMASK(SMT1SIGPPS), 3
extern volatile __bit                   SMT1SIGPPS4         @ (((unsigned) &SMT1SIGPPS)*8) + 4;
#define                                 SMT1SIGPPS4_bit     BANKMASK(SMT1SIGPPS), 4
extern volatile __bit                   SMT1SSEL0           @ (((unsigned) &SMT1SIG)*8) + 0;
#define                                 SMT1SSEL0_bit       BANKMASK(SMT1SIG), 0
extern volatile __bit                   SMT1SSEL1           @ (((unsigned) &SMT1SIG)*8) + 1;
#define                                 SMT1SSEL1_bit       BANKMASK(SMT1SIG), 1
extern volatile __bit                   SMT1SSEL2           @ (((unsigned) &SMT1SIG)*8) + 2;
#define                                 SMT1SSEL2_bit       BANKMASK(SMT1SIG), 2
extern volatile __bit                   SMT1SSEL3           @ (((unsigned) &SMT1SIG)*8) + 3;
#define                                 SMT1SSEL3_bit       BANKMASK(SMT1SIG), 3
extern volatile __bit                   SMT1SSEL4           @ (((unsigned) &SMT1SIG)*8) + 4;
#define                                 SMT1SSEL4_bit       BANKMASK(SMT1SIG), 4
extern volatile __bit                   SMT1TMR0            @ (((unsigned) &SMT1TMRL)*8) + 0;
#define                                 SMT1TMR0_bit        BANKMASK(SMT1TMRL), 0
extern volatile __bit                   SMT1TMR1            @ (((unsigned) &SMT1TMRL)*8) + 1;
#define                                 SMT1TMR1_bit        BANKMASK(SMT1TMRL), 1
extern volatile __bit                   SMT1TMR10           @ (((unsigned) &SMT1TMRH)*8) + 2;
#define                                 SMT1TMR10_bit       BANKMASK(SMT1TMRH), 2
extern volatile __bit                   SMT1TMR11           @ (((unsigned) &SMT1TMRH)*8) + 3;
#define                                 SMT1TMR11_bit       BANKMASK(SMT1TMRH), 3
extern volatile __bit                   SMT1TMR12           @ (((unsigned) &SMT1TMRH)*8) + 4;
#define                                 SMT1TMR12_bit       BANKMASK(SMT1TMRH), 4
extern volatile __bit                   SMT1TMR13           @ (((unsigned) &SMT1TMRH)*8) + 5;
#define                                 SMT1TMR13_bit       BANKMASK(SMT1TMRH), 5
extern volatile __bit                   SMT1TMR14           @ (((unsigned) &SMT1TMRH)*8) + 6;
#define                                 SMT1TMR14_bit       BANKMASK(SMT1TMRH), 6
extern volatile __bit                   SMT1TMR15           @ (((unsigned) &SMT1TMRH)*8) + 7;
#define                                 SMT1TMR15_bit       BANKMASK(SMT1TMRH), 7
extern volatile __bit                   SMT1TMR16           @ (((unsigned) &SMT1TMRU)*8) + 0;
#define                                 SMT1TMR16_bit       BANKMASK(SMT1TMRU), 0
extern volatile __bit                   SMT1TMR17           @ (((unsigned) &SMT1TMRU)*8) + 1;
#define                                 SMT1TMR17_bit       BANKMASK(SMT1TMRU), 1
extern volatile __bit                   SMT1TMR18           @ (((unsigned) &SMT1TMRU)*8) + 2;
#define                                 SMT1TMR18_bit       BANKMASK(SMT1TMRU), 2
extern volatile __bit                   SMT1TMR19           @ (((unsigned) &SMT1TMRU)*8) + 3;
#define                                 SMT1TMR19_bit       BANKMASK(SMT1TMRU), 3
extern volatile __bit                   SMT1TMR2            @ (((unsigned) &SMT1TMRL)*8) + 2;
#define                                 SMT1TMR2_bit        BANKMASK(SMT1TMRL), 2
extern volatile __bit                   SMT1TMR20           @ (((unsigned) &SMT1TMRU)*8) + 4;
#define                                 SMT1TMR20_bit       BANKMASK(SMT1TMRU), 4
extern volatile __bit                   SMT1TMR21           @ (((unsigned) &SMT1TMRU)*8) + 5;
#define                                 SMT1TMR21_bit       BANKMASK(SMT1TMRU), 5
extern volatile __bit                   SMT1TMR22           @ (((unsigned) &SMT1TMRU)*8) + 6;
#define                                 SMT1TMR22_bit       BANKMASK(SMT1TMRU), 6
extern volatile __bit                   SMT1TMR23           @ (((unsigned) &SMT1TMRU)*8) + 7;
#define                                 SMT1TMR23_bit       BANKMASK(SMT1TMRU), 7
extern volatile __bit                   SMT1TMR3            @ (((unsigned) &SMT1TMRL)*8) + 3;
#define                                 SMT1TMR3_bit        BANKMASK(SMT1TMRL), 3
extern volatile __bit                   SMT1TMR4            @ (((unsigned) &SMT1TMRL)*8) + 4;
#define                                 SMT1TMR4_bit        BANKMASK(SMT1TMRL), 4
extern volatile __bit                   SMT1TMR5            @ (((unsigned) &SMT1TMRL)*8) + 5;
#define                                 SMT1TMR5_bit        BANKMASK(SMT1TMRL), 5
extern volatile __bit                   SMT1TMR6            @ (((unsigned) &SMT1TMRL)*8) + 6;
#define                                 SMT1TMR6_bit        BANKMASK(SMT1TMRL), 6
extern volatile __bit                   SMT1TMR7            @ (((unsigned) &SMT1TMRL)*8) + 7;
#define                                 SMT1TMR7_bit        BANKMASK(SMT1TMRL), 7
extern volatile __bit                   SMT1TMR8            @ (((unsigned) &SMT1TMRH)*8) + 0;
#define                                 SMT1TMR8_bit        BANKMASK(SMT1TMRH), 0
extern volatile __bit                   SMT1TMR9            @ (((unsigned) &SMT1TMRH)*8) + 1;
#define                                 SMT1TMR9_bit        BANKMASK(SMT1TMRH), 1
extern volatile __bit                   SMT1TS              @ (((unsigned) &SMT1STAT)*8) + 2;
#define                                 SMT1TS_bit          BANKMASK(SMT1STAT), 2
extern volatile __bit                   SMT1WS              @ (((unsigned) &SMT1STAT)*8) + 1;
#define                                 SMT1WS_bit          BANKMASK(SMT1STAT), 1
extern volatile __bit                   SMT1WSEL0           @ (((unsigned) &SMT1WIN)*8) + 0;
#define                                 SMT1WSEL0_bit       BANKMASK(SMT1WIN), 0
extern volatile __bit                   SMT1WSEL1           @ (((unsigned) &SMT1WIN)*8) + 1;
#define                                 SMT1WSEL1_bit       BANKMASK(SMT1WIN), 1
extern volatile __bit                   SMT1WSEL2           @ (((unsigned) &SMT1WIN)*8) + 2;
#define                                 SMT1WSEL2_bit       BANKMASK(SMT1WIN), 2
extern volatile __bit                   SMT1WSEL3           @ (((unsigned) &SMT1WIN)*8) + 3;
#define                                 SMT1WSEL3_bit       BANKMASK(SMT1WIN), 3
extern volatile __bit                   SMT1WSEL4           @ (((unsigned) &SMT1WIN)*8) + 4;
#define                                 SMT1WSEL4_bit       BANKMASK(SMT1WIN), 4
extern volatile __bit                   SMT2AS              @ (((unsigned) &SMT2STAT)*8) + 0;
#define                                 SMT2AS_bit          BANKMASK(SMT2STAT), 0
extern volatile __bit                   SMT2CPR0            @ (((unsigned) &SMT2CPRL)*8) + 0;
#define                                 SMT2CPR0_bit        BANKMASK(SMT2CPRL), 0
extern volatile __bit                   SMT2CPR1            @ (((unsigned) &SMT2CPRL)*8) + 1;
#define                                 SMT2CPR1_bit        BANKMASK(SMT2CPRL), 1
extern volatile __bit                   SMT2CPR10           @ (((unsigned) &SMT2CPRH)*8) + 2;
#define                                 SMT2CPR10_bit       BANKMASK(SMT2CPRH), 2
extern volatile __bit                   SMT2CPR11           @ (((unsigned) &SMT2CPRH)*8) + 3;
#define                                 SMT2CPR11_bit       BANKMASK(SMT2CPRH), 3
extern volatile __bit                   SMT2CPR12           @ (((unsigned) &SMT2CPRH)*8) + 4;
#define                                 SMT2CPR12_bit       BANKMASK(SMT2CPRH), 4
extern volatile __bit                   SMT2CPR13           @ (((unsigned) &SMT2CPRH)*8) + 5;
#define                                 SMT2CPR13_bit       BANKMASK(SMT2CPRH), 5
extern volatile __bit                   SMT2CPR14           @ (((unsigned) &SMT2CPRH)*8) + 6;
#define                                 SMT2CPR14_bit       BANKMASK(SMT2CPRH), 6
extern volatile __bit                   SMT2CPR15           @ (((unsigned) &SMT2CPRH)*8) + 7;
#define                                 SMT2CPR15_bit       BANKMASK(SMT2CPRH), 7
extern volatile __bit                   SMT2CPR16           @ (((unsigned) &SMT2CPRU)*8) + 0;
#define                                 SMT2CPR16_bit       BANKMASK(SMT2CPRU), 0
extern volatile __bit                   SMT2CPR17           @ (((unsigned) &SMT2CPRU)*8) + 1;
#define                                 SMT2CPR17_bit       BANKMASK(SMT2CPRU), 1
extern volatile __bit                   SMT2CPR18           @ (((unsigned) &SMT2CPRU)*8) + 2;
#define                                 SMT2CPR18_bit       BANKMASK(SMT2CPRU), 2
extern volatile __bit                   SMT2CPR19           @ (((unsigned) &SMT2CPRU)*8) + 3;
#define                                 SMT2CPR19_bit       BANKMASK(SMT2CPRU), 3
extern volatile __bit                   SMT2CPR2            @ (((unsigned) &SMT2CPRL)*8) + 2;
#define                                 SMT2CPR2_bit        BANKMASK(SMT2CPRL), 2
extern volatile __bit                   SMT2CPR20           @ (((unsigned) &SMT2CPRU)*8) + 4;
#define                                 SMT2CPR20_bit       BANKMASK(SMT2CPRU), 4
extern volatile __bit                   SMT2CPR21           @ (((unsigned) &SMT2CPRU)*8) + 5;
#define                                 SMT2CPR21_bit       BANKMASK(SMT2CPRU), 5
extern volatile __bit                   SMT2CPR22           @ (((unsigned) &SMT2CPRU)*8) + 6;
#define                                 SMT2CPR22_bit       BANKMASK(SMT2CPRU), 6
extern volatile __bit                   SMT2CPR23           @ (((unsigned) &SMT2CPRU)*8) + 7;
#define                                 SMT2CPR23_bit       BANKMASK(SMT2CPRU), 7
extern volatile __bit                   SMT2CPR3            @ (((unsigned) &SMT2CPRL)*8) + 3;
#define                                 SMT2CPR3_bit        BANKMASK(SMT2CPRL), 3
extern volatile __bit                   SMT2CPR4            @ (((unsigned) &SMT2CPRL)*8) + 4;
#define                                 SMT2CPR4_bit        BANKMASK(SMT2CPRL), 4
extern volatile __bit                   SMT2CPR5            @ (((unsigned) &SMT2CPRL)*8) + 5;
#define                                 SMT2CPR5_bit        BANKMASK(SMT2CPRL), 5
extern volatile __bit                   SMT2CPR6            @ (((unsigned) &SMT2CPRL)*8) + 6;
#define                                 SMT2CPR6_bit        BANKMASK(SMT2CPRL), 6
extern volatile __bit                   SMT2CPR7            @ (((unsigned) &SMT2CPRL)*8) + 7;
#define                                 SMT2CPR7_bit        BANKMASK(SMT2CPRL), 7
extern volatile __bit                   SMT2CPR8            @ (((unsigned) &SMT2CPRH)*8) + 0;
#define                                 SMT2CPR8_bit        BANKMASK(SMT2CPRH), 0
extern volatile __bit                   SMT2CPR9            @ (((unsigned) &SMT2CPRH)*8) + 1;
#define                                 SMT2CPR9_bit        BANKMASK(SMT2CPRH), 1
extern volatile __bit                   SMT2CPRUP           @ (((unsigned) &SMT2STAT)*8) + 7;
#define                                 SMT2CPRUP_bit       BANKMASK(SMT2STAT), 7
extern volatile __bit                   SMT2CPW0            @ (((unsigned) &SMT2CPWL)*8) + 0;
#define                                 SMT2CPW0_bit        BANKMASK(SMT2CPWL), 0
extern volatile __bit                   SMT2CPW1            @ (((unsigned) &SMT2CPWL)*8) + 1;
#define                                 SMT2CPW1_bit        BANKMASK(SMT2CPWL), 1
extern volatile __bit                   SMT2CPW10           @ (((unsigned) &SMT2CPWH)*8) + 2;
#define                                 SMT2CPW10_bit       BANKMASK(SMT2CPWH), 2
extern volatile __bit                   SMT2CPW11           @ (((unsigned) &SMT2CPWH)*8) + 3;
#define                                 SMT2CPW11_bit       BANKMASK(SMT2CPWH), 3
extern volatile __bit                   SMT2CPW12           @ (((unsigned) &SMT2CPWH)*8) + 4;
#define                                 SMT2CPW12_bit       BANKMASK(SMT2CPWH), 4
extern volatile __bit                   SMT2CPW13           @ (((unsigned) &SMT2CPWH)*8) + 5;
#define                                 SMT2CPW13_bit       BANKMASK(SMT2CPWH), 5
extern volatile __bit                   SMT2CPW14           @ (((unsigned) &SMT2CPWH)*8) + 6;
#define                                 SMT2CPW14_bit       BANKMASK(SMT2CPWH), 6
extern volatile __bit                   SMT2CPW15           @ (((unsigned) &SMT2CPWH)*8) + 7;
#define                                 SMT2CPW15_bit       BANKMASK(SMT2CPWH), 7
extern volatile __bit                   SMT2CPW16           @ (((unsigned) &SMT2CPWU)*8) + 0;
#define                                 SMT2CPW16_bit       BANKMASK(SMT2CPWU), 0
extern volatile __bit                   SMT2CPW17           @ (((unsigned) &SMT2CPWU)*8) + 1;
#define                                 SMT2CPW17_bit       BANKMASK(SMT2CPWU), 1
extern volatile __bit                   SMT2CPW18           @ (((unsigned) &SMT2CPWU)*8) + 2;
#define                                 SMT2CPW18_bit       BANKMASK(SMT2CPWU), 2
extern volatile __bit                   SMT2CPW19           @ (((unsigned) &SMT2CPWU)*8) + 3;
#define                                 SMT2CPW19_bit       BANKMASK(SMT2CPWU), 3
extern volatile __bit                   SMT2CPW2            @ (((unsigned) &SMT2CPWL)*8) + 2;
#define                                 SMT2CPW2_bit        BANKMASK(SMT2CPWL), 2
extern volatile __bit                   SMT2CPW20           @ (((unsigned) &SMT2CPWU)*8) + 4;
#define                                 SMT2CPW20_bit       BANKMASK(SMT2CPWU), 4
extern volatile __bit                   SMT2CPW21           @ (((unsigned) &SMT2CPWU)*8) + 5;
#define                                 SMT2CPW21_bit       BANKMASK(SMT2CPWU), 5
extern volatile __bit                   SMT2CPW22           @ (((unsigned) &SMT2CPWU)*8) + 6;
#define                                 SMT2CPW22_bit       BANKMASK(SMT2CPWU), 6
extern volatile __bit                   SMT2CPW23           @ (((unsigned) &SMT2CPWU)*8) + 7;
#define                                 SMT2CPW23_bit       BANKMASK(SMT2CPWU), 7
extern volatile __bit                   SMT2CPW3            @ (((unsigned) &SMT2CPWL)*8) + 3;
#define                                 SMT2CPW3_bit        BANKMASK(SMT2CPWL), 3
extern volatile __bit                   SMT2CPW4            @ (((unsigned) &SMT2CPWL)*8) + 4;
#define                                 SMT2CPW4_bit        BANKMASK(SMT2CPWL), 4
extern volatile __bit                   SMT2CPW5            @ (((unsigned) &SMT2CPWL)*8) + 5;
#define                                 SMT2CPW5_bit        BANKMASK(SMT2CPWL), 5
extern volatile __bit                   SMT2CPW6            @ (((unsigned) &SMT2CPWL)*8) + 6;
#define                                 SMT2CPW6_bit        BANKMASK(SMT2CPWL), 6
extern volatile __bit                   SMT2CPW7            @ (((unsigned) &SMT2CPWL)*8) + 7;
#define                                 SMT2CPW7_bit        BANKMASK(SMT2CPWL), 7
extern volatile __bit                   SMT2CPW8            @ (((unsigned) &SMT2CPWH)*8) + 0;
#define                                 SMT2CPW8_bit        BANKMASK(SMT2CPWH), 0
extern volatile __bit                   SMT2CPW9            @ (((unsigned) &SMT2CPWH)*8) + 1;
#define                                 SMT2CPW9_bit        BANKMASK(SMT2CPWH), 1
extern volatile __bit                   SMT2CPWUP           @ (((unsigned) &SMT2STAT)*8) + 6;
#define                                 SMT2CPWUP_bit       BANKMASK(SMT2STAT), 6
extern volatile __bit                   SMT2CSEL0           @ (((unsigned) &SMT2CLK)*8) + 0;
#define                                 SMT2CSEL0_bit       BANKMASK(SMT2CLK), 0
extern volatile __bit                   SMT2CSEL1           @ (((unsigned) &SMT2CLK)*8) + 1;
#define                                 SMT2CSEL1_bit       BANKMASK(SMT2CLK), 1
extern volatile __bit                   SMT2CSEL2           @ (((unsigned) &SMT2CLK)*8) + 2;
#define                                 SMT2CSEL2_bit       BANKMASK(SMT2CLK), 2
extern volatile __bit                   SMT2GO              @ (((unsigned) &SMT2CON1)*8) + 7;
#define                                 SMT2GO_bit          BANKMASK(SMT2CON1), 7
extern volatile __bit                   SMT2IE              @ (((unsigned) &PIE4)*8) + 3;
#define                                 SMT2IE_bit          BANKMASK(PIE4), 3
extern volatile __bit                   SMT2IF              @ (((unsigned) &PIR4)*8) + 3;
#define                                 SMT2IF_bit          BANKMASK(PIR4), 3
extern volatile __bit                   SMT2MODE0           @ (((unsigned) &SMT2CON1)*8) + 0;
#define                                 SMT2MODE0_bit       BANKMASK(SMT2CON1), 0
extern volatile __bit                   SMT2MODE1           @ (((unsigned) &SMT2CON1)*8) + 1;
#define                                 SMT2MODE1_bit       BANKMASK(SMT2CON1), 1
extern volatile __bit                   SMT2MODE2           @ (((unsigned) &SMT2CON1)*8) + 2;
#define                                 SMT2MODE2_bit       BANKMASK(SMT2CON1), 2
extern volatile __bit                   SMT2MODE3           @ (((unsigned) &SMT2CON1)*8) + 3;
#define                                 SMT2MODE3_bit       BANKMASK(SMT2CON1), 3
extern volatile __bit                   SMT2PR0             @ (((unsigned) &SMT2PRL)*8) + 0;
#define                                 SMT2PR0_bit         BANKMASK(SMT2PRL), 0
extern volatile __bit                   SMT2PR1             @ (((unsigned) &SMT2PRL)*8) + 1;
#define                                 SMT2PR1_bit         BANKMASK(SMT2PRL), 1
extern volatile __bit                   SMT2PR10            @ (((unsigned) &SMT2PRH)*8) + 2;
#define                                 SMT2PR10_bit        BANKMASK(SMT2PRH), 2
extern volatile __bit                   SMT2PR11            @ (((unsigned) &SMT2PRH)*8) + 3;
#define                                 SMT2PR11_bit        BANKMASK(SMT2PRH), 3
extern volatile __bit                   SMT2PR12            @ (((unsigned) &SMT2PRH)*8) + 4;
#define                                 SMT2PR12_bit        BANKMASK(SMT2PRH), 4
extern volatile __bit                   SMT2PR13            @ (((unsigned) &SMT2PRH)*8) + 5;
#define                                 SMT2PR13_bit        BANKMASK(SMT2PRH), 5
extern volatile __bit                   SMT2PR14            @ (((unsigned) &SMT2PRH)*8) + 6;
#define                                 SMT2PR14_bit        BANKMASK(SMT2PRH), 6
extern volatile __bit                   SMT2PR15            @ (((unsigned) &SMT2PRH)*8) + 7;
#define                                 SMT2PR15_bit        BANKMASK(SMT2PRH), 7
extern volatile __bit                   SMT2PR16            @ (((unsigned) &SMT2PRU)*8) + 0;
#define                                 SMT2PR16_bit        BANKMASK(SMT2PRU), 0
extern volatile __bit                   SMT2PR17            @ (((unsigned) &SMT2PRU)*8) + 1;
#define                                 SMT2PR17_bit        BANKMASK(SMT2PRU), 1
extern volatile __bit                   SMT2PR18            @ (((unsigned) &SMT2PRU)*8) + 2;
#define                                 SMT2PR18_bit        BANKMASK(SMT2PRU), 2
extern volatile __bit                   SMT2PR19            @ (((unsigned) &SMT2PRU)*8) + 3;
#define                                 SMT2PR19_bit        BANKMASK(SMT2PRU), 3
extern volatile __bit                   SMT2PR2             @ (((unsigned) &SMT2PRL)*8) + 2;
#define                                 SMT2PR2_bit         BANKMASK(SMT2PRL), 2
extern volatile __bit                   SMT2PR20            @ (((unsigned) &SMT2PRU)*8) + 4;
#define                                 SMT2PR20_bit        BANKMASK(SMT2PRU), 4
extern volatile __bit                   SMT2PR21            @ (((unsigned) &SMT2PRU)*8) + 5;
#define                                 SMT2PR21_bit        BANKMASK(SMT2PRU), 5
extern volatile __bit                   SMT2PR22            @ (((unsigned) &SMT2PRU)*8) + 6;
#define                                 SMT2PR22_bit        BANKMASK(SMT2PRU), 6
extern volatile __bit                   SMT2PR23            @ (((unsigned) &SMT2PRU)*8) + 7;
#define                                 SMT2PR23_bit        BANKMASK(SMT2PRU), 7
extern volatile __bit                   SMT2PR3             @ (((unsigned) &SMT2PRL)*8) + 3;
#define                                 SMT2PR3_bit         BANKMASK(SMT2PRL), 3
extern volatile __bit                   SMT2PR4             @ (((unsigned) &SMT2PRL)*8) + 4;
#define                                 SMT2PR4_bit         BANKMASK(SMT2PRL), 4
extern volatile __bit                   SMT2PR5             @ (((unsigned) &SMT2PRL)*8) + 5;
#define                                 SMT2PR5_bit         BANKMASK(SMT2PRL), 5
extern volatile __bit                   SMT2PR6             @ (((unsigned) &SMT2PRL)*8) + 6;
#define                                 SMT2PR6_bit         BANKMASK(SMT2PRL), 6
extern volatile __bit                   SMT2PR7             @ (((unsigned) &SMT2PRL)*8) + 7;
#define                                 SMT2PR7_bit         BANKMASK(SMT2PRL), 7
extern volatile __bit                   SMT2PR8             @ (((unsigned) &SMT2PRH)*8) + 0;
#define                                 SMT2PR8_bit         BANKMASK(SMT2PRH), 0
extern volatile __bit                   SMT2PR9             @ (((unsigned) &SMT2PRH)*8) + 1;
#define                                 SMT2PR9_bit         BANKMASK(SMT2PRH), 1
extern volatile __bit                   SMT2PRAIE           @ (((unsigned) &PIE4)*8) + 4;
#define                                 SMT2PRAIE_bit       BANKMASK(PIE4), 4
extern volatile __bit                   SMT2PRAIF           @ (((unsigned) &PIR4)*8) + 4;
#define                                 SMT2PRAIF_bit       BANKMASK(PIR4), 4
extern volatile __bit                   SMT2PS0             @ (((unsigned) &SMT2CON0)*8) + 0;
#define                                 SMT2PS0_bit         BANKMASK(SMT2CON0), 0
extern volatile __bit                   SMT2PS1             @ (((unsigned) &SMT2CON0)*8) + 1;
#define                                 SMT2PS1_bit         BANKMASK(SMT2CON0), 1
extern volatile __bit                   SMT2PWAIE           @ (((unsigned) &PIE4)*8) + 5;
#define                                 SMT2PWAIE_bit       BANKMASK(PIE4), 5
extern volatile __bit                   SMT2PWAIF           @ (((unsigned) &PIR4)*8) + 5;
#define                                 SMT2PWAIF_bit       BANKMASK(PIR4), 5
extern volatile __bit                   SMT2REPEAT          @ (((unsigned) &SMT2CON1)*8) + 6;
#define                                 SMT2REPEAT_bit      BANKMASK(SMT2CON1), 6
extern volatile __bit                   SMT2RESET           @ (((unsigned) &SMT2STAT)*8) + 5;
#define                                 SMT2RESET_bit       BANKMASK(SMT2STAT), 5
extern volatile __bit                   SMT2SIGPPS0         @ (((unsigned) &SMT2SIGPPS)*8) + 0;
#define                                 SMT2SIGPPS0_bit     BANKMASK(SMT2SIGPPS), 0
extern volatile __bit                   SMT2SIGPPS1         @ (((unsigned) &SMT2SIGPPS)*8) + 1;
#define                                 SMT2SIGPPS1_bit     BANKMASK(SMT2SIGPPS), 1
extern volatile __bit                   SMT2SIGPPS2         @ (((unsigned) &SMT2SIGPPS)*8) + 2;
#define                                 SMT2SIGPPS2_bit     BANKMASK(SMT2SIGPPS), 2
extern volatile __bit                   SMT2SIGPPS3         @ (((unsigned) &SMT2SIGPPS)*8) + 3;
#define                                 SMT2SIGPPS3_bit     BANKMASK(SMT2SIGPPS), 3
extern volatile __bit                   SMT2SIGPPS4         @ (((unsigned) &SMT2SIGPPS)*8) + 4;
#define                                 SMT2SIGPPS4_bit     BANKMASK(SMT2SIGPPS), 4
extern volatile __bit                   SMT2SSEL0           @ (((unsigned) &SMT2SIG)*8) + 0;
#define                                 SMT2SSEL0_bit       BANKMASK(SMT2SIG), 0
extern volatile __bit                   SMT2SSEL1           @ (((unsigned) &SMT2SIG)*8) + 1;
#define                                 SMT2SSEL1_bit       BANKMASK(SMT2SIG), 1
extern volatile __bit                   SMT2SSEL2           @ (((unsigned) &SMT2SIG)*8) + 2;
#define                                 SMT2SSEL2_bit       BANKMASK(SMT2SIG), 2
extern volatile __bit                   SMT2SSEL3           @ (((unsigned) &SMT2SIG)*8) + 3;
#define                                 SMT2SSEL3_bit       BANKMASK(SMT2SIG), 3
extern volatile __bit                   SMT2SSEL4           @ (((unsigned) &SMT2SIG)*8) + 4;
#define                                 SMT2SSEL4_bit       BANKMASK(SMT2SIG), 4
extern volatile __bit                   SMT2TMR0            @ (((unsigned) &SMT2TMRL)*8) + 0;
#define                                 SMT2TMR0_bit        BANKMASK(SMT2TMRL), 0
extern volatile __bit                   SMT2TMR1            @ (((unsigned) &SMT2TMRL)*8) + 1;
#define                                 SMT2TMR1_bit        BANKMASK(SMT2TMRL), 1
extern volatile __bit                   SMT2TMR10           @ (((unsigned) &SMT2TMRH)*8) + 2;
#define                                 SMT2TMR10_bit       BANKMASK(SMT2TMRH), 2
extern volatile __bit                   SMT2TMR11           @ (((unsigned) &SMT2TMRH)*8) + 3;
#define                                 SMT2TMR11_bit       BANKMASK(SMT2TMRH), 3
extern volatile __bit                   SMT2TMR12           @ (((unsigned) &SMT2TMRH)*8) + 4;
#define                                 SMT2TMR12_bit       BANKMASK(SMT2TMRH), 4
extern volatile __bit                   SMT2TMR13           @ (((unsigned) &SMT2TMRH)*8) + 5;
#define                                 SMT2TMR13_bit       BANKMASK(SMT2TMRH), 5
extern volatile __bit                   SMT2TMR14           @ (((unsigned) &SMT2TMRH)*8) + 6;
#define                                 SMT2TMR14_bit       BANKMASK(SMT2TMRH), 6
extern volatile __bit                   SMT2TMR15           @ (((unsigned) &SMT2TMRH)*8) + 7;
#define                                 SMT2TMR15_bit       BANKMASK(SMT2TMRH), 7
extern volatile __bit                   SMT2TMR16           @ (((unsigned) &SMT2TMRU)*8) + 0;
#define                                 SMT2TMR16_bit       BANKMASK(SMT2TMRU), 0
extern volatile __bit                   SMT2TMR17           @ (((unsigned) &SMT2TMRU)*8) + 1;
#define                                 SMT2TMR17_bit       BANKMASK(SMT2TMRU), 1
extern volatile __bit                   SMT2TMR18           @ (((unsigned) &SMT2TMRU)*8) + 2;
#define                                 SMT2TMR18_bit       BANKMASK(SMT2TMRU), 2
extern volatile __bit                   SMT2TMR19           @ (((unsigned) &SMT2TMRU)*8) + 3;
#define                                 SMT2TMR19_bit       BANKMASK(SMT2TMRU), 3
extern volatile __bit                   SMT2TMR2            @ (((unsigned) &SMT2TMRL)*8) + 2;
#define                                 SMT2TMR2_bit        BANKMASK(SMT2TMRL), 2
extern volatile __bit                   SMT2TMR20           @ (((unsigned) &SMT2TMRU)*8) + 4;
#define                                 SMT2TMR20_bit       BANKMASK(SMT2TMRU), 4
extern volatile __bit                   SMT2TMR21           @ (((unsigned) &SMT2TMRU)*8) + 5;
#define                                 SMT2TMR21_bit       BANKMASK(SMT2TMRU), 5
extern volatile __bit                   SMT2TMR22           @ (((unsigned) &SMT2TMRU)*8) + 6;
#define                                 SMT2TMR22_bit       BANKMASK(SMT2TMRU), 6
extern volatile __bit                   SMT2TMR23           @ (((unsigned) &SMT2TMRU)*8) + 7;
#define                                 SMT2TMR23_bit       BANKMASK(SMT2TMRU), 7
extern volatile __bit                   SMT2TMR3            @ (((unsigned) &SMT2TMRL)*8) + 3;
#define                                 SMT2TMR3_bit        BANKMASK(SMT2TMRL), 3
extern volatile __bit                   SMT2TMR4            @ (((unsigned) &SMT2TMRL)*8) + 4;
#define                                 SMT2TMR4_bit        BANKMASK(SMT2TMRL), 4
extern volatile __bit                   SMT2TMR5            @ (((unsigned) &SMT2TMRL)*8) + 5;
#define                                 SMT2TMR5_bit        BANKMASK(SMT2TMRL), 5
extern volatile __bit                   SMT2TMR6            @ (((unsigned) &SMT2TMRL)*8) + 6;
#define                                 SMT2TMR6_bit        BANKMASK(SMT2TMRL), 6
extern volatile __bit                   SMT2TMR7            @ (((unsigned) &SMT2TMRL)*8) + 7;
#define                                 SMT2TMR7_bit        BANKMASK(SMT2TMRL), 7
extern volatile __bit                   SMT2TMR8            @ (((unsigned) &SMT2TMRH)*8) + 0;
#define                                 SMT2TMR8_bit        BANKMASK(SMT2TMRH), 0
extern volatile __bit                   SMT2TMR9            @ (((unsigned) &SMT2TMRH)*8) + 1;
#define                                 SMT2TMR9_bit        BANKMASK(SMT2TMRH), 1
extern volatile __bit                   SMT2TS              @ (((unsigned) &SMT2STAT)*8) + 2;
#define                                 SMT2TS_bit          BANKMASK(SMT2STAT), 2
extern volatile __bit                   SMT2WINPPS0         @ (((unsigned) &SMT2WINPPS)*8) + 0;
#define                                 SMT2WINPPS0_bit     BANKMASK(SMT2WINPPS), 0
extern volatile __bit                   SMT2WINPPS1         @ (((unsigned) &SMT2WINPPS)*8) + 1;
#define                                 SMT2WINPPS1_bit     BANKMASK(SMT2WINPPS), 1
extern volatile __bit                   SMT2WINPPS2         @ (((unsigned) &SMT2WINPPS)*8) + 2;
#define                                 SMT2WINPPS2_bit     BANKMASK(SMT2WINPPS), 2
extern volatile __bit                   SMT2WINPPS3         @ (((unsigned) &SMT2WINPPS)*8) + 3;
#define                                 SMT2WINPPS3_bit     BANKMASK(SMT2WINPPS), 3
extern volatile __bit                   SMT2WINPPS4         @ (((unsigned) &SMT2WINPPS)*8) + 4;
#define                                 SMT2WINPPS4_bit     BANKMASK(SMT2WINPPS), 4
extern volatile __bit                   SMT2WS              @ (((unsigned) &SMT2STAT)*8) + 1;
#define                                 SMT2WS_bit          BANKMASK(SMT2STAT), 1
extern volatile __bit                   SMT2WSEL0           @ (((unsigned) &SMT2WIN)*8) + 0;
#define                                 SMT2WSEL0_bit       BANKMASK(SMT2WIN), 0
extern volatile __bit                   SMT2WSEL1           @ (((unsigned) &SMT2WIN)*8) + 1;
#define                                 SMT2WSEL1_bit       BANKMASK(SMT2WIN), 1
extern volatile __bit                   SMT2WSEL2           @ (((unsigned) &SMT2WIN)*8) + 2;
#define                                 SMT2WSEL2_bit       BANKMASK(SMT2WIN), 2
extern volatile __bit                   SMT2WSEL3           @ (((unsigned) &SMT2WIN)*8) + 3;
#define                                 SMT2WSEL3_bit       BANKMASK(SMT2WIN), 3
extern volatile __bit                   SMT2WSEL4           @ (((unsigned) &SMT2WIN)*8) + 4;
#define                                 SMT2WSEL4_bit       BANKMASK(SMT2WIN), 4
extern volatile __bit                   SMTWINPPS0          @ (((unsigned) &SMT1WINPPS)*8) + 0;
#define                                 SMTWINPPS0_bit      BANKMASK(SMT1WINPPS), 0
extern volatile __bit                   SMTWINPPS1          @ (((unsigned) &SMT1WINPPS)*8) + 1;
#define                                 SMTWINPPS1_bit      BANKMASK(SMT1WINPPS), 1
extern volatile __bit                   SMTWINPPS2          @ (((unsigned) &SMT1WINPPS)*8) + 2;
#define                                 SMTWINPPS2_bit      BANKMASK(SMT1WINPPS), 2
extern volatile __bit                   SMTWINPPS3          @ (((unsigned) &SMT1WINPPS)*8) + 3;
#define                                 SMTWINPPS3_bit      BANKMASK(SMT1WINPPS), 3
extern volatile __bit                   SMTWINPPS4          @ (((unsigned) &SMT1WINPPS)*8) + 4;
#define                                 SMTWINPPS4_bit      BANKMASK(SMT1WINPPS), 4
extern volatile __bit                   SPEN                @ (((unsigned) &RC1STA)*8) + 7;
#define                                 SPEN_bit            BANKMASK(RC1STA), 7
extern volatile __bit                   SPLLEN              @ (((unsigned) &OSCCON)*8) + 7;
#define                                 SPLLEN_bit          BANKMASK(OSCCON), 7
extern volatile __bit                   SREN                @ (((unsigned) &RC1STA)*8) + 5;
#define                                 SREN_bit            BANKMASK(RC1STA), 5
extern volatile __bit                   SSP1ADD0            @ (((unsigned) &SSP1ADD)*8) + 0;
#define                                 SSP1ADD0_bit        BANKMASK(SSP1ADD), 0
extern volatile __bit                   SSP1ADD1            @ (((unsigned) &SSP1ADD)*8) + 1;
#define                                 SSP1ADD1_bit        BANKMASK(SSP1ADD), 1
extern volatile __bit                   SSP1ADD2            @ (((unsigned) &SSP1ADD)*8) + 2;
#define                                 SSP1ADD2_bit        BANKMASK(SSP1ADD), 2
extern volatile __bit                   SSP1ADD3            @ (((unsigned) &SSP1ADD)*8) + 3;
#define                                 SSP1ADD3_bit        BANKMASK(SSP1ADD), 3
extern volatile __bit                   SSP1ADD4            @ (((unsigned) &SSP1ADD)*8) + 4;
#define                                 SSP1ADD4_bit        BANKMASK(SSP1ADD), 4
extern volatile __bit                   SSP1ADD5            @ (((unsigned) &SSP1ADD)*8) + 5;
#define                                 SSP1ADD5_bit        BANKMASK(SSP1ADD), 5
extern volatile __bit                   SSP1ADD6            @ (((unsigned) &SSP1ADD)*8) + 6;
#define                                 SSP1ADD6_bit        BANKMASK(SSP1ADD), 6
extern volatile __bit                   SSP1ADD7            @ (((unsigned) &SSP1ADD)*8) + 7;
#define                                 SSP1ADD7_bit        BANKMASK(SSP1ADD), 7
extern volatile __bit                   SSP1BUF0            @ (((unsigned) &SSP1BUF)*8) + 0;
#define                                 SSP1BUF0_bit        BANKMASK(SSP1BUF), 0
extern volatile __bit                   SSP1BUF1            @ (((unsigned) &SSP1BUF)*8) + 1;
#define                                 SSP1BUF1_bit        BANKMASK(SSP1BUF), 1
extern volatile __bit                   SSP1BUF2            @ (((unsigned) &SSP1BUF)*8) + 2;
#define                                 SSP1BUF2_bit        BANKMASK(SSP1BUF), 2
extern volatile __bit                   SSP1BUF3            @ (((unsigned) &SSP1BUF)*8) + 3;
#define                                 SSP1BUF3_bit        BANKMASK(SSP1BUF), 3
extern volatile __bit                   SSP1BUF4            @ (((unsigned) &SSP1BUF)*8) + 4;
#define                                 SSP1BUF4_bit        BANKMASK(SSP1BUF), 4
extern volatile __bit                   SSP1BUF5            @ (((unsigned) &SSP1BUF)*8) + 5;
#define                                 SSP1BUF5_bit        BANKMASK(SSP1BUF), 5
extern volatile __bit                   SSP1BUF6            @ (((unsigned) &SSP1BUF)*8) + 6;
#define                                 SSP1BUF6_bit        BANKMASK(SSP1BUF), 6
extern volatile __bit                   SSP1BUF7            @ (((unsigned) &SSP1BUF)*8) + 7;
#define                                 SSP1BUF7_bit        BANKMASK(SSP1BUF), 7
extern volatile __bit                   SSP1IE              @ (((unsigned) &PIE1)*8) + 3;
#define                                 SSP1IE_bit          BANKMASK(PIE1), 3
extern volatile __bit                   SSP1IF              @ (((unsigned) &PIR1)*8) + 3;
#define                                 SSP1IF_bit          BANKMASK(PIR1), 3
extern volatile __bit                   SSP1MSK0            @ (((unsigned) &SSP1MSK)*8) + 0;
#define                                 SSP1MSK0_bit        BANKMASK(SSP1MSK), 0
extern volatile __bit                   SSP1MSK1            @ (((unsigned) &SSP1MSK)*8) + 1;
#define                                 SSP1MSK1_bit        BANKMASK(SSP1MSK), 1
extern volatile __bit                   SSP1MSK2            @ (((unsigned) &SSP1MSK)*8) + 2;
#define                                 SSP1MSK2_bit        BANKMASK(SSP1MSK), 2
extern volatile __bit                   SSP1MSK3            @ (((unsigned) &SSP1MSK)*8) + 3;
#define                                 SSP1MSK3_bit        BANKMASK(SSP1MSK), 3
extern volatile __bit                   SSP1MSK4            @ (((unsigned) &SSP1MSK)*8) + 4;
#define                                 SSP1MSK4_bit        BANKMASK(SSP1MSK), 4
extern volatile __bit                   SSP1MSK5            @ (((unsigned) &SSP1MSK)*8) + 5;
#define                                 SSP1MSK5_bit        BANKMASK(SSP1MSK), 5
extern volatile __bit                   SSP1MSK6            @ (((unsigned) &SSP1MSK)*8) + 6;
#define                                 SSP1MSK6_bit        BANKMASK(SSP1MSK), 6
extern volatile __bit                   SSP1MSK7            @ (((unsigned) &SSP1MSK)*8) + 7;
#define                                 SSP1MSK7_bit        BANKMASK(SSP1MSK), 7
extern volatile __bit                   SSPCLKPPS0          @ (((unsigned) &SSPCLKPPS)*8) + 0;
#define                                 SSPCLKPPS0_bit      BANKMASK(SSPCLKPPS), 0
extern volatile __bit                   SSPCLKPPS1          @ (((unsigned) &SSPCLKPPS)*8) + 1;
#define                                 SSPCLKPPS1_bit      BANKMASK(SSPCLKPPS), 1
extern volatile __bit                   SSPCLKPPS2          @ (((unsigned) &SSPCLKPPS)*8) + 2;
#define                                 SSPCLKPPS2_bit      BANKMASK(SSPCLKPPS), 2
extern volatile __bit                   SSPCLKPPS3          @ (((unsigned) &SSPCLKPPS)*8) + 3;
#define                                 SSPCLKPPS3_bit      BANKMASK(SSPCLKPPS), 3
extern volatile __bit                   SSPCLKPPS4          @ (((unsigned) &SSPCLKPPS)*8) + 4;
#define                                 SSPCLKPPS4_bit      BANKMASK(SSPCLKPPS), 4
extern volatile __bit                   SSPDATPPS0          @ (((unsigned) &SSPDATPPS)*8) + 0;
#define                                 SSPDATPPS0_bit      BANKMASK(SSPDATPPS), 0
extern volatile __bit                   SSPDATPPS1          @ (((unsigned) &SSPDATPPS)*8) + 1;
#define                                 SSPDATPPS1_bit      BANKMASK(SSPDATPPS), 1
extern volatile __bit                   SSPDATPPS2          @ (((unsigned) &SSPDATPPS)*8) + 2;
#define                                 SSPDATPPS2_bit      BANKMASK(SSPDATPPS), 2
extern volatile __bit                   SSPDATPPS3          @ (((unsigned) &SSPDATPPS)*8) + 3;
#define                                 SSPDATPPS3_bit      BANKMASK(SSPDATPPS), 3
extern volatile __bit                   SSPDATPPS4          @ (((unsigned) &SSPDATPPS)*8) + 4;
#define                                 SSPDATPPS4_bit      BANKMASK(SSPDATPPS), 4
extern volatile __bit                   SSPEN               @ (((unsigned) &SSP1CON1)*8) + 5;
#define                                 SSPEN_bit           BANKMASK(SSP1CON1), 5
extern volatile __bit                   SSPM0               @ (((unsigned) &SSP1CON1)*8) + 0;
#define                                 SSPM0_bit           BANKMASK(SSP1CON1), 0
extern volatile __bit                   SSPM1               @ (((unsigned) &SSP1CON1)*8) + 1;
#define                                 SSPM1_bit           BANKMASK(SSP1CON1), 1
extern volatile __bit                   SSPM2               @ (((unsigned) &SSP1CON1)*8) + 2;
#define                                 SSPM2_bit           BANKMASK(SSP1CON1), 2
extern volatile __bit                   SSPM3               @ (((unsigned) &SSP1CON1)*8) + 3;
#define                                 SSPM3_bit           BANKMASK(SSP1CON1), 3
extern volatile __bit                   SSPOV               @ (((unsigned) &SSP1CON1)*8) + 6;
#define                                 SSPOV_bit           BANKMASK(SSP1CON1), 6
extern volatile __bit                   SSPSSPPS0           @ (((unsigned) &SSPSSPPS)*8) + 0;
#define                                 SSPSSPPS0_bit       BANKMASK(SSPSSPPS), 0
extern volatile __bit                   SSPSSPPS1           @ (((unsigned) &SSPSSPPS)*8) + 1;
#define                                 SSPSSPPS1_bit       BANKMASK(SSPSSPPS), 1
extern volatile __bit                   SSPSSPPS2           @ (((unsigned) &SSPSSPPS)*8) + 2;
#define                                 SSPSSPPS2_bit       BANKMASK(SSPSSPPS), 2
extern volatile __bit                   SSPSSPPS3           @ (((unsigned) &SSPSSPPS)*8) + 3;
#define                                 SSPSSPPS3_bit       BANKMASK(SSPSSPPS), 3
extern volatile __bit                   SSPSSPPS4           @ (((unsigned) &SSPSSPPS)*8) + 4;
#define                                 SSPSSPPS4_bit       BANKMASK(SSPSSPPS), 4
extern volatile __bit                   STATE               @ (((unsigned) &WDTTMR)*8) + 2;
#define                                 STATE_bit           BANKMASK(WDTTMR), 2
extern volatile __bit                   STKOVF              @ (((unsigned) &PCON)*8) + 7;
#define                                 STKOVF_bit          BANKMASK(PCON), 7
extern volatile __bit                   STKUNF              @ (((unsigned) &PCON)*8) + 6;
#define                                 STKUNF_bit          BANKMASK(PCON), 6
extern volatile __bit                   STPT0               @ (((unsigned) &AT1STPTL)*8) + 0;
#define                                 STPT0_bit           BANKMASK(AT1STPTL), 0
extern volatile __bit                   STPT1               @ (((unsigned) &AT1STPTL)*8) + 1;
#define                                 STPT1_bit           BANKMASK(AT1STPTL), 1
extern volatile __bit                   STPT10              @ (((unsigned) &AT1STPTH)*8) + 2;
#define                                 STPT10_bit          BANKMASK(AT1STPTH), 2
extern volatile __bit                   STPT11              @ (((unsigned) &AT1STPTH)*8) + 3;
#define                                 STPT11_bit          BANKMASK(AT1STPTH), 3
extern volatile __bit                   STPT12              @ (((unsigned) &AT1STPTH)*8) + 4;
#define                                 STPT12_bit          BANKMASK(AT1STPTH), 4
extern volatile __bit                   STPT13              @ (((unsigned) &AT1STPTH)*8) + 5;
#define                                 STPT13_bit          BANKMASK(AT1STPTH), 5
extern volatile __bit                   STPT14              @ (((unsigned) &AT1STPTH)*8) + 6;
#define                                 STPT14_bit          BANKMASK(AT1STPTH), 6
extern volatile __bit                   STPT2               @ (((unsigned) &AT1STPTL)*8) + 2;
#define                                 STPT2_bit           BANKMASK(AT1STPTL), 2
extern volatile __bit                   STPT3               @ (((unsigned) &AT1STPTL)*8) + 3;
#define                                 STPT3_bit           BANKMASK(AT1STPTL), 3
extern volatile __bit                   STPT4               @ (((unsigned) &AT1STPTL)*8) + 4;
#define                                 STPT4_bit           BANKMASK(AT1STPTL), 4
extern volatile __bit                   STPT5               @ (((unsigned) &AT1STPTL)*8) + 5;
#define                                 STPT5_bit           BANKMASK(AT1STPTL), 5
extern volatile __bit                   STPT6               @ (((unsigned) &AT1STPTL)*8) + 6;
#define                                 STPT6_bit           BANKMASK(AT1STPTL), 6
extern volatile __bit                   STPT7               @ (((unsigned) &AT1STPTL)*8) + 7;
#define                                 STPT7_bit           BANKMASK(AT1STPTL), 7
extern volatile __bit                   STPT8               @ (((unsigned) &AT1STPTH)*8) + 0;
#define                                 STPT8_bit           BANKMASK(AT1STPTH), 0
extern volatile __bit                   STPT9               @ (((unsigned) &AT1STPTH)*8) + 1;
#define                                 STPT9_bit           BANKMASK(AT1STPTH), 1
extern volatile __bit                   STRA                @ (((unsigned) &CWG1OCON0)*8) + 0;
#define                                 STRA_bit            BANKMASK(CWG1OCON0), 0
extern volatile __bit                   STRB                @ (((unsigned) &CWG1OCON0)*8) + 1;
#define                                 STRB_bit            BANKMASK(CWG1OCON0), 1
extern volatile __bit                   STRC                @ (((unsigned) &CWG1OCON0)*8) + 2;
#define                                 STRC_bit            BANKMASK(CWG1OCON0), 2
extern volatile __bit                   STRD                @ (((unsigned) &CWG1OCON0)*8) + 3;
#define                                 STRD_bit            BANKMASK(CWG1OCON0), 3
extern volatile __bit                   SWDTEN              @ (((unsigned) &WDTCON0)*8) + 0;
#define                                 SWDTEN_bit          BANKMASK(WDTCON0), 0
extern volatile __bit                   SYNC                @ (((unsigned) &TX1STA)*8) + 4;
#define                                 SYNC_bit            BANKMASK(TX1STA), 4
extern volatile __bit                   T0CKIPPS0           @ (((unsigned) &T0CKIPPS)*8) + 0;
#define                                 T0CKIPPS0_bit       BANKMASK(T0CKIPPS), 0
extern volatile __bit                   T0CKIPPS1           @ (((unsigned) &T0CKIPPS)*8) + 1;
#define                                 T0CKIPPS1_bit       BANKMASK(T0CKIPPS), 1
extern volatile __bit                   T0CKIPPS2           @ (((unsigned) &T0CKIPPS)*8) + 2;
#define                                 T0CKIPPS2_bit       BANKMASK(T0CKIPPS), 2
extern volatile __bit                   T0CKIPPS3           @ (((unsigned) &T0CKIPPS)*8) + 3;
#define                                 T0CKIPPS3_bit       BANKMASK(T0CKIPPS), 3
extern volatile __bit                   T0CKIPPS4           @ (((unsigned) &T0CKIPPS)*8) + 4;
#define                                 T0CKIPPS4_bit       BANKMASK(T0CKIPPS), 4
extern volatile __bit                   T0CS                @ (((unsigned) &OPTION_REG)*8) + 5;
#define                                 T0CS_bit            BANKMASK(OPTION_REG), 5
extern volatile __bit                   T0IE                @ (((unsigned) &INTCON)*8) + 5;
#define                                 T0IE_bit            BANKMASK(INTCON), 5
extern volatile __bit                   T0IF                @ (((unsigned) &INTCON)*8) + 2;
#define                                 T0IF_bit            BANKMASK(INTCON), 2
extern volatile __bit                   T0SE                @ (((unsigned) &OPTION_REG)*8) + 4;
#define                                 T0SE_bit            BANKMASK(OPTION_REG), 4
extern volatile __bit                   T1CKIPPS0           @ (((unsigned) &T1CKIPPS)*8) + 0;
#define                                 T1CKIPPS0_bit       BANKMASK(T1CKIPPS), 0
extern volatile __bit                   T1CKIPPS1           @ (((unsigned) &T1CKIPPS)*8) + 1;
#define                                 T1CKIPPS1_bit       BANKMASK(T1CKIPPS), 1
extern volatile __bit                   T1CKIPPS2           @ (((unsigned) &T1CKIPPS)*8) + 2;
#define                                 T1CKIPPS2_bit       BANKMASK(T1CKIPPS), 2
extern volatile __bit                   T1CKIPPS3           @ (((unsigned) &T1CKIPPS)*8) + 3;
#define                                 T1CKIPPS3_bit       BANKMASK(T1CKIPPS), 3
extern volatile __bit                   T1CKIPPS4           @ (((unsigned) &T1CKIPPS)*8) + 4;
#define                                 T1CKIPPS4_bit       BANKMASK(T1CKIPPS), 4
extern volatile __bit                   T1CKPS0             @ (((unsigned) &T1CON)*8) + 4;
#define                                 T1CKPS0_bit         BANKMASK(T1CON), 4
extern volatile __bit                   T1CKPS1             @ (((unsigned) &T1CON)*8) + 5;
#define                                 T1CKPS1_bit         BANKMASK(T1CON), 5
extern volatile __bit                   T1GGO_nDONE         @ (((unsigned) &T1GCON)*8) + 3;
#define                                 T1GGO_nDONE_bit     BANKMASK(T1GCON), 3
extern volatile __bit                   T1GPOL              @ (((unsigned) &T1GCON)*8) + 6;
#define                                 T1GPOL_bit          BANKMASK(T1GCON), 6
extern volatile __bit                   T1GPPS0             @ (((unsigned) &T1GPPS)*8) + 0;
#define                                 T1GPPS0_bit         BANKMASK(T1GPPS), 0
extern volatile __bit                   T1GPPS1             @ (((unsigned) &T1GPPS)*8) + 1;
#define                                 T1GPPS1_bit         BANKMASK(T1GPPS), 1
extern volatile __bit                   T1GPPS2             @ (((unsigned) &T1GPPS)*8) + 2;
#define                                 T1GPPS2_bit         BANKMASK(T1GPPS), 2
extern volatile __bit                   T1GPPS3             @ (((unsigned) &T1GPPS)*8) + 3;
#define                                 T1GPPS3_bit         BANKMASK(T1GPPS), 3
extern volatile __bit                   T1GPPS4             @ (((unsigned) &T1GPPS)*8) + 4;
#define                                 T1GPPS4_bit         BANKMASK(T1GPPS), 4
extern volatile __bit                   T1GSPM              @ (((unsigned) &T1GCON)*8) + 4;
#define                                 T1GSPM_bit          BANKMASK(T1GCON), 4
extern volatile __bit                   T1GSS0              @ (((unsigned) &T1GCON)*8) + 0;
#define                                 T1GSS0_bit          BANKMASK(T1GCON), 0
extern volatile __bit                   T1GSS1              @ (((unsigned) &T1GCON)*8) + 1;
#define                                 T1GSS1_bit          BANKMASK(T1GCON), 1
extern volatile __bit                   T1GTM               @ (((unsigned) &T1GCON)*8) + 5;
#define                                 T1GTM_bit           BANKMASK(T1GCON), 5
extern volatile __bit                   T1GVAL              @ (((unsigned) &T1GCON)*8) + 2;
#define                                 T1GVAL_bit          BANKMASK(T1GCON), 2
extern volatile __bit                   T2CKPOL             @ (((unsigned) &T2HLT)*8) + 6;
#define                                 T2CKPOL_bit         BANKMASK(T2HLT), 6
extern volatile __bit                   T2CKPS0             @ (((unsigned) &T2CON)*8) + 4;
#define                                 T2CKPS0_bit         BANKMASK(T2CON), 4
extern volatile __bit                   T2CKPS1             @ (((unsigned) &T2CON)*8) + 5;
#define                                 T2CKPS1_bit         BANKMASK(T2CON), 5
extern volatile __bit                   T2CKPS2             @ (((unsigned) &T2CON)*8) + 6;
#define                                 T2CKPS2_bit         BANKMASK(T2CON), 6
extern volatile __bit                   T2CKSYNC            @ (((unsigned) &T2HLT)*8) + 5;
#define                                 T2CKSYNC_bit        BANKMASK(T2HLT), 5
extern volatile __bit                   T2CS0               @ (((unsigned) &T2CLKCON)*8) + 0;
#define                                 T2CS0_bit           BANKMASK(T2CLKCON), 0
extern volatile __bit                   T2CS1               @ (((unsigned) &T2CLKCON)*8) + 1;
#define                                 T2CS1_bit           BANKMASK(T2CLKCON), 1
extern volatile __bit                   T2CS2               @ (((unsigned) &T2CLKCON)*8) + 2;
#define                                 T2CS2_bit           BANKMASK(T2CLKCON), 2
extern volatile __bit                   T2CS3               @ (((unsigned) &T2CLKCON)*8) + 3;
#define                                 T2CS3_bit           BANKMASK(T2CLKCON), 3
extern volatile __bit                   T2MODE0             @ (((unsigned) &T2HLT)*8) + 0;
#define                                 T2MODE0_bit         BANKMASK(T2HLT), 0
extern volatile __bit                   T2MODE1             @ (((unsigned) &T2HLT)*8) + 1;
#define                                 T2MODE1_bit         BANKMASK(T2HLT), 1
extern volatile __bit                   T2MODE2             @ (((unsigned) &T2HLT)*8) + 2;
#define                                 T2MODE2_bit         BANKMASK(T2HLT), 2
extern volatile __bit                   T2MODE3             @ (((unsigned) &T2HLT)*8) + 3;
#define                                 T2MODE3_bit         BANKMASK(T2HLT), 3
extern volatile __bit                   T2MODE4             @ (((unsigned) &T2HLT)*8) + 4;
#define                                 T2MODE4_bit         BANKMASK(T2HLT), 4
extern volatile __bit                   T2ON                @ (((unsigned) &T2CON)*8) + 7;
#define                                 T2ON_bit            BANKMASK(T2CON), 7
extern volatile __bit                   T2OUTPS0            @ (((unsigned) &T2CON)*8) + 0;
#define                                 T2OUTPS0_bit        BANKMASK(T2CON), 0
extern volatile __bit                   T2OUTPS1            @ (((unsigned) &T2CON)*8) + 1;
#define                                 T2OUTPS1_bit        BANKMASK(T2CON), 1
extern volatile __bit                   T2OUTPS2            @ (((unsigned) &T2CON)*8) + 2;
#define                                 T2OUTPS2_bit        BANKMASK(T2CON), 2
extern volatile __bit                   T2OUTPS3            @ (((unsigned) &T2CON)*8) + 3;
#define                                 T2OUTPS3_bit        BANKMASK(T2CON), 3
extern volatile __bit                   T2PPS0              @ (((unsigned) &T2PPS)*8) + 0;
#define                                 T2PPS0_bit          BANKMASK(T2PPS), 0
extern volatile __bit                   T2PPS1              @ (((unsigned) &T2PPS)*8) + 1;
#define                                 T2PPS1_bit          BANKMASK(T2PPS), 1
extern volatile __bit                   T2PPS2              @ (((unsigned) &T2PPS)*8) + 2;
#define                                 T2PPS2_bit          BANKMASK(T2PPS), 2
extern volatile __bit                   T2PPS3              @ (((unsigned) &T2PPS)*8) + 3;
#define                                 T2PPS3_bit          BANKMASK(T2PPS), 3
extern volatile __bit                   T2PPS4              @ (((unsigned) &T2PPS)*8) + 4;
#define                                 T2PPS4_bit          BANKMASK(T2PPS), 4
extern volatile __bit                   T2PSYNC             @ (((unsigned) &T2HLT)*8) + 7;
#define                                 T2PSYNC_bit         BANKMASK(T2HLT), 7
extern volatile __bit                   T2RSEL0             @ (((unsigned) &T2RST)*8) + 0;
#define                                 T2RSEL0_bit         BANKMASK(T2RST), 0
extern volatile __bit                   T2RSEL1             @ (((unsigned) &T2RST)*8) + 1;
#define                                 T2RSEL1_bit         BANKMASK(T2RST), 1
extern volatile __bit                   T2RSEL2             @ (((unsigned) &T2RST)*8) + 2;
#define                                 T2RSEL2_bit         BANKMASK(T2RST), 2
extern volatile __bit                   T2RSEL3             @ (((unsigned) &T2RST)*8) + 3;
#define                                 T2RSEL3_bit         BANKMASK(T2RST), 3
extern volatile __bit                   T3CKIPPS0           @ (((unsigned) &T3CKIPPS)*8) + 0;
#define                                 T3CKIPPS0_bit       BANKMASK(T3CKIPPS), 0
extern volatile __bit                   T3CKIPPS1           @ (((unsigned) &T3CKIPPS)*8) + 1;
#define                                 T3CKIPPS1_bit       BANKMASK(T3CKIPPS), 1
extern volatile __bit                   T3CKIPPS2           @ (((unsigned) &T3CKIPPS)*8) + 2;
#define                                 T3CKIPPS2_bit       BANKMASK(T3CKIPPS), 2
extern volatile __bit                   T3CKIPPS3           @ (((unsigned) &T3CKIPPS)*8) + 3;
#define                                 T3CKIPPS3_bit       BANKMASK(T3CKIPPS), 3
extern volatile __bit                   T3CKIPPS4           @ (((unsigned) &T3CKIPPS)*8) + 4;
#define                                 T3CKIPPS4_bit       BANKMASK(T3CKIPPS), 4
extern volatile __bit                   T3CKPS0             @ (((unsigned) &T3CON)*8) + 4;
#define                                 T3CKPS0_bit         BANKMASK(T3CON), 4
extern volatile __bit                   T3CKPS1             @ (((unsigned) &T3CON)*8) + 5;
#define                                 T3CKPS1_bit         BANKMASK(T3CON), 5
extern volatile __bit                   T3GGO_nDONE         @ (((unsigned) &T3GCON)*8) + 3;
#define                                 T3GGO_nDONE_bit     BANKMASK(T3GCON), 3
extern volatile __bit                   T3GPOL              @ (((unsigned) &T3GCON)*8) + 6;
#define                                 T3GPOL_bit          BANKMASK(T3GCON), 6
extern volatile __bit                   T3GPPS0             @ (((unsigned) &T3GPPS)*8) + 0;
#define                                 T3GPPS0_bit         BANKMASK(T3GPPS), 0
extern volatile __bit                   T3GPPS1             @ (((unsigned) &T3GPPS)*8) + 1;
#define                                 T3GPPS1_bit         BANKMASK(T3GPPS), 1
extern volatile __bit                   T3GPPS2             @ (((unsigned) &T3GPPS)*8) + 2;
#define                                 T3GPPS2_bit         BANKMASK(T3GPPS), 2
extern volatile __bit                   T3GPPS3             @ (((unsigned) &T3GPPS)*8) + 3;
#define                                 T3GPPS3_bit         BANKMASK(T3GPPS), 3
extern volatile __bit                   T3GPPS4             @ (((unsigned) &T3GPPS)*8) + 4;
#define                                 T3GPPS4_bit         BANKMASK(T3GPPS), 4
extern volatile __bit                   T3GSPM              @ (((unsigned) &T3GCON)*8) + 4;
#define                                 T3GSPM_bit          BANKMASK(T3GCON), 4
extern volatile __bit                   T3GSS0              @ (((unsigned) &T3GCON)*8) + 0;
#define                                 T3GSS0_bit          BANKMASK(T3GCON), 0
extern volatile __bit                   T3GSS1              @ (((unsigned) &T3GCON)*8) + 1;
#define                                 T3GSS1_bit          BANKMASK(T3GCON), 1
extern volatile __bit                   T3GTM               @ (((unsigned) &T3GCON)*8) + 5;
#define                                 T3GTM_bit           BANKMASK(T3GCON), 5
extern volatile __bit                   T3GVAL              @ (((unsigned) &T3GCON)*8) + 2;
#define                                 T3GVAL_bit          BANKMASK(T3GCON), 2
extern volatile __bit                   T3SYNC              @ (((unsigned) &T3CON)*8) + 2;
#define                                 T3SYNC_bit          BANKMASK(T3CON), 2
extern volatile __bit                   T4CKPOL             @ (((unsigned) &T4HLT)*8) + 6;
#define                                 T4CKPOL_bit         BANKMASK(T4HLT), 6
extern volatile __bit                   T4CKPS0             @ (((unsigned) &T4CON)*8) + 4;
#define                                 T4CKPS0_bit         BANKMASK(T4CON), 4
extern volatile __bit                   T4CKPS1             @ (((unsigned) &T4CON)*8) + 5;
#define                                 T4CKPS1_bit         BANKMASK(T4CON), 5
extern volatile __bit                   T4CKPS2             @ (((unsigned) &T4CON)*8) + 6;
#define                                 T4CKPS2_bit         BANKMASK(T4CON), 6
extern volatile __bit                   T4CKSYNC            @ (((unsigned) &T4HLT)*8) + 5;
#define                                 T4CKSYNC_bit        BANKMASK(T4HLT), 5
extern volatile __bit                   T4CS0               @ (((unsigned) &T4CLKCON)*8) + 0;
#define                                 T4CS0_bit           BANKMASK(T4CLKCON), 0
extern volatile __bit                   T4CS1               @ (((unsigned) &T4CLKCON)*8) + 1;
#define                                 T4CS1_bit           BANKMASK(T4CLKCON), 1
extern volatile __bit                   T4CS2               @ (((unsigned) &T4CLKCON)*8) + 2;
#define                                 T4CS2_bit           BANKMASK(T4CLKCON), 2
extern volatile __bit                   T4CS3               @ (((unsigned) &T4CLKCON)*8) + 3;
#define                                 T4CS3_bit           BANKMASK(T4CLKCON), 3
extern volatile __bit                   T4MODE0             @ (((unsigned) &T4HLT)*8) + 0;
#define                                 T4MODE0_bit         BANKMASK(T4HLT), 0
extern volatile __bit                   T4MODE1             @ (((unsigned) &T4HLT)*8) + 1;
#define                                 T4MODE1_bit         BANKMASK(T4HLT), 1
extern volatile __bit                   T4MODE2             @ (((unsigned) &T4HLT)*8) + 2;
#define                                 T4MODE2_bit         BANKMASK(T4HLT), 2
extern volatile __bit                   T4MODE3             @ (((unsigned) &T4HLT)*8) + 3;
#define                                 T4MODE3_bit         BANKMASK(T4HLT), 3
extern volatile __bit                   T4MODE4             @ (((unsigned) &T4HLT)*8) + 4;
#define                                 T4MODE4_bit         BANKMASK(T4HLT), 4
extern volatile __bit                   T4ON                @ (((unsigned) &T4CON)*8) + 7;
#define                                 T4ON_bit            BANKMASK(T4CON), 7
extern volatile __bit                   T4OUTPS0            @ (((unsigned) &T4CON)*8) + 0;
#define                                 T4OUTPS0_bit        BANKMASK(T4CON), 0
extern volatile __bit                   T4OUTPS1            @ (((unsigned) &T4CON)*8) + 1;
#define                                 T4OUTPS1_bit        BANKMASK(T4CON), 1
extern volatile __bit                   T4OUTPS2            @ (((unsigned) &T4CON)*8) + 2;
#define                                 T4OUTPS2_bit        BANKMASK(T4CON), 2
extern volatile __bit                   T4OUTPS3            @ (((unsigned) &T4CON)*8) + 3;
#define                                 T4OUTPS3_bit        BANKMASK(T4CON), 3
extern volatile __bit                   T4PPS0              @ (((unsigned) &T4PPS)*8) + 0;
#define                                 T4PPS0_bit          BANKMASK(T4PPS), 0
extern volatile __bit                   T4PPS1              @ (((unsigned) &T4PPS)*8) + 1;
#define                                 T4PPS1_bit          BANKMASK(T4PPS), 1
extern volatile __bit                   T4PPS2              @ (((unsigned) &T4PPS)*8) + 2;
#define                                 T4PPS2_bit          BANKMASK(T4PPS), 2
extern volatile __bit                   T4PPS3              @ (((unsigned) &T4PPS)*8) + 3;
#define                                 T4PPS3_bit          BANKMASK(T4PPS), 3
extern volatile __bit                   T4PPS4              @ (((unsigned) &T4PPS)*8) + 4;
#define                                 T4PPS4_bit          BANKMASK(T4PPS), 4
extern volatile __bit                   T4PSYNC             @ (((unsigned) &T4HLT)*8) + 7;
#define                                 T4PSYNC_bit         BANKMASK(T4HLT), 7
extern volatile __bit                   T4RSEL0             @ (((unsigned) &T4RST)*8) + 0;
#define                                 T4RSEL0_bit         BANKMASK(T4RST), 0
extern volatile __bit                   T4RSEL1             @ (((unsigned) &T4RST)*8) + 1;
#define                                 T4RSEL1_bit         BANKMASK(T4RST), 1
extern volatile __bit                   T4RSEL2             @ (((unsigned) &T4RST)*8) + 2;
#define                                 T4RSEL2_bit         BANKMASK(T4RST), 2
extern volatile __bit                   T4RSEL3             @ (((unsigned) &T4RST)*8) + 3;
#define                                 T4RSEL3_bit         BANKMASK(T4RST), 3
extern volatile __bit                   T5CKIPPS0           @ (((unsigned) &T5CKIPPS)*8) + 0;
#define                                 T5CKIPPS0_bit       BANKMASK(T5CKIPPS), 0
extern volatile __bit                   T5CKIPPS1           @ (((unsigned) &T5CKIPPS)*8) + 1;
#define                                 T5CKIPPS1_bit       BANKMASK(T5CKIPPS), 1
extern volatile __bit                   T5CKIPPS2           @ (((unsigned) &T5CKIPPS)*8) + 2;
#define                                 T5CKIPPS2_bit       BANKMASK(T5CKIPPS), 2
extern volatile __bit                   T5CKIPPS3           @ (((unsigned) &T5CKIPPS)*8) + 3;
#define                                 T5CKIPPS3_bit       BANKMASK(T5CKIPPS), 3
extern volatile __bit                   T5CKIPPS4           @ (((unsigned) &T5CKIPPS)*8) + 4;
#define                                 T5CKIPPS4_bit       BANKMASK(T5CKIPPS), 4
extern volatile __bit                   T5CKPS0             @ (((unsigned) &T5CON)*8) + 4;
#define                                 T5CKPS0_bit         BANKMASK(T5CON), 4
extern volatile __bit                   T5CKPS1             @ (((unsigned) &T5CON)*8) + 5;
#define                                 T5CKPS1_bit         BANKMASK(T5CON), 5
extern volatile __bit                   T5GGO_nDONE         @ (((unsigned) &T5GCON)*8) + 3;
#define                                 T5GGO_nDONE_bit     BANKMASK(T5GCON), 3
extern volatile __bit                   T5GPOL              @ (((unsigned) &T5GCON)*8) + 6;
#define                                 T5GPOL_bit          BANKMASK(T5GCON), 6
extern volatile __bit                   T5GPPS0             @ (((unsigned) &T5GPPS)*8) + 0;
#define                                 T5GPPS0_bit         BANKMASK(T5GPPS), 0
extern volatile __bit                   T5GPPS1             @ (((unsigned) &T5GPPS)*8) + 1;
#define                                 T5GPPS1_bit         BANKMASK(T5GPPS), 1
extern volatile __bit                   T5GPPS2             @ (((unsigned) &T5GPPS)*8) + 2;
#define                                 T5GPPS2_bit         BANKMASK(T5GPPS), 2
extern volatile __bit                   T5GPPS3             @ (((unsigned) &T5GPPS)*8) + 3;
#define                                 T5GPPS3_bit         BANKMASK(T5GPPS), 3
extern volatile __bit                   T5GPPS4             @ (((unsigned) &T5GPPS)*8) + 4;
#define                                 T5GPPS4_bit         BANKMASK(T5GPPS), 4
extern volatile __bit                   T5GSPM              @ (((unsigned) &T5GCON)*8) + 4;
#define                                 T5GSPM_bit          BANKMASK(T5GCON), 4
extern volatile __bit                   T5GSS0              @ (((unsigned) &T5GCON)*8) + 0;
#define                                 T5GSS0_bit          BANKMASK(T5GCON), 0
extern volatile __bit                   T5GSS1              @ (((unsigned) &T5GCON)*8) + 1;
#define                                 T5GSS1_bit          BANKMASK(T5GCON), 1
extern volatile __bit                   T5GTM               @ (((unsigned) &T5GCON)*8) + 5;
#define                                 T5GTM_bit           BANKMASK(T5GCON), 5
extern volatile __bit                   T5GVAL              @ (((unsigned) &T5GCON)*8) + 2;
#define                                 T5GVAL_bit          BANKMASK(T5GCON), 2
extern volatile __bit                   T5SYNC              @ (((unsigned) &T5CON)*8) + 2;
#define                                 T5SYNC_bit          BANKMASK(T5CON), 2
extern volatile __bit                   T6CKPOL             @ (((unsigned) &T6HLT)*8) + 6;
#define                                 T6CKPOL_bit         BANKMASK(T6HLT), 6
extern volatile __bit                   T6CKPS0             @ (((unsigned) &T6CON)*8) + 4;
#define                                 T6CKPS0_bit         BANKMASK(T6CON), 4
extern volatile __bit                   T6CKPS1             @ (((unsigned) &T6CON)*8) + 5;
#define                                 T6CKPS1_bit         BANKMASK(T6CON), 5
extern volatile __bit                   T6CKPS2             @ (((unsigned) &T6CON)*8) + 6;
#define                                 T6CKPS2_bit         BANKMASK(T6CON), 6
extern volatile __bit                   T6CKSYNC            @ (((unsigned) &T6HLT)*8) + 5;
#define                                 T6CKSYNC_bit        BANKMASK(T6HLT), 5
extern volatile __bit                   T6CS0               @ (((unsigned) &T6CLKCON)*8) + 0;
#define                                 T6CS0_bit           BANKMASK(T6CLKCON), 0
extern volatile __bit                   T6CS1               @ (((unsigned) &T6CLKCON)*8) + 1;
#define                                 T6CS1_bit           BANKMASK(T6CLKCON), 1
extern volatile __bit                   T6CS2               @ (((unsigned) &T6CLKCON)*8) + 2;
#define                                 T6CS2_bit           BANKMASK(T6CLKCON), 2
extern volatile __bit                   T6CS3               @ (((unsigned) &T6CLKCON)*8) + 3;
#define                                 T6CS3_bit           BANKMASK(T6CLKCON), 3
extern volatile __bit                   T6MODE0             @ (((unsigned) &T6HLT)*8) + 0;
#define                                 T6MODE0_bit         BANKMASK(T6HLT), 0
extern volatile __bit                   T6MODE1             @ (((unsigned) &T6HLT)*8) + 1;
#define                                 T6MODE1_bit         BANKMASK(T6HLT), 1
extern volatile __bit                   T6MODE2             @ (((unsigned) &T6HLT)*8) + 2;
#define                                 T6MODE2_bit         BANKMASK(T6HLT), 2
extern volatile __bit                   T6MODE3             @ (((unsigned) &T6HLT)*8) + 3;
#define                                 T6MODE3_bit         BANKMASK(T6HLT), 3
extern volatile __bit                   T6MODE4             @ (((unsigned) &T6HLT)*8) + 4;
#define                                 T6MODE4_bit         BANKMASK(T6HLT), 4
extern volatile __bit                   T6ON                @ (((unsigned) &T6CON)*8) + 7;
#define                                 T6ON_bit            BANKMASK(T6CON), 7
extern volatile __bit                   T6OUTPS0            @ (((unsigned) &T6CON)*8) + 0;
#define                                 T6OUTPS0_bit        BANKMASK(T6CON), 0
extern volatile __bit                   T6OUTPS1            @ (((unsigned) &T6CON)*8) + 1;
#define                                 T6OUTPS1_bit        BANKMASK(T6CON), 1
extern volatile __bit                   T6OUTPS2            @ (((unsigned) &T6CON)*8) + 2;
#define                                 T6OUTPS2_bit        BANKMASK(T6CON), 2
extern volatile __bit                   T6OUTPS3            @ (((unsigned) &T6CON)*8) + 3;
#define                                 T6OUTPS3_bit        BANKMASK(T6CON), 3
extern volatile __bit                   T6PPS0              @ (((unsigned) &T6PPS)*8) + 0;
#define                                 T6PPS0_bit          BANKMASK(T6PPS), 0
extern volatile __bit                   T6PPS1              @ (((unsigned) &T6PPS)*8) + 1;
#define                                 T6PPS1_bit          BANKMASK(T6PPS), 1
extern volatile __bit                   T6PPS2              @ (((unsigned) &T6PPS)*8) + 2;
#define                                 T6PPS2_bit          BANKMASK(T6PPS), 2
extern volatile __bit                   T6PPS3              @ (((unsigned) &T6PPS)*8) + 3;
#define                                 T6PPS3_bit          BANKMASK(T6PPS), 3
extern volatile __bit                   T6PPS4              @ (((unsigned) &T6PPS)*8) + 4;
#define                                 T6PPS4_bit          BANKMASK(T6PPS), 4
extern volatile __bit                   T6PSYNC             @ (((unsigned) &T6HLT)*8) + 7;
#define                                 T6PSYNC_bit         BANKMASK(T6HLT), 7
extern volatile __bit                   T6RSEL0             @ (((unsigned) &T6RST)*8) + 0;
#define                                 T6RSEL0_bit         BANKMASK(T6RST), 0
extern volatile __bit                   T6RSEL1             @ (((unsigned) &T6RST)*8) + 1;
#define                                 T6RSEL1_bit         BANKMASK(T6RST), 1
extern volatile __bit                   T6RSEL2             @ (((unsigned) &T6RST)*8) + 2;
#define                                 T6RSEL2_bit         BANKMASK(T6RST), 2
extern volatile __bit                   T6RSEL3             @ (((unsigned) &T6RST)*8) + 3;
#define                                 T6RSEL3_bit         BANKMASK(T6RST), 3
extern volatile __bit                   TMR0CS              @ (((unsigned) &OPTION_REG)*8) + 5;
#define                                 TMR0CS_bit          BANKMASK(OPTION_REG), 5
extern volatile __bit                   TMR0IE              @ (((unsigned) &INTCON)*8) + 5;
#define                                 TMR0IE_bit          BANKMASK(INTCON), 5
extern volatile __bit                   TMR0IF              @ (((unsigned) &INTCON)*8) + 2;
#define                                 TMR0IF_bit          BANKMASK(INTCON), 2
extern volatile __bit                   TMR0SE              @ (((unsigned) &OPTION_REG)*8) + 4;
#define                                 TMR0SE_bit          BANKMASK(OPTION_REG), 4
extern volatile __bit                   TMR1CS0             @ (((unsigned) &T1CON)*8) + 6;
#define                                 TMR1CS0_bit         BANKMASK(T1CON), 6
extern volatile __bit                   TMR1CS1             @ (((unsigned) &T1CON)*8) + 7;
#define                                 TMR1CS1_bit         BANKMASK(T1CON), 7
extern volatile __bit                   TMR1GE              @ (((unsigned) &T1GCON)*8) + 7;
#define                                 TMR1GE_bit          BANKMASK(T1GCON), 7
extern volatile __bit                   TMR1GIE             @ (((unsigned) &PIE1)*8) + 7;
#define                                 TMR1GIE_bit         BANKMASK(PIE1), 7
extern volatile __bit                   TMR1GIF             @ (((unsigned) &PIR1)*8) + 7;
#define                                 TMR1GIF_bit         BANKMASK(PIR1), 7
extern volatile __bit                   TMR1IE              @ (((unsigned) &PIE1)*8) + 0;
#define                                 TMR1IE_bit          BANKMASK(PIE1), 0
extern volatile __bit                   TMR1IF              @ (((unsigned) &PIR1)*8) + 0;
#define                                 TMR1IF_bit          BANKMASK(PIR1), 0
extern volatile __bit                   TMR1ON              @ (((unsigned) &T1CON)*8) + 0;
#define                                 TMR1ON_bit          BANKMASK(T1CON), 0
extern volatile __bit                   TMR2AS              @ (((unsigned) &CWG1AS1)*8) + 4;
#define                                 TMR2AS_bit          BANKMASK(CWG1AS1), 4
extern volatile __bit                   TMR2IE              @ (((unsigned) &PIE1)*8) + 1;
#define                                 TMR2IE_bit          BANKMASK(PIE1), 1
extern volatile __bit                   TMR2IF              @ (((unsigned) &PIR1)*8) + 1;
#define                                 TMR2IF_bit          BANKMASK(PIR1), 1
extern volatile __bit                   TMR2ON              @ (((unsigned) &T2CON)*8) + 7;
#define                                 TMR2ON_bit          BANKMASK(T2CON), 7
extern volatile __bit                   TMR3CS0             @ (((unsigned) &T3CON)*8) + 6;
#define                                 TMR3CS0_bit         BANKMASK(T3CON), 6
extern volatile __bit                   TMR3CS1             @ (((unsigned) &T3CON)*8) + 7;
#define                                 TMR3CS1_bit         BANKMASK(T3CON), 7
extern volatile __bit                   TMR3GE              @ (((unsigned) &T3GCON)*8) + 7;
#define                                 TMR3GE_bit          BANKMASK(T3GCON), 7
extern volatile __bit                   TMR3GIE             @ (((unsigned) &PIE5)*8) + 7;
#define                                 TMR3GIE_bit         BANKMASK(PIE5), 7
extern volatile __bit                   TMR3GIF             @ (((unsigned) &PIR5)*8) + 7;
#define                                 TMR3GIF_bit         BANKMASK(PIR5), 7
extern volatile __bit                   TMR3IE              @ (((unsigned) &PIE5)*8) + 6;
#define                                 TMR3IE_bit          BANKMASK(PIE5), 6
extern volatile __bit                   TMR3IF              @ (((unsigned) &PIR5)*8) + 6;
#define                                 TMR3IF_bit          BANKMASK(PIR5), 6
extern volatile __bit                   TMR3ON              @ (((unsigned) &T3CON)*8) + 0;
#define                                 TMR3ON_bit          BANKMASK(T3CON), 0
extern volatile __bit                   TMR4AS              @ (((unsigned) &CWG1AS1)*8) + 5;
#define                                 TMR4AS_bit          BANKMASK(CWG1AS1), 5
extern volatile __bit                   TMR4IE              @ (((unsigned) &PIE2)*8) + 1;
#define                                 TMR4IE_bit          BANKMASK(PIE2), 1
extern volatile __bit                   TMR4IF              @ (((unsigned) &PIR2)*8) + 1;
#define                                 TMR4IF_bit          BANKMASK(PIR2), 1
extern volatile __bit                   TMR4ON              @ (((unsigned) &T4CON)*8) + 7;
#define                                 TMR4ON_bit          BANKMASK(T4CON), 7
extern volatile __bit                   TMR5CS0             @ (((unsigned) &T5CON)*8) + 6;
#define                                 TMR5CS0_bit         BANKMASK(T5CON), 6
extern volatile __bit                   TMR5CS1             @ (((unsigned) &T5CON)*8) + 7;
#define                                 TMR5CS1_bit         BANKMASK(T5CON), 7
extern volatile __bit                   TMR5GE              @ (((unsigned) &T5GCON)*8) + 7;
#define                                 TMR5GE_bit          BANKMASK(T5GCON), 7
extern volatile __bit                   TMR5GIE             @ (((unsigned) &PIE5)*8) + 5;
#define                                 TMR5GIE_bit         BANKMASK(PIE5), 5
extern volatile __bit                   TMR5GIF             @ (((unsigned) &PIR5)*8) + 5;
#define                                 TMR5GIF_bit         BANKMASK(PIR5), 5
extern volatile __bit                   TMR5IE              @ (((unsigned) &PIE5)*8) + 4;
#define                                 TMR5IE_bit          BANKMASK(PIE5), 4
extern volatile __bit                   TMR5IF              @ (((unsigned) &PIR5)*8) + 4;
#define                                 TMR5IF_bit          BANKMASK(PIR5), 4
extern volatile __bit                   TMR5ON              @ (((unsigned) &T5CON)*8) + 0;
#define                                 TMR5ON_bit          BANKMASK(T5CON), 0
extern volatile __bit                   TMR6AS              @ (((unsigned) &CWG1AS1)*8) + 6;
#define                                 TMR6AS_bit          BANKMASK(CWG1AS1), 6
extern volatile __bit                   TMR6IE              @ (((unsigned) &PIE2)*8) + 2;
#define                                 TMR6IE_bit          BANKMASK(PIE2), 2
extern volatile __bit                   TMR6IF              @ (((unsigned) &PIR2)*8) + 2;
#define                                 TMR6IF_bit          BANKMASK(PIR2), 2
extern volatile __bit                   TMR6ON              @ (((unsigned) &T6CON)*8) + 7;
#define                                 TMR6ON_bit          BANKMASK(T6CON), 7
extern volatile __bit                   TRIGSEL0            @ (((unsigned) &ADCON2)*8) + 4;
#define                                 TRIGSEL0_bit        BANKMASK(ADCON2), 4
extern volatile __bit                   TRIGSEL1            @ (((unsigned) &ADCON2)*8) + 5;
#define                                 TRIGSEL1_bit        BANKMASK(ADCON2), 5
extern volatile __bit                   TRIGSEL2            @ (((unsigned) &ADCON2)*8) + 6;
#define                                 TRIGSEL2_bit        BANKMASK(ADCON2), 6
extern volatile __bit                   TRIGSEL3            @ (((unsigned) &ADCON2)*8) + 7;
#define                                 TRIGSEL3_bit        BANKMASK(ADCON2), 7
extern volatile __bit                   TRISA0              @ (((unsigned) &TRISA)*8) + 0;
#define                                 TRISA0_bit          BANKMASK(TRISA), 0
extern volatile __bit                   TRISA1              @ (((unsigned) &TRISA)*8) + 1;
#define                                 TRISA1_bit          BANKMASK(TRISA), 1
extern volatile __bit                   TRISA2              @ (((unsigned) &TRISA)*8) + 2;
#define                                 TRISA2_bit          BANKMASK(TRISA), 2
extern volatile __bit                   TRISA3              @ (((unsigned) &TRISA)*8) + 3;
#define                                 TRISA3_bit          BANKMASK(TRISA), 3
extern volatile __bit                   TRISA4              @ (((unsigned) &TRISA)*8) + 4;
#define                                 TRISA4_bit          BANKMASK(TRISA), 4
extern volatile __bit                   TRISA5              @ (((unsigned) &TRISA)*8) + 5;
#define                                 TRISA5_bit          BANKMASK(TRISA), 5
extern volatile __bit                   TRISB4              @ (((unsigned) &TRISB)*8) + 4;
#define                                 TRISB4_bit          BANKMASK(TRISB), 4
extern volatile __bit                   TRISB5              @ (((unsigned) &TRISB)*8) + 5;
#define                                 TRISB5_bit          BANKMASK(TRISB), 5
extern volatile __bit                   TRISB6              @ (((unsigned) &TRISB)*8) + 6;
#define                                 TRISB6_bit          BANKMASK(TRISB), 6
extern volatile __bit                   TRISB7              @ (((unsigned) &TRISB)*8) + 7;
#define                                 TRISB7_bit          BANKMASK(TRISB), 7
extern volatile __bit                   TRISC0              @ (((unsigned) &TRISC)*8) + 0;
#define                                 TRISC0_bit          BANKMASK(TRISC), 0
extern volatile __bit                   TRISC1              @ (((unsigned) &TRISC)*8) + 1;
#define                                 TRISC1_bit          BANKMASK(TRISC), 1
extern volatile __bit                   TRISC2              @ (((unsigned) &TRISC)*8) + 2;
#define                                 TRISC2_bit          BANKMASK(TRISC), 2
extern volatile __bit                   TRISC3              @ (((unsigned) &TRISC)*8) + 3;
#define                                 TRISC3_bit          BANKMASK(TRISC), 3
extern volatile __bit                   TRISC4              @ (((unsigned) &TRISC)*8) + 4;
#define                                 TRISC4_bit          BANKMASK(TRISC), 4
extern volatile __bit                   TRISC5              @ (((unsigned) &TRISC)*8) + 5;
#define                                 TRISC5_bit          BANKMASK(TRISC), 5
extern volatile __bit                   TRISC6              @ (((unsigned) &TRISC)*8) + 6;
#define                                 TRISC6_bit          BANKMASK(TRISC), 6
extern volatile __bit                   TRISC7              @ (((unsigned) &TRISC)*8) + 7;
#define                                 TRISC7_bit          BANKMASK(TRISC), 7
extern volatile __bit                   TRMT                @ (((unsigned) &TX1STA)*8) + 1;
#define                                 TRMT_bit            BANKMASK(TX1STA), 1
extern volatile __bit                   TSEL0               @ (((unsigned) &SCANTRIG)*8) + 0;
#define                                 TSEL0_bit           BANKMASK(SCANTRIG), 0
extern volatile __bit                   TSEL1               @ (((unsigned) &SCANTRIG)*8) + 1;
#define                                 TSEL1_bit           BANKMASK(SCANTRIG), 1
extern volatile __bit                   TSEL2               @ (((unsigned) &SCANTRIG)*8) + 2;
#define                                 TSEL2_bit           BANKMASK(SCANTRIG), 2
extern volatile __bit                   TSEL3               @ (((unsigned) &SCANTRIG)*8) + 3;
#define                                 TSEL3_bit           BANKMASK(SCANTRIG), 3
extern volatile __bit                   TSEN                @ (((unsigned) &FVRCON)*8) + 5;
#define                                 TSEN_bit            BANKMASK(FVRCON), 5
extern volatile __bit                   TSRNG               @ (((unsigned) &FVRCON)*8) + 4;
#define                                 TSRNG_bit           BANKMASK(FVRCON), 4
extern volatile __bit                   TUN0                @ (((unsigned) &OSCTUNE)*8) + 0;
#define                                 TUN0_bit            BANKMASK(OSCTUNE), 0
extern volatile __bit                   TUN1                @ (((unsigned) &OSCTUNE)*8) + 1;
#define                                 TUN1_bit            BANKMASK(OSCTUNE), 1
extern volatile __bit                   TUN2                @ (((unsigned) &OSCTUNE)*8) + 2;
#define                                 TUN2_bit            BANKMASK(OSCTUNE), 2
extern volatile __bit                   TUN3                @ (((unsigned) &OSCTUNE)*8) + 3;
#define                                 TUN3_bit            BANKMASK(OSCTUNE), 3
extern volatile __bit                   TUN4                @ (((unsigned) &OSCTUNE)*8) + 4;
#define                                 TUN4_bit            BANKMASK(OSCTUNE), 4
extern volatile __bit                   TUN5                @ (((unsigned) &OSCTUNE)*8) + 5;
#define                                 TUN5_bit            BANKMASK(OSCTUNE), 5
extern volatile __bit                   TX9                 @ (((unsigned) &TX1STA)*8) + 6;
#define                                 TX9_bit             BANKMASK(TX1STA), 6
extern volatile __bit                   TX9D                @ (((unsigned) &TX1STA)*8) + 0;
#define                                 TX9D_bit            BANKMASK(TX1STA), 0
extern volatile __bit                   TXEN                @ (((unsigned) &TX1STA)*8) + 5;
#define                                 TXEN_bit            BANKMASK(TX1STA), 5
extern volatile __bit                   TXIE                @ (((unsigned) &PIE1)*8) + 4;
#define                                 TXIE_bit            BANKMASK(PIE1), 4
extern volatile __bit                   TXIF                @ (((unsigned) &PIR1)*8) + 4;
#define                                 TXIF_bit            BANKMASK(PIR1), 4
extern volatile __bit                   UA                  @ (((unsigned) &SSP1STAT)*8) + 1;
#define                                 UA_bit              BANKMASK(SSP1STAT), 1
extern volatile __bit                   VALID               @ (((unsigned) &AT1CON1)*8) + 0;
#define                                 VALID_bit           BANKMASK(AT1CON1), 0
extern volatile __bit                   VREGPM0             @ (((unsigned) &VREGCON)*8) + 0;
#define                                 VREGPM0_bit         BANKMASK(VREGCON), 0
extern volatile __bit                   VREGPM1             @ (((unsigned) &VREGCON)*8) + 1;
#define                                 VREGPM1_bit         BANKMASK(VREGCON), 1
extern volatile __bit                   WCOL                @ (((unsigned) &SSP1CON1)*8) + 7;
#define                                 WCOL_bit            BANKMASK(SSP1CON1), 7
extern volatile __bit                   WDTCS0              @ (((unsigned) &WDTCON1)*8) + 4;
#define                                 WDTCS0_bit          BANKMASK(WDTCON1), 4
extern volatile __bit                   WDTCS1              @ (((unsigned) &WDTCON1)*8) + 5;
#define                                 WDTCS1_bit          BANKMASK(WDTCON1), 5
extern volatile __bit                   WDTCS2              @ (((unsigned) &WDTCON1)*8) + 6;
#define                                 WDTCS2_bit          BANKMASK(WDTCON1), 6
extern volatile __bit                   WDTPS0              @ (((unsigned) &WDTCON0)*8) + 1;
#define                                 WDTPS0_bit          BANKMASK(WDTCON0), 1
extern volatile __bit                   WDTPS1              @ (((unsigned) &WDTCON0)*8) + 2;
#define                                 WDTPS1_bit          BANKMASK(WDTCON0), 2
extern volatile __bit                   WDTPS2              @ (((unsigned) &WDTCON0)*8) + 3;
#define                                 WDTPS2_bit          BANKMASK(WDTCON0), 3
extern volatile __bit                   WDTPS3              @ (((unsigned) &WDTCON0)*8) + 4;
#define                                 WDTPS3_bit          BANKMASK(WDTCON0), 4
extern volatile __bit                   WDTPS4              @ (((unsigned) &WDTCON0)*8) + 5;
#define                                 WDTPS4_bit          BANKMASK(WDTCON0), 5
extern volatile __bit                   WDTPSCNT0           @ (((unsigned) &WDTPSL)*8) + 0;
#define                                 WDTPSCNT0_bit       BANKMASK(WDTPSL), 0
extern volatile __bit                   WDTPSCNT1           @ (((unsigned) &WDTPSL)*8) + 1;
#define                                 WDTPSCNT1_bit       BANKMASK(WDTPSL), 1
extern volatile __bit                   WDTPSCNT10          @ (((unsigned) &WDTPSH)*8) + 2;
#define                                 WDTPSCNT10_bit      BANKMASK(WDTPSH), 2
extern volatile __bit                   WDTPSCNT11          @ (((unsigned) &WDTPSH)*8) + 3;
#define                                 WDTPSCNT11_bit      BANKMASK(WDTPSH), 3
extern volatile __bit                   WDTPSCNT12          @ (((unsigned) &WDTPSH)*8) + 4;
#define                                 WDTPSCNT12_bit      BANKMASK(WDTPSH), 4
extern volatile __bit                   WDTPSCNT13          @ (((unsigned) &WDTPSH)*8) + 5;
#define                                 WDTPSCNT13_bit      BANKMASK(WDTPSH), 5
extern volatile __bit                   WDTPSCNT14          @ (((unsigned) &WDTPSH)*8) + 6;
#define                                 WDTPSCNT14_bit      BANKMASK(WDTPSH), 6
extern volatile __bit                   WDTPSCNT15          @ (((unsigned) &WDTPSH)*8) + 7;
#define                                 WDTPSCNT15_bit      BANKMASK(WDTPSH), 7
extern volatile __bit                   WDTPSCNT16          @ (((unsigned) &WDTTMR)*8) + 0;
#define                                 WDTPSCNT16_bit      BANKMASK(WDTTMR), 0
extern volatile __bit                   WDTPSCNT17          @ (((unsigned) &WDTTMR)*8) + 1;
#define                                 WDTPSCNT17_bit      BANKMASK(WDTTMR), 1
extern volatile __bit                   WDTPSCNT2           @ (((unsigned) &WDTPSL)*8) + 2;
#define                                 WDTPSCNT2_bit       BANKMASK(WDTPSL), 2
extern volatile __bit                   WDTPSCNT3           @ (((unsigned) &WDTPSL)*8) + 3;
#define                                 WDTPSCNT3_bit       BANKMASK(WDTPSL), 3
extern volatile __bit                   WDTPSCNT4           @ (((unsigned) &WDTPSL)*8) + 4;
#define                                 WDTPSCNT4_bit       BANKMASK(WDTPSL), 4
extern volatile __bit                   WDTPSCNT5           @ (((unsigned) &WDTPSL)*8) + 5;
#define                                 WDTPSCNT5_bit       BANKMASK(WDTPSL), 5
extern volatile __bit                   WDTPSCNT6           @ (((unsigned) &WDTPSL)*8) + 6;
#define                                 WDTPSCNT6_bit       BANKMASK(WDTPSL), 6
extern volatile __bit                   WDTPSCNT7           @ (((unsigned) &WDTPSL)*8) + 7;
#define                                 WDTPSCNT7_bit       BANKMASK(WDTPSL), 7
extern volatile __bit                   WDTPSCNT8           @ (((unsigned) &WDTPSH)*8) + 0;
#define                                 WDTPSCNT8_bit       BANKMASK(WDTPSH), 0
extern volatile __bit                   WDTPSCNT9           @ (((unsigned) &WDTPSH)*8) + 1;
#define                                 WDTPSCNT9_bit       BANKMASK(WDTPSH), 1
extern volatile __bit                   WDTSEN              @ (((unsigned) &WDTCON0)*8) + 0;
#define                                 WDTSEN_bit          BANKMASK(WDTCON0), 0
extern volatile __bit                   WDTSTATE            @ (((unsigned) &WDTTMR)*8) + 2;
#define                                 WDTSTATE_bit        BANKMASK(WDTTMR), 2
extern volatile __bit                   WDTTMR0             @ (((unsigned) &WDTTMR)*8) + 3;
#define                                 WDTTMR0_bit         BANKMASK(WDTTMR), 3
extern volatile __bit                   WDTTMR1             @ (((unsigned) &WDTTMR)*8) + 4;
#define                                 WDTTMR1_bit         BANKMASK(WDTTMR), 4
extern volatile __bit                   WDTTMR2             @ (((unsigned) &WDTTMR)*8) + 5;
#define                                 WDTTMR2_bit         BANKMASK(WDTTMR), 5
extern volatile __bit                   WDTTMR3             @ (((unsigned) &WDTTMR)*8) + 6;
#define                                 WDTTMR3_bit         BANKMASK(WDTTMR), 6
extern volatile __bit                   WDTTMR4             @ (((unsigned) &WDTTMR)*8) + 7;
#define                                 WDTTMR4_bit         BANKMASK(WDTTMR), 7
extern volatile __bit                   WDTWINDOW0          @ (((unsigned) &WDTCON1)*8) + 0;
#define                                 WDTWINDOW0_bit      BANKMASK(WDTCON1), 0
extern volatile __bit                   WDTWINDOW1          @ (((unsigned) &WDTCON1)*8) + 1;
#define                                 WDTWINDOW1_bit      BANKMASK(WDTCON1), 1
extern volatile __bit                   WDTWINDOW2          @ (((unsigned) &WDTCON1)*8) + 2;
#define                                 WDTWINDOW2_bit      BANKMASK(WDTCON1), 2
extern volatile __bit                   WINDOW0             @ (((unsigned) &WDTCON1)*8) + 0;
#define                                 WINDOW0_bit         BANKMASK(WDTCON1), 0
extern volatile __bit                   WINDOW1             @ (((unsigned) &WDTCON1)*8) + 1;
#define                                 WINDOW1_bit         BANKMASK(WDTCON1), 1
extern volatile __bit                   WINDOW2             @ (((unsigned) &WDTCON1)*8) + 2;
#define                                 WINDOW2_bit         BANKMASK(WDTCON1), 2
extern volatile __bit                   WPUA0               @ (((unsigned) &WPUA)*8) + 0;
#define                                 WPUA0_bit           BANKMASK(WPUA), 0
extern volatile __bit                   WPUA1               @ (((unsigned) &WPUA)*8) + 1;
#define                                 WPUA1_bit           BANKMASK(WPUA), 1
extern volatile __bit                   WPUA2               @ (((unsigned) &WPUA)*8) + 2;
#define                                 WPUA2_bit           BANKMASK(WPUA), 2
extern volatile __bit                   WPUA3               @ (((unsigned) &WPUA)*8) + 3;
#define                                 WPUA3_bit           BANKMASK(WPUA), 3
extern volatile __bit                   WPUA4               @ (((unsigned) &WPUA)*8) + 4;
#define                                 WPUA4_bit           BANKMASK(WPUA), 4
extern volatile __bit                   WPUA5               @ (((unsigned) &WPUA)*8) + 5;
#define                                 WPUA5_bit           BANKMASK(WPUA), 5
extern volatile __bit                   WPUB4               @ (((unsigned) &WPUB)*8) + 4;
#define                                 WPUB4_bit           BANKMASK(WPUB), 4
extern volatile __bit                   WPUB5               @ (((unsigned) &WPUB)*8) + 5;
#define                                 WPUB5_bit           BANKMASK(WPUB), 5
extern volatile __bit                   WPUB6               @ (((unsigned) &WPUB)*8) + 6;
#define                                 WPUB6_bit           BANKMASK(WPUB), 6
extern volatile __bit                   WPUB7               @ (((unsigned) &WPUB)*8) + 7;
#define                                 WPUB7_bit           BANKMASK(WPUB), 7
extern volatile __bit                   WPUC0               @ (((unsigned) &WPUC)*8) + 0;
#define                                 WPUC0_bit           BANKMASK(WPUC), 0
extern volatile __bit                   WPUC1               @ (((unsigned) &WPUC)*8) + 1;
#define                                 WPUC1_bit           BANKMASK(WPUC), 1
extern volatile __bit                   WPUC2               @ (((unsigned) &WPUC)*8) + 2;
#define                                 WPUC2_bit           BANKMASK(WPUC), 2
extern volatile __bit                   WPUC3               @ (((unsigned) &WPUC)*8) + 3;
#define                                 WPUC3_bit           BANKMASK(WPUC), 3
extern volatile __bit                   WPUC4               @ (((unsigned) &WPUC)*8) + 4;
#define                                 WPUC4_bit           BANKMASK(WPUC), 4
extern volatile __bit                   WPUC5               @ (((unsigned) &WPUC)*8) + 5;
#define                                 WPUC5_bit           BANKMASK(WPUC), 5
extern volatile __bit                   WPUC6               @ (((unsigned) &WPUC)*8) + 6;
#define                                 WPUC6_bit           BANKMASK(WPUC), 6
extern volatile __bit                   WPUC7               @ (((unsigned) &WPUC)*8) + 7;
#define                                 WPUC7_bit           BANKMASK(WPUC), 7
extern volatile __bit                   WR                  @ (((unsigned) &PMCON1)*8) + 1;
#define                                 WR_bit              BANKMASK(PMCON1), 1
extern volatile __bit                   WREN                @ (((unsigned) &PMCON1)*8) + 2;
#define                                 WREN_bit            BANKMASK(PMCON1), 2
extern volatile __bit                   WRERR               @ (((unsigned) &PMCON1)*8) + 3;
#define                                 WRERR_bit           BANKMASK(PMCON1), 3
extern volatile __bit                   WUE                 @ (((unsigned) &BAUD1CON)*8) + 1;
#define                                 WUE_bit             BANKMASK(BAUD1CON), 1
extern volatile __bit                   XOR1                @ (((unsigned) &CRCXORL)*8) + 1;
#define                                 XOR1_bit            BANKMASK(CRCXORL), 1
extern volatile __bit                   XOR10               @ (((unsigned) &CRCXORH)*8) + 2;
#define                                 XOR10_bit           BANKMASK(CRCXORH), 2
extern volatile __bit                   XOR11               @ (((unsigned) &CRCXORH)*8) + 3;
#define                                 XOR11_bit           BANKMASK(CRCXORH), 3
extern volatile __bit                   XOR12               @ (((unsigned) &CRCXORH)*8) + 4;
#define                                 XOR12_bit           BANKMASK(CRCXORH), 4
extern volatile __bit                   XOR13               @ (((unsigned) &CRCXORH)*8) + 5;
#define                                 XOR13_bit           BANKMASK(CRCXORH), 5
extern volatile __bit                   XOR14               @ (((unsigned) &CRCXORH)*8) + 6;
#define                                 XOR14_bit           BANKMASK(CRCXORH), 6
extern volatile __bit                   XOR15               @ (((unsigned) &CRCXORH)*8) + 7;
#define                                 XOR15_bit           BANKMASK(CRCXORH), 7
extern volatile __bit                   XOR2                @ (((unsigned) &CRCXORL)*8) + 2;
#define                                 XOR2_bit            BANKMASK(CRCXORL), 2
extern volatile __bit                   XOR3                @ (((unsigned) &CRCXORL)*8) + 3;
#define                                 XOR3_bit            BANKMASK(CRCXORL), 3
extern volatile __bit                   XOR4                @ (((unsigned) &CRCXORL)*8) + 4;
#define                                 XOR4_bit            BANKMASK(CRCXORL), 4
extern volatile __bit                   XOR5                @ (((unsigned) &CRCXORL)*8) + 5;
#define                                 XOR5_bit            BANKMASK(CRCXORL), 5
extern volatile __bit                   XOR6                @ (((unsigned) &CRCXORL)*8) + 6;
#define                                 XOR6_bit            BANKMASK(CRCXORL), 6
extern volatile __bit                   XOR7                @ (((unsigned) &CRCXORL)*8) + 7;
#define                                 XOR7_bit            BANKMASK(CRCXORL), 7
extern volatile __bit                   XOR8                @ (((unsigned) &CRCXORH)*8) + 0;
#define                                 XOR8_bit            BANKMASK(CRCXORH), 0
extern volatile __bit                   XOR9                @ (((unsigned) &CRCXORH)*8) + 1;
#define                                 XOR9_bit            BANKMASK(CRCXORH), 1
extern volatile __bit                   Z10                 @ (((unsigned) &PID1Z1L)*8) + 0;
#define                                 Z10_bit             BANKMASK(PID1Z1L), 0
extern volatile __bit                   Z11                 @ (((unsigned) &PID1Z1L)*8) + 1;
#define                                 Z11_bit             BANKMASK(PID1Z1L), 1
extern volatile __bit                   Z110                @ (((unsigned) &PID1Z1H)*8) + 2;
#define                                 Z110_bit            BANKMASK(PID1Z1H), 2
extern volatile __bit                   Z111                @ (((unsigned) &PID1Z1H)*8) + 3;
#define                                 Z111_bit            BANKMASK(PID1Z1H), 3
extern volatile __bit                   Z112                @ (((unsigned) &PID1Z1H)*8) + 4;
#define                                 Z112_bit            BANKMASK(PID1Z1H), 4
extern volatile __bit                   Z113                @ (((unsigned) &PID1Z1H)*8) + 5;
#define                                 Z113_bit            BANKMASK(PID1Z1H), 5
extern volatile __bit                   Z114                @ (((unsigned) &PID1Z1H)*8) + 6;
#define                                 Z114_bit            BANKMASK(PID1Z1H), 6
extern volatile __bit                   Z115                @ (((unsigned) &PID1Z1H)*8) + 7;
#define                                 Z115_bit            BANKMASK(PID1Z1H), 7
extern volatile __bit                   Z116                @ (((unsigned) &PID1Z1U)*8) + 0;
#define                                 Z116_bit            BANKMASK(PID1Z1U), 0
extern volatile __bit                   Z12                 @ (((unsigned) &PID1Z1L)*8) + 2;
#define                                 Z12_bit             BANKMASK(PID1Z1L), 2
extern volatile __bit                   Z13                 @ (((unsigned) &PID1Z1L)*8) + 3;
#define                                 Z13_bit             BANKMASK(PID1Z1L), 3
extern volatile __bit                   Z14                 @ (((unsigned) &PID1Z1L)*8) + 4;
#define                                 Z14_bit             BANKMASK(PID1Z1L), 4
extern volatile __bit                   Z15                 @ (((unsigned) &PID1Z1L)*8) + 5;
#define                                 Z15_bit             BANKMASK(PID1Z1L), 5
extern volatile __bit                   Z16                 @ (((unsigned) &PID1Z1L)*8) + 6;
#define                                 Z16_bit             BANKMASK(PID1Z1L), 6
extern volatile __bit                   Z17                 @ (((unsigned) &PID1Z1L)*8) + 7;
#define                                 Z17_bit             BANKMASK(PID1Z1L), 7
extern volatile __bit                   Z18                 @ (((unsigned) &PID1Z1H)*8) + 0;
#define                                 Z18_bit             BANKMASK(PID1Z1H), 0
extern volatile __bit                   Z19                 @ (((unsigned) &PID1Z1H)*8) + 1;
#define                                 Z19_bit             BANKMASK(PID1Z1H), 1
extern volatile __bit                   Z20                 @ (((unsigned) &PID1Z2L)*8) + 0;
#define                                 Z20_bit             BANKMASK(PID1Z2L), 0
extern volatile __bit                   Z21                 @ (((unsigned) &PID1Z2L)*8) + 1;
#define                                 Z21_bit             BANKMASK(PID1Z2L), 1
extern volatile __bit                   Z210                @ (((unsigned) &PID1Z2H)*8) + 2;
#define                                 Z210_bit            BANKMASK(PID1Z2H), 2
extern volatile __bit                   Z211                @ (((unsigned) &PID1Z2H)*8) + 3;
#define                                 Z211_bit            BANKMASK(PID1Z2H), 3
extern volatile __bit                   Z212                @ (((unsigned) &PID1Z2H)*8) + 4;
#define                                 Z212_bit            BANKMASK(PID1Z2H), 4
extern volatile __bit                   Z213                @ (((unsigned) &PID1Z2H)*8) + 5;
#define                                 Z213_bit            BANKMASK(PID1Z2H), 5
extern volatile __bit                   Z214                @ (((unsigned) &PID1Z2H)*8) + 6;
#define                                 Z214_bit            BANKMASK(PID1Z2H), 6
extern volatile __bit                   Z215                @ (((unsigned) &PID1Z2H)*8) + 7;
#define                                 Z215_bit            BANKMASK(PID1Z2H), 7
extern volatile __bit                   Z216                @ (((unsigned) &PID1Z2U)*8) + 0;
#define                                 Z216_bit            BANKMASK(PID1Z2U), 0
extern volatile __bit                   Z22                 @ (((unsigned) &PID1Z2L)*8) + 2;
#define                                 Z22_bit             BANKMASK(PID1Z2L), 2
extern volatile __bit                   Z23                 @ (((unsigned) &PID1Z2L)*8) + 3;
#define                                 Z23_bit             BANKMASK(PID1Z2L), 3
extern volatile __bit                   Z24                 @ (((unsigned) &PID1Z2L)*8) + 4;
#define                                 Z24_bit             BANKMASK(PID1Z2L), 4
extern volatile __bit                   Z25                 @ (((unsigned) &PID1Z2L)*8) + 5;
#define                                 Z25_bit             BANKMASK(PID1Z2L), 5
extern volatile __bit                   Z26                 @ (((unsigned) &PID1Z2L)*8) + 6;
#define                                 Z26_bit             BANKMASK(PID1Z2L), 6
extern volatile __bit                   Z27                 @ (((unsigned) &PID1Z2L)*8) + 7;
#define                                 Z27_bit             BANKMASK(PID1Z2L), 7
extern volatile __bit                   Z28                 @ (((unsigned) &PID1Z2H)*8) + 0;
#define                                 Z28_bit             BANKMASK(PID1Z2H), 0
extern volatile __bit                   Z29                 @ (((unsigned) &PID1Z2H)*8) + 1;
#define                                 Z29_bit             BANKMASK(PID1Z2H), 1
extern volatile __bit                   ZCD1EN              @ (((unsigned) &ZCD1CON)*8) + 7;
#define                                 ZCD1EN_bit          BANKMASK(ZCD1CON), 7
extern volatile __bit                   ZCD1INTN            @ (((unsigned) &ZCD1CON)*8) + 0;
#define                                 ZCD1INTN_bit        BANKMASK(ZCD1CON), 0
extern volatile __bit                   ZCD1INTP            @ (((unsigned) &ZCD1CON)*8) + 1;
#define                                 ZCD1INTP_bit        BANKMASK(ZCD1CON), 1
extern volatile __bit                   ZCD1OUT             @ (((unsigned) &ZCD1CON)*8) + 5;
#define                                 ZCD1OUT_bit         BANKMASK(ZCD1CON), 5
extern volatile __bit                   ZCD1POL             @ (((unsigned) &ZCD1CON)*8) + 4;
#define                                 ZCD1POL_bit         BANKMASK(ZCD1CON), 4
extern volatile __bit                   ZCDIE               @ (((unsigned) &PIE3)*8) + 4;
#define                                 ZCDIE_bit           BANKMASK(PIE3), 4
extern volatile __bit                   ZCDIF               @ (((unsigned) &PIR3)*8) + 4;
#define                                 ZCDIF_bit           BANKMASK(PIR3), 4
extern volatile __bit                   ZERO                @ (((unsigned) &STATUS)*8) + 2;
#define                                 ZERO_bit            BANKMASK(STATUS), 2
extern volatile __bit                   Z_SHAD              @ (((unsigned) &STATUS_SHAD)*8) + 2;
#define                                 Z_SHAD_bit          BANKMASK(STATUS_SHAD), 2
extern volatile __bit                   nBOR                @ (((unsigned) &PCON)*8) + 0;
#define                                 nBOR_bit            BANKMASK(PCON), 0
extern volatile __bit                   nPD                 @ (((unsigned) &STATUS)*8) + 3;
#define                                 nPD_bit             BANKMASK(STATUS), 3
extern volatile __bit                   nPOR                @ (((unsigned) &PCON)*8) + 1;
#define                                 nPOR_bit            BANKMASK(PCON), 1
extern volatile __bit                   nRI                 @ (((unsigned) &PCON)*8) + 2;
#define                                 nRI_bit             BANKMASK(PCON), 2
extern volatile __bit                   nRMCLR              @ (((unsigned) &PCON)*8) + 3;
#define                                 nRMCLR_bit          BANKMASK(PCON), 3
extern volatile __bit                   nRWDT               @ (((unsigned) &PCON)*8) + 4;
#define                                 nRWDT_bit           BANKMASK(PCON), 4
extern volatile __bit                   nT1SYNC             @ (((unsigned) &T1CON)*8) + 2;
#define                                 nT1SYNC_bit         BANKMASK(T1CON), 2
extern volatile __bit                   nTO                 @ (((unsigned) &STATUS)*8) + 4;
#define                                 nTO_bit             BANKMASK(STATUS), 4
extern volatile __bit                   nWDTWV              @ (((unsigned) &PCON)*8) + 5;
#define                                 nWDTWV_bit          BANKMASK(PCON), 5
extern volatile __bit                   nWPUEN              @ (((unsigned) &OPTION_REG)*8) + 7;
#define                                 nWPUEN_bit          BANKMASK(OPTION_REG), 7

#endif // _PIC16F1619_H_
